;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'latin-unity-custom-defines) (error "Feature latin-unity-custom-defines already loaded"))

;;;### (autoloads (latin-unity-debug) "latin-unity-vars" "latin-unity/latin-unity-vars.el")
(defconst custom-define-current-source-file "latin-unity-vars.el")

(defcustom latin-unity-debug nil "\
If non-nil, make file write operations as slow as molasses.
If there were bugs, this might help find them, but there aren't. ;^)" :type 'boolean :group 'latin-unity)

;;;***

;;;### (autoloads (latin-unity-may-set-coding-flag latin-unity-like-to-live-dangerously latin-unity-hack-cookies-enabled-p latin-unity-coding-system-list-buffer latin-unity-iso-8859-1-aliases latin-unity-coding-system-alias-alist latin-unity-charset-alias-alist latin-unity-ucs-list latin-unity-preferred-coding-system-list latin-unity-preapproved-coding-system-list latin-unity) "latin-unity" "latin-unity/latin-unity.el")
(defconst custom-define-current-source-file "latin-unity.el")

(defgroup latin-unity nil "Handle equivalent ISO-8859 characters properly (identify them) on output." :group 'mule)

(defcustom latin-unity-preapproved-coding-system-list '(buffer-default preferred) "\
*List of coding systems used without querying the user if feasible.

The first feasible coding system in this list is used.  The special values
'preferred and 'buffer-default may be present:

  buffer-default  Use the coding system used by `write-region', if feasible.
  preferred       Use the coding system specified by `prefer-coding-system'
                  if feasible.

\"Feasible\" means that all characters in the buffer can be represented by
the coding system.  Coding systems in `latin-unity-ucs-list' are always
considered feasible.  Other feasible coding systems are computed by
`latin-unity-representations-feasible-region'.

Most users will want at least one ISO 8859 coding system in this list, as
otherwise pure ASCII files will not be preapproved.  (This is a bug, due
to the limitation of applicability of this package to Latin and universal.
The condition that an ISO 8859 coding system be included will be satisfied
implicitly by 'buffer-default or 'preferred for most users, but it can be
annoying for users of ISO 2022 or EUC coding systems.)

Note that the first universal coding system in this list shadows all other
coding systems.  In particular, if your preferred coding system is a universal
coding system, and 'preferred is a member of this list, latin-unity will
blithely convert all your files to that coding system.  This is considered a
feature, but it may surprise most users.  Users who don't like this behavior
should move 'preferred to `latin-unity-preferred-coding-system-list'." :type '(repeat symbol) :group 'latin-unity)

(defcustom latin-unity-preferred-coding-system-list '(iso-8859-1 iso-8859-15 iso-8859-2 iso-8859-3 iso-8859-4 iso-8859-9) "\
*List of coding systems suggested the user if feasible.

If no coding system in `latin-unity-preapproved-coding-system-list' is
feasible, this list will be recommended to the user, followed by the
`latin-unity-ucs-list'.  (Since the user makes the choice, including
universal coding systems in this list is redundant.)
The first coding system in this list is the default choice.

The special values 'preferred and 'buffer-default may be present:
  buffer-default  Use the coding system used by `write-region', if feasible.
  preferred       Use the coding system specified by `prefer-coding-system'
                  if feasible.

\"Feasible\" means that all characters in the buffer can be represented by
the coding system.  Coding systems in `latin-unity-ucs-list' are always
considered feasible.  Other feasible coding systems are computed by
`latin-unity-representations-feasible-region'." :type '(repeat symbol) :group 'latin-unity)

(defcustom latin-unity-ucs-list '(utf-8 iso-2022-7 ctext escape-quoted) "\
*List of coding systems considered to be universal.

A universal coding system can represent all characters by definition.

Order matters; coding systems earlier in the list will be preferred
when recommending a coding system.  These coding systems will not be
used without querying the user (unless they are also present in
`latin-unity-preapproved-coding-system-list'), and follow the
`latin-unity-preferred-coding-system-list' in the list of suggested
coding systems.

If none of the preferred coding systems are feasible, the first in
this list will be the default.

Notes on certain coding systems:  If `escape-quoted' is not a member of
this list, you will be unable to autosave files or byte-compile Mule
Lisp files.

latin-unity does not try to be \"smart\" about general ISO 2022 coding
systems, such as ISO-2022-JP.  (They are not recognized as equivalent
to `iso-2022-7'.)  If your preferred coding system is one of these,
consider adding it to `latin-unity-ucs-list'.  Note that choice of 7-bit
UCSes for saving files will have the side effect that ISO 8859 files will
be saved in 7-bit form with ISO 2022 escape sequences.  `ctext', i.e. X
Compound Text, is exceptional in that it will preserve ISO 8859/1.  `ctext'
will convert files encoded in other ISO 8859 coding systems to 7-bit form." :type '(repeat symbol) :group 'latin-unity)

(defcustom latin-unity-charset-alias-alist '((latin-1 . latin-iso8859-1) (latin-2 . latin-iso8859-2) (latin-3 . latin-iso8859-3) (latin-4 . latin-iso8859-4) (latin-5 . latin-iso8859-9) (latin-7 . latin-iso8859-13) (latin-9 . latin-iso8859-15) (latin-10 . latin-iso8859-16)) "\
*Alist mapping aliases (symbols) to Mule charset names (symbols).

Both aliases and names are symbols.
Aliases of unsupported charsets will be treated as if the charset name had
been entered directly (normally an error will be signaled for the Mule
charset)." :type '(repeat (cons symbol symbol)) :group 'latin-unity)

(defcustom latin-unity-coding-system-alias-alist nil "\
*Alist mapping aliases to Mule coding system names.

Both aliases and names are symbols.
Aliases of unsupported coding systems will be treated as if the coding system
name had been entered directly (normally an error will be signaled)." :type '(repeat (cons symbol symbol)) :group 'latin-unity)

(defcustom latin-unity-iso-8859-1-aliases '(iso-8859-1) "\
List of coding systems to be treated as aliases of ISO 8859/1.

Not a user variable.  Customize input of coding systems or charsets via
`latin-unity-coding-system-alias-alist' or `latin-unity-charset-alias-alist'." :type '(repeat symbol) :group 'latin-unity)

(defcustom latin-unity-coding-system-list-buffer " *latin-unity coding system preferences*" "\
Name of buffer used to display codings systems by priority." :type 'string :group 'latin-unity)

(defcustom latin-unity-hack-cookies-enabled-p t "\
If non-nil, `latin-unity-sanity-check' validates coding cookies." :type 'boolean :group 'latin-unity)

(defcustom latin-unity-like-to-live-dangerously nil "\
Convert failure to remap buffer from error to warning.

Note that in ordinary editing, the buffer will normally remain, so the user
can re-save in a feasible coding system.  However, many subsystems such as
MUAs may destroy the buffer immediately after disposing of the contents." :type 'boolean :group 'latin-unity)

(defcustom latin-unity-may-set-coding-flag 'ask "\
When may latin-unity reset `buffer-file-coding-system'?

    nil           never change it, return silently
    t             always change it, return silently
    regrets-only  never change it, warn that coding system is inappropriate
    warn          always change it, warn user of change
    ask           ask user's permission." :type '(choice (const nil :doc "never change, return silently") (const t :doc "always change, return silently") (const regrets-only :doc "never change, warn that coding system is inappropriate") (const warn :doc "always change, warn user of change") (const ask :doc "ask user's permission")) :group 'latin-unity)

;;;***

(provide 'latin-unity-custom-defines)
