;;; DO NOT MODIFY THIS FILE -*- coding: escape-quoted -*-
(or (featurep 'mule) (error "Loading this file requires Mule support"))
;;;###coding system: escape-quoted
(if (featurep 'lookup-custom-defines) (error "Feature lookup-custom-defines already loaded"))

;;;### (autoloads (lookup-package-directory) "lookup-package" "lisp/lookup-package.el")
(defconst custom-define-current-source-file "lookup-package.el")

(defcustom lookup-package-directory (expand-file-name "packages" lookup-data-directory) "\
*$(BJd=u%Q%C%1!<%8$,<}$a$i$l$k%G%#%l%/%H%j!#(B" :type 'directory :group 'lookup-setup)

;;;***

;;;### (autoloads (lookup-faces lookup-kakasi-coding-system lookup-process-coding-system lookup-gaiji-alternate lookup-cite-prefix lookup-cite-header lookup-max-text lookup-max-hits lookup-enable-gaiji lookup-use-kakasi lookup-use-bitmap lookup-save-configuration lookup-window-height lookup-fill-column lookup-frame-alist lookup-default-method lookup-general-options lookup-dictionary-options-alist lookup-default-dictionary-options lookup-agent-options-alist lookup-default-agent-options lookup-search-modules lookup-search-agents lookup-data-directory lookup-init-file lookup-setup-variables lookup-agents lookup) "lookup-vars" "lisp/lookup-vars.el")
(defconst custom-define-current-source-file "lookup-vars.el")

(defgroup lookup nil "Search interface to electronic dictionaries." :group 'applications)

(defgroup lookup-agents nil "Search agents." :group 'lookup)

(defgroup lookup-setup-variables nil "Setup variables." :group 'lookup)

(defcustom lookup-init-file (concat "~" init-file-user "/.lookup") "\
*Lookup $(B$N=i4|2=%U%!%$%kL>!#(B
$(B$3$N%U%!%$%k$O(B lookup.el $(B$N%m!<%ID>8e$KFI$_9~$^$l$k!#(B" :type 'file :group 'lookup-setup-variables)

(defcustom lookup-data-directory "@pkgemacsdir@" "\
*Lookup $(B$K4X$9$k%W%m%0%i%`0J30$N%G!<%?$,<}$a$i$l$k%G%#%l%/%H%j!#(B" :type 'directory :group 'lookup-setup-variables)

(defcustom lookup-search-agents nil "\
*$(B8!:w%(!<%8%'%s%H$N@_Dj$N%j%9%H!#(B
$(B%j%9%H$N3FMWAG$O<!$N7A<0$r<h$k(B:

  (CLASS LOCATION [KEY1 VALUE1 [KEY2 VALUE2 [...]]])

CLASS $(B$K$O!"%(!<%8%'%s%H$N<oN`$r%7%s%\%k$G;XDj$9$k!#(B
LOCATION $(B$K$O!"%(!<%8%'%s%H$N=j:_$rJ8;zNs$G;XDj$9$k!#(B
KEY $(B5Z$S(B VALUE $(B$O>JN,2DG=$G!"%(!<%8%'%s%H$KBP$9$k%*%W%7%g%s$r;XDj$9$k!#(B

$(BNc(B: (setq lookup-search-agents
          '((ndtp \"dserver\" :port 2010)
            (ndeb \"/cdrom\" :enable (\"EIWA\")))))" :type '(repeat (sexp :tag "agent")) :group 'lookup-setup-variables)

(defcustom lookup-search-modules nil "\
*$(B8!:w%b%8%e!<%k$N@_Dj$N%j%9%H!#(B" :type '(repeat (cons :tag "Module" (string :tag "name") (repeat :tag "Dictionary" (string :tag "ID")))) :group 'lookup-setup-variables)

(defcustom lookup-default-agent-options nil "\
*$(B8!:w%(!<%8%'%s%H$K%G%U%)%k%H$GM?$($k%*%W%7%g%s$N%j%9%H!#(B
$(B3F%*%W%7%g%s$O!"%?%0$H$J$k%7%s%\%k$H!"CM$H$J$kG$0U$N%*%V%8%'%/%H$H$N(B
cons $(B$K$h$C$FI=$o$9!#(B" :type '(repeat (cons :tag "option" (symbol :tag "tag") (sexp :tag "value"))) :group 'lookup-setup-variables)

(defcustom lookup-agent-options-alist nil "\
*$(B8!:w%(!<%8%'%s%H$N%*%W%7%g%s$r@_Dj$9$kO"A[%j%9%H!#(B
$(B3FMWAG$N(B car $(B$K$O%(!<%8%'%s%H(BID(\"CLASS+LOCATION\")$(B$r;XDj$7!"(B
cdr $(B$K$O%*%W%7%g%s$N%j%9%H$r;XDj$9$k!#(B" :type '(repeat (cons :tag "Agent" (string :tag "ID") (repeat :tag "options" (cons :tag "option" (symbol :tag "tag") (sexp :tag "value"))))) :group 'lookup-setup-variables)

(defcustom lookup-default-dictionary-options nil "\
*$(B<-=q$K%G%U%)%k%H$GM?$($k%*%W%7%g%s$N%j%9%H!#(B
$(B3F%*%W%7%g%s$O!"%?%0$H$J$k%7%s%\%k$H!"CM$H$J$kG$0U$N%*%V%8%'%/%H$H$N(B
cons $(B$K$h$C$FI=$o$9!#(B" :type '(repeat (cons :tag "option" (symbol :tag "tag") (sexp :tag "value"))) :group 'lookup-setup-variables)

(defcustom lookup-dictionary-options-alist nil "\
*$(B<-=q$N%*%W%7%g%s$r@_Dj$9$kO"A[%j%9%H!#(B
$(B3FMWAG$N(B car $(B$K$O<-=q(BID(\"CLASS+LOCATION:NAME\")$(B$r;XDj$7!"(B
cdr $(B$K$O%*%W%7%g%s$N%j%9%H$r;XDj$9$k!#(B" :type '(repeat (cons :tag "Dictionary" (string :tag "ID") (repeat :tag "options" (cons :tag "option" (symbol :tag "tag") (sexp :tag "value"))))) :group 'lookup-setup-variables)

(defgroup lookup-general-options nil "General customizable variables." :group 'lookup)

(defcustom lookup-default-method 'exact "\
*\\[lookup-pattern] $(B$G<B9T$5$l$kI8=`$N8!:wJ}<0!#(B
$(BJQ?t(B `lookup-word-search-methods' $(B$N$$$:$l$+$NCM$r;XDj2DG=!#(B" :type 'symbol :group 'lookup-general-options)

(defcustom lookup-frame-alist '((title . "Lookup") (menu-bar-lines . 0) (width . 48) (height . 32) (lookup-fill-column . 45)) "\
*Lookup $(B@lMQ%U%l!<%`$N%Q%i%a!<%?$N%j%9%H!#(B
$(B@_Dj$9$Y$-CM$K$D$$$F$O!"(B`default-frame-alist' $(B$r;2>H!#(B" :type '(repeat (cons :tag "Parameter" (symbol :tag "tag") (sexp :tag "value"))) :group 'lookup-general-options)

(defcustom lookup-fill-column 0.9 "\
*$(B%(%s%H%jFbMF$r(B fill $(B$9$k$H$-$N7e?t!#(B
$(B>.?t$r;XDj$7$?>l9g$O!"%&%#%s%I%&$NI}$KBP$9$k3d9g$H$7$FMQ$$$i$l$k!#(B" :type 'number :group 'lookup-general-options)

(defcustom lookup-window-height 4 "\
*Entry $(B%P%C%U%!Ey$N%&%#%s%I%&$N9b$5!#(B
$(B>.?t$r;XDj$7$?>l9g$O!"(BLookup $(BA4BN$N%&%#%s%I%&$N9b$5$KBP$9$k3d9g$H$7$F(B
$(BMQ$$$i$l$k!#(B" :type 'number :group 'lookup-general-options)

(defcustom lookup-save-configuration t "\
*Non-nil $(B$r;XDj$9$k$H!"(BLookup $(B$rH4$1$?$H$-$K%&%#%s%I%&>uBV$r2sI|$9$k!#(B" :type 'boolean :group 'lookup-general-options)

(defcustom lookup-use-bitmap (featurep 'bitmap) "\
*Non-nil $(B$r;XDj$9$k$H!"(Bbitmap-mule $(B%Q%C%1!<%8$rMxMQ$7$?30;zI=<($r9T$J$&!#(B" :type 'boolean :group 'lookup-general-options)

(defcustom lookup-use-kakasi nil "\
*Non-nil $(B$r;XDj$9$k$H!"$$$/$D$+$N6ILL$G(B KAKASI $(B$,MxMQ$5$l$k!#(B
$(B$3$l$O8=:_!"6qBNE*$K$OF|K\8l$N%G%U%)%k%H$N8!:w8l$N@Z$j=P$7$KMQ$$$F$$$k!#(B" :type 'boolean :group 'lookup-general-options)

(defcustom lookup-enable-gaiji t "\
*Non-nil $(B$r;XDj$9$k$H!"30;zI=<($,M-8z$H$J$k!#(B" :type 'boolean :group 'lookup-general-options)

(defcustom lookup-max-hits 50 "\
*$(B8!:w;~$KI=<($9$k%(%s%H%j$N:GBg?t!#(B
0 $(B$r;XDj$9$k$H!"8+$D$+$C$?A4$F$N%(%s%H%j$rI=<($9$k!#(B" :type 'integer :group 'lookup-general-options)

(defcustom lookup-max-text 10000 "\
*$(B8!:w;~$KI=<($9$k%(%s%H%jK\J8$N:GBgD9!#(B
0 $(B$r;XDj$9$k$H!"A4J8$rI=<($9$k!#(B" :type 'integer :group 'lookup-general-options)

(defcustom lookup-cite-header nil "\
*$(B%(%s%H%jK\J8$r0zMQ$9$k$H$-$N%X%C%@!#(B
$(B%3%^%s%I(B `lookup-entry-cite-content' $(B5Z$S(B `lookup-content-cite-region'
$(B$K$h$jFbMF$r<h$j9~$`$H$-!"$=$N@hF,$K;XDj$7$?J8;zNs$,IU$12C$($i$l$k!#(B
$(BJ8;zNs$,(B \"%T\" $(B$r4^$`>l9g!"<-=q$N%?%$%H%k$KCV$-49$($i$l$k!#(B
$(B<-=q%*%W%7%g%s(B `cite-header' $(B$,;XDj$5$l$F$$$k>l9g!"$=$A$i$,M%@h$5$l$k!#(B" :type 'string :group 'lookup-general-options)

(defcustom lookup-cite-prefix nil "\
*$(B%(%s%H%jK\J8$r0zMQ$9$k$H$-$N%W%l%U%#%/%9!#(B
$(B%3%^%s%I(B `lookup-entry-cite-content' $(B5Z$S(B `lookup-content-cite-region'
$(B$K$h$jFbMF$r<h$j9~$`$H$-!"3F9T$N@hF,$K;XDj$7$?J8;zNs$,IU$12C$($i$l$k!#(B
$(B<-=q%*%W%7%g%s(B `cite-preifx' $(B$,;XDj$5$l$F$$$k>l9g!"$=$A$i$,M%@h$5$l$k!#(B" :type 'string :group 'lookup-general-options)

(defcustom lookup-gaiji-alternate "_" "\
*$(B30;z$NBeBXJ8;zNs$H$7$FMQ$$$i$l$k%G%U%)%k%H$NJ8;zNs!#(B" :type 'string :group 'lookup-general-options)

(defcustom lookup-process-coding-system (when (featurep 'evi-mule) (if (memq system-type '(ms-dos windows-nt OS/2 emx)) (evi-coding-system 'sjis) (evi-coding-system 'euc-jp))) "\
*$(B30It%W%m%;%9$H$N%G%U%)%k%H$NJ8;z%3!<%I!#(B" :type 'symbol :group 'lookup-general-options)

(defcustom lookup-kakasi-coding-system lookup-process-coding-system "\
*KAKASI $(B$N8F$S=P$7$KMQ$$$kJ8;z%3!<%I!#(B" :type 'symbol :group 'lookup-general-options)

(defgroup lookup-faces nil "Faces." :group 'lookup)

;;;***

;;;### (autoloads (ndeb-process-coding-system ndeb-prompt-string ndeb-program-name ndeb) "ndeb" "lisp/ndeb.el")
(defconst custom-define-current-source-file "ndeb.el")

(defgroup ndeb nil "Lookup eblook interface." :group 'lookup-agents)

(defcustom ndeb-program-name "eblook" "\
*Program name of eblook." :type 'string :group 'ndeb)

(defcustom ndeb-prompt-string "eblook> " "\
*Prompt string of eblook." :type 'string :group 'ndeb)

(defcustom ndeb-process-coding-system lookup-process-coding-system "\
*Coding system for eblook process." :type 'symbol :group 'ndeb)

;;;***

;;;### (autoloads (ndic-dictzip-program ndic) "ndic" "lisp/ndic.el")
(defconst custom-define-current-source-file "ndic.el")

(defgroup ndic nil "Lookup by free dictionaries." :group 'lookup-agents)

(defcustom ndic-dictzip-program "dictzip" "\
*Program name of dictzip." :type 'string :group 'ndic)

;;;***

;;;### (autoloads (ndkks-process-coding-system ndkks-content-format ndkks-dictionary-title ndkks-program-name ndkks) "ndkks" "lisp/ndkks.el")
(defconst custom-define-current-source-file "ndkks.el")

(defgroup ndkks nil "Lookup KAKASI interface." :group 'lookup-agents)

(defcustom ndkks-program-name "kakasi" "\
*KAKASI $(B$N%W%m%0%i%`L>!#(B" :type 'string :group 'ndkks)

(defcustom ndkks-dictionary-title "$(B4A;z$+$J<-E5(B" "\
*ndkks $(B<-=q$N%?%$%H%k!#(B" :type 'string :group 'ndkks)

(defcustom ndkks-content-format '(t "\n" ("-JH") "\n" "$(B!Z?6$j2>L>![(B" ("-JH" "-f" "-p") "\n") "\
*ndkks $(B<-=q$,=PNO$9$k%(%s%H%jFbMF$N%U%)!<%^%C%H!#(B
$(B%j%9%H$N3FMWAG$H$7$F!"J8;zNs!"J8;zNs$N%j%9%H!"5Z$S(B `t' $(B$r;XDj$G$-$k!#(B
$(BJ8;zNs$N>l9g!"$=$l$,$=$N$^$^A^F~$5$l$k!#(B
$(B%j%9%H$N>l9g!"$=$l$r0z?t$H$7$F(B KAKASI $(B$,8F$S=P$5$l!"$=$N7k2L$,A^F~$5$l$k!#(B
`t' $(B$N>l9g!"8!:w8l$,A^F~$5$l$k!#(B" :type '(repeat (radio :tag "$(B=PNOFbMF(B" (const :tag "$(B8!:w8l(B" t) (string :tag "$(BJ8;zNs(B") (repeat :tag "KAKASI $(B8F$S=P$7(B" (string :tag "option")))) :group 'ndkks)

(defcustom ndkks-process-coding-system lookup-kakasi-coding-system "\
*Coding system for KAKASI process." :type 'symbol :group 'ndkks)

;;;***

;;;### (autoloads (ndnmz-program-name ndnmz) "ndnmz" "lisp/ndnmz.el")
(defconst custom-define-current-source-file "ndnmz.el")

(defgroup ndnmz nil "Lookup Namazu interface." :group 'lookup-agents)

(defcustom ndnmz-program-name "namazu" "\
*Program name of Namazu." :type 'string :group 'ndnmz)

;;;***

;;;### (autoloads (ndspell-process-coding-system ndspell-search-dictionaries ndspell-dictionary-title ndspell-words-dictionary ndspell-grep-program ndspell-ispell-program ndspell) "ndspell" "lisp/ndspell.el")
(defconst custom-define-current-source-file "ndspell.el")

(defgroup ndspell nil "Lookup spell checker." :group 'lookup-agents)

(defcustom ndspell-ispell-program "ispell" "\
*Program name of Ispell." :type 'string :group 'ndspell)

(defcustom ndspell-grep-program "grep" "\
*Program name of grep." :type 'string :group 'ndspell)

(defcustom ndspell-words-dictionary "/usr/share/dict/words" "\
*Dictionary file." :type 'file :group 'ndspell)

(defcustom ndspell-dictionary-title "Spell Checker" "\
*Title of ndspell dictionary." :type 'string :group 'ndspell)

(defcustom ndspell-search-dictionaries t "\
*List of dictionary ID to be searched by dynamic reference.
`t' means all selected dictionaries are used." :type '(radio (const :tag "Selected dictionaries" t) (repeat :tag "Specific dictionaries" (string :tag "ID"))) :group 'ndspell)

(defcustom ndspell-process-coding-system lookup-process-coding-system "\
*Coding system for Ispell process." :type 'symbol :group 'ndspell)

;;;***

;;;### (autoloads (ndsrd-process-coding-system ndsrd-program-name ndsrd) "ndsrd" "lisp/ndsrd.el")
(defconst custom-define-current-source-file "ndsrd.el")

(defgroup ndsrd nil "Lookup csrd interface." :group 'lookup-agents)

(defcustom ndsrd-program-name "csrd" "\
*csrd $(B$N%3%^%s%IL>!#(B" :type 'string :group 'ndsrd)

(defcustom ndsrd-process-coding-system lookup-process-coding-system "\
*Coding system for csrd process." :type 'symbol :group 'ndsrd)

;;;***

(provide 'lookup-custom-defines)
