;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ada-custom-defines) (error "Feature ada-custom-defines already loaded"))

;;;### (autoloads (ada-krunch-args ada-fill-comment-postfix ada-fill-comment-prefix ada-compiler-make ada-compiler-syntax-check ada-make-options ada-compile-options ada-tmp-directory ada-external-pretty-print-program ada-clean-buffer-before-saving ada-auto-case ada-case-attribute ada-case-identifier ada-case-keyword ada-language-version ada-search-directories ada-body-suffix-as-regexp ada-spec-suffix-as-regexp ada-body-suffix ada-spec-suffix ada-move-to-declaration ada-tab-policy ada-search-paren-char-count-limit ada-indent-to-open-paren ada-indent-is-separate ada-indent-comment-as-code ada-indent-record-rel-type ada-when-indent ada-stmt-end-indent ada-label-indent ada-broken-indent ada-indent ada) "ada-mode" "ada/ada-mode.el")
(defconst custom-define-current-source-file "ada-mode.el")

(defgroup ada nil "Major mode for editing Ada source in Emacs" :group 'languages)

(defcustom ada-indent 3 "\
*Defines the size of Ada indentation." :type 'integer :group 'ada)

(defcustom ada-broken-indent 2 "\
*# of columns to indent the continuation of a broken line." :type 'integer :group 'ada)

(defcustom ada-label-indent -4 "\
*# of columns to indent a label." :type 'integer :group 'ada)

(defcustom ada-stmt-end-indent 0 "\
*# of columns to indent a statement end keyword in a separate line.
Examples are 'is', 'loop', 'record', ..." :type 'integer :group 'ada)

(defcustom ada-when-indent 3 "\
*Defines the indentation for 'when' relative to 'exception' or 'case'." :type 'integer :group 'ada)

(defcustom ada-indent-record-rel-type 3 "\
*Defines the indentation for 'record' relative to 'type' or 'use'." :type 'integer :group 'ada)

(defcustom ada-indent-comment-as-code t "\
*If non-nil, comment-lines get indented as Ada code." :type 'boolean :group 'ada)

(defcustom ada-indent-is-separate t "\
*If non-nil, 'is separate' or 'is abstract' on a single line are indented." :type 'boolean :group 'ada)

(defcustom ada-indent-to-open-paren t "\
*If non-nil, indent according to the innermost open parenthesis." :type 'boolean :group 'ada)

(defcustom ada-search-paren-char-count-limit 3000 "\
*Search that many characters for an open parenthesis." :type 'integer :group 'ada)

(defcustom ada-tab-policy 'indent-auto "\
*Control behaviour of the TAB key.
Must be one of `indent-rigidly', `indent-auto', `gei', `indent-af'
or `always-tab'.

`indent-rigidly' : always adds ada-indent blanks at the beginning of the line.
`indent-auto'    : use indentation functions in this file.
`gei'            : use David Kgedal's Generic Indentation Engine.
`indent-af'      : use Gary E. Barnes' ada-format.el
`always-tab'     : do indent-relative." :type '(choice (const indent-auto) (const indent-rigidly) (const gei) (const indent-af) (const always-tab)) :group 'ada)

(defcustom ada-move-to-declaration nil "\
*If non-nil, `ada-move-to-start' moves point to the subprog declaration,
not to 'begin'." :type 'boolean :group 'ada)

(defcustom ada-spec-suffix ".ads" "\
*Suffix of Ada specification files." :type 'string :group 'ada)

(defcustom ada-body-suffix ".adb" "\
*Suffix of Ada body files." :type 'string :group 'ada)

(defcustom ada-spec-suffix-as-regexp "\\.ads$" "\
*Regexp to find Ada specification files." :type 'string :group 'ada)

(defcustom ada-body-suffix-as-regexp "\\.adb$" "\
*Regexp to find Ada body files." :type 'string :group 'ada)

(defcustom ada-search-directories '("." "/usr/adainclude" "/usr/local/adainclude" "/opt/gnu/adainclude") "\
*List of directories to search for Ada files.
See the description for the `ff-search-directories' variable." :type '(repeat (choice :tag "Directory" (const :tag "default" nil) (directory :format "%v"))) :group 'ada)

(defcustom ada-language-version 'ada95 "\
*Do we program in `ada83' or `ada95'?" :type '(choice (const ada83) (const ada95)) :group 'ada)

(defcustom ada-case-keyword 'downcase-word "\
*Function to call to adjust the case of Ada keywords.
It may be `downcase-word', `upcase-word', `ada-loose-case-word' or 
`capitalize-word'." :type '(choice (const downcase-word) (const upcase-word) (const capitalize-word) (const ada-loose-case-word)) :group 'ada)

(defcustom ada-case-identifier 'ada-loose-case-word "\
*Function to call to adjust the case of an Ada identifier.
It may be `downcase-word', `upcase-word', `ada-loose-case-word' or 
`capitalize-word'." :type '(choice (const downcase-word) (const upcase-word) (const capitalize-word) (const ada-loose-case-word)) :group 'ada)

(defcustom ada-case-attribute 'capitalize-word "\
*Function to call to adjust the case of Ada attributes.
It may be `downcase-word', `upcase-word', `ada-loose-case-word' or 
`capitalize-word'." :type '(choice (const downcase-word) (const upcase-word) (const capitalize-word) (const ada-loose-case-word)) :group 'ada)

(defcustom ada-auto-case t "\
*Non-nil automatically changes case of preceding word while typing.
Casing is done according to `ada-case-keyword', `ada-case-identifier'
and `ada-case-attribute'." :type 'boolean :group 'ada)

(defcustom ada-clean-buffer-before-saving t "\
*If non-nil, `remove-trailing-spaces' and `untabify' buffer before saving." :type 'boolean :group 'ada)

(defcustom ada-external-pretty-print-program "aimap" "\
*External pretty printer to call from within Ada mode." :type 'string :group 'ada)

(defcustom ada-tmp-directory "/tmp/" "\
*Directory to store the temporary file for the Ada pretty printer." :type 'string :group 'ada)

(defcustom ada-compile-options "-c" "\
*Buffer local options passed to the Ada compiler.
These options are used when the compiler is invoked on the current buffer." :type 'string :group 'ada)

(defcustom ada-make-options "-c" "\
*Buffer local options passed to `ada-compiler-make' (usually `gnatmake').
These options are used when `gnatmake' is invoked on the current buffer." :type 'string :group 'ada)

(defcustom ada-compiler-syntax-check "gcc -c -gnats" "\
*Compiler command with options for syntax checking." :type 'string :group 'ada)

(defcustom ada-compiler-make "gnatmake" "\
*The `make' command for the given compiler." :type 'string :group 'ada)

(defcustom ada-fill-comment-prefix "-- " "\
*This is inserted in the first columns when filling a comment paragraph." :type 'string :group 'ada)

(defcustom ada-fill-comment-postfix " --" "\
*This is inserted at the end of each line when filling a comment paragraph.
with `ada-fill-comment-paragraph-postfix'." :type 'string :group 'ada)

(defcustom ada-krunch-args "0" "\
*Argument of gnatkr, a string containing the max number of characters.
Set to 0, if you don't use crunched filenames." :type 'string :group 'ada)

;;;***

(provide 'ada-custom-defines)
