;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'apel-custom-defines) (error "Feature apel-custom-defines already loaded"))

;;;### (autoloads (default-mime-charset-detect-method-for-write default-mime-charset-for-write) "mcharset" "apel/mcharset.el")
(defconst custom-define-current-source-file "mcharset.el")

(defcustom default-mime-charset-for-write (if (mime-charset-p 'utf-8) 'utf-8 default-mime-charset) "\
Default value of MIME-charset for encoding.
It may be used when suitable MIME-charset is not found.
It must be symbol." :group 'i18n :type 'mime-charset)

(defcustom default-mime-charset-detect-method-for-write nil "\
Function called when suitable MIME-charset is not found to encode.
It must be nil or function.
If it is nil, variable `default-mime-charset-for-write' is used.
If it is a function, interface must be (TYPE CHARSETS &rest ARGS).
CHARSETS is list of charset.
If TYPE is 'region, ARGS has START and END." :group 'i18n :type '(choice function (const nil)))

;;;***

;;;### (autoloads (default-mime-charset mime-charset-to-coding-system-default-method mime-charset-coding-system-alist) "mcs-20" "apel/mcs-20.el")
(defconst custom-define-current-source-file "mcs-20.el")

(defcustom mime-charset-coding-system-alist (let ((rest '((us-ascii . raw-text) (gb2312 . cn-gb-2312) (cn-gb . cn-gb-2312) (iso-2022-jp-2 . iso-2022-7bit-ss2) (iso-2022-jp-3 . iso-2022-7bit-ss2) (tis-620 . tis620) (windows-874 . tis-620) (cp874 . tis-620) (x-ctext . ctext) (unknown . undecided) (x-unknown . undecided))) dest) (while rest (let ((pair (car rest))) (or (find-coding-system (car pair)) (setq dest (cons pair dest)))) (setq rest (cdr rest))) dest) "\
Alist MIME CHARSET vs CODING-SYSTEM.
MIME CHARSET and CODING-SYSTEM must be symbol." :group 'i18n :type '(repeat (cons symbol coding-system)))

(defcustom mime-charset-to-coding-system-default-method nil "\
Function called when suitable coding-system is not found from MIME-charset.
It must be nil or function.
If it is a function, interface must be (CHARSET LBT CODING-SYSTEM)." :group 'i18n :type '(choice function (const nil)))

(defcustom default-mime-charset 'x-unknown "\
Default value of MIME-charset.
It is used when MIME-charset is not specified.
It must be symbol." :group 'i18n :type 'mime-charset)

;;;***

;;;### (autoloads (mime-charset-decoder-alist) "mcs-xm" "apel/mcs-xm.el")
(defconst custom-define-current-source-file "mcs-xm.el")

(defcustom mime-charset-decoder-alist (let ((alist '((hz-gb-2312 . decode-mime-charset-region-for-hz) (t . decode-mime-charset-region-default)))) (if (featurep 'utf-2000) alist (list* '(iso-2022-jp . decode-mime-charset-region-with-iso646-unification) '(iso-2022-jp-2 . decode-mime-charset-region-with-iso646-unification) alist))) "\
Alist MIME-charset vs. decoder function." :group 'i18n :type '(repeat (cons mime-charset function)))

;;;***

;;;### (autoloads (mime-character-unification-limit-size mime-unified-character-face mime-iso646-character-unification-alist) "mcs-xmu" "apel/mcs-xmu.el")
(defconst custom-define-current-source-file "mcs-xmu.el")

(defcustom mime-iso646-character-unification-alist (eval-when-compile (let (dest (i 33)) (while (< i 92) (setq dest (cons (cons (char-to-string (make-char 'latin-jisx0201 i)) (format "%c" i)) dest)) (setq i (1+ i))) (setq i 93) (while (< i 126) (setq dest (cons (cons (char-to-string (make-char 'latin-jisx0201 i)) (format "%c" i)) dest)) (setq i (1+ i))) (nreverse dest))) "\
Alist unified string vs. canonical string." :group 'i18n :type '(repeat (cons string string)))

(defcustom mime-unified-character-face nil "\
Face of unified character." :group 'i18n :type 'face)

(defcustom mime-character-unification-limit-size 2048 "\
Limit size to unify characters.  It is referred by the function
`decode-mime-charset-region-with-iso646-unification'.  If the length of
the specified region (start end) is larger than its value, the function
works for only decoding MIME-CHARSET.  If it is nil, size is unlimited." :group 'i18n :type '(radio (integer :tag "Max size") (const :tag "Unlimited" nil)))

;;;***

(provide 'apel-custom-defines)
