;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'auctex-custom-defines) (error "Feature auctex-custom-defines already loaded"))

;;;### (autoloads (TeX-modes TeX-auto-global AUCTeX) "auto-autoloads" "auctex/auto-autoloads.el")
(defconst custom-define-current-source-file "auto-autoloads.el")

(defgroup AUCTeX nil "A (La)TeX environment." :tag "AUCTeX" :link '(custom-manual "(auctex)Top") :link '(url-link :tag "Home Page" "http://www.gnu.org/software/auctex/") :prefix "TeX-" :group 'tex :load "tex" :load "latex" :load "tex-style")

(defcustom TeX-auto-global "/usr/local/var/auctex/" "\
*Directory containing automatically generated information.
Must end with a directory separator.

For storing automatic extracted information about the TeX macros
shared by all users of a site." :group 'TeX-file :type 'directory)

(defcustom TeX-modes (mapcar 'car TeX-mode-alist) "\
List of modes provided by AUCTeX.

This variable can't be set normally; use customize for that, or
set it with `TeX-modes-set'." :type (cons 'set (mapcar (lambda (x) (list 'const (car x))) TeX-mode-alist)) :set 'TeX-modes-set :group 'AUCTeX :initialize (lambda (var value) (custom-initialize-reset var value) (unless (fboundp 'advice-add) (let ((list TeX-mode-alist)) (while list (eval-after-load (cdar list) (backquote (TeX-modes-set '(\, var) (\, var) t))) (setq list (cdr list)))))))

;;;***

;;;### (autoloads (bib-string-ignored-warning bib-substitute-string-in-display bib-ref-regexp bib-etags-filename bib-etags-append-command bib-etags-command bib-dos-or-os2-variable bib-cite-aux-inputs bib-cite-inputs bib-bibtex-env-variable bib-label-help-echo-format bib-highlight-mouse-t bib-switch-to-buffer-function bib-novice bib-cite-use-reftex-view-crossref bib-cite) "bib-cite" "auctex/bib-cite.el")
(defconst custom-define-current-source-file "bib-cite.el")

(defgroup bib-cite nil "bib-cite, LaTeX minor-mode to display \\cite, \\ref and \\label commands." :group 'tex)

(defcustom bib-cite-use-reftex-view-crossref nil "\
*Non-nil means, RefTeX will be used to find cross references.
When this variable is non-nil, both `bib-find' and `bib-display' will
call a function in RefTeX to find or display the cross reference of a
\\ref or \\cite macro at point." :group 'bib-cite :type 'boolean)

(defcustom bib-novice t "\
*Give advice to novice users about what commands to use next." :group 'bib-cite :type 'boolean)

(defcustom bib-switch-to-buffer-function 'switch-to-buffer "\
*Function used to select buffers if they differ from the original.
You may use `switch-to-buffer' `switch-to-buffer-other-window' or
`switch-to-buffer-other-frame'." :group 'bib-cite :type '(choice (function-item switch-to-buffer) (function-item switch-to-buffer-other-window) (function-item switch-to-buffer-other-frame)))

(defcustom bib-highlight-mouse-t t "\
*Call bib-highlight-mouse from `LaTeX-mode-hook' to add green highlight." :group 'bib-cite :type 'boolean)

(defcustom bib-label-help-echo-format "button2 finds %s, button3 displays %s" "\
*Format string for info if the mouse is over LaTeX commands.
If nil, do not display info." :group 'bib-cite :type '(radio (const :tag "Don't display info" nil) string))

(defcustom bib-bibtex-env-variable "BIBINPUTS" "\
*Environment variable setting the path where BiBTeX input files are found.
BiBTeX 0.99b manual says this should be TEXBIB.
Another version says it should BSTINPUTS.  I don't know anymore!

The colon character (:) is the default path separator in unix, but you may
use semi-colon (;) for DOS or OS/2 if you set bib-dos-or-os2-variable to t." :group 'bib-cite :type 'string)

(defcustom bib-cite-inputs nil "\
*List of directories to search for .bib files.
This is in addition to those listed in the environment variable specified by
`bib-bibtex-env-variable'." :group 'bib-cite :type '(repeat (file :format "%v")))

(defcustom bib-cite-aux-inputs nil "\
*List of directories to search for .aux files.
MiKTeX has the LaTeX option -aux-directory to store .aux files in an alternate
directory.  You may set this variable to let bib-cite find these .aux files." :group 'bib-cite :type '(repeat (file :format "%v")))

(defcustom bib-dos-or-os2-variable (or (equal 'emx system-type) (equal 'ms-dos system-type)) "\
*Whether you use DOS or OS/2 for bib-make-bibliography/bib-display.

It tells bib-make-bibliography and bib-display to translate
the BIBINPUTS environment variable using the \";\" character as
a path separator and to translate DOS' backslash to slash.

e.g. Use a path like \"c:\\emtex\\bibinput;c:\\latex\\bibinput\"

\(You can change the environment variable which is searched by setting the  elisp variable bib-bibtex-env-variable)" :group 'bib-cite :type 'boolean)

(defcustom bib-etags-command "etags -r '/.*\\\\\\(eq\\|page\\|[fvF]\\)ref.*/' -o " "\
*Variable for the etags command and its output option.
In unix, this is usually \"etags -r '/.*\\(eq|page|[fvF])ref.*/' -o \"
\(we use the -r option to tell etags to list AMS-LaTeX's \\eqref command.)
In DOS and OS/2, this *may* be different, e.g. using slashes like \"etags /o=\"
If so, set it this variable." :group 'bib-cite :type 'string)

(defcustom bib-etags-append-command "etags -r '/.*\\\\\\(eq\\|page\\|[fvF]\\)ref.*/' -a -o " "\
*Variable for the etags command and its append and output option.
In unix, this is usually \"etags -r '/.*\\(eq|page|[fvF])ref.*/' -a -o \"
In DOS and OS/2, this *may* be \"etags /a /o=\"  If so, set it this variable." :group 'bib-cite :type 'string)

(defcustom bib-etags-filename "TAGS" "\
*Variable for the filename generated by etags, by defaults this TAGS.
but you may want to change this to something like TAGSLaTeX such that it can
coexist with some other tags file in your master file directory." :group 'bib-cite :type 'string)

(defcustom bib-ref-regexp "\\\\\\(eq\\|page\\|[fvF]\\)?ref" "\
*Regular expression for \\ref LaTeX commands that have a matching \\label.
without the curly bracket.

If you change this variable and you use multi-file documents, make sure you
also edit the variables bib-etags-command and bib-etags-append-command." :group 'bib-cite :type 'regexp)

(defcustom bib-substitute-string-in-display t "\
*Determines if bib-display will substitute @string definitions.
If t, then the @string text is substituted.
If nil, the text is not substituted but the @string entry is included." :group 'bib-cite :type 'boolean)

(defcustom bib-string-ignored-warning '("jan" "feb" "mar" "apr" "may" "jun" "jul" "aug" "sep" "sept" "oct" "nov" "dec" "acmcs" "acta" "cacm" "ibmjrd" "ibmjs" "ieeese" "ieeetcad" "ieeetc" "ipl" "jacm" "jcss" "scp" "sicomp" "tcs" "tocs" "tods" "tog" "toms" "toois" "toplas") "\
*@string abbreviations for which a warning is not given if not defined.
These are usually month abbreviations (or journals) defined in a style file." :group 'bib-cite :type '(repeat (string :tag "Entry")))

;;;***

;;;### (autoloads (ConTeXt-default-environment-en) "context-en" "auctex/context-en.el")
(defconst custom-define-current-source-file "context-en.el")

(defcustom ConTeXt-default-environment-en "itemize" "\
*The default environment when creating new ones with `ConTeXt-environment'." :group 'ConTeXt-en-environment :type 'string)

;;;***

;;;### (autoloads (ConTeXt-default-environment-nl) "context-nl" "auctex/context-nl.el")
(defconst custom-define-current-source-file "context-nl.el")

(defcustom ConTeXt-default-environment-nl "opsomming" "\
*The default environment when creating new ones with `ConTeXt-environment'." :group 'ConTeXt-nl-environment :type 'string)

;;;***

;;;### (autoloads (ConTeXt-clean-output-suffixes ConTeXt-clean-intermediate-suffixes ConTeXt-font-list ConTeXt-default-environment ConTeXt-environment ConTeXt-unnumbered-section-hook ConTeXt-numbered-section-hook ConTeXt-default-interface ConTeXt-macro) "context" "auctex/context.el")
(defconst custom-define-current-source-file "context.el")

(defgroup ConTeXt-macro nil "Special support for ConTeXt macros in AUCTeX." :prefix "TeX-" :group 'ConTeXt :group 'TeX-macro)

(defcustom ConTeXt-default-interface "en" "\
Default interface to be used when running ConTeXt." :group 'ConTeXt :type 'string)

(defcustom ConTeXt-numbered-section-hook '(ConTeXt-numbered-section-heading ConTeXt-section-title ConTeXt-section-ref ConTeXt-section-section) "\
List of hooks to run when a new section is inserted.

The following variables are set before the hooks are run

level - numeric section level, see the documentation of `ConTeXt-section'.
name - name of the sectioning command, derived from `level'.
title - The title of the section, default to an empty string.
`done-mark' - Position of point afterwards, default nil (meaning end).

The following standard hook exist -

ConTeXt-section-heading: Query the user about the name of the
sectioning command.  Modifies `level' and `name'.

ConTeXt-section-title: Query the user about the title of the
section.  Modifies `title'.

ConTeXt-section-section: Insert ConTeXt section command according to
`name', `title', and `reference'.  If `title' is an empty string,
`done-mark' will be placed at the point they should be inserted.

ConTeXt-section-ref: Insert a reference for this section command.

To get a full featured `ConTeXt-section' command, insert

 (setq ConTeXt-numbered-section-hook
			 '(ConTeXt-numbered-section-heading
				 ConTeXt-section-title
				 ConTeXt-section-section
				 ConTeXt-section-ref))

in your .emacs file." :group 'ConTeXt-macro :type 'hook :options '(ConTeXt-numbered-section-heading ConTeXt-section-title ConTeXt-section-ref ConTeXt-section-section))

(defcustom ConTeXt-unnumbered-section-hook '(ConTeXt-unnumbered-section-heading ConTeXt-section-title ConTeXt-section-ref ConTeXt-section-section) "\
List of hooks to run when a new section is inserted.

The following variables are set before the hooks are run

level - numeric section level, see the documentation of `ConTeXt-section'.
name - name of the sectioning command, derived from `level'.
title - The title of the section, default to an empty string.
`done-mark' - Position of point afterwards, default nil (meaning end).

The following standard hook exist -

ConTeXt-section-heading: Query the user about the name of the
sectioning command.  Modifies `level' and `name'.

ConTeXt-section-title: Query the user about the title of the
section.  Modifies `title'.

ConTeXt-section-section: Insert ConTeXt section command according to
`name', `title', and `reference'.  If `title' is an empty string,
`done-mark' will be placed at the point they should be inserted.

ConTeXt-section-ref: Insert a reference for this section command.

To get a full featured `ConTeXt-section' command, insert

 (setq ConTeXt-unnumbered-section-hook
			 '(ConTeXt-unnumbered-section-heading
				 ConTeXt-section-title
				 ConTeXt-section-section
				 ConTeXt-section-ref))

in your .emacs file." :group 'ConTeXt-macro :type 'hook :options '(ConTeXt-unnumbered-section-heading ConTeXt-section-title ConTeXt-section-ref ConTeXt-section-section))

(defgroup ConTeXt-environment nil "Environments in AUCTeX." :group 'ConTeXt-macro)

(defcustom ConTeXt-default-environment "itemize" "\
*The default environment when creating new ones with `ConTeXt-environment'." :group 'ConTeXt-environment :type 'string)

(defcustom ConTeXt-font-list '((?\^B "{\\bf " "}") (?\^C "{\\sc " "}") (?\^E "{\\em " "}") (?\t "{\\it " "}") (?\^R "{\\rm " "}") (?\^S "{\\sl " "}") (?\^T "{\\tt " "}") (?\^D "" "" t)) "\
List of fonts used by `TeX-font'.

Each entry is a list.
The first element is the key to activate the font.
The second element is the string to insert before point, and the third
element is the string to insert after point.
If the fourth and fifth element are strings, they specify the prefix and
suffix to be used in math mode.
An optional fourth (or sixth) element means always replace if t." :group 'TeX-macro :type '(repeat (group :value (?\^A "" "") (character :tag "Key") (string :tag "Prefix") (string :tag "Suffix") (option (group :inline t (string :tag "Math Prefix") (string :tag "Math Suffix"))) (option (sexp :format "Replace
" :value t)))))

(defcustom ConTeXt-clean-intermediate-suffixes '("\\.tui" "\\.tup" "\\.ted" "\\.tes" "\\.top" "\\.log" "\\.tmp" "\\.run" "\\.bck" "\\.rlg" "\\.mpt" "\\.mpx" "\\.mpd" "\\.mpo" "\\.tuo" "\\.tub" "\\.top" "-mpgraph\\.mp" "-mpgraph\\.mpd" "-mpgraph\\.mpo" "-mpgraph\\.mpy" "-mprun\\.mp" "-mprun\\.mpd" "-mprun\\.mpo" "-mprun\\.mpy") "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

(defcustom ConTeXt-clean-output-suffixes '("\\.dvi" "\\.pdf" "\\.ps") "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

;;;***

;;;### (autoloads (font-latex-math-environments font-latex-script-display font-latex-fontify-script font-latex-user-keyword-classes font-latex-deactivated-keyword-classes font-latex-fontify-sectioning font-latex-quotes font-latex-highlighting-faces font-latex-keywords font-latex) "font-latex" "auctex/font-latex.el")
(defconst custom-define-current-source-file "font-latex.el")

(defgroup font-latex nil "Font-latex text highlighting package." :prefix "font-latex-" :group 'faces :group 'tex :group 'AUCTeX)

(defgroup font-latex-keywords nil "Keywords for highlighting text in font-latex." :prefix "font-latex-" :group 'font-latex)

(defgroup font-latex-highlighting-faces nil "Faces for highlighting text in font-latex." :prefix "font-latex-" :group 'font-latex)

(defcustom font-latex-quotes 'auto "\
Whether to fontify << French quotes >> or >>German quotes<<.
Also selects \"<quote\"> versus \">quote\"<.

If value `auto' is chosen, an attempt is being made in deriving
the type of quotation mark matching from document settings like
the language option supplied to the babel package.

If nil, quoted content will not be fontified." :type '(choice (const auto) (const french) (const german) (const nil)) :group 'font-latex)

(defcustom font-latex-fontify-sectioning 1.1 "\
Whether to fontify sectioning macros with varying height or a color face.

If it is a number, use varying height faces.  The number is used
for scaling starting from `font-latex-sectioning-5-face'.  Typically
values from 1.05 to 1.3 give best results, depending on your font
setup.  If it is the symbol `color', use `font-lock-type-face'.

Caveats: Customizing the scaling factor applies to all sectioning
faces unless those face have been saved by customize.  Setting
this variable directly does not take effect unless you call
`font-latex-update-sectioning-faces' or restart Emacs.

Switching from `color' to a number or vice versa does not take
effect unless you call \\[font-lock-fontify-buffer] or restart
Emacs." :type '(choice (number :tag "Scale factor") (const color)) :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (unless (eq value 'color) (font-latex-update-sectioning-faces font-latex-sectioning-max value))) :group 'font-latex)

(defcustom font-latex-deactivated-keyword-classes nil "\
List of strings for built-in keyword classes to be deactivated.

Valid entries are \"warning\", \"variable\", \"reference\",
\"function\" , \"sectioning-0\", \"sectioning-1\", \"sectioning-2\",
\"sectioning-3\", \"sectioning-4\", \"sectioning-5\", \"textual\",
\"bold-command\", \"italic-command\", \"math-command\", \"type-command\",
\"bold-declaration\", \"italic-declaration\", \"type-declaration\".

You have to restart Emacs for a change of this variable to take effect." :group 'font-latex-keywords :type (backquote (set (\,@ (mapcar (lambda (spec) (backquote (const :tag (\, (concat (let ((name (split-string (car spec) "-"))) (setcar name (capitalize (car name))) (mapconcat 'identity name " ")) " keywords in `" (symbol-name (eval (nth 2 spec))) "'.
" (with-temp-buffer (insert "  Keywords: " (mapconcat (lambda (x) (if (listp x) (car x) x)) (nth 1 spec) ", ")) (fill-paragraph nil) (buffer-substring-no-properties (point-min) (point-max))))) (\, (car spec))))) font-latex-built-in-keyword-classes)))))

(defcustom font-latex-user-keyword-classes nil "\
List of user-defined keyword classes for font locking.

Every keyword class consists of four parts, a name, a list of
keywords, a face and a specifier for the type of macro to be
highlighted.

When adding new entries, you have to use unique values for the
class names, i.e. they must not clash with names of the built-in
keyword classes or other names given by you.  Additionally the
names must not contain spaces.

The list of keywords defines which commands and declarations
should be covered by the keyword class.  A keyword can either be
a simple command name omitting the leading backslash or a list
consisting of the command name and a string specifying the syntax
of the command.  The latter is useful if you want to match LaTeX
macros with arguments (see below).  You can specify the occurence
and order of optional (\"[\") and mandatory (\"{\") arguments for
each keyword.  For example for \"documentclass\" you'd use \"[{\"
because the macro has one optional followed by one mandatory
argument.  Optionally starred macros can be indicated with \"*\".
In case an argument is an unbraced macro, use \"\\\".  You can
also specify two alternative arguments by prefixing them with
\"|\".  As an example, the specifier for \\newcommand is
\"*|{\\=\\[[{\".

The face argument can either be an existing face or a font
specification.  (The latter option is not available in XEmacs.)

There are three alternatives for the class type:

A value of `command' indicates commands with arguments
\(\"\\foo[bar]{baz}\").  The mandatory arguments in curly braces
will get the face you specified.

A value of `declaration' indicates declarations inside of TeX
groups (\"{\\foo bar}\").  The content inside the braces,
excluding the command, will get the face you specified.  In case
the braces are missing, the face will be applied to the command
itself.

A value of `noarg' indicates commands without arguments
\(\"\\foo\").  The command itself will get the face you
specified.

Setting this variable directly does not take effect;
use \\[customize] or restart Emacs." :group 'font-latex-keywords :type (backquote (repeat (list (string :tag "Name") (choice (repeat :tag "Keywords" (string :tag "Keyword")) (repeat :tag "Keywords with specs" (group (string :tag "Keyword") (string :tag "Format specifier")))) (\, (if (featurep 'xemacs) '(face :tag "Face name") '(choice (custom-face-edit :tag "Face attributes") (face :tag "Face name")))) (choice :tag "Type" (const :tag "Command with arguments" command) (const :tag "Declaration inside TeX group" declaration) (const :tag "Command without arguments" noarg))))) :set (lambda (symbol value) (dolist (item value) (when (string-match " " (car item)) (error "No spaces allowed in name"))) (let (names names-uniq) (dolist (item (append font-latex-built-in-keyword-classes value)) (setq names (append names (list (car item))))) (setq names (TeX-sort-strings names)) (setq names-uniq (TeX-delete-duplicate-strings names)) (dotimes (i (safe-length names-uniq)) (unless (string= (nth i names) (nth i names-uniq)) (error "Name %S already exists" (nth i names))))) (set-default symbol value) (let ((prefix "font-latex-match-")) (dolist (elt value) (unless (boundp (intern (concat prefix (car elt)))) (eval (backquote (defvar (\, (intern (concat prefix (car elt)))) nil)))) (let ((keywords (nth 1 elt)) single-char-macro-flag) (setq keywords (if (listp (car keywords)) (mapcar 'car keywords) keywords)) (catch 'single-char (dolist (keyword keywords) (unless (string-match "^[A-Za-z]" keyword) (setq single-char-macro-flag t) (throw 'single-char nil)))) (set (intern (concat prefix (car elt))) (when (> (safe-length keywords) 0) (concat "\\\\" (let ((max-specpdl-size 1000)) (regexp-opt keywords t)) (unless single-char-macro-flag "\\>")))))))))

(defcustom font-latex-fontify-script (not (featurep 'xemacs)) "\
If non-nil, fontify subscript and superscript strings.
This feature does not work in XEmacs." :type 'boolean :group 'font-latex)

(defcustom font-latex-script-display '((raise -0.3) raise 0.3) "\
Display specification for subscript and superscript content.
The car is used for subscript, the cdr is used for superscripts." :group 'font-latex :type '(cons (choice (sexp :tag "Subscript form") (const :tag "No lowering" nil)) (choice (sexp :tag "Superscript form") (const :tag "No raising" nil))))

(defcustom font-latex-math-environments '("display" "displaymath" "equation" "eqnarray" "gather" "multline" "align" "alignat" "xalignat" "xxalignat" "flalign") "\
List of math environment names for font locking." :type '(repeat string) :group 'font-latex)

;;;***

;;;### (autoloads (LaTeX-clean-output-suffixes LaTeX-clean-intermediate-suffixes docTeX-clean-output-suffixes docTeX-clean-intermediate-suffixes LaTeX-mode-hook TeX-arg-right-insert-p TeX-arg-item-label-p TeX-arg-footnote-number-p TeX-arg-cite-note-p LaTeX-macro LaTeX-enable-toolbar LaTeX-babel-hyphen-language-alist LaTeX-babel-hyphen-after-hyphen LaTeX-babel-hyphen LaTeX-font-list LaTeX-submenu-name-format LaTeX-menu-max-items LaTeX-fold-math-spec-list LaTeX-fold-env-spec-list LaTeX-fold-macro-spec-list LaTeX-math-insert-function LaTeX-math-list LaTeX-math-abbrev-prefix LaTeX-math-menu-unicode LaTeX-math LaTeX-paragraph-commands LaTeX-fill-break-before-code-comments LaTeX-fill-break-at-separators LaTeX-indent-comment-start-regexp LaTeX-left-right-indent-level LaTeX-end-regexp LaTeX-begin-regexp LaTeX-verbatim-regexp LaTeX-document-regexp LaTeX-indent-environment-check LaTeX-indent-environment-list LaTeX-item-regexp LaTeX-item-indent LaTeX-indent-level LaTeX-indentation LaTeX-syntactic-comments LaTeX-verbatim-environments LaTeX-verbatim-macros-with-braces LaTeX-verbatim-macros-with-delims LaTeX-default-author LaTeX-electric-left-right-brace TeX-braces-user-association LaTeX-default-verb-delimiter TeX-date-format TeX-arg-input-file-search LaTeX-search-files-type-alist LaTeX-style-list LaTeX-label-alist LaTeX-eqnarray-label LaTeX-equation-label LaTeX-default-position LaTeX-default-width LaTeX-default-format LaTeX-table-label LaTeX-figure-label LaTeX-label-function LaTeX-label LaTeX-top-caption-list LaTeX-float LaTeX-default-environment LaTeX-environment LaTeX-section-label LaTeX-section-hook TeX-outline-extra LaTeX-insert-into-comments LaTeX-default-options LaTeX-default-style) "latex" "auctex/latex.el")
(defconst custom-define-current-source-file "latex.el")

(defcustom LaTeX-default-style "article" "\
*Default when creating new documents." :group 'LaTeX-environment :type 'string)

(defcustom LaTeX-default-options nil "\
Default options to documentclass.
A comma-seperated list of strings." :group 'LaTeX-environment :type '(repeat (string :format "%v")))

(defcustom LaTeX-insert-into-comments t "\
*Whether insertion commands stay in comments.
This allows using the insertion commands even when
the lines are outcommented, like in dtx files." :group 'LaTeX-environment :type 'boolean)

(defcustom TeX-outline-extra nil "\
List of extra TeX outline levels.

Each element is a list with two entries.  The first entry is the
regular expression matching a header, and the second is the level of
the header.  See `LaTeX-section-list' for existing header levels." :group 'LaTeX :type '(repeat (group (regexp :tag "Match") (integer :tag "Level"))))

(defcustom LaTeX-section-hook '(LaTeX-section-heading LaTeX-section-title LaTeX-section-section LaTeX-section-label) "\
List of hooks to run when a new section is inserted.

The following variables are set before the hooks are run

level - numeric section level, see the documentation of `LaTeX-section'.
name - name of the sectioning command, derived from `level'.
title - The title of the section, default to an empty string.
toc - Entry for the table of contents list, default nil.
done-mark - Position of point afterwards, default nil (meaning end).

The following standard hook exist -

LaTeX-section-heading: Query the user about the name of the
sectioning command.  Modifies `level' and `name'.

LaTeX-section-title: Query the user about the title of the
section.  Modifies `title'.

LaTeX-section-toc: Query the user for the toc entry.  Modifies
`toc'.

LaTeX-section-section: Insert LaTeX section command according to
`name', `title', and `toc'.  If `toc' is nil, no toc entry is
inserted.  If `toc' or `title' are empty strings, `done-mark' will be
placed at the point they should be inserted.

LaTeX-section-label: Insert a label after the section command.
Controled by the variable `LaTeX-section-label'.

To get a full featured `LaTeX-section' command, insert

 (setq LaTeX-section-hook
       '(LaTeX-section-heading
	 LaTeX-section-title
	 LaTeX-section-toc
	 LaTeX-section-section
	 LaTeX-section-label))

in your .emacs file." :group 'LaTeX-macro :type 'hook :options '(LaTeX-section-heading LaTeX-section-title LaTeX-section-toc LaTeX-section-section LaTeX-section-label))

(defcustom LaTeX-section-label '(("part" . "part:") ("chapter" . "chap:") ("section" . "sec:") ("subsection" . "sec:") ("subsubsection" . "sec:")) "\
Default prefix when asking for a label.

Some LaTeX packages (such as `fancyref') look at the prefix to generate some
text around cross-references automatically.  When using those packages, you
should not change this variable.

If it is a string, it it used unchanged for all kinds of sections.
If it is nil, no label is inserted.
If it is a list, the list is searched for a member whose car is equal
to the name of the sectioning command being inserted.  The cdr is then
used as the prefix.  If the name is not found, or if the cdr is nil,
no label is inserted." :group 'LaTeX-label :type '(choice (const :tag "none" nil) (string :format "%v" :tag "Common") (repeat :menu-tag "Level specific" :format "
%v%i" (cons :format "%v" (string :tag "Type") (choice :tag "Prefix" (const :tag "none" nil) (string :format "%v"))))))

(defgroup LaTeX-environment nil "Environments in AUCTeX." :group 'LaTeX-macro)

(defcustom LaTeX-default-environment "itemize" "\
*The default environment when creating new ones with `LaTeX-environment'.
It is overridden by `LaTeX-default-document-environment' when it
is non-nil and the current environment is \"document\"." :group 'LaTeX-environment :type 'string)

(defcustom LaTeX-float "" "\
Default float position for figures and tables.
If nil, act like the empty string is given, but do not prompt.
\(The standard LaTeX classes use [tbp] as float position if the
optional argument is omitted.)" :group 'LaTeX-environment :type '(choice (const :tag "Do not prompt" nil) (const :tag "Empty" "") (string :format "%v")))

(defcustom LaTeX-top-caption-list nil "\
*List of float environments with top caption." :group 'LaTeX-environment :type '(repeat (string :format "%v")))

(defgroup LaTeX-label nil "Adding labels for LaTeX commands in AUCTeX." :group 'LaTeX)

(defcustom LaTeX-label-function nil "\
*A function inserting a label at point.
Sole argument of the function is the environment.  The function has to return
the label inserted, or nil if no label was inserted." :group 'LaTeX-label :type 'function)

(defcustom LaTeX-figure-label "fig:" "\
*Default prefix to figure labels." :group 'LaTeX-label :group 'LaTeX-environment :type 'string)

(defcustom LaTeX-table-label "tab:" "\
*Default prefix to table labels." :group 'LaTeX-label :group 'LaTeX-environment :type 'string)

(defcustom LaTeX-default-format "" "\
Default format for array and tabular environments." :group 'LaTeX-environment :type 'string)

(defcustom LaTeX-default-width "1.0\\linewidth" "\
Default width for minipage and tabular* environments." :group 'LaTeX-environment :type 'string)

(defcustom LaTeX-default-position "" "\
Default position for array and tabular environments.
If nil, act like the empty string is given, but do not prompt." :group 'LaTeX-environment :type '(choice (const :tag "Do not prompt" nil) (const :tag "Empty" "") string))

(defcustom LaTeX-equation-label "eq:" "\
*Default prefix to equation labels." :group 'LaTeX-label :type 'string)

(defcustom LaTeX-eqnarray-label LaTeX-equation-label "\
*Default prefix to eqnarray labels." :group 'LaTeX-label :type 'string)

(defcustom LaTeX-label-alist '(("figure" . LaTeX-figure-label) ("table" . LaTeX-table-label) ("figure*" . LaTeX-figure-label) ("table*" . LaTeX-table-label) ("equation" . LaTeX-equation-label) ("eqnarray" . LaTeX-eqnarray-label)) "\
Lookup prefixes for labels.
An alist where the CAR is the environment name, and the CDR
either the prefix or a symbol referring to one.

If the name is not found, or if the CDR is nil, no label is
automatically inserted for that environment.

If you want to automatically insert a label for a environment but
with an empty prefix, use the empty string \"\" as the CDR of the
corresponding entry." :group 'LaTeX-label :type '(repeat (cons (string :tag "Environment") (choice (string :tag "Label prefix") (symbol :tag "Label prefix symbol")))))

(defcustom LaTeX-style-list '(("amsart") ("amsbook") ("article") ("beamer") ("book") ("dinbrief") ("foils") ("letter") ("memoir") ("minimal") ("prosper") ("report") ("scrartcl") ("scrbook") ("scrlttr2") ("scrreprt") ("slides")) "\
List of document classes offered when inserting a document environment.

If `TeX-arg-input-file-search' is set to `t', you will get
completion with all LaTeX classes available in your distribution
and this variable will be ignored." :group 'LaTeX-environment :type '(repeat (group (string :format "%v"))))

(defcustom LaTeX-search-files-type-alist '((texinputs "${TEXINPUTS.latex}" ("tex/generic/" "tex/latex/") TeX-file-extensions) (docs "${TEXDOCS}" ("doc/") TeX-doc-extensions) (graphics "${TEXINPUTS}" ("tex/") LaTeX-includegraphics-extensions) (bibinputs "${BIBINPUTS}" ("bibtex/bib/") BibTeX-file-extensions) (bstinputs "${BSTINPUTS}" ("bibtex/bst/") BibTeX-style-extensions) (bbxinputs "" ("tex/latex/") BibLaTeX-style-extensions) (biberinputs "${BIBINPUTS}" ("bibtex/bib/") TeX-Biber-file-extensions)) "\
Alist of filetypes with locations and file extensions.
Each element of the alist consists of a symbol expressing the
filetype, a variable which can be expanded on kpathsea-based
systems into the directories where files of the given type
reside, a list of absolute directories, relative directories
below the root of a TDS-compliant TeX tree or a list of variables
with either type of directories as an alternative for
non-kpathsea-based systems and a list of extensions to be matched
upon a file search.  Note that the directories have to end with a
directory separator.

Reset the mode for a change of this variable to take effect." :group 'TeX-file :type '(alist :key-type symbol :value-type (group (string :tag "Kpathsea variable") (choice :tag "Directories" (repeat :tag "TDS subdirectories" string) (repeat :tag "Absolute directories" directory) (repeat :tag "Variables" variable)) (choice :tag "Extensions" variable (repeat string)))))

(defcustom TeX-arg-input-file-search t "\
If `TeX-arg-input-file' should search for files.
If the value is t, files in TeX's search path are searched for
and provided for completion.  The file name is then inserted
without directory and extension.  If the value is nil, the file
name can be specified manually and is inserted with a path
relative to the directory of the current buffer's file and with
extension.  If the value is `ask', you are asked for the method
to use every time `TeX-arg-input-file' is called." :group 'LaTeX-macro :type '(choice (const t) (const nil) (const ask)))

(defcustom TeX-date-format "%Y/%m/%d" "\
The default date format prompted by `TeX-arg-date'." :group 'LaTeX-macro :type 'string)

(defcustom LaTeX-default-verb-delimiter ?| "\
Default delimiter for `\\verb' macros." :group 'LaTeX-macro :type 'character)

(defcustom TeX-braces-user-association nil "\
A list of your personal association of brace symbols.
These are used for \\left and \\right.

The car of each entry is the brace used with \\left,
the cdr is the brace used with \\right." :group 'LaTeX-macro :group 'LaTeX-math :type '(repeat (cons :format "%v" (string :tag "Left") (string :tag "Right"))))

(defcustom LaTeX-electric-left-right-brace nil "\
If non-nil, insert right brace with suitable macro after typing left brace." :group 'LaTeX-macro :type 'boolean)

(defcustom LaTeX-default-author 'user-full-name "\
Initial input to `LaTeX-arg-author' prompt.
If nil, do not prompt at all." :group 'LaTeX-macro :type '(choice (const :tag "User name in Emacs" user-full-name) (const :tag "Do not prompt" nil) string))

(defcustom LaTeX-verbatim-macros-with-delims '("verb" "verb*") "\
Macros for inline verbatim with arguments in delimiters, like \\foo|...|.

Programs should not use this variable directly but the function
`LaTeX-verbatim-macros-with-delims' which returns a value
including buffer-local keyword additions via
`LaTeX-verbatim-macros-with-delims-local' as well." :group 'LaTeX-macro :type '(repeat (string)))

(defcustom LaTeX-verbatim-macros-with-braces nil "\
Macros for inline verbatim with arguments in braces, like \\foo{...}.

Programs should not use this variable directly but the function
`LaTeX-verbatim-macros-with-braces' which returns a value
including buffer-local keyword additions via
`LaTeX-verbatim-macros-with-braces-local' as well." :group 'LaTeX-macro :type '(repeat (string)))

(defcustom LaTeX-verbatim-environments '("verbatim" "verbatim*") "\
Verbatim environments.

Programs should not use this variable directly but the function
`LaTeX-verbatim-environments' which returns a value including
buffer-local keyword additions via
`LaTeX-verbatim-environments-local' as well." :group 'LaTeX-environment :type '(repeat (string)))

(defcustom LaTeX-syntactic-comments t "\
If non-nil comments will be handled according to LaTeX syntax.
This variable influences, among others, the behavior of
indentation and filling which will take LaTeX syntax into
consideration just as is in the non-commented source code." :type 'boolean :group 'LaTeX)

(defgroup LaTeX-indentation nil "Indentation of LaTeX code in AUCTeX" :group 'LaTeX :group 'TeX-indentation)

(defcustom LaTeX-indent-level 2 "\
*Indentation of begin-end blocks in LaTeX." :group 'LaTeX-indentation :type 'integer)

(defcustom LaTeX-item-indent (- LaTeX-indent-level) "\
*Extra indentation for lines beginning with an item." :group 'LaTeX-indentation :type 'integer)

(defcustom LaTeX-item-regexp "\\(bib\\)?item\\b" "\
*Regular expression matching macros considered items." :group 'LaTeX-indentation :type 'regexp)

(defcustom LaTeX-indent-environment-list '(("verbatim" current-indentation) ("verbatim*" current-indentation) ("tabular" LaTeX-indent-tabular) ("tabular*" LaTeX-indent-tabular) ("align" LaTeX-indent-tabular) ("align*" LaTeX-indent-tabular) ("array" LaTeX-indent-tabular) ("eqnarray" LaTeX-indent-tabular) ("eqnarray*" LaTeX-indent-tabular) ("displaymath") ("equation") ("equation*") ("picture") ("tabbing") ("table") ("table*")) "\
Alist of environments with special indentation.
The second element in each entry is the function to calculate the
indentation level in columns." :group 'LaTeX-indentation :type '(repeat (list (string :tag "Environment") (option function))))

(defcustom LaTeX-indent-environment-check t "\
*If non-nil, check for any special environments." :group 'LaTeX-indentation :type 'boolean)

(defcustom LaTeX-document-regexp "document" "\
Regexp matching environments in which the indentation starts at col 0." :group 'LaTeX-indentation :type 'regexp)

(defcustom LaTeX-verbatim-regexp "verbatim\\*?" "\
*Regexp matching environments with indentation at col 0 for begin/end." :group 'LaTeX-indentation :type 'regexp)

(defcustom LaTeX-begin-regexp "begin\\b" "\
*Regexp matching macros considered begins." :group 'LaTeX-indentation :type 'regexp)

(defcustom LaTeX-end-regexp "end\\b" "\
*Regexp matching macros considered ends." :group 'LaTeX-indentation :type 'regexp)

(defcustom LaTeX-left-right-indent-level LaTeX-indent-level "\
*The level of indentation produced by a \\left macro." :group 'LaTeX-indentation :type 'integer)

(defcustom LaTeX-indent-comment-start-regexp "%" "\
*Regexp matching comments ending the indent level count.
This means, we just count the LaTeX tokens \\left, \\right, \\begin,
and \\end up to the first occurence of text matching this regexp.
Thus, the default \"%\" stops counting the tokens at a comment.  A
value of \"%[^>]\" would allow you to alter the indentation with
comments, e.g. with comment `%> \\begin'.
Lines which start with `%' are not considered at all, regardless if this
value." :group 'LaTeX-indentation :type 'regexp)

(defcustom LaTeX-fill-break-at-separators '(\\\( \\\) \\\[ \\\]) "\
List of separators before or after which respectively a line
break will be inserted if they do not fit into one line." :group 'LaTeX :type '(set :tag "Contents" (const :tag "Opening Brace" {) (const :tag "Closing Brace" }) (const :tag "Opening Bracket" \[) (const :tag "Opening Inline Math Switches" \\\() (const :tag "Closing Inline Math Switches" \\\)) (const :tag "Opening Display Math Switch" \\\[) (const :tag "Closing Display Math Switch" \\\])))

(defcustom LaTeX-fill-break-before-code-comments t "\
If non-nil, a line with some code followed by a comment will
be broken before the last non-comment word in case the comment
does not fit into the line." :group 'LaTeX :type 'boolean)

(defcustom LaTeX-paragraph-commands nil "\
List of LaTeX macros that should have their own line.
The list should contain macro names without the leading backslash." :group 'LaTeX-macro :type '(repeat (string)) :set (lambda (symbol value) (set-default symbol value) (setq LaTeX-paragraph-commands-regexp (LaTeX-paragraph-commands-regexp-make))))

(defgroup LaTeX-math nil "Mathematics in AUCTeX." :group 'LaTeX-macro)

(defcustom LaTeX-math-menu-unicode (or (string-match "\\<GTK\\>" (emacs-version)) (eq window-system 'w32)) "\
Whether the LaTeX menu should try using Unicode for effect." :type 'boolean :group 'LaTeX-math)

(defcustom LaTeX-math-abbrev-prefix "`" "\
Prefix key for use in `LaTeX-math-mode'.
This has to be a string representing a key sequence in a format
understood by the `kbd' macro.  This corresponds to the syntax
usually used in the Emacs and Elisp manuals.

Setting this variable directly does not take effect;
use \\[customize]." :group 'LaTeX-math :initialize 'custom-initialize-default :set '(lambda (symbol value) (define-key LaTeX-math-mode-map (LaTeX-math-abbrev-prefix) t) (set-default symbol value) (define-key LaTeX-math-mode-map (LaTeX-math-abbrev-prefix) LaTeX-math-keymap)) :type '(string :tag "Key sequence"))

(defcustom LaTeX-math-list nil "\
Alist of your personal LaTeX math symbols.

Each entry should be a list with up to four elements, KEY, VALUE,
MENU and CHARACTER.

KEY is the key (after `LaTeX-math-abbrev-prefix') to be redefined
in math minor mode.  If KEY is nil, the symbol has no associated
keystroke (it is available in the menu, though).

VALUE can be a string with the name of the macro to be inserted,
or a function to be called.  The macro must be given without the
leading backslash.

The third element MENU is the name of the submenu where the
command should be added.  MENU can be either a string
\(e.g. \"greek\"), a list (e.g. (\"AMS\" \"Delimiters\")) or
nil.  If MENU is nil, no menu item will be created.

The fourth element CHARACTER is a Unicode character position for
menu display.  When nil, no character is shown.

See also `LaTeX-math-menu'." :group 'LaTeX-math :set (lambda (symbol value) (set-default symbol value) (LaTeX-math-initialize)) :type '(repeat (group (choice :tag "Key" (const :tag "none" nil) (choice (character) (string :tag "Key sequence"))) (choice :tag "Value" (string :tag "Macro") (function)) (choice :tag "Menu" (string :tag "Top level menu") (repeat :tag "Submenu" (string :tag "Menu"))) (choice :tag "Unicode character" (const :tag "none" nil) (integer :tag "Number")))))

(defcustom LaTeX-math-insert-function 'TeX-insert-macro "\
Function called with argument STRING to insert \\STRING." :group 'LaTeX-math :type 'function)

(defcustom LaTeX-fold-macro-spec-list nil "\
List of display strings and macros to fold in LaTeX mode." :type '(repeat (group (choice (string :tag "Display String") (integer :tag "Number of argument" :value 1)) (repeat :tag "Macros" (string)))) :group 'TeX-fold)

(defcustom LaTeX-fold-env-spec-list nil "\
List of display strings and environments to fold in LaTeX mode." :type '(repeat (group (choice (string :tag "Display String") (integer :tag "Number of argument" :value 1)) (repeat :tag "Environments" (string)))) :group 'TeX-fold)

(defcustom LaTeX-fold-math-spec-list (delete nil (mapcar (lambda (elt) (let ((tex-token (nth 1 elt)) (submenu (nth 2 elt)) (unicode (nth 3 elt)) uchar noargp) (when (and (fboundp 'decode-char) (integerp unicode)) (setq uchar (decode-char 'ucs unicode))) (when (listp submenu) (setq submenu (nth 1 submenu))) (setq noargp (not (string-match (concat "^" (regexp-opt '("Constructs" "Accents"))) submenu))) (when (and (stringp tex-token) (integerp uchar) noargp) (backquote ((\, (char-to-string uchar)) ((\, tex-token))))))) (backquote ((nil "to" "" 8594) (nil "gets" "" 8592) (\,@ LaTeX-math-default))))) "\
List of display strings and math macros to fold in LaTeX mode." :type '(repeat (group (choice (string :tag "Display String") (integer :tag "Number of argument" :value 1)) (repeat :tag "Math Macros" (string)))) :group 'TeX-fold)

(defcustom LaTeX-menu-max-items 25 "\
*Maximum number of items in the menu for LaTeX environments.
If number of entries in a menu is larger than this value, split menu
into submenus of nearly equal length.  If nil, never split menu into
submenus." :group 'LaTeX-environment :type '(choice (const :tag "no submenus" nil) (integer)))

(defcustom LaTeX-submenu-name-format "%-12.12s ... %.12s" "\
*Format specification of the submenu name.
Used by `LaTeX-split-long-menu' if the number of entries in a menu is
larger than `LaTeX-menu-max-items'.
This string should contain one %s for the name of the first entry and
one %s for the name of the last entry in the submenu.
If the value is a function, it should return the submenu name.  The
function is called with two arguments, the names of the first and
the last entry in the menu." :group 'LaTeX-environment :type '(choice (string :tag "Format string") (function)))

(defcustom LaTeX-font-list '((?\^A "" "" "\\mathcal{" "}") (?\^B "\\textbf{" "}" "\\mathbf{" "}") (?\^C "\\textsc{" "}") (?\^E "\\emph{" "}") (?\^F "\\textsf{" "}" "\\mathsf{" "}") (?\t "\\textit{" "}" "\\mathit{" "}") (?\r "\\textmd{" "}") (?\^N "\\textnormal{" "}" "\\mathnormal{" "}") (?\^R "\\textrm{" "}" "\\mathrm{" "}") (?\^S "\\textsl{" "}" "\\mathbb{" "}") (?\^T "\\texttt{" "}" "\\mathtt{" "}") (?\^U "\\textup{" "}") (?\^D "" "" t)) "\
Font commands used with LaTeX2e.  See `TeX-font-list'." :group 'LaTeX-macro :type '(repeat (group :value (?\^A "" "") (character :tag "Key") (string :tag "Prefix") (string :tag "Suffix") (option (group :inline t (string :tag "Math Prefix") (string :tag "Math Suffix"))) (option (sexp :format "Replace
" :value t)))))

(defcustom LaTeX-babel-hyphen "\"=" "\
String to be used when typing `-'.
This usually is a hyphen alternative or hyphenation aid, like
\"=, \"~ or \"-, provided by babel and the related language style
files.

Set it to an empty string or nil in order to disable this
feature.  Alter `LaTeX-babel-hyphen-language-alist' in case you
want to change the behavior for a specific language only." :group 'LaTeX-macro :type 'string)

(defcustom LaTeX-babel-hyphen-after-hyphen t "\
Control insertion of hyphen strings.
If non-nil insert normal hyphen on first key press and swap it
with the language-specific hyphen string specified in the
variable `LaTeX-babel-hyphen' on second key press.  If nil do it
the other way round." :group 'LaTeX-macro :type 'boolean)

(defcustom LaTeX-babel-hyphen-language-alist nil "\
Alist controlling hyphen insertion for specific languages.
It may be used to override the defaults given by `LaTeX-babel-hyphen'
and `LaTeX-babel-hyphen-after-hyphen' respectively.  The first item
in each element is a string specifying the language as set by the
language-specific style file.  The second item is the string to be
used instead of `LaTeX-babel-hyphen'.  The third element is the
value overriding `LaTeX-bybel-hyphen-after-hyphen'." :group 'LaTeX-macro :type '(alist :key-type (string :tag "Language") :value-type (group (string :tag "Hyphen string") (boolean :tag "Insert plain hyphen first" :value t))))

(defcustom LaTeX-enable-toolbar t "\
Enable LaTeX tool bar." :group 'TeX-tool-bar :type 'boolean)

(defgroup LaTeX-macro nil "Special support for LaTeX macros in AUCTeX." :prefix "TeX-" :group 'LaTeX :group 'TeX-macro)

(defcustom TeX-arg-cite-note-p nil "\
*If non-nil, ask for optional note in citations." :type 'boolean :group 'LaTeX-macro)

(defcustom TeX-arg-footnote-number-p nil "\
*If non-nil, ask for optional number in footnotes." :type 'boolean :group 'LaTeX-macro)

(defcustom TeX-arg-item-label-p nil "\
*If non-nil, always ask for optional label in items.
Otherwise, only ask in description environments." :type 'boolean :group 'LaTeX-macro)

(defcustom TeX-arg-right-insert-p t "\
*If non-nil, always insert automatically the corresponding \\right.
This happens when \\left is inserted." :type 'boolean :group 'LaTeX-macro)

(defcustom LaTeX-mode-hook nil "\
A hook run in LaTeX mode buffers." :type 'hook :group 'LaTeX)

(defcustom docTeX-clean-intermediate-suffixes TeX-clean-default-intermediate-suffixes "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

(defcustom docTeX-clean-output-suffixes TeX-clean-default-output-suffixes "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

(defcustom LaTeX-clean-intermediate-suffixes TeX-clean-default-intermediate-suffixes "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

(defcustom LaTeX-clean-output-suffixes TeX-clean-default-output-suffixes "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

;;;***

;;;### (autoloads (plain-TeX-clean-output-suffixes plain-TeX-clean-intermediate-suffixes plain-TeX-mode-hook plain-TeX-enable-toolbar) "plain-tex" "auctex/plain-tex.el")
(defconst custom-define-current-source-file "plain-tex.el")

(defcustom plain-TeX-enable-toolbar t "\
Enable TeX tool bar in plain TeX mode." :group 'TeX-tool-bar :type 'boolean)

(defcustom plain-TeX-mode-hook nil "\
A hook run in plain TeX mode buffers." :type 'hook :group 'TeX-misc)

(defcustom plain-TeX-clean-intermediate-suffixes TeX-clean-default-intermediate-suffixes "\
List of regexps matching suffixes of intermediate files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

(defcustom plain-TeX-clean-output-suffixes TeX-clean-default-output-suffixes "\
List of regexps matching suffixes of output files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

;;;***

;;;### (autoloads (TeX-bar-LaTeX-button-alist TeX-bar-LaTeX-all-button-alists TeX-tool-bar-button-definitions TeX-bar-LaTeX-buttons TeX-bar-TeX-button-alist TeX-bar-TeX-all-button-alists TeX-tool-bar-button-definitions TeX-bar-TeX-buttons TeX-tool-bar) "tex-bar" "auctex/tex-bar.el")
(defconst custom-define-current-source-file "tex-bar.el")

(defgroup TeX-tool-bar nil "Tool bar support in AUCTeX." :group 'AUCTeX)

(defcustom TeX-bar-TeX-buttons '(new-file open-file dired kill-buffer save-buffer cut copy paste undo [separator nil] tex next-error view bibtex spell) "\
List of buttons available in `tex-mode'.
It should be a list in the same format of the BUTTONS parameter
in function `toolbarx-install-toolbar', often a symbol that
labels a button or Emacs/XEmacs choice of buttons.

Type `\\[TeX-bar-TeX-buttons]' for a list of available buttons.

Buttons are defined in alists (labels associated to properties
that define a button).  For a list of variables that hold such
alists, see variable `TeX-bar-TeX-all-button-alists'." :type '(list (set :inline t (const new-file) (const open-file) (const dired) (const kill-buffer) (const save-buffer) (const write-file) (const undo) (const cut) (const copy) (const paste) (const search-forward) (const print-buffer) (const [separator nil]) (const tex) (const next-error) (const view) (const file) (const bibtex) (const clean) (const spell)) (repeat (choice (symbol :tag "Label") (vector :args ((symbol :tag "Label in Emacs ") (symbol :tag "Label in XEmacs")) :tag "Emacs/XEmacs choice") (sexp :tag "General element")))) :group 'TeX-tool-bar)

(defgroup TeX-tool-bar-button-definitions nil "Collections of button definitions." :group 'TeX-tool-bar)

(defcustom TeX-bar-TeX-all-button-alists '(TeX-bar-TeX-button-alist toolbarx-default-toolbar-meaning-alist) "\
List of variables that hold buttons properties.
Each element should be a symbol bound to list in the format of
the argument BUTTON-ALIST in function `toolbarx-install-toolbar'." :type '(repeat variable) :group 'TeX-tool-bar-button-definitions)

(defcustom TeX-bar-TeX-button-alist '((tex :image (lambda nil (if TeX-PDF-mode "pdftex" "tex")) :command (progn (TeX-save-document (TeX-master-file)) (TeX-command "TeX" 'TeX-master-file -1)) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "TeX"))) (pdftex :image "pdftex" :command (progn (TeX-save-document (TeX-master-file)) (TeX-command "PDFTeX" 'TeX-master-file -1)) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "PDFTeX"))) (next-error :image "error" :command TeX-next-error :enable (plist-get TeX-error-report-switches (intern (TeX-master-file))) :visible (plist-get TeX-error-report-switches (intern (TeX-master-file)))) (view :image (lambda nil (if TeX-PDF-mode "viewpdf" "viewdvi")) :command (TeX-command "View" 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "View"))) (file :image "dvips" :command (TeX-command "File" 'TeX-master-file -1) :visible (not TeX-PDF-mode) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "File"))) (bibtex :image "bibtex" :command (TeX-command "BibTeX" 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "BibTeX"))) (clean :image "delete" :command (TeX-command "Clean" 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "Clean"))) (spell :image "spell" :command (TeX-command "Spell" 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "Spell")))) "\
Alist for button definitions in TeX bar.
Value should le a list where each element is of format (KEY .
PROPS), where KEY is a symbol that labels the button and PROPS is
a list of properties of the button.  For a description of the
format of PROPS, please see documentation of function
`toolbarx-install-toolbar'.  This custom variable is in the same
format of the argument MEANING-ALIST in the mentioned function." :type '(alist :key-type symbol :value-type sexp) :group 'TeX-tool-bar-button-definitions)

(defcustom TeX-bar-LaTeX-buttons '(new-file open-file dired kill-buffer save-buffer cut copy paste undo [separator nil] latex next-error view bibtex spell) "\
List of buttons available in `latex-mode'.
It should be a list in the same format of the BUTTONS parameter
in function `toolbarx-install-toolbar', often a symbol that
labels a button or Emacs/XEmacs choice of buttons.

Type `\\[TeX-bar-LaTeX-buttons]' for a list of available buttons.

Buttons are defined in alists (labels associated to properties
that define a button).  For a list of variables that hold such
alists, see variable `TeX-bar-LaTeX-all-button-alists'." :type '(list (set :inline t (const new-file) (const open-file) (const dired) (const kill-buffer) (const save-buffer) (const write-file) (const undo) (const cut) (const copy) (const paste) (const search-forward) (const print-buffer) (const [separator nil]) (const latex) (const next-error) (const view) (const file) (const bibtex) (const clean) (const spell) (const latex-symbols-experimental)) (repeat (choice (symbol :tag "Label") (vector :args ((symbol :tag "Label in Emacs ") (symbol :tag "Label in XEmacs")) :tag "Emacs/XEmacs choice") (sexp :tag "General element")))) :group 'TeX-tool-bar)

(defgroup TeX-tool-bar-button-definitions nil "Collections of button definitions." :group 'TeX-tool-bar)

(defcustom TeX-bar-LaTeX-all-button-alists '(TeX-bar-LaTeX-button-alist toolbarx-default-toolbar-meaning-alist) "\
List of variables that hold buttons properties.
Each element should be a symbol bound to list in the format of
the argument BUTTON-ALIST in function `toolbarx-install-toolbar'." :type '(repeat variable) :group 'TeX-tool-bar-button-definitions)

(defcustom TeX-bar-LaTeX-button-alist '((latex :image (lambda nil (if TeX-PDF-mode "pdftex" "tex")) :command (progn (TeX-save-document (TeX-master-file)) (TeX-command "LaTeX" 'TeX-master-file -1)) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "LaTeX"))) (pdflatex :image "pdftex" :command (progn (TeX-save-document (TeX-master-file)) (TeX-command "PDFLaTeX" 'TeX-master-file -1)) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "PDFLaTeX"))) (next-error :image "error" :command TeX-next-error :enable (plist-get TeX-error-report-switches (intern (TeX-master-file))) :visible (plist-get TeX-error-report-switches (intern (TeX-master-file)))) (view :image (lambda nil (if TeX-PDF-mode "viewpdf" "viewdvi")) :command (TeX-command "View" 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "View"))) (file :image "dvips" :command (TeX-command "File" 'TeX-master-file -1) :visible (not TeX-PDF-mode) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "File"))) (bibtex :image "bibtex" :command (TeX-command (if LaTeX-using-Biber "Biber" "BibTeX") 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list (if LaTeX-using-Biber "Biber" "BibTeX")))) (clean :image "delete" :command (TeX-command "Clean" 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "Clean"))) (spell :image "spell" :command (TeX-command "Spell" 'TeX-master-file -1) :help (lambda (&rest ignored) (TeX-bar-help-from-command-list "Spell"))) (latex-symbols-experimental :alias :eval-group LaTeX-symbols-toolbar-switch-contents LaTeX-symbols-toolbar-contents)) "\
Alist for button definitions in TeX bar.
Value should le a list where each element is of format (KEY .
PROPS), where KEY is a symbol that labels the button and PROPS is
a list of properties of the button.  For a description of the
format of PROPS, please see documentation of function
`toolbarx-install-toolbar'.  This custom variable is in the same
format of the argument MEANING-ALIST in the mentioned function." :type '(alist :key-type symbol :value-type sexp) :group 'TeX-tool-bar-button-definitions)

;;;***

;;;### (autoloads (TeX-error-overview-open-after-TeX-run TeX-error-overview-frame-parameters TeX-error-overview-setup TeX-error-description-list TeX-error-description-faces TeX-parse-all-errors TeX-region TeX-region-extra TeX-show-compilation TeX-save-query TeX-shell-command-option TeX-shell TeX-process-asynchronous) "tex-buf" "auctex/tex-buf.el")
(defconst custom-define-current-source-file "tex-buf.el")

(defcustom TeX-process-asynchronous (not (eq system-type 'ms-dos)) "\
*Use asynchronous processes." :group 'TeX-command :type 'boolean)

(defcustom TeX-shell (if (memq system-type '(ms-dos emx windows-nt)) shell-file-name "/bin/sh") "\
Name of shell used to parse TeX commands." :group 'TeX-command :type 'file)

(defcustom TeX-shell-command-option (cond ((memq system-type '(ms-dos emx windows-nt)) (cond ((boundp 'shell-command-option) shell-command-option) ((boundp 'shell-command-switch) shell-command-switch) (t "/c"))) (t "-c")) "\
Shell argument indicating that next argument is the command." :group 'TeX-command :type 'string)

(defcustom TeX-save-query t "\
*If non-nil, ask user for permission to save files before starting TeX." :group 'TeX-command :type 'boolean)

(defcustom TeX-show-compilation nil "\
*If non-nil, show output of TeX compilation in other window." :group 'TeX-command :type 'boolean)

(defcustom TeX-region-extra "" "\
*String to insert in the region file between the header and the text." :group 'TeX-command :type 'string)

(defcustom TeX-region "_region_" "\
*Base name of temporary file for `TeX-command-region' and `TeX-command-buffer'." :group 'TeX-command :type 'string)

(defcustom TeX-parse-all-errors t "\
Whether to automatically collect all warning and errors after running TeX.

If t, it makes it possible to use `TeX-previous-error' with TeX
commands." :group 'TeX-command :type 'boolean)

(defgroup TeX-error-description-faces nil "Faces used in error descriptions." :prefix "TeX-error-description-" :group 'TeX-output)

(defcustom TeX-error-description-list '(("\\(?:Package Preview Error\\|Preview\\):.*" . "The `auctex' option to `preview' should not be applied manually.\nIf you see this error message outside of a preview run, either\nyou did something too clever, or AUCTeX something too stupid.") ("Bad \\\\line or \\\\vector argument.*" . "The first argument of a \\line or \\vector command, which specifies the\nslope, is illegal.") ("Bad math environment delimiter.*" . "TeX has found either a math-mode-starting command such as \\[ or \\(\nwhen it is already in math mode, or else a math-mode-ending command\nsuch as \\) or \\] while in LR or paragraph mode.  The problem is caused\nby either unmatched math mode delimiters or unbalanced braces.") ("Bad use of \\\\\\\\.*" . "A \\\\ command appears between paragraphs, where it makes no sense. This\nerror message occurs when the \\\\ is used in a centering or flushing\nenvironment or else in the scope of a centering or flushing\ndeclaration.") ("\\\\begin{[^ ]*} ended by \\\\end{[^ ]*}." . "LaTeX has found an \\end command that doesn't match the corresponding\n\\begin command. You probably misspelled the environment name in the\n\\end command, have an extra \\begin, or else forgot an \\end.") ("Can be used only in preamble." . "LaTeX has encountered, after the \\begin{document}, one of the\nfollowing commands that should appear only in the preamble:\n\\documentclass, \\nofiles, \\includeonly, \\makeindex, or\n\\makeglossary.  The error is also caused by an extra \\begin{document}\ncommand.") ("Command name [^ ]* already used.*" . "You are using \\newcommand, \\newenvironment, \\newlength, \\newsavebox,\nor \\newtheorem to define a command or environment name that is\nalready defined, or \\newcounter to define a counter that already\nexists. (Defining an environment named gnu automatically defines the\ncommand \\gnu.) You'll have to choose a new name or, in the case of\n\\newcommand or \\newenvironment, switch to the \\renew ...  command.") ("Counter too large." . "1. Some object that is numbered with letters, probably an item in a\nenumerated list, has received a number greater than 26. Either you're\nmaking a very long list or you've been resetting counter values.\n\n2. Footnotes are being ``numbered'' with letters or footnote symbols\nand LaTeX has run out of letters or symbols. This is probably caused\nby too many \\thanks commands.") ("Environment [^ ]* undefined." . "LaTeX has encountered a \\begin command for a nonexistent environment.\nYou probably misspelled the environment name. ") ("Float(s) lost." . "You put a figure or table environment or a \\marginpar command inside a\nparbox---either one made with a minipage environment or \\parbox\ncommand, or one constructed by LaTeX in making a footnote, figure,\netc. This is an outputting error, and the offending environment or\ncommand may be quite a way back from the point where LaTeX discovered\nthe problem. One or more figures, tables, and/or marginal notes have\nbeen lost, but not necessarily the one that caused the error.") ("Illegal character in array arg." . "There is an illegal character in the argument of an array or tabular\nenvironment, or in the second argument of a \\multicolumn command.") ("Missing \\\\begin{document}." . "LaTeX produced printed output before encountering a \\begin{document}\ncommand. Either you forgot the \\begin{document} command or there is\nsomething wrong in the preamble. The problem may be a stray character\nor an error in a declaration---for example, omitting the braces around\nan argument or forgetting the \\ in a command name.") ("Missing p-arg in array arg.*" . "There is a p that is not followed by an expression in braces in the\nargument of an array or tabular environment, or in the second argument\nof a \\multicolumn command.") ("Missing @-exp in array arg." . "There is an @ character not followed by an @-expression in the\nargument of an array or tabular environment, or in the second argument\nof a \\multicolumn command.") ("No such counter." . "You have specified a nonexistent counter in a \\setcounter or\n\\addtocounter command. This is probably caused by a simple typing\nerror.  However, if the error occurred while a file with the extension\naux is being read, then you probably used a \\newcounter command\noutside the preamble.") ("Not in outer par mode." . "You had a figure or table environment or a \\marginpar command in math\nmode or inside a parbox.") ("\\\\pushtabs and \\\\poptabs don't match." . "LaTeX found a \\poptabs with no matching \\pushtabs, or has come to the\n\\end{tabbing} command with one or more unmatched \\pushtabs commands.") ("Something's wrong--perhaps a missing \\\\item." . "The most probable cause is an omitted \\item command in a list-making\nenvironment. It is also caused by forgetting the argument of a\nthebibliography environment.") ("Tab overflow." . "A \\= command has exceeded the maximum number of tab stops that LaTeX\npermits.") ("There's no line here to end." . "A \\newline or \\\\ command appears between paragraphs, where it makes no\nsense. If you're trying to ``leave a blank line'', use a \\vspace\ncommand.") ("This may be a LaTeX bug." . "LaTeX has become thoroughly confused. This is probably due to a\npreviously detected error, but it is possible that you have found an\nerror in LaTeX itself. If this is the first error message produced by\nthe input file and you can't find anything wrong, save the file and\ncontact the person listed in your Local Guide.") ("Too deeply nested." . "There are too many list-making environments nested within one another.\nHow many levels of nesting are permitted may depend upon what computer\nyou are using, but at least four levels are provided, which should be\nenough.") ("Too many unprocessed floats." . "While this error can result from having too many \\marginpar commands\non a page, a more likely cause is forcing LaTeX to save more figures\nand tables than it has room for.  When typesetting its continuous\nscroll, LaTeX saves figures and tables separately and inserts them as\nit cuts off pages. This error occurs when LaTeX finds too many figure\nand/or table environments before it is time to cut off a page, a\nproblem that is solved by moving some of the environments farther\ntowards the end of the input file. The error can also be caused by a\n``logjam''---a figure or table that cannot be printed causing others\nto pile up behind it, since LaTeX will not print figures or tables out\nof order. The jam can be started by a figure or table that either is\ntoo large to fit on a page or won't fit where its optional placement\nargument says it must go. This is likely to happen if the argument\ndoes not contain a p option.") ("Undefined tab position." . "A \\>, \\+, \\-, or \\< command is trying to go to a nonexistent tab\nposition---one not defined by a \\= command.") ("\\\\< in mid line." . "A \\< command appears in the middle of a line in a tabbing environment.\nThis command should come only at the beginning of a line.") ("Double subscript." . "There are two subscripts in a row in a mathematical\nformula---something like x_{2}_{3}, which makes no sense.") ("Double superscript." . "There are two superscripts in a row in a mathematical\nformula---something like x^{2}^{3}, which makes no sense.") ("Extra alignment tab has been changed to \\\\cr." . "There are too many separate items (column entries) in a single row of\nan array or tabular environment. In other words, there were too many &\n's before the end of the row. You probably forgot the \\\\ at the end of\nthe preceding row.") ("Extra \\}, or forgotten \\$." . "The braces or math mode delimiters don't match properly. You probably\nforgot a {, \\[, \\(, or $.") ("Font [^ ]* not loaded: Not enough room left." . "The document uses more fonts than TeX has room for. If different parts\nof the document use different fonts, then you can get around the\nproblem by processing it in parts.") ("I can't find file `.*'." . "TeX can't find a file that it needs. If the name of the missing file\nhas the extension tex, then it is looking for an input file that you\nspecified---either your main file or another file inserted with an\n\\input or \\include command. If the missing file has the extension sty\n, then you have specified a nonexistent document style or style\noption.") ("Illegal parameter number in definition of .*" . "This is probably caused by a \\newcommand, \\renewcommand,\n\\newenvironment, or \\renewenvironment command in which a # is used\nincorrectly.  A # character, except as part of the command name \\#,\ncan be used only to indicate an argument parameter, as in #2, which\ndenotes the second argument. This error is also caused by nesting one\nof the above four commands inside another, or by putting a parameter\nlike #2 in the last argument of a \\newenvironment or \\renewenvironment\ncommand.") ("Illegal unit of measure ([^ ]* inserted)." . "If you just got a\n\n      ! Missing number, treated as zero.\n\nerror, then this is part of the same problem.  If not, it means that\nLaTeX was expecting a length as an argument and found a number\ninstead.  The most common cause of this error is writing 0 instead of\nsomething like 0in for a length of zero, in which case typing return\nshould result in correct output. However, the error can also be caused\nby omitting a command argument.") ("Misplaced alignment tab character \\&." . "The special character &, which should be used only to separate items\nin an array or tabular environment, appeared in ordinary text. You\nprobably meant to type \\&.") ("Missing control sequence inserted." . "This is probably caused by a \\newcommand, \\renewcommand, \\newlength,\nor \\newsavebox command whose first argument is not a command name.") ("Missing number, treated as zero." . "This is usually caused by a LaTeX command expecting but not finding\neither a number or a length as an argument. You may have omitted an\nargument, or a square bracket in the text may have been mistaken for\nthe beginning of an optional argument. This error is also caused by\nputting \\protect in front of either a length command or a command such\nas \\value that produces a number.") ("Missing [{}] inserted." . "TeX has become confused. The position indicated by the error locator\nis probably beyond the point where the incorrect input is.") ("Missing \\$ inserted." . "TeX probably found a command that can be used only in math mode when\nit wasn't in math mode.  Remember that unless stated otherwise, all\nall the commands of Section 3.3 in LaTeX Book (Lamport) can be used\nonly in math mode. TeX is not in math mode when it begins processing\nthe argument of a box-making command, even if that command is inside a\nmath environment. This error also occurs if TeX encounters a blank\nline when it is in math mode.") ("Not a letter." . "Something appears in the argument of a \\hyphenation command that\ndoesn't belong there.") ("Paragraph ended before [^ ]* was complete." . "A blank line occurred in a command argument that shouldn't contain\none. You probably forgot the right brace at the end of an argument.") ("\\\\[^ ]*font [^ ]* is undefined .*" . "These errors occur when an uncommon font is used in math mode---for\nexample, if you use a \\sc command in a formula inside a footnote,\ncalling for a footnote-sized small caps font.  This problem is solved\nby using a \\load command.") ("Font .* not found." . "You requested a family/series/shape/size combination that is totally\nunknown.  There are two cases in which this error can occur:\n  1) You used the \\size macro to select a size that is not available.\n  2) If you did not do that, go to your local `wizard' and\n     complain fiercely that the font selection tables are corrupted!") ("TeX capacity exceeded, sorry .*" . "TeX has just run out of space and aborted its execution. Before you\npanic, remember that the least likely cause of this error is TeX not\nhaving the capacity to process your document.  It was probably an\nerror in your input file that caused TeX to run out of room. The\nfollowing discussion explains how to decide whether you've really\nexceeded TeX's capacity and, if so, what to do. If the problem is an\nerror in the input, you may have to use the divide and conquer method\ndescribed previously to locate it. LaTeX seldom runs out of space on a\nshort input file, so if running it on the last few pages before the\nerror indicator's position still produces the error, then there's\nalmost certainly something wrong in the input file.\n\nThe end of the error indicator tells what kind of space TeX ran out\nof. The more common ones are listed below, with an explanation of\ntheir probable causes.\n\nbuffer size\n===========\nCan be caused by too long a piece of text as the argument\nof a sectioning, \\caption, \\addcontentsline, or \\addtocontents\ncommand. This error will probably occur when the \\end{document} is\nbeing processed, but it could happen when a \\tableofcontents,\n\\listoffigures, or \\listoftables command is executed. To solve this\nproblem, use a shorter optional argument. Even if you're producing a\ntable of contents or a list of figures or tables, such a long entry\nwon't help the reader.\n\nexception dictionary\n====================\nYou have used \\hyphenation commands to give TeX\nmore hyphenation information than it has room for. Remove some of the\nless frequently used words from the \\hyphenation commands and insert\n\\- commands instead.\n\nhash size\n=========\nYour input file defines too many command names and/or uses\ntoo many cross-ref- erencing labels.\n\ninput stack size\n================\nThis is probably caused by an error in a command\ndefinition. For example, the following command makes a circular\ndefinition, defining \\gnu in terms of itself:\n\n	  \\newcommand{\\gnu}{a \\gnu} % This is wrong!\n\nWhen TeX encounters this \\gnu command, it will keep chasing its tail\ntrying to figure out what \\gnu should produce, and eventually run out\nof ``input stack''.\n\nmain memory size\n================\nThis is one kind of space that TeX can run out of when processing a\nshort file. There are three ways you can run TeX out of main memory\nspace: (1) defining a lot of very long, complicated commands, (2)\nmaking an index or glossary and having too many \\index or \\glossary\ncommands on a single page, and (3) creating so complicated a page of\noutput that TeX can't hold all the information needed to generate it.\nThe solution to the first two problems is obvious: define fewer\ncommands or use fewer \\index and \\glossary commands. The third problem\nis nastier. It can be caused by large tabbing, tabular, array, and\npicture environments. TeX's space may also be filled up with figures\nand tables waiting for a place to go.  To find out if you've really\nexceeded TeX's capacity in this way, put a \\clearpage command in your\ninput file right before the place where TeX ran out of room and try\nrunning it again. If it doesn't run out of room with the \\clearpage\ncommand there, then you did exceed TeX's capacity.  If it still runs\nout of room, then there's probably an error in your file.  If TeX is\nreally out of room, you must give it some help. Remember that TeX\nprocesses a complete paragraph before deciding whether to cut the\npage. Inserting a \\newpage command in the middle of the paragraph,\nwhere TeX should break the page, may save the day by letting TeX write\nthe current page before processing the rest of the paragraph. (A\n\\pagebreak command won't help.) If the problem is caused by\naccumulated figures and tables, you can try to prevent them from\naccumulating---either by moving them further towards the end of the\ndocument or by trying to get them to come out sooner.  If you are\nstill writing the document, simply add a \\clearpage command and forget\nabout the problem until you're ready to produce the final version.\nChanges to the input file are likely to make the problem go away.\n\npool size\n=========\nYou probably used too many cross-ref-erencing \\labels and/or defined\ntoo many new command names. More precisely, the labels and command\nnames that you define have too many characters, so this problem can be\nsolved by using shorter names. However, the error can also be caused\nby omitting the right brace that ends the argument of either a counter\ncommand such as \\setcounter, or a \\newenvironment or \\newtheorem\ncommand.\n\nsave size\n=========\nThis occurs when commands, environments, and the scopes of\ndeclarations are nested too deeply---for example, by having the\nargument of a \\multiput command contain a picture environment that in\nturn has a \\footnotesize declaration whose scope contains a \\multiput\ncommand containing a ....") ("Text line contains an invalid character." . "The input contains some strange character that it shouldn't. A mistake\nwhen creating the file probably caused your text editor to insert this\ncharacter. Exactly what could have happened depends upon what text\neditor you used. If examining the input file doesn't reveal the\noffending character, consult the Local Guide for suggestions.") ("Undefined control sequence." . "TeX encountered an unknown command name. You probably misspelled the\nname. If this message occurs when a LaTeX command is being processed,\nthe command is probably in the wrong place---for example, the error\ncan be produced by an \\item command that's not inside a list-making\nenvironment. The error can also be caused by a missing \\documentclass\ncommand.") ("Use of [^ ]* doesn't match its definition." . "It's probably one of the picture-drawing commands, and you have used\nthe wrong syntax for specifying an argument. If it's \\@array that\ndoesn't match its definition, then there is something wrong in an\n@-expression in the argument of an array or tabular\nenvironment---perhaps a fragile command that is not \\protect'ed.") ("You can't use `macro parameter character \\#' in [^ ]* mode." . "The special character # has appeared in ordinary text. You probably\nmeant to type \\#.") ("Overfull \\\\hbox .*" . "Because it couldn't find a good place for a line break, TeX put more\non this line than it should.") ("Overfull \\\\vbox .*" . "Because it couldn't find a good place for a page break, TeX put more\non the page than it should. ") ("Underfull \\\\hbox .*" . "Check your output for extra vertical space.  If you find some, it was\nprobably caused by a problem with a \\\\ or \\newline command---for\nexample, two \\\\ commands in succession. This warning can also be\ncaused by using the sloppypar environment or \\sloppy declaration, or\nby inserting a \\linebreak command.") ("Underfull \\\\vbox .*" . "TeX could not find a good place to break the page, so it produced a\npage without enough text on it. ") (".*" . "No help available")) "\
A list of the form (\"err-regexp\" . \"context\") used by function
`TeX-help-error' to display help-text on an error message or warning.
err-regexp should be a regular expression matching the error message
given from TeX/LaTeX, and context should be some lines describing that
error." :group 'TeX-output :type '(repeat (cons :tag "Entry" (regexp :tag "Match") (string :format "Description:
%v"))))

(defcustom TeX-error-overview-setup nil "\
The frame setup of the error overview.

The possible value is: `separate-frame' (error oveview in a
separate frame); with a nil value the current frame is used.

If the display does not support multi frame, the current frame
will be used regardless of the value of this variable." :group 'TeX-output :type '(choice (const :tag "Error overview in separate frame" separate-frame) (const :tag "Use current frame" nil)))

(defcustom TeX-error-overview-frame-parameters '((name . "TeX errors") (title . "TeX errors") (height . 10) (width . 80) (top - 0) (left - 0) (unsplittable . t) (minibuffer) (vertical-scroll-bars . t) (tool-bar-lines . 0)) "\
Parameters of the error overview frame." :group 'TeX-output :type 'alist :options '((name string) (title string) (height integer) (width integer) (top integer) (left integer) (unsplittable boolean) (minibuffer boolean) (vertical-scroll-bars boolean) (tool-bar-lines integer)))

(defcustom TeX-error-overview-open-after-TeX-run nil "\
Whether to open automatically the error overview after running TeX." :group 'TeX-output :type 'boolean)

;;;***

;;;### (autoloads (TeX-fold-command-prefix TeX-fold-auto TeX-fold-force-fontify TeX-fold-help-echo-max-length TeX-fold-unfold-around-mark TeX-fold-preserve-comments TeX-fold-unspec-use-name TeX-fold-unspec-env-display-string TeX-fold-unspec-macro-display-string TeX-fold-math-spec-list TeX-fold-env-spec-list TeX-fold-macro-spec-list TeX-fold-type-list TeX-fold) "tex-fold" "auctex/tex-fold.el")
(defconst custom-define-current-source-file "tex-fold.el")

(defgroup TeX-fold nil "Fold TeX macros." :group 'AUCTeX)

(defcustom TeX-fold-type-list '(env macro math) "\
List of item types to consider when folding.
Valid items are the symbols 'env for environments, 'macro for
macros, 'math for math macros and 'comment for comments." :type '(set (const :tag "Environments" env) (const :tag "Macros" macro) (const :tag "Math Macros" math) (const :tag "Comments" comment)) :group 'TeX-fold)

(defcustom TeX-fold-macro-spec-list (backquote (("[f]" ("footnote" "marginpar")) ("[c]" ("cite")) ("[l]" ("label")) ("[r]" ("ref" "pageref" "eqref")) ("[i]" ("index" "glossary")) ("[1]:||*" ("item")) ("..." ("dots")) ("(C)" ("copyright")) ("(R)" ("textregistered")) ("TM" ("texttrademark")) (1 ("part" "chapter" "section" "subsection" "subsubsection" "paragraph" "subparagraph" "part*" "chapter*" "section*" "subsection*" "subsubsection*" "paragraph*" "subparagraph*" "emph" "textit" "textsl" "textmd" "textrm" "textsf" "texttt" "textbf" "textsc" "textup")))) "\
List of replacement specifiers and macros to fold.

The first element of each item can be a string, an integer or a
function symbol.  The second element is a list of macros two fold
without the leading backslash.

If the first element is a string, it will be used as a display
replacement for the whole macro.  Numbers in braces, brackets,
parens or angle brackets will be replaced by the respective macro
argument.  For example \"{1}\" will be replaced by the first
mandatory argument of the macro.  One can also define
alternatives within the specifier which are used if an argument
is not found.  Alternatives are separated by \"||\".  They are
most useful with optional arguments.  As an example, the default
specifier for \\item is \"[1]:||*\" which means that if there is
an optional argument, its value is shown followed by a colon.  If
there is no optional argument, only an asterisk is used as the
display string.

If the first element is an integer, the macro will be replaced by
the respective macro argument.

If the first element is a function symbol, the function will be
called with all mandatory arguments of the macro and the result
of the function call will be used as a replacement for the macro.

Setting this variable does not take effect immediately.  Use
Customize or reset the mode." :type '(repeat (group (choice (string :tag "Display String") (integer :tag "Number of argument" :value 1) (function :tag "Function to execute")) (repeat :tag "Macros" (string)))) :group 'TeX-fold)

(defcustom TeX-fold-env-spec-list '(("[comment]" ("comment"))) "\
List of display strings and environments to fold." :type '(repeat (group (choice (string :tag "Display String") (integer :tag "Number of argument" :value 1)) (repeat :tag "Environments" (string)))) :group 'TeX-fold)

(defcustom TeX-fold-math-spec-list nil "\
List of display strings and math macros to fold." :type '(repeat (group (choice (string :tag "Display String") (integer :tag "Number of argument" :value 1)) (repeat :tag "Math Macros" (string)))) :group 'TeX-fold)

(defcustom TeX-fold-unspec-macro-display-string "[m]" "\
Display string for unspecified macros.
This string will be displayed if a single macro is being hidden
which is not specified in `TeX-fold-macro-spec-list'." :type '(string) :group 'TeX-fold)

(defcustom TeX-fold-unspec-env-display-string "[env]" "\
Display string for unspecified environments.
This string will be displayed if a single environment is being
hidden which is not specified in `TeX-fold-env-spec-list'." :type '(string) :group 'TeX-fold)

(defcustom TeX-fold-unspec-use-name t "\
If non-nil use the name of an unspecified item as display string.
Set it to nil if you want to use the values of the variables
`TeX-fold-unspec-macro-display-string' or
`TeX-fold-unspec-env-display-string' respectively as a display
string for any unspecified macro or environment." :type 'boolean :group 'TeX-fold)

(defcustom TeX-fold-preserve-comments nil "\
If non-nil do not fold in comments." :type 'boolean :group 'TeX-fold)

(defcustom TeX-fold-unfold-around-mark t "\
Unfold text around the mark, if active." :type 'boolean :group 'TeX-fold)

(defcustom TeX-fold-help-echo-max-length 70 "\
Maximum length of help echo message for folded overlays.
Set it to zero in order to disable help echos." :type 'integer :group 'TeX-fold)

(defcustom TeX-fold-force-fontify t "\
Force the buffer to be fully fontified by folding it." :group 'TeX-fold :type 'boolean)

(defcustom TeX-fold-auto nil "\
If non-nil, fold macros automatically after `TeX-insert-macro'." :group 'TeX-fold :type 'boolean)

(defcustom TeX-fold-command-prefix "" "\
Prefix key to use for commands in TeX Fold mode.
The value of this variable is checked as part of loading TeX Fold mode.
After that, changing the prefix key requires manipulating keymaps." :type 'string :group 'TeX-fold)

;;;***

;;;### (autoloads (Texinfo-clean-output-suffixes Texinfo-clean-intermediate-suffixes) "tex-info" "auctex/tex-info.el")
(defconst custom-define-current-source-file "tex-info.el")

(defcustom Texinfo-clean-intermediate-suffixes nil "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

(defcustom Texinfo-clean-output-suffixes '("\\.info\\(-[0-9]+\\)?" "\\.dvi" "\\.pdf" "\\.ps" "\\.html" "_toc\\.html" "_fot\\.html" "_abt\\.html" "_[0-9]+\\.html" "_l2h_img.+") "\
List of regexps matching suffixes of files to be deleted.
The regexps will be anchored at the end of the file name to be matched,
i.e. you do _not_ have to cater for this yourself by adding \\\\' or $." :type '(repeat regexp) :group 'TeX-command)

;;;***

;;;### (autoloads (japanese-LaTeX-style-list japanese-LaTeX-default-style japanese-LaTeX-command-default japanese-TeX-command-default japanese-TeX-error-messages japanese-TeX-command-list japanese-TeX-engine-default AUCTeX-jp) "tex-jp" "auctex/tex-jp.el")
(defconst custom-define-current-source-file "tex-jp.el")

(defgroup AUCTeX-jp nil "Japanese support in AUCTeX." :group 'AUCTeX)

(defcustom japanese-TeX-engine-default 'ptex "\
Default TeX engine for Japanese TeX." :group 'AUCTeX-jp :type '(choice (const :tag "pTeX" ptex) (const :tag "jTeX" jtex) (const :tag "upTeX" uptex)))

(defcustom japanese-TeX-command-list '(("jTeX" "%(PDF)jtex %`%S%(PDFout)%(mode)%' %t" TeX-run-TeX nil (plain-tex-mode) :help "Run NTT jTeX") ("jLaTeX" "%(PDF)jlatex %`%S%(PDFout)%(mode)%' %t" TeX-run-TeX nil (latex-mode) :help "Run NTT jLaTeX") ("pTeX" "%(PDF)ptex %(kanjiopt)%`%S%(PDFout)%(mode)%' %t" TeX-run-TeX nil (plain-tex-mode) :help "Run ASCII pTeX") ("pLaTeX" "%(PDF)platex %(kanjiopt)%`%S%(PDFout)%(mode)%' %t" TeX-run-TeX nil (latex-mode) :help "Run ASCII pLaTeX") ("Mendex" "mendex %(mendexkopt)%s" TeX-run-command nil t :help "Create index file with mendex") ("jBibTeX" "jbibtex %s" TeX-run-BibTeX nil t :help "Run jBibTeX") ("pBibTeX" "pbibtex %(kanjiopt)%s" TeX-run-BibTeX nil t :help "Run pBibTeX")) "\
Additional list of commands, especially for Japanese.
For detail, see `TeX-command-list', to which this list is appended." :group 'AUCTeX-jp :type '(repeat (group :value ("" "" TeX-run-command nil t) (string :tag "Name") (string :tag "Command") (choice :tag "How" :value TeX-run-command (function-item TeX-run-command) (function-item TeX-run-format) (function-item TeX-run-TeX) (function-item TeX-run-interactive) (function-item TeX-run-BibTeX) (function-item TeX-run-compile) (function-item TeX-run-shell) (function-item TeX-run-discard) (function-item TeX-run-background) (function-item TeX-run-silent) (function-item TeX-run-discard-foreground) (function-item TeX-run-function) (function-item TeX-run-discard-or-function) (function :tag "Other")) (boolean :tag "Prompt") (choice :tag "Modes" (const :tag "All" t) (set (const :tag "Plain TeX" plain-tex-mode) (const :tag "LaTeX" latex-mode) (const :tag "DocTeX" doctex-mode) (const :tag "ConTeXt" context-mode) (const :tag "Texinfo" texinfo-mode) (const :tag "AmSTeX" ams-tex-mode))) (repeat :tag "Menu elements" :inline t sexp))))

(defcustom japanese-TeX-error-messages t "\
*If non-nil, explain TeX error messages in Japanese." :group 'AUCTeX-jp :type 'boolean)

(defcustom japanese-TeX-command-default "pTeX" "\
*The default command for `TeX-command' in the japanese-TeX mode." :group 'AUCTeX-jp :type 'string)

(defcustom japanese-LaTeX-command-default "pLaTeX" "\
*The default command for `TeX-command' in the japanese-LaTeX mode." :group 'AUCTeX-jp :type 'string)

(defcustom japanese-LaTeX-default-style "jarticle" "\
*Default when creating new Japanese documents." :group 'AUCTeX-jp :type 'string)

(defcustom japanese-LaTeX-style-list '(("j-article") ("j-report") ("j-book") ("jslides") ("jarticle") ("jreport") ("jbook") ("tarticle") ("treport") ("tbook") ("jsarticle") ("jsbook")) "\
*List of Japanese document styles." :group 'AUCTeX-jp :type '(repeat (group (string :format "%v"))))

;;;***

;;;### (autoloads (TeX-modes TeX-auto-global AUCTeX) "tex-site" "auctex/tex-site.el")
(defconst custom-define-current-source-file "tex-site.el")

(defgroup AUCTeX nil "A (La)TeX environment." :tag "AUCTeX" :link '(custom-manual "(auctex)Top") :link '(url-link :tag "Home Page" "http://www.gnu.org/software/auctex/") :prefix "TeX-" :group 'tex :load "tex" :load "latex" :load "tex-style")

(defcustom TeX-auto-global "/usr/local/var/auctex/" "\
*Directory containing automatically generated information.
Must end with a directory separator.

For storing automatic extracted information about the TeX macros
shared by all users of a site." :group 'TeX-file :type 'directory)

(defcustom TeX-modes (mapcar 'car TeX-mode-alist) "\
List of modes provided by AUCTeX.

This variable can't be set normally; use customize for that, or
set it with `TeX-modes-set'." :type (cons 'set (mapcar (lambda (x) (list 'const (car x))) TeX-mode-alist)) :set 'TeX-modes-set :group 'AUCTeX :initialize (lambda (var value) (custom-initialize-reset var value) (unless (fboundp 'advice-add) (let ((list TeX-mode-alist)) (while list (eval-after-load (cdar list) (backquote (TeX-modes-set '(\, var) (\, var) t))) (setq list (cdr list)))))))

;;;***

;;;### (autoloads (LaTeX-includegraphics-read-file LaTeX-includegraphics-strip-extension-flag LaTeX-includegraphics-options-alist LaTeX-includegraphics-extensions LaTeX-fontspec-font-list-default LaTeX-fontspec-arg-font-search LaTeX-write18-enabled-p LaTeX-csquotes-close-quote LaTeX-csquotes-open-quote LaTeX-csquotes-quote-after-quote LaTeX-comment-env-list LaTeX-beamer-font-themes LaTeX-beamer-color-themes LaTeX-beamer-outer-themes LaTeX-beamer-inner-themes LaTeX-beamer-themes LaTeX-beamer-item-overlay-flag LaTeX-beamer-section-labels-flag LaTeX-amsmath-label LaTeX-style) "tex-style" "auctex/tex-style.el")
(defconst custom-define-current-source-file "tex-style.el")

(defgroup LaTeX-style nil "Support for special LaTeX style files in AUCTeX." :group 'LaTeX-macro)

(defcustom LaTeX-amsmath-label nil "\
Default prefix to amsmath equation labels.

Amsmath equations include \"align\", \"alignat\", \"xalignat\",
\"multline\", \"flalign\" and \"gather\".  If it is nil,
`LaTeX-equation-label' is used." :group 'LaTeX-label :type '(choice (const :tag "Use `LaTeX-equation-label'" nil) (string)))

(defcustom LaTeX-beamer-section-labels-flag nil "\
If non-nil section labels are added" :type 'boolean :group 'LaTeX-style)

(defcustom LaTeX-beamer-item-overlay-flag t "\
If non-nil do prompt for an overlay in itemize-like environments." :type 'boolean :group 'LaTeX-style)

(defcustom LaTeX-beamer-themes 'local "\
Presentation themes for the LaTeX beamer package.
It can be a list of themes or a function.  If it is the symbol
`local', search only once per buffer." :group 'LaTeX-style :type '(choice (const :tag "TeX search" LaTeX-beamer-search-themes) (const :tag "Search once per buffer" local) (function :tag "Other function") (list :value ("Antibes" "Bergen" "Berkeley" "Berlin" "Boadilla" "Copenhagen" "Darmstadt" "Dresden" "Frankfurt" "Goettingen" "Hannover" "Ilmenau" "JuanLesPins" "Luebeck" "Madrid" "Malmoe" "Marburg" "Montpellier" "PaloAlto" "Pittsburgh" "Rochester" "Singapore" "Szeged" "Warsaw") (set :inline t (const "Antibes") (const "Bergen") (const "Berkeley") (const "Berlin") (const "Boadilla") (const "Copenhagen") (const "Darmstadt") (const "Dresden") (const "Frankfurt") (const "Goettingen") (const "Hannover") (const "Ilmenau") (const "JuanLesPins") (const "Luebeck") (const "Madrid") (const "Malmoe") (const "Marburg") (const "Montpellier") (const "PaloAlto") (const "Pittsburgh") (const "Rochester") (const "Singapore") (const "Szeged") (const "Warsaw")) (repeat :inline t :tag "Other" (string)))))

(defcustom LaTeX-beamer-inner-themes 'local "\
Presentation inner themes for the LaTeX beamer package.
It can be a list of themes or a function.  If it is the symbol
`local', search only once per buffer." :group 'LaTeX-style :type '(choice (const :tag "TeX search" LaTeX-beamer-search-inner-themes) (const :tag "Search once per buffer" local) (function :tag "Other function") (list :value ("circles" "default" "inmargin" "rectangles" "rounded") (set :inline t (const "circles") (const "default") (const "inmargin") (const "rectangles") (const "rounded")) (repeat :inline t :tag "Other" (string)))))

(defcustom LaTeX-beamer-outer-themes 'local "\
Presentation outer themes for the LaTeX beamer package.
It can be a list of themes or a function.  If it is the symbol
`local', search only once per buffer." :group 'LaTeX-style :type '(choice (const :tag "TeX search" LaTeX-beamer-search-outer-themes) (const :tag "Search once per buffer" local) (function :tag "Other function") (list :value ("default" "infolines" "miniframes" "shadow" "sidebar" "smoothbars" "smoothtree" "split" "tree") (set :inline t (const "default") (const "infolines") (const "miniframes") (const "shadow") (const "sidebar") (const "smoothbars") (const "smoothtree") (const "split") (const "tree")) (repeat :inline t :tag "Other" (string)))))

(defcustom LaTeX-beamer-color-themes 'local "\
Presentation color themes for the LaTeX beamer package.
It can be a list of themes or a function.  If it is the symbol
`local', search only once per buffer." :group 'LaTeX-style :type '(choice (const :tag "TeX search" LaTeX-beamer-search-color-themes) (const :tag "Search once per buffer" local) (function :tag "Other function") (list :value ("albatross" "beetle" "crane" "default" "dolphin" "dove" "fly" "lily" "orchid" "rose" "seagull" "seahorse" "sidebartab" "structure" "whale") (set :inline t (const "albatross") (const "beetle") (const "crane") (const "default") (const "dolphin") (const "dove") (const "fly") (const "lily") (const "orchid") (const "rose") (const "seagull") (const "seahorse") (const "sidebartab") (const "structure") (const "whale")) (repeat :inline t :tag "Other" (string)))))

(defcustom LaTeX-beamer-font-themes 'local "\
Presentation font themes for the LaTeX beamer package.
It can be a list of themes or a function.  If it is the symbol
`local', search only once per buffer." :group 'LaTeX-style :type '(choice (const :tag "TeX search" LaTeX-beamer-search-font-themes) (const :tag "Search once per buffer" local) (function :tag "Other function") (list :value ("default" "professionalfonts" "serif" "structurebold" "structureitalicserif" "structuresmallcapsserif") (set :inline t (const "default") (const "professionalfonts") (const "serif") (const "structurebold") (const "structureitalicserif") (const "structuresmallcapsserif")) (repeat :inline t :tag "Other" (string)))))

(defcustom LaTeX-comment-env-list '("comment") "\
List of environment names defined with comment.sty.
Setting this variable does not take effect unless you
reinitialize affected buffers." :type '(repeat string) :group 'LaTeX-style)

(defcustom LaTeX-csquotes-quote-after-quote nil "\
Initial value of `TeX-quote-after-quote' for `csquotes.el'" :type 'boolean :group 'LaTeX-style)

(defcustom LaTeX-csquotes-open-quote "" "\
Opening quotation mark to be used with the csquotes package.
The specified string will be used for `TeX-open-quote' (and override
any language-specific setting) only if both `LaTeX-csquotes-open-quote'
and `LaTeX-csquotes-close-quote' are non-empty strings." :type 'string :group 'LaTeX-style)

(defcustom LaTeX-csquotes-close-quote "" "\
Closing quotation mark to be used with the csquotes package.
The specified string will be used for `TeX-close-quote' (and override
any language-specific setting) only if both `LaTeX-csquotes-open-quote'
and `LaTeX-csquotes-close-quote' are non-empty strings." :type 'string :group 'LaTeX-style)

(defcustom LaTeX-write18-enabled-p t "\
*If non-nil, insert automatically the \\write18 calling metapost.
When disabled, you have to use mpost on the mp files automatically 
produced by emp.sty and then re-LaTeX the document." :type 'boolean :group 'LaTeX-style)

(defcustom LaTeX-fontspec-arg-font-search t "\
If `LaTeX-fontspec-arg-font' should search for fonts.
If the value is t, fonts are retrieved automatically and provided
for completion.  If the value is nil,
`LaTeX-fontspec-font-list-default' is used for completion.  If
the value is `ask', you are asked for the method to use every
time `LaTeX-fontspec-arg-font' is called.

`LaTeX-fontspec-arg-font' calls `luaotf-load --list=basename' to
automatically get the list of fonts.  This requires
`luaotfload-tool' version 2.3 or higher in order to work." :group 'LaTeX-style :type '(choice (const :tag "Search automatically" t) (const :tag "Use default font list" nil) (const :tag "Ask what to do" ask)))

(defcustom LaTeX-fontspec-font-list-default nil "\
List of default fonts to be used as completion for
`LaTeX-fontspec-arg-font'." :group 'LaTeX-style :type '(repeat (string :tag "Font")))

(defcustom LaTeX-includegraphics-extensions '("eps" "jpe?g" "pdf" "png") "\
Extensions for images files used by \\includegraphics." :group 'LaTeX-style :type '(list (set :inline t (const "eps") (const "jpe?g") (const "pdf") (const "png")) (repeat :inline t :tag "Other" (string))))

(defcustom LaTeX-includegraphics-options-alist '((0 width) (4) (5 trim) (16 height totalheight width scale angle origin bb viewport trim clip keepaspectratio page)) "\
Controls for which optional arguments of \\includegraphics you get prompted.

An alist, consisting of (NUMBER . LIST) pairs.  Valid elements of LIST are
`width', `height', `keepaspectratio', `clip', `angle', `totalheight', `trim'
and `bb' (Bounding Box).

The list corresponding to 0 is used if no prefix is given.  Note that 4 (one
\\[universal-argument]) and 16 (two \\[universal-argument]'s) are easy to
type and should be used for frequently needed combinations." :group 'LaTeX-style :type '(repeat (cons (integer :tag "Argument") (list (set :inline t (const height) (const totalheight) (const width) (const scale) (const angle) (const origin) (const :tag "Bounding Box" bb) (const viewport) (const trim) (const clip) (const keepaspectratio))))))

(defcustom LaTeX-includegraphics-strip-extension-flag t "\
Non-nil means to strip known extensions from image file name." :group 'LaTeX-style :type 'boolean)

(defcustom LaTeX-includegraphics-read-file 'LaTeX-includegraphics-read-file-TeX "\
Function for reading \\includegraphics files.

`LaTeX-includegraphics-read-file-TeX' lists all graphic files
found in the TeX search path.

`LaTeX-includegraphics-read-file-relative' lists all graphic files
in the master directory and its subdirectories and inserts the
relative file name.  This option does not work with Emacs 21 or
XEmacs.

The custom option `simple' works as
`LaTeX-includegraphics-read-file-relative' but it lists all kind of
files.

Inserting the subdirectory in the filename (as
`LaTeX-includegraphics-read-file-relative') is discouraged by
`epslatex.ps'." :group 'LaTeX-style :type '(choice (const :tag "TeX" LaTeX-includegraphics-read-file-TeX) (const :tag "relative" LaTeX-includegraphics-read-file-relative) (const :tag "simple" (lambda nil (file-relative-name (read-file-name "Image file: ") (TeX-master-directory)))) (function :tag "other")))

;;;***

;;;### (autoloads (TeX-quote-language-alist TeX-quote-after-quote TeX-close-quote TeX-open-quote TeX-quote TeX-electric-math TeX-math-toggle-off-input-method TeX-font-list TeX-brace-indent-level TeX-indentation TeX-newline-function TeX-electric-sub-and-superscript TeX-electric-escape TeX-kpathsea-path-delimiter TeX-tree-roots BibTeX-style-extensions BibLaTeX-style-extensions BibTeX-file-extensions TeX-Biber-file-extensions docTeX-default-extension TeX-default-extension TeX-all-extensions TeX-file-extensions TeX-file-extension TeX-auto-x-regexp-list TeX-auto-x-parse-length TeX-auto-parse-length TeX-auto-regexp-list TeX-file-recurse TeX-ignore-file TeX-auto-default TeX-macro-default TeX-auto-untabify TeX-auto-save TeX-parse TeX-force-default-mode TeX-default-mode TeX-install-font-lock TeX-default-unit-for-image TeX-insert-macro-default-style TeX-insert-braces-alist TeX-insert-braces TeX-default-macro TeX-complete-expert-commands TeX-complete-word TeX-macro TeX-parse-self TeX-virgin-style TeX-byte-compile TeX-check-path TeX-style-path TeX-style-private TeX-auto-private TeX-macro-private TeX-macro-global TeX-style-local TeX-auto-local TeX-style-global TeX-one-master TeX-master TeX-clean-confirm TeX-command-Queue TeX-command-Print TeX-command-Show TeX-command-Biber TeX-command-BibTeX TeX-command-name TeX-DVI-via-PDFTeX TeX-PDF-mode TeX-source-specials-view-emacsclient-flags TeX-source-specials-view-gnuclient-flags TeX-source-specials-view-editor-flags TeX-source-specials-view-position-flags TeX-source-specials-places TeX-source-specials-tex-flags TeX-source-correlate-start-server TeX-source-correlate-method TeX-engine TeX-engine-alist TeX-view-program-selection TeX-view-program-list TeX-view-predicate-list TeX-output-view-style TeX-view-style TeX-view TeX-debug-warnings TeX-debug-bad-boxes TeX-display-help TeX-output TeX-expand-list TeX-command-extra-options TeX-print-style TeX-printer-default TeX-printer-list TeX-queue-command TeX-print-command LaTeX-command-style LaTeX-version TeX-command-output-list TeX-command-list AmS-TeX-mode-hook TeX-mode-hook ConTeXt-Omega-engine ConTeXt-engine LaTeX-Omega-command LaTeX-command TeX-Omega-command TeX-command TeX-misc LaTeX TeX-command TeX-file) "tex" "auctex/tex.el")
(defconst custom-define-current-source-file "tex.el")

(defgroup TeX-file nil "Files used by AUCTeX." :group 'AUCTeX)

(defgroup TeX-command nil "Calling external commands from AUCTeX." :group 'AUCTeX)

(defgroup LaTeX nil "LaTeX support in AUCTeX." :tag "LaTeX" :group 'AUCTeX :prefix "LaTeX-")

(defgroup TeX-misc nil "Various AUCTeX settings." :group 'AUCTeX)

(defcustom TeX-command "tex" "\
Command to run plain TeX." :group 'TeX-command :type 'string)

(defcustom TeX-Omega-command "omega" "\
Command to run plain TeX on Omega." :group 'TeX-command :type 'string)

(defcustom LaTeX-command "latex" "\
Command to run LaTeX." :group 'TeX-command :type 'string)

(defcustom LaTeX-Omega-command "lambda" "\
Command to run LaTeX on Omega." :group 'TeX-command :type 'string)

(defcustom ConTeXt-engine nil "\
Engine to use for --engine in the texexec command.
If nil, none is specified." :group 'TeX-command :type '(choice (const :tag "Unspecified" nil) string))

(defcustom ConTeXt-Omega-engine TeX-Omega-command "\
Engine to use for --engine in the texexec command in Omega mode.
If nil, none is specified." :group 'TeX-command :type '(choice (const :tag "Unspecified" nil) string))

(defcustom TeX-mode-hook nil "\
A hook run in TeX mode buffers." :type 'hook :group 'TeX-misc)

(defcustom AmS-TeX-mode-hook nil "\
A hook run in AmS-TeX mode buffers." :type 'hook :group 'TeX-misc)

(defcustom TeX-command-list (backquote (("TeX" "%(PDF)%(tex) %(extraopts) %`%S%(PDFout)%(mode)%' %t" TeX-run-TeX nil (plain-tex-mode ams-tex-mode texinfo-mode) :help "Run plain TeX") ("LaTeX" "%`%l%(mode)%' %t" TeX-run-TeX nil (latex-mode doctex-mode) :help "Run LaTeX") ("Makeinfo" "makeinfo %(extraopts) %t" TeX-run-compile nil (texinfo-mode) :help "Run Makeinfo with Info output") ("Makeinfo HTML" "makeinfo %(extraopts) --html %t" TeX-run-compile nil (texinfo-mode) :help "Run Makeinfo with HTML output") ("AmSTeX" "%(PDF)amstex %(extraopts) %`%S%(PDFout)%(mode)%' %t" TeX-run-TeX nil (ams-tex-mode) :help "Run AMSTeX") ("ConTeXt" "texexec --once --texutil %(extraopts) %(execopts)%t" TeX-run-TeX nil (context-mode) :help "Run ConTeXt once") ("ConTeXt Full" "texexec %(extraopts) %(execopts)%t" TeX-run-TeX nil (context-mode) :help "Run ConTeXt until completion") ("BibTeX" "bibtex %s" TeX-run-BibTeX nil t :help "Run BibTeX") ("Biber" "biber %s" TeX-run-Biber nil t :help "Run Biber") (\, (if (or window-system (getenv "DISPLAY")) '("View" "%V" TeX-run-discard-or-function t t :help "Run Viewer") '("View" "dvi2tty -q -w 132 %s" TeX-run-command t t :help "Run Text viewer"))) ("Print" "%p" TeX-run-command t t :help "Print the file") ("Queue" "%q" TeX-run-background nil t :help "View the printer queue" :visible TeX-queue-command) ("File" "%(o?)dvips %d -o %f " TeX-run-command t t :help "Generate PostScript file") ("Index" "makeindex %s" TeX-run-command nil t :help "Create index file") ("Xindy" "texindy %s" TeX-run-command nil t :help "Run xindy to create index file") ("Check" "lacheck %s" TeX-run-compile nil (latex-mode) :help "Check LaTeX file for correctness") ("ChkTeX" "chktex -v6 %s" TeX-run-compile nil (latex-mode) :help "Check LaTeX file for common mistakes") ("Spell" "(TeX-ispell-document \"\")" TeX-run-function nil t :help "Spell-check the document") ("Clean" "TeX-clean" TeX-run-function nil t :help "Delete generated intermediate files") ("Clean All" "(TeX-clean t)" TeX-run-function nil t :help "Delete generated intermediate and output files") ("Other" "" TeX-run-command t t :help "Run an arbitrary command"))) "\
List of commands to execute on the current document.

Each element is a list, whose first element is the name of the command
as it will be presented to the user.

The second element is the string handed to the shell after being
expanded.  The expansion is done using the information found in
`TeX-expand-list'.

The third element is the function which actually start the process.
Several such hooks has been defined:

TeX-run-command: Start up the process and show the output in a
separate buffer.  Check that there is not two commands running for the
same file.  Return the process object.

TeX-run-format: As `TeX-run-command', but assume the output is created
by a TeX macro package.  Return the process object.

TeX-run-TeX: For TeX output.

TeX-run-interactive: Run TeX or LaTeX interactively.

TeX-run-BibTeX: For BibTeX output.

TeX-run-Biber: For Biber output.

TeX-run-compile: Use `compile' to run the process.

TeX-run-shell: Use `shell-command' to run the process.

TeX-run-discard: Start the process in the background, discarding its
output.

TeX-run-background: Start the process in the background, show output
in other window.

TeX-run-silent: Start the process in the background.

TeX-run-discard-foreground: Start the process in the foreground,
discarding its output.

TeX-run-function: Execute the Lisp function or function call
specified by the string in the second element.  Consequently,
this hook does not start a process.

TeX-run-discard-or-function: If the command is a Lisp function,
execute it as such, otherwise start the command as a process,
discarding its output.

To create your own hook, define a function taking three arguments: The
name of the command, the command string, and the name of the file to
process.  It might be useful to use `TeX-run-command' in order to
create an asynchronous process.

If the fourth element is non-nil, the user will get a chance to
modify the expanded string.

The fifth element indicates in which mode(s) the command should be
present in the Command menu.  Use t if it should be active in any
mode.  If it should only be present in some modes, specify a list with
the respective mode names.

Any additional elements get just transferred to the respective menu entries." :group 'TeX-command :type '(repeat (group :value ("" "" TeX-run-command nil t) (string :tag "Name") (string :tag "Command") (choice :tag "How" :value TeX-run-command (function-item TeX-run-command) (function-item TeX-run-format) (function-item TeX-run-TeX) (function-item TeX-run-interactive) (function-item TeX-run-BibTeX) (function-item TeX-run-Biber) (function-item TeX-run-compile) (function-item TeX-run-shell) (function-item TeX-run-discard) (function-item TeX-run-background) (function-item TeX-run-silent) (function-item TeX-run-discard-foreground) (function-item TeX-run-function) (function-item TeX-run-discard-or-function) (function :tag "Other")) (boolean :tag "Prompt") (choice :tag "Modes" (const :tag "All" t) (set (const :tag "Plain TeX" plain-tex-mode) (const :tag "LaTeX" latex-mode) (const :tag "DocTeX" doctex-mode) (const :tag "ConTeXt" context-mode) (const :tag "Texinfo" texinfo-mode) (const :tag "AmSTeX" ams-tex-mode))) (repeat :tag "Menu elements" :inline t sexp))))

(defcustom TeX-command-output-list 'nil "\
List of regexps and file extensions.

Each element is a list, whose first element is a regular expression to
match against the name of the command that will be used to process the TeX
file.

The second element is either a string or a list with a string as element.
If it is a string this is the default file extension that will be expected
for output files that are produced by commands that match the first
element.  The real file extension will be obtained from the logging output
if possible, defaulting to the given string.
If it is a list, the element of the list will be the fixed extension used
without looking at the logging output.

If this list does not yield an extension, the default is either \"dvi\"
or \"pdf\", depending on the setting of `TeX-PDF-mode'.
Extensions must be given without the \".\"." :group 'TeX-command :type '(repeat (group (regexp :tag "Command Regexp") (choice (string :tag "Default Extension") (group (string :tag "Fixed Extension"))))))

(defcustom LaTeX-version "2e" "\
Default LaTeX version.  Currently recognized is \"2\" and \"2e\"." :group 'LaTeX :type '(radio (const :format "%v
%h" :doc "The executable `latex' is LaTeX version 2." "2") (const :format "%v
%h" :doc "The executable `latex' is LaTeX version 2e." "2e") (string :tag "Other")))

(defcustom LaTeX-command-style '(("" "%(PDF)%(latex) %(extraopts) %S%(PDFout)")) "\
List of style options and LaTeX commands.

If the first element (a regular expression) matches the name of one of
the style files, any occurrence of the string `%l' in a command in
`TeX-command-list' will be replaced with the second element.  The first
match is used, if no match is found the `%l' is replaced with the empty
string." :group 'TeX-command :type '(repeat (group :value ("" "") regexp (string :tag "Style"))))

(defcustom TeX-print-command "{ test -e %s.dvi && %(o?)dvips -P%p %r %s; } || lpr -P%p %o" "\
Command used to print a file.

First `%p' is expanded to the printer name, then ordinary expansion is
performed as specified in `TeX-expand-list'.  If it is nil,
then customization is requested." :group 'TeX-command :type '(choice (string :tag "Print command") (const :tag "No print command customized" nil)))

(defcustom TeX-queue-command "lpq -P%p" "\
Command used to show the status of a printer queue.

First `%p' is expanded to the printer name, then ordinary expansion is
performed as specified in `TeX-expand-list'.  If this is nil,
the printer has no corresponding command." :group 'TeX-command :type '(choice (string :tag "Queue check command") (const :tag "No such command" nil)))

(defcustom TeX-printer-list '(("Default" "{ test -e %s.dvi && %(o?)dvips -f %r %s | lpr; } || lpr %o" "lpq")) "\
List of available printers.

The first element of each entry is the printer name.

The second element is the command used to print to this
printer.  It defaults to the value of `TeX-print-command' when nil.

The third element is the command used to examine the print queue for
this printer.  It defaults to the value of `TeX-queue-command' similarly.

Any occurrence of `%p' in the second or third element is expanded to
the printer name given in the first element, then ordinary expansion
is performed as specified in `TeX-expand-list'.

If this list is empty, only `TeX-print-command' and `TeX-queue-command'
get consulted." :group 'TeX-command :type '(repeat (group (string :tag "Name") (option (group :inline t :extra-offset -4 (choice :tag "Print" (const :tag "default") (string :format "%v")) (option (choice :tag "Queue" (const :tag "default") (string :format "%v"))))))))

(defcustom TeX-printer-default (or (getenv "PRINTER") (and TeX-printer-list (car (car TeX-printer-list))) "lp") "\
Default printer to use with `TeX-command'." :group 'TeX-command :type 'string)

(defcustom TeX-print-style '(("^landscape$" "-t landscape")) "\
List of style options and print options.

If the first element (a regular expression) matches the name of one of
the style files, any occurrence of the string `%r' in a command in
`TeX-command-list' will be replaced with the second element.  The first
match is used, if no match is found the `%r' is replaced with the empty
string." :group 'TeX-command :type '(repeat (group regexp (string :tag "Command"))))

(defcustom TeX-command-extra-options "" "\
String with the extra options to be given to the TeX processor." :type 'string)

(defcustom TeX-expand-list '(("%p" TeX-printer-query) ("%q" (lambda nil (TeX-printer-query t))) ("%V" (lambda nil (TeX-source-correlate-start-server-maybe) (TeX-view-command-raw))) ("%vv" (lambda nil (TeX-source-correlate-start-server-maybe) (TeX-output-style-check TeX-output-view-style))) ("%v" (lambda nil (TeX-source-correlate-start-server-maybe) (TeX-style-check TeX-view-style))) ("%r" (lambda nil (TeX-style-check TeX-print-style))) ("%l" (lambda nil (TeX-style-check LaTeX-command-style))) ("%(PDF)" (lambda nil (if (and (eq TeX-engine 'default) (or TeX-PDF-mode TeX-DVI-via-PDFTeX)) "pdf" ""))) ("%(PDFout)" (lambda nil (cond ((and (eq TeX-engine 'xetex) (not TeX-PDF-mode)) " -no-pdf") ((and (eq TeX-engine 'luatex) (not TeX-PDF-mode)) " --output-format=dvi") ((and (eq TeX-engine 'default) (not TeX-PDF-mode) TeX-DVI-via-PDFTeX) " \"\\pdfoutput=0 \"") (t "")))) ("%(mode)" (lambda nil (if TeX-interactive-mode "" " -interaction=nonstopmode"))) ("%(o?)" (lambda nil (if (eq TeX-engine 'omega) "o" ""))) ("%(tex)" (lambda nil (eval (nth 2 (assq TeX-engine (TeX-engine-alist)))))) ("%(latex)" (lambda nil (eval (nth 3 (assq TeX-engine (TeX-engine-alist)))))) ("%(execopts)" ConTeXt-expand-options) ("%(extraopts)" (lambda nil TeX-command-extra-options)) ("%S" TeX-source-correlate-expand-options) ("%dS" TeX-source-specials-view-expand-options) ("%cS" TeX-source-specials-view-expand-client) ("%(outpage)" (lambda nil (and TeX-source-correlate-mode (null TeX-source-correlate-output-page-function) (eq (TeX-source-correlate-method-active) 'synctex) (setq TeX-source-correlate-output-page-function 'TeX-synctex-output-page)) (or (if TeX-source-correlate-output-page-function (funcall TeX-source-correlate-output-page-function)) "1"))) ("%s" file nil t) ("%t" file t t) ("%`" (lambda nil (setq TeX-command-pos t TeX-command-text ""))) (" \"\\" (lambda nil (if (eq TeX-command-pos t) (setq TeX-command-pos pos pos (+ 3 pos)) (setq pos (1+ pos))))) ("\"" (lambda nil (if (numberp TeX-command-pos) (setq TeX-command-text (concat TeX-command-text (substring command TeX-command-pos (1+ pos))) command (concat (substring command 0 TeX-command-pos) (substring command (1+ pos))) pos TeX-command-pos TeX-command-pos t) (setq pos (1+ pos))))) ("%'" (lambda nil (prog1 (if (stringp TeX-command-text) (progn (setq pos (+ pos (length TeX-command-text) 9) TeX-command-pos (and (string-match " " (funcall file t t)) "\"")) (concat TeX-command-text " \"\\input\"")) (setq TeX-command-pos nil) "") (setq TeX-command-text nil)))) ("%n" TeX-current-line) ("%d" file "dvi" t) ("%f" file "ps" t) ("%o" (lambda nil (funcall file (TeX-output-extension) t))) ("%b" TeX-current-file-name-master-relative) ("%a" (lambda nil (prin1-to-string (expand-file-name (buffer-file-name))))) ("%m" preview-create-subdirectory)) "\
List of expansion strings for TeX command names.

Each entry is a list with two or more elements.  The first element is
the string to be expanded.  The second element is the name of a
function returning the expanded string when called with the remaining
elements as arguments.  The special value `file' will be expanded to
the name of the file being processed, with an optional extension." :group 'TeX-command :type '(repeat (group (string :tag "Key") (sexp :tag "Expander") (repeat :inline t :tag "Arguments" (sexp :format "%v")))))

(defgroup TeX-output nil "Parsing TeX output." :prefix "TeX-" :group 'AUCTeX)

(defcustom TeX-display-help t "\
Control type of help display when stepping through errors with \\[TeX-next-error].
If t display help buffer.  If nil display message about error in
echo area.  If `expert' display output buffer with raw processor output." :group 'TeX-output :type '(choice (const :tag "Help buffer" t) (const :tag "Echo area" nil) (const :tag "Output buffer" expert)))

(defcustom TeX-debug-bad-boxes nil "\
Non-nil means also find overfull/underfull box warnings with \\[TeX-next-error]." :group 'TeX-output :type 'boolean)

(defcustom TeX-debug-warnings nil "\
Non-nil means also find LaTeX or package warnings with \\[TeX-next-error]." :group 'TeX-output :type 'boolean)

(defgroup TeX-view nil "Calling viewers from AUCTeX." :group 'TeX-command)

(defcustom TeX-view-style (backquote (((\, (concat "^" (regexp-opt '("a4paper" "a4dutch" "a4wide" "sem-a4")) "$")) "%(o?)xdvi %dS -paper a4 %d") ((\, (concat "^" (regexp-opt '("a5paper" "a5comb")) "$")) "%(o?)xdvi %dS -paper a5 %d") ("^b5paper$" "%(o?)xdvi %dS -paper b5 %d") ("^letterpaper$" "%(o?)xdvi %dS -paper us %d") ("^legalpaper$" "%(o?)xdvi %dS -paper legal %d") ("^executivepaper$" "%(o?)xdvi %dS -paper 7.25x10.5in %d") ("^landscape$" "%(o?)xdvi %dS -paper a4r -s 0 %d") ("." "%(o?)xdvi %dS %d"))) "\
List of style options and view options.

If the first element (a regular expression) matches the name of
one of the style files, any occurrence of the string `%v' in a
command in `TeX-command-list' will be replaced with the second
element.  The first match is used, if no match is found the `%v'
is replaced with the empty string.

As a default, the \"View\" command in `TeX-command-list' is set
to `%V'.  This means that `TeX-output-view-style' will be
consulted before `TeX-view-style'.  Only if no match is found in
`TeX-output-view-style' the settings in `TeX-view-style' will be
considered.  If you want to bypass `TeX-output-view-style', which
is not recommended because it is more powerful than
`TeX-view-style', use `%v' in the \"View\" command." :group 'TeX-view :type '(repeat (group regexp (string :tag "Command"))))

(defcustom TeX-output-view-style (backquote (("^dvi$" ("^landscape$" "^pstricks$\\|^pst-\\|^psfrag$") "%(o?)dvips -t landscape %d -o && gv %f") ("^dvi$" "^pstricks$\\|^pst-\\|^psfrag$" "%(o?)dvips %d -o && gv %f") ("^dvi$" ((\, (concat "^" (regexp-opt '("a4paper" "a4dutch" "a4wide" "sem-a4")) "$")) "^landscape$") "%(o?)xdvi %dS -paper a4r -s 0 %d") ("^dvi$" (\, (concat "^" (regexp-opt '("a4paper" "a4dutch" "a4wide" "sem-a4")) "$")) "%(o?)xdvi %dS -paper a4 %d") ("^dvi$" ((\, (concat "^" (regexp-opt '("a5paper" "a5comb")) "$")) "^landscape$") "%(o?)xdvi %dS -paper a5r -s 0 %d") ("^dvi$" (\, (concat "^" (regexp-opt '("a5paper" "a5comb")) "$")) "%(o?)xdvi %dS -paper a5 %d") ("^dvi$" "^b5paper$" "%(o?)xdvi %dS -paper b5 %d") ("^dvi$" "^letterpaper$" "%(o?)xdvi %dS -paper us %d") ("^dvi$" "^legalpaper$" "%(o?)xdvi %dS -paper legal %d") ("^dvi$" "^executivepaper$" "%(o?)xdvi %dS -paper 7.25x10.5in %d") ("^dvi$" "." "%(o?)xdvi %dS %d") ("^pdf$" "." "xpdf -remote %s -raise %o %(outpage)") ("^html?$" "." "netscape %o"))) "\
List of output file extensions and view options.

If the first element (a regular expression) matches the output
file extension, and the second element (a regular expression)
matches the name of one of the style options, any occurrence of
the string `%V' in a command in `TeX-command-list' will be
replaced with the third element.  The first match is used; if no
match is found the `%V' is replaced with `%v'.  The outcome of `%v'
is determined by the settings in `TeX-view-style' which therefore
serves as a fallback for `TeX-output-view-style'.  The second
element may also be a list of regular expressions, in which case
all the regular expressions must match for the element to apply." :group 'TeX-view :type '(repeat (group (regexp :tag "Extension") (choice regexp (repeat :tag "List" regexp)) (string :tag "Command"))))

(defcustom TeX-view-predicate-list nil "\
Alist of predicates for viewer selection and invocation.
The key of each list item is a symbol and the value a Lisp form
to be evaluated.  The form should return nil if the predicate is
not fulfilled.

Built-in predicates provided in `TeX-view-predicate-list-builtin'
can be overwritten by defining predicates with the same symbol.

The following built-in predicates are available:
  `output-dvi': The output is a DVI file.
  `output-pdf': The output is a PDF file.
  `output-html': The output is an HTML file.
  `style-pstricks': The document loads a PSTricks package.
  `engine-omega': The Omega engine is used for typesetting.
  `engine-xetex': The XeTeX engine is used for typesetting.
  `mode-io-correlate': TeX Source Correlate mode is active.
  `paper-landscape': The document is typeset in landscape orientation.
  `paper-portrait': The document is not typeset in landscape orientation.
  `paper-a4': The paper format is A4.
  `paper-a5': The paper format is A5.
  `paper-b5': The paper format is B5.
  `paper-letter': The paper format is letter.
  `paper-legal': The paper format is legal.
  `paper-executive': The paper format is executive." :group 'TeX-view :type '(alist :key-type symbol :value-type (group sexp)))

(defcustom TeX-view-program-list nil "\
Alist of viewer specifications.
This variable can be used to specify how a viewer is to be
invoked and thereby add new viewers on top of the built-in list
of viewers defined in `TeX-view-program-list-builtin' or override
entries in the latter.

The car of each item is a string with a user-readable name.  The
second element can be a command line to be run as a process or a
Lisp function to be executed.  The command line can either be
specified as a single string or a list of strings and two-part
lists.  The first element of the two-part lists is a symbol or a
list of symbols referring to one or more of the predicates in
`TeX-view-predicate-list' or `TeX-view-predicate-list-builtin'.
The second part of the two-part lists is a command line part.
The command line for the viewer is constructed by concatenating
the command line parts.  Parts with a predicate are only
considered if the predicate was evaluated with a positive result.
Note that the command line can contain placeholders as defined in
`TeX-expand-list' which are expanded before the viewer is called.

The use of a function as the second element only works if the
View command in `TeX-command-list' makes use of the hook
`TeX-run-discard-or-function'.

Note: Predicates defined in the current Emacs session will only
show up in the customization interface for this variable after
restarting Emacs." :group 'TeX-view :type (backquote (alist :key-type (string :tag "Name") :value-type (choice (group :tag "Command" (string :tag "Command")) (group :tag "Command parts" (repeat :tag "Command parts" (choice (string :tag "Command part") (list :tag "Predicate and command part" (\, (let (list) (mapc (lambda (spec) (add-to-list 'list (backquote (const (\, (car spec)))))) (append TeX-view-predicate-list TeX-view-predicate-list-builtin)) (setq list (sort list (lambda (a b) (string< (downcase (symbol-name (cadr a))) (downcase (symbol-name (cadr b))))))) (backquote (choice (choice :tag "Predicate" (\,@ list)) (repeat :tag "List of predicates" (choice :tag "Predicate" (\,@ list))))))) (string :tag "Command part"))))) (group :tag "Function" function)))))

(defcustom TeX-view-program-selection (cond ((eq system-type 'windows-nt) '(((output-dvi style-pstricks) "dvips and start") (output-dvi "Yap") (output-pdf "start") (output-html "start"))) ((eq system-type 'darwin) '((output-dvi "open") (output-pdf "open") (output-html "open"))) (t '(((output-dvi style-pstricks) "dvips and gv") (output-dvi "xdvi") (output-pdf "Evince") (output-html "xdg-open")))) "\
Alist of predicates and viewers.
Each entry consists of a list with two elements.  The first
element is a symbol or list of symbols referring to predicates as
defined in `TeX-view-predicate-list' or
`TeX-view-predicate-list-builtin'.  The second element is a
string referring to the name of a viewer as defined in
`TeX-view-program-list' or `TeX-view-program-list-builtin'.
\(Note: Viewers added to `TeX-view-program-list' in the current
Emacs session will not show up in the customization interface of
`TeX-view-program-selection' until you restart Emacs.)

When a viewer is called for, the entries are evaluated in turn
and the viewer related to the first entry all predicates of which
are evaluated positively is chosen." :group 'TeX-view :type (backquote (alist :key-type (\, (let (list) (mapc (lambda (spec) (add-to-list 'list (backquote (const (\, (car spec)))))) (append TeX-view-predicate-list TeX-view-predicate-list-builtin)) (setq list (sort list (lambda (a b) (string< (downcase (symbol-name (cadr a))) (downcase (symbol-name (cadr b))))))) (backquote (choice (choice :tag "Single predicate" (\,@ list)) (repeat :tag "Multiple predicates" (choice (\,@ list))))))) :value-type (group (choice :tag "Viewer" (\,@ (let (list) (mapc (lambda (spec) (add-to-list 'list (backquote (const (\, (car spec)))))) (append TeX-view-program-list TeX-view-program-list-builtin)) (sort list (lambda (a b) (string< (downcase (cadr a)) (downcase (cadr b))))))))))))

(defcustom TeX-engine-alist nil "\
Alist of TeX engines and associated commands.
Each entry is a list with a maximum of five elements.  The first
element is a symbol used to identify the engine.  The second is a
string describing the engine.  The third is the command to be
used for plain TeX.  The fourth is the command to be used for
LaTeX.  The fifth is the command to be used for the --engine
parameter of ConTeXt's texexec program.  Each command can either
be a variable or a string.  An empty string or nil means there is
no command available.

You can override a built-in engine defined in the variable
`TeX-engine-alist-builtin' by adding an entry beginning with the
same symbol as the built-in entry to `TeX-engine-alist'." :group 'TeX-command :type '(repeat (group symbol (string :tag "Name") (choice :tag "Plain TeX command" string variable) (choice :tag "LaTeX command" string variable) (choice :tag "ConTeXt command" string variable))))

(defcustom TeX-engine 'default (concat "Type of TeX engine to use.\nIt should be one of the following symbols:\n\n" (mapconcat (lambda (x) (format "* `%s'" (car x))) (TeX-engine-alist) "\n")) :group 'TeX-command :type (backquote (choice (\,@ (mapcar (lambda (x) (backquote (const :tag (\, (nth 1 x)) (\, (car x))))) (TeX-engine-alist))))))

(defcustom TeX-source-correlate-method '((dvi . source-specials) (pdf . synctex)) "\
Method to use for enabling forward and inverse search.
This can be `source-specials' if source specials should be used,
`synctex' if SyncTeX should be used, or `auto' if AUCTeX should
decide.

The previous values determine the variable for both DVI and PDF
mode.  This variable can also be an alist of the kind

  ((dvi . <source-specials or synctex>)
   (pdf . <source-specials or synctex>))

in which the CDR of each entry is a symbol specifying the method
to be used in the corresponding mode.

Programs should not use this variable directly but the function
`TeX-source-correlate-method-active' which returns the method
actually used for forward and inverse search." :type '(choice (const auto) (const synctex) (const source-specials) (list :tag "Different method for DVI and PDF" (cons (const dvi) (choice :tag "Method for DVI mode" (const synctex) (const source-specials))) (cons (const pdf) (choice :tag "Method for PDF mode" (const synctex) (const source-specials))))) :group 'TeX-view)

(defcustom TeX-source-correlate-start-server 'ask "\
Control if server should be started for inverse search." :type '(choice (const :tag "Always" t) (const :tag "Never" nil) (const :tag "Ask" ask)) :group 'TeX-view)

(defcustom TeX-source-specials-tex-flags "-src-specials" "\
Extra flags to pass to TeX commands to generate source specials." :group 'TeX-view :type 'string)

(defcustom TeX-source-specials-places nil "\
List of places where to insert source specials into the DVI file.
If nil, use (La)TeX's defaults." :group 'TeX-view :type '(list (set :inline t (const "cr") (const "display") (const "hbox") (const "math") (const "par") (const "parend") (const "vbox")) (repeat :inline t :tag "Other options" (string))))

(defcustom TeX-source-specials-view-position-flags "-sourceposition \"%n %b\"" "\
Flags to pass to the DVI viewer commands for the position in the source." :group 'TeX-view :type 'string)

(defcustom TeX-source-specials-view-editor-flags "-editor \"%cS\"" "\
Flags to pass to DVI viewer commands for inverse search." :group 'TeX-view :type 'string)

(defcustom TeX-source-specials-view-gnuclient-flags "-q +%%l %%f" "\
Flags to pass to gnuclient for inverse search." :group 'TeX-view :type 'string)

(defcustom TeX-source-specials-view-emacsclient-flags "--no-wait +%%l %%f" "\
Flags to emacsclient for inverse search." :group 'TeX-view :type 'string)

(defcustom TeX-PDF-mode t nil :group 'TeX-command :set 'TeX-mode-set :type 'boolean)

(defcustom TeX-DVI-via-PDFTeX nil "\
Whether to use PDFTeX also for producing DVI files." :group 'TeX-command :type 'boolean)

(defgroup TeX-command-name nil "Names for external commands in AUCTeX." :group 'TeX-command)

(defcustom TeX-command-BibTeX "BibTeX" "\
*The name of the BibTeX entry in `TeX-command-list'." :group 'TeX-command-name :type 'string)

(defcustom TeX-command-Biber "Biber" "\
*The name of the Biber entry in `TeX-command-list'." :group 'TeX-command-name :type 'string)

(defcustom TeX-command-Show "View" "\
*The default command to show (view or print) a TeX file.
Must be the car of an entry in `TeX-command-list'." :group 'TeX-command-name :type 'string)

(defcustom TeX-command-Print "Print" "\
The name of the Print entry in `TeX-command-Print'." :group 'TeX-command-name :type 'string)

(defcustom TeX-command-Queue "Queue" "\
The name of the Queue entry in `TeX-command-Queue'." :group 'TeX-command-name :type 'string)

(defcustom TeX-clean-confirm t "\
If non-nil, ask before deleting files." :type 'boolean :group 'TeX-command)

(defcustom TeX-master t "\
*The master file associated with the current buffer.
If the file being edited is actually included from another file, you
can tell AUCTeX the name of the master file by setting this variable.
If there are multiple levels of nesting, specify the top level file.

If this variable is nil, AUCTeX will query you for the name.

If the variable is t, AUCTeX will assume the file is a master file
itself.

If the variable is 'shared, AUCTeX will query for the name, but not
change the file.

If the variable is 'dwim, AUCTeX will try to avoid querying by
attempting to `do what I mean'; and then change the file.

It is suggested that you use the File Variables (see the info node in
the Emacs manual) to set this variable permanently for each file." :group 'TeX-command :group 'TeX-parse :type '(choice (const :tag "Query" nil) (const :tag "This file" t) (const :tag "Shared" shared) (const :tag "Dwim" dwim) (string :format "%v")))

(defcustom TeX-one-master "\\.\\(texi?\\|dtx\\)$" "\
*Regular expression matching ordinary TeX files.

You should set this variable to match the name of all files, where
automatically adding a file variable with the name of the master file
is a good idea.  When AUCTeX adds the name of the master file as a
file variable, it does not need to ask next time you edit the file.

If you dislike AUCTeX automatically modifying your files, you can set
this variable to \"<none>\"." :group 'TeX-command :type 'regexp)

(defcustom TeX-style-global (expand-file-name "style" TeX-data-directory) "\
*Directory containing hand generated TeX information.

These correspond to TeX macros shared by all users of a site." :group 'TeX-file :type 'directory)

(defcustom TeX-auto-local "auto" "\
*Directory containing automatically generated TeX information.

This correspond to TeX macros found in the current directory, and must
be relative to that." :group 'TeX-file :type 'string)

(defcustom TeX-style-local "style" "\
*Directory containing hand generated TeX information.

These correspond to TeX macros found in the current directory, and must
be relative to that." :group 'TeX-file :type 'string)

(defcustom TeX-macro-global (TeX-macro-global) "\
Directories containing the site's TeX macro and style files." :group 'TeX-file :type '(repeat (directory :format "%v")))

(defcustom TeX-macro-private (or (append (TeX-parse-path "TEXINPUTS") (TeX-parse-path "BIBINPUTS")) (TeX-macro-private)) "\
Directories where you store your personal TeX macros." :group 'TeX-file :type '(repeat (file :format "%v")))

(defcustom TeX-auto-private (list (expand-file-name TeX-auto-local (or (and (boundp 'user-emacs-directory) (concat user-emacs-directory "auctex/")) "~/.emacs.d/auctex/"))) "\
List of directories containing automatically generated AUCTeX style files.

These correspond to the personal TeX macros." :group 'TeX-file :type '(repeat (file :format "%v")))

(defcustom TeX-style-private (list (expand-file-name TeX-style-local (or (and (boundp 'user-emacs-directory) (concat user-emacs-directory "auctex/")) "~/.emacs.d/auctex/"))) "\
List of directories containing hand-generated AUCTeX style files.

These correspond to the personal TeX macros." :group 'TeX-file :type '(repeat (file :format "%v")))

(defcustom TeX-style-path (let ((path)) (mapcar (lambda (file) (when file (add-to-list 'path file t))) (append (list TeX-auto-global TeX-style-global) TeX-auto-private TeX-style-private (list TeX-auto-local TeX-style-local))) path) "\
List of directories to search for AUCTeX style files.
Per default the list is built from the values of the variables
`TeX-auto-global', `TeX-style-global', `TeX-auto-private',
`TeX-style-private', `TeX-auto-local', and `TeX-style-local'." :group 'TeX-file :type '(repeat (file :format "%v")))

(defcustom TeX-check-path (append (list ".") TeX-macro-private TeX-macro-global) "\
Directory path to search for dependencies.

If nil, just check the current file.
Used when checking if any files have changed." :group 'TeX-file :type '(repeat (file :format "%v")))

(defcustom TeX-byte-compile nil "\
*Not nil means try to byte compile auto files before loading." :group 'TeX-parse :type 'boolean)

(defcustom TeX-virgin-style (if (and TeX-auto-global (file-directory-p TeX-auto-global)) "virtex" "NoVirtexSymbols") "\
Style all documents use." :group 'TeX-parse :type 'string)

(defcustom TeX-parse-self nil "\
Parse file after loading it if no style hook is found for it." :group 'TeX-parse :type 'boolean)

(defgroup TeX-macro nil "Support for TeX macros in AUCTeX." :prefix "TeX-" :group 'AUCTeX)

(defcustom TeX-complete-word 'ispell-complete-word "\
*Function to call for completing non-macros in `tex-mode'." :group 'TeX-macro)

(defcustom TeX-complete-expert-commands nil "\
Complete macros and environments marked as expert commands.

Possible values are nil, t, or a list of style names.

  - nil           Don't complete expert commands (default).
  - t             Always complete expert commands.
  - (STYLES ...)  Only complete expert commands of STYLES." :group 'TeX-macro :type '(choice (const :tag "Don't complete expert commands" nil) (const :tag "Always complete expert commands" t) (repeat :tag "Complete expert commands of certain styles" string)))

(defcustom TeX-default-macro "ref" "\
*The default macro when creating new ones with `TeX-insert-macro'." :group 'TeX-macro :type 'string)

(defcustom TeX-insert-braces t "\
*If non-nil, append a empty pair of braces after inserting a macro.

See also `TeX-insert-braces-alist'." :group 'TeX-macro :type 'boolean)

(defcustom TeX-insert-braces-alist nil "\
Alist of macros to which braces should or should not be appended.

Each element is a cons cell, whose CAR is the macro name, and the
CDR is non-nil or nil, depending on whether a pair of braces
should be, respectively, appended or not to the macro.

If a macro has an element in this variable, `TeX-parse-macro'
will use its value to decided what to do, whatever the value of
the variable `TeX-insert-braces'." :group 'TeX-macro :type '(repeat (cons (string :tag "Macro name") (boolean :tag "Append braces?"))))

(defcustom TeX-insert-macro-default-style 'show-optional-args "\
Specifies whether `TeX-insert-macro' will ask for all optional arguments.

If set to the symbol `show-optional-args', `TeX-insert-macro'
asks for optional arguments of TeX marcos, unless the previous
optional argument has been rejected.  If set to
`show-all-optional-args', `TeX-insert-macro' asks for all
optional arguments.  If set to `mandatory-args-only',
`TeX-insert-macro' asks only for mandatory argument.

When `TeX-insert-macro' is called with \\[universal-argument], it's the other
way round.

Note that for some macros, there are special mechanisms, see e.g.
`LaTeX-includegraphics-options-alist' and `TeX-arg-cite-note-p'." :group 'TeX-macro :type '(choice (const mandatory-args-only) (const show-optional-args) (const show-all-optional-args)))

(defcustom TeX-default-unit-for-image "cm" "\
Default unit when prompting for an image size." :group 'TeX-macro :type '(choice (const "cm") (const "in") (const "\\linewidth") (string :tag "Other")))

(defcustom TeX-install-font-lock 'font-latex-setup "\
Function to call to install font lock support.
Choose `ignore' if you don't want AUCTeX to install support for font locking." :group 'TeX-misc :type '(radio (function-item font-latex-setup) (function-item tex-font-setup) (function-item ignore) (function :tag "Other")))

(defcustom TeX-default-mode 'latex-mode "\
*Mode to enter for a new file when it can't be determined otherwise." :group 'TeX-misc :type '(radio (function-item latex-mode) (function-item plain-tex-mode) (function :tag "Other")))

(defcustom TeX-force-default-mode nil "\
*If set to nil, try to infer the mode of the file from its content." :group 'TeX-misc :type 'boolean)

(defgroup TeX-parse nil "Parsing TeX files from AUCTeX." :group 'AUCTeX)

(defcustom TeX-auto-save nil "\
*Automatically save style information when saving the buffer." :group 'TeX-parse :type 'boolean)

(defcustom TeX-auto-untabify nil "\
*Automatically untabify when saving the buffer." :group 'TeX-parse :type 'boolean)

(defcustom TeX-macro-default (car-safe TeX-macro-private) "\
*Default directory to search for TeX macros." :group 'TeX-file :type 'directory)

(defcustom TeX-auto-default (car-safe TeX-auto-private) "\
*Default directory to place automatically generated TeX information." :group 'TeX-file :type 'directory)

(defcustom TeX-ignore-file "\\(^\\|[/\\]\\)\\(\\.\\|\\.\\.\\|RCS\\|SCCS\\|CVS\\|babel\\..*\\)$" "\
Regular expression matching file names to ignore.

These files or directories will not be considered when searching for
TeX files in a directory." :group 'TeX-parse :type 'regexp)

(defcustom TeX-file-recurse t "\
Whether to search TeX directories recursively.
nil means do not recurse, a positive integer means go that far deep in the
directory hierarchy, t means recurse indefinitely." :group 'TeX-parse :type '(choice (const :tag "On" t) (const :tag "Off" nil) (integer :tag "Depth" :value 1)))

(defcustom TeX-auto-regexp-list 'TeX-auto-full-regexp-list "\
List of regular expressions used for parsing the current file." :type '(radio (variable-item TeX-auto-empty-regexp-list) (variable-item TeX-auto-full-regexp-list) (variable-item plain-TeX-auto-regexp-list) (variable-item LaTeX-auto-minimal-regexp-list) (variable-item LaTeX-auto-label-regexp-list) (variable-item LaTeX-auto-regexp-list) (symbol :tag "Other") (repeat :tag "Specify" (group (regexp :tag "Match") (sexp :tag "Groups") symbol))) :group 'TeX-parse)

(defcustom TeX-auto-parse-length 999999 "\
Maximal length of TeX file (in characters) that will be parsed." :group 'TeX-parse :type 'integer)

(defcustom TeX-auto-x-parse-length 0 "\
Maximum length of TeX file that will be parsed additionally.
Use `TeX-auto-x-regexp-list' for parsing the region between
`TeX-auto-parse-length' and this value." :group 'TeX-parse :type 'integer)

(defcustom TeX-auto-x-regexp-list 'LaTeX-auto-label-regexp-list "\
List of regular expressions used for additional parsing.
See `TeX-auto-x-parse-length'." :type '(radio (variable-item TeX-auto-empty-regexp-list) (variable-item TeX-auto-full-regexp-list) (variable-item plain-TeX-auto-regexp-list) (variable-item LaTeX-auto-minimal-regexp-list) (variable-item LaTeX-auto-label-regexp-list) (variable-item LaTeX-auto-regexp-list) (symbol :tag "Other") (repeat :tag "Specify" (group (regexp :tag "Match") (sexp :tag "Groups") symbol))) :group 'TeX-parse)

(defgroup TeX-file-extension nil "File extensions recognized by AUCTeX." :group 'TeX-file)

(defcustom TeX-file-extensions '("tex" "sty" "cls" "ltx" "texi" "txi" "texinfo" "dtx") "\
*File extensions used by manually generated TeX files." :group 'TeX-file-extension :type '(repeat (string :format "%v")))

(defcustom TeX-all-extensions '("[^.\n]+") "\
All possible file extensions." :group 'TeX-file-extension :type '(repeat (regexp :format "%v")))

(defcustom TeX-default-extension "tex" "\
*Default extension for TeX files." :group 'TeX-file-extension :type 'string)

(defcustom docTeX-default-extension "dtx" "\
*Default extension for docTeX files." :group 'TeX-file-extension :type 'string)

(defcustom TeX-Biber-file-extensions '("bib" "ris" "xml") "\
Valid file extensions for Biber files." :group 'TeX-file-extension :type '(repeat (string :format "%v")))

(defcustom BibTeX-file-extensions '("bib") "\
Valid file extensions for BibTeX files." :group 'TeX-file-extension :type '(repeat (string :format "%v")))

(defcustom BibLaTeX-style-extensions '("bbx") "\
Valid file extensions for BibLaTeX styles." :group 'TeX-file-extension :type '(repeat (string :format "%v")))

(defcustom BibTeX-style-extensions '("bst") "\
Valid file extensions for BibTeX styles." :group 'TeX-file-extension :type '(repeat (string :format "%v")))

(defcustom TeX-tree-roots (TeX-tree-roots) "\
List of all available TeX tree root directories." :group 'TeX-file :type '(repeat directory))

(defcustom TeX-kpathsea-path-delimiter t "\
Path delimiter for kpathsea output.
t means autodetect, nil means kpathsea is disabled." :group 'TeX-file :type '(choice (const ":") (const ";") (const :tag "Autodetect" t) (const :tag "Off" nil)))

(defcustom TeX-electric-escape nil "\
If non-nil, ``\\'' will be bound to `TeX-electric-macro'." :group 'TeX-macro :type 'boolean)

(defcustom TeX-electric-sub-and-superscript nil "\
If non-nil, insert braces after typing `^' and `_' in math mode." :group 'TeX-macro :type 'boolean)

(defcustom TeX-newline-function 'newline "\
Function to be called upon pressing `RET'." :group 'TeX-indentation :type '(choice (const newline) (const newline-and-indent) (const reindent-then-newline-and-indent) (sexp :tag "Other")))

(defgroup TeX-indentation nil "Indentation of TeX buffers in AUCTeX." :group 'AUCTeX)

(defcustom TeX-brace-indent-level 2 "\
*The level of indentation produced by an open brace." :group 'TeX-indentation :type 'integer)

(defcustom TeX-font-list '((?\^B "{\\bf " "}") (?\^C "{\\sc " "}") (?\^E "{\\em " "\\/}") (?\t "{\\it " "\\/}") (?\^R "{\\rm " "}") (?\^S "{\\sl " "\\/}") (?\^T "{\\tt " "}") (?\^D "" "" t)) "\
List of fonts used by `TeX-font'.

Each entry is a list.
The first element is the key to activate the font.
The second element is the string to insert before point, and the third
element is the string to insert after point.
If the fourth and fifth element are strings, they specify the prefix and
suffix to be used in math mode.
An optional fourth (or sixth) element means always replace if t." :group 'TeX-macro :type '(repeat (group :value (?\^A "" "") (character :tag "Key") (string :tag "Prefix") (string :tag "Suffix") (option (group :inline t (string :tag "Math Prefix") (string :tag "Math Suffix"))) (option (sexp :format "Replace
" :value t)))))

(defcustom TeX-math-toggle-off-input-method t "\
*If non-nil, auto toggle off CJK input methods when entering math mode." :group 'TeX-macro :type 'boolean)

(defcustom TeX-electric-math nil "\
If non-nil, when outside math mode `TeX-insert-dollar' will
insert symbols for opening and closing inline equation and put
the point between them.  If there is an active region,
`TeX-insert-dollar' will put around it symbols for opening and
closing inline equation and keep the region active, with point
after closing symbol.  If you press `$' again, you can toggle
between inline equation, display equation, and no equation.

If non-nil and point is inside math mode right between a couple
of single dollars, pressing `$' will insert another pair of
dollar signs and leave the point between them.

If nil, `TeX-insert-dollar' will simply insert \"$\" at point,
this is the default.

If non-nil, this variable is a cons cell whose CAR is the string
to insert before point, the CDR is the string to insert after
point.  You can choose between \"$...$\" and \"\\(...\\)\"." :group 'TeX-macro :type '(choice (const :tag "No electricity" nil) (const :tag "$...$" ("$" . "$")) (const :tag "\\(...\\)" ("\\(" . "\\)")) (cons :tag "Other" (string :tag "Insert before point") (string :tag "Insert after point"))))

(defgroup TeX-quote nil "Quoting in AUCTeX." :group 'AUCTeX)

(defcustom TeX-open-quote "``" "\
String inserted by typing \\[TeX-insert-quote] to open a quotation." :group 'TeX-quote :type 'string)

(defcustom TeX-close-quote "''" "\
String inserted by typing \\[TeX-insert-quote] to close a quotation." :group 'TeX-quote :type 'string)

(defcustom TeX-quote-after-quote nil "\
Behaviour of \\[TeX-insert-quote].
Nil means standard behaviour; when non-nil, opening and closing
quotes are inserted only after \"." :group 'TeX-quote :type 'boolean)

(defcustom TeX-quote-language-alist nil "\
Alist for overriding the default language-specific quote insertion.
First element in each item is the name of the language as set by
the language style file as a string.  Second element is the
opening quotation mark.  Third element is the closing quotation
mark.  Opening and closing quotation marks can be specified
directly as strings or as functions returning a string.  Fourth
element is a boolean specifying insertion behavior, overriding
`TeX-quote-after-quote'.  See Info node `(auctex)European' for
valid languages." :group 'TeX-quote :link '(custom-manual "(auctex)European") :type '(repeat (group (choice (const "czech") (const "danish") (const "dutch") (const "german") (const "ngerman") (const "french") (const "italian") (const "polish") (const "slovak") (const "swedish") (string :tag "Other Language")) (choice :tag "Opening quotation mark" string function) (choice :tag "Closing quotation mark" string function) (boolean :tag "Insert plain quote first" :value t))))

;;;***

;;;### (autoloads (texmathp-allow-detached-args texmathp-search-n-paragraphs texmathp-tex-commands texmathp) "texmathp" "auctex/texmathp.el")
(defconst custom-define-current-source-file "texmathp.el")

(defgroup texmathp nil "Testing TeX and LaTeX documents for math mode." :tag "Test For TeX and LaTeX Math Mode" :prefix "texmathp-" :group 'tex)

(defcustom texmathp-tex-commands nil "\
List of environments and macros influencing (La)TeX math mode.
This user-defined list is used in addition to LaTeX and AMSLaTeX defaults.
The structure of each entry is (NAME TYPE)

- The first item in each entry is the name of an environment or macro.
  If it's a macro, include the backslash.

- The second item is a symbol indicating how the command works:
    `env-on'     Environment: turns math mode for its body  on
    `env-off'    Environment: turns math mode for its body  off
    `arg-on'     Command: turns math mode for its arguments on
    `arg-off'    Command: turns math mode for its arguments off
    `sw-on'      Switch: turns math-mode of following text  on
    `sw-off'     Switch: turns math-mode of following text  off
    `sw-toggle'  Switch: toggles math mode of following text" :group 'texmathp :set '(lambda (symbol value) (set-default symbol value) (texmathp-compile)) :type '(repeat (list :value ("" env-on) (string :tag "Name") (choice :tag "Type" (const :tag "Environment: turns math mode for its body on" env-on) (const :tag "Environment: turns math mode for its body off" env-off) (const :tag "Command: turns math mode for its argument on" arg-on) (const :tag "Command: turns math-mode for its argument off" arg-off) (const :tag "Switch: turns math-mode of following text on" sw-on) (const :tag "Switch: turns math-mode of following text off" sw-off) (const :tag "Switch: toggles math mode of following text" sw-toggle)))))

(defcustom texmathp-search-n-paragraphs 2 "\
*Number of paragraphs to check before point.
Normally, you cannot have an empty line in a math environment in (La)TeX.
The fastest method to test for math mode is then limiting the search
backward to the nearest empty line.
However, during editing it happens that such lines exist temporarily.
Therefore we look a little further.  This variable determines how many
empty lines we go back to fix the search limit." :group 'texmathp :type 'number)

(defcustom texmathp-allow-detached-args nil "\
*Non-nil means, allow arguments of macros to be detached by whitespace.
When this is t, `aaa' will be interpreted as an argument of b in the
following construct:  bb [xxx] {aaa}
This is legal in TeX.  The disadvantage is that any number of braces expressions
will be considered arguments of the macro independent of its definition." :group 'texmathp :type 'boolean)

;;;***

(provide 'auctex-custom-defines)
