;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'bbdb-custom-defines) (error "Feature bbdb-custom-defines already loaded"))

;;;### (autoloads (bbdb-get-only-first-address-p bbdb-get-addresses-headers bbdb-update-records-mode bbdb-info-file bbdb-finger-host-field bbdb-finger-buffer-name bbdb-sound-volume bbdb-modem-device bbdb-modem-dial bbdb-sound-files bbdb-sound-player bbdb-dial-long-distance-prefix bbdb-dial-local-prefix bbdb-dial-local-prefix-alist bbdb-mail-abbrev-expand-hook bbdb-define-all-aliases-mode bbdb-define-all-aliases-field bbdb-complete-name-hooks bbdb-complete-name-allow-cycling bbdb-dwim-net-address-allow-redundancy bbdb-notes-sort-order bbdb-refile-notes-default-merge-function bbdb-refile-notes-generate-alist bbdb-address-editing-function bbdb-legal-zip-codes bbdb-check-zip-codes-p bbdb-expand-mail-aliases bbdb-default-country bbdb-extract-address-components-func) "bbdb-com" "lisp/bbdb-com.el")
(defconst custom-define-current-source-file "bbdb-com.el")

(defcustom bbdb-extract-address-components-func 'bbdb-rfc822-addresses "\
Function called to parse one or more email addresses.
See bbdb-extract-address-components for an example." :group 'bbdb-noticing-records :type 'function)

(defcustom bbdb-default-country '"Emacs" "\
*Default country to use if none is specified." :group 'bbdb-record-creation :type 'string)

(defcustom bbdb-expand-mail-aliases t "\
If non-nil, expand mail aliases in `bbdb-complete-name'." :group 'bbdb-record-use :type 'boolean)

(defcustom bbdb-check-zip-codes-p t "\
If non-nil, require legal zip codes when entering an address.
The format of legal zip codes is determined by the variable
`bbdb-legal-zip-codes'." :group 'bbdb-record-creation :type 'boolean)

(defcustom bbdb-legal-zip-codes '("^$" "^[ 	\n]*[0-9][0-9]?[0-9]?[0-9]?[0-9]?[0-9]?[ 	\n]*$" "^[ 	\n]*\\([0-9][0-9][0-9][0-9][0-9]\\)[ 	\n]*-?[ 	\n]*\\([0-9][0-9][0-9][0-9]?\\)[ 	\n]*$" "^[ 	\n]*\\([A-Za-z0-9]+\\)[ 	\n]+\\([A-Za-z0-9]+\\)[ 	\n]*$" "^[ 	\n]*\\([A-Z]+\\)[ 	\n]*-?[ 	\n]*\\([0-9]+ ?[A-Z]*\\)[ 	\n]*$" "^[ 	\n]*\\([A-Z]+\\)[ 	\n]*-?[ 	\n]*\\([0-9]+\\)[ 	\n]+\\([0-9]+\\)[ 	\n]*$") "\
List of regexps that match legal zip codes.
Whether this is used at all depends on the variable `bbdb-check-zip-codes-p'." :group 'bbdb-record-creation :type '(repeat regexp))

(defcustom bbdb-address-editing-function 'bbdb-address-edit-default "\
Function to use for address editing.
The function must accept a BBDB address as parameter and allow the
user to edit it.  This variable is called from `bbdb-record-edit-address'.
The default value is the symbol `bbdb-address-edit-default'." :group 'bbdb-record-creation :type 'function)

(defcustom bbdb-refile-notes-generate-alist '((creation-date . bbdb-refile-notes-string-least) (timestamp . bbdb-refile-notes-string-most)) "\
*An alist defining specific merging function, based on notes field." :group 'bbdb-noticing-records :type '(repeat (cons (symbol :tag "Notes filed") (hook :tag "Generating function"))))

(defcustom bbdb-refile-notes-default-merge-function 'bbdb-refile-notes-default-merge-function "\
*Default function to use for merging BBDB notes records.

If the note field has an entry in `bbdb-refile-notes-generate-alist',
that function will be used instead." :group 'bbdb-noticing-records :type 'function)

(defcustom bbdb-notes-sort-order '((notes . 0) (www . 1) (ftp . 2) (gopher . 3) (telnet . 4) (mail-alias . 5) (mail-folder . 6) (lpr . 7) (creation-date . 1000) (timestamp . 1001)) "\
*The order for sorting the notes.
If a note is not in the alist, it is assigned weight 100, so all notes
with weights less then 100 will be in the beginning, and all notes with
weights more than 100 will be in the end." :group 'bbdb-noticing-records :type 'list)

(defcustom bbdb-dwim-net-address-allow-redundancy nil "\
*Non-nil means always use full name when sending mail, even if same as net." :group 'bbdb :type '(choice (const :tag "Disallow redundancy" nil) (const :tag "Return only the net" 'netonly) (const :tag "Allow redundancy" t)))

(defcustom bbdb-complete-name-allow-cycling nil "\
Whether to allow cycling of email addresses when calling
`bbdb-complete-name' on a completed address in a composition buffer." :group 'bbdb-mua-specific :type 'boolean)

(defcustom bbdb-complete-name-hooks nil "\
List of functions called after a sucessful completion." :group 'bbdb-mua-specific :type 'boolean)

(defcustom bbdb-define-all-aliases-field 'mail-alias "\
*The field which `bbdb-define-all-aliases' searches for." :group 'bbdb :type 'symbol)

(defcustom bbdb-define-all-aliases-mode 'first "\
*The type of alias which are created.
first: Default is to generate an abbrev which is \"alias\" and expands to the
       primary net.
star:  Generate an extra alias \"<alias>*\" which expands to all nets of an
       record.
all:   Generate an alias all nets (as for 'star) and an alias for each net
       as \"<alias>n\" where n is the position of the net in the nets of the
       record." :group 'bbdb :type '(choice (symbol :tag "Only first" first) (symbol :tag "<alias>* for all nets" star) (symbol :tag "All aliases" all)))

(defcustom bbdb-mail-abbrev-expand-hook nil "\
*Hook or hooks invoked each time an alias is expanded.
The hook is called with two arguments the alias and the list of records." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-dial-local-prefix-alist '(((if (integerp bbdb-default-area-code) (format "(%03d)" bbdb-default-area-code) (or bbdb-default-area-code "")) "")) "\
Mapping to remove local prefixes from numbers.
If this is non-nil, it should be an alist of
\(PREFIX REPLACEMENT) elements. The first part of a phone number
matching the regexp returned by evaluating PREFIX will be replaced by
the corresponding REPLACEMENT when dialing." :group 'bbdb-phone-dialing :type 'sexp)

(defcustom bbdb-dial-local-prefix nil "\
Local prefix digits.
If this is non-nil, it should be a string of digits which your phone
system requires before making local calls (for example, if your phone system
requires you to dial 9 before making outside calls.) In BBDB's
opinion, you're dialing a local number if it starts with a 0 after
processing bbdb-dial-local-prefix-alist." :group 'bbdb-phone-dialing :type '(choice (const :tag "No digits required" nil) (string :tag "Dial this first" "9")))

(defcustom bbdb-dial-long-distance-prefix nil "\
Long distance prefix digits.
If this is non-nil, it should be a string of digits which your phone
system requires before making a long distance call (one not in your local
area code).  For example, in some areas you must dial 1 before an area
code. Note that this is used to replace the + sign in phone numbers
when dialling (international dialing prefix.)" :group 'bbdb-phone-dialing :type '(choice (const :tag "No digits required" nil) (string :tag "Dial this first" "1")))

(defcustom bbdb-sound-player nil "\
The program to be used to play the sounds for the touch-tone digits." :group 'bbdb-phone-dialing :type '(choice (const :tag "No External Player" nil) (file :tag "Sound Player" "/usr/local/bin/play")))

(defcustom bbdb-sound-files '["/usr/demo/SOUND/sounds/touchtone.0.au" "/usr/demo/SOUND/sounds/touchtone.1.au" "/usr/demo/SOUND/sounds/touchtone.2.au" "/usr/demo/SOUND/sounds/touchtone.3.au" "/usr/demo/SOUND/sounds/touchtone.4.au" "/usr/demo/SOUND/sounds/touchtone.5.au" "/usr/demo/SOUND/sounds/touchtone.6.au" "/usr/demo/SOUND/sounds/touchtone.7.au" "/usr/demo/SOUND/sounds/touchtone.8.au" "/usr/demo/SOUND/sounds/touchtone.9.au" "/usr/demo/SOUND/sounds/touchtone.pound.au" "/usr/demo/SOUND/sounds/touchtone.star.au"] "\
A vector of ten sound files to be used for dialing.  They
correspond to the 0, 1, 2, ... 9 digits, pound and star, respectively." :group 'bbdb-phone-dialing :type 'vector)

(defcustom bbdb-modem-dial nil "\
Type of dialing to use.
If this value is nil, the audio device is used for dialing. Otherwise,
this string is fed to the modem before the phone number digits." :group 'bbdb-phone-dialing :type '(choice (const :tag "audio" nil) (string :tag "tone dialing" "ATDT ") (string :tag "pulse dialing" "ATDP ")))

(defcustom bbdb-modem-device "/dev/modem" "\
The name of the modem device.
This is only used if bbdb-modem-dial is set to something other than nil." :group 'bbdb-phone-dialing :type 'string)

(defcustom bbdb-sound-volume 50 "\
The volume to play back dial tones at. The range is 0 to 100.
This is only used if bbdb-modem-dial is set to nil." :group 'bbdb-phone-dialing :type 'integer)

(defcustom bbdb-finger-buffer-name "*finger*" "\
The buffer into which finger output should be directed." :group 'bbdb-utilities-finger :type 'string)

(defcustom bbdb-finger-host-field 'finger-host "\
*The field for special net addresses used by \"\\[bbdb-finger]\"." :group 'bbdb-utilities-finger :type 'symbol)

(defcustom bbdb-info-file nil "\
*Set this to the location of the bbdb info file, if it's not in the
standard place." :group 'bbdb :type '(choice (const :tag "Standard location" nil) (file :tag "New location")))

(defcustom bbdb-update-records-mode 'annotating "\
Controls how `bbdb-update-records' processes email addresses.
Set this to an expression which evaluates either to 'searching or
'annotating.  When set to 'annotating email addresses will be fed to
`bbdb-annotate-message-sender' in order to update existing records or create
new ones.  A value of 'searching will search just for existing records having
the right net.

There is a version of this variable for each MUA, which overrides this variable
when set!

This variable is also used for inter-function communication between the
functions `bbdb-update-records' and `bbdb-prompt-for-create'." :group 'bbdb-mua-specific :type '(choice (const :tag "annotating all messages" annotating) (const :tag "annotating no messages" searching) (sexp :tag "user defined")))

(defcustom bbdb-get-addresses-headers '((authors "From" "Resent-From" "Reply-To") (recipients "Resent-To" "Resent-CC" "To" "CC" "BCC")) "\
*List of headers to search for senders and recipients email addresses.
The headers are grouped into two classes, the authors and the senders headers." :group 'bbdb-mua-specific :type 'list)

(defcustom bbdb-get-only-first-address-p t "\
*If t `bbdb-update-records' will return only the first one.
Changing this variable will show its effect only after clearing the
`bbdb-message-cache' of a folder or closing and visiting it again." :group 'bbdb-mua-specific :type 'boolean)

;;;***

;;;### (autoloads (bbdb-ftp-site-name-designator-prefix bbdb-default-ftp-dir bbdb-default-ftp-user) "bbdb-ftp" "lisp/bbdb-ftp.el")
(defconst custom-define-current-source-file "bbdb-ftp.el")

(defcustom bbdb-default-ftp-user "anonymous" "\
*The default login to use when ftp-ing." :group 'bbdb-utilities-ftp :type 'string)

(defcustom bbdb-default-ftp-dir "/" "\
*The default directory to open when ftp-ing." :group 'bbdb-utilities-ftp :type 'string)

(defcustom bbdb-ftp-site-name-designator-prefix "Ftp Site: " "\
*The prefix that all ftp sites in the bbdb will have in their name field." :group 'bbdb-utilities-ftp :type 'string)

;;;***

;;;### (autoloads (bbdb/gnus-split-public-field bbdb/gnus-split-private-field bbdb/gnus-split-crosspost-default bbdb/gnus-split-myaddr-regexp bbdb/gnus-split-nomatch-function bbdb/gnus-split-default-group bbdb/gnus-score-default bbdb/gnus-score-field bbdb-message-marker-field bbdb/gnus-summary-in-bbdb-format-letter bbdb/gnus-summary-user-format-letter bbdb/gnus-summary-prefer-real-names bbdb/gnus-summary-prefer-bbdb-data bbdb/gnus-summary-show-bbdb-names bbdb/gnus-summary-known-poster-mark bbdb/gnus-summary-mark-known-posters bbdb/gnus-lines-and-from-length bbdb/gnus-update-records-mode) "bbdb-gnus" "lisp/bbdb-gnus.el")
(defconst custom-define-current-source-file "bbdb-gnus.el")

(defcustom bbdb/gnus-update-records-mode 'annotating "\
Controls how `bbdb/gnus-update-records' processes email addresses.
Set this to an expression which evaluates either to 'searching or
'annotating.  When set to 'annotating email addresses will be fed to
`bbdb-annotate-message-sender' in order to update existing records or create
new ones.  A value of 'searching will search just for existing records having
the right net.

The default is to annotate only new messages." :group 'bbdb-mua-specific-gnus :type '(choice (const :tag "annotating all messages" annotating) (const :tag "annotating no messages" searching) (const :tag "annotating only new messages" (if (equal "" (gnus-summary-article-mark (gnus-summary-article-number))) 'annotating 'searching)) (sexp :tag "user defined")))

(defcustom bbdb/gnus-lines-and-from-length 18 "\
*The number of characters used to display From: info in Gnus, if you have
set gnus-optional-headers to 'bbdb/gnus-lines-and-from." :group 'bbdb-mua-specific-gnus :type 'integer)

(defcustom bbdb/gnus-summary-mark-known-posters t "\
*If t, mark messages created by people with records in the BBDB.
In Gnus, this marking will take place in the subject list (assuming
`gnus-optional-headers' contains `bbdb/gnus-lines-and-from').  In Gnus, the
marking will take place in the Summary buffer if the format code defined by
`bbdb/gnus-summary-user-format-letter' is used in `gnus-summary-line-format'.
This variable has no effect on the marking controlled by
`bbdb/gnus-summary-in-bbdb-format-letter'." :group 'bbdb-mua-specific-gnus :type '(choice (const :tag "Mark known posters" t) (const :tag "Do not mark known posters" nil)))

(defcustom bbdb/gnus-summary-known-poster-mark "+" "\
This is the default character to prefix author names with if
bbdb/gnus-summary-mark-known-posters is t.  If the poster's record has
an entry in the field named by bbdb-message-marker-field, then that will
be used instead." :group 'bbdb-mua-specific-gnus :type 'character)

(defcustom bbdb/gnus-summary-show-bbdb-names t "\
*If both this variable and `bbdb/gnus-summary-prefer-real-names' are true,
then for messages from authors who are in your database, the name
displayed will be the primary name in the database, rather than the
one in the From line of the message.  This doesn't affect the names of
people who aren't in the database, of course.  (`gnus-optional-headers'
must be `bbdb/gnus-lines-and-from' for Gnus users.)" :group 'bbdb-mua-specific-gnus :type 'boolean)

(defcustom bbdb/gnus-summary-prefer-bbdb-data t "\
If t, then for posters who are in our BBDB, replace the information
provided in the From header with data from the BBDB." :group 'bbdb-mua-specific-gnus :type 'boolean)

(defcustom bbdb/gnus-summary-prefer-real-names t "\
If t, then display the poster's name from the BBDB if we have one,
otherwise display his/her primary net address if we have one.  If it
is set to the symbol bbdb, then real names will be used from the BBDB
if present, otherwise the net address in the post will be used.  If
bbdb/gnus-summary-prefer-bbdb-data is nil, then this has no effect.
See `bbdb/gnus-lines-and-from' for Gnus users, or
`bbdb/gnus-summary-user-format-letter' for Gnus users." :group 'bbdb-mua-specific-gnus :type '(choice (const :tag "Prefer real names" t) (const :tag "Prefer network addresses" nil)))

(defcustom bbdb/gnus-summary-user-format-letter "B" "\
This is the gnus-user-format-function- that will be used to insert
the information from the BBDB in the summary buffer (using
`bbdb/gnus-summary-get-author').  This format code is meant to replace
codes that insert sender names or addresses (like %A or %n). Unless
you've already got other code using user format B, you might as well
stick with the default.  Additionally, if the value of this variable
is nil, no format function will be installed for
`bbdb/gnus-summary-get-author'.  See also
`bbdb/gnus-summary-in-bbdb-format-letter', which installs a format
code for `bbdb/gnus-summary-author-in-bbdb'" :group 'bbdb-mua-specific-gnus :type 'character)

(defcustom bbdb/gnus-summary-in-bbdb-format-letter "b" "\
This is the gnus-user-format-function- that will be used to insert
`bbdb/gnus-summary-known-poster-mark' (using
`bbdb/gnus-summary-author-in-bbdb') if the poster is in the BBDB, and
\" \" if not.  If the value of this variable is nil, no format code
will be installed for `bbdb/gnus-summary-author-in-bbdb'.  See also
`bbdb/gnus-summary-user-format-letter', which installs a format code
for `bbdb/gnus-summary-get-author'." :group 'bbdb-mua-specific-gnus :type 'character)

(defcustom bbdb-message-marker-field 'mark-char "\
*The field whose value will be used to mark messages by this user in Gnus." :group 'bbdb-mua-specific-gnus :type 'symbol)

(defcustom bbdb/gnus-score-field 'gnus-score "\
This variable contains the name of the BBDB field which should be
checked for a score to add to the net addresses in the same record." :group 'bbdb-mua-specific-gnus-scoring :type 'symbol)

(defcustom bbdb/gnus-score-default nil "\
If this is set, then every net address in the BBDB that does not have
an associated score field will be assigned this score.  A value of nil
implies a default score of zero." :group 'bbdb-mua-specific-gnus-scoring :type '(choice (const :tag "Do not assign default score") (integer :tag "Assign this default score" 0)))

(defcustom bbdb/gnus-split-default-group "mail.misc" "\
*If the BBDB doesn't indicate any group to spool a message to, it will
be spooled to this group.  If bbdb/gnus-split-crosspost-default is not
nil, and if the BBDB did not indicate a specific group for one or more
addresses, messages will be crossposted to this group in addition to any
group(s) which the BBDB indicated." :group 'bbdb-mua-specific-gnus-splitting :type 'string)

(defcustom bbdb/gnus-split-nomatch-function nil "\
*This function will be called after searching the BBDB if no place to
file the message could be found.  It should return a group name (or list
of group names) -- nnmail-split-fancy as provided with Gnus is an
excellent choice." :group 'bbdb-mua-specific-gnus-splitting :type 'function)

(defcustom bbdb/gnus-split-myaddr-regexp (concat "^" (user-login-name) "$\\|^" (user-login-name) "@\\([-a-z0-9]+\\.\\)*" (or gnus-local-domain (message-make-domain) (system-name) "") "$") "\
*This regular expression should match your address as found in the
From header of your mail.  You should make sure gnus-local-domain or
gnus-use-generic-from are set before loading this module, if they differ
from (system-name).  If you send mail/news from multiple addresses, then
you'll likely have to set this yourself anyways." :group 'bbdb-mua-specific-gnus-splitting :type 'string)

(defcustom bbdb/gnus-split-crosspost-default nil "\
*If this variable is not nil, then if the BBDB could not identify a
group for every mail address, messages will be filed in
bbdb/gnus-split-default-group in addition to any group(s) which the BBDB
identified." :group 'bbdb-mua-specific-gnus-splitting :type 'boolean)

(defcustom bbdb/gnus-split-private-field 'gnus-private "\
*This variable is used to determine the field to reference to find the
associated group when saving private mail for a network address known to
the BBDB.  The value of the field should be the name of a mail group." :group 'bbdb-mua-specific-gnus-splitting :type 'string)

(defcustom bbdb/gnus-split-public-field 'gnus-public "\
*This variable is used to determine the field to reference to find the
associated group when saving non-private mail (received from a mailing
list) for a network address known to the BBDB.  The value of the field
should be the name of a mail group, followed by a space, and a regular
expression to match on the envelope sender to verify that this mail came
from the list in question." :group 'bbdb-mua-specific-gnus-splitting :type 'string)

;;;***

;;;### (autoloads (bbdb-user-menu-commands) "bbdb-gui" "lisp/bbdb-gui.el")
(defconst custom-define-current-source-file "bbdb-gui.el")

(defcustom bbdb-user-menu-commands nil "\
User defined menu entries which should be appended to the BBDB menu.
This should be a list of menu entries.
When set to a fucntion the function gets called with two arguments the
RECORD and the FIELD and it should either return nil or a list of menu
entries." :group 'bbdb-database :type 'sexp)

;;;***

;;;### (autoloads (bbdb-canonical-hosts bbdb-auto-notes-ignore-all bbdb-auto-notes-ignore bbdb-auto-notes-alist bbdb-ignore-some-messages-alist bbdb-ignore-most-messages-alist) "bbdb-hooks" "lisp/bbdb-hooks.el")
(defconst custom-define-current-source-file "bbdb-hooks.el")

(defcustom bbdb-ignore-most-messages-alist 'nil "\
*An alist describing which messages to automatically create BBDB
records for.  This only works if bbdb/news-auto-create-p or
bbdb/mail-auto-create-p (or both) is 'bbdb-ignore-most-messages-hook.
The format of this alist is
   (( HEADER-NAME . REGEXP ) ... )
for example,
   ((\"From\" . \"@.*\\.maximegalon\\.edu\")
    (\"Subject\" . \"time travel\"))
will cause BBDB entries to be made only for messages sent by people at
Maximegalon U., or (that's *or*) people posting about time travel.

See also bbdb-ignore-some-messages-alist, which has the opposite effect." :group 'bbdb-noticing-records :type '(repeat (cons (string :tag "Header name") (regexp :tag "Regex to match on header value"))))

(defcustom bbdb-ignore-some-messages-alist 'nil "\
*An alist describing which messages *not* to automatically create
BBDB records for.  This only works if bbdb/news-auto-create-p or
bbdb/mail-auto-create-p (or both) is 'bbdb-ignore-some-messages-hook.
The format of this alist is
   (( HEADER-NAME . REGEXP ) ... )
for example,
   ((\"From\" . \"mailer-daemon\")
    (\"To\" . \"mailing-list-1\\\\|mailing-list-2\")
    (\"CC\" . \"mailing-list-1\\\\|mailing-list-2\"))
will cause BBDB entries to not be made for messages from any mailer daemon,
or messages sent to or CCed to either of two mailing lists.

See also bbdb-ignore-most-messages-alist, which has the opposite effect." :group 'bbdb-noticing-records :type '(repeat (cons (string :tag "Header name") (regexp :tag "Regex to match on header value"))))

(defcustom bbdb-auto-notes-alist nil "\
*An alist which lets you have certain pieces of text automatically added
to the BBDB record representing the sender of the current message based on
the subject or other header fields.  This only works if `bbdb-notice-hook'
contains `bbdb-auto-notes-hook'.  The format of this alist is

   ((HEADER-NAME [ADDRESS-CLASS-LIST]
       (REGEXP . STRING) ... )
      ... )
for example,
   ((\"To\" (\"-vm@\" . \"VM mailing list\"))
    (\"Subject\" (\"sprocket\" . \"mail about sprockets\")
               (\"you bonehead\" . \"called me a bonehead\")))

will cause the text \"VM mailing list\" to be added to the notes field of
the record corresponding to anyone you get mail from via one of the VM
mailing lists.  If, that is, `bbdb/mail-auto-create-p' is set such that the
record would have been created, or the record already existed.

A ADDRESS-CLASS-LIST is optional and by default actions will be performed only
for records of authors of a message.  However, by giving an list of classes
specified in `bbdb-get-addresses-headers'.  Actions will then only be
performed if the currently processed email is of a class listed in
ADDRESS-CLASS-LIST.  ADDRESS-CLASS-LIST might also be an alist with elements
of the form (CLASS . HEADER) which allows actions only when the current
address matches one of the elemets.

The format of elements of this list may also be
       (REGEXP FIELD-NAME STRING)
or
       (REGEXP FIELD-NAME STRING REPLACE-P)
instead of
       (REGEXP . STRING)

meaning add the given string to the named field.  The field-name may not
be name, address, phone, or net (builtin fields) but must be either ``notes,''
``company,'' or the name of a user-defined note-field.
       (\"pattern\" . \"string to add\")
is equivalent to
       (\"pattern\" notes \"string to add\")

STRING can contain \\& or \\N escapes like in function
`replace-match'.  For example, to automatically add the contents of the
\"organization\" field of a message to the \"company\" field of a BBDB
record, you can use this:

        (\"Organization\" (\".*\" company \"\\\\&\"))

\(Note you need two \\ to get a single \\ into a lisp string literal.)

If STRING is an integer N, the N'th matching subexpression is used, so
the above example could be written more efficiently as

        (\"Organization\" (\".*\" company 0))

If STRING is neither a string or an integer, it should be a function, which
will be called with the contents of the field.  The result of that function
call is used as the field value (the returned value must be a string.)

If REPLACE-P is t, the string replaces the old contents instead of
being appended to it.

If multiple clauses match the message, all of the corresponding strings
will be added.

This works for news as well.  You might want to arrange for this to have
a different value when in mail as when in news.

See also variables `bbdb-auto-notes-ignore' and `bbdb-auto-notes-ignore-all'." :group 'bbdb-noticing-records :type '(repeat (bbdb-alist-with-header (string :tag "Header name") (repeat (choice (cons :tag "Address Class" (repeat (choice (const authors) (const recipients)))) (cons :tag "Value Pair" (regexp :tag "Regexp to match on header value") (string :tag "String for notes if regexp matches")) (list :tag "Replacement list" (regexp :tag "Regexp to match on header value") (choice :tag "Record field" (const notes :tag "Notes") (const company :tag "Company") (symbol :tag "Other")) (choice :tag "Regexp match" (string :tag "Replacement string") (integer :tag "Subexpression match") (function :tag "Callback Function")) (choice :tag "Replace previous contents" (const :tag "No" nil) (const :tag "Yes" t))))))))

(defcustom bbdb-auto-notes-ignore nil "\
Alist of headers and regexps to ignore in `bbdb-auto-notes-hook'.
Each element looks like

    (HEADER . REGEXP)

For example,

    (\"Organization\" . \"^Gatewayed from\\\\|^Source only\")

would exclude the phony `Organization:' headers in GNU mailing-lists
gatewayed to gnu.* newsgroups.  Note that this exclusion applies only
to a single field, not to the entire message.  For that, use the variable
`bbdb-auto-notes-ignore-all'." :group 'bbdb-noticing-records :type '(repeat (cons (string :tag "Header name") (regexp :tag "Regexp to match on header value"))))

(defcustom bbdb-auto-notes-ignore-all nil "\
Alist of headers and regexps which cause the entire message to be ignored
in `bbdb-auto-notes-hook'.  Each element looks like

    (HEADER . REGEXP)

For example,

    (\"From\" . \"BLAT\\\\.COM\")

would exclude any notes recording for message coming from BLAT.COM.
Note that this is different from `bbdb-auto-notes-ignore', which applies
only to a particular header field, rather than the entire message." :group 'bbdb-noticing-records :type '(repeat (cons (string :tag "Header name") (regexp :tag "Regexp to match on header value"))))

(defcustom bbdb-canonical-hosts (mapconcat 'regexp-quote '("cs.cmu.edu" "ri.cmu.edu" "edrc.cmu.edu" "andrew.cmu.edu" "mcom.com" "netscape.com" "cenatls.cena.dgac.fr" "cenaath.cena.dgac.fr" "irit.fr" "enseeiht.fr" "inria.fr" "cs.uiuc.edu" "xemacs.org") "\\|") "\
Certain sites have a single mail-host; for example, all mail originating
at hosts whose names end in \".cs.cmu.edu\" can (and probably should) be
addressed to \"user@cs.cmu.edu\" instead.  This variable lists other hosts
which behave the same way." :group 'bbdb :type '(regexp :tag "Regexp matching sites"))

;;;***

;;;### (autoloads (bbdb-print-net bbdb-print-epilog bbdb-print-prolog bbdb-print-brief-alist bbdb-print-full-alist bbdb-print-alist bbdb-print-require bbdb-print-omit-fields bbdb-print-file-name) "bbdb-print" "lisp/bbdb-print.el")
(defconst custom-define-current-source-file "bbdb-print.el")

(defcustom bbdb-print-file-name "~/bbdb.tex" "\
*Default file name for printouts of BBDB database." :group 'bbdb-utilities-print :type 'file)

(defcustom bbdb-print-omit-fields '(omit tex-name aka mail-alias) "\
*List of fields NOT to print in address list.
See also bbdb-print-require." :group 'bbdb-utilities-print :type '(repeat (symbol :tag "Field to exclude")))

(defcustom bbdb-print-require '(or address phone) "\
*What fields are required for printing a record.
This is evaluated for each record, and the record will be printed only
if it returns non-nil.  The symbols name, company, net, phone,
address, and notes will be set to appropriate values when this is
evaluated; they will be nil if the field does not exist or is elided.

The value of this variable can be any lisp expression, but typically
it will be used for a boolean combination of the field variables, as
in the following simple examples:

  Print only people whose phone numbers are known:
    (setq bbdb-print-require 'phone)
  Print people whose names AND companies are known:
    (setq bbdb-print-require '(and name company))
  Print people whose names, and either addresses OR phone numbers are known:
    (setq bbdb-print-require '(and name (or address phone)))." :group 'bbdb-utilities-print :type '(choice (const :tag "Print all records" t) (symbol :tag "Print all records with this field" phone) (sexp :tag "Print only when this evaluates to non-nil" '(or phone address phone))))

(defcustom bbdb-print-alist (backquote ((omit-area-code \, (concat "^(" (if (integerp bbdb-default-area-code) (int-to-string bbdb-default-area-code) "000") ") ")) (phone-on-first-line . "^[ 	]*$") (ps-fonts) (font-size . 6) (quad-hsize . "3.15in") (quad-vsize . "4.5in"))) "\
*Formatting options for `bbdb-print', all formats.
This is an alist of the form ((option1 . value1) (option2 . value2) ...)

You can have separate settings for brief and non-brief printouts;
see the variables `bbdb-print-brief-alist' and `bbdb-print-full-alist'.
Settings there will override the common settings in this variable.

The possible options and legal values are:
 - columns: 1, 2, 3, 4 or 'quad (4 little 2-column pages per sheet)
     or 'grid (12 credit-card-sized pages per sheet).
 - separator: 0-7, the style of heading for each letter.
     0=none, 1=line, 2=boxed letters, 3=large boxed letters, 4=large letters,
     5=letters with lines, 6=letters with suits, 7=boxed letters with suits.
 - omit-area-code: a regular expression matching area codes to omit.
 - phone-on-first-line: t means to put first phone number on the same
     line with the name, nil means just the name.  A string means to
     use the first phone number whose \"location\" matches that string,
     which should be a valid regular expression.
 - n-phones: maximum number of phone numbers to include.
 - n-addresses: maximum number of addresses to include.
 - include-files: list of TeX files to \\input.  If these filenames are not
   absolute, the files must be located somewhere that TeX will find them.
 - ps-fonts: nonnil means to use them, nil to use standard TeX fonts.
 - font-size: in points, any integer (assuming fonts in that size exist!).
 - hsize, vsize: horizontal dimension of pages.  String value can be any valid
   TeX dimension, or nil to use TeX's default.
 - hoffset, voffset: shift TeX's output rightward (downward) by this distance
   (any TeX dimension).  Nil or 0 uses TeX's default positioning.
 - quad-hsize, quad-vsize: for the quad format, horizontal and
     vertical size of the little pages.  These must be strings which
     are valid TeX dimensions, eg \"10cm\"." :group 'bbdb-utilities-print :type 'bbdb-print-alist-widget)

(defcustom bbdb-print-full-alist '((columns . 3) (separator . 2) (include-files "bbdb-print" "bbdb-cols")) "\
*Extra options for `bbdb-print' non-brief format.
These supplement or override entries in `bbdb-print-alist'; see description
of possible contents there." :group 'bbdb-utilities-print :type 'bbdb-print-alist-widget)

(defcustom bbdb-print-brief-alist '((columns . 1) (separator . 1) (n-phones . 2) (n-addresses . 1) (include-files "bbdb-print-brief" "bbdb-cols")) "\
*Extra Options for `bbdb-print', brief format.
These supplement or override entries in `bbdb-print-alist'; see description
of possible contents there." :group 'bbdb-utilities-print :type 'bbdb-print-alist-widget)

(defcustom bbdb-print-prolog (concat "%%%% ====== Phone/Address list in -*-TeX-*- Format =====\n" "%%%%        produced by bbdb-print, version 3.0\n\n") "\
*TeX statements to include at the beginning of the `bbdb-print' file." :group 'bbdb-utilities-print :type '(text :format "%t:
%v"))

(defcustom bbdb-print-epilog "\\endaddresses\n\\bye\n" "\
*TeX statements to include at the end of the `bbdb-print' file." :group 'bbdb-utilities-print :type '(text :format "%t:
%v"))

(defcustom bbdb-print-net 'primary "\
*Indicates whether only the primary or all email addresses are printed.
Symbol `primary' means print the primary email address only.
Symbol `all' means print all email addresses." :group 'bbdb-utilities-print :type '(choice (const primary) (const all)))

;;;***

;;;### (autoloads (bbdb/rmail-update-records-mode) "bbdb-rmail" "lisp/bbdb-rmail.el")
(defconst custom-define-current-source-file "bbdb-rmail.el")

(defcustom bbdb/rmail-update-records-mode '(if (bbdb/rmail-new-flag rmail-buffer) 'annotating 'searching) "\
RMAIL-specific version of `bbdb-update-records-mode', which see." :group 'bbdb-mua-specific-rmail :type '(choice (const :tag "annotating all messages" annotating) (const :tag "annotating no messages" searching) (const :tag "annotating only new messages" (if (bbdb/rmail-new-flag rmail-buffer) 'annotating 'searching)) (sexp :tag "user defined")))

;;;***

;;;### (autoloads (bbdb/sc-last-attribution bbdb/sc-attribution-field bbdb/sc-replace-attr-p) "bbdb-sc" "lisp/bbdb-sc.el")
(defconst custom-define-current-source-file "bbdb-sc.el")

(defcustom bbdb/sc-replace-attr-p t "\
t if you like to create a new BBDB entry when
entering a non-default attribution, 'ask if the user
should be asked before creation and NIL if we never create a new entry." :group 'bbdb-utilities-supercite :type '(choice (const "Create a new BBDB entry" t) (const "Confirm new record creation" ask) (const "Don't create a new entry" nil)))

(defcustom bbdb/sc-attribution-field 'attribution "\
The BBDB field used for Supercite attribution information." :group 'bbdb-utilities-supercite :type '(symbol :tag "Field name"))

(defcustom bbdb/sc-last-attribution "" "\
Default attribution return by the SuperCite citation engine,
used to compare against citation selected by the user." :group 'bbdb-utilities-supercite :type '(string :tag "Default citation" ""))

;;;***

;;;### (autoloads (bbdb-extract-address-component-handler bbdb-extract-address-component-ignore-regexp bbdb-extract-address-component-regexps bbdb-snarf-web-prop) "bbdb-snarf" "lisp/bbdb-snarf.el")
(defconst custom-define-current-source-file "bbdb-snarf.el")

(defcustom bbdb-snarf-web-prop 'www "\
What property bbdb should use for the web, or nil to not detect web URLs." :group 'bbdb :type 'symbol)

(defcustom bbdb-extract-address-component-regexps '(("\"\\([^\"]*\\)\"\\s-*<\\([^>]+\\)>" (bbdb-clean-username (match-string 1 adstring)) 2) ("\\([^<>,	][^<>,]+[^<>, 	]\\)\\s-*<\\([^>]+\\)>" 1 2) ("<\\([^>,]+\\)>" nil 1) ("\\(\\b[^<\",()]+\\b\\)\\s-*(\\([^)]+\\))" (car (mail-extract-address-components (concat "\"" (match-string 2 adstring) "\""))) 1) ("\\b\\(\\([^@ 	\n.]+\\.[^@ 	\n.]+\\)@[^@ 	\n]+\\)\\b" (car (mail-extract-address-components (concat "\"" (match-string 2 adstring) "\""))) 1) ("\\b\\(\\([^@ 	\n]+\\)@[^@ 	\n]+\\)\\b" nil 1) ("\\b\\([^@ 	\n]+\\)\\b" nil 1)) "\
*List of regexps matching headers.
Each list element should have the form (REGEXP FULLNAME ADDRESS), where
REGEXP matches the address while the actual address components should
be a parenthesized expression.

FULLNAME is a default string for addresses without full name or a
number denoting parenthesized expression.
ADDRESS is a number denoting the parenthesized expression matching the
address.

If FULLNAME or ADDRESS is a list it will be evaluated to return a
string or nil.  If its a function it will be called with the remaining
address-string as argument." :group 'bbdb-noticing-records :type 'list)

(defcustom bbdb-extract-address-component-ignore-regexp "\\(\\(undisclosed\\|unlisted\\)[^,]*recipients\\)\\|no To-header on input" "\
*A regexp matching addresses which should be ignored." :group 'bbdb-noticing-records :type 'string)

(defcustom bbdb-extract-address-component-handler 'message "\
*Specifies how `bbdb-extract-address-components' reports errors.

A value of nil means ignore unparsable stuff and 'warn will report
a warning, 'message will report a message in the minibuffer and all
other value will fire a error.

When set to a function it will be called with the remaining string in
order to extract the address components and return the rest and the
components as list or to do what ever it wants, e.g. send a complain
to the author ...

To skip known unparseable stuff you rather should set the variable
`bbdb-extract-address-component-ignore-regexp' instead of disabling
this handler." :group 'bbdb-noticing-records :type '(choice (const :tag "Ignore problems." nil) (const :tag "Warn about parsing problems." 'warn) (const :tag "Show a message about parsing problems." 'message) (function :tag "A user defined handler")))

;;;***

;;;### (autoloads (bbdb/srv-display-delay bbdb/srv-auto-create-p) "bbdb-srv" "lisp/bbdb-srv.el")
(defconst custom-define-current-source-file "bbdb-srv.el")

(defcustom bbdb/srv-auto-create-p nil "\
*Like `bbdb/news-auto-create-p' and `bbdb/mail-auto-create-p',
but for the case where the record is being displayed by some external
process via the `gnudoit' mechanism.

If this is t, then records will automatically be created; if this is a
function name or lambda, then it is called with no arguments to decide
whether an entry should be automatically created.  You can use this to,
for example, create or not create messages which have a particular subject.

`bbdb/srv-auto-create-mail-news-dispatcher' is a good value for this --
that function will try to decide if this is a mail message or a news
message, and then run either `bbdb/news-auto-create-p' or
`bbdb/mail-auto-create-p' as appropriate." :group 'bbdb-utilities-server :type '(choice (const :tag "Don't automatically create records" nil) (const :tag "Automatically create records" t) (sexp :tag "Use function to determine record creation" bbdb/srv-auto-create-mail-news-dispatcher)))

(defcustom bbdb/srv-display-delay 2 "\
*How long (in seconds) we must be idle before displaying a record." :group 'bbdb-utilities-server :type 'integer)

;;;***

;;;### (autoloads (bbdb/vm-auto-add-label-field bbdb/vm-auto-add-label-list bbdb/vm-set-auto-folder-alist-headers bbdb/vm-set-auto-folder-alist-field bbdb/vm-update-records-mode) "bbdb-vm" "lisp/bbdb-vm.el")
(defconst custom-define-current-source-file "bbdb-vm.el")

(defcustom bbdb/vm-update-records-mode '(if (vm-new-flag msg) 'annotating 'searching) "\
Controls how `bbdb/vm-update-records' processes email addresses.
Set this to an expression which evaluates either to 'searching or
'annotating.  When set to 'annotating email addresses will be fed to
`bbdb-annotate-message-sender' in order to update existing records or create
new ones.  A value of 'searching will search just for existing records having
the right net.

The default is to annotate only new messages." :group 'bbdb-mua-specific-vm :type '(choice (const :tag "annotating all messages" annotating) (const :tag "annotating no messages" searching) (const :tag "annotating only new messages" (if (vm-new-flag msg) 'annotating 'searching)) (sexp :tag "user defined")))

(defcustom bbdb/vm-set-auto-folder-alist-field 'vm-folder "\
*The field which `bbdb/vm-set-auto-folder-alist' searches for." :group 'bbdb-mua-specific-vm :type 'symbol)

(defcustom bbdb/vm-set-auto-folder-alist-headers '("From:" "To:" "CC:") "\
*The headers used by `bbdb/vm-set-auto-folder-alist'.
The order in this list is the order how matching will be performed!" :group 'bbdb-mua-specific-vm :type '(repeat (string :tag "header name")))

(defcustom bbdb/vm-auto-add-label-list nil "\
*List used by `bbdb/vm-auto-add-label' to automatically label messages.
Each element in the list is either a string or a list of two strings.
If a single string then it is used as both the field value to check for
and the label to apply to the message.  If a list of two strings, the first
is the field value to search for and the second is the label to apply." :group 'bbdb-mua-specific-vm :type 'list)

(defcustom bbdb/vm-auto-add-label-field bbdb-define-all-aliases-field "\
*Fields used by `bbdb/vm-auto-add-label' to automatically label messages.
Value is either a single symbol or a list of symbols of bbdb fields that
`bbdb/vm-auto-add-label' uses to check for labels to apply to messages.
Defaults to `bbdb-define-all-aliases-field' which is typically `mail-alias'." :group 'bbdb-mua-specific-vm :type '(choice symbol list))

;;;***

;;;### (autoloads (bbdb-whois-server) "bbdb-whois" "lisp/bbdb-whois.el")
(defconst custom-define-current-source-file "bbdb-whois.el")

(defcustom bbdb-whois-server (or (and (boundp 'whois-server) whois-server) "whois.geektools.com") "\
*Server for \\[bbdb-whois] lookups." :group 'bbdb-utilities :type 'string)

;;;***

;;;### (autoloads (bbdb-sound-volume bbdb-sounds-directory) "bbdb-xemacs" "lisp/bbdb-xemacs.el")
(defconst custom-define-current-source-file "bbdb-xemacs.el")

(defcustom bbdb-sounds-directory (expand-file-name "~/.xemacs/etc/sounds") "\
The directory to load the touchtone sound files from, or nil if none." :group 'bbdb-phone-dialing :type 'directory)

(defcustom bbdb-sound-volume 50 "\
Volume for playing sounds." :group 'bbdb-phone-dialing :type 'integer)

;;;***

;;;### (autoloads (bbdb-save-db-timeout bbdb-notes-default-separator bbdb-address-formatting-alist bbdb-pop-up-display-layout bbdb-display-layout bbdb-display-layout-alist bbdb-time-display-format bbdb-addresses-label-list bbdb-phones-label-list bbdb-default-label-list bbdb-multiple-buffers bbdb-initialize-hook bbdb-load-hook bbdb-after-read-db-hook bbdb-notice-hook bbdb-canonicalize-redundant-nets-p bbdb-canonicalize-net-hook bbdb-after-change-hook bbdb-change-hook bbdb-create-hook bbdb-list-hook bbdb-mode-hook bbdb-silent-running bbdb-message-caching-enabled bbdb-offer-save bbdb-send-mail-style bbdb-new-nets-always-primary bbdb-always-add-addresses bbdb-user-mail-names bbdb-completion-display-record bbdb-completion-type bbdb-pop-up-target-lines bbdb-use-pop-up bbdb-notice-auto-save-file bbdb-auto-revert-p bbdb-continental-zip-regexp bbdb-readonly-p bbdb-use-alternate-names bbdb-quiet-about-name-mismatches bbdb/news-auto-create-p bbdb/mail-auto-create-p bbdb-case-fold-search bbdb-electric-p bbdb-north-american-phone-numbers-p bbdb-default-domain bbdb-lastname-prefixes bbdb-default-area-code bbdb-hashtable-size bbdb-file-remote-save-always bbdb-file-remote bbdb-file bbdb-utilities-server bbdb-utilities-supercite bbdb-utilities-print bbdb-utilities-ftp bbdb-utilities-finger bbdb-utilities bbdb-phone-dialing bbdb-mua-specific-vm bbdb-mua-specific-gnus-splitting bbdb-mua-specific-gnus-scoring bbdb-mua-specific-gnus bbdb-mua-specific bbdb-saving bbdb-database bbdb-record-use bbdb-noticing-records bbdb-record-creation bbdb-record-display bbdb-hooks bbdb bbdb-gui) "bbdb" "lisp/bbdb.el")
(defconst custom-define-current-source-file "bbdb.el")

(defcustom bbdb-gui (if (fboundp 'display-color-p) (display-color-p) (not (null window-system))) "\
*Non-nil means fontify the *BBDB* buffer." :group 'bbdb :type 'boolean)

(defgroup bbdb nil "The Insidious Big Brother Database." :group 'news :group 'mail)

(defgroup bbdb-hooks nil "Hooks run at various times by the BBDB" :group 'bbdb)

(defgroup bbdb-record-display nil "Variables that affect the display of BBDB records" :group 'bbdb)

(defgroup bbdb-record-creation nil "Variables that affect the creation of BBDB records" :group 'bbdb)

(defgroup bbdb-noticing-records nil "Variables that affect the noticing of new authors" :group 'bbdb-record-creation)

(defgroup bbdb-record-use nil "Variables that affect the use of BBDB records" :group 'bbdb)

(defgroup bbdb-database nil "Variables that affect the database as a whole" :group 'bbdb)

(defgroup bbdb-saving nil "Variables that affect saving of the BBDB" :group 'bbdb-database)

(defgroup bbdb-mua-specific nil "MUA-specific customizations" :group 'bbdb)

(defgroup bbdb-mua-specific-gnus nil "Gnus-specific BBDB customizations" :group 'bbdb-mua-specific)

(defgroup bbdb-mua-specific-gnus-scoring nil "Gnus-specific scoring BBDB customizations" :group 'bbdb-mua-specific-gnus)

(defgroup bbdb-mua-specific-gnus-splitting nil "Gnus-specific splitting BBDB customizations" :group 'bbdb-mua-specific-gnus)

(defgroup bbdb-mua-specific-vm nil "VM-specific BBDB customizations" :group 'bbdb-mua-specific)

(defgroup bbdb-phone-dialing nil "Customizations for phone number dialing" :group 'bbdb)

(defgroup bbdb-utilities nil "Customize BBDB Utilities" :group 'bbdb)

(defgroup bbdb-utilities-finger nil "Customizations for fingering from within the BBDB" :group 'bbdb-utilities :prefix "bbdb-finger")

(defgroup bbdb-utilities-ftp nil "Customizations for using FTP sites stored in BBDB records." :group 'bbdb-utilities)

(defgroup bbdb-utilities-print nil "Customizations for printing the BBDB." :group 'bbdb-utilities :prefix "bbdb-print")

(defgroup bbdb-utilities-supercite nil "Customizations for using Supercite with the BBDB." :group 'bbdb-utilities :prefix "bbdb/sc")

(defgroup bbdb-utilities-server nil "Customizations for interfacing with the BBDB from external programs." :group 'bbdb-utilities :prefix "bbdb/srv")

(defcustom bbdb-file "~/.bbdb" "\
*The name of the Insidious Big Brother Database file." :group 'bbdb-database :type 'file)

(defcustom bbdb-file-remote nil "\
*The remote file to save the database to.
When this is non-nil, it should be a file name.
When BBDB reads `bbdb-file', it checks this file,
 and if it is newer, downloads it.
When BBDB writes `bbdb-file', it also writes this file.

This feature allows one to keep the database in one place while using
different computers, thus reducing the need for merging different files." :group 'bbdb-database :type '(choice (const :tag "none" nil) (file :tag "remote file name")))

(defcustom bbdb-file-remote-save-always t "\
*Should the `bbdb-file-remote' file be saved whenever the database is saved?
When nil, you will be asked." :group 'bbdb-database :type 'boolean)

(defcustom bbdb-hashtable-size 1021 "\
*The size of the bbdb hashtable.
BBDB hashtable is an obarray, so this must be a prime integer.
Set this to a prime number (much) larger than the size of your database
before loading it.
If you change this variable outside `customize',
you should reload `bbdb-file'." :group 'bbdb-database :type 'integer :set (lambda (symb val) (unless (primep val) (error "`%s' must be prime, not %s" symb val)) (set symb val) (when (fboundp 'bbdb-records) (bbdb-records)) val))

(defcustom bbdb-default-area-code nil "\
*The default area code to use when prompting for a new phone number.
This variable also affects dialing." :group 'bbdb-record-creation :type '(choice (const :tag "none" nil) (integer :tag "Default Area Code")) :set (lambda (symb val) (if (or (and (stringp val) (string-match "^[0-9]+$" val)) (integerp val) (null val)) (set symb val) (error "%s must contain digits only." symb))))

(defcustom bbdb-lastname-prefixes '("von" "Von" "de" "De") "\
*List of lastname prefixes recognized in name fields. Used to
enhance dividing name strings into firstname and lastname parts." :group 'bbdb-record-creation :type '(repeat string))

(defcustom bbdb-default-domain nil "\
*The default domain to append when prompting for a new net address.
If the address entered does not contain `[@%!]', `@bbdb-default-domain'
will be appended to it.

The address will not be altered if bbdb-default-domain remains at its
default value of nil, or if one provides a prefix argument to the
bbdb-insert-new-field command." :group 'bbdb-record-creation :type '(choice (const :tag "none" nil) (string :tag "Domain" :value nil)))

(defcustom bbdb-north-american-phone-numbers-p t "\
*Set this to nil if you want to enter phone numbers that aren't the same
syntax as those in North America (that is, [[1] nnn] nnn nnnn ['x' n*]).
If this is true, then some error checking is done so that you can't enter
incorrect phone numbers, and all phone numbers are pretty-printed the same
way.  European phone numbers don't have as strict a syntax, however, so
this is a harder problem for them (on which I am punting).

You can have both styles of phone number in your database by providing a
prefix argument to the bbdb-insert-new-field command." :group 'bbdb-record-creation :type 'boolean)

(defcustom bbdb-electric-p nil "\
*Whether bbdb mode should be `electric' like `electric-buffer-list'." :group 'bbdb-record-display :type 'boolean)

(defcustom bbdb-case-fold-search (default-value 'case-fold-search) "\
*This is the value of `case-fold-search' used by `bbdb' and friends.
This variable lets the case-sensitivity of ^S and of the bbdb
commands be different." :group 'bbdb :type 'boolean)

(defcustom bbdb/mail-auto-create-p t "\
*If this is t, then Gnus, MH, RMAIL, and VM will automatically
create new bbdb records for people you receive mail from. If this
is a function name or lambda, then it is called with no arguments
to decide whether an entry should be automatically created. You
can use this to, for example, not create records for messages
which have reached you through a particular mailing list, or to
only create records automatically if the mail has a particular
subject." :group 'bbdb-noticing-records :type '(choice (const :tag "Automatically create" t) (const :tag "Prompt before creating" prompt) (const :tag "Do not automatically create" nil) (function :tag "Create with function" bbdb-)))

(defcustom bbdb/news-auto-create-p nil "\
*If this is t, then Gnus will automatically create new bbdb
records for people you receive mail from.  If this is a function name
or lambda, then it is called with no arguments to decide whether an
entry should be automatically created.  You can use this to, for
example, create or not create messages which have a particular
subject.  If you want to autocreate messages based on the current
newsgroup, it's probably a better idea to set this variable to t or
nil from your `gnus-select-group-hook' instead." :group 'bbdb-noticing-records :type '(choice (const :tag "Automatically create" t) (const :tag "Prompt before creating" prompt) (const :tag "Do not automatically create" nil) (function :tag "Create with function" bbdb-)))

(defcustom bbdb-quiet-about-name-mismatches nil "\
*If this is true, then BBDB will not prompt you when it notices a
name change, that is, when the \"real name\" in a message doesn't correspond
to a record already in the database with the same network address.  As in,
\"John Smith <jqs@frob.com>\" versus \"John Q. Smith <jqs@frob.com>\".
Normally you will be asked if you want to change it.
If set to a number it is the number of seconds to sit for while
displaying the mismatch message." :group 'bbdb-noticing-records :type '(choice (const :tag "Prompt for name changes" nil) (const :tag "Do not prompt for name changes" t) (integer :tag "Instead of prompting, warn for this many seconds")))

(defcustom bbdb-use-alternate-names t "\
*If this is true, then when bbdb notices a name change, it will ask you
if you want both names to map to the same record." :group 'bbdb-noticing-records :type '(choice (const :tag "Ask to use alternate names field" t) (const :tag "Use alternate names field without asking" nil)))

(defcustom bbdb-readonly-p nil "\
*If this is true, then nothing will attempt to change the bbdb database
implicitly, and you will be prevented from doing it explicitly.  If you have
more than one emacs running at the same time, you might want to arrange for
this to be set to t in all but one of them." :group 'bbdb-database :type '(choice (const :tag "Database is read-only" t) (const :tag "Database is writable" nil)))

(defcustom bbdb-continental-zip-regexp "^\\s *[A-Z][A-Z]?\\s *-\\s *[0-9][0-9][0-9]" "\
Regexp matching continental zip codes.
Addresses with zip codes matching the regexp will be formated using
`bbdb-format-address-continental'.  The regexp should match zip codes
of the form CH-8052, NL-2300RA, and SE-132 54." :group 'bbdb-record-display :type 'regexp)

(defcustom bbdb-auto-revert-p nil "\
*If this variable is true and the BBDB file is noticed to have changed on
disk, it will be automatically reverted without prompting you first.  Otherwise
you will be asked. (But if the file has changed and you hae made changes in
memory as well, you will always be asked.)" :group 'bbdb-saving :type '(choice (const :tag "Revert unchanged database without prompting" t) (const :tag "Ask before reverting database")))

(defcustom bbdb-notice-auto-save-file nil "\
*If this is true, then the BBDB will notice when its auto-save file is
newer than the file is was read from, and will offer to revert." :group 'bbdb-saving :type '(choice (const :tag "Check auto-save file" t) (const :tag "Do not check auto-save file" nil)))

(defcustom bbdb-use-pop-up t "\
If true, display a continuously-updating bbdb window while in VM, MH,
RMAIL, or Gnus.  If 'horiz, stack the window horizontally if there is room." :group 'bbdb-record-display :type '(choice (const :tag "Automatic BBDB window, stacked vertically" t) (const :tag "Automatic BBDB window, stacked horizontally" 'horiz) (const :tag "No Automatic BBDB window" nil)))

(defcustom bbdb-pop-up-target-lines 5 "\
*Desired number of lines in a VM/MH/RMAIL/Gnus pop-up bbdb window." :group 'bbdb-record-display :type 'integer)

(defcustom bbdb-completion-type nil "\
*Controls the behaviour of `bbdb-complete-name'.  If nil, completion is
done across the set of all full-names and user-ids in the bbdb-database;
if the symbol 'name, completion is done on names only; if the symbol 'net,
completion is done on network addresses only; if it is 'primary, then
completion is done only across the set of primary network addresses (the
first address in the list of addresses for a given user).  If it is
'primary-or-name, completion is done across primaries and real names." :group 'bbdb-record-use :type '(choice (const :tag "Complete across names and net addresses" nil) (const :tag "Complete across names" name) (const :tag "Complete across net addresses" net) (const :tag "Complete across primary net addresses" primary) (const :tag "Complete across names and primary net addresses" primary-or-name)))

(defcustom bbdb-completion-display-record t "\
*Whether `bbdb-complete-name' (\\<mail-mode-map>\\[bbdb-complete-name]
in mail-mode) will update the *BBDB* buffer
to display the record whose email address has just been inserted." :group 'bbdb-record-use :type '(choice (const :tag "Update the BBDB buffer" t) (const :tag "Don't update the BBDB buffer" nil)))

(defcustom bbdb-user-mail-names nil "\
*A regular expression identifying the addresses that belong to you.
If a message from an address matching this is seen, the BBDB record for
the To: line will be shown instead of the one for the From: line.  If
this is nil, it will default to the value of (user-login-name)." :group 'bbdb-noticing-records :type (list 'choice '(const :tag "Use value of (user-login-name)" nil) (list 'regexp :tag "Pattern matching your addresses" (or (user-login-name) "address"))))

(defcustom bbdb-always-add-addresses 'ask "\
*If this is true, then when the Insidious Big Brother Database notices
a new email address for a person, it will automatically add it to the list of
addresses.  If it is 'ask, you will be asked whether to add it.  If it is nil
then new network addresses will never be automatically added nor the user will
be asked.

When set to a function name the function should return one of these values.

See also the variable `bbdb-new-nets-always-primary' for control of whether
the addresses go at the front of the list or the back." :group 'bbdb-noticing-records :type '(choice (const :tag "Automatically add new addresses" t) (const :tag "Ask before adding new addresses" ask) (const :tag "Never add new addresses" nil) (const bbdb-ignore-some-messages-hook) (const bbdb-ignore-most-messages-hook)))

(defcustom bbdb-new-nets-always-primary nil "\
*If this is true, then when the Insidious Big Brother Database adds a new
address to a record, it will always add it to the front of the list of
addresses, making it the primary address.  If this is nil, you will be asked.
If it is the symbol 'never (really, if it is any non-t, non-nil value) then
new network addresses will always be added at the end of the list." :group 'bbdb-noticing-records :type '(choice (const :tag "New address automatically made primary" t) (const :tag "Ask before making new address primary" nil) (const :tag "Never make new address primary" never)))

(defcustom bbdb-send-mail-style nil "\
*Specifies which package should be used to send mail.
Should be 'vm, 'mh, 'mail, 'message, or 'gnus (or nil, meaning guess.)" :group 'bbdb-record-use :type '(choice (const :tag "Use VM to send mail" vm) (const :tag "Use MH-E to send mail" mh) (const :tag "Use send-mail mode to send mail" mail) (const :tag "Use Message to send mail" message) (const :tag "Use Mew to send mail" mew) (const :tag "Use compose-mail to send mail" compose-mail) (const :tag "Use gnus to send mail" gnus) (const :tag "Guess which package to use" nil)))

(defcustom bbdb-offer-save t "\
*If t, then certain actions will cause the BBDB to ask you whether
you wish to save the database.  If nil, then the offer to save will never
be made.  If not t and not nil, then any time it would ask you, it will
just save it without asking." :group 'bbdb-saving :type '(choice (const :tag "Offer to save the database" t) (const :tag "Never offer to save the database" nil) (const :tag "Save database without asking" savenoprompt)))

(defcustom bbdb-message-caching-enabled t "\
*Whether caching of the message->bbdb-record association should be used
for the interfaces which support it (VM, MH, and RMAIL).  This can speed
things up a lot.  One implication of this variable being true is that the
`bbdb-notice-hook' will not be called each time a message is selected, but
only the first time.  Likewise, if selecting a message would generate a
question (whether to add an address, change the name, etc) you will only
be asked that question the very first time the message is selected." :group 'bbdb :type '(choice (const :tag "Enable caching" t) (const :tag "Disable caching" nil)))

(defcustom bbdb-silent-running nil "\
*If this is true, bbdb will suppress all its informational messages and
queries. Be very very certain you want to set this, because it will suppress
prompting to alter record names, assign names to addresses, etc." :group 'bbdb :type '(choice (const :tag "Run silently" t) (const :tag "Disable silent running" nil)))

(defcustom bbdb-mode-hook nil "\
*Hook or hooks invoked when the *BBDB* buffer is created." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-list-hook nil "\
*Hook or hooks invoked after the `bbdb-list-buffer' is filled in.
Invoked with no arguments." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-create-hook 'bbdb-creation-date-hook "\
*Hook or hooks invoked each time a new BBDB record is created.  Invoked
with one argument, the new record.  This is called *before* the record is
added to the database.  Note that `bbdb-change-hook' will be called as well.

Hook functions can use the variable `bbdb-update-address-class' to determine
the class of an email address according to `bbdb-get-addresses-headers' and
the variable `bbdb-update-address-header' is set to the header the email
address was extracted from." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-change-hook 'bbdb-timestamp-hook "\
*Hook or hooks invoked each time a BBDB record is altered.  Invoked with
one argument, the record.  This is called *before* the bbdb-database buffer
is modified.  Note that if a new bbdb record is created, both this hook and
`bbdb-create-hook' will be called." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-after-change-hook nil "\
*Hook or hooks invoked each time a BBDB record is altered.  Invoked with
one argument, the record.  This is called *after* the bbdb-database buffer
is modified, so if you want to modify the record each time it is changed,
you should use the `bbdb-change-hook' instead.  Note that if a new bbdb
record is created, both this hook and `bbdb-create-hook' will be called." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-canonicalize-net-hook nil "\
*If this is non-nil, it should be a function of one arg: a network address
string.  Whenever the Insidious Big Brother Database \"notices\" a message,
the corresponding network address will be passed to this function first, as
a kind of \"filter\" to do whatever transformations upon it you like before
it is compared against or added to the database.  For example: it is the case
that CS.CMU.EDU is a valid return address for all mail originating at a
machine in the .CS.CMU.EDU domain.  So, if you wanted all such addresses to
be canonically hashed as user@CS.CMU.EDU, instead of as user@host.CS.CMU.EDU,
you might set this variable to a function like this:

 (setq bbdb-canonicalize-net-hook
       '(lambda (addr)
          (cond ((string-match \"\\\\`\\\\([^@]+@\\\\).*\\\\.\\\\(CS\\\\.CMU\\\\.EDU\\\\)\\\\'\"
                               addr)
                 (concat (substring addr (match-beginning 1) (match-end 1))
                         (substring addr (match-beginning 2) (match-end 2))))
                (t addr))))

You could also use this function to rewrite UUCP-style addresses into domain-
style addresses, or any number of things.

This function will be called repeatedly until it returns a value EQ to the
value passed in.  So multiple rewrite rules might apply to a single address." :group 'bbdb-hooks :type 'function)

(defcustom bbdb-canonicalize-redundant-nets-p t "\
*If this is non-nil, redundant network addresses will be ignored.
If a record has an address of the form foo@baz.com, setting this to t
will cause subsequently-noticed addresses like foo@bar.baz.com to be
ignored (since we already have a more general form of that address.)
This is similar in function to one of the possible uses of the variable
`bbdb-canonicalize-net-hook' but is somewhat more automatic.  (This
can't quite be implemented in terms of the canonicalize-net-hook because
it needs access to the database to determine whether an address is
redundant, and the canonicalize-net-hook is purely a textual manipulation
which is performed before any database access.)" :group 'bbdb-noticing-records :type '(choice (const :tag "Ignore redundant addresses" t) (const :tag "Don't ignore redundant addresses" nil)))

(defcustom bbdb-notice-hook nil "\
*Hook or hooks invoked each time a BBDB record is \"noticed\", that is,
each time it is displayed by the news or mail interfaces.  Invoked with
one argument, the new record.  The record need not have been modified for
this to be called - use `bbdb-change-hook' for that.  You can use this to,
for example, add something to the notes field based on the subject of the
current message.  It is up to your hook to determine whether it is running
in Gnus, VM, MH, or RMAIL, and to act appropriately.

Also note that `bbdb-change-hook' will NOT be called as a result of any
modifications you may make to the record inside this hook.

Hook functions can use the variable `bbdb-update-address-class' to determine
the class of an email address according to `bbdb-get-addresses-headers' and
the variable `bbdb-update-address-header' is set to the header the email
address was extracted from.

Beware that if the variable `bbdb-message-caching-enabled' is true (a good
idea) then when you are using VM, MH, or RMAIL, this hook will be called only
the first time that message is selected.  (The Gnus interface does not use
caching.)  When debugging the value of this hook, it is a good idea to set
caching-enabled to nil." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-after-read-db-hook nil "\
*Hook or hooks invoked (with no arguments) just after the Insidious Big
Brother Database is read in.  Note that this can be called more than once if
the BBDB is reverted." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-load-hook nil "\
*Hook or hooks invoked when the BBDB code is first loaded.

WARNING:  This hook will be run the first time you traverse the Custom menus
          for the BBDB.  As a result, nothing slow should be added to
          this hook." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-initialize-hook nil "\
*Hook or hooks invoked (with no arguments) when the Insidious Big Brother
Database initialization function `bbdb-initialize' is run." :group 'bbdb-hooks :type 'hook)

(defcustom bbdb-multiple-buffers nil "\
When non-nil we create a new buffer of every buffer causing pop-ups.
You can also set this to a function returning a buffer name." :group 'bbdb-record-display :type '(choice (const :tag "Disabled" nil) (function :tag "Enabled" bbdb-multiple-buffers-default) (function :tag "User defined function")))

(defcustom bbdb-default-label-list '("Home" "Office" "Mobile" "Other") "\
*Default list of labels for Address and Phone fields." :group 'bbdb-record-creation :type '(repeat string))

(defcustom bbdb-phones-label-list bbdb-default-label-list "\
*List of labels for Phone field.
The default value is `bbdb-default-label-list'." :group 'bbdb-record-creation :type '(repeat string))

(defcustom bbdb-addresses-label-list bbdb-default-label-list "\
*List of labels for Address field.
The default value is `bbdb-default-label-list'." :group 'bbdb-record-creation :type '(repeat string))

(defcustom bbdb-time-display-format "%d %b %Y" "\
The format for the timestamp to be used in the creation-date and
timestamp fields.  See the documentation for `format-time-string'." :group 'bbdb :type 'string)

(defcustom bbdb-display-layout-alist '((one-line (order phones mail-alias net notes) (name-end . 24) (toggle . t)) (multi-line (omit creation-date timestamp) (toggle . t)) (pop-up-multi-line) (full-multi-line)) "\
*An alist describing each display layout.
The format of an element is (LAYOUT-NAME OPTION-ALIST).

By default there are four different layout types used by BBDB, which are
`one-line', `multi-line', `pop-up-multi-line' (used for pop-ups) and
`full-multi-line' (showing all fields of a record).

OPTION-ALIST specifies the options for the layout.  Valid options are:

                           ------- Availability --------
    Format                  one-line        multi-line        default if unset
------------------------------------------------------------------------------
 (toggle . BOOL)                 +               +              nil
 (order . FIELD-LIST)            +               +              '(phones ...)
 (omit . FIELD-LIST)             +               +              nil
 (name-end . INTEGER)            +               -              40
 (indentation . INTEGER)         -               +              14
 (primary . BOOL)                -               +              nil
 (test . SEXP)                   +               +              nil

- toggle: controls if this layout is included when toggeling the display layout
- order: defines a user specific order for the fields, where `t' is a place
  holder for all remaining fields
- omit: is a list of fields which should not be displayed or `t' to exclude all
  fields except those listed in the order option
- name-end: sets the column where the name should end in one-line layout.
- indentation: sets the level of indentation for multi-line display.
- primary: controls wether only the primary net is shown or all are shown.
- test: a lisp expression controlling wether the record is to be displayed.

When you add a new layout FOO, you can write a corresponding layout
function bbdb-format-record-layout-FOO.  If you do not write your own
layout function, the multi-line layout will be used." :group 'bbdb :type (backquote (repeat (cons :tag "Layout Definition" (choice :tag "Layout type" (const one-line) (const multi-line) (const pop-up-multi-line) (const full-multi-line) (symbol)) (set :tag "Properties" (cons :tag "Order" (const :tag "List of fields to order by" order) (repeat (choice (const phones) (const addresses) (const net) (const AKA) (const notes) (symbol :tag "other") (const :tag "Remaining fields" t)))) (choice :tag "Omit" :value (omit) (cons :tag "List of fields to omit" (const :tag "Fields not to display" omit) (repeat (choice (const phones) (const addresses) (const net) (const AKA) (const notes) (symbol :tag "other")))) (const :tag "Exclude all fields except those listed in the order property" t)) (cons :tag "Indentation" :value (indentation . 14) (const :tag "Level of indentation for multi-line layout" indentation) (number :tag "Column")) (cons :tag "End of name field" :value (name-end . 24) (const :tag "The column where the name should end in one-line layout" name-end) (number :tag "Column")) (cons :tag "Toggle" (const :tag "The layout is included when toggling display layout" toggle) boolean) (cons :tag "Primary Net Only" (const :tag "Only the primary net address is included" primary) boolean) (cons :tag "Test" (const :tag "Show only records passing this test" test) (choice (const :tag "No test" nil) (cons :tag "List of required fields" (const :tag "Choose from the attributes in the following set:" and) (set (const name) (const company) (const net) (const phones) (const addresses) (const notes))) (sexp :tag "Lisp expression"))))))))

(defcustom bbdb-display-layout 'multi-line "\
*The default display layout." :group 'bbdb :type '(choice (const one-line) (const multi-line) (const full-multi-line) (symbol)))

(defcustom bbdb-pop-up-display-layout 'pop-up-multi-line "\
*The default display layout pop-up BBDB buffers, i.e. mail, news." :group 'bbdb :type '(choice (const one-line) (const multi-line) (const full-multi-line) (symbol)))

(defcustom bbdb-address-formatting-alist '((bbdb-address-is-continental . bbdb-format-address-continental) (nil . bbdb-format-address-default)) "\
Alist of address identifying and address formatting functions.
The key is an identifying function which accepts an address.  The
associated value is a formatting function which inserts the formatted
address in the current buffer.  If the identifying function returns
non-nil, the formatting function is called.  When nil is used as the
car, then the associated formatting function will always be called.
Therefore you should always have (nil . bbdb-format-address-default) as
the last element in the alist.

All functions should take two arguments, the address and an indentation.
The indentation argument may be optional.

This alist is used in `bbdb-format-address'.

See also `bbdb-address-print-formatting-alist'." :group 'bbdb-record-display :type '(repeat (cons function function)))

(defcustom bbdb-notes-default-separator ", " "\
*The default separator inserted by `bbdb-annotate-notes'.
This is used for notes which do not have `field-separator' property set.
E.g., if you want URLs to be separated by newlines, you can put
  (put 'www 'field-separator \"\\n\")
into your .emacs." :group 'bbdb-noticing-records :type 'string)

(defcustom bbdb-save-db-timeout nil "\
*If non-nil, then when `bbdb-save-db' is asking you whether to save the db,
it will time out to `yes' after this many seconds.  This only works if the
function `y-or-n-p-with-timeout' is defined." :group 'bbdb-save :type '(choice (const :tag "Don't time out" nil) (integer :tag "Time out after this many seconds" 5)))

;;;***

(provide 'bbdb-custom-defines)
