;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'build-custom-defines) (error "Feature build-custom-defines already loaded"))

;;;### (autoloads (build-report-file-encoding build-report-prompts build-report-subject build-report-installation-insert-all build-report-version-file build-report-installation-file build-report-make-output-files build-report-make-output-dir build-report-delete-regexp build-report-keep-regexp build-report-destination build-report) "build-report" "build/build-report.el")
(defconst custom-define-current-source-file "build-report.el")

(defgroup build-report nil "Standardizes the Creation of XEmacs Build Reports." :load 'build-report :group 'build)

(defcustom build-report-destination (list "XEmacs Build Reports List <xemacs-buildreports@xemacs.org>" "XEmacs Beta List <xemacs-beta@xemacs.org>") "\
*The list of mail addresses XEmacs Build Reports should most likely
go to." :type '(repeat :custom-show t :documentation-shown t string) :group 'build-report)

(defcustom build-report-keep-regexp (list "^\\(cd\\|n?make\\)\\s-" "errors?" "warnings?" "pure.*\\(space\\|size\\)" "hides\\b" "strange" "shadowings" "^Compil\\(ing\\s-+in\\|ation\\)" "^Using" "not\\s-+found" "^While\\s-+compiling.*\\(\n\\s-+.+\\)*" "^Note:" "Installing" "[Ff]ile(s) copied" "\\s-+tests\\s-+" "^[A-Z] [^ ]+$" "^Wrong number of arguments:" "^  \\*\\* " "^\\(FAIL\\|SKIP\\):") "\
*Regexp of make process output lines to keep in the report." :type '(repeat :custom-show t :documentation-shown t regexp) :group 'build-report)

(defcustom build-report-delete-regexp (list "confl.*with.*auto-inlining" "^Formatting:" "^\\s-*0 .*\\(failure\\|error\\)s?" "^PASS:" "(100%) tests successful") "\
*Regexp of make process output lines to delete from the report." :type '(repeat :custom-show t :documentation-shown t regexp) :group 'build-report)

(defcustom build-report-make-output-dir (cond ((equal system-type 'windows-nt) (expand-file-name "nt" (gethash 'blddir (config-value-hash-table)))) (t (gethash 'blddir (config-value-hash-table)))) "\
*Directory where the build report file is found.
  If this is empty or nil, the default, it is replaced by the value of
  the XEmacs build directory." :type '(directory :custom-show t :documentation-shown t) :group 'build-report)

(defcustom build-report-make-output-files (list "beta.err" "xemacs-make-all.err" "xemacs-make-check-temacs.err" "xemacs-make-check.err" "xemacs-make-install.err") "\
*List of Filenames where stdout and stderr of XEmacs make process
have been stored.  These are relative to
`build-report-make-output-dir`.  You'll have to run make with output
redirection or use the `build' XEmacs package to save this output. You
may use following alias

alias mk 'make !* >>&! !$.err &'

under csh, so that you get beta.err when you run `mk beta'." :type '(repeat :custom-show t :documentation-shown t file) :group 'build-report)

(defcustom build-report-installation-file (expand-file-name "Installation" (gethash 'blddir (config-value-hash-table))) "\
*Installation file produced by XEmacs configure process." :type '(file :custom-show t :documentation-shown t) :group 'build-report)

(defcustom build-report-version-file (expand-file-name "version.sh" (gethash 'blddir (config-value-hash-table))) "\
*version.sh file identifying XEmacs (Beta) Distribution." :type '(file :custom-show t :documentation-shown t) :group 'build-report)

(defcustom build-report-installation-insert-all nil "\
*Tell build-report to insert the whole Installation file
  instead of just the last report." :type 'boolean :group 'build-report)

(defcustom build-report-subject (concat "[%s] " emacs-version " on " system-configuration) "\
*XEmacs Build Report Subject Line. %s-sequences will be substituted
  with user input through `build-report' according to
  `build-report-prompts' using `format'." :type '(string :custom-show t :documentation-shown t) :group 'build-report)

(defcustom build-report-prompts '(("Status?: " ("Success" "Failure"))) "\
*XEmacs Build Report Prompt(s). This is a list of prompt-string
  lists used by `build-report' in conjunction with
  `build-report-subject'. Each list consists of a prompt string
  followed by any number of strings which can be chosen via the history
  mechanism." :type '(repeat :custom-show t :documentation-shown t (list :tag "Prompt" string (repeat :tag "Values" string))) :group 'build-report)

(defcustom build-report-file-encoding "7bit" "\
*XEmacs Build Report File Encoding to be used when MIME support is
  available." :group 'build-report)

;;;***

;;;### (autoloads (build-settings build-with-MS-make-options build-with-MS-make-command build-with-MS build-tarball-site build-tarball-set build-tarball-prefix build-tarball-dir build-tarball-dest build-tarball build-cvs-xemacs-release build-cvs-working-dir-naming build-cvs-xemacs-repository build-cvs-use-pcl-cvs build-cvs-checkout-parent-dir build-cvs-update-options build-cvs-options build-cvs-checkout-options build-cvs build build-with-what build-from-what) "build" "build/build.el")
(defconst custom-define-current-source-file "build.el")

(defcustom build-from-what "Tarballs" "\
The Source Code units XEmacs is to be built from (\"Tarballs\" or
\"CVS\")." :type '(choice :custom-state t (const "Tarballs") (const "CVS")) :group 'build)

(defcustom build-with-what "GNU Tools" "\
The Toolset XEmacs is to be built with (\"GNU Tools\" or
\"Microsoft Tools\")." :type '(choice :custom-state t (const "GNU Tools") (const "Microsoft Tools")) :group 'build)

(defgroup build nil "Simplifies Building XEmacs; i.e. Fetching, Configuring, Making, and\nReporting." :link '(url-link :tag "XEmacs Build Reference Manual" "http://www.xemacs.org/Documentation/packages/html/build.html") :link '(url-link :tag "XEmacs Beta README" "ftp://ftp@ftp.xemacs.org/pub/xemacs/beta/README") :link '(url-link :tag "XEmacs Gamma README" "ftp://ftp@ftp.xemacs.org/pub/xemacs/gamma/README") :link '(url-link :tag "XEmacs Stable README" "ftp://ftp@ftp.xemacs.org/pub/xemacs/stable/README") :group 'emacs)

(defgroup build-cvs nil "Standardizes the fetching of XEmacs from the CVS repository." :group 'build)

(defcustom build-cvs-checkout-options "-P" "\
CVS checkout command-line options to use for all CVS commands." :type 'string :set 'build-cvs-checkout-options-validate :group 'build-cvs)

(defcustom build-cvs-options "-z3" "\
CVS command-line options to use for all CVS commands." :type 'string :set 'build-cvs-set-var-and-update-buffer :group 'build-cvs)

(defcustom build-cvs-update-options "-P -d" "\
CVS update command-line options to use for all CVS commands." :type 'string :set 'build-cvs-set-var-and-update-buffer :group 'build-cvs)

(defcustom build-cvs-checkout-parent-dir (temp-directory) "\
The parent directory on the local host into which the
`build-cvs-xemacs-module' will be checked out, named according to
`build-cvs-checkout-dir'." :type 'directory :set 'build-cvs-set-var-and-update-buffer :group 'build-cvs)

(defcustom build-cvs-use-pcl-cvs nil "\
*Whether build is to use PCL-CVS, when available.
Alternatively, build will run CVS commands via `compile'." :type 'boolean :set 'build-cvs-set-var-and-update-buffer :group 'build-cvs)

(defcustom build-cvs-xemacs-repository ":pserver:cvs@cvs.xemacs.org:/pack/xemacscvs" "\
CVS Repository where XEmacs can be checked out from." :type 'string :set 'build-cvs-set-var-and-update-buffer :group 'build-cvs)

(defcustom build-cvs-working-dir-naming '(format "%s-%s" build-cvs-xemacs-module build-cvs-xemacs-release) "\
The naming of the directory on the local host into which the
`build-cvs-xemacs-module' will be checked out. Be aware that cvs
checkout options -d and -N will affect the resulting directory
structure.  Therefor these options are disallowed in
`build-cvs-checkout-options'.  The -N option is not supported, in order
to avoid unknown directory structures." :type '(choice (const :tag "Named after CVS MODULE" build-cvs-xemacs-module) (const :tag "Named after RELEASE Tag" build-cvs-xemacs-release) (const :tag "Named after MODULE-RELEASE" (format "%s-%s" build-cvs-xemacs-module build-cvs-xemacs-release)) (string :tag "Working Dir Named manually" "")) :set 'build-cvs-set-var-and-update-buffer :group 'build-cvs)

(defcustom build-cvs-xemacs-release "HEAD" "\
CVS XEmacs release to be checked out.
The list of available releases is updated via cvs, if installed, by
`build-from-CVS'.  Use \"Specify Tag Name\" to fill in the name of a
release tag not yet in the list of choices." :type '(choice :custom-state t (string :tag "Unlisted Release Name" "") (const :tag "release-21-1 (branch: 1.165.2)" "release-21-1") (const :tag "release-21-4 (branch: 1.166.2)" "release-21-4") (const :tag "r21-5-9 (revision: 1.183)" "r21-5-9")) :set 'build-cvs-set-var-and-update-buffer :group 'build-cvs)

(defgroup build-tarball nil "Standardized the fetching of XEmacs beta/release tarballs." :group 'build)

(defcustom build-tarball-dest (temp-directory) "\
The destination directory on the local host the `build-tarball-set'
will be deposited in." :type 'directory :group 'build-tarball)

(defcustom build-tarball-dir "beta" "\
The sub-directory under `build-tarball-site' in which the
`build-tarball-set' is located." :type '(choice :custom-state t (const "beta") (const "gamma") (const "stable")) :group 'build-tarball)

(defcustom build-tarball-prefix "xemacs-21.5.6" "\
The prefix shared among all of the `build-tarball-set'.  This makes
it easy to switch over from one beta/gamma/stable release tarball set
to the next,
e.g. from \"xemacs-21.5.5\" to \"xemacs-21.5.6\"." :type 'string :group 'build-tarball)

(defcustom build-tarball-set nil "\
The set of final name components of XEmacs tarballs you wish to
fetch." :type '(set (const :tag "XEmacs byte-compiled lisp tarball" "-elc.tar.gz") (const :tag "XEmacs byte-compiled lisp tarball signature" "-elc.tar.gz.asc") (const :tag "XEmacs info tarball" "-info.tar.gz") (const :tag "XEmacs info tarball signature" "-info.tar.gz.asc") (const :tag "XEmacs Mule tarball" "-mule.tar.gz") (const :tag "XEmacs Mule tarball signature" "-mule.tar.gz.asc") (const :tag "XEmacs source tarball" ".tar.gz") (const :tag "XEmacs source tarball signature" ".tar.gz.asc") (repeat :custom-show t :documentation-shown t (string ""))) :group 'build-tarball)

(defcustom build-tarball-site "/ftp@ftp.xemacs.org:/pub/xemacs/" "\
The EFS path to a top-level XEmacs directory to fetch the XEmacs
  `build-tarball-set' from.
The list of available sites is dynamically generated based on
`package-get-download-sites'.  In addition you may set the value to a
manually chosen EFS path." :link '(url-link :tag "XEmacs Download Locations" "http://www.xemacs.org/Download/") :type (append '(choice :custom-state t) (cons '(directory :tag "EFS Path" "/user@host.domain:/directory/") (remove nil (mapcar (function (lambda (entry) (let (comment host path efs-path) (setq comment (nth 0 entry) host (nth 1 entry) path (nth 2 entry)) (when (and host (not (string-equal comment "Pre-Releases"))) (setq efs-path (format "/ftp@%s:/%s" host path)) (list 'const :tag (format "%s - %s" efs-path comment) (file-name-directory efs-path)))))) package-get-download-sites)))) :group 'build-tarball)

(defgroup build-with-MS nil "Standardizes the building of XEmacs with MiroSoft tools." :group 'build)

(defcustom build-with-MS-make-command "nmake" "\
Path of Microsoft make utility used to build XEmacs." :type 'file :group 'build-with-MS)

(defcustom build-with-MS-make-options '("/f xemacs.mak") "\
Options to use with Microsoft make utility when building XEmacs." :type '(repeat string) :group 'build-with-MS)

(defcustom build-settings nil "\
Internal alist of named settings for building multiple XEmacs
configurations.
This variable is updated via \"Delete\", Load\", and \"Save\" buttons
of the `build' GUI." :type 'sexp :group 'build)

;;;***

(provide 'build-custom-defines)
