;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'calendar-custom-defines) (error "Feature calendar-custom-defines already loaded"))

;;;### (autoloads (appt-mode-line-string appt-delete-window-function appt-disp-window-function appt-display-interval appt-make-list-hook appt-display-diary appt-display-duration appt-display-mode-line appt-display-format appt-msg-window appt-visible appt-audible appt-message-warning-time appt-issue-message) "appt" "calendar/appt.el")
(defconst custom-define-current-source-file "appt.el")

(defcustom appt-issue-message t "\
*Non-nil means check for appointments in the diary buffer.
To be detected, the diary entry must have the format described in the
documentation of the function `appt-check'." :type 'boolean :group 'appt)

(defcustom appt-message-warning-time 12 "\
*Time in minutes before an appointment that the warning begins." :type 'integer :group 'appt)

(defcustom appt-audible t "\
*Non-nil means beep to indicate appointment." :type 'boolean :group 'appt)

(defcustom appt-visible t "\
*Non-nil means display appointment message in echo area.
This variable is only relevant if `appt-msg-window' is nil." :type 'boolean :group 'appt)

(defcustom appt-msg-window t "\
*Non-nil means display appointment message in another window.
If non-nil, this variable overrides `appt-visible'." :type 'boolean :group 'appt)

(defcustom appt-display-format 'ignore "\
How appointment reminders should be displayed.
The options are:
   window - use a separate window
   echo   - use the echo area
   nil    - no visible reminder.
See also `appt-audible' and `appt-display-mode-line'.

The default value is 'ignore, which means to fall back on the value
of the (obsolete) variables `appt-msg-window' and `appt-visible'." :type '(choice (const :tag "Separate window" window) (const :tag "Echo-area" echo) (const :tag "No visible display" nil) (const :tag "Backwards compatibility setting - choose another value" ignore)) :group 'appt :version "22.1")

(defcustom appt-display-mode-line t "\
*Non-nil means display minutes to appointment and time on the mode line.
This is in addition to any other display of appointment messages." :type 'boolean :group 'appt)

(defcustom appt-display-duration 10 "\
*The number of seconds an appointment message is displayed.
Only relevant if reminders are to be displayed in their own window." :type 'integer :group 'appt)

(defcustom appt-display-diary t "\
*Non-nil displays the diary when the appointment list is first initialized.
This will occur at midnight when the appointment list is updated." :type 'boolean :group 'appt)

(defcustom appt-make-list-hook nil "\
*List of functions to be called after `appt-make-list' finishes.
This is designed to be used with `appt-included-diary-entries' which 
supports included or shared diary files." :type 'hook :group 'appt)

(defcustom appt-display-interval 3 "\
*Number of minutes to wait between checking the appointment list." :type 'integer :group 'appt)

(defcustom appt-disp-window-function 'appt-disp-window "\
Function called to display appointment window.
Only relevant if reminders are being displayed in a window." :type '(choice (const appt-disp-window) function) :group 'appt)

(defcustom appt-delete-window-function 'appt-delete-window "\
Function called to remove appointment window and buffer.
Only relevant if reminders are being displayed in a window." :type '(choice (const appt-delete-window) function) :group 'appt)

(defcustom appt-mode-line-string "" "\
*The string displayed in the mode line by the appointment package." :type 'string :group 'appt)

;;;***

;;;### (autoloads (chinese-calendar-daylight-savings-ends-time chinese-calendar-daylight-savings-starts-time chinese-calendar-daylight-savings-ends chinese-calendar-daylight-savings-starts chinese-calendar-daylight-time-zone-name chinese-calendar-standard-time-zone-name chinese-calendar-daylight-time-offset chinese-calendar-location-name chinese-calendar-time-zone) "cal-china" "calendar/cal-china.el")
(defconst custom-define-current-source-file "cal-china.el")

(defcustom chinese-calendar-time-zone '(if (< year 1928) (+ 465 (/ 40.0 60.0)) 480) "\
*Number of minutes difference between local standard time for Chinese
calendar and Coordinated Universal (Greenwich) Time.  Default is for Beijing.
This is an expression in `year' since it changed at 1928-01-01 00:00:00 from
UT+7:45:40 to UT+8." :type 'sexp :group 'chinese-calendar)

(defcustom chinese-calendar-location-name "Beijing" "\
*Name of location used for calculation of Chinese calendar." :type 'string :group 'chinese-calendar)

(defcustom chinese-calendar-daylight-time-offset 0 "\
*Number of minutes difference between daylight saving and standard time
for Chinese calendar.  Default is for no daylight saving time." :type 'integer :group 'chinese-calendar)

(defcustom chinese-calendar-standard-time-zone-name '(if (< year 1928) "PMT" "CST") "\
*Abbreviated name of standard time zone used for Chinese calendar.
This is an expression depending on `year' because it changed
at 1928-01-01 00:00:00 from `PMT' to `CST'." :type 'sexp :group 'chinese-calendar)

(defcustom chinese-calendar-daylight-time-zone-name "CDT" "\
*Abbreviated name of daylight saving time zone used for Chinese calendar." :type 'string :group 'chinese-calendar)

(defcustom chinese-calendar-daylight-savings-starts nil "\
*Sexp giving the date on which daylight saving time starts for Chinese
calendar.  Default is for no daylight saving time.  See documentation of
`calendar-daylight-savings-starts'." :type 'sexp :group 'chinese-calendar)

(defcustom chinese-calendar-daylight-savings-ends nil "\
*Sexp giving the date on which daylight saving time ends for Chinese
calendar.  Default is for no daylight saving time.  See documentation of
`calendar-daylight-savings-ends'." :type 'sexp :group 'chinese-calendar)

(defcustom chinese-calendar-daylight-savings-starts-time 0 "\
*Number of minutes after midnight that daylight saving time starts for
Chinese calendar.  Default is for no daylight saving time." :type 'integer :group 'chinese-calendar)

(defcustom chinese-calendar-daylight-savings-ends-time 0 "\
*Number of minutes after midnight that daylight saving time ends for
Chinese calendar.  Default is for no daylight saving time." :type 'integer :group 'chinese-calendar)

;;;***

;;;### (autoloads (calendar-dst-check-each-year-flag) "cal-dst" "calendar/cal-dst.el")
(defconst custom-define-current-source-file "cal-dst.el")

(defcustom calendar-dst-check-each-year-flag t "\
Non-nil means to check each year for DST transitions as needed.
Otherwise assume the next two transitions found after the
current date apply to all years.  This is faster, but not always
correct, since the dates of daylight saving transitions sometimes
change." :type 'boolean :version "22.1" :group 'calendar)

;;;***

;;;### (autoloads (cal-html-css-default cal-html-day-abbrev-array cal-html-year-index-cols cal-html-print-day-number-flag cal-html-directory calendar-html) "cal-html" "calendar/cal-html.el")
(defconst custom-define-current-source-file "cal-html.el")

(defgroup calendar-html nil "Options for HTML calendars." :prefix "cal-html-" :group 'calendar)

(defcustom cal-html-directory "~/public_html" "\
Directory for HTML pages generated by cal-html." :type 'string :group 'calendar-html)

(defcustom cal-html-print-day-number-flag nil "\
Non-nil means print the day-of-the-year number in the monthly cal-html page." :type 'boolean :group 'calendar-html)

(defcustom cal-html-year-index-cols 3 "\
Number of columns in the cal-html yearly index page." :type 'integer :group 'calendar-html)

(defcustom cal-html-day-abbrev-array (calendar-abbrev-construct calendar-day-abbrev-array calendar-day-name-array) "\
Array of seven strings for abbreviated day names (starting with Sunday)." :type '(vector string string string string string string string) :group 'calendar-html)

(defcustom cal-html-css-default (concat "<STYLE TYPE=\"text/css\">\n" "  BODY { background: #bde; }\n" "  H1   { text-align: center; }\n" "  TABLE  { padding: 2pt; }\n" "  TH { background: #dee; }\n" "  TABLE.year   { width: 100%; }\n" "  TABLE.agenda { width: 100%; }\n" "  TABLE.header { width: 100%; text-align: center; }\n" "  TABLE.minical TD { background: white; text-align: center; }\n" "  TABLE.agenda TD  { background: white; text-align: left; }\n" "  TABLE.agenda TH  { text-align: left; width: 20%; }\n" "  SPAN.NO-YEAR  { color: #0b3; font-weight: bold; }\n" "  SPAN.ANN      { color: #0bb; font-weight: bold; }\n" "  SPAN.BLOCK    { color: #048; font-style: italic; }\n" "</STYLE>\n\n") "\
Default cal-html css style.  You can override this with a \"cal.css\" file." :type 'string :group 'calendar-html)

;;;***

;;;### (autoloads (cal-tex-daily-hook cal-tex-week-hook cal-tex-month-hook cal-tex-year-hook cal-tex-hook cal-tex-preamble-extra cal-tex-daily-end cal-tex-daily-start cal-tex-24 cal-tex-buffer cal-tex-daily-string cal-tex-rules cal-tex-diary cal-tex-holidays cal-tex-which-days) "cal-tex" "calendar/cal-tex.el")
(defconst custom-define-current-source-file "cal-tex.el")

(defcustom cal-tex-which-days '(0 1 2 3 4 5 6) "\
*The days of the week that are displayed on the portrait monthly calendar.
Sunday is 0, Monday is 1, and so on.  The default is to print from Sunday to
Saturday.  For example, use

                    (setq cal-tex-which-days '(1 3 5))

to only print Monday, Wednesday, Friday." :type '(repeat integer) :group 'calendar-tex)

(defcustom cal-tex-holidays t "\
*If t (default), then the holidays are also printed.
If finding the holidays is too slow, set this to nil." :type 'boolean :group 'calendar-tex)

(defcustom cal-tex-diary nil "\
*If t, the diary entries are printed in the calendar." :type 'boolean :group 'calendar-tex)

(defcustom cal-tex-rules nil "\
*If t, pages will be ruled in some styles." :type 'boolean :group 'calendar-tex)

(defcustom cal-tex-daily-string '(let* ((year (extract-calendar-year date)) (day (calendar-day-number date)) (days-remaining (- (calendar-day-number (list 12 31 year)) day))) (format "%d/%d" day days-remaining)) "\
*An expression in the variable `date' whose value is placed on date.
The string resulting from evaluating this expression is placed at the bottom
center of `date' on the monthly calendar, next to the date in the weekly
calendars, and in the top center of daily calendars.

Default is ordinal day number of the year and the number of days remaining.
As an example of what you do, setting this to

    '(progn
       (require 'cal-hebrew)
       (calendar-hebrew-date-string date))

will put the Hebrew date at the bottom of each day." :type 'sexp :group 'calendar-tex)

(defcustom cal-tex-buffer "calendar.tex" "\
*The name for the tex-ed calendar." :type 'string :group 'calendar-tex)

(defcustom cal-tex-24 nil "\
*If t, use a 24 hour clock in the daily calendar." :type 'boolean :group 'calendar-tex)

(defcustom cal-tex-daily-start 8 "\
*The first hour of the daily calendar page." :type 'integer :group 'calendar-tex)

(defcustom cal-tex-daily-end 20 "\
*The last hour of the daily calendar page." :type 'integer :group 'calendar-tex)

(defcustom cal-tex-preamble-extra nil "\
A string giving extra LaTeX commands to insert in the calendar preamble.
For example, to include extra packages:
\"\\\\usepackage{foo}\\n\\\\usepackage{bar}\\n\"." :type 'string :group 'calendar-tex :version "22.1")

(defcustom cal-tex-hook nil "\
*List of functions called after any LaTeX calendar buffer is generated.
You can use this to do postprocessing on the buffer.  For example, to change
characters with diacritical marks to their LaTeX equivalents, use
     (add-hook 'cal-tex-hook
               '(lambda () (iso-iso2tex (point-min) (point-max))))" :type 'hook :group 'calendar-tex)

(defcustom cal-tex-year-hook nil "\
*List of functions called after a LaTeX year calendar buffer is generated." :type 'hook :group 'calendar-tex)

(defcustom cal-tex-month-hook nil "\
*List of functions called after a LaTeX month calendar buffer is generated." :type 'hook :group 'calendar-tex)

(defcustom cal-tex-week-hook nil "\
*List of functions called after a LaTeX week calendar buffer is generated." :type 'hook :group 'calendar-tex)

(defcustom cal-tex-daily-hook nil "\
*List of functions called after a LaTeX daily calendar buffer is generated." :type 'hook :group 'calendar-tex)

;;;***

;;;### (autoloads (calendar-debug-sexp calendar-week-start-day calendar-minimum-window-height calendar-setup calendar-holidays solar-holidays bahai-holidays islamic-holidays christian-holidays hebrew-holidays other-holidays local-holidays oriental-holidays general-holidays holidays-in-diary-buffer diary-list-include-blanks nongregorian-diary-marking-hook mark-diary-entries-hook nongregorian-diary-listing-hook diary-display-hook diary-hook list-diary-entries-hook print-diary-entries-hook calendar-date-display-form american-calendar-display-form european-calendar-display-form diary-date-forms european-date-diary-pattern american-date-diary-pattern european-calendar-style abbreviated-calendar-year sexp-diary-entry-symbol diary-file-name-prefix diary-face-attrs diary-glob-file-regexp-prefix diary-include-string bahai-diary-entry-symbol islamic-diary-entry-symbol hebrew-diary-entry-symbol diary-nonmarking-symbol diary-file calendar-move-hook today-invisible-calendar-hook today-visible-calendar-hook initial-calendar-window-hook calendar-load-hook calendar-mode-hook all-bahai-calendar-holidays diary-file-name-prefix-function all-islamic-calendar-holidays all-christian-calendar-holidays all-hebrew-calendar-holidays mark-holidays-in-calendar view-calendar-holidays-initially calendar-holiday-marker calendar-today-marker diary-entry-marker calendar-remove-frame-by-deleting mark-diary-entries-in-calendar view-diary-entries-initially calendar-offset calendar-hooks calendar-tex chinese-calendar holidays appt diary calendar) "calendar" "calendar/calendar.el")
(defconst custom-define-current-source-file "calendar.el")

(defgroup calendar nil "Calendar and time management support." :group 'applications)

(defgroup diary nil "Emacs diary." :group 'calendar)

(defgroup appt nil "Appointment notification." :tag "Appointments" :group 'calendar)

(defgroup holidays nil "Holidays support in calendar." :group 'calendar :prefix "calendar-" :group 'local)

(defgroup chinese-calendar nil "Chinese calendar support." :group 'calendar)

(defgroup calendar-tex nil "Options for printing calendar with LaTeX." :prefix "cal-tex-" :group 'calendar)

(defgroup calendar-hooks nil "Calendar hooks." :prefix "calendar-" :group 'calendar)

(defcustom calendar-offset 0 "\
The offset of the principal month from the center of the calendar window.
0 means the principal month is in the center (default), -1 means on the left,
+1 means on the right.  Larger (or smaller) values push the principal month off
the screen." :type 'integer :group 'calendar)

(defcustom view-diary-entries-initially nil "\
Non-nil means display current date's diary entries on entry to calendar.
The diary is displayed in another window when the calendar is first displayed,
if the current date is visible.  The number of days of diary entries displayed
is governed by the variable `number-of-diary-entries'.  This variable can
be overridden by the value of `calendar-setup'." :type 'boolean :group 'diary)

(defcustom mark-diary-entries-in-calendar nil "\
Non-nil means mark dates with diary entries, in the calendar window.
The marking symbol is specified by the variable `diary-entry-marker'." :type 'boolean :group 'diary)

(defcustom calendar-remove-frame-by-deleting nil "\
Determine how the calendar mode removes a frame no longer needed.
If nil, make an icon of the frame.  If non-nil, delete the frame." :type 'boolean :group 'view)

(defcustom diary-entry-marker (if (not (display-color-p)) "+" 'diary) "\
How to mark dates that have diary entries.
The value can be either a single-character string or a face." :type '(choice string face) :group 'diary)

(defcustom calendar-today-marker (if (not (display-color-p)) "=" 'calendar-today-face) "\
How to mark today's date in the calendar.
The value can be either a single-character string or a face.
Marking today's date is done only if you set up `today-visible-calendar-hook'
to request that." :type '(choice string face) :group 'calendar)

(defcustom calendar-holiday-marker (if (not (display-color-p)) "*" 'holiday-face) "\
How to mark notable dates in the calendar.
The value can be either a single-character string or a face." :type '(choice string face) :group 'calendar)

(defcustom view-calendar-holidays-initially nil "\
Non-nil means display holidays for current three month period on entry.
The holidays are displayed in another window when the calendar is first
displayed." :type 'boolean :group 'holidays)

(defcustom mark-holidays-in-calendar nil "\
Non-nil means mark dates of holidays in the calendar window.
The marking symbol is specified by the variable `calendar-holiday-marker'." :type 'boolean :group 'holidays)

(defcustom all-hebrew-calendar-holidays nil "\
If nil, show only major holidays from the Hebrew calendar.
This means only those Jewish holidays that appear on secular calendars.

If t, show all the holidays that would appear in a complete Hebrew calendar." :type 'boolean :group 'holidays)

(defcustom all-christian-calendar-holidays nil "\
If nil, show only major holidays from the Christian calendar.
This means only those Christian holidays that appear on secular calendars.

If t, show all the holidays that would appear in a complete Christian
calendar." :type 'boolean :group 'holidays)

(defcustom all-islamic-calendar-holidays nil "\
If nil, show only major holidays from the Islamic calendar.
This means only those Islamic holidays that appear on secular calendars.

If t, show all the holidays that would appear in a complete Islamic
calendar." :type 'boolean :group 'holidays)

(defcustom diary-file-name-prefix-function (function (lambda (str) str)) "\
The function that will take a diary file name and return the desired prefix." :type 'function :group 'diary)

(defcustom all-bahai-calendar-holidays nil "\
If nil, show only major holidays from the Baha'i calendar.
These are the days on which work and school must be suspended.

If t, show all the holidays that would appear in a complete Baha'i
calendar." :type 'boolean :group 'holidays)

(defcustom calendar-mode-hook nil "\
Hook run when entering `calendar-mode'." :type 'hook :group 'calendar-hooks)

(defcustom calendar-load-hook nil "\
List of functions to be called after the calendar is first loaded.
This is the place to add key bindings to `calendar-mode-map'." :type 'hook :group 'calendar-hooks)

(defcustom initial-calendar-window-hook nil "\
List of functions to be called when the calendar window is first opened.
The functions invoked are called after the calendar window is opened, but
once opened is never called again.  Leaving the calendar with the `q' command
and reentering it will cause these functions to be called again." :type 'hook :group 'calendar-hooks)

(defcustom today-visible-calendar-hook nil "\
List of functions called whenever the current date is visible.
This can be used, for example, to replace today's date with asterisks; a
function `calendar-star-date' is included for this purpose:
    (setq today-visible-calendar-hook 'calendar-star-date)
It can also be used to mark the current date with `calendar-today-marker';
a function is also provided for this:
    (setq today-visible-calendar-hook 'calendar-mark-today)

The corresponding variable `today-invisible-calendar-hook' is the list of
functions called when the calendar function was called when the current
date is not visible in the window.

Other than the use of the provided functions, the changing of any
characters in the calendar buffer by the hooks may cause the failure of the
functions that move by days and weeks." :type 'hook :group 'calendar-hooks)

(defcustom today-invisible-calendar-hook nil "\
List of functions called whenever the current date is not visible.

The corresponding variable `today-visible-calendar-hook' is the list of
functions called when the calendar function was called when the current
date is visible in the window.

Other than the use of the provided functions, the changing of any
characters in the calendar buffer by the hooks may cause the failure of the
functions that move by days and weeks." :type 'hook :group 'calendar-hooks)

(defcustom calendar-move-hook nil "\
List of functions called whenever the cursor moves in the calendar.

For example,

  (add-hook 'calendar-move-hook (lambda () (diary-view-entries 1)))

redisplays the diary for whatever date the cursor is moved to." :type 'hook :group 'calendar-hooks)

(defcustom diary-file "~/diary" "\
Name of the file in which one's personal diary of dates is kept.

The file's entries are lines beginning with any of the forms
specified by the variable `american-date-diary-pattern', by default:

            MONTH/DAY
            MONTH/DAY/YEAR
            MONTHNAME DAY
            MONTHNAME DAY, YEAR
            DAYNAME

with the remainder of the line being the diary entry string for
that date.  MONTH and DAY are one or two digit numbers, YEAR is a
number and may be written in full or abbreviated to the final two
digits (if `abbreviated-calendar-year' is non-nil).  MONTHNAME
and DAYNAME can be spelled in full (as specified by the variables
`calendar-month-name-array' and `calendar-day-name-array'),
abbreviated (as specified by `calendar-month-abbrev-array' and
`calendar-day-abbrev-array') with or without a period,
capitalized or not.  Any of DAY, MONTH, or MONTHNAME, YEAR can be
`*' which matches any day, month, or year, respectively. If the
date does not contain a year, it is generic and applies to any
year.  A DAYNAME entry applies to the appropriate day of the week
in every week.

The European style (in which the day precedes the month) can be
used instead, if you execute `european-calendar' when in the
calendar, or set `european-calendar-style' to t in your .emacs
file.  The European forms (see `european-date-diary-pattern') are

            DAY/MONTH
            DAY/MONTH/YEAR
            DAY MONTHNAME
            DAY MONTHNAME YEAR
            DAYNAME

To revert to the default American style from the European style, execute
`american-calendar' in the calendar.

A diary entry can be preceded by the character
`diary-nonmarking-symbol' (ordinarily `&') to make that entry
nonmarking--that is, it will not be marked on dates in the calendar
window but will appear in a diary window.

Multiline diary entries are made by indenting lines after the first with
either a TAB or one or more spaces.

Lines not in one the above formats are ignored.  Here are some sample diary
entries (in the default American style):

     12/22/1988 Twentieth wedding anniversary!!
     &1/1. Happy New Year!
     10/22 Ruth's birthday.
     21: Payday
     Tuesday--weekly meeting with grad students at 10am
              Supowit, Shen, Bitner, and Kapoor to attend.
     1/13/89 Friday the thirteenth!!
     &thu 4pm squash game with Lloyd.
     mar 16 Dad's birthday
     April 15, 1989 Income tax due.
     &* 15 time cards due.

If the first line of a diary entry consists only of the date or day name with
no trailing blanks or punctuation, then that line is not displayed in the
diary window; only the continuation lines is shown.  For example, the
single diary entry

     02/11/1989
      Bill Blattner visits Princeton today
      2pm Cognitive Studies Committee meeting
      2:30-5:30 Lizzie at Lawrenceville for `Group Initiative'
      4:00pm Jamie Tappenden
      7:30pm Dinner at George and Ed's for Alan Ryan
      7:30-10:00pm dance at Stewart Country Day School

will appear in the diary window without the date line at the beginning.  This
facility allows the diary window to look neater, but can cause confusion if
used with more than one day's entries displayed.

Diary entries can be based on Lisp sexps.  For example, the diary entry

      %%(diary-block 11 1 1990 11 10 1990) Vacation

causes the diary entry \"Vacation\" to appear from November 1 through
November 10, 1990.  Other functions available are `diary-float',
`diary-anniversary', `diary-cyclic', `diary-day-of-year',
`diary-iso-date', `diary-french-date', `diary-hebrew-date',
`diary-islamic-date', `diary-bahai-date', `diary-mayan-date',
`diary-chinese-date', `diary-coptic-date', `diary-ethiopic-date',
`diary-persian-date', `diary-yahrzeit', `diary-sunrise-sunset',
`diary-phases-of-moon', `diary-parasha', `diary-omer',
`diary-rosh-hodesh', and `diary-sabbath-candles'.  See the
documentation for the function `list-sexp-diary-entries' for more
details.

Diary entries based on the Hebrew, the Islamic and/or the Baha'i
calendar are also possible, but because these are somewhat slow, they
are ignored unless you set the `nongregorian-diary-listing-hook' and
the `nongregorian-diary-marking-hook' appropriately.  See the
documentation for these functions for details.

Diary files can contain directives to include the contents of other files; for
details, see the documentation for the variable `list-diary-entries-hook'." :type 'file :group 'diary)

(defcustom diary-nonmarking-symbol "&" "\
Symbol indicating that a diary entry is not to be marked in the calendar." :type 'string :group 'diary)

(defcustom hebrew-diary-entry-symbol "H" "\
Symbol indicating a diary entry according to the Hebrew calendar." :type 'string :group 'diary)

(defcustom islamic-diary-entry-symbol "I" "\
Symbol indicating a diary entry according to the Islamic calendar." :type 'string :group 'diary)

(defcustom bahai-diary-entry-symbol "B" "\
Symbol indicating a diary entry according to the Baha'i calendar." :type 'string :group 'diary)

(defcustom diary-include-string "#include" "\
The string indicating inclusion of another file of diary entries.
See the documentation for the function `include-other-diary-files'." :type 'string :group 'diary)

(defcustom diary-glob-file-regexp-prefix "^\\#" "\
The regular expression that gets pre-pended to each of the attribute-regexp's for file-wide specifiers." :type 'regexp :group 'diary)

(defcustom diary-face-attrs '((" *\\[foreground:\\([-a-z]+\\)\\]$" 1 :foreground string) (" *\\[background:\\([-a-z]+\\)\\]$" 1 :background string) (" *\\[width:\\([-a-z]+\\)\\]$" 1 :width symbol) (" *\\[height:\\([-0-9a-z]+\\)\\]$" 1 :height int) (" *\\[weight:\\([-a-z]+\\)\\]$" 1 :weight symbol) (" *\\[slant:\\([-a-z]+\\)\\]$" 1 :slant symbol) (" *\\[underline:\\([-a-z]+\\)\\]$" 1 :underline tnil) (" *\\[overline:\\([-a-z]+\\)\\]$" 1 :overline stringtnil) (" *\\[strike-through:\\([-a-z]+\\)\\]$" 1 :strike-through stringtnil) (" *\\[inverse-video:\\([-a-z]+\\)\\]$" 1 :inverse-video tnil) (" *\\[face:\\([-0-9a-z]+\\)\\]$" 1 :face string) (" *\\[font:\\([-a-z0-9]+\\)\\]$" 1 :font string)) "\
A list of (regexp regnum attr attrtype) lists where the
regexp says how to find the tag, the regnum says which
parenthetical sub-regexp this regexp looks for, and the attr says
which attribute of the face (or that this _is_ a face) is being
modified." :type 'sexp :group 'diary)

(defcustom diary-file-name-prefix nil "\
If non-nil each diary entry is prefixed with the name of the file where it is defined." :type 'boolean :group 'diary)

(defcustom sexp-diary-entry-symbol "%%" "\
The string used to indicate a sexp diary entry in `diary-file'.
See the documentation for the function `list-sexp-diary-entries'." :type 'string :group 'diary)

(defcustom abbreviated-calendar-year t "\
Interpret a two-digit year DD in a diary entry as either 19DD or 20DD.
For the Gregorian calendar; similarly for the Hebrew, Islamic and
Baha'i calendars.  If this variable is nil, years must be written in
full." :type 'boolean :group 'diary)

(defcustom european-calendar-style nil "\
Use the European style of dates in the diary and in any displays.
If this variable is t, a date 1/2/1990 would be interpreted as February 1,
1990.  The default European date styles (see `european-date-diary-pattern')
are

            DAY/MONTH
            DAY/MONTH/YEAR
            DAY MONTHNAME
            DAY MONTHNAME YEAR
            DAYNAME

Names can be capitalized or not, written in full (as specified by the
variable `calendar-day-name-array'), or abbreviated (as specified by
`calendar-day-abbrev-array') with or without a period.

Setting this variable directly does not take effect (if the
calendar package is already loaded).  Rather, use either
\\[customize] or the functions `european-calendar' and
`american-calendar'." :type 'boolean :initialize 'custom-initialize-default :set (lambda (symbol value) (if value (european-calendar) (american-calendar))) :group 'diary)

(defcustom american-date-diary-pattern '((month "/" day "[^/0-9]") (month "/" day "/" year "[^0-9]") (monthname " *" day "[^,0-9]") (monthname " *" day ", *" year "[^0-9]") (dayname "\\W")) "\
List of pseudo-patterns describing the American patterns of date used.
See the documentation of `diary-date-forms' for an explanation." :type '(repeat (choice (cons :tag "Backup" :value (backup) (const backup) (repeat (list :inline t :format "%v" (symbol :tag "Keyword") (choice symbol regexp)))) (repeat (list :inline t :format "%v" (symbol :tag "Keyword") (choice symbol regexp))))) :group 'diary)

(defcustom european-date-diary-pattern '((day "/" month "[^/0-9]") (day "/" month "/" year "[^0-9]") (backup day " *" monthname "\\W+\\<\\([^*0-9]\\|\\([0-9]+[:aApP]\\)\\)") (day " *" monthname " *" year "[^0-9]") (dayname "\\W")) "\
List of pseudo-patterns describing the European patterns of date used.
See the documentation of `diary-date-forms' for an explanation." :type '(repeat (choice (cons :tag "Backup" :value (backup) (const backup) (repeat (list :inline t :format "%v" (symbol :tag "Keyword") (choice symbol regexp)))) (repeat (list :inline t :format "%v" (symbol :tag "Keyword") (choice symbol regexp))))) :group 'diary)

(defcustom diary-date-forms (if european-calendar-style european-date-diary-pattern american-date-diary-pattern) "\
List of pseudo-patterns describing the forms of date used in the diary.
The patterns on the list must be MUTUALLY EXCLUSIVE and should not match
any portion of the diary entry itself, just the date component.

A pseudo-pattern is a list of regular expressions and the keywords `month',
`day', `year', `monthname', and `dayname'.  The keyword `monthname' will
match the name of the month (see `calendar-month-name-array'), capitalized
or not, or its user-specified abbreviation (see `calendar-month-abbrev-array'),
followed by a period or not; it will also match `*'.  Similarly, `dayname'
will match the name of the day (see `calendar-day-name-array'), capitalized or
not, or its user-specified abbreviation (see `calendar-day-abbrev-array'),
followed by a period or not.  The keywords `month', `day', and `year' will
match those numerical values, preceded by arbitrarily many zeros; they will
also match `*'.

The matching of the diary entries with the date forms is done with the
standard syntax table from Fundamental mode, but with the `*' changed so
that it is a word constituent.

If, to be mutually exclusive, a pseudo-pattern must match a portion of the
diary entry itself, the first element of the pattern MUST be `backup'.  This
directive causes the date recognizer to back up to the beginning of the
current word of the diary entry, so in no case can the pattern match more than
a portion of the first word of the diary entry." :type '(repeat (choice (cons :tag "Backup" :value (backup) (const backup) (repeat (list :inline t :format "%v" (symbol :tag "Keyword") (choice symbol regexp)))) (repeat (list :inline t :format "%v" (symbol :tag "Keyword") (choice symbol regexp))))) :group 'diary)

(defcustom european-calendar-display-form '((if dayname (concat dayname ", ")) day " " monthname " " year) "\
Pseudo-pattern governing the way a date appears in the European style.
See the documentation of `calendar-date-display-form' for an explanation." :type 'sexp :group 'calendar)

(defcustom american-calendar-display-form '((if dayname (concat dayname ", ")) monthname " " day ", " year) "\
Pseudo-pattern governing the way a date appears in the American style.
See the documentation of `calendar-date-display-form' for an explanation." :type 'sexp :group 'calendar)

(defcustom calendar-date-display-form (if european-calendar-style european-calendar-display-form american-calendar-display-form) "\
Pseudo-pattern governing the way a date appears.

Used by the function `calendar-date-string', a pseudo-pattern is a list of
expressions that can involve the keywords `month', `day', and `year', all
numbers in string form, and `monthname' and `dayname', both alphabetic
strings.  For example, the ISO standard would use the pseudo- pattern

       '(year \"-\" month \"-\" day)

while a typical American form would be

       '(month \"/\" day \"/\" (substring year -2))

and

       '((format \"%9s, %9s %2s, %4s\" dayname monthname day year))

would give the usual American style in fixed-length fields.

See the documentation of the function `calendar-date-string'." :type 'sexp :group 'calendar)

(defcustom print-diary-entries-hook 'lpr-buffer "\
List of functions called after a temporary diary buffer is prepared.
The buffer shows only the diary entries currently visible in the diary
buffer.  The default just does the printing.  Other uses might include, for
example, rearranging the lines into order by day and time, saving the buffer
instead of deleting it, or changing the function used to do the printing." :type 'hook :group 'diary)

(defcustom list-diary-entries-hook nil "\
List of functions called after diary file is culled for relevant entries.
It is to be used for diary entries that are not found in the diary file.

A function `include-other-diary-files' is provided for use as the value of
this hook.  This function enables you to use shared diary files together
with your own.  The files included are specified in the diary file by lines
of the form

        #include \"filename\"

This is recursive; that is, #include directives in files thus included are
obeyed.  You can change the \"#include\" to some other string by changing
the variable `diary-include-string'.  When you use `include-other-diary-files'
as part of the list-diary-entries-hook, you will probably also want to use the
function `mark-included-diary-files' as part of `mark-diary-entries-hook'.

For example, you could use

     (setq list-diary-entries-hook
       '(include-other-diary-files sort-diary-entries))
     (setq diary-display-hook 'fancy-diary-display)

in your `.emacs' file to cause the fancy diary buffer to be displayed with
diary entries from various included files, each day's entries sorted into
lexicographic order." :type 'hook :options '(include-other-diary-files sort-diary-entries) :group 'diary)

(defcustom diary-hook nil "\
List of functions called after the display of the diary.
Can be used for appointment notification." :type 'hook :group 'diary)

(defcustom diary-display-hook nil "\
List of functions that handle the display of the diary.
If nil (the default), `simple-diary-display' is used.  Use `ignore' for no
diary display.

Ordinarily, this just displays the diary buffer (with holidays indicated in
the mode line), if there are any relevant entries.  At the time these
functions are called, the variable `diary-entries-list' is a list, in order
by date, of all relevant diary entries in the form of ((MONTH DAY YEAR)
STRING), where string is the diary entry for the given date.  This can be
used, for example, a different buffer for display (perhaps combined with
holidays), or produce hard copy output.

A function `fancy-diary-display' is provided as an alternative
choice for this hook; this function prepares a special noneditable diary
buffer with the relevant diary entries that has neat day-by-day arrangement
with headings.  The fancy diary buffer will show the holidays unless the
variable `holidays-in-diary-buffer' is set to nil.  Ordinarily, the fancy
diary buffer will not show days for which there are no diary entries, even
if that day is a holiday; if you want such days to be shown in the fancy
diary buffer, set the variable `diary-list-include-blanks' to t." :type 'hook :options '(fancy-diary-display) :initialize 'custom-initialize-default :set 'diary-set-maybe-redraw :group 'diary)

(defcustom nongregorian-diary-listing-hook nil "\
List of functions called for listing diary file and included files.
As the files are processed for diary entries, these functions are used
to cull relevant entries.  You can use either or both of
`list-hebrew-diary-entries', `list-islamic-diary-entries' and
`list-bahai-diary-entries'.  The documentation for these functions
describes the style of such diary entries." :type 'hook :options '(list-hebrew-diary-entries list-islamic-diary-entries list-bahai-diary-entries) :group 'diary)

(defcustom mark-diary-entries-hook nil "\
List of functions called after marking diary entries in the calendar.

A function `mark-included-diary-files' is also provided for use as the
`mark-diary-entries-hook'; it enables you to use shared diary files together
with your own.  The files included are specified in the diary file by lines
of the form
        #include \"filename\"
This is recursive; that is, #include directives in files thus included are
obeyed.  You can change the \"#include\" to some other string by changing the
variable `diary-include-string'.  When you use `mark-included-diary-files' as
part of the mark-diary-entries-hook, you will probably also want to use the
function `include-other-diary-files' as part of `list-diary-entries-hook'." :type 'hook :options '(mark-included-diary-files) :group 'diary)

(defcustom nongregorian-diary-marking-hook nil "\
List of functions called for marking diary file and included files.
As the files are processed for diary entries, these functions are used
to cull relevant entries.  You can use either or both of
`mark-hebrew-diary-entries', `mark-islamic-diary-entries' and
`mark-bahai-diary-entries'.  The documentation for these functions
describes the style of such diary entries." :type 'hook :options '(mark-hebrew-diary-entries mark-islamic-diary-entries mark-bahai-diary-entries) :group 'diary)

(defcustom diary-list-include-blanks nil "\
If nil, do not include days with no diary entry in the list of diary entries.
Such days will then not be shown in the fancy diary buffer, even if they
are holidays." :type 'boolean :group 'diary)

(defcustom holidays-in-diary-buffer t "\
Non-nil means include holidays in the diary display.
The holidays appear in the mode line of the diary buffer, or in the
fancy diary buffer next to the date.  This slows down the diary functions
somewhat; setting it to nil makes the diary display faster." :type 'boolean :group 'holidays)

(defcustom general-holidays '((holiday-fixed 1 1 "New Year's Day") (holiday-float 1 1 3 "Martin Luther King Day") (holiday-fixed 2 2 "Groundhog Day") (holiday-fixed 2 14 "Valentine's Day") (holiday-float 2 1 3 "President's Day") (holiday-fixed 3 17 "St. Patrick's Day") (holiday-fixed 4 1 "April Fools' Day") (holiday-float 5 0 2 "Mother's Day") (holiday-float 5 1 -1 "Memorial Day") (holiday-fixed 6 14 "Flag Day") (holiday-float 6 0 3 "Father's Day") (holiday-fixed 7 4 "Independence Day") (holiday-float 9 1 1 "Labor Day") (holiday-float 10 1 2 "Columbus Day") (holiday-fixed 10 31 "Halloween") (holiday-fixed 11 11 "Veteran's Day") (holiday-float 11 4 4 "Thanksgiving")) "\
General holidays.  Default value is for the United States.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom oriental-holidays '((if (fboundp 'atan) (holiday-chinese-new-year))) "\
Oriental holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom local-holidays nil "\
Local holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'local :group 'holidays)

(defcustom other-holidays nil "\
User defined holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom hebrew-holidays (append hebrew-holidays-1 hebrew-holidays-2 hebrew-holidays-3 hebrew-holidays-4) "\
Jewish holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom christian-holidays '((if all-christian-calendar-holidays (holiday-fixed 1 6 "Epiphany")) (holiday-easter-etc 0 "Easter Sunday") (holiday-easter-etc -2 "Good Friday") (holiday-easter-etc -46 "Ash Wednesday") (if all-christian-calendar-holidays (holiday-easter-etc -63 "Septuagesima Sunday")) (if all-christian-calendar-holidays (holiday-easter-etc -56 "Sexagesima Sunday")) (if all-christian-calendar-holidays (holiday-easter-etc -49 "Shrove Sunday")) (if all-christian-calendar-holidays (holiday-easter-etc -48 "Shrove Monday")) (if all-christian-calendar-holidays (holiday-easter-etc -47 "Shrove Tuesday")) (if all-christian-calendar-holidays (holiday-easter-etc -14 "Passion Sunday")) (if all-christian-calendar-holidays (holiday-easter-etc -7 "Palm Sunday")) (if all-christian-calendar-holidays (holiday-easter-etc -3 "Maundy Thursday")) (if all-christian-calendar-holidays (holiday-easter-etc 35 "Rogation Sunday")) (if all-christian-calendar-holidays (holiday-easter-etc 39 "Ascension Day")) (if all-christian-calendar-holidays (holiday-easter-etc 49 "Pentecost (Whitsunday)")) (if all-christian-calendar-holidays (holiday-easter-etc 50 "Whitmonday")) (if all-christian-calendar-holidays (holiday-easter-etc 56 "Trinity Sunday")) (if all-christian-calendar-holidays (holiday-easter-etc 60 "Corpus Christi")) (if all-christian-calendar-holidays (holiday-greek-orthodox-easter)) (if all-christian-calendar-holidays (holiday-fixed 8 15 "Assumption")) (if all-christian-calendar-holidays (holiday-advent 0 "Advent")) (holiday-fixed 12 25 "Christmas") (if all-christian-calendar-holidays (holiday-julian 12 25 "Eastern Orthodox Christmas"))) "\
Christian holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom islamic-holidays '((holiday-islamic 1 1 (format "Islamic New Year %d" (let ((m displayed-month) (y displayed-year)) (increment-calendar-month m y 1) (extract-calendar-year (calendar-islamic-from-absolute (calendar-absolute-from-gregorian (list m (calendar-last-day-of-month m y) y))))))) (if all-islamic-calendar-holidays (holiday-islamic 1 10 "Ashura")) (if all-islamic-calendar-holidays (holiday-islamic 3 12 "Mulad-al-Nabi")) (if all-islamic-calendar-holidays (holiday-islamic 7 26 "Shab-e-Mi'raj")) (if all-islamic-calendar-holidays (holiday-islamic 8 15 "Shab-e-Bara't")) (holiday-islamic 9 1 "Ramadan Begins") (if all-islamic-calendar-holidays (holiday-islamic 9 27 "Shab-e Qadr")) (if all-islamic-calendar-holidays (holiday-islamic 10 1 "Id-al-Fitr")) (if all-islamic-calendar-holidays (holiday-islamic 12 10 "Id-al-Adha"))) "\
Islamic holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom bahai-holidays '((holiday-fixed 3 21 (format "Baha'i New Year (Naw-Ruz) %d" (- displayed-year (1- 1844)))) (holiday-fixed 4 21 "First Day of Ridvan") (if all-bahai-calendar-holidays (holiday-fixed 4 22 "Second Day of Ridvan")) (if all-bahai-calendar-holidays (holiday-fixed 4 23 "Third Day of Ridvan")) (if all-bahai-calendar-holidays (holiday-fixed 4 24 "Fourth Day of Ridvan")) (if all-bahai-calendar-holidays (holiday-fixed 4 25 "Fifth Day of Ridvan")) (if all-bahai-calendar-holidays (holiday-fixed 4 26 "Sixth Day of Ridvan")) (if all-bahai-calendar-holidays (holiday-fixed 4 27 "Seventh Day of Ridvan")) (if all-bahai-calendar-holidays (holiday-fixed 4 28 "Eighth Day of Ridvan")) (holiday-fixed 4 29 "Ninth Day of Ridvan") (if all-bahai-calendar-holidays (holiday-fixed 4 30 "Tenth Day of Ridvan")) (if all-bahai-calendar-holidays (holiday-fixed 5 1 "Eleventh Day of Ridvan")) (holiday-fixed 5 2 "Twelfth Day of Ridvan") (holiday-fixed 5 23 "Declaration of the Bab") (holiday-fixed 5 29 "Ascension of Baha'u'llah") (holiday-fixed 7 9 "Martyrdom of the Bab") (holiday-fixed 10 20 "Birth of the Bab") (holiday-fixed 11 12 "Birth of Baha'u'llah") (if all-bahai-calendar-holidays (holiday-fixed 11 26 "Day of the Covenant")) (if all-bahai-calendar-holidays (holiday-fixed 11 28 "Ascension of `Abdu'l-Baha"))) "\
Baha'i holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom solar-holidays '((if (fboundp 'atan) (solar-equinoxes-solstices)) (if (progn (require 'cal-dst) t) (funcall 'holiday-sexp calendar-daylight-savings-starts '(format "Daylight Saving Time Begins %s" (if (fboundp 'atan) (solar-time-string (/ calendar-daylight-savings-starts-time (float 60)) calendar-standard-time-zone-name) "")))) (funcall 'holiday-sexp calendar-daylight-savings-ends '(format "Daylight Saving Time Ends %s" (if (fboundp 'atan) (solar-time-string (/ calendar-daylight-savings-ends-time (float 60)) calendar-daylight-time-zone-name) "")))) "\
Sun-related holidays.
See the documentation for `calendar-holidays' for details." :type 'sexp :group 'holidays)

(defcustom calendar-holidays (append general-holidays local-holidays other-holidays christian-holidays hebrew-holidays islamic-holidays bahai-holidays oriental-holidays solar-holidays) "\
List of notable days for the command \\[holidays].

Additional holidays are easy to add to the list, just put them in the
list `other-holidays' in your .emacs file.  Similarly, by setting any
of `general-holidays', `local-holidays' `christian-holidays',
`hebrew-holidays', `islamic-holidays', `bahai-holidays',
`oriental-holidays', or `solar-holidays' to nil in your .emacs file,
you can eliminate unwanted categories of holidays.

The aforementioned variables control the holiday choices offered
by the function `list-holidays' when it is called interactively.

They also initialize the default value of `calendar-holidays',
which is the default list of holidays used by the function
`list-holidays' in the non-interactive case.  Note that these
variables have no effect on `calendar-holidays' after it has been
set (e.g. after the calendar is loaded).  In that case, customize
`calendar-holidays' directly.

The intention is that (in the US) `local-holidays' be set in
site-init.el and `other-holidays' be set by the user.

Entries on the list are expressions that return (possibly empty) lists of
items of the form ((month day year) string) of a holiday in the in the
three-month period centered around `displayed-month' of `displayed-year'.
Several basic functions are provided for this purpose:

    (holiday-fixed MONTH DAY STRING) is a fixed date on the Gregorian calendar
    (holiday-float MONTH DAYNAME K STRING &optional day) is the Kth DAYNAME in
                               MONTH on the Gregorian calendar (0 for Sunday,
                               etc.); K<0 means count back from the end of the
                               month.  An optional parameter DAY means the Kth
                               DAYNAME after/before MONTH DAY.
    (holiday-hebrew MONTH DAY STRING)  a fixed date on the Hebrew calendar
    (holiday-islamic MONTH DAY STRING) a fixed date on the Islamic calendar
    (holiday-bahai MONTH DAY STRING)   a fixed date on the Baha'i calendar
    (holiday-julian MONTH DAY STRING)  a fixed date on the Julian calendar
    (holiday-sexp SEXP STRING) SEXP is a Gregorian-date-valued expression
                               in the variable `year'; if it evaluates to
                               a visible date, that's the holiday; if it
                               evaluates to nil, there's no holiday.  STRING
                               is an expression in the variable `date'.

For example, to add Bastille Day, celebrated in France on July 14, add

     (holiday-fixed 7 14 \"Bastille Day\")

to the list.  To add Hurricane Supplication Day, celebrated in the Virgin
Islands on the fourth Monday in August, add

     (holiday-float 8 1 4 \"Hurricane Supplication Day\")

to the list (the last Monday would be specified with `-1' instead of `4').
To add the last day of Hanukkah to the list, use

     (holiday-hebrew 10 2 \"Last day of Hanukkah\")

since the Hebrew months are numbered with 1 starting from Nisan, while to
add the Islamic feast celebrating Mohammed's birthday use

     (holiday-islamic 3 12 \"Mohammed's Birthday\")

since the Islamic months are numbered from 1 starting with Muharram.  To
add an entry for the Baha'i festival of Ridvan, use

     (holiday-bahai 2 13 \"Festival of Ridvan\")

since the Baha'i months are numbered from 1 starting with Baha.  To
add Thomas Jefferson's birthday, April 2, 1743 (Julian), use

     (holiday-julian 4 2 \"Jefferson's Birthday\")

To include a holiday conditionally, use the sexp form or a conditional.  For
example, to include American presidential elections, which occur on the first
Tuesday after the first Monday in November of years divisible by 4, add

     (holiday-sexp
       '(if (zerop (% year 4))
           (calendar-gregorian-from-absolute
             (1+ (calendar-dayname-on-or-before
                   1 (+ 6 (calendar-absolute-from-gregorian
                            (list 11 1 year)))))))
       \"US Presidential Election\")

or

     (if (zerop (% displayed-year 4))
         (holiday-fixed 11
                (extract-calendar-day
                 (calendar-gregorian-from-absolute
                  (1+ (calendar-dayname-on-or-before
                       1 (+ 6 (calendar-absolute-from-gregorian
                               (list 11 1 displayed-year)))))))
                \"US Presidential Election\"))

to the list.  To include the phases of the moon, add

     (lunar-phases)

to the holiday list, where `lunar-phases' is an Emacs-Lisp function that
you've written to return a (possibly empty) list of the relevant VISIBLE dates
with descriptive strings such as

     (((2 6 1989) \"New Moon\") ((2 12 1989) \"First Quarter Moon\") ... )." :type 'sexp :group 'holidays)

(defcustom calendar-setup nil "\
The frame setup of the calendar.
The choices are: `one-frame' (calendar and diary together in one separate,
dedicated frame); `two-frames' (calendar and diary in separate, dedicated
frames); `calendar-only' (calendar in a separate, dedicated frame); with
any other value the current frame is used.  Using any of the first
three options overrides the value of `view-diary-entries-initially'." :type '(choice (const :tag "calendar and diary in separate frame" one-frame) (const :tag "calendar and diary each in own frame" two-frames) (const :tag "calendar in separate frame" calendar-only) (const :tag "use current frame" nil)) :group 'calendar)

(defcustom calendar-minimum-window-height 8 "\
Minimum height `generate-calendar-window' should use for calendar window." :type 'integer :version "22.1" :group 'calendar)

(defcustom calendar-week-start-day 0 "\
The day of the week on which a week in the calendar begins.
0 means Sunday (default), 1 means Monday, and so on.

If you change this variable directly (without using customize)
after starting `calendar', you should call `redraw-calendar' to
update the calendar display to reflect the change, otherwise
movement commands will not work correctly." :type 'integer :set (lambda (sym val) (set sym val) (let ((buffer (get-buffer calendar-buffer))) (when (buffer-live-p buffer) (with-current-buffer buffer (redraw-calendar))))) :group 'calendar)

(defcustom calendar-debug-sexp nil "\
Turn debugging on when evaluating a sexp in the diary or holiday list." :type 'boolean :group 'calendar)

;;;***

;;;### (autoloads (diary-outlook-formats diary-remind-message diary-unknown-time diary-mail-days diary-mail-addr number-of-diary-entries diary-header-line-format diary-header-line-flag) "diary-lib" "calendar/diary-lib.el")
(defconst custom-define-current-source-file "diary-lib.el")

(defcustom diary-header-line-flag t "\
If non-nil, `simple-diary-display' will show a header line.
The format of the header is specified by `diary-header-line-format'." :group 'diary :type 'boolean :initialize 'custom-initialize-default :set 'diary-set-maybe-redraw :version "22.1")

(defcustom diary-header-line-format '(:eval (calendar-string-spread (list (if diary-selective-display "Selective display active - press \"s\" in calendar before edit/copy" "Diary")) ?s (frame-width))) "\
Format of the header line displayed by `simple-diary-display'.
Only used if `diary-header-line-flag' is non-nil." :group 'diary :type 'sexp :version "22.1")

(defcustom number-of-diary-entries 1 "\
Specifies how many days of diary entries are to be displayed initially.
This variable affects the diary display when the command \\[diary] is used,
or if the value of the variable `view-diary-entries-initially' is t.  For
example, if the default value 1 is used, then only the current day's diary
entries will be displayed.  If the value 2 is used, then both the current
day's and the next day's entries will be displayed.

The value can also be a vector such as [0 2 2 2 2 4 1]; this value
says to display no diary entries on Sunday, the entries for
the current date and the day after on Monday through Thursday,
Friday through Monday's entries on Friday, and only Saturday's
entries on Saturday.

This variable does not affect the diary display with the `d' command
from the calendar; in that case, the prefix argument controls the
number of days of diary entries displayed." :type '(choice (integer :tag "Entries") (vector :value [0 0 0 0 0 0 0] (integer :tag "Sunday") (integer :tag "Monday") (integer :tag "Tuesday") (integer :tag "Wednesday") (integer :tag "Thursday") (integer :tag "Friday") (integer :tag "Saturday"))) :initialize 'custom-initialize-default :set 'diary-set-maybe-redraw :group 'diary)

(defcustom diary-mail-addr (if (boundp 'user-mail-address) user-mail-address "") "\
Email address that `diary-mail-entries' will send email to." :group 'diary :type 'string :version "20.3")

(defcustom diary-mail-days 7 "\
Default number of days for `diary-mail-entries' to check." :group 'diary :type 'integer :version "20.3")

(defcustom diary-unknown-time -9999 "\
Value returned by diary-entry-time when no time is found.
The default value -9999 causes entries with no recognizable time to be placed
before those with times; 9999 would place entries with no recognizable time
after those with times." :type 'integer :group 'diary :version "20.3")

(defcustom diary-remind-message '("Reminder: Only " (if (= 0 (% days 7)) (concat (int-to-string (/ days 7)) (if (= 7 days) " week" " weeks")) (concat (int-to-string days) (if (= 1 days) " day" " days"))) " until " diary-entry) "\
Pseudo-pattern giving form of reminder messages in the fancy diary
display.

Used by the function `diary-remind', a pseudo-pattern is a list of
expressions that can involve the keywords `days' (a number), `date' (a list of
month, day, year), and `diary-entry' (a string)." :type 'sexp :group 'diary)

(defcustom diary-outlook-formats '(("When: \\([0-9]+ [[:alpha:]]+ [0-9]+\\) \\([^ ]+\\) [^\n]+\n[^\n]+\n\\(?:Where: \\([^\n]+\\)\n+\\)?\n\\*~\\*~\\*~\\*~\\*~\\*~\\*~\\*~\\*~\\*" . "\\1\n \\2 %s, \\3") ("^When: [[:alpha:]]+, \\([[:alpha:]]+\\) \\([0-9][0-9]*\\), \\([0-9]\\{4\\}\\) \\([^ ]+\\) [^\n]+\n[^\n]+\n\\(?:Where: \\([^\n]+\\)\\)?\n+" . "\\2 \\1 \\3\n \\4 %s, \\5") ("^Zeit: [^ ]+, +\\([0-9]+\\). +\\([[:upper:]][[:lower:]][[:lower:]]\\)[^ ]* +\\([0-9]+\\) +\\([^ ]+\\).*$" . "\\1 \\2 \\3\n \\4 %s")) "\
Alist of regexps matching message text and replacement text.

The regexp must match the start of the message text containing an
appointment, but need not include a leading `^'.  If it matches the
current message, a diary entry is made from the corresponding
template.  If the template is a string, it should be suitable for
passing to `replace-match', and so will have occurrences of `\\D' to
substitute the match for the Dth subexpression.  It must also contain
a single `%s' which will be replaced with the text of the message's
Subject field.  Any other `%' characters must be doubled, so that the
template can be passed to `format'.

If the template is actually a function, it is called with the message
body text as argument, and may use `match-string' etc. to make a
template following the rules above." :type '(alist :key-type (regexp :tag "Regexp matching time/place") :value-type (choice (string :tag "Template for entry") (function :tag "Unary function providing template"))) :version "22.1" :group 'diary)

;;;***

;;;### (autoloads (icalendar-import-format-class icalendar-import-format-status icalendar-import-format-url icalendar-import-format-organizer icalendar-import-format-location icalendar-import-format-description icalendar-import-format-summary icalendar-import-format icalendar) "icalendar" "calendar/icalendar.el")
(defconst custom-define-current-source-file "icalendar.el")

(defgroup icalendar nil "Icalendar support." :prefix "icalendar-" :group 'calendar)

(defcustom icalendar-import-format "%s%d%l%o" "\
Format string for importing events from iCalendar into Emacs diary.
This string defines how iCalendar events are inserted into diary
file.  Meaning of the specifiers:
%c Class, see `icalendar-import-format-class'
%d Description, see `icalendar-import-format-description'
%l Location, see `icalendar-import-format-location'
%o Organizer, see `icalendar-import-format-organizer'
%s Summary, see `icalendar-import-format-summary'
%t Status, see `icalendar-import-format-status'
%u URL, see `icalendar-import-format-url'" :type 'string :group 'icalendar)

(defcustom icalendar-import-format-summary "%s" "\
Format string defining how the summary element is formatted.
This applies only if the summary is not empty! `%s' is replaced
by the summary." :type 'string :group 'icalendar)

(defcustom icalendar-import-format-description "\n Desc: %s" "\
Format string defining how the description element is formatted.
This applies only if the description is not empty! `%s' is
replaced by the description." :type 'string :group 'icalendar)

(defcustom icalendar-import-format-location "\n Location: %s" "\
Format string defining how the location element is formatted.
This applies only if the location is not empty! `%s' is replaced
by the location." :type 'string :group 'icalendar)

(defcustom icalendar-import-format-organizer "\n Organizer: %s" "\
Format string defining how the organizer element is formatted.
This applies only if the organizer is not empty! `%s' is
replaced by the organizer." :type 'string :group 'icalendar)

(defcustom icalendar-import-format-url "\n URL: %s" "\
Format string defining how the URL element is formatted.
This applies only if the URL is not empty! `%s' is replaced by
the URL." :type 'string :group 'icalendar)

(defcustom icalendar-import-format-status "\n Status: %s" "\
Format string defining how the status element is formatted.
This applies only if the status is not empty! `%s' is replaced by
the status." :type 'string :group 'icalendar)

(defcustom icalendar-import-format-class "\n Class: %s" "\
Format string defining how the class element is formatted.
This applies only if the class is not empty! `%s' is replaced by
the class." :type 'string :group 'icalendar)

;;;***

;;;### (autoloads (diary-sabbath-candles-minutes solar-error calendar-location-name calendar-longitude calendar-latitude calendar-time-display-form) "solar" "calendar/solar.el")
(defconst custom-define-current-source-file "solar.el")

(defcustom calendar-time-display-form '(12-hours ":" minutes am-pm (if time-zone " (") time-zone (if time-zone ")")) "\
*The pseudo-pattern that governs the way a time of day is formatted.

A pseudo-pattern is a list of expressions that can involve the keywords
`12-hours', `24-hours', and `minutes', all numbers in string form,
and `am-pm' and `time-zone', both alphabetic strings.

For example, the form

  '(24-hours \":\" minutes
    (if time-zone \" (\") time-zone (if time-zone \")\"))

would give military-style times like `21:07 (UTC)'." :type 'sexp :group 'calendar)

(defcustom calendar-latitude nil "\
*Latitude of `calendar-location-name' in degrees.

The value can be either a decimal fraction (one place of accuracy is
sufficient), + north, - south, such as 40.7 for New York City, or the value
can be a vector [degrees minutes north/south] such as [40 50 north] for New
York City.

This variable should be set in `site-start'.el." :type '(choice (const nil) (number :tag "Exact") (vector :value [0 0 north] (integer :tag "Degrees") (integer :tag "Minutes") (choice :tag "Position" (const north) (const south)))) :group 'calendar)

(defcustom calendar-longitude nil "\
*Longitude of `calendar-location-name' in degrees.

The value can be either a decimal fraction (one place of accuracy is
sufficient), + east, - west, such as -73.9 for New York City, or the value
can be a vector [degrees minutes east/west] such as [73 55 west] for New
York City.

This variable should be set in `site-start'.el." :type '(choice (const nil) (number :tag "Exact") (vector :value [0 0 west] (integer :tag "Degrees") (integer :tag "Minutes") (choice :tag "Position" (const east) (const west)))) :group 'calendar)

(defcustom calendar-location-name '(let ((float-output-format "%.1f")) (format "%s%s, %s%s" (if (numberp calendar-latitude) (abs calendar-latitude) (+ (aref calendar-latitude 0) (/ (aref calendar-latitude 1) 60.0))) (if (numberp calendar-latitude) (if (> calendar-latitude 0) "N" "S") (if (equal (aref calendar-latitude 2) 'north) "N" "S")) (if (numberp calendar-longitude) (abs calendar-longitude) (+ (aref calendar-longitude 0) (/ (aref calendar-longitude 1) 60.0))) (if (numberp calendar-longitude) (if (> calendar-longitude 0) "E" "W") (if (equal (aref calendar-longitude 2) 'east) "E" "W")))) "\
*Expression evaluating to name of `calendar-longitude', `calendar-latitude'.
For example, \"New York City\".  Default value is just the latitude, longitude
pair.

This variable should be set in `site-start'.el." :type 'sexp :group 'calendar)

(defcustom solar-error 0.5 "\
*Tolerance (in minutes) for sunrise/sunset calculations.

A larger value makes the calculations for sunrise/sunset faster, but less
accurate.  The default is half a minute (30 seconds), so that sunrise/sunset
times will be correct to the minute.

It is useless to set the value smaller than 4*delta, where delta is the
accuracy in the longitude of the sun (given by the function
`solar-ecliptic-coordinates') in degrees since (delta/360) x (86400/60) = 4 x
delta.  At present, delta = 0.01 degrees, so the value of the variable
`solar-error' should be at least 0.04 minutes (about 2.5 seconds)." :type 'number :group 'calendar)

(defcustom diary-sabbath-candles-minutes 18 "\
*Number of minutes before sunset for sabbath candle lighting." :group 'diary :type 'integer :version "21.1")

;;;***

;;;### (autoloads (timeclock-modeline-display timeclock-event-hook timeclock-done-hook timeclock-out-hook timeclock-day-over-hook timeclock-in-hook timeclock-load-hook timeclock-first-in-hook timeclock-use-display-time timeclock-use-history timeclock-ask-before-exiting timeclock-get-workday-function timeclock-get-reason-function timeclock-get-project-function timeclock-relative timeclock-workday timeclock-file timeclock) "timeclock" "calendar/timeclock.el")
(defconst custom-define-current-source-file "timeclock.el")

(defgroup timeclock nil "Keeping track of the time that gets spent." :group 'data)

(defcustom timeclock-file (convert-standard-filename "~/.timelog") "\
*The file used to store timeclock data in." :type 'file :group 'timeclock)

(defcustom timeclock-workday (* 8 60 60) "\
*The length of a work period." :type 'integer :group 'timeclock)

(defcustom timeclock-relative t "\
*Whether to make reported time relative to `timeclock-workday'.
For example, if the length of a normal workday is eight hours, and you
work four hours on Monday, then the amount of time \"remaining\" on
Tuesday is twelve hours -- relative to an averaged work period of
eight hours -- or eight hours, non-relative.  So relative time takes
into account any discrepancy of time under-worked or over-worked on
previous days.  This only affects the timeclock modeline display." :type 'boolean :group 'timeclock)

(defcustom timeclock-get-project-function 'timeclock-ask-for-project "\
*The function used to determine the name of the current project.
When clocking in, and no project is specified, this function will be
called to determine what is the current project to be worked on.
If this variable is nil, no questions will be asked." :type 'function :group 'timeclock)

(defcustom timeclock-get-reason-function 'timeclock-ask-for-reason "\
*A function used to determine the reason for clocking out.
When clocking out, and no reason is specified, this function will be
called to determine what is the reason.
If this variable is nil, no questions will be asked." :type 'function :group 'timeclock)

(defcustom timeclock-get-workday-function nil "\
*A function used to determine the length of today's workday.
The first time that a user clocks in each day, this function will be
called to determine what is the length of the current workday.  If
the return value is nil, or equal to `timeclock-workday', nothing special
will be done.  If it is a quantity different from `timeclock-workday',
however, a record will be output to the timelog file to note the fact that
that day has a length that is different from the norm." :type '(choice (const nil) function) :group 'timeclock)

(defcustom timeclock-ask-before-exiting t "\
*If non-nil, ask if the user wants to clock out before exiting Emacs.
This variable only has effect if set with \\[customize]." :set (lambda (symbol value) (if value (add-hook 'kill-emacs-query-functions 'timeclock-query-out) (remove-hook 'kill-emacs-query-functions 'timeclock-query-out)) (setq timeclock-ask-before-exiting value)) :type 'boolean :group 'timeclock)

(defcustom timeclock-use-history nil "\
*If non-nil, user is prompted for timestamp, previous values are
available via history mechanism.

\\{minibuffer-local-map}.

This variable only has effect if set with \\[customize]." :type 'boolean :group 'timeclock)

(defcustom timeclock-use-display-time t "\
*If non-nil, use `display-time-hook' for doing modeline updates.
The advantage of this is that one less timer has to be set running
amok in Emacs' process space.  The disadvantage is that it requires
you to have `display-time' running.  If you don't want to use
`display-time', but still want the modeline to show how much time is
left, set this variable to nil.  Changing the value of this variable
while timeclock information is being displayed in the modeline has no
effect.  You should call the function `timeclock-modeline-display' with
a positive argument to force an update." :set (lambda (symbol value) (let ((currently-displaying (and (boundp 'timeclock-modeline-display) timeclock-modeline-display))) (if (and currently-displaying (or (and value (boundp 'display-time-hook) (memq 'timeclock-update-modeline display-time-hook)) (and (not value) timeclock-update-timer))) (setq currently-displaying nil)) (and currently-displaying (set-variable 'timeclock-modeline-display nil)) (setq timeclock-use-display-time value) (and currently-displaying (set-variable 'timeclock-modeline-display t)) timeclock-use-display-time)) :type 'boolean :group 'timeclock :require 'time)

(defcustom timeclock-first-in-hook nil "\
*A hook run for the first \"in\" event each day.
Note that this hook is run before recording any events.  Thus the
value of `timeclock-hours-today', `timeclock-last-event' and the
return value of function `timeclock-last-period' are relative previous
to today." :type 'hook :group 'timeclock)

(defcustom timeclock-load-hook nil "\
*Hook that gets run after timeclock has been loaded." :type 'hook :group 'timeclock)

(defcustom timeclock-in-hook nil "\
*A hook run every time an \"in\" event is recorded." :type 'hook :group 'timeclock)

(defcustom timeclock-day-over-hook nil "\
*A hook that is run when the workday has been completed.
This hook is only run if the current time remaining is being displayed
in the modeline.  See the variable `timeclock-modeline-display'." :type 'hook :group 'timeclock)

(defcustom timeclock-out-hook nil "\
*A hook run every time an \"out\" event is recorded." :type 'hook :group 'timeclock)

(defcustom timeclock-done-hook nil "\
*A hook run every time a project is marked as completed." :type 'hook :group 'timeclock)

(defcustom timeclock-event-hook nil "\
*A hook run every time any event is recorded." :type 'hook :group 'timeclock)

(defcustom timeclock-modeline-display nil "\
Toggle modeline display of time remaining.
You must modify via \\[customize] for this variable to have an effect." :set (lambda (symbol value) (setq timeclock-modeline-display (timeclock-modeline-display (or value 0)))) :type 'boolean :group 'timeclock :require 'timeclock)

;;;***

;;;### (autoloads (todo-initials todo-entry-prefix-function todo-time-string-format todo-save-top-priorities-too todo-remove-separator todo-print-priorities todo-show-priorities todo-print-function todo-file-top todo-insert-threshold todo-edit-mode-hook todo-mode-hook todo-file-done todo-file-do todo-prefix todo) "todo-mode" "calendar/todo-mode.el")
(defconst custom-define-current-source-file "todo-mode.el")

(defgroup todo nil "Maintain a list of todo items." :link '(emacs-commentary-link "todo-mode") :version "21.1" :group 'calendar)

(defcustom todo-prefix "*/*" "\
*TODO mode prefix for entries.

This is useful in conjunction with `calendar' and `diary' if you use

#include \"~/.todo-do\"

in your diary file to include your todo list file as part of your
diary.  With the default value \"*/*\" the diary displays each entry
every day and it may also be marked on every day of the calendar.
Using \"&%%(equal (calendar-current-date) date)\" instead will only
show and mark todo entreis for today, but may slow down processing of
the diary file somewhat." :type 'string :group 'todo)

(defcustom todo-file-do "~/.todo-do" "\
*TODO mode list file." :type 'file :group 'todo)

(defcustom todo-file-done "~/.todo-done" "\
*TODO mode archive file." :type 'file :group 'todo)

(defcustom todo-mode-hook nil "\
*TODO mode hooks." :type 'hook :group 'todo)

(defcustom todo-edit-mode-hook nil "\
*TODO Edit mode hooks." :type 'hook :group 'todo)

(defcustom todo-insert-threshold 0 "\
*TODO mode insertion accuracy.

If you have 8 items in your TODO list, then you may get asked 4
questions by the binary insertion algorithm.  However, you may not
really have a need for such accurate priorities amongst your TODO
items.  If you now think about the binary insertion halfing the size
of the window each time, then the threshhold is the window size at
which it will stop.  If you set the threshhold to zero, the upper and
lower bound will coincide at the end of the loop and you will insert
your item just before that point.  If you set the threshhold to,
e.g. 8, it will stop as soon as the window size drops below that
amount and will insert the item in the approximate center of that
window." :type 'integer :group 'todo)

(defcustom todo-file-top "~/.todo-top" "\
*TODO mode top priorities file.

Not in TODO format, but diary compatible.
Automatically generated when `todo-save-top-priorities' is non-nil." :type 'string :group 'todo)

(defcustom todo-print-function 'ps-print-buffer-with-faces "\
*Function to print the current buffer." :type 'symbol :group 'todo)

(defcustom todo-show-priorities 1 "\
*Default number of priorities to show by \\[todo-top-priorities].
0 means show all entries." :type 'integer :group 'todo)

(defcustom todo-print-priorities 0 "\
*Default number of priorities to print by \\[todo-print].
0 means print all entries." :type 'integer :group 'todo)

(defcustom todo-remove-separator t "\
*Non-nil to remove category separators in\\[todo-top-priorities] and \\[todo-print]." :type 'boolean :group 'todo)

(defcustom todo-save-top-priorities-too t "\
*Non-nil makes `todo-save' automatically save top-priorities in `todo-file-top'." :type 'boolean :group 'todo)

(defcustom todo-time-string-format "%:y-%02m-%02d %02H:%02M" "\
*TODO mode time string format for done entries.
For details see the variable `time-stamp-format'." :type 'string :group 'todo)

(defcustom todo-entry-prefix-function 'todo-entry-timestamp-initials "\
*Function producing text to insert at start of todo entry." :type 'symbol :group 'todo)

(defcustom todo-initials (or (getenv "INITIALS") (user-login-name)) "\
*Initials of todo item author." :type 'string :group 'todo)

;;;***

(provide 'calendar-custom-defines)
