;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'cc-mode-custom-defines) (error "Feature cc-mode-custom-defines already loaded"))

;;;### (autoloads (c-guess-region-max c-guess-offset-threshold) "cc-guess" "cc-mode/cc-guess.el")
(defconst custom-define-current-source-file "cc-guess.el")

(defcustom c-guess-offset-threshold 10 "\
Threshold of acceptable offsets when examining indent information.
Discard an examined offset if its absolute value is greater than this.

The offset of a line included in the indent information returned by
`c-guess-basic-syntax'." :type 'integer :group 'c)

(defcustom c-guess-region-max 50000 "\
The maximum region size for examining indent information with `c-guess'.
It takes a long time to examine indent information from a large region;
this option helps you limit that time. `nil' means no limit." :type 'integer :group 'c)

;;;***

;;;### (autoloads (pike-font-lock-extra-types idl-font-lock-extra-types java-font-lock-extra-types objc-font-lock-extra-types c++-font-lock-extra-types c-font-lock-extra-types c-enable-xemacs-performance-kludge-p c-initialization-hook c-mode-common-hook awk-mode-hook pike-mode-hook idl-mode-hook java-mode-hook objc-mode-hook c++-mode-hook c-mode-hook c-style-variables-are-local-p c-offsets-alist c-default-style c-objc-method-parameter-offset c-objc-method-arg-unfinished-offset c-objc-method-arg-min-delta-to-bracket c-progress-interval c-special-indent-hook c-electric-pound-behavior c-require-final-newline c-delete-function c-backspace-function c-auto-align-backslashes c-max-one-liner-length c-ignore-auto-fill c-defun-tactic c-syntactic-indentation-in-macros c-syntactic-indentation c-insert-tab-function c-tab-always-indent c-report-syntactic-errors c-echo-syntactic-information-p c-strict-syntax-p) "cc-vars" "cc-mode/cc-vars.el")
(defconst custom-define-current-source-file "cc-vars.el")

(defcustom c-strict-syntax-p nil "\
*If non-nil, all syntactic symbols must be found in `c-offsets-alist'.
If the syntactic symbol for a particular line does not match a symbol
in the offsets alist, or if no non-nil offset value can be determined
for a symbol, an error is generated, otherwise no error is reported
and the syntactic symbol is ignored.

This variable is considered obsolete; it doesn't work well with lineup
functions that return nil to support the feature of using lists on
syntactic symbols in `c-offsets-alist'.  Please keep it set to nil." :type 'boolean :group 'c)

(defcustom c-echo-syntactic-information-p nil "\
*If non-nil, syntactic info is echoed when the line is indented." :type 'boolean :group 'c)

(defcustom c-report-syntactic-errors nil "\
*If non-nil, certain syntactic errors are reported with a ding
and a message, for example when an \"else\" is indented for which
there's no corresponding \"if\".

Note however that CC Mode doesn't make any special effort to check for
syntactic errors; that's the job of the compiler.  The reason it can
report cases like the one above is that it can't find the correct
anchoring position to indent the line in that case." :type 'boolean :group 'c)

(defcustom c-tab-always-indent t "\
*Controls the operation of the TAB key.
If t, hitting TAB always just indents the current line.  If nil, hitting
TAB indents the current line if point is at the left margin or in the
line's indentation, otherwise it inserts a `real' tab character (see
note).  If some other value (not nil or t), then tab is inserted only
within literals (comments and strings), but the line is always
reindented.

Note: The value of `indent-tabs-mode' will determine whether a real
tab character will be inserted, or the equivalent number of spaces.
When inserting a tab, actually the function stored in the variable
`c-insert-tab-function' is called.

Note: indentation of lines containing only comments is also controlled
by the `c-comment-only-line-offset' variable." :type '(radio (const :tag "TAB key always indents, never inserts TAB" t) (const :tag "TAB key indents in left margin, otherwise inserts TAB" nil) (other :tag "TAB key inserts TAB in literals, otherwise indents" other)) :group 'c)

(defcustom c-insert-tab-function 'insert-tab "\
*Function used when inserting a tab for \\[c-indent-command].
Only used when `c-tab-always-indent' indicates a `real' tab character
should be inserted.  Value must be a function taking no arguments." :type 'function :group 'c)

(defcustom c-syntactic-indentation t "\
*Whether the indentation should be controlled by the syntactic context.

If t, the indentation functions indent according to the syntactic
context, using the style settings specified by `c-offsets-alist'.

If nil, every line is just indented to the same level as the previous
one, and the \\[c-indent-command] command adjusts the indentation in
steps specified by `c-basic-offset'.  The indentation style has no
effect in this mode, nor any of the indentation associated variables,
e.g. `c-special-indent-hook'." :type 'boolean :group 'c)

(defcustom c-syntactic-indentation-in-macros t "\
*Enable syntactic analysis inside macros.
If this is nil, all lines inside macro definitions are analyzed as
`cpp-macro-cont'.  Otherwise they are analyzed syntactically, just
like normal code, and `cpp-define-intro' is used to create the
additional indentation of the bodies of \"#define\" macros.

Having this enabled simplifies editing of large multiline macros, but
it might complicate editing if CC Mode doesn't recognize the context
of the macro content.  The default context inside the macro is the
same as the top level, so if it contains \"bare\" statements they
might be indented wrongly, although there are special cases that
handle this in most cases.  If this problem occurs, it's usually
countered easily by surrounding the statements by a block (or even
better with the \"do { ... } while (0)\" trick)." :type 'boolean :group 'c)

(defcustom c-defun-tactic 'go-outward "\
*Whether functions are recognized inside, e.g., a class.
This is used by `c-beginning-of-defun' and like functions.

Its value is one of:
 t           -- Functions are recognized only at the top level.
 go-outward  -- Nested functions are also recognized.  Should a function
                command hit the beginning/end of a nested scope, it will
                carry on at the less nested level." :type '(radio (const :tag "Functions are at the top-level" t) (const :tag "Functions are also recognized inside declaration scopes" go-outward)) :group 'c)

(defcustom c-ignore-auto-fill '(string cpp code) "\
*List of contexts in which automatic filling never occurs.
If Auto Fill mode is active, it will be temporarily disabled if point
is in any context on this list.  It's e.g. useful to enable Auto Fill
in comments only, but not in strings or normal code.  The valid
contexts are:

 string  -- inside a string or character literal
 c       -- inside a C style block comment
 c++     -- inside a C++ style line comment
 cpp     -- inside a preprocessor directive
 code    -- anywhere else, i.e. in normal code" :type '(set (const :tag "String literals" string) (const :tag "C style block comments" c) (const :tag "C++ style line comments" c++) (const :tag "Preprocessor directives" cpp) (const :tag "Normal code" code)) :group 'c)

(defcustom c-max-one-liner-length 80 "\
Maximum length of line that clean-up \"one-liner-defun\" will compact to.
Zero or nil means no limit." :type 'integer :group 'c)

(defcustom c-auto-align-backslashes t "\
*Align automatically inserted line continuation backslashes.
When line continuation backslashes are inserted automatically for line
breaks in multiline macros, e.g. by \\[c-context-line-break], they are
aligned with the other backslashes in the same macro if this flag is
set.  Otherwise the inserted backslashes are preceded by a single
space." :type 'boolean :group 'c)

(defcustom c-backspace-function 'backward-delete-char-untabify "\
*Function called by `c-electric-backspace' when deleting backwards." :type 'function :group 'c)

(defcustom c-delete-function 'delete-char "\
*Function called by `c-electric-delete-forward' when deleting forwards." :type 'function :group 'c)

(defcustom c-require-final-newline '((c-mode . t) (c++-mode . t) (objc-mode . t)) "\
*Controls whether a final newline is ensured when the file is saved.
The value is an association list that for each language mode specifies
the value to give to `require-final-newline' at mode initialization;
see that variable for details about the value.  If a language isn't
present on the association list, CC Mode won't touch
`require-final-newline' in buffers for that language." :type (backquote (set (cons :format "%v" (const :format "C     " c-mode) (symbol :format "%v" :value (\, require-final-newline))) (cons :format "%v" (const :format "C++   " c++-mode) (symbol :format "%v" :value (\, require-final-newline))) (cons :format "%v" (const :format "ObjC  " objc-mode) (symbol :format "%v" :value (\, require-final-newline))) (cons :format "%v" (const :format "Java  " java-mode) (symbol :format "%v" :value (\, require-final-newline))) (cons :format "%v" (const :format "IDL   " idl-mode) (symbol :format "%v" :value (\, require-final-newline))) (cons :format "%v" (const :format "Pike  " pike-mode) (symbol :format "%v" :value (\, require-final-newline))) (cons :format "%v" (const :format "AWK   " awk-mode) (symbol :format "%v" :value (\, require-final-newline))))) :group 'c)

(defcustom c-electric-pound-behavior nil "\
*List of behaviors for electric pound insertion.
Only currently supported behavior is `alignleft'." :type '(set (const alignleft)) :group 'c)

(defcustom c-special-indent-hook nil "\
*Hook for user defined special indentation adjustments.
This hook gets called after each line is indented by the mode.  It is only
called when `c-syntactic-indentation' is non-nil." :type 'hook :group 'c)

(defcustom c-progress-interval 5 "\
*Interval used to update progress status during long re-indentation.
If a number, percentage complete gets updated after each interval of
that many seconds.  To inhibit all messages during indentation, set
this variable to nil." :type 'integer :group 'c)

(defcustom c-objc-method-arg-min-delta-to-bracket 2 "\
*Minimum number of chars to the opening bracket.

Consider this ObjC snippet:

	[foo blahBlah: fred
	|<-x->|barBaz: barney

If `x' is less than this number then `c-lineup-ObjC-method-call-colons'
will defer the indentation decision to the next function.  By default
this is `c-lineup-ObjC-method-call', which would align it like:

	[foo blahBlahBlah: fred
	     thisIsTooDamnLong: barney

This behavior can be overridden by customizing the indentation of
`objc-method-call-cont' in the \"objc\" style." :type 'integer :group 'c)

(defcustom c-objc-method-arg-unfinished-offset 4 "\
*Offset relative to bracket if first selector is on a new line.

    [aaaaaaaaa
    |<-x->|bbbbbbb:  cccccc
             ddddd: eeee];" :type 'integer :group 'c)

(defcustom c-objc-method-parameter-offset 4 "\
*Offset for selector parameter on a new line (relative to first selector.

    [aaaaaaa bbbbbbbbbb:
	     |<-x->|cccccccc
                    ddd: eeee
                   ffff: ggg];" :type 'integer :group 'c)

(defcustom c-default-style '((java-mode . "java") (awk-mode . "awk") (other . "gnu")) "\
*Style which gets installed by default when a file is visited.

The value of this variable can be any style defined in
`c-style-alist', including styles you add.  The value can also be an
association list of major mode symbols to style names.

When the value is a string, all CC Mode major modes will install this
style by default.

When the value is an alist, the major mode symbol is looked up in it
and the associated style is installed.  If the major mode is not
listed in the alist, then the symbol `other' is looked up in it, and
if found, the style in that entry is used.  If `other' is not found in
the alist, then \"gnu\" style is used.

The default style gets installed before your mode hooks run, so you
can always override the use of `c-default-style' by making calls to
`c-set-style' in the appropriate mode hook." :type '(radio (string :tag "Style in all modes") (set :tag "Mode-specific styles" (cons :format "%v" (const :format "C     " c-mode) (string :format "%v")) (cons :format "%v" (const :format "C++   " c++-mode) (string :format "%v")) (cons :format "%v" (const :format "ObjC  " objc-mode) (string :format "%v")) (cons :format "%v" (const :format "Java  " java-mode) (string :format "%v")) (cons :format "%v" (const :format "IDL   " idl-mode) (string :format "%v")) (cons :format "%v" (const :format "Pike  " pike-mode) (string :format "%v")) (cons :format "%v" (const :format "AWK   " awk-mode) (string :format "%v")) (cons :format "%v" (const :format "Other " other) (string :format "%v")))) :group 'c)

(defcustom c-offsets-alist nil "\
Association list of syntactic element symbols and indentation offsets.
As described below, each cons cell in this list has the form:

    (SYNTACTIC-SYMBOL . OFFSET)

When a line is indented, CC Mode first determines the syntactic
context of it by generating a list of symbols called syntactic
elements.  The global variable `c-syntactic-context' is bound to the
that list.  Each element in the list is in turn a list where the first
element is a syntactic symbol which tells what kind of construct the
indentation point is located within.  More elements in the syntactic
element lists are optional.  If there is one more and it isn't nil,
then it's the anchor position for that construct.

After generating the syntactic context for the line, CC Mode
calculates the absolute indentation: First the base indentation is
found by using the anchor position for the first syntactic element
that provides one.  If none does, zero is used as base indentation.
Then CC Mode looks at each syntactic element in the context in turn.
It compares the car of the syntactic element against the
SYNTACTIC-SYMBOL's in `c-offsets-alist'.  When it finds a match, it
adds OFFSET to the base indentation.  The sum of this calculation is
the absolute offset for line being indented.

If the syntactic element does not match any in the `c-offsets-alist',
the element is ignored.

OFFSET can specify an offset in several different ways:

  If OFFSET is nil then it's ignored.

  If OFFSET is an integer then it's used as relative offset, i.e. it's
  added to the base indentation.

  If OFFSET is one of the symbols `+', `-', `++', `--', `*', or `/'
  then a positive or negative multiple of `c-basic-offset' is added to
  the base indentation; 1, -1, 2, -2, 0.5, and -0.5, respectively.

  If OFFSET is a symbol with a value binding then that value, which
  must be an integer, is used as relative offset.

  If OFFSET is a vector then its first element, which must be an
  integer, is used as an absolute indentation column.  This overrides
  the previous base indentation and the relative offsets applied to
  it, and it becomes the new base indentation.

  If OFFSET is a function or a lambda expression then it's called with
  a single argument containing the cons of the syntactic symbol and
  the anchor position (or nil if there is none).  The return value
  from the function is then reinterpreted as an offset specification.

  If OFFSET is a list then its elements are evaluated recursively as
  offset specifications.  If the first element is any of the symbols
  below then it isn't evaluated but instead specifies how the
  remaining offsets in the list should be combined.  If it's something
  else then the list is combined according the method `first'.  The
  valid combination methods are:

  `first' -- Use the first offset (that doesn't evaluate to nil).
  `min'   -- Use the minimum of all the offsets.  All must be either
             relative or absolute - they can't be mixed.
  `max'   -- Use the maximum of all the offsets.  All must be either
             relative or absolute - they can't be mixed.
  `add'   -- Add all the evaluated offsets together.  Exactly one of
             them may be absolute, in which case the result is
             absolute.  Any relative offsets that preceded the
             absolute one in the list will be ignored in that case.

`c-offsets-alist' is a style variable.  This means that the offsets on
this variable are normally taken from the style system in CC Mode
\(see `c-default-style' and `c-style-alist').  However, any offsets
put explicitly on this list will override the style system when a CC
Mode buffer is initialized (there is a variable
`c-old-style-variable-behavior' that changes this, though).

Here is the current list of valid syntactic element symbols:

 string                 -- Inside multi-line string.
 c                      -- Inside a multi-line C style block comment.
 defun-open             -- Brace that opens a function definition.
 defun-close            -- Brace that closes a function definition.
 defun-block-intro      -- The first line in a top-level defun.
 class-open             -- Brace that opens a class definition.
 class-close            -- Brace that closes a class definition.
 inline-open            -- Brace that opens an in-class inline method.
 inline-close           -- Brace that closes an in-class inline method.
 func-decl-cont         -- The region between a function definition's
                           argument list and the function opening brace
                           (excluding K&R argument declarations).  In C, you
                           cannot put anything but whitespace and comments
                           between them; in C++ and Java, throws declarations
                           and other things can appear in this context.
 knr-argdecl-intro      -- First line of a K&R C argument declaration.
 knr-argdecl		-- Subsequent lines in a K&R C argument declaration.
 topmost-intro		-- The first line in a topmost construct definition.
 topmost-intro-cont	-- Topmost definition continuation lines.
 annotation-top-cont    -- Topmost definition continuation line where only
 			   annotations are on previous lines.
 annotation-var-cont    -- A continuation of a C (or like) statement where
 			   only annotations are on previous lines.
 member-init-intro	-- First line in a member initialization list.
 member-init-cont	-- Subsequent member initialization list lines.
 inher-intro		-- First line of a multiple inheritance list.
 inher-cont             -- Subsequent multiple inheritance lines.
 block-open             -- Statement block open brace.
 block-close            -- Statement block close brace.
 brace-list-open        -- Open brace of an enum or static array list.
 brace-list-close       -- Close brace of an enum or static array list.
 brace-list-intro       -- First line in an enum or static array list.
 brace-list-entry       -- Subsequent lines in an enum or static array list.
 brace-entry-open       -- Subsequent lines in an enum or static array
                           list that start with an open brace.
 statement              -- A C (or like) statement.
 statement-cont         -- A continuation of a C (or like) statement.
 statement-block-intro  -- The first line in a new statement block.
 statement-case-intro   -- The first line in a case \"block\".
 statement-case-open    -- The first line in a case block starting with brace.
 substatement           -- The first line after an if/while/for/do/else.
 substatement-open      -- The brace that opens a substatement block.
 substatement-label     -- Labeled line after an if/while/for/do/else.
 case-label             -- A \"case\" or \"default\" label.
 access-label           -- C++ private/protected/public access label.
 label                  -- Any ordinary label.
 do-while-closure       -- The \"while\" that ends a do/while construct.
 else-clause            -- The \"else\" of an if/else construct.
 catch-clause           -- The \"catch\" or \"finally\" of a try/catch construct.
 comment-intro          -- A line containing only a comment introduction.
 arglist-intro          -- The first line in an argument list.
 arglist-cont           -- Subsequent argument list lines when no
                           arguments follow on the same line as the
                           arglist opening paren.
 arglist-cont-nonempty  -- Subsequent argument list lines when at
                           least one argument follows on the same
                           line as the arglist opening paren.
 arglist-close          -- The solo close paren of an argument list.
 stream-op              -- Lines continuing a stream operator construct.
 inclass                -- The construct is nested inside a class definition.
                           Used together with e.g. `topmost-intro'.
 cpp-macro              -- The start of a C preprocessor macro definition.
 cpp-macro-cont         -- Inside a multi-line C preprocessor macro definition.
 friend                 -- A C++ friend declaration.
 objc-method-intro      -- The first line of an Objective-C method definition.
 objc-method-args-cont  -- Lines continuing an Objective-C method definition.
 objc-method-call-cont  -- Lines continuing an Objective-C method call.
 extern-lang-open       -- Brace that opens an \"extern\" block.
 extern-lang-close      -- Brace that closes an \"extern\" block.
 inextern-lang          -- Analogous to the `inclass' syntactic symbol,
                           but used inside \"extern\" blocks.
 namespace-open, namespace-close, innamespace
                        -- Similar to the three `extern-lang' symbols, but for
                           C++ \"namespace\" blocks.
 module-open, module-close, inmodule
                        -- Similar to the three `extern-lang' symbols, but for
                           CORBA IDL \"module\" blocks.
 composition-open, composition-close, incomposition
                        -- Similar to the three `extern-lang' symbols, but for
                           CORBA CIDL \"composition\" blocks.
 template-args-cont     -- C++ template argument list continuations.
 inlambda               -- In the header or body of a lambda function.
 lambda-intro-cont      -- Continuation of the header of a lambda function.
 inexpr-statement       -- The statement is inside an expression.
 inexpr-class           -- The class is inside an expression.  Used e.g. for
                           Java anonymous classes." :type (backquote (set :format "%{%t%}:
 Override style setting
 |  Syntax                     Offset
%v" (\,@ (mapcar (lambda (elt) (backquote (cons :format "%v" :value (\, elt) (\, (c-constant-symbol (car elt) 25)) (sexp :format "%v" :validate (lambda (widget) (unless (c-valid-offset (widget-value widget)) (widget-put widget :error "Invalid offset") widget)))))) (get 'c-offsets-alist 'c-stylevar-fallback))))) :group 'c)

(defcustom c-style-variables-are-local-p t "\
*Whether style variables should be buffer local by default.
If non-nil, then all indentation style related variables will be made
buffer local by default.  If nil, they will remain global.  Variables
are made buffer local when this file is loaded, and once buffer
localized, they cannot be made global again.

This variable must be set appropriately before CC Mode is loaded.

The list of variables to buffer localize are:
    c-basic-offset
    c-comment-only-line-offset
    c-indent-comment-alist
    c-indent-comments-syntactically-p
    c-block-comment-prefix
    c-comment-prefix-regexp
    c-doc-comment-style
    c-cleanup-list
    c-hanging-braces-alist
    c-hanging-colons-alist
    c-hanging-semi&comma-criteria
    c-backslash-column
    c-backslash-max-column
    c-label-minimum-indentation
    c-offsets-alist
    c-special-indent-hook
    c-indentation-style" :type 'boolean :group 'c)

(defcustom c-mode-hook nil "\
*Hook called by `c-mode'." :type 'hook :group 'c)

(defcustom c++-mode-hook nil "\
*Hook called by `c++-mode'." :type 'hook :group 'c)

(defcustom objc-mode-hook nil "\
*Hook called by `objc-mode'." :type 'hook :group 'c)

(defcustom java-mode-hook nil "\
*Hook called by `java-mode'." :type 'hook :group 'c)

(defcustom idl-mode-hook nil "\
*Hook called by `idl-mode'." :type 'hook :group 'c)

(defcustom pike-mode-hook nil "\
*Hook called by `pike-mode'." :type 'hook :group 'c)

(defcustom awk-mode-hook nil "\
*Hook called by `awk-mode'." :type 'hook :group 'c)

(defcustom c-mode-common-hook nil "\
*Hook called by all CC Mode modes for common initializations." :type 'hook :group 'c)

(defcustom c-initialization-hook nil "\
*Hook called when the CC Mode package gets initialized.
This hook is only run once per Emacs session and can be used as a
`load-hook' or in place of using `eval-after-load'." :type 'hook :group 'c)

(defcustom c-enable-xemacs-performance-kludge-p nil "\
*Enables a XEmacs only hack that may improve speed for some coding styles.
For styles that hang top-level opening braces (as is common with JDK
Java coding styles) this can improve performance between 3 and 60
times for core indentation functions (e.g. `c-parse-state').  For
styles that conform to the Emacs recommendation of putting these
braces in column zero, this can degrade performance about as much.
This variable only has effect in XEmacs." :type 'boolean :group 'c)

(defcustom c-font-lock-extra-types '("\\sw+_t" "bool" "complex" "imaginary" "FILE" "lconv" "tm" "va_list" "jmp_buf" "Lisp_Object") (c-make-font-lock-extra-types-blurb "C" "c-mode" "For example, a value of (\"FILE\" \"\\\\sw+_t\") means the word \"FILE\"\nand words ending in \"_t\" are treated as type names.") :type 'c-extra-types-widget :group 'c)

(defcustom c++-font-lock-extra-types '("\\sw+_t" "FILE" "lconv" "tm" "va_list" "jmp_buf" "istream" "istreambuf" "ostream" "ostreambuf" "ifstream" "ofstream" "fstream" "strstream" "strstreambuf" "istrstream" "ostrstream" "ios" "string" "rope" "list" "slist" "deque" "vector" "bit_vector" "set" "multiset" "map" "multimap" "hash" "hash_set" "hash_multiset" "hash_map" "hash_multimap" "stack" "queue" "priority_queue" "type_info" "iterator" "const_iterator" "reverse_iterator" "const_reverse_iterator" "reference" "const_reference") (c-make-font-lock-extra-types-blurb "C++" "c++-mode" "For example, a value of (\"string\") means the word \"string\" is treated\nas a type name.") :type 'c-extra-types-widget :group 'c)

(defcustom objc-font-lock-extra-types (list (concat "[" c-upper "]\\sw*[" c-lower "]\\sw*")) (c-make-font-lock-extra-types-blurb "ObjC" "objc-mode" (concat "For example, a value of (\"[" c-upper "]\\\\sw*[" c-lower "]\\\\sw*\") means\ncapitalized words are treated as type names (the requirement for a\nlower case char is to avoid recognizing all-caps macro and constant\nnames).")) :type 'c-extra-types-widget :group 'c)

(defcustom java-font-lock-extra-types (list (concat "[" c-upper "]\\sw*[" c-lower "]\\sw")) (c-make-font-lock-extra-types-blurb "Java" "java-mode" (concat "For example, a value of (\"[" c-upper "]\\\\sw*[" c-lower "]\\\\sw*\") means\ncapitalized words are treated as type names (the requirement for a\nlower case char is to avoid recognizing all-caps constant names).")) :type 'c-extra-types-widget :group 'c)

(defcustom idl-font-lock-extra-types nil (c-make-font-lock-extra-types-blurb "IDL" "idl-mode" "") :type 'c-extra-types-widget :group 'c)

(defcustom pike-font-lock-extra-types (list (concat "[" c-upper "]\\sw*[" c-lower "]\\sw*")) (c-make-font-lock-extra-types-blurb "Pike" "pike-mode" (concat "For example, a value of (\"[" c-upper "]\\\\sw*[" c-lower "]\\\\sw*\") means\ncapitalized words are treated as type names (the requirement for a\nlower case char is to avoid recognizing all-caps macro and constant\nnames).")) :type 'c-extra-types-widget :group 'c)

;;;***

(provide 'cc-mode-custom-defines)
