;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'cogre-custom-defines) (error "Feature cogre-custom-defines already loaded"))

;;;### (autoloads (cogre-mode-hooks cogre-vertical-margins cogre-horizontal-margins cogre) "cogre" "cogre/cogre.el")
(defconst custom-define-current-source-file "cogre.el")

(defgroup cogre nil "COnnected GRaph Editor." :group 'tools)

(defcustom cogre-horizontal-margins 10 "\
*Horizontal margins between nodes when they are being layed out." :group 'cogre :type 'number)

(defcustom cogre-vertical-margins 7 "\
*Horizontal margins between nodes when they are being layed out." :group 'cogre :type 'number)

(defcustom cogre-mode-hooks nil "\
Hooks run in `cogre-mode'." :group 'cogre :type 'hook)

;;;***

;;;### (autoloads (cogre-uml-source-display-window-size cogre-uml-browse-token-hook cogre-uml-source-display-method cogre-token->uml-function) "uml-create" "cogre/uml-create.el")
(defconst custom-define-current-source-file "uml-create.el")

(defcustom cogre-token->uml-function 'semantic-uml-abbreviate-nonterminal "\
Function to use to create strings for tokens in CLASS nodes." :group 'cogre :type semantic-format-tag-functions)

(defcustom cogre-uml-source-display-method 'cogre-uml-source-display-bottom "\
A Function called to display a source buffer associated with a Graph.
This function can be anything, or nil, though the following options
are preferred:
 `cogre-uml-source-display-bottom' - in a window on the bottom of the frame.
 `cogre-uml-source-display-top' - in a window on the top of the frame.
The function specified must take a `point-marker' to specify the
location that is to be displayed." :group 'cogre :type '(choice (const 'cogre-uml-source-display-bottom) (const 'cogre-uml-source-display-top)))

(defcustom cogre-uml-browse-token-hook nil "\
*Hooks run when a token is browsed by the COGRE graph.
Each hook takes one argument, and one optional argument, the token
being browsed too, and a containing parent token, if available.
This is run when the token is first found, not during the actual
browse.  The token will be under point when this hook is called.
Changing window configurations is not recommended." :group 'cogre :type 'function)

(defcustom cogre-uml-source-display-window-size 5 "\
Size of same-frame window displaying source code." :group 'cogre :type 'integer)

;;;***

(provide 'cogre-custom-defines)
