;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'crisp-custom-defines) (error "Feature crisp-custom-defines already loaded"))

;;;### (autoloads (crisp-load-hook crisp-load-scroll-lock crisp-override-meta-x crisp-mode-enabled crisp-mode-modeline-string crisp) "crisp" "crisp/crisp.el")
(defconst custom-define-current-source-file "crisp.el")

(defgroup crisp nil "Emulator for CRiSP and Brief key bindings." :prefix "crisp-" :group 'emulations)

(defcustom crisp-mode-modeline-string " *CRiSP*" "\
*String to display in the modeline when CRiSP emulation mode is enabled." :type 'string :group 'crisp)

(defcustom crisp-mode-enabled nil "\
Track status of CRiSP emulation mode.
A value of nil means CRiSP mode is not enabled.  A value of t
indicates CRiSP mode is enabled." :type 'boolean :group 'crisp)

(defcustom crisp-override-meta-x t "\
*Controls overriding the normal Emacs M-x key binding in the CRiSP emulator.
Normally the CRiSP emulator rebinds M-x to `save-buffers-exit-emacs', and
provides the usual M-x functionality on the F10 key.  If this variable
is non-nil, M-x will exit Emacs." :type 'boolean :group 'crisp)

(defcustom crisp-load-scroll-lock nil "\
Controls loading of the Scroll Lock in the CRiSP emulator.
Its default behavior is to load and enable the Scroll Lock minor mode
package when enabling the CRiSP emulator.

If this variable is nil when you start the CRiSP emulator, it
does not load the scroll-lock package." :type 'boolean :group 'crisp)

(defcustom crisp-load-hook nil "\
Hooks to run after loading the CRiSP emulator package." :type 'hook :group 'crisp)

;;;***

(provide 'crisp-custom-defines)
