;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'dictionary-custom-defines) (error "Feature dictionary-custom-defines already loaded"))

;;;### (autoloads (dictionary-tooltip-dictionary dictionary-description-close-delimiter dictionary-description-open-delimiter dictionary-use-single-buffer dictionary-proxy-port dictionary-proxy-server dictionary-use-http-proxy dictionary-mode-hook dictionary-create-buttons dictionary-default-popup-strategy dictionary-default-strategy dictionary-default-dictionary dictionary-identification dictionary-port dictionary-server dictionary-proxy dictionary) "dictionary" "dictionary/dictionary.el")
(defconst custom-define-current-source-file "dictionary.el")

(defgroup dictionary nil "Client for accessing the dictd server based dictionaries" :group 'hypermedia)

(defgroup dictionary-proxy nil "Proxy configuration options for the dictionary client" :group 'dictionary)

(defcustom dictionary-server "dict.org" "\
This server is contacted for searching the dictionary" :group 'dictionary :type 'string)

(defcustom dictionary-port 2628 "\
The port of the dictionary server.
 This port is propably always 2628 so there should be no need to modify it." :group 'dictionary :type 'number)

(defcustom dictionary-identification "dictionary.el emacs lisp dictionary client" "\
This is the identification string that will be sent to the server." :group 'dictionary :type 'string)

(defcustom dictionary-default-dictionary "*" "\
The dictionary which is used for searching definitions and matching.
 * and ! have a special meaning, * search all dictionaries, ! search until
 one dictionary yields matches." :group 'dictionary :type 'string)

(defcustom dictionary-default-strategy "." "\
The default strategy for listing matching words." :group 'dictionary :type 'string)

(defcustom dictionary-default-popup-strategy "exact" "\
The default strategy for listing matching words within a popup window.

The following algorithm (defined by the dictd server) are supported
by the choice value:

- Exact match

  The found word exactly matches the searched word.

- Similiar sounding

  The found word sounds similiar to the searched word.  For this match type
  the soundex algorithm defined by Donald E. Knuth is used.  It will only
  works with english words and the algorithm is not very reliable (i.e.,
  the soundex algorithm is quite simple).

- Levenshtein distance one

  The Levenshtein distance is defined as the number of insertions, deletions,
  or replacements needed to get the searched word.  This algorithm searches
  for word where spelling mistakes are allowed.  Levenshtein distance one
  means there is either a deleted character, an inserted character, or a
  modified one. 

- User choice

  Here you can enter any matching algorithm supported by your
  dictionary server.
" :group 'dictionary :type '(choice (const :tag "Exact match" "exact") (const :tag "Similiar sounding" "soundex") (const :tag "Levenshtein distance one" "lev") (string :tag "User choice")))

(defcustom dictionary-create-buttons t "\
Create some clickable buttons on top of the window if non-nil." :group 'dictionary :type 'boolean)

(defcustom dictionary-mode-hook nil "\
Hook run in dictionary mode buffers." :group 'dictionary :type 'hook)

(defcustom dictionary-use-http-proxy nil "\
Connects via a HTTP proxy using the CONNECT command when not nil." :group 'dictionary-proxy :type 'boolean)

(defcustom dictionary-proxy-server "proxy" "\
The name of the HTTP proxy to use when dictionary-use-http-proxy is set." :group 'dictionary-proxy :type 'string)

(defcustom dictionary-proxy-port 3128 "\
The port of the proxy server, used only when dictionary-use-http-proxy is set." :group 'dictionary-proxy :type 'number)

(defcustom dictionary-use-single-buffer nil "\
Should the dictionary command reuse previous dictionary buffers?" :group 'dictionary :type 'boolean)

(defcustom dictionary-description-open-delimiter "" "\
The delimiter to display in front of the dictionaries description" :group 'dictionary :type 'string)

(defcustom dictionary-description-close-delimiter "" "\
The delimiter to display after of the dictionaries description" :group 'dictionary :type 'string)

(defcustom dictionary-tooltip-dictionary nil "\
This dictionary to lookup words for tooltips" :group 'dictionary :type 'string)

;;;***

(provide 'dictionary-custom-defines)
