;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'docbookide-custom-defines) (error "Feature docbookide-custom-defines already loaded"))

;;;### (autoloads (docbook-process-error-regexps docbook-process-command docbook-offer-save docbook-process) "dbide-process" "docbookide/dbide-process.el")
(defconst custom-define-current-source-file "dbide-process.el")

(defgroup docbook-process nil "Processing DocBook documents." :group 'docbook)

(defcustom docbook-offer-save t "\
*If non-nil, ask about saving modified buffers before \\[docbook-process] is run." :type '(choice (const :tag "Yes" t) (const :tag "No" nil)) :group 'docbook-process)

(defcustom docbook-process-command "java com.jclark.docbook.Driver %s %s %s" "\
*The shell command to process an DOCBOOK document.

This is a `format' control string that by default should contain two
`%s' conversion specifications: the first will be replaced by the
value of `docbook-xml-source' (or the empty string, if nil); the
second will be replaced by the current buffer's file name (or the
empty string, if nil).

If `docbook-process-files' is non-nil, the format string should contain
one `%s' conversion specification for each element of its result.

If docbook-process-command is a list, then every element should be a
string.  The strings will be tried in order and %-sequences in the
string will be replaced according to the list below, if the string contains
%-sequences with no replacement value the next string will be tried.

%b means the visited file of the current buffer
%s means the DOCBOOK declaration specified in the docbook-xml-source variable
%d means the file containing the DOCTYPE declaration, if not in the buffer 
" :type '(repeat :tag "Commands" string) :group 'docbook-process)

(defcustom docbook-process-error-regexps '(("file:\\([^:]+\\):\\([0-9]+\\):\\([0-9]+\\):" 1 2 3) ("file:/\\(\\([A-Za-z]:\\)?[^:]+\\):\\([0-9]+\\):\\(\\([0-9]+\\):\\)?" 1 3 5)) "\
Alist of regexps to recognize error messages from `docbook-process'.
See `compilation-error-regexp-alist'." :type '(repeat :tag "Regexps" (list (regexp :tag "Regexp") (integer :tag "File index") (integer :tag "Line index") (choice :tag "Column index" (integer) (const :tag "None" nil)))) :group 'docbook-process)

;;;***

;;;### (autoloads (docbook) "docbookide" "docbookide/docbookide.el")
(defconst custom-define-current-source-file "docbookide.el")

(defgroup docbook nil "Major mode for editing DocBook documents." :prefix "docbook-" :group 'languages)

;;;***

(provide 'docbookide-custom-defines)
