;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'easypg-custom-defines) (error "Feature easypg-custom-defines already loaded"))

;;;### (autoloads (epa-file-select-keys epa-file-inhibit-auto-save epa-file-cache-passphrase-for-symmetric-encryption epa-file-name-regexp epa-file) "epa-file" "easypg/epa-file.el")
(defconst custom-define-current-source-file "epa-file.el")

(defgroup epa-file nil "The EasyPG Assistant hooks for transparent file encryption" :group 'epa)

(defcustom epa-file-name-regexp "\\.gpg\\(~\\|\\.~[0-9]+~\\)?\\'" "\
Regexp which matches filenames to be encrypted with GnuPG.

If you set this outside Custom while epa-file is already enabled, you
have to call `epa-file-name-regexp-update' after setting it to
properly update file-name-handler-alist.  Setting this through Custom
does that automatically." :type 'regexp :group 'epa-file :set 'epa-file--file-name-regexp-set)

(defcustom epa-file-cache-passphrase-for-symmetric-encryption nil "\
If non-nil, cache passphrase for symmetric encryption." :type 'boolean :group 'epa-file)

(defcustom epa-file-inhibit-auto-save t "\
If non-nil, disable auto-saving when opening an encrypted file." :type 'boolean :group 'epa-file)

(defcustom epa-file-select-keys nil "\
If non-nil, always asks user to select recipients." :type 'boolean :group 'epa-file)

;;;***

;;;### (autoloads (epa-validity-face-alist epa-faces epa-info-window-height epa-popup-info-window epa) "epa" "easypg/epa.el")
(defconst custom-define-current-source-file "epa.el")

(defgroup epa nil "The EasyPG Assistant" :group 'epg)

(defcustom epa-popup-info-window t "\
If non-nil, status information from epa commands is displayed on
the separate window." :type 'boolean :group 'epa)

(defcustom epa-info-window-height 5 "\
Number of lines used to display status information." :type 'integer :group 'epa)

(defgroup epa-faces nil "Faces for epa-mode." :group 'epa)

(defcustom epa-validity-face-alist '((unknown . epa-validity-disabled) (invalid . epa-validity-disabled) (disabled . epa-validity-disabled) (revoked . epa-validity-disabled) (expired . epa-validity-disabled) (none . epa-validity-low) (undefined . epa-validity-low) (never . epa-validity-low) (marginal . epa-validity-medium) (full . epa-validity-high) (ultimate . epa-validity-high)) "\
An alist mapping validity values to faces." :type '(repeat (cons symbol face)) :group 'epa)

;;;***

;;;### (autoloads (epg-debug epg-passphrase-coding-system epg-gpg-home-directory epg-gpgsm-program epg-gpg-program epg) "epg-config" "easypg/epg-config.el")
(defconst custom-define-current-source-file "epg-config.el")

(defgroup epg nil "The EasyPG Library" :group 'emacs)

(defcustom epg-gpg-program "gpg" "\
The `gpg' executable." :group 'epg :type 'string)

(defcustom epg-gpgsm-program "gpgsm" "\
The `gpgsm' executable." :group 'epg :type 'string)

(defcustom epg-gpg-home-directory nil "\
The directory which contains the configuration files of `epg-gpg-program'." :group 'epg :type '(choice (const :tag "Default" nil) directory))

(defcustom epg-passphrase-coding-system nil "\
Coding system to use with messages from `epg-gpg-program'." :group 'epg :type 'symbol)

(defcustom epg-debug nil "\
If non-nil, debug output goes to the \" *epg-debug*\" buffer.
Note that the buffer name starts with a space." :group 'epg :type 'boolean)

;;;***

(provide 'easypg-custom-defines)
