;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ecb-custom-defines) (error "Feature ecb-custom-defines already loaded"))

;;;### (autoloads (ecb-common-tree-buffer-after-create-hook ecb-mouse-click-destination ecb-tree-mouse-action-trigger ecb-primary-secondary-mouse-buttons ecb-show-node-info-in-minibuffer ecb-tree-navigation-by-arrow ecb-tree-incremental-search ecb-truncate-long-names ecb-tree-easy-hor-scroll ecb-truncate-lines ecb-tree-image-icons-directories ecb-tree-buffer-style ecb-tree-expand-symbol-before ecb-tree-indent ecb-tree-RET-selects-edit-window ecb-use-speedbar-instead-native-tree-buffer ecb-bucket-node-display ecb-tree-buffer) "ecb-common-browser" "ecb/ecb-common-browser.el")
(defconst custom-define-current-source-file "ecb-common-browser.el")

(defgroup ecb-tree-buffer nil "General settings related to the tree-buffers of ECB." :group 'ecb :prefix "ecb-")

(defcustom ecb-bucket-node-display '("" "" ecb-bucket-node-face) "\
*How ECB displays bucket-nodes in a ECB tree-buffer.
Bucket-nodes have only one job: Nodes with similar properties will be dropped
into one bucket for such a common property and all these nodes will be added
as children to the bucket-node. Besides being expandable and collapsable a
bucket-node has no senseful action assigned. Examples for bucket-nodes are
\"[+] Variables\", \"[+] Dependencies\" etc. in the Methods-buffer or buckets
which combine filenames with same extension under a bucket-node with name this
extension.

This option defines how bucket-node should be displayed. The name of the
bucket-node is computed by ECB but you can define a prefix, a suffix and a
special face for the bucket-node

The default are empty prefix/suffix-strings and 'ecb-bucket-node-face'. But
an alternative can be for example '(\"[\" \"]\" nil) which means no special
face and a display like \"[+] [<bucket-name>]\"." :group 'ecb-general :set (function (lambda (symbol value) (set symbol value) (ecb-clear-tag-tree-cache))) :type '(list (string :tag "Bucket-prefix" :value "[") (string :tag "Bucket-suffix" :value "]") (choice :tag "Bucket-face" :menu-tag "Bucket-face" (const :tag "No special face" :value nil) (face :tag "Face" :value ecb-bucket-node-face))) :initialize 'custom-initialize-default)

(defcustom ecb-use-speedbar-instead-native-tree-buffer nil "\
*If true then uses speedbar for directories, sources or methods.
This means that speedbar is integrated in the ECB-frame and is displayed in
that window normally displaying the standard ECB-directories-buffer,
ECB-sources-buffer or ECB-methods-buffer.

This option takes effect in all layouts which contain either a directory
window, a sources window or a method window.

This option can have four valid values:
- nil: Do not use speedbar (default)
- dir: Use speedbar instead of the standard directories-buffer
- source: Use speedbar instead of the standard sources-buffer
- method: Use speedbar instead of the standard methods-buffer

Note: For directories and sources a similar effect and usability is available
by setting this option to nil (or 'method) and setting
`ecb-show-sources-in-directories-buffer' to not nil, because this combination
displays also directories and sources in one window.

`ecb-use-speedbar-instead-native-tree-buffer' is for people who like the
speedbar way handling directories and source-files or methods and want it in
conjunction with ECB." :group 'ecb-general :group 'ecb-directories :group 'ecb-sources :group 'ecb-methods :type '(radio (const :tag "Do not use speedbar" :value nil) (const :tag "For directories" :value dir) (const :tag "For sources" :value source) (const :tag "For methods" :value method)) :initialize 'custom-initialize-default :set (function (lambda (sym val) (set sym val) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode) (ecb-redraw-layout-full)))))

(defcustom ecb-tree-RET-selects-edit-window '(ecb-directories-buffer-name ecb-sources-buffer-name ecb-methods-buffer-name ecb-history-buffer-name) "\
*In which tree-buffers RET should finally select an edit-window.
If one of the symbols `ecb-directories-buffer-name',
`ecb-sources-buffer-name', `ecb-methods-buffer-name' or
`ecb-history-buffer-name' is contained in this list then hitting RET in the
associated tree-buffer selects as last action the right edit-window otherwise
only the right action is performed (opening a new source, selecting a method
etc.) but point stays in the tree-buffer.

A special remark for the `ecb-directories-buffer-name': Of course here the
edit-window is only selected if the name of the current layout is contained in
`ecb-show-sources-in-directories-buffer' or if the value of
`ecb-show-sources-in-directories-buffer' is 'always and the hitted node
represents a sourcefile (otherwise this would not make any sense)!

The setting in this option is only the default for each tree-buffer. With
`ecb-toggle-RET-selects-edit-window' the behavior of RET can be changed fast
and easy in a tree-buffer without customizing this option, but of course not
for future Emacs sessions!" :group 'ecb-tree-buffer :set (function (lambda (sym val) (set sym val) (setq ecb-tree-RET-selects-edit-window--internal (ecb-copy-list val)))) :type '(set (const :tag "ecb-directories-buffer-name" :value ecb-directories-buffer-name) (const :tag "ecb-sources-buffer-name" :value ecb-sources-buffer-name) (const :tag "ecb-methods-buffer-name" :value ecb-methods-buffer-name) (const :tag "ecb-history-buffer-name" :value ecb-history-buffer-name)))

(defcustom ecb-tree-indent 4 "\
*Indent size for tree buffer.
If you change this during ECB is activated you must deactivate and activate
ECB again to take effect." :group 'ecb-tree-buffer :group 'ecb-most-important :type 'integer)

(defcustom ecb-tree-expand-symbol-before t "\
*Show the expand symbol before the items in a tree.
When the expand-symbol is located before the items then the tree looks like:

[-] ECB
    [+] code-save
    [-] ecb-images
        [-] directories

When located after then the tree looks like:

ECB [-]
  code-save [+]
  ecb-images [-]
    directories [-]

The after-example above use a value of 2 for `ecb-tree-indent' whereas the
before-example uses a value of 4.

It is recommended to display the expand-symbol before because otherwise it
could be that with a deep nested item-structure with and/or with long
item-names (e.g. a deep directory-structure with some long
subdirectory-names) the expand-symbol is not visible in the tree-buffer and
the tree-buffer has to be horizontal scrolled to expand an item." :group 'ecb-tree-buffer :group 'ecb-most-important :type 'boolean)

(defcustom ecb-tree-buffer-style (if ecb-images-can-be-used 'image 'ascii-guides) "\
*The style of the tree-buffers.
There are three different styles available:

Image-style (value 'image):
Very nice and modern - just try it. For this style the options
`ecb-tree-indent' and `ecb-tree-expand-symbol-before' have no effect!
Note: GNU Emacs <= 21.3.X for Windows does not support image-display so ECB
uses always 'ascii-guides even when here 'image is set!

Ascii-style with guide-lines (value 'ascii-guides):
[-] ECB
 |  [+] code-save
 `- [-] ecb-images
     |  [-] directories
     |   |  [-] height-15
     |   |   |  * close.xpm
     |   |   |  * empty.xpm
     |   |   |  * leaf.xpm
     |   |   `- * open.xpm
     |   |  [+] height-17
     |   |  [+] height-19
     |   `- [+] height-21
     |  [x] history
     |  [x] methods
     `- [x] sources

Ascii-style without guide-lines (value 'ascii-no-guides) - this is the style
used by ECB <= 1.96:
[-] ECB
    [+] code-save
    [-] ecb-images
        [-] directories
            [-] height-15
                * close.xpm
                * empty.xpm
                * leaf.xpm
                * open.xpm
            [+] height-17
            [+] height-19
            [+] height-21
        [x] history
        [x] methods
        [x] sources

With both ascii-styles the tree-layout can be affected with the options
`ecb-tree-indent' and `ecb-tree-expand-symbol-before'." :group 'ecb-tree-buffer :group 'ecb-most-important :type '(radio (const :tag "Images-style" :value image) (const :tag "Ascii-style with guide-lines" :value ascii-guides) (const :tag "Ascii-style w/o guide-lines" :value ascii-no-guides)))

(defcustom ecb-tree-image-icons-directories (let ((base (concat (if ecb-regular-xemacs-package-p (format "%s" (locate-data-directory "ecb")) ecb-ecb-dir) "ecb-images/"))) (append (mapcar (function (lambda (i) (if i (concat base i)))) '("default/height-17" "directories/height-17" "sources/height-14_to_21" "methods/height-14_to_21" nil)))) "\
*Directories where the images for the tree-buffer can be found.
This is a five-element list where:
1. element: Default directory where the default images for the tree-buffer can
   be found. It should contain an image for every name of
   `tree-buffer-tree-image-names'. The name of an image-file must be:
   \"ecb-<NAME of TREE-BUFFER-TREE-IMAGE-NAMES>.<ALLOWED EXTENSIONS>\".
2. element: Directory for special images for the Directories-buffer.
3. element: Directory for special images for the Sources-buffer.
4. element: Directory for special images for the Methods-buffer.
5. element: Directory for special images for the History-buffer.

The directories of the elements 2 - 5 are additional image-directories which
are searched first for images needed for the respective tree-buffer. If the
image can not be found in this directory then the default-directory (1.
element) is searched. If the image can't even be found there the related
ascii-symbol is used - which is defined in `tree-buffer-tree-image-names'.

All but the first element (the default directory) can be nil.

ECB comes with images defined in four different heights - so for the most
senseful font-heights of a tree-buffer a fitting image-size should be
available. The images reside either in the subdirectory \"ecb-images\" of the
ECB-installation or - if ECB is installed as regular XEmacs-package - in the
ECB-etc data-directory (the directory returned by (locate-data-directory
\"ecb\")." :group 'ecb-tree-buffer :type '(list (directory :tag "Full default image-path") (choice :tag "Directories" :menu-tag "Directories" (const :tag "No special path" :value nil) (directory :tag "Full image-path for directories")) (choice :tag "Sources" :menu-tag "Sources" (const :tag "No special path" :value nil) (directory :tag "Full image-path for sources")) (choice :tag "Methods" :menu-tag "Methods" (const :tag "No special path" :value nil) (directory :tag "Full image-path for methods")) (choice :tag "History" :menu-tag "History" (const :tag "No special path" :value nil) (directory :tag "Full image-path for history"))))

(defcustom ecb-truncate-lines '(t t t t) "\
*Truncate lines in ECB buffers.
If you change this during ECB is activated you must deactivate and activate
ECB again to take effect." :group 'ecb-tree-buffer :group 'ecb-most-important :type '(list (boolean :tag "Directories buffer") (boolean :tag "Sources buffer") (boolean :tag "Methods buffer") (boolean :tag "History buffer")))

(defcustom ecb-tree-easy-hor-scroll 5 "\
*Scroll step for easy hor. scrolling via mouse-click in tree-buffers.
XEmacs has horizontal scroll-bars so invisible parts beyond the right
window-border of a tree-buffer can always made visible very easy.

GNU Emacs does not have hor. scroll-bars so especially with the mouse it is
quite impossible to scroll smoothly right and left. The functions
`scroll-left' and `scroll-right' can be annoying and are also not bound to
mouse-buttons.

If this option is a positive integer S then in all ECB-tree-buffers the keys
[M-mouse-1] and [M-mouse-3] are bound to scrolling left rsp. right with
scroll-step S - clicking with mouse-1 or mouse-2 onto the edge of the modeline
has the same effect, i.e. if you click with mouse-1 onto the left (rsp.
right) edge of the modeline you will scroll left (rsp. right). Additionally
[C-M-mouse-1] and [C-M-mouse-3] are bound to scrolling left rsp. right with
scroll-step `window-width' - 2. Default is a scroll-step of 5. If the value is
nil then no keys for horizontal scrolling are bound." :group 'ecb-tree-buffer :type '(radio :value 5 (const :tag "No hor. mouse scrolling" :value nil) (integer :tag "Scroll step")))

(defcustom ecb-truncate-long-names t "\
*Truncate long names that don't fit in the width of the ECB windows.
If you change this during ECB is activated you must deactivate and activate
ECB again to take effect." :group 'ecb-tree-buffer :group 'ecb-most-important :type 'boolean)

(defcustom ecb-tree-incremental-search 'prefix "\
*Enable incremental search in the ECB-tree-buffers.
For a detailed explanation see the online help section \"Working with the
keyboard in the ECB buffers\". If you change this during ECB is activated you
must deactivate and activate ECB again to take effect." :group 'ecb-tree-buffer :type '(radio (const :tag "Match only prefix" :value prefix) (const :tag "Match every substring" :value substring) (const :tag "No incremental search" :value nil)))

(defcustom ecb-tree-navigation-by-arrow t "\
*Enable smart navigation in the tree-windows by horizontal arrow-keys.
If not nil then the left- and right-arrow keys work in the ECB tree-window in
the following smart way if onto an expandable node:
+ Left-arrow: If node is expanded then it will be collapsed otherwise point
  jumps to the next \"higher\" node in the hierarchical tree (higher means
  the next higher tree-level or - if no higher level available - the next
  higher node on the same level).
+ Right-arrow: If node is not expanded then it will be expanded.
Onto a not expandable node the horizontal arrow-keys go one character in the
senseful correct direction.

If this option is changed the new value takes first effect after deactivating
ECB and then activating it again!" :group 'ecb-tree-buffer :type 'boolean)

(defcustom ecb-show-node-info-in-minibuffer '((if-too-long . path) (if-too-long . name) (always . path) (if-too-long . name+type)) "\
*Node info to display in a tree-buffer.
Define which node info should displayed in a tree-buffer after
mouse moving over the node or after a shift click onto the node.

For every tree-buffer you can define \"when\" node info should be displayed:
- always: Node info is displayed by moving with the mouse over a node.
- if-too-long: Node info is only displayed by moving with the mouse over a
  node does not fit into the window-width of the tree-buffer window.
  In the ECB directories buffer this means also if a node is shortend or if
  the node has an alias (see `ecb-source-path').
- shift-click: Node info is only displayed after a shift click with the
  primary mouse button onto the node.
- never: Node info is never displayed.

For every tree-buffer you can define what info should be displayed:
+ Directory-buffer:
  - name: Only the full node-name is displayed.
  - path: The full-path of the node is displayed.
+ Sources-buffer:
  - name: Only the full node-name is displayed.
  - file-info: File infos for this file are displayed.
  - file-info-full: Fill infos incl. full path for this file are displayed.
+ History-buffer:
  see Directories-buffer.
+ Methods-buffer:
  - name: Only the full node name is displayed.
  - name+type: The full name + the type of the node (function, class,
    variable) is displayed.

Do NOT set this option directly via setq but use always customize!" :group 'ecb-tree-buffer :group 'ecb-most-important :set (function (lambda (symbol value) (set symbol value) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode) (let ((when-list (mapcar (lambda (elem) (car elem)) value))) (if (or (member 'if-too-long when-list) (member 'always when-list)) (tree-buffer-activate-follow-mouse) (tree-buffer-deactivate-follow-mouse) (tree-buffer-deactivate-mouse-tracking)))))) :initialize 'custom-initialize-default :type '(list (cons :tag "* Directories-buffer" (choice :tag "When" (const :tag "Always" :value always) (const :tag "If too long" :value if-too-long) (const :tag "After shift click" :value shift-click) (const :tag "Never" :value never)) (choice :tag "What" (const :tag "Node-name" :value name) (const :tag "Full path" :value path))) (cons :tag "* Sources-buffer" (choice :tag "When" (const :tag "Always" :value always) (const :tag "If too long" :value if-too-long) (const :tag "After shift click" :value shift-click) (const :tag "Never" :value never)) (choice :tag "What" (const :tag "Node-name" :value name) (const :tag "File info" :value file-info) (const :tag "File info (full path)" :value file-info-full))) (cons :tag "* History-buffer" (choice :tag "When" (const :tag "Always" :value always) (const :tag "If too long" :value if-too-long) (const :tag "After shift click" :value shift-click) (const :tag "Never" :value never)) (choice :tag "What" (const :tag "Node-name" :value name) (const :tag "Full path" :value path))) (cons :tag "* Method-buffer" (choice :tag "When" (const :tag "Always" :value always) (const :tag "If too long" :value if-too-long) (const :tag "After shift click" :value shift-click) (const :tag "Never" :value never)) (choice :tag "What" (const :tag "Node-name" :value name) (const :tag "Node-name + type" :value name+type)))))

(defcustom ecb-primary-secondary-mouse-buttons 'mouse-2--C-mouse-2 "\
*Primary- and secondary mouse button for using the ECB-buffers.
A click with the primary button causes the main effect in each ECB-buffer:
- ECB Directories: Expanding/collapsing nodes and displaying files in the ECB
  Sources buffer.
- ECB sources/history: Opening the file in that edit-window specified by the
  option `ecb-mouse-click-destination'.
- ECB Methods: Jumping to the method in that edit-window specified by the
  option `ecb-mouse-click-destination'.

A click with the primary mouse-button while the SHIFT-key is pressed called
the POWER-click and does the following (depending on the ECB-buffer where the
POWER-click occurs):
+ Directory-buffer: Refreshing the directory-contents-cache (see
  `ecb-cache-directory-contents').
+ Sources- and History-buffer: Only displaying the source-contents in the
  method-buffer but not displaying the source-file in the edit-window.
+ Methods-buffer: Narrowing to the clicked method/variable/ect... (see
  `ecb-tag-visit-post-actions'). This works only for sources supported by
  semantic!

In addition always the whole node-name is displayed in the minibuffer after a
POWER-click (for this see `ecb-show-node-info-in-minibuffer').

The secondary mouse-button is for opening (jumping to) the file in another
edit-window (see the documentation `ecb-mouse-click-destination').

The following combinations are possible:
- primary: mouse-2, secondary: C-mouse-2 (means mouse-2 while CTRL-key is
  pressed). This is the default setting.
- primary: mouse-1, secondary: C-mouse-1
- primary: mouse-1, secondary: mouse-2

Note: If the tree-buffers are used with the keyboard instead with the mouse
then [RET] is interpreted as primary mouse-button and [C-RET] as secondary
mouse-button!

If you change this during ECB is activated you must deactivate and activate
ECB again to take effect!" :group 'ecb-tree-buffer :group 'ecb-most-important :type '(radio (const :tag "Primary: mouse-2, secondary: Ctrl-mouse-2" :value mouse-2--C-mouse-2) (const :tag "Primary: mouse-1, secondary: Ctrl-mouse-1" :value mouse-1--C-mouse-1) (const :tag "Primary: mouse-1, secondary: mouse-2" :value mouse-1--mouse-2)))

(defcustom ecb-tree-mouse-action-trigger 'button-release "\
*When the tree-buffer mouse-action should be triggered.
This option determines the moment a mouse-action in a tree-buffer is
triggered. This can be either direct after pressing a mouse-button (value
'button-press) or not until releasing the mouse-button (value:
'button-release).

If you change this during ECB is activated you must deactivate and activate
ECB again to take effect!" :group 'ecb-tree-buffer :type '(radio (const :tag "After button release" :value button-release) (const :tag "After button press" :value button-press)))

(defcustom ecb-mouse-click-destination 'last-point "\
*Destination of a mouse-button click.
Defines in which edit-window (if splitted) ECB does the \"right\" action
\(opening a source, jumping to a method/variable etc.) after clicking with a
mouse-button (see `ecb-primary-secondary-mouse-buttons') onto a node. There
are two possible choices:
- left-top: Does the \"right\" action always in the left/topmost edit-window.
- last-point: Does the \"right\" action always in that edit-window which had
  the point before.
This is if the user has clicked either with the primary mouse-button or
has activated a popup-menu in the tree-buffer.

A click with the secondary mouse-button (see again
`ecb-primary-secondary-mouse-buttons') does the \"right\" action always in
another edit-window related to the setting in this option: If there are two
edit-windows then the \"other\" edit-window is used and for more than 2
edit-windows the \"next\" edit-window is used (whereas the next edit-window
of the last edit-window is the first edit-window).

If the edit-window is not splitted this setting has no effect.

Note: If the tree-buffers are used with the keyboard instead with the mouse
then this option takes effect too because [RET] is interpreted as primary
mouse-button and [C-RET] as secondary mouse-button!" :group 'ecb-general :group 'ecb-most-important :type '(radio (const :tag "Left/topmost edit-window" :value left-top) (const :tag "Last edit-window with point" :value last-point)))

(defcustom ecb-common-tree-buffer-after-create-hook nil "\
*Local hook running at the end of each tree-buffer creation.
Every function of this hook is called once without arguments direct after
creating a tree-buffer of ECB and it's local key-map. So for example a function
could be added which performs calls of `local-set-key' to define new
key-bindings for EVERY tree-buffer.

The following keys must not be rebind in all tree-buffers:
- <RET> and all combinations with <Shift> and <Ctrl>
- <TAB>
- `C-t'" :group 'ecb-tree-buffer :type 'hook)

;;;***

;;;### (autoloads (ecb-compilation-predicates ecb-compilation-major-modes ecb-compilation-buffer-names) "ecb-compilation" "ecb/ecb-compilation.el")
(defconst custom-define-current-source-file "ecb-compilation.el")

(defcustom ecb-compilation-buffer-names (backquote (("*Calculator*") ("*vc*") ("*vc-diff*") (\, (if ecb-running-xemacs '("\\*Apropos.*\\*" . t) '("*Apropos*"))) ("*Occur*") ("*shell*") ("\\*[cC]ompilation.*\\*" . t) ("\\*i?grep.*\\*" . t) ("*JDEE Compile Server*") (\, (if ecb-running-xemacs '("\\*Help.*\\*" . t) '("*Help*"))) ("*Completions*") ("*Backtrace*") ("*Compile-log*") ("*bsh*") ((\, (if ecb-running-xemacs " *Message-Log*" "*Messages*"))))) "\
*Additional buffer names that should be displayed in the compile-window.
Buffer names can either be defined as strings or as regexps. If the
buffer-name of a buffer matches one of the defined string or regexp then it
will be displayed in the compile-window of ECB even if `compilation-buffer-p'
says nil for this buffer.

It is not recommended to add the name of eshell-buffers to this list because
ECB already handles the eshell-integration as best as possible.

See also the options `ecb-compilation-major-modes' and
`ecb-compilation-predicates'." :group 'ecb-compilation :group 'ecb-most-important :type '(repeat (cons (string :tag "Buffer name") (boolean :tag "Handled as regexp"))))

(defcustom ecb-compilation-major-modes '(compilation-mode) "\
*Additional major-mode that should be displayed in the compile-window.
All buffers of a major-mode contained in this list are displayed in the
compile-window even if `compilation-buffer-p' says nil for such a buffer.

It is not recommended to add `eshell-mode' to this list because ECB already
handles the eshell-integration as best as possible." :group 'ecb-compilation :type '(repeat (symbol :tag "major-mode name")))

(defcustom ecb-compilation-predicates '(comint-check-proc) "\
*Predicates when a buffer should be treated as compilation-buffer.
Every element of this list has to be a function or lambda-expression which
gets as argument a buffer-object and which has to return not nil when this
buffer should be treated as compilation-buffer (even if
`compilation-buffer-p' says nil) and therefore be displayed in the
compile-window of ECB (if there is any).

In combination with the values of `ecb-compilation-buffer-names' and
`ecb-compilation-major-modes' ECB decides when a buffer is displayed in the
compile-window.

Default value is the function `comint-check-proc' which returns not nil when
the buffer is related to a living process." :group 'ecb-compilation :type '(repeat (symbol :tag "Compilation predicate")))

;;;***

;;;### (autoloads (ecb-create-layout-frame-height ecb-create-layout-frame-width ecb-create-layout-file ecb-create-layout) "ecb-create-layout" "ecb/ecb-create-layout.el")
(defconst custom-define-current-source-file "ecb-create-layout.el")

(defgroup ecb-create-layout nil "Settings for creating new ECB-layouts." :group 'ecb-layout :prefix "ecb-create-layout-")

(defcustom ecb-create-layout-file "~/.ecb-user-layouts.el" "\
*File where all layouts created by `ecb-create-new-layout' are stored." :group 'ecb-create-layout :type 'file)

(defcustom ecb-create-layout-frame-width 110 "\
*Frame width of the layout creation frame." :group 'ecb-create-layout :type 'integer)

(defcustom ecb-create-layout-frame-height 42 "\
*Frame height of the layout creation frame." :group 'ecb-create-layout :type 'integer)

;;;***

;;;### (autoloads (ecb-cycle) "ecb-cycle" "ecb/ecb-cycle.el")
(defconst custom-define-current-source-file "ecb-cycle.el")

(defgroup ecb-cycle nil "Setting for cycling through misc ECB buffers." :group 'ecb :prefix "ecb-cycle-")

;;;***

;;;### (autoloads (ecb-eshell-synchronize ecb-eshell-auto-activate ecb-eshell-fit-window-to-command-output ecb-eshell-enlarge-when-eshell ecb-eshell) "ecb-eshell" "ecb/ecb-eshell.el")
(defconst custom-define-current-source-file "ecb-eshell.el")

(defgroup ecb-eshell nil "Settings for eshell integration within the ECB." :group 'ecb :prefix "ecb-eshell-")

(defcustom ecb-eshell-enlarge-when-eshell t "\
*Enlarge the compile-window if it is selected by `eshell'.
This takes only effect if the command `eshell' is called!" :group 'ecb-eshell :type 'boolean)

(defcustom ecb-eshell-fit-window-to-command-output t "\
*Fit the compile-window after an eshell-command to the output.
This is done by the function `ecb-eshell-fit-window-to-output' which is added
to `eshell-post-command-hook' ie. which is running autom. after each
eshell-command." :group 'ecb-eshell :type 'boolean)

(defcustom ecb-eshell-auto-activate nil "\
*Startup the eshell and display it in the compile-window.
If current layout does not display a compile-window (see
`ecb-compile-window-height') then nothing is done." :group 'ecb-eshell :type 'boolean)

(defcustom ecb-eshell-synchronize t "\
*Synchronize eshell with the default-directory of current source-buffer.
The synchronization is done by `ecb-eshell-current-buffer-sync' which can be
called interactively but normally it is called autom. by the
`ecb-current-buffer-sync-hook'." :group 'ecb-eshell :type 'boolean)

;;;***

;;;### (autoloads (ecb-mode-line-data-face ecb-mode-line-prefix-face ecb-mode-line-win-nr-face ecb-directory-not-accessible-face ecb-source-read-only-face ecb-source-in-directories-buffer-face ecb-tag-header-face ecb-history-face ecb-method-non-semantic-face ecb-method-face ecb-source-face ecb-directory-face ecb-history-general-face ecb-methods-general-face ecb-sources-general-face ecb-directories-general-face ecb-tree-guide-line-face ecb-faces ecb-face-options) "ecb-face" "ecb/ecb-face.el")
(defconst custom-define-current-source-file "ecb-face.el")

(defgroup ecb-face-options nil "Settings for all faces used in ECB." :group 'ecb :prefix "ecb-")

(defgroup ecb-faces nil "Definitions of all ECB-faces" :group 'ecb-face-options :group 'faces :prefix "ecb-")

(defcustom ecb-tree-guide-line-face 'ecb-tree-guide-line-face "\
*Face for the guide-lines in the tree-buffers." :group 'ecb-face-options)

(defcustom ecb-directories-general-face 'ecb-default-general-face "\
*Basic face for the ECB directories buffer.
This defines the basic face the whole directory buffer should displayed with.
If the face 'ecb-default-general-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-general-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-directories :type '(radio (const :tag "Use ecb-default-general-face" :value ecb-default-general-face) (face :tag "Special face" :value ecb-directories-general-face)))

(defcustom ecb-sources-general-face 'ecb-default-general-face "\
*Basic face for the ECB sources buffer.
This defines the basic face the whole sources buffer should displayed with. If
the face 'ecb-default-general-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-general-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-sources :type 'face :type '(radio (const :tag "Use ecb-default-general-face" :value ecb-default-general-face) (face :tag "Special face" :value ecb-sources-general-face)))

(defcustom ecb-methods-general-face 'ecb-default-general-face "\
*Basic face for the ECB methods buffer.
This defines the basic face the whole methods buffer should displayed with. If
the face 'ecb-default-general-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-general-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-methods :type '(radio (const :tag "Use ecb-default-general-face" :value ecb-default-general-face) (face :tag "Special face" :value ecb-methods-general-face)))

(defcustom ecb-history-general-face 'ecb-default-general-face "\
*Basic face for the ECB directory buffer.
This defines the basic face the whole history buffer should displayed with. If
the face 'ecb-default-general-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-general-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-history :type '(radio (const :tag "Use ecb-default-general-face" :value ecb-default-general-face) (face :tag "Special face" :value ecb-history-general-face)))

(defcustom ecb-directory-face 'ecb-default-highlight-face "\
*Face used for highlighting current directory in the directories-buffer.
If the face 'ecb-default-highlight-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-highlight-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-directories :type '(radio (const :tag "Use ecb-default-highlight-face" :value ecb-default-highlight-face) (face :tag "Special face" :value ecb-directory-face)))

(defcustom ecb-source-face 'ecb-default-highlight-face "\
*Face used for highlighting current source in the sources buffer.
If the face 'ecb-default-highlight-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-highlight-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-sources :type '(radio (const :tag "Use ecb-default-highlight-face" :value ecb-default-highlight-face) (face :tag "Special face" :value ecb-sources-face)))

(defcustom ecb-method-face 'ecb-default-highlight-face "\
*Face used for highlighting current tag in the methods buffer.
If the face 'ecb-default-highlight-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-highlight-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-methods :type '(radio (const :tag "Use ecb-default-highlight-face" :value ecb-default-highlight-face) (face :tag "Special face" :value ecb-method-face)))

(defcustom ecb-method-non-semantic-face 'speedbar-tag-face "\
*Face used for for displaying tags of non-semantic-sources.
Default is the face used by speedbar for tags.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-methods :type '(radio (const :tag "Use ecb-default-highlight-face" :value ecb-default-highlight-face) (face :tag "Special face" :value ecb-method-face)))

(defcustom ecb-history-face 'ecb-default-highlight-face "\
*Face used for highlighting current entry in the history buffer.
If the face 'ecb-default-highlight-face' is used then the display of all
ECB-tree-buffers can be changed by modifying only the face
'ecb-default-highlight-face'.

Changes take first effect after finishing and reactivating ECB!" :group 'ecb-face-options :group 'ecb-history :type '(radio (const :tag "Use ecb-default-highlight-face" :value ecb-default-highlight-face) (face :tag "Special face" :value ecb-history-face)))

(defcustom ecb-tag-header-face 'ecb-tag-header-face "\
*Face used for highlighting the tag header.
The tag header is the first line of the tag which is highlighted after
jumping to it by clicking onto a node in the methods buffer." :group 'ecb-face-options :group 'ecb-methods :type 'face)

(defcustom ecb-source-in-directories-buffer-face 'ecb-source-in-directories-buffer-face "\
*Face for source files in the directories buffer." :group 'ecb-directories :group 'ecb-face-options :type 'face)

(defcustom ecb-source-read-only-face 'ecb-source-read-only-face "\
*Face for read-only sources." :group 'ecb-sources :group 'ecb-directories :group 'ecb-face-options :type 'face)

(defcustom ecb-directory-not-accessible-face 'ecb-directory-not-accessible-face "\
*Face for not accessible dirs in the directories buffer." :group 'ecb-directories :group 'ecb-face-options :type 'face)

(defcustom ecb-mode-line-win-nr-face 'ecb-mode-line-win-nr-face "\
*Face used for the window-number in the mode-line.
See `ecb-mode-line-display-window-number'. For XEmacs the face should inherit
from the face 'modeline (see `set-face-parent')!" :group 'ecb-mode-line :group 'ecb-face-options :type 'face)

(defcustom ecb-mode-line-prefix-face 'ecb-mode-line-prefix-face "\
*Face used for the prefix in the mode-line.
See `ecb-mode-line-prefixes'. For XEmacs the face should inherit from the face
'modeline (see `set-face-parent')!" :group 'ecb-mode-line :group 'ecb-face-options :type 'face)

(defcustom ecb-mode-line-data-face 'ecb-mode-line-data-face "\
*Face used for the data in the mode-line.
See `ecb-mode-line-data'. For XEmacs the face should inherit from the face
'modeline (see `set-face-parent')!" :group 'ecb-mode-line :group 'ecb-face-options :type 'face)

;;;***

;;;### (autoloads (ecb-vc-supported-backends ecb-vc-state-mapping ecb-vc-xemacs-exclude-remote-cvs-repository ecb-vc-directory-exclude-regexps ecb-vc-enable-support ecb-history-buffer-after-create-hook ecb-sources-buffer-after-create-hook ecb-directories-buffer-after-create-hook ecb-history-menu-sorter ecb-sources-menu-sorter ecb-directories-menu-sorter ecb-history-menu-user-extension-function ecb-history-menu-user-extension ecb-sources-menu-user-extension-function ecb-sources-menu-user-extension ecb-directories-menu-user-extension-function ecb-directories-menu-user-extension ecb-history-item-name ecb-kill-buffer-clears-history ecb-history-sort-ignore-case ecb-history-sort-method ecb-history-exclude-file-regexps ecb-history-buffer-name ecb-sources-sort-ignore-case ecb-sources-sort-method ecb-show-source-file-extension ecb-source-file-regexps ecb-sources-exclude-cvsignore ecb-sources-buffer-name ecb-auto-expand-directory-tree ecb-excluded-directories-regexps ecb-directories-buffer-name ecb-read-only-check-exclude-regexps ecb-sources-perform-read-only-check ecb-after-directory-change-hook ecb-prescan-directories-exclude-regexps ecb-prescan-directories-for-emptyness ecb-host-accessible-check-valid-time ecb-ping-options ecb-ping-program ecb-cache-directory-contents-not ecb-cache-directory-contents ecb-directories-update-speedbar ecb-show-sources-in-directories-buffer ecb-display-default-dir-after-start ecb-add-path-for-not-matching-files ecb-source-path ecb-version-control ecb-history ecb-sources ecb-directories) "ecb-file-browser" "ecb/ecb-file-browser.el")
(defconst custom-define-current-source-file "ecb-file-browser.el")

(defgroup ecb-directories nil "Settings for the directories-buffer in the Emacs code browser." :group 'ecb :prefix "ecb-")

(defgroup ecb-sources nil "Settings for the sources-buffers in the Emacs code browser." :group 'ecb :prefix "ecb-")

(defgroup ecb-history nil "Settings for the history-buffer in the Emacs code browser." :group 'ecb :prefix "ecb-")

(defgroup ecb-version-control nil "Settings for the version-control support in the ECB." :group 'ecb :prefix "ecb-")

(defcustom ecb-source-path nil "\
*Paths where to find code sources.
Each path can have an optional alias that is used as it's display name. If no
alias is set, the path is used as display name.

Lisp-type of this option: The value must be a list L whereas each element of L
is either
- a simple string which has to be the full path of a directory (this string
  is displayed in the directory-browser of ECB) or
- a 2-element list whereas the first element is the full path of a directory
  (string) and the second element is an arbitrary alias (string) for this
  directory which is then displayed instead of the underlying directory." :group 'ecb-directories :group 'ecb-most-important :initialize 'custom-initialize-default :set (function (lambda (symbol value) (set symbol value) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode (functionp 'ecb-update-directories-buffer)) (ecb-update-directories-buffer)))) :type '(repeat (choice :tag "Display type" :menu-tag "Display type" (directory :tag "Path") (list :tag "Path with alias" (directory :tag "Path") (string :tag "Alias")))))

(defcustom ecb-add-path-for-not-matching-files '(t) "\
*Add path of a file to `ecb-source-path' if not already contained.
This is done during the auto. windows synchronization which happens if a file
is opened not via the file/directory-browser of ECB. In such a situation ECB
adds the path of the new file auto. to `ecb-source-path' at least temporally
for the current Emacs session. This option defines two things:
1. Should only the root-part (which means for Unix-like systems always '/'
   and for windows-like systems the drive) of the new file be added as
   source-path to `ecb-source-path' or the whole directory-part? For
   remote-files (e.g. tramp, ange-ftp- or efs-files) the root-part is the
   complete host-part + the root-dir at that host (example:
   /berndl@ecb.sourceforge.net:/ would be the root-part of
   /berndl@ecb.sourceforge.net:/tmp/test.txt).
2. Should this path be added for future sessions too?

The value of this option is a cons-cell where the car is a boolean for 1. and
the cdr is a boolean for 2.

A value of not nil for the car (1.) is reasonably if a user often opens files
not via the ECB-browser which are not located in any of the paths of
`ecb-source-path' because then only one path for each drive (windows) or the
root-path (unix) is added to the directory buffer of ECB." :group 'ecb-directories :type '(cons (boolean :tag "Add only root path") (boolean :tag "Ask for saving for future sessions")))

(defcustom ecb-display-default-dir-after-start t "\
*Automatically display current default-directory after activating ECB.
If a file-buffer is displayed in the edit-window then ECB synchronizes its
tree-buffers to this file-buffer - at least if the option `ecb-window-sync' it
not nil. So for this situation `ecb-display-default-dir-after-start' takes no
effect but this option is for the case if no file-buffer is displayed in the
edit-window after startup:

If true then ECB selects autom. the current default-directory after activation
even if no file-buffer is displayed in the edit-window. This is useful if ECB
is autom. activated after startup of Emacs and Emacs is started without a
file-argument. So the directory from which the startup has performed is auto.
selected in the ECB-directories buffer and the ECB-sources buffer displays the
contents of this directory." :group 'ecb-directories :type 'boolean)

(defcustom ecb-show-sources-in-directories-buffer '("left7" "left13" "left14" "left15") "\
*Show source files in directories buffer.
The value is either 'always or 'never or a list of layout-names for which
layouts sources should be displayed in the directories window." :group 'ecb-directories :initialize 'custom-initialize-default :set (function (lambda (symbol value) (set symbol value) (if (and ecb-minor-mode (functionp 'ecb-set-selected-directory) ecb-path-selected-directory) (ecb-set-selected-directory ecb-path-selected-directory t)))) :type '(radio (const :tag "Always" :value always) (const :tag "Never" :value never) (repeat :tag "With these layouts" (string :tag "Layout name"))))

(defcustom ecb-directories-update-speedbar 'auto "\
*Update an integrated speedbar after selecting a directory.
If not nil then an integrated speedbar will be updated after selecting a
directory in the ECB-directories-buffer so the speedbar displays the contents
of that directory.

Of course this option makes only sense if the integrated speedbar is displayed
in addition to the ECB-directories-buffer.

This option can have the following values:
- t: Always update speedbar.
- nil: Never update speedbar.
- auto: Update when senseful (see scenarios below)
- <function>: A user-defined function. The function is called after a
  directory is selected, gets the selected directory as argument and has to
  return nil if the the integrated speedbar should NOT be updated.

Two example-scenarios where different values for this option can be senseful:

If `ecb-show-sources-in-directories-buffer' is not nil or you have a layout
where an ECB-sources-buffer is visible then you probably want to use the
ECB-directories-buffer (and/or the ECB-sources-buffer) for directory- and
file-browsing. If you have in addition an integrated speedbar running then you
probably want to use speedbar instead of the ECB-methods-buffer for
source-content-browsing. In this case you probably want the speedbar not be
updated because you do not need speedbar reflecting the current-directory
contents but only the contents of the currently selected source-file and the
integrated speedbar updates itself autom. for the latter one!

If `ecb-show-sources-in-directories-buffer' is nil and there is also no
ECB-sources-buffer visible in the current layout then you probably want to use
an integrated speedbar for browsing directory-contents (i.e. the files) and
file-contents (instead of the ECB-methods-buffer for example). In this case
you probably want the speedbar updated because you need speedbar reflecting
the current-directory contents so you can select files.

The value 'auto (see above) takes exactly these two scenarios into account." :group 'ecb-directories :type '(radio (const :tag "Always" :value t) (const :tag "Never" :value nil) (const :tag "Automatic" :value auto) (function :tag "Custom function")))

(defcustom ecb-cache-directory-contents '(("^/\\([^:/]*@\\)?\\([^@:/]*\\):.*" . 0) (".*" . 50)) "\
*Cache contents of certain directories.
This can be useful if `ecb-source-path' contains directories with many files
and subdirs, especially if these directories are mounted net-drives (\"many\"
means here something > 1000, dependent of the speed of the net-connection and
the machine). Or if it contains remote-source-paths which means paths in the
sense of tramp, ange-ftp or efs. For these directories actualizing the
sources- and/or directories- buffer of ECB (if displayed in current layout!)
can slow down dramatically so a caching increases speed a lot.

The value of this option is a list where the each element is a cons-cell and
looks like:
  (<dir-regexp> . <filenumber threshold>)
<dir-regexp>: Regular expression a directory must match to be cached.
<filenumber threshold>: Number of directory contents must exceed this number.

A directory will only be cached if and only if the directory-name matches
one regexp of this option and its content-number exceeds the related
threshold AND the directory-name does not match and regexp of
`ecb-cache-directory-contents-not'!

The cache entry for a certain directory will be refreshed and actualized only
by using the POWER-click (see `ecb-primary-secondary-mouse-buttons') in the
directories-buffer of ECB.

Default-value: ECB caches the contents of all remote directories regardless of
the size and all other directories if more than 50 entries are contained.

Examples:

An entry (\"/usr/home/john_smith/bigdir*\" . 1000) means the contents of
every subdirectory of the home-directory of John Smith will be cached if the
directory contains more than 1000 entries and its name begins with \"bigdir\".

An entry (\".*\" . 1000) caches every directory which has more than 1000
entries.

An entry (\"^/\\\\([^:/]*@\\\\)?\\\\([^@:/]*\\\\):.*\" . 0) caches every
remote (in the sense of tramp, ange-ftp or efs) directory regardless of the
number of entries.

Please note: If you want your home-dir being cached then you MUST NOT use
\"~\" because ECB tries always to match full path-names!" :group 'ecb-directories :group 'ecb-most-important :type (backquote (repeat (cons (regexp :tag "Directory-regexp") (integer :tag "Filenumber threshold" :value 1000)))))

(defcustom ecb-cache-directory-contents-not nil "\
*Do not cache the contents of certain directories.
The value of this option is a list where the each element is a regular
expression a directory must match if it should not being cached.

If a directory-name matches at least one of the regexps of this option the
directory-contents will never being cached. See `ecb-cache-directory-contents'
to see when a directory will be cached.

This option can be useful when normally all directories with a certain amount
of content (files and subdirs) should be cached but some special directories
not. This can be achieved by:
- setting `ecb-cache-directory-contents' to (\".*\" . 500): Caches all
  directories with more then 500 entries
- setting `ecb-cache-directory-contents-not' to a value which matches these
  directories which should not being cached (e.g. (\"/usr/home/john_smith\")
  excludes the HOME-directory of John Smith from being cached).

Please note: If you want your home-dir exclude from being cached then you MUST
NOT use \"~\" because ECB tries always to match full path-names!" :group 'ecb-directories :type (backquote (repeat (regexp :tag "Directory-regexp"))))

(defcustom ecb-ping-program "ping" "\
Program to send network test packets to a host.
See also `ecb-ping-options'." :group 'ecb-directories :type 'string)

(defcustom ecb-ping-options (if (eq system-type 'windows-nt) (list "-n" "1") (list "-c" "1")) "\
List of options for the ping program.
These options can be used to limit how many ICMP packets are emitted. Ping is
used to test if a remote host of a remote path (e.g. a tramp-, ange-ftp- or
efs-path) is accessible. See also `ecb-ping-program'." :group 'ecb-directories :type '(repeat string))

(defcustom ecb-host-accessible-check-valid-time nil "\
Time in seconds a cached accessible-state of a remote host is valid.
This option is a list where each element specifies how long for a certain
remote host the cached ping-state (i.e. if the host is accessible or not)
should be valid. During this time-intervall ECB pings such a remote host only
once, all other checks use the cached value of that real check. But it the
cached value is older than the value of this option ECB will ping again.

Per default ECB discards after 1 minute the cached ping-state of each remote
host. But if you are sure that a certain remote host is always accessible
\(i.e. means in consequence that you are always online when working with ECB
and remote-paths) then add an entry to this option with a high valid-interval.

Examples: An entry (\".*sourceforge.*\" . 3600) ensures that all remote hosts
machting the string \"sourceforge\" will only once pinged during one hour. Or
\(\".*\" . 300) would ensure that every remote host would be pinged only once
during 5 minutes." :group 'ecb-directories :type '(repeat (cons (regexp :tag "Remote host regexp") (integer :tag "Valid interval"))))

(defcustom ecb-prescan-directories-for-emptyness 'unless-remote "\
*Prescan directories for emptyness.
ECB does this so directories are displayed as empty in the directories-buffer
even without user-interaction (i.e. in previous ECB-versions the emptyness of
a directory has been first checked when the user has clicked onto a
directory). ECB optimizes this check as best as possible but if a directory
contains a lot of subdirectories which contain in turn a lot of entries, then
expanding such a directory or selecting it would take of course more time as
without this check - at least at the first time (all following selects of a
directory uses the cached information if its subdirectories are empty or not).
Therefore ECB performs this check stealthy (see `ecb-stealthy-tasks-delay')
so normally there should no performance-decrease or additional waiting-time
for the user. There is one exception: For remote directories (in the sense of
tramp, ange-ftp, or efs) this check can descrease performance even if
performed stealthy and interruptable. Therefore this option offers three
possible settings:

  t: Switch on this feature

  'unless-remote: Switch on this feature but not for remote directories. The
  term \"remote\" means here directories which are used via tramp, ange-ftp or
  efs. So mounted directories are counted not as remote directories here even
  if such a directory is maybe hosted on a remote machine. But normally only
  directories in a LAN are mounted so there should be no performance-problems
  with such mounted directories.

  nil: Switch off this feature completely.

The option `ecb-prescan-directories-exclude-regexps' offers are more fine
granularity to exclude certain directories from this prescan." :group 'ecb-directories :group 'ecb-most-important :type '(radio (const :tag "Switch on" :value t) (const :tag "Switch off for remote directories" :value unless-remote) (const :tag "Switch off completely" :value nil)))

(defcustom ecb-prescan-directories-exclude-regexps nil "\
*Which directories should be excluded from the empty-prescan.
If a directory matches any of the regexps of this option it will not be
prescanned for emptyness - This option takes only effect if
`ecb-prescan-directories-for-emptyness' is not nil." :group 'ecb-directories :type '(repeat (regexp :tag "Directory-regexp")))

(defcustom ecb-after-directory-change-hook nil "\
*Hook which run directly after the selected directory has changed.
This means not onyl after a click onto a directory in the directory-window of
ECB but it means this hook runs always when the current directory changes
regardless of the trigger of this change. So for example it runs also when you
just switches from one buffer to another via `switch-to-buffer' or
`switch-to-buffer-other-window' and the directory of these filebuffers is
different but only when auto-synchronizing of the ECB-windows is on (see
`ecb-window-sync'). It runs not when switching between buffers and the
associated files reside in the same directory.

Each function added to this hook will be called with two arguments: The
directory which was current _before_ the directory-change-trigger and the
directory which was now the current (i.e. after the trigger).

Example: If you switch from a filebuffer \"~/.emacs\" to a filebuffer
\"/tmp/test.txt\" then the functions of this hook will be called with the
two arguments \"~\" and \"/tmp\"." :group 'ecb-directories :type 'hook)

(defcustom ecb-sources-perform-read-only-check 'unless-remote "\
*Check if source-items in the tree-buffers are read-only.
If a sourcefile is read-only then it will be displayed with that face set in
the option `ecb-source-read-only-face'.

Because this check can be take some time if files are used via a mounted
net-drive ECB performs this check stealthy (see `ecb-stealthy-tasks-delay')
so normally there should no performance-decrease or additional waiting-time
for the user. But to get sure this option offers three choices: t,
'unless-remote and nil. See `ecb-prescan-directories-for-emptyness' for an
explanation for these three choices.

The option `ecb-read-only-check-exclude-regexps' offers are more fine
granularity to exclude the sources of certain directories from the read-only
state-check." :group 'ecb-sources :group 'ecb-directories :group 'ecb-most-important :type '(radio (const :tag "Switch on" :value t) (const :tag "Switch off for remote directories" :value unless-remote) (const :tag "Switch off completely" :value nil)))

(defcustom ecb-read-only-check-exclude-regexps nil "\
*Which directories should be excluded from the sources-read-only-check.
If a directory matches any of the regexps of this option their sources will
not be checked if they are writable - This option takes only effect if
`ecb-sources-perform-read-only-check' is not nil." :group 'ecb-sources :group 'ecb-directories :type '(repeat (regexp :tag "Directory-regexp")))

(defcustom ecb-directories-buffer-name " *ECB Directories*" "\
*Name of the ECB directory buffer.
Because it is not a normal buffer for editing you should enclose the name with
stars, e.g. \"*ECB Directories*\".

If it is necessary for you you can get emacs-lisp access to the buffer-object of
the ECB-directory-buffer by this name, e.g. by a call of `set-buffer'.

Changes for this option at runtime will take affect only after deactivating and
then activating ECB again!" :group 'ecb-directories :type 'string)

(defcustom ecb-excluded-directories-regexps '("^\\(CVS\\|\\.[^xX]*\\)$") "\
*Directories that should not be included in the directories list.
The value of this variable should be a list of regular expressions." :group 'ecb-directories :type '(repeat (regexp :tag "Directory-regexp")))

(defcustom ecb-auto-expand-directory-tree 'best "\
*Automatically expand the directory tree to the current source file.
There are three options:
- best: Expand the best-matching source-path
- first: Expand the first matching source-path
- nil: Do not automatically expand the directory tree." :group 'ecb-directories :type '(radio (const :tag "Best matching" :value best) (const :tag "First matching" :value first) (const :tag "No auto. expand" :value nil)))

(defcustom ecb-sources-buffer-name " *ECB Sources*" "\
*Name of the ECB sources buffer.
Because it is not a normal buffer for editing you should enclose the name with
stars, e.g. \"*ECB Sources*\".

If it is necessary for you you can get emacs-lisp access to the buffer-object of
the ECB-sources-buffer by this name, e.g. by a call of `set-buffer'.

Changes for this option at runtime will take affect only after deactivating and
then activating ECB again!" :group 'ecb-sources :type 'string)

(defcustom ecb-sources-exclude-cvsignore nil "\
*Specify if files contained in a .cvsignore should be excluded.
Value is a list of regular expressions or nil. If you want to exclude files
listed in a .cvsignore-file from being displayed in the ecb-sources-buffer
then specify a regexp for such a directory.

If you want to exclude the contents of .cvsignore-files for every directory
then you should add one regexp \".*\" which matches every directory.

If you never want to exclude the contents of .cvsignore-files then set this
option to nil. This is the default." :group 'ecb-sources :group 'ecb-directories :type '(repeat (regexp :tag "Directory-regexp")))

(defcustom ecb-source-file-regexps '((".*" ("\\(^\\(\\.\\|#\\)\\|\\(~$\\|\\.\\(elc\\|obj\\|o\\|class\\|lib\\|dll\\|a\\|so\\|cache\\)$\\)\\)") ("^\\.\\(emacs\\|gnus\\)$"))) "\
*Specifies which files are shown as source files.
This is done on directory-base, which means for each directory-regexp the
files to display can be specified. If more than one directory-regexp matches
the current selected directory then always the first one (and its related
file-exclude/include-regexps) is used! If no directory-regexp matches then all
files are displayed for the currently selected directory.

Important note: It is recommended that the *LAST* element of this list should
contain an always matching directory-regexp (\".*\")!

So the value of this option is a list of cons-cells where the car is a
directory regexp and the cdr is a 2 element list where the first element is a
list of exclude regexps and the second element is a list of include regexps. A
file is displayed in the sources-buffer of ECB iff: The file does not match
any of the exclude regexps OR the file matches at least one of the include
regexps.

But regardless of the value of this option a file F is never displayed in the
sources-buffer if the directory matches `ecb-sources-exclude-cvsignore'
and the directory contains a file .cvsignore which contains F as an entry!

There are three predefined and useful combinations of an exclude and include
regexp:
- All files
- All, but no backup, object, lib or ini-files (except .emacs and .gnus). This
  means all files except those starting with \".\", \"#\" or ending with
  \"~\", \".elc\", \".obj\", \".o\", \".lib\", \".dll\", \".a\", \".so\".
  (but including .emacs and .gnus)
- Common source file types (.c, .java etc.)
In addition to these predefined values a custom exclude and include
combination can be defined. Here each list must at least contain one regexp -
this can be a least the empty regexp \"\"!

Tips for the directory- and file-regexps: \"$^\" matches no files/directories,
\".*\" matches all files/directories." :group 'ecb-sources :group 'ecb-most-important :type '(repeat (cons :tag "Directory file-spec" (regexp :tag "Directory regexp") (choice :tag "Files to display" :menu-tag "Files to display" (const :tag "All files" :value (("") (""))) (const :tag "All, but no backups, objects, etc..." :value (("\\(^\\(\\.\\|#\\)\\|\\(~$\\|\\.\\(elc\\|obj\\|o\\|class\\|lib\\|dll\\|a\\|so\\|cache\\)$\\)\\)") ("^\\.\\(x?emacs\\|gnus\\)$"))) (const :tag "Common source file types" :value (("") ("\\(\\(M\\|m\\)akefile\\|.*\\.\\(java\\|el\\|c\\|cc\\|h\\|hh\\|txt\\|html\\|texi\\|info\\|bnf\\)\\)$"))) (list :tag "Custom" (repeat (regexp :tag "Exclude regexp" :value "")) (repeat (regexp :tag "Include regexp" :value "")))))))

(defcustom ecb-show-source-file-extension t "\
*Show the file extension of source files." :group 'ecb-sources :type 'boolean)

(defcustom ecb-sources-sort-method 'name "\
*Defines how the source files are sorted.
- 'name: Sorting by name.
- 'extension: Sorting first by extension and then by name.
- nil: No sorting, means source files are displayed in the sequence returned by
  `directory-files' (called without sorting).
See also `ecb-sources-sort-ignore-case'." :group 'ecb-sources :type '(radio (const :tag "By name" :value name) (const :tag "By extension" :value extension) (const :tag "No sorting" :value nil)))

(defcustom ecb-sources-sort-ignore-case t "\
*Ignore case for sorting the source-files of the Sources-buffer.
See also `ecb-sources-sort-method'." :group 'ecb-sources :type 'boolean)

(defcustom ecb-history-buffer-name " *ECB History*" "\
*Name of the ECB history buffer.
Because it is not a normal buffer for editing you should enclose the name with
stars, e.g. \"*ECB History*\".

If it is necessary for you you can get emacs-lisp access to the buffer-object of
the ECB-history-buffer by this name, e.g. by a call of `set-buffer'.

Changes for this option at runtime will take affect only after deactivating and
then activating ECB again!" :group 'ecb-history :type 'string)

(defcustom ecb-history-exclude-file-regexps '("TAGS$" "semantic\\.cache$") "\
*List of regexps which exclude source-files from being historized. Be aware
that each always full filenames (ie. incl. full path) are matched against
these regexps! Therefore be carefore with regexps beginning with ^!" :group 'ecb-history :type '(repeat (regexp :tag "Source-regexp")))

(defcustom ecb-history-sort-method 'name "\
*Defines how the entries in the history-buffer are sorted.
- 'name: Sorting by name.
- 'extension: Sorting first by extension and then by name.
- nil: No sorting, means the most recently used buffers are on the top of the
       history and the seldom used buffers at the bottom.
See also `ecb-history-sort-ignore-case'." :group 'ecb-history :type '(radio (const :tag "By name" :value name) (const :tag "By extension" :value extension) (const :tag "No sorting" :value nil)))

(defcustom ecb-history-sort-ignore-case t "\
*Ignore case for sorting the history-entries.
See also `ecb-history-sort-method'." :group 'ecb-history :type 'boolean)

(defcustom ecb-kill-buffer-clears-history nil "\
*Define if `kill-buffer' should also clear the history.
There are three options:
- auto: Removes automatically the corresponding history-entry after the buffer
  has been killed.
- ask: Asks, if the history-entry should be removed after the kill.
- nil: `kill-buffer' does not affect the history (this is the default)." :group 'ecb-history :type '(radio (const :tag "Remove history entry automatically" :value auto) (const :tag "Ask if history entry should be removed" :value ask) (const :tag "Do not clear the history" :value nil)))

(defcustom ecb-history-item-name 'buffer-name "\
*The name to use for items in the history buffer." :group 'ecb-history :type '(radio (const :tag "Buffer name" :value buffer-name) (const :tag "File name" :value file-name)))

(defcustom ecb-directories-menu-user-extension '(("Version Control" (ecb-dir-popup-cvs-status "CVS Status") (ecb-dir-popup-cvs-examine "CVS Examine") (ecb-dir-popup-cvs-update "CVS Update"))) "\
*Static user extensions for the popup-menu of the directories buffer.
Value is a list of elements of the following type: Each element defines a new
menu-entry and is either:

a) Menu-command: A list containing two sub-elements, whereas the first is the
   function (a function symbol) being called if the menu-entry is selected
   and the second is the name of the menu-entry.
b) Separator: A one-element-list and the element is the string \"---\": Then a
   non-selectable menu-separator is displayed.
c) Submenu: A list where the first element is the title of the submenu
   displayed in the main-menu and all other elements are either menu-commands
   (see a) or separators (see b) or another submenu (see c). This allows
   deep nested menu-submenu-structures. Currently a level of 4 is allowed but
   in general there could be an infinite depth of nesting but it makes no
   sense - if possible at all - to define infinite nested defcustom-types. So
   there is a limit of 4 levels but tis is not a hard limit: Just increase the
   value of the `ecb-max-submenu-depth' *BEFORE* first loading ECB!

The function of a menu-command must follow the following guidelines: Such a
function must be defined with the macro `tree-buffer-defpopup-command! This
macro defines a new popup-command whereas the newly defined command gets one
argument NODE. See the docstring of `tree-buffer-defpopup-command' for further
details.

Example for the definition of such a popupmenu-command:

\(tree-buffer-defpopup-command ecb-my-special-dir-popup-function
  \"Prints the name of the directory of the node under point.\"
  (let ((node-data=dir (tree-node-get-data node)))
     (message \"Dir under node: %s\" node-data=dir)))

Per default the static user-extensions are added at the beginning of the
built-in menu-entries of `ecb-directories-menu' but the whole menu can be
re-arranged with `ecb-directories-menu-sorter'.

These menu-extensions are static. A dynamic menu-extension can be achieved via
`ecb-directories-menu-user-extension-function'." :group 'ecb-directories :type (ecb-create-menu-user-ext-type 1 ecb-max-submenu-depth))

(defcustom ecb-directories-menu-user-extension-function nil "\
*Dynamic user extensions for the popup-menu of the directories buffer.
A function which has to return a list in the same format like the option
`ecb-directories-menu-user-extension'. This function is called when the user
opens the popup-menu for the directories buffer.

Per default the dynamic user-extensions are added in front of the static
extensions of `ecb-directories-menu-user-extension' but the whole menu can be
re-arranged with `ecb-directories-menu-sorter'." :group 'ecb-directories :type 'function)

(defcustom ecb-sources-menu-user-extension '(("Version control" (ecb-file-popup-ediff-revision "Ediff against revision") ("---") (ecb-file-popup-vc-next-action "Check In/Out") (ecb-file-popup-vc-log "Revision history") (ecb-file-popup-vc-annotate "Annotate") (ecb-file-popup-vc-diff "Diff against last version") ("---") (ecb-file-popup-vc-refresh-file "Recompute state for file") (ecb-file-popup-vc-refresh-dir "Recompute state for whole dir"))) "\
*Static user extensions for the popup-menu of the sources buffer.
For further explanations see `ecb-directories-menu-user-extension'.

The node-argument of a menu-function contains as data the filename of the
source for which the popup-menu has been opened.

Per default the static user-extensions are added at the beginning of the
built-in menu-entries of `ecb-sources-menu' but the whole menu can be
re-arranged with `ecb-sources-menu-sorter'." :group 'ecb-sources :type (ecb-create-menu-user-ext-type 1 ecb-max-submenu-depth))

(defcustom ecb-sources-menu-user-extension-function nil "\
*Dynamic user extensions for the popup-menu of the sources buffer.
A function which has to return a list in the same format like the option
`ecb-sources-menu-user-extension'. This function is called when the user
opens the popup-menu for the sources buffer.

Per default the dynamic user-extensions are added in front of the static
extensions of `ecb-sources-menu-user-extension' but the whole menu can be
re-arranged with `ecb-sources-menu-sorter'." :group 'ecb-sources :type 'function)

(defcustom ecb-history-menu-user-extension '(("Version control" (ecb-file-popup-ediff-revision "Ediff against revision") ("---") (ecb-file-popup-vc-next-action "Check In/Out") (ecb-file-popup-vc-log "Revision history") (ecb-file-popup-vc-annotate "Annotate") (ecb-file-popup-vc-diff "Diff against last version") ("---") (ecb-file-popup-vc-refresh-file "Recompute state for file") (ecb-file-popup-vc-refresh-all-files "Recompute state for whole history"))) "\
*Static user extensions for the popup-menu of the history buffer.
For further explanations see `ecb-directories-menu-user-extension'.

The node-argument of a menu-function contains as data the filename of the
source for which the popup-menu has been opened.

Per default the static user-extensions are added at the beginning of the
built-in menu-entries of `ecb-history-menu' but the whole menu can be
re-arranged with `ecb-history-menu-sorter'." :group 'ecb-history :type (ecb-create-menu-user-ext-type 1 ecb-max-submenu-depth))

(defcustom ecb-history-menu-user-extension-function nil "\
*Dynamic user extensions for the popup-menu of the history buffer.
A function which has to return a list in the same format like the option
`ecb-history-menu-user-extension'. This function is called when the user
opens the popup-menu for the history buffer.

Per default the dynamic user-extensions are added in front of the static
extensions of `ecb-history-menu-user-extension' but the whole menu can be
re-arranged with `ecb-history-menu-sorter'." :group 'ecb-history :type 'function)

(defcustom ecb-directories-menu-sorter nil "\
*Function which re-sorts the menu-entries of the directories buffer.
If a function then this function is called to re-arrange the menu-entries of
the combined menu-entries of the user-menu-extensions of
`ecb-directories-menu-user-extension' and the built-in-menu
`ecb-directories-menu'. If nil then no special sorting will be done and the
user-extensions are placed in front of the built-in-entries.

The function get one argument, a list of menu-entries. For the format of this
argument see `ecb-directories-menu-user-extension'. The function must return a
new list in the same format. Of course this function can not only re-arrange
the entries but also delete entries or add new entries." :group 'ecb-directories :type '(choice :tag "Menu-sorter" :menu-tag "Menu-sorter" (const :tag "No special sorting" :value nil) (function :tag "Sort-function" :value identity)))

(defcustom ecb-sources-menu-sorter nil "\
*Function which re-sorts the menu-entries of the directories buffer.
If a function then this function is called to sort the menu-entries of the
combined menu-entries of the user-menu-extensions of
`ecb-sources-menu-user-extension' and the built-in-menu
`ecb-sources-menu'. If nil then no special sorting will be done and the
user-extensions are placed in front of the built-in-entries.

For the guidelines for such a sorter-function see
`ecb-directories-menu-sorter'." :group 'ecb-sources :type '(choice :tag "Menu-sorter" :menu-tag "Menu-sorter" (const :tag "No special sorting" :value nil) (function :tag "Sort-function" :value identity)))

(defcustom ecb-history-menu-sorter nil "\
*Function which re-sorts the menu-entries of the directories buffer.
If a function then this function is called to sort the menu-entries of the
combined menu-entries of the user-menu-extensions of
`ecb-history-menu-user-extension' and the built-in-menu
`ecb-history-menu'. If nil then no special sorting will be done and the
user-extensions are placed in front of the built-in-entries.

For the guidelines for such a sorter-function see
`ecb-directories-menu-sorter'." :group 'ecb-history :type '(choice :tag "Menu-sorter" :menu-tag "Menu-sorter" (const :tag "No special sorting" :value nil) (function :tag "Sort-function" :value identity)))

(defcustom ecb-directories-buffer-after-create-hook nil "\
*Local hook running after the creation of the directories-buffer.
Every function of this hook is called once without arguments direct after
creating the directories-buffer of ECB and it's local key-map. So for example a
function could be added which performs calls of `local-set-key' to define new
key-bindings only for the directories-buffer of ECB.

The following keys must not be rebind in the directories-buffer:
<F2>, <F3> and <F4>" :group 'ecb-directories :type 'hook)

(defcustom ecb-sources-buffer-after-create-hook nil "\
*Local hook running after the creation of the sources-buffer.
Every function of this hook is called once without arguments direct after
creating the sources-buffer of ECB and it's local key-map. So for example a
function could be added which performs calls of `local-set-key' to define new
key-bindings only for the sources-buffer of ECB." :group 'ecb-sources :type 'hook)

(defcustom ecb-history-buffer-after-create-hook nil "\
*Local hook running after the creation of the history-buffer.
Every function of this hook is called once without arguments direct after
creating the history-buffer of ECB and it's local key-map. So for example a
function could be added which performs calls of `local-set-key' to define new
key-bindings only for the history-buffer of ECB." :group 'ecb-history :type 'hook)

(defcustom ecb-vc-enable-support 'unless-remote "\
*Enable support for version-control (VC) systems.
If on then in the directories-buffer (if the value of the option
`ecb-show-sources-in-directories-buffer' is on for current layout), the
sources-buffer and the history-buffer all file-items are displayed with an
appropriate icon in front of the item-name to indicate the VC-state of this
item. If off then no version-control-state checking is done.

Because this check can be take some time if files are managed by a not local
Version-control-server ECB performs this check stealthy (see
`ecb-stealthy-tasks-delay') so normally there should no performance-decrease
or additional waiting-time for the user. But to get sure this option offers
three choices: t, 'unless-remote and nil. See the option
`ecb-prescan-directories-for-emptyness' for an explanation for these three
choices.

The option `ecb-vc-directory-exclude-regexps' offers are more fine granularity
to exclude the sources of certain directories from the VC-state-check.

See `ecb-vc-supported-backends' how to customize the VC-support itself." :group 'ecb-version-control :group 'ecb-sources :group 'ecb-most-important :type '(radio (const :tag "Switch on" :value t) (const :tag "Switch off for remote directories" :value unless-remote) (const :tag "Switch off completely" :value nil)))

(defcustom ecb-vc-directory-exclude-regexps nil "\
*Which directories should be excluded from VC-state-check.
If a directory matches any of the regexps of this option the VC-state of its
sources will not be checked - This option takes only effect if
`ecb-vc-enable-support' is not nil." :group 'ecb-version-control :group 'ecb-sources :type '(repeat (regexp :tag "Directory-regexp")))

(defcustom ecb-vc-xemacs-exclude-remote-cvs-repository (if ecb-running-xemacs t nil) "\
*Exclude directories with a remote cvs-repository from VC-check.
This option takes only effect for XEmacs and is needed cause of the outdated
VC-package of XEmacs which offers no heuristic state-checking and also no
option `vc-cvs-stay-local'. So this option takes only effect if
`vc-cvs-stay-local' is not avaiable. In this case ECB treats directories which
are managed by CVS but have a remote repository as if the directory would be
not managed by CVS (so the files are not checked for their VC-state). This si
done to avoid blocking XEmacs when running full cvs-commands (e.g. \"cvs
status\") over the net.

Note: When ECB can find the option `vc-cvs-stay-local' then this option will
automatically take no effect regardless which Emacs-version is used." :group 'ecb-version-control :group 'ecb-sources :type 'boolean)

(defcustom ecb-vc-state-mapping '((up-to-date . up-to-date) (edited . edited) (locally-modified . edited) (needs-patch . needs-patch) (needs-checkout . needs-patch) (needs-merge . needs-merge) (unlocked-changes . unlocked-changes) (added . added) (locally-added . added) (ignored . ignored) (unknown . unknown)) "\
*Mapping from VC-state-values of the backends to VC-state-values of ECB.
ECB understands the following state-values:

  'up-to-date        The working file is unmodified with respect to the
                     latest version on the current branch, and not locked.

  'edited            The working file has been locally edited by the user. If
                     locking is used for the file, this state means that
                     the current version is locked by the calling user.

  'needs-patch       The file has not been edited by the user, but there is
                     a more recent version on the current branch stored
                     in the master file.

  'needs-merge       The file has been edited by the user, and there is also
                     a more recent version on the current branch stored in
                     the master file. This state can only occur if locking
                     is not used for the file.

  'unlocked-changes  The current version of the working file is not locked,
                     but the working file has been changed with respect
                     to that version. This state can only occur for files
                     with locking; it represents an erroneous condition that
                     should be resolved by the user.

  'added             The working file has already been added/registered to the
                     VC-system but not yet commited.

  'ignored           The version-control-system ignores this file (e.g.
                     because included in a .cvsignore-file in case of CVS).

  'unknown           The state of the file can not be retrieved; probably the
                     file is not under a version-control-system.

All state-values a check-vc-state-function of `ecb-vc-supported-backends' can
return must have a mapping to one of the ECB-state-values listed above. If for
a certain backend-VC-state no mapping can be found then per default 'edited is
assumed!

The default value of this option maps already the possible returned
state-values of `ecb-vc-state', `vc-state' and `vc-recompute-state' (both GNU
Emacs) and `vc-cvs-status' (Xemacs) to the ECB-VC-state-values." :group 'ecb-version-control :group 'ecb-sources :initialize 'custom-initialize-default :set (function (lambda (sym val) (set sym val) (ecb-vc-cache-clear))) :type '(repeat (cons (choice :tag "Backend VC-state" :menu-tag "Backend VC-state" (const :tag "up-to-date" :value up-to-date) (const :tag "edited" :value edited) (const :tag "locally-modified" :value locally-modified) (const :tag "needs-patch" :value needs-patch) (const :tag "needs-checkout" :value needs-checkout) (const :tag "needs-merge" :value needs-merge) (const :tag "unlocked-changes" :value unlocked-changes) (const :tag "added" :value added) (const :tag "locally-added" :value locally-added) (const :tag "ignored" :value ignored) (const :tag "unknown" :value unknown) (symbol :tag "Other...")) (choice :tag "ECB VC-state" :menu-tag "ECB VC-state" (const :tag "up-to-date" :value up-to-date) (const :tag "edited" :value edited) (const :tag "needs-patch" :value needs-patch) (const :tag "needs-merge" :value needs-merge) (const :tag "unlocked-changes" :value unlocked-changes) (const :tag "added" :value added) (const :tag "ignored" :value ignored) (const :tag "unknown" :value unknown)))))

(defcustom ecb-vc-supported-backends (delq nil (if ecb-running-xemacs (backquote ((ecb-vc-dir-managed-by-CVS . vc-cvs-status))) (backquote ((ecb-vc-dir-managed-by-CVS . ecb-vc-state) (ecb-vc-dir-managed-by-RCS . ecb-vc-state) (ecb-vc-dir-managed-by-SCCS . ecb-vc-state) (ecb-vc-dir-managed-by-SVN . ecb-vc-state))))) "\
*Define how to to identify the VC-backend and how to check the state.
The value of this option is a list containing cons-cells where the car is a
function which is called to identify the VC-backend for a DIRECTORY and the
cdr is a function which is called to check the VC-state of the FILEs contained
in DIRECTORY.

Identify-backend-function: It gets a full directory-name as argument - always
without ending slash (rsp. backslash for native Windows-XEmacs) - and has to
return a unique symbol for the VC-backend which manages that directory (e.g.
'CVS for the CVS-system or 'RCS for the RCS-system) or nil if the file is not
managed by a version-control-system.

Check-vc-state-function: It gets a full filename (ie. incl. the complete
directory-part) and has to return a symbol which indicates the VC-state of
that file. The possible returned values of such a check-vc-state-function have
to be mapped with `ecb-vc-state-mapping' to the allowed ECB-VC-state values.

ECB runs for a certain DIRECTORY all identify-backend-functions in that order
they are listed in this option. For the first which returns a value unequal
nil the associated check-state-function is used to retrieve the VC-state of
all sourcefiles in that DIRECTORY.

There is no need for the identify-backend-function or the
check-vc-state-function to cache any state because ECB automatically caches
internally all necessary informations for directories and files for best
possible performance.

To prepend ECB from checking the VC-state for any file set
`ecb-vc-enable-support' to nil.

Default value for GNU Emacs: Support for CVS, RCS, SCCS and Subversion (for
the later one the most recent version of the VC-package incl. the vc-svn
library is needed). To identify the VC-backend the functions
`ecb-vc-managed-by-CVS', `ecb-vc-managed-by-RCS' rsp. `ecb-vc-managed-by-SCCS'
rsp. `ecb-vc-managed-by-SVN' are used. For all four backends the function
`ecb-vc-state' of the VC-package is used.

Default value for XEmacs: XEmacs contains only a quite outdated VC-package,
especially there is no backend-independent check-vc-state-function available
\(like `vc-state' for GNU Emacs). Only for CVS a check-vc-state-function is
available: `vc-cvs-status'. Therefore ECB adds per default only support for
CVS and uses `ecb-vc-managed-by-CVS' rsp. `vc-cvs-status'. But read the
documentation of `ecb-vc-dir-managed-by-CVS'!

Example for GNU Emacs: If `vc-recompute-state' (to get real state-values not
only heuristic ones) should be used to check the state for CVS-managed files
and `vc-state' for all other backends then an element
\(ecb-vc-dir-managed-by-CVS . vc-recompute-state) should be added at the
beginning of this option." :group 'ecb-version-control :group 'ecb-sources :initialize 'custom-initialize-default :set (function (lambda (sym val) (set sym val) (ecb-vc-cache-clear))) :type '(repeat (cons (symbol :tag "Identify-backend-function") (symbol :tag "Check-state-function"))))

;;;***

;;;### (autoloads (ecb-help-html-path ecb-help-info-path ecb-show-help-format ecb-help) "ecb-help" "ecb/ecb-help.el")
(defconst custom-define-current-source-file "ecb-help.el")

(defgroup ecb-help nil "Settings for the ECB online help" :group 'ecb)

(defcustom ecb-show-help-format 'info "\
*The format `ecb-show-help' shows its online help.
Allowed values are 'info (for the Info format) and 'html (for HTML format).
If the value is 'html then `browse-url-browser-function' says which browser is
used.

Note: If you got ECB as a standard XEmacs-package maybe the
HTML-online-documentation is not included." :group 'ecb-help :group 'ecb-most-important :type '(choice :tag "Online-help format" :menu-tag "Online-help format" (const :tag "Info" :value info) (const :tag "Html" :value html)))

(defcustom ecb-help-info-path (concat (if ecb-running-xemacs (if (file-exists-p (concat ecb-ecb-dir ecb-help-info-subdir ecb-help-info-start-file)) ecb-help-info-subdir "../../info/") ecb-help-info-subdir) ecb-help-info-start-file) "\
*Path where the ECB online help in info format resides.
This must be the location of the file \"ecb.info\" which comes with the ECB
distribution. If is installed by unpacking the archive available on the ECB
web-site then this is the subdir `ecb-help-info-subdir' of the installation
directory of ECB. If it is installed as XEmacs-package (e.g. via the package
manager of XEmacs) then this is probably the directory \"../../info/\"
\(relativ to the Elisp directory of ECB).

The path can either be an absolute path or a path relative to the directory
where the Elisp files of ECB are.

Normally there should be no need to change this option!" :group 'ecb-help :type 'file)

(defcustom ecb-help-html-path (if (not ecb-running-xemacs) (concat ecb-help-html-subdir ecb-help-html-start-file) (cond ((file-exists-p (concat ecb-ecb-dir ecb-help-html-subdir ecb-help-html-start-file)) (concat ecb-help-html-subdir ecb-help-html-start-file)) ((file-exists-p (concat ecb-ecb-dir "../../html/" ecb-help-html-start-file)) (concat "../../html/" ecb-help-html-start-file)) ((file-exists-p (concat ecb-ecb-dir "../../html/ecb/index.html")) "../../html/ecb/index.html") (t (concat "../../etc/ecb/html/" ecb-help-html-start-file)))) "\
*Path where the ECB online help in HTML format resides.
This must be the location of the file \"index.html\" which comes with the ECB
distribution. If is installed by unpacking the archive available on the ECB
web-site then this is the subdir `ecb-help-html-subdir' of the installation
directory of ECB. If it is installed as XEmacs-package (e.g. via the package
manager of XEmacs) then this is probably either the directory \"../../html/\" or
\"../../etc/ecb/html/\" (both relative to the Elisp directory of ECB).

The path can either be an absolute path or a path relative to the directory
where the Elisp files of ECB are.

Normally there should be no need to change this option!" :group 'ecb-help :type 'file)

;;;***

;;;### (autoloads (ecb-jde-set-directories-buffer-to-jde-sourcepath ecb-jde-integration) "ecb-jde" "ecb/ecb-jde.el")
(defconst custom-define-current-source-file "ecb-jde.el")

(defgroup ecb-jde-integration nil "Settings for the JDEE-integration in the Emacs code browser." :group 'ecb :prefix "ecb-jde-")

(defcustom ecb-jde-set-directories-buffer-to-jde-sourcepath nil "\
*THIS FEATURE IS NOT YET FINISHED" :group 'ecb-jde-integration :type '(radio (const :tag "No" :value nil) (const :tag "Add" :value add) (const :tag "Replace" :value replace)))

;;;***

;;;### (autoloads (ecb-layout-debug-mode ecb-redraw-layout-before-hook ecb-redraw-layout-after-hook ecb-show-ecb-windows-after-hook ecb-show-ecb-windows-before-hook ecb-hide-ecb-windows-after-hook ecb-hide-ecb-windows-before-hook ecb-toggle-layout-sequence ecb-redraw-layout-quickly ecb-layout-window-sizes ecb-layout-always-operate-in-edit-window ecb-advice-window-functions-signal-error ecb-advice-window-functions ecb-other-window-behavior ecb-fix-window-size ecb-windows-height ecb-windows-width ecb-split-edit-window-after-start ecb-ignore-display-buffer-function ecb-ignore-special-display ecb-scroll-other-window-scrolls-compile-window ecb-enlarged-compilation-window-max-height ecb-compile-window-prevent-shrink-below-height ecb-maximize-ecb-window-after-selection ecb-compile-window-temporally-enlarge ecb-change-layout-preserves-compwin-state ecb-compile-window-width ecb-compile-window-height ecb-layout-name ecb-activate-before-new-frame-created-hook ecb-new-ecb-frame ecb-select-edit-window-on-redraw ecb-compilation ecb-layout) "ecb-layout" "ecb/ecb-layout.el")
(defconst custom-define-current-source-file "ecb-layout.el")

(defgroup ecb-layout nil "Settings for the screen-layout of the Emacs code browser." :group 'ecb :prefix "ecb-")

(defgroup ecb-compilation nil "Settings for the compile window of ECB." :group 'ecb-layout :prefix "ecb-")

(defcustom ecb-select-edit-window-on-redraw nil "\
*Select the first edit window on `ecb-redraw-layout'." :group 'ecb-layout :type 'boolean)

(defcustom ecb-new-ecb-frame nil "\
*Create a new frame at activation time of ECB." :group 'ecb-layout :group 'ecb-most-important :type 'boolean)

(defcustom ecb-activate-before-new-frame-created-hook nil "\
*Hook run before the new ECB-frame is created.
This has only an effect if `ecb-new-ecb-frame' is not nil (otherwise this
hook is not evaluated)." :group 'ecb-layout :type 'hook)

(defcustom ecb-layout-name "left8" "\
*Select a window layout of ECB.
Value is any arbitrary string. There are four different types of layouts:
left, right, top and left-right, which means the location of the
ECB-tree-windows in the ECB-frame. Currently there are 20 predefined layouts;
names see below. You can savely try out any of them by changing this value and
saving it only for the current session. If you are sure which layout you want
you can save it for future sessions. To get a picture of the layout for name
<name> call `ecb-show-layout-help'.

Currently available layouts:

+ Left layouts:
  left1 left2 left3 left4 left5 left6 left7 left8 left9 left10 left11 left12
  left13 left14 left15

+ Right layouts:
  right1

+ Top layouts:
  top1 top2

+ Left-right layouts:
  leftright1 leftright2 leftright3

Regardless of the settings you define here: If you have destroyed or
changed the ECB-screen-layout by any action you can always go back to this
layout with `ecb-redraw-layout'" :group 'ecb-layout :group 'ecb-most-important :initialize 'custom-initialize-default :set (function (lambda (symbol value) (ecb-load-layouts) (if (fboundp (intern (format "ecb-layout-function-%s" value))) (progn (setq ecb-last-selected-layout ecb-layout-name) (funcall ecb-layout-option-set-function symbol value)) (ecb-error "There is no layout with name %s available!" value)))) :type 'string)

(defcustom ecb-compile-window-height nil "\
*Height of the durable compilation-window of ECB.
If you want a compilation window shown at the bottom of the ECB-layout
then set here the height of it (Default is a height of 5). If you redraw the
current layout with `ecb-redraw-layout' then the compilation window (if any)
has the height you set here. If the number is less than 1.0 the height is a
fraction of the frame height.

If you do not set a durable compilation window then doing a compilation or
displaying temp-buffers (e.g. *Help*-buffers) splits temporally the edit
window vertically if the edit window is not splitted already or uses another
edit window temporally for compilation output if the edit window is already
splitted. This is the recommended value for this option because this is the
standard-behavior of Emacs.

Beware: If you set a durable compilation window then ECB displays all buffers
for which `ecb-compilation-buffer-p' returns not nil in that durable
compilation window. If a buffer which should being displayed there is not
displayed there then try to modify the options `ecb-compilation-buffer-names',
`ecb-compilation-major-modes' or `ecb-compilation-predicates' (in this
sequence).

See also the options `ecb-compile-window-temporally-enlarge' and
`ecb-enlarged-compilation-window-max-height' and also the command
`ecb-toggle-compile-window-height'!

ECB offers the functionality of such a durable compile-window regardless if
the special ECB-windows are visible or not (see the command
`ecb-toggle-ecb-windows').

Regardless of the settings you define here: If you have destroyed or
changed the ECB-screen-layout by any action you can always go back to this
layout with `ecb-redraw-layout'" :group 'ecb-compilation :group 'ecb-most-important :initialize 'custom-initialize-default :set (function (lambda (symbol value) (ecb-set-window-size-fixed nil) (set symbol value) (when (and (boundp 'ecb-minor-mode) ecb-minor-mode (frame-live-p ecb-frame)) (ecb-enable-temp-buffer-shrink-to-fit value) (let ((curr-frame (selected-frame))) (unwind-protect (progn (select-frame ecb-frame) (ecb-redraw-layout-full nil nil nil ecb-windows-hidden)) (select-frame curr-frame)))))) :type '(radio (const :tag "No compilation window" nil) (number :tag "Window height" :value 6)))

(defcustom ecb-compile-window-width 'frame "\
*Width of the compile-window.

Possible values are 'frame and 'edit-window.
With 'frame the compile-window looks like:

   -------------------------------------------------------
   |              |                                      |
   |  Directories |                                      |
   |              |                                      |
   |--------------|            edit-window(s)            |
   |              |                                      |
   |  Methods     |                                      |
   |              |                                      |
   -------------------------------------------------------
   |                                                     |
   |                    Compilation                      |
   |                                                     |
   -------------------------------------------------------


With 'edit-window the compile-window looks like:

   -------------------------------------------------------
   |              |                                      |
   |  Directories |                                      |
   |              |                                      |
   |--------------|            edit-window(s)            |
   |              |                                      |
   |  Methods     |                                      |
   |              |                                      |
   |              |---------------------------------------
   |              |                                      |
   |              |            Compilation               |
   |              |                                      |
   -------------------------------------------------------

This option takes only effect if `ecb-compile-window-height' is not nil!" :group 'ecb-compilation :group 'ecb-most-important :initialize 'custom-initialize-default :set (function (lambda (symbol value) (ecb-set-window-size-fixed nil) (set symbol value) (when (and (boundp 'ecb-minor-mode) ecb-minor-mode (frame-live-p ecb-frame)) (let ((curr-frame (selected-frame))) (unwind-protect (progn (select-frame ecb-frame) (ecb-redraw-layout-full nil nil nil ecb-windows-hidden)) (select-frame curr-frame)))))) :type '(radio (const :tag "Width of ECB-frame" :value frame) (const :tag "Width of edit-window" :value edit-window)))

(defcustom ecb-change-layout-preserves-compwin-state t "\
*Changing the layout preserves the state of the compile-window.
This is for example useful if the user toggles between several layouts (see
`ecb-toggle-layout') and wants to preserve the hidden-state of the
compile-window." :group 'ecb-compilation :type 'boolean)

(defcustom ecb-compile-window-temporally-enlarge 'after-display "\
*Let Emacs temporally enlarge the compile-window of the ECB-layout.
This option has only an effect if `ecb-compile-window-height' is not nil!

The following values are possible:
- 'after-display: After displaying a \"compilation-buffer\" (in the sense of
  `ecb-compilation-buffer-p'!) in the compile-window of ECB. For the max.
  height of the enlarged compile-window see the option
  `ecb-enlarged-compilation-window-max-height'.

- 'after-selection: selecting the `ecb-compile-window' auto. enlarges it and
  de-selecting (means leaving `ecb-compile-window') auto. shrinks it.
  Enlarging and shrinking the `ecb-compile-window' is done with
  `ecb-toggle-compile-window-height'. See also the documentation of this
  function!

- 'both: The combination of 'after-display and 'after-selection.

- nil: ECB fixes always the height of the `ecb-compile-window' at the value of
  `ecb-compile-window-height'.

To restore the ECB-layout after such a buffer-enlarge just call
`ecb-toggle-compile-window-height' or `ecb-redraw-layout'." :group 'ecb-compilation :type '(radio (const :tag "After displaying a buffer in the compile-window" :value after-display) (const :tag "After selecting the compile window" :value after-selection) (const :tag "Both of them" :value both) (const :tag "Never" :value nil)))

(defcustom ecb-maximize-ecb-window-after-selection nil "\
*If not nil maximize current tree-window after selection.
When selecting another not-tree-window after such an automatic maximizing all
tree-windows of current layout are displayed again. But a tree-window is not
maximized if either a node has been selected via primary- oder secondarc
mouse-button or the popup-menu of that tree-buffer has been opened." :group 'ecb-layout :type 'boolean)

(defcustom ecb-compile-window-prevent-shrink-below-height t "\
*Allow the compile-window to be shrunken below its height.
A non nil value means ECB prevents the compile-window from being shrunken
below the threshold of `ecb-compile-window-height' by displaying temp-buffers
\(e.g. *Help* etc.) or after running compilations or greps. But interactively
it is always allowed to shrink it to every height!

If nil then ECB does nothing to prevent being shrunken below the value of
`ecb-compile-window-height'.

Default is t." :group 'ecb-compilation :type 'boolean)

(defcustom ecb-enlarged-compilation-window-max-height 'best "\
*The max height of the compile-window after enlarging it.
The max height of the compilation window after enlarged by
`ecb-toggle-compile-window-height'. The following values are allowed:

'best:

ECB fits the height of the compile-window exactly to the size of its current
contents but never shrinks below the value of `ecb-compile-window-height' or
enlarges over the half of the frame-height of the ECB-frame. The values of the
options `compilation-window-height' and `temp-buffer-max-height' are taken
into account dependent of the current `major-mode' of the buffer in the
compile-window: If `compilation-mode' then `compilation-window-height' is used
otherwise `temp-buffer-max-height'.

'half:

1/2 the frame-height of the ECB-frame

Any number:

Max height in lines. If the number is less than 1.0 the height is a fraction
of the frame height (e.g. 0.33 results in a max-height of 1/3 the
frame-height)." :group 'ecb-compilation :type '(radio (const :tag "Compute best height" :value best) (const :tag "1/2 the frame height)" :value half) (number :tag "Height" :value 0.3)))

(defcustom ecb-scroll-other-window-scrolls-compile-window nil "\
*`scroll-other-window' scrolls always the compile-window.
For all details about the scroll-behavior of `scroll-other-window' see the
advice documentation of `other-window-for-scrolling'." :group 'ecb-compilation :type 'boolean)

(defcustom ecb-ignore-special-display 'compile-window "\
*Ignore special-display-handling.
This means, that all values of `special-display-function',
`special-display-buffer-names' and `special-display-regexps' are ignored
- only when durable compile window is used - i.e. if
  `ecb-compile-window-height' is not nil - this is the default value.
- always when ECB is active - that means no special-display-handling of
  buffers when ECB is active
- never, i.e. special-dislay-handling depends on the values of the options
  `special-display-function', `special-display-buffer-names' and
  `special-display-regexps'." :group 'ecb-layout :type '(radio (const :tag "When a durable compile-window is used" :value compile-window) (const :tag "Always" :value always) (const :tag "Never" nil)))

(defcustom ecb-ignore-display-buffer-function 'always "\
*Adviced `display-buffer' ignores `display-buffer-function'.
This means, that the adviced version of `display-buffer' (see
`ecb-advice-window-functions') ignores the value of `display-buffer-function'
when called for the `ecb-frame'. If this variable should not be ignored then
the function of `display-buffer-function' is completely responsible which
window is used for the buffer to display - no smart ECB-logic will help to
deal best with the ECB-window-layout! You can define if and when
`display-buffer-function' should be ignored:
- only when durable compile window is used - i.e. if
  `ecb-compile-window-height' is not nil
- always when ECB is active - that means ignore when ECB is active otherwise
  not - this is the default value
- never, the adviced version of `display-buffer' always uses the value of
  `display-buffer-function' if the value is a function." :group 'ecb-layout :type '(radio (const :tag "When a durable compile-window is used" :value compile-window) (const :tag "Always" :value always) (const :tag "Never" nil)))

(defcustom ecb-split-edit-window-after-start 'before-deactivation "\
*Sets how and if the edit window should be splitted after ECB-start.
But be aware: This option determines only if and how the edit-window should be
splitted at start-time of ECB. There are five different values allowed for
this option:
- nil: Do not split the edit-area of ECB after activation, i.e. there will be
  only one edit-window after starting ECB.
- 'horizontal: Split the edit-area in 2 edit-windows side by side.
- 'vertical: Split the edit-area in 2 edit-windows, one above the other.
- 'before-activation: Split the edit-area as before the ECB-start, i.e. the
  edit-area will have after start a window-layout as the whole frame had
  before the start of ECB.
- 'before-deactivation: Split the edit-area into a window-layout ECB had in
  its edit-area direct before the ECB-deactivation. This value preserves the
  full state between activations of ECB, i.e. the visibility of the
  ECB-windows, the visibility of a compile-window and also the full
  split-state of the edit-area. But this can only be done if important
  layout-options have not been changed in the meanwhile. These are the options
  `ecb-layout-name', `ecb-compile-window-height', `ecb-compile-window-width',
  `ecb-windows-width' and `ecb-windows-height'.

Default value is 'before-deactivation.

Some remarks to the value 'before-activation: If this value has been set then
ECB needs four permanent adivces even when ECB is deactivated: `split-window',
`delete-window', `delete-other-windows' and `set-window-configuration'. But
these advices do not change any behavior of these functions but only storing
in an internal ECB-variable the facts that a window has been splitted or
deleted etc. In addition to this these advices are 100% error-save, means the
functionality of the original functions will be performed in every(!) case
even if within the advice an error occurs (but normally there can no errors
occur in these advices because they are very simple). Conclusion: If you want
really all ECB-advices being disabled after deactivating ECB then you have to
set this option to other values then 'before-activation. But setting this
variable to this value is really completely save." :group 'ecb-layout :type '(radio (const :tag "Split as before ECB-start" :value before-activation) (const :tag "Split as before last ECB-deactivation" :value before-deactivation) (const :tag "Split horizontally" :value horizontal) (const :tag "Split vertically" :value vertical) (const :tag "Do not split" :value nil)))

(defcustom ecb-windows-width 0.33 "\
*The width of the ECB windows in columns for left- and right layouts.
If the number is less than 1.0 the width is a fraction of the frame width." :group 'ecb-layout :initialize 'custom-initialize-default :set ecb-layout-option-set-function :type 'number)

(defcustom ecb-windows-height 0.33 "\
*The height of the ECB windows in lines for top layouts.
If the number is less than 1.0 the width is a fraction of the frame height." :group 'ecb-layout :initialize 'custom-initialize-default :set ecb-layout-option-set-function :type 'number)

(defcustom ecb-fix-window-size nil "\
*Fix size of the ECB-windows/buffers even after frame-resizing.
The fix type (valid values are nil, t, width and height) can either be set on
a layout-basis (means a different value for each layout) or one value can be
set for all layouts. In the latter case there is an additional value 'auto
which choose autom. the senseful fix-type depending on the current
layout-type: For top-layouts the fix-type 'height and for all other
layout-types the fix-type 'width.

For a detailed description of the valid values see documentation of
`window-size-fixed' which is newly introduced in GNU Emacs 21 and is only
available there. Therefore this option takes only effect with GNU Emacs 21.

Note1: Manually resizing the ECB-windows via `enlarge-window',
`shrink-window', `mouse-drag-vertical-line' and `mouse-drag-mode-line' is
still possible even if the window-sizes are fixed for frame-resizing!

Note2: The description of `window-size-fixed' in the elisp-info-manual is more
detailed than the description offered by [C-h v]!

Note3: With current Emacs 21.2.X there seems to be no distinction between
'width, 'height and t. Therefore this option takes no effect (means all
ecb-windows have always unfixed sizes) if `ecb-compile-window-height' is not
nil.

Per default no window-size fixing has been done." :group 'ecb-directories :initialize 'custom-initialize-default :set (function (lambda (sym value) (set sym value) (ecb-set-window-size-fixed (ecb-get-window-fix-type ecb-layout-name)))) :type '(radio (choice :tag "Fix type for all layouts" :menu-tag "Fix type for all layouts" (const :tag "Automatic" :value auto) (const :tag "Fix only width" :value width) (const :tag "Fix only height" :value height) (const :tag "Fix both" :value t) (const :tag "No fixing" :value nil)) (repeat :tag "With these layouts" (cons (string :tag "Layout name") (choice :tag "Fix type" :menu-tag "Fix type for all layouts" (const :tag "Fix only width" :value width) (const :tag "Fix only height" :value height) (const :tag "Fix both" :value t) (const :tag "No fixing" :value nil))))))

(defcustom ecb-other-window-behavior 'smart "\
*The behavior of ECB concerning getting an \"other window\".
This has an effect if either `other-window' or `other-window-for-scrolling' is
adviced by ECB, see `ecb-advice-window-functions'. The following settings are
possible:

'all:

ECB will cycle through all windows of the ECB-frame or scroll simply
the next window in the ECB-frame, means it behaves like the original
`other-window' rsp. the original `other-window-for-scrolling'.

'only-edit:

ECB will only cycle through the edit-windows of ECB or only
scroll another edit-window. If the selected window is not an edit-window
then it behaves like with value 'all.

'edit-and-compile:

Like 'only-edit plus the compile window if any. If the
selected window is neither an edit-window nor the compile-window then it
behaves like with value 'all.

'smart:

With this setting ECB tries to choose the `other-window'-destination or the
\"other window\" to scroll in a smart and intuitive way: If point is in one of
the edit-windows and if the edit-area is splitted then always the \"next\"
edit-window is choosen (whereas the next edit-window of the last edit-window
is the first edit-window)- if the edit-area is unsplitted then the
compile-window is used if there is one. In the context of an
`other-window'-call the ARG of `other-window' will be taken into account.

If one of the special ecb-windows is selected then always the \"next\"
ecb-window is choosen (whereas the next ecb-window of the last ecb-window is
the first ecb-window). In the context of an `other-window'-call the ARG of
`other-window' will be taken into account. If there is only one ecb-window
then ECB considers also the edit-windows!

If the compile-window is selected then always the last selected edit-window
will be used unless `other-window' has been called with a prefix-argument
unequal 1.

If there is an active minibuffer:

Regardless of the allowed values above ECB handles the situation of an active
minibuffer during a call to `other-window' or `scroll-other-window' like
follows:

If the minibuffer-window is selected then ECB always chooses the window
`minibuffer-scroll-window' points to (when this variable is set, otherwise
the compile-window or the last selected edit-window is choosen) when the
called command is called to choose the 1. next window (always true for
scrolling another window or true when `other-window' called without prefix-arg
or with prefix-arg equal 1). Otherwise the window ARG steps away is choosen
\(in case of `other-window).

If there is an active minibuffer but the minibuffer-window is not selected
then `other-window' and `scroll-other-window' behave like the original
version.

In addition to the allowed values above the value of this option can also be a
function:

This function gets seven arguments:
1. A canonical list of all currently visible windows of the `ecb-frame'
2. A canonical list of all currently visible edit-windows
3. A canonical list of all currently visible ecb-windows
4. The window-object of the compile-window if there is any.
5. The minibuffer-window of the ECB-frame if there is an active minibuffer.
5. The result of the function `ecb-where-is-point' - see the documentation
   of this function for details.
6. An integer which indicates how many steps away from the current selected
   window the \"other-window is. Is nil when this function is called in
   another context then for `other-window'.
The function has to return a window-object which is then used as \"other
window\" for the command `other-window' or for scrolling another window
\(e.g. with `scroll-other-window').

This function has to handle all properly situations for itself.
`ecb-get-other-window-smart' is an example for such a function." :group 'ecb-layout :group 'ecb-most-important :type '(radio (const :tag "Smart" :value smart) (const :tag "All windows" all) (const :tag "Only edit windows" only-edit) (const :tag "Edit + compile window" edit-and-compile) (function :tag "User defined" :value ignore)))

(defcustom ecb-advice-window-functions '(other-window delete-window delete-other-windows delete-windows-on split-window-horizontally split-window-vertically split-window switch-to-buffer switch-to-buffer-other-window display-buffer other-window-for-scrolling balance-windows) "\
*Advice functions to be more intelligent if used with ECB.
You can choose the following functions to be adviced by ECB so they behave as
if the edit-window(s) of ECB would be the only windows(s) of the ECB-frame:
- `other-window'
  For this one see also the option `ecb-other-window-behavior'!
- `delete-window'
- `delete-other-windows'
- `delete-windows-on'
- `split-window-horizontally'
- `split-window-vertically'
- `split-window'
  If this is enabled then `split-window-vertically' and
  `split-window-horizontally' are autom. enabled too!
- `switch-to-buffer'
- `switch-to-buffer-other-window'
- `display-buffer'
  Especially if `ecb-compile-window-height' is not nil it is strongly
  recommended not to disable this advice!
- `other-window-for-scrolling': If this advice is enabled then the behavior of
  the following functions depends on `ecb-other-window-behavior':
  - `scroll-other-window'
  - `scroll-other-window-down'
  - `beginning-of-buffer-other-window'
  - `end-of-buffer-other-window'
- `balance-windows': Only the edit-windows of the ecb-frame are balanced.

For working most conveniently with ECB it is the best to advice all these
functions, because then all the standard shortcuts of these functions are also
usable with ECB without doing anything else. Also other packages can interact
best with ECB if these functions are all adviced. If these adviced functions
are called in another frame than the ECB-frame they behave all exactly like the
not adviced versions!

But please read also the following:

Normally all packages should work correct with ECB and its adviced functions
but if there occur problems with a package cause of some of these adviced
functions ECB offers the following fall-back solution:

1. Deactivate in `ecb-advice-window-functions' all the adviced-functions which
   make problems with other packages.
2. For every of the advice-able functions <adv-FUNC> ECB offers a interactively
   function named \"ecb-<adv-func>\" which does exactly the same as the
   adviced version of <adv-func>. Use \"ecb-<adv-func>\" instead the original
   one to get the proper ECB behavior even if the function is not adviced
   anymore.
3. You can bind in `ecb-activate-hook' the standard-shortcut of <adv-func> to
   \"ecb-<adv-func>\" and rebind it in `ecb-deactivate-hook' to <adv-func>.
4. Now you have the best of both worlds: The problematic package works and you
   have the ECB-behavior of <adv-func> as if it would be adviced.

Here is an example: Suppose you must deactivating the advice for
`switch-to-buffer-other-window'. Then you deactivate this function with this
option and you can use `ecb-switch-to-buffer-other-window' instead. Bind the
shortcut you normally use for `switch-to-buffer-other-window' to
`ecb-switch-to-buffer-other-window' (use `ecb-activate-hook' for this) and
rebind it to the original function in the `ecb-deactivate-hook'." :group 'ecb-layout :initialize 'custom-initialize-set :set (function (lambda (symbol value) (when (member 'split-window value) (add-to-list 'value 'split-window-vertically) (add-to-list 'value 'split-window-horizontally)) (set symbol value) (when (and (boundp 'ecb-minor-mode) ecb-minor-mode) (ecb-activate-adviced-functions value)))) :type '(set (const :tag "other-window" :value other-window) (const :tag "delete-window" :value delete-window) (const :tag "delete-other-windows" :value delete-other-windows) (const :tag "delete-windows-on" :value delete-windows-on) (const :tag "split-window-horizontally" :value split-window-horizontally) (const :tag "split-window-vertically" :value split-window-vertically) (const :tag "split-window" :value split-window) (const :tag "switch-to-buffer" :value switch-to-buffer) (const :tag "switch-to-buffer-other-window" :value switch-to-buffer-other-window) (const :tag "display-buffer" :value display-buffer) (const :tag "other-window-for-scrolling" :value other-window-for-scrolling) (const :tag "balance-windows" :value balance-windows)))

(defcustom ecb-advice-window-functions-signal-error nil "\
*Signal an error if an adviced function can not do its job.
If not nil then an error is signaled if one of the adviced functions (see
`ecb-advice-window-functions') can not do its job. So for example if the user
tries to split the compile-window or an ecb-tree-window or if one tries to
switch to another buffer in one of the ecb-tree-windows. For details see the
documentation of each of the adviced functions to get info when an error is
signaled.

If this option is nil then no error is signaled but the called adviced
function does simply nothing.

Default is nil but it can also be useful to signal errors - so you see when
call a function in a situation which is not supported by this function." :group 'ecb-layout :type 'boolean)

(defcustom ecb-layout-always-operate-in-edit-window '(switch-to-buffer) "\
*Adviced window functions work always in the edit-window.
If we are in an ECB special buffer (methods, directories, etc), and any of the
adviced windowing functions is called interactively (see
`ecb-advice-window-functions'), we will select first an edit-window according
to the value of `ecb-mouse-click-destination'. This is useful if you have any
functions that use such functions and you don't want them to fail with an
error complaining that the current buffer can not be split, or something
similar.

Because this may not be desirable in all situations and for all adviced
functions this can be enabled separately for every advicable function (see
also `ecb-advice-window-functions'). If the symbol of an adviced function is
contained in the value of this option, then the edit-window is first selected
otherwise either an error is reported or some other special reaction (depends
on `ecb-advice-window-functions-signal-error'); see the documentation of the
adviced functions for this.

For `other-window', `other-window-for-scrolling', `display-buffer' and
`switch-to-buffer-other-window' this makes no sense, therefore you can not
enable this for them.

Per default this is only enabled for `switch-to-buffer'." :group 'ecb-layout :type '(set (const :tag "delete-window" :value delete-window) (const :tag "delete-other-windows" :value delete-other-windows) (const :tag "split-window-horizontally" :value split-window-horizontally) (const :tag "split-window-vertically" :value split-window-vertically) (const :tag "split-window" :value split-window) (const :tag "display-buffer" :value display-buffer) (const :tag "switch-to-buffer" :value switch-to-buffer)))

(defcustom ecb-layout-window-sizes nil "\
*Specifies the sizes of the ECB windows for each layout.
The easiest way (and also the strongly recommended way) to change this
variable is to change the window sizes by dragging the window borders using
the mouse and then store the window sizes by calling the command
`ecb-store-window-sizes'. Next time the layout is redrawn the values stored in
this option will be used.

If `ecb-store-window-sizes' is used then the windows sizes are stored per
default as fractions of current frame-width and -height of the ecb-frame, so
the stored values will \"work\" for other frame sizes too. But if you call
`ecb-store-window-sizes' with a prefix-argument then the fixed values of
current width and height are stored!

If this option is set \"by hand\" (i.e. not by `ecb-store-window-sizes') then
the following is important:
- It is recommended to use fractions of frame-width and -height!.
- The order of the sequence of the inserted window sizes must be the same as
  `other-window' (the not-adviced version!) would walk!" :group 'ecb-layout :initialize 'custom-initialize-default :set ecb-layout-option-set-function :type '(repeat (cons :tag "Window layout" (string :tag "Layout name") (repeat :tag "Window sizes" (cons (choice :tag "Width" :menu-tag "Width" :value 0.0 (const :tag "Default value" :value nil) (number :tag "Custom size")) (choice :tag "Height" :menu-tag "Height" (const :tag "Default value" :value nil) (number :tag "Custom size")))))))

(defcustom ecb-redraw-layout-quickly nil "\
If non-nil, we will attempt to redraw the layout quickly.
Please read also carefully the documentation of `ecb-redraw-layout'." :type 'boolean :group 'ecb-layout)

(defcustom ecb-toggle-layout-sequence '("left9" "left14") "\
*Toggle sequence for layout toggling with `ecb-toggle-layout'.
Every element of this list has to be a valid layout-name (a string) i.e.
either one of the predefined layouts or one of the user-defined layouts (see
`ecb-create-new-layout').

You can add here as many layouts as you want but to use this option most
effective you should not add more than 2 or 3 layouts so every layout can be
accessed very fast by toggling with `ecb-toggle-layout'. It is also senseful
to add layouts which have the same principal outline, i.e. all their
tree-buffers are on the same side of the frame and the
tree-buffer-\"column\" (or -\"row\") has identical size for the layouts.

Recommended values are for example:
- (\"left10\" \"left15\"), toggles between methods and directories/history
- (\"left10\" \"left13\"), toggles between methods and directories
- (\"left10\" \"left14\"), toggles between methods and history
- (\"left10\" \"left13\" \"left14\"), toggles between methods, history and
  directories

See also option `ecb-show-sources-in-directories-buffer'.

This option makes only sense if the value is a list with more than 1 element!" :group 'ecb-layout :type '(repeat (string :tag "Layout name.")) :initialize 'custom-initialize-default :set (function (lambda (symbol value) (ecb-load-layouts) (dolist (name value) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode (not (fboundp (intern (format "ecb-layout-function-%s" name))))) (ecb-error "There is no layout available with name %s!" name))) (set symbol value))))

(defcustom ecb-hide-ecb-windows-before-hook nil "\
*Hook run direct before the ECB windows will be hidden.
Hiding is done either by `ecb-toggle-ecb-windows' or `ecb-hide-ecb-windows'.
This means that at runtime of this hook all the ECB-tree-windows of current
layout are visible.

IMPORTANT: Showing the hidden ECB-windows is internally done by calling
`ecb-redraw-layout' and therefore also the hooks
`ecb-redraw-layout-before-hook' and `ecb-redraw-layout-after-hook' are
evaluated. The hook-sequence is analogous to that described in
`ecb-show-ecb-windows-before-hook'." :group 'ecb-layout :type 'hook)

(defcustom ecb-hide-ecb-windows-after-hook nil "\
*Hooks run direct after the ECB windows have been hidden.
Hiding was done either by `ecb-toggle-ecb-windows' or `ecb-hide-ecb-windows'.

IMPORTANT: Showing the hidden ECB-windows is internally done by calling
`ecb-redraw-layout' and therefore also the hooks
`ecb-redraw-layout-before-hook' and `ecb-redraw-layout-after-hook' are
evaluated. The hook-sequence is analogous to that described in
`ecb-show-ecb-windows-after-hook'." :group 'ecb-layout :type 'hook)

(defcustom ecb-show-ecb-windows-before-hook nil "\
*Hooks run direct before the ECB windows will be shown.
Showing is done either by `ecb-toggle-ecb-windows' or `ecb-show-ecb-windows'.
This means that at runtime of this hook the ECB-windows are still hidden.

IMPORTANT: Showing the hidden ECB-windows is internally done by calling
`ecb-redraw-layout' and therefore also the hooks
`ecb-redraw-layout-before-hook' and `ecb-redraw-layout-after-hook' are
evaluated. So there is the following sequence of hooks during the process of
showing the hidden ECB-windows:
1. `ecb-show-ecb-windows-before-hook'
2. `ecb-redraw-layout-before-hook'
3. <redrawing the layout to show the hidden ECB-windows>
4. `ecb-redraw-layout-after-hook'
5. `ecb-show-ecb-windows-after-hook'
So be aware which code you add to which hook!" :group 'ecb-layout :type 'hook)

(defcustom ecb-show-ecb-windows-after-hook nil "\
*Hooks run direct before the ECB windows will be shown.
Showing has been done either by `ecb-toggle-ecb-windows' or
`ecb-show-ecb-windows'. This means that at runtime of this hook the
ECB-windows are already visible.

IMPORTANT: Showing the hidden ECB-windows is internally done by calling
`ecb-redraw-layout' and therefore also the hooks
`ecb-redraw-layout-before-hook' and `ecb-redraw-layout-after-hook' are
evaluated. So there is the following sequence of hooks during the process of
showing the hidden ECB-windows:
1. `ecb-show-ecb-windows-before-hook'
2. `ecb-redraw-layout-before-hook'
3. <redrawing the layout to show the hidden ECB-windows>
4. `ecb-redraw-layout-after-hook'
5. `ecb-show-ecb-windows-after-hook'
So be aware which code you add to which hook!" :group 'ecb-layout :type 'hook)

(defcustom ecb-redraw-layout-after-hook '(ecb-eshell-recenter) "\
*Hooks run direct after the ECB-layout has been redrawn.
If you use the eshell-integration of ECB then the function
`ecb-eshell-recenter' should be in this hook." :group 'ecb-layout :type 'hook)

(defcustom ecb-redraw-layout-before-hook nil "\
*Hooks run direct before the ECB-layout will be redrawn." :group 'ecb-layout :type 'hook)

(defcustom ecb-layout-debug-mode nil "\
*Write debug-information about layout-operations in the Messages-buffer.
Normally there should be no need to set this option to true but if there are
problems to display buffers in the compile-window of ECB (e.g. buffers which
should be displayed there aren't or the temporally enlarging-mechanism does
not do what you think it should do etc...) then please do the following steps:
1. Set `ecb-layout-debug-mode' to not nil
2. Reproduce the wrong behavior exactly by repeating all the operations which
   lead to the problem.
3. Now send immediately a bug report with `ecb-submit-problem-report'.
4. Set `ecb-layout-debug-mode' back to nil if you do not want further
   debugging output in the *Messages* buffer" :group 'ecb-layout :type 'boolean)

;;;***

;;;### (autoloads (ecb-rebuild-non-semantic-methods-before-hook ecb-non-semantic-exclude-modes ecb-auto-save-before-etags-methods-rebuild ecb-non-semantic-methods-initial-expand ecb-non-semantic-parsing-function ecb-process-non-semantic-files ecb-methods-buffer-after-create-hook ecb-methods-menu-sorter ecb-methods-menu-user-extension-function ecb-methods-menu-user-extension ecb-tag-visit-post-actions ecb-highlight-tag-with-point-delay ecb-highlight-tag-with-point ecb-exclude-parents-regexps ecb-methods-nodes-collapse-spec ecb-methods-nodes-expand-spec ecb-methods-filter-replace-existing ecb-methods-separate-prototypes ecb-show-tags ecb-show-only-positioned-tags ecb-default-tag-filter ecb-post-process-semantic-taglist ecb-display-image-icons-for-semantic-tags ecb-type-tag-expansion ecb-type-tag-display ecb-tag-display-function ecb-tag-jump-sets-mark ecb-font-lock-tags ecb-auto-update-methods-after-save ecb-expand-methods-switch-off-auto-expand ecb-auto-expand-tag-tree-collapse-other ecb-auto-expand-tag-tree ecb-methods-buffer-name ecb-non-semantic ecb-methods) "ecb-method-browser" "ecb/ecb-method-browser.el")
(defconst custom-define-current-source-file "ecb-method-browser.el")

(defgroup ecb-methods nil "Settings for the methods-buffer in the Emacs code browser." :group 'ecb :prefix "ecb-")

(defgroup ecb-non-semantic nil "Settings for parsing and displaying non-semantic files." :group 'ecb :prefix "ecb-")

(defcustom ecb-methods-buffer-name " *ECB Methods*" "\
*Name of the ECB methods buffer.
Because it is not a normal buffer for editing you should enclose the name with
stars, e.g. \"*ECB Methods*\".

If it is necessary for you you can get emacs-lisp access to the buffer-object of
the ECB-methods-buffer by this name, e.g. by a call of `set-buffer'.

Changes for this option at runtime will take affect only after deactivating and
then activating ECB again!" :group 'ecb-methods :type 'string)

(defcustom ecb-auto-expand-tag-tree 'expand-spec "\
*Expand the methods-tag-tree automatically if node invisible.
This option has only an effect if option `ecb-highlight-tag-with-point' is
switched on too. There are three possible choices:
- nil: No auto. expanding of the method buffer.
- expand-spec: Auto expand the method-buffer nodes if the node belonging to
  current tag under point is invisible because its parent-node is collapsed.
  But expanding is only done if the type of the tag under point in the
  edit-buffer is contained in `ecb-methods-nodes-expand-spec'.
- all: Like expand-spec but expands all tags regardless of the setting in
  `ecb-methods-nodes-expand-spec'.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :type '(radio (const :tag "No auto. expand" :value nil) (const :tag "Expand as specified" :value expand-spec) (const :tag "Expand all" :value all)))

(defcustom ecb-auto-expand-tag-tree-collapse-other nil "\
*Auto. expanding the tag-tree collapses all not related nodes.
There are several choices:
- Only if on tag: This means collapsing all nodes which have no relevance for
  the currently highlighted node will be collapsed, because they are not
  necessary to make the highlighted node visible. But do this only if point
  stays onto a tag in the selected edit-window.
- Always: Same as before but collapse also when point doesn't stays on a tag
  (e.g. between two defuns in elisp) in the selected edit-window. This means
  in such a situation a full collapsing of the methods-buffer.
- Never: Do not automatically collapse the methods-buffer." :group 'ecb-methods :type '(radio (const :tag "Collapse only when point stays on a tag" :value only-if-on-tag) (const :tag "Collapse always" :value always) (const :tag "Never" :value nil)))

(defcustom ecb-expand-methods-switch-off-auto-expand t "\
*Switch off auto expanding in the ECB-method buffer.
If on then auto expanding is switched off after explicit expanding or
collapsing by `ecb-expand-methods-nodes'.

This is done with `ecb-toggle-auto-expand-tag-tree' so after the switch off
the auto expanding feature can again switched on quickly.

But after explicitly expanding/collapsing the methods-buffer to a certain
level the auto. expanding could undo this when the node belonging to current
tag under point in the edit-window is invisible after
`ecb-expand-methods-nodes' - then the auto. expand feature would make this
node immediately visible and destroys the explicitly set expand-level." :group 'ecb-methods :type 'boolean)

(defcustom ecb-auto-update-methods-after-save t "\
*Automatically updating the ECB method buffer after saving a source." :group 'ecb-methods :type 'boolean)

(defcustom ecb-font-lock-tags t "\
*Adds font-locking (means highlighting) to the ECB-method buffer.
This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :set (function (lambda (symbol value) (set symbol value) (ecb-clear-tag-tree-cache))) :type 'boolean :initialize 'custom-initialize-default)

(defcustom ecb-tag-jump-sets-mark t "\
*Set the mark after jumping to a tag from the ECB-method buffer.
If set the user can easily jump back." :group 'ecb-methods :type 'boolean)

(defcustom ecb-tag-display-function '((default . ecb-format-tag-uml-prototype)) "\
*Function to use for displaying tags in the methods buffer.
This functionality is set on major-mode base, i.e. for every major-mode a
different function can be used. The value of this option is a list of
cons-cells:
- The car is either a major-mode symbol or the special symbol 'default which
  means if no function for a certain major-mode is defined then the cdr of
  the 'default cons-cell is used.
- The cdr is the function used for displaying a tag in the related
  major-mode.
Every function is called with 3 arguments:
1. The tag
2. The parent-tag of tag (can be nil)
3. The value of `ecb-font-lock-tags'.
Every function must return the display of the tag as string, colorized if
the third argument is not nil.

The following functions are predefined:
- For each element E of `ecb--semantic-format-function-alist' exists a
  function with name \"ecb--<(cdr E)>\". These functions are just aliase to
  the builtin format-functions of semantic. See the docstring of these
  functions to see what they do.
  Example: (semantic-name-nonterminal . semantic-format-tag-name) is an
  element of `ecb--semantic-format-function-alist'. Therefore the
  alias-function for this element is named `ecb--semantic-format-tag-name'.
- For every cdr in `ecb--semantic-format-function-alist' with name
  \"semantic-XYZ\" a function with name \"ecb-XYC\" is predefined. The
  differences between the semantic- and the ECB-version are:
  + The ECB-version displays for type tags only the type-name and nothing
    else (exception: In c++-mode a template specifier is appended to the
    type-name if a template instead a normal class).
  + The ECB-version displays type-tags according to the setting in
    `ecb-type-tag-display'. This is useful for better recognizing
    different classes, structs etc. in the ECB-method window.
  For all tags which are not types the display of the ECB-version is
  identical to the semantic version. Example: For
  `ecb--semantic-format-tag-name' (the builtin semantic formatter) the
  pendant is `ecb-format-tag-name'.

This functionality also allows the user to display tags as UML. To enable
this functionality set the function for a major-mode (e.g. `jde-mode') to
`ecb--semantic-format-tag-uml-concise-prototype',
`ecb--semantic-format-tag-uml-prototype', or
`ecb--semantic-format-tag-uml-abbreviate' the ECB-versions of these functions.

If the value is nil, i.e. neither a function for a major-mode is defined nor
the special 'default, then `ecb--semantic-format-tag-prototype' is used for
displaying the tags.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :group 'ecb-most-important :set (function (lambda (symbol value) (set symbol value) (ecb-clear-tag-tree-cache))) :type (list 'repeat ':tag "Display functions per mode" (list 'cons ':tag "Mode tag display" '(symbol :tag "Major mode") (nconc (list 'choice ':tag "Display function" ':menu-tag '"Display function") (append (mapcar (lambda (f) (list 'const ':tag (symbol-name (car f)) (car f))) ecb-tag->text-functions) (mapcar (lambda (f) (list 'const ':tag (symbol-name (cdr f)) (cdr f))) ecb-tag->text-functions) (list '(function :tag "Function")))))) :initialize 'custom-initialize-default)

(defcustom ecb-type-tag-display nil "\
*How to display semantic type-tags in the methods buffer.
Normally all tag displaying, colorizing and facing is done by semantic
according to the value of `ecb--semantic-format-face-alist' and the semantic
display-function (e.g. one from `ecb--semantic-format-function-alist'). But
sometimes a finer distinction in displaying the different type specifiers of
type-tags can be useful. For a description when this option is evaluated look
at `ecb-tag-display-function'!

This functionality is set on a major-mode base, i.e. for every major-mode a
different setting can be used. The value of this option is a list of
cons-cells:
- The car is either a major-mode symbol or the special symbol 'default which
  means if no setting for a certain major-mode is defined then the cdr of
  the 'default cons-cell is used.
- The cdr is a list of 3-element-lists:
  1. First entry is a semantic type specifier in string-form. Current
     available type specifiers are for example \"class\", \"interface\",
     \"struct\", \"typedef\", \"union\" and \"enum\". In addition to these
     ones there is also a special ECB type specifier \"group\" which is
     related to grouping tags (see `ecb-post-process-semantic-taglist' and
     `ecb-group-function-tags-with-parents'). Any arbitrary specifier can be
     set here but if it is not \"group\" or not known by semantic it will be
     useless.
  2. Second entry is a flag which indicates if the type-specifier string from
     (1.) itself should be removed (if there is any) from the display.
  3. Third entry is the face which is used in the ECB-method window to display
     type-tags with this specifier. ECB has some predefined faces for this
     (`ecb-type-tag-class-face', `ecb-type-tag-interface-face',
     `ecb-type-tag-struct-face', `ecb-type-tag-typedef-face',
     `ecb-type-tag-union-face', `ecb-type-tag-enum-face' and
     `ecb-type-tag-group-face') but any arbitrary face can be set here. This
     face is merged with the faces semantic already uses to display a tag,
     i.e. the result is a display where all face-attributes of the ECB-face
     take effect plus all face-attributes of the semantic-faces which are not
     set in the ECB-face (with XEmacs this merge doesn't work so here the
     ECB-face replaces the semantic-faces; this may be fixed in future
     versions).

The default value is nil means there is no special ECB-displaying of
type-tags in addition to the displaying and colorizing semantic does. But a
value like the following could be a useful setting:

  ((default
     (\"class\" t ecb-type-tag-class-face)
     (\"group\" nil ecb-type-tag-group-face))
    (c-mode
     (\"struct\" nil ecb-type-tag-struct-face)
     (\"typedef\" nil ecb-type-tag-typedef-face)))

This means that in `c-mode' only \"struct\"s and \"typedef\"s are displayed
with special faces (the specifiers itself are not removed) and in all other
modes \"class\"es and grouping-tags (see `ecb-tag-display-function',
`ecb-group-function-tags-with-parents') have special faces and the \"class\"
specifier-string is removed from the display.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :group 'ecb-most-important :set (function (lambda (symbol value) (set symbol value) (ecb-clear-tag-tree-cache))) :type '(repeat (cons (symbol :tag "Major-mode") (repeat :tag "Display of type specifiers" (list (choice :tag "Specifier list" :menu-tag "Specifier list" (const :tag "class" :value "class") (const :tag "interface" :value "interface") (const :tag "struct" :value "struct") (const :tag "typedef" :value "typedef") (const :tag "union" :value "union") (const :tag "enum" :value "enum") (const :tag "group" :value "group") (string :tag "Any specifier")) (boolean :tag "Remove the type-specifier" t) (face :tag "Any face" :value ecb-type-tag-class-face))))) :initialize 'custom-initialize-default)

(defcustom ecb-type-tag-expansion '((default "class" "interface" "group" "namespace") (c-mode "struct")) "\
*Default expansion of semantic type-tags.
Semantic groups type-tags into different type-specifiers. Current available
type specifiers are for example \"class\", \"interface\", \"struct\",
\"typedef\", \"union\" and \"enum\". In addition to these ones there is also a
special ECB type specifier \"group\" which is related to grouping tags (see
`ecb-post-process-semantic-taglist').

This option defines which type-specifiers should be expanded at
file-open-time. Any arbitrary specifier can be set here but if it is not
\"group\" or not known by semantic it will be useless.

This functionality is set on a major-mode base, i.e. for every major-mode a
different setting can be used. The value of this option is a list of
cons-cells:
- The car is either a major-mode symbol or the special symbol 'default which
  means if no setting for a certain major-mode is defined then the cdr of
  the 'default cons-cell is used.
- The cdr is either a list of type-specifiers which should be expanded at
  file-open-time or the symbol 'all-specifiers (then a type-tag is always
  expanded regardless of its type-specifier).

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :group 'ecb-most-important :type '(repeat (cons (symbol :tag "Major-mode") (radio (const :tag "Expand all type-specifiers" :value all-specifiers) (repeat :tag "Expand type specifiers" (choice :tag "Specifier" :menu-tag "Specifier" (const :tag "class" :value "class") (const :tag "interface" :value "interface") (const :tag "struct" :value "struct") (const :tag "typedef" :value "typedef") (const :tag "union" :value "union") (const :tag "enum" :value "enum") (const :tag "group" :value "group") (string :tag "Any specifier")))))) :set (function (lambda (symbol value) (set symbol value) (ecb-clear-tag-tree-cache))) :initialize 'custom-initialize-default)

(defcustom ecb-display-image-icons-for-semantic-tags ecb-images-can-be-used "\
*Display nice and pretty icons for semantic-tags in the Methods-buffer.
This option takes only effect if Emacs can display images and if
`ecb-tree-buffer-style' is set to 'image." :group 'ecb-methods :type 'boolean)

(defcustom ecb-post-process-semantic-taglist '((c++-mode ecb-group-function-tags-with-parents) (emacs-lisp-mode ecb-group-function-tags-with-parents) (c-mode ecb-filter-c-prototype-tags)) "\
*Define mode-dependent post-processing for the semantic-taglist.
This is an alist where the car is a major-mode symbol and the cdr is a list of
function-symbols of functions which should be used for post-processing the
taglist (returned by `ecb--semantic-fetch-tags') for a buffer in this
major-mode. The first function in the list is called with current semantic
taglist of current buffer and must return a valid taglist again. All other
functions are called with the result-taglist of its preceding function and
have to return a new taglist again.

For oo-programming languages where the methods of a class can be defined
outside the class-definition (e.g. C++, Eieio) the function
`ecb-group-function-tags-with-parents' can be used to get a much better
method-display in the methods-window of ECB, because all method
implementations of a class are grouped together.

Another senseful usage is to filter out certain tags, e.g. prototype tags in
`c-mode'. For this you can set `ecb-filter-c-prototype-tags'.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :type '(repeat (cons (symbol :tag "Major-mode") (repeat (function :tag "Post-process function")))))

(defcustom ecb-default-tag-filter nil "\
*Default tag-filters for certain files.
This option allow to define default tag-filters for certain files which are
applied automatically after loading such a file into a buffer. The possible
filters are the same as offered by the command `ecb-methods-filter' and they
are applied in the same manner - the only difference is they are applied
automatically. Please be aware that symbol-filters (e.g. protection-symbols
like public or private) must not be inserted with quotes whereas a
filter-regexp has to be inserted with surrounding double-quotes! In addition
backslashes in a regexp have to be doubled!

For each file-spec (a major-mode plus a file-regexp which both specify a
file for which filters should be applied) there can be as much filters as
needed - they are layered like with `ecb-methods-filter' too.

Tag-classes which are completely hidden or excluded by the option
`ecb-show-tags' will never being displayed in the Methods-buffer regardless of
the filters of this option!" :group 'ecb-methods :type '(repeat (cons :tag "Default tag filter" (cons :tag "Filespec" (symbol :tag "Major-mode") (regexp :tag "Filename-regexp")) (repeat :tag "Default filters" (list :tag "Filterspec" (choice :tag "Filter-type" :menu-tag "Filtertype" (const :tag "Regexp" :value regexp) (const :tag "Protection" :value protection) (const :tag "Tag-class" :value tag-class) (const :tag "Funtion" :value function)) (sexp :tag "Filter-value") (boolean :tag "inverse"))))))

(defcustom ecb-show-only-positioned-tags t "\
*Show only nodes in the method-buffer which are \"jump-able\".
If not nil then ECB displays in the method-buffer only nodes which are
\"jump-able\", i.e. after selecting it by clicking or with RET then ECB jumps
to the corresponding location in the edit-window.
Example: With CLOS or Eieio source-code there can exist some position-less
nodes like variable-attributes in a `defclass' form which are only displayed
if this option is nil. Displaying such nodes can be senseful even if they can
not be jumped.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :type 'boolean)

(defcustom ecb-show-tags '((default (include collapsed nil) (parent collapsed nil) (type flattened nil) (variable collapsed access) (function flattened access) (label hidden nil) (t collapsed nil)) (c++-mode (include collapsed nil) (parent collapsed nil) (type flattened nil) (variable collapsed access) (function flattened access) (function collapsed access) (label hidden nil) (t collapsed nil)) (c-mode (include collapsed nil) (parent collapsed nil) (type flattened nil) (variable collapsed access) (function flattened access) (function collapsed access) (label hidden nil) (t collapsed nil)) (bovine-grammar-mode (keyword collapsed name) (token collapsed name) (nonterminal flattened name) (rule flattened name) (t collapsed nil)) (wisent-grammar-mode (keyword collapsed name) (token collapsed name) (nonterminal flattened name) (rule flattened name) (t collapsed nil)) (texinfo-mode (section flattened nil) (def collapsed name) (t collapsed nil))) "\
*How to show tags in the methods buffer first time after find-file.
This functionality is set on a major-mode base, i.e. for every major-mode a
different setting can be used. The value of this option is a list of
cons-cells:

The car is either a major-mode symbol or the special symbol 'default which
means if no setting for a certain major-mode is defined then the cdr of
the 'default cons-cell is used. This option should always contain a
default-setting!

The cdr is a list where each element represents a type of tags:

\(<tag type> <display type> <sort method>)

There can be more than 1 element for a certain <tag type>. This is for example
useful for C++ and C because these languages distinct between a
method-prototype (rsp. function-prototype for C) and the method (rsp.
function for C) itself. The default value of these option contains two entries
for <tag type> is 'function whereas the first one is responsible for the
\"real\" methods (rsp. functions) and the second one for the prototypes. So
if the methods should be flattened and the prototypes collapsed the
show-tags-list for C++ and C must contain two entries for <tag type>
'function, the first one defined as 'flattened and the second one defined as
'collapsed. See also `ecb-methods-separate-prototypes'.

The tags in the methods buffer are displayed in the order as they appear in
this list.

Tag Type
----------

A Semantic tag type symbol (for all possible type symbols see documentation
of semantic):
- include
- type
- variable
- function
- rule
- section (chapters and sections in `info-mode')
- def (definitions in `info-mode')

or one of the following:

- t:      All tag types not specified anywhere else in the list.
- parent: The parents of a type.

Display Type
------------

A symbol which describes how the tags of this type shall be shown:

- expanded:  The tags are shown in an expanded node.
- collapsed: The tags are shown in a collapsed node.
- flattened: The tags are added to the parent node.
- hidden:    The tags are not shown.

Sort Method
-----------

A symbol describing how to sort the tags of this type:

- name:   Sort by the tag name.
- access: Sort by tag access (public, protected, private) and then by name.
- nil:    Don't sort tags. They appear in the same order as in the source
          buffer.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :group 'ecb-most-important :set (function (lambda (symbol value) (set symbol value) (ecb-clear-tag-tree-cache))) :type '(repeat (cons (symbol :tag "Major-mode") (repeat (list (symbol :tag "Tag symbol") (choice :tag "Display type" :value collapsed (const :tag "Expanded" expanded) (const :tag "Collapsed" collapsed) (const :tag "Flattened" flattened) (const :tag "Hidden" hidden)) (choice :tag "Sort by" :value nil (const :tag "Name" name) (const :tag "Access then name" access) (const :tag "No sort" nil)))))) :initialize 'custom-initialize-default)

(defcustom ecb-methods-separate-prototypes t "\
*Separate function-prototypes from the real functions.
This is for example useful for C++ and C because these languages distinct
between a method-prototype (rsp. function-prototype for C) and the method
\(rsp. function for C) itself. If this option is not nil then ECB separates
the prototypes from the real function/methods. Then with `ecb-show-tags' the
user can define different display-settings for each of them. If this option is
nil then the prototypes and the real functions are filled in the same bucket
and displayed plain and there is no sorting between prototypes and functions
possible. If this option is switched on then it is senseful that
`ecb-show-tags' contains for all modes which distinct between prototypes and
real functions/methods two entries for the tag-type 'function - see the
documentation of this option." :group 'ecb-methods :type 'boolean)

(defcustom ecb-methods-filter-replace-existing 'never "\
*How the methods-filter should be applied to existing filters.
There are three different choices:
- 'never: This is the default and means that calling `ecb-methods-filter'
  always adds the new filter on top of already existing filters. So you can
  combine several filter to one combined like this example: 'Display only all
  public methods having the string \"test\" in its name.' With this setting
  the filters can only be cleared by calling `ecb-methods-filter' and then
  choosing \"nothing\".
- 'always: This means that `ecb-methods-filter' always clears a previous
  filter before applying the new one.
- 'ask: ECB asks if the new filter should replace the existing ones." :group 'ecb-methods :type '(radio (const :tag "Do not replace" :value never) (const :tag "Always replace" :value always) (const :tag "Ask if to replace" :value ask)))

(defcustom ecb-methods-nodes-expand-spec '(type variable function section nonterminal keyword token) "\
*Semantic tag-types expanded by `ecb-expand-methods-nodes'.
The value of this option is either the symbol 'all (all tags are expanded
regardless of their type) or a list of symbols where each symbol is a valid
semantic tag-type. For a description of semantic tag types see option
`ecb-show-tags'.

But this option also defines if bucket-nodes in the ECB-method-buffer (e.g.
\"[Variables]\") should be expanded. Therefore valid symbols for this list
are also all cars of the variable `semantic-symbol->name-assoc-list'.

If there is a bucket-name (the node-name stripped of the settings in
`ecb-bucket-node-display') which is not contained as cdr in
`semantic-symbol->name-assoc-list' then the symbol with this bucket-name as
name is also a valid symbol for this list. Example: In ECB there are buckets
\"[Parents]\". The bucket-name is \"Parents\" and the valid symbol-name is
then 'Parents.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :type '(radio (const :tag "All node-types" :value all) (repeat :tag "Node-type list" (symbol :tag "Node-type"))))

(defcustom ecb-methods-nodes-collapse-spec 'all "\
*Semantic tag-types collapsed by `ecb-expand-methods-nodes'.
For valid values of this option see `ecb-methods-nodes-expand-spec'!

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :type '(radio (const :tag "All node-types" :value all) (repeat :tag "Node-type list" (symbol :tag "Node-type"))))

(defcustom ecb-exclude-parents-regexps nil "\
*Regexps which parent classes should not be shown in the methods buffer.
If nil then all parents will be shown if `ecb-show-parents' is not nil.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :set (function (lambda (symbol value) (set symbol value) (ecb-clear-tag-tree-cache))) :type '(repeat (regexp :tag "Parents-regexp to exclude")) :initialize 'custom-initialize-default)

(defcustom ecb-highlight-tag-with-point 'highlight-scroll "\
*How to highlight the method or variable under the cursor.
- highlight-scroll: Always scroll the method buffer, so the current method of the
  edit-window is highlighted in the method-window.
- highlight: Only highlight the current method of the edit window in the
  method window if the method is visible in the method-window.
- nil: No highlighting is done.
See also `ecb-highlight-tag-with-point-delay'.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :type '(radio (const :tag "Highlight and scroll window" :value highlight-scroll) (const :tag "Just highlight" :value highlight) (const :tag "Do not highlight" :value nil)))

(defcustom ecb-highlight-tag-with-point-delay 0.25 "\
*Time Emacs must be idle before current tag is highlighted.
If nil then there is no delay, means current tag is highlighted immediately.
A small value of about 0.25 seconds saves CPU resources and you get even
though almost the same effect as if you set no delay. But such a delay
prevents also \"jumping backward/forward\" during scrolling within
java-classes if point goes out of method-definition into class-definition.
Therefore the default value is a delay of 0.25 seconds.

This options takes only effect for semantic-sources - means sources supported
by semantic!" :group 'ecb-methods :type '(radio (const :tag "No highlighting delay" :value nil) (number :tag "Idle time before highlighting" :value 0.25)) :set (function (lambda (symbol value) (set symbol value) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode) (ecb-activate-ecb-autocontrol-functions value 'ecb-tag-sync)))) :initialize 'custom-initialize-default)

(defcustom ecb-tag-visit-post-actions '((default ecb-tag-visit-smart-tag-start ecb-tag-visit-highlight-tag-header) (java-mode ecb-tag-visit-goto-doc-start) (jde-mode ecb-tag-visit-goto-doc-start)) "\
*Actions to perform after visiting a tag from the Method-buffer.
With this option actions can be added which will be performed after visiting
the start of the tag in the source-buffer.

This functionality is set on a `major-mode' base, i.e. for every `major-mode' a
different setting can be used. The value of this option is a list of
cons-cells:
- The car is either a `major-mode' symbol or the special symbol 'default.
- The cdr is a list of action-functions or nil.

ECB first performs all actions defined for the special symbol 'default (if
any) and then all actions defined for current `major-mode' (if any).

ECB offers some predefined senseful action-functions. Currently there are:
- `ecb-tag-visit-highlight-tag-header'
- `ecb-tag-visit-smart-tag-start'
- `ecb-tag-visit-recenter'
- `ecb-tag-visit-recenter-top'
- `ecb-tag-visit-goto-doc-start'
- `ecb-tag-visit-narrow-tag'
See the documentation of these function for details what they do.

But you can add any arbitrary function if the following conditions are
fulfilled:
- The function gets the semantic tag as argument and
- the function returns the (new) point after finishing its job.
- The function must not put the point outside the tag-boundaries of the
  tag-argument." :group 'ecb-methods :type '(repeat (cons :value (nil ecb-tag-visit-recenter) (symbol :tag "Major-mode or default") (repeat (choice :tag "Post action" :menu-tag "Post action" (const :tag "ecb-tag-visit-smart-tag-start" :value ecb-tag-visit-smart-tag-start) (const :tag "ecb-tag-visit-highlight-tag-header" :value ecb-tag-visit-highlight-tag-header) (const :tag "ecb-tag-visit-goto-doc-start" :value ecb-tag-visit-goto-doc-start) (const :tag "ecb-tag-visit-narrow-tag" :value ecb-tag-visit-narrow-tag) (const :tag "ecb-tag-visit-recenter-top" :value ecb-tag-visit-recenter-top) (const :tag "ecb-tag-visit-recenter" :value ecb-tag-visit-recenter) (function :tag "Function"))))))

(defcustom ecb-methods-menu-user-extension nil "\
*Static user extensions for the popup-menu of the methods buffer.
For further explanations see `ecb-directories-menu-user-extension'.

The node-argument of a menu-function contains as data the semantic-tag of
the method/variable/tag for which the popup-menu has been opened.

Per default the static user-extensions are added at the beginning of the
built-in menu-entries of `ecb-methods-menu' but the whole menu can be
re-arranged with `ecb-methods-menu-sorter'." :group 'ecb-methods :type (ecb-create-menu-user-ext-type 1 ecb-max-submenu-depth))

(defcustom ecb-methods-menu-user-extension-function nil "\
*Dynamic user extensions for the popup-menu of the methods buffer.
A function which has to return a list in the same format like the option
`ecb-methods-menu-user-extension'. This function is called when the user opens
the popup-menu for the methods buffer. For an example how such a function can
be programmed see `ecb-methods-menu-editwin-entries'.

Per default the dynamic user-extensions are added in front of the static
extensions of `ecb-methods-menu-user-extension' but the whole menu can be
re-arranged with `ecb-methods-menu-sorter'." :group 'ecb-methods :type 'function)

(defcustom ecb-methods-menu-sorter nil "\
*Function which re-sorts the menu-entries of the directories buffer.
If a function then this function is called to sort the menu-entries of the
combined menu-entries of the user-menu-extensions of
`ecb-methods-menu-user-extension' and the built-in-menu
`ecb-methods-menu'. If nil then no special sorting will be done and the
user-extensions are placed in front of the built-in-entries.

For the guidelines for such a sorter-function see
`ecb-directories-menu-sorter'." :group 'ecb-methods :type '(choice :tag "Menu-sorter" :menu-tag "Menu-sorter" (const :tag "No special sorting" :value nil) (function :tag "Sort-function" :value identity)))

(defcustom ecb-methods-buffer-after-create-hook nil "\
*Local hook running after the creation of the methods-buffer.
Every function of this hook is called once without arguments direct after
creating the methods-buffer of ECB and it's local key-map. So for example a
function could be added which performs calls of `local-set-key' to define new
key-bindings only for the methods-buffer of ECB." :group 'ecb-methods :type 'hook)

(defcustom ecb-process-non-semantic-files (if (locate-library "speedbar") t) "\
*Display contents of non-semantic-files in the ECB-methods-buffer.
See also `ecb-non-semantic-parsing-function'." :group 'ecb-general :group 'ecb-non-semantic :group 'ecb-most-important :type 'boolean)

(defcustom ecb-non-semantic-parsing-function nil "\
*Define mode-dependent parsing functions for non-semantic files.
This is an alist where the car is a major-mode symbol and the cdr is a
function-symbol of a function which should be used for parsing a non-semantic
buffer, i.h. a buffer for which no semantic grammar exists. Such a function
gets one argument - the filename of current buffer - and has to generate and
return a tag/tag list which is understandable by
`speedbar-insert-generic-list'. speedbar has already included two functions
`speedbar-fetch-dynamic-imenu' and `speedbar-fetch-dynamic-etags' which can be
used for parsing buffers with imenu rsp. etags.

This option takes only effect if `ecb-process-non-semantic-files' is not nil:
Then ECB checks for non-semantic buffers if current `major-mode' is contained
in this option and if yes, then the specified parsing function is called;
if not then the cars of the elements of `speedbar-dynamic-tags-function-list'
are called in that sequence they are listed in this variable. See option
`speedbar-dynamic-tags-function-list' for further details.

In most cases imenu-parsing is preferable over etags-parsing because imenu
operates on Emacs-buffers and needs no external tool and therefore parsing
works also if current contents of a buffer are not saved to disk. But maybe
sometimes etags may return better parsing results.

IMPORTANT: if imenu-parsing should be used then the option
`speedbar-use-imenu-flag' must be set to not nil!" :group 'ecb-methods :group 'ecb-non-semantic :type '(repeat (cons (symbol :tag "Major-mode") (function :tag "Parsing function"))))

(defcustom ecb-non-semantic-methods-initial-expand nil "\
*Initially expand all tags for not by semantic supported sources.
This option can be customized on a major-mode basis, i.e. if a `major-mode' is
contained in this option then all tags for this modes will be initially
expanded - otherwise not." :group 'ecb-methods :group 'ecb-non-semantic :type '(repeat :tag "Expand this modes" (symbol :tag "major mode")))

(defcustom ecb-auto-save-before-etags-methods-rebuild t "\
*Automatic saving of current buffer before rebuilding its methods.
This option is only relevant for sources which are supported and parsed by
etags (see `ecb-process-non-semantic-files'). Because etags is an external
tool a source-buffer can only be reparsed if the buffer is saved to disk. So
the command `ecb-rebuild-methods-buffer' checks for sources which are not
supported by semantic or imenu if either this option is t or if the major-mode
of the source-buffer is contained in this list: In both cases ECB saves the
current source-buffer before it re-runs etags for reparsing the source.
If nil or if the major-mode is not contained then no automatic saving will be
done!

For all source supported by semantic or by imenu this option takes no effect." :group 'ecb-methods :group 'ecb-non-semantic :type '(radio (const :tag "For all etags modes" :value t) (repeat :tag "For these modes" (symbol :tag "Major-mode"))))

(defcustom ecb-non-semantic-exclude-modes '(sh-mode fundamental-mode text-mode) "\
*Exclude modes from parsing with imenu or etags.
Per default, ECB tries to parse all file-types not supported by semantic with
imenu or etags or some other method (for details see the option
`ecb-non-semantic-parsing-function'). If a file-type can not be parsed by
semantic, imenu or etags than this simply results in an empty method-buffer
for this file. But nevertheless you will get a message \"Sorry, no support for
a file of that extension\" which comes from the speedbar-library and can not
switched off. Therefore if a `major-mode' is known as not parse-able by
semantic, imenu or etags it can be added to this option and then it will be
excluded from being tried to parsed." :group 'ecb-non-semantic :type '(repeat :tag "Modes to exclude" (symbol :tag "Major-mode")))

(defcustom ecb-rebuild-non-semantic-methods-before-hook nil "\
*Hook at beginning of `ecb-rebuild-methods-buffer-for-non-semantic'.
So this function is always called by the command `ecb-rebuild-methods-buffer'
for not semantic supported source-types.

Every function of this hook gets one argument: The complete filename of the
current source-buffer in the edit-window. The Method-buffer is only rebuild by
`ecb-rebuild-methods-buffer-for-non-semantic' if either the hook contains no
function (the default) or if no function of this hook returns nil! See
`run-hook-with-args-until-failure' for description how these function are
processed." :group 'ecb-methods :group 'ecb-non-semantic :type 'hook)

;;;***

;;;### (autoloads (ecb-mode-line-data ecb-mode-line-display-window-number ecb-mode-line-prefixes ecb-mode-line) "ecb-mode-line" "ecb/ecb-mode-line.el")
(defconst custom-define-current-source-file "ecb-mode-line.el")

(defgroup ecb-mode-line nil "Settings for the modelines of the ECB-tree-buffers." :group 'ecb-general :prefix "ecb-")

(defcustom ecb-mode-line-prefixes '((ecb-directories-buffer-name) (ecb-sources-buffer-name . ecb-sources-filter-modeline-prefix) (ecb-methods-buffer-name . ecb-methods-filter-modeline-prefix) (ecb-history-buffer-name . ecb-history-filter-modeline-prefix)) "\
*Prefixes shown in the modelines of the special ECB-buffers.
The displayed prefix then looks like: \"[ <PREFIX>[: ]]\", means if a prefix
is defined for an special ECB-buffer then a single space is prepended and if
there is additional text to display (e.g. the current directory in the
sources buffer, see `ecb-mode-line-data') then also the string \": \" is
appended.

Everey element of this list is a cons-cell where the car is used to define a
buffer-name and the cdr to define the modeline-prefix for that buffer.

The buffer-name can either be defined as plain string or with a symbol which
contains the buffer-name as value. The latter one is recommended to define a
prefix for one of the builtin ECB-tree-buffers because then simply the related
option-symbol can be used. To add a prefix for the builtin directories
tree-buffer just set the symbol `ecb-directories-buffer-name' as car.

The cdr is the prefix for a buffer and can either be a string which used as it
is or a function-symbol which is called with three argument (the buffer-name,
the current selected directory and the current selected source-file) and must
return either nil (for no prefix) or a string which is then used a prefix.
Such a function can add the text-property 'help-echo to the result-string.
Then this help-string will be displayed when the user moves the mouse over
this section of the modeline.

If a special ECB-buffer should not have a prefix in its modeline then this
buffer-name should either not being added to this option or added with \"No
prefix\" (= nil as cdr)." :group 'ecb-mode-line :set (function (lambda (symbol value) (set symbol value) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode) (ecb-mode-line-format)))) :initialize 'custom-initialize-default :type '(repeat (cons :tag "Prefix-definition" (choice :tag "Buffer-name" :menu-tag "Buffer-name" (string :tag "Buffer-name as string") (symbol :tag "Symbol containing buffer-name")) (choice :tag "Prefix" :menu-tag "Prefix" (const :tag "No prefix" :value nil) (string :tag "Prefix-string") (function :tag "Compute prefix with")))))

(defcustom ecb-mode-line-display-window-number t "\
*Display in the modeline of every special ECB-window the window-number.
The left-top-most window in a frame has the window-number 0 and all other
windows are numbered with increasing numbers in the sequence, functions like
`other-window' or `next-window' would walk through the frame.

This can be used to jump to windows by number with commands like:

  (defun my-switch-to-window-number (number)
    \"Switch to the nth window\"
    (interactive \"P\")
    (if (integerp number)
        (select-window (nth number (window-list)))))

Currently this feature is only available for GNU Emacs 21.X, because neither
GNU Emacs < 21 nor XEmacs can evaluate dynamically forms in the mode-line." :group 'ecb-mode-line :set (function (lambda (symbol value) (set symbol value) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode) (ecb-mode-line-format)))) :initialize 'custom-initialize-default :type 'boolean)

(defcustom ecb-mode-line-data '((ecb-directories-buffer-name . sel-dir) (ecb-sources-buffer-name . sel-dir) (ecb-methods-buffer-name . sel-source) (ecb-history-buffer-name . "History")) "\
*Data shown in the modelines of the special ECB-buffers.
Everey element of this list is a cons-cell where the car is used to define a
buffer-name and the cdr to define the modeline-data for that buffer. For
details about how to defining a buffer-name see `ecb-mode-line-prefixes' - its
completely the same.

The cdr is the data for ths modeline and can either be the symbol 'sel-dir or
'sel-source whereas the former one displays the current selected directory as
modeline-data and the latter one the current selected source-file (without
path).

In addition to these two predefined values for every special ECB-buffer either
a simple string (which will be displayed) or a function can be specified
which gets three args (name of the buffer, current selected directory and
current selected source-file) and must return a string which will be displayed
in the modeline (or nil if no data should be displayed). Such a function can
add the text-property 'help-echo to the result-string. Then this help-string
will be displayed when the user moves the mouse over this section of the
modeline. 

If a special ECB-buffer should not display special data in its modeline then
this buffer-name should either not being added to this option or added with
\"No data\" (= nil as cdr).

The whole modeline of the special ECB-buffer consists of the prefix of
`ecb-mode-line-prefixes' and the data of `ecb-mode-line-data' - eventually
prepended by the window-number, see `ecb-mode-line-display-window-number'." :group 'ecb-mode-line :set (function (lambda (symbol value) (set symbol value) (if (and (boundp 'ecb-minor-mode) ecb-minor-mode) (ecb-mode-line-format)))) :initialize 'custom-initialize-default :type '(repeat (cons :tag "Data-definition" (choice :tag "Buffer-name" :menu-tag "Buffer-name" (string :tag "Buffer-name as string") (symbol :tag "Symbol containing buffer-name")) (choice :tag "Modeline-data" :menu-tag "Modeline-data" (const :tag "No data" :value nil) (const :tag "Current selected directory" :value sel-dir) (const :tag "Current selected source" :value sel-source) (string :tag "Data-string") (function :tag "Compute data with")))))

;;;***

;;;### (autoloads (ecb-speedbar-before-activate-hook ecb-speedbar) "ecb-speedbar" "ecb/ecb-speedbar.el")
(defconst custom-define-current-source-file "ecb-speedbar.el")

(defgroup ecb-speedbar nil "Settings for the speedbar-integration of ECB." :group 'ecb-general :prefix "ecb-")

(defcustom ecb-speedbar-before-activate-hook nil "\
*Hook running directly before ECB activates the integrated speedbar.

For example this hook can be used to change the expansion-mode of the
integrated speedbar via `speedbar-change-initial-expansion-list'.
Example: (speedbar-change-initial-expansion-list \"buffers\")." :group 'ecb-speedbar :type 'hook)

;;;***

;;;### (autoloads (ecb-tip-of-the-day-file ecb-tip-of-the-day) "ecb-tod" "ecb/ecb-tod.el")
(defconst custom-define-current-source-file "ecb-tod.el")

(defcustom ecb-tip-of-the-day t "\
*Show tip of the day at start time of ECB." :group 'ecb-general :type 'boolean)

(defcustom ecb-tip-of-the-day-file "~/.ecb-tip-of-day.el" "\
*File where tip-of-the-day cursor is stored." :group 'ecb-general :type 'file)

;;;***

;;;### (autoloads (ecb-cedet-url ecb-download-delete-archive ecb-download-install-parent-dir ecb-download-package-version-type ecb-download-url ecb-download ecb-options-version ecb-upgrade-internal) "ecb-upgrade" "ecb/ecb-upgrade.el")
(defconst custom-define-current-source-file "ecb-upgrade.el")

(defgroup ecb-upgrade-internal nil "Only Internal setting for the ECB upgrade-mechanism - no user-options!" :group 'ecb-general :prefix "ecb-")

(defcustom ecb-options-version ecb-version "\
*DO NOT CUSTOMIZE THIS VALUE - IT IS ONLY FOR INTERNAL USAGE!" :group 'ecb-upgrade-internal :type 'string)

(defgroup ecb-download nil "Settings for downloading and installing a new ECB from within ECB." :group 'ecb :prefix "ecb-")

(defcustom ecb-download-url "http://ftp1.sourceforge.net/ecb/" "\
*URL where download-able ECB-versions are located.
The ECB-archive-file (e.g. ecb-1.70.tar.gz) will be appended to this URL and
`ecb-download-ecb' will try to download this archive.

Note: Normally this URL should never change but who knows..." :group 'ecb-download :type 'string)

(defcustom ecb-download-package-version-type 1 "\
*Version type ECB is allowed to download for upgrading.
If you want to upgrade to a newer ECB-version via `ecb-download-ecb' or if you
must upgrade to newer semantic- and/or eieio-versions (because ECB requires
these newer versions) then this option specifies which version-types are
allowed. ECB checks on the download-sites of ECB/semantic/eieio which versions
are currently available and then downloads always the latest version matching
the specified type:

2: Gets the newest version of all stable versions available.
1: Gets the newest version of all stable and beta versions available.
0: Gets the newest version of all stable, beta and alpha versions
   available.
-1: Ask before downloading in the minibuffer for a version (TAB-completion
    of all available versions is possible).

So, 2 means stable, 1 means stable and betas, 0 means stable, betas and alphas
and -1 means ask the user for a version.

Per default stable and beta-versions are allowed (value 1). This comes also
from the fact, that currently speedbar is only available in beta versions
which are very stable.

But all versions must match the restrictions of the specified min- and
max-versions of the required packages. For this see the file README!" :group 'ecb-download :type '(radio (const :tag "Only stable versions" :value 2) (const :tag "Allow beta versions" :value 1) (const :tag "Allow alpha versions" :value 0) (const :tag "Ask for version" :value -1)))

(defcustom ecb-download-install-parent-dir (or (and (file-writable-p ecb-ecb-parent-dir) ecb-ecb-parent-dir) "~") "\
*Parent directory where downloaded packages are installed.
ECB installs a downloaded package in this directory, i.e. the downloaded
archive X.tar.gz will be extracted in this directory so afterwards this
directory contains a new subdirectory X which contains the downloaded package.

This directory must be write-able!" :group 'ecb-download :type 'directory)

(defcustom ecb-download-delete-archive 'always "\
*Should the downloaded archive be deleted after success or failure.
Possible values are:
- only-after-success: Archive is only deleted after successful installation
  but not if a failure occurs during the installation process.
- always: Archive is also deleted if an error occurs.
- nil: Archive will never be deleted." :group 'ecb-download :type '(choice :tag "Delete archive" :menu-tag "Delete archive" (const :tag "After successful installation" only-after-success) (const :tag "Always" always) (const :tag "Never" nil)))

(defcustom ecb-cedet-url "http://ftp1.sourceforge.net/cedet/" "\
*URL where download-able CEDET-libraries are located.
ECB will try to download (if necessary) required versions of the libraries
needed by ECB: The CEDET libraries semantic, eieio and speedbar.

Note: Normally this URL should never change but who knows..." :group 'ecb-download :type 'string)

;;;***

;;;### (autoloads (ecb-winman-winring-name ecb-winman-escreen-number ecb-winman-support) "ecb-winman-support" "ecb/ecb-winman-support.el")
(defconst custom-define-current-source-file "ecb-winman-support.el")

(defgroup ecb-winman-support nil "Settings for supporting several window-managers.\nCurrently winring and escreen are supported." :group 'ecb :prefix "ecb-winman-")

(defcustom ecb-winman-escreen-number 1 "\
*Number of the escreen which is reserved for ECB.
If you go to the escreen with this number you go always to the escreen with
activated ECB. All other escreen-numbers are escreens with deactivated ECB!" :group 'ecb-winman-support :group 'ecb-most-important :type 'integer)

(defcustom ecb-winman-winring-name "ECB" "\
*Name of the winring-window-configuration reserved for ECB.
If you go to the window-configuration with this name you go always to the
window-configuration with activated ECB. All other window-configuration are
configurations with deactivated ECB!" :group 'ecb-winman-support :group 'ecb-most-important :type 'string)

;;;***

;;;### (autoloads (ecb-key-map ecb-current-buffer-sync-hook ecb-before-deactivate-hook ecb-deactivate-hook ecb-activate-hook ecb-before-activate-hook ecb-activate-before-layout-draw-hook ecb-run-ediff-in-ecb-frame ecb-debug-mode ecb-version-check ecb-auto-compatibility-check ecb-minor-mode-text ecb-stealthy-tasks-delay ecb-window-sync-delay ecb-window-sync ecb-grep-find-function ecb-grep-function ecb-clear-caches-before-activate ecb-major-modes-show-or-hide ecb-activation-selects-ecb-frame-if-already-active ecb-auto-activate ecb-use-recursive-edit ecb-most-important ecb-general ecb) "ecb" "ecb/ecb.el")
(defconst custom-define-current-source-file "ecb.el")

(defgroup ecb nil "Emacs code browser." :group 'tools :prefix "ecb-")

(defgroup ecb-general nil "General settings for the Emacs code browser." :group 'ecb :prefix "ecb-")

(defgroup ecb-most-important nil "The most important settings of ECB you should know." :group 'ecb :prefix "ecb-")

(defcustom ecb-use-recursive-edit nil "\
*Tell ECB to use a recursive edit.
If set then it can easily be deactivated by (keyboard-escape-quit)." :group 'ecb-general :type 'boolean)

(defcustom ecb-auto-activate nil "\
*Automatically startup ECB when Emacs starts up.
This should only be true if you always want to run `ecb-activate'." :group 'ecb-general :group 'ecb-most-important :type 'boolean)

(defcustom ecb-activation-selects-ecb-frame-if-already-active 'ask "\
*Trying to activate an already activated ECB selects the ECB-frame.
If t then the ECB-frame is selected, if nil then it is not. If 'ask then ECB
asks if the ECB-frame should be selected if the current-frame is not the
`ecb-frame'." :group 'ecb-general :type '(radio (const :tag "Select the ECB-frame" :value t) (const :tag "Ask if the ECB-frame should be selected" :value ask) (const :tag "Do not select the ECB-frame" :value nil)))

(defcustom ecb-major-modes-show-or-hide (cons nil nil) "\
*List of major-modes which show or hide the ecb-windows.
The value is a cons-cell where the car contains all major-mode-symbols which
should show the special ecb-windows and the cdr contains all
major-mode-symbols which should hide the special ecb-windows. If the symbol of
a major-mode is neither contained in the car-\"show-list\" nor in the
cdr-\"hide-list\" then the visibility-state of the ecb-windows does not
change." :group 'ecb-general :group 'ecb-most-important :type '(cons (repeat :tag "Modes for activation" (symbol :tag "Major-mode")) (repeat :tag "Modes for deactivation" (symbol :tag "Major-mode"))))

(defcustom ecb-clear-caches-before-activate nil "\
*Clear all ECB internal caches before startup.
If t then ECB clears all its internal caches before starting up. Caches are
used for files- and subdirs (see `ecb-cache-directory-contents' and
`ecb-cache-directory-contents-not') for semantic-tags and for the
history-filter.

This caches are completely clean at load-time of the ECB-library!

Default is nil, because is makes sense not to clear these caches at start-time
because ECB is often deacticated temporally especially in combination with
window-managers like escreen.el. In these situations the internal state of ECB
should be preserved for next activation." :group 'ecb-general :type 'boolean)

(defcustom ecb-grep-function (if (fboundp 'igrep) 'igrep 'grep) "\
*Function used for performing a grep.
The popup-menu of the tree-buffers \"Directories\", \"Sources\" and
\"History\" offer to grep the \"current\" directory:
- Directory-buffer: The grep is performed in the current popup-directory after
  clicking the right mouse-button onto a node.
- Sources-buffer: The grep is performed in the current selected directory.
- History-buffer: The grep is performed in the directory of the current
  popup-source after clicking the right mouse-button onto a node.

Conditions for such a function:
- The function is called interactively via `call-interactively'
- During the function-call the `default-directory' is temp. set to that
  directory mentioned above with \"... is performed in ...\", i.e. the
  function can use the value of `default-directory' to determine the directory
  to grep.
- The function must read all it's arguments itself.
- The function is completely responsible for performing the grep itself and
  displaying the results.

Normally one of the standard-grepping functions like `grep' or `igrep' (or
some wrappers around it) should be used!" :group 'ecb-general :type 'function)

(defcustom ecb-grep-find-function (if (fboundp 'igrep-find) 'igrep-find 'grep-find) "\
*Function used for performing a recursive grep.
For more Details see option `ecb-grep-function' and replace \"grep\" with
\"recursive grep\" or \"grep-find\"." :group 'ecb-general :type 'function)

(defcustom ecb-window-sync '(Info-mode dired-mode) "\
*Synchronize the ECB-windows automatically with current edit window.
If 'always then the synchronization takes place always a buffer changes in the
edit window, if nil then never. If a list of major-modes then only if the
`major-mode' of the new buffer belongs NOT to this list.

But in every case the synchronization takes only place if the current-buffer
in the edit-window has a relation to files or directories. Examples for the
former one are all programming-language-modes, `Info-mode' too, an example for
the latter one is `dired-mode'. For all major-modes related to
non-file/directory-buffers like `help-mode', `customize-mode' and others never
an autom. synchronization will be done!

It's recommended to exclude at least `Info-mode' because it makes no sense to
synchronize the ECB-windows after calling the Info help. Per default also
`dired-mode' is excluded but it can also making sense to synchronize the
ECB-directories/sources windows with the current directory in the
dired-buffer.

IMPORTANT NOTE: Every time the synchronization is done the hook
`ecb-current-buffer-sync-hook' is evaluated." :group 'ecb-general :type '(radio :tag "Synchronize ECB windows" (const :tag "Always" :value always) (const :tag "Never" nil) (repeat :tag "Not with these modes" (symbol :tag "mode"))))

(defcustom ecb-window-sync-delay 0.25 "\
*Time Emacs must be idle before the ECB-windows are synchronized.
Synchronizing is done with the current source displayed in the edit window. If
nil then there is no delay, means synchronization takes place immediately. A
small value of about 0.25 seconds saves CPU resources and you get even though
almost the same effect as if you set no delay." :group 'ecb-general :type '(radio (const :tag "No synchronizing delay" :value nil) (number :tag "Idle time before synchronizing" :value 0.25)) :set (function (lambda (symbol value) (set symbol value) (if ecb-minor-mode (ecb-activate-ecb-autocontrol-functions value 'ecb-window-sync-function)))) :initialize 'custom-initialize-default)

(defcustom ecb-stealthy-tasks-delay 1 "\
*Time Emacs must be idle before ECB runs its stealthy tasks.
Currently ECB performes the following stealthy tasks:

  Prescann directories for emptyness: Prescann directories and display them as
  empty or not-empty in the directories-buffer. See the documentation of the
  option `ecb-prescan-directories-for-emptyness' for a description.

  File is read only: Check if sourcefile-items of the directories- or
  sources-buffer are read-only or not. See documentation of the option
  `ecb-sources-perform-read-only-check'.

  Version-control-state: Checks the version-control-state of files in
  directories which are managed by a VC-backend. See the option
  `ecb-vc-enable-support'.

Here the interval is defined ECB has to be idle before starting with these
stealthy tasks. It can be a floating-point value in seconds. The value can
also be changed during running ECB." :group 'ecb-general :group 'ecb-most-important :type '(number :tag "Idle time before running stealthy tasks" :value 1) :initialize 'custom-initialize-default :set (function (lambda (sym val) (set sym val) (ecb-activate-ecb-autocontrol-functions val 'ecb-stealthy-updates))))

(defcustom ecb-minor-mode-text " ECB" "\
*String to display in the mode line when ECB minor mode is active.
\(When the string is not empty, make sure that it has a leading space.)

Because for ECB it is quite obvious if it is active or not when the
ECB-windows are visible this text is only display in the modeline if the
ECB-windows are hidden." :group 'ecb-general :type 'string)

(defcustom ecb-auto-compatibility-check t "\
*Check at ECB-startup if all ECB-options have correct values.
If not nil then all ECB-options are checked if their current value have the
correct type. It the type is incorrect the option is either auto. upgraded to
the new type or reset to the default-value of current ECB if no upgrade is
possible. This feature can also upgrade options which are renamed in current
ECB and try to transform the old-value to the new named option. After startup
all upgraded or reset options are displayed with their old (before
upgrade/reset) and new values. See also the commands `ecb-upgrade-options' and
`ecb-display-upgraded-options'. If this option is off then the user can
perform the check and reset manually with `ecb-upgrade-options'." :group 'ecb-general :type 'boolean)

(defcustom ecb-version-check t "\
*Checks at start-time if the requirements are fulfilled.
It checks if the required versions of the libraries semantic, eieio and
speedbar are installed and loaded into Emacs.

It is strongly recommended to set this option to not nil!" :group 'ecb-general :type 'boolean)

(defcustom ecb-debug-mode nil "\
*If not nil ECB displays debug-information in the Messages-buffer.
This is done for some critical situations concerning semantic-tags and their
overlays (or extends for XEmacs). Normally you should not need this switched
on! But if you get errors like \"destroyed extend\" for XEmacs or
\"wrong-argument-type\" concerning overlays for GNU Emacs then you should
switch on this option and submitting a bug-report to the ecb-mailing-list
\(`ecb-submit-problem-report') after getting the error again!" :group 'ecb-general :type 'boolean)

(defcustom ecb-run-ediff-in-ecb-frame t "\
*Run ediff-sessions in the same frame as ECB is running.
If not nil then ECB ensures that ediff runs in the same frame as ECB and ECB
restores exactly the \"before-ediff\"-window-layout after quiting ediff. If
nil then ediff decides in which frame it will run - depending on the current
window-layout (e.g. if the ecb-windows are currently hidden) this can be the
ecb-frame but this can also be a newly created frame or any other frame." :group 'ecb-general :type 'boolean)

(defcustom ecb-activate-before-layout-draw-hook nil "\
*Hook run at the end of activating ECB by `ecb-activate'.
These hooks run after all the internal setup process but directly before(!)
drawing the layout specified in `ecb-layout' (means before dividing the frame
into several windows). A senseful using of this hook can be maximizing the
Emacs-frame for example, because this should be done before the layout is
drawn because ECB computes the size of the ECB-windows with the current frame
size! If you need a hook-option for the real end of the activating process
\(i.e. after the layout-drawing) look at `ecb-activate-hook'.

IMPORTANT: The difference between this hook and
`ecb-redraw-layout-before-hook' is that the latter one is evaluated always
before the layout is redrawn (for example after calling `ecb-redraw-layout')
whereas the former one (this hook) is only evaluated exactly once during the
activation-process of ECB. So during the activation process there is the
following sequence of hooks:
1. 'ecb-activate-before-layout-draw-hook' (this one)
2. `ecb-redraw-layout-before-hook'
3. <Drawing the layout>
4. `ecb-redraw-layout-after-hook'
5. `ecb-activate-hook'" :group 'ecb-general :type 'hook)

(defcustom ecb-before-activate-hook nil "\
*Hook run at the beginning of activating ECB by `ecb-activate'.
These hooks run before any other tasks of the activating process are
performed. If any of these hooks returns nil then ECB will not be activated!

This can be used to check some conditions and then only start ECB if all
conditions are true. For example a function could be added which returns only
nil if Gnus is running. Then calling `ecb-activate' or `ecb-minor-mode' will
only start ECB if Gnus is not already running." :group 'ecb-general :type 'hook)

(defcustom ecb-activate-hook nil "\
*Hook run at the end of activating ECB by `ecb-activate'.
These hooks run at the real end of the activating process, means after the
layout has been drawn!. If you need hooks which are run direct before the
layout-drawing look at `ecb-activate-before-layout-draw-hook'." :group 'ecb-general :type 'hook)

(defcustom ecb-deactivate-hook nil "\
*Hook run at the end of deactivating ECB by `ecb-deactivate'.
These hooks run before the ecb-layout is cleared!" :group 'ecb-general :type 'hook)

(defcustom ecb-before-deactivate-hook nil "\
*Hook run at the beginning of deactivating ECB by `ecb-deactivate'.
These hooks run before any other tasks of the deactivating process are
performed. If any of these hooks returns nil then ECB will not be deactivated!
See also `ecb-before-activate-hook'." :group 'ecb-general :type 'hook)

(defcustom ecb-current-buffer-sync-hook nil "\
*Hook run at the end of `ecb-current-buffer-sync'.
See documentation of `ecb-current-buffer-sync' for conditions when
synchronization takes place and so in turn these hooks are evaluated.

Precondition for such a hook:
Current buffer is the buffer of the currently selected edit-window.

Postcondition for such a hook:
Point must stay in the same edit-window as before evaluating the hook.

Important note: If `ecb-window-sync' is not nil `ecb-current-buffer-sync' is
running either every time Emacs is idle or even after every command (see
`ecb-window-sync-delay'). So these hooks can be really called very often!
Therefore each function of this hook should/must check in an efficient way at
beginning if its task have to be really performed and then do them only if
really necessary! Otherwise performance of Emacs could slow down
dramatically!

It is strongly recommended that each function added to this hook uses the
macro `ecb-do-if-buffer-visible-in-ecb-frame' at beginning! See
`ecb-speedbar-current-buffer-sync' and `ecb-eshell-current-buffer-sync' for
examples how to use this macro!" :group 'ecb-general :type 'hook)

(defcustom ecb-key-map '("C-c ." (t "fh" ecb-history-filter) (t "fs" ecb-sources-filter) (t "fm" ecb-methods-filter) (t "fr" ecb-methods-filter-regexp) (t "ft" ecb-methods-filter-tagclass) (t "fc" ecb-methods-filter-current-type) (t "fp" ecb-methods-filter-protection) (t "fn" ecb-methods-filter-nofilter) (t "fl" ecb-methods-filter-delete-last) (t "ff" ecb-methods-filter-function) (t "p" ecb-nav-goto-previous) (t "n" ecb-nav-goto-next) (t "lc" ecb-change-layout) (t "lr" ecb-redraw-layout) (t "lw" ecb-toggle-ecb-windows) (t "lt" ecb-toggle-layout) (t "s" ecb-window-sync) (t "r" ecb-rebuild-methods-buffer) (t "a" ecb-toggle-auto-expand-tag-tree) (t "x" ecb-expand-methods-nodes) (t "h" ecb-show-help) (t "gl" ecb-goto-window-edit-last) (t "g1" ecb-goto-window-edit1) (t "g2" ecb-goto-window-edit2) (t "gc" ecb-goto-window-compilation) (t "gd" ecb-goto-window-directories) (t "gs" ecb-goto-window-sources) (t "gm" ecb-goto-window-methods) (t "gh" ecb-goto-window-history) (t "gb" ecb-goto-window-speedbar) (t "md" ecb-maximize-window-directories) (t "ms" ecb-maximize-window-sources) (t "mm" ecb-maximize-window-methods) (t "mh" ecb-maximize-window-history) (t "mb" ecb-maximize-window-speedbar) (t "e" eshell) (t "o" ecb-toggle-scroll-other-window-scrolls-compile) (t "\\" ecb-toggle-compile-window) (t "/" ecb-toggle-compile-window-height) (t "," ecb-cycle-maximized-ecb-buffers) (t "." ecb-cycle-through-compilation-buffers)) "\
*Specifies all key-bindings for the ECB minor-mode key-map.
The value is a cons-cell where the car is a common-prefix key for all the
key-bindings. The cdr is a list of key-bindings each of them a list again. A
key-binding has the following form:

  '(<common-prefix-flag> <keysequence> <function>) where

<common-prefix-flag>: If t then the common-prefixkey defined as car of the
                      value (see above) is used.
<keysequence>: If the common prefixkey is used then the final key-binding is the
               concatenation of the common-prefixkey (see above) and this
               keysequence.
<function>: The function to bind to the key. This can also be a
            lambda-expression .

It is highly recommended to use one of the standard keys C-c or C-x as first key
of your common-prefixkey!

You MUST change this option via customize to take effect!

All keysequences must be inserted as a string and must follow the syntax needed
by `read-kbd-macro' or `kbd'. This means you can insert the key in the same
manner \"C-h k\" displays keysequences. Here is the summary of the syntax:

Text is divided into \"words \" separated by whitespace. Except for the words
described below, the characters of each word go directly as characters of the
keysequence. The whitespace that separates words is ignored. Whitespace in the
macro must be written explicitly, as in \"C-c SPC\".

  * The special words RET, SPC, TAB, DEL, LFD, ESC, and NUL represent special
   control characters. The words must be written in uppercase.

  * A word in angle brackets, e.g., <return>, <down>, <left> or <f1>, represents
    a function key. (Note that in the standard configuration, the function
    key <return> and the control key RET are synonymous.). You can use angle
    brackets on the words RET, SPC, etc., but they are not required there.

  * Keys can be written by their ASCII code, using a backslash followed by up
    to six octal digits. This is the only way to represent keys with codes
    above .

  * One or more prefixes M- (meta), C- (control), S- (shift), A- (alt),
    H- (hyper), and s- (super) may precede a character or key notation. For
    function keys, the prefixes may go inside or outside of the brackets:
    C-<down> = <C-down>. The prefixes may be written in any order: M-C-x =
    C-M-x.
    Prefixes are not allowed on multi-key words, e.g., C-abc, except that the
    Meta prefix is allowed on a sequence of digits and optional minus sign:
    M--123 = M-- M-1 M-2 M-3.

  * The `^' notation for control characters also works:  ^M = C-m." :group 'ecb-general :group 'ecb-most-important :type '(cons (choice :tag "Common prefix-key" (const :tag "No common prefix-key" :value nil) (string :tag "Prefix-key" :value "C-c .")) (repeat :tag "Key-bindings" (list :tag "Key-definition" (boolean :tag "o Use common prefix-key" :value t) (string :tag "o Key") (function :tag "o Function or lambda-expression" :value nil)))) :set (function (lambda (symbol value) (set symbol value) (setq ecb-mode-map (let ((km (make-sparse-keymap)) (val-list (ecb-copy-list (cdr value))) keq-string) (dolist (elem val-list) (setq key-string (concat (if (nth 0 elem) (car value)) " " (nth 1 elem))) (define-key km (read-kbd-macro key-string) (nth 2 elem))) (easy-menu-define ecb-minor-menu km "ECB Minor Mode Menu" ecb-menu-bar) km)) (ecb-add-to-minor-modes))))

;;;***

(provide 'ecb-custom-defines)
