;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ecrypto-custom-defines) (error "Feature ecrypto-custom-defines already loaded"))

;;;### (autoloads (encrypt-gpg-path encrypt-file-alist encrypt) "encrypt" "ecrypto/encrypt.el")
(defconst custom-define-current-source-file "encrypt.el")

(defgroup encrypt '((password-cache custom-variable) (password-cache-expiry custom-variable)) "File encryption configuration." :group 'applications)

(defcustom encrypt-file-alist nil "\
List of file names or regexes matched with encryptions.
Format example:
 '((\"beta\"
    (gpg \"AES\"))
   (\"/home/tzz/alpha\"
    (encrypt-xor \"Semi-Secret\")))" :type '(repeat (list :tag "Encryption entry" (radio :tag "What to encrypt" (file :tag "Filename") (regexp :tag "Regular expression match")) (radio :tag "How to encrypt it" (list :tag "GPG Encryption" (const :tag "GPG Program" gpg) (radio :tag "Choose a cipher" (const :tag "3DES Encryption" "3DES") (const :tag "CAST5 Encryption" "CAST5") (const :tag "Blowfish Encryption" "BLOWFISH") (const :tag "AES Encryption" "AES") (const :tag "AES192 Encryption" "AES192") (const :tag "AES256 Encryption" "AES256") (const :tag "Twofish Encryption" "TWOFISH") (string :tag "Cipher Name"))) (list :tag "Built-in simple XOR" (const :tag "XOR Encryption" encrypt-xor) (string :tag "XOR Cipher Value (seed value)"))))) :group 'encrypt)

(defcustom encrypt-gpg-path (executable-find "gpg") "\
Path to the GPG program." :type '(radio (file :tag "Location of the GPG executable") (const :tag "GPG is not installed" nil)) :group 'encrypt)

;;;***

;;;### (autoloads (md5-maximum-internal-length md5-program) "md5-el" "ecrypto/md5-el.el")
(defconst custom-define-current-source-file "md5-el.el")

(defcustom md5-program "md5" "\
*Program that reads a message on its standard input and writes an
MD5 digest on its output." :type 'string)

(defcustom md5-maximum-internal-length 4096 "\
*The maximum size of a piece of data that should use the MD5 routines
written in lisp.  If a message exceeds this, it will be run through an
external filter for processing.  Also see the `md5-program' variable.
This variable has no effect if you call the md5-init|update|final
functions - only used by the `md5' function's simpler interface." :type 'integer)

;;;***

;;;### (autoloads (password-cache-expiry password-cache) "password" "ecrypto/password.el")
(defconst custom-define-current-source-file "password.el")

(defcustom password-cache t "\
Whether to cache passwords." :group 'password :type 'boolean)

(defcustom password-cache-expiry 16 "\
How many seconds passwords are cached, or nil to disable expiring.
Whether passwords are cached at all is controlled by `password-cache'." :group 'password :type '(choice (const :tag "Never" nil) (integer :tag "Seconds")))

;;;***

;;;### (autoloads (rijndael-monte-carlo-loop rijndael-monte-carlo-limit rijndael) "rijndael" "ecrypto/rijndael.el")
(defconst custom-define-current-source-file "rijndael.el")

(defgroup rijndael nil "Rijndael cryptographic functions")

(defcustom rijndael-monte-carlo-limit 10000 "\
How many iterations to do in the Monte-Carlo tests.
NIST uses 10000 (the default), but this will be very slow, so you may
change this to a lower value (like, say, 1).  Of course, you must
modify the Rijndael reference implementation to be able to compare the
output." :group 'rijndael :type 'integer)

(defcustom rijndael-monte-carlo-loop 400 "\
How many iterations to do in the Monte-Carlo tests.
NIST uses 400 (the default), but this will be very slow, so you may
change this to a lower value (like, say, 1).  Of course, you must
modify the Rijndael reference implementation to be able to compare the
output." :group 'rijndael :type 'integer)

;;;***

;;;### (autoloads (sha1-use-external sha1-program sha1-maximum-internal-length sha1) "sha1" "ecrypto/sha1.el")
(defconst custom-define-current-source-file "sha1.el")

(defgroup sha1 nil "Elisp interface for SHA1 hash computation." :group 'extensions)

(defcustom sha1-maximum-internal-length 500 "\
*Maximum length of message to use Lisp version of SHA1 function.
If message is longer than this, `sha1-program' is used instead.

If this variable is set to 0, use external program only.
If this variable is set to nil, use internal function only." :type 'integer :group 'sha1)

(defcustom sha1-program '("sha1sum") "\
*Name of program to compute SHA1.
It must be a string (program name) or list of strings (name and its args)." :type '(repeat string) :group 'sha1)

(defcustom sha1-use-external (condition-case nil (executable-find (car sha1-program)) (error)) "\
*Use external SHA1 program.
If this variable is set to nil, use internal function only." :type 'boolean :group 'sha1)

;;;***

(provide 'ecrypto-custom-defines)
