;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ede-custom-defines) (error "Feature ede-custom-defines already loaded"))

;;;### (autoloads (ede-simple-save-file-name ede-simple-save-directory) "ede-simple" "ede/ede-simple.el")
(defconst custom-define-current-source-file "ede-simple.el")

(defcustom ede-simple-save-directory "~/.ede" "\
*Directory where simple EDE project overlays are saved." :group 'ede :type 'directory)

(defcustom ede-simple-save-file-name "ProjSimple.ede" "\
*File name used for simple project wrappers." :group 'ede :type 'string)

;;;***

;;;### (autoloads (ede-project-placeholder-cache-file ede-debug-program-function ede-auto-add-method ede) "ede" "ede/ede.el")
(defconst custom-define-current-source-file "ede.el")

(defgroup ede nil "Emacs Development Environment gloss." :group 'tools :group 'convenience)

(defcustom ede-auto-add-method 'ask "\
*Determins if a new source file shoud be automatically added to a target.
Whenever a new file is encountered in a directory controlled by a
project file, all targets are queried to see if it should be added.
If the value is 'always, then the new file is added to the first
target encountered.  If the value is 'multi-ask, then if more than one
target wants the file, the user is asked.  If only one target wants
the file, then then it is automatically added to that target.  If the
value is 'ask, then the user is always asked, unless there is no
target willing to take the file.  'never means never perform the check." :group 'ede :type '(choice (const always) (const multi-ask) (const ask) (const never)))

(defcustom ede-debug-program-function 'gdb "\
*Default Emacs command used to debug a target." :group 'ede :type 'sexp)

(defcustom ede-project-placeholder-cache-file (expand-file-name "~/.projects.ede") "\
*File containing the list of projects EDE has viewed." :group 'ede :type 'file)

;;;***

;;;### (autoloads (project-am-debug-target-function project-am-compile-target-command project-am-compile-project-command project-am) "project-am" "ede/project-am.el")
(defconst custom-define-current-source-file "project-am.el")

(defgroup project-am nil "File and tag browser frame." :group 'tools :group 'ede)

(defcustom project-am-compile-project-command nil "\
*Default command used to compile a project." :group 'project-am :type 'string)

(defcustom project-am-compile-target-command "make -k %s" "\
*Default command used to compile a project." :group 'project-am :type 'string)

(defcustom project-am-debug-target-function 'gdb "\
*Default Emacs command used to debug a target." :group 'project-am :type 'sexp)

;;;***

(provide 'ede-custom-defines)
