;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ediff-custom-defines) (error "Feature ediff-custom-defines already loaded"))

;;;### (autoloads (ediff-diff3-ok-lines-regexp ediff-diff3-options ediff-custom-diff-options ediff-custom-diff-program ediff-ignore-case-option3 ediff-ignore-case-option ediff-diff-options ediff-cmp-options ediff-cmp-program ediff-shell ediff-diff3-program ediff-diff-program ediff-diff) "ediff-diff" "ediff/ediff-diff.el")
(defconst custom-define-current-source-file "ediff-diff.el")

(defgroup ediff-diff nil "Diff related utilities." :prefix "ediff-" :group 'ediff)

(defcustom ediff-diff-program "diff" "\
Program to use for generating the differential of the two files." :type 'string :group 'ediff-diff)

(defcustom ediff-diff3-program "diff3" "\
Program to be used for three-way comparison.
Must produce output compatible with Unix's diff3 program." :type 'string :group 'ediff-diff)

(defcustom ediff-shell (cond ((eq system-type 'emx) "cmd") ((memq system-type '(ms-dos windows-nt windows-95)) shell-file-name) (t "sh")) "\
The shell used to run diff and patch.
If user's .profile or .cshrc files are set up correctly, any shell
will do.  However, some people set $prompt or other things
incorrectly, which leads to undesirable output messages.  These may
cause Ediff to fail.  In such a case, set `ediff-shell' to a shell that
you are not using or, better, fix your shell's startup file." :type 'string :group 'ediff-diff)

(defcustom ediff-cmp-program "cmp" "\
Utility to use to determine if two files are identical.
It must return code 0, if its arguments are identical files." :type 'string :group 'ediff-diff)

(defcustom ediff-cmp-options nil "\
Options to pass to `ediff-cmp-program'.
If GNU diff is used as `ediff-cmp-program', then the most useful options
are `-I REGEXP', to ignore changes whose lines match the REGEXP." :type '(repeat string) :group 'ediff-diff)

(defcustom ediff-diff-options (if (memq system-type '(ms-dos windows-nt windows-95)) "--binary" "") "\
Options to pass to `ediff-diff-program'.
If Unix diff is used as `ediff-diff-program',
then a useful option is `-w', to ignore space.
Options `-c', `-u', and `-i' are not allowed. Case sensitivity can be
toggled interactively using \\[ediff-toggle-ignore-case].

Do not remove the default options. If you need to change this variable, add new
options after the default ones.

This variable is not for customizing the look of the differences produced by
the command \\[ediff-show-diff-output]. Use the variable
`ediff-custom-diff-options' for that." :set 'ediff-set-diff-options :type 'string :group 'ediff-diff)

(defcustom ediff-ignore-case-option "-i" "\
Option that causes the diff program to ignore case of letters." :type 'string :group 'ediff-diff)

(defcustom ediff-ignore-case-option3 "" "\
Option that causes the diff3 program to ignore case of letters.
GNU diff3 doesn't have such an option." :type 'string :group 'ediff-diff)

(defcustom ediff-custom-diff-program ediff-diff-program "\
Program to use for generating custom diff output for saving it in a file.
This output is not used by Ediff internally." :type 'string :group 'ediff-diff)

(defcustom ediff-custom-diff-options "-c" "\
Options to pass to `ediff-custom-diff-program'." :type 'string :group 'ediff-diff)

(defcustom ediff-diff3-options "" "\
Options to pass to `ediff-diff3-program'." :set 'ediff-set-diff-options :type 'string :group 'ediff-diff)

(defcustom ediff-diff3-ok-lines-regexp "^\\([1-3]:\\|====\\|  \\|.*Warning *:\\|.*No newline\\|.*missing newline\\|^
$\\)" "\
Regexp that matches normal output lines from `ediff-diff3-program'.
Lines that do not match are assumed to be error messages." :type 'regexp :group 'ediff-diff)

;;;***

;;;### (autoloads (ediff-use-long-help-message) "ediff-help" "ediff/ediff-help.el")
(defconst custom-define-current-source-file "ediff-help.el")

(defcustom ediff-use-long-help-message nil "\
If t, Ediff displays a long help message.  Short help message otherwise." :type 'boolean :group 'ediff-window)

;;;***

;;;### (autoloads (ediff-metachars ediff-temp-file-mode ediff-temp-file-prefix ediff-no-emacs-help-in-control-buffer ediff-merge-filename-prefix ediff-autostore-merges ediff-make-buffers-readonly-at-startup ediff-coding-system-for-write ediff-coding-system-for-read ediff-version-control-package ediff-highlight-all-diffs ediff-keep-variants ediff-use-faces ediff-after-flag-mol ediff-before-flag-mol ediff-after-flag-eol ediff-before-flag-bol ediff-cleanup-hook ediff-quit-hook ediff-suspend-hook ediff-display-help-hook ediff-keymap-setup-hook ediff-mode-hook ediff-load-hook ediff-prepare-buffer-hook ediff-unselect-hook ediff-select-hook ediff-startup-hook ediff-after-setup-control-frame-hook ediff-before-setup-control-frame-hook ediff-after-setup-windows-hook ediff-before-setup-windows-hook ediff-before-setup-hook ediff-hook ediff-merge ediff-highlighting) "ediff-init" "ediff/ediff-init.el")
(defconst custom-define-current-source-file "ediff-init.el")

(defgroup ediff-highlighting nil "Hilighting of difference regions in Ediff." :prefix "ediff-" :group 'ediff)

(defgroup ediff-merge nil "Merging utilities." :prefix "ediff-" :group 'ediff)

(defgroup ediff-hook nil "Hooks run by Ediff." :prefix "ediff-" :group 'ediff)

(defcustom ediff-before-setup-hook nil "\
Hooks to run before Ediff begins to set up windows and buffers.
This hook can be used to save the previous window config, which can be restored
on ediff-quit or ediff-suspend." :type 'hook :group 'ediff-hook)

(defcustom ediff-before-setup-windows-hook nil "\
Hooks to run before Ediff sets its window configuration.
This hook is run every time when Ediff arranges its windows.
This happens each time Ediff detects that the windows were messed up by the
user." :type 'hook :group 'ediff-hook)

(defcustom ediff-after-setup-windows-hook nil "\
Hooks to run after Ediff sets its window configuration.
This can be used to set up control window or icon in a desired place." :type 'hook :group 'ediff-hook)

(defcustom ediff-before-setup-control-frame-hook nil "\
Hooks run before setting up the frame to display Ediff Control Panel.
Can be used to change control frame parameters to position it where it
is desirable." :type 'hook :group 'ediff-hook)

(defcustom ediff-after-setup-control-frame-hook nil "\
Hooks run after setting up the frame to display Ediff Control Panel.
Can be used to move the frame where it is desired." :type 'hook :group 'ediff-hook)

(defcustom ediff-startup-hook nil "\
Hooks to run in the control buffer after Ediff has been set up and is ready for the job." :type 'hook :group 'ediff-hook)

(defcustom ediff-select-hook nil "\
Hooks to run after a difference has been selected." :type 'hook :group 'ediff-hook)

(defcustom ediff-unselect-hook nil "\
Hooks to run after a difference has been unselected." :type 'hook :group 'ediff-hook)

(defcustom ediff-prepare-buffer-hook nil "\
Hooks run after buffers A, B, and C are set up.
For each buffer, the hooks are run with that buffer made current." :type 'hook :group 'ediff-hook)

(defcustom ediff-load-hook nil "\
Hook run after Ediff is loaded.  Can be used to change defaults." :type 'hook :group 'ediff-hook)

(defcustom ediff-mode-hook nil "\
Hook run just after ediff-mode is set up in the control buffer.
This is done before any windows or frames are created.  One can use it to
set local variables that determine how the display looks like." :type 'hook :group 'ediff-hook)

(defcustom ediff-keymap-setup-hook nil "\
Hook run just after the default bindings in Ediff keymap are set up." :type 'hook :group 'ediff-hook)

(defcustom ediff-display-help-hook nil "\
Hooks run after preparing the help message." :type 'hook :group 'ediff-hook)

(defcustom ediff-suspend-hook nil "\
Hooks to run in the Ediff control buffer when Ediff is suspended." :type 'hook :group 'ediff-hook)

(defcustom ediff-quit-hook nil "\
Hooks to run in the Ediff control buffer after finishing Ediff." :type 'hook :group 'ediff-hook)

(defcustom ediff-cleanup-hook nil "\
Hooks to run on exiting Ediff but before killing the control and variant buffers." :type 'hook :group 'ediff-hook)

(defcustom ediff-before-flag-bol (if (featurep 'xemacs) (make-glyph "->>") "->>") "\
Flag placed before a highlighted block of differences, if block starts at beginning of a line." :type 'string :tag "Region before-flag at beginning of line" :group 'ediff)

(defcustom ediff-after-flag-eol (if (featurep 'xemacs) (make-glyph "<<-") "<<-") "\
Flag placed after a highlighted block of differences, if block ends at end of a line." :type 'string :tag "Region after-flag at end of line" :group 'ediff)

(defcustom ediff-before-flag-mol (if (featurep 'xemacs) (make-glyph "->>") "->>") "\
Flag placed before a highlighted block of differences, if block starts in mid-line." :type 'string :tag "Region before-flag in the middle of line" :group 'ediff)

(defcustom ediff-after-flag-mol (if (featurep 'xemacs) (make-glyph "<<-") "<<-") "\
Flag placed after a highlighted block of differences, if block ends in mid-line." :type 'string :tag "Region after-flag in the middle of line" :group 'ediff)

(defcustom ediff-use-faces t "\
If t, differences are highlighted using faces, if device supports faces.
If nil, differences are highlighted using ASCII flags, ediff-before-flag
and ediff-after-flag.  On a non-window system, differences are always
highlighted using ASCII flags." :type 'boolean :group 'ediff-highlighting)

(defcustom ediff-keep-variants t "\
nil means prompt to remove unmodified buffers A/B/C at session end.
Supplying a prefix argument to the quit command `q' temporarily reverses the
meaning of this variable." :type 'boolean :group 'ediff)

(defcustom ediff-highlight-all-diffs t "\
If nil, only the selected differences are highlighted.
Otherwise, all difference regions are highlighted, but the selected region is
shown in brighter colors." :type 'boolean :group 'ediff-highlighting)

(defcustom ediff-version-control-package 'vc "\
Version control package used.
Currently, Ediff supports vc.el, rcs.el, pcl-cvs.el, and generic-sc.el.  The
standard Emacs interface to RCS, CVS, SCCS, etc., is vc.el.  However, some
people find the other two packages more convenient.  Set this variable to the
appropriate symbol: `rcs', `pcl-cvs', or `generic-sc' if you so desire." :type 'symbol :group 'ediff)

(defcustom ediff-coding-system-for-read 'raw-text "\
The coding system for read to use when running the diff program as a subprocess.
In most cases, the default will do.  However, under certain circumstances in
MS-Windows you might need to use something like 'raw-text-dos here.
So, if the output that your diff program sends to Emacs contains extra ^M's,
you might need to experiment here, if the default or 'raw-text-dos doesn't
work." :type 'symbol :group 'ediff)

(defcustom ediff-coding-system-for-write (if (featurep 'xemacs) 'escape-quoted 'emacs-internal) "\
The coding system for write to use when writing out difference regions
to temp files in buffer jobs and when Ediff needs to find fine differences." :type 'symbol :group 'ediff)

(defcustom ediff-make-buffers-readonly-at-startup nil "\
Make all variant buffers read-only when Ediff starts up.
This property can be toggled interactively." :type 'boolean :group 'ediff)

(defcustom ediff-autostore-merges 'group-jobs-only "\
Save the results of merge jobs automatically.
With value nil, don't save automatically.  With value t, always
save.  Anything else means save automatically only if the merge
job is part of a group of jobs, such as `ediff-merge-directory'
or `ediff-merge-directory-revisions'." :type '(choice (const nil) (const t) (const group-jobs-only)) :group 'ediff-merge)

(defcustom ediff-merge-filename-prefix "merge_" "\
Prefix to be attached to saved merge buffers." :type 'string :group 'ediff-merge)

(defcustom ediff-no-emacs-help-in-control-buffer nil "\
Non-nil means C-h should not invoke Emacs help in control buffer.
Instead, C-h would jump to previous difference." :type 'boolean :group 'ediff)

(defcustom ediff-temp-file-prefix (file-name-as-directory (cond ((boundp 'temporary-file-directory) temporary-file-directory) ((fboundp 'temp-directory) (temp-directory)) (t "/tmp/"))) "\
Prefix to put on Ediff temporary file names.
Do not start with `~/' or `~USERNAME/'." :type 'string :group 'ediff)

(defcustom ediff-temp-file-mode 384 "\
Mode for Ediff temporary files." :type 'integer :group 'ediff)

(defcustom ediff-metachars "[ 	\n!\"#$&'()*;<=>?[\\^`{|~]" "\
Regexp that matches characters that must be quoted with `\\' in shell command line.
This default should work without changes." :type 'string :group 'ediff)

;;;***

;;;### (autoloads (ediff-skip-merge-regions-that-differ-from-default ediff-show-clashes-only ediff-combination-pattern ediff-default-variant ediff-quit-merge-hook) "ediff-merg" "ediff/ediff-merg.el")
(defconst custom-define-current-source-file "ediff-merg.el")

(defcustom ediff-quit-merge-hook 'ediff-maybe-save-and-delete-merge "\
Hooks to run before quitting a merge job.
The most common use is to save and delete the merge buffer." :type 'hook :group 'ediff-merge)

(defcustom ediff-default-variant 'combined "\
The variant to be used as a default for buffer C in merging.
Valid values are the symbols `default-A', `default-B', and `combined'." :type '(radio (const default-A) (const default-B) (const combined)) :group 'ediff-merge)

(defcustom ediff-combination-pattern '("<<<<<<< variant A" A ">>>>>>> variant B" B "####### Ancestor" Ancestor "======= end") "\
Pattern to be used for combining difference regions in buffers A and B.
The value must be a list of the form
\(STRING1 bufspec1  STRING2 bufspec2 STRING3 bufspec3 STRING4)
where bufspec is the symbol A, B, or Ancestor. For instance, if the value is
'(STRING1 A  STRING2 Ancestor STRING3 B STRING4) then the
combined text will look like this:

STRING1
diff region from variant A
STRING2
diff region from the ancestor
STRING3
diff region from variant B
STRING4
" :type '(choice (list string symbol string symbol string) (list string symbol string symbol string symbol string)) :group 'ediff-merge)

(defcustom ediff-show-clashes-only nil "\
If t, show only those diff regions where both buffers disagree with the ancestor.
This means that regions that have status prefer-A or prefer-B will be
skipped over.  A value of nil means show all regions." :type 'boolean :group 'ediff-merge)

(defcustom ediff-skip-merge-regions-that-differ-from-default nil "\
If t, show only the regions that have not been changed by the user.
A region is considered to have been changed if it is different from the current
default (`default-A', `default-B', `combined') and it hasn't been marked as
`prefer-A' or `prefer-B'.
A region is considered to have been changed also when it is marked as
as `prefer-A', but is different from the corresponding difference region in
Buffer A or if it is marked as `prefer-B' and is different from the region in
Buffer B." :type 'boolean :group 'ediff-merge)

;;;***

;;;### (autoloads (ediff-meta-buffer-keymap-setup-hook ediff-show-session-group-hook ediff-show-registry-hook ediff-quit-session-group-hook ediff-after-session-group-setup-hook ediff-before-session-group-setup-hooks ediff-registry-setup-hook ediff-meta-mode-hook ediff-meta-truncate-filenames ediff-default-filtering-regexp ediff-mult) "ediff-mult" "ediff/ediff-mult.el")
(defconst custom-define-current-source-file "ediff-mult.el")

(defgroup ediff-mult nil "Multi-file and multi-buffer processing in Ediff." :prefix "ediff-" :group 'ediff)

(defcustom ediff-default-filtering-regexp nil "\
The default regular expression used as a filename filter in multifile comparisons.
Should be a sexp.  For instance (car ediff-filtering-regexp-history) or nil." :type 'sexp :group 'ediff-mult)

(defcustom ediff-meta-truncate-filenames t "\
If non-nil, truncate long file names in the session group buffers.
This can be toggled with `ediff-toggle-filename-truncation'." :type 'boolean :group 'ediff-mult)

(defcustom ediff-meta-mode-hook nil "\
Hooks run just after setting up meta mode." :type 'hook :group 'ediff-mult)

(defcustom ediff-registry-setup-hook nil "\
Hooks run just after the registry control panel is set up." :type 'hook :group 'ediff-mult)

(defcustom ediff-before-session-group-setup-hooks nil "\
Hooks to run before Ediff arranges the window for group-level operations.
It is used by commands such as `ediff-directories'.
This hook can be used to save the previous window config, which can be restored
on `ediff-quit', `ediff-suspend', or `ediff-quit-session-group-hook'." :type 'hook :group 'ediff-hook)

(defcustom ediff-after-session-group-setup-hook nil "\
Hooks run just after a meta-buffer controlling a session group, such as
ediff-directories, is run." :type 'hook :group 'ediff-mult)

(defcustom ediff-quit-session-group-hook nil "\
Hooks run just before exiting a session group." :type 'hook :group 'ediff-mult)

(defcustom ediff-show-registry-hook nil "\
Hooks run just after the registry buffer is shown." :type 'hook :group 'ediff-mult)

(defcustom ediff-show-session-group-hook '(delete-other-windows) "\
Hooks run just after a session group buffer is shown." :type 'hook :group 'ediff-mult)

(defcustom ediff-meta-buffer-keymap-setup-hook nil "\
Hooks run just after setting up the `ediff-meta-buffer-map'.
This keymap controls key bindings in the meta buffer and is a local variable.
This means that you can set different bindings for different kinds of meta
buffers." :type 'hook :group 'ediff-mult)

;;;***

;;;### (autoloads (ediff-context-diff-label-regexp ediff-patch-default-directory ediff-backup-specs ediff-backup-extension ediff-patch-options ediff-patch-program ediff-ptch) "ediff-ptch" "ediff/ediff-ptch.el")
(defconst custom-define-current-source-file "ediff-ptch.el")

(defgroup ediff-ptch nil "Ediff patch support." :tag "Patch" :prefix "ediff-" :group 'ediff)

(defcustom ediff-patch-program "patch" "\
Name of the program that applies patches.
It is recommended to use GNU-compatible versions." :type 'string :group 'ediff-ptch)

(defcustom ediff-patch-options "-f" "\
Options to pass to ediff-patch-program.

Note: the `-b' option should be specified in `ediff-backup-specs'.

It is recommended to pass the `-f' option to the patch program, so it won't ask
questions.  However, some implementations don't accept this option, in which
case the default value for this variable should be changed." :type 'string :group 'ediff-ptch)

(defcustom ediff-backup-extension ediff-default-backup-extension "\
Backup extension used by the patch program.
See also `ediff-backup-specs'." :type 'string :group 'ediff-ptch)

(defcustom ediff-backup-specs (let ((type (ediff-test-patch-utility))) (cond ((eq type 'gnu) (format "-z%s -b" ediff-backup-extension)) ((eq type 'posix) (setq ediff-backup-extension ediff-default-backup-extension) "-b") (t (format "-b %s" ediff-backup-extension)))) "\
Backup directives to pass to the patch program.
Ediff requires that the old version of the file (before applying the patch)
be saved in a file named `the-patch-file.extension'.  Usually `extension' is
`.orig', but this can be changed by the user and may depend on the system.
Therefore, Ediff needs to know the backup extension used by the patch program.

Some versions of the patch program let you specify `-b backup-extension'.
Other versions only permit `-b', which assumes the extension `.orig'
\(in which case ediff-backup-extension MUST be also `.orig').  The latest
versions of GNU patch require `-b -z backup-extension'.

Note that both `ediff-backup-extension' and `ediff-backup-specs'
must be set properly.  If your patch program takes the option `-b',
but not `-b extension', the variable `ediff-backup-extension' must
still be set so Ediff will know which extension to use.

Ediff tries to guess the appropriate value for this variables.  It is believed
to be working for `traditional' patch, all versions of GNU patch, and for POSIX
patch.  So, don't change these variables, unless the default doesn't work." :type 'string :group 'ediff-ptch)

(defcustom ediff-patch-default-directory nil "\
Default directory to look for patches." :type '(choice (const nil) string) :group 'ediff-ptch)

(defcustom ediff-context-diff-label-regexp (concat "\\(" "^\\*\\*\\* +\\([^ 	]+\\)[^*]+[	 ]*\n--- +\\([^ 	]+\\)" "\\|" "^--- +\\([^ 	]+\\).*\n\\+\\+\\+ +\\([^ 	]+\\)" "\\)") "\
Regexp matching filename 2-liners at the start of each context diff.
You probably don't want to change that, unless you are using an obscure patch
program." :type 'regexp :group 'ediff-ptch)

;;;***

;;;### (autoloads (ediff-use-toolbar-p) "ediff-tbar" "ediff/ediff-tbar.el")
(defconst custom-define-current-source-file "ediff-tbar.el")

(defcustom ediff-use-toolbar-p nil "\
*If t, Ediff will use a toolbar for the control frame.
This has an effect only if your emacs supports Toolbars.
Currently, XEmacs does, but Emacs doesn't.
This variable can be changed only via the menu bar or
through the Emacs customization widget." :type 'boolean :set (lambda (widget value) (or (eq value ediff-use-toolbar-p) (ediff-toggle-use-toolbar))) :group 'ediff)

;;;***

;;;### (autoloads (ediff-keep-tmp-versions) "ediff-vers" "ediff/ediff-vers.el")
(defconst custom-define-current-source-file "ediff-vers.el")

(defcustom ediff-keep-tmp-versions nil "\
If t, do not delete temporary previous versions for the files on which
comparison or merge operations are being performed." :type 'boolean :group 'ediff-vers)

;;;***

;;;### (autoloads (ediff-prefer-iconified-control-frame ediff-wide-control-frame-rightward-shift ediff-narrow-control-frame-leftward-shift ediff-control-frame-upward-shift ediff-control-frame-position-function ediff-grab-mouse ediff-merge-split-window-function ediff-split-window-function ediff-window-setup-function ediff-window) "ediff-wind" "ediff/ediff-wind.el")
(defconst custom-define-current-source-file "ediff-wind.el")

(defgroup ediff-window nil "Ediff window manipulation." :prefix "ediff-" :group 'ediff :group 'frames)

(defcustom ediff-window-setup-function (ediff-choose-window-setup-function-automatically) "\
Function called to set up windows.
Ediff provides a choice of two functions: `ediff-setup-windows-plain', for
doing everything in one frame and `ediff-setup-windows-multiframe', which sets
the control panel in a separate frame. By default, the appropriate function is
chosen automatically depending on the current window system.
However, `ediff-toggle-multiframe' can be used to toggle between the multiframe
display and the single frame display.
If the multiframe function detects that one of the buffers A/B is seen in some
other frame, it will try to keep that buffer in that frame.

If you don't like any of the two provided functions, write your own one.
The basic guidelines:
    1. It should leave the control buffer current and the control window
       selected.
    2. It should set `ediff-window-A', `ediff-window-B', `ediff-window-C',
       and `ediff-control-window' to contain window objects that display
       the corresponding buffers.
    3. It should accept the following arguments:
       buffer-A, buffer-B, buffer-C, control-buffer
       Buffer C may not be used in jobs that compare only two buffers.
If you plan to do something fancy, take a close look at how the two
provided functions are written." :type '(choice (const :tag "Multi Frame" ediff-setup-windows-multiframe) (const :tag "Single Frame" ediff-setup-windows-plain) (function :tag "Other function")) :group 'ediff-window)

(defcustom ediff-split-window-function 'split-window-vertically "\
The function used to split the main window between buffer-A and buffer-B.
You can set it to a horizontal split instead of the default vertical split
by setting this variable to `split-window-horizontally'.
You can also have your own function to do fancy splits.
This variable has no effect when buffer-A/B are shown in different frames.
In this case, Ediff will use those frames to display these buffers." :type '(choice (const :tag "Split vertically" split-window-vertically) (const :tag "Split horizontally" split-window-horizontally) function) :group 'ediff-window)

(defcustom ediff-merge-split-window-function 'split-window-horizontally "\
The function used to split the main window between buffer-A and buffer-B.
You can set it to a vertical split instead of the default horizontal split
by setting this variable to `split-window-vertically'.
You can also have your own function to do fancy splits.
This variable has no effect when buffer-A/B/C are shown in different frames.
In this case, Ediff will use those frames to display these buffers." :type '(choice (const :tag "Split vertically" split-window-vertically) (const :tag "Split horizontally" split-window-horizontally) function) :group 'ediff-window)

(defcustom ediff-grab-mouse t "\
If t, Ediff will always grab the mouse and put it in the control frame.
If 'maybe, Ediff will do it sometimes, but not after operations that require
relatively long time.  If nil, the mouse will be entirely user's
responsibility." :type 'boolean :group 'ediff-window)

(defcustom ediff-control-frame-position-function 'ediff-make-frame-position "\
Function to call to determine the desired location for the control panel.
Expects three parameters: the control buffer, the desired width and height
of the control frame.  It returns an association list
of the form ((top . <position>) (left . <position>))" :type 'function :group 'ediff-window)

(defcustom ediff-control-frame-upward-shift 42 "\
The upward shift of control frame from the top of buffer A's frame.
Measured in pixels.
This is used by the default control frame positioning function,
`ediff-make-frame-position'.  This variable is provided for easy
customization of the default control frame positioning." :type 'integer :group 'ediff-window)

(defcustom ediff-narrow-control-frame-leftward-shift (if (featurep 'xemacs) 7 3) "\
The leftward shift of control frame from the right edge of buf A's frame.
Measured in characters.
This is used by the default control frame positioning function,
`ediff-make-frame-position' to adjust the position of the control frame
when it shows the short menu.  This variable is provided for easy
customization of the default." :type 'integer :group 'ediff-window)

(defcustom ediff-wide-control-frame-rightward-shift 7 "\
The rightward shift of control frame from the left edge of buf A's frame.
Measured in characters.
This is used by the default control frame positioning function,
`ediff-make-frame-position' to adjust the position of the control frame
when it shows the full menu.  This variable is provided for easy
customization of the default." :type 'integer :group 'ediff-window)

(defcustom ediff-prefer-iconified-control-frame nil "\
If t, keep control panel iconified when help message is off.
This has effect only on a windowing system.
If t, hitting `?' to toggle control panel off iconifies it.

This is only useful in Emacs and only for certain kinds of window managers,
such as TWM and its derivatives, since the window manager must permit
keyboard input to go into icons.  XEmacs completely ignores keyboard input
into icons, regardless of the window manager." :type 'boolean :group 'ediff-window)

;;;***

;;;### (autoloads (ediff-use-last-dir ediff) "ediff" "ediff/ediff.el")
(defconst custom-define-current-source-file "ediff.el")

(defgroup ediff nil "A comprehensive visual interface to diff & patch." :tag "Ediff" :group 'tools)

(defcustom ediff-use-last-dir nil "\
If t, Ediff will use previous directory as default when reading file name." :type 'boolean :group 'ediff)

;;;***

(provide 'ediff-custom-defines)
