;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'edit-utils-custom-defines) (error "Feature edit-utils-custom-defines already loaded"))

;;;### (autoloads (After-save-alist) "after-save-commands" "edit-utils/after-save-commands.el")
(defconst custom-define-current-source-file "after-save-commands.el")

(defcustom After-save-alist '(("/etc/X11/Xresources/\\|/\\.Xresources" nil t "xrdb $f") ("/\\.crontab\\'" nil t "crontab $f") ("/etc/inetd.conf" nil t "echo /etc/init.d/netbase reload") ("\\.mailrc" nil t (build-mail-aliases)) ((eq major-mode 'sh-mode) nil t "chmod a+x $f") ("#  __JUST_FOR_EXAMPLE__  #" (("Set_ME" . "to some value") ("UN_Set_ME")) nil "echo 'rm -rf / && Bwahahahha!'")) "\
*List associating file regexp or condition to shell command or lisp form.
Each element is of the form
  (PREDICATE ((VAR1 . VAL1) (VAR2 . VAL2) (VAR3)...) PROMPT-P COMMAND)
where
  PREDICATE    is a string regexp to match against the file name,
               or a lisp form to evaluate.
  (VAR . VAL)  are environment variable assignments.
               Omit VAL to unset VAR.
  PROMPT-P     whether to ask for confirmation each time the file is saved 
               and prior to running the command.
  COMMAND      Shell command (string) to run or lisp form to eval,
               after the file is saved.

While you are visiting a file that has an `after-save-command' associated with
it, the modeline will display \"AScmd\" in the minor mode list, and moving the
mouse over that indicator will cause the buffer's associated shell command to
be displayed in the minibuffer. Clicking button 2 there will toggle whether
the command will be run or not.

This facility can be very handy for doing things like:
- running `newaliases(1)' after you've edited the `sendmail(8)' daemon's
  \"/etc/aliases\" file,
- running `xrdb(1)' after you've hand-tweaked your \".Xresource\" settings
- installing a \".crontab\"
- sending a signal to a system daemon whose configuration file you've edited.
- running (build-mail-aliases) after you've edited .mailrc

You may create or change these settings while you are visiting a file, since
it works by installing a function in the global `after-save-hook', and a
lookup in `After-save-alist' for your command spec happens then. You may also
change the settings for a file that's already got an after-save entry, prior
to saving it.

The command you specify will be run in a subshell, out of the
`after-save-hook', using the lisp function `shell-command'. You can cause it
to background by suffixing the command with the usual \"&\". It will inherit
the `process-environment' of your XEmacs session, along with the specified
environment modifications, as well as the following automatically defined
variables:

   $f -- The full path and filename of the file, `buffer-file-name'
   $d -- The directory, with a trailing \"/\" where the file was saved.

The `Var=\"Value\" pair' environment variables will be defined in the context
the shell command will be run in. You may reference previously defined
environment variables within the `Value' fields, since they are expanded
sequentially, from top to bottom, using `substitute-in-file-name', just before
the command is run. $f and $d are set first, and so may be used for expansion
within your environment specifications, as well as in the commandline.

Note that no shell processing will be done until the commandline is fed to
your shell. That is, globbing or brace expansions and things don't happen
until the command is run.

If you use `write-file' (`C-x C-w') to write the visited buffer to a different
filename, the `after-save-command' will not be run, and the after save command
property will be removed from the buffer, unless the new file name matches one
of your `After-save-alist' specifications." :require 'after-save-commands :set (function (lambda (var val) (set-default var val) (mapc (function (lambda (b) (with-current-buffer b (if (After-save--ascmd-property) (setq modeline-process nil)) (After-save--find-file-hook)))) (buffer-list)) (redraw-modeline t))) :type '(repeat (list :tag "------------------------------------------------------------" :indent 2 (choice (regexp :tag "File name regexp" "") (sexp :tag "ELisp form (predicate)" "")) (repeat :tag "Environment" :indent 1 (cons :tag "Var=\"Value\" pair" (string :tag "Variable" "") (choice (string :tag "Value" "") (const :tag "unset" nil)))) (boolean :tag "Confirm before execution? " t) (choice (string :tag "Shell Command line (use $f and $d)" "") (sexp :tag "ELisp form to evaluate " "")))) :group 'files)

;;;***

;;;### (autoloads (align-vhdl-rules-list align-exclude-rules-list align-rules-list align-region-separate align-open-comment-modes align-sq-string-modes align-dq-string-modes align-text-modes align-tex-modes align-lisp-modes align-perl-modes align-c++-modes align-large-region align-highlight-nochange-face align-highlight-change-face align-region-heuristic align-to-tab-stop align-default-spacing align-indent-before-aligning align-load-hook align) "align" "edit-utils/align.el")
(defconst custom-define-current-source-file "align.el")

(defgroup align nil "Align text to a specific column, by regexp." :group 'fill)

(defcustom align-load-hook nil "\
*Hook that gets run after the aligner has been loaded." :type 'hook :group 'align)

(defcustom align-indent-before-aligning nil "\
*If non-nil, indent the marked region before aligning it." :type 'boolean :group 'align)

(defcustom align-default-spacing 1 "\
*An integer that represents the default amount of padding to use.
If `align-to-tab-stop' is non-nil, this will represent the number of
tab stops to use for alignment, rather than the number of spaces.
Each alignment rule can optionally override both this variable.  See
`align-mode-alist'." :type 'integer :group 'align)

(defcustom align-to-tab-stop 'indent-tabs-mode "\
*If non-nil, alignments will always fall on a tab boundary.
It may also be a symbol, whose value will be taken." :type '(choice (const nil) symbol) :group 'align)

(defcustom align-region-heuristic 500 "\
*If non-nil, used as a heuristic by `align-current'.
Since each alignment rule can possibly have its own set of alignment
sections (whenever `align-region-separate' is non-nil, and not a
string), this heuristic is used to determine how far before and after
point we should search in looking for a region separator.  Larger
values can mean slower perform in large files, although smaller values
may cause unexpected behavior at times." :type 'integer :group 'align)

(defcustom align-highlight-change-face 'highlight "\
*The face to highlight with if changes are necessary." :type 'face :group 'align)

(defcustom align-highlight-nochange-face 'secondary-selection "\
*The face to highlight with if no changes are necessary." :type 'face :group 'align)

(defcustom align-large-region 10000 "\
*If an integer, defines what constitutes a \"large\" region.
If nil,then no messages will ever be printed to the minibuffer." :type 'integer :group 'align)

(defcustom align-c++-modes '(c++-mode c-mode java-mode) "\
*A list of modes whose syntax resembles C/C++." :type '(repeat symbol) :group 'align)

(defcustom align-perl-modes '(perl-mode cperl-mode) "\
*A list of modes where perl syntax is to be seen." :type '(repeat symbol) :group 'align)

(defcustom align-lisp-modes '(emacs-lisp-mode lisp-interaction-mode lisp-mode scheme-mode) "\
*A list of modes whose syntax resembles Lisp." :type '(repeat symbol) :group 'align)

(defcustom align-tex-modes '(tex-mode plain-tex-mode latex-mode slitex-mode) "\
*A list of modes whose syntax resembles TeX (and family)." :type '(repeat symbol) :group 'align)

(defcustom align-text-modes '(text-mode outline-mode) "\
*A list of modes whose content is plain text." :type '(repeat symbol) :group 'align)

(defcustom align-dq-string-modes (append align-lisp-modes align-c++-modes align-perl-modes '(python-mode)) "\
*A list of modes where double quoted strings should be excluded." :type '(repeat symbol) :group 'align)

(defcustom align-sq-string-modes (append align-perl-modes '(python-mode)) "\
*A list of modes where single quoted strings should be excluded." :type '(repeat symbol) :group 'align)

(defcustom align-open-comment-modes (append align-lisp-modes align-c++-modes align-perl-modes '(python-mode makefile-mode)) "\
*A list of modes with a single-line comment syntax.
These are comments as in Lisp, which have a beginning but, end with
the line (i.e., `comment-end' is an empty string)." :type '(repeat symbol) :group 'align)

(defcustom align-region-separate "^\\s-*[{}]?\\s-*$" "\
*Select the method by which alignment sections will be separated.
If this is a symbol, that symbol's value will be used.

For the sake of clarification, consider the following example, which
will be referred to in the descriptions below.

    int alpha = 1; /* one */
    double beta = 2.0;
    long gamma; /* ten */

    unsigned int delta = 1; /* one */
    long double epsilon = 3.0;
    long long omega; /* ten */

The possible settings for `align-region-separate' are:

 `entire'  The entire region being aligned will be considered as a
	   single alignment section.  Assuming that comments were not
	   being aligned to a particular column, the example would
	   become:

	     int          alpha    = 1;   /* one */
	     double       beta     = 2.0;
	     long         gamma;          /* ten */

	     unsigned int delta    = 1;   /* one */
	     long double  epsilon;
	     long long    chi      = 10;  /* ten */

 `group'   Each contiguous set of lines where a specific alignment
	   occurs is considered a section for that alignment rule.
	   Note that each rule will may have any entirely different
	   set of section divisions than another.

	     int    alpha = 1; /* one */
	     double beta  = 2.0;
	     long   gamma; /* ten */

	     unsigned int delta = 1; /* one */
	     long double  epsilon;
	     long long    chi = 10; /* ten */

 `largest' When contiguous rule sets overlap, the largest section
	   described will be taken as the alignment section for each
	   rule touched by that section.

	     int    alpha = 1;   /* one */
	     double beta  = 2.0;
	     long   gamma;       /* ten */

	     unsigned int delta    = 1;  /* one */
	     long double  epsilon;
	     long long    chi      = 10; /* ten */

	   NOTE: This option is not supported yet, due to algorithmic
	   issues which haven't been satisfactorily resolved.  There
	   are ways to do it, but they're both ugly and resource
	   consumptive.

 regexp    A regular expression string which defines the section
	   divider.  If the mode you're in has a consistent divider
	   between sections, the behavior will be very similar to
	   `largest', and faster.  But if the mode does not use clear
	   separators (for example, if you collapse your braces onto
	   the preceding statement in C or perl), `largest' is
	   probably the better alternative.

 function  A function that will be passed the beginning and ending
	   locations of the region in which to look for the section
	   separator.  At the very beginning of the attempt to align,
	   both of these parameters will be nil, in which case the
	   function should return non-nil if it wants each rule to
	   define its own section, or nil if it wants the largest
	   section found to be used as the common section for all rules
	   that occur there.

 list      A list of markers within the buffer that represent where
	   the section dividers lie.  Be certain to use markers!  For
	   when the aligning begins, the ensuing contract/expanding of
	   whitespace will throw off any non-marker positions.

	   This method is intended for use in Lisp programs, and not
	   by the user." :type '(choice (const :tag "Entire region is one section" entire) (const :tag "Align by contiguous groups" group) (regexp :tag "Regexp defines section boundaries") (function :tag "Function defines section boundaries")) :group 'align)

(defcustom align-rules-list (backquote ((lisp-second-arg (regexp . "\\(^\\s-+[^( 	\n]\\|(\\(\\S-+\\)\\s-+\\)\\S-+\\(\\s-+\\)") (group . 3) (modes . align-lisp-modes) (run-if \, (function (lambda nil current-prefix-arg)))) (lisp-alist-dot (regexp . "\\(\\s-*\\)\\.\\(\\s-*\\)") (group 1 2) (modes . align-lisp-modes)) (open-comment (regexp \, (function (lambda (end reverse) (funcall (if reverse 're-search-backward 're-search-forward) (concat "[^ 	\n\\\\]" (regexp-quote comment-start) "\\(.+\\)$") end t)))) (modes . align-open-comment-modes)) (c-macro-definition (regexp . "^\\s-*#\\s-*define\\s-+\\S-+\\(\\s-+\\)") (modes . align-c++-modes)) (c-variable-declaration (regexp \, (concat "[*&0-9A-Za-z_]>?[&*]*\\(\\s-+[*&]*\\)" "[A-Za-z_][0-9A-Za-z:_]*\\s-*\\(\\()\\|" "=[^=\n].*\\|(.*)\\|\\(\\[.*\\]\\)*\\)?" "\\s-*[;,]\\|)\\s-*$\\)")) (group . 1) (modes . align-c++-modes) (justify . t) (valid \, (function (lambda nil (not (or (save-excursion (goto-char (match-beginning 1)) (backward-word 1) (looking-at "\\(goto\\|return\\|new\\|delete\\|throw\\)")) (if (and (boundp 'font-lock-mode) font-lock-mode) (eq (get-text-property (point) 'face) 'font-lock-comment-face) (eq (caar (c-guess-basic-syntax)) 'c)))))))) (c-assignment (regexp \, (concat "[^-=!^&*+<>/| 	\n]\\(\\s-*[-=!^&*+<>/|]*\\)" "=\\(\\s-*\\)\\([^= 	\n]\\|$\\)")) (group 1 2) (modes . align-c++-modes) (justify . t) (tab-stop)) (perl-assignment (regexp \, (concat "[^=!^&*-+<>/| 	\n]\\(\\s-*\\)=[~>]?" "\\(\\s-*\\)\\([^>= 	\n]\\|$\\)")) (group 1 2) (modes . align-perl-modes) (tab-stop)) (python-assignment (regexp \, (concat "[^=!<> 	\n]\\(\\s-*\\)=" "\\(\\s-*\\)\\([^>= 	\n]\\|$\\)")) (group 1 2) (modes quote (python-mode)) (tab-stop)) (make-assignment (regexp . "^\\s-*\\w+\\(\\s-*\\):?=\\(\\s-*\\)\\([^	\n \\\\]\\|$\\)") (group 1 2) (modes quote (makefile-mode)) (tab-stop)) (c-comma-delimiter (regexp . ",\\(\\s-*\\)[^/ 	\n]") (repeat . t) (modes . align-c++-modes) (run-if \, (function (lambda nil current-prefix-arg)))) (basic-comma-delimiter (regexp . ",\\(\\s-*\\)[^# 	\n]") (repeat . t) (modes append align-perl-modes '(python-mode)) (run-if \, (function (lambda nil current-prefix-arg)))) (c++-comment (regexp . "\\(\\s-*\\)\\(//.*\\|/\\*.*\\*/\\s-*\\)$") (modes . align-c++-modes) (column . comment-column) (valid \, (function (lambda nil (save-excursion (goto-char (match-beginning 1)) (not (bolp))))))) (c-chain-logic (regexp . "\\(\\s-*\\)\\(&&\\|||\\|\\<and\\>\\|\\<or\\>\\)") (modes . align-c++-modes) (valid \, (function (lambda nil (save-excursion (goto-char (match-end 2)) (looking-at "\\s-*\\(/[*/]\\|$\\)")))))) (perl-chain-logic (regexp . "\\(\\s-*\\)\\(&&\\|||\\|\\<and\\>\\|\\<or\\>\\)") (modes . align-perl-modes) (valid \, (function (lambda nil (save-excursion (goto-char (match-end 2)) (looking-at "\\s-*\\(#\\|$\\)")))))) (python-chain-logic (regexp . "\\(\\s-*\\)\\(\\<and\\>\\|\\<or\\>\\)") (modes quote (python-mode)) (valid \, (function (lambda nil (save-excursion (goto-char (match-end 2)) (looking-at "\\s-*\\(#\\|$\\|\\\\\\)")))))) (c-macro-line-continuation (regexp . "\\(\\s-*\\)\\\\$") (modes . align-c++-modes) (column . c-backslash-column)) (basic-line-continuation (regexp . "\\(\\s-*\\)\\\\$") (modes quote (python-mode makefile-mode))) (tex-record-separator (regexp \, (function (lambda (end reverse) (align-match-tex-pattern "&" end reverse)))) (group 1 2) (modes . align-tex-modes) (repeat . t)) (tex-tabbing-separator (regexp \, (function (lambda (end reverse) (align-match-tex-pattern "\\\\[=>]" end reverse)))) (group 1 2) (modes . align-tex-modes) (repeat . t) (run-if \, (function (lambda nil (eq major-mode 'latex-mode))))) (tex-record-break (regexp . "\\(\\s-*\\)\\\\\\\\") (modes . align-tex-modes)) (text-column (regexp . "\\(^\\|\\S-\\)\\(\\s-+\\)\\(\\S-\\|$\\)") (group . 2) (modes . align-text-modes) (repeat . t) (run-if \, (function (lambda nil (and current-prefix-arg (not (eq '- current-prefix-arg))))))) (text-dollar-figure (regexp . "\\$?\\(\\s-+[0-9]+\\)\\.") (modes . align-text-modes) (justify . t) (run-if \, (function (lambda nil (eq '- current-prefix-arg))))))) "\
*A list describing all of the available alignment rules.
The format is:

   ((TITLE
     (ATTRIBUTE . VALUE) ...)
    ...)

The following attributes are meaningful:

`regexp'    This required attribute must be either a string describing
	    a regular expression, or a function (described below).
	    For every line within the section that this regular
	    expression matches, the given rule will be applied to that
	    line.  The exclusion rules denote which part(s) of the
	    line should not be modified; the alignment rules cause the
	    identified whitespace group to be contracted/expanded such
	    that the \"alignment character\" (the character
	    immediately following the identified parenthesis group),
	    occurs in the same column for every line within the
	    alignment section (see `align-region-separate' for a
	    description of how the region is broken up into alignment
	    sections).

	    The `regexp' attribute describes how the text should be
	    treated.  Within this regexp, there must be at least one
	    group of characters (typically whitespace) identified by
	    the special opening and closing parens used in regexp
	    expressions (`\\\\(' and `\\\\)') (see the Emacs manual on
	    the syntax of regular expressions for more info).

	    If `regexp' is a function, it will be called as a
	    replacement for `re-search-forward'.  This means that it
	    should return nil if nothing is found to match the rule,
	    or it should set the match data appropriately, move point
	    to the end of the match, and return the value of point.

`group'     For exclusion rules, the group identifies the range of
	    characters that should be ignored.  For alignment rules,
	    these are the characters that will be deleted/expanded for
	    the purposes of alignment.  The \"alignment character\" is
	    always the first character immediately following this
	    parenthesis group.  This attribute may also be a list of
	    integer, in which case multiple alignment characters will
	    be aligned, with the list of integer identifying the
	    whitespace groups which precede them.  The default for
	    this attribute is 1.

`modes'     The `modes' attribute, if set, should name a list of
	    major modes -- or evaluate to such a value -- in which the
	    rule is valid.  If not set, the rule will apply to all
	    modes.

`case-fold' If `regexp' is an ordinary regular expression string
	    containing alphabetic character, sometimes you may want
	    the search to proceed case-insensitively (for languages
	    that ignore case, such as pascal for example).  In that
	    case, set `case-fold' to a non-nil value, and the regular
	    expression search will ignore case.  If `regexp' is set to
	    a function, that function must handle the job of ignoring
	    case by itself.

`tab-stop'  If the `tab-stop' attribute is set, and non-nil, the
	    alignment character will always fall on a tab stop
	    (whether it uses tabs to get there or not depends on the
	    value of `indent-tabs-mode').  If the `tab-stop' attribute
	    is set to nil, tab stops will never be used.  Otherwise,
	    the value of `align-to-tab-stop' determines whether or not
	    to align to a tab stop.  The `tab-stop' attribute may also
	    be a list of t or nil values, corresponding to the number
	    of parenthesis groups specified by the `group' attribute.

`repeat'    If the `repeat' attribute is present, and non-nil, the
	    rule will be applied to the line continuously until no
	    further matches are found.

`valid'     If the `valid' attribute is set, it will be used to
	    determine whether the rule should be invoked.  This form
	    is evaluated after the regular expression match has been
	    performed, so that it is possible to use the results of
	    that match to determine whether the alignment should be
	    performed.  The buffer should not be modified during the
	    evaluation of this form.

`run-if'    Like `valid', the `run-if' attribute tests whether the
	    rule should be run at all -- even before any searches are
	    done to determine if the rule applies to the alignment
	    region.  This can save time, since `run-if' will only be
	    run once for each rule.  If it returns nil, the rule will
	    not be attempted.

`column'    For alignment rules, if the `column' attribute is set --
	    which must be an integer, or a symbol whose value is an
	    integer -- it will be used as the column in which to align
	    the alignment character.  If the text on a particular line
	    happens to overrun that column, a single space character,
	    or tab stop (see `align-to-tab-stop') will be added
	    between the last text character and the alignment
	    character.

`spacing'   Alignment rules may also override the amount of spacing
	    that would normally be used by providing a `spacing'
	    attribute.  This must be an integer, or a list of integers
	    corresponding to the number of parenthesis groups matched
	    by the `group' attribute.  If a list of value is used, and
	    any of those values is nil, `align-default-spacing' will
	    be used for that subgroup.  See `align-default-spacing'
	    for more details on spacing, tab stops, and how to
	    indicate how much spacing should be used.  If TAB-STOP is
	    present, it will override the value of `align-to-tab-stop'
	    for that rule.

`justify'   It is possible with `regexp' and `group' to identify a
	    character group that contains more than just whitespace
	    characters.  By default, any non-whitespace characters in
	    that group will also be deleted while aligning the
	    alignment character.  However, if the `justify' attribute
	    is set to a non-nil value, only the initial whitespace
	    characters within that group will be deleted.  This has
	    the effect of right-justifying the characters that remain,
	    and can be used for outdenting or just plain old right-
	    justification.

`separate'  Each rule can define its own section separator, which
	    describes how to identify the separation of \"sections\"
	    within the region to be aligned.  Setting the `separate'
	    attribute overrides the value of `align-region-separate'
	    (see the documentation of that variable for possible
	    values), and any separation argument passed to `align'." :type align-rules-list-type :group 'align)

(defcustom align-exclude-rules-list (backquote ((exc-dq-string (regexp . "\"\\([^\"\n]+\\)\"") (repeat . t) (modes . align-dq-string-modes)) (exc-sq-string (regexp . "'\\([^'\n]+\\)'") (repeat . t) (modes . align-sq-string-modes)) (exc-open-comment (regexp \, (function (lambda (end reverse) (funcall (if reverse 're-search-backward 're-search-forward) (concat "[^ 	\n\\\\]" (regexp-quote comment-start) "\\(.+\\)$") end t)))) (modes . align-open-comment-modes)) (exc-c-comment (regexp . "/\\*\\(.+\\)\\*/") (repeat . t) (modes . align-c++-modes)) (exc-c-func-params (regexp . "(\\([^)\n]+\\))") (repeat . t) (modes . align-c++-modes)) (exc-c-macro (regexp . "^\\s-*#\\s-*\\(if\\w*\\|endif\\)\\(.*\\)$") (group . 2) (modes . align-c++-modes)))) "\
*A list describing text that should be excluded from alignment.
See the documentation for `align-rules-list' for more info." :type align-exclude-rules-list-type :group 'align)

(defcustom align-vhdl-rules-list (backquote ((vhdl-declaration (regexp . "\\(signal\\|variable\\|constant\\)\\(\\s-+\\)\\S-") (group . 2)) (vhdl-case (regexp . "\\(others\\|[^ 	\n=<]\\)\\(\\s-*\\)=>\\(\\s-*\\)\\S-") (group 2 3) (valid \, (function (lambda nil (not (string= (downcase (match-string 1)) "others")))))) (vhdl-colon (regexp . "[^ 	\n:]\\(\\s-*\\):\\(\\s-*\\)[^=\n]") (group 1 2)) (direction (regexp . ":\\s-*\\(in\\|out\\|inout\\|buffer\\)\\(\\s-*\\)") (group . 2)) (sig-assign (regexp . "[^ 	\n=<]\\(\\s-*\\)<=\\(\\s-*\\)\\S-") (group 1 2)) (var-assign (regexp . "[^ 	\n:]\\(\\s-*\\):=")) (use-entity (regexp . "\\(\\s-+\\)use\\s-+entity")))) "\
*Alignment rules for `vhdl-mode'.  See `align-rules-list' for more info." :type align-rules-list-type :group 'align)

;;;***

;;;### (autoloads (outline-inhibit-protection outline-reindent-bodies outline-use-hanging-indents outline-isearch-dynamic-expose outline-command-prefix outline-indent outline-line-skip outline-title outline-title-style outline-body-line-style outline-head-line-style outline-label-style outline-number-pages outline-abbreviate-flattened-numbering outline-presentation-padding outline-file-xref-bullet outline-numbered-bullet outline-stylish-prefixes outline-old-style-prefixes outline-use-mode-specific-leader outline-distinctive-bullets-string outline-plain-bullets-string outline-primary-bullet outline-header-prefix outline-show-bodies outline-auto-activation allout) "allout" "edit-utils/allout.el")
(defconst custom-define-current-source-file "allout.el")

(defgroup allout nil "Extensive outline mode for use alone and with other modes." :prefix "outline-" :group 'outlines)

(defcustom outline-auto-activation nil "\
*Regulates auto-activation modality of allout outlines - see `outline-init'.

Setq-default by `outline-init' to regulate whether or not allout
outline mode is automatically activated when the buffer-specific
variable `outline-layout' is non-nil, and whether or not the layout
dictated by `outline-layout' should be imposed on mode activation.

With value `t', auto-mode-activation and auto-layout are enabled.
\(This also depends on `outline-find-file-hooks' being installed in
`find-file-hooks', which is also done by `outline-init'.)

With value `ask', auto-mode-activation is enabled, and endorsement for
performing auto-layout is asked of the user each time.

With value `activate', only auto-mode-activation is enabled, 
auto-layout is not.

With value `nil', neither auto-mode-activation nor auto-layout are
enabled.

See the docstring for `outline-init' for the proper interface to
this variable." :type '(choice (const :tag "On" t) (const :tag "Ask about layout" "ask") (const :tag "Mode only" "activate") (const :tag "Off" nil)) :group 'allout)

(defcustom outline-show-bodies nil "\
*If non-nil, show entire body when exposing a topic, rather than
just the header." :type 'boolean :group 'allout)

(defcustom outline-header-prefix "." "\
*Leading string which helps distinguish topic headers.

Outline topic header lines are identified by a leading topic
header prefix, which mostly have the value of this var at their front.
\(Level 1 topics are exceptions.  They consist of only a single
character, which is typically set to the outline-primary-bullet.  Many
outlines start at level 2 to avoid this discrepancy." :type 'string :group 'allout)

(defcustom outline-primary-bullet "*" "\
Bullet used for top-level outline topics.

Outline topic header lines are identified by a leading topic header
prefix, which is concluded by bullets that includes the value of this
var and the respective outline-*-bullets-string vars.

The value of an asterisk (`*') provides for backwards compatibility
with the original emacs outline mode.  See outline-plain-bullets-string
and outline-distinctive-bullets-string for the range of available
bullets." :type 'string :group 'allout)

(defcustom outline-plain-bullets-string ".:,;" "\
*The bullets normally used in outline topic prefixes.

See `outline-distinctive-bullets-string' for the other kind of
bullets.

DO NOT include the close-square-bracket, `]', as a bullet.

Outline mode has to be reactivated in order for changes to the value
of this var to take effect." :type 'string :group 'allout)

(defcustom outline-distinctive-bullets-string "*+-=>([{}&!?#%\"X@$~_\\" "\
*Persistent outline header bullets used to distinguish special topics.

These bullets are used to distinguish topics from the run-of-the-mill
ones.  They are not used in the standard topic headers created by
the topic-opening, shifting, and rebulleting (eg, on topic shift, 
topic paste, blanket rebulleting) routines, but are offered among the
choices for rebulleting.  They are not altered by the above automatic
rebulleting, so they can be used to characterize topics, eg:

 `?' question topics
 `(' parenthetic comment (with a matching close paren inside)
 `[' meta-note (with a matching close ] inside)
 `\"' a quote
 `=' value settings
 `~' \"more or less\"

... just for example.  (`#' typically has a special meaning to the
software, according to the value of `outline-numbered-bullet'.)

See `outline-plain-bullets-string' for the selection of
alternating bullets.

You must run `set-outline-regexp' in order for outline mode to
reconcile to changes of this value.

DO NOT include the close-square-bracket, `]', on either of the bullet
strings." :type 'string :group 'allout)

(defcustom outline-use-mode-specific-leader t "\
*When non-nil, use mode-specific topic-header prefixes.

Allout outline mode will use the mode-specific `outline-mode-leaders'
and/or comment-start string, if any, to lead the topic prefix string,
so topic headers look like comments in the programming language.

String values are used as they stand.

Value `t' means to first check for assoc value in `outline-mode-leaders'
alist, then use comment-start string, if any, then use default (`.').
\(See note about use of comment-start strings, below.)

Set to the symbol for either of `outline-mode-leaders' or
`comment-start' to use only one of them, respectively.

Value `nil' means to always use the default (`.').

comment-start strings that do not end in spaces are tripled, and an
`_' underscore is tacked on the end, to distinguish them from regular
comment strings.  comment-start strings that do end in spaces are not
tripled, but an underscore is substituted for the space. [This
presumes that the space is for appearance, not comment syntax.  You
can use `outline-mode-leaders' to override this behavior, when
incorrect.]" :type '(choice (const t) (const nil) string (const outline-mode-leaders) (const comment-start)) :group 'allout)

(defcustom outline-old-style-prefixes nil "\
*When non-nil, use only old-and-crusty outline-mode `*' topic prefixes.

Non-nil restricts the topic creation and modification
functions to asterix-padded prefixes, so they look exactly
like the original emacs-outline style prefixes.

Whatever the setting of this variable, both old and new style prefixes
are always respected by the topic maneuvering functions." :type 'boolean :group 'allout)

(defcustom outline-stylish-prefixes t "\
*Do fancy stuff with topic prefix bullets according to level, etc.

Non-nil enables topic creation, modification, and repositioning
functions to vary the topic bullet char (the char that marks the topic
depth) just preceding the start of the topic text) according to level.
Otherwise, only asterisks (`*') and distinctive bullets are used.

This is how an outline can look (but sans indentation) with stylish
prefixes:

    * Top level
    .* A topic
    . + One level 3 subtopic
    .  . One level 4 subtopic
    .  . A second 4 subtopic
    . + Another level 3 subtopic
    .  #1 A numbered level 4 subtopic
    .  #2 Another
    .  ! Another level 4 subtopic with a different distinctive bullet
    .  #4 And another numbered level 4 subtopic

This would be an outline with stylish prefixes inhibited (but the
numbered and other distinctive bullets retained):

    * Top level
    .* A topic
    . * One level 3 subtopic
    .  * One level 4 subtopic
    .  * A second 4 subtopic
    . * Another level 3 subtopic
    .  #1 A numbered level 4 subtopic
    .  #2 Another
    .  ! Another level 4 subtopic with a different distinctive bullet
    .  #4 And another numbered level 4 subtopic

Stylish and constant prefixes (as well as old-style prefixes) are
always respected by the topic maneuvering functions, regardless of
this variable setting.

The setting of this var is not relevant when outline-old-style-prefixes
is non-nil." :type 'boolean :group 'allout)

(defcustom outline-numbered-bullet "#" "\
*String designating bullet of topics that have auto-numbering; nil for none.

Topics having this bullet have automatic maintenance of a sibling
sequence-number tacked on, just after the bullet.  Conventionally set
to \"#\", you can set it to a bullet of your choice.  A nil value
disables numbering maintenance." :type '(choice (const nil) string) :group 'allout)

(defcustom outline-file-xref-bullet "@" "\
*Bullet signifying file cross-references, for `outline-resolve-xref'.

Set this var to the bullet you want to use for file cross-references." :type '(choice (const nil) string) :group 'allout)

(defcustom outline-presentation-padding 2 "\
*Presentation-format white-space padding factor, for greater indent." :type 'integer :group 'allout)

(defcustom outline-abbreviate-flattened-numbering nil "\
*If non-nil, `outline-flatten-exposed-to-buffer' abbreviates topic
numbers to minimal amount with some context.  Otherwise, entire
numbers are always used." :type 'boolean :group 'allout)

(defcustom outline-number-pages nil "\
*Non-nil turns on page numbering for LaTeX formatting of an outline." :type 'boolean :group 'allout)

(defcustom outline-label-style "\\large\\bf" "\
*Font and size of labels for LaTeX formatting of an outline." :type 'string :group 'allout)

(defcustom outline-head-line-style "\\large\\sl " "\
*Font and size of entries for LaTeX formatting of an outline." :type 'string :group 'allout)

(defcustom outline-body-line-style " " "\
*Font and size of entries for LaTeX formatting of an outline." :type 'string :group 'allout)

(defcustom outline-title-style "\\Large\\bf" "\
*Font and size of titles for LaTeX formatting of an outline." :type 'string :group 'allout)

(defcustom outline-title '(or buffer-file-name (current-buffer-name)) "\
*Expression to be evaluated to determine the title for LaTeX
formatted copy." :type 'sexp :group 'allout)

(defcustom outline-line-skip ".05cm" "\
*Space between lines for LaTeX formatting of an outline." :type 'string :group 'allout)

(defcustom outline-indent ".3cm" "\
*LaTeX formatted depth-indent spacing." :type 'string :group 'allout)

(defcustom outline-command-prefix "" "\
*Key sequence to be used as prefix for outline mode command key bindings." :type 'string :group 'allout)

(defcustom outline-isearch-dynamic-expose t "\
*Non-nil enable dynamic exposure of hidden incremental-search
targets as they're encountered." :type 'boolean :group 'allout)

(defcustom outline-use-hanging-indents t "\
*If non-nil, topic body text auto-indent defaults to indent of the header.
Ie, it is indented to be just past the header prefix.  This is
relevant mostly for use with indented-text-mode, or other situations
where auto-fill occurs.

[This feature no longer depends in any way on the `filladapt.el'
lisp-archive package.]" :type 'boolean :group 'allout)

(defcustom outline-reindent-bodies (if outline-use-hanging-indents 'text) "\
*Non-nil enables auto-adjust of topic body hanging indent with depth shifts.

When active, topic body lines that are indented even with or beyond
their topic header are reindented to correspond with depth shifts of
the header.

A value of `t' enables reindent in non-programming-code buffers, ie
those that do not have the variable `comment-start' set.  A value of
`force' enables reindent whether or not `comment-start' is set." :type '(choice (const nil) (const t) (const text) (const force)) :group 'allout)

(defcustom outline-inhibit-protection nil "\
*Non-nil disables warnings and confirmation-checks for concealed-text edits.

Outline mode uses emacs change-triggered functions to detect unruly
changes to concealed regions.  Set this var non-nil to disable the
protection, potentially increasing text-entry responsiveness a bit.

This var takes effect at outline-mode activation, so you may have to
deactivate and then reactivate the mode if you want to toggle the
behavior." :type 'boolean :group 'allout)

;;;***

;;;### (autoloads (register-menu buffer-colors) "auto-autoloads" "edit-utils/auto-autoloads.el")
(defconst custom-define-current-source-file "auto-autoloads.el")

(defgroup buffer-colors nil "A system for easily modifying default foreground and backgrounds of buffers.")

(defgroup register-menu nil "A Top-Level Menu for Register commands." :version "21.5.B32 with patches to register.el and sequence.c")

;;;***

;;;### (autoloads (auto-revert-load-hook global-auto-revert-ignore-modes global-auto-revert-non-file-buffers global-auto-revert-mode-hook global-auto-revert-mode-text auto-revert-mode-hook auto-revert-mode-text auto-revert-verbose auto-revert-stop-on-user-input auto-revert-interval global-auto-revert-mode auto-revert) "autorevert" "edit-utils/autorevert.el")
(defconst custom-define-current-source-file "autorevert.el")

(defgroup auto-revert nil "Revert individual buffers when files on disk change.\n\nAuto-Revert Mode can be activated for individual buffer.\nGlobal Auto-Revert Mode applies to all buffers." :group 'files)

(defcustom global-auto-revert-mode nil "\
When on, buffers are automatically reverted when files on disk change.

Set this variable using \\[customize] only.  Otherwise, use the
command `global-auto-revert-mode'." :group 'auto-revert :initialize 'custom-initialize-default :set '(lambda (symbol value) (global-auto-revert-mode (or value 0))) :type 'boolean :require 'autorevert)

(defcustom auto-revert-interval 5 "\
Time, in seconds, between Auto-Revert Mode file checks." :group 'auto-revert :type 'integer)

(defcustom auto-revert-stop-on-user-input t "\
When non-nil Auto-Revert Mode stops checking files on user input." :group 'auto-revert :type 'boolean)

(defcustom auto-revert-verbose t "\
When nil, Auto-Revert Mode will not generate any messages.

Currently, messages are generated when the mode is activated or
deactivated, and whenever a file is reverted." :group 'auto-revert :type 'boolean)

(defcustom auto-revert-mode-text " ARev" "\
String to display in the mode line when Auto-Revert Mode is active.

\(When the string is not empty, make sure that it has a leading space.)" :tag "Auto Revert Mode Text" :group 'auto-revert :type 'string)

(defcustom auto-revert-mode-hook nil "\
Functions to run when Auto-Revert Mode is activated." :tag "Auto Revert Mode Hook" :group 'auto-revert :type 'hook)

(defcustom global-auto-revert-mode-text "" "\
String to display when Global Auto-Revert Mode is active.

The default is nothing since when this mode is active this text doesn't
vary over time, or between buffers.  Hence mode line text
would only waste precious space." :group 'auto-revert :type 'string)

(defcustom global-auto-revert-mode-hook nil "\
Hook called when Global Auto-Revert Mode is activated." :group 'auto-revert :type 'hook)

(defcustom global-auto-revert-non-file-buffers nil "\
*When nil only file buffers are reverted by Global Auto-Revert Mode.

When non-nil, both file buffers and buffers with a custom
`revert-buffer-function' are reverted by Global Auto-Revert Mode." :group 'auto-revert :type 'boolean)

(defcustom global-auto-revert-ignore-modes '(Info-mode) "\
List of major modes Global Auto-Revert Mode should not check." :group 'auto-revert :type '(repeat sexp))

(defcustom auto-revert-load-hook nil "\
Functions to run when Auto-Revert Mode is first loaded." :tag "Load Hook" :group 'auto-revert :type 'hook)

;;;***

;;;### (autoloads (mouse-avoidance-mode-line-string mouse-avoidance-threshold mouse-avoidance-animation-delay mouse-avoidance-nudge-var mouse-avoidance-nudge-dist mouse-avoidance-mode avoid) "avoid" "edit-utils/avoid.el")
(defconst custom-define-current-source-file "avoid.el")

(defgroup avoid nil "Make mouse pointer stay out of the way of editing." :prefix "mouse-avoidance-" :group 'mouse)

(defcustom mouse-avoidance-mode nil "\
Value is t or a symbol if the mouse pointer should avoid the cursor.
See function `mouse-avoidance-mode' for possible values. Normally, you
shouldn't modify this variable by hand, but use the function instead. However,
the default value can be customized from the options menu." :type '(radio (const :tag "No mouse avoidance" nil) (const :tag "Move the mouse on keypress" banish) (const :tag "Move the mouse if the cursor gets too close" exile) (const :tag "Displace the mouse if the cursor gets too close" jump) (const :tag "Animate the mouse" animate) (const :tag "Animate + change shape" proteus)) :set (lambda (symbol value) (mouse-avoidance-mode (or value 'none))) :initialize 'custom-initialize-default :require 'avoid :group 'avoid)

(defcustom mouse-avoidance-nudge-dist 15 "\
*Average distance that mouse will be moved when approached by cursor.
Only applies in mouse-avoidance-mode `jump' and its derivatives.
For best results make this larger than `mouse-avoidance-threshold'." :type 'integer :group 'avoid)

(defcustom mouse-avoidance-nudge-var 10 "\
*Variability of `mouse-avoidance-nudge-dist' (which see)." :type 'integer :group 'avoid)

(defcustom mouse-avoidance-animation-delay 0.01 "\
Delay between animation steps, in seconds." :type 'number :group 'avoid)

(defcustom mouse-avoidance-threshold 5 "\
*Mouse-pointer's flight distance.
If the cursor gets closer than this, the mouse pointer will move away.
Only applies in mouse-avoidance-modes `animate' and `jump'." :type 'integer :group 'avoid)

(defcustom mouse-avoidance-mode-line-string " Avoid" "\
*String to display in the modeline when `mouse-avoidance-mode' is active.
Set this to nil if you don't want a modeline indicator." :type '(choice string (const :tag "none" nil)) :group 'avoid)

;;;***

;;;### (autoloads (bkup-backup-directory-info) "backup-dir" "edit-utils/backup-dir.el")
(defconst custom-define-current-source-file "backup-dir.el")

(defcustom bkup-backup-directory-info nil "\
*Alist of (FILE-REGEXP BACKUP-DIR OPTIONS ...))
If the filename to be backed up matches FILE-REGEXP, or FILE-REGEXP is t,
then BACKUP-DIR is used as the path for its backups.

Directories may begin with \"/\" to specify an absolute pathname.

If BACKUP-DIR does not exist and OPTIONS contains the symbol `ok-create',
then it is created if possible.  Otherwise the usual behavior (backup in the
same directory as the file) results.

If OPTIONS contains the symbol `full-path', then the full path of the file
being backed up is prepended to the backup file name, with each \"/\"
replaced by a \"!\".  This is intended for cases where an absolute backup
path is used.  If OPTIONS contains `prepend-name' in addition to `full-path',
then the file name is prepended rather than appended to the path component
when forming the backup name.

If OPTIONS contains the symbol `search-upward' and the backup directory
BACKUP-DIR is a relative path, then a directory with that name is searched
for starting at the current directory and proceeding upward (.., ../.., etc)
until one is found of that name, or the root is reached, and if one is found
it is used as the backup directory.

Finally, if no FILE-REGEXP matches the file name being backed up, then the
usual behavior results.

Once you save this variable with `M-x customize-variable',
`backup-dir' will  be loaded for you each time you start XEmacs." :type '(repeat (list (regexp :tag "File regexp") (string :tag "Backup Dir") (set :inline t (const ok-create) (const full-path) (const prepend-name) (const search-upward)))) :require 'backup-dir :group 'backup)

;;;***

;;;### (autoloads (balloon-help-mode-line-string balloon-help-aggressively-follow-mouse balloon-help-frame-name balloon-help-use-sound balloon-help-border-width balloon-help-border-color balloon-help-font balloon-help-background-pixmap balloon-help-background balloon-help-foreground balloon-help-timeout balloon-help-mode balloon-help) "balloon-help" "edit-utils/balloon-help.el")
(defconst custom-define-current-source-file "balloon-help.el")

(defgroup balloon-help nil "Balloon-help support in XEmacs" :group 'frames)

(defcustom balloon-help-mode nil "\
*Non-nil means Balloon help mode is enabled." :type 'boolean :set (lambda (symbol value) (balloon-help-mode (or value 0))) :initialize 'custom-initialize-default :require 'balloon-help :group 'balloon-help)

(defcustom balloon-help-timeout 1500 "\
*Display help after this many milliseconds of mouse inactivity." :type 'integer :group 'balloon-help)

(defcustom balloon-help-foreground "black" "\
*The foreground color for displaying balloon help text." :type 'string :group 'balloon-help)

(defcustom balloon-help-background "gray80" "\
*The background color for the balloon help frame." :type 'string :group 'balloon-help)

(defcustom balloon-help-background-pixmap "" "\
*The background pixmap for the balloon help frame." :type 'string :group 'balloon-help)

(defcustom balloon-help-font "variable" "\
*The font for displaying balloon help text." :type 'string :group 'balloon-help)

(defcustom balloon-help-border-color "black" "\
*The color for displaying balloon help frame's border." :type 'string :group 'balloon-help)

(defcustom balloon-help-border-width 1 "\
*The width of the balloon help frame's border." :type 'integer :group 'balloon-help)

(defcustom balloon-help-use-sound nil "\
*Non-nil value means play a sound to herald the appearance
and disappearance of the help frame.

`balloon-help-appears' will be played when the frame appears.
`balloon-help-disappears' will be played when the frame disappears.

See the documentation for the function load-sound-file to see how
define sounds." :type 'boolean :group 'balloon-help)

(defcustom balloon-help-frame-name "balloon-help" "\
*The frame name to use for the frame to display the balloon help." :type 'string :group 'balloon-help)

(defcustom balloon-help-aggressively-follow-mouse nil "\
*Non-nil means the balloon should move with the mouse even if the mouse
is over the same object as the last mouse motion event." :type 'boolean :group 'balloon-help)

(defcustom balloon-help-mode-line-string " Bal" "\
*String to display in the modeline when `balloon-help-minor-mode' is active.
Set this to nil if you don't want a modeline indicator." :type '(choice string (const :tag "none" nil)) :group 'balloon-help)

;;;***

;;;### (autoloads (blink-cursor-mode blink-cursor) "blink-cursor" "edit-utils/blink-cursor.el")
(defconst custom-define-current-source-file "blink-cursor.el")

(defgroup blink-cursor nil "Blinking cursor mode")

(defcustom blink-cursor-mode nil "\
Non nil means `blink-cursor-mode' is on. Normally, you shouldn't modify
this variable by hand, but use the function `blink-cursor-mode'
instead. However, the default value can be customized from the options menu." :type 'boolean :set (lambda (var val) (blink-cursor-mode (or val 0))) :initialize 'custom-initialize-default :require 'blink-cursor :group 'blink-cursor)

;;;***

;;;### (autoloads (bookmark-menu-length bookmark-bmenu-toggle-filenames bookmark-bmenu-file-column bookmark-automatically-show-annotations bookmark-sort-flag bookmark-completion-ignore-case bookmark-version-control bookmark-save-flag bookmark-use-annotations bookmarks) "bookmark" "edit-utils/bookmark.el")
(defconst custom-define-current-source-file "bookmark.el")

(defgroup bookmarks nil "Set bookmarks, maybe annotate them, jump to them later." :prefix "bookmark-" :group 'editing)

(defcustom bookmark-use-annotations nil "\
*If non-nil, saving a bookmark will query for an annotation in a
buffer." :type 'boolean :group 'bookmarks)

(defcustom bookmark-save-flag t "\
*Controls when Emacs saves bookmarks to a file.
--> Nil means never save bookmarks, except when `bookmark-save' is
    explicitly called (\\[bookmark-save]).
--> t means save bookmarks when Emacs is killed.
--> Otherwise, it should be a number that is the frequency with which
    the bookmark list is saved (i.e.: the number of times which
    Emacs' bookmark list may be modified before it is automatically
    saved.).  If it is a number, Emacs will also automatically save
    bookmarks when it is killed.

Therefore, the way to get it to save every time you make or delete a
bookmark is to set this variable to 1 (or 0, which produces the same
behavior.)

To specify the file in which to save them, modify the variable
bookmark-default-file, which is `~/.emacs.bmk' by default." :type '(choice (const :tag "Never" nil) (const :tag "On Exit" t) (number :tag "Frequency" 1)) :group 'bookmarks)

(defcustom bookmark-version-control 'nospecial "\
*Whether or not to make numbered backups of the bookmark file.
It can have four values: t, nil, `never', and `nospecial'.
The first three have the same meaning that they do for the
variable `version-control', and the final value `nospecial' means just
use the value of `version-control'." :type '(choice (const t) (const nil) (const never) (const nospecial)) :group 'bookmarks)

(defcustom bookmark-completion-ignore-case t "\
*Non-nil means bookmark functions ignore case in completion." :type 'boolean :group 'bookmarks)

(defcustom bookmark-sort-flag t "\
*Non-nil means that bookmarks will be displayed sorted by bookmark
name.  Otherwise they will be displayed in LIFO order (that is, most
recently set ones come first, oldest ones come last)." :type 'boolean :group 'bookmarks)

(defcustom bookmark-automatically-show-annotations t "\
*Nil means don't show annotations when jumping to a bookmark." :type 'boolean :group 'bookmarks)

(defcustom bookmark-bmenu-file-column 30 "\
*Column at which to display filenames in a buffer listing bookmarks.
You can toggle whether files are shown with \\<bookmark-bmenu-mode-map>\\[bookmark-bmenu-toggle-filenames]." :type 'integer :group 'bookmarks)

(defcustom bookmark-bmenu-toggle-filenames t "\
*Non-nil means show filenames when listing bookmarks.
This may result in truncated bookmark names.  To disable this, put the
following in your .emacs:

\(setq bookmark-bmenu-toggle-filenames nil)" :type 'boolean :group 'bookmarks)

(defcustom bookmark-menu-length 70 "\
*Maximum length of a bookmark name displayed on a popup menu." :type 'integer :group 'bookmarks)

;;;***

;;;### (autoloads (bc-file-color-tests bc-buffer-color-combos bc-new-colors-at-bottom-flag bc-per-window-flag buffer-colors) "buffer-colors" "edit-utils/buffer-colors.el")
(defconst custom-define-current-source-file "buffer-colors.el")

(defgroup buffer-colors nil "A system for easily modifying default foreground and backgrounds of buffers.")

(defcustom bc-per-window-flag nil "\
Scope of color assignments. Colors can follow current window or current buffer." :tag "Buffer color scope" :group 'buffer-colors :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (bc-refresh-buffer-color-menu)) :type '(choice :tag "Colors follow" (const :tag "Buffer" nil) (const :tag "Window" t)))

(defcustom bc-new-colors-at-bottom-flag nil "\
Sorting direction for Buffer Colors menu" :tag "Buffer Colors menu sort direction" :group 'buffer-colors :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (bc-refresh-buffer-color-menu)) :type '(choice :tag "Buffer Colors menu is sorted from" (const :tag "Newest to Oldest" nil) (const :tag "Oldest to Newest" t)))

(defcustom bc-buffer-color-combos '(("black" . "white") ("white" . "black") ("green" . "black") ("yellow" . "black") ("lightgoldenrod" . "sandybrown") ("orchid" . "mediumvioletred") ("deepskyblue" . "saddlebrowwn") ("yellowgreen" . "darkslategrey") ("slateblue" . "cornflowerblue") ("yellow" . "navyblue") ("darkslategrey" . "coral")) "\
Foreground/background pairs for default buffer text.
These will show up on the Buffers->Buffer Colors menu." :group 'buffer-colors :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (bc-refresh-buffer-color-menu)) :type '(repeat (cons :tag "Menu entry" (color :tag "Foreground") (color :tag "Background"))))

(defcustom bc-file-color-tests '((t bc-read-only-p "tomato" "black" (bc-read-only)) (t bc-c-file-p "mediumspringgreen" "black" nil) (t bc-h-file-p "mediumspringgreen" "navy" nil) (t bc-el-file-p "PaleGreen" "black" nil)) "\
A list of rules for coloring new buffers.
If a Predicate evaluates to non-nil, the associated color pair will be
applied to the new buffer.  Predicate will be evaluated in the new
buffer, so buffer-local variables (eg `buffer-file-name') will be
correct.
The last matching rule is used." :group 'buffer-colors :type '(repeat (list :tag "Rule" :extra-offset 4 (choice :tag "This rule is" (const :tag "Enabled" t) (const :tag "Disabled" nil)) (symbol :tag "Predicate") (string :tag "Foreground") (string :tag "Background") (choice :tag "Tag-set" (const :tag "None" nil) (repeat :tag "List" (symbol :tag "Tag" :value bc-read-only))))))

;;;***

;;;### (autoloads (completions-merging-modes completion-search-distance completion-cdabbrev-prompt-flag completion-prompt-speed-threshold completions-file-versions-kept completion-on-separator-character save-completions-retention-time save-completions-file-name save-completions-flag enable-completion completion) "completion" "edit-utils/completion.el")
(defconst custom-define-current-source-file "completion.el")

(defgroup completion nil "Dynamic word-completion code." :group 'matching)

(defcustom enable-completion t "\
*Non-nil means enable recording and saving of completions.
If nil, no new words added to the database or saved to the init file." :type 'boolean :group 'completion)

(defcustom save-completions-flag t "\
*Non-nil means save most-used completions when exiting Emacs.
See also `saved-completions-retention-time'." :type 'boolean :group 'completion)

(defcustom save-completions-file-name (convert-standard-filename "~/.completions") "\
*The filename to save completions to." :type 'file :group 'completion)

(defcustom save-completions-retention-time 336 "\
*Discard a completion if unused for this many hours.
\(1 day = 24, 1 week = 168).  If this is 0, non-permanent completions
will not be saved unless these are used.  Default is two weeks." :type 'integer :group 'completion)

(defcustom completion-on-separator-character nil "\
*Non-nil means separator characters mark previous word as used.
This means the word will be saved as a completion." :type 'boolean :group 'completion)

(defcustom completions-file-versions-kept kept-new-versions "\
*Number of versions to keep for the saved completions file." :type 'integer :group 'completion)

(defcustom completion-prompt-speed-threshold 4800 "\
*Minimum output speed at which to display next potential completion." :type 'integer :group 'completion)

(defcustom completion-cdabbrev-prompt-flag nil "\
*If non-nil, the next completion prompt does a cdabbrev search.
This can be time consuming." :type 'boolean :group 'completion)

(defcustom completion-search-distance 15000 "\
*How far to search in the buffer when looking for completions.
In number of characters.  If nil, search the whole buffer." :type 'integer :group 'completion)

(defcustom completions-merging-modes '(lisp c) "\
*List of modes {`c' or `lisp'} for automatic completions merging.
Definitions from visited files which have these modes
are automatically added to the completion database." :type '(set (const lisp) (const c)) :group 'completion)

;;;***

;;;### (autoloads (dabbrev-search-these-buffers-only dabbrev-friend-buffer-function dabbrev-check-other-buffers dabbrev-ignored-buffer-regexps dabbrev-ignored-buffer-names dabbrev-check-all-buffers dabbrev-abbrev-char-regexp dabbrev-case-replace dabbrev-case-distinction dabbrev-upcase-means-case-search dabbrev-case-fold-search dabbrev--eliminate-newlines dabbrev-abbrev-skip-leading-regexp dabbrev-limit dabbrev-backward-only dabbrev) "dabbrev" "edit-utils/dabbrev.el")
(defconst custom-define-current-source-file "dabbrev.el")

(defgroup dabbrev nil "Dynamic Abbreviations" :tag "Dynamic Abbreviations" :group 'abbrev :group 'convenience)

(defcustom dabbrev-backward-only nil "\
*If non-nil, `dabbrev-expand' only looks backwards." :type 'boolean :group 'dabbrev)

(defcustom dabbrev-limit nil "\
*Limits region searched by `dabbrev-expand' to this many chars away." :type '(choice (const :tag "off" nil) integer) :group 'dabbrev)

(defcustom dabbrev-abbrev-skip-leading-regexp nil "\
*Regexp for skipping leading characters of an abbreviation.

Example: Set this to \"\\\\$\" for programming languages
in which variable names may appear with or without a leading `$'.
\(For example, in Makefiles.)

Set this to nil if no characters should be skipped." :type '(choice regexp (const :tag "off" nil)) :group 'dabbrev)

(defcustom dabbrev--eliminate-newlines t "\
*Non-nil means dabbrev should not insert newlines.
Instead it converts them to spaces." :type 'boolean :group 'dabbrev)

(defcustom dabbrev-case-fold-search nil "\
*Control whether dabbrev searches should ignore case.
A value of nil means case is significant.
A value of `case-fold-search' means case is significant
 if `case-fold-search' is nil.
Any other non-nil version means case is not significant." :type '(choice (const :tag "off" nil) (const :tag "like search" case-fold-search) (other :tag "on" t)) :group 'dabbrev)

(defcustom dabbrev-upcase-means-case-search nil "\
*The significance of an uppercase character in an abbreviation.
nil means case fold search when searching for possible expansions;
non-nil means case sensitive search.

This variable has an effect only when the value of
`dabbrev-case-fold-search' says to ignore case." :type 'boolean :group 'dabbrev)

(defcustom dabbrev-case-distinction 'case-replace "\
*Whether dabbrev treats expansions as the same if they differ in case.

A value of nil means treat them as different.
A value of `case-replace' means distinguish them if `case-replace' is nil.
Any other non-nil value means to treat them as the same.

This variable has an effect only when the value of
`dabbrev-case-fold-search' specifies to ignore case." :type '(choice (const :tag "off" nil) (const :tag "based on `case-replace'" case-replace) (other :tag "on" t)) :group 'dabbrev :version "21.4")

(defcustom dabbrev-case-replace 'case-replace "\
*Whether dabbrev applies the abbreviations's case pattern to the expansion.

A value of nil means preserve the expansion's case pattern.
A value of `case-replace' means preserve it if `case-replace' is nil.
Any other non-nil value means modify the expansion
by applying the abbreviation's case pattern to it.

This variable has an effect only when the value of
`dabbrev-case-fold-search' specifies to ignore case." :type '(choice (const :tag "off" nil) (const :tag "based on `case-replace'" case-replace) (other :tag "on" t)) :group 'dabbrev)

(defcustom dabbrev-abbrev-char-regexp nil "\
*Regexp to recognize a character in an abbreviation or expansion.
This regexp will be surrounded with \\\\( ... \\\\) when actually used.

Set this variable to \"\\\\sw\" if you want ordinary words or
\"\\\\sw\\\\|\\\\s_\" if you want symbols (including characters whose
syntax is \"symbol\" as well as those whose syntax is \"word\".

The value nil has a special meaning: the abbreviation is from point to
previous word-start, but the search is for symbols.

For instance, if you are programming in Lisp, `yes-or-no-p' is a symbol,
while `yes', `or', `no' and `p' are considered words.  If this
variable is nil, then expanding `yes-or-no-' looks for a symbol
starting with or containing `no-'.  If you set this variable to
\"\\\\sw\\\\|\\\\s_\", that expansion looks for a symbol starting with
`yes-or-no-'.  Finally, if you set this variable to \"\\\\sw\", then
expanding `yes-or-no-' signals an error because `-' is not part of a word;
but expanding `yes-or-no' looks for a word starting with `no'.

The recommended value is \"\\\\sw\\\\|\\\\s_\"." :type '(choice (const nil) regexp) :group 'dabbrev)

(defcustom dabbrev-check-all-buffers t "\
*Non-nil means dabbrev package should search *all* buffers.

Dabbrev always searches the current buffer first.  Then, if
`dabbrev-check-other-buffers' says so, it searches the buffers
designated by `dabbrev-select-buffers-function'.

Then, if `dabbrev-check-all-buffers' is non-nil, dabbrev searches
all the other buffers, except those named in `dabbrev-ignored-buffer-names',
or matched by `dabbrev-ignored-regexps'." :type 'boolean :group 'dabbrev)

(defcustom dabbrev-ignored-buffer-names '("*Messages*" "*Buffer List*") "\
*List of buffer names that dabbrev should not check.
See also `dabbrev-ignored-buffer-regexps'." :type '(repeat (string :tag "Buffer name")) :group 'dabbrev :version "20.3")

(defcustom dabbrev-ignored-buffer-regexps nil "\
*List of regexps matching names of buffers that dabbrev should not check.
See also `dabbrev-ignored-buffer-names'." :type '(repeat regexp) :group 'dabbrev :version "21.1")

(defcustom dabbrev-check-other-buffers t "\
*Should \\[dabbrev-expand] look in other buffers?
nil: Don't look in other buffers.
t: Also look for expansions in the buffers pointed out by
   `dabbrev-select-buffers-function'.
Anything else: When we can't find any more expansions in
the current buffer, then ask the user whether to look in other
buffers too.

The default value is t." :type '(choice (const :tag "off" nil) (const :tag "on" t) (other :tag "ask" other)) :group 'dabbrev)

(defcustom dabbrev-friend-buffer-function 'dabbrev--same-major-mode-p "\
*A function to decide whether dabbrev should search OTHER-BUFFER.
The function should take one argument, OTHER-BUFFER, and return
non-nil if that buffer should be searched.  Have a look at
`dabbrev--same-major-mode-p' for an example.

The value of `dabbrev-friend-buffer-function' has an effect only if
the value of `dabbrev-select-buffers-function' uses it.  The function
`dabbrev--select-buffers' is one function you can use here.

A mode setting this variable should make it buffer local." :type 'function :group 'dabbrev)

(defcustom dabbrev-search-these-buffers-only nil "\
If non-nil, a list of buffers which dabbrev should search.
If this variable is non-nil, dabbrev will only look in these buffers.
It will not even look in the current buffer if it is not a member of
this list.")

;;;***

;;;### (autoloads (desktop-relative-file-names desktop-clear-preserve-buffers desktop-minor-mode-table desktop-save-hook desktop-buffer-handlers desktop-buffer-misc-functions desktop-buffer-name desktop-buffer-file-name desktop-buffer-major-mode desktop-modes-not-to-save desktop-buffer-modes-to-save desktop-files-not-to-save desktop-buffers-not-to-save desktop-locals-to-save desktop-globals-to-save desktop-missing-file-warning desktop-basefilename desktop-enable-save-on-exit desktop-enable desktop) "desktop" "edit-utils/desktop.el")
(defconst custom-define-current-source-file "desktop.el")

(defgroup desktop nil "Save partial state of Emacs when you exit." :group 'frames)

(defcustom desktop-enable nil "\
*Non-nil enables Desktop to load the saved state of Emacs on startup." :group 'desktop :type 'boolean :require 'desktop :initialize 'custom-initialize-default :version "20.3")

(defcustom desktop-enable-save-on-exit t "\
*Non-nil enables Desktop to save the state of Emacs when you exit.
Set to nil to disable saving on exit while keeping loading on startup." :group 'desktop :type 'boolean :require 'desktop :initialize 'custom-initialize-default)

(defcustom desktop-basefilename (if (or (eq system-type 'ms-dos) (eq system-type 'windows-nt)) "emacs.dsk" (convert-standard-filename ".emacs.desktop")) "\
File for Emacs desktop, not including the directory name." :type 'file :group 'desktop)

(defcustom desktop-missing-file-warning nil "\
*If non-nil then desktop warns when a file no longer exists.
Otherwise it simply ignores that file." :type 'boolean :group 'desktop)

(defcustom desktop-globals-to-save (list 'desktop-missing-file-warning 'tags-file-name 'tags-table-list 'search-ring 'regexp-search-ring 'register-alist) "\
List of global variables to save when killing Emacs.
An element may be variable name (a symbol)
or a cons cell of the form  (VAR . MAX-SIZE),
which means to truncate VAR's value to at most MAX-SIZE elements
\(if the value is a list) before saving the value." :type '(repeat (choice (symbol :tag "Variable") (cons (symbol :tag "Variable") (integer :tag "Size")))) :group 'desktop)

(defcustom desktop-locals-to-save (list 'desktop-locals-to-save 'truncate-lines 'case-fold-search 'case-replace 'fill-column 'overwrite-mode 'change-log-default-name 'line-number-mode) "\
List of local variables to save for each buffer.
The variables are saved only when they really are local." :type '(repeat (choice (symbol :tag "Variable") (cons (symbol :tag "Variable") (integer :tag "Size")))) :group 'desktop)

(defcustom desktop-buffers-not-to-save "\\(^nn\\.a[0-9]+\\|\\.log\\|(ftp)\\|^tags\\|^TAGS\\)$" "\
Regexp identifying buffers that are to be excluded from saving." :type 'regexp :group 'desktop)

(defcustom desktop-files-not-to-save "^/[^/:]*:" "\
Regexp identifying files whose buffers are to be excluded from saving." :type 'regexp :group 'desktop)

(defcustom desktop-buffer-modes-to-save '(Info-mode rmail-mode) "\
If a buffer is of one of these major modes, save the buffer name.
It is up to the functions in `desktop-buffer-handlers' to decide
whether the buffer should be recreated or not, and how." :type '(repeat symbol) :group 'desktop)

(defcustom desktop-modes-not-to-save nil "\
List of major modes whose buffers should not be saved." :type '(repeat symbol) :group 'desktop)

(defcustom desktop-buffer-major-mode nil "\
When desktop creates a buffer, this holds the desired Major mode." :type 'symbol :group 'desktop)

(defcustom desktop-buffer-file-name nil "\
When desktop creates a buffer, this holds the file name to visit." :type '(choice file (const nil)) :group 'desktop)

(defcustom desktop-buffer-name nil "\
When desktop creates a buffer, this holds the desired buffer name." :type '(choice string (const nil)) :group 'desktop)

(defcustom desktop-buffer-misc-functions '(desktop-buffer-info-misc-data desktop-buffer-dired-misc-data) "\
*Functions used to determine auxiliary information for a buffer.
These functions are called in order, with no arguments.  If a function
returns non-nil, its value is saved along with the desktop buffer for
which it was called; no further functions will be called.

Later, when desktop.el restores the buffers it has saved, each of the
`desktop-buffer-handlers' functions will have access to a buffer local
variable, named `desktop-buffer-misc', whose value is what the
\"misc\" function returned previously." :type '(repeat function) :group 'desktop)

(defcustom desktop-buffer-handlers '(desktop-buffer-dired desktop-buffer-rmail desktop-buffer-mh desktop-buffer-info desktop-buffer-file) "\
*List of functions to call in order to create a buffer.
The functions are called without explicit parameters but can use the
variables `desktop-buffer-major-mode', `desktop-buffer-file-name',
`desktop-buffer-name'.
If one function returns non-nil, no further functions are called.
If the function returns t then the buffer is considered created." :type '(repeat function) :group 'desktop)

(defcustom desktop-save-hook nil "\
Hook run before desktop saves the state of Emacs.
This is useful for truncating history lists, for example." :type 'hook :group 'desktop)

(defcustom desktop-minor-mode-table '((auto-fill-function auto-fill-mode) (vc-mode nil)) "\
Table mapping minor mode variables to minor mode functions.
Each entry has the form (NAME RESTORE-FUNCTION).
NAME is the name of the buffer-local variable indicating that the minor
mode is active.  RESTORE-FUNCTION is the function to activate the minor mode.
called.  RESTORE-FUNCTION nil means don't try to restore the minor mode.
Only minor modes for which the name of the buffer-local variable
and the name of the minor mode function are different have to added to
this table." :type 'sexp :group 'desktop)

(defcustom desktop-clear-preserve-buffers '("*scratch*" "*Warnings*") "\
*Buffer names that `desktop-clear' should not delete." :type '(repeat string) :group 'desktop)

(defcustom desktop-relative-file-names nil "\
*Non-nil means file names in the desktop file are relative to
`desktop-dirname'." :type 'boolean :group 'desktop)

;;;***

;;;### (autoloads (minibuf-frame-pos-x minibuf-frame-pos-y minibuf-frame-width minibuf-frame-height add-minibuf-options detached-minibuf) "detached-minibuf" "edit-utils/detached-minibuf.el")
(defconst custom-define-current-source-file "detached-minibuf.el")

(defgroup detached-minibuf nil "Support a detached minibuffer in XEmacs" :group 'minibuffer :prefix "minibuf-frame-" :group 'frames)

(defcustom add-minibuf-options t "\
*If nil, prevent minibuffer options from being added to the Options menu.This must be set before detached-minibuf is loaded." :type 'boolean :group 'detached-minibuf)

(defcustom minibuf-frame-height 1 "\
*The height in lines of the minibuffer frame created by make-detached-minibuf" :type 'integer :group 'detached-minibuf)

(defcustom minibuf-frame-width (frame-width (selected-frame)) "\
*The width in chars of the minibuffer frame created by make-detached-minibuf" :type 'integer :group 'detached-minibuf)

(defcustom minibuf-frame-pos-y -2 "\
*The y position of the minibuffer frame as created by make-detached-minibuf" :type 'integer :group 'detached-minibuf)

(defcustom minibuf-frame-pos-x -2 "\
*The x position of the minibuffer frame as created by make-detached-minibuf" :type 'integer :group 'detached-minibuf)

;;;***

;;;### (autoloads (fast-lock-verbose fast-lock-save-others fast-lock-save-events fast-lock-minimum-size fast-lock-cache-directories fast-lock-mode fast-lock) "fast-lock" "edit-utils/fast-lock.el")
(defconst custom-define-current-source-file "fast-lock.el")

(defgroup fast-lock nil "Automagic text properties caching for fast Font Lock mode" :group 'faces)

(defcustom fast-lock-mode nil "\
Non nil means `fast-lock-mode' is on" :group 'fast-lock :require 'fast-lock :type 'boolean :initialize 'custom-initialize-default :set '(lambda (var val) (if val (progn (fast-lock-mode 1) (add-hook 'font-lock-mode-hook 'turn-on-fast-lock)) (fast-lock-mode -1) (remove-hook 'font-lock-mode-hook 'turn-on-fast-lock)) (setq-default fast-lock-mode val)))

(defcustom fast-lock-cache-directories '("~/.emacs-flc") "\
*Directories in which Font Lock cache files are saved and read.
Each item should be either DIR or a cons pair of the form (REGEXP . DIR) where
DIR is a directory name (relative or absolute) and REGEXP is a regexp.

An attempt will be made to save or read Font Lock cache files using these items
until one succeeds (i.e., until a readable or writable one is found).  If an
item contains REGEXP, DIR is used only if the buffer file name matches REGEXP.
For example:

 (let ((home (expand-file-name (abbreviate-file-name (file-truename \"~/\")))))
   (list (cons (concat \"^\" (regexp-quote home)) \".\") \"~/.emacs-flc\"))
    =>
 ((\"^/your/true/home/directory/\" . \".\") \"~/.emacs-flc\")

would cause a file's current directory to be used if the file is under your
home directory hierarchy, or otherwise the absolute directory `~/.emacs-flc'.
This list should contain only trusted directories in order to avoid processing
potentially malicious cache files." :type '(repeat (choice (cons regexp directory) directory)) :group 'fast-lock)

(defcustom fast-lock-minimum-size (* 25 1024) "\
*Minimum size of a buffer for cached fontification.
Only buffers more than this can have associated Font Lock cache files saved.
If nil, means cache files are never created.
If a list, each element should be a cons pair of the form (MAJOR-MODE . SIZE),
where MAJOR-MODE is a symbol or t (meaning the default).  For example:
 ((c-mode . 25600) (c++-mode . 25600) (rmail-mode . 1048576))
means that the minimum size is 25K for buffers in C or C++ modes, one megabyte
for buffers in Rmail mode, and size is irrelevant otherwise." :type '(choice (integer :tag "Size") (repeat (cons (symbol :tag "Major Mode") (integer :tag "Size")))) :group 'fast-lock)

(defcustom fast-lock-save-events '(kill-buffer kill-emacs) "\
*Events under which caches will be saved.
Valid events are `save-buffer', `kill-buffer' and `kill-emacs'.
If concurrent editing sessions use the same associated cache file for a file's
buffer, then you should add `save-buffer' to this list." :type '(set (const kill-buffer) (const save-buffer) (const kill-emacs)) :group 'fast-lock)

(defcustom fast-lock-save-others t "\
*If non-nil, save Font Lock cache files irrespective of file owner.
If nil, means only buffer files known to be owned by you can have associated
Font Lock cache files saved.  Ownership may be unknown for networked files." :type 'boolean :group 'fast-lock)

(defcustom fast-lock-verbose font-lock-verbose "\
*If non-nil, means show status messages for cache processing.
If a number, only buffers greater than this size have processing messages." :type '(choice integer boolean) :group 'fast-lock)

;;;***

;;;### (autoloads (fume-mode-hook fume-mode-line-string fume-python-fully-qualified-names fume-perl-fully-qualified-names fume-rescanning-message fume-scanning-message fume-index-method fume-fn-window-position fume-max-items fume-menubar-menu-location fume-menubar-menu-name fume-auto-position-popup fume) "func-menu" "edit-utils/func-menu.el")
(defconst custom-define-current-source-file "func-menu.el")

(defgroup fume nil "Jump to a function within a buffer." :tag "Func Menu" :group 'tools :group 'c :group 'lisp)

(defcustom fume-auto-position-popup t "\
*Setting of t (default) means popup the Function menu at the mouse cursor,
nil means at a window corner." :type 'boolean :group 'fume)

(defcustom fume-menubar-menu-name "Functions" "\
*Name of the menubar menu which displays current buffer function definitions." :type 'string :group 'fume)

(defcustom fume-menubar-menu-location "Buffers" "\
*Name of menu before which function menu should appear (default=\"Buffers\").
Nil means display it after the last non-right-justified menubar item." :type '(choice (const :tag "Last" nil) (string :format "%v")) :group 'fume)

(defcustom fume-max-items 24 "\
*Maximum number of elements in a function menu or submenu (default = 24)." :type 'integer :group 'fume)

(defcustom fume-fn-window-position 3 "\
*Number of lines from top of window at which to show a function (default = 3)
If nil, display function start from the centre of the window." :type '(choice (const :tag "Center" nil) integer) :group 'fume)

(defcustom fume-index-method 3 "\
*Set this to the method number you want used.

Methods currently supported:
0 = if you want submenu names to be numbered
1 = if you want submenu range indicated by first character
2 = if you want submenu range indicated by first 12 characters
3 = if you want submenu range indicated by as many characters as needed" :type '(radio (const :tag "Numbered" 0) (const :tag "Indicated by first character" 1) (const :tag "Indicated by first 12 characters" 2) (const :tag "Indicated by as many characters as needed" 3)) :group 'fume)

(defcustom fume-scanning-message "Scanning buffer... (%3d%%)" "\
*Message string format displayed during manual buffer function scans.
Nil means inhibit such messages." :type '(choice (const :tag "None" nil) string) :group 'fume)

(defcustom fume-rescanning-message nil "\
*Message string format displayed during automatic buffer function scans.
For example, \"Re-Scanning buffer...\".  Nil (default) means inhibit such
messages." :type '(choice (const :tag "None" nil) string) :group 'fume)

(defcustom fume-perl-fully-qualified-names t "\
*If non-nil, use fully qualified names for Perl functions." :type 'boolean :group 'fume)

(defcustom fume-python-fully-qualified-names t "\
*If non-nil, include class name for python functions." :type 'boolean :group 'fume)

(defcustom fume-mode-line-string " Func" "\
*String to use in the modeline when func-menu minor mode is active." :group 'fume :type 'string)

(defcustom fume-mode-hook nil "\
*Hooks to run after setting up func-menu minor mode." :group 'fume :type 'hook)

;;;***

;;;### (autoloads (highline-selected-window highline-priority highline-ignore-regexp highline-verbose highline-vertical highline-line highline-vertical-face highline-face highline) "highline" "edit-utils/highline.el")
(defconst custom-define-current-source-file "highline.el")

(defgroup highline nil "Highlight the current line" :link '(emacs-library-link :tag "Source Lisp File" "highline.el") :group 'faces :group 'frames :group 'editing)

(defcustom highline-face 'highline-face "\
*Specify face used to highlight the current line." :type 'face :group 'highline)

(defcustom highline-vertical-face 'highline-vertical-face "\
*Specify face used to highlight other than current line.

See also `highline-vertical'." :type 'face :group 'highline)

(defcustom highline-line nil "\
*Specify which part of line should be highlighted.

Valid values are:

   t			mark up to end of line.

   nil			mark up to window border.  On XEmacs, it behaves as t.
			NOTE: Let me know, if you find a way to mark up to
			      window border on XEmacs.

   INTEGER		mark up from beginning of line to column INTEGER or to
			end of line if INTEGER exceeds line length.  If INTEGER
			is negative, the region marked starts from end of line
			instead of beginning of line.

   (LOWER . UPPER)	mark up the region from column LOWER to column UPPER or
			to end of line if UPPER exceeds line length.  Nothing
			happens if LOWER exceeds line length.
			It must: 0 <= LOWER < UPPER.

   (beyond . INTEGER)	mark up the region from column INTEGER to end of line.
			Nothing happens if INTEGER exceeds line length.
			It must: INTEGER > 0.

   (point . INTEGER)	mark up the region from column
			(- (current-column) INTEGER) to column
			(+ (current-column) INTEGER).  It never goes beyond
			beginning or end of line.
			It must: INTEGER > 0.

Any other value is treated as t." :type '(choice :menu-tag "Mark Up To" :tag "Mark Up To" (const :tag "End Of Line" t) (const :tag "Window Border" nil) (integer :tag "Column") (cons :tag "Point" :value (point . 0) (const :tag "Point" point) (integer :tag "To")) (cons :tag "Beyond" :value (beyond . 0) (const :tag "Beyond" beyond) (integer :tag "From")) (cons :tag "Range" :value (0 . 0) (integer :tag "From") (integer :tag "To"))) :group 'highline)

(defcustom highline-vertical nil "\
*Specify how many vertical lines should be highlighted.

Valid values are:

   nil			Highlight only current line.

   t			Highlight all current window.

   (ABOVE . BELOW)	Highlight the vertical range from line
			(current-line-number - ABOVE) to line
			(current-line-number + BELOW).  ABOVE and BELOW should
			be integers.  There are the following cases:

			1. ABOVE <= 0 and BELOW <= 0
				This is the same as nil, that is, only current
				line is highlighted.  It's recommended to set
				`highline-vertical' to nil instead of (0 . 0),
				it'll have a better performance.

			2. ABOVE <= 0 and BELOW > 0
				Only current line and lines below will be
				highlighted.

			3. ABOVE > 0 and BELOW <= 0
				Only current line and lines above will be
				highlighted.

			4. ABOVE > 0 and BELOW > 0
				Current line, lines above and lines below will
				be highlighted.

Any other value is treated as t." :type '(choice :menu-tag "" :tag "" (const :tag "Only Current Line" nil) (const :tag "All Current Window" t) (cons :tag "Vertical Range" :value (1 . 1) (integer :tag "Above") (integer :tag "Below"))) :group 'highline)

(defcustom highline-verbose t "\
*Non-nil means generate messages." :type 'boolean :group 'highline)

(defcustom highline-ignore-regexp (concat "Faces\\|Colors\\|Minibuf\\|\\*tip\\*") "\
*Specify regexp for buffers to ignore.

Set to nil or \"\", to accept any buffer.

Used by `highline-highlight-current-line'." :type 'regexp :group 'highline)

(defcustom highline-priority 0 "\
*Specify highline overlay priority.

Higher integer means higher priority, so highline overlay will have precedence
over overlays with lower priority.  *Don't* use negative number." :type 'integer :group 'highline)

(defcustom highline-selected-window nil "\
*Non-nil means highlight current line on current window.

This is useful when you have a buffer in two or more windows and wish to
highlight only on current window." :type 'boolean :group 'highline)

;;;***

;;;### (autoloads (icomplete-minibuffer-setup-hook icomplete-max-delay-chars icomplete-delay-completions-threshold icomplete-compute-delay icomplete-prospects-length icomplete-mode icomplete) "icomplete" "edit-utils/icomplete.el")
(defconst custom-define-current-source-file "icomplete.el")

(defgroup icomplete nil "Minibuffer completion incremental feedback." :group 'minibuffer)

(defcustom icomplete-mode nil "\
*Non-nil activates incremental minibuffer completion." :type 'boolean :set (lambda (symbol value) (icomplete-mode (if value 1 -1))) :initialize 'custom-initialize-default :require 'icomplete :group 'icomplete)

(defcustom icomplete-prospects-length 80 "\
*Length of string displaying the prospects." :type 'integer :group 'icomplete)

(defcustom icomplete-compute-delay 0.3 "\
*Completions-computation stall, used only with large-number
completions - see `icomplete-delay-completions-threshold'." :type 'number :group 'icomplete)

(defcustom icomplete-delay-completions-threshold 400 "\
*Pending-completions number over which to apply icomplete-compute-delay." :type 'integer :group 'icomplete)

(defcustom icomplete-max-delay-chars 3 "\
*Maximum number of initial chars to apply icomplete compute delay." :type 'integer :group 'icomplete)

(defcustom icomplete-minibuffer-setup-hook nil "\
*Icomplete-specific customization of minibuffer setup.

This hook is run during minibuffer setup iff icomplete will be active.
It is intended for use in customizing icomplete for interoperation
with other packages.  For instance:

  (add-hook 'icomplete-minibuffer-setup-hook
	    (function
	     (lambda ()
	       (make-local-variable 'resize-minibuffer-window-max-height)
	       (setq resize-minibuffer-window-max-height 3))))

will constrain rsz-mini to a maximum minibuffer height of 3 lines when
icompletion is occurring." :type 'hook :group 'icomplete)

;;;***

;;;### (autoloads (id-select-syntax-alist id-select-whitespace id-select-display-type id-select-char-p id-select-indent-modes id-select-text-modes id-select-markup-modes id-select-brace-modes id-select) "id-select" "edit-utils/id-select.el")
(defconst custom-define-current-source-file "id-select.el")

(defgroup id-select nil "Select larger and larger syntax-driven regions in a buffer" :group 'matching :group 'mouse)

(defcustom id-select-brace-modes '(c++-mode c-mode java-mode objc-mode perl-mode tcl-mode) "\
*List of language major modes which define things with brace delimiters." :type '(repeat (symbol :tag "Mode" symbol)) :group 'id-select)

(defcustom id-select-markup-modes '(html-mode sgml-mode) "\
*List of markup language modes that use SGML-style <tag> </tag> pairs." :type '(repeat (symbol :tag "Mode")) :group 'id-select)

(defcustom id-select-text-modes '(fundamental-mode kotl-mode indented-text-mode Info-mode outline-mode text-mode) "\
*List of textual modes where paragraphs may be outdented or indented." :type '(repeat (symbol :tag "Mode")) :group 'id-select)

(defcustom id-select-indent-modes (append '(altmath-mode asm-mode csh-mode eiffel-mode ksh-mode math-mode miranda-mode python-mode pascal-mode sather-mode) id-select-text-modes) "\
*List of language major modes which use mostly indentation to define syntactic structure." :type '(repeat (symbol :tag "Mode")) :group 'id-select)

(defcustom id-select-char-p t "\
*If t, return single character boundaries when all else fails." :type 'boolean :group 'id-select)

(defcustom id-select-display-type t "\
*If t, display the thing selected with each mouse click." :type 'boolean :group 'id-select)

(defcustom id-select-whitespace t "\
*If t, groups of whitespace are considered as things." :type 'boolean :group 'id-select)

(defcustom id-select-syntax-alist '((?w id-select-word) (?_ id-select-symbol) (?\" id-select-string) (?\( id-select-sexp-start) (?$ id-select-sexp-start) (?\' id-select-sexp-start) (?\) id-select-sexp-end) (?\  id-select-whitespace) (?< id-select-comment) (?\. id-select-punctuation)) "\
*List of pairs of the form (SYNTAX-CHAR FUNCTION) used by the function `id-select-syntactical-region'.
Each FUNCTION takes a single position argument and returns a region
\(start . end) delineating the boundaries of the thing at that position.
Ordering of entries is largely irrelevant to any code that uses this list." :type '(repeat (list (sexp :tag "Syntax-Char" function))) :group 'id-select)

;;;***

;;;### (autoloads (ido-before-fallback-functions ido-read-file-name-non-ido ido-read-file-name-as-directory-commands ido-save-directory-list-file ido-minibuffer-setup-hook ido-completion-buffer-all-completions ido-completion-buffer ido-rewrite-file-prompt-functions ido-make-buffer-list-hook ido-make-dir-list-hook ido-make-file-list-hook ido-use-faces ido-use-virtual-buffers ido-decorations ido-separator ido-setup-hook ido-create-new-buffer ido-enter-matching-directory ido-rotate-file-list-default ido-max-directory-size ido-max-dir-file-cache ido-merged-indicator ido-auto-merge-inhibit-characters-regexp ido-auto-merge-delay-time ido-auto-merge-work-directories-length ido-work-directory-match-only ido-max-work-file-list ido-cache-unc-host-shares-time ido-ignore-unc-host-regexps ido-downcase-unc-hosts ido-unc-hosts ido-slow-ftp-host-regexps ido-slow-ftp-hosts ido-cache-ftp-work-directory-time ido-merge-ftp-work-directories ido-record-ftp-work-directories ido-enable-tramp-completion ido-use-url-at-point ido-use-filename-at-point ido-work-directory-list-ignore-regexps ido-max-work-directory-list ido-enable-last-directory-history ido-max-window-height ido-max-file-prompt-width ido-max-prospects ido-record-commands ido-cannot-complete-command ido-confirm-unique-completion ido-enable-dot-prefix ido-enable-prefix ido-enable-regexp ido-enable-flex-matching ido-default-buffer-method ido-default-file-method ido-ignore-directories-merge ido-ignore-directories ido-file-extensions-order ido-show-dot-for-dired ido-ignore-extensions ido-ignore-files ido-ignore-buffers ido-case-fold ido-mode ido) "ido" "edit-utils/ido.el")
(defconst custom-define-current-source-file "ido.el")

(defgroup ido nil "Switch between files using substrings." :group 'extensions :group 'convenience :version "22.1" :link '(emacs-commentary-link :tag "Commentary" "ido.el") :link '(emacs-library-link :tag "Lisp File" "ido.el"))

(defcustom ido-mode nil "\
Determines for which functional group (buffer and files) ido behavior
should be enabled.  The following values are possible:
- `buffer': Turn only on ido buffer behavior (switching, killing,
  displaying...)
- `file': Turn only on ido file behavior (finding, writing, inserting...)
- `both': Turn on ido buffer and file behavior.
- `nil': Turn off any ido switching.

Setting this variable directly does not take effect;
use either \\[customize] or the function `ido-mode'." :set (function (lambda (_symbol value) (ido-mode value))) :initialize 'custom-initialize-default :require 'ido :link '(emacs-commentary-link "ido.el") :set-after '(ido-save-directory-list-file ido-unc-hosts) :type '(choice (const :tag "Turn on only buffer" buffer) (const :tag "Turn on only file" file) (const :tag "Turn on both buffer and file" both) (const :tag "Switch off all" nil)) :group 'ido)

(defcustom ido-case-fold case-fold-search "\
Non-nil if searching of buffer and file names should ignore case." :type 'boolean :group 'ido)

(defcustom ido-ignore-buffers '("\\` ") "\
List of regexps or functions matching buffer names to ignore.
For example, traditional behavior is not to list buffers whose names begin
with a space, for which the regexp is `\\` '.  See the source file for
example functions that filter buffer names." :type '(repeat (choice regexp function)) :group 'ido)

(defcustom ido-ignore-files '("\\`CVS/" "\\`#" "\\`.#" "\\`\\.\\./" "\\`\\./") "\
List of regexps or functions matching file names to ignore.
For example, traditional behavior is not to list files whose names begin
with a #, for which the regexp is `\\`#'.  See the source file for
example functions that filter filenames." :type '(repeat (choice regexp function)) :group 'ido)

(defcustom ido-ignore-extensions t "\
Non-nil means ignore files in `completion-ignored-extensions' list." :type 'boolean :group 'ido)

(defcustom ido-show-dot-for-dired nil "\
Non-nil means to always put . as the first item in file name lists.
This allows the current directory to be opened immediately with `dired'." :type 'boolean :group 'ido)

(defcustom ido-file-extensions-order nil "\
List of file extensions specifying preferred order of file selections.
Each element is either a string with `.' as the first char, an empty
string matching files without extension, or t which is the default order
for files with an unlisted file extension." :type '(repeat (choice string (const :tag "Default order" t))) :group 'ido)

(defcustom ido-ignore-directories '("\\`CVS/" "\\`\\.\\./" "\\`\\./") "\
List of regexps or functions matching sub-directory names to ignore." :type '(repeat (choice regexp function)) :group 'ido)

(defcustom ido-ignore-directories-merge nil "\
List of regexps or functions matching directory names to ignore during merge.
Directory names matched by one of the regexps in this list are not inserted
in merged file and directory lists." :type '(repeat (choice regexp function)) :group 'ido)

(defcustom ido-default-file-method 'raise-frame "\
How to visit a new file when using `ido-find-file'.
Possible values:
`selected-window' Show new file in selected window
`other-window'	  Show new file in another window (same frame)
`display'	  Display file in another window without selecting to it
`other-frame'	  Show new file in another frame
`maybe-frame'	  If a file is visible in another frame, prompt to ask if you
		  you want to see the file in the same window of the current
  		  frame or in the other frame
`raise-frame'     If a file is visible in another frame, raise that
		  frame; otherwise, visit the file in the same window" :type '(choice (const :tag "Visit in selected window" selected-window) (const :tag "Visit in other window" other-window) (const :tag "Display (no select) in other window" display) (const :tag "Visit in other frame" other-frame) (const :tag "Ask to visit in other frame" maybe-frame) (const :tag "Raise frame if already visited" raise-frame)) :group 'ido)

(defcustom ido-default-buffer-method 'raise-frame "\
How to switch to new buffer when using `ido-switch-buffer'.
See `ido-default-file-method' for details." :type '(choice (const :tag "Show in selected window" selected-window) (const :tag "Show in other window" other-window) (const :tag "Display (no select) in other window" display) (const :tag "Show in other frame" other-frame) (const :tag "Ask to show in other frame" maybe-frame) (const :tag "Raise frame if already shown" raise-frame)) :group 'ido)

(defcustom ido-enable-flex-matching nil "\
Non-nil means that `ido' will do flexible string matching.
Flexible matching means that if the entered string does not
match any item, any item containing the entered characters
in the given sequence will match." :type 'boolean :group 'ido)

(defcustom ido-enable-regexp nil "\
Non-nil means that `ido' will do regexp matching.
Value can be toggled within `ido' using `ido-toggle-regexp'." :type 'boolean :group 'ido)

(defcustom ido-enable-prefix nil "\
Non-nil means only match if the entered text is a prefix of file name.
This behavior is like the standard Emacs completion.
If nil, match if the entered text is an arbitrary substring.
Value can be toggled within `ido' using `ido-toggle-prefix'." :type 'boolean :group 'ido)

(defcustom ido-enable-dot-prefix nil "\
Non-nil means to match leading dot as prefix.
I.e. hidden files and buffers will match only if you type a dot
as first char even if `ido-enable-prefix' is nil." :type 'boolean :group 'ido)

(defcustom ido-confirm-unique-completion nil "\
Non-nil means that even a unique completion must be confirmed.
This means that \\[ido-complete] must always be followed by \\[ido-exit-minibuffer]
even when there is only one unique completion." :type 'boolean :group 'ido)

(defcustom ido-cannot-complete-command 'ido-completion-help "\
Command run when `ido-complete' can't complete any more.
The most useful values are `ido-completion-help', which pops up a
window with completion alternatives, or `ido-next-match' or
`ido-prev-match', which cycle the buffer list." :type 'function :group 'ido)

(defcustom ido-record-commands t "\
Non-nil means that `ido' will record commands in command history.
Note that the non-ido equivalent command is recorded." :type 'boolean :group 'ido)

(defcustom ido-max-prospects 12 "\
Non-zero means that the prospect list will be limited to that number of items.
For a long list of prospects, building the full list for the minibuffer can take a
non-negligible amount of time; setting this variable reduces that time." :type 'integer :group 'ido)

(defcustom ido-max-file-prompt-width 0.35 "\
Non-zero means that the prompt string be limited to that number of characters.
If value is a floating point number, it specifies a fraction of the frame width." :type '(choice (integer :tag "Characters" :value 20) (restricted-sexp :tag "Fraction of frame width" :value 0.35 :match-alternatives (ido-fractionp))) :group 'ido)

(defcustom ido-max-window-height nil "\
Non-nil specifies a value to override `max-mini-window-height'." :type '(choice (const :tag "Don't override" nil) (integer :tag "Number of lines" :value 1) (restricted-sexp :tag "Fraction of window height" :value 0.25 :match-alternatives (ido-fractionp))) :group 'ido)

(defcustom ido-enable-last-directory-history t "\
Non-nil means that `ido' will remember latest selected directory names.
See `ido-last-directory-list' and `ido-save-directory-list-file'." :type 'boolean :group 'ido)

(defcustom ido-max-work-directory-list 50 "\
Maximum number of working directories to record.
This is the list of directories where files have most recently been opened.
See `ido-work-directory-list' and `ido-save-directory-list-file'." :type 'integer :group 'ido)

(defcustom ido-work-directory-list-ignore-regexps nil "\
List of regexps matching directories which should not be recorded.
Directory names matched by one of the regexps in this list are not inserted in
the `ido-work-directory-list' list." :type '(repeat regexp) :group 'ido)

(defcustom ido-use-filename-at-point nil "\
Non-nil means that ido shall look for a filename at point.
May use `ffap-guesser' to guess whether text at point is a filename.
If found, use that as the starting point for filename selection." :type '(choice (const :tag "Disabled" nil) (const :tag "Guess filename" guess) (other :tag "Use literal filename" t)) :group 'ido)

(defcustom ido-use-url-at-point nil "\
Non-nil means that ido shall look for a URL at point.
If found, call `find-file-at-point' to visit it." :type 'boolean :group 'ido)

(defcustom ido-enable-tramp-completion t "\
Non-nil means that ido shall perform tramp method and server name completion.
A tramp file name uses the following syntax: /method:user@host:filename." :type 'boolean :group 'ido)

(defcustom ido-record-ftp-work-directories t "\
Non-nil means record ftp file names in the work directory list." :type 'boolean :group 'ido)

(defcustom ido-merge-ftp-work-directories nil "\
If nil, merging ignores ftp file names in the work directory list." :type 'boolean :group 'ido)

(defcustom ido-cache-ftp-work-directory-time 1.0 "\
Maximum time to cache contents of an ftp directory (in hours).
Use C-l in prompt to refresh list.
If zero, ftp directories are not cached." :type 'number :group 'ido)

(defcustom ido-slow-ftp-hosts nil "\
List of slow ftp hosts where ido prompting should not be used.
If an ftp host is on this list, ido automatically switches to the non-ido
equivalent function, e.g. `find-file' rather than `ido-find-file'." :type '(repeat string) :group 'ido)

(defcustom ido-slow-ftp-host-regexps nil "\
List of regexps matching slow ftp hosts (see `ido-slow-ftp-hosts')." :type '(repeat regexp) :group 'ido)

(defcustom ido-unc-hosts nil "\
List of known UNC host names to complete after initial //.
If value is a function, that function is called to search network for
hosts on first use of UNC path." :type '(choice (repeat :tag "List of UNC host names" string) (function-item :tag "Use `NET VIEW'" :value ido-unc-hosts-net-view) (function :tag "Your own function")) :set (function (lambda (symbol value) (set symbol value) (setq ido-unc-hosts-cache t))) :group 'ido)

(defcustom ido-downcase-unc-hosts t "\
Non-nil if UNC host names should be downcased." :type 'boolean :group 'ido)

(defcustom ido-ignore-unc-host-regexps nil "\
List of regexps matching UNC hosts to ignore.
Case is ignored if `ido-downcase-unc-hosts' is set." :type '(repeat regexp) :group 'ido)

(defcustom ido-cache-unc-host-shares-time 8.0 "\
Maximum time to cache shares of an UNC host (in hours).
Use C-l in prompt to refresh list.
If zero, UNC host shares are not cached." :type 'number :group 'ido)

(defcustom ido-max-work-file-list 10 "\
Maximum number of names of recently opened files to record.
This is the list of the file names (sans directory) which have most recently
been opened.  See `ido-work-file-list' and `ido-save-directory-list-file'." :type 'integer :group 'ido)

(defcustom ido-work-directory-match-only t "\
Non-nil means to skip non-matching directories in the directory history.
When some text is already entered at the `ido-find-file' prompt, using
\\[ido-prev-work-directory] or \\[ido-next-work-directory] will skip directories
without any matching entries." :type 'boolean :group 'ido)

(defcustom ido-auto-merge-work-directories-length 0 "\
Automatically switch to merged work directories during file name input.
The value is number of characters to type before switching to merged mode.
If zero, the switch happens when no matches are found in the current directory.
Automatic merging is disabled if the value is negative." :type 'integer :group 'ido)

(defcustom ido-auto-merge-delay-time 0.7 "\
Delay in seconds to wait for more input before doing auto merge." :type 'number :group 'ido)

(defcustom ido-auto-merge-inhibit-characters-regexp "[][*?~]" "\
Regexp matching characters which should inhibit automatic merging.
When a (partial) file name matches this regexp, merging is inhibited." :type 'regexp :group 'ido)

(defcustom ido-merged-indicator "^" "\
The string appended to first choice if it has multiple directory choices." :type 'string :group 'ido)

(defcustom ido-max-dir-file-cache 100 "\
Maximum number of working directories to be cached.
This is the size of the cache of `file-name-all-completions' results.
Each cache entry is time stamped with the modification time of the
directory.  Some systems, like Windows, have unreliable directory
modification times, so you may choose to disable caching on such
systems, or explicitly refresh the cache contents using the command
`ido-reread-directory' command (C-l) in the minibuffer.
See also `ido-dir-file-cache' and `ido-save-directory-list-file'." :type 'integer :group 'ido)

(defcustom ido-max-directory-size 30000 "\
Maximum size (in bytes) for directories to use ido completion.
If you enter a directory with a size larger than this size, ido will
not provide the normal completion.  To show the completions, use C-a." :type '(choice (const :tag "No limit" nil) (integer :tag "Size in bytes" 30000)) :group 'ido)

(defcustom ido-rotate-file-list-default nil "\
Non-nil means that `ido' will always rotate file list to get default in front." :type 'boolean :group 'ido)

(defcustom ido-enter-matching-directory 'only "\
Additional methods to enter sub-directory of first/only matching item.
If value is 'first, enter first matching sub-directory when typing a slash.
If value is 'only, typing a slash only enters the sub-directory if it is
the only matching item.
If value is t, automatically enter a sub-directory when it is the only
matching item, even without typing a slash." :type '(choice (const :tag "Never" nil) (const :tag "Slash enters first directory" first) (const :tag "Slash enters first and only directory" only) (other :tag "Always enter unique directory" t)) :group 'ido)

(defcustom ido-create-new-buffer 'prompt "\
Specify whether a new buffer is created if no buffer matches substring.
Choices are 'always to create new buffers unconditionally, 'prompt to
ask user whether to create buffer, or 'never to never create new buffer." :type '(choice (const always) (const prompt) (const never)) :group 'ido)

(defcustom ido-setup-hook nil "\
Hook run after the ido variables and keymap have been setup.
The dynamic variable `ido-cur-item' contains the current type of item that
is read by ido; possible values are file, dir, buffer, and list.
Additional keys can be defined in `ido-completion-map'." :type 'hook :group 'ido)

(defcustom ido-separator nil "\
String used by ido to separate the alternatives in the minibuffer.
Obsolete.  Set 3rd element of `ido-decorations' instead." :type '(choice string (const nil)) :group 'ido)

(defcustom ido-decorations '("{" "}" " | " " | ..." "[" "]" " [No match]" " [Matched]" " [Not readable]" " [Too big]" " [Confirm]") "\
List of strings used by ido to display the alternatives in the minibuffer.
There are 11 elements in this list:
1st and 2nd elements are used as brackets around the prospect list,
3rd element is the separator between prospects (ignored if `ido-separator' is set),
4th element is the string inserted at the end of a truncated list of prospects,
5th and 6th elements are used as brackets around the common match string which
can be completed using TAB,
7th element is the string displayed when there are no matches, and
8th element is displayed if there is a single match (and faces are not used),
9th element is displayed when the current directory is non-readable,
10th element is displayed when directory exceeds `ido-max-directory-size',
11th element is displayed to confirm creating new file or buffer." :type '(repeat string) :group 'ido)

(defcustom ido-use-virtual-buffers nil "\
If non-nil, refer to past buffers as well as existing ones.
Essentially it works as follows: Say you are visiting a file and
the buffer gets cleaned up by midnight.el.  Later, you want to
switch to that buffer, but find it's no longer open.  With
virtual buffers enabled, the buffer name stays in the buffer
list (using the `ido-virtual' face, and always at the end), and if
you select it, it opens the file back up again.  This allows you
to think less about whether recently opened files are still open
or not.  Most of the time you can quit Emacs, restart, and then
switch to a file buffer that was previously open as if it still
were.
    This feature relies upon the `recentf' package, which will be
enabled if this variable is configured to a non-nil value." :version "24.1" :type 'boolean :group 'ido)

(defcustom ido-use-faces t "\
Non-nil means use ido faces to highlighting first match, only match and
subdirs in the alternatives." :type 'boolean :group 'ido)

(defcustom ido-make-file-list-hook nil "\
List of functions to run when the list of matching files is created.
Each function on the list may modify the dynamically bound variable
`ido-temp-list' which contains the current list of matching files." :type 'hook :group 'ido)

(defcustom ido-make-dir-list-hook nil "\
List of functions to run when the list of matching directories is created.
Each function on the list may modify the dynamically bound variable
`ido-temp-list' which contains the current list of matching directories." :type 'hook :group 'ido)

(defcustom ido-make-buffer-list-hook nil "\
List of functions to run when the list of matching buffers is created.
Each function on the list may modify the dynamically bound variable
`ido-temp-list' which contains the current list of matching buffer names." :type 'hook :group 'ido)

(defcustom ido-rewrite-file-prompt-functions nil "\
List of functions to run when the find-file prompt is created.
Each function on the list may modify the following dynamically bound
variables:
  dirname   - the (abbreviated) directory name
		 to be modified by the hook functions
  max-width - the max width of the resulting dirname; nil means no limit
  prompt    - the basic prompt (e.g. \"Find File: \")
  literal   - the string shown if doing \"literal\" find; set to nil to omit
  vc-off    - the string shown if version control is inhibited; set to nil to omit
  prefix    - either nil or a fixed prefix for the dirname

The following variables are available, but should not be changed:
  `ido-current-directory' - the unabbreviated directory name
  item - equals `file' or `dir' depending on the current mode." :type 'hook :group 'ido)

(defcustom ido-completion-buffer "*Ido Completions*" "\
Name of completion buffer used by ido.
Set to nil to disable completion buffers popping up." :type 'string :group 'ido)

(defcustom ido-completion-buffer-all-completions nil "\
Non-nil means to show all completions in completion buffer.
Otherwise, only the current list of matches is shown." :type 'boolean :group 'ido)

(defcustom ido-minibuffer-setup-hook nil "\
Ido-specific customization of minibuffer setup.

This hook is run during minibuffer setup if `ido' is active.
It is intended for use in customizing ido for interoperation
with other packages.  For instance:

  (add-hook 'ido-minibuffer-setup-hook
	    (function
	     (lambda ()
	       (make-local-variable 'max-mini-window-height)
	       (setq max-mini-window-height 3))))

will constrain Emacs to a maximum minibuffer height of 3 lines when
ido is running.  Copied from `icomplete-minibuffer-setup-hook'." :type 'hook :group 'ido)

(defcustom ido-save-directory-list-file (convert-standard-filename "~/.ido.last") "\
File in which the ido state is saved between invocations.
Variables stored are: `ido-last-directory-list', `ido-work-directory-list',
`ido-work-file-list', and `ido-dir-file-cache'.
Must be set before enabling ido mode." :type 'string :group 'ido)

(defcustom ido-read-file-name-as-directory-commands 'nil "\
List of commands which uses `read-file-name' to read a directory name.
When `ido-everywhere' is non-nil, the commands in this list will read
the directory using `ido-read-directory-name'." :type '(repeat symbol) :group 'ido)

(defcustom ido-read-file-name-non-ido 'nil "\
List of commands which shall not read file names the ido way.
When `ido-everywhere' is non-nil, the commands in this list will read
the file name using normal `read-file-name' style." :type '(repeat symbol) :group 'ido)

(defcustom ido-before-fallback-functions 'nil "\
List of functions to call before calling a fallback command.
The fallback command is passed as an argument to the functions." :type 'hook :group 'ido)

;;;***

;;;### (autoloads (info-lookup-file-name-alist info-lookup-highlight-face info-lookup-other-window-flag info-lookup) "info-look" "edit-utils/info-look.el")
(defconst custom-define-current-source-file "info-look.el")

(defgroup info-lookup nil "Major mode sensitive help agent." :group 'help :group 'languages)

(defcustom info-lookup-other-window-flag t "\
Non-nil means pop up the Info buffer in another window." :group 'info-lookup :type 'boolean)

(defcustom info-lookup-highlight-face 'highlight "\
Face for highlighting looked up help items.
Setting this variable to nil disables highlighting." :group 'info-lookup :type 'face)

(defcustom info-lookup-file-name-alist '(("\\`configure\\.in\\'" . autoconf-mode) ("\\`ac\\(local\\|site\\|include\\)\\.m4\\'" . autoconf-mode)) "\
Alist of file names handled specially.
List elements are cons cells of the form

    (REGEXP . MODE)

If a file name matches REGEXP, then use help mode MODE instead of the
buffer's major mode." :group 'info-lookup :type '(repeat (cons (string :tag "Regexp") (symbol :tag "Mode"))))

;;;***

;;;### (autoloads (iswitchb-minibuffer-setup-hook iswitchb-make-buflist-hook iswitchb-use-fonts iswitchb-define-mode-map-hook iswitchb-prompt-newbuffer iswitchb-newbuffer iswitchb-regexp iswitchb-default-method iswitchb-buffer-ignore iswitchb-case iswitchb) "iswitchb" "edit-utils/iswitchb.el")
(defconst custom-define-current-source-file "iswitchb.el")

(defgroup iswitchb nil "Switch between buffers using substrings." :group 'extensions :link '(emacs-commentary-link :tag "Commentary" "iswitchb.el") :link '(emacs-library-link :tag "Lisp File" "iswitchb.el"))

(defcustom iswitchb-case case-fold-search "\
*Non-nil if searching of buffer names should ignore case." :type 'boolean :group 'iswitchb)

(defcustom iswitchb-buffer-ignore '("^ ") "\
*List of regexps or functions matching buffer names to ignore.
For example, traditional behavior is not to list buffers whose names begin
with a space, for which the regexp is `^ '.  See the source file for
example functions that filter buffernames." :type '(repeat regexp) :group 'iswitchb)

(defcustom iswitchb-default-method 'always-frame "\
*How to switch to new buffer when using `iswitchb-buffer'.
Possible values:
`samewindow'	Show new buffer in same window
`otherwindow'	Show new buffer in another window (same frame)
`display'	Display buffer in another window without switching to it
`otherframe'	Show new buffer in another frame
`maybe-frame'	If a buffer is visible in another frame, prompt to ask if you
		you want to see the buffer in the same window of the current
  		frame or in the other frame.
`always-frame'  If a buffer is visible in another frame, raise that
		frame.  Otherwise, visit the buffer in the same window." :type '(choice (const samewindow) (const otherwindow) (const display) (const otherframe) (const maybe-frame) (const always-frame)) :group 'iswitchb)

(defcustom iswitchb-regexp nil "\
*Non-nil means that `iswitchb' will do regexp matching.
Value can be toggled within `iswitchb' using `iswitchb-toggle-regexp'." :type 'boolean :group 'iswitchb)

(defcustom iswitchb-newbuffer t "\
*Non-nil means create new buffer if no buffer matches substring.
See also `iswitchb-prompt-newbuffer'." :type 'boolean :group 'iswitchb)

(defcustom iswitchb-prompt-newbuffer t "\
*Non-nil means prompt user to confirm before creating new buffer.
See also `iswitchb-newbuffer'." :type 'boolean :group 'iswitchb)

(defcustom iswitchb-define-mode-map-hook nil "\
*Hook to define keys in `iswitchb-mode-map' for extra keybindings." :type 'hook :group 'iswitchb)

(defcustom iswitchb-use-fonts t "\
*Non-nil means use font-lock fonts for showing first match." :type 'boolean :group 'iswitchb)

(defcustom iswitchb-make-buflist-hook nil "\
*Hook to run when list of matching buffers is created." :type 'hook :group 'iswitchb)

(defcustom iswitchb-minibuffer-setup-hook nil "\
*Iswitchb-specific customization of minibuffer setup.

This hook is run during minibuffer setup iff `iswitchb' will be active.
It is intended for use in customizing iswitchb for interoperation
with other packages.  For instance:

  (add-hook 'iswitchb-minibuffer-setup-hook 
	    (function
	     (lambda ()
	       (make-local-variable 'resize-minibuffer-window-max-height)
	       (setq resize-minibuffer-window-max-height 3))))

will constrain rsz-mini to a maximum minibuffer height of 3 lines when
iswitchb is running.  Copied from `icomplete-minibuffer-setup-hook'." :type 'hook :group 'iswitchb)

;;;***

;;;### (autoloads (lazy-lock-mode-line-string lazy-lock-walk-windows lazy-lock-stealth-verbose lazy-lock-stealth-nice lazy-lock-stealth-load lazy-lock-stealth-lines lazy-lock-stealth-time lazy-lock-defer-time lazy-lock-defer-contextually lazy-lock-defer-on-the-fly lazy-lock-minimum-size lazy-lock-mode lazy-lock) "lazy-lock" "edit-utils/lazy-lock.el")
(defconst custom-define-current-source-file "lazy-lock.el")

(defgroup lazy-lock nil "Lazy-lock customizations" :group 'font-lock :prefix "lazy-lock-")

(defcustom lazy-lock-mode nil "\
Non nil means `lazy-lock-mode' is on." :group 'lazy-lock :require 'lazy-lock :type 'boolean :initialize 'custom-initialize-default :set '(lambda (var val) (if val (progn (lazy-lock-mode 1) (add-hook 'font-lock-mode-hook 'turn-on-lazy-lock)) (lazy-lock-mode -1) (remove-hook 'font-lock-mode-hook 'turn-on-lazy-lock))))

(defcustom lazy-lock-minimum-size 25600 "\
*Minimum size of a buffer for demand-driven fontification.
On-demand fontification occurs if the buffer size is greater than this value.
If nil, means demand-driven fontification is never performed.
If a list, each element should be a cons pair of the form (MAJOR-MODE . SIZE),
where MAJOR-MODE is a symbol or t (meaning the default).  For example:
 ((c-mode . 25600) (c++-mode . 25600) (rmail-mode . 1048576))
means that the minimum size is 25K for buffers in C or C++ modes, one megabyte
for buffers in Rmail mode, and size is irrelevant otherwise.

The value of this variable is used when Lazy Lock mode is turned on." :type '(choice (const :tag "none" nil) (integer :tag "size") (repeat :menu-tag "mode specific" :tag "mode specific" :value ((t)) (cons :tag "Instance" (radio :tag "Mode" (const :tag "all" t) (symbol :tag "name")) (radio :tag "Size" (const :tag "none" nil) (integer :tag "size"))))) :group 'lazy-lock)

(defcustom lazy-lock-defer-on-the-fly nil "\
*If non-nil, means fontification after a change should be deferred.
If nil, means on-the-fly fontification is performed.  This means when changes
occur in the buffer, those areas are immediately fontified.
If a list, it should be a list of `major-mode' symbol names for which deferred
fontification should occur.  The sense of the list is negated if it begins with
`not'.  For example:
 (c-mode c++-mode)
means that on-the-fly fontification is deferred for buffers in C and C++ modes
only, and deferral does not occur otherwise.

NOTE: Not currently implemented in this version of lazy-lock.

The value of this variable is used when Lazy Lock mode is turned on." :type '(choice (const :tag "never" nil) (const :tag "always" t) (set :menu-tag "mode specific" :tag "modes" :value (not) (const :tag "Except" not) (repeat :inline t (symbol :tag "mode")))) :group 'lazy-lock)

(defcustom lazy-lock-defer-contextually 'syntax-driven "\
*If non-nil, means deferred fontification should be syntactically true.
If nil, means deferred fontification occurs only on those lines modified.  This
means where modification on a line causes syntactic change on subsequent lines,
those subsequent lines are not refontified to reflect their new context.
If t, means deferred fontification occurs on those lines modified and all
subsequent lines.  This means those subsequent lines are refontified to reflect
their new syntactic context, either immediately or when scrolling into them.
If any other value, e.g., `syntax-driven', means deferred syntactically true
fontification occurs only if syntactic fontification is performed using the
buffer mode's syntax table, i.e., only if `font-lock-keywords-only' is nil.

The value of this variable is used when Lazy Lock mode is turned on." :type '(choice (const :tag "never" nil) (const :tag "always" t) (other :tag "syntax-driven" syntax-driven)) :group 'lazy-lock)

(defcustom lazy-lock-defer-time (if (featurep 'lisp-float-type) (/ (float 1) (float 4)) 1) "\
*Time in seconds to delay before beginning deferred fontification.
Deferred fontification occurs if there is no input within this time.
If nil, means fontification is never deferred, regardless of the values of the
variables `lazy-lock-defer-on-the-fly' and `lazy-lock-defer-contextually'.

The value of this variable is used when Lazy Lock mode is turned on." :type '(choice (const :tag "never" nil) (number :tag "seconds")) :group 'lazy-lock)

(defcustom lazy-lock-stealth-time nil "\
*Time in seconds to delay before beginning stealth fontification.
Stealth fontification occurs if there is no input within this time.
If nil, means stealth fontification is never performed.

The value of this variable is used when Lazy Lock mode is turned on." :type '(choice (const :tag "never" nil) (number :tag "seconds")) :group 'lazy-lock)

(defcustom lazy-lock-stealth-lines (if font-lock-maximum-decoration 100 250) "\
*Maximum size of a chunk of stealth fontification.
Each iteration of stealth fontification can fontify this number of lines.
To speed up input response during stealth fontification, at the cost of stealth
taking longer to fontify, you could reduce the value of this variable." :type '(integer :tag "lines") :group 'lazy-lock)

(defcustom lazy-lock-stealth-load (if (condition-case nil (load-average) (error)) 200) "\
*Load in percentage above which stealth fontification is suspended.
Stealth fontification pauses when the system short-term load average (as
returned by the function `load-average' if supported) goes above this level,
thus reducing the demand that stealth fontification makes on the system.
If nil, means stealth fontification is never suspended.
To reduce machine load during stealth fontification, at the cost of stealth
taking longer to fontify, you could reduce the value of this variable.
See also `lazy-lock-stealth-nice'." :type (if (condition-case nil (load-average) (error)) '(choice (const :tag "never" nil) (integer :tag "load")) '(const :format "%t: unsupported
" nil)) :group 'lazy-lock)

(defcustom lazy-lock-stealth-nice (if (featurep 'lisp-float-type) (/ (float 1) (float 8)) 1) "\
*Time in seconds to pause between chunks of stealth fontification.
Each iteration of stealth fontification is separated by this amount of time,
thus reducing the demand that stealth fontification makes on the system.
If nil, means stealth fontification is never paused.
To reduce machine load during stealth fontification, at the cost of stealth
taking longer to fontify, you could increase the value of this variable.
See also `lazy-lock-stealth-load'." :type '(choice (const :tag "never" nil) (number :tag "seconds")) :group 'lazy-lock)

(defcustom lazy-lock-stealth-verbose (if (featurep 'lisp-float-type) (and (not lazy-lock-defer-contextually) (not (null font-lock-verbose)))) "\
*If non-nil, means stealth fontification should show status messages." :type 'boolean :group 'lazy-lock)

(defcustom lazy-lock-walk-windows 'all-frames "\
*If non-nil, fontify windows other than the selected window.
If `all-frames', fontify windows even on other frames.
A non-nil value slows down redisplay." :type 'boolean :group 'lazy-lock)

(defcustom lazy-lock-mode-line-string nil "\
*String to display in the modeline when `lazy-lock-mode' is active.
Set this to nil if you don't want a modeline indicator." :type '(choice string (const :tag "none" nil)) :group 'lazy-lock)

;;;***

;;;### (autoloads (lazy-shot-stealth-verbose lazy-shot-verbose lazy-shot-stealth-nice lazy-shot-stealth-lines lazy-shot-stealth-time lazy-shot-step-size lazy-shot-minimum-size lazy-shot-mode lazy-shot) "lazy-shot" "edit-utils/lazy-shot.el")
(defconst custom-define-current-source-file "lazy-shot.el")

(defgroup lazy-shot nil "Lazy-shot customizations" :group 'tools :group 'faces :prefix "lazy-shot-")

(defcustom lazy-shot-mode nil "\
Non nil means `lazy-shot-mode' is on." :group 'lazy-shot :require 'lazy-shot :type 'boolean :initialize 'custom-initialize-default :set '(lambda (var val) (if val (progn (lazy-shot-mode 1) (add-hook 'font-lock-mode-hook 'turn-on-lazy-shot)) (lazy-shot-mode -1) (remove-hook 'font-lock-mode-hook 'turn-on-lazy-shot)) (setq-default lazy-shot-mode val)))

(defcustom lazy-shot-minimum-size 0 "\
*Minimum size of a buffer for demand-driven fontification.
On-demand fontification occurs if the buffer size is greater than this value.
If nil, means demand-driven fontification is never performed." :type '(choice (const :tag "Off" nil) (integer :tag "Size")) :group 'lazy-shot)

(defcustom lazy-shot-step-size 1024 "\
Minimum size of each fontification shot." :type 'integer :group 'lazy-shot)

(defcustom lazy-shot-stealth-time 30 "\
*Time in seconds to delay before beginning stealth fontification.
Stealth fontification occurs if there is no input within this time.
If nil, means stealth fontification is never performed.

The value of this variable is used when Lazy Shot mode is turned on." :type '(choice (const :tag "Off" nil) (number :tag "Time")) :group 'lazy-shot)

(defcustom lazy-shot-stealth-lines (if font-lock-maximum-decoration 100 250) "\
*Maximum size of a chunk of stealth fontification.
Each iteration of stealth fontification can fontify this number of lines.
To speed up input response during stealth fontification, at the cost of stealth
taking longer to fontify, you could reduce the value of this variable." :type 'integer :group 'lazy-shot)

(defcustom lazy-shot-stealth-nice (/ (float 1) (float 8)) "\
*Time in seconds to pause between chunks of stealth fontification.
Each iteration of stealth fontification is separated by this amount of time.
To reduce machine load during stealth fontification, at the cost of stealth
taking longer to fontify, you could increase the value of this variable." :type 'number :group 'lazy-shot)

(defcustom lazy-shot-verbose (not (null font-lock-verbose)) "\
*If non-nil, means demand fontification should show status messages." :type 'boolean :group 'lazy-shot)

(defcustom lazy-shot-stealth-verbose (not (null lazy-shot-verbose)) "\
*If non-nil, means stealth fontification should show status messages." :type 'boolean :group 'lazy-shot)

;;;***

;;;### (autoloads (Manual-use-rosetta-man Manual-snip-subchapter Manual-mode-hook Manual-switches Manual-buffer-view-mode Manual-program man) "man" "edit-utils/man.el")
(defconst custom-define-current-source-file "man.el")

(defgroup man nil "Browse Unix manual pages" :group 'help)

(defcustom Manual-program "man" "\
*Name of the program to invoke in order to format the source man pages." :type 'string :group 'man)

(defcustom Manual-buffer-view-mode t "\
*Whether manual buffers should be placed in view-mode.
nil means leave the buffer in fundamental-mode in another window.
t means use `view-buffer' to display the man page in the current window.
Any other value means use `view-buffer-other-window'." :type '(radio (const :tag "Fundamental-mode other window" nil) (const :tag "View-mode current window" t) (sexp :format "%t
" :tag "View-mode other window" other)) :group 'man)

(defcustom Manual-switches nil "\
List of switches to the man program." :type '(choice (const :tag "none" nil) (repeat (string :tag "switch"))) :group 'man)

(defcustom Manual-mode-hook nil "\
Function or functions run on entry to Manual-mode." :type 'hook :group 'man)

(defcustom Manual-snip-subchapter (not (string-match "solaris" system-configuration)) "\
*Should man look in chapter 3 for ctime(3c)?
This is relevant for Solaris and, perhaps, other systems which have
`man -s 3' not find things in chapter 3c, or other such sub-chapters" :type 'boolean :group 'man)

(defcustom Manual-use-rosetta-man (locate-file "rman" exec-path) "\
If non-nil, use RosettaMan (rman) to filter man pages.
This makes man-page cleanup virtually instantaneous, instead of
potentially taking a long time." :type '(choice (symbol :tag "Do not use Rosettaman" nil) (file :tag "RosettaMan Programm")) :group 'man)

;;;***

;;;### (autoloads (paren-no-match-face paren-mismatch-face paren-match-face paren-bind-modified-sexp-functions paren-dont-load-timer paren-dont-touch-blink paren-delay paren-ding-unmatched paren-message-truncate-lines paren-message-no-match paren-message-show-linenumber paren-message-linefeed-display paren-display-message paren-highlight-offscreen paren-highlight-at-point paren-sexp-mode paren-overlay-priority paren-priority mic-paren-matching) "mic-paren" "edit-utils/mic-paren.el")
(defconst custom-define-current-source-file "mic-paren.el")

(defgroup mic-paren-matching nil "Showing advanced (un)matching of parens and expressions." :prefix "paren-" :group 'paren-matching)

(defcustom paren-priority 'both "\
*Defines the behaviour of mic-paren when point is between a
closing and an opening parenthesis. This means what should be done in a
situation like this: (a b)(c d)
                           ^
                         point
- 'close means highlight the parenthesis matching the close-parenthesis
  before the point (highlight opening paren before 'a').
- 'open means highlight the parenthesis matching the open-parenthesis after
  the point (highlight closing paren after 'd').
- 'both means highlight both parenthesis matching the parenthesis beside
  the point (highlight opening before 'a' and closing after 'd')." :type '(choice (const :tag "Match close" close) (const :tag "Match open" open) (const :tag "Match both" both)) :group 'mic-paren-matching)

(defcustom paren-overlay-priority 999 "\
*Specify paren overlay priority (Integer >= 0). For a description of the
priority of an overlay see in the emacs-lisp manual the node Overlays.
Normally you don't want to change the default-value!" :set (function (lambda (symbol value) (set symbol (if (< value 0) (* -1 value) value)))) :initialize 'custom-initialize-default :type 'integer :group 'mic-paren-matching)

(defcustom paren-sexp-mode nil "\
*Defines in which situations the whole sexp should be highlighted.
This means the whole s-expression between the matching parenthesis is
highlighted instead of only the matching/mismatching parenthesis.

- t: Always highlight the whole s-expression.
- nil: Never highlight the whole s-expression.
- 'match: Highlight the whole s-expression only if the parens match.
- 'mismatch: Highlight the whole s-expression only if the parens don't match." :type '(choice (const :tag "Never sexp-mode" nil) (const :tag "Always sexp-mode" t) (const :tag "If match" match) (const :tag "If mismatch" mismatch)) :group 'mic-paren-matching)

(defcustom paren-highlight-at-point t "\
*If non-nil and point is after a close parenthesis, both the close
and open parenthesis is highlighted. If nil, only the open parenthesis is
highlighted." :type '(choice (const :tag "Highlight both" t) (const :tag "Highlight open" nil)) :group 'mic-paren-matching)

(defcustom paren-highlight-offscreen nil "\
*If non-nil mic-paren will highlight text which is not visible in the
current buffer.

This is useful if you regularly display the current buffer in multiple
windows or frames. For instance if you use follow-mode (by
andersl@csd.uu.se), however it may slow down your Emacs.

\(This variable is ignored (treated as non-nil) if you set paren-sexp-mode to
non-nil.)" :type 'boolean :group 'mic-paren-matching)

(defcustom paren-display-message 'only "\
*Display message if matching parenthesis is off-screen.
Possible settings are:
- 'always: message is always displayed regardless if offscreen or not
- 'only:   message is only displayed when matching is offscreen
- 'never:  never a message is displayed." :type '(choice (const :tag "Display always" always) (const :tag "Display if offscreen" only) (const :tag "No Message display" never)) :group 'mic-paren-matching)

(defcustom paren-message-linefeed-display " RET " "\
*How a linefeed in the matching paren context message is displayed.
There are three predefined values:
- Displays linefeeds with \" RET \" in the message.
- Displays linefeeds with a SPACE in the message.
- Displays linefeeds in the standard-form, means with \"^J\".
But you can also specify any user-defined string for it.

For further explanations about message displaying look at
`paren-display-message'." :type '(choice (const :tag "Display with \"RET\"" :value " RET ") (const :tag "Display with a SPACE" :value " ") (const :tag "Standard" :value "^J") (string :tag "User defined")) :group 'mic-paren-matching)

(defcustom paren-message-show-linenumber 'sexp "\
*Determine the computation of the offscreen-message-linenumber.
If the matching paren is offscreen, then maybe a message with the context of
the matching paren and its linenumber is displayed (depends on the setting
in `paren-display-message'). Here the computation of the linenumber can be
determined:
- 'sexp: Display the number of lines between the matching parens. Then the
         number of lines is displayed as negativ number if the matching paren
         is somewhere above. Otherwise the number has a positive sign.
- 'absolute: Display the absolute linenumber of the machting paren computed
             from the beginning of the buffer." :type '(choice (const :tag "Count accros sexp" sexp) (const :tag "Absolute number" absolute)) :group 'mic-paren-matching)

(defcustom paren-message-no-match t "\
*Display message if no matching parenthesis is found." :type '(choice (const :tag "Display message" t) (const :tag "No message" nil)) :group 'mic-paren-matching)

(defcustom paren-message-truncate-lines t "\
*Non nil means truncate lines for all messages mic-paren can display.
This option has only an effect with GNU Emacs 21.x!" :type 'boolean :group 'mic-paren-matching)

(defcustom paren-ding-unmatched nil "\
*Non nil means make noise if the cursor is at an unmatched
parenthesis or no matching parenthesis is found.
Even if nil, typing an unmatched parenthesis produces a ding." :type 'boolean :group 'mic-paren-matching)

(defcustom paren-delay nil "\
*This variable controls when highlighting is done.
The variable has different meaning in different versions of Emacs.

In Emacs 19.29 and below:
  This variable is ignored.

In Emacs 19.30:
  A value of nil will make highlighting happen immediately (this may slow
  down your Emacs if running on a slow system). Any non-nil value will
  delay highlighting for the time specified by post-command-idle-delay.

In Emacs 19.31 and above:
  A value of nil will make highlighting happen immediately (this may slow
  down your Emacs if running on a slow system). If not nil, the value
  should be a number (possible a floating point number if your Emacs
  support floating point numbers). The number is the delay in seconds
  before mic-paren performs highlighting.

If you change this variable when mic-paren is active you have to
re-activate (with M-x paren-activate) mic-paren for the change to take
effect." :type '(choice (number :tag "Delay time") (const :tag "No delay" nil)) :group 'mic-paren-matching)

(defcustom paren-dont-touch-blink nil "\
*Non-nil means not to change the value of blink-matching-paren
when mic-paren is activated of deactivated.
If nil mic-paren turns of blinking when activated and turns on blinking when
deactivated." :type 'boolean :group 'mic-paren-matching)

(defcustom paren-dont-load-timer (not (string-match "XEmacs\\|Lucid" emacs-version)) "\
*If non-nil mic-paren will not try to load the timer-feature when
loaded.

\(I have no idea why Emacs user ever want to set this to non-nil but I hate
packages which loads/activates stuff I don't want to use so I provide this
way to prevent the loading if someone doesn't want timers to be loaded.)" :type 'boolean :group 'mic-paren-matching)

(defcustom paren-bind-modified-sexp-functions t "\
*Automatic binding of the new sexp-functions to the old bindings.
If non nil mic-paren checks at load-time the keybindings for the functions
`forward-sexp' and `backward-sexp' and binds the modified sexp-functions
`paren-forward-sexp' and `paren-backward-sexp' to exactly these
bindings if and only if matching quoted/escaped parens is turned on by
`paren-toggle-matching-quoted-paren'. These new binding is done only
for the buffer local-key-map, therefore if you activate the quoted matching
only in some modes from within a hook only in these buffers the new binding
is active and 'in all other not.
If you deactivate the quoted matching feature by
`paren-toggle-matching-quoted-paren' then `forward-sexp' and
`backward-sexp' will be bound again to their original key-bindings!" :type 'boolean :group 'mic-paren-matching)

(defcustom paren-match-face 'paren-face-match "\
*Face to use for showing the matching parenthesis." :type 'face :group 'mic-paren-matching)

(defcustom paren-mismatch-face 'paren-face-mismatch "\
*Face to use when highlighting a mismatched parenthesis." :type 'face :group 'mic-paren-matching)

(defcustom paren-no-match-face 'paren-face-no-match "\
*Face to use when highlighting an unmatched parenthesis." :type 'face :group 'mic-paren-matching)

;;;***

;;;### (autoloads (outline-scanning-message outline-move-point-after-click outline-sync-with-func-menu outline-glyph-lit-colour outline-glyph-shade-colour outline-glyph-colour outline-glyphs-on-left outline-mac-style outl-mouse) "outl-mouse" "edit-utils/outl-mouse.el")
(defconst custom-define-current-source-file "outl-mouse.el")

(defgroup outl-mouse nil "Outline mouse mode commands for Emacs" :prefix "outline-" :group 'outlines :group 'mouse)

(defcustom outline-mac-style nil "\
*If t then outline glyphs will be right and down arrows." :type 'boolean :group 'outl-mouse)

(defcustom outline-glyphs-on-left t "\
*The position of outline glyphs on a line.
Note: This setting is currently being ignored:
The outline glyphs are always on the left." :type 'boolean :group 'outl-mouse)

(defcustom outline-glyph-colour "Gray75" "\
*The colour of outlining arrows." :type 'color :group 'outl-mouse)

(defcustom outline-glyph-shade-colour "Gray40" "\
*The shadow colour of outlining arrows." :type 'color :group 'outl-mouse)

(defcustom outline-glyph-lit-colour "Gray90" "\
*The lit colour of outlining arrows." :type 'color :group 'outl-mouse)

(defcustom outline-sync-with-func-menu nil "\
*If t then outline glyphs are permanently added by func-menu scans.
If outline-minor-mode is turned off then turning it back on will have
no effect. Instead the buffer should be rescanned from the function
menu." :type 'boolean :group 'outl-mouse)

(defcustom outline-move-point-after-click t "\
*If t then point is moved to the current heading when clicked." :type 'boolean :group 'outl-mouse)

(defcustom outline-scanning-message "Adding glyphs... (%3d%%)" "\
*Progress message during the scanning of the buffer.
Set this to nil to inhibit progress messages." :type 'string :group 'outl-mouse)

;;;***

;;;### (autoloads (pages-directory-for-adding-addresses-narrowing-p pages-directory-for-addresses-buffer-keep-windows-p pages-directory-for-addresses-goto-narrowing-p pages-addresses-file-name pages-directory-for-adding-new-page-before-current-page-p pages-directory-for-adding-page-narrowing-p pages-directory-buffer-narrowing-p pages) "page-ext" "edit-utils/page-ext.el")
(defconst custom-define-current-source-file "page-ext.el")

(defgroup pages nil "Extended page-handling commands." :group 'extensions)

(defcustom pages-directory-buffer-narrowing-p t "\
*If non-nil, `pages-directory-goto' narrows pages buffer to entry." :type 'boolean :group 'pages)

(defcustom pages-directory-for-adding-page-narrowing-p t "\
*If non-nil, `add-new-page' narrows page buffer to new entry." :type 'boolean :group 'pages)

(defcustom pages-directory-for-adding-new-page-before-current-page-p t "\
*If non-nil, `add-new-page' inserts new page before current page." :type 'boolean :group 'pages)

(defcustom pages-addresses-file-name "~/addresses" "\
*Standard name for file of addresses. Entries separated by page-delimiter.
Used by `pages-directory-for-addresses' function." :type 'file :group 'pages)

(defcustom pages-directory-for-addresses-goto-narrowing-p t "\
*If non-nil, `pages-directory-goto' narrows addresses buffer to entry." :type 'boolean :group 'pages)

(defcustom pages-directory-for-addresses-buffer-keep-windows-p t "\
*If nil, `pages-directory-for-addresses' deletes other windows." :type 'boolean :group 'pages)

(defcustom pages-directory-for-adding-addresses-narrowing-p t "\
*If non-nil, `add-new-page' narrows addresses buffer to new entry." :type 'boolean :group 'pages)

;;;***

;;;### (autoloads (paren-max-blinks paren-blink-interval paren-backwards-message paren-ding-unmatched paren-message-offscreen paren-mode paren-matching) "paren" "edit-utils/paren.el")
(defconst custom-define-current-source-file "paren.el")

(defgroup paren-matching nil "Highlight (un)matching of parens and expressions." :prefix "paren-" :group 'matching)

(defcustom paren-mode nil "\
*Sets the style of parenthesis highlighting.
Valid values are nil, `blink-paren', `paren', and `sexp'.
  nil		no parenthesis highlighting.
  blink-paren	causes the matching paren to blink.
  paren		causes the matching paren to be highlighted but not to blink.
  sexp		whole expression enclosed by the local paren at its mate.
  sexp-surround whole surrounding expression, even if point is not at paren.
  nested	(not yet implemented) use variable shading to see the
		nesting of an expression.  Also groks regular expressions
		and shell quoting.

This variable is global by default, but you can make it buffer-local and
highlight parentheses differently in different major modes." :type '(radio (const :tag "None (default)" nil) (const :tag "Blinking Paren" blink-paren) (const :tag "Highlighted Paren" paren) (const :tag "Highlighted Expression" sexp) (const :tag "Highlighted Surrounding Expression" sexp-surround)) :set (lambda (symbol value) (paren-set-mode value)) :initialize 'custom-initialize-default :require 'paren :group 'paren-matching)

(defcustom paren-message-offscreen t "\
*Non-nil means display a message if matching open paren is offscreen." :type 'boolean :group 'paren-matching)

(defcustom paren-ding-unmatched nil "\
*Make noise if the cursor is at an unmatched paren.

If t, then typing or passing over an unmatched paren will ring the bell
using the `paren' sound.  If nil, then the bell will not ring even if an
unmatched paren is typed.  If neither t nor nil, then the bell will not ring
when the cursor moves over unmatched parens but will ring if one is typed." :type '(choice (const :tag "off" nil) (const :tag "on" t) (const :tag "other" other)) :group 'paren-matching)

(defcustom paren-backwards-message nil "\
*Control what context is reported when a matching paren is offscreen.

If nil, the matching paren and the following context is reported;
if non-nil, the matching paren and the previous context.

This variable should normally be set in a language major mode hook as
appropriate for the syntax of a program in that language." :type 'boolean :group 'paren-matching)

(defcustom paren-blink-interval 0.2 "\
*If the cursor is on a parenthesis, the matching parenthesis will blink.
This variable controls how long each phase of the blink lasts in seconds.
This should be a fractional part of a second (a float.)" :type 'number :group 'paren-matching)

(defcustom paren-max-blinks (* 5 60 5) "\
*Maximum number of times that a matching parenthesis will blink.
Set this to NIL if you want indefinite blinking." :type '(choice (const nil) number) :group 'paren-matching)

;;;***

;;;### (autoloads (permanent-buffers-mode permanent-buffers-alist permanent-buffers) "permanent-buffers" "edit-utils/permanent-buffers.el")
(defconst custom-define-current-source-file "permanent-buffers.el")

(defgroup permanent-buffers nil "Permanent Buffers Management." :group 'editing)

(defcustom permanent-buffers-alist '(("*scratch*" (lisp-interaction-mode)) ("*text*" (text-mode))) "\
*An alist of permanent buffers. See `permanent-buffers-mode' for more
details on what a permanent buffer is.
Each element looks like (NAME FORM ...) where NAME is the name of the
buffer, and FORMs are lisp expressions to be executed when the buffer
is regenerated (this buffer will be current when evaluating the
expressions)." :group 'permanent-buffers :type '(repeat (cons :tag "Permanent buffer" (string :tag "Buffer name") (repeat :tag "Forms to execute" (sexp :tag "")))))

(defcustom permanent-buffers-mode nil "\
Indicates whether the `permanent-buffers' behavior is active. You can
customize this variable to change the default value. To change the value
during an XEmacs session, please use the function instead." :type 'boolean :set (lambda (sym val) (permanent-buffers-mode (if val 1 -1))) :initialize 'custom-initialize-default :require 'permanent-buffers :group 'permanent-buffers)

;;;***

;;;### (autoloads (popper-fix-incompatible-settings popper-inhibit-warnings popper-use-pixel-heights popper-delete-window-can-delete-frame popper-split-preserve-popper-size popper-mode-line-text popper-max-heights popper-min-heights popper-empty-min popper-scroll-buffers popper-eat-newlines popper-buffers-no-skip popper-buffers-to-skip popper-no-pop-buffers popper-pop-buffers popper-context-lines popper-use-message-buffer popper-prefix popper-load-hook popper-install-when-load popper) "popper" "edit-utils/popper.el")
(defconst custom-define-current-source-file "popper.el")

(defgroup popper nil "Shrink wrapped display of temporary pop-up buffers." :group 'environment)

(defcustom popper-install-when-load nil "\
*If non-nil, install popper when it is loaded.
If this variable is set and saved with M-x customize-variable, popper
will be loaded and initialized automatically when emacs is started." :type 'boolean :require 'popper :group 'popper)

(defcustom popper-load-hook nil "\
*List of functions to run when the popper module is loaded, but prior
to popper installation.  This is a good place to change any options." :type 'hook :group 'popper)

(defcustom popper-prefix "" "\
*If non-nil, where to install the popper prefix keymap" :type '(choice (const :tag "No binding" nil) (sexp :tag "Binding")) :group 'popper)

(defcustom popper-use-message-buffer nil "\
*If non-nil makes output to popper-buffers that is one line or less
go to the minibuffer." :type 'boolean :group 'popper)

(defcustom popper-context-lines 1 "\
*Number of lines of context to keep above point when popper is shown.
Usually when the popper window is displayed, the parent window's
start position is adjusted to minimize the display jump.  This
variable specifies how many lines of context to keep visible when
the window must be scrolled to keep point visible." :type 'integer :group 'popper)

(defcustom popper-pop-buffers t "\
*List of buffers to put in the shrink-wrapped pop-up window.  
If it is T, all temporary buffers will be put in the pop-up window." :type '(choice (const :tag "All" t) (const :tag "None" nil) (repeat :tag "Buffer list" (regexp :tag "Buffer regexp"))) :group 'popper)

(defcustom popper-no-pop-buffers nil "\
*If popper-pop-buffers is T, these buffers will not be put into the
pop-up window." :type '(choice (const :tag "None" nil) (repeat :tag "Buffer list" (regexp :tag "Buffer regexp"))) :group 'popper)

(defcustom popper-buffers-to-skip popper-pop-buffers "\
*\\[popper-other-window] will skip over these buffers when they are
used in a temporary window.  If it is T, all popper windows will be
skipped except those in popper-buffers-no-skip." :type '(choice (const :tag "All" t) (const :tag "None" nil) (repeat :tag "Buffer list" (regexp :tag "Buffer regexp"))) :group 'popper)

(defcustom popper-buffers-no-skip nil "\
*\\[popper-other-window] will not skip these buffers when they are
used in a popper window if popper-buffers-to-skip is T." :type '(choice (const :tag "None" nil) (repeat :tag "Buffer list" (regexp :tag "Buffer regexp"))) :group 'popper)

(defcustom popper-eat-newlines t "\
*Boolean for eating trailing newlines in popper buffers." :type 'boolean :group 'popper)

(defcustom popper-scroll-buffers t "\
*If set to T or a list of buffer names, cause buffers with
associated processes to scroll automatically." :type '(choice (const :tag "All" t) (repeat :tag "Buffer list" (regexp :tag "Buffer regexp"))) :group 'popper)

(defcustom popper-empty-min (max 1 (1- window-min-height)) "\
*Minimum number of lines to display for an empty popper buffer.
If it is a list, it is a percentage 0-100 of the available space." :type '(choice (integer :tag "Lines") (list :tag "Percent" (integer))) :group 'popper)

(defcustom popper-min-heights nil "\
*List of cons where each car is a regular expression pattern to
match a buffer name and the cdr is the minimum number of lines to
allow when popping buffers that match the regular expression.  If the
number is a list, it is interpreted as the percentage of available
space 0-100 to use for the window." :type '(choice (const :tag "None" nil) (repeat (cons (regexp :tag "Buffer regexp") (choice (integer :tag "Lines") (list :tag "Percent" (integer)))))) :group 'popper)

(defcustom popper-max-heights nil "\
*List of cons where each car is a regular expression pattern to
match a buffer name and the cdr is the maximum number of lines to
allow when popping up buffers that match the regular expression.  If the
number is a list, it is interpreted as the percentage of available
space 0-100 to use for the window." :type '(choice (const :tag "None" nil) (repeat (cons (regexp :tag "Buffer regexp") (choice (integer :tag "Lines") (list :tag "Percent" (integer)))))) :group 'popper)

(defcustom popper-mode-line-text nil "\
*Minor mode text for mode line of popper buffers.  If nil, it will
be set to a short help message on first use of popper." :type '(choice (const :tag "Default" nil) (string :tag "Text")) :group 'popper)

(defcustom popper-split-preserve-popper-size nil "\
*When non-nil, split-window from the popper parent window should
preserve the pop up window's height." :type 'boolean :group 'popper)

(defcustom popper-delete-window-can-delete-frame t "\
*When non-nil, `popper-delete-window' will behave like `delete-window'
and when deleting the last window on a frame also delete that frame.
When nil, an attempt to delete the last window on a frame is ignored." :type 'boolean :group 'popper)

(defcustom popper-use-pixel-heights (and (fboundp 'window-pixel-height) (fboundp 'window-text-area-pixel-height) (fboundp 'enlarge-window-pixels) (fboundp 'window-displayed-text-pixel-height) (fboundp 'vertical-motion-pixels) (let ((func (symbol-function 'vertical-motion))) (and (subrp func) (> (subr-max-args func) 2)))) "\
*Boolean indicating whether popper should perform pixel level
window height adjustments." :type 'boolean :group 'popper)

(defcustom popper-inhibit-warnings nil "\
*When non-nil, popper checks the settings of certain Emacs user
variables that might adversely affect popper." :type 'boolean :group 'popper)

(defcustom popper-fix-incompatible-settings nil "\
*When non-nil, if popper finds settings of certain Emacs user
variables that might adversely affect popper it sets them appropriately." :type 'boolean :group 'popper)

;;;***

;;;### (autoloads (power-macros-verbose-on-load power-macros-run-on-end-macro power-macros-save-on-change power-macros-file power-macros) "power-macros" "edit-utils/power-macros.el")
(defconst custom-define-current-source-file "power-macros.el")

(defgroup power-macros nil "Power Macros makes it much easier to work with macros.\nThe following features are the reason for that:\n- With power-macros you may bind a macro directly to a key after \n  having defined it.\n- With power-macros you may give your macros a description, which \n  makes it easier to maintain them.\n- With power-macros you may define macros as being global or \n  major-mode specific.\n- With power-macros your macros are automatically saved to your .emacs \n  file for later sessions." :group 'convenience)

(defcustom power-macros-file user-init-file "\
File in which new macros are saved by default.
If you change the file name to something different from `.emacs' then
you should insert the following line into your .emacs file:
\(load power-macros-file)
to ensure that macros are still loaded on startup." :type 'file :group 'power-macros)

(defcustom power-macros-save-on-change t "\
Non-nil means save macro to their files whenever a change is made.
That is, whenever a change is made in the macro-manage buffer." :type 'boolean :group 'power-macros)

(defcustom power-macros-run-on-end-macro t "\
Non-nil means that power-macros is executed upon macro definition.
When disabled you may invoke power-macros (that is `pm-define' to
be accurate) by pressing \\[pm-define]." :type 'boolean :group 'power-macros)

(defcustom power-macros-verbose-on-load t "\
Non-nil means that `pm-def-macro' will inform which macros are loaded." :type 'boolean :group 'power-macros)

;;;***

;;;### (autoloads (recent-files-include-save-now recent-files-find-file-command recent-files-permanent-first recent-files-actions-on-top recent-files-add-menu-before recent-files-menu-path recent-files-menu-title recent-files-commands-submenu-title recent-files-commands-submenu recent-files-non-permanent-submenu recent-files-permanent-submenu recent-files-sort-function recent-files-filename-replacements recent-files-use-full-names recent-files-dont-include recent-files-save-file recent-files-number-of-saved-entries recent-files-number-of-entries recent-files-menu recent-files) "recent-files" "edit-utils/recent-files.el")
(defconst custom-define-current-source-file "recent-files.el")

(defgroup recent-files nil "Maintain a menu of recently opened files." :group 'files :group 'menu)

(defgroup recent-files-menu nil "Menu options of recent-files." :prefix "recent-files-" :group 'recent-files)

(defcustom recent-files-number-of-entries 15 "\
*Maximum of non-permanent entries in the recent-files menu." :type 'integer :group 'recent-files)

(defcustom recent-files-number-of-saved-entries 50 "\
*Maximum of non-permanent entries saved to `recent-files-save-file'." :type 'integer :group 'recent-files)

(defcustom recent-files-save-file (expand-file-name "~/.recent-files.el") "\
*File to save the recent-files list in." :type 'file :group 'recent-files)

(defcustom recent-files-dont-include nil "\
*List of regexps for filenames *not* to keep in recent-files." :type '(repeat regexp) :group 'recent-files)

(defcustom recent-files-use-full-names t "\
*If non-nil, use the full pathname of a file in the recent-files menu.
Otherwise use only the filename part. The `recent-files-filename-replacements'
are not applied in the latter case." :type 'boolean :group 'recent-files)

(defcustom recent-files-filename-replacements (list (cons (regexp-quote (expand-file-name "~")) "~")) "\
*List of regexp/replacement pairs for filename filenames.
If a filename of a filename matches one of the regexps, it is replaced
by the corresponding replacement." :type '(repeat (cons regexp (string :tag "Replacement"))) :group 'recent-files)

(defcustom recent-files-sort-function (function recent-files-dont-sort) "\
*Function to sort the recent-files list with.
The value `recent-files-dont-sort' means to keep the \"most recent on top\"
order." :type 'function :group 'recent-files)

(defcustom recent-files-permanent-submenu nil "\
*If non-nil, put the permanent entries of recent-files into a submenu." :type 'boolean :group 'recent-files-menu)

(defcustom recent-files-non-permanent-submenu nil "\
*If non-nil, put the non-permanent entries of recent-files into a submenu." :type 'boolean :group 'recent-files-menu)

(defcustom recent-files-commands-submenu nil "\
*If non-nil, put the commands of recent-files into a submenu." :type 'boolean :group 'recent-files-menu)

(defcustom recent-files-commands-submenu-title "Commands..." "\
*Title of the commands submenu of recent-files." :type 'string :group 'recent-files-menu)

(defcustom recent-files-menu-title "Recent Files" "\
*Name to be displayed as title of the recent-files menu." :type 'string :group 'recent-files-menu)

(defcustom recent-files-menu-path nil "\
*Path where to add the recent-files menu.
A value of nil means add it as top-level menu.
For more information look up the documentation of `add-menu'." :type '(choice (const :tag "Top Level" nil) (sexp :tag "Menu Path")) :group 'recent-files-menu)

(defcustom recent-files-add-menu-before nil "\
*Name of the menu before which the recent-files menu shall be added.
A value of nil means add it as the last menu in recent-files-menu-path.
For more information look up the documentation of `add-menu'." :type '(choice (string :tag "Name") (const :tag "Last" nil)) :group 'recent-files-menu)

(defcustom recent-files-actions-on-top nil "\
*If non-nil, put the actions on top of the recent-files menu." :type 'boolean :group 'recent-files-menu)

(defcustom recent-files-permanent-first 'sort "\
*Control the placement of entries in the recent-files menu.
If the value is t, permanent entries are put first.
If the value is nil, non-permanent entries are put first.
If the value is neither, the entries are mixed following
recent-files-sort-function if neither appear in a submenu." :type '(choice (const :tag "Permanent First" t) (const :tag "Non-Permanent First" nil) (sexp :tag "Mixed")) :group 'recent-files-menu)

(defcustom recent-files-find-file-command (function find-file) "\
*Command to invoke with an entry of the recent-files list." :type 'function :group 'recent-files)

(defcustom recent-files-include-save-now nil "\
*If non-nil, have a menu entry to save the recent-files list immediately." :type 'boolean :group 'recent-files-menu)

;;;***

;;;### (autoloads (rm-preview-field-width rm-before-menu-pos rm-register-set rm-submenu-height rm-use-submenus rm-enable register-menu) "register-menu" "edit-utils/register-menu.el")
(defconst custom-define-current-source-file "register-menu.el")

(defgroup register-menu nil "A Top-Level Menu for Register commands." :version "21.5.B32 with patches to register.el and sequence.c")

(defcustom rm-enable nil "\
Enable or disable Register-Menu.
Enabling this adds the Register-Menu as a top level menu." :tag "Register Menu Enable" :group 'register-menu :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (rm-update)) :type '(boolean))

(defcustom rm-use-submenus t "\
whether input for choosing the register name is in the minibuffer or on the menus." :tag "Register Menu input method" :group 'register-menu :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (rm-update)) :type '(choice :tag "Input Method" (const :tag "Keyboard Input" nil) (const :tag "Menu Input" t)))

(defcustom rm-submenu-height 26 "\
Max number of lines for each submenu for choosing register names.
sane values are 10 to 36 lines high.
a 24-30 inch monitor can have up to 36; 
choosing 13 yields 3 submenus for a list of 36 register names." :tag "Register Menu Submenu Height" :group 'register-menu :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (rm-update)) :type '(integer :tag "submenu height in lines"))

(defcustom rm-register-set '(rm-lc-az rm-uc-az) "\
Stores list of lisp variables to include in menu of registers.
Each element should be a list of chars." :tag "Registers to display in menu:" :group 'register-menu :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (setq rm-current-reg-names (loop for variable in value append (eval variable))) (rm-update)) :type '(set (const :tag "Lower-case letters (a-z)" rm-lc-az) (const :tag "Upper-case letters (A-Z)" rm-uc-az) (const :tag "Numbers (0-9)" rm-numbers-09)))

(defcustom rm-before-menu-pos "Options" "\
Menu item Register menu should be inserted directly before.
Defaults to Options, to permit a significant preview of register contents." :tag "Menu position" :group 'register-menu :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (rm-update)) :type 'string)

(defcustom rm-preview-field-width 40 "\
Width (in characters) of the preview field 
 next to the register name in the register-menu submenus." :tag "Register Menu preview field width" :group 'register-menu :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (rm-update)) :type '(choice :tag "Preview Field Width" (const :tag "10 chars" 10) (const :tag "15 chars" 15) (const :tag "20 chars" 20) (const :tag "25 chars" 25) (const :tag "30 chars" 30) (const :tag "35 chars" 35) (const :tag "40 chars" 40) (const :tag "45 chars" 45)))

;;;***

;;;### (autoloads (resize-minibuffer-frame-exactly resize-minibuffer-frame-max-height resize-minibuffer-frame resize-minibuffer-window-exactly resize-minibuffer-window-max-height resize-minibuffer-mode resize-minibuffer) "rsz-minibuf" "edit-utils/rsz-minibuf.el")
(defconst custom-define-current-source-file "rsz-minibuf.el")

(defgroup resize-minibuffer nil "Dynamically resize minibuffer to display entire contents" :group 'frames)

(defcustom resize-minibuffer-mode nil "\
*If non-`nil', resize the minibuffer so its entire contents are visible." :type 'boolean :require 'rsz-minibuf :group 'resize-minibuffer)

(defcustom resize-minibuffer-window-max-height nil "\
*Maximum size the minibuffer window is allowed to become.
If less than 1 or not a number, the limit is the height of the frame in
which the active minibuffer window resides." :type '(choice (const nil) integer) :group 'resize-minibuffer)

(defcustom resize-minibuffer-window-exactly t "\
*If non-`nil', make minibuffer exactly the size needed to display all its contents.
Otherwise, the minibuffer window can temporarily increase in size but
never get smaller while it is active." :type 'boolean :group 'resize-minibuffer)

(defcustom resize-minibuffer-frame nil "\
*If non-`nil' and the active minibuffer is the sole window in its frame, allow changing the frame height." :type 'boolean :group 'resize-minibuffer)

(defcustom resize-minibuffer-frame-max-height nil "\
*Maximum size the minibuffer frame is allowed to become.
If less than 1 or not a number, there is no limit.")

(defcustom resize-minibuffer-frame-exactly nil "\
*If non-`nil', make minibuffer frame exactly the size needed to display all its contents.
Otherwise, the minibuffer frame can temporarily increase in size but
never get smaller while it is active." :type 'boolean :group 'resize-minibuffer)

;;;***

;;;### (autoloads (savehist-save-hook savehist-autosave-interval savehist-file-modes savehist-file savehist-additional-variables savehist-save-minibuffer-history savehist-mode savehist) "savehist" "edit-utils/savehist.el")
(defconst custom-define-current-source-file "savehist.el")

(defgroup savehist nil "Save minibuffer history." :group 'minibuffer)

(defcustom savehist-mode nil "\
Mode for automatic saving of minibuffer history.
Set this by calling the `savehist-mode' function or using the customize
interface." :type 'boolean :set (lambda (symbol value) (savehist-mode (or value 0))) :initialize 'custom-initialize-default :require 'savehist :group 'savehist)

(defcustom savehist-save-minibuffer-history t "\
*If non-nil, save all recorded minibuffer histories.
If you want to save only specific histories, use `savehist-save-hook' to
modify the value of `savehist-minibuffer-history-variables'." :type 'boolean :group 'savehist)

(defcustom savehist-additional-variables nil "\
*List of additional variables to save.
Each element is a symbol whose value will be persisted across Emacs
sessions that use savehist.  The contents of variables should be
printable with the Lisp printer.  You don't need to add minibuffer
history variables to this list, all minibuffer histories will be
saved automatically as long as `savehist-save-minibuffer-history' is
non-nil.

User options should be saved with the customize interface.  This
list is useful for saving automatically updated variables that are not
minibuffer histories, such as `compile-command' or `kill-ring'." :type '(repeat variable) :group 'savehist)

(defcustom savehist-file (cond ((file-exists-p "~/.emacs-history") "~/.emacs-history") ((and (not (featurep 'xemacs)) (file-directory-p "~/.emacs.d/")) "~/.emacs.d/history") ((and (featurep 'xemacs) (file-directory-p "~/.xemacs/")) "~/.xemacs/history") (t "~/.emacs-history")) "\
*File name where minibuffer history is saved to and loaded from.
The minibuffer history is a series of Lisp expressions loaded
automatically when `savehist-mode' is turned on.  See `savehist-mode'
for more details.

If you want your minibuffer history shared between Emacs and XEmacs,
customize this value and make sure that `savehist-coding-system' is
set to a coding system that exists in both emacsen." :type 'file :group 'savehist)

(defcustom savehist-file-modes 384 "\
*Default permissions of the history file.
This is decimal, not octal.  The default is 384 (0600 in octal).
Set to nil to use the default permissions that Emacs uses, typically
mandated by umask.  The default is a bit more restrictive to protect
the user's privacy." :type 'integer :group 'savehist)

(defcustom savehist-autosave-interval (* 5 60) "\
*The interval between autosaves of minibuffer history.
If set to nil, disables timer-based autosaving." :type 'integer :group 'savehist)

(defcustom savehist-save-hook nil "\
Hook called by `savehist-save' before saving the variables.
You can use this hook to influence choice and content of variables to
save." :type 'hook)

;;;***

;;;### (autoloads (save-place-limit save-place-version-control save-place-file save-place save-place) "saveplace" "edit-utils/saveplace.el")
(defconst custom-define-current-source-file "saveplace.el")

(defgroup save-place nil "Automatically save place in files." :group 'data)

(defcustom save-place nil "\
*Non-nil means automatically save place in each file.
This means when you visit a file, point goes to the last place
where it was when you previously visited the same file.
This variable is automatically buffer-local.

If you wish your place in any file to always be automatically saved,
simply put this in your `~/.emacs' file:

\(setq-default save-place t)" :type 'boolean :require 'saveplace :group 'save-place)

(defcustom save-place-file (convert-standard-filename "~/.emacs-places") "\
*Name of the file that records `save-place-alist' value." :type 'file :group 'save-place)

(defcustom save-place-version-control nil "\
*Controls whether to make numbered backups of master save-place file.
It can have four values: t, nil, `never', and `nospecial'.  The first
three have the same meaning that they do for the variable
`version-control', and the final value `nospecial' means just use the
value of `version-control'." :type '(radio (const :tag "Unconditionally" t) (const :tag "For VC Files" nil) (const never) (const :tag "Use value of `version-control'" nospecial)) :group 'save-place)

(defcustom save-place-limit nil "\
Maximum number of entries to retain in the list; nil means no limit." :type '(choice (integer :tag "Entries" :value 1) (const :tag "No Limit" nil)) :group 'save-place)

;;;***

;;;### (autoloads (tempo-leave-completion-buffer tempo-show-completion-buffer tempo-insert-region tempo-interactive tempo) "tempo" "edit-utils/tempo.el")
(defconst custom-define-current-source-file "tempo.el")

(defgroup tempo nil "Flexible template insertion." :prefix "tempo-" :group 'extensions)

(defcustom tempo-interactive t "\
*Prompt user for strings in templates.
If this variable is non-nil, `tempo-insert' prompts the
user for text to insert in the templates" :type 'boolean :group 'tempo)

(defcustom tempo-insert-region nil "\
*Automatically insert current region when there is a `r' in the template.
If this variable is nil, `r' elements will be treated just like `p'
elements, unless the template function is given a prefix (or a non-nil
argument).  If this variable is non-nil, the behaviour is reversed.

In Transient Mark mode, this option is unused." :type 'boolean :group 'tempo)

(defcustom tempo-show-completion-buffer t "\
*If non-nil, show a buffer with possible completions, when only
a partial completion can be found." :type 'boolean :group 'tempo)

(defcustom tempo-leave-completion-buffer nil "\
*If nil, a completion buffer generated by \\[tempo-complete-tag]
disappears at the next keypress; otherwise, it remains forever." :type 'boolean :group 'tempo)

;;;***

;;;### (autoloads (toolbar-button-default-position edit-toolbar) "toolbar-utils" "edit-utils/toolbar-utils.el")
(defconst custom-define-current-source-file "toolbar-utils.el")

(defgroup edit-toolbar nil "Tools for interactive editing and non-interactive management of toolbars.")

(defcustom toolbar-button-default-position 'right "\
Default position for adding toolbar buttons on the fly.

See `toolbar-add-button-on-the-fly' for possible values and meanings." :type 'sexp :group 'edit-toolbar)

;;;***

;;;### (autoloads (uniquify-trailing-separator-p uniquify-separator uniquify-min-dir-content uniquify-ignore-buffers-query-functions uniquify-ignore-buffers-mode-re uniquify-ignore-buffers-re uniquify-ask-about-buffer-names-p uniquify-after-kill-buffer-p uniquify-buffer-name-style uniquify) "uniquify" "edit-utils/uniquify.el")
(defconst custom-define-current-source-file "uniquify.el")

(defgroup uniquify nil "Unique buffer names dependent on file name" :group 'applications)

(defcustom uniquify-buffer-name-style nil "\
*If non-nil, buffer names are uniquified with parts of directory name.
The value determines the buffer name style and is one of `forward',
`reverse', `post-forward' (the default), or `post-forward-angle-brackets'.
For example, files `/foo/bar/mumble/name' and `/baz/quux/mumble/name'
would have the following buffer names in the various styles:
  forward        bar/mumble/name  quux/mumble/name
  reverse        name\\mumble\\bar  name\\mumble\\quux
  post-forward   name|bar/mumble  name|quux/mumble
  post-forward-angle-brackets   name<bar/mumble>  name<quux/mumble>
  nil            name  name<2>" :type '(radio (const forward) (const reverse) (const post-forward) (const post-forward-angle-brackets) (const :tag "standard Emacs behavior (nil)" nil)) :group 'uniquify)

(defcustom uniquify-after-kill-buffer-p nil "\
*If non-nil, rerationalize buffer names after a buffer has been killed.
This can be dangerous if Emacs Lisp code is keeping track of buffers by their
names (rather than keeping pointers to the buffers themselves)." :type 'boolean :group 'uniquify)

(defcustom uniquify-ask-about-buffer-names-p nil "\
*If non-nil, permit user to choose names for buffers with same base file.
If the user chooses to name a buffer, uniquification is preempted and no
other buffer names are changed." :type 'boolean :group 'uniquify)

(defcustom uniquify-ignore-buffers-re nil "\
*Regular expression matching buffer names that should not be uniquified.
For instance, set this to \"^draft-[0-9]+$\" to avoid having uniquify rename
draft buffers even if `uniquify-after-kill-buffer-p' is non-nil and the
visited file name isn't the same as that of the buffer." :type '(choice (const :tag "Uniquify all buffers" nil) regexp) :group 'uniquify)

(defcustom uniquify-ignore-buffers-mode-re "^Info-mode$" "\
*Regexp matching names of major modes of buffers that should not be uniquified.
For instance, set this to \"^\\\\(Info\\\\)\\\\|\\\\(message\\\\)-mode$\" to avoid
having uniquify rename Info and mail message buffers." :type '(choice (const :tag "Uniquify all buffers" nil) regexp) :group 'uniquify)

(defcustom uniquify-ignore-buffers-query-functions '(uniquify-ignore-buffers-re uniquify-ignore-buffers-mode-re) "\
*Functions to call to determine if a buffer name should not be uniquified.
The functions are called with one argument, the buffer.  If any function
returns t, the buffer name is not uniquified." :type '(repeat (function :format "%v")) :group 'uniquify)

(defcustom uniquify-min-dir-content 0 "\
*Minimum number of directory name components included in buffer name." :type 'integer :group 'uniquify)

(defcustom uniquify-separator nil "\
*String separator for buffer name components.
When `uniquify-buffer-name-style' is `post-forward', separates
base file name from directory part in buffer names (default \"|\").
When `uniquify-buffer-name-style' is `reverse', separates all
file name components (default \"\\\")." :type '(choice (const nil) string) :group 'uniquify)

(defcustom uniquify-trailing-separator-p nil "\
*If non-nil, add a file name separator to dired buffer names.
If `uniquify-buffer-name-style' is `forward', add the separator at the end;
if it is `reverse', add the separator at the beginning; otherwise, this
variable is ignored." :type 'boolean :group 'uniquify)

;;;***

;;;### (autoloads (where-was-i-db wwi-auto-install-on-startup-flag where-was-i) "where-was-i-db" "edit-utils/where-was-i-db.el")
(defconst custom-define-current-source-file "where-was-i-db.el")

(defgroup where-was-i nil "Remember where you were in files you have visited." :group 'files)

(defcustom wwi-auto-install-on-startup-flag nil "\
Setting and saving this option will cause `where-was-i-db' to be
loaded with `require' when your options.el file is loaded, and setting
it to `on' will cause it to install its hooks at that time also.

Resetting it to the factory-default should make it no longer be
auto-required.

Please read the documentation to `toggle-where-was-i'." :type 'boolean :tag "Auto-install on startup?" :require 'where-was-i-db :group 'where-was-i)

(defcustom where-was-i-db (cond ((boundp 'load-user-init-file-p) (paths-construct-path (list user-init-directory ".wwi.db"))) (t (paths-construct-path (list (concat "~" (or init-file-user "")) user-init-directory ".wwi.db")))) "\
Location and filename of the `where-was-i-db' database file.
The default location is usually the right place for it." :type 'file :tag "Database file-name" :group 'where-was-i)

;;;***

;;;### (autoloads (which-func-format which-func-maxout which-func-non-auto-modes which-func-modes which-func) "which-func" "edit-utils/which-func.el")
(defconst custom-define-current-source-file "which-func.el")

(defgroup which-func nil "Display the current function name in the mode line." :group 'tools :version "20.3")

(defcustom which-func-modes t "\
List of major modes for which Which Function mode should be used.
For other modes it is disabled.  If this is equal to t,
then Which Function mode is enabled in any major mode that supports it." :group 'which-func :version "24.3" :type '(choice (const :tag "All modes" t) (repeat (symbol :tag "Major mode"))))

(defcustom which-func-non-auto-modes nil "\
List of major modes where Which Function mode is inactive till Imenu is used.
This means that Which Function mode won't really do anything
until you use Imenu, in these modes.  Note that files
larger than `which-func-maxout' behave in this way too;
Which Function mode doesn't do anything until you use Imenu." :group 'which-func :type '(repeat (symbol :tag "Major mode")))

(defcustom which-func-maxout 500000 "\
Don't automatically compute the Imenu menu if buffer is this big or bigger.
Zero means compute the Imenu menu regardless of size." :group 'which-func :type 'integer)

(defcustom which-func-format (backquote ("[" (:propertize which-func-current local-map (\, which-func-keymap) face which-func mouse-face mode-line-highlight help-echo "mouse-1: go to beginning\nmouse-2: toggle rest visibility\nmouse-3: go to end") "]")) "\
Format for displaying the function in the mode line." :version "24.2" :group 'which-func :type 'sexp)

;;;***

;;;### (autoloads (winring-name-generator winring-show-names winring-new-config-buffer-name winring-prompt-on-create winring-ring-size winring) "winring" "edit-utils/winring.el")
(defconst custom-define-current-source-file "winring.el")

(defgroup winring nil "Window configuration rings" :prefix "winring-" :group 'frames)

(defcustom winring-ring-size 7 "\
*Size of the window configuration ring." :type 'integer :group 'winring)

(defcustom winring-prompt-on-create 'usually "\
*When true, prompt for new configuration name on creation.
If not t and not nil, prompt for configuration name on creation,
except when creating the initial configuration on a new frame." :type '(radio (const :tag "Never prompt for configuration name" nil) (const :tag "Always prompt for configuration name" t) (const :tag "Prompt for all but initial configuration name" usually)) :group 'winring)

(defcustom winring-new-config-buffer-name "*scratch*" "\
*Name of the buffer to switch to when a new configuration is created." :type 'string :group 'winring)

(defcustom winring-show-names nil "\
*If non-nil, window configuration names are shown in the modeline.
If nil, the name is echoed in the minibuffer when switching window
configurations." :type 'boolean :group 'winring)

(defcustom winring-name-generator 'winring-next-name "\
*Function that generates new automatic window configuration names.
When a new window configuration is created with `winring-new-configuration',
and the user did not specify an explicit name, this function is called with
no arguments to get the new name.  It must return a string." :type 'function :group 'winring)

;;;***

(provide 'edit-utils-custom-defines)
