;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'erc-custom-defines) (error "Feature erc-custom-defines already loaded"))

;;;### (autoloads (erc-autoaway-message erc-autoaway-idle-seconds erc-autoaway-no-auto-discard-regexp erc-auto-discard-away erc-auto-set-away erc-autoaway-use-emacs-idle erc-autoaway) "erc-autoaway" "erc/erc-autoaway.el")
(defconst custom-define-current-source-file "erc-autoaway.el")

(defgroup erc-autoaway nil "Set yourself automatically away after some idletime and set\nyourself back when you type something." :group 'erc)

(defcustom erc-autoaway-use-emacs-idle nil "\
*If non-nil, the idle time refers to idletime in Emacs.
If nil, the idle time refers to idletime on IRC only.
The time itself is specified by `erc-autoaway-idle-seconds'.
See `erc-autoaway-mode' for more information on the various
definitions of being idle.

Note that using Emacs idletime is currently broken for most versions,
since process activity (as happens all the time on IRC) makes Emacs
non-idle.  Emacs idle-time and user idle-time are just not the same." :group 'erc-autoaway :type 'boolean)

(defcustom erc-auto-set-away t "\
*If non-nil, set away after `erc-autoaway-idle-seconds' seconds of idling.
ERC autoaway mode can set you away when you idle, and set you no
longer away when you type something.  This variable controls whether
you will be set away when you idle.  See `erc-auto-discard-away' for
the other half." :group 'erc-autoaway :type 'boolean)

(defcustom erc-auto-discard-away t "\
*If non-nil, sending anything when away automatically discards away state.
ERC autoaway mode can set you away when you idle, and set you no
longer away when you type something.  This variable controls whether
you will be set no longer away when you type something.  See
`erc-auto-set-away' for the other half.
See also `erc-autoaway-no-auto-discard-regexp'." :group 'erc-autoaway :type 'boolean)

(defcustom erc-autoaway-no-auto-discard-regexp "^/g?away.*$" "\
*Input that matches this will not automatically discard away status.
See `erc-auto-discard-away'." :group 'erc-autoaway :type 'regexp)

(defcustom erc-autoaway-idle-seconds 1800 "\
*Number of seconds after which ERC will set you automatically away.
If you are changing this variable using lisp instead of customizing it,
you have to run `erc-autoaway-reestablish-idletimer' afterwards." :group 'erc-autoaway :set (lambda (sym val) (set-default sym val) (when erc-autoaway-use-emacs-idle (erc-autoaway-reestablish-idletimer))) :type 'number)

(defcustom erc-autoaway-message "I'm gone (autoaway after %i seconds of idletime)" "\
*Message ERC will use when he sets you automatically away.
It is used as a `format' string with the argument of the idletime in
seconds." :group 'erc-autoaway :type 'string)

;;;***

;;;### (autoloads (erc-autojoin-domain-only erc-autojoin-channels-alist erc-autojoin) "erc-autojoin" "erc/erc-autojoin.el")
(defconst custom-define-current-source-file "erc-autojoin.el")

(defgroup erc-autojoin nil "Enable autojoining." :group 'erc)

(defcustom erc-autojoin-channels-alist nil "\
Alist of channels to autojoin on IRC networks.
Every element in the alist has the form (SERVER . CHANNELS).
SERVER is a regexp matching the server, and channels is the
list of channels to join.

Customize this variable to set the value for your first connect.
Once you are connected and join and part channels, this alist
keeps track of what channels you are on, and will join them
again when you get disconnected.  When you restart Emacs, however,
those changes are lost, and the customization you saved the last
time is used again." :group 'erc-autojoin :type '(repeat (cons :tag "Server" (regexp :tag "Name") (repeat :tag "Channels" (string :tag "Name")))))

(defcustom erc-autojoin-domain-only t "\
Truncate host name to the domain name when joining a server.
If non-nil, and a channel on the server a.b.c is joined, then
only b.c is used as the server for `erc-autojoin-channels-alist'.
This is important for networks that redirect you to other
servers, presumably in the same domain." :group 'erc-autojoin :type 'boolean)

;;;***

;;;### (autoloads (erc-server-send-ping-interval erc-server-flood-penalty erc-server-flood-margin erc-server-duplicate-timeout erc-server-prevent-duplicates erc-server-connect-function erc-encoding-coding-alist erc-server-coding-system erc-split-line-length erc-server-auto-reconnect erc-server) "erc-backend" "erc/erc-backend.el")
(defconst custom-define-current-source-file "erc-backend.el")

(defgroup erc-server nil "Parameters for dealing with IRC servers." :group 'erc)

(defcustom erc-server-auto-reconnect t "\
Non-nil means that ERC will attempt to reestablish broken connections.

Reconnection will happen automatically for any unexpected disconnection." :group 'erc-server :type 'boolean)

(defcustom erc-split-line-length 440 "\
*The maximum length of a single message.
If a message exceeds this size, it is broken into multiple ones.

IRC allows for lines up to 512 bytes. Two of them are CR LF.
And a typical message looks like this:

  :nicky!uhuser@host212223.dialin.fnordisp.net PRIVMSG #lazybastards :Hello!

You can limit here the maximum length of the \"Hello!\" part.
Good luck." :type 'integer :group 'erc-server)

(defcustom erc-server-coding-system (if (and (fboundp 'coding-system-p) (coding-system-p 'undecided) (coding-system-p 'utf-8)) '(utf-8 . undecided) nil) "\
The default coding system for incoming and outgoing text.
This is either a coding system, a cons, a function, or nil.

If a cons, the encoding system for outgoing text is in the car
and the decoding system for incoming text is in the cdr. The most
interesting use for this is to put `undecided' in the cdr. If a
function, it is called with no arguments and should return a
coding system or a cons as described above. Note that you can use
the dynamically bound variable `target' to get the current
target. See `erc-coding-system-for-target'.

If you need to send non-ASCII text to people not using a client that
does decoding on its own, you must tell ERC what encoding to use.
Emacs cannot guess it, since it does not know what the people on the
other end of the line are using." :group 'erc-server :type '(choice (const :tag "None" nil) coding-system (cons (coding-system :tag "encoding" :value utf-8) (coding-system :tag "decoding" :value undecided)) function))

(defcustom erc-encoding-coding-alist nil "\
Alist of target regexp and coding-system pairs to use.
This overrides `erc-server-coding-system' depending on the
current target as returned by `erc-default-target'.

Example: If you know that the channel #linux-ru uses the coding-system
`cyrillic-koi8', then add '(\"#linux-ru\" . cyrillic-koi8) to the
alist." :group 'erc-server :type '(repeat (cons (string :tag "Target") coding-system)))

(defcustom erc-server-connect-function 'open-network-stream "\
Function used to initiate a connection.
It should take same arguments as `open-network-stream' does." :group 'erc-server :type 'function)

(defcustom erc-server-prevent-duplicates '("301") "\
*Either nil or a list of strings.
Each string is a IRC message type, like PRIVMSG or NOTICE.
All Message types in that list of subjected to duplicate prevention." :type '(choice (const nil) (list string)) :group 'erc-server)

(defcustom erc-server-duplicate-timeout 60 "\
*The time allowed in seconds between duplicate messages.

If two identical messages arrive within this value of one another, the second
isn't displayed." :type 'integer :group 'erc-server)

(defcustom erc-server-flood-margin 10 "\
*A margin on how much excess data we send.
The flood protection algorithm of ERC works like the one
detailed in RFC 2813, section 5.8 \"Flood control of clients\".

  * If `erc-server-flood-last-message' is less than the current
    time, set it equal.
  * While `erc-server-flood-last-message' is less than
    `erc-server-flood-margin' seconds ahead of the current
    time, send a message, and increase
    `erc-server-flood-last-message' by
    `erc-server-flood-penalty' for each message." :type 'integer :group 'erc-server)

(defcustom erc-server-flood-penalty 3 "\
How much we penalize a message.
See `erc-server-flood-margin' for an explanation of the flood
protection algorithm." :type 'integer :group 'erc-server)

(defcustom erc-server-send-ping-interval 90 "\
*Interval of sending pings to the server, in seconds.
If this is set to nil, pinging the server is disabled." :group 'erc-server :type '(choice (const nil) (integer :tag "Seconds")))

;;;***

;;;### (autoloads (erc-bbdb-electric-p erc-bbdb-elide-display erc-bbdb-bitlbee-name-field erc-bbdb-irc-highlight-field erc-bbdb-irc-channel-field erc-bbdb-irc-nick-field erc-bbdb-popup-type erc-bbdb-auto-create-on-nick-p erc-bbdb-auto-create-on-join-p erc-bbdb-auto-create-on-whois-p erc-bbdb) "erc-bbdb" "erc/erc-bbdb.el")
(defconst custom-define-current-source-file "erc-bbdb.el")

(defgroup erc-bbdb nil "Variables related to BBDB usage." :group 'erc)

(defcustom erc-bbdb-auto-create-on-whois-p nil "\
*If nil, don't create bbdb records automatically when a WHOIS is done.
Leaving this at nil is a good idea, but you can turn it
on if you want to have lots of People named \"John Doe\" in your BBDB." :group 'erc-bbdb :type 'boolean)

(defcustom erc-bbdb-auto-create-on-join-p nil "\
*If nil, don't create bbdb records automatically when a person joins a channel.
Leaving this at nil is a good idea, but you can turn it
on if you want to have lots of People named \"John Doe\" in your BBDB." :group 'erc-bbdb :type 'boolean)

(defcustom erc-bbdb-auto-create-on-nick-p nil "\
*If nil, don't create bbdb records automatically when a person changes her nick.
Leaving this at nil is a good idea, but you can turn it
on if you want to have lots of People named \"John Doe\" in your BBDB." :group 'erc-bbdb :type 'boolean)

(defcustom erc-bbdb-popup-type 'visible "\
*If t, pop up a BBDB buffer showing the record of a WHOISed person
or the person who has just joined a channel.
If set to 'visible, the BBDB buffer only pops up when someone was WHOISed
or a person joined a channel visible on any frame." :group 'erc-bbdb :type 'sexp)

(defcustom erc-bbdb-irc-nick-field 'irc-nick "\
The notes field name to use for annotating IRC nicknames." :group 'erc-bbdb :type 'symbol)

(defcustom erc-bbdb-irc-channel-field 'irc-channel "\
The notes field name to use for annotating IRC channels." :group 'erc-bbdb :type 'symbol)

(defcustom erc-bbdb-irc-highlight-field 'irc-highlight "\
The notes field name to use for highlighting a person's messages." :group 'erc-bbdb :type 'symbol)

(defcustom erc-bbdb-bitlbee-name-field 'bitlbee-name "\
The notes field name to use for annotating bitlbee displayed name.
This is the name that a bitlbee (AIM/MSN/ICQ) contact provides as
their \"displayed name\"." :group 'erc-bbdb :type 'symbol)

(defcustom erc-bbdb-elide-display nil "\
*If t, show BBDB popup buffer elided." :group 'erc-bbdb :type 'boolean)

(defcustom erc-bbdb-electric-p nil "\
*If t, BBDB popup buffer is electric." :group 'erc-bbdb :type 'boolean)

;;;***

;;;### (autoloads (erc-nick-popup-alist erc-emacswiki-lisp-url erc-emacswiki-url erc-button-alist erc-button-google-url erc-button-rfc-url erc-button-buttonize-nicks erc-button-wrap-long-urls erc-button-url-regexp erc-button-mouse-face erc-button-nickname-face erc-button-face erc-button) "erc-button" "erc/erc-button.el")
(defconst custom-define-current-source-file "erc-button.el")

(defgroup erc-button nil "Define how text can be turned into clickable buttons." :group 'erc)

(defcustom erc-button-face 'erc-button "\
Face used for highlighting buttons in ERC buffers.

A button is a piece of text that you can activate by pressing
`RET' or `mouse-2' above it. See also `erc-button-keymap'." :type 'face :group 'erc-faces)

(defcustom erc-button-nickname-face 'erc-nick-default-face "\
Face used for ERC nickname buttons." :type 'face :group 'erc-faces)

(defcustom erc-button-mouse-face 'highlight "\
Face used for mouse highlighting in ERC buffers.

Buttons will be displayed in this face when the mouse cursor is
above them." :type 'face :group 'erc-faces)

(defcustom erc-button-url-regexp (concat "\\(www\\.\\|\\(s?https?\\|" "ftp\\|file\\|gopher\\|news\\|telnet\\|wais\\|mailto\\):\\)" "\\(//[-a-zA-Z0-9_.]+:[0-9]*\\)?" "[-a-zA-Z0-9_=!?#$@~`%&*+\\/:;.,]+[-a-zA-Z0-9_=#$@~`%&*+\\/]") "\
Regular expression that matches URLs." :group 'erc-button :type 'regexp)

(defcustom erc-button-wrap-long-urls nil "\
If non-nil, \"long\" URLs matching `erc-button-url-regexp' will be wrapped.

If this variable is a number, consider URLs longer than its value to
be \"long\".  If t, URLs will be considered \"long\" if they are
longer than `erc-fill-column'." :group 'erc-button :type '(choice integer boolean))

(defcustom erc-button-buttonize-nicks t "\
Flag indicating whether nicks should be buttonized or not." :group 'erc-button :type 'boolean)

(defcustom erc-button-rfc-url "http://www.faqs.org/rfcs/rfc%s.html" "\
*URL used to browse rfc references.
%s is replaced by the number." :group 'erc-button :type 'string)

(defcustom erc-button-google-url "http://www.google.com/search?q=%s" "\
*URL used to browse Google search references.
%s is replaced by the search string." :group 'erc-button :type 'string)

(defcustom erc-button-alist '(('nicknames 0 erc-button-buttonize-nicks erc-nick-popup 0) (erc-button-url-regexp 0 t browse-url 0) ("<URL: *\\([^<> ]+\\) *>" 0 t browse-url 1) ("(\\(\\([^~\n 	@][^\n 	@]*\\)@\\([a-zA-Z0-9.:-]+\\)\\)" 1 t finger 2 3) ("[`]\\([a-zA-Z][-a-zA-Z_0-9]+\\)[']" 1 t erc-button-describe-symbol 1) ("\\bInfo:[\"]\\([^\"]+\\)[\"]" 0 t Info-goto-node 1) ("\\b\\(Ward\\|Wiki\\|WardsWiki\\|TheWiki\\):\\([A-Z][a-z]+\\([A-Z][a-z]+\\)+\\)" 0 t (lambda (page) (browse-url (concat "http://c2.com/cgi-bin/wiki?" page))) 2) ("EmacsWiki:\\([A-Z][a-z]+\\([A-Z][a-z]+\\)+\\)" 0 t erc-browse-emacswiki 1) ("Lisp:\\([a-zA-Z.+-]+\\)" 0 t erc-browse-emacswiki-lisp 1) ("\\bGoogle:\\([^ 	\n
\^L]+\\)" 0 t (lambda (keywords) (browse-url (format erc-button-google-url keywords))) 1) ("\\brfc[#: ]?\\([0-9]+\\)" 0 t (lambda (num) (browse-url (format erc-button-rfc-url num))) 1) ("\\s-\\(@\\([0-9][0-9][0-9]\\)\\)" 1 t erc-button-beats-to-time 2)) "\
*Alist of regexps matching buttons in ERC buffers.
Each entry has the form (REGEXP BUTTON FORM CALLBACK PAR...), where

REGEXP is the string matching text around the button or a symbol
  indicating a variable holding that string, or a list of
  strings, or an alist with the strings in the car.  Note that
  entries in lists or alists are considered to be nicks or other
  complete words.  Therefore they are enclosed in \\< and \\>
  while searching.  REGEXP can also be the quoted symbol
  'nicknames, which matches the nickname of any user on the
  current server.

BUTTON is the number of the regexp grouping actually matching the
  button,  This is ignored if REGEXP is 'nicknames.

FORM is a lisp expression which must eval to true for the button to
  be added,

CALLBACK is the function to call when the user push this button.
  CALLBACK can also be a symbol.  Its variable value will be used
  as the callback function.

PAR is a number of a regexp grouping whose text will be passed to
  CALLBACK.  There can be several PAR arguments.  If REGEXP is
  'nicknames, these are ignored, and CALLBACK will be called with
  the nickname matched as the argument." :group 'erc-button :type '(repeat (list :tag "Button" (choice :tag "Matches" regexp (variable :tag "Variable containing regexp") (const :tag "Nicknames" 'nicknames)) (integer :tag "Number of the regexp section that matches") (choice :tag "When to buttonize" (const :tag "Always" t) (sexp :tag "Only when this evaluates to non-nil")) (function :tag "Function to call when button is pressed") (repeat :tag "Sections of regexp to send to the function" :inline t (integer :tag "Regexp section number")))))

(defcustom erc-emacswiki-url "http://www.emacswiki.org/cgi-bin/wiki.pl?" "\
*URL of the EmacsWiki Homepage." :group 'erc-button :type 'string)

(defcustom erc-emacswiki-lisp-url "http://www.emacswiki.org/elisp/" "\
*URL of the EmacsWiki ELisp area." :group 'erc-button :type 'string)

(defcustom erc-nick-popup-alist '(("DeOp" erc-cmd-DEOP nick) ("Kick" erc-cmd-KICK (concat nick " " (read-from-minibuffer (concat "Kick " nick ", reason: ")))) ("Msg" erc-cmd-MSG (concat nick " " (read-from-minibuffer (concat "Message to " nick ": ")))) ("Op" erc-cmd-OP nick) ("Query" erc-cmd-QUERY nick) ("Whois" erc-cmd-WHOIS nick) ("Lastlog" erc-cmd-LASTLOG nick)) "\
*An alist of possible actions to take on a nickname.
An entry looks like (\"Action\" . SEXP) where SEXP is evaluated with
the variable `nick' bound to the nick in question.

Examples:
 (\"DebianDB\" .
  (shell-command
   (format
    \"ldapsearch -x -P 2 -h db.debian.org -b dc=debian,dc=org ircnick=%s\"
    nick)))" :group 'erc-button :type '(repeat (cons (string :tag "Op") sexp)))

;;;***

;;;### (autoloads (erc-chess-debug-flag erc-chess-verbose-flag erc-chess) "erc-chess" "erc/erc-chess.el")
(defconst custom-define-current-source-file "erc-chess.el")

(defgroup erc-chess nil "Playing chess over IRC." :group 'erc)

(defcustom erc-chess-verbose-flag nil "\
*If non-nil, inform about bogus CTCP CHESS messages in the server buffer." :group 'erc-chess :type 'boolean)

(defcustom erc-chess-debug-flag t "\
*If non-nil, print all chess CTCP messages received in the server buffer." :group 'erc-chess :type 'boolean)

;;;***

;;;### (autoloads (erc-nick-completion-postfix erc-nick-completion-ignore-case erc-nick-completion erc-old-complete) "erc-complete" "erc/erc-complete.el")
(defconst custom-define-current-source-file "erc-complete.el")

(defgroup erc-old-complete nil "Nick completion.  Obsolete, use erc-pcomplete instead." :group 'erc)

(defcustom erc-nick-completion 'all "\
Determine how the list of nicks is determined during nick completion.
See `erc-complete-nick' for information on how to activate this.

pals:   Use `erc-pals'.
all:    All channel members.

You may also provide your own function that returns a list of completions.
One example is `erc-nick-completion-exclude-myself',
or you may use an arbitrary lisp expression." :type '(choice (const :tag "List of pals" pals) (const :tag "All channel members" all) (const :tag "All channel members except yourself" erc-nick-completion-exclude-myself) (repeat :tag "List" (string :tag "Nick")) function sexp) :group 'erc-old-complete)

(defcustom erc-nick-completion-ignore-case t "\
*Non-nil means don't consider case significant in nick completion.
Case will be automatically corrected when non-nil.
For instance if you type \"dely TAB\" the word completes and changes to
\"delYsid\"." :group 'erc-old-complete :type 'boolean)

(defcustom erc-nick-completion-postfix ": " "\
*When `erc-complete' is used in the first word after the prompt,
add this string when a unique expansion was found." :group 'erc-old-complete :type 'string)

;;;***

;;;### (autoloads (erc-dcc-chat-exit-hook erc-dcc-chat-connect-hook erc-dcc-chat-mode-hook erc-dcc-chat-buffer-name-format erc-dcc-send-connect-hook erc-dcc-pump-bytes erc-dcc-block-size erc-dcc-chat-request erc-dcc-get-default-directory erc-dcc-auto-masks erc-dcc-port-range erc-dcc-send-request erc-dcc-host erc-verbose-dcc erc-dcc) "erc-dcc" "erc/erc-dcc.el")
(defconst custom-define-current-source-file "erc-dcc.el")

(defgroup erc-dcc nil "DCC stands for Direct Client Communication, where you and your\nfriend's client programs connect directly to each other,\nbypassing IRC servers and their occasional \"lag\" or \"split\"\nproblems.  Like /MSG, the DCC chat is completely private.\n\nUsing DCC get and send, you can transfer files directly from and to other\nIRC users." :group 'erc)

(defcustom erc-verbose-dcc t "\
*If non-nil, be verbose about DCC activity reporting." :group 'erc-dcc :type 'boolean)

(defcustom erc-dcc-host nil "\
*IP address to use for outgoing DCC offers.
Should be set to a string or nil, if nil, automatic detection of the
host interface to use will be attempted." :group 'erc-dcc :type (list 'choice (list 'const :tag "Auto-detect" nil) (list 'string :tag "IP-address" :valid-regexp erc-dcc-ipv4-regexp)))

(defcustom erc-dcc-send-request 'ask "\
*How to treat incoming DCC Send requests.
'ask - Report the Send request, and wait for the user to manually accept it
       You might want to set `erc-dcc-auto-masks' for this.
'auto - Automatically accept the request and begin downloading the file
'ignore - Ignore incoming DCC Send requests completely." :group 'erc-dcc :type '(choice (const ask) (const auto) (const ignore)))

(defcustom erc-dcc-port-range nil "\
If nil, any available user port is used for outgoing DCC connections.
If set to a cons, it specifies a range of ports to use in the form (min . max)" :group 'erc-dcc :type '(choice (const :tag "Any port" nil) (cons :tag "Port range" (integer :tag "Lower port") (integer :tag "Upper port"))))

(defcustom erc-dcc-auto-masks nil "\
List of regexps matching user identifiers whose DCC send offers should be
accepted automatically.  A user identifier has the form \"nick!login@host\".
For instance, to accept all incoming DCC send offers automatically, add the
string \".*!.*@.*\" to this list." :group 'erc-dcc :type '(repeat regexp))

(defcustom erc-dcc-get-default-directory nil "\
*Default directory for incoming DCC file transfers.
If this is nil, then the current value of `default-directory' is used." :group 'erc-dcc :type '(choice (const nil :tag "Default directory") directory))

(defcustom erc-dcc-chat-request 'ask "\
*How to treat incoming DCC Chat requests.
'ask - Report the Chat request, and wait for the user to manually accept it
'auto - Automatically accept the request and open a new chat window
'ignore - Ignore incoming DCC chat requests completely." :group 'erc-dcc :type '(choice (const ask) (const auto) (const ignore)))

(defcustom erc-dcc-block-size 1024 "\
*Block size to use for DCC SEND sessions." :group 'erc-dcc :type 'integer)

(defcustom erc-dcc-pump-bytes nil "\
*If set to an integer, keep sending until that number of bytes are
unconfirmed." :group 'erc-dcc :type '(choice (const nil) integer))

(defcustom erc-dcc-send-connect-hook '((lambda (proc) (erc-display-message nil 'notice (erc-dcc-get-parent proc) (format "DCC: SEND connect from %s" (format-network-address (process-contact proc :remote))))) erc-dcc-send-block) "\
*Hook run whenever the remote end of a DCC SEND offer connected to your
listening port." :group 'erc-dcc :type 'hook)

(defcustom erc-dcc-chat-buffer-name-format "DCC-CHAT-%s" "\
*Format to use for DCC Chat buffer names." :group 'erc-dcc :type 'string)

(defcustom erc-dcc-chat-mode-hook nil "\
*Hook calls when `erc-dcc-chat-mode' finished setting up the buffer." :group 'erc-dcc :type 'hook)

(defcustom erc-dcc-chat-connect-hook nil "\
" :group 'erc-dcc :type 'hook)

(defcustom erc-dcc-chat-exit-hook nil "\
" :group 'erc-dcc :type 'hook)

;;;***

;;;### (autoloads (erc-ezb-login-alist erc-ezb-regexp erc-ezbounce) "erc-ezbounce" "erc/erc-ezbounce.el")
(defconst custom-define-current-source-file "erc-ezbounce.el")

(defgroup erc-ezbounce nil "Interface to the EZBounce IRC bouncer (a virtual IRC server)" :group 'erc)

(defcustom erc-ezb-regexp "^ezbounce!srv$" "\
Regexp used by the EZBouncer to identify itself to the user." :group 'erc-ezbounce :type 'string)

(defcustom erc-ezb-login-alist 'nil "\
Alist of logins suitable for the server we're connecting to.

The alist's format is as follows:

 (((server . port) . (username . password))
  ((server . port) . (username . password))
  ...)" :group 'erc-ezbounce :type '(repeat (cons (cons :tag "Server" string string) (cons :tag "Login" string string))))

;;;***

;;;### (autoloads (erc-fill-column erc-fill-variable-maximum-indentation erc-fill-static-center erc-fill-function erc-fill-prefix erc-fill) "erc-fill" "erc/erc-fill.el")
(defconst custom-define-current-source-file "erc-fill.el")

(defgroup erc-fill nil "Filling means to reformat long lines in different ways." :group 'erc)

(defcustom erc-fill-prefix nil "\
Values used as `fill-prefix' for `erc-fill-variable'.
nil means fill with space, a string means fill with this string." :group 'erc-fill :type '(choice (const nil) string))

(defcustom erc-fill-function 'erc-fill-variable "\
Function to use for filling messages.

Variable Filling with an `erc-fill-prefix' of nil:

<shortnick> this is a very very very long message with no
	    meaning at all

Variable Filling with an `erc-fill-prefix' of four spaces:

<shortnick> this is a very very very long message with no
    meaning at all

Static Filling with `erc-fill-static-center' of 27:

		<shortnick> foo bar baz
	 <a-very-long-nick> foo bar baz quuuuux
		<shortnick> this is a very very very long message with no
			    meaning at all

These two styles are implemented using `erc-fill-variable' and
`erc-fill-static'.  You can, of course, define your own filling
function.  Narrowing to the region in question is in effect while your
function is called." :group 'erc-fill :type '(choice (const :tag "Variable Filling" erc-fill-variable) (const :tag "Static Filling" erc-fill-static) function))

(defcustom erc-fill-static-center 27 "\
Column around which all statically filled messages will be
centered.  This column denotes the point where the ' ' character
between <nickname> and the entered text will be put, thus aligning
nick names right and text left." :group 'erc-fill :type 'integer)

(defcustom erc-fill-variable-maximum-indentation 17 "\
If we indent a line after a long nick, don't indent more then this
characters. Set to nil to disable." :group 'erc-fill :type 'integer)

(defcustom erc-fill-column 78 "\
The column at which a filled paragraph is broken." :group 'erc-fill :type 'integer)

;;;***

;;;### (autoloads (erc-beep-p erc-interpret-mirc-color erc-interpret-controls-p erc-control-characters erc-input-line-position) "erc-goodies" "erc/erc-goodies.el")
(defconst custom-define-current-source-file "erc-goodies.el")

(defcustom erc-input-line-position nil "\
Specify where to position the input line when using `erc-scroll-to-bottom'.

This should be an integer specifying the line of the buffer on which
the input line should stay.  A value of \"-1\" would keep the input
line positioned on the last line in the buffer.  This is passed as an
argument to `recenter'." :group 'erc-display :type '(choice integer (const nil)))

(defgroup erc-control-characters nil "Dealing with control characters" :group 'erc)

(defcustom erc-interpret-controls-p t "\
*If non-nil, display IRC colours and other highlighting effects.

If this is set to the symbol `remove', ERC removes all IRC colors and
highlighting effects.  When this variable is non-nil, it can cause Emacs to run
slowly on systems lacking sufficient CPU speed.  In chatty channels, or in an
emergency (message flood) it can be turned off to save processing time.  See
`erc-toggle-interpret-controls'." :group 'erc-control-characters :type '(choice (const :tag "Highlight control characters" t) (const :tag "Remove control characters" remove) (const :tag "Display raw control characters" nil)))

(defcustom erc-interpret-mirc-color nil "\
*If non-nil, erc will interpret mIRC color codes." :group 'erc-control-characters :type 'boolean)

(defcustom erc-beep-p nil "\
Beep if C-g is in the server message.
The value `erc-interpret-controls-p' must also be t for this to work." :group 'erc-control-characters :type 'boolean)

;;;***

;;;### (autoloads (erc-ibuffer-dangerous-host-char erc-ibuffer-fool-char erc-ibuffer-pal-char erc-ibuffer-keyword-char erc-ibuffer) "erc-ibuffer" "erc/erc-ibuffer.el")
(defconst custom-define-current-source-file "erc-ibuffer.el")

(defgroup erc-ibuffer nil "The Ibuffer group for ERC." :group 'erc)

(defcustom erc-ibuffer-keyword-char ?k "\
Char used to indicate a channel which had keyword traffic lately (hidden)." :group 'erc-ibuffer :type 'character)

(defcustom erc-ibuffer-pal-char ?p "\
Char used to indicate a channel which had pal traffic lately (hidden)." :group 'erc-ibuffer :type 'character)

(defcustom erc-ibuffer-fool-char ?f "\
Char used to indicate a channel which had fool traffic lately (hidden)." :group 'erc-ibuffer :type 'character)

(defcustom erc-ibuffer-dangerous-host-char ?d "\
Char used to indicate a channel which had dangerous-host traffic lately
\(hidden)." :group 'erc-ibuffer :type 'character)

;;;***

;;;### (autoloads (erc-chanlist-mode-hook erc-chanlist-highlight-face erc-chanlist-hide-modeline erc-chanlist-frame-parameters erc-no-list-networks erc-chanlist-progress-message erc-list) "erc-list" "erc/erc-list.el")
(defconst custom-define-current-source-file "erc-list.el")

(defgroup erc-list nil "Display IRC channels in another window when using /LIST" :group 'erc)

(defcustom erc-chanlist-progress-message t "\
*Show progress message while accumulating channel list." :group 'erc-list :type 'boolean)

(defcustom erc-no-list-networks nil "\
*A list of network names on which the /LIST command refuses to work." :group 'erc-list :type '(repeat string))

(defcustom erc-chanlist-frame-parameters nil "\
*If nil, the channel list is displayed in a new window; if non-nil,
this variable holds the frame parameters used to make a frame to
display the channel list." :group 'erc-list :type 'list)

(defcustom erc-chanlist-hide-modeline nil "\
*If nil, the channel list buffer has a modeline, otherwise the modeline is hidden." :group 'erc-list :type 'boolean)

(defcustom erc-chanlist-highlight-face 'erc-chanlist-highlight "\
Face used for highlighting the current line in a list." :type 'face :group 'erc-faces)

(defcustom erc-chanlist-mode-hook nil "\
Hook run by erc-chanlist-mode." :group 'erc-list :type 'hook)

;;;***

;;;### (autoloads (erc-log-file-coding-system erc-save-queries-on-quit erc-log-insert-log-on-open erc-log-channels-directory erc-enable-logging erc-truncate-buffer-on-save erc-save-buffer-on-part erc-generate-log-file-name-function erc-log) "erc-log" "erc/erc-log.el")
(defconst custom-define-current-source-file "erc-log.el")

(defgroup erc-log nil "Logging facilities for ERC." :group 'erc)

(defcustom erc-generate-log-file-name-function 'erc-generate-log-file-name-long "\
*A function to generate a log filename.
The function must take five arguments: BUFFER, TARGET, NICK, SERVER and PORT.
BUFFER is the buffer to be saved,
TARGET is the name of the channel, or the target of the query,
NICK is the current nick,
SERVER and PORT are the parameters used to connect BUFFERs
`erc-server-process'." :group 'erc-log :type '(choice (const erc-generate-log-file-name-long) (const erc-generate-log-file-name-short) (const erc-generate-log-file-name-with-date) (symbol)))

(defcustom erc-save-buffer-on-part nil "\
*Save the channel buffer content using `erc-save-buffer-in-logs' on PART." :group 'erc-log :type 'boolean)

(defcustom erc-truncate-buffer-on-save nil "\
Truncate any ERC (channel, query, server) buffer when it is saved." :group 'erc-log :type 'boolean)

(defcustom erc-enable-logging t "\
If non-nil, ERC will log IRC conversations.
This can either be a boolean value of nil or t, or a function.
If the value is a function, it will be called with one argument, the
name of the current ERC buffer.  One possible function, which saves
all but server buffers is `erc-log-all-but-server-buffers'.

This variable is buffer local.  Setting it via \\[customize] sets the
default value.

Log files are stored in `erc-log-channels-directory'." :group 'erc-log :type '(choice boolean function))

(defcustom erc-log-channels-directory "~/log" "\
The directory to place log files for channels.
Leave blank to disable logging.  If not nil, all the channel
buffers are logged in separate files in that directory.  The
directory should not end with a trailing slash." :group 'erc-log :type '(choice directory (const nil)))

(defcustom erc-log-insert-log-on-open t "\
*Insert log file contents into the buffer if a log file exists." :group 'erc-log :type 'boolean)

(defcustom erc-save-queries-on-quit nil "\
Save all query (also channel) buffers of the server on QUIT.
See the variable `erc-save-buffer-on-part' for details." :group 'erc-log :type 'boolean)

(defcustom erc-log-file-coding-system (if (featurep 'xemacs) 'binary 'emacs-mule) "\
*The coding system ERC should use for writing log files.

This should ideally, be a \"catch-all\" coding system, like
`emacs-mule', or `iso-2022-7bit'." :group 'erc-log)

;;;***

;;;### (autoloads (erc-text-matched-hook erc-beep-match-types erc-log-match-format erc-log-matches-flag erc-log-matches-types-alist erc-dangerous-host-highlight-type erc-keyword-highlight-type erc-fool-highlight-type erc-pal-highlight-type erc-current-nick-highlight-type erc-dangerous-hosts erc-keywords erc-fools erc-pals erc-match) "erc-match" "erc/erc-match.el")
(defconst custom-define-current-source-file "erc-match.el")

(defgroup erc-match nil "Keyword and Friend/Foe/... recognition.\nGroup containing all things concerning pattern matching in ERC\nmessages." :group 'erc)

(defcustom erc-pals nil "\
List of pals on IRC." :group 'erc-match :type '(repeat regexp))

(defcustom erc-fools nil "\
List of fools on IRC." :group 'erc-match :type '(repeat regexp))

(defcustom erc-keywords nil "\
List of keywords to highlight in all incoming messages.
Each entry in the list is either a regexp, or a cons cell with the
regexp in the car and the face to use in the cdr.  If no face is
specified, `erc-keyword-face' is used." :group 'erc-match :type '(repeat (choice regexp (list regexp face))))

(defcustom erc-dangerous-hosts nil "\
List of regexps for hosts to highlight.
Useful to mark nicks from dangerous hosts." :group 'erc-match :type '(repeat regexp))

(defcustom erc-current-nick-highlight-type 'keyword "\
*Determines how to highlight text in which your current nickname appears
\(does not apply to text sent by you).

The following values are allowed:

 nil              - do not highlight the message at all
 'keyword         - highlight all instances of current nickname in message
 'nick            - highlight the nick of the user who typed your nickname
 'nick-or-keyword - highlight the nick of the user who typed your nickname,
                    or all instances of the current nickname if there was
                    no sending user
 'all             - highlight the entire message where current nickname occurs

Any other value disables highlighting of current nickname altogether." :group 'erc-match :type '(choice (const nil) (const nick) (const keyword) (const nick-or-keyword) (const all)))

(defcustom erc-pal-highlight-type 'nick "\
*Determines how to highlight messages by pals.
See `erc-pals'.

The following values are allowed:

    nil   - do not highlight the message at all
    'nick - highlight pal's nickname only
    'all  - highlight the entire message from pal

Any other value disables pal highlighting altogether." :group 'erc-match :type '(choice (const nil) (const nick) (const all)))

(defcustom erc-fool-highlight-type 'nick "\
*Determines how to highlight messages by fools.
See `erc-fools'.

The following values are allowed:

    nil   - do not highlight the message at all
    'nick - highlight fool's nickname only
    'all  - highlight the entire message from fool

Any other value disables fool highlighting altogether." :group 'erc-match :type '(choice (const nil) (const nick) (const all)))

(defcustom erc-keyword-highlight-type 'keyword "\
*Determines how to highlight messages containing keywords.
See variable `erc-keywords'.

The following values are allowed:

    'keyword - highlight keyword only
    'all     - highlight the entire message containing keyword

Any other value disables keyword highlighting altogether." :group 'erc-match :type '(choice (const nil) (const keyword) (const all)))

(defcustom erc-dangerous-host-highlight-type 'nick "\
*Determines how to highlight messages by nicks from dangerous-hosts.
See `erc-dangerous-hosts'.

The following values are allowed:

    'nick - highlight nick from dangerous-host only
    'all  - highlight the entire message from dangerous-host

Any other value disables dangerous-host highlighting altogether." :group 'erc-match :type '(choice (const nil) (const nick) (const all)))

(defcustom erc-log-matches-types-alist '((keyword . "ERC Keywords")) "\
Alist telling ERC where to log which match types.
Valid match type keys are:
- keyword
- pal
- dangerous-host
- fool
- current-nick

The other element of each cons pair in this list is the buffer name to
use for the logged message." :group 'erc-match :type '(repeat (cons (choice :tag "Key" (const keyword) (const pal) (const dangerous-host) (const fool) (const current-nick)) (string :tag "Buffer name"))))

(defcustom erc-log-matches-flag 'away "\
Flag specifying when matched message logging should happen.
When nil, don't log any matched messages.
When t, log messages.
When 'away, log messages only when away." :group 'erc-match :type '(choice (const nil) (const away) (const t)))

(defcustom erc-log-match-format "%t<%n:%c> %m" "\
Format for matched Messages.
This variable specifies how messages in the corresponding log buffers will
be formatted. The various format specs are:

%t Timestamp (uses `erc-timestamp-format' if non-nil or \"[%Y-%m-%d %H:%M] \")
%n Nickname of sender
%u Nickname!user@host of sender
%c Channel in which this was received
%m Message" :group 'erc-match :type 'string)

(defcustom erc-beep-match-types '(current-nick) "\
Types of matches to beep for when a match occurs.
The function `erc-beep-on-match' needs to be added to `erc-text-matched-hook'
for beeping to work." :group 'erc-match :type '(choice (repeat :tag "Beep on match" (choice (const current-nick) (const keyword) (const pal) (const dangerous-host) (const fool))) (const :tag "Don't beep" nil)))

(defcustom erc-text-matched-hook '(erc-log-matches) "\
Hook run when text matches a given match-type.
Functions in this hook are passed as arguments:
\(match-type nick!user@host message) where MATCH-TYPE is a symbol of:
current-nick, keyword, pal, dangerous-host, fool" :options '(erc-log-matches erc-hide-fools erc-beep-on-match) :group 'erc-match :type 'hook)

;;;***

;;;### (autoloads (erc-members-changed-hook) "erc-members" "erc/erc-members.el")
(defconst custom-define-current-source-file "erc-members.el")

(defcustom erc-members-changed-hook nil "\
*This hook is called everytime the variable `erc-members' changes.
Note that if a bunch of changes happen at the same time, the hook is only
called once, at the end." :group 'erc-hooks :type 'hook)

;;;***

;;;### (autoloads (erc-networks-alist erc-server-alist erc-networks) "erc-nets" "erc/erc-nets.el")
(defconst custom-define-current-source-file "erc-nets.el")

(defgroup erc-networks nil "IRC Networks" :group 'erc)

(defcustom erc-server-alist '(("4-irc: Random server" 4-irc "4-irc.com" 6667) ("A5KNet: Random server" A5KNet "irc.a5knet.com" ((6660 6669))) ("AbleNet: Random server" AbleNet "irc.ablenet.org" 6667) ("Accessirc: Random server" Accessirc "irc.accessirc.net" 6667) ("Acestar: Random server" Acestar "irc.acestar.org" 6667) ("Action-IRC: Random server" Action-IRC "irc.action-irc.net" ((6660 6669))) ("AfterNET: Random server" AfterNET "irc.afternet.org" 6667) ("Alternativenet: Random server" Alternativenet "irc.altnet.org" 6667) ("AmigaNet: Random server" AmigaNet "irc.amiganet.org" 6667) ("AngelEyez: Random server" AngelEyez "irc.angeleyez.net" ((6666 7000))) ("AnotherNet: Random server" Anothernet "irc.another.net" (6667 7000)) ("ArabChat: Random server" ArabChat "irc.arabchat.org" ((6660 6667))) ("AsiaTalk: Random server" AsiaTalk "irc.asiatalk.org" ((6667 6669) 7000)) ("AstroLink: Random server" AstroLink "irc.astrolink.org" ((6660 6667))) ("Asylumnet: Random server" Asylumnet "irc.asylum-net.org" ((6661 6669) 7000 7777)) ("Austnet: Random AU server" Austnet "au.austnet.org" 6667) ("Austnet: Random NZ server" Austnet "nz.austnet.org" 6667) ("Austnet: Random SG server" Austnet "sg.austnet.org" 6667) ("Austnet: Random US server" Austnet "us.austnet.org" 6667) ("AwesomeChat: Random server" AwesomeChat "irc.awesomechat.net" ((6661 6669))) ("Awesomechristians: Random server" Awesomechristians "irc.awesomechristians.com" 7000) ("Axenet: Random server" Axenet "irc.axenet.org" ((6660 6667))) ("BeyondIRC: Random server" Beyondirc "irc.beyondirc.net" ((6660 6669))) ("BGIRC: Random server" BGIRC "irc.bulgaria.org" ((6666 6669) 7000)) ("Blabbernet: Random server" Blabbernet "irc.blabber.net" (6667 7000)) ("Blitzed: Random server" Blitzed "irc.blitzed.org" (6667 7000)) ("Brasirc: Random server" Brasirc "irc.brasirc.net" ((6666 6667))) ("Brasirc: BR, PA, Belem" Brasirc "irc.libnet.com.br" ((6666 6668) 7777 8002)) ("BRASnet: Random European server" BRASnet "eu.brasnet.org" ((6665 6669))) ("BRASnet: Random US server" BRASnet "us.brasnet.org" ((6665 6669))) ("BubbleNet: Random server" BubbleNet "irc.bubblenet.org" ((6667 6669))) ("CCnet: Random server" CCnet "irc.cchat.net" (6667 7000)) ("CCnet: US, TX, Dallas" CCnet "irc2.cchat.net" (6667 7000)) ("Chat-Net: Random server" Chat-Net "irc.chat-net.org" 6667) ("Chat-Solutions: Random server" Chat-Solutions "irc.chat-solutions.org" 6667) ("Chatcafe: Random server" Chatcafe "irc.chatcafe.net" 6667) ("Chatchannel: Random server" Chatchannel "irc.chatchannel.org" ((6666 6669) 7000)) ("ChatCircuit: Random server" ChatCircuit "irc.chatcircuit.com" 6668) ("Chatlink: Random server" Chatlink "irc.chatlink.org" 6667) ("Chatnet: Random AU server" Chatnet "au.chatnet.org" 6667) ("Chatnet: Random EU server" Chatnet "eu.chatnet.org" 6667) ("Chatnet: Random US server" Chatnet "us.chatnet.org" 6667) ("ChatNut: Random server" ChatNut "irc.chatnut.net" (6667 7000)) ("Chatpinoy: Random server" Chatpinoy "irc.chatpinoy.com" 6667) ("ChatPR: Random server" ChatPR "irc.chatpr.org" 6667) ("Chatroom: Random server" Chatroom "irc.chatroom.org" 6667) ("Chatster: Random server" Chatster "irc.chatster.org" 6667) ("ChatX: Random server" ChatX "irc.chatx.net" 6667) ("China263: Random server" China263 "irc.263.net" 6667) ("Cineplex1: Random server" Cineplex1 "irc.cineplex1.com" ((6666 6668))) ("CNN: CNN News discussions" CNN "chat.cnn.com" ((6667 6669) 7000)) ("CobraNet: Random server" CobraNet "irc.cobra.net" 6667) ("Coolchat: Random server" Coolchat "irc.coolchat.net" 6667) ("Criten: Random server" Criten "irc.criten.net" 6667) ("Cyberchat: Random server" Cyberchat "irc.cyberchat.org" (6667 6668)) ("CyGanet: Random server" CyGanet "irc.cyga.net" 6667) ("DALnet: AS, MY, Coins" DALnet "coins.dal.net" ((6663 6668) 7000)) ("DALnet: CA, ON, Sodre" DALnet "sodre.on.ca.dal.net" ((6661 6669) 7000)) ("DALnet: EU, DE, Nexgo" DALnet "nexgo.de.eu.dal.net" ((6664 6669) 7000)) ("DALnet: EU, NO, Powertech" DALnet "powertech.no.eu.dal.net" ((6666 6667) 7000)) ("DALnet: EU, SE, Borg" DALnet "borg.se.eu.dal.net" (6667 7000)) ("DALnet: EU, SE, Ced" DALnet "ced.se.eu.dal.net" (6667 7000)) ("DALnet: US, GA, Astro" DALnet "astro.ga.us.dal.net" ((6661 6669) 7000)) ("DALnet: US, GA, Dragons" DALnet "dragons.ga.us.dal.net" ((6661 6669) 7000)) ("DALnet: US, GA, Elysium" DALnet "elysium.ga.us.dal.net" ((6661 6669) 7000)) ("DALnet: US, MA, Twisted" DALnet "twisted.ma.us.dal.net" ((6660 6669) 7001 7002)) ("DALnet: US, MO, Global" DALnet "global.mo.us.dal.net" ((6661 6669) 7000)) ("DALnet: US, NJ, Liberty" DALnet "liberty.nj.us.dal.net" ((6662 6669) 7000)) ("DALnet: US, VA, Wombat" DALnet "wombat.va.us.dal.net" ((6661 6669) 7000)) ("DALnet: Random EU server" DALnet "irc.eu.dal.net" 6667) ("DALnet: Random US server" DALnet "irc.dal.net" ((6660 6667))) ("Dark-Tou-Net: Random server" Dark-Tou-Net "irc.d-t-net.de" 6667) ("Darkfire: Random server" Darkfire "irc.darkfire.net" (6667 7000 8000)) ("DarkMyst: Random server" DarkMyst "irc.darkmyst.org" 6667) ("Darkserv: Random server" Darkserv "irc.darkserv.net" 6667) ("Darksystem: Random server" Darksystem "irc.darksystem.com" 6667) ("Darktree: Random server" Darktree "irc.darktree.net" 6667) ("DayNet: Random server" DayNet "irc.daynet.org" 6667) ("Deepspace: Disability network" Deepspace "irc.deepspace.org" 6667) ("Different: Random server" Different "irc.different.net" 6667) ("Digarix: Random server" Digarix "irc.digarix.net" 6667) ("Digatech: Random server" Digatech "irc.digatech.net" 6667) ("Digital-Base: Random server" Digital-Base "irc.digital-base.net" ((6660 7000))) ("Digitalirc: Random server" Digitalirc "irc.digitalirc.net" 6667) ("Discussioni: Random server" Discussioni "irc.discussioni.org" ((6666 6669))) ("DorukNet: TR, Istanbul" DorukNet "irc.doruk.net.tr" ((6660 6669) 7000 8888)) ("Dreamcast: Random server" Dreamcast "irc0.dreamcast.com" 6667) ("DWChat: Random server" DWChat "irc.dwchat.net" 6667) ("Dynastynet: Random server" Dynastynet "irc.dynastynet.net" 6667) ("EFnet: CA, AB, Edmonton (arcti)" EFnet "irc.arcti.ca" 6667) ("EFnet: CA, AB, Edmonton (mpls)" EFnet "irc.mpls.ca" ((6660 6669))) ("EFnet: CA, ON, Toronto" EFnet "irc2.magic.ca" 6667) ("EFnet: CA, QB, Montreal" EFnet "irc.qeast.net" 6667) ("EFnet: EU, DK, Aarhus" EFnet "irc.inet.tele.dk" 6667) ("EFnet: EU, FI, Helsinki" EFnet "efnet.cs.hut.fi" 6667) ("EFnet: EU, FR, Paris" EFnet "irc.isdnet.fr" ((6667 6669))) ("EFnet: EU, NL, Amsterdam" EFnet "efnet.vuurwerk.nl" 6667) ("EFnet: EU, NO, Homelien" EFnet "irc.homelien.no" (5190 (6666 6667) (7000 7001))) ("EFnet: EU, NO, Oslo" EFnet "irc.daxnet.no" ((6666 7000))) ("EFnet: EU, PL, Warszawa" EFnet "irc.efnet.pl" 6667) ("EFnet: EU, RU, Moscow" EFnet "irc.rt.ru" ((6661 6669))) ("EFnet: EU, SE, Dalarna" EFnet "irc.du.se" ((6666 6669))) ("EFnet: EU, SE, Gothenberg" EFnet "irc.hemmet.chalmers.se" ((6666 7000))) ("EFnet: EU, SE, Sweden" EFnet "irc.light.se" 6667) ("EFnet: EU, UK, London (carrier)" EFnet "irc.carrier1.net.uk" ((6666 6669))) ("EFnet: EU, UK, London (demon)" EFnet "efnet.demon.co.uk" ((6665 6669))) ("EFnet: ME, IL, Inter" EFnet "irc.inter.net.il" ((6665 6669))) ("EFnet: US, AZ, Phoenix" EFnet "irc.easynews.com" (6660 (6665 6667) 7000)) ("EFnet: US, CA, San Jose" EFnet "irc.concentric.net" ((6665 6668))) ("EFnet: US, CA, San Luis Obispo" EFnet "irc.prison.net" ((6666 6667))) ("EFnet: US, GA, Atlanta" EFnet "irc.mindspring.com" ((6660 6669))) ("EFnet: US, MI, Ann Arbor" EFnet "irc.umich.edu" 6667) ("EFnet: US, MN, Twin Cities" EFnet "irc.umn.edu" ((6665 6669))) ("EFnet: US, NY, Mineola" EFnet "irc.lightning.net" ((6665 7000))) ("EFnet: US, NY, New York (east)" EFnet "irc.east.gblx.net" 6667) ("EFnet: US, NY, New York (flamed)" EFnet "irc.flamed.net" ((6665 6669))) ("EFnet: US, TX, Houston" EFnet "ircd.lagged.org" ((6660 6669))) ("EFnet: US, VA, Ashburn" EFnet "irc.secsup.uu.net" ((6665 6669) 8080)) ("EFnet: Random AU server" EFnet "au.rr.efnet.net" 6667) ("EFnet: Random CA server" EFnet "ca.rr.efnet.net" 6667) ("EFnet: Random EU server" EFnet "eu.rr.efnet.net" 6667) ("EFnet: Random US server" EFnet "us.rr.efnet.net" 6667) ("EgyptianIRC: Random server" EgyptianIRC "irc.egyptianirc.net" ((6667 6669))) ("Eircnet: Random server" Eircnet "irc.eircnet.org" ((6660 6669) 7000)) ("Eleethal: Random server" Eleethal "irc.eleethal.com" ((6660 6669) 7000)) ("EntertheGame: Random server" EntertheGame "irc.enterthegame.com" ((6667 6669))) ("EpiKnet: Random server" EpiKnet "irc.epiknet.org" ((6660 6669) 7000 7001)) ("EsperNet: Random server" EsperNet "irc.esper.net" (5555 (6667 6669))) ("Esprit: Random server" Esprit "irc.esprit.net" 6667) ("euIRC: Random server" euIRC "irc.euirc.net" ((6665 6669))) ("Evilzinc: Random server" Evilzinc "irc.evilzinc.net" ((6660 6669) 7000 8000)) ("ExodusIRC: Random server" ExodusIRC "irc.exodusirc.net" ((6660 6669))) ("FDFnet: Random server" FDFnet "irc.fdfnet.net" ((6666 6668) 9999)) ("FEFnet: Random server" FEFnet "irc.fef.net" 6667) ("Financialchat: Random server" Financialchat "irc.financialchat.com" ((6667 6669) 7000)) ("Forestnet: Random server" Forestnet "irc.forestnet.org" (6667 7000)) ("ForeverChat: Random server" ForeverChat "irc.foreverchat.net" ((6660 6669) 7000)) ("Fraggers: Random server" Fraggers "irc.fraggers.co.uk" ((6661 6669) (7000 7001))) ("FreedomChat: Random server" FreedomChat "chat.freedomchat.net" 6667) ("FreedomIRC: Random server" FreedomIRC "irc.freedomirc.net" 6667) ("Freenode: Random server" freenode "irc.freenode.net" 6667) ("Freenode: Random EU server" freenode "irc.eu.freenode.net" 6667) ("Freenode: Random US server" freenode "irc.us.freenode.net" 6667) ("FunNet: Random server" FunNet "irc.funnet.org" 6667) ("Galaxynet: Random server" GalaxyNet "irc.galaxynet.org" ((6662 6668) 7000)) ("Galaxynet: AU, NZ, Auckland" GalaxyNet "auckland.nz.galaxynet.org" ((6661 6669))) ("Galaxynet: EU, BE, Online" GalaxyNet "online.be.galaxynet.org" ((6661 6669))) ("Galaxynet: US, FL, Florida" GalaxyNet "gymnet.us.galaxynet.org" ((6661 6669))) ("Gamesnet: Random east US server" Gamesnet "east.gamesnet.net" 6667) ("Gamesnet: Random west US server" Gamesnet "west.gamesnet.net" 6667) ("GammaForce: Random server" GammaForce "irc.gammaforce.org" ((6660 6669) 7000)) ("GIKInet: Random server" GIKInet "irc.giki.edu.pk" 6667) ("GizNet: Random server" GizNet "irc.giznet.org" ((6666 6669) 7000)) ("Globalchat: Random server" Globalchat "irc.globalchat.org" 6667) ("GlobIRC: Random server" GlobIRC "irc.globirc.net" ((6666 6668) 9999)) ("Goldchat: Random server" Goldchat "irc.goldchat.nl" ((6660 6669) 7000)) ("Goodchatting: Random server" Goodchatting "irc.goodchatting.com" ((6661 6669) 7000)) ("GravityLords: Random server" GravityLords "irc.gravitylords.net" 6667) ("Grnet: Random EU server" GRnet "gr.irc.gr" (6667 7000)) ("Grnet: Random server" GRnet "srv.irc.gr" (6667 7000)) ("Grnet: Random US server" GRnet "us.irc.gr" (6667 7000)) ("GulfChat: Random server" GulfChat "irc.gulfchat.net" ((6660 6669))) ("HabberNet: Random server" HabberNet "irc.habber.net" 6667) ("HanIRC: Random server" HanIRC "irc.hanirc.org" 6667) ("Hellenicnet: Random server" Hellenicnet "irc.mirc.gr" (6667 7000)) ("IceNet: Random server" IceNet "irc.icenet.org.za" 6667) ("ICQnet: Random server" ICQnet "irc.icq.com" 6667) ("Infatech: Random server" Infatech "irc.infatech.net" ((6660 6669))) ("Infinity: Random server" Infinity "irc.infinity-irc.org" 6667) ("Infomatrix: Random server" Infomatrix "irc.infomatrix.net" 6667) ("Inside3D: Random server" Inside3D "irc.inside3d.net" ((6661 6669))) ("InterlinkChat: Random server" InterlinkChat "irc.interlinkchat.net" ((6660 6669) 7000)) ("IRC-Chile: Random server" IRC-Chile "irc.cl" 6667) ("IRC-Hispano: Random server" IRC-Hispano "irc.irc-hispano.org" 6667) ("IRCchat: Random server" IRCchat "irc.ircchat.tk" 6667) ("IRCGate: Random server" IRCGate "irc.ircgate.net" ((6667 6669))) ("IRCGeeks: Random server" IRCGeeks "irc.ircgeeks.org" ((6660 6669))) ("IRChat: Random server" IRChat "irc.irchat.net" ((6660 6669))) ("IrcLordz: Random server" IrcLordz "irc.irclordz.com" 6667) ("IrcMalta: Random server" IrcMalta "irc.ircmalta.org" ((6660 6667))) ("IRCnet: EU, FR, Random" IRCnet "irc.fr.ircnet.net" 6667) ("IRCnet: EU, IT, Random" IRCnet "irc.ircd.it" ((6665 6669))) ("IRCnet: AS, IL, Haifa" IRCnet "ircnet.netvision.net.il" ((6661 6668))) ("IRCnet: AS, JP, Tokyo" IRCnet "irc.tokyo.wide.ad.jp" 6667) ("IRCnet: AS, TW, Seed" IRCnet "irc.seed.net.tw" 6667) ("IRCnet: EU, AT, Linz" IRCnet "linz.irc.at" ((6666 6668))) ("IRCnet: EU, AT, Wien" IRCnet "vienna.irc.at" ((6666 6669))) ("IRCnet: EU, BE, Brussels" IRCnet "irc.belnet.be" 6667) ("IRCnet: EU, BE, Zaventem" IRCnet "ircnet.wanadoo.be" ((6661 6669))) ("IRCnet: EU, CZ, Prague" IRCnet "irc.felk.cvut.cz" 6667) ("IRCnet: EU, DE, Berlin" IRCnet "irc.fu-berlin.de" ((6665 6669))) ("IRCnet: EU, DE, Dusseldorf" IRCnet "irc.freenet.de" ((6665 6669))) ("IRCnet: EU, DE, Stuttgart" IRCnet "irc.belwue.de" ((6665 6669))) ("IRCnet: EU, DK, Copenhagen" IRCnet "irc.ircnet.dk" 6667) ("IRCnet: EU, EE, Tallinn" IRCnet "irc.estpak.ee" ((6666 6668))) ("IRCnet: EU, FI, Helsinki" IRCnet "irc.cs.hut.fi" 6667) ("IRCnet: EU, GR, Thessaloniki" IRCnet "irc.ee.auth.gr" ((6666 6669))) ("IRCnet: EU, HU, Budapest" IRCnet "irc.elte.hu" 6667) ("IRCnet: EU, IS, Reykjavik (ircnet)" IRCnet "irc.ircnet.is" ((6661 6669))) ("IRCnet: EU, IS, Reykjavik (simnet)" IRCnet "irc.simnet.is" ((6661 6669))) ("IRCnet: EU, IT, Rome" IRCnet "irc.tin.it" ((6665 6669))) ("IRCnet: EU, NL, Amsterdam (nlnet)" IRCnet "irc.nl.uu.net" ((6660 6669))) ("IRCnet: EU, NL, Amsterdam (xs4all)" IRCnet "irc.xs4all.nl" ((6660 6669))) ("IRCnet: EU, NL, Enschede" IRCnet "irc.snt.utwente.nl" ((6660 6669))) ("IRCnet: EU, NL, Nijmegen" IRCnet "irc.sci.kun.nl" ((6660 6669))) ("IRCnet: EU, NO, Oslo" IRCnet "irc.ifi.uio.no" 6667) ("IRCnet: EU, NO, Trondheim" IRCnet "irc.pvv.ntnu.no" 6667) ("IRCnet: EU, PL, Lublin" IRCnet "lublin.irc.pl" ((6666 6668))) ("IRCnet: EU, PL, Warsaw" IRCnet "warszawa.irc.pl" ((6666 6668))) ("IRCnet: EU, RU, Moscow" IRCnet "irc.msu.ru" 6667) ("IRCnet: EU, SE, Lulea" IRCnet "irc.ludd.luth.se" ((6661 6669))) ("IRCnet: EU, UK, London (Demon)" IRCnet "ircnet.demon.co.uk" ((6665 6669))) ("IRCnet: EU, UK, London (Easynet)" IRCnet "ircnet.easynet.co.uk" ((6666 6669))) ("IRCnet: US, NY, New York" IRCnet "irc.stealth.net" ((6660 6669))) ("IRCnet: Random AU server" IRCnet "au.ircnet.org" 6667) ("IRCnet: Random EU server" IRCnet "eu.ircnet.org" ((6665 6668))) ("IRCnet: Random US server" IRCnet "us.ircnet.org" ((6665 6668))) ("IRCSoulZ: Random server" IRCSoulZ "irc.ircsoulz.net" 6667) ("IRCSul: BR, PR, Maringa" IRCSul "irc.wnet.com.br" 6667) ("IrcTalk: Random server" IrcTalk "irc.irctalk.net" ((6660 6669))) ("Irctoo: Random server" Irctoo "irc.irctoo.net" 6667) ("IRCtown: Random server" IRCtown "irc.irctown.net" ((6666 6669) 7000)) ("IRCworld: Random server" IRCworld "irc.ircworld.org" 6667) ("ircXtreme: Random server" ircXtreme "irc.ircXtreme.net" ((6660 6669))) ("Israelnet: Random server" Israelnet "irc.israel.net" 6667) ("K0wNet: Random server" K0wNet "irc.k0w.net" ((6660 6669))) ("KDFSnet: Random server" KDFSnet "irc.kdfs.net" ((6667 6669))) ("Kemik: Random server" Kemik "irc.kemik.net" 6667) ("Kewl.Org: Random server" Kewl\.Org "irc.kewl.org" (6667 7000)) ("Kickchat: Random server" Kickchat "irc.kickchat.com" ((6660 6669) 7000)) ("Kidsworld: Random server" KidsWorld "irc.kidsworld.org" ((6666 6669))) ("Knightnet: AF, ZA, Durban" Knightnet "orc.dbn.za.knightnet.net" (6667 5555)) ("Knightnet: US, CA, Goldengate" Knightnet "goldengate.ca.us.knightnet.net" (6667 5555)) ("Konfido.Net: Random server" Konfido\.Net "irc.konfido.net" 6667) ("KreyNet: Random server" Kreynet "irc.krey.net" 6667) ("Krono: Random server" Krono "irc.krono.net" ((6660 6669) 7000)) ("Krushnet: Random server" Krushnet "irc.krushnet.org" 6667) ("LagNet: Random server" LagNet "irc.lagnet.org.za" 6667) ("LagNet: AF, ZA, Cape Town" LagNet "reaper.lagnet.org.za" 6667) ("LagNet: AF, ZA, Johannesburg" LagNet "mystery.lagnet.org.za" 6667) ("Librenet: Random server" Librenet "irc.librenet.net" 6667) ("LinkNet: Random server" LinkNet "irc.link-net.org" ((6667 6669))) ("Liquidized: Random server" Liquidized "irc.liquidized.net" (6667 7000)) ("M-IRC: Random server" M-IRC "irc.m-sys.org" ((6667 6669))) ("MagicStar: Random server" MagicStar "irc.magicstar.net" 6667) ("Mavra: Random server" Mavra "irc.mavra.net" 6667) ("MediaDriven: Random server" MediaDriven "irc.mediadriven.com" ((6667 6669))) ("mIRC-X: Random server" mIRC-X "irc.mircx.com" (6667 7000)) ("Morat: Random server" Morat "irc.morat.net" 6667) ("MusicCity: Random server" MusicCity "chat.musiccity.com" 6667) ("Mysteria: Random server" Mysteria "irc.mysteria.net" (6667 7000)) ("Mysterychat: Random server" Mysterychat "irc.mysterychat.net" ((6667 6669))) ("Mystical: Random server" Mystical "irc.mystical.net" (6667 7000)) ("Narancs: Random server" Narancs "irc.narancs.com" ((6667 6669) 7000)) ("Net-France: Random server" Net-France "irc.net-france.com" 6667) ("Nevernet: Random server" Nevernet "irc.nevernet.net" 6667) ("Newnet: Random server" Newnet "irc.newnet.net" ((6665 6667))) ("Nexusirc: Random server" Nexusirc "irc.nexusirc.org" 6667) ("Nightstar: Random server" NightStar "irc.nightstar.net" ((6665 6669))) ("NitrousNet: Random server" NitrousNet "irc.nitrousnet.net" 6667) ("Novernet: Random server" Novernet "irc.novernet.com" ((6665 6669) 7000)) ("Nullrouted: Random server" Nullrouted "irc.nullrouted.org" ((6666 6669) 7000)) ("NullusNet: Random server" NullusNet "irc.nullus.net" 6667) ("OpChat: Random server" OpChat "irc.opchat.org" ((6667 6669))) ("Othernet: Random server" Othernet "irc.othernet.org" 6667) ("Othernet: US, FL, Miami" Othernet "miami.fl.us.othernet.org" 6667) ("Othernet: US, MO, StLouis" Othernet "stlouis.mo.us.othernet.org" 6667) ("Otherside: Random server" OtherSide "irc.othersideirc.net" 6667) ("Outsiderz: Random server" Outsiderz "irc.outsiderz.com" 6667) ("OzOrg: AU, Perth" OzOrg "iinet.perth.oz.org" 6667) ("Peacefulhaven: Random server" Peacefulhaven "irc.peacefulhaven.net" ((6660 6669) 7000)) ("PhazedIRC: Random server" PhazedIRC "irc.phazedirc.net" 6667) ("Philchat: Random server" Philchat "irc.philchat.net" 6667) ("phrozN: Random server" phrozN "irc.phrozn.net" 6667) ("PiNet: Random server" PiNet "irc.praetorians.org" ((6665 6669))) ("Pinoycentral: Random server" Pinoycentral "chat.abs-cbn.com" 6667) ("Planetarion: Random server" Planetarion "irc.planetarion.com" 6667) ("POLNet: Random server" POLNet "irc.ircnet.pl" 6667) ("Psionics: CA, PQ, Montreal" Psionics "chat.psionics.net" ((6660 6669))) ("PTirc: Random server" PTirc "irc.ptirc.com.pt" 6667) ("PTlink: Random server" PTlink "irc.ptlink.net" 6667) ("PTnet: Random server" PTnet "irc.ptnet.org" 6667) ("QChat: Random server" QChat "irc.qchat.net" 6667) ("QuakeNet: Random German server" QuakeNet "de.quakenet.org" ((6667 6669))) ("QuakeNet: Random server" QuakeNet "irc.quakenet.eu.org" ((6667 6669))) ("QuakeNet: Random Swedish server" QuakeNet "se.quakenet.org" ((6667 6669))) ("QuakeNet: Random UK server" QuakeNet "uk.quakenet.org" ((6667 6669))) ("QuakeNet: Random US server" QuakeNet "us.quakenet.org" ((6667 6669))) ("Realirc: Random server" Realirc "irc.realirc.org" 6667) ("RealmNET: Random server" RealmNET "irc.realmnet.com" 6667) ("Rebelchat: Random server" Rebelchat "irc.rebelchat.org" 6667) ("Red-Latina: Random server" Red-Latina "irc.red-latina.org" 6667) ("RedLatona: Random server" RedLatona "irc.redlatona.net" (6667 6668)) ("Relicnet: Random server" Relicnet "irc.relic.net" 6667) ("Rezosup: Random server" Rezosup "irc.rezosup.org" 6667) ("Risanet: Random server" Risanet "irc.risanet.com" ((6667 6669))) ("Rubiks: Random server" Rubiks "irc.rubiks.net" 6667) ("Rusnet: EU, RU, Tomsk" Rusnet "irc.tsk.ru" ((6667 6669) (7770 7775))) ("Rusnet: EU, RU, Vladivostok" Rusnet "irc.vladivostok.ru" ((6667 6669) (7770 7775))) ("Rusnet: EU, UA, Kiev" Rusnet "irc.kar.net" ((6667 6669) (7770 7775))) ("Sandnet: Random server" Sandnet "irc.sandnet.net" ((6660 6669) 7000)) ("Scunc: Random server" Scunc "irc.scunc.net" 6667) ("SerbianCafe: Random server" SerbianCafe "irc.serbiancafe.ws" ((6665 6669))) ("SexNet: Random server" SexNet "irc.sexnet.org" 6667) ("ShadowFire: Random server" ShadowFire "irc.shadowfire.org" 6667) ("ShadowWorld: Random server" ShadowWorld "irc.shadowworld.net" 6667) ("SkyNet: Random server" SkyNet "irc.bronowski.pl" ((6666 6668))) ("Slashnet: Random server" Slashnet "irc.slashnet.org" 6667) ("SolarStone: Random server" SolarStone "irc.solarstone.net" ((6660 6669))) ("Sorcerynet: Random server" Sorcery "irc.sorcery.net" (6667 7000 9000)) ("Sorcerynet: EU, SE, Karlskrona" Sorcery "nexus.sorcery.net" (6667 7000 9000)) ("Sorcerynet: US, CA, Palo Alto" Sorcery "kechara.sorcery.net" (6667 7000 9000)) ("SourceIRC: Random server" SourceIRC "irc.sourceirc.net" ((6667 6669) 7000)) ("SpaceTronix: Random server" SpaceTronix "irc.spacetronix.net" ((6660 6669) 7000)) ("Spirit-Harmony: Random server" Spirit-Harmony "irc.spirit-harmony.com" ((6661 6669))) ("StarChat: Random server" StarChat "irc.starchat.net" ((6667 6669) 7000)) ("StarEquinox: Random server" StarEquinox "irc.starequinox.net" ((6660 6669))) ("StarLink: Random server" Starlink "irc.starlink.net" ((6660 6669))) ("StarLink-irc: Random server" starlink-irc "irc.starlink-irc.org" 6667) ("StarWars-IRC: Random server" StarWars-IRC "irc.starwars-irc.net" ((6663 6667))) ("Stormdancing: Random server" Stormdancing "irc.stormdancing.net" ((6664 6669) 7000 9000)) ("Superchat: Random server" Superchat "irc.superchat.org" ((6660 6668))) ("Sysopnet: Random server" Sysopnet "irc.sysopnet.org" ((6666 6668))) ("Telstra: Random server" Telstra "irc.telstra.com" ((6667 6669))) ("TR-net: EU, TR, Ankara" TR-net "irc.dominet.com.tr" 6667) ("TR-net: EU, Tr, Istanbul" TR-net "irc.teklan.com.tr" 6667) ("Tri-net: Random server" Tri-net "irc.tri-net.org" 6667) ("TriLink: Random server" TriLink "irc.ft4u.net" 6667) ("TurkishChat: Random server" TurkishChat "irc.turkishchat.org" ((6660 6669) 7000)) ("UberNinja: Random server" UberNinja "irc.uberninja.net" ((6667 6669))) ("UICN: Random server" UICN "irc.uicn.net" 6667) ("UltraIRC: Random server" UltraIRC "irc.ultrairc.net" 6667) ("UnderChat: Random server" UnderChat "irc.underchat.it" ((6660 6669) 7000)) ("Undernet: CA, ON, Toronto" Undernet "toronto.on.ca.undernet.org" ((6661 6669))) ("Undernet: CA, QC, Montreal" Undernet "montreal.qu.ca.undernet.org" ((6660 6669))) ("Undernet: EU, AT, Graz" Undernet "graz.at.eu.undernet.org" ((6661 6669))) ("Undernet: EU, BE, Antwerp" Undernet "flanders.be.eu.undernet.org" ((6660 6669))) ("Undernet: EU, BE, Brussels" Undernet "brussels.be.eu.undernet.org" 6667) ("Undernet: EU, CH, Geneva" Undernet "geneva.ch.eu.undernet.org" ((6660 6669) 7777 8000)) ("Undernet: EU, FR, Caen" Undernet "caen.fr.eu.undernet.org" ((6666 6669))) ("Undernet: EU, NL, Diemen" Undernet "diemen.nl.eu.undernet.org" ((6660 6669))) ("Undernet: EU, NL, Haarlem" Undernet "haarlem.nl.eu.undernet.org" ((6660 6669))) ("Undernet: EU, NO, Oslo" Undernet "oslo.no.eu.undernet.org" ((6660 6669))) ("Undernet: EU, SE, Stockholm" Undernet "stockholm.se.eu.undernet.org" ((6666 6669))) ("Undernet: EU, UK, Surrey" Undernet "surrey.uk.eu.undernet.org" ((6660 6669))) ("Undernet: US, AZ, Mesa" Undernet "mesa.az.us.undernet.org" ((6665 6667))) ("Undernet: US, CA, San Diego" Undernet "sandiego.ca.us.undernet.org" ((6660 6670))) ("Undernet: US, DC, Washington" Undernet "washington.dc.us.undernet.org" ((6660 6669))) ("Undernet: US, KS, Manhattan" Undernet "manhattan.ks.us.undernet.org" ((6660 6669))) ("Undernet: US, NV, Las Vegas" Undernet "lasvegas.nv.us.undernet.org" ((6660 6669))) ("Undernet: US, TX, Austin" Undernet "austin.tx.us.undernet.org" ((6660 6669))) ("Undernet: US, UT, Saltlake" Undernet "saltlake.ut.us.undernet.org" ((6660 6669))) ("Undernet: US, VA, Arlington" Undernet "arlington.va.us.undernet.org" ((6660 6669))) ("Undernet: US, VA, McLean" Undernet "mclean.va.us.undernet.org" ((6666 6669))) ("Undernet: Random EU server" Undernet "eu.undernet.org" 6667) ("Undernet: Random US server" Undernet "us.undernet.org" 6667) ("UnderZ: Random server" UnderZ "irc.underz.org" ((6667 6668))) ("UniChat: Random server" UniChat "irc.uni-chat.net" 6667) ("UnionLatina: Random server" UnionLatina "irc.unionlatina.org" 6667) ("Univers: Random server" Univers "irc.univers.org" ((6665 6669))) ("UnixR: Random server" UnixR "irc.unixr.net" ((6667 6669))) ("Vidgamechat: Random server" Vidgamechat "irc.vidgamechat.com" 6667) ("VirtuaNet: Random server" VirtuaNet "irc.virtuanet.org" ((6660 6669) 7000)) ("Vitamina: Random server" Vitamina "irc.vitamina.ca" 6667) ("Voila: Random server" Voila "irc.voila.fr" 6667) ("Wahou: Random server" Wahou "irc.wahou.org" ((6665 6669))) ("Warpednet: Random server" Warpednet "irc.warped.net" 6667) ("Weaklinks: Random server" Weaklinks "irc.weaklinks.net" ((6667 6669))) ("Webnet: Random server" Webnet "irc.webchat.org" ((6667 6669) 7000)) ("Webnet: US, CA, Santa Clara" Webnet "webmaster.ca.us.webchat.org" ((6661 6669))) ("WinChat: Random server" WinChat "irc.winchat.net" ((6661 6669))) ("WinIRC: Random server" WinIRC "irc.winirc.org" ((6667 6669) 4400)) ("WorldIRC: Random server" WorldIRC "irc.worldirc.org" ((6660 6667))) ("WyldRyde: Random server" WyldRyde "irc.wyldryde.net" ((6666 6669))) ("XentoniX: Random server" XentoniX "irc.xentonix.net" ((6661 6669))) ("Xevion: Random server" Xevion "irc.xevion.net" (6667 7000)) ("XNet: Random server" XNet "irc.xnet.org" 6667) ("XWorld: Random server" XWorld "irc.xworld.org" 6667) ("ZAnet Net: Random server" ZAnetNet "irc.zanet.net" 6667) ("ZAnet Org: UK, London" ZAnetOrg "mystic.zanet.org.za" 6667) ("ZiRC: Random server" ZiRC "irc.zirc.org" ((6660 6669))) ("ZUHnet: Random server" ZUHnet "irc.zuh.net" 6667) ("Zurna: Random server" Zurna "irc.zurna.net" 6667)) "\
Alist of irc servers. (NAME NET HOST PORTS) where
NAME is a name for that server,
NET is a symbol indicating to which network from `erc-networks-alist' this
  server corresponds,
HOST is the servers hostname and
PORTS is either a number, a list of numbers, or a list of port ranges." :group 'erc-networks :type 'sexp)

(defcustom erc-networks-alist '((4-irc "4-irc.com") (A5KNet "a5knet.com") (AbleNet "ablenet.org") (Accessirc "accessirc.net") (Acestar "acestar.org") (Action-IRC "action-irc.net") (AfterNET "afternet.org") (Alternativenet "altnet.org") (AmigaNet "amiganet.org") (AngelEyez "angeleyez.net") (Anothernet "another.net") (ArabChat "arabchat.org") (AsiaTalk "asiatalk.org") (AstroLink "astrolink.org") (Asylumnet "asylumnet.org") (Austnet "austnet.org") (AwesomeChat "awesomechat.net") (Awesomechristians "awesomechristians.com") (Axenet "axenet.org") (Beyondirc "beyondirc.net") (BGIRC "bulgaria.org") (Blabbernet "blabber.net") (Blitzed "blitzed.org") (BrasIRC "brasirc.net") (BRASnet "brasnet.org") (BubbleNet "bubblenet.org") (CCnet "christian-chat.net") (Chat-Net "chat-net.org") (Chat-Solutions "chat-solutions.org") (Chatcafe "chatcafe.net") (Chatchannel "chatchannel.org") (ChatCircuit "chatcircuit.com") (Chatlink "chatlink.org") (Chatnet "chatnet.org") (ChatNut "chatnut.net") (Chatpinoy "chatpinoy.com") (ChatPR "chatpr.org") (Chatroom "chatroom.org") (Chatster "chatster.org") (ChatX "chatx.net") (China263 "263.net") (Cineplex1 "cineplex1.com") (CNN "cnn.com") (CobraNet "cobra.net") (Coolchat "coolchat.net") (Criten "criten.net") (Cyberchat "cyberchat.org") (CyGanet "cyga.net") (DALnet "dal.net") (Dark-Tou-Net "d-t-net.de") (Darkfire "darkfire.net") (DarkMyst "darkmyst.org") (Darkserv "darkserv.net") (Darksystem "darksystem.com") (Darktree "darktree.net") (DayNet "daynet.org") (Deepspace "deepspace.org") (Different "different.net") (Digarix "digarix.net") (Digatech "digatech.net") (Digital-Base "digital-base.net") (Digitalirc "digitalirc.net") (Discussioni "discussioni.org") (DorukNet "doruk.net.tr") (DWChat "dwchat.net") (Dynastynet "dynastynet.net") (EFnet nil) (EgyptianIRC "egyptianirc.net") (Eircnet "eircnet.org") (Eleethal "eleethal.com") (EntertheGame "enterthegame.com") (EpiKnet "epiknet.org") (EsperNet "esper.net") (Esprit "esprit.net") (euIRC "euirc.net") (Evilzinc "evilzinc.net") (ExodusIRC "exodusirc.net") (FDFnet "fdfnet.net") (FEFnet "fef.net") (Financialchat "financialchat.com") (Forestnet "forestnet.org") (ForeverChat "foreverchat.net") (Fraggers "fraggers.co.uk") (FreedomChat "freedomchat.net") (FreedomIRC "freedomirc.net") (freenode "freenode.net") (FunNet "funnet.org") (GalaxyNet "galaxynet.org") (Gamesnet "gamesnet.net") (GammaForce "gammaforce.org") (GIKInet "giki.edu.pk") (GizNet "giznet.org") (Globalchat "globalchat.org") (GlobIRC "globirc.net") (Goldchat "goldchat.nl") (Goodchatting "goodchatting.com") (GravityLords "gravitylords.net") (GRnet "irc.gr") (GulfChat "gulfchat.net") (HabberNet "habber.net") (HanIRC "hanirc.org") (Hellenicnet "mirc.gr") (IceNet "icenet.org.za") (ICQnet "icq.com") (iip "anon.iip") (Infatech "infatech.net") (Infinity "infinity-irc.org") (Infomatrix "infomatrix.net") (Inside3D "inside3d.net") (InterlinkChat "interlinkchat.net") (IRC-Chile "irc.cl") (IRC-Hispano "irc-hispano.org") (IRCchat "ircchat.tk") (IRCGate "ircgate.net") (IRCGeeks "ircgeeks.org") (IRChat "irchat.net") (IrcLordz "irclordz.com") (IrcMalta "ircmalta.org") (IRCnet nil) (IRCSoulZ "ircsoulz.net") (IRCSul "wnet.com.br") (IrcTalk "irctalk.net") (Irctoo "irctoo.net") (IRCtown "irc.irctown.net") (IRCworld "ircworld.org") (ircXtreme "ircXtreme.net") (Israelnet "israel.net") (K0wNet "k0w.net") (KDFSnet "kdfs.net") (Kemik "kemik.net") (Kewl\.Org "kewl.org") (Kickchat "kickchat.com") (KidsWorld "kidsworld.org") (Knightnet "knightnet.net") (Konfido\.Net "konfido.net") (Kreynet "krey.net") (Krono "krono.net") (Krushnet "krushnet.org") (LagNet "lagnet.org.za") (Librenet "librenet.net") (LinkNet "link-net.org") (Liquidized "liquidized.net") (M-IRC "m-sys.org") (MagicStar "magicstar.net") (Mavra "mavra.net") (MediaDriven "mediadriven.com") (mIRC-X "mircx.com") (Morat "morat.net") (MusicCity "musiccity.com") (Mysteria "mysteria.net") (Mysterychat "mysterychat.net") (Mystical "mystical.net") (Narancs "narancs.com") (Net-France "net-france.com") (Nevernet "nevernet.net") (Newnet "newnet.net") (Nexusirc "nexusirc.org") (NightStar "nightstar.net") (NitrousNet "nitrousnet.net") (Novernet "novernet.com") (Nullrouted "nullrouted.org") (NullusNet "nullus.net") (OpChat "opchat.org") (Openprojects "openprojects.net") (Othernet "othernet.org") (OtherSide "othersideirc.net") (Outsiderz "outsiderz.com") (OzOrg "oz.org") (Peacefulhaven "peacefulhaven.net") (PhazedIRC "phazedirc.net") (Philchat "philchat.net") (phrozN "phrozn.net") (PiNet "praetorians.org") (Pinoycentral "abs-cbn.com") (Planetarion "planetarion.com") (POLNet "ircnet.pl") (Psionics "psionics.net") (PTirc "ptirc.com.pt") (PTlink "ptlink.net") (PTnet "ptnet.org") (QChat "qchat.net") (QuakeNet "quakenet.org") (Realirc "realirc.org") (RealmNET "realmnet.com") (Rebelchat "rebelchat.org") (Red-Latina "red-latina.org") (RedLatona "redlatona.net") (Relicnet "relic.net") (Rezosup "rezosup.org") (Risanet "risanet.com") (Rubiks "rubiks.net") (Rusnet "nil") (Sandnet "sandnet.net") (Scunc "scunc.net") (SerbianCafe "serbiancafe.ws") (SexNet "sexnet.org") (ShadowFire "shadowfire.org") (ShadowWorld "shadowworld.net") (SkyNet "bronowski.pl") (SlashNET "slashnet.org") (SolarStone "solarstone.net") (Sorcery "sorcery.net") (SourceIRC "sourceirc.net") (SpaceTronix "spacetronix.net") (Spirit-Harmony "spirit-harmony.com") (StarChat "starchat.net") (StarEquinox "starequinox.net") (Starlink "starlink.net") (starlink-irc "starlink-irc.org") (StarWars-IRC "starwars-irc.net") (Stormdancing "stormdancing.net") (Superchat "superchat.org") (Sysopnet "sysopnet.org") (Telstra "telstra.com") (TR-net "dominet.com.tr") (Tri-net "tri-net.org") (TriLink "ft4u.net") (TurkishChat "turkishchat.org") (UberNinja "uberninja.net") (UICN "uicn.net") (UltraIRC "ultrairc.net") (UnderChat "underchat.it") (Undernet "undernet.org") (UnderZ "underz.org") (UniChat "irc.uni-chat.net") (UnionLatina "unionlatina.org") (Univers "univers.org") (UnixR "unixr.net") (Vidgamechat "vidgamechat.com") (VirtuaNet "virtuanet.org") (Vitamina "vitamina.ca") (Voila "voila.fr") (Wahou "wf-net.org") (Warpednet "warped.net") (Weaklinks "weaklinks.net") (Webnet "webchat.org") (WinChat "winchat.net") (WinIRC "winirc.org") (WorldIRC "worldirc.org") (WyldRyde "wyldryde.net") (XentoniX "xentonix.net") (Xevion "xevion.net") (XNet "xnet.org") (XWorld "xworld.org") (ZAnetNet "zanet.net") (ZAnetOrg "zanet.org.za") (ZiRC "zirc.org") (ZUHnet "zuh.net") (Zurna "zurna.net")) "\
Alist of IRC networks. (NET MATCHER) where
NET is a symbol naming that IRC network and
MATCHER is used to find a corresponding network to a server while connected to
  it. If it is regexp, it's used to match against `erc-server-announced-name'.
  It can also be a function (predicate). Then it is executed with the
  server buffer as current-buffer." :group 'erc-networks :type '(repeat (list :tag "Network" (symbol :tag "Network name") (choice :tag "Network's common server ending" (regexp) (const :tag "Network has no common server ending" nil)))))

;;;***

;;;### (autoloads (erc-netjoin-hook erc-netsplit-hook erc-netsplit-regexp erc-netsplit-debug erc-netsplit-show-server-mode-changes-flag erc-netsplit) "erc-netsplit" "erc/erc-netsplit.el")
(defconst custom-define-current-source-file "erc-netsplit.el")

(defgroup erc-netsplit nil "Netsplit detection tries to automatically figure when a\nnetsplit happens, and filters the QUIT messages. It also keeps\ntrack of netsplits, so that it can filter the JOIN messages on a netjoin too." :group 'erc)

(defcustom erc-netsplit-show-server-mode-changes-flag nil "\
Set to t to enable display of server mode changes." :group 'erc-netsplit :type 'boolean)

(defcustom erc-netsplit-debug nil "\
If non-nil, debug messages will be shown in the
sever buffer." :group 'erc-netsplit :type 'boolean)

(defcustom erc-netsplit-regexp "^[^ @!\"\n]+\\.[^ @!\n]+ [^ @!\n]+\\.[^ @!\"\n]+$" "\
This regular expression should match quit reasons produced
by netsplits." :group 'erc-netsplit :type 'regexp)

(defcustom erc-netsplit-hook nil "\
Run whenever a netsplit is detected the first time.
Args: PROC is the process the netsplit originated from and
      SPLIT is the netsplit (e.g. \"server.name.1 server.name.2\")." :group 'erc-hooks :type 'hook)

(defcustom erc-netjoin-hook nil "\
Run whenever a netjoin is detected the first time.
Args: PROC is the process the netjoin originated from and
      SPLIT is the netsplit (e.g. \"server.name.1 server.name.2\")." :group 'erc-hooks :type 'hook)

;;;***

;;;### (autoloads (erc-nicklist-window-size erc-nicklist-voiced-position erc-nicklist-icons-directory erc-nicklist-use-icons erc-nicklist) "erc-nicklist" "erc/erc-nicklist.el")
(defconst custom-define-current-source-file "erc-nicklist.el")

(defgroup erc-nicklist nil "Display a list of nicknames in a separate window." :group 'erc)

(defcustom erc-nicklist-use-icons t "\
*If non-nil, display an icon instead of the name of the chat medium.
By \"chat medium\", we mean IRC, AOL, MSN, ICQ, etc." :group 'erc-nicklist :type 'boolean)

(defcustom erc-nicklist-icons-directory (concat default-directory "images/") "\
*Directory of the PNG files for chat icons.
Icons are displayed if `erc-nicklist-use-icons' is non-nil." :group 'erc-nicklist :type 'string)

(defcustom erc-nicklist-voiced-position 'bottom "\
*Position of voiced nicks in the nicklist.
The value can be `top', `bottom' or nil (don't sort)." :group 'erc-nicklist :type '(choice (const :tag "Top" 'top) (const :tag "Bottom" 'bottom) (const :tag "Mixed" nil)))

(defcustom erc-nicklist-window-size 20.0 "\
*The size of the nicklist window.

This specifies a percentage of the channel window width.

A negative value means the nicklist window appears on the left of the
channel window, and vice versa." :group 'erc-nicklist :type 'float)

;;;***

;;;### (autoloads (erc-nickserv-alist erc-nickserv-passwords erc-prompt-for-nickserv-password erc-nickserv-identify-mode erc-services) "erc-nickserv" "erc/erc-nickserv.el")
(defconst custom-define-current-source-file "erc-nickserv.el")

(defgroup erc-services nil "Configuration for IRC services.\n\nOn some networks, there exists a special type of automated irc bot,\ncalled Services.  Those usually allow you to register your nickname,\npost/read memos to other registered users who are currently offline,\nand do various other things.\n\nThis group allows you to set variables to somewhat automate\ncommunication with those Services." :group 'erc)

(defcustom erc-nickserv-identify-mode 'autodetect "\
The mode which is used when identifying to Nickserv.

Possible settings are:.

'autodetect  - Identify when the real Nickserv sends an identify request.
'nick-change - Identify when you change your nickname.
nil          - Disables automatic Nickserv identification.

You can also use M-x erc-nickserv-identify-mode to change modes." :group 'erc-services :type '(choice (const autodetect) (const nick-change) (const nil)) :set (lambda (sym val) (set-default sym val) (erc-nickserv-identify-mode val)))

(defcustom erc-prompt-for-nickserv-password t "\
Ask for the password when identifying to NickServ." :group 'erc-services :type 'boolean)

(defcustom erc-nickserv-passwords nil "\
Passwords used when identifying to NickServ automatically.

Example of use:
  (setq erc-nickserv-passwords
        '((freenode ((\"nick-one\" . \"password\")
                     (\"nick-two\" . \"password\")))
          (DALnet ((\"nick\" . \"password\")))))" :group 'erc-services :type '(repeat (list :tag "Network" (choice :tag "Network name" (const freenode) (const DALnet) (const GalaxyNet) (const SlashNET) (const BRASnet) (const iip) (const Austnet) (symbol :tag "Network name")) (repeat :tag "Nickname and password" (cons :tag "Identity" (string :tag "Nick") (string :tag "Password"))))))

(defcustom erc-nickserv-alist '((DALnet "NickServ!service@dal.net" "/msg\\s-NickServ@services.dal.net\\s-IDENTIFY\\s-<password>" "NickServ@services.dal.net" "IDENTIFY" nil) (freenode "NickServ!NickServ@services." "/msg\\s-NickServ\\s-IDENTIFY\\s-<password>" "NickServ" "IDENTIFY" nil) (GalaxyNet "NS!nickserv@galaxynet.org" "Please\\s-change\\s-nicks\\s-or\\s-authenticate." "NS@services.galaxynet.org" "AUTH" t) (SlashNET "NickServ!services@services.slashnet.org" "/msg\\s-NickServ\\s-IDENTIFY\\s-password" "NickServ@services.slashnet.org" "IDENTIFY" nil) (iip "Trent@anon.iip" "type\\s-/squery\\s-Trent\\s-identify\\s-<password>" "Trent@anon.iip" "IDENTIFY" nil "SQUERY") (BRASnet "NickServ!services@brasnet.org" "/NickServ\\s-IDENTIFY\\s-senha" "NickServ" "IDENTIFY" nil "") (Austnet "NickOP!service@austnet.org" "/msg\\s-NickOP@austnet.org\\s-identify\\s-<password>" "nickop@austnet.org" "identify" nil) (Azzurra "NickServ!service@azzurra.org" "/ns\\s-IDENTIFY\\s-password" "NickServ" "IDENTIFY" nil) (OFTC "NickServ!services@services.oftc.net" "/msg\\s-NickServ\\s-IDENTIFY\\s-password" "NickServ" "IDENTIFY" nil)) "\
Alist of NickServer details, sorted by network.
Every element in the list has the form
  (SYMBOL NICKSERV REGEXP NICK KEYWORD USE-CURRENT ANSWER)

SYMBOL is a network identifier, a symbol, as used in `erc-networks-alist'.
NICKSERV is the description of the nickserv in the form nick!user@host.
REGEXP is a regular expression matching the message from nickserv.
NICK is nickserv's nickname.  Use nick@server where necessary/possible.
KEYWORD is the keyword to use in the reply message to identify yourself.
USE-CURRENT indicates whether the current nickname must be used when
  identifying.
ANSWER is the command to use for the answer.  The default is 'privmsg.
  This last element is optional." :group 'erc-services :type '(repeat (list :tag "Nickserv data" (symbol :tag "Network name") (string :tag "Nickserv's nick!user@host") (regexp :tag "Identify request sent by Nickserv") (string :tag "Identify to") (string :tag "Identify keyword") (boolean :tag "Use current nick in identify message?") (choice :tag "Command to use (optional)" (string :tag "Command") (const :tag "No special command necessary" nil)))))

;;;***

;;;### (autoloads (erc-notify-signoff-hook erc-notify-signon-hook erc-notify-interval erc-notify-list erc-notify) "erc-notify" "erc/erc-notify.el")
(defconst custom-define-current-source-file "erc-notify.el")

(defgroup erc-notify nil "Track online status of certain nicknames." :group 'erc)

(defcustom erc-notify-list nil "\
*List of nicknames you want to be notified about online/offline
status change." :group 'erc-notify :type '(repeat string))

(defcustom erc-notify-interval 60 "\
*Time interval (in seconds) for checking online status of notificated
people." :group 'erc-notify :type 'integer)

(defcustom erc-notify-signon-hook nil "\
*Hook run after someone on `erc-notify-list' has signed on.
Two arguments are passed to the function, SERVER and NICK, both
strings." :group 'erc-notify :type 'hook :options '(erc-notify-signon))

(defcustom erc-notify-signoff-hook nil "\
*Hook run after someone on `erc-notify-list' has signed off.
Two arguments are passed to the function, SERVER and NICK, both
strings." :group 'erc-notify :type 'hook :options '(erc-notify-signoff))

;;;***

;;;### (autoloads (erc-ctcp-query-PAGE-hook erc-page-function erc-page) "erc-page" "erc/erc-page.el")
(defconst custom-define-current-source-file "erc-page.el")

(defgroup erc-page nil "React to CTCP PAGE messages." :group 'erc)

(defcustom erc-page-function nil "\
A function to process a \"page\" request.
If nil, this prints the page message in the minibuffer and calls
`beep'.  If non-nil, it must be a function that takes two arguments:
SENDER and MSG, both strings.

Example for your ~/.emacs file:

\(setq erc-page-function
      (lambda (sender msg)
	(play-sound-file \"/home/alex/elisp/erc/sounds/ni.wav\")
	(message \"IRC Page from %s: %s\" sender msg)))" :group 'erc-page :type '(choice (const nil) (function)))

(defcustom erc-ctcp-query-PAGE-hook '(erc-ctcp-query-PAGE) "\
List of functions to be called when a CTCP PAGE is received.
This is called from `erc-process-ctcp-query'.  The functions are called
with six arguments: PROC NICK LOGIN HOST TO MSG.  Note that you can
also set `erc-page-function' to a function, which only gets two arguments,
SENDER and MSG, so that might be easier to use." :group 'erc-page :type '(repeat function))

;;;***

;;;### (autoloads (erc-pcomplete-order-nickname-completions erc-pcomplete-nick-postfix erc-pcomplete) "erc-pcomplete" "erc/erc-pcomplete.el")
(defconst custom-define-current-source-file "erc-pcomplete.el")

(defgroup erc-pcomplete nil "Programmable completion for ERC" :group 'erc)

(defcustom erc-pcomplete-nick-postfix ": " "\
*When `pcomplete' is used in the first word after the prompt,
add this string to nicks completed." :group 'erc-pcomplete :type 'string)

(defcustom erc-pcomplete-order-nickname-completions t "\
If t, channel nickname completions will be ordered such that
the most recent speakers are listed first." :group 'erc-pcomplete :type 'boolean)

;;;***

;;;### (autoloads (erc-replace-alist erc-replace) "erc-replace" "erc/erc-replace.el")
(defconst custom-define-current-source-file "erc-replace.el")

(defgroup erc-replace nil "Replace text from incoming messages" :group 'erc)

(defcustom erc-replace-alist nil "\
Alist describing text to be replaced in incoming messages.
This is useful for filters.

The alist has elements of the form (FROM . TO).  FROM can be a regular
expression or a variable, or any sexp, TO can be a string or a
function to call, or any sexp.  If a function, it will be called with
one argument, the string to be replaced, and it should return a
replacement string." :group 'erc-replace :type '(repeat (cons :tag "Search & Replace" (choice :tag "From" regexp variable sexp) (choice :tag "To" string function sexp))))

;;;***

;;;### (autoloads (erc-play-command erc-default-sound erc-sound-path erc-play-sound erc-sound) "erc-sound" "erc/erc-sound.el")
(defconst custom-define-current-source-file "erc-sound.el")

(defgroup erc-sound nil "Make ERC play bells and whistles while chatting with people." :group 'erc)

(defcustom erc-play-sound t "\
*Play sound on SOUND ctcp requests (used in ICQ chat)." :group 'erc-sound :type 'boolean)

(defcustom erc-sound-path nil "\
List of directories that contain sound samples to play on SOUND events." :group 'erc-sound :type '(repeat directory))

(defcustom erc-default-sound nil "\
Play this sound if the requested file was not found." :group 'erc-sound :type '(choice (const nil) file))

(defcustom erc-play-command "play" "\
Command for playing sound samples." :group 'erc-sound :type 'string)

;;;***

;;;### (autoloads (erc-speak-channel-personality erc-speak-smiley-personality erc-speak-smileys erc-speak-acronyms erc-speak-filter-timestamp erc-speak-filter-host erc-speak-personalities erc-speak) "erc-speak" "erc/erc-speak.el")
(defconst custom-define-current-source-file "erc-speak.el")

(defgroup erc-speak nil "Enable speech synthesis with the ERC chat client using Emacspeak" :group 'erc)

(defcustom erc-speak-personalities '((erc-default-face paul) (erc-direct-msg-face paul-animated) (erc-input-face paul-smooth) (erc-bold-face paul-bold) (erc-inverse-face betty) (erc-underline-face ursula) (erc-prompt-face harry) (erc-notice-face paul-italic) (erc-action-face paul-monotone) (erc-error-face kid) (erc-dangerous-host-face paul-surprized) (erc-pal-face paul-animated) (erc-fool-face paul-angry) (erc-keyword-face paul-animated)) "\
Maps faces used in erc to speaker personalities in emacspeak." :group 'erc-speak :type '(repeat (list :tag "mapping" (symbol :tag "face") (symbol :tag "personality"))))

(defcustom erc-speak-filter-host t "\
Set to t if you want to filter out user@host constructs." :group 'erc-speak :type 'bool)

(defcustom erc-speak-filter-timestamp t "\
If non-nil, try to filter out the timestamp when speaking arriving messages.

Note, your erc-timestamp-format variable needs to start with a [
and end with ]." :group 'erc-speak :type 'bool)

(defcustom erc-speak-acronyms '(("brb" "be right back") ("btw" "by the way") ("wtf" "what the fuck") ("rotfl" "rolling on the floor and laughing") ("afaik" "as far as I know") ("afaics" "as far as I can see") ("iirc" "if I remember correctly")) "\
List of acronyms to expand." :group 'erc-speak :type '(repeat sexp))

(defcustom erc-speak-smileys '((":-)" "smiling face") (":)" "smiling face") (":-(" "sad face") (":(" "sad face")) "\
List of smileys and their textual description." :group 'erc-speak :type '(repeat (list 'symbol 'symbol)))

(defcustom erc-speak-smiley-personality 'harry "\
Personality used for smiley announcements." :group 'erc-speak :type 'symbol)

(defcustom erc-speak-channel-personality 'harry "\
*Personality to announce channel names with." :group 'erc-speak :type 'symbol)

;;;***

;;;### (autoloads (erc-speedbar-sort-users-type erc-speedbar) "erc-speedbar" "erc/erc-speedbar.el")
(defconst custom-define-current-source-file "erc-speedbar.el")

(defgroup erc-speedbar nil "Integration of ERC in the Speedbar" :group 'erc)

(defcustom erc-speedbar-sort-users-type 'activity "\
How channel nicknames are sorted.

'activity     - Sort users by channel activity
'alphabetical - Sort users alphabetically
nil           - Do not sort users" :group 'erc-speedbar :type '(choice (const :tag "Sort users by channel activity" activity) (const :tag "Sort users alphabetically" alphabetical) (const :tag "Do not sort users" nil)))

;;;***

;;;### (autoloads (erc-spelling-dictionaries) "erc-spelling" "erc/erc-spelling.el")
(defconst custom-define-current-source-file "erc-spelling.el")

(defcustom erc-spelling-dictionaries nil "\
An alist mapping buffer names to dictionaries.
The `car' of every cell is a buffer name, the `cadr' is the
string name of an associated dictionary.
The dictionary is inherited from server buffers, so if you want a
default dictionary for some server, you can use a server buffer
name here." :type '(choice (const nil) (repeat (cons (string :tag "Buffer name") (string :tag "Dictionary")))) :group 'erc-spelling)

;;;***

;;;### (autoloads (erc-timestamp-use-align-to erc-timestamp-right-column erc-timestamp-only-if-changed-flag erc-timestamp-intangible erc-echo-timestamp-format erc-echo-timestamps erc-hide-timestamps erc-insert-away-timestamp-function erc-away-timestamp-format erc-insert-timestamp-function erc-timestamp-format erc-stamp) "erc-stamp" "erc/erc-stamp.el")
(defconst custom-define-current-source-file "erc-stamp.el")

(defgroup erc-stamp nil "For long conversation on IRC it is sometimes quite\nuseful to have individual messages timestamp.  This\ngroup provides settings related to the format and display\nof timestamp information in `erc-mode' buffer.\n\nFor timestamping to be activated, you just need to load `erc-stamp'\nin your .emacs file or interactively using `load-library'." :group 'erc)

(defcustom erc-timestamp-format "[%H:%M]" "\
*If set to a string, messages will be timestamped.
This string is processed using `format-time-string'.
Good examples are \"%T\" and \"%H:%M\".

If nil, timestamping is turned off." :group 'erc-stamp :type '(choice (const nil) (string)))

(defcustom erc-insert-timestamp-function 'erc-insert-timestamp-right "\
*Function to use to insert timestamps.

It takes a single argument STRING which is the final string
which all text-properties already appended.  This function only cares about
inserting this string at the right position.  Narrowing is in effect
while it is called, so (point-min) and (point-max) determine the region to
operate on." :group 'erc-stamp :type '(choice (const :tag "Right" erc-insert-timestamp-right) (const :tag "Left" erc-insert-timestamp-left) function))

(defcustom erc-away-timestamp-format "<%H:%M>" "\
*Timestamp format used when marked as being away.

If nil, timestamping is turned off when away unless `erc-timestamp-format'
is set.

If `erc-timestamp-format' is set, this will not be used." :group 'erc-stamp :type '(choice (const nil) (string)))

(defcustom erc-insert-away-timestamp-function 'erc-insert-timestamp-right "\
*Function to use to insert the away timestamp.

See `erc-insert-timestamp-function' for details." :group 'erc-stamp :type '(choice (const :tag "Right" erc-insert-timestamp-right) (const :tag "Left" erc-insert-timestamp-left) function))

(defcustom erc-hide-timestamps nil "\
*If non-nil, timestamps will be invisible.

This is useful for logging, because, although timestamps will be
hidden, they will still be present in the logs." :group 'erc-stamp :type 'boolean)

(defcustom erc-echo-timestamps nil "\
*If non-nil, print timestamp in the minibuffer when point is moved.
Using this variable, you can turn off normal timestamping,
and simply move point to an irc message to see its timestamp
printed in the minibuffer." :group 'erc-stamp :type 'boolean)

(defcustom erc-echo-timestamp-format "Timestamped %A, %H:%M:%S" "\
*Format string to be used when `erc-echo-timestamps' is non-nil.
This string specifies the format of the timestamp being echoed in
the minibuffer." :group 'erc-stamp :type 'string)

(defcustom erc-timestamp-intangible t "\
*Whether the timestamps should be intangible, i.e. prevent the point
from entering them and instead jump over them." :group 'erc-stamp :type 'boolean)

(defcustom erc-timestamp-only-if-changed-flag t "\
*Insert timestamp only if its value changed since last insertion.
If `erc-insert-timestamp-function' is `erc-insert-timestamp-left', a
string of spaces which is the same size as the timestamp is added to
the beginning of the line in its place. If you use
`erc-insert-timestamp-right', nothing gets inserted in place of the
timestamp." :group 'erc-stamp :type 'boolean)

(defcustom erc-timestamp-right-column nil "\
*If non-nil, the column at which the timestamp is inserted,
if the timestamp is to be printed to the right.  If nil,
`erc-insert-timestamp-right' will use other means to determine
the correct column." :group 'erc-stamp :type '(choice (integer :tag "Column number") (const :tag "Unspecified" nil)))

(defcustom erc-timestamp-use-align-to (and (not (featurep 'xemacs)) (>= emacs-major-version 22) (eq window-system 'x)) "\
*If non-nil, use the :align-to display property to align the stamp.
This gives better results when variable-width characters (like
Asian language characters and math symbols) precede a timestamp.
Unfortunately, it only works in Emacs 22 and when using the X
Window System.

A side effect of enabling this is that there will only be one
space before a right timestamp in any saved logs." :group 'erc-stamp :type 'boolean)

;;;***

;;;### (autoloads (erc-track-switch-direction erc-track-switch-from-erc erc-track-showcount-string erc-track-showcount erc-track-position-in-mode-line erc-track-priority-faces-only erc-track-faces-priority-list erc-track-use-faces erc-track-shorten-function erc-track-shorten-aggressively erc-track-shorten-cutoff erc-track-shorten-start erc-track-exclude-server-buffer erc-track-exclude-types erc-track-exclude erc-track-visibility erc-track) "erc-track" "erc/erc-track.el")
(defconst custom-define-current-source-file "erc-track.el")

(defgroup erc-track nil "Track active buffers and show activity in the modeline." :group 'erc)

(defcustom erc-track-visibility t "\
Where do we look for buffers to determine their visibility?
The value of this variable determines, when a buffer is considered
visible or invisible.  New messages in invisible buffers are tracked,
while switching to visible buffers when they are tracked removes them
from the list.  See also `erc-track-when-inactive-mode'.

Possible values are:

t                - all frames
visible          - all visible frames
nil              - only the selected frame
selected-visible - only the selected frame if it is visible

Activity means that there was no user input in the last 10 seconds." :group 'erc-track :type '(choice (const :tag "All frames" t) (const :tag "All visible frames" visible) (const :tag "Only the selected frame" nil) (const :tag "Only the selected frame if it was active" active)))

(defcustom erc-track-exclude nil "\
A list targets (channel names or query targets) which should not be tracked." :group 'erc-track :type '(repeat string))

(defcustom erc-track-exclude-types '("NICK") "\
*List of message types to be ignored.
This list could look like '(\"JOIN\" \"PART\")." :group 'erc-track :type 'erc-message-type)

(defcustom erc-track-exclude-server-buffer nil "\
*If true, don't perform tracking on the server buffer; this is
useful for excluding all the things like MOTDs from the server and
other miscellaneous functions." :group 'erc-track :type 'boolean)

(defcustom erc-track-shorten-start 1 "\
This number specifies the minimum number of characters a channel name in
the mode-line should be reduced to." :group 'erc-track :type 'number)

(defcustom erc-track-shorten-cutoff 4 "\
All channel names longer than this value will be shortened." :group 'erc-track :type 'number)

(defcustom erc-track-shorten-aggressively nil "\
*If non-nil, channel names will be shortened more aggressively.
Usually, names are not shortened if this will save only one character.
Example: If there are two channels, #linux-de and #linux-fr, then
normally these will not be shortened.  When shortening aggressively,
however, these will be shortened to #linux-d and #linux-f.

If this variable is set to `max', then channel names will be shortened
to the max.  Usually, shortened channel names will remain unique for a
given set of existing channels.  When shortening to the max, the shortened
channel names will be unique for the set of active channels only.
Example: If there are tow active channels #emacs and #vi, and two inactive
channels #electronica and #folk, then usually the active channels are
shortened to #em and #v.  When shortening to the max, however, #emacs is
not compared to #electronica -- only to #vi, therefore it can be shortened
even more and the result is #e and #v.

This setting is used by `erc-track-shorten-names'." :group 'erc-track :type '(choice (const :tag "No" nil) (const :tag "Yes" t) (const :tag "Max" max)))

(defcustom erc-track-shorten-function 'erc-track-shorten-names "\
*This function will be used to reduce the channel names before display.
It takes one argument, CHANNEL-NAMES which is a list of strings.
It should return a list of strings of the same number of elements.
If nil instead of a function, shortening is disabled." :group 'erc-track :type '(choice (const :tag "Disabled") function))

(defcustom erc-track-use-faces t "\
*Use faces in the mode-line.
The faces used are the same as used for text in the buffers.
\(e.g. `erc-pal-face' is used if a pal sent a message to that channel.)" :group 'erc-track :type 'boolean)

(defcustom erc-track-faces-priority-list '(erc-error-face erc-current-nick-face erc-keyword-face erc-pal-face erc-nick-msg-face erc-direct-msg-face erc-button erc-dangerous-host-face erc-default-face erc-action-face erc-nick-default-face erc-fool-face erc-notice-face erc-input-face erc-prompt-face) "\
A list of faces used to highlight active buffer names in the modeline.
If a message contains one of the faces in this list, the buffer name will
be highlighted using that face.  The first matching face is used." :group 'erc-track :type '(repeat face))

(defcustom erc-track-priority-faces-only nil "\
Only track text highlighted with a priority face.
If you would like to ignore changes in certain channels where there
are no faces corresponding to your `erc-track-faces-priority-list', set
this variable.  You can set a list of channel name strings, so those
will be ignored while all other channels will be tracked as normal.
Other options are 'all, to apply this to all channels or nil, to disable
this feature.
Note: If you have a lot of faces listed in `erc-track-faces-priority-list',
setting this variable might not be very useful." :group 'erc-track :type '(choice (const nil) (repeat string) (const all)))

(defcustom erc-track-position-in-mode-line 'before-modes "\
Where to show modified channel information in the mode-line.

Setting this variable only has effects in GNU Emacs versions above 21.3.

Choices are:
'before-modes - add to the beginning of `mode-line-modes'
'after-modes  - add to the end of `mode-line-modes'

Any other value means add to the end of `global-mode-string'." :group 'erc-track :type '(choice (const :tag "Just before mode information" before-modes) (const :tag "Just after mode information" after-modes) (const :tag "After all other information" nil)) :set (lambda (sym val) (set sym val) (when (and (boundp 'erc-track-mode) erc-track-mode) (erc-track-remove-from-mode-line) (erc-track-add-to-mode-line val))))

(defcustom erc-track-showcount nil "\
If non-nil, count of unseen messages will be shown for each channel." :type 'boolean :group 'erc-track)

(defcustom erc-track-showcount-string ":" "\
The string to display between buffer name and the count in the mode line.
The default is a colon, resulting in \"#emacs:9\"." :type 'string :group 'erc-track)

(defcustom erc-track-switch-from-erc t "\
If non-nil, `erc-track-switch-buffer' will return to the last non-erc buffer
when there are no more active channels." :type 'boolean :group 'erc-track)

(defcustom erc-track-switch-direction 'oldest "\
Direction `erc-track-switch-buffer' should switch.

  oldest      -  find oldest active buffer
  newest      -  find newest active buffer
  leastactive -  find buffer with least unseen messages
  mostactive  -  find buffer with most unseen messages." :group 'erc-track :type '(choice (const oldest) (const newest) (const leastactive) (const mostactive)))

;;;***

;;;### (autoloads (erc-max-buffer-size erc-truncate) "erc-truncate" "erc/erc-truncate.el")
(defconst custom-define-current-source-file "erc-truncate.el")

(defgroup erc-truncate nil "Truncate buffers when they reach a certain size" :group 'erc)

(defcustom erc-max-buffer-size 30000 "\
*Maximum size in chars of each ERC buffer.
Used only when auto-truncation is enabled.
\(see `erc-truncate-buffer' and `erc-insert-post-hook')." :group 'erc-truncate :type 'integer)

;;;***

;;;### (autoloads (erc-xdcc-help-text erc-xdcc-handler-alist erc-xdcc-verbose-flag erc-xdcc-files) "erc-xdcc" "erc/erc-xdcc.el")
(defconst custom-define-current-source-file "erc-xdcc.el")

(defcustom erc-xdcc-files nil "\
*List of files to offer via XDCC.
Your friends should issue \"/ctcp yournick XDCC list\" to see this." :group 'erc-dcc :type '(repeat file))

(defcustom erc-xdcc-verbose-flag t "\
*Report XDCC CTCP requests in the server buffer." :group 'erc-dcc :type 'boolean)

(defcustom erc-xdcc-handler-alist '(("help" . erc-xdcc-help) ("list" . erc-xdcc-list) ("send" . erc-xdcc-send)) "\
*Sub-command handler alist for XDCC CTCP queries." :group 'erc-dcc :type '(alist :key-type (string :tag "Sub-command") :value-type function))

(defcustom erc-xdcc-help-text '(("Hey " nick ", wondering how this works?  Pretty easy.") ("Available commands: XDCC [" (mapconcat 'car erc-xdcc-handler-alist "|") "]") ("Type \"/ctcp " (erc-current-nick) " XDCC list\" to see the list of offered files, then type \"/ctcp " (erc-current-nick) " XDCC send #\" to get a particular file number.")) "\
*Help text sent in response to XDCC help command.
A list of messages, each consisting of strings and expressions, expressions
being evaluated and should return stings." :group 'erc-dcc :type '(repeat (repeat :tag "Message" (choice string sexp))))

;;;***

;;;### (autoloads (erc-kill-buffer-hook erc-kill-channel-hook erc-kill-server-hook erc-mode-line-away-status-format erc-common-server-suffixes erc-show-channel-key-p erc-header-line-face-method erc-header-line-uses-help-echo-p erc-header-line-format erc-mode-line-format erc-channel-members-changed-hook erc-format-nick-function erc-server-hooks erc-minibuffer-ignored erc-minibuffer-notice erc-format-query-as-channel-p erc-query-on-unjoined-chan-privmsg erc-auto-query erc-default-server-hook erc-after-connect erc-before-connect erc-modules erc-reuse-buffers erc-frame-dedicated-flag erc-frame-alist erc-join-buffer erc-faces erc-send-completed-hook erc-send-post-hook erc-send-modify-hook erc-insert-post-hook erc-insert-modify-hook erc-send-pre-hook erc-insert-pre-hook erc-timer-hook erc-mode-hook erc-hooks erc-part-reason erc-quit-reason erc-part-reason-various-alist erc-quit-reason-various-alist erc-kill-server-buffer-on-quit erc-kill-queries-on-quit erc-kill-buffer-on-part erc-script-echo erc-script-path erc-startup-file-list erc-ignore-reply-list erc-ignore-list erc-email-userid erc-prompt-for-channel-key erc-anonymous-login erc-disable-ctcp-replies erc-paranoid erc-away-nickname erc-public-away-p erc-verbose-server-ping erc-whowas-on-nosuchnick erc-echo-notice-always-hook erc-echo-notice-hook erc-notice-highlight-type erc-notice-prefix erc-command-indicator erc-prompt erc-connect-pre-hook erc-nick-changed-functions erc-kick-hook erc-part-hook erc-quit-hook erc-join-hook erc-complete-functions erc-disconnected-hook erc-hide-list erc-show-my-nick erc-hide-prompt erc-send-whitespace-lines erc-warn-about-blank-lines erc-prompt-for-password erc-user-mode erc-user-full-name erc-manual-set-nick-on-bad-nick-p erc-nick-uniquifier erc-nick erc-port erc-server erc-scripts erc-paranoia erc-quit-and-part erc-query erc-ignore erc-mode-line-and-header erc-display erc-buffers erc) "erc" "erc/erc.el")
(defconst custom-define-current-source-file "erc.el")

(defgroup erc nil "Emacs Internet Relay Chat client." :link '(url-link "http://www.emacswiki.org/cgi-bin/wiki.pl?EmacsIRCClient") :prefix "erc-" :group 'applications)

(defgroup erc-buffers nil "Creating new ERC buffers" :group 'erc)

(defgroup erc-display nil "Settings for how various things are displayed" :group 'erc)

(defgroup erc-mode-line-and-header nil "Displaying information in the mode-line and header" :group 'erc-display)

(defgroup erc-ignore nil "Ignoring certain messages" :group 'erc)

(defgroup erc-query nil "Using separate buffers for private discussions" :group 'erc)

(defgroup erc-quit-and-part nil "Quitting and parting channels" :group 'erc)

(defgroup erc-paranoia nil "Know what is sent and received; control the display of sensitive data." :group 'erc)

(defgroup erc-scripts nil "Running scripts at startup and with /LOAD" :group 'erc)

(defcustom erc-server nil "\
IRC server to use.
See function `erc-compute-server' for more details on connection
parameters and authentication." :group 'erc :type '(choice (const nil) string))

(defcustom erc-port nil "\
IRC port to use." :group 'erc :type '(choice (const nil) number string))

(defcustom erc-nick nil "\
Nickname to use.

Can be either a string, or a list of strings.
In the latter case, if the first nick in the list is already in use,
other nicks are tried in the list order.

See function `erc-compute-nick' for more details on connection
parameters and authentication." :group 'erc :type '(choice (const nil) (string :tag "Nickname") (repeat string)))

(defcustom erc-nick-uniquifier "`" "\
The character to append to the nick if it is already in use." :group 'erc :type 'string)

(defcustom erc-manual-set-nick-on-bad-nick-p nil "\
If the nickname you chose isn't available, ERC should not automatically
attempt to set another nickname.  You can manually set another nickname with
the /NICK command." :group 'erc :type 'boolean)

(defcustom erc-user-full-name nil "\
User full name.

See function `erc-compute-full-name' for more details on connection
parameters and authentication." :group 'erc :type '(choice (const nil) string function) :set (lambda (sym val) (if (functionp val) (set sym (funcall val)) (set sym val))))

(defcustom erc-user-mode nil "\
Initial user modes to be set after a connection is established." :group 'erc :type '(choice (const nil) string function))

(defcustom erc-prompt-for-password t "\
Asks before using the default password, or whether to enter a new one." :group 'erc :type 'boolean)

(defcustom erc-warn-about-blank-lines t "\
Warn the user if they attempt to send a blank line." :group 'erc :type 'boolean)

(defcustom erc-send-whitespace-lines nil "\
If set to non-nil, send lines consisting of only whitespace." :group 'erc :type 'boolean)

(defcustom erc-hide-prompt nil "\
If non-nil, do not display the prompt for commands.

\(A command is any input starting with a '/').

See also the variables `erc-prompt' and `erc-command-indicator'." :group 'erc-display :type 'boolean)

(defcustom erc-show-my-nick t "\
If non-nil, display one's own nickname when sending a message.

If non-nil, \"<nickname>\" will be shown.
If nil, only \"> \" will be shown." :group 'erc-display :type 'boolean)

(defcustom erc-hide-list nil "\
*List of IRC type messages to hide.
A typical value would be '(\"JOIN\" \"PART\" \"QUIT\")." :group 'erc-ignore :type 'erc-message-type)

(defcustom erc-disconnected-hook nil "\
Run this hook with arguments (NICK IP REASON) when disconnected.
This happens before automatic reconnection.  Note, that
`erc-server-QUIT-functions' might not be run when we disconnect,
simply because we do not necessarily receive the QUIT event." :group 'erc-hooks :type 'hook)

(defcustom erc-complete-functions nil "\
These functions get called when the user hits TAB in ERC.
Each function in turn is called until one returns non-nil to
indicate it has handled the input." :group 'erc-hooks :type 'hook)

(defcustom erc-join-hook nil "\
Hook run when we join a channel.  Hook functions are called
without arguments, with the current buffer set to the buffer of
the new channel.

See also `erc-server-JOIN-functions', `erc-part-hook'." :group 'erc-hooks :type 'hook)

(defcustom erc-quit-hook nil "\
Hook run when processing a quit command directed at our nick.

The hook receives one argument, the current PROCESS.
See also `erc-server-QUIT-functions' and `erc-disconnected-hook'." :group 'erc-hooks :type 'hook)

(defcustom erc-part-hook nil "\
Hook run when processing a PART message directed at our nick.

The hook receives one argument, the current BUFFER.
See also `erc-server-QUIT-functions', `erc-quit-hook' and
`erc-disconnected-hook'." :group 'erc-hooks :type 'hook)

(defcustom erc-kick-hook nil "\
Hook run when processing a KICK message directed at our nick.

The hook receives one argument, the current BUFFER.
See also `erc-server-PART-functions' and `erc-part-hook'." :group 'erc-hooks :type 'hook)

(defcustom erc-nick-changed-functions nil "\
List of functions run when your nick was successfully changed.

Each function should accept two arguments, NEW-NICK and OLD-NICK." :group 'erc-hooks :type 'hook)

(defcustom erc-connect-pre-hook '(erc-initialize-log-marker) "\
Hook called just before `erc' calls `erc-connect'.
Functions are run in the buffer-to-be." :group 'erc-hooks :type 'hook)

(defcustom erc-prompt "ERC>" "\
Prompt used by ERC.  Trailing whitespace is not required." :group 'erc-display :type '(choice string function))

(defcustom erc-command-indicator nil "\
Indicator used by ERC for showing commands.

If non-nil, this will be used in the ERC buffer to indicate
commands (i.e., input starting with a '/').

If nil, the prompt will be constructed from the variable `erc-prompt'." :group 'erc-display :type '(choice (const nil) string function))

(defcustom erc-notice-prefix "*** " "\
*Prefix for all notices." :group 'erc-display :type 'string)

(defcustom erc-notice-highlight-type 'all "\
*Determines how to highlight notices.
See `erc-notice-prefix'.

The following values are allowed:

    'prefix - highlight notice prefix only
    'all    - highlight the entire notice

Any other value disables notice's highlighting altogether." :group 'erc-display :type '(choice (const :tag "highlight notice prefix only" prefix) (const :tag "highlight the entire notice" all) (const :tag "don't highlight notices at all" nil)))

(defcustom erc-echo-notice-hook nil "\
*Specifies a list of functions to call to echo a private
notice.  Each function is called with four arguments, the string
to display, the parsed server message, the target buffer (or
nil), and the sender.  The functions are called in order, until a
function evaluates to non-nil.  These hooks are called after
those specified in `erc-echo-notice-always-hook'.

See also: `erc-echo-notice-always-hook',
`erc-echo-notice-in-default-buffer',
`erc-echo-notice-in-target-buffer',
`erc-echo-notice-in-minibuffer',
`erc-echo-notice-in-server-buffer',
`erc-echo-notice-in-active-non-server-buffer',
`erc-echo-notice-in-active-buffer',
`erc-echo-notice-in-user-buffers',
`erc-echo-notice-in-user-and-target-buffers',
`erc-echo-notice-in-first-user-buffer'" :group 'erc-hooks :type 'hook :options '(erc-echo-notice-in-default-buffer erc-echo-notice-in-target-buffer erc-echo-notice-in-minibuffer erc-echo-notice-in-server-buffer erc-echo-notice-in-active-non-server-buffer erc-echo-notice-in-active-buffer erc-echo-notice-in-user-buffers erc-echo-notice-in-user-and-target-buffers erc-echo-notice-in-first-user-buffer))

(defcustom erc-echo-notice-always-hook '(erc-echo-notice-in-default-buffer) "\
*Specifies a list of functions to call to echo a private
notice.  Each function is called with four arguments, the string
to display, the parsed server message, the target buffer (or
nil), and the sender.  The functions are called in order, and all
functions are called.  These hooks are called before those
specified in `erc-echo-notice-hook'.

See also: `erc-echo-notice-hook',
`erc-echo-notice-in-default-buffer',
`erc-echo-notice-in-target-buffer',
`erc-echo-notice-in-minibuffer',
`erc-echo-notice-in-server-buffer',
`erc-echo-notice-in-active-non-server-buffer',
`erc-echo-notice-in-active-buffer',
`erc-echo-notice-in-user-buffers',
`erc-echo-notice-in-user-and-target-buffers',
`erc-echo-notice-in-first-user-buffer'" :group 'erc-hooks :type 'hook :options '(erc-echo-notice-in-default-buffer erc-echo-notice-in-target-buffer erc-echo-notice-in-minibuffer erc-echo-notice-in-server-buffer erc-echo-notice-in-active-non-server-buffer erc-echo-notice-in-active-buffer erc-echo-notice-in-user-buffers erc-echo-notice-in-user-and-target-buffers erc-echo-notice-in-first-user-buffer))

(defcustom erc-whowas-on-nosuchnick nil "\
*If non-nil, do a whowas on a nick if no such nick." :group 'erc :type 'boolean)

(defcustom erc-verbose-server-ping nil "\
*If non-nil, show every time you get a PING or PONG from the server." :group 'erc-paranoia :type 'boolean)

(defcustom erc-public-away-p nil "\
*Let others know you are back when you are no longer marked away.
This happens in this form:
* <nick> is back (gone for <time>)

Many consider it impolite to do so automatically." :group 'erc :type 'boolean)

(defcustom erc-away-nickname nil "\
*The nickname to take when you are marked as being away." :group 'erc :type '(choice (const nil) string))

(defcustom erc-paranoid nil "\
If non-nil, then all incoming CTCP requests will be shown." :group 'erc-paranoia :type 'boolean)

(defcustom erc-disable-ctcp-replies nil "\
Disable replies to CTCP requests that require a reply.
If non-nil, then all incoming CTCP requests that normally require
an automatic reply (like VERSION or PING) will be ignored.  Good to
set if some hacker is trying to flood you away." :group 'erc-paranoia :type 'boolean)

(defcustom erc-anonymous-login t "\
Be paranoid, don't give away your machine name." :group 'erc-paranoia :type 'boolean)

(defcustom erc-prompt-for-channel-key nil "\
Prompt for channel key when using `erc-join-channel' interactively" :group 'erc :type 'boolean)

(defcustom erc-email-userid "user" "\
Use this as your email user ID." :group 'erc :type 'string)

(defcustom erc-ignore-list nil "\
*List of regexps matching user identifiers to ignore.

A user identifier has the form \"nick!login@host\".  If an
identifier matches, the message from the person will not be
processed." :group 'erc-ignore :type '(repeat regexp))

(defcustom erc-ignore-reply-list nil "\
*List of regexps matching user identifiers to ignore completely.

This differs from `erc-ignore-list' in that it also ignores any
messages directed at the user.

A user identifier has the form \"nick!login@host\".

If an identifier matches, or a message is addressed to a nick
whose identifier matches, the message will not be processed.

CAVEAT: ERC doesn't know about the user and host of anyone who
was already in the channel when you joined, but never said
anything, so it won't be able to match the user and host of those
people. You can update the ERC internal info using /WHO *." :group 'erc-ignore :type '(repeat regexp))

(defcustom erc-startup-file-list '("~/.ercrc.el" "~/.ercrc" ".ercrc.el" ".ercrc") "\
List of files to try for a startup script.
The first existent and readable one will get executed.

If the filename ends with `.el' it is presumed to be an emacs-lisp
script and it gets (load)ed.  Otherwise is is treated as a bunch of
regular IRC commands" :group 'erc-scripts :type '(repeat file))

(defcustom erc-script-path nil "\
List of directories to look for a script in /load command.
The script is first searched in the current directory, then in each
directory in the list." :group 'erc-scripts :type '(repeat directory))

(defcustom erc-script-echo t "\
*If not-NIL, echo the IRC script commands locally." :group 'erc-scripts :type 'boolean)

(defcustom erc-kill-buffer-on-part nil "\
Kill the channel buffer on PART.
This variable should probably stay nil, as ERC can reuse buffers if
you rejoin them later." :group 'erc-quit-and-part :type 'boolean)

(defcustom erc-kill-queries-on-quit nil "\
Kill all query (also channel) buffers of this server on QUIT.
See the variable `erc-kill-buffer-on-part' for details." :group 'erc-quit-and-part :type 'boolean)

(defcustom erc-kill-server-buffer-on-quit nil "\
Kill the server buffer of the process on QUIT." :group 'erc-quit-and-part :type 'boolean)

(defcustom erc-quit-reason-various-alist nil "\
Alist of possible arguments to the /quit command.

Each element has the form:
  (REGEXP RESULT)

If REGEXP matches the argument to /quit, then its relevant RESULT
will be used.  RESULT may be either a string, or a function.  If
a function, it should return the quit message as a string.

If no elements match, then the empty string is used.

As an example:
  (setq erc-quit-reason-various-alist
      '((\"zippy\" erc-quit-reason-zippy)
	(\"xmms\" dme:now-playing)
	(\"version\" erc-quit-reason-normal)
	(\"home\" \"Gone home !\")
	(\"\" \"Default Reason\")))
If the user types \"/quit zippy\", then a Zippy the Pinhead quotation
will be used as the quit message." :group 'erc-quit-and-part :type '(repeat (list regexp (choice (string) (function)))))

(defcustom erc-part-reason-various-alist nil "\
Alist of possible arguments to the /part command.

Each element has the form:
  (REGEXP RESULT)

If REGEXP matches the argument to /part, then its relevant RESULT
will be used.  RESULT may be either a string, or a function.  If
a function, it should return the part message as a string.

If no elements match, then the empty string is used.

As an example:
  (setq erc-part-reason-various-alist
      '((\"zippy\" erc-part-reason-zippy)
	(\"xmms\" dme:now-playing)
	(\"version\" erc-part-reason-normal)
	(\"home\" \"Gone home !\")
	(\"\" \"Default Reason\")))
If the user types \"/part zippy\", then a Zippy the Pinhead quotation
will be used as the part message." :group 'erc-quit-and-part :type '(repeat (list regexp (choice (string) (function)))))

(defcustom erc-quit-reason 'erc-quit-reason-normal "\
*A function which returns the reason for quitting.

The function is passed a single argument, the string typed by the
user after \"/quit\"." :group 'erc-quit-and-part :type '(choice (const erc-quit-reason-normal) (const erc-quit-reason-zippy) (const erc-quit-reason-various) (symbol)))

(defcustom erc-part-reason 'erc-part-reason-normal "\
A function which returns the reason for parting a channel.

The function is passed a single argument, the string typed by the
user after \"/PART\"." :group 'erc-quit-and-part :type '(choice (const erc-part-reason-normal) (const erc-part-reason-zippy) (const erc-part-reason-various) (symbol)))

(defgroup erc-hooks nil "Hook variables for fancy customizations of ERC." :group 'erc)

(defcustom erc-mode-hook nil "\
Hook run after `erc-mode' setup is finished." :group 'erc-hooks :type 'hook :options '(erc-add-scroll-to-bottom))

(defcustom erc-timer-hook nil "\
Put functions which should get called more or less periodically here.
The idea is that servers always play ping pong with the client, and so there
is no need for any idle-timer games with Emacs." :group 'erc-hooks :type 'hook)

(defcustom erc-insert-pre-hook nil "\
Hook called first when some text is inserted through `erc-display-line'.
It gets called with one argument, STRING.
To be able to modify the inserted text, use `erc-insert-modify-hook' instead.
Filtering functions can set `erc-insert-this' to nil to avoid
display of that particular string at all." :group 'erc-hooks :type 'hook)

(defcustom erc-send-pre-hook nil "\
Hook called first when some text is sent through `erc-send-current-line'.
It gets called with one argument, STRING.

To change the text that will be sent, set the variable STR which is
used in `erc-send-current-line'.

To change the text inserted into the buffer without changing the text
that will be sent, use `erc-send-modify-hook' instead.

Filtering functions can set `erc-send-this' to nil to avoid sending of
that particular string at all and `erc-insert-this' to prevent
inserting that particular string into the buffer.

Note that it's useless to set `erc-send-this' to nil and
`erc-insert-this' to t.  ERC is sane enough to not insert the text
anyway." :group 'erc-hooks :type 'hook)

(defcustom erc-insert-modify-hook nil "\
Insertion hook for functions that will change the text's appearance.
This hook is called just after `erc-insert-pre-hook' when the value
of `erc-insert-this' is t.
While this hook is run, narrowing is in effect and `current-buffer' is
the buffer where the text got inserted.  One possible value to add here
is `erc-fill'." :group 'erc-hooks :type 'hook)

(defcustom erc-insert-post-hook nil "\
This hook is called just after `erc-insert-modify-hook'.
At this point, all modifications from prior hook functions are done." :group 'erc-hooks :type 'hook :options '(erc-truncate-buffer erc-make-read-only erc-save-buffer-in-logs))

(defcustom erc-send-modify-hook nil "\
Sending hook for functions that will change the text's appearance.
This hook is called just after `erc-send-pre-hook' when the values
of `erc-send-this' and `erc-insert-this' are both t.
While this hook is run, narrowing is in effect and `current-buffer' is
the buffer where the text got inserted.

Note that no function in this hook can change the appearance of the
text that is sent.  Only changing the sent text's appearance on the
sending user's screen is possible.  One possible value to add here
is `erc-fill'." :group 'erc-hooks :type 'hook)

(defcustom erc-send-post-hook nil "\
This hook is called just after `erc-send-modify-hook'.
At this point, all modifications from prior hook functions are done.
NOTE: The functions on this hook are called _before_ sending a command
to the server.

This function is called with narrowing, ala `erc-send-modify-hook'" :group 'erc-hooks :type 'hook :options '(erc-make-read-only))

(defcustom erc-send-completed-hook (when (featurep 'emacspeak) (list (byte-compile (lambda (str) (emacspeak-auditory-icon 'select-object))))) "\
Hook called after a message has been parsed by ERC.

The single argument to the functions is the unmodified string
which the local user typed." :group 'erc-hooks :type 'hook)

(defgroup erc-faces nil "Faces for ERC." :group 'erc)

(defcustom erc-join-buffer 'buffer "\
Determines how to display the newly created IRC buffer.
'window - in another window,
'window-noselect - in another window, but don't select that one,
'frame - in another frame,
'bury - bury it in a new buffer,
any other value - in place of the current buffer" :group 'erc-buffers :type '(choice (const window) (const window-noselect) (const frame) (const bury) (const buffer)))

(defcustom erc-frame-alist nil "\
*Alist of frame parameters for creating erc frames.
A value of `nil means to use `default-frame-alist'." :group 'erc-buffers :type '(repeat (cons :format "%v" (symbol :tag "Parameter") (sexp :tag "Value"))))

(defcustom erc-frame-dedicated-flag nil "\
*Non-nil means the erc frames are dedicated to that buffer.
This only has effect when `erc-join-buffer' is set to `frame'." :group 'erc-buffers :type 'boolean)

(defcustom erc-reuse-buffers t "\
*If nil, create new buffers on joining a channel/query.
If non-nil, a new buffer will only be created when you join
channels with same names on different servers, or have query buffers
open with nicks of the same name on different servers.  Otherwise,
the existing buffers will be reused." :group 'erc-buffers :type 'boolean)

(defcustom erc-modules '(netsplit fill button match track pcomplete readonly ring autojoin noncommands irccontrols stamp) "\
A list of modules which erc should enable.
If you set the value of this without using `customize' remember to call
\(erc-update-modules) after you change it.  When using `customize', modules
removed from the list will be disabled." :set (lambda (sym val) (when (and (boundp 'erc-modules) erc-modules val) (dolist (module erc-modules) (unless (member module val) (let ((f (intern-soft (format "erc-%s-mode" module)))) (when (and (fboundp f) (boundp f) (symbol-value f)) (message "Disabling `erc-%s'" module) (funcall f 0)))))) (set-default sym val) (when (fboundp 'erc-update-modules) (erc-update-modules))) :type '(set :greedy t (const :tag "Set away status automatically" autoaway) (const :tag "Join channels automatically" autojoin) (const :tag "Integrate with Big Brother Database" bbdb) (const :tag "Buttonize URLs, nicknames, and other text" button) (const :tag "Wrap long lines" fill) (const :tag "Highlight or remove IRC control characters" irccontrols) (const :tag "Save buffers in logs" log) (const :tag "Highlight pals, fools, and other keywords" match) (const :tag "Detect netsplits" netsplit) (const :tag "Don't display non-IRC commands after evaluation" noncommands) (const :tag "Notify when the online status of certain users changes" notify) (const :tag "Complete nicknames and commands (programmable)" pcomplete) (const :tag "Complete nicknames and commands (old)" completion) (const :tag "Make displayed lines read-only" readonly) (const :tag "Replace text in messages" replace) (const :tag "Enable an input history" ring) (const :tag "Scroll to the bottom of the buffer" scrolltobottom) (const :tag "Identify to Nickserv (IRC Services) automatically" services) (const :tag "Convert smileys to pretty icons" smiley) (const :tag "Play sounds when you receive CTCP SOUND requests" sound) (const :tag "Add timestamps to messages" stamp) (const :tag "Check spelling" spelling) (const :tag "Track channel activity in the mode-line" track) (const :tag "Truncate buffers to a certain size" truncate) (const :tag "Translate morse code in messages" unmorse) (repeat :tag "Others" :inline t symbol)) :group 'erc)

(defcustom erc-before-connect nil "\
Hook called before connecting to a server.
This hook gets executed before `erc-select' actually invokes `erc-mode'
with your input data.  The functions in here get called with three
parameters, SERVER, PORT and NICK." :group 'erc-hooks :type 'hook)

(defcustom erc-after-connect nil "\
Hook called after connecting to a server.
This hook gets executed when an end of MOTD has been received.	All
functions in here get called with the parameters SERVER and NICK." :group 'erc-hooks :type 'hook)

(defcustom erc-default-server-hook '(erc-debug-missing-hooks erc-default-server-handler) "\
*Default for server messages which aren't covered by `erc-server-hooks'." :group 'erc-server-hooks :type 'hook)

(defcustom erc-auto-query nil "\
If non-nil, create a query buffer each time you receive a private message.

If the buffer doesn't already exist it is created.  This can be
set to a symbol, to control how the new query window should
appear.  See the documentation for `erc-join-buffer' for
available choices." :group 'erc-query :type '(choice (const nil) (const buffer) (const window) (const window-noselect) (const bury) (const frame)))

(defcustom erc-query-on-unjoined-chan-privmsg t "\
If non-nil create query buffer on receiving any PRIVMSG at all.
This includes PRIVMSGs directed to channels.  If you are using an IRC
bouncer, such as dircproxy, to keep a log of channels when you are
disconnected, you should set this option to t." :group 'erc-query :type 'boolean)

(defcustom erc-format-query-as-channel-p t "\
If non-nil, format text from others in a query buffer like in a channel,
otherwise format like a private message." :group 'erc-query :type 'boolean)

(defcustom erc-minibuffer-notice nil "\
If non-nil, print ERC notices for the user in the minibuffer.
Only happens when the session buffer isn't visible." :group 'erc-display :type 'boolean)

(defcustom erc-minibuffer-ignored nil "\
If non-nil, print a message in the minibuffer if we ignored something." :group 'erc-ignore :type 'boolean)

(defgroup erc-server-hooks nil "Server event callbacks.\nEvery server event - like numeric replies - has it's own hook.\nThose hooks are all called using `run-hook-with-args-until-success'.\nThey receive as first argument the process object from where the event\noriginated from,\nand as second argument the event parsed as a vector." :group 'erc-hooks)

(defcustom erc-format-nick-function 'erc-format-nick "\
*Function to format a nickname for message display." :group 'erc-display :type 'function)

(defcustom erc-channel-members-changed-hook nil "\
*This hook is called every time the variable `channel-members' changes.
The buffer where the change happened is current while this hook is called." :group 'erc-hooks :type 'hook)

(defcustom erc-mode-line-format "%s %a" "\
A string to be formatted and shown in the mode-line in `erc-mode'.

The string is formatted using `format-spec' and the result is set as the value
of `mode-line-buffer-identification'.

The following characters are replaced:
%a: String indicating away status or \"\" if you are not away
%m: The modes of the channel
%n: The current nick name
%o: The topic of the channel
%p: The session port
%t: The name of the target (channel, nickname, or servername:port)
%s: In the server-buffer, this gets filled with the value of
    `erc-server-announced-name', in a channel, the value of
    (erc-default-target) also get concatenated." :group 'erc-mode-line-and-header :type 'string)

(defcustom erc-header-line-format "[IRC] %n on %t %m %o" "\
A string to be formatted and shown in the header-line in `erc-mode'.
Only used in Emacs 21.

See `erc-mode-line-format' for which characters are can be used." :group 'erc-mode-line-and-header :type 'string)

(defcustom erc-header-line-uses-help-echo-p t "\
Show the contents of the header line in the echo area or as a tooltip
when you move point into the header line." :group 'erc-mode-line-and-header :type 'boolean)

(defcustom erc-header-line-face-method nil "\
Determine what method to use when colorizing the header line text.

If nil, don't colorize the header text.
If given a function, call it and use the resulting face name.
Otherwise, use the `erc-header-line' face." :group 'erc-mode-line-and-header :type '(choice (const :tag "Don't colorize" nil) (const :tag "Use the erc-header-line face" t) (function :tag "Call a function")))

(defcustom erc-show-channel-key-p t "\
Show the the channel key in the header line." :group 'erc-paranoia :type 'boolean)

(defcustom erc-common-server-suffixes '(("openprojects.net$" . "OPN") ("freenode.net$" . "OPN")) "\
Alist of common server name suffixes.
This variable is used in mode-line display to save screen
real estate.  Set it to nil if you want to avoid changing
displayed hostnames." :group 'erc-mode-line-and-header :type 'alist)

(defcustom erc-mode-line-away-status-format "(AWAY since %a %b %d %H:%M) " "\
When you're away on a server, this is shown in the mode line.
This should be a string with substitution variables recognized by
format-time-message." :group 'erc-mode-line-and-header :type 'string)

(defcustom erc-kill-server-hook '(erc-kill-server) "\
*Invoked whenever a server-buffer is killed via `kill-buffer'." :group 'erc-hooks :type 'hook)

(defcustom erc-kill-channel-hook '(erc-kill-channel) "\
*Invoked whenever a channel-buffer is killed via `kill-buffer'." :group 'erc-hooks :type 'hook)

(defcustom erc-kill-buffer-hook nil "\
*Hook run whenever a non-server or channel buffer is killed.

See also `kill-buffer'." :group 'erc-hooks :type 'hook)

;;;***

(provide 'erc-custom-defines)
