;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'escreen-custom-defines) (error "Feature escreen-custom-defines already loaded"))

;;;### (autoloads (escreen-prefix-char escreen-menu-mode-hook escreen-goto-screen-hook escreen-install-number-mode-format escreen-number-mode escreen-preserve-buffer-list-order escreen-restore-killed-buffers escreen-new-screen-default-buffer escreen-max-screens escreen) "escreen" "escreen/escreen.el")
(defconst custom-define-current-source-file "escreen.el")

(defgroup escreen nil "Window configuration management" :group 'escreen :group 'extensions)

(defcustom escreen-max-screens 10 "\
*Maximum number of screens that may be created." :type 'integer :group 'escreen)

(defcustom escreen-new-screen-default-buffer "*scratch*" "\
*Default buffer to display in newly-created screens." :type 'string :group 'escreen)

(defcustom escreen-restore-killed-buffers nil "\
*If non-nil, automatically revisit files if they have been killed.
That is, if a buffer was killed while in another screen session,
recreate them, visiting whatever file they were visiting." :type 'boolean :group 'escreen)

(defcustom escreen-preserve-buffer-list-order t "\
*If non-nil, preserve buffer list for each screen when switching.
When returning to a previously-saved screen, the buffer list order is
restored.  Buffers which have been created since the saved screen was last
visited, are put at the end of the list but the relative order is preserved.

This buffer list order is returned by the function `buffer-list' and
affects the behavior of `other-buffer', etc.

In Emacs 20 and later, each frame has its own ordered buffer list.
Switching screen sessions affects the selected frame's buffer list only." :type 'boolean :group 'escreen)

(defcustom escreen-number-mode t "\
*If non-nil, display current escreen number in mode line." :type 'boolean :group 'escreen)

(defcustom escreen-install-number-mode-format t "\
*If non-nil, install `escreen-mode-line-format' on `global-mode-string'.
This is performed by `escreen-install'." :type 'boolean :group 'escreen)

(defcustom escreen-goto-screen-hook nil "\
*Hook to run after `escreen-goto-screen' completes.
An example function that can make use of this hook is
`escreen-enable-number-mode-if-more-than-one-screen'." :type 'hook :group 'escreen)

(defcustom escreen-menu-mode-hook nil "\
*Hook to run by `escreen-menu' after everything else." :type 'hook :group 'escreen)

(defcustom escreen-prefix-char "" "\
*Character prefixing escreen commands.
If you wish to change this, you must also do

   (global-set-key escreen-prefix-char 'escreen-prefix)

to update the prefix in the global keymap." :type 'string :group 'escreen)

;;;***

(provide 'escreen-custom-defines)
