;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'eshell-custom-defines) (error "Feature eshell-custom-defines already loaded"))

;;;### (autoloads (eshell-alias-load-hook eshell-bad-command-tolerance eshell-aliases-file eshell-alias) "em-alias" "eshell/em-alias.el")
(defconst custom-define-current-source-file "em-alias.el")

(defgroup eshell-alias nil "Command aliases allow for easy definition of alternate commands." :tag "Command aliases" :group 'eshell-module)

(defcustom eshell-aliases-file (concat eshell-directory-name "alias") "\
*The file in which aliases are kept.
Whenever an alias is defined by the user, using the `alias' command,
it will be written to this file.  Thus, alias definitions (and
deletions) are always permanent.  This approach was chosen for the
sake of simplicity, since that's pretty much the only benefit to be
gained by using this module." :type 'file :group 'eshell-alias)

(defcustom eshell-bad-command-tolerance 3 "\
*The number of failed commands to ignore before creating an alias." :type 'integer :group 'eshell-alias)

(defcustom eshell-alias-load-hook '(eshell-alias-initialize) "\
*A hook that gets run when `eshell-alias' is loaded." :type 'hook :group 'eshell-alias)

;;;***

;;;### (autoloads (eshell-banner-load-hook eshell-banner-message eshell-banner) "em-banner" "eshell/em-banner.el")
(defconst custom-define-current-source-file "em-banner.el")

(defgroup eshell-banner nil "This sample module displays a welcome banner at login.\nIt exists so that others wishing to create their own Eshell extension\nmodules may have a simple template to begin with." :tag "Login banner" :group 'eshell-module)

(defcustom eshell-banner-message "Welcome to the Emacs shell\n\n" "\
*The banner message to be displayed when Eshell is loaded.
This can be any sexp, and should end with at least two newlines." :type 'sexp :group 'eshell-banner)

(defcustom eshell-banner-load-hook '(eshell-banner-initialize) "\
*A list of functions to run when `eshell-banner' is loaded." :type 'hook :group 'eshell-banner)

;;;***

;;;### (autoloads (eshell-plain-echo-behavior eshell-basic) "em-basic" "eshell/em-basic.el")
(defconst custom-define-current-source-file "em-basic.el")

(defgroup eshell-basic nil "The \"basic\" code provides a set of convenience functions which\nare traditionally considered shell builtins.  Since all of the\nfunctionality provided by them is accessible through Lisp, they are\nnot really builtins at all, but offer a command-oriented way to do the\nsame thing." :tag "Basic shell commands" :group 'eshell-module)

(defcustom eshell-plain-echo-behavior nil "\
*If non-nil, `echo' tries to behave like an ordinary shell echo.
This comes at some detriment to Lisp functionality.  However, the Lisp
equivalent of `echo' can always be achieved by using `identity'." :type 'boolean :group 'eshell-basic)

;;;***

;;;### (autoloads (eshell-cmpl-use-paring eshell-default-completion-function eshell-cmpl-command-name-function eshell-command-completion-function eshell-cmpl-restore-window-delay eshell-cmpl-cycle-cutoff-length eshell-cmpl-cycle-completions eshell-cmpl-expand-before-complete eshell-cmpl-compare-entry-function eshell-cmpl-man-function eshell-cmpl-recexact eshell-cmpl-suffix-list eshell-cmpl-autolist eshell-cmpl-ignore-case eshell-cmpl-dir-ignore eshell-cmpl-file-ignore eshell-command-completions-alist eshell-no-completion-during-jobs eshell-show-lisp-alternatives eshell-show-lisp-completions eshell-cmpl-load-hook eshell-cmpl) "em-cmpl" "eshell/em-cmpl.el")
(defconst custom-define-current-source-file "em-cmpl.el")

(defgroup eshell-cmpl nil "This module provides a programmable completion function bound to\nthe TAB key, which allows for completing command names, file names,\nvariable names, arguments, etc." :tag "Argument completion" :group 'eshell-module)

(defcustom eshell-cmpl-load-hook '(eshell-cmpl-initialize) "\
*A list of functions to run when `eshell-cmpl' is loaded." :type 'hook :group 'eshell-cmpl)

(defcustom eshell-show-lisp-completions nil "\
*If non-nil, include Lisp functions in the command completion list.
If this variable is nil, Lisp completion can still be done in command
position by using M-TAB instead of TAB." :type 'boolean :group 'eshell-cmpl)

(defcustom eshell-show-lisp-alternatives t "\
*If non-nil, and no other completions found, show Lisp functions.
Setting this variable means nothing if `eshell-show-lisp-completions'
is non-nil." :type 'boolean :group 'eshell-cmpl)

(defcustom eshell-no-completion-during-jobs t "\
*If non-nil, don't allow completion while a process is running." :type 'boolean :group 'eshell-cmpl)

(defcustom eshell-command-completions-alist '(("acroread" . "\\.pdf\\'") ("xpdf" . "\\.pdf\\'") ("ar" . "\\.[ao]\\'") ("gcc" . "\\.[Cc]\\([Cc]\\|[Pp][Pp]\\)?\\'") ("g++" . "\\.[Cc]\\([Cc]\\|[Pp][Pp]\\)?\\'") ("cc" . "\\.[Cc]\\([Cc]\\|[Pp][Pp]\\)?\\'") ("CC" . "\\.[Cc]\\([Cc]\\|[Pp][Pp]\\)?\\'") ("acc" . "\\.[Cc]\\([Cc]\\|[Pp][Pp]\\)?\\'") ("bcc" . "\\.[Cc]\\([Cc]\\|[Pp][Pp]\\)?\\'") ("readelf" . "\\(\\`[^.]*\\|\\.\\([ao]\\|so\\)\\)\\'") ("objdump" . "\\(\\`[^.]*\\|\\.\\([ao]\\|so\\)\\)\\'") ("nm" . "\\(\\`[^.]*\\|\\.\\([ao]\\|so\\)\\)\\'") ("gdb" . "\\`\\([^.]*\\|a\\.out\\)\\'") ("dbx" . "\\`\\([^.]*\\|a\\.out\\)\\'") ("sdb" . "\\`\\([^.]*\\|a\\.out\\)\\'") ("adb" . "\\`\\([^.]*\\|a\\.out\\)\\'")) "\
*An alist that defines simple argument type correlations.
This is provided for common commands, as a simplistic alternative
to writing a completion function." :type '(repeat (cons string regexp)) :group 'eshell-cmpl)

(defcustom eshell-cmpl-file-ignore "~\\'" (documentation-property 'pcomplete-file-ignore 'variable-documentation) :type (get 'pcomplete-file-ignore 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-dir-ignore (format "\\`\\(\\.\\.?\\|CVS\\)%c\\'" directory-sep-char) (documentation-property 'pcomplete-dir-ignore 'variable-documentation) :type (get 'pcomplete-dir-ignore 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-ignore-case (eshell-under-windows-p) (documentation-property 'pcomplete-ignore-case 'variable-documentation) :type (get 'pcomplete-ignore-case 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-autolist nil (documentation-property 'pcomplete-autolist 'variable-documentation) :type (get 'pcomplete-autolist 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-suffix-list (list directory-sep-char ?:) (documentation-property 'pcomplete-suffix-list 'variable-documentation) :type (get 'pcomplete-suffix-list 'custom-type) :group 'pcomplete)

(defcustom eshell-cmpl-recexact nil (documentation-property 'pcomplete-recexact 'variable-documentation) :type (get 'pcomplete-recexact 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-man-function (if (featurep 'xemacs) (function manual-entry) (function man)) (documentation-property 'pcomplete-man-function 'variable-documentation) :type (get 'pcomplete-man-function 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-compare-entry-function 'file-newer-than-file-p (documentation-property 'pcomplete-compare-entry-function 'variable-documentation) :type (get 'pcomplete-compare-entry-function 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-expand-before-complete nil (documentation-property 'pcomplete-expand-before-complete 'variable-documentation) :type (get 'pcomplete-expand-before-complete 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-cycle-completions t (documentation-property 'pcomplete-cycle-completions 'variable-documentation) :type (get 'pcomplete-cycle-completions 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-cycle-cutoff-length 5 (documentation-property 'pcomplete-cycle-cutoff-length 'variable-documentation) :type (get 'pcomplete-cycle-cutoff-length 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-restore-window-delay 1 (documentation-property 'pcomplete-restore-window-delay 'variable-documentation) :type (get 'pcomplete-restore-window-delay 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-command-completion-function (function (lambda nil (pcomplete-here (eshell-complete-commands-list)))) (documentation-property 'pcomplete-command-completion-function 'variable-documentation) :type (get 'pcomplete-command-completion-function 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-command-name-function 'eshell-completion-command-name (documentation-property 'pcomplete-command-name-function 'variable-documentation) :type (get 'pcomplete-command-name-function 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-default-completion-function (function (lambda nil (while (pcomplete-here (pcomplete-dirs-or-entries (cdr (assoc (funcall eshell-cmpl-command-name-function) eshell-command-completions-alist))))))) (documentation-property 'pcomplete-default-completion-function 'variable-documentation) :type (get 'pcomplete-default-completion-function 'custom-type) :group 'eshell-cmpl)

(defcustom eshell-cmpl-use-paring t (documentation-property 'pcomplete-use-paring 'variable-documentation) :type (get 'pcomplete-use-paring 'custom-type) :group 'eshell-cmpl)

;;;***

;;;### (autoloads (eshell-last-dir-unique eshell-last-dir-ring-size eshell-last-dir-ring-file-name eshell-dirtrack-verbose eshell-pushd-dunique eshell-pushd-dextract eshell-pushd-tohome eshell-list-files-after-cd eshell-directory-change-hook eshell-cd-on-directory eshell-cd-shows-directory eshell-ask-to-save-last-dir eshell-pwd-convert-function eshell-dirs-load-hook eshell-dirs) "em-dirs" "eshell/em-dirs.el")
(defconst custom-define-current-source-file "em-dirs.el")

(defgroup eshell-dirs nil "Directory navigation involves changing directories, examining the\ncurrent directory, maintaining a directory stack, and also keeping\ntrack of a history of the last directory locations the user was in.\nEmacs does provide standard Lisp definitions of `pwd' and `cd', but\nthey lack somewhat in feel from the typical shell equivalents." :tag "Directory navigation" :group 'eshell-module)

(defcustom eshell-dirs-load-hook '(eshell-dirs-initialize) "\
*A hook that gets run when `eshell-dirs' is loaded." :type 'hook :group 'eshell-dirs)

(defcustom eshell-pwd-convert-function (if (eshell-under-windows-p) 'expand-file-name 'identity) "\
*The function used to normalize the value of Eshell's `pwd'.
The value returned by `pwd' is also used when recording the
last-visited directory in the last-dir-ring, so it will affect the
form of the list used by 'cd ='." :type '(radio (function-item file-truename) (function-item expand-file-name) (function-item identity) (function :tag "Other")) :group 'eshell-dirs)

(defcustom eshell-ask-to-save-last-dir 'always "\
*Determine if the last-dir-ring should be automatically saved.
The last-dir-ring is always preserved when exiting an Eshell buffer.
However, when Emacs is being shut down, this variable determines
whether to prompt the user, or just save the ring.
If set to nil, it means never ask whether to save the last-dir-ring.
If set to t, always ask if any Eshell buffers are open at exit time.
If set to `always', the list-dir-ring will always be saved, silently." :type '(choice (const :tag "Never" nil) (const :tag "Ask" t) (const :tag "Always save" always)) :group 'eshell-dirs)

(defcustom eshell-cd-shows-directory nil "\
*If non-nil, using `cd' will report the directory it changes to." :type 'boolean :group 'eshell-dirs)

(defcustom eshell-cd-on-directory t "\
*If non-nil, do a cd if a directory is in command position." :type 'boolean :group 'eshell-dirs)

(defcustom eshell-directory-change-hook nil "\
*A hook to run when the current directory changes." :type 'hook :group 'eshell-dirs)

(defcustom eshell-list-files-after-cd nil "\
*If non-nil, call \"ls\" with any remaining args after doing a cd.
This is provided for convenience, since the same effect is easily
achieved by adding a function to `eshell-directory-change-hook' that
calls \"ls\" and references `eshell-last-arguments'." :type 'boolean :group 'eshell-dirs)

(defcustom eshell-pushd-tohome nil "\
*If non-nil, make pushd with no arg behave as 'pushd ~' (like `cd').
This mirrors the optional behavior of tcsh." :type 'boolean :group 'eshell-dirs)

(defcustom eshell-pushd-dextract nil "\
*If non-nil, make \"pushd +n\" pop the nth dir to the stack top.
This mirrors the optional behavior of tcsh." :type 'boolean :group 'eshell-dirs)

(defcustom eshell-pushd-dunique nil "\
*If non-nil, make pushd only add unique directories to the stack.
This mirrors the optional behavior of tcsh." :type 'boolean :group 'eshell-dirs)

(defcustom eshell-dirtrack-verbose t "\
*If non-nil, show the directory stack following directory change.
This is effective only if directory tracking is enabled." :type 'boolean :group 'eshell-dirs)

(defcustom eshell-last-dir-ring-file-name (concat eshell-directory-name "lastdir") "\
*If non-nil, name of the file to read/write the last-dir-ring.
See also `eshell-read-last-dir-ring' and `eshell-write-last-dir-ring'.
If it is nil, the last-dir-ring will not be written to disk." :type 'file :group 'eshell-dirs)

(defcustom eshell-last-dir-ring-size 32 "\
*If non-nil, the size of the directory history ring.
This ring is added to every time `cd' or `pushd' is used.  It simply
stores the most recent directory locations Eshell has been in.  To
return to the most recent entry, use 'cd -' (equivalent to 'cd -0').
To return to an older entry, use 'cd -N', where N is an integer less
than `eshell-last-dir-ring-size'.  To return to the last directory
matching a particular regexp, use 'cd =REGEXP'.  To display the
directory history list, use 'cd ='.

This mechanism is very similar to that provided by `pushd', except
it's far more automatic.  `pushd' allows the user to decide which
directories gets pushed, and its size is unlimited.

`eshell-last-dir-ring' is meant for users who don't use `pushd'
explicity very much, but every once in a while would like to return to
a previously visited directory without having to type in the whole
thing again." :type 'integer :group 'eshell-dirs)

(defcustom eshell-last-dir-unique t "\
*If non-nil, `eshell-last-dir-ring' contains only unique entries." :type 'boolean :group 'eshell-dirs)

;;;***

;;;### (autoloads (eshell-glob-translate-alist eshell-glob-chars-list eshell-error-if-no-glob eshell-glob-show-progress eshell-glob-case-insensitive eshell-glob-include-dot-dot eshell-glob-include-dot-files eshell-glob-load-hook eshell-glob) "em-glob" "eshell/em-glob.el")
(defconst custom-define-current-source-file "em-glob.el")

(defgroup eshell-glob nil "This module provides extended globbing syntax, similar what is used\nby zsh for filename generation." :tag "Extended filename globbing" :group 'eshell-module)

(defcustom eshell-glob-load-hook '(eshell-glob-initialize) "\
*A list of functions to run when `eshell-glob' is loaded." :type 'hook :group 'eshell-glob)

(defcustom eshell-glob-include-dot-files nil "\
*If non-nil, glob patterns will match files beginning with a dot." :type 'boolean :group 'eshell-glob)

(defcustom eshell-glob-include-dot-dot t "\
*If non-nil, glob patterns that match dots will match . and .." :type 'boolean :group 'eshell-glob)

(defcustom eshell-glob-case-insensitive (eshell-under-windows-p) "\
*If non-nil, glob pattern matching will ignore case." :type 'boolean :group 'eshell-glob)

(defcustom eshell-glob-show-progress nil "\
*If non-nil, display progress messages during a recursive glob.
This option slows down recursive glob processing by quite a bit." :type 'boolean :group 'eshell-glob)

(defcustom eshell-error-if-no-glob nil "\
*If non-nil, it is an error for a glob pattern not to match.
 This mimcs the behavior of zsh if non-nil, but bash if nil." :type 'boolean :group 'eshell-glob)

(defcustom eshell-glob-chars-list '(?\] ?\[ ?* ?\? ?~ ?\( ?\) ?| ?\# ?^) "\
*List of additional characters used in extended globbing." :type '(repeat character) :group 'eshell-glob)

(defcustom eshell-glob-translate-alist '((?\] . "]") (?\[ . "[") (?^ . "^") (?\? . ".") (?* . ".*") (?~ . "~") (?\( . "\\(") (?\) . "\\)") (?| . "\\|") (?\# lambda (str pos) (if (and (< (1+ pos) (length str)) (memq (aref str (1+ pos)) '(?* ?\# ?+ ?\?))) (cons (if (eq (aref str (1+ pos)) ?\?) "?" (if (eq (aref str (1+ pos)) ?*) "*" "+")) (+ pos 2)) (cons "*" (1+ pos))))) "\
*An alist for translation of extended globbing characters." :type '(repeat (cons character (choice regexp function))) :group 'eshell-glob)

;;;***

;;;### (autoloads (eshell-hist-rebind-keys-alist eshell-hist-modifier eshell-hist-word-designator eshell-hist-event-designator eshell-hist-move-to-end eshell-hist-match-partial eshell-input-filter eshell-ask-to-save-history eshell-hist-ignoredups eshell-history-size eshell-history-file-name eshell-hist-unload-hook eshell-hist-load-hook eshell-hist) "em-hist" "eshell/em-hist.el")
(defconst custom-define-current-source-file "em-hist.el")

(defgroup eshell-hist nil "This module provides command history management." :tag "History list management" :group 'eshell-module)

(defcustom eshell-hist-load-hook '(eshell-hist-initialize) "\
*A list of functions to call when loading `eshell-hist'." :type 'hook :group 'eshell-hist)

(defcustom eshell-hist-unload-hook (list (function (lambda nil (remove-hook 'kill-emacs-hook 'eshell-save-some-history)))) "\
*A hook that gets run when `eshell-hist' is unloaded." :type 'hook :group 'eshell-hist)

(defcustom eshell-history-file-name (concat eshell-directory-name "history") "\
*If non-nil, name of the file to read/write input history.
See also `eshell-read-history' and `eshell-write-history'.
If it is nil, Eshell will use the value of HISTFILE." :type 'file :group 'eshell-hist)

(defcustom eshell-history-size 128 "\
*Size of the input history ring.  If nil, use envvar HISTSIZE." :type 'integer :group 'eshell-hist)

(defcustom eshell-hist-ignoredups nil "\
*If non-nil, don't add input matching the last on the input ring.
This mirrors the optional behavior of bash." :type 'boolean :group 'eshell-hist)

(defcustom eshell-ask-to-save-history t "\
*Determine if history should be automatically saved.
History is always preserved after sanely exiting an Eshell buffer.
However, when Emacs is being shut down, this variable determines
whether to prompt the user.
If set to nil, it means never save history on termination of Emacs.
If set to `ask', ask if any Eshell buffers are open at exit time.
If set to t, history will always be saved, silently." :type '(choice (const :tag "Never" nil) (const :tag "Ask" ask) (const :tag "Always save" t)) :group 'eshell-hist)

(defcustom eshell-input-filter (function (lambda (str) (not (string-match "\\`\\s-*\\'" str)))) "\
*Predicate for filtering additions to input history.
Takes one argument, the input.  If non-nil, the input may be saved on
the input history list.  Default is to save anything that isn't all
whitespace." :type 'function :group 'eshell-hist)

(defcustom eshell-hist-match-partial t "\
*If non-nil, movement through history is constrained by current input.
Otherwise, typing <M-p> and <M-n> will always go to the next history
element, regardless of any text on the command line.  In that case,
<C-c M-r> and <C-c M-s> still offer that functionality." :type 'boolean :group 'eshell-hist)

(defcustom eshell-hist-move-to-end t "\
*If non-nil, move to the end of the buffer before cycling history." :type 'boolean :group 'eshell-hist)

(defcustom eshell-hist-event-designator "^!\\(!\\|-?[0-9]+\\|\\??[^:^$%*?]+\\??\\|#\\)" "\
*The regexp used to identifier history event designators." :type 'regexp :group 'eshell-hist)

(defcustom eshell-hist-word-designator "^:?\\([0-9]+\\|[$^%*]\\)?\\(\\*\\|-[0-9]*\\|[$^%*]\\)?" "\
*The regexp used to identify history word designators." :type 'regexp :group 'eshell-hist)

(defcustom eshell-hist-modifier "^\\(:\\([hretpqx&g]\\|s/\\([^/]*\\)/\\([^/]*\\)/\\)\\)*" "\
*The regexp used to identity history modifiers." :type 'regexp :group 'eshell-hist)

(defcustom eshell-hist-rebind-keys-alist '(([(control ?p)] . eshell-previous-input) ([(control ?n)] . eshell-next-input) ([(control up)] . eshell-previous-input) ([(control down)] . eshell-next-input) ([(control ?r)] . eshell-isearch-backward) ([(control ?s)] . eshell-isearch-forward) ([(meta ?r)] . eshell-previous-matching-input) ([(meta ?s)] . eshell-next-matching-input) ([(meta ?p)] . eshell-previous-matching-input-from-input) ([(meta ?n)] . eshell-next-matching-input-from-input) ([up] . eshell-previous-matching-input-from-input) ([down] . eshell-next-matching-input-from-input)) "\
*History keys to bind differently if point is in input text." :type '(repeat (cons (vector :tag "Keys to bind" (repeat :inline t sexp)) (function :tag "Command"))) :group 'eshell-hist)

;;;***

;;;### (autoloads (eshell-ls-highlight-alist eshell-ls-clutter-regexp eshell-ls-product-regexp eshell-ls-backup-regexp eshell-ls-archive-regexp eshell-ls-use-colors eshell-ls-exclude-hidden eshell-ls-exclude-regexp eshell-ls-default-blocksize eshell-ls-use-in-dired eshell-ls-dired-initial-args eshell-ls-initial-args eshell-ls-unload-hook eshell-ls) "em-ls" "eshell/em-ls.el")
(defconst custom-define-current-source-file "em-ls.el")

(defgroup eshell-ls nil "This module implements the \"ls\" utility fully in Lisp.  If it is\npassed any unrecognized command switches, it will revert to the\noperating system's version.  This version of \"ls\" uses text\nproperties to colorize its output based on the setting of\n`eshell-ls-use-colors'." :tag "Implementation of `ls' in Lisp" :group 'eshell-module)

(defcustom eshell-ls-unload-hook (list (function (lambda nil (fset 'insert-directory eshell-ls-orig-insert-directory)))) "\
*When unloading `eshell-ls', restore the definition of `insert-directory'." :type 'hook :group 'eshell-ls)

(defcustom eshell-ls-initial-args nil "\
*If non-nil, this list of args is included before any call to `ls'.
This is useful for enabling human-readable format (-h), for example." :type '(repeat :tag "Arguments" string) :group 'eshell-ls)

(defcustom eshell-ls-dired-initial-args nil "\
*If non-nil, args is included before any call to `ls' in Dired.
This is useful for enabling human-readable format (-h), for example." :type '(repeat :tag "Arguments" string) :group 'eshell-ls)

(defcustom eshell-ls-use-in-dired nil "\
*If non-nil, use `eshell-ls' to read directories in Dired." :set (lambda (symbol value) (if value (unless (and (boundp 'eshell-ls-use-in-dired) eshell-ls-use-in-dired) (fset 'insert-directory 'eshell-ls-insert-directory)) (when (and (boundp 'eshell-ls-insert-directory) eshell-ls-use-in-dired) (fset 'insert-directory eshell-ls-orig-insert-directory))) (setq eshell-ls-use-in-dired value)) :type 'boolean :require 'em-ls :group 'eshell-ls)

(defcustom eshell-ls-default-blocksize 1024 "\
*The default blocksize to use when display file sizes with -s." :type 'integer :group 'eshell-ls)

(defcustom eshell-ls-exclude-regexp nil "\
*Unless -a is specified, files matching this regexp will not be shown." :type '(choice regexp (const nil)) :group 'eshell-ls)

(defcustom eshell-ls-exclude-hidden t "\
*Unless -a is specified, files beginning with . will not be shown.
Using this boolean, instead of `eshell-ls-exclude-regexp', is both
faster and conserves more memory." :type 'boolean :group 'eshell-ls)

(defcustom eshell-ls-use-colors t "\
*If non-nil, use colors in file listings." :type 'boolean :group 'eshell-ls)

(defcustom eshell-ls-archive-regexp (concat "\\.\\(t\\(a[rz]\\|gz\\)\\|arj\\|lzh\\|" "zip\\|[zZ]\\|gz\\|bz2\\|deb\\|rpm\\)\\'") "\
*A regular expression that matches names of file archives.
This typically includes both traditional archives and compressed
files." :type 'regexp :group 'eshell-ls)

(defcustom eshell-ls-backup-regexp "\\(\\`\\.?#\\|\\(\\.bak\\|~\\)\\'\\)" "\
*A regular expression that matches names of backup files." :type 'regexp :group 'eshell-ls)

(defcustom eshell-ls-product-regexp "\\.\\(elc\\|o\\(bj\\)?\\|a\\|lib\\|res\\)\\'" "\
*A regular expression that matches names of product files.
Products are files that get generated from a source file, and hence
ought to be recreatable if they are deleted." :type 'regexp :group 'eshell-ls)

(defcustom eshell-ls-clutter-regexp "\\(^texput\\.log\\|^core\\)\\'" "\
*A regular expression that matches names of junk files.
These are mainly files that get created for various reasons, but don't
really need to stick around for very long." :type 'regexp :group 'eshell-ls)

(defcustom eshell-ls-highlight-alist nil "\
*This alist correlates test functions to color.
The format of the members of this alist is

  (TEST-SEXP . FACE)

If TEST-SEXP evals to non-nil, that face will be used to highlight the
name of the file.  The first match wins.  `file' and `attrs' are in
scope during the evaluation of TEST-SEXP." :type '(repeat (cons function face)) :group 'eshell-ls)

;;;***

;;;### (autoloads (eshell-modifier-alist eshell-predicate-alist eshell-pred-load-hook eshell-pred) "em-pred" "eshell/em-pred.el")
(defconst custom-define-current-source-file "em-pred.el")

(defgroup eshell-pred nil "This module allows for predicates to be applied to globbing\npatterns (similar to zsh), in addition to string modifiers which can\nbe applied either to globbing results, variable references, or just\nordinary strings." :tag "Value modifiers and predicates" :group 'eshell-module)

(defcustom eshell-pred-load-hook '(eshell-pred-initialize) "\
*A list of functions to run when `eshell-pred' is loaded." :type 'hook :group 'eshell-pred)

(defcustom eshell-predicate-alist '((?/ eshell-pred-file-type ?d) (?\. eshell-pred-file-type ?-) (?s eshell-pred-file-type ?s) (?p eshell-pred-file-type ?p) (?@ eshell-pred-file-type ?l) (?% eshell-pred-file-type ?%) (?r eshell-pred-file-mode 400) (?w eshell-pred-file-mode 200) (?x eshell-pred-file-mode 100) (?A eshell-pred-file-mode 40) (?I eshell-pred-file-mode 20) (?E eshell-pred-file-mode 10) (?R eshell-pred-file-mode 4) (?W eshell-pred-file-mode 2) (?X eshell-pred-file-mode 1) (?s eshell-pred-file-mode 4000) (?S eshell-pred-file-mode 2000) (?t eshell-pred-file-mode 1000) (?U quote (lambda (file) (if (file-exists-p file) (= (nth 2 (file-attributes file)) (user-uid))))) (?* quote (lambda (file) (and (file-regular-p file) (not (file-symlink-p file)) (file-executable-p file)))) (?l eshell-pred-file-links) (?u eshell-pred-user-or-group ?u "user" 2 'eshell-user-id) (?g eshell-pred-user-or-group ?g "group" 3 'eshell-group-id) (?a eshell-pred-file-time ?a "access" 4) (?m eshell-pred-file-time ?m "modification" 5) (?c eshell-pred-file-time ?c "change" 6) (?L eshell-pred-file-size)) "\
*A list of predicates than can be applied to a globbing pattern.
The format of each entry is

  (CHAR . PREDICATE-FUNC-SEXP)" :type '(repeat (cons character sexp)) :group 'eshell-pred)

(defcustom eshell-modifier-alist '((?E quote (lambda (lst) (mapcar (function (lambda (str) (eshell-stringify (car (eshell-parse-argument str))))) lst))) (?L quote (lambda (lst) (mapcar 'downcase lst))) (?U quote (lambda (lst) (mapcar 'upcase lst))) (?C quote (lambda (lst) (mapcar 'capitalize lst))) (?h quote (lambda (lst) (mapcar 'file-name-directory lst))) (?i eshell-include-members) (?x eshell-include-members t) (?r quote (lambda (lst) (mapcar 'file-name-sans-extension lst))) (?e quote (lambda (lst) (mapcar 'file-name-extension lst))) (?t quote (lambda (lst) (mapcar 'file-name-nondirectory lst))) (?q quote (lambda (lst) (mapcar 'eshell-escape-arg lst))) (?u quote (lambda (lst) (eshell-uniqify-list lst))) (?o quote (lambda (lst) (sort lst 'string-lessp))) (?O quote (lambda (lst) (nreverse (sort lst 'string-lessp)))) (?j eshell-join-members) (?S eshell-split-members) (?R quote reverse) (?g progn (forward-char) (if (eq (char-before) ?s) (eshell-pred-substitute t) (error "`g' modifier cannot be used alone"))) (?s eshell-pred-substitute)) "\
*A list of modifiers than can be applied to an argument expansion.
The format of each entry is

  (CHAR ENTRYWISE-P MODIFIER-FUNC-SEXP)" :type '(repeat (cons character sexp)) :group 'eshell-pred)

;;;***

;;;### (autoloads (eshell-after-prompt-hook eshell-before-prompt-hook eshell-highlight-prompt eshell-prompt-regexp eshell-prompt-function eshell-prompt-load-hook eshell-prompt) "em-prompt" "eshell/em-prompt.el")
(defconst custom-define-current-source-file "em-prompt.el")

(defgroup eshell-prompt nil "This module provides command prompts, and navigation between them,\nas is common with most shells." :tag "Command prompts" :group 'eshell-module)

(defcustom eshell-prompt-load-hook '(eshell-prompt-initialize) "\
*A list of functions to call when loading `eshell-prompt'." :type 'hook :group 'eshell-prompt)

(defcustom eshell-prompt-function (function (lambda nil (concat (eshell/pwd) (if (= (user-uid) 0) " # " " $ ")))) "\
*A function that returns the Eshell prompt string.
Make sure to update `eshell-prompt-regexp' so that it will match your
prompt." :type 'function :group 'eshell-prompt)

(defcustom eshell-prompt-regexp "^[^#$\n]* [#$] " "\
*A regexp which fully matches your eshell prompt.
This setting is important, since it affects how eshell will interpret
the lines that are passed to it.
If this variable is changed, all Eshell buffers must be exited and
re-entered for it to take effect." :type 'regexp :group 'eshell-prompt)

(defcustom eshell-highlight-prompt t "\
*If non-nil, Eshell should highlight the prompt." :type 'boolean :group 'eshell-prompt)

(defcustom eshell-before-prompt-hook nil "\
*A list of functions to call before outputting the prompt." :type 'hook :options '(eshell-begin-on-new-line) :group 'eshell-prompt)

(defcustom eshell-after-prompt-hook nil "\
*A list of functions to call after outputting the prompt.
Note that if `eshell-scroll-show-maximum-output' is non-nil, then
setting `eshell-show-maximum-output' here won't do much.  It depends
on whether the user wants the resizing to happen while output is
arriving, or after." :type 'hook :options '(eshell-show-maximum-output) :group 'eshell-prompt)

;;;***

;;;### (autoloads (eshell-cannot-leave-input-list eshell-remap-previous-input eshell-error-if-move-away eshell-confine-point-to-input eshell-rebind-keys-alist eshell-rebind-load-hook eshell-rebind) "em-rebind" "eshell/em-rebind.el")
(defconst custom-define-current-source-file "em-rebind.el")

(defgroup eshell-rebind nil "This module allows for special keybindings that only take effect\nwhile the point is in a region of input text.  By default, it binds\nC-a to move to the beginning of the input text (rather than just the\nbeginning of the line), and C-p and C-n to move through the input\nhistory, C-u kills the current input text, etc.  It also, if\n`eshell-confine-point-to-input' is non-nil, does not allow certain\ncommands to cause the point to leave the input area, such as\n`backward-word', `previous-line', etc.  This module intends to mimic\nthe behavior of normal shells while the user editing new input text." :tag "Rebind keys at input" :group 'eshell-module)

(defcustom eshell-rebind-load-hook '(eshell-rebind-initialize) "\
*A list of functions to call when loading `eshell-rebind'." :type 'hook :group 'eshell-rebind)

(defcustom eshell-rebind-keys-alist '(([(control ?a)] . eshell-bol) ([home] . eshell-bol) ([(control ?d)] . eshell-delchar-or-maybe-eof) ([backspace] . eshell-delete-backward-char) ([delete] . eshell-delete-backward-char) ([(control ?w)] . backward-kill-word) ([(control ?u)] . eshell-kill-input)) "\
*Bind some keys differently if point is in input text." :type '(repeat (cons (vector :tag "Keys to bind" (repeat :inline t sexp)) (function :tag "Command"))) :group 'eshell-rebind)

(defcustom eshell-confine-point-to-input t "\
*If non-nil, do not allow the point to leave the current input.
This is more difficult to do nicely in Emacs than one might think.
Basically, the `point-left' attribute is added to the input text, and
a function is placed on that hook to take the point back to
`eshell-last-output-end' every time the user tries to move away.  But
since there are many cases in which the point _ought_ to move away
\(for programmatic reasons), the variable
`eshell-cannot-leave-input-list' defines commands which are affected
from this rule.  However, this list is by no means as complete as it
probably should be, so basically all one can hope for is that other
people will left the point alone in the Eshell buffer.  Sigh." :type 'boolean :group 'eshell-rebind)

(defcustom eshell-error-if-move-away t "\
*If non-nil, consider it an error to try to move outside current input.
This is default behavior of shells like bash." :type 'boolean :group 'eshell-rebind)

(defcustom eshell-remap-previous-input t "\
*If non-nil, remap input keybindings on previous prompts as well." :type 'boolean :group 'eshell-rebind)

(defcustom eshell-cannot-leave-input-list '(beginning-of-line-text beginning-of-line move-to-column move-to-column-force move-to-left-margin move-to-tab-stop forward-char backward-char delete-char delete-backward-char backward-delete-char backward-delete-char-untabify kill-paragraph backward-kill-paragraph kill-sentence backward-kill-sentence kill-sexp backward-kill-sexp kill-word backward-kill-word kill-region forward-list backward-list forward-page backward-page forward-point forward-paragraph backward-paragraph backward-prefix-chars forward-sentence backward-sentence forward-sexp backward-sexp forward-to-indentation backward-to-indentation backward-up-list forward-word backward-word forward-line previous-line next-line forward-visible-line forward-comment forward-thing) "\
*A list of commands that cannot leave the input area." :type '(repeat function) :group 'eshell-rebind)

;;;***

;;;### (autoloads (eshell-rc-script eshell-login-script eshell-script-load-hook eshell-script) "em-script" "eshell/em-script.el")
(defconst custom-define-current-source-file "em-script.el")

(defgroup eshell-script nil "This module allows for the execution of files containing Eshell\ncommands, as a script file." :tag "Running script files." :group 'eshell-module)

(defcustom eshell-script-load-hook '(eshell-script-initialize) "\
*A list of functions to call when loading `eshell-script'." :type 'hook :group 'eshell-script)

(defcustom eshell-login-script (concat eshell-directory-name "login") "\
*If non-nil, a file to invoke when starting up Eshell interactively.
This file should be a file containing Eshell commands, where comment
lines begin with '#'." :type 'file :group 'eshell-script)

(defcustom eshell-rc-script (concat eshell-directory-name "profile") "\
*If non-nil, a file to invoke whenever Eshell is started.
This includes when running `eshell-command'." :type 'file :group 'eshell-script)

;;;***

;;;### (autoloads (eshell-where-to-jump eshell-smart-space-goes-to-end eshell-smart-display-navigate-list eshell-review-quick-commands eshell-smart-unload-hook eshell-smart-load-hook eshell-smart) "em-smart" "eshell/em-smart.el")
(defconst custom-define-current-source-file "em-smart.el")

(defgroup eshell-smart nil "This module combines the facility of normal, modern shells with\nsome of the edit/review concepts inherent in the design of Plan 9's\n9term.  See the docs for more details.\n\nMost likely you will have to turn this option on and play around with\nit to get a real sense of how it works." :tag "Smart display of output" :group 'eshell-module)

(defcustom eshell-smart-load-hook '(eshell-smart-initialize) "\
*A list of functions to call when loading `eshell-smart'." :type 'hook :group 'eshell-smart)

(defcustom eshell-smart-unload-hook (list (function (lambda nil (remove-hook 'window-configuration-change-hook 'eshell-refresh-windows)))) "\
*A hook that gets run when `eshell-smart' is unloaded." :type 'hook :group 'eshell-smart)

(defcustom eshell-review-quick-commands nil "\
*If t, always review commands.
Reviewing means keeping point on the text of the command that was just
invoked, to allow corrections to be made easily.

If set to nil, quick commands won't be reviewed.  A quick command is a
command that produces no output, and exits successfully.

If set to `not-even-short-output', then the definition of \"quick
command\" is extended to include commands that produce output, iff
that output can be presented in its entirely in the Eshell window." :type '(choice (const :tag "No" nil) (const :tag "Yes" t) (const :tag "Not even short output" not-even-short-output)) :group 'eshell-smart)

(defcustom eshell-smart-display-navigate-list '(insert-parentheses mouse-yank-at-click mouse-yank-secondary yank-pop yank-rectangle yank) "\
*A list of commands which cause Eshell to jump to the end of buffer." :type '(repeat function) :group 'eshell-smart)

(defcustom eshell-smart-space-goes-to-end t "\
*If non-nil, space will go to end of buffer when point-max is visible.
That is, if a command is running and the user presses SPACE at a time
when the end of the buffer is visible, point will go to the end of the
buffer and smart-display will be turned off (that is, subsequently
pressing backspace will not cause the buffer to scroll down).

This feature is provided to make it very easy to watch the output of a
long-running command, such as make, where it's more desirable to see
the output go by than to review it afterward.

Setting this variable to nil means that space and backspace will
always have a consistent behavior, which is to move back and forth
through displayed output.  But it also means that enabling output
tracking requires the user to manually move point to the end of the
buffer using \\[end-of-buffer]." :type 'boolean :group 'eshell-smart)

(defcustom eshell-where-to-jump 'begin "\
*This variable indicates where point should jump to after a command.
The options are `begin', `after' or `end'." :type '(radio (const :tag "Beginning of command" begin) (const :tag "After command word" after) (const :tag "End of command" end)) :group 'eshell-smart)

;;;***

;;;### (autoloads (eshell-escape-control-x eshell-term-name eshell-visual-commands eshell-term-load-hook eshell-term) "em-term" "eshell/em-term.el")
(defconst custom-define-current-source-file "em-term.el")

(defgroup eshell-term nil "This module causes visual commands (e.g., 'vi') to be executed by\nthe `term' package, which comes with Emacs.  This package handles most\nof the ANSI control codes, allowing curses-based applications to run\nwithin an Emacs window.  The variable `eshell-visual-commands' defines\nwhich commands are considered visual in nature." :tag "Running visual commands" :group 'eshell-module)

(defcustom eshell-term-load-hook '(eshell-term-initialize) "\
*A list of functions to call when loading `eshell-term'." :type 'hook :group 'eshell-term)

(defcustom eshell-visual-commands '("vi" "screen" "top" "less" "more" "lynx" "ncftp" "pine" "tin" "trn" "elm") "\
*A list of commands that present their output in a visual fashion." :type '(repeat string) :group 'eshell-term)

(defcustom eshell-term-name "eterm" "\
*Name to use for the TERM variable when running visual commands.
See `term-term-name' in term.el for more information on how this is
used." :type 'string :group 'eshell-term)

(defcustom eshell-escape-control-x t "\
*If non-nil, allow <C-x> to be handled by Emacs key in visual buffers.
See the variable `eshell-visual-commands'.  If this variable is set to
nil, <C-x> will send that control character to the invoked process." :type 'boolean :group 'eshell-term)

;;;***

;;;### (autoloads (eshell-du-prefer-over-ange eshell-default-target-is-dot eshell-ln-overwrite-files eshell-ln-interactive-query eshell-cp-overwrite-files eshell-cp-interactive-query eshell-mv-overwrite-files eshell-mv-interactive-query eshell-rm-interactive-query eshell-rm-removes-directories eshell-plain-locate-behavior eshell-plain-diff-behavior eshell-no-grep-available eshell-plain-grep-behavior eshell-unix-load-hook eshell-unix) "em-unix" "eshell/em-unix.el")
(defconst custom-define-current-source-file "em-unix.el")

(defgroup eshell-unix nil "This module defines many of the more common UNIX utilities as\naliases implemented in Lisp.  These include mv, ln, cp, rm, etc.  If\nthe user passes arguments which are too complex, or are unrecognized\nby the Lisp variant, the external version will be called (if\navailable).  The only reason not to use them would be because they are\nusually much slower.  But in several cases their tight integration\nwith Eshell makes them more versatile than their traditional cousins\n(such as being able to use `kill' to kill Eshell background processes\nby name)." :tag "UNIX commands in Lisp" :group 'eshell-module)

(defcustom eshell-unix-load-hook '(eshell-unix-initialize) "\
*A list of functions to run when `eshell-unix' is loaded." :type 'hook :group 'eshell-unix)

(defcustom eshell-plain-grep-behavior nil "\
*If non-nil, standalone \"grep\" commands will behave normally.
Standalone in this context means not redirected, and not on the
receiving side of a command pipeline." :type 'boolean :group 'eshell-unix)

(defcustom eshell-no-grep-available (not (eshell-search-path "grep")) "\
*If non-nil, no grep is available on the current machine." :type 'boolean :group 'eshell-unix)

(defcustom eshell-plain-diff-behavior nil "\
*If non-nil, standalone \"diff\" commands will behave normally.
Standalone in this context means not redirected, and not on the
receiving side of a command pipeline." :type 'boolean :group 'eshell-unix)

(defcustom eshell-plain-locate-behavior (eshell-under-xemacs-p) "\
*If non-nil, standalone \"locate\" commands will behave normally.
Standalone in this context means not redirected, and not on the
receiving side of a command pipeline." :type 'boolean :group 'eshell-unix)

(defcustom eshell-rm-removes-directories nil "\
*If non-nil, `rm' will remove directory entries.
Otherwise, `rmdir' is required." :type 'boolean :group 'eshell-unix)

(defcustom eshell-rm-interactive-query (= (user-uid) 0) "\
*If non-nil, `rm' will query before removing anything." :type 'boolean :group 'eshell-unix)

(defcustom eshell-mv-interactive-query (= (user-uid) 0) "\
*If non-nil, `mv' will query before overwriting anything." :type 'boolean :group 'eshell-unix)

(defcustom eshell-mv-overwrite-files t "\
*If non-nil, `mv' will overwrite files without warning." :type 'boolean :group 'eshell-unix)

(defcustom eshell-cp-interactive-query (= (user-uid) 0) "\
*If non-nil, `cp' will query before overwriting anything." :type 'boolean :group 'eshell-unix)

(defcustom eshell-cp-overwrite-files t "\
*If non-nil, `cp' will overwrite files without warning." :type 'boolean :group 'eshell-unix)

(defcustom eshell-ln-interactive-query (= (user-uid) 0) "\
*If non-nil, `ln' will query before overwriting anything." :type 'boolean :group 'eshell-unix)

(defcustom eshell-ln-overwrite-files nil "\
*If non-nil, `ln' will overwrite files without warning." :type 'boolean :group 'eshell-unix)

(defcustom eshell-default-target-is-dot nil "\
*If non-nil, the default destination for cp, mv or ln is `.'." :type 'boolean :group 'eshell-unix)

(defcustom eshell-du-prefer-over-ange nil "\
*Use Eshell's du in ange-ftp remote directories.
Otherwise, Emacs will attempt to use rsh to invoke du on the remote machine." :type 'boolean :group 'eshell-unix)

;;;***

;;;### (autoloads (eshell-xtra) "em-xtra" "eshell/em-xtra.el")
(defconst custom-define-current-source-file "em-xtra.el")

(defgroup eshell-xtra nil "This module defines some extra alias functions which are entirely\noptional.  They can be viewed as samples for how to write Eshell alias\nfunctions, or as aliases which make some of Emacs' behavior more\nnaturally accessible within Emacs." :tag "Extra alias functions" :group 'eshell-module)

;;;***

;;;### (autoloads (eshell-special-chars-outside-quoting eshell-special-chars-inside-quoting eshell-delimiter-argument-list eshell-arg-load-hook eshell-parse-argument-hook eshell-arg) "esh-arg" "eshell/esh-arg.el")
(defconst custom-define-current-source-file "esh-arg.el")

(defgroup eshell-arg nil "Argument parsing involves transforming the arguments passed on the\ncommand line into equivalent Lisp forms that, when evaluated, will\nyield the values intended." :tag "Argument parsing" :group 'eshell)

(defcustom eshell-parse-argument-hook (list 'eshell-parse-special-reference (function (lambda nil (when (and (not eshell-current-argument) (not eshell-current-quoted) (looking-at eshell-number-regexp) (eshell-arg-delimiter (match-end 0))) (goto-char (match-end 0)) (let ((str (match-string 0))) (if (> (length str) 0) (add-text-properties 0 1 '(number t) str)) str)))) (function (lambda nil (unless eshell-inside-quote-regexp (setq eshell-inside-quote-regexp (format "[^%s]+" (apply 'string eshell-special-chars-inside-quoting)))) (unless eshell-outside-quote-regexp (setq eshell-outside-quote-regexp (format "[^%s]+" (apply 'string eshell-special-chars-outside-quoting)))) (when (looking-at (if eshell-current-quoted eshell-inside-quote-regexp eshell-outside-quote-regexp)) (goto-char (match-end 0)) (let ((str (match-string 0))) (if str (set-text-properties 0 (length str) nil str)) str)))) (function (lambda nil (let (comment-p) (when (or (looking-at "[ 	]+") (and (not eshell-current-argument) (looking-at "#\\([^<'].*\\|$\\)") (setq comment-p t))) (if comment-p (add-text-properties (match-beginning 0) (match-end 0) '(comment t))) (goto-char (match-end 0)) (eshell-finish-arg))))) 'eshell-parse-backslash 'eshell-parse-literal-quote 'eshell-parse-double-quote 'eshell-parse-delimiter) "\
*Define how to process Eshell command line arguments.
When each function on this hook is called, point will be at the
current position within the argument list.  The function should either
return nil, meaning that it did no argument parsing, or it should
return the result of the parse as a sexp.  It is also responsible for
moving the point forward to reflect the amount of input text that was
parsed.

If no function handles the current character at point, it will be
treated as a literal character." :type 'hook :group 'eshell-arg)

(defcustom eshell-arg-load-hook '(eshell-arg-initialize) "\
*A hook that gets run when `eshell-arg' is loaded." :type 'hook :group 'eshell-arg)

(defcustom eshell-delimiter-argument-list '(?\; ?& ?| ?> ?\  ?\t ?\n) "\
List of characters to recognize as argument separators." :type '(repeat character) :group 'eshell-arg)

(defcustom eshell-special-chars-inside-quoting '(?\\ ?\") "\
*Characters which are still special inside double quotes." :type '(repeat character) :group 'eshell-arg)

(defcustom eshell-special-chars-outside-quoting (append eshell-delimiter-argument-list '(?\# ?! ?\\ ?\" ?\')) "\
*Characters that require escaping outside of double quotes.
Without escaping them, they will introduce a change in the argument." :type '(repeat character) :group 'eshell-arg)

;;;***

;;;### (autoloads (eshell-subcommand-bindings eshell-deferrable-commands eshell-debug-command eshell-cmd-load-hook eshell-complex-commands eshell-post-rewrite-command-hook eshell-rewrite-command-hook eshell-pre-rewrite-command-hook eshell-named-command-hook eshell-prepare-command-hook eshell-post-command-hook eshell-pre-command-hook eshell-lisp-regexp eshell-prefer-lisp-functions eshell-cmd) "esh-cmd" "eshell/esh-cmd.el")
(defconst custom-define-current-source-file "esh-cmd.el")

(defgroup eshell-cmd nil "Executing an Eshell command is as simple as typing it in and\npressing <RET>.  There are several different kinds of commands,\nhowever." :tag "Command invocation" :group 'eshell)

(defcustom eshell-prefer-lisp-functions nil "\
*If non-nil, prefer Lisp functions to external commands." :type 'boolean :group 'eshell-cmd)

(defcustom eshell-lisp-regexp "\\([(`]\\|#'\\)" "\
*A regexp which, if matched at beginning of an argument, means Lisp.
Such arguments will be passed to `read', and then evaluated." :type 'regexp :group 'eshell-cmd)

(defcustom eshell-pre-command-hook nil "\
*A hook run before each interactive command is invoked." :type 'hook :group 'eshell-cmd)

(defcustom eshell-post-command-hook nil "\
*A hook run after each interactive command is invoked." :type 'hook :group 'eshell-cmd)

(defcustom eshell-prepare-command-hook nil "\
*A set of functions called to prepare a named command.
The command name and its argument are in `eshell-last-command-name'
and `eshell-last-arguments'.  The functions on this hook can change
the value of these symbols if necessary.

To prevent a command from executing at all, set
`eshell-last-command-name' to nil." :type 'hook :group 'eshell-cmd)

(defcustom eshell-named-command-hook nil "\
*A set of functions called before a named command is invoked.
Each function will be passed the command name and arguments that were
passed to `eshell-named-command'.

If any of the functions returns a non-nil value, the named command
will not be invoked, and that value will be returned from
`eshell-named-command'.

In order to substitute an alternate command form for execution, the
hook function should throw it using the tag `eshell-replace-command'.
For example:

  (add-hook 'eshell-named-command-hook 'subst-with-cd)
  (defun subst-with-cd (command args)
    (throw 'eshell-replace-command
	   (eshell-parse-command \"cd\" args)))

Although useless, the above code will cause any non-glob, non-Lisp
command (i.e., 'ls' as opposed to '*ls' or '(ls)') to be replaced by a
call to `cd' using the arguments that were passed to the function." :type 'hook :group 'eshell-cmd)

(defcustom eshell-pre-rewrite-command-hook '(eshell-no-command-conversion eshell-subcommand-arg-values) "\
*A hook run before command rewriting begins.
The terms of the command to be rewritten is passed as arguments, and
may be modified in place.  Any return value is ignored." :type 'hook :group 'eshell-cmd)

(defcustom eshell-rewrite-command-hook '(eshell-rewrite-for-command eshell-rewrite-while-command eshell-rewrite-if-command eshell-rewrite-sexp-command eshell-rewrite-initial-subcommand eshell-rewrite-named-command) "\
*A set of functions used to rewrite the command argument.
Once parsing of a command line is completed, the next step is to
rewrite the initial argument into something runnable.

A module may wish to associate special behavior with certain argument
syntaxes at the beginning of a command line.  They are welcome to do
so by adding a function to this hook.  The first function to return a
substitute command form is the one used.  Each function is passed the
command's full argument list, which is a list of sexps (typically
forms or strings)." :type 'hook :group 'eshell-cmd)

(defcustom eshell-post-rewrite-command-hook nil "\
*A hook run after command rewriting is finished.
Each function is passed the symbol containing the rewritten command,
which may be modified directly.  Any return value is ignored." :type 'hook :group 'eshell-cmd)

(defcustom eshell-complex-commands nil "\
*A list of commands names or functions, that determine complexity.
That is, if a command is defined by a function named eshell/NAME,
and NAME is part of this list, it is invoked as a complex command.
Complex commands are always correct, but run much slower.  If a
command works fine without being part of this list, then it doesn't
need to be.

If an entry is a function, it will be called with the name, and should
return non-nil if the command is complex." :type '(repeat :tag "Commands" (choice (string :tag "Name") (function :tag "Predicate"))) :group 'eshell-cmd)

(defcustom eshell-cmd-load-hook '(eshell-cmd-initialize) "\
*A hook that gets run when `eshell-cmd' is loaded." :type 'hook :group 'eshell-cmd)

(defcustom eshell-debug-command nil "\
*If non-nil, enable debugging code.  SSLLOOWW.
This option is only useful for reporting bugs.  If you enable it, you
will have to visit the file 'eshell-cmd.el' and run the command
\\[eval-buffer]." :type 'boolean :group 'eshell-cmd)

(defcustom eshell-deferrable-commands '(eshell-named-command eshell-lisp-command eshell-process-identity) "\
*A list of functions which might return an ansychronous process.
If they return a process object, execution of the calling Eshell
command will wait for completion (in the background) before finishing
the command." :type '(repeat function) :group 'eshell-cmd)

(defcustom eshell-subcommand-bindings '((eshell-in-subcommand-p t) (default-directory default-directory) (process-environment (eshell-copy-environment))) "\
*A list of `let' bindings for subcommand environments." :type 'sexp :group 'eshell-cmd)

;;;***

;;;### (autoloads (eshell-explicit-command-char eshell-command-interpreter-max-length eshell-alternate-command-hook eshell-interpreter-alist eshell-windows-shell-file eshell-force-execution eshell-binary-suffixes eshell-ext-load-hook eshell-ext) "esh-ext" "eshell/esh-ext.el")
(defconst custom-define-current-source-file "esh-ext.el")

(defgroup eshell-ext nil "External commands are invoked when operating system executables are\nloaded into memory, thus beginning a new process." :tag "External commands" :group 'eshell)

(defcustom eshell-ext-load-hook '(eshell-ext-initialize) "\
*A hook that gets run when `eshell-ext' is loaded." :type 'hook :group 'eshell-ext)

(defcustom eshell-binary-suffixes (if (eshell-under-windows-p) '(".exe" ".com" ".bat" ".cmd" "") '("")) "\
*A list of suffixes used when searching for executable files." :type '(repeat string) :group 'eshell-ext)

(defcustom eshell-force-execution nil "\
*If non-nil, try to execute binary files regardless of permissions.
This can be useful on systems like Windows, where the operating system
doesn't happen to honor the permission bits in certain cases; or in
cases where you want to associate an interpreter with a particular
kind of script file, but the language won't let you but a '#!'
interpreter line in the file, and you don't want to make it executable
since nothing else but Eshell will be able to understand
`eshell-interpreter-alist'." :type 'boolean :group 'eshell-ext)

(defcustom eshell-windows-shell-file (if (eshell-under-windows-p) (if (string-match "\\(\\`cmdproxy\\|sh\\)\\.\\(com\\|exe\\)" shell-file-name) (or (eshell-search-path "cmd.exe") (eshell-search-path "command.com")) shell-file-name)) "\
*The name of the shell command to use for DOS/Windows batch files.
This defaults to nil on non-Windows systems, where this variable is
wholly ignored." :type '(choice file (const nil)) :group 'eshell-ext)

(defcustom eshell-interpreter-alist (if (eshell-under-windows-p) '(("\\.\\(bat\\|cmd\\)\\'" . eshell-invoke-batch-file))) "\
*An alist defining interpreter substitutions.
Each member is a cons cell of the form:

  (MATCH . INTERPRETER)

MATCH should be a regexp, which is matched against the command name,
or a function.  If either returns a non-nil value, then INTERPRETER
will be used for that command.

If INTERPRETER is a string, it will be called as the command name,
with the original command name passed as the first argument, with all
subsequent arguments following.  If INTERPRETER is a function, it will
be called with all of those arguments.  Note that interpreter
functions should throw `eshell-replace-command' with the alternate
command form, or they should return a value compatible with the
possible return values of `eshell-external-command', which see." :type '(repeat (cons (choice regexp (function :tag "Predicate")) (choice string (function :tag "Interpreter")))) :group 'eshell-ext)

(defcustom eshell-alternate-command-hook nil "\
*A hook run whenever external command lookup fails.
If a functions wishes to provide an alternate command, they must throw
it using the tag `eshell-replace-command'.  This is done because the
substituted command need not be external at all, and therefore must be
passed up to a higher level for re-evaluation.

Or, if the function returns a filename, that filename will be invoked
with the current command arguments rather than the command specified
by the user on the command line." :type 'hook :group 'eshell-ext)

(defcustom eshell-command-interpreter-max-length 256 "\
*The maximum length of any command interpreter string, plus args." :type 'integer :group 'eshell-ext)

(defcustom eshell-explicit-command-char ?* "\
*If this char occurs before a command name, call it externally.
That is, although `vi' may be an alias, `i' will always call the
external version." :type 'character :group 'eshell-ext)

;;;***

;;;### (autoloads (eshell-virtual-targets eshell-print-queue-size eshell-buffer-shorthand eshell-error-handle eshell-output-handle eshell-number-of-handles eshell-io-load-hook eshell-io) "esh-io" "eshell/esh-io.el")
(defconst custom-define-current-source-file "esh-io.el")

(defgroup eshell-io nil "Eshell's I/O management code provides a scheme for treating many\ndifferent kinds of objects -- symbols, files, buffers, etc. -- as\nthough they were files." :tag "I/O management" :group 'eshell)

(defcustom eshell-io-load-hook '(eshell-io-initialize) "\
*A hook that gets run when `eshell-io' is loaded." :type 'hook :group 'eshell-io)

(defcustom eshell-number-of-handles 3 "\
*The number of file handles that eshell supports.
Currently this is standard input, output and error.  But even all of
these Emacs does not currently support with asynchronous processes
\(which is what eshell uses so that you can continue doing work in
other buffers) ." :type 'integer :group 'eshell-io)

(defcustom eshell-output-handle 1 "\
*The index of the standard output handle." :type 'integer :group 'eshell-io)

(defcustom eshell-error-handle 2 "\
*The index of the standard error handle." :type 'integer :group 'eshell-io)

(defcustom eshell-buffer-shorthand nil "\
*If non-nil, a symbol name can be used for a buffer in redirection.
If nil, redirecting to a buffer requires buffer name syntax.  If this
variable is set, redirection directly to Lisp symbols will be
impossible.

Example:

  echo hello > '*scratch*  ; works if `eshell-buffer-shorthand' is t
  echo hello > #<buffer *scratch*>  ; always works" :type 'boolean :group 'eshell-io)

(defcustom eshell-print-queue-size 5 "\
*The size of the print queue, for doing buffered printing.
This is basically a speed enhancement, to avoid blocking the Lisp code
from executing while Emacs is redisplaying." :type 'integer :group 'eshell-io)

(defcustom eshell-virtual-targets '(("/dev/eshell" eshell-interactive-print nil) ("/dev/kill" (lambda (mode) (if (eq mode 'overwrite) (kill-new "")) 'eshell-kill-append) t) ("/dev/clip" (lambda (mode) (if (eq mode 'overwrite) (let ((x-select-enable-clipboard t)) (kill-new ""))) 'eshell-clipboard-append) t)) "\
*Map virtual devices name to Emacs Lisp functions.
If the user specifies any of the filenames above as a redirection
target, the function in the second element will be called.

If the third element is non-nil, the redirection mode is passed as an
argument (which is the symbol `overwrite', `append' or `insert'), and
the function is expected to return another function -- which is the
output function.  Otherwise, the second element itself is the output
function.

The output function is then called repeatedly with single strings,
which represents successive pieces of the output of the command, until nil
is passed, meaning EOF.

NOTE: /dev/null is handled specially as a virtual target, and should
not be added to this variable." :type '(repeat (list (string :tag "Target") function (choice (const :tag "Func returns output-func" t) (const :tag "Func is output-func" nil)))) :group 'eshell-io)

;;;***

;;;### (autoloads (eshell-status-in-modeline eshell-skip-prompt-function eshell-password-prompt-regexp eshell-preoutput-filter-functions eshell-output-filter-functions eshell-buffer-maximum-lines eshell-scroll-show-maximum-output eshell-scroll-to-bottom-on-output eshell-scroll-to-bottom-on-input eshell-expand-input-functions eshell-send-direct-to-subprocesses eshell-input-filter-functions eshell-kill-on-exit eshell-exit-hook eshell-first-time-mode-hook eshell-mode-hook eshell-mode-unload-hook eshell-mode) "esh-mode" "eshell/esh-mode.el")
(defconst custom-define-current-source-file "esh-mode.el")

(defgroup eshell-mode nil "This module contains code for handling input from the user." :tag "User interface" :group 'eshell)

(defcustom eshell-mode-unload-hook nil "\
*A hook that gets run when `eshell-mode' is unloaded." :type 'hook :group 'eshell-mode)

(defcustom eshell-mode-hook nil "\
*A hook that gets run when `eshell-mode' is entered." :type 'hook :group 'eshell-mode)

(defcustom eshell-first-time-mode-hook nil "\
*A hook that gets run the first time `eshell-mode' is entered.
That is to say, the first time during an Emacs session." :type 'hook :group 'eshell-mode)

(defcustom eshell-exit-hook '(eshell-query-kill-processes) "\
*A hook that is run whenever `eshell' is exited.
This hook is only run if exiting actually kills the buffer." :type 'hook :group 'eshell-mode)

(defcustom eshell-kill-on-exit t "\
*If non-nil, kill the Eshell buffer on the `exit' command.
Otherwise, the buffer will simply be buried." :type 'boolean :group 'eshell-mode)

(defcustom eshell-input-filter-functions nil "\
*Functions to call before input is processed.
The input is contained in the region from `eshell-last-input-start' to
`eshell-last-input-end'." :type 'hook :group 'eshell-mode)

(defcustom eshell-send-direct-to-subprocesses nil "\
*If t, send any input immediately to a subprocess." :type 'boolean :group 'eshell-mode)

(defcustom eshell-expand-input-functions nil "\
*Functions to call before input is parsed.
Each function is passed two arguments, which bounds the region of the
current input text." :type 'hook :group 'eshell-mode)

(defcustom eshell-scroll-to-bottom-on-input nil "\
*Controls whether input to interpreter causes window to scroll.
If nil, then do not scroll.  If t or `all', scroll all windows showing
buffer.  If `this', scroll only the selected window.

See `eshell-preinput-scroll-to-bottom'." :type '(radio (const :tag "Do not scroll Eshell windows" nil) (const :tag "Scroll all windows showing the buffer" all) (const :tag "Scroll only the selected window" this)) :group 'eshell-mode)

(defcustom eshell-scroll-to-bottom-on-output nil "\
*Controls whether interpreter output causes window to scroll.
If nil, then do not scroll.  If t or `all', scroll all windows showing
buffer.  If `this', scroll only the selected window.  If `others',
scroll only those that are not the selected window.

See variable `eshell-scroll-show-maximum-output' and function
`eshell-postoutput-scroll-to-bottom'." :type '(radio (const :tag "Do not scroll Eshell windows" nil) (const :tag "Scroll all windows showing the buffer" all) (const :tag "Scroll only the selected window" this) (const :tag "Scroll all windows other than selected" this)) :group 'eshell-mode)

(defcustom eshell-scroll-show-maximum-output t "\
*Controls how interpreter output causes window to scroll.
If non-nil, then show the maximum output when the window is scrolled.

See variable `eshell-scroll-to-bottom-on-output' and function
`eshell-postoutput-scroll-to-bottom'." :type 'boolean :group 'eshell-mode)

(defcustom eshell-buffer-maximum-lines 1024 "\
*The maximum size in lines for eshell buffers.
Eshell buffers are truncated from the top to be no greater than this
number, if the function `eshell-truncate-buffer' is on
`eshell-output-filter-functions'." :type 'integer :group 'eshell-mode)

(defcustom eshell-output-filter-functions '(eshell-handle-control-codes eshell-watch-for-password-prompt) "\
*Functions to call before output is displayed.
These functions are only called for output that is displayed
interactively, and not for output which is redirected." :type 'hook :group 'eshell-mode)

(defcustom eshell-preoutput-filter-functions nil "\
*Functions to call before output is inserted into the buffer.
These functions get one argument, a string containing the text to be
inserted.  They return the string as it should be inserted." :type 'hook :group 'eshell-mode)

(defcustom eshell-password-prompt-regexp "[Pp]ass\\(word\\|phrase\\).*:\\s *\\'" "\
*Regexp matching prompts for passwords in the inferior process.
This is used by `eshell-watch-for-password-prompt'." :type 'regexp :group 'eshell-mode)

(defcustom eshell-skip-prompt-function nil "\
*A function called from beginning of line to skip the prompt." :type '(choice (const nil) function) :group 'eshell-mode)

(defcustom eshell-status-in-modeline t "\
*If non-nil, let the user know a command is running in the modeline." :type 'boolean :group 'eshell-mode)

;;;***

;;;### (autoloads (eshell-modules-list eshell-module-unload-hook eshell-module) "esh-module" "eshell/esh-module.el")
(defconst custom-define-current-source-file "esh-module.el")

(defgroup eshell-module nil "The `eshell-module' group is for Eshell extension modules, which\nprovide optional behavior which the user can enable or disable by\ncustomizing the variable `eshell-modules-list'." :tag "Extension modules" :group 'eshell)

(defcustom eshell-module-unload-hook '(eshell-unload-extension-modules) "\
*A hook run when `eshell-module' is unloaded." :type 'hook :group 'eshell-module)

(defcustom eshell-modules-list '(eshell-alias eshell-banner eshell-basic eshell-cmpl eshell-dirs eshell-glob eshell-hist eshell-ls eshell-pred eshell-prompt eshell-script eshell-term eshell-unix) "\
*A list of optional add-on modules to be loaded by Eshell.
Changes will only take effect in future Eshell buffers." :type (append (list 'set ':tag "Supported modules") (mapcar (function (lambda (modname) (let ((modsym (intern modname))) (list 'const ':tag (format "%s -- %s" modname (get modsym 'custom-tag)) ':link (caar (get modsym 'custom-links)) ':doc (concat "
" (get modsym 'group-documentation) "
 ") modsym)))) (sort (mapcar 'symbol-name (eshell-subgroups 'eshell-module)) 'string-lessp)) '((repeat :inline t :tag "Other modules" symbol))) :group 'eshell-module)

;;;***

;;;### (autoloads (eshell-opt) "esh-opt" "eshell/esh-opt.el")
(defconst custom-define-current-source-file "esh-opt.el")

(defgroup eshell-opt nil "The options processing code handles command argument parsing for\nEshell commands implemented in Lisp." :tag "Command options processing" :group 'eshell)

;;;***

;;;### (autoloads (eshell-kill-processes-on-exit eshell-kill-process-signals eshell-kill-process-wait-time eshell-kill-hook eshell-exec-hook eshell-reset-signals eshell-delete-exited-processes eshell-done-messages-in-minibuffer eshell-process-wait-milliseconds eshell-process-wait-seconds eshell-proc-load-hook eshell-proc) "esh-proc" "eshell/esh-proc.el")
(defconst custom-define-current-source-file "esh-proc.el")

(defgroup eshell-proc nil "When Eshell invokes external commands, it always does so\nasynchronously, so that Emacs isn't tied up waiting for the process to\nfinish." :tag "Process management" :group 'eshell)

(defcustom eshell-proc-load-hook '(eshell-proc-initialize) "\
*A hook that gets run when `eshell-proc' is loaded." :type 'hook :group 'eshell-proc)

(defcustom eshell-process-wait-seconds 0 "\
*The number of seconds to delay waiting for a synchronous process." :type 'integer :group 'eshell-proc)

(defcustom eshell-process-wait-milliseconds 50 "\
*The number of milliseconds to delay waiting for a synchronous process." :type 'integer :group 'eshell-proc)

(defcustom eshell-done-messages-in-minibuffer t "\
*If non-nil, subjob \"Done\" messages will display in minibuffer." :type 'boolean :group 'eshell-proc)

(defcustom eshell-delete-exited-processes t "\
*If nil, process entries will stick around until `jobs' is run.
This variable sets the buffer-local value of `delete-exited-processes'
in Eshell buffers.

This variable causes Eshell to mimic the behavior of bash when set to
nil.  It allows the user to view the exit status of a completed subjob
\(process) at their leisure, because the process entry remains in
memory until the user examines it using \\[list-processes].

Otherwise, if `eshell-done-messages-in-minibuffer' is nil, and this
variable is set to t, the only indication the user will have that a
subjob is done is that it will no longer appear in the
\\[list-processes\\] display.

Note that Eshell will have to be restarted for a change in this
variable's value to take effect." :type 'boolean :group 'eshell-proc)

(defcustom eshell-reset-signals "^\\(interrupt\\|killed\\|quit\\|stopped\\)" "\
*If a termination signal matches this regexp, the terminal will be reset." :type 'regexp :group 'eshell-proc)

(defcustom eshell-exec-hook nil "\
*Called each time a process is exec'd by `eshell-gather-process-output'.
It is passed one argument, which is the process that was just started.
It is useful for things that must be done each time a process is
executed in a eshell mode buffer (e.g., `process-kill-without-query').
In contrast, `eshell-mode-hook' is only executed once when the buffer
is created." :type 'hook :group 'eshell-proc)

(defcustom eshell-kill-hook '(eshell-reset-after-proc) "\
*Called when a process run by `eshell-gather-process-output' has ended.
It is passed two arguments: the process that was just ended, and the
termination status (as a string).  Note that the first argument may be
nil, in which case the user attempted to send a signal, but there was
no relevant process.  This can be used for displaying help
information, for example." :type 'hook :group 'eshell-proc)

(defcustom eshell-kill-process-wait-time 5 "\
*Seconds to wait between sending termination signals to a subprocess." :type 'integer :group 'eshell-proc)

(defcustom eshell-kill-process-signals '(SIGINT SIGQUIT SIGKILL) "\
*Signals used to kill processes when an Eshell buffer exits.
Eshell calls each of these signals in order when an Eshell buffer is
killed; if the process is still alive afterwards, Eshell waits a
number of seconds defined by `eshell-kill-process-wait-time', and
tries the next signal in the list." :type '(repeat symbol) :group 'eshell-proc)

(defcustom eshell-kill-processes-on-exit nil "\
*If non-nil, kill active processes when exiting an Eshell buffer.
Emacs will only kill processes owned by that Eshell buffer.

If nil, ownership of background and foreground processes reverts to
Emacs itself, and will die only if the user exits Emacs, calls
`kill-process', or terminates the processes externally.

If `ask', Emacs prompts the user before killing any processes.

If `every', it prompts once for every process.

If t, it kills all buffer-owned processes without asking.

Processes are first sent SIGHUP, then SIGINT, then SIGQUIT, then
SIGKILL.  The variable `eshell-kill-process-wait-time' specifies how
long to delay between signals." :type '(choice (const :tag "Kill all, don't ask" t) (const :tag "Ask before killing" ask) (const :tag "Ask for each process" every) (const :tag "Don't kill subprocesses" nil)) :group 'eshell-proc)

;;;***

;;;### (autoloads (eshell-show-usage-metrics eshell-test) "esh-test" "eshell/esh-test.el")
(defconst custom-define-current-source-file "esh-test.el")

(defgroup eshell-test nil "This module is meant to ensure that Eshell is working correctly." :tag "Eshell test suite" :group 'eshell)

(defcustom eshell-show-usage-metrics nil "\
*If non-nil, display different usage metrics for each Eshell command." :set (lambda (symbol value) (if value (add-hook 'eshell-mode-hook 'eshell-show-usage-metrics) (remove-hook 'eshell-mode-hook 'eshell-show-usage-metrics)) (set symbol value)) :type '(choice (const :tag "No metrics" nil) (const :tag "Cons cells consumed" t) (const :tag "Time elapsed" 0)) :group 'eshell-test)

;;;***

;;;### (autoloads (eshell-ange-ls-uids eshell-number-regexp eshell-convert-numeric-arguments eshell-tar-regexp eshell-private-directory-modes eshell-private-file-modes eshell-handle-errors eshell-hosts-file eshell-passwd-file eshell-group-file eshell-stringify-t eshell-util) "esh-util" "eshell/esh-util.el")
(defconst custom-define-current-source-file "esh-util.el")

(defgroup eshell-util nil "This is general utility code, meant for use by Eshell itself." :tag "General utilities" :group 'eshell)

(defcustom eshell-stringify-t t "\
*If non-nil, the string representation of t is 't'.
If nil, t will be represented only in the exit code of the function,
and not printed as a string.  This causes Lisp functions to behave
similarly to external commands, as far as successful result output." :type 'boolean :group 'eshell-util)

(defcustom eshell-group-file "/etc/group" "\
*If non-nil, the name of the group file on your system." :type '(choice (const :tag "No group file" nil) file) :group 'eshell-util)

(defcustom eshell-passwd-file "/etc/passwd" "\
*If non-nil, the name of the passwd file on your system." :type '(choice (const :tag "No passwd file" nil) file) :group 'eshell-util)

(defcustom eshell-hosts-file "/etc/hosts" "\
*The name of the /etc/hosts file." :type '(choice (const :tag "No hosts file" nil) file) :group 'eshell-util)

(defcustom eshell-handle-errors t "\
*If non-nil, Eshell will handle errors itself.
Setting this to nil is offered as an aid to debugging only." :type 'boolean :group 'eshell-util)

(defcustom eshell-private-file-modes 384 "\
*The file-modes value to use for creating \"private\" files." :type 'integer :group 'eshell-util)

(defcustom eshell-private-directory-modes 448 "\
*The file-modes value to use for creating \"private\" directories." :type 'integer :group 'eshell-util)

(defcustom eshell-tar-regexp "\\.t\\(ar\\(\\.\\(gz\\|bz2\\|Z\\)\\)?\\|gz\\|a[zZ]\\|z2\\)\\'" "\
*Regular expression used to match tar file names." :type 'regexp :group 'eshell-util)

(defcustom eshell-convert-numeric-arguments t "\
*If non-nil, converting arguments of numeric form to Lisp numbers.
Numeric form is tested using the regular expression
`eshell-number-regexp'.

NOTE: If you find that numeric conversions are intefering with the
specification of filenames (for example, in calling `find-file', or
some other Lisp function that deals with files, not numbers), add the
following in your .emacs file:

  (put 'find-file 'eshell-no-numeric-conversions t)

Any function with the property `eshell-no-numeric-conversions' set to
a non-nil value, will be passed strings, not numbers, even when an
argument matches `eshell-number-regexp'." :type 'boolean :group 'eshell-util)

(defcustom eshell-number-regexp "-?\\([0-9]*\\.\\)?[0-9]+\\(e[-0-9.]+\\)?" "\
*Regular expression used to match numeric arguments.
If `eshell-convert-numeric-arguments' is non-nil, and an argument
matches this regexp, it will be converted to a Lisp number, using the
function `string-to-number'." :type 'regexp :group 'eshell-util)

(defcustom eshell-ange-ls-uids nil "\
*List of user/host/id strings, used to determine remote ownership." :type '(repeat (cons :tag "Host for User/UID map" (string :tag "Hostname") (repeat (cons :tag "User/UID List" (string :tag "Username") (repeat :tag "UIDs" string))))) :group 'eshell-util)

;;;***

;;;### (autoloads (eshell-variable-aliases-list eshell-variable-name-regexp eshell-modify-global-environment eshell-complete-export-definition eshell-prefer-lisp-variables eshell-var-load-hook eshell-var) "esh-var" "eshell/esh-var.el")
(defconst custom-define-current-source-file "esh-var.el")

(defgroup eshell-var nil "Variable interpolation is introduced whenever the '$' character\nappears unquoted in any argument (except when that argument is\nsurrounded by single quotes).  It may be used to interpolate a\nvariable value, a subcommand, or even the result of a Lisp form." :tag "Variable handling" :group 'eshell)

(defcustom eshell-var-load-hook '(eshell-var-initialize) "\
*A list of functions to call when loading `eshell-var'." :type 'hook :group 'eshell-var)

(defcustom eshell-prefer-lisp-variables nil "\
*If non-nil, prefer Lisp variables to environment variables." :type 'boolean :group 'eshell-var)

(defcustom eshell-complete-export-definition t "\
*If non-nil, completing names for `export' shows current definition." :type 'boolean :group 'eshell-var)

(defcustom eshell-modify-global-environment nil "\
*If non-nil, using `export' changes Emacs's global environment." :type 'boolean :group 'eshell-var)

(defcustom eshell-variable-name-regexp "[A-Za-z0-9_-]+" "\
*A regexp identifying what constitutes a variable name reference.
Note that this only applies for '$NAME'.  If the syntax '$<NAME>' is
used, then NAME can contain any character, including angle brackets,
if they are quoted with a backslash." :type 'regexp :group 'eshell-var)

(defcustom eshell-variable-aliases-list '(("COLUMNS" (lambda (indices) (window-width)) t) ("LINES" (lambda (indices) (window-height)) t) ("_" (lambda (indices) (if (not indices) (car (last eshell-last-arguments)) (eshell-apply-indices eshell-last-arguments indices)))) ("?" eshell-last-command-status) ("$" eshell-last-command-result) ("0" eshell-command-name) ("1" (lambda (indices) (nth 0 eshell-command-arguments))) ("2" (lambda (indices) (nth 1 eshell-command-arguments))) ("3" (lambda (indices) (nth 2 eshell-command-arguments))) ("4" (lambda (indices) (nth 3 eshell-command-arguments))) ("5" (lambda (indices) (nth 4 eshell-command-arguments))) ("6" (lambda (indices) (nth 5 eshell-command-arguments))) ("7" (lambda (indices) (nth 6 eshell-command-arguments))) ("8" (lambda (indices) (nth 7 eshell-command-arguments))) ("9" (lambda (indices) (nth 8 eshell-command-arguments))) ("*" (lambda (indices) (if (not indices) eshell-command-arguments (eshell-apply-indices eshell-command-arguments indices))))) "\
*This list provides aliasing for variable references.
It is very similar in concept to what `eshell-user-aliases-list' does
for commands.  Each member of this defines defines the name of a
command, and the Lisp value to return for that variable if it is
accessed via the syntax '$NAME'.

If the value is a function, that function will be called with two
arguments: the list of the indices that was used in the reference, and
whether the user is requesting the length of the ultimate element.
For example, a reference of '$NAME[10][20]' would result in the
function for alias `NAME' being called (assuming it were aliased to a
function), and the arguments passed to this function would be the list
'(10 20)', and nil." :type '(repeat (list string sexp (choice (const :tag "Copy to environment" t) (const :tag "Use only in Eshell" nil)))) :group 'eshell-var)

;;;***

;;;### (autoloads (eshell-prefer-to-shell eshell-directory-name eshell-buffer-name eshell-unload-hook eshell-load-hook eshell) "eshell" "eshell/eshell.el")
(defconst custom-define-current-source-file "eshell.el")

(defgroup eshell nil "Eshell is a command shell implemented entirely in Emacs Lisp.  It\ninvokes no external processes beyond those requested by the user.  It\nis intended to be a functional replacement for command shells such as\nbash, zsh, rc, 4dos; since Emacs itself is capable of handling most of\nthe tasks accomplished by such tools." :tag "The Emacs shell" :link '(info-link "(eshell)Top") :version "21.1" :group 'applications)

(defcustom eshell-load-hook nil "\
*A hook run once Eshell has been loaded." :type 'hook :group 'eshell)

(defcustom eshell-unload-hook '(eshell-remove-from-window-buffer-names eshell-unload-all-modules) "\
*A hook run when Eshell is unloaded from memory." :type 'hook :group 'eshell)

(defcustom eshell-buffer-name "*eshell*" "\
*The basename used for Eshell buffers." :set (lambda (symbol value) (if (boundp 'eshell-buffer-name) (eshell-remove-from-window-buffer-names)) (set symbol value) (eshell-add-to-window-buffer-names) value) :type 'string :group 'eshell)

(defcustom eshell-directory-name (convert-standard-filename "~/.eshell/") "\
*The directory where Eshell control files should be kept." :type 'directory :group 'eshell)

(defcustom eshell-prefer-to-shell nil "\
*If non-nil, \\[shell-command] will use Eshell instead of shell-mode." :set (lambda (symbol value) (if value (progn (define-key global-map [(meta ?!)] 'eshell-command)) (define-key global-map [(meta ?!)] 'shell-command)) (set symbol value)) :type 'boolean :require 'eshell :group 'eshell)

;;;***

(provide 'eshell-custom-defines)
