;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'eterm-custom-defines) (error "Feature eterm-custom-defines already loaded"))

;;;### (autoloads (term-backspace-string term-delete-string term-exec-hook term-mode-hook term-eol-on-send term-scroll-show-maximum-output term-scroll-to-bottom-on-output term-input-ring-file-name term-input-ignoredups term-input-autoexpand explicit-shell-file-name term) "term" "eterm/term.el")
(defconst custom-define-current-source-file "term.el")

(defgroup term nil "General command interpreter in a window" :group 'processes :group 'unix)

(defcustom explicit-shell-file-name nil "\
*If non-nil, is file name to use for explicitly requested inferior shell." :type '(choice (const nil) file) :group 'term)

(defcustom term-input-autoexpand nil "\
*If non-nil, expand input command history references on completion.
This mirrors the optional behavior of tcsh (its autoexpand and histlit).

If the value is `input', then the expansion is seen on input.
If the value is `history', then the expansion is only when inserting
into the buffer's input ring.  See also `term-magic-space' and
`term-dynamic-complete'.

This variable is buffer-local." :type '(choice (const nil) (const t) (const input) (const history)) :group 'term)

(defcustom term-input-ignoredups nil "\
*If non-nil, don't add input matching the last on the input ring.
This mirrors the optional behavior of bash.

This variable is buffer-local." :type 'boolean :group 'term)

(defcustom term-input-ring-file-name nil "\
*If non-nil, name of the file to read/write input history.
See also `term-read-input-ring' and `term-write-input-ring'.

This variable is buffer-local, and is a good thing to set in mode hooks." :type 'boolean :group 'term)

(defcustom term-scroll-to-bottom-on-output nil "\
*Controls whether interpreter output causes window to scroll.
If nil, then do not scroll.  If t or `all', scroll all windows showing buffer.
If `this', scroll only the selected window.
If `others', scroll only those that are not the selected window.

The default is nil.

See variable `term-scroll-show-maximum-output'. This variable is buffer-local." :type '(choice (const :tag "off" nil) (const t) (const all) (const this) (const others)) :group 'term)

(defcustom term-scroll-show-maximum-output nil "\
*Controls how interpreter output causes window to scroll.
If non-nil, then show the maximum output when the window is scrolled.

See variable `term-scroll-to-bottom-on-output'.
This variable is buffer-local." :type 'boolean :group 'term)

(defcustom term-eol-on-send t "\
*Non-nil means go to the end of the line before sending input.
See `term-send-input'." :type 'boolean :group 'term)

(defcustom term-mode-hook 'nil "\
Called upon entry into term-mode
This is run before the process is cranked up." :type 'hook :group 'term)

(defcustom term-exec-hook 'nil "\
Called each time a process is exec'd by term-exec.
This is called after the process is cranked up.  It is useful for things that
must be done each time a process is executed in a term-mode buffer (e.g.,
\(process-kill-without-query)).  In contrast, the term-mode-hook is only
executed once when the buffer is created." :type 'hook :group 'term)

(defcustom term-delete-string "" "\
String to send when Delete is pressed." :type 'string :group 'term)

(defcustom term-backspace-string "" "\
String to send when BackSpace is pressed." :type 'string :group 'term)

;;;***

(provide 'eterm-custom-defines)
