;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'footnote-custom-defines) (error "Feature footnote-custom-defines already loaded"))

;;;### (autoloads (footnote-body-tag-spacing footnote-use-message-mode footnote-style footnote-always-blank-line-before-signature footnote-spaced-footnotes footnote-prompt-before-deletion footnote-narrow-to-footnotes-when-editing footnote-mode-hook footnote-mode-line-string footnote) "footnote" "footnote/footnote.el")
(defconst custom-define-current-source-file "footnote.el")

(defgroup footnote nil "Support for footnotes in mail and news messages." :group 'message)

(defcustom footnote-mode-line-string " FN" "\
*String to display in modes section of the mode-line." :group 'footnote)

(defcustom footnote-mode-hook nil "\
*Hook functions run when footnote-mode is activated." :type 'hook :group 'footnote)

(defcustom footnote-narrow-to-footnotes-when-editing nil "\
*If set, narrow to footnote text body while editing a footnote." :type 'boolean :group 'footnote)

(defcustom footnote-prompt-before-deletion t "\
*If set, prompt before deleting a footnote.
There is currently no way to undo deletions." :type 'boolean :group 'footnote)

(defcustom footnote-spaced-footnotes t "\
If set true it will put a blank line between each footnote.
If nil, no blank line will be inserted." :type 'boolean :group 'footnote)

(defcustom footnote-always-blank-line-before-signature t "\
If set true, a blank line will always be inserted before signature.
This has visible effect only when `footnote-spaced-footnotes' is not true." :type 'boolean :group 'footnote)

(defcustom footnote-style 'numeric "\
*Style used for footnoting.
numeric == 1, 2, 3, ...
numeric-latin == {, , } | {1, 2, 3, 4, ...}
english-lower == a, b, c, ...
english-upper == A, B, C, ...
roman-lower == i, ii, iii, iv, v, ...
roman-upper == I, II, III, IV, V, ...
Some versions of XEmacs and Emacs/mule may support further styles
like 'hebrew, 'greek-lower, and 'greek-upper." :type 'symbol :group 'footnote)

(defcustom footnote-use-message-mode t "\
*If non-nil assume Footnoting will be done in message-mode." :type 'boolean :group 'footnote)

(defcustom footnote-body-tag-spacing 2 "\
*Number of blanks separating a footnote body tag and its text." :type 'integer :group 'footnote)

;;;***

(provide 'footnote-custom-defines)
