;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'forms-custom-defines) (error "Feature forms-custom-defines already loaded"))

;;;### (autoloads (forms-rw-face forms-ro-face forms-insert-after forms-use-text-properties forms-use-extents forms-use-colors forms-forms-jump forms-forms-scroll forms-check-number-of-fields forms-mode-hooks forms) "forms" "forms/forms.el")
(defconst custom-define-current-source-file "forms.el")

(defgroup forms nil "Edit a file as a form to fill in." :group 'data)

(defcustom forms-mode-hooks nil "\
Hook functions to be run upon entering Forms mode." :group 'forms :type 'function)

(defcustom forms-check-number-of-fields t "\
*If non-nil, warn about records with wrong number of fields." :group 'forms :type 'boolean)

(defcustom forms-forms-scroll nil "\
*Non-nil means replace scroll-up/down commands in Forms mode.
The replacement commands performs forms-next/prev-record." :group 'forms :type 'boolean)

(defcustom forms-forms-jump nil "\
*Non-nil means redefine beginning/end-of-buffer in Forms mode.
The replacement commands performs forms-first/last-record." :group 'forms :type 'boolean)

(defcustom forms-use-colors t "\
*Non-nil means Emacs should attempt to use text-properties (GNU
 Emacs) or extents (XEmacs) if they are available." :group 'forms :type 'boolean)

(defcustom forms-use-extents (and forms-use-colors (fboundp 'set-extent-property)) "\
*Non-nil means: use XEmacs/Lucid Emacs extents.
Defaults to t if this Emacs is capable of handling extents." :group 'forms :type 'boolean)

(defcustom forms-use-text-properties (and forms-use-colors (not forms-use-extents) (fboundp 'set-text-properties)) "\
*Non-nil means: use text properties.
Defaults to t if this Emacs is capable of handling text properties." :group 'forms :type 'boolean)

(defcustom forms-insert-after nil "\
*Non-nil means: inserts of new records go after current record.
Also, initial position is at last record." :group 'forms :type 'boolean)

(defcustom forms-ro-face (if (string-match "XEmacs" emacs-version) 'forms-label-face 'default) "\
The face (a symbol) that is used to display read-only text on the screen." :group 'forms :type 'face)

(defcustom forms-rw-face (if (string-match "XEmacs" emacs-version) 'forms-field-face 'region) "\
The face (a symbol) that is used to display read-write text on the screen." :group 'forms :type 'face)

;;;***

(provide 'forms-custom-defines)
