;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'fortran-modes-custom-defines) (error "Feature fortran-modes-custom-defines already loaded"))

;;;### (autoloads (f90-mode-hook f90-leave-line-no f90-auto-keyword-case f90-break-before-delimiters f90-break-delimiters f90-smart-end f90-beginning-ampersand f90-directive-comment-re f90-indented-comment-re f90-comment-region f90-continuation-indent f90-program-indent f90-type-indent f90-if-indent f90-do-indent f90-indent f90) "f90" "fortran-modes/f90.el")
(defconst custom-define-current-source-file "f90.el")

(defgroup f90 nil "Major mode for editing free format Fortran 90,95 code." :group 'languages)

(defgroup f90-indent nil "Indentation in free format Fortran." :prefix "f90-" :group 'f90)

(defcustom f90-do-indent 3 "\
*Extra indentation applied to DO blocks." :type 'integer :group 'f90-indent)

(defcustom f90-if-indent 3 "\
*Extra indentation applied to IF, SELECT CASE, WHERE and FORALL blocks." :type 'integer :group 'f90-indent)

(defcustom f90-type-indent 3 "\
*Extra indentation applied to TYPE, INTERFACE and BLOCK DATA blocks." :type 'integer :group 'f90-indent)

(defcustom f90-program-indent 2 "\
*Extra indentation applied to PROGRAM, MODULE, SUBROUTINE, FUNCTION blocks." :type 'integer :group 'f90-indent)

(defcustom f90-continuation-indent 5 "\
*Extra indentation applied to continuation lines." :type 'integer :group 'f90-indent)

(defcustom f90-comment-region "!!$" "\
*String inserted by \\[f90-comment-region] at start of each line in region." :type 'string :group 'f90-indent)

(defcustom f90-indented-comment-re "!" "\
*Regexp matching comments to indent as code." :type 'regexp :group 'f90-indent)

(defcustom f90-directive-comment-re "!hpf\\$" "\
*Regexp of comment-like directive like \"!HPF\\\\$\", not to be indented." :type 'regexp :group 'f90-indent)

(defcustom f90-beginning-ampersand t "\
*Non-nil gives automatic insertion of & at start of continuation line." :type 'boolean :group 'f90)

(defcustom f90-smart-end 'blink "\
*From an END statement, check and fill the end using matching block start.
Allowed values are 'blink, 'no-blink, and nil, which determine
whether to blink the matching beginning." :type '(choice (const blink) (const no-blink) (const nil)) :group 'f90)

(defcustom f90-break-delimiters "[-+\\*/><=,% 	]" "\
*Regexp matching delimiter characters at which lines may be broken.
There are certain tokens comprised entirely of characters
matching this regexp that should not be split, and these are
specified by the constant `f90-no-break-re'." :type 'regexp :group 'f90)

(defcustom f90-break-before-delimiters t "\
*Non-nil causes `f90-do-auto-fill' to break lines before delimiters." :type 'boolean :group 'f90)

(defcustom f90-auto-keyword-case nil "\
*Automatic case conversion of keywords.
The options are 'downcase-word, 'upcase-word, 'capitalize-word and nil." :type '(choice (const downcase-word) (const upcase-word) (const capitalize-word) (const nil)) :group 'f90)

(defcustom f90-leave-line-no nil "\
*If non-nil, line numbers are not left justified." :type 'boolean :group 'f90)

(defcustom f90-mode-hook nil "\
Hook run when entering F90 mode." :type 'hook :options '(f90-add-imenu-menu) :group 'f90)

;;;***

;;;### (autoloads (fortran-break-before-delimiters fortran-startup-message fortran-electric-line-number fortran-comment-region fortran-continuation-string fortran-blink-matching-if fortran-check-all-num-for-matching-do fortran-line-number-indent fortran-comment-indent-char fortran-minimum-statement-indent-tab fortran-minimum-statement-indent-fixed fortran-comment-line-start-skip fortran-comment-line-start fortran-comment-line-extra-indent fortran-comment-indent-style fortran-continuation-indent fortran-structure-indent fortran-if-indent fortran-do-indent fortran-tab-mode-string fortran-tab-mode-default fortran-comment fortran-indent fortran) "fortran" "fortran-modes/fortran.el")
(defconst custom-define-current-source-file "fortran.el")

(defgroup fortran nil "Fortran mode for Emacs" :group 'languages)

(defgroup fortran-indent nil "Indentation variables in Fortran mode" :prefix "fortran-" :group 'fortran)

(defgroup fortran-comment nil "Comment-handling variables in Fortran mode" :prefix "fortran-" :group 'fortran)

(defcustom fortran-tab-mode-default nil "\
*Default tabbing/carriage control style for empty files in Fortran mode.
A value of t specifies tab-digit style of continuation control.
A value of nil specifies that continuation lines are marked
with a character in column 6." :type 'boolean :group 'fortran-indent)

(defcustom fortran-tab-mode-string nil "\
String to appear in mode line when TAB format mode is on." :type '(choice (const nil) string) :group 'fortran-indent)

(defcustom fortran-do-indent 3 "\
*Extra indentation applied to DO blocks." :type 'integer :group 'fortran-indent)

(defcustom fortran-if-indent 3 "\
*Extra indentation applied to IF blocks." :type 'integer :group 'fortran-indent)

(defcustom fortran-structure-indent 3 "\
*Extra indentation applied to STRUCTURE, UNION, MAP and INTERFACE blocks." :type 'integer :group 'fortran-indent)

(defcustom fortran-continuation-indent 5 "\
*Extra indentation applied to Fortran continuation lines." :type 'integer :group 'fortran-indent)

(defcustom fortran-comment-indent-style 'fixed "\
*nil forces comment lines not to be touched,
'fixed makes fixed comment indentation to `fortran-comment-line-extra-indent'
columns beyond `fortran-minimum-statement-indent-fixed' (for
`indent-tabs-mode' of nil) or `fortran-minimum-statement-indent-tab' (for
`indent-tabs-mode' of t), and 'relative indents to current
Fortran indentation plus `fortran-comment-line-extra-indent'." :type '(radio (const nil) (const fixed) (const relative)) :group 'fortran-indent)

(defcustom fortran-comment-line-extra-indent 0 "\
*Amount of extra indentation for text within full-line comments." :type 'integer :group 'fortran-indent :group 'fortran-comment)

(defcustom fortran-comment-line-start nil "\
*Delimiter inserted to start new full-line comment." :type '(choice string (const nil)) :group 'fortran-comment)

(defcustom fortran-comment-line-start-skip nil "\
*Regexp to match the start of a full-line comment." :type '(choice string (const nil)) :group 'fortran-comment)

(defcustom fortran-minimum-statement-indent-fixed 6 "\
*Minimum statement indentation for fixed format continuation style." :type 'integer :group 'fortran-indent)

(defcustom fortran-minimum-statement-indent-tab (max tab-width 6) "\
*Minimum statement indentation for TAB format continuation style." :type 'integer :group 'fortran-indent)

(defcustom fortran-comment-indent-char " " "\
*Single-character string inserted for Fortran comment indentation.
Normally a space." :type 'string :group 'fortran-comment)

(defcustom fortran-line-number-indent 1 "\
*Maximum indentation for Fortran line numbers.
5 means right-justify them within their five-column field." :type 'integer :group 'fortran-indent)

(defcustom fortran-check-all-num-for-matching-do nil "\
*Non-nil causes all numbered lines to be treated as possible DO loop ends." :type 'boolean :group 'fortran)

(defcustom fortran-blink-matching-if nil "\
*Non-nil causes \\[fortran-indent-line] on ENDIF statement to blink on matching IF.
Also, from an ENDDO statement blink on matching DO [WHILE] statement." :type 'boolean :group 'fortran)

(defcustom fortran-continuation-string "$" "\
*Single-character string used for Fortran continuation lines.
In fixed format continuation style, this character is inserted in
column 6 by \\[fortran-split-line] to begin a continuation line.
Also, if \\[fortran-indent-line] finds this at the beginning of a line, it will
convert the line into a continuation line of the appropriate style.
Normally $." :type 'string :group 'fortran)

(defcustom fortran-comment-region "c$$$" "\
*String inserted by \\[fortran-comment-region] at start of each line in region." :type 'string :group 'fortran-comment)

(defcustom fortran-electric-line-number t "\
*Non-nil causes line number digits to be moved to the correct column as typed." :type 'boolean :group 'fortran)

(defcustom fortran-startup-message t "\
*Non-nil displays a startup message when Fortran mode is first called." :type 'boolean :group 'fortran)

(defcustom fortran-break-before-delimiters t "\
*Non-nil causes `fortran-fill' to break lines before delimiters." :type 'boolean :group 'fortran)

;;;***

(provide 'fortran-modes-custom-defines)
