;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'fsf-compat-autoloads) (error "Feature fsf-compat-autoloads already loaded"))

(package-provide 'fsf-compat :version 1.24 :author-version "No-Upstream-Ver" :type 'single-file)

;;;### (autoloads (backward-button forward-button push-button previous-button next-button button-at make-text-button insert-button make-button button-activate define-button-type) "button" "fsf-compat/button.el")

(autoload 'define-button-type "button" "\
Define a `button type' called NAME (a symbol).
The remaining arguments form a sequence of PROPERTY VALUE pairs,
specifying properties to use as defaults for buttons with this type
\(a button's type may be set by giving it a `type' property when
creating the button, using the :type keyword argument).

In addition, the keyword argument :supertype may be used to specify a
button-type from which NAME inherits its default property values
\(however, the inheritance happens only when NAME is defined; subsequent
changes to a supertype are not reflected in its subtypes).

arguments: (NAME &rest PROPERTIES)
" nil nil)

(autoload 'button-activate "button" "\
Call BUTTON's action property.
If USE-MOUSE-ACTION is non-nil, invoke the button's mouse-action
instead of its normal action; if the button has no mouse-action,
the normal action is used instead.

The action can either be a marker or a function.  If it's a
marker then goto it.  Otherwise if it is a function then it is
called with BUTTON as only argument.  BUTTON is either an
extent, a buffer position, or (for buttons in the mode-line or
header-line) a string.

arguments: (BUTTON &optional USE-MOUSE-ACTION)
" nil nil)

(autoload 'make-button "button" "\
Make a button from BEG to END in the current buffer.
The remaining arguments form a sequence of PROPERTY VALUE pairs,
specifying properties to add to the button.
In addition, the keyword argument :type may be used to specify a
button-type from which to inherit other properties; see
`define-button-type'.

Also see `make-text-button', `insert-button'.

arguments: (BEG END &rest PROPERTIES)
" nil nil)

(autoload 'insert-button "button" "\
Insert a button with the label LABEL.
The remaining arguments form a sequence of PROPERTY VALUE pairs,
specifying properties to add to the button.
In addition, the keyword argument :type may be used to specify a
button-type from which to inherit other properties; see
`define-button-type'.

Also see `insert-text-button', `make-button'.

arguments: (LABEL &rest PROPERTIES)
" nil nil)

(autoload 'make-text-button "button" "\
Make a button from BEG to END in the current buffer.
The remaining arguments form a sequence of PROPERTY VALUE pairs,
specifying properties to add to the button.
In addition, the keyword argument :type may be used to specify a
button-type from which to inherit other properties; see
`define-button-type'.

This function is like `make-button', except that the button is actually
part of the text instead of being a property of the buffer.  That is,
this function uses text properties, the other uses extents.
Creating large numbers of buttons can also be somewhat faster
using `make-text-button'.  Note, however, that if there is an existing
face property at the site of the button, the button face may not be visible.
You may want to use `make-button' in that case.

BEG can also be a string, in which case it is made into a button.

Also see `insert-text-button'.

arguments: (BEG END &rest PROPERTIES)
" nil nil)

(autoload 'button-at "button" "\
Return the button at position POS in the current buffer, or nil.
If the button at POS is a text property button, the return value
is a marker pointing to POS.

arguments: (POS)
" nil nil)

(autoload 'next-button "button" "\
Return the next button after position POS in the current buffer.
If COUNT-CURRENT is non-nil, count any button at POS in the search,
instead of starting at the next button.

arguments: (POS &optional COUNT-CURRENT)
" nil nil)

(autoload 'previous-button "button" "\
Return the previous button before position POS in the current buffer.
If COUNT-CURRENT is non-nil, count any button at POS in the search,
instead of starting at the next button.

arguments: (POS &optional COUNT-CURRENT)
" nil nil)

(autoload 'push-button "button" "\
Perform the action specified by a button at location POS.
POS may be either a buffer position or a mouse-event.  If
USE-MOUSE-ACTION is non-nil, invoke the button's mouse-action
instead of its normal action; if the button has no mouse-action,
the normal action is used instead.  The action may be either a
function to call or a marker to display and is invoked using
`button-activate' (which see).

POS defaults to point, except when `push-button' is invoked
interactively as the result of a mouse-event, in which case, the
mouse event is used.
If there's no button at POS, do nothing and return nil, otherwise
return t.

arguments: (&optional POS USE-MOUSE-ACTION)
" t nil)

(autoload 'forward-button "button" "\
Move to the Nth next button, or Nth previous button if N is negative.
If N is 0, move to the start of any button at point.
If WRAP is non-nil, moving past either end of the buffer continues from the
other end.
If DISPLAY-MESSAGE is non-nil, the button's help-echo string is displayed.
Any button with a non-nil `skip' property is skipped over.
Returns the button found.

arguments: (N &optional WRAP DISPLAY-MESSAGE)
" t nil)

(autoload 'backward-button "button" "\
Move to the Nth previous button, or Nth next button if N is negative.
If N is 0, move to the start of any button at point.
If WRAP is non-nil, moving past either end of the buffer continues from the
other end.
If DISPLAY-MESSAGE is non-nil, the button's help-echo string is displayed.
Any button with a non-nil `skip' property is skipped over.
Returns the button found.

arguments: (N &optional WRAP DISPLAY-MESSAGE)
" t nil)

;;;***

;;;### (autoloads (goto-address goto-address-at-point goto-address-at-mouse) "goto-addr" "fsf-compat/goto-addr.el")

(autoload 'goto-address-at-mouse "goto-addr" "\
Send to the e-mail address or load the URL clicked with the mouse.
Send mail to address at position of mouse click.  See documentation for
`goto-address-find-address-at-point'.  If no address is found
there, then load the URL at or before the position of the mouse click.

arguments: (EVENT)
" t nil)

(autoload 'goto-address-at-point "goto-addr" "\
Send to the e-mail address or load the URL at point.
Send mail to address at point.  See documentation for
`goto-address-find-address-at-point'.  If no address is found
there, then load the URL at or before point.

arguments: ()
" t nil)

(autoload 'goto-address "goto-addr" "\
Sets up goto-address functionality in the current buffer.
Allows user to use mouse/keyboard command to click to go to a URL
or to send e-mail.
By default, goto-address binds to mouse-2 and C-c RET.

Also fontifies the buffer appropriately (see `goto-address-fontify-p' and
`goto-address-highlight-p' for more information).

arguments: ()
" t nil)

;;;***

;;;### (autoloads (declare-function) "subr-fsf" "fsf-compat/subr-fsf.el")

(defalias 'wholenump 'natnump)

(autoload 'declare-function "subr-fsf" "\


arguments: (FN FILE &optional ARGLIST FILEONLY)
" nil 'macro)

;;;***

;;;### (autoloads (thing-at-point bounds-of-thing-at-point forward-thing) "thingatpt" "fsf-compat/thingatpt.el")

(autoload 'forward-thing "thingatpt" "\
Move forward to the end of the next THING.

arguments: (THING &optional N)
" nil nil)

(autoload 'bounds-of-thing-at-point "thingatpt" "\
Determine the start and end buffer locations for the THING at point.
THING is a symbol which specifies the kind of syntactic entity you want.
Possibilities include `symbol', `list', `sexp', `defun', `filename', `url',
`word', `sentence', `whitespace', `line', `page' and others.

See the file `thingatpt.el' for documentation on how to define
a symbol as a valid THING.

The value is a cons cell (START . END) giving the start and end positions
of the textual entity that was found.

arguments: (THING)
" nil nil)

(autoload 'thing-at-point "thingatpt" "\
Return the THING at point.
THING is a symbol which specifies the kind of syntactic entity you want.
Possibilities include `symbol', `list', `sexp', `defun', `filename', `url',
`word', `sentence', `whitespace', `line', `page' and others.

See the file `thingatpt.el' for documentation on how to define
a symbol as a valid THING.

arguments: (THING)
" nil nil)

;;;***

;;;### (autoloads (x-popup-menu) "x-popup-menu" "fsf-compat/x-popup-menu.el")

(autoload 'x-popup-menu "x-popup-menu" "\
Pop up menu for Mouse-2 for selected date in the calendar window.

arguments: (EVENT MENU)
" nil nil)

;;;***

(provide 'fsf-compat-autoloads)
