;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'haskell-mode-custom-defines) (error "Feature haskell-mode-custom-defines already loaded"))

;;;### (autoloads (haskell-doc-chop-off-fctname haskell-doc-chop-off-context haskell-doc-show-user-defined haskell-doc-show-strategy haskell-doc-show-prelude haskell-doc-show-reserved haskell-doc-show-global-types haskell-doc) "haskell-doc" "haskell-mode/haskell-doc.el")
(defconst custom-define-current-source-file "haskell-doc.el")

(defgroup haskell-doc nil "Show Haskell function types in echo area." :group 'haskell :prefix "haskell-doc-")

(defcustom haskell-doc-show-global-types nil "\
If non-nil, search for the types of global functions by loading the files.
This variable is buffer-local." :type 'boolean)

(defcustom haskell-doc-show-reserved t "\
If non-nil, show a documentation string for reserved ids.
This variable is buffer-local." :type 'boolean)

(defcustom haskell-doc-show-prelude t "\
If non-nil, show a documentation string for prelude functions.
This variable is buffer-local." :type 'boolean)

(defcustom haskell-doc-show-strategy t "\
If non-nil, show a documentation string for strategies.
This variable is buffer-local." :type 'boolean)

(defcustom haskell-doc-show-user-defined t "\
If non-nil, show a documentation string for user defined ids.
This variable is buffer-local." :type 'boolean)

(defcustom haskell-doc-chop-off-context t "\
If non-nil eliminate the context part in a Haskell type." :type 'boolean)

(defcustom haskell-doc-chop-off-fctname nil "\
If non-nil omit the function name and show only the type." :type 'boolean)

;;;***

;;;### (autoloads (haskell-font-lock-symbols) "haskell-font-lock" "haskell-mode/haskell-font-lock.el")
(defconst custom-define-current-source-file "haskell-font-lock.el")

(defcustom haskell-font-lock-symbols nil "\
Display \\ and -> and such using symbols in fonts.
This may sound like a neat trick, but be extra careful: it changes the
alignment and can thus lead to nasty surprises w.r.t layout.
If t, try to use whichever font is available.  Otherwise you can
set it to a particular font of your preference among `japanese-jisx0208'
and `unicode'." :group 'haskell :type '(choice (const nil) (const t) (const unicode) (const japanese-jisx0208)))

;;;***

;;;### (autoloads (haskell-ghci-program-args haskell-ghci-program-name haskell-ghci) "haskell-ghci" "haskell-mode/haskell-ghci.el")
(defconst custom-define-current-source-file "haskell-ghci.el")

(defgroup haskell-ghci nil "Major mode for interacting with an inferior GHCi session." :group 'haskell :prefix "haskell-ghci-")

(defcustom haskell-ghci-program-name "ghci" "\
*The name of the GHCi interpreter program." :type 'string :group 'haskell-ghci)

(defcustom haskell-ghci-program-args nil "\
*A list of string args to pass when starting the GHCi interpreter." :type '(repeat string) :group 'haskell-ghci)

;;;***

;;;### (autoloads (haskell-hugs-program-args haskell-hugs-program-name haskell-hugs) "haskell-hugs" "haskell-mode/haskell-hugs.el")
(defconst custom-define-current-source-file "haskell-hugs.el")

(defgroup haskell-hugs nil "Major mode for interacting with an inferior Hugs session." :group 'haskell :prefix "haskell-hugs-")

(defcustom haskell-hugs-program-name "hugs" "\
*The name of the command to start the Hugs interpreter." :type 'string :group 'haskell-hugs)

(defcustom haskell-hugs-program-args '("+.") "\
*A list of string args to send to the hugs process." :type '(repeat string) :group 'haskell-hugs)

;;;***

;;;### (autoloads (haskell-indent-after-keywords haskell-indent-rhs-align-column haskell-indent-literate-Bird-default-offset haskell-indent-offset haskell-indent) "haskell-indent" "haskell-mode/haskell-indent.el")
(defconst custom-define-current-source-file "haskell-indent.el")

(defgroup haskell-indent nil "Haskell indentation." :group 'haskell :prefix "haskell-indent-")

(defcustom haskell-indent-offset 4 "\
Indentation of Haskell statements with respect to containing block." :type 'integer :group 'haskell-indent)

(defcustom haskell-indent-literate-Bird-default-offset 1 "\
Default number of blanks after > in a Bird style literate script." :type 'integer :group 'haskell-indent)

(defcustom haskell-indent-rhs-align-column 0 "\
Column on which to align right-hand sides (use 0 for ad-hoc alignment)." :type 'integer :group 'haskell-indent)

(defcustom haskell-indent-after-keywords '(("where" 2 0) ("of" 2) ("do" 2) ("in" 2 0) "if" "then" "else" "let") "\
Keywords after which indentation should be indented by some offset.
Each keyword info can have the following forms:

   KEYWORD | (KEYWORD OFFSET [OFFSET-HANGING])

If absent OFFSET-HANGING defaults to OFFSET.
If absent OFFSET defaults to `haskell-indent-offset'.

OFFSET-HANGING is the offset to use in the case where the keyword
is at the end of an otherwise-non-empty line." :type '(repeat (choice string (cons :tag "" (string :tag "keyword:") (cons :tag "" (integer :tag "offset") (choice (const nil) (list :tag "" (integer :tag "offset-pending"))))))))

;;;***

;;;### (autoloads (haskell-mode-hook haskell-literate-default haskell) "haskell-mode" "haskell-mode/haskell-mode.el")
(defconst custom-define-current-source-file "haskell-mode.el")

(defgroup haskell nil "Major mode for editing Haskell programs." :group 'languages :prefix "haskell-")

(defcustom haskell-literate-default 'bird "\
*Default value for `haskell-literate'.
Used if the style of a literate buffer is ambiguous.  This variable should
be set to the preferred literate style." :type '(choice (const bird) (const latex) (const nil)))

(defcustom haskell-mode-hook nil "\
Hook run after entering Haskell mode." :type 'hook :options '(turn-on-haskell-indent turn-on-font-lock turn-on-eldoc-mode imenu-add-menubar-index))

;;;***

;;;### (autoloads (haskell-program-name) "inf-haskell" "haskell-mode/inf-haskell.el")
(defconst custom-define-current-source-file "inf-haskell.el")

(defcustom haskell-program-name (or (cond ((not (fboundp 'executable-find)) nil) ((executable-find "hugs") "hugs \"+.\"") ((executable-find "ghci") "ghci")) "hugs \"+.\"") "\
The name of the command to start the inferior Haskell process.
The command can include arguments." :group 'haskell :type '(choice string (repeat string)))

;;;***

(provide 'haskell-mode-custom-defines)
