;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ibuffer-custom-defines) (error "Feature ibuffer-custom-defines already loaded"))

;;;### (autoloads (ibuffer-faces ibuffer) "auto-autoloads" "ibuffer/auto-autoloads.el")
(defconst custom-define-current-source-file "auto-autoloads.el")

(defgroup ibuffer nil "An advanced replacement for `buffer-menu'.\n\nIbuffer allows you to operate on buffers in a manner much like Dired.\nOperations include sorting, marking by regular expression, and\nthe ability to filter the displayed buffers by various criteria." :group 'convenience)

(defgroup ibuffer-faces nil "Faces used by Ibuffer package." :group 'ibuffer :group 'faces)

;;;***

;;;### (autoloads (ibuffer-saved-filter-groups ibuffer-show-empty-filter-groups) "ibuf-ext" "ibuffer/ibuf-ext.el")
(defconst custom-define-current-source-file "ibuf-ext.el")

(defcustom ibuffer-show-empty-filter-groups t "\
If non-nil, then show the names of filter groups which are empty." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-saved-filter-groups '(("gnus" ((or (mode . message-mode) (mode . mail-mode) (mode . gnus-group-mode) (mode . gnus-summary-mode) (mode . gnus-article-mode)))) ("programming" ((or (mode . emacs-lisp-mode) (mode . cperl-mode) (mode . c-mode) (mode . java-mode) (mode . idl-mode) (mode . lisp-mode))))) "\
An alist of filtering groups to switch between.

This variable should look like ((\"STRING\" QUALIFIERS)
                                (\"STRING\" QUALIFIERS) ...), where
QUALIFIERS is a list of the same form as
`ibuffer-filtering-qualifiers'.

See also the variables `ibuffer-filter-groups',
`ibuffer-filtering-qualifiers', `ibuffer-filtering-alist', and the
functions `ibuffer-switch-to-saved-filter-group',
`ibuffer-save-filter-group'." :type '(repeat sexp) :group 'ibuffer)

;;;***

;;;### (autoloads (ibuffer-save-with-custom ibuffer-old-time ibuffer-saved-filters ibuffer-always-show-predicates ibuffer-never-show-predicates ibuffer-filter-format-alist ibuffer-truncate-lines ibuffer-directory-abbrev-alist ibuffer-mode-hooks ibuffer-hooks ibuffer-default-directory ibuffer-use-header-line ibuffer-always-show-last-buffer ibuffer-view-ibuffer ibuffer-expert ibuffer-deletion-char ibuffer-marked-char ibuffer-read-only-char ibuffer-modified-char ibuffer-maybe-show-predicates ibuffer-eliding-string ibuffer-elide-long-columns ibuffer-default-sorting-reversep ibuffer-toggle-sorting-modes ibuffer-default-sorting-mode ibuffer-case-fold-search ibuffer-default-shrink-to-minimum-size ibuffer-use-other-window ibuffer-fontification-alist ibuffer-help-buffer-modes ibuffer-use-fontification ibuffer-header-line-face ibuffer-filter-group-name-face ibuffer-occur-match-face ibuffer-dired-buffer-face ibuffer-help-buffer-face ibuffer-hidden-buffer-face ibuffer-special-buffer-face ibuffer-read-only-buffer-face ibuffer-title-face ibuffer-deletion-face ibuffer-marked-face ibuffer-faces ibuffer-always-compile-formats ibuffer-formats ibuffer) "ibuffer" "ibuffer/ibuffer.el")
(defconst custom-define-current-source-file "ibuffer.el")

(defgroup ibuffer nil "An advanced replacement for `buffer-menu'.\n\nIbuffer allows you to operate on buffers in a manner much like Dired.\nOperations include sorting, marking by regular expression, and\nthe ability to filter the displayed buffers by various criteria." :group 'convenience)

(defcustom ibuffer-formats '((mark modified read-only " " (name 16 16 :left :elide) " " (size 7 -1 :right) " " (mode 16 16 :center :elide) " " filename) (mark "  " (name 18 18 :left :elide) "  " (major-mode 20 20 :left :elide) "  " filename)) "\
A list of ways to display buffer lines.

With Ibuffer, you are not limited to displaying just certain
attributes of a buffer such as size, name, and mode in a particular
fashion.  Through this variable, you can completely customize and
control the appearance of an Ibuffer buffer.  See also
`define-ibuffer-column', which allows you to define your own columns
for display.

This variable has the form
 ((COLUMN COLUMN ...) (COLUMN COLUMN ...) ...)
Each element in `ibuffer-formats' should be a list containing COLUMN
specifiers.  A COLUMN can be any of the following:

  SYMBOL - A symbol naming the column.  Predefined columns are:
       mark modified read-only name size mode process filename
   When you define your own columns using `define-ibuffer-column', just
   use their name like the predefined columns here.  This entry can
   also be a function of two arguments, which should return a string.
   The first argument is the buffer object, and the second is the mark
   on that buffer.
 or
  \"STRING\" - A literal string to display.
 or
  (SYMBOL MIN-SIZE MAX-SIZE &optional ALIGN ELIDE) - SYMBOL is a
   symbol naming the column, and MIN-SIZE and MAX-SIZE are integers (or
   functions of no arguments returning an integer) which constrict the
   size of a column.  If MAX-SIZE is -1, there is no upper bound.  The
   default values are 0 and -1, respectively.  If MIN-SIZE is negative,
   use the end of the string.  The optional element ALIGN describes the
   alignment of the column; it can be :left, :center or :right.  The
   optional element ELIDE describes whether or not to elide the column
   if it is too long; valid values are :elide and nil.  The default is
   nil (don't elide).

Some example of valid entries in `ibuffer-formats', with
description (also, feel free to try them out, and experiment with your
own!):

 (mark \" \" name)
  This format just displays the current mark (if any) and the name of
  the buffer, separated by a space.
 (mark modified read-only \" \" (name 16 16 :left) \" \" (size 6 -1 :right))
  This format displays the current mark (if any), its modification and
  read-only status, as well as the name of the buffer and its size.  In
  this format, the name is restricted to 16 characters (longer names
  will be truncated, and shorter names will be padded with spaces), and
  the name is also aligned to the right.  The size of the buffer will
  be padded with spaces up to a minimum of six characters, but there is
  no upper limit on its size.  The size will also be aligned to the
  right.

Thus, if you wanted to use these two formats, add

 (setq ibuffer-formats '((mark \" \" name)
		         (mark modified read-only
			  (name 16 16 :left) (size 6 -1 :right))))

to your ~/.emacs file.

Using \\[ibuffer-switch-format], you can rotate the display between
the specified formats in the list." :type '(repeat sexp) :group 'ibuffer)

(defcustom ibuffer-always-compile-formats (featurep 'bytecomp) "\
If non-nil, then use the byte-compiler to optimize `ibuffer-formats'.
This will increase the redisplay speed, at the cost of loading the
elisp byte-compiler." :type 'boolean :group 'ibuffer)

(defgroup ibuffer-faces nil "Faces used by Ibuffer package." :group 'ibuffer :group 'faces)

(defcustom ibuffer-marked-face 'font-lock-warning-face "\
Face used for displaying marked buffers." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-deletion-face 'font-lock-type-face "\
Face used for displaying buffers marked for deletion." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-title-face 'font-lock-type-face "\
Face used for the title string." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-read-only-buffer-face 'font-lock-keyword-face "\
Face used for displaying read-only buffers." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-special-buffer-face 'font-lock-keyword-face "\
Face used for displaying \"special\" buffers." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-hidden-buffer-face 'font-lock-keyword-face "\
Face used for displaying normally hidden buffers." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-help-buffer-face 'font-lock-keyword-face "\
Face used for displaying help buffers (info, apropos, help)." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-dired-buffer-face 'font-lock-keyword-face "\
Face used for displaying dired buffers." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-occur-match-face 'font-lock-warning-face "\
Face used for displaying matched strings for `ibuffer-do-occur'." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-filter-group-name-face 'bold "\
Face used for displaying filtering group names." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-header-line-face 'header-line "\
Face used for displaying header-line." :type 'face :group 'ibuffer-faces)

(defcustom ibuffer-use-fontification (if (boundp 'font-lock-auto-fontify) font-lock-auto-fontify (if (boundp 'global-font-lock-mode) global-font-lock-mode nil)) "\
If non-nil, fontify contents of Ibuffer buffer." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-help-buffer-modes '(help-mode apropos-mode hyper-apropos-mode hyper-apropos-help-mode Info-mode Info-edit-mode) "\
List of \"Help\" major modes." :type '(repeat function) :group 'ibuffer)

(defcustom ibuffer-fontification-alist (backquote ((10 buffer-read-only (\, ibuffer-read-only-buffer-face)) (15 (string-match "^*" (buffer-name)) (\, ibuffer-special-buffer-face)) (20 (string-match "^ " (buffer-name)) (\, ibuffer-hidden-buffer-face)) (25 (memq major-mode ibuffer-help-buffer-modes) (\, ibuffer-help-buffer-face)) (30 (eq major-mode 'dired-mode) (\, ibuffer-dired-buffer-face)))) "\
An alist describing how to fontify buffers.
Each element should be of the form (PRIORITY FORM FACE), where
PRIORITY is an integer, FORM is an arbitrary form to evaluate in the
buffer, and FACE is the face to use for fontification.  If the FORM
evaluates to non-nil, then FACE will be put on the buffer name.  The
element with the highest PRIORITY takes precedence." :type '(repeat (list (integer :tag "Priority") (sexp :tag "Test Form") face)) :group 'ibuffer)

(defcustom ibuffer-use-other-window nil "\
If non-nil, display the Ibuffer in another window by default." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-default-shrink-to-minimum-size nil "\
If non-nil, minimize the size of the Ibuffer window by default." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-case-fold-search case-fold-search "\
If non-nil, ignore case when searching." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-default-sorting-mode 'recency "\
The criteria by which to sort the buffers.

Note that this variable is local to each ibuffer buffer.  Thus, you
can have multiple ibuffer buffers open, each with a different sorted
view of the buffers." :type '(choice (const :tag "Last view time" :value recency) (const :tag "Lexicographic" :value alphabetic) (const :tag "Buffer size" :value size) (const :tag "Major mode" :value major-mode) (const :tag "Mode name" :value mode-name)) :group 'ibuffer)

(defcustom ibuffer-toggle-sorting-modes '(alphabetic major-mode mode-name recency size) "\
List of sorters that `ibuffer-toggle-sorting-mode' toggles between." :type '(choice (repeat :tag "Edit" (symbol :tag "Sorter")) (const :tag "Default" :value (alphabetic major-mode mode-name recency size)) (const :tag "All" :value all)) :group 'ibuffer)

(defcustom ibuffer-default-sorting-reversep nil "\
If non-nil, reverse the default sorting order." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-elide-long-columns nil "\
If non-nil, then elide column entries which exceed their max length.
This variable is deprecated; use the :elide argument of
`ibuffer-formats' to elide just certain columns." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-eliding-string "..." "\
The string to use for eliding long columns." :type 'string :group 'ibuffer)

(defcustom ibuffer-maybe-show-predicates (backquote ((\, (lambda (buf) (and (string-match "^ " (buffer-name buf)) (null buffer-file-name)))))) "\
A list of predicates (a regexp or function) for buffers to display conditionally.
If a regexp, then it will be matched against the buffer's name.
If a function, it will be called with the buffer as an argument, and
should return non-nil if this buffer should be shown.

Viewing of buffers hidden because of these predicates is enabled by
giving a non-nil prefix argument to `ibuffer-update'.  Note that this
specialized filtering occurs before real filtering." :type '(repeat (choice regexp function)) :group 'ibuffer)

(defcustom ibuffer-modified-char ?* "\
The character to display for modified buffers." :type 'character :group 'ibuffer)

(defcustom ibuffer-read-only-char ?% "\
The character to display for read-only buffers." :type 'character :group 'ibuffer)

(defcustom ibuffer-marked-char ?> "\
The character to display for marked buffers." :type 'character :group 'ibuffer)

(defcustom ibuffer-deletion-char ?D "\
The character to display for buffers marked for deletion." :type 'character :group 'ibuffer)

(defcustom ibuffer-expert nil "\
If non-nil, don't ask for confirmation of \"dangerous\" operations." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-view-ibuffer nil "\
If non-nil, display the current Ibuffer buffer itself.
Note that this has a drawback - the data about the current Ibuffer
buffer will most likely be inaccurate.  This includes modification
state, size, etc." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-always-show-last-buffer nil "\
If non-nil, always display the previous buffer.  This variable
takes precedence over filtering, and even `ibuffer-never-show-predicates'." :type '(choice (const :tag "Always" :value t) (const :tag "Never" :value nil) (const :tag "Always except minibuffer" :value :nomini)) :group 'ibuffer)

(defcustom ibuffer-use-header-line t "\
If non-nil, display a header line containing current filters." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-default-directory nil "\
The default directory to use for a new ibuffer buffer.
If nil, inherit the directory of the buffer in which `ibuffer' was
called.  Otherwise, this variable should be a string naming a
directory, like `default-directory'." :type '(choice (const :tag "Inherit" :value nil) string) :group 'ibuffer)

(defcustom ibuffer-hooks nil "\
Hooks run when `ibuffer' is called." :type 'hook :group 'ibuffer)

(defcustom ibuffer-mode-hooks nil "\
Hooks run upon entry into `ibuffer-mode'." :type 'hook :group 'ibuffer)

(defcustom ibuffer-directory-abbrev-alist nil "\
An alist of file name abbreviations like `directory-abbrev-alist'." :type '(repeat (cons :format "%v" :value ("" . "") (regexp :tag "From") (regexp :tag "To"))) :group 'ibuffer)

(defcustom ibuffer-truncate-lines t "\
If non-nil, do not display continuation lines." :type 'boolean :group 'ibuffer)

(defcustom ibuffer-filter-format-alist nil "\
An alist which has special formats used when a filter is active.
The contents of this variable should look like:
 ((FILTER (FORMAT FORMAT ...)) (FILTER (FORMAT FORMAT ...)) ...)

For example, suppose that when you add a filter for buffers whose
major mode is `emacs-lisp-mode', you only want to see the mark and the
name of the buffer.  You could accomplish that by adding:
 (mode ((mark \" \" name)))
to this variable." :type '(repeat (list :tag "Association" (symbol :tag "Filter") (list :tag "Formats" (repeat (sexp :tag "Format"))))) :group 'ibuffer)

(defcustom ibuffer-never-show-predicates nil "\
A list of predicates (a regexp or function) for buffers not to display.
If a regexp, then it will be matched against the buffer's name.
If a function, it will be called with the buffer as an argument, and
should return non-nil if this buffer should not be shown." :type '(repeat (choice regexp function)) :group 'ibuffer)

(defcustom ibuffer-always-show-predicates nil "\
A list of predicates (a regexp or function) for buffers to always display.
If a regexp, then it will be matched against the buffer's name.
If a function, it will be called with the buffer as an argument, and
should return non-nil if this buffer should be shown.
Note that buffers matching one of these predicates will be shown
regardless of any active filters in this buffer." :type '(repeat (choice regexp function)) :group 'ibuffer)

(defcustom ibuffer-saved-filters '(("gnus" ((or (mode . message-mode) (mode . mail-mode) (mode . gnus-group-mode) (mode . gnus-summary-mode) (mode . gnus-article-mode)))) ("programming" ((or (mode . emacs-lisp-mode) (mode . cperl-mode) (mode . c-mode) (mode . java-mode) (mode . idl-mode) (mode . lisp-mode))))) "\
An alist of filter qualifiers to switch between.

This variable should look like ((\"STRING\" QUALIFIERS)
                                (\"STRING\" QUALIFIERS) ...), where
QUALIFIERS is a list of the same form as
`ibuffer-filtering-qualifiers'.
See also the variables `ibuffer-filtering-qualifiers',
`ibuffer-filtering-alist', and the functions
`ibuffer-switch-to-saved-filters', `ibuffer-save-filters'." :type '(repeat sexp) :group 'ibuffer)

(defcustom ibuffer-old-time 72 "\
The number of hours before a buffer is considered \"old\"." :type '(choice (const :tag "72 hours (3 days)" 72) (const :tag "48 hours (2 days)" 48) (const :tag "24 hours (1 day)" 24) (integer :tag "hours")) :group 'ibuffer)

(defcustom ibuffer-save-with-custom t "\
If non-nil, then use Custom to save interactively changed variables.
Currently, this only applies to `ibuffer-saved-filters'." :type 'boolean :group 'ibuffer)

;;;***

(provide 'ibuffer-custom-defines)
