;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'idlwave-custom-defines) (error "Feature idlwave-custom-defines already loaded"))

;;;### (autoloads (idlwave-help-doclib-keyword idlwave-help-doclib-name idlwave-help-source-try-header idlwave-help-fontify-source-code idlwave-extra-help-function idlwave-max-popup-menu-items idlwave-help-frame-parameters idlwave-help-use-dedicated-frame idlwave-help-browser-is-local idlwave-help-browser-generic-args idlwave-help-browser-generic-program idlwave-help-browser-function idlwave-help-use-hh idlwave-html-help-location idlwave-online-help) "idlw-help" "idlwave/idlw-help.el")
(defconst custom-define-current-source-file "idlw-help.el")

(defgroup idlwave-online-help nil "Online Help options for IDLWAVE mode." :group 'idlwave)

(defcustom idlwave-html-help-location (if (memq system-type '(ms-dos windows-nt)) nil "/usr/local/etc/") "\
The directory where the idl_html_help/ dir or idl.chm help file
\(Windows only) lives." :group 'idlwave-online-help :type 'directory)

(defcustom idlwave-help-use-hh nil "\
Whether to use the HTMLHelp viewer with idl.chm (Windows only)." :group 'idlwave-online-help :type '(choice :tag "use help viewer" (const :tag "<none>" nil) (const :tag "hh" 'hh) (const :tag "keyhh" 'keyhh)))

(defcustom idlwave-help-browser-function browse-url-browser-function "\
Function to use to display html help.
Defaults to `browse-url-browser-function', which see." :group 'idlwave-online-help :type 'function)

(defcustom idlwave-help-browser-generic-program browse-url-generic-program "\
Program to run if using browse-url-generic-program." :group 'idlwave-online-help :type 'string)

(defcustom idlwave-help-browser-generic-args (if (boundp 'browse-url-generic-args) browse-url-generic-args "") "\
Program args to use if using browse-url-generic-program." :group 'idlwave-online-help :type 'string)

(defcustom idlwave-help-browser-is-local nil "\
Whether the browser will display locally in an Emacs window.
Several browsers run and/or display inside Emacs windows, but most are
external programs.  If the browser name contains \"-w3\", it is
assumed to be local to Emacs.  For other local browsers, this variable
must be explicitly set non-nil in order for the variable
`idlwave-help-use-dedicated-frame' to function." :group 'idlwave-online-help :type 'boolean)

(defcustom idlwave-help-use-dedicated-frame t "\
*Non-nil means, use a separate frame for Online Help if possible." :group 'idlwave-online-help :type 'boolean)

(defcustom idlwave-help-frame-parameters '((height . 32) (unsplittable . t)) "\
The frame parameters for the special Online Help frame.
See also `idlwave-help-use-dedicated-frame'.
If you do not set the frame width here, the value specified in
`idlw-help.el' will be used." :group 'idlwave-online-help :type '(repeat (cons symbol sexp)))

(defcustom idlwave-max-popup-menu-items 20 "\
Maximum number of items per pane in popup menus.
Currently only used for class selection during completion help." :group 'idlwave-online-help :type 'integer)

(defcustom idlwave-extra-help-function 'idlwave-help-with-source "\
The function to call for online help if the normal help fails.
Online help works only for system routines which are described in the
IDL manuals.  A function may be specified to access help from other sources.

The function must accept four arguments: NAME, TYPE, CLASS, KEYWORD.
The Help buffer is current when this function is called, and the help
text should be loaded into this buffer.  If help is found, the
function should return the buffer position which should be used as
`window-start' in the help window.  Also, the variable
`idlwave-help-mode-line-indicator' should be set to a useful string,
which will be displayed in the mode line of the help window.  If
should also set the variable `idlwave-help-min-frame-width' to a
positive integer.  IDLWAVE will ensure that the help frame is at least
that many columns wide.  Failure to find help should be indicated by
throwing an error.

When this variable is non-nil, IDLWAVE will allow the mouse-3 help click
for every routine and keyword, even though the item may not be highlighted
in blue (indicating the availability of system documentation).

The default value for this function is `idlwave-help-with-source' which
loads the routine source file into the help buffer.  If you try to write
a different function which accesses a special help file or so, it is
probably a good idea to still call this function as a fallback." :group 'idlwave-online-help :type 'symbol)

(defcustom idlwave-help-fontify-source-code nil "\
*Non-nil means, fontify source code displayed as help like normal code." :group 'idlwave-online-help :type 'boolean)

(defcustom idlwave-help-source-try-header t "\
*Non-nil means, try to find help in routine header when displaying source.
Routines which are not documented in the system manual use their source as
help text.  When this variable is non-nil, we try to find a description of
the help item in the first routine doclib header above the routine definition.
If the variable is nil, or if we cannot find/parse the header, the routine
definition is displayed instead." :group 'idlwave-online-help :type 'boolean)

(defcustom idlwave-help-doclib-name "name" "\
*A regexp for the heading word to search for in doclib headers
which specifies the `name' section.  Can be used for localization
support." :group 'idlwave-online-help :type 'string)

(defcustom idlwave-help-doclib-keyword "KEYWORD" "\
*A regexp for the heading word to search for in doclib headers
which specifies the `keywords' section.  Can be used for localization
support." :group 'idlwave-online-help :type 'string)

;;;***

;;;### (autoloads (idlwave-shell-output-face idlwave-shell-expression-face idlwave-shell-breakpoint-face idlwave-shell-mark-breakpoints idlwave-shell-electric-stop-line-face idlwave-shell-electric-stop-color idlwave-shell-stop-line-face idlwave-shell-overlay-arrow idlwave-shell-mark-stop-line idlwave-shell-highlighting-and-faces idlwave-shell-input-mode-spells idlwave-shell-use-input-mode-magic idlwave-shell-query-for-class idlwave-shell-comint-settings idlwave-shell-separate-examine-output idlwave-shell-examine-alist idlwave-shell-show-commands idlwave-shell-command-history-file idlwave-shell-save-command-history idlwave-shell-initial-commands idlwave-shell-command-setup idlwave-shell-graphics-window-size idlwave-shell-mode-hook idlwave-shell-file-name-chars idlwave-shell-use-truename idlwave-shell-electric-zap-to-file idlwave-shell-automatic-electric-debug idlwave-shell-activate-prefix-keybindings idlwave-shell-prefix-key idlwave-shell-temp-pro-prefix idlwave-shell-use-toolbar idlwave-shell-arrows-do-history idlwave-shell-raise-frame idlwave-shell-frame-parameters idlwave-shell-use-dedicated-frame idlwave-shell-process-name idlwave-shell-prompt-pattern idlwave-shell-general-setup) "idlw-shell" "idlwave/idlw-shell.el")
(defconst custom-define-current-source-file "idlw-shell.el")

(defgroup idlwave-shell-general-setup nil "General setup of the Shell interaction for IDLWAVE/Shell." :prefix "idlwave-shell" :group 'idlwave)

(defcustom idlwave-shell-prompt-pattern "^ ?IDL> " "\
*Regexp to match IDL prompt at beginning of a line. 
For example, \"^IDL> \" or \"^WAVE> \". 
The \"^\" means beginning of line, and is required.
This variable is used to initialize `comint-prompt-regexp' in the 
process buffer.

This is a fine thing to set in your `.emacs' file." :group 'idlwave-shell-general-setup :type 'regexp)

(defcustom idlwave-shell-process-name "idl" "\
*Name to be associated with the IDL process.  The buffer for the
process output is made by surrounding this name with `*'s." :group 'idlwave-shell-general-setup :type 'string)

(defcustom idlwave-shell-use-dedicated-frame nil "\
*Non-nil means, IDLWAVE should use a special frame to display shell buffer." :group 'idlwave-shell-general-setup :type 'boolean)

(defcustom idlwave-shell-frame-parameters '((height . 30) (unsplittable)) "\
The frame parameters for a dedicated idlwave-shell frame.
See also `idlwave-shell-use-dedicated-frame'.
The default makes the frame splittable, so that completion works correctly." :group 'idlwave-shell-general-setup :type '(repeat (cons symbol sexp)))

(defcustom idlwave-shell-raise-frame t "\
*Non-nil means, `idlwave-shell' raises the frame showing the shell window." :group 'idlwave-shell-general-setup :type 'boolean)

(defcustom idlwave-shell-arrows-do-history t "\
*Non-nil means UP and DOWN arrows move through command history.
This variable can have 3 values:
nil        Arrows just move the cursor
t          Arrows force the cursor back to the current command line and
           walk the history
'cmdline   When the cursor is in the current command line, arrows walk the
           history.  Everywhere else in the buffer, arrows move the cursor." :group 'idlwave-shell-general-setup :type '(choice (const :tag "never" nil) (const :tag "everywhere" t) (const :tag "in command line only" cmdline)))

(defcustom idlwave-shell-use-toolbar t "\
*Non-nil means, use the debugging toolbar in all IDL related buffers.
Starting the shell will then add the toolbar to all idlwave-mode buffers.
Exiting the shell will removed everywhere.
Available on XEmacs and on Emacs 21.x or later.
At any time you can toggle the display of the toolbar with
`C-c C-d C-t' (`idlwave-shell-toggle-toolbar')." :group 'idlwave-shell-general-setup :type 'boolean)

(defcustom idlwave-shell-temp-pro-prefix "/tmp/idltemp" "\
*The prefix for temporary IDL files used when compiling regions.
It should be an absolute pathname.
The full temporary file name is obtained by using `make-temp-file'
so that the name will be unique among multiple Emacs processes." :group 'idlwave-shell-general-setup :type 'string)

(defcustom idlwave-shell-prefix-key "" "\
*The prefix key for the debugging map `idlwave-shell-mode-prefix-map'.
This variable must already be set when idlwave-shell.el is loaded.
Setting it in the mode-hook is too late." :group 'idlwave-shell-general-setup :type 'string)

(defcustom idlwave-shell-activate-prefix-keybindings t "\
Non-nil means, the debug commands will be bound to the prefix key.
The prefix key itself is given in the option `idlwave-shell-prefix-key'.
So by default setting a breakpoint will be on C-c C-d C-b." :group 'idlwave-shell-general-setup :type 'boolean)

(defcustom idlwave-shell-automatic-electric-debug 'breakpoint "\
Enter the electric-debug minor mode automatically.  
This occurs at a breakpoint or any other halt.  The mode is exited
upon return to the main level.  Can be set to 'breakpoint to enter
electric debug mode only when breakpoints are tripped." :group 'idlwave-shell-general-setup :type '(choice (const :tag "never" nil) (const :tag "always" t) (const :tag "for breakpoints only" breakpoint)))

(defcustom idlwave-shell-electric-zap-to-file t "\
When entering electric debug mode, select the window displaying the
file at which point is stopped.  This takes point away from the shell
window, but is useful for stepping, etc." :group 'idlwave-shell-general-setup :type 'boolean)

(defcustom idlwave-shell-use-truename nil "\
*Non-nil means, use use `file-truename' when looking for buffers.
If this variable is non-nil, Emacs will use the function `file-truename' to
resolve symbolic links in the file paths printed by e.g., STOP commands.
This means, unvisited files will be loaded under their truename.
However, when a file is already visited under a different name, IDLWAVE will
reuse that buffer.
This option was once introduced in order to avoid multiple buffers visiting
the same file.  However, IDLWAVE no longer makes this mistake, so it is safe
to set this option to nil." :group 'idlwave-shell-general-setup :type 'boolean)

(defcustom idlwave-shell-file-name-chars "~/A-Za-z0-9+:_.$#%={}\\-" "\
The characters allowed in file names, as a string.
Used for file name completion. Must not contain `'', `,' and `\"'
because these are used as separators by IDL." :group 'idlwave-shell-general-setup :type 'string)

(defcustom idlwave-shell-mode-hook 'nil "\
*Hook for customising `idlwave-shell-mode'." :group 'idlwave-shell-general-setup :type 'hook)

(defcustom idlwave-shell-graphics-window-size '(500 400) "\
Size of IDL graphics windows popped up by special IDLWAVE command.
The command is `C-c C-d C-f' and accepts as a prefix the window nr.
A command like `WINDOW,N,xsize=XX,ysize=YY' is sent to IDL." :group 'idlwave-shell-general-setup :type '(list (integer :tag "x size") (integer :tag "y size")))

(defgroup idlwave-shell-command-setup nil "Setup for command parameters of the Shell interaction for IDLWAVE." :prefix "idlwave-shell" :group 'idlwave)

(defcustom idlwave-shell-initial-commands "!more=0 & defsysv,'!ERROR_STATE',EXISTS=__e & if __e then begin & !ERROR_STATE.MSG_PREFIX=\"% \" & delvar,__e & endif" "\
Initial commands, separated by newlines, to send to IDL.
This string is sent to the IDL process by `idlwave-shell-mode' which is
invoked by `idlwave-shell'." :group 'idlwave-shell-command-setup :type 'string)

(defcustom idlwave-shell-save-command-history t "\
Non-nil means preserve command history between sessions.
The file `idlwave-shell-command-history-file' is used to save and restore
the history." :group 'idlwave-shell-command-setup :type 'boolean)

(defcustom idlwave-shell-command-history-file "idlwhist" "\
The file in which the command history of the idlwave shell is saved.
In order to change the size of the history, see the variable
`comint-input-ring-size'.
The history is only saved if the variable `idlwave-shell-save-command-history'
is non-nil." :group 'idlwave-shell-command-setup :type 'file)

(defcustom idlwave-shell-show-commands '(run misc breakpoint) "\
*A list of command types to show output from in the shell.
Possibilities are 'run, 'debug, 'breakpoint, and 'misc.  Unselected
types are not displayed in the shell.  The type 'everything causes all
the copious shell traffic to be displayed." :group 'idlwave-shell-command-setup :type '(choice (const everything) (set :tag "Checklist" :greedy t (const :tag "All .run and .compile commands" run) (const :tag "All breakpoint commands" breakpoint) (const :tag "All debug and stepping commands" debug) (const :tag "Close, window, retall, etc. commands" misc))))

(defcustom idlwave-shell-examine-alist '(("Print" . "print,___") ("Help" . "help,___") ("Structure Help" . "help,___,/STRUCTURE") ("Dimensions" . "print,size(___,/DIMENSIONS)") ("Type" . "print,size(___,/TNAME)") ("N_Elements" . "print,n_elements(___)") ("All Size Info" . "help,(__IWsz__=size(___,/STRUCTURE)),/STRUCTURE & print,__IWsz__.DIMENSIONS") ("Ptr Valid" . "print,ptr_valid(___)") ("Widget Valid" . "print,widget_info(___,/VALID)") ("Widget Geometry" . "help,widget_info(___,/GEOMETRY)")) "\
Alist of special examine commands for popup selection.  
The keys are used in the selection popup created by
`idlwave-shell-examine-select', and the corresponding value is sent as
a command to the shell, with special sequence `___' replaced by the
expression being examined." :group 'idlwave-shell-command-setup :type '(repeat (cons (string :tag "Label  ") (string :tag "Command"))))

(defcustom idlwave-shell-separate-examine-output t "\
*Non-nil mean, put output of examine commands in their own buffer." :group 'idlwave-shell-command-setup :type 'boolean)

(defcustom idlwave-shell-comint-settings '((comint-scroll-to-bottom-on-input . t) (comint-scroll-to-bottom-on-output . t) (comint-scroll-show-maximum-output)) "\
Alist of special settings for the comint variables in the IDLWAVE Shell.
Each entry is a cons cell with the name of a variable and a value.
The function `idlwave-shell-mode' will make local variables out of each entry.
Changes to this variable will only be active when the shell buffer is
newly created." :group 'idlwave-shell-command-setup :type '(repeat (cons variable sexp)))

(defcustom idlwave-shell-query-for-class t "\
*Non-nil means query the shell for object class on object completions." :group 'idlwave-shell-command-setup :type 'boolean)

(defcustom idlwave-shell-use-input-mode-magic nil "\
*Non-nil means, IDLWAVE should check for input mode spells in output.
The spells are strings printed by your IDL program and matched
by the regular expressions in `idlwave-shell-input-mode-spells'.
When these expressions match, IDLWAVE switches to character input mode and
back, respectively.  See `idlwave-shell-input-mode-spells' for details." :group 'idlwave-shell-command-setup :type 'boolean)

(defcustom idlwave-shell-input-mode-spells '("^<onechar>$" "^<chars>$" "^</chars>$") "\
The three regular expressions which match the magic spells for input modes.

When the first regexp matches in the output streem of IDL, IDLWAVE
prompts for a single character and sends it immediately to IDL, similar
to the command \\[idlwave-shell-send-char].

When the second regexp matches, IDLWAVE switches to a blocking
single-character input mode.  This is the same mode which can be entered
manually with \\[idlwave-shell-char-mode-loop].
This input mode exits when the third regexp matches in the output,
or when the IDL prompt is encountered.

The variable `idlwave-shell-use-input-mode-magic' must be non-nil to enable
scanning for these expressions.  If the IDL program produces lots of
output, shell operation may be slowed down.

This mechanism is useful for correct interaction with the IDL function
GET_KBRD, because in normal operation IDLWAVE only sends \\n terminated
strings.  Here is some example code which makes use of the default spells.

  print,'<chars>'               ; Make IDLWAVE switch to character mode
  REPEAT BEGIN
      A = GET_KBRD(1)
      PRINT, BYTE(A)
  ENDREP UNTIL A EQ 'q'
  print,'</chars>'              ; Make IDLWAVE switch back to line mode

  print,'Quit the program, y or n?'
  print,'<onechar>'             ; Ask IDLWAVE to send one character
  answer = GET_KBRD(1)

Since the IDLWAVE shell defines the system variable `!IDLWAVE_VERSION',
you could actually check if you are running under Emacs before printing 
the magic strings.  Here is a procedure which uses this.

Usage:
======
idlwave_char_input               ; Make IDLWAVE send one character
idlwave_char_input,/on           ; Start the loop to send characters
idlwave_char_input,/off          ; End the loop to send chracters


pro idlwave_char_input,on=on,off=off
  ;; Test if we are running under Emacs
  defsysv,'!idlwave_version',exists=running_emacs
  if running_emacs then begin
      if keyword_set(on) then         print,'<chars>' $
        else if keyword_set(off) then print,'</chars>' $
        else                          print,'<onechar>'
  endif 
end" :group 'idlwave-shell-command-setup :type '(list (regexp :tag "One-char  regexp") (regexp :tag "Char-mode regexp") (regexp :tag "Line-mode regexp")))

(defgroup idlwave-shell-highlighting-and-faces nil "Highlighting and Faces used by the IDLWAVE Shell mode." :prefix "idlwave-shell" :group 'idlwave)

(defcustom idlwave-shell-mark-stop-line t "\
*Non-nil means, mark the source code line where IDL is currently stopped.
Value decides about the method which is used to mark the line.  Legal values
are:

nil       Do not mark the line
'arrow    Use the overlay arrow
'face     Use `idlwave-shell-stop-line-face' to highlight the line.
t         Use what IDLWAVE thinks is best.  Will be a face where possible,
          otherwise the overlay arrow.
The overlay-arrow has the disadvantage to hide the first chars of a line.
Since many people do not have the main block of IDL programs indented,
a face highlighting may be better.
In Emacs 21, the overlay arrow is displayed in a special area and never
hides any code, so setting this to 'arrow on Emacs 21 sounds like a good idea." :group 'idlwave-shell-highlighting-and-faces :type '(choice (const :tag "No marking" nil) (const :tag "Use overlay arrow" arrow) (const :tag "Highlight with face" face) (const :tag "Face or arrow." t)))

(defcustom idlwave-shell-overlay-arrow ">" "\
*The overlay arrow to display at source lines where execution halts.
We use a single character by default, since the main block of IDL procedures
often has no indentation.  Where possible, IDLWAVE will use overlays to
display the stop-lines.  The arrow is only used on character-based terminals.
See also `idlwave-shell-use-overlay-arrow'." :group 'idlwave-shell-highlighting-and-faces :type 'string)

(defcustom idlwave-shell-stop-line-face 'highlight "\
*The face for `idlwave-shell-stop-line-overlay'.
Allows you to choose the font, color and other properties for
line where IDL is stopped.  See also `idlwave-shell-mark-stop-line'." :group 'idlwave-shell-highlighting-and-faces :type 'symbol)

(defcustom idlwave-shell-electric-stop-color "Violet" "\
*The color for the default face or overlay arrow when stopped." :group 'idlwave-shell-highlighting-and-faces :type 'string)

(defcustom idlwave-shell-electric-stop-line-face (prog1 (copy-face 'modeline 'idlwave-shell-electric-stop-line-face) (set-face-background 'idlwave-shell-electric-stop-line-face idlwave-shell-electric-stop-color) (condition-case nil (set-face-foreground 'idlwave-shell-electric-stop-line-face nil) (error nil))) "\
*The face for `idlwave-shell-stop-line-overlay' when in electric debug mode.
Allows you to choose the font, color and other properties for the line
where IDL is stopped, when in Electric Debug Mode." :group 'idlwave-shell-highlighting-and-faces :type 'symbol)

(defcustom idlwave-shell-mark-breakpoints t "\
*Non-nil means, mark breakpoints in the source files.
Legal values are:
nil        Do not mark breakpoints.
'face      Highlight line with `idlwave-shell-breakpoint-face'.
'glyph     Red dot at the beginning of line.  If the display does not
           support glyphs, will use 'face instead.
t          Glyph when possible, otherwise face (same effect as 'glyph)." :group 'idlwave-shell-highlighting-and-faces :type '(choice (const :tag "No marking" nil) (const :tag "Highlight with face" face) (const :tag "Display glyph (red dot)" glyph) (const :tag "Glyph or face." t)))

(defcustom idlwave-shell-breakpoint-face 'idlwave-shell-bp-face "\
*The face for breakpoint lines in the source code.
Allows you to choose the font, color and other properties for
lines which have a breakpoint.  See also `idlwave-shell-mark-breakpoints'." :group 'idlwave-shell-highlighting-and-faces :type 'symbol)

(defcustom idlwave-shell-expression-face 'secondary-selection "\
*The face for `idlwave-shell-expression-overlay'.
Allows you to choose the font, color and other properties for
the expression printed by IDL." :group 'idlwave-shell-highlighting-and-faces :type 'symbol)

(defcustom idlwave-shell-output-face 'secondary-selection "\
*The face for `idlwave-shell-output-overlay'.
Allows you to choose the font, color and other properties for
the expression output by IDL." :group 'idlwave-shell-highlighting-and-faces :type 'symbol)

;;;***

;;;### (autoloads (idlwave-load-hook idlwave-mode-hook idlwave-default-font-lock-items idlwave-startup-message idlwave-misc idlwave-shell-automatic-start idlwave-shell-debug-modifiers idlwave-help-application idlwave-shell-command-line-options idlwave-shell-explicit-file-name idlwave-external-programs idlwave-doclib-end idlwave-doclib-start idlwave-doc-modifications-keyword idlwave-timestamp-hook idlwave-header-to-beginning-of-file idlwave-documentation idlwave-reserved-word-upcase idlwave-abbrev-change-case idlwave-abbrev-move idlwave-reindent-end idlwave-expand-generic-end idlwave-show-block idlwave-pad-keyword idlwave-surround-by-blank idlwave-abbrev-start-char idlwave-do-actions idlwave-abbrev-and-indent-action idlwave-completion-restore-window-configuration idlwave-function-completion-adds-paren idlwave-keyword-completion-adds-equal idlwave-resize-routine-help-window idlwave-class-arrow-face idlwave-store-inquired-class idlwave-query-class idlwave-completion-fontify-classes idlwave-completion-show-classes idlwave-keyword-class-inheritance idlwave-support-inheritance idlwave-highlight-help-links-in-completion idlwave-buffer-case-takes-precedence idlwave-complete-empty-string-as-lower-case idlwave-completion-force-default-case idlwave-completion-case idlwave-completion idlwave-auto-write-paths idlwave-special-lib-alist idlwave-config-directory idlwave-system-directory idlwave-library-path idlwave-rinfo-max-source-lines idlwave-auto-routine-info-updates idlwave-query-shell-for-routine-info idlwave-scan-all-buffers-for-routine-info idlwave-init-rinfo-when-idle-after idlwave-use-library-catalogs idlwave-routine-info idlwave-code-comment idlwave-begin-line-comment idlwave-no-change-comment idlwave-split-line-string idlwave-auto-fill-split-string idlwave-fill-comment-line-only idlwave-use-last-hang-indent idlwave-hang-indent-regexp idlwave-hanging-indent idlwave-indent-to-open-paren idlwave-max-extra-continuation-indent idlwave-continuation-indent idlwave-end-offset idlwave-block-indent idlwave-main-block-indent idlwave-code-formatting idlwave) "idlwave" "idlwave/idlwave.el")
(defconst custom-define-current-source-file "idlwave.el")

(defgroup idlwave nil "Major mode for editing IDL .pro files" :tag "IDLWAVE" :link '(url-link :tag "Home Page" "http://idlwave.org") :link '(emacs-commentary-link :tag "Commentary in idlw-shell.el" "idlw-shell.el") :link '(emacs-commentary-link :tag "Commentary in idlwave.el" "idlwave.el") :link '(custom-manual "(idlwave)Top") :prefix "idlwave" :group 'languages)

(defgroup idlwave-code-formatting nil "Indentation and formatting options for IDLWAVE mode." :group 'idlwave)

(defcustom idlwave-main-block-indent 0 "\
*Extra indentation for the main block of code.
That is the block between the FUNCTION/PRO statement and the END
statement for that program unit." :group 'idlwave-code-formatting :type 'integer)

(defcustom idlwave-block-indent 4 "\
*Extra indentation applied to block lines.
If you change this, you probably also want to change `idlwave-end-offset'." :group 'idlwave-code-formatting :type 'integer)

(defcustom idlwave-end-offset -4 "\
*Extra indentation applied to block END lines.
A value equal to negative `idlwave-block-indent' will make END lines
line up with the block BEGIN lines." :group 'idlwave-code-formatting :type 'integer)

(defcustom idlwave-continuation-indent 2 "\
*Extra indentation applied to continuation lines.
This extra offset applies to the first of a set of continuation lines.
The following lines receive the same indentation as the first." :group 'idlwave-code-formatting :type 'integer)

(defcustom idlwave-max-extra-continuation-indent 20 "\
*Maximum additional indentation for special continuation indent.
Several special indentations are tried to help line up continuation
lines in routine calls or definitions, other statements with
parentheses, or assignment statements.  This variable specifies a
maximum amount by which this special indentation can exceed the
standard continuation indentation, otherwise defaulting to a fixed
offset.  Set to 0 to effectively disable all special continuation
indentation, or to a large number (like 100) to enable it in all
cases.  See also `idlwave-indent-top-open-paren', which can override
this variable." :group 'idlwave-code-formatting :type 'integer)

(defcustom idlwave-indent-to-open-paren t "\
*Non-nil means, indent continuation lines to innermost open
parenthesis.  This indentation occurs even if otherwise disallowed by
`idlwave-max-extra-continuation-indent'.  Matching parens and the
interleaving args are lined up.  Example:

  x = function_a(function_b(function_c( a, b, [1,2,3, $
                                               4,5,6 $
                                              ], $
                                        c, d $
                                      )))

When this variable is nil, paren alignment may still occur, based on
the value of `max-extra-continuation-indent', which, if zero, would
yield:

  x = function_a(function_b(function_c( a, b, [1,2,3, $
     4,5,6 $
     ], $
     c, d $
     )))" :group 'idlwave-code-formatting :type 'boolean)

(defcustom idlwave-hanging-indent t "\
*If set non-nil then comment paragraphs are indented under the
hanging indent given by `idlwave-hang-indent-regexp' match in the first line
of the paragraph." :group 'idlwave-code-formatting :type 'boolean)

(defcustom idlwave-hang-indent-regexp "- " "\
*Regular expression matching the position of the hanging indent
in the first line of a comment paragraph. The size of the indent
extends to the end of the match for the regular expression." :group 'idlwave-code-formatting :type 'regexp)

(defcustom idlwave-use-last-hang-indent nil "\
*If non-nil then use last match on line for `idlwave-indent-regexp'." :group 'idlwave-code-formatting :type 'boolean)

(defcustom idlwave-fill-comment-line-only t "\
*If non-nil then auto fill will only operate on comment lines." :group 'idlwave-code-formatting :type 'boolean)

(defcustom idlwave-auto-fill-split-string t "\
*If non-nil then auto fill will split strings with the IDL `+' operator.
When the line end falls within a string, string concatenation with the 
'+' operator will be used to distribute a long string over lines.  
If nil and a string is split then a terminal beep and warning are issued.

This variable is ignored when `idlwave-fill-comment-line-only' is
non-nil, since in this case code is not auto-filled." :group 'idlwave-code-formatting :type 'boolean)

(defcustom idlwave-split-line-string t "\
*If non-nil then `idlwave-split-line' will split strings with `+'.
When the splitting point of a line falls inside a string, split the string
using the `+' string concatenation operator.  If nil and a string is
split then a terminal beep and warning are issued." :group 'idlwave-code-formatting :type 'boolean)

(defcustom idlwave-no-change-comment ";;;" "\
*The indentation of a comment that starts with this regular
expression will not be changed. Note that the indentation of a comment
at the beginning of a line is never changed." :group 'idlwave-code-formatting :type 'string)

(defcustom idlwave-begin-line-comment nil "\
*A comment anchored at the beginning of line.
A comment matching this regular expression will not have its
indentation changed.  If nil the default is \"^;\", i.e., any line
beginning with a \";\".  Expressions for comments at the beginning of
the line should begin with \"^\"." :group 'idlwave-code-formatting :type '(choice (const :tag "Any line beginning with `;'" nil) 'regexp))

(defcustom idlwave-code-comment ";;[^;]" "\
*A comment that starts with this regular expression on a line by
itself is indented as if it is a part of IDL code.  As a result if
the comment is not preceded by whitespace it is unchanged." :group 'idlwave-code-formatting :type 'regexp)

(defgroup idlwave-routine-info nil "Routine Info options for IDLWAVE mode." :group 'idlwave)

(defcustom idlwave-use-library-catalogs t "\
*Non-nil means search the IDL path for library catalog files.

These files, named .idlwave_catalog, document routine information for
individual directories and libraries of IDL .pro files.  Many popular
libraries come with catalog files by default, so leaving this on is a
usually a good idea.." :group 'idlwave-routine-info :type 'boolean)

(defcustom idlwave-init-rinfo-when-idle-after 10 "\
*Seconds of idle time before routine info is automatically initialized.
Initializing the routine info can take long, in particular if a large
library catalog is involved.  When Emacs is idle for more than the number
of seconds specified by this variable, it starts the initialization.
The process is split into five steps, in order to keep possible work 
interruption as short as possible.  If one of the steps finishes, and no
user input has arrived in the mean time, initialization proceeds immediately
to the next step.
A good value for this variable is about 1/3 of the time initialization
take in you setup.  So if you have a fast machine and no problems with a slow network connection, don't hesitate to set this to 2 seconds.
A Value of 0 means, don't initialize automatically." :group 'idlwave-routine-info :type 'number)

(defcustom idlwave-scan-all-buffers-for-routine-info t "\
*Non-nil means, scan buffers for IDL programs when updating info.
The scanning is done by the command `idlwave-update-routine-info'.
The following values are allowed:

nil       Don't scan any buffers.
t         Scan all idlwave-mode buffers in the current editing session.
current   Scan only the current buffer, but no other buffers." :group 'idlwave-routine-info :type '(choice (const :tag "No buffer" nil) (const :tag "All buffers" t) (const :tag "Current buffer only" 'current)))

(defcustom idlwave-query-shell-for-routine-info t "\
*Non-nil means query the shell for info about compiled routines.
Querying the shell is useful to get information about compiled modules,
and it is turned on by default.  However, when you have a complete library
scan, this is not necessary." :group 'idlwave-routine-info :type 'boolean)

(defcustom idlwave-auto-routine-info-updates '(find-file save-buffer kill-buffer compile-buffer) "\
*Controls under what circumstances routine info is updated automatically.
Possible values:
nil       Never
t         All available
\(...)     A list of circumstances. Allowed members are:
           find-file       Add info for new IDLWAVE buffers.
           save-buffer     Update buffer info when buffer is saved
           kill-buffer     Remove buffer info when buffer gets killed
           compile-buffer  Update shell info after `idlwave-shell-save-and...'" :group 'idlwave-routine-info :type '(choice (const :tag "Never" nil) (const :tag "As often as possible" t) (set :tag "Checklist" :greedy t (const :tag "When visiting a file" find-file) (const :tag "When saving a buffer" save-buffer) (const :tag "After a buffer was killed" kill-buffer) (const :tag "After a buffer was compiled successfully, update shell info" compile-buffer))))

(defcustom idlwave-rinfo-max-source-lines 5 "\
*Maximum number of source files displayed in the Routine Info window.
When an integer, it is the maximum number of source files displayed.
t means to show all source files." :group 'idlwave-routine-info :type 'integer)

(defcustom idlwave-library-path nil "\
Library path for Windows and MacOS.  Not needed under Unix.  When
selecting the directories to scan for IDL user catalog routine info,
IDLWAVE can, under UNIX, query the shell for the exact search path
\(the value of !PATH).  However, under Windows and MacOS (pre-OSX),
the IDLWAVE shell does not work.  In this case, this variable can be
set to specify the paths where IDLWAVE can find PRO files.  The shell
will only be asked for a list of paths when this variable is nil.  The
value is a list of directories.  A directory preceeded by a `+' will
be searched recursively.  If you set this variable on a UNIX system,
the shell will not be queried.  See also `idlwave-system-directory'." :group 'idlwave-routine-info :type '(repeat (directory)))

(defcustom idlwave-system-directory "" "\
The IDL system directory for Windows and MacOS.  Not needed under
UNIX.  Set this to the value of the `!DIR' system variable in IDL.
IDLWAVE uses this to find out which of the library routines belong to
the official system library.  All files inside the `lib' subdirectory
are considered system library files - so don't install private stuff
in this directory.  On UNIX systems, IDLWAVE queries the shell for the
value of `!DIR'.  See also `idlwave-library-path'." :group 'idlwave-routine-info :type 'directory)

(defcustom idlwave-config-directory (convert-standard-filename "~/.idlwave") "\
*Directory for configuration files and user-library catalog." :group 'idlwave-routine-info :type 'file)

(defcustom idlwave-special-lib-alist nil "\
Alist of regular expressions matching special library directories.
When listing routine source locations, IDLWAVE gives a short hint where
the file defining the routine is located.  By default it lists `SystemLib' 
for routines in the system library `!DIR/lib' and `Library' for anything
else.  This variable can define additional types.  The car of each entry
is a regular expression matching the file name (they normally will match
on the path).  The cdr is the string to be used as identifier.  Max 10
chars are allowed." :group 'idlwave-routine-info :type '(repeat (cons regexp string)))

(defcustom idlwave-auto-write-paths t "\
Write out path (!PATH) and system directory (!DIR) info automatically.  
Path info is needed to locate library catalog files.  If non-nil,
whenever the path-list changes as a result of shell-query, etc., it is
written to file.  Otherwise, the menu option \"Write Paths\" can be
used to force a write." :group 'idlwave-routine-info :type 'boolean)

(defgroup idlwave-completion nil "Completion options for IDLWAVE mode." :prefix "idlwave" :group 'idlwave)

(defcustom idlwave-completion-case '((routine . upcase) (keyword . upcase) (class . preserve) (method . preserve)) "\
Association list setting the case of completed words.

This variable determines the case (UPPER/lower/Capitalized...) of
words inserted into the buffer by completion.  The preferred case can
be specified separately for routine names, keywords, classes and
methods. 
This alist should therefore have entries for `routine' (normal
functions and procedures, i.e. non-methods), `keyword', `class', and
`method'.  Plausible values are

upcase      upcase whole word, like `BOX_CURSOR'
downcase    downcase whole word, like `read_ppm'
capitalize  capitalize each part, like `Widget_Control'
preserve    preserve case as is, like `IDLgrView'

The value can also be any Emacs Lisp function which transforms the
case of characters in a string.

A value of `preserve' means that the case of the completed word is
identical to the way it was written in the definition statement of the
routine.  This was implemented to allow for mixed-case completion, in
particular of object classes and methods.
If a completable word is defined in multiple locations, the meaning of
`preserve' is not unique since the different definitions might be
cased differently.  Therefore IDLWAVE always takes the case of the
*first* definition it encounters during routine info collection and
uses the case derived from it consistently.

Note that a lowercase-only string in the buffer will always be completed in
lower case (but see the variable `idlwave-completion-force-default-case').

After changing this variable, you need to either restart Emacs or press
`C-u C-c C-i' to update the internal lists." :group 'idlwave-completion :type (backquote (repeat (cons (symbol :tag "Derive completion case for") (\, idlwave-tmp)))))

(defcustom idlwave-completion-force-default-case nil "\
*Non-nil means, completion will always honor `idlwave-completion-case'.
When nil, only the completion of a mixed case or upper case string
will honor the default settings in `idlwave-completion-case', while
the completion of lower case strings will be completed entirely in
lower case." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-complete-empty-string-as-lower-case nil "\
*Non-nil means, the empty string is considered downcase for completion.
The case of what is already in the buffer determines the case of completions.
When this variable is non-nil, the empty string is considered to be downcase.
Completing on the empty string then offers downcase versions of the possible
completions." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-buffer-case-takes-precedence nil "\
*Non-nil means, the case of tokens in buffers dominates over system stuff.
To make this possible, we need to re-case everything each time we update
the routine info from the buffers.  This is slow.
The default is to consider the case given in the system and library files
first which makes updating much faster." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-highlight-help-links-in-completion t "\
*Non-nil means, highlight completions for which system help is available.
Help can then be accessed with mouse-3.
This option is only effective when the online help system is installed." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-support-inheritance t "\
Non-nil means, treat inheritance with completion, online help etc.
When nil, IDLWAVE only knows about the native methods and tags of a class,
not about inherited ones." :group 'idlwave-routine-info :type 'boolean)

(defcustom idlwave-keyword-class-inheritance '("^[gs]etproperty$" "^init$") "\
List of regular expressions for class-driven keyword inheritance.
Keyword inheritance is often tied to class inheritance by \"chaining\"
up the class tree.  While it cannot be assumed that the presence of an
_EXTRA or _REF_EXTRA symbol guarantees such chaining will occur, for
certain methods this assumption is almost always true.  The methods
for which to assume this can be set here." :group 'idlwave-routine-info :type '(repeat (regexp :tag "Match method:")))

(defcustom idlwave-completion-show-classes 1 "\
*Number of classes to show when completing object methods and keywords.
When completing methods or keywords for an object with unknown class,
the *Completions* buffer will show the legal classes for each completion
like this:

MyMethod <Class1,Class2,Class3>

The value of this variable may be nil to inhibit display, or an integer to
indicate the maximum number of classes to display.

On XEmacs, a full list of classes will also be placed into a `help-echo'
property on the competion items, so that the list of classes for the current
item is displayed in the echo area.  If the value of this variable is a
negative integer, the `help-echo' property will be suppressed." :group 'idlwave-completion :type '(choice (const :tag "Don't show" nil) (integer :tag "Number of classes shown" 1)))

(defcustom idlwave-completion-fontify-classes t "\
*Non-nil means, fontify the classes in completions buffer.
This makes it easier to distinguish the completion items from the extra
class info listed.  See `idlwave-completion-show-classes'." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-query-class '((method-default) (keyword-default)) "\
Association list governing specification of object classes for completion.

When IDLWAVE tries to complete object-oriented methods, it usually
cannot determine the class of a given object from context.  In order
to provide the user with a correct list of methods or keywords, it
needs to determine the appropriate class.  IDLWAVE has two ways of
doing this (well, three ways if you count the shell... see
`idlwave-shell-query-for-class'):

1. Combine the items of all available classes which contain this
   method for the purpose of completion.  So when completing a method,
   all methods of all known classes are available, and when completing
   a keyword, all keywords allowed for this method in any class are
   shown.  This behavior is very much like normal completion and is
   therefore the default.  It works much better than one might think -
   only for the INIT, GETPROPERTY and SETPROPERTY the keyword lists
   become uncomfortably long.  See also
   `idlwave-completion-show-classes'.

2. The second possibility is to ask the user on each occasion.  To
   make this less interruptive, IDLWAVE can store the class as a text
   property on the object operator `->'.  For a given object in the
   source code, class selection will then be needed only once
   - for example to complete the method.  Keywords to the method can
   then be completed directly, because the class is already known.
   You will have to turn on the storage of the selected class
   explicitly with the variable `idlwave-store-inquired-class'.

This variable allows you to configure IDLWAVE's method and
method-keyword completion behavior.  Its value is an alist, which
should contain at least two elements: (method-default . VALUE) and
\(keyword-default . VALUE), where VALUE is either t or nil.  These
specify if the class should be found during method and keyword
completion, respectively.

The alist may have additional entries specifying exceptions from the 
keyword completion rule for specific methods, like INIT or
GETPROPERTY.  In order to turn on class specification for the INIT
method, add an entry (\"INIT\" . t).  The method name must be ALL-CAPS." :group 'idlwave-completion :type '(list (cons (const method-default) (boolean :tag "Determine class when completing METHODS    ")) (cons (const keyword-default) (boolean :tag "Determine class when completing KEYWORDS   ")) (repeat :tag "Exceptions to defaults" :inline t (cons (string :tag "MODULE" :value "") (boolean :tag "Determine class for this method")))))

(defcustom idlwave-store-inquired-class nil "\
*Non-nil means, store class of a method call as text property on `->'.
IDLWAVE sometimes has to ask the user for the class associated with a
particular object method call.  This happens during the commands
`idlwave-routine-info' and `idlwave-complete', depending upon the
value of the variable `idlwave-query-class'.

When you specify a class, this information can be stored as a text
property on the `->' arrow in the source code, so that during the same 
editing session, IDLWAVE will not have to ask again.  When this
variable is non-nil, IDLWAVE will store and reuse the class information.
The class stored can be checked and removed with `\\[idlwave-routine-info]'
on the arrow.

The default of this variable is nil, since the result of commands then
is more predictable.  However, if you know what you are doing, it can
be nice to turn this on.

An arrow which knows the class will be highlighted with
`idlwave-class-arrow-face'.  The command \\[idlwave-routine-info]
displays (with prefix arg: deletes) the class stored on the arrow
at point." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-class-arrow-face 'bold "\
*Face to highlight object operator arrows `->' which carry a class property.
When IDLWAVE stores a class name as text property on an object arrow
\(see variable `idlwave-store-inquired-class', it highlights the arrow
with this font in order to remind the user that this arrow is special." :group 'idlwave-completion :type 'symbol)

(defcustom idlwave-resize-routine-help-window t "\
*Non-nil means, resize the Routine-info *Help* window to fit the content." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-keyword-completion-adds-equal t "\
*Non-nil means, completion automatically adds `=' after completed keywords." :group 'idlwave-completion :type 'boolean)

(defcustom idlwave-function-completion-adds-paren t "\
*Non-nil means, completion automatically adds `(' after completed function.
nil means, don't add anything.
A value of `2' means, also add the closing parenthesis and position cursor
between the two." :group 'idlwave-completion :type '(choice (const :tag "Nothing" nil) (const :tag "(" t) (const :tag "()" 2)))

(defcustom idlwave-completion-restore-window-configuration t "\
*Non-nil means, try to restore the window configuration after completion.
When completion is not unique, Emacs displays a list of completions.
This messes up your window configuration.  With this variable set, IDLWAVE
restores the old configuration after successful completion." :group 'idlwave-completion :type 'boolean)

(defgroup idlwave-abbrev-and-indent-action nil "IDLWAVE performs actions when expanding abbreviations or indenting lines.\nThe variables in this group govern this." :group 'idlwave)

(defcustom idlwave-do-actions nil "\
*Non-nil means performs actions when indenting.
The actions that can be performed are listed in `idlwave-indent-action-table'." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defcustom idlwave-abbrev-start-char "\\" "\
*A single character string used to start abbreviations in abbrev mode.
Possible characters to chose from: ~`%
or even '?'.  '.' is not a good choice because it can make structure
field names act like abbrevs in certain circumstances.

Changes to this in `idlwave-mode-hook' will have no effect.  Instead a user
must set it directly using `setq' in the .emacs file before idlwave.el
is loaded." :group 'idlwave-abbrev-and-indent-action :type 'string)

(defcustom idlwave-surround-by-blank nil "\
*Non-nil means, enable `idlwave-surround'.
If non-nil, `=',`<',`>',`&',`,', `->' are surrounded with spaces by
`idlwave-surround'.
See help for `idlwave-indent-action-table' for symbols using `idlwave-surround'.

Also see the default key bindings for keys using `idlwave-surround'.
Keys are bound and made into actions calling `idlwave-surround' with
`idlwave-action-and-binding'.
See help for `idlwave-action-and-binding' for examples.

Also see help for `idlwave-surround'." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defcustom idlwave-pad-keyword t "\
*Non-nil means pad '=' for keywords like assignments.
Whenever `idlwave-surround' is non-nil then this affects how '=' is padded
for keywords.  If t, it is padded the same as for assignments.
If nil then spaces are removed.  With any other value, spaces are left
unchanged." :group 'idlwave-abbrev-and-indent-action :type '(choice (const :tag "Pad like assignments" t) (const :tag "Remove space near `='" nil) (const :tag "Keep space near `='" 'keep)))

(defcustom idlwave-show-block t "\
*Non-nil means point blinks to block beginning for `idlwave-show-begin'." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defcustom idlwave-expand-generic-end nil "\
*Non-nil means expand generic END to ENDIF/ENDELSE/ENDWHILE etc." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defcustom idlwave-reindent-end t "\
*Non-nil means re-indent line after END was typed." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defcustom idlwave-abbrev-move t "\
*Non-nil means the abbrev hook can move point.
Set to nil by `idlwave-expand-region-abbrevs'. To see the abbrev
definitions, use the command `list-abbrevs', for abbrevs that move
point. Moving point is useful, for example, to place point between
parentheses of expanded functions.

See `idlwave-check-abbrev'." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defcustom idlwave-abbrev-change-case nil "\
*Non-nil means all abbrevs will be forced to either upper or lower case.
If the value t, all expanded abbrevs will be upper case.
If the value is 'down then abbrevs will be forced to lower case.
If nil, the case will not change.
If `idlwave-reserved-word-upcase' is non-nil, reserved words will always be
upper case, regardless of this variable." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defcustom idlwave-reserved-word-upcase nil "\
*Non-nil means, reserved words will be made upper case via abbrev expansion.
If nil case of reserved words is controlled by `idlwave-abbrev-change-case'.
Has effect only if in abbrev-mode." :group 'idlwave-abbrev-and-indent-action :type 'boolean)

(defgroup idlwave-documentation nil "Options for documenting IDLWAVE files." :group 'idlwave)

(defcustom idlwave-header-to-beginning-of-file nil "\
*Non-nil means, the documentation header will always be at start of file.
When nil, the header is positioned between the PRO/FUNCTION line of
the current routine and the code, allowing several routine headers in
a file." :group 'idlwave-documentation :type 'boolean)

(defcustom idlwave-timestamp-hook 'idlwave-default-insert-timestamp "\
*The hook function used to update the timestamp of a function." :group 'idlwave-documentation :type 'function)

(defcustom idlwave-doc-modifications-keyword "HISTORY" "\
*The modifications keyword to use with the log documentation commands.
A ':' is added to the keyword end.
Inserted by doc-header and used to position logs by doc-modification.
If nil it will not be inserted." :group 'idlwave-documentation :type 'string)

(defcustom idlwave-doclib-start "^;+\\+" "\
*Regexp matching the start of a document library header." :group 'idlwave-documentation :type 'regexp)

(defcustom idlwave-doclib-end "^;+-" "\
*Regexp matching the end of a document library header." :group 'idlwave-documentation :type 'regexp)

(defgroup idlwave-external-programs nil "Path locations of external commands used by IDLWAVE." :group 'idlwave)

(defcustom idlwave-shell-explicit-file-name "idl" "\
*If non-nil, this is the command to run IDL.
Should be an absolute file path or path relative to the current environment
execution search path.  If you want to specify command line switches
for the idl program, use `idlwave-shell-command-line-options'.

I know the name of this variable is badly chosen, but I cannot change
it without compromizing backwards-compatibility." :group 'idlwave-external-programs :type 'string)

(defcustom idlwave-shell-command-line-options nil "\
*A list of command line options for calling the IDL program.
Since IDL is executed directly without going through a shell like /bin/sh,
this should be a list of strings like '(\"-rt=file\" \"-nw\") with a separate
string for each argument.  But you may also give a single string which
contains the options whitespace-separated.  Emacs will be kind enough to
split it for you." :type '(choice string (repeat (string :value ""))) :group 'idlwave-external-programs)

(defcustom idlwave-help-application "idlhelp" "\
*The external application providing reference help for programming." :group 'idlwave-external-programs :type 'string)

(defcustom idlwave-shell-debug-modifiers 'nil "\
List of modifiers to be used for the debugging commands.
Will be used to bind debugging commands in the shell buffer and in all
source buffers.  These are additional convenience bindings, the debugging
commands are always available with the `C-c C-d' prefix.
If you set this to '(control shift), this means setting a breakpoint will
be on `C-S-b', compiling a source file on `C-S-c' etc.  Possible modifiers
are `control', `meta', `super', `hyper', `alt', and `shift'." :group 'idlwave-shell-general-setup :type '(set :tag "Specify modifiers" (const control) (const meta) (const super) (const hyper) (const alt) (const shift)))

(defcustom idlwave-shell-automatic-start nil "\
*If non-nil attempt invoke idlwave-shell if not already running.
This is checked when an attempt to send a command to an
IDL process is made." :group 'idlwave-shell-general-setup :type 'boolean)

(defgroup idlwave-misc nil "Miscellaneous options for IDLWAVE mode." :group 'idlwave)

(defcustom idlwave-startup-message t "\
*Non-nil displays a startup message when `idlwave-mode' is first called." :group 'idlwave-misc :type 'boolean)

(defcustom idlwave-default-font-lock-items '(pros-and-functions batch-files idlwave-idl-keywords label goto common-blocks class-arrows) "\
Items which should be fontified on the default fontification level 2.
IDLWAVE defines 3 levels of fontification.  Level 1 is very little, level 3
is everything and level 2 is specified by this list.
This variable must be set before IDLWAVE gets loaded.  It is
a list of symbols, the following symbols are allowed.

pros-and-functions   Procedure and Function definitions
batch-files          Batch Files
idlwave-idl-keywords IDL Keywords
label                Statement Labels
goto                 Goto Statements
common-blocks        Common Blocks
keyword-parameters   Keyword Parameters in routine definitions and calls
system-variables     System Variables
fixme                FIXME: Warning in comments (on XEmacs only v. 21.0 and up)
class-arrows         Object Arrows with class property" :group 'idlwave-misc :type '(set :inline t :greedy t (const :tag "Procedure and Function definitions" pros-and-functions) (const :tag "Batch Files" batch-files) (const :tag "IDL Keywords (reserved words)" idlwave-idl-keywords) (const :tag "Statement Labels" label) (const :tag "Goto Statements" goto) (const :tag "Tags in Structure Definition" structtag) (const :tag "Structure Name" structname) (const :tag "Common Blocks" common-blocks) (const :tag "Keyword Parameters" keyword-parameters) (const :tag "System Variables" system-variables) (const :tag "FIXME: Warning" fixme) (const :tag "Object Arrows with class property " class-arrows)))

(defcustom idlwave-mode-hook nil "\
Normal hook.  Executed when a buffer is put into `idlwave-mode'." :group 'idlwave-misc :type 'hook)

(defcustom idlwave-load-hook nil "\
Normal hook.  Executed when idlwave.el is loaded." :group 'idlwave-misc :type 'hook)

;;;***

(provide 'idlwave-custom-defines)
