;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'igrep-custom-defines) (error "Feature igrep-custom-defines already loaded"))

;;;### (autoloads (igrep-menu-bar igrep-save-buffers igrep-insert-default-key igrep-insert-default-directory igrep-verbose-prompts igrep-files-default igrep-regex-default igrep-read-multiple-files igrep-read-options igrep-case-fold-search igrep-options igrep) "igrep" "igrep/igrep.el")
(defconst custom-define-current-source-file "igrep.el")

(defgroup igrep nil "An improved interface to `grep` and `find`." :group 'compilation)

(defcustom igrep-options nil "\
*The options passed by `\\[igrep]' to `igrep-program', or nil.

\"-n\" will automatically be passed to `igrep-program', to generate the
output expected by `\\[next-error]' and `\\[compile-goto-error]'.
\"-e\" will automatically be passed to `igrep-program', if it supports
that option." :group 'igrep :type '(choice (const nil) (string)))

(defcustom igrep-case-fold-search nil "\
*If non-nil, `\\[igrep]' ignores case unless REGEX has uppercase letters." :group 'igrep :type '(boolean))

(defcustom igrep-read-options nil "\
*If non-nil, `\\[igrep]' always prompts for options;
otherwise, it only prompts when 1 or 3 `C-u's are given as a prefix arg." :group 'igrep :type '(boolean))

(defcustom igrep-read-multiple-files nil "\
*If non-nil, `\\[igrep]' always prompts for multiple-files;
otherwise, it only prompts when 2 or 3 `C-u's are given as a prefix arg." :group 'igrep :type '(boolean))

(defcustom igrep-regex-default 'current-word "\
*If non-nil, a function that returns a default REGEX for `\\[igrep]'.
The function is called with no arguments and should return a string (or nil).

A different function can be specified for any particular mode by specifying
a value for that `major-mode' property; for example:
	(put 'igrep-regex-default 'dired-mode
	     'igrep-dired-file-current-word)" :group 'igrep :type '(choice (const nil) (function)))

(defcustom igrep-files-default 'igrep-buffer-file-name-pattern "\
*If non-nil, a function that returns the default FILES for `\\[igrep]'.
The function is called with no arguments and should return a string,
or a list of strings (or nil).

A different function can be specified for any particular mode by specifying
a value for that `major-mode' property; for example:
	(put 'igrep-files-default 'dired-mode
	     'igrep-dired-directory-file-pattern)" :group 'igrep :type '(choice (const nil) (function)))

(defcustom igrep-verbose-prompts t "\
*If t, `\\[igrep]' prompts for arguments verbosely;
if not t but non-nil, `\\[igrep]' prompts for arguments semi-verbosely;
if nil, `\\[igrep]' prompts for arguments tersely." :group 'igrep :type '(choice (const :tag "Verbose" t) (other :tag "Semi-verbose" semi) (const :tag "Terse" nil)))

(defcustom igrep-insert-default-directory nil "\
*The value of `insert-default-directory' for `\\[igrep]'." :group 'igrep :type '(boolean))

(defcustom igrep-insert-default-key (if (< emacs-major-version 20) "") "\
*The key used to insert the default argument in the minibuffer.
In Emacs 20, the default is available via the minibuffer history (\\<minibuffer-local-map>\\[next-history-element])." :group 'igrep :type '(choice (const nil) (string) (vector)))

(defcustom igrep-save-buffers 'query "\
*If t, `\\[igrep]' first saves each modified file buffer;
if not t but non-nil, `\\[igrep]' offers to save each modified file buffer." :group 'igrep :type '(choice (const :tag "Save" t) (other :tag "Query" query) (const :tag "Don't Save" nil)))

(defcustom igrep-menu-bar t "\
*If non-nil, enable the `igrep-menu' submenu on the \"Tools\" menu bar." :group 'igrep :type '(boolean))

;;;***

(provide 'igrep-custom-defines)
