;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ilisp-custom-defines) (error "Feature ilisp-custom-defines already loaded"))

;;;### (autoloads (lisp-no-popper ilisp-*prefix* ILisp-interaction ILisp) "custom-ilisp" "ilisp/custom-ilisp.el")
(defconst custom-define-current-source-file "custom-ilisp.el")

(defgroup ILisp nil "The ILisp Inferior Lisp System." :group 'programming :group 'lisp)

(defgroup ILisp-interaction nil "ILisp interaction customization." :group 'ILisp)

(defcustom ilisp-*prefix* "" "\
Prefix sequence for ILisp commands." :group 'ILisp-interaction)

(defcustom lisp-no-popper 'message "\
*T if all output goes to the inferior LISP rather than in a pop-up window.
Use 'message' if you want output of one line to go to the echo area
\(usually the Minibuffer) or to a pop-up window if more.  You should
probably also set 'comint-always-scroll' to T as well so that output is
always visible." :group 'ILisp-interaction :options '(nil t message))

;;;***

;;;### (autoloads (ilisp-bindings-*bind-space-p* ilisp-bindings-*bind-right-bracket-p* ilisp-*use-fsf-compliant-keybindings* ilisp-*prefix*) "ilisp-def" "ilisp/ilisp-def.el")
(defconst custom-define-current-source-file "ilisp-def.el")

(defcustom ilisp-*prefix* (if (and (boundp 'ilisp-*use-fsf-compliant-keybindings*) ilisp-*use-fsf-compliant-keybindings*) "" "") "\
Prefix sequence for ilisp commands.")

(defcustom ilisp-*use-fsf-compliant-keybindings* nil "\
*If non-nil,  ILISP will use FSF Emacs compliant keybindings.

In brief, this means all ilisp-specific features will be bound to C-c
KEY, where KEY is a control character, a digit, or one of }, {, >, <,
:, or ;.  In some cases ilisp may rebind a regular Emacs key, if the
new binding does \"the same thing\" as the original binding but in a
way more appropriate for ilisp." :type 'boolean :version "20.5" :group 'ILisp-interaction)

(defcustom ilisp-bindings-*bind-right-bracket-p* nil "\
If non-nil the key ']' will be bound to #'close-all-lisp." :group 'ILisp-interaction)

(defcustom ilisp-bindings-*bind-space-p* t "\
If non-nil the 'SPACE' key will be bound to #'ilisp-arglist-message-lisp-space." :group 'ILisp-interaction)

;;;***

(provide 'ilisp-custom-defines)
