;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ispell-custom-defines) (error "Feature ispell-custom-defines already loaded"))

;;;### (autoloads (ispell-local-dictionary-alist ispell-skip-html ispell-extra-args ispell-dictionary ispell-local-dictionary ispell-silently-savep ispell-personal-dictionary ispell-use-framepop-p ispell-format-word-function ispell-quietly ispell-help-in-bufferp ispell-following-word ispell-use-ptys-p ispell-look-options ispell-have-new-look ispell-look-p ispell-look-command ispell-grep-options ispell-grep-command ispell-message-fcc-skip ispell-message-dictionary-alist ispell-complete-word-dict ispell-alternate-dictionary ispell-program-name ispell-choices-win-default-height ispell-keep-choices-win ispell-skip-tib ispell-query-replace-choices ispell-check-comments ispell-highlight-face ispell-lazy-highlight ispell-highlight-p ispell) "ispell" "ispell/ispell.el")
(defconst custom-define-current-source-file "ispell.el")

(defgroup ispell nil "User variables for Emacs ispell interface." :group 'applications)

(defcustom ispell-highlight-p 'block "\
Highlight spelling errors when non-nil.
When set to `block', assumes a block cursor with TTY displays." :type '(choice (const block) (const :tag "off" nil) (const :tag "on" t)) :group 'ispell)

(defcustom ispell-lazy-highlight (boundp 'lazy-highlight-cleanup) "\
Controls the lazy-highlighting of spelling errors.
When non-nil, all text in the buffer matching the current spelling
error is highlighted lazily using isearch lazy highlighting (see
`lazy-highlight-initial-delay' and `lazy-highlight-interval')." :type 'boolean :group 'lazy-highlight :group 'ispell :version "22.1")

(defcustom ispell-highlight-face (if ispell-lazy-highlight 'isearch 'highlight) "\
The face used for Ispell highlighting.  For Emacsen with overlays.
Possible values are `highlight', `modeline', `secondary-selection',
`region', and `underline'.
This variable can be set by the user to whatever face they desire.
It's most convenient if the cursor color and highlight color are
slightly different." :type 'face :group 'ispell)

(defcustom ispell-check-comments t "\
Spelling of comments checked when non-nil.
When set to `exclusive', ONLY comments are checked.  (For code comments).
Warning!  Not checking comments, when a comment start is embedded in strings,
may produce undesired results." :type '(choice (const exclusive) (const :tag "off" nil) (const :tag "on" t)) :group 'ispell)

(defcustom ispell-query-replace-choices nil "\
Corrections made throughout region when non-nil.
Uses `query-replace' (\\[query-replace]) for corrections." :type 'boolean :group 'ispell)

(defcustom ispell-skip-tib nil "\
Does not spell check `tib' bibliography references when non-nil.
Skips any text between strings matching regular expressions
`ispell-tib-ref-beginning' and `ispell-tib-ref-end'.

TeX users beware:  Any text between [. and .] will be skipped -- even if
that's your whole buffer -- unless you set `ispell-skip-tib' to nil.
That includes the [.5mm] type of number..." :type 'boolean :group 'ispell)

(defcustom ispell-keep-choices-win t "\
If non-nil, keep the `*Choices*' window for the entire spelling session.
This minimizes redisplay thrashing." :type 'boolean :group 'ispell)

(defcustom ispell-choices-win-default-height 2 "\
The default size of the `*Choices*' window, including the mode line.
Must be greater than 1." :type 'integer :group 'ispell)

(defcustom ispell-program-name (or (locate-file "aspell" exec-path ispell-binary-suffixes 'executable) (locate-file "ispell" exec-path ispell-binary-suffixes 'executable) (locate-file "hunspell" exec-path ispell-binary-suffixes 'executable) "ispell") "\
Program invoked by \\[ispell-word] and \\[ispell-region] commands." :type 'string :set (lambda (symbol value) (set-default symbol value) (if (featurep 'ispell) (ispell-set-spellchecker-params))) :group 'ispell)

(defcustom ispell-alternate-dictionary (cond ((file-readable-p "/usr/dict/web2") "/usr/dict/web2") ((file-readable-p "/usr/share/dict/web2") "/usr/share/dict/web2") ((file-readable-p "/usr/dict/words") "/usr/dict/words") ((file-readable-p "/usr/lib/dict/words") "/usr/lib/dict/words") ((file-readable-p "/usr/share/dict/words") "/usr/share/dict/words") ((file-readable-p "/usr/share/lib/dict/words") "/usr/share/lib/dict/words") ((file-readable-p "/sys/dict") "/sys/dict")) "\
Alternate plain word-list dictionary for spelling help." :type '(choice file (const :tag "None" nil)) :group 'ispell)

(defcustom ispell-complete-word-dict nil "\
Plain word-list dictionary used for word completion if
different from `ispell-alternate-dictionary'." :type '(choice file (const :tag "None" nil)) :group 'ispell)

(defcustom ispell-message-dictionary-alist nil "\
List used by `ispell-message' to select a new dictionary.
It consists of pairs (REGEXP . DICTIONARY).  If REGEXP is found
in the message headers, `ispell-local-dictionary' will be set to
DICTIONARY if `ispell-local-dictionary' is not buffer-local.
E.g. you may use the following value:
  '((\"^Newsgroups:[ \\t]*de\\\\.\" . \"deutsch8\")
    (\"^To:[^\\n,]+\\\\.de[ \\t\\n,>]\" . \"deutsch8\"))" :type '(repeat (cons regexp string)) :group 'ispell)

(defcustom ispell-message-fcc-skip 50000 "\
Query before saving Fcc message copy if attachment larger than this value.
Always stores Fcc copy of message when nil." :type '(choice integer (const :tag "off" nil)) :group 'ispell)

(defcustom ispell-grep-command (if (memq system-type '(windows-nt ms-dos)) "grep" "egrep") "\
Name of the grep command for search processes." :type 'string :group 'ispell)

(defcustom ispell-grep-options (if (memq system-type '(windows-nt ms-dos)) "-Ei" "-i") "\
String of options to use when running the program in `ispell-grep-command'.
Should probably be \"-i\" or \"-e\".
Some machines (like the NeXT) don't support \"-i\"." :type 'string :group 'ispell)

(defcustom ispell-look-command (cond ((file-exists-p "/bin/look") "/bin/look") ((file-exists-p "/usr/local/bin/look") "/usr/local/bin/look") ((file-exists-p "/usr/bin/look") "/usr/bin/look") (t "look")) "\
Name of the look command for search processes.
This must be an absolute file name." :type 'file :group 'ispell)

(defcustom ispell-look-p (file-exists-p ispell-look-command) "\
Non-nil means use `look' rather than `grep'.
Default is based on whether `look' seems to be available." :type 'boolean :group 'ispell)

(defcustom ispell-have-new-look nil "\
Non-nil means use the `-r' option (regexp) when running `look'." :type 'boolean :group 'ispell)

(defcustom ispell-look-options (if ispell-have-new-look "-dfr" "-df") "\
String of command options for `ispell-look-command'." :type 'string :group 'ispell)

(defcustom ispell-use-ptys-p nil "\
When non-nil, Emacs uses ptys to communicate with Ispell.
When nil, Emacs uses pipes." :type 'boolean :group 'ispell)

(defcustom ispell-following-word nil "\
Non-nil means `ispell-word' checks the word around or after point.
Otherwise `ispell-word' checks the preceding word." :type 'boolean :group 'ispell)

(defcustom ispell-help-in-bufferp nil "\
Non-nil means display interactive keymap help in a buffer.
The following values are supported:
  nil        Expand the minibuffer and display a short help message
             there for a couple of seconds.
  t          Pop up a new buffer and display a short help message there
             for a couple of seconds.
  electric   Pop up a new buffer and display a long help message there.
             User can browse and then exit the help mode." :type '(choice (const electric) (const :tag "off" nil) (const :tag "on" t)) :group 'ispell)

(defcustom ispell-quietly nil "\
Non-nil means suppress messages in `ispell-word'." :type 'boolean :group 'ispell)

(defcustom ispell-format-word-function (function upcase) "\
Formatting function for displaying word being spell checked.
The function must take one string argument and return a string." :type 'function :group 'ispell)

(defcustom ispell-use-framepop-p nil "\
When non-nil ispell uses framepop to display choices in a dedicated frame.
You can set this variable to dynamically use framepop if you are in a
window system by evaluating the following on startup to set this variable:
  (and window-system (condition-case () (require 'framepop) (error nil)))" :type 'boolean :group 'ispell)

(defcustom ispell-personal-dictionary nil "\
File name of your personal spelling dictionary, or nil.
If nil, the default personal dictionary, (\"~/.ispell_DICTNAME\" for ispell or
\"~/.aspell.LANG.pws\" for aspell) is used, where DICTNAME is the name of your
default dictionary and LANG the two letter language code." :type '(choice file (const :tag "default" nil)) :group 'ispell)

(defcustom ispell-silently-savep nil "\
When non-nil, save personal dictionary without asking for confirmation." :type 'boolean :group 'ispell)

(defcustom ispell-local-dictionary nil "\
If non-nil, the dictionary to be used for Ispell commands in this buffer.
The value must be a string dictionary name,
or nil, which means use the global setting in `ispell-dictionary'.
Dictionary names are defined in `ispell-local-dictionary-alist'
and `ispell-dictionary-alist'.

Setting `ispell-local-dictionary' to a value has the same effect as
calling \\[ispell-change-dictionary] with that value.  This variable
is automatically set when defined in the file with either
`ispell-dictionary-keyword' or the Local Variable syntax." :type '(choice string (const :tag "default" nil)) :group 'ispell)

(defcustom ispell-dictionary nil "\
Default dictionary to use if `ispell-local-dictionary' is nil." :type '(choice string (const :tag "default" nil)) :group 'ispell)

(defcustom ispell-extra-args nil "\
If non-nil, a list of extra switches to pass to the Ispell program.
For example, (\"-W\" \"3\") to cause it to accept all 1-3 character
words as correct.  See also `ispell-dictionary-alist', which may be used
for language-specific arguments." :type '(repeat string) :group 'ispell)

(defcustom ispell-skip-html 'use-mode-name "\
Indicates whether ispell should skip spell checking of SGML markup.
If t, always skip SGML markup; if nil, never skip; if non-t and non-nil,
guess whether SGML markup should be skipped according to the name of the
buffer's major mode." :type '(choice (const :tag "always" t) (const :tag "never" nil) (const :tag "use-mode-name" use-mode-name)) :group 'ispell)

(defcustom ispell-local-dictionary-alist nil "\
List of local or customized dictionary definitions.
These can override the values in `ispell-dictionary-alist'.

To make permanent changes to your dictionary definitions, you
will need to make your changes in this variable, save, and then
re-start Emacs." :type '(repeat (list (choice :tag "Dictionary" (string :tag "Dictionary name") (const :tag "default" nil)) (regexp :tag "Case characters") (regexp :tag "Non case characters") (regexp :tag "Other characters") (boolean :tag "Many other characters") (repeat :tag "Ispell command line args" (string :tag "Arg")) (choice :tag "Extended character mode" (const "~tex") (const "~plaintex") (const "~nroff") (const "~list") (const "~latin1") (const "~latin3") (const :tag "default" nil)) (coding-system :tag "Coding System"))) :group 'ispell)

;;;***

(provide 'ispell-custom-defines)
