;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'mh-e-custom-defines) (error "Feature mh-e-custom-defines already loaded"))

;;;### (autoloads (mh-unseen-updated-hook mh-show-mode-hook mh-show-hook mh-refile-msg-hook mh-quit-hook mh-pick-mode-hook mh-letter-mode-hook mh-letter-insert-signature-hook mh-kill-folder-suppress-prompt-hook mh-inc-folder-hook mh-folder-updated-hook mh-folder-mode-hook mh-find-path-hook mh-edit-mhn-hook mh-delete-msg-hook mh-before-send-letter-hook mh-before-quit-hook mh-identity-list mh-identity-default mh-auto-fields-list mh-alias-system-aliases mh-alias-passwd-gecos-comma-separator-flag mh-alias-local-users-prefix mh-alias-local-users mh-alias-insertion-location mh-alias-insert-file mh-alias-flash-on-comma mh-alias-expand-aliases-flag mh-alias-completion-ignore-case-flag mh-yank-from-start-of-msg mh-x-face-file mh-signature-file-name mh-reply-show-message-flag mh-reply-default-reply-to mh-letter-fill-column mh-letter-complete-function mh-insert-x-mailer-flag mh-ins-buf-prefix mh-forward-subject-format mh-extract-from-attribution-verb mh-delete-yanked-msg-window-flag mh-compose-space-does-completion-flag mh-compose-skipped-header-fields mh-compose-prompt-flag mh-compose-letter-function mh-compose-insertion mhl-formfile mh-visible-header-fields mh-summary-height mh-show-use-xface-flag mh-show-use-goto-addr-flag mh-show-maximum-size mh-max-inline-image-width mh-max-inline-image-height mh-invisible-header-fields mh-highlight-citation-p mh-graphical-emphasis-flag mh-graphical-smileys-flag mh-fetch-x-image-url mh-do-not-confirm-flag mh-display-buttons-for-inline-parts-flag mh-display-buttons-for-alternatives-flag mh-decode-mime-flag mh-clean-message-header-flag mh-bury-show-buffer-flag mh-junk-program mh-junk-mail-folder mh-index-ticked-messages-folders mh-index-program mh-index-new-messages-folders mh-update-sequences-after-mh-show-flag mh-tick-seq mh-store-default-directory mh-show-threads-flag mh-scan-prog mh-scan-format-file mh-refile-preserves-sequences-flag mh-recursive-folders-flag mh-recenter-summary-flag mh-print-background-flag mh-mime-save-parts-default-directory mh-lpr-command-format mh-interpret-number-as-range-flag mh-inc-spool-list mh-inc-prog mh-default-folder-prefix mh-default-folder-must-exist-flag mh-default-folder-list mh-adaptive-cmd-note-flag mh-speed-run-flists-flag mh-speed-flists-interval mh-large-folder mh-tool-bar-search-function mh-letter-faces mh-show-faces mh-index-faces mh-folder-faces mh-speed-faces mh-hooks mh-identity mh-alias mh-letter mh-faces mh-show mh-junk mh-index mh-folder mh-speed mh-toolbar mh) "mh-customize" "mh-e/mh-customize.el")
(defconst custom-define-current-source-file "mh-customize.el")

(defgroup mh nil "GNU Emacs interface to the MH mail system." :link '(custom-manual "(mh-e)Top") :group 'mail)

(defgroup mh-toolbar nil "Toolbar configuration." :prefix "mh-" :group 'mh)

(defgroup mh-speed nil "Speedbar and folder configuration." :prefix "mh-" :link '(custom-manual "(mh-e)Customizing Moving Mail") :group 'mh)

(defgroup mh-folder nil "Options for controlling scan listing." :prefix "mh-" :link '(custom-manual "(mh-e)Customizing Moving Mail") :group 'mh)

(defgroup mh-index nil "Indexed searching." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh)

(defgroup mh-junk nil "Spam handling." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-junk-" :group 'mh)

(defgroup mh-show nil "Message display." :prefix "mh-" :link '(custom-manual "(mh-e)Customizing Reading") :group 'mh)

(defgroup mh-faces nil "Faces used in MH-E." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'faces :group 'mh)

(defgroup mh-letter nil "Composing messages." :prefix "mh-" :link '(custom-manual "(mh-e)Customizing Sending") :group 'mh)

(defgroup mh-alias nil "Alias handling." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-alias-" :group 'mh)

(defgroup mh-identity nil "Multiple personalities." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh)

(defgroup mh-hooks nil "MH-E hooks." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh)

(defgroup mh-speed-faces nil "Faces used in speedbar." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh-faces :group 'mh-speed)

(defgroup mh-folder-faces nil "Faces used in scan listing." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh-faces :group 'mh-folder)

(defgroup mh-index-faces nil "Faces used in indexed searches." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh-faces :group 'mh-index)

(defgroup mh-show-faces nil "Faces used in message display." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh-faces :group 'mh-show)

(defgroup mh-letter-faces nil "Faces used when composing messages." :link '(custom-manual "(mh-e)Customizing mh-e") :prefix "mh-" :group 'mh-faces :group 'mh-letter)

(defcustom mh-tool-bar-search-function 'mh-search-folder "\
*Function called by the tool-bar search button.
See `mh-search-folder' and `mh-index-search' for details." :type '(choice (const mh-search-folder) (const mh-index-search) (function :tag "Other function")) :group 'mh-toolbar)

(defcustom mh-large-folder 200 "\
The number of messages that indicates a large folder.
If a folder is deemed to be large, that is the number of messages in it exceed
this value, then confirmation is needed when it is visited. Even when
`mh-show-threads-flag' is non-nil, the folder is not automatically threaded, if
it is large. If set to nil all folders are treated as if they are small." :type '(choice (const :tag "No limit") integer) :group 'mh-speed)

(defcustom mh-speed-flists-interval 60 "\
Time between calls to flists in seconds.
If 0, flists is not called repeatedly." :type 'integer :group 'mh-speed)

(defcustom mh-speed-run-flists-flag t "\
Non-nil means flists is used.
If non-nil, flists is executed every `mh-speed-flists-interval' seconds to
update the display of the number of unseen and total messages in each folder.
If resources are limited, this can be set to nil and the speedbar display can
be updated manually with the \\[mh-speed-flists] command." :type 'boolean :group 'mh-speed)

(defcustom mh-adaptive-cmd-note-flag t "\
*Non-nil means that the message number width is determined dynamically.
This is done once when a folder is first opened by running scan on the last
message of the folder. The message number for the last message is extracted
and its width calculated. This width is used when calling `mh-set-cmd-note'.

If you prefer fixed-width message numbers, set this variable to nil and call
`mh-set-cmd-note' with the width specified by the scan format in
`mh-scan-format-file'. For example, the default width is 4, so you would use
\"(mh-set-cmd-note 4)\" if `mh-scan-format-file' were nil." :type 'boolean :group 'mh-folder)

(defcustom mh-default-folder-list nil "\
*Alist of addresses and folders.
When refiling messages, these folders are the default that is provided if the
sender (or recipient if the Check Recipient checkbox has been selected) has
the associated address, a regexp. The first entry to match will be used, so
order them according to the wanted priority. You do not need to list your
aliases here as that lookup is already performed.

See `mh-prompt-for-refile-folder' and `mh-folder-from-address' for more
information." :type '(repeat (list (regexp :tag "Address") (string :tag "Folder") (boolean :tag "Check Recipient"))) :group 'mh-folder)

(defcustom mh-default-folder-must-exist-flag t "\
*Non-nil means guessed folder name must exist to be used.
If this variable is t, then the guessed name is only used if the folder
already exists; if the folder doesn't exist, then the last folder name used
is suggested. This is useful if you get mail from various people for whom you
have an alias, but file them all in the same project folder.
See `mh-prompt-for-refile-folder' and `mh-folder-from-address' for more
information." :type 'boolean :group 'mh-folder)

(defcustom mh-default-folder-prefix "" "\
*Prefix used for guessed folder names.
This can be used to put folders associated with your aliases in a sub-folder
so as to not clutter your mail directory.
See `mh-prompt-for-refile-folder' and `mh-folder-from-address' for more
information." :type 'string :group 'mh-folder)

(defcustom mh-inc-prog "inc" "\
*Program to run to incorporate new mail into a folder.
Normally \"inc\".  This file is searched for relative to
the `mh-progs' directory unless it is an absolute pathname." :type 'string :group 'mh-folder)

(defcustom mh-inc-spool-list nil "\
*Alist of alternate spool files, corresponding folders and keybindings.
Here's an example. Suppose you have subscribed to the MH-E devel mailing
list. You could filter its mail into a separate spool file named
~/mail/mh-e using Procmail and a .procmailrc entry like:

MAILDIR=$HOME/mail      #you'd better make sure it exists
:0:
* ^From mh-e-devel-admin@lists.sourceforge.net
mh-e

If you wanted to incorporate that spool file into an MH folder called
mh-e by pressing \"I m\" in folder-mode or by `M-x mh-inc-spool-mh-e',
you would setup  `mh-inc-spool-list' with an entry:

 Spool file:  ~/mail/mh-e
 Folder:      mh-e
 Key binding: m

Then, you could also install `xbuffy' and configure an extra mailbox like so:

box ~/mail/mh-e
 title mh-e
 origMode
 polltime 10
 headertime 0
 command gnudoit -q '(mh-inc-spool-mh-e)'

Note that the entry above uses the gnuserv package to communicate the
command `mh-inc-spool-mh-e' to Emacs. It will incorporate the spool file
when clicking the xbuffy box with the middle mouse button." :type '(repeat (list (file :tag "Spool file") (string :tag "Folder") (character :tag "Key binding"))) :set 'mh-inc-spool-list-set :group 'mh-folder)

(defcustom mh-interpret-number-as-range-flag t "\
Non-nil means interpret a number as a range.
If the variable is non-nil, and you use an integer, N, when asked for a
range to scan, then MH-E uses the range \"last:N\"." :type 'boolean :group 'mh-folder)

(defcustom mh-lpr-command-format "lpr -J '%s'" "\
*Format for Unix command that prints a message.
The string should be a Unix command line, with the string '%s' where
the job's name (folder and message number) should appear.  The formatted
message text is piped to this command when you type \\<mh-folder-mode-map>`\\[mh-print-msg]'." :type 'string :group 'mh-folder)

(defcustom mh-mime-save-parts-default-directory t "\
Default directory to use for `mh-mime-save-parts'.
If nil, prompt and set for next time the command is used during same session.
If t, prompt always" :type '(choice (const :tag "Prompt the first time" nil) (const :tag "Prompt always" t) directory) :group 'mh-folder)

(defcustom mh-print-background-flag nil "\
*Non-nil means messages should be printed in the background.
WARNING: do not delete the messages until printing is finished;
otherwise, your output may be truncated." :type 'boolean :group 'mh-folder)

(defcustom mh-recenter-summary-flag nil "\
*Non-nil means to recenter the summary window.
Recenter the summary window when the show window is toggled off if non-nil." :type 'boolean :group 'mh-folder)

(defcustom mh-recursive-folders-flag nil "\
*Non-nil means that commands which operate on folders do so recursively." :type 'boolean :group 'mh-folder)

(defcustom mh-refile-preserves-sequences-flag t "\
*Non-nil means that sequences are preserved when messages are refiled.
If this variable is non-nil and a message belonging to a sequence other than
cur or Previous-Sequence (see mh-profile 5) is refiled then it is put in the
same sequence in the destination folder." :type 'boolean :group 'mh-folder)

(defcustom mh-scan-format-file t "\
Specifies the format file to pass to the scan program.
If t, the format string will be taken from the either `mh-scan-format-mh'
or `mh-scan-format-nmh' depending on whether MH or nmh is in use.
If nil, the default scan output will be used.

If you customize the scan format, you may need to modify a few variables
containing regexps that MH-E uses to identify specific portions of the output.
Use `M-x apropos RET mh-scan.*regexp' to obtain a list of these variables. You
may also have to call `mh-set-cmd-note' with the width of your message
numbers. See also `mh-adaptive-cmd-note-flag'." :type '(choice (const :tag "Use MH-E scan format" t) (const :tag "Use default scan format" nil) (file :tag "Specify a scan format file")) :group 'mh-folder)

(defcustom mh-scan-prog "scan" "\
*Program to run to generate one-line-per-message listing of a folder.
Normally \"scan\" or a file name linked to scan.  This file is searched
for relative to the `mh-progs' directory unless it is an absolute pathname." :type 'string :group 'mh-folder)

(defcustom mh-show-threads-flag nil "\
Non-nil means new folders start in threaded mode.
Threading large number of messages can be time consuming. So if the flag is
non-nil then threading will be done only if the number of messages being
threaded is less than `mh-large-folder'." :type 'boolean :group 'mh-folder)

(defcustom mh-store-default-directory nil "\
*Last directory used by \\[mh-store-msg]; default for next store.
A directory name string, or nil to use current directory." :type '(choice (const :tag "Current" nil) directory) :group 'mh-folder)

(defcustom mh-tick-seq 'tick "\
The name of the MH tick sequence." :type '(choice (const :tag "Disable ticking" nil) symbol) :group 'mh-folder)

(defcustom mh-update-sequences-after-mh-show-flag t "\
*Non-nil means `mh-update-sequence' is called from `mh-show-mode'.
If set, `mh-update-sequence' is run every time a message is shown, telling
MH or nmh that this is your current message.  It's useful, for example, to
display MIME content using \"M-! mhshow RET\"" :type 'boolean :group 'mh-folder)

(defcustom mh-index-new-messages-folders t "\
Folders searched for `mh-unseen-seq'.
If t, then `mh-inbox' is searched. If nil, all the top level folders are
searched. Otherwise the list of folders specified as strings are searched.
See also `mh-recursive-folders-flag'." :group 'mh-index :type '(choice (const :tag "Inbox" t) (const :tag "All" nil) (repeat :tag "Choose folders" (string :tag "Folder"))))

(defcustom mh-index-program nil "\
Indexing program that MH-E shall use.
The possible choices are swish++, swish-e, mairix, namazu, glimpse, pick and
grep. By default this variable is nil which means that the programs are tried
in order and the first one found is used.

More information about setting up an indexing program to use with MH-E can be
found in the documentation of `mh-index-search'." :type '(choice (const :tag "Auto-detect" nil) (const :tag "swish++" swish++) (const :tag "swish-e" swish) (const :tag "mairix" mairix) (const :tag "namazu" namazu) (const :tag "glimpse" glimpse) (const :tag "pick" pick) (const :tag "grep" grep)) :group 'mh-index)

(defcustom mh-index-ticked-messages-folders t "\
Folders searched for `mh-tick-seq'.
If t, then `mh-inbox' is searched. If nil, all the top level folders are
searched. Otherwise the list of folders specified as strings are searched.
See also `mh-recursive-folders-flag'." :group 'mh-index :type '(choice (const :tag "Inbox" t) (const :tag "All" nil) (repeat :tag "Choose folders" (string :tag "Folder"))))

(defcustom mh-junk-mail-folder nil "\
Folder to put spam mail in.
If nil then the spam is deleted." :type '(choice (const :tag "Delete spam" nil) (string :tag "Spam folder")) :group 'mh-junk)

(defcustom mh-junk-program nil "\
Spam program that MH-E shall use.
The possible choices are bogofilter, spamprobe, and spamassassin. By default
this variable is nil which means that the programs are tried in order and the
first one found is used." :type '(choice (const :tag "auto-detect" nil) (const :tag "bogofilter" bogofilter) (const :tag "spamprobe" spamprobe) (const :tag "spamassassin" spamassassin)) :set 'mh-junk-choose :group 'mh-junk)

(defcustom mh-bury-show-buffer-flag t "\
*Non-nil means that the displayed show buffer for a folder is buried." :type 'boolean :group 'mh-show)

(defcustom mh-clean-message-header-flag t "\
*Non-nil means clean headers of messages that are displayed or inserted.
The variable `mh-invisible-headers' if set determines the header fields that
are displayed. If it isn't set, then the variable `mh-invisible-headers'
determines the header fields that are removed." :type 'boolean :group 'mh-show)

(defcustom mh-decode-mime-flag (not (not (locate-library "mm-decode"))) "\
*Non-nil means that Gnus is used to show MIME attachments with Gnus." :type 'boolean :group 'mh-show)

(defcustom mh-display-buttons-for-alternatives-flag nil "\
*Non-nil means display buttons for all MIME alternatives.
Default behavior is to display only the preferred alternative. If this
variable is non-nil, then the preferred part is shown inline and buttons
are shown for each of the other alternatives." :type 'boolean :group 'mh-show)

(defcustom mh-display-buttons-for-inline-parts-flag nil "\
*Non-nil means display buttons for all inline MIME parts.
If non-nil, buttons are displayed for all MIME parts. Inline parts start off
in displayed state but they can be hidden by clicking the button. If nil no
buttons are shown for inline parts." :type 'boolean :group 'mh-show)

(defcustom mh-do-not-confirm-flag nil "\
*Non-nil means do not prompt for confirmation.
Commands such as `mh-pack-folder' prompt to confirm whether to process
outstanding moves and deletes or not before continuing. A non-nil setting will
perform the action--which is usually desired but cannot be retracted--without
question." :type 'boolean :group 'mh-show)

(defcustom mh-fetch-x-image-url nil "\
Control fetching of X-Image-URL header field image.
This setting only has effect if `mh-show-use-xface-flag' is non-nil.

If set to t, the image is fetched.

If set to 'ask, the user is prompted before the image is fetched. MH-E will
remember your reply and will either use the already fetched image the next time
the same URL is encountered or silently skip it if you didn't fetch it the
first time.

If set to nil, the default, images are not fetched and only displayed if they
are already present in the cache." :type '(choice (const :tag "Always fetch" t) (const :tag "Ask before fetching" ask) (const :tag "Never fetch" nil)) :group 'mh-show)

(defcustom mh-graphical-smileys-flag t "\
*Non-nil means graphical smileys are displayed.
Non-nil means that small graphics will be used in the show buffer instead of
patterns like :-), ;-) etc. The setting only has effect if
`mh-decode-mime-flag' is non-nil." :type 'boolean :group 'mh-show)

(defcustom mh-graphical-emphasis-flag t "\
*Non-nil means graphical emphasis is displayed.
Non-nil means that _underline_ will be underlined, *bold* will appear in bold,
/italic/ will appear in italic etc. See `gnus-emphasis-alist' for the whole
list. The setting only has effect if `mh-decode-mime-flag' is non-nil." :type 'boolean :group 'mh-show)

(defcustom mh-highlight-citation-p 'gnus "\
How to highlight citations in show buffers.
The gnus method uses a different color for each indentation." :type '(choice (const :tag "Use Gnus" gnus) (const :tag "Use font-lock" font-lock) (const :tag "Don't fontify" nil)) :group 'mh-show)

(defcustom mh-invisible-header-fields '("Approved:" "Autoforwarded:" "Bestservhost:" "Cancel-Lock:" "Content-" "Delivered-To:" "Delivery-Date:" "Delivery:" "Encoding:" "Envelope-to:" "Errors-To:" "Face:" "Forwarded:" "From " "Importance:" "In-Reply-To:" "Lines:" "List-" "List-" "List-Subscribe:" "List-Unsubscribe:" "Mail-from:" "Mailing-List:" "Message-Id:" "Mime-Version" "NNTP-" "Old-Return-Path:" "Original-Encoded-Information-Types:" "Original-Lines:" "Original-Newsgroups:" "Original-NNTP-" "Original-Path:" "Original-Received:" "Original-To:" "Original-X-" "P1-Content-Type:" "P1-Message-Id:" "P1-Recipient:" "Path:" "Precedence:" "Prev-Resent" "Priority:" "Received:" "References:" "Remailed-" "Replied:" "Resent" "Return-Path:" "Sensitivity:" "Status:" "Ua-Content-Id:" "Via:" "X-Abuse-Info:" "X-Accept-Language:" "X-Accept-Language:" "X-Ack:" "X-Apparently-From:" "X-Apparently-To:" "X-Authentication-Warning:" "X-Beenthere:" "X-Bogosity:" "X-Complaints-To:" "X-Cron-Env:" "X-Delivered" "X-Envelope-Sender:" "X-Envelope-To:" "X-Face:" "X-Folder:" "X-From-Line" "X-Gnus-Mail-Source:" "X-Habeas-SWE-1:" "X-Habeas-SWE-2:" "X-Habeas-SWE-3:" "X-Habeas-SWE-4:" "X-Habeas-SWE-5:" "X-Habeas-SWE-6:" "X-Habeas-SWE-7:" "X-Habeas-SWE-8:" "X-Habeas-SWE-9:" "X-Info:" "X-Juno-" "X-List-Host:" "X-List-Subscribe:" "X-List-Unsubscribe:" "X-Listserver:" "X-Loop:" "X-MIME-Autoconverted:" "X-MIMETrack:" "X-MS-TNEF-Correlator:" "X-Mailing-List:" "X-Mailman-Version:" "X-Majordomo:" "X-Message-Id" "X-MHE-Checksum" "X-MimeOLE:" "X-Mozilla-Status:" "X-Msmail-" "X-News:" "X-No-Archive:" "X-Notes-Item:" "X-Orcl-Content-Type:" "X-Original-Complaints-To:" "X-Original-Date:" "X-Original-To:" "X-Original-Trace:" "X-OriginalArrivalTime:" "X-Originating-IP:" "X-Priority:" "X-Qotd-" "X-Received-Date:" "X-Received:" "X-Request-" "X-SBClass:" "X-SBNote:" "X-SBPass:" "X-SBRule:" "X-Scanned-By" "X-Sender:" "X-Server-Date:" "X-Server-Uuid:" "X-Sieve:" "X-Spam-Checker-Version:" "X-Spam-Level:" "X-Spam-Score:" "X-Spam-Status:" "X-SpamBouncer:" "X-Trace:" "X-UIDL:" "X-UserInfo1:" "X-VSMLoop:" "X-Vms-To:" "X-Wss-Id:" "X-eGroups-" "X-pgp:" "X-submission-address:" "X400-" "Xref:") "\
*List of header fields that are not to be shown.
Regexps are not allowed. Unique fields should have a \":\" suffix; otherwise,
the element can be used to render invisible an entire class of fields that
start with the same prefix.
This variable is ignored if the variable `mh-visible-headers' is set." :type '(repeat (string :tag "Header field")) :set (lambda (symbol value) (set-default symbol value) (mh-invisible-headers)) :group 'mh-show)

(defcustom mh-max-inline-image-height nil "\
*Maximum inline image height if Content-Disposition is not present.
If nil, image will be displayed if its height is smaller than the height of
the window." :type '(choice (const nil) integer) :group 'mh-show)

(defcustom mh-max-inline-image-width nil "\
*Maximum inline image width if Content-Disposition is not present.
If nil, image will be displayed if its width is smaller than the width of the
window." :type '(choice (const nil) integer) :group 'mh-show)

(defcustom mh-show-maximum-size 0 "\
*Maximum size of message (in bytes) to display automatically.
Provides an opportunity to skip over large messages which may be slow to load.
Use a value of 0 to display all messages automatically regardless of size." :type 'integer :group 'mh-show)

(defcustom mh-show-use-goto-addr-flag (and (boundp 'goto-address-highlight-p) goto-address-highlight-p) "\
*Non-nil means highlight URLs and email addresses.
The `goto-addr' module is used." :type 'boolean :group 'mh-show)

(defcustom mh-show-use-xface-flag (>= emacs-major-version 21) "\
*Non-nil means display face images in `mh-show-mode'.
This flag controls the display of three kinds of faces.

The first is the traditional X-Face header field. For GNU Emacs 21
and above, the `uncompface' binary is required to be in the execute
PATH for the display of X-Face images. It can be obtained from
ftp://ftp.cs.indiana.edu/pub/faces/compface/compface.tar.Z.

If the XEmacs you are using has internal support for X-Face images, then MH-E
will display X-Face images in XEmacs \"out of the box\". Even if you don't have
X-Face support compiled into your XEmacs, you can still see the X-Face images
in MH-E with the aid of an external x-face package and `uncompface'. It is
available from ftp://ftp.jpl.org/pub/elisp/. Download it, put its files in the
`load-path' and MH-E will invoke it automatically.

Second, MH-E supports the display of the Gnus-specific Face
header field in GNU Emacs >= 21 and XEmacs. No external packages
are required. More information about the Face header can be found
at: http://quimby.gnus.org/circus/face/.

Finally, MH-E can also display images from the X-Image-URL header field. The
display of the images requires the `wget' program, available from
http://www.gnu.org/software/wget/wget.html, to fetch the image and the
`convert' program from the ImageMagick suite, available from
http://www.imagemagick.org/. Of the three header fields this is the most
efficient in terms of network usage since the image doesn't need to be
transmitted with every single mail. However its display needs the recipient to
fetch a URL and this can be misused. So it is disabled by default. It can be
enabled by customizing `mh-fetch-x-image-url'. Setting that to ask for
confirmation before fetching seems like a good choice.

Versions of GNU Emacs prior to 21.1 don't support the display of
inline images. So face images are not displayed in these versions." :type 'boolean :group 'mh-show)

(defcustom mh-summary-height nil "\
*Number of lines in MH-Folder window (including the mode line)." :type '(choice (const :tag "Automatic" nil) (integer :tag "Fixed sized")) :group 'mh-show)

(defcustom mh-visible-header-fields nil "\
*List of header fields that are to be shown.
Regexps are not allowed. Unique fields should have a \":\" suffix; otherwise,
the element can be used to render visible an entire class of fields that
start with the same prefix.
Only used if `mh-clean-message-header-flag' is non-nil.
Setting it overrides the variable `mh-invisible-headers'." :type '(repeat (string :tag "Header field")) :set (lambda (symbol value) (set-default symbol value) (mh-visible-headers)) :group 'mh-show)

(defcustom mhl-formfile nil "\
*Name of format file to be used by mhl to show and print messages.
A value of t means use the default format file.
nil means don't use mhl to format messages when showing; mhl is still used,
with the default format file, to format messages when printing them.
The format used should specify a non-zero value for overflowoffset so
the message continues to conform to RFC 822 and MH-E can parse the headers." :type '(choice (const nil) (const t) string) :group 'mh-show)

(defcustom mh-compose-insertion (if (locate-library "mml") 'gnus 'mhn) "\
Use either 'gnus or 'mhn to insert MIME message directives in messages." :type '(choice (const :tag "Use Gnus" gnus) (const :tag "Use mhn" mhn)) :group 'mh-letter)

(defcustom mh-compose-letter-function nil "\
Invoked when setting up a letter draft.
It is passed three arguments: TO recipients, SUBJECT, and CC recipients." :type '(choice (const nil) function) :group 'mh-letter)

(defcustom mh-compose-prompt-flag nil "\
*Non-nil means prompt for header fields when composing a new draft." :type 'boolean :group 'mh-letter)

(defcustom mh-compose-skipped-header-fields '("from" "organization" "references" "in-reply-to" "x-face" "face" "x-mailer") "\
List of header fields to skip over when navigating in draft." :type '(repeat (string :tag "Field")) :group 'mh-letter)

(defcustom mh-compose-space-does-completion-flag nil "\
*Non-nil means that SPACE does completion in message header." :type 'boolean :group 'mh-letter)

(defcustom mh-delete-yanked-msg-window-flag nil "\
*Non-nil means delete any window displaying the message.
Controls window display when a message is yanked by \\<mh-letter-mode-map>\\[mh-yank-cur-msg].
If non-nil, yanking the current message into a draft letter deletes any
windows displaying the message." :type 'boolean :group 'mh-letter)

(defcustom mh-extract-from-attribution-verb "wrote:" "\
*Verb to use for attribution when a message is yanked by \\<mh-letter-mode-map>\\[mh-yank-cur-msg]." :type '(choice (const "wrote:") (const "a crit :") (string :tag "Custom string")) :group 'mh-letter)

(defcustom mh-forward-subject-format "%s: %s" "\
*Format to generate the Subject: line contents for a forwarded message.
The two string arguments to the format are the sender of the original
message and the original subject line." :type 'string :group 'mh-letter)

(defcustom mh-ins-buf-prefix "> " "\
*String to put before each non-blank line of a yanked or inserted message.
\\<mh-letter-mode-map>Used when the message is inserted into an outgoing letter
by \\[mh-insert-letter] or \\[mh-yank-cur-msg]." :type 'string :group 'mh-letter)

(defcustom mh-insert-x-mailer-flag t "\
*Non-nil means append an X-Mailer field to the header." :type 'boolean :group 'mh-letter)

(defcustom mh-letter-complete-function 'ispell-complete-word "\
*Function to call when completing outside of fields specific to aliases." :type '(choice function (const nil)) :group 'mh-letter)

(defcustom mh-letter-fill-column 72 "\
*Fill column to use in `mh-letter-mode'.
This is usually less than in other text modes because email messages get
quoted by some prefix (sometimes many times) when they are replied to,
and it's best to avoid quoted lines that span more than 80 columns." :type 'integer :group 'mh-letter)

(defcustom mh-reply-default-reply-to nil "\
*Sets the person or persons to whom a reply will be sent.
If nil, prompt for recipient.  If non-nil, then \\<mh-folder-mode-map>`\\[mh-reply]' will use this
value and it should be one of \"from\", \"to\", \"cc\", or \"all\".
The values \"cc\" and \"all\" do the same thing." :type '(choice (const :tag "Prompt" nil) (const "from") (const "to") (const "cc") (const "all")) :group 'mh-letter)

(defcustom mh-reply-show-message-flag t "\
*Non-nil means the show buffer is displayed using \\<mh-letter-mode-map>\\[mh-reply].

The setting of this variable determines whether the MH `show-buffer' is
displayed with the current message when using `mh-reply' without a prefix
argument.  Set it to nil if you already include the message automatically
in your draft using
 repl: -filter repl.filter
in your ~/.mh_profile file." :type 'boolean :group 'mh-letter)

(defcustom mh-signature-file-name "~/.signature" "\
*Name of file containing the user's signature.
Inserted into message by \\<mh-letter-mode-map>\\[mh-insert-signature]." :type 'file :group 'mh-letter)

(defcustom mh-x-face-file "~/.face" "\
*File containing X-Face or Face header field to insert in outgoing mail.

If the file starts with either of the strings \"X-Face: \", \"Face: \" or
\"X-Image-URL: \" then it is assumed to contain the whole field and is added to
the message header verbatim. Otherwise it is assumed that the file contains the
value of the X-Face header field.

X-Face header fields can be generated using `compface', which can be obtained
from ftp://ftp.cs.indiana.edu/pub/faces/compface/compface.tar.Z. The \"Online
X-Face Convertor\" at http://www.dairiki.org/xface/ is a useful resource for
quick conversion of images into X-Face header fields.

There is a `make-face' script that converts a jpeg image to a Face header
field at http://quimby.gnus.org/circus/face/make-face.

The URL of any image can be used for the X-Image-URL field and no processing
of the image is required.

If nil, or the file does not exist, nothing is added to the message header." :type 'file :group 'mh-letter)

(defcustom mh-yank-from-start-of-msg 'attribution "\
*Controls which part of a message is yanked by \\<mh-letter-mode-map>\\[mh-yank-cur-msg].
If t, include the entire message, with full headers.  This is historically
here for use with supercite, but is now deprecated in favor of the setting
`supercite' below.

If the symbol `body', then yank the message minus the header.

If the symbol `supercite', include the entire message, with full headers.
This also causes the invocation of `sc-cite-original' without the setting
of `mail-citation-hook', now deprecated practice.

If the symbol `autosupercite', do as for `supercite' automatically when
show buffer matches the message being replied-to.  When this option is used,
the -noformat switch is passed to the repl program to override a -filter or
-format switch.

If the symbol `attribution', then yank the message minus the header and add
a simple attribution line at the top.

If the symbol `autoattrib', do as for `attribution' automatically when show
buffer matches the message being replied-to.  You can make sure this is
always the case by setting `mh-reply-show-message-flag' to t (which is the
default) and optionally `mh-delete-yanked-msg-window-flag' to t as well such
that the show window is never displayed.  When the `autoattrib' option is
used, the -noformat switch is passed to the repl program to override a
-filter or -format switch.

If nil, yank only the portion of the message following the point.

If the show buffer has a region, this variable is ignored unless its value is
one of `attribution' or `autoattrib' in which case the attribution is added
to the yanked region." :type '(choice (const :tag "Below point" nil) (const :tag "Without header" body) (const :tag "Invoke supercite" supercite) (const :tag "Invoke supercite, automatically" autosupercite) (const :tag "Without header, with attribution" attribution) (const :tag "Without header, with attribution, automatically" autoattrib) (const :tag "Entire message with headers" t)) :group 'mh-letter)

(defcustom mh-alias-completion-ignore-case-flag t "\
*Non-nil means don't consider case significant in MH alias completion.
This is the default in plain MH, so it is the default here as well. It
can be useful to set this to t if, for example, you use lowercase
aliases for people and uppercase for mailing lists." :type 'boolean :group 'mh-alias)

(defcustom mh-alias-expand-aliases-flag nil "\
*Non-nil means to expand aliases entered in the minibuffer.
In other words, aliases entered in the minibuffer will be expanded to the full
address in the message draft. By default, this expansion is not performed." :type 'boolean :group 'mh-alias)

(defcustom mh-alias-flash-on-comma t "\
*Specify whether to flash or warn on translation.
When a [comma] is pressed while entering aliases or addresses, setting this
variable to the following values has the listed effects:
t   Flash alias translation but don't warn if there is no translation.
1   Flash alias translation and warn if there is no translation.
nil Do not flash alias translation nor warn if there is no translation." :type '(choice (const :tag "Flash but don't warn if no translation" t) (const :tag "Flash and warn if no translation" 1) (const :tag "Don't flash nor warn if no translation" nil)) :group 'mh-alias)

(defcustom mh-alias-insert-file nil "\
*Filename to use to store new MH-E aliases.
This variable can also be a list of filenames, in which case MH-E will prompt
for one of them. If nil, the default, then MH-E will use the first file found
in the \"AliasFile\" component of the MH profile." :type '(choice (const :tag "Use AliasFile MH profile component" nil) (file :tag "Alias file") (repeat :tag "List of alias files" file)) :group 'mh-alias)

(defcustom mh-alias-insertion-location 'sorted "\
Specifies where new aliases are entered in alias files.
Options are sorted alphabetically, at the top of the file or at the bottom." :type '(choice (const :tag "Sorted alphabetically" sorted) (const :tag "At the top of file" top) (const :tag "At the bottom of file" bottom)) :group 'mh-alias)

(defcustom mh-alias-local-users t "\
*If t, local users are completed in MH-E To: and Cc: prompts.

Users with a userid greater than some magic number (usually 200) are available
for completion.

If you set this variable to a string, it will be executed to generate a
password file. A value of \"ypcat passwd\" is helpful if NIS is in use." :type '(choice (boolean) (string)) :group 'mh-alias)

(defcustom mh-alias-local-users-prefix "local." "\
*String prepended to the real names of users from the passwd file.
If nil, use the username string unmodified instead of the real name from
the gecos field of the passwd file.

For example, given the following passwd file line:

 psg:x:1000:1000:Peter S Galbraith,,,:/home/psg:/bin/tcsh

here are the derived aliases for different values of this variable:

 \"local.\"  -> local.peter.galbraith
 \"\"        -> peter.galbraith
 nii       -> psg

This variable is only meaningful if the variable `mh-alias-local-users' is
non-nil." :type '(choice (const :tag "Use username instead of real name" nil) (string)) :group 'mh-alias)

(defcustom mh-alias-passwd-gecos-comma-separator-flag t "\
*Non-nil means the gecos field in the passwd file uses comma as a separator.
Used to construct aliases for users in the passwd file." :type 'boolean :group 'mh-alias)

(defcustom mh-alias-system-aliases '("/etc/nmh/MailAliases" "/usr/lib/mh/MailAliases" "/etc/passwd") "\
*A list of system files from which to cull aliases.
If these files are modified, they are automatically reread. This list need
include only system aliases and the passwd file, since personal alias files
listed in your \"AliasFile\" MH profile component are automatically included.
You can update the alias list manually using \\[mh-alias-reload]." :type '(choice (file) (repeat file)) :group 'mh-alias)

(defcustom mh-auto-fields-list nil "\
Alist of addresses for which header lines are automatically inserted.
Each element has the form (REGEXP ((KEYWORD VALUE) (KEYWORD VALUE)).
When the REGEXP appears in the To or cc fields of a message, the corresponding
KEYWORD header field is insert with its VALUE in the message header.

There is one special case for KEYWORD, that of \"identity\", which means to
insert that identity using `mh-insert-identity'.

The common KEYWORD cases of \"Mail-Followup-To\" and \"fcc\" are also
prompted for in the customization interface." :type (backquote (repeat (list :tag "" (string :tag "Regular expression to match") (repeat :tag "At least one pair from below" (choice (cons :tag "Identity entry" (const "identity") (\, (append '(radio) (mapcar (function (lambda (arg) (backquote (const (\, arg))))) (mapcar 'car mh-identity-list))))) (cons :tag "fcc field" (const "fcc") (string :tag "Value")) (cons :tag "Mail-Followup-To field" (const "Mail-Followup-To") (string :tag "Value")) (cons :tag "Other field and value pair" (string :tag "Field") (string :tag "Value"))))))) :group 'mh-identity)

(defcustom mh-identity-default nil "\
Default identity to use when `mh-letter-mode' is called." :type (append '(radio) (cons '(const :tag "None" nil) (mapcar (function (lambda (arg) (backquote (const (\, arg))))) (mapcar 'car mh-identity-list)))) :group 'mh-identity)

(defcustom mh-identity-list nil "\
*List holding MH-E identity.
Omit the colon and trailing space from the field names.
The keyword name \"none\" is reserved for internal use.
Use the keyname name \"signature\" to specify either a signature file or a
function to call to insert a signature at point.

Providing an empty Value (\"\") will cause the field to be deleted.

Example entries using the customize interface:
   Keyword name: work
            From
            Value: John Doe <john@work.com>
            Organization
            Value: Acme Inc.
   Keyword name: home
            From
            Value: John Doe <johndoe@home.net>
            Organization
            Value:

This would produce the equivalent of:
 (setq mh-identity-list
      '((\"work\"
         ((\"From\" . \"John Doe <john@work.com>\")
          (\"Organization\" . \"Acme Inc.\")))
        (\"home\"
         ((\"From\" . \"John Doe <johndoe@home.net>\")
          (\"Organization\" . \"\")))))" :type '(repeat (list :tag "" (string :tag "Keyword name") (repeat :tag "At least one pair from below" (choice (cons :tag "From field" (const "From") (string :tag "Value")) (cons :tag "Organization field" (const "Organization") (string :tag "Value")) (cons :tag "Signature" (const "signature") (choice (file) (function))) (cons :tag "Other field & value pair" (string :tag "Field") (string :tag "Value")))))) :set 'mh-identity-list-set :group 'mh-identity)

(defcustom mh-before-quit-hook nil "\
Invoked by \\<mh-folder-mode-map>`\\[mh-quit]' before quitting MH-E.
See also `mh-quit-hook'." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-before-send-letter-hook nil "\
Invoked at the beginning of the \\<mh-letter-mode-map>\\[mh-send-letter] command." :type 'hook :group 'mh-hooks :group 'mh-letter)

(defcustom mh-delete-msg-hook nil "\
Invoked after marking each message for deletion." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-edit-mhn-hook nil "\
Invoked on the formatted letter by \\<mh-letter-mode-map>\\[mh-edit-mhn]." :type 'hook :group 'mh-hooks :group 'mh-letter)

(defcustom mh-find-path-hook nil "\
Invoked by `mh-find-path' after reading the user's MH profile." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-folder-mode-hook nil "\
Invoked in `mh-folder-mode' on a new folder." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-folder-updated-hook nil "\
Invoked when the folder actions (such as moves and deletes) are performed.
Variables that are useful in this hook include `mh-delete-list' and
`mh-refile-list' which can be used to see which changes are being made to
current folder, `mh-current-folder'." :type 'hook :group 'mh-hooks)

(defcustom mh-inc-folder-hook nil "\
Invoked by \\<mh-folder-mode-map>`\\[mh-inc-folder]' after incorporating mail into a folder." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-kill-folder-suppress-prompt-hook '(mh-index-p) "\
Invoked at the beginning of the  \\<mh-folder-mode-map>`\\[mh-kill-folder]' command.
This hook is a list of functions to be called, with no arguments, which should
return a value of non-nil if you should not be asked if you're sure that you
want to remove the folder. This is useful for folders that are easily
regenerated.

The default value of `mh-index-p' suppresses the prompt on folders generated
by an index search.

WARNING: Use this hook with care. If there is a bug in your hook which returns
t on +inbox and you hit \\<mh-folder-mode-map>`\\[mh-kill-folder]' by accident
in the +inbox buffer, you will not be happy." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-letter-insert-signature-hook nil "\
Invoked at the beginning of the \\<mh-letter-mode-map>\\[mh-insert-signature] command.
Can be used to determine which signature file to use based on message content.
On return, if `mh-signature-file-name' is non-nil that file will be inserted at
the current point in the buffer." :type 'hook :group 'mh-hooks :group 'mh-letter)

(defcustom mh-letter-mode-hook nil "\
Invoked in `mh-letter-mode' on a new letter." :type 'hook :group 'mh-hooks :group 'mh-letter)

(defcustom mh-pick-mode-hook nil "\
Invoked upon entry to `mh-pick-mode'." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-quit-hook nil "\
Invoked after \\<mh-folder-mode-map>`\\[mh-quit]' quits MH-E.
See also `mh-before-quit-hook'." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-refile-msg-hook nil "\
Invoked after marking each message for refiling." :type 'hook :group 'mh-hooks :group 'mh-folder)

(defcustom mh-show-hook nil "\
Invoked after \\<mh-folder-mode-map>`\\[mh-show]' shows a message." :type 'hook :group 'mh-hooks :group 'mh-show)

(defcustom mh-show-mode-hook nil "\
Invoked upon entry to `mh-show-mode'." :type 'hook :group 'mh-hooks :group 'mh-show)

(defcustom mh-unseen-updated-hook nil "\
Invoked after the unseen sequence has been updated.
The variable `mh-seen-list' can be used to obtain the list of messages which
will be removed from the unseen sequence." :type 'hook :group 'mh-hooks :group 'mh-folder)

;;;***

(provide 'mh-e-custom-defines)
