;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'mine-custom-defines) (error "Feature mine-custom-defines already loaded"))

;;;### (autoloads (xmine-solved-sound xmine-explode-sound xmine-unhide-many-sound xmine-unhide-sound xmine-flag-sound xmine-play-sounds xmine-background xmine-balloon-list xmine-%-of-mines xmine-glyph-dir xmine-height xmine-width xmine) "xmine" "mine/xmine.el")
(defconst custom-define-current-source-file "xmine.el")

(defgroup xmine nil "The well known mine searching game." :group 'games)

(defcustom xmine-width 25 "\
The width of the mine field" :group 'xmine :type 'integer)

(defcustom xmine-height 20 "\
The height of the mine field" :group 'xmine :type 'integer)

(defcustom xmine-glyph-dir (locate-data-directory "mine") "\
The directory where the mine glyphs reside" :group 'xmine :type 'directory)

(defcustom xmine-%-of-mines 12 "\
The percentage of tiles that should be mines." :group 'xmine :type 'integer)

(defcustom xmine-balloon-list (list "Push Me!" "Don't Sleep." "Are you sure?" "I'm getting bored.") "\
(Random) texts for the balloon-help property of the tiles. 
This can be a list of strings or the symbol 'yow, in which case a random quote from
Zippy The Pinhead will be used..." :group 'xmine :type '(choice (repeat string) (const yow)))

(defcustom xmine-background "white" "\
The background color of XMine's buffer.
Many colors will not blend nicely with the logo. Shades of light grey are
preferred if you don't want to use white." :group 'xmine :type 'color)

(defcustom xmine-play-sounds nil "\
If XMine should play some sounds for various events to happen." :group 'xmine :type 'boolean)

(defcustom xmine-flag-sound (locate-data-file (concat (file-name-as-directory "sounds") "click.au")) "\
The sound played when flagging/un-flagging a tile" :group 'xmine :type 'file)

(defcustom xmine-unhide-sound (locate-data-file (concat (file-name-as-directory "sounds") "drip.au")) "\
The sound played when unhiding a tile" :group 'xmine :type 'file)

(defcustom xmine-unhide-many-sound (locate-data-file (concat (file-name-as-directory "sounds") "boing.au")) "\
The sound played when unhiding all neighbours of a tile" :group 'xmine :type 'file)

(defcustom xmine-explode-sound (concat xmine-glyph-dir "explosion3.au") "\
The sound played when you unhide a mine" :group 'xmine :type 'file)

(defcustom xmine-solved-sound (locate-data-file (concat (file-name-as-directory "sounds") "im_so_happy.au")) "\
The sound played if you managed to win the game." :group 'xmine :type 'file)

;;;***

(provide 'mine-custom-defines)
