;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'net-utils-custom-defines) (error "Feature net-utils-custom-defines already loaded"))

;;;### (autoloads (dig-font-lock-keywords dig-dns-server dig-program dig) "dig" "net-utils/dig.el")
(defconst custom-define-current-source-file "dig.el")

(defgroup dig nil "Dig configuration." :group 'comm)

(defcustom dig-program "dig" "\
Name of dig (domain information groper) binary." :type 'file :group 'dig)

(defcustom dig-dns-server nil "\
DNS server to query.
If nil, use system defaults." :type '(choice (const :tag "System defaults") string) :group 'dig)

(defcustom dig-font-lock-keywords '(("^;; [A-Z]+ SECTION:" 0 font-lock-keyword-face) ("^;;.*" 0 font-lock-comment-face) ("^; <<>>.*" 0 font-lock-type-face) ("^;.*" 0 font-lock-function-name-face)) "\
Default expressions to highlight in dig mode." :type 'sexp :group 'dig)

;;;***

;;;### (autoloads (dns-mode-font-lock-keywords dns-mode) "dns-mode" "net-utils/dns-mode.el")
(defconst custom-define-current-source-file "dns-mode.el")

(defgroup dns-mode nil "DNS master file mode configuration." :group 'comm)

(defcustom dns-mode-font-lock-keywords (backquote (("^$ORIGIN" 0 (\, dns-mode-control-entity-face)) ("^$INCLUDE" 0 (\, dns-mode-control-entity-face)) ("^$[a-z0-9A-Z]+" 0 (\, dns-mode-bad-control-entity-face)) ((\, (regexp-opt dns-mode-classes)) 0 (\, dns-mode-class-face)) ((\, (regexp-opt dns-mode-types)) 0 (\, dns-mode-type-face)))) "\
Font lock keywords used to highlight text in DNS master file mode." :type 'sexp :group 'dns-mode)

;;;***

;;;### (autoloads (feedmail-binmail-template feedmail-buffer-eating-function feedmail-queue-runner-cleaner-upper feedmail-queue-runner-message-sender feedmail-queue-alternative-mail-header-separator feedmail-queue-runner-mode-setter feedmail-queue-express-hook feedmail-before-fcc-hook feedmail-last-chance-hook feedmail-debug-sit-for feedmail-debug feedmail-queue-auto-file-nuke feedmail-nuke-buffer-after-queue feedmail-queue-fqm-suffix feedmail-queue-default-file-slug feedmail-queue-slug-suspect-regexp feedmail-queue-slug-maker feedmail-ask-for-queue-slug feedmail-queue-use-send-time-for-message-id feedmail-queue-use-send-time-for-date feedmail-queue-run-orderer feedmail-queue-chatty-sit-for feedmail-queue-chatty feedmail-queue-reminder-alist feedmail-prompt-before-queue-help-supplement feedmail-prompt-before-queue-user-alist feedmail-ask-before-queue-default feedmail-ask-before-queue-reprompt feedmail-ask-before-queue-prompt feedmail-ask-before-queue feedmail-queue-draft-directory feedmail-queue-directory feedmail-queue-runner-confirm-global feedmail-enable-queue feedmail-spray-address-fiddle-plex-list feedmail-enable-spray feedmail-fiddle-plex-user-list feedmail-fiddle-headers-upwardly feedmail-date-generator feedmail-message-id-suffix feedmail-message-id-generator feedmail-x-mailer-line feedmail-x-mailer-line-user-appendage feedmail-deduce-envelope-from feedmail-sendmail-f-doesnt-sell-me-out feedmail-from-line feedmail-sender-line feedmail-nuke-empty-headers feedmail-force-expand-mail-aliases feedmail-nuke-body-in-fcc feedmail-nuke-bcc-in-fcc feedmail-fill-to-cc-fill-column feedmail-fill-to-cc feedmail-deduce-bcc-where feedmail-nuke-resent-bcc feedmail-nuke-bcc feedmail-confirm-outgoing-timeout feedmail-display-full-frame feedmail-confirm-outgoing feedmail-debug feedmail-queue feedmail-headers feedmail-misc feedmail) "feedmail" "net-utils/feedmail.el")
(defconst custom-define-current-source-file "feedmail.el")

(defgroup feedmail nil "Assist other email packages to massage outgoing messages." :group 'mail)

(defgroup feedmail-misc nil "Miscellaneous feedmail options that don't fit in other groups." :group 'feedmail)

(defgroup feedmail-headers nil "Options related to manipulating specific headers or types of headers." :group 'feedmail)

(defgroup feedmail-queue nil "Options related to queuing messages for later sending." :group 'feedmail)

(defgroup feedmail-debug nil "Options related to debug messages for later sending." :group 'feedmail)

(defcustom feedmail-confirm-outgoing nil "\
*If non-nil, give a y-or-n confirmation prompt before sending mail.
This is done after the message is completely prepped, and you'll be
looking at the top of the message in a buffer when you get the prompt.
If set to the symbol 'queued, give the confirmation prompt only while
running the queue (however, the prompt is always suppressed if you are
processing the queue via feedmail-run-the-queue-no-prompts).  If set
to the symbol 'immediate, give the confirmation prompt only when
sending immediately.  For any other non-nil value, prompt in both
cases.  You can give a timeout for the prompt; see variable
feedmail-confirm-outgoing-timeout." :group 'feedmail-misc :type 'boolean)

(defcustom feedmail-display-full-frame 'queued "\
*If non-nil, show prepped messages in a full frame.
If nil, the prepped message will be shown, for confirmation or
otherwise, in some window in the current frame without resizing
anything.  That may or may not display enough of the message to
distinguish it from others.  If set to the symbol 'queued, take
this action only when running the queue.  If set to the symbol
'immediate, take this action only when sending immediately.  For
any other non-nil value, take the action in both cases.  Even if
you're not confirming the sending of immediate or queued messages,
it can still be interesting to see a lot about them as they are
shuttled robotically onward." :group 'feedmail-misc :type 'boolean)

(defcustom feedmail-confirm-outgoing-timeout nil "\
*If non-nil, a timeout in seconds at the send confirmation prompt.
If a positive number, it's a timeout before sending.  If a negative
number, it's a timeout before not sending.  This will not work if your
version of emacs doesn't include the function y-or-n-p-with-timeout
\(e.g., some versions of XEmacs)." :group 'feedmail-misc :type '(choice (const nil) integer))

(defcustom feedmail-nuke-bcc t "\
*If non-nil remove BCC: lines from the message headers.
In any case, the BCC: lines do participate in the composed address
list.  You may want to leave them in if you're using sendmail
see `feedmail-buffer-eating-function'." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-nuke-resent-bcc t "\
*If non-nil remove RESENT-BCC: lines from the message headers.
In any case, the RESENT-BCC: lines do participate in the composed
address list.  You may want to leave them in if you're using sendmail
see `feedmail-buffer-eating-function'." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-deduce-bcc-where nil "\
*Where should BCC:/RESENT-BCC: addresses appear in the envelope list?
Addresses for the message envelope are deduced by examining
appropriate address headers in the message.  Generally, they will show
up in the list of deduced addresses in the order that the headers
happen to appear (duplicate addresses are eliminated in any case).
This variable can be set to the symbol 'first, in which case the
BCC:/RESENT-BCC: addresses will appear at the beginning in the list;
or, it can be set to the symbol 'last, in which case they will appear
at the end of the list.

Why should you care?  Well, maybe you don't, and certainly the same
things could be accomplished by affecting the order of message headers
in the outgoing message.  Some people use BCC: as a way of getting
their own \"come back\" copy of each message they send.  If BCC:
addresses are not handled first, there can be substantial delays in
seeing the message again.  Some configurations of sendmail, for example,
seem to try to deliver to each addressee at least once, immediately
and serially, so slow SMTP conversations can add up to a delay.  There
is an option for either 'first or 'last because you might have a
delivery agent that processes the addresses backwards." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-fill-to-cc t "\
*If non-nil do smart filling of addressee header lines.
Smart filling means breaking long lines at appropriate points and
making continuation lines.  Despite the function name, it includes
TO:, CC:, BCC: (and their RESENT-* forms), as well as FROM: and
REPLY-TO: (though they seldom need it).  If nil, the lines are left
as-is.  The filling is done after mail address alias expansion." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-fill-to-cc-fill-column default-fill-column "\
*Fill column used by feedmail-fill-to-cc." :group 'feedmail-headers :type 'integer)

(defcustom feedmail-nuke-bcc-in-fcc nil "\
*If non-nil remove [RESENT-]BCC: lines in message copies saved via FCC:.
This is independent of whether the BCC: header lines are actually sent
with the message (see feedmail-nuke-bcc).  Though not implied in the name,
the same FCC: treatment applies to both BCC: and RESENT-BCC: lines." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-nuke-body-in-fcc nil "\
*If non-nil remove body of message in copies saved via FCC:.
If an positive integer value, leave (up to) that many lines of the
beginning of the body intact.  The result is that the FCC: copy will
consist only of the message headers, serving as a sort of an outgoing
message log." :group 'feedmail-headers :type '(choice (const nil) (const t) integer))

(defcustom feedmail-force-expand-mail-aliases nil "\
*If non-nil force the calling of expand-mail-aliases.
Normally, feedmail tries to figure out if you're using mailalias or
mailabbrevs and only calls expand-mail-aliases if it thinks you're
using the mailalias package.  This user option can be used to force
the issue since there are configurations which fool the figuring
out." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-nuke-empty-headers t "\
*If non-nil, remove header lines which have no contents.
A completely empty SUBJECT: header is always removed, regardless of
the setting of this variable.  The only time you would want them left
in would be if you used some headers whose presence indicated
something rather than their contents.  This is rare in Internet email
but common in some proprietary systems." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-sender-line nil "\
*If non-nil and the email has no SENDER: header, use this value.
May be nil, in which case nothing in particular is done with respect
to SENDER: lines.  By design, will not replace an existing SENDER:
line, but you can achieve that with a fiddle-plex 'replace action.
NB: it makes no sense to use the value t since there is no sensible
default for SENDER:.

If not nil, it may be a string, a fiddle-plex, or a function which
returns either nil, t, a string, or a fiddle-plex (or, in fact,
another function, but let's not be ridiculous).  If a string, it
should be just the contents of the header, not the name of the header
itself nor the trailing newline.  If a function, it will be called
with no arguments.  For an explanation of fiddle-plexes, see the
documentation for the variable feedmail-fiddle-plex-blurb.  In all
cases the name element of the fiddle-plex is ignored and is hardwired
by feedmail to either \"X-Sender\" or \"X-Resent-Sender\".

You can probably leave this nil, but if you feel like using it, a good
value would be a string of a fully-qualified domain name form of your
address.  For example, \"bill@bubblegum.net (WJCarpenter)\".  The SENDER:
header is fiddled after the FROM: header is fiddled." :group 'feedmail-headers :type '(choice (const nil) string))

(defcustom feedmail-from-line t "\
*If non-nil and the email has no FROM: header, use this value.
May be t, in which case a default is computed (and you probably won't
be happy with it).  May be nil, in which case nothing in particular is
done with respect to FROM: lines.  By design, will not replace an
existing FROM: line, but you can achieve that with a fiddle-plex 'replace
action.

If neither nil nor t, it may be a string, a fiddle-plex, or a function
which returns either nil, t, a string, or a fiddle-plex (or, in fact,
another function, but let's not be ridiculous).  If a string, it
should be just the contents of the header, not the name of the header
itself nor the trailing newline.  If a function, it will be called
with no arguments.  For an explanation of fiddle-plexes, see the
documentation for the variable feedmail-fiddle-plex-blurb.  In all
cases the name element of the fiddle-plex is ignored and is hardwired
by feedmail to either \"X-From\" or \"X-Resent-From\".

A good value would be a string fully-qualified domain name form of
your address.  For example, \"bill@bubblegum.net (WJCarpenter)\".  The
default value of this variable uses the standard elisp variable
user-mail-address which should be set on every system but has a decent
chance of being wrong.  It also honors mail-from-style.  Better to set
this variable explicitly to the string you want or find some other way
to arrange for the message to get a FROM: line." :group 'feedmail-headers :type '(choice (const nil) string))

(defcustom feedmail-sendmail-f-doesnt-sell-me-out nil "\
*Says whether the sendmail program issues a warning header if called with \"-f\".
The sendmail program has a useful feature to let you set the envelope FROM
address via a command line option, \"-f\".  Unfortunately, it also has a widely
disliked default behavior of selling you out if you do that by inserting
an unattractive warning in the headers.  It looks something like this:

  X-Authentication-Warning: u1.example.com: niceguy set sender to niceguy@example.com using -f

It is possible to configure sendmail to not do this, but such a reconfiguration
is not an option for many users.  As this is the default behavior of most
sendmail installations, one can mostly only wish it were otherwise.  If feedmail
believes the sendmail program will sell you out this way, it won't use the \"-f\"
option when calling sendmail.  If it doesn't think sendmail will sell you out,
it will use the \"-f\" (since it is a handy feature).  You control what
feedmail thinks with this variable.  The default is nil, meaning that feedmail
will believe that sendmail will sell you out." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-deduce-envelope-from t "\
*If non-nil, deduce message envelope \"from\" from header FROM: or SENDER:.
In other words, if there is a SENDER: header in the message, temporarily
change the value of user-mail-address to be the same while the message
is being sent.  If there is no SENDER: header, use the FROM: header,
if any.  Address values are taken from the actual message just before
it is sent, and the process is independent of the values of
feedmail-from-line and/or feedmail-sender-line.

There are many and good reasons for having the message header
FROM:/SENDER: be different from the message envelope \"from\"
information.  However, for most people and for most circumstances, it
is usual for them to be the same (this is probably especially true for
the case where the user doesn't understand the difference between the
two in the first place).

The idea behind this feature is that you can have everything set up
some normal way for yourself.  If for some reason you want to send a
message with another FROM: line, you can just type it at the top of
the message, and feedmail will take care of \"fixing up\" the envelope
\"from\".  This only works for mail senders which make use of
user-mail-address as the envelope \"from\" value.  For some mail
senders (e.g., feedmail-buffer-to-bin-mail), there is no simple way to
influence what they will use as the envelope." :group 'feedmail-headers :type 'boolean)

(defcustom feedmail-x-mailer-line-user-appendage nil "\
*See feedmail-x-mailer-line." :group 'feedmail-headers :type '(choice (const nil) string))

(defcustom feedmail-x-mailer-line t "\
*Control the form of an X-MAILER: header in an outgoing message.
Moderately useful for debugging, keeping track of your correspondents'
mailer preferences, or just wearing your MUA on your sleeve.  You
should probably know that some people are fairly emotional about the
presence of X-MAILER: lines in email.

If nil, nothing is done about X-MAILER:.

If t, an X-MAILER: header of a predetermined format is produced,
combining its efforts with any existing X-MAILER: header.  If you want
to take the default construct and just add a little blob of your own
at the end, define the variable feedmail-x-mailer-line-user-appendage
as that blob string.  A value of t is equivalent to using the function
feedmail-default-x-mailer-generator.

If neither nil nor t, it may be a string, a fiddle-plex, or a function
which returns either nil, t, a string, or a fiddle-plex (or, in fact,
another function, but let's not be ridiculous).  If a string, it
should be just the contents of the header, not the name of the header
itself nor the trailing newline.  If a function, it will be called
with no arguments.  For an explanation of fiddle-plexes, see the
documentation for the variable feedmail-fiddle-plex-blurb.  In all
cases the name element of the fiddle-plex is ignored and is hardwired
by feedmail to either \"X-Mailer\" or \"X-Resent-Mailer\"." :group 'feedmail-headers :type '(choice (const t) (const nil) string function))

(defcustom feedmail-message-id-generator t "\
*Specifies the creation of a MESSAGE-ID: header field.

If nil, nothing is done about MESSAGE-ID:.

If t, a MESSAGE-ID: header of a predetermined format is produced, but
only if there is not already a MESSAGE-ID: in the message.  A value of
t is equivalent to using the function feedmail-default-message-id-generator.

If neither nil nor t, it may be a string, a fiddle-plex, or a function
which returns either nil, t, a string, or a fiddle-plex (or, in fact,
another function, but let's not be ridiculous).  If a string, it
should be just the contents of the header, not the name of the header
itself nor the trailing newline.  If a function, it will be called
with one argument: the possibly-nil name of the file associated with
the message buffer.  For an explanation of fiddle-plexes, see the
documentation for the variable feedmail-fiddle-plex-blurb.  In all
cases the name element of the fiddle-plex is ignored and is hardwired
by feedmail to either \"Message-ID\" or \"Resent-Message-ID\".

You should let feedmail generate a MESSAGE-ID: for you unless you are sure
that whatever you give your messages to will do it for you (e.g., most
configurations of sendmail).  Even if the latter case is true, it
probably won't hurt you to generate your own, and it will then show up
in the saved message if you use FCC:." :group 'feedmail-headers :type '(choice (const nil) function))

(defcustom feedmail-message-id-suffix nil "\
*If non-nil, used as a suffix in generated MESSAGE-ID: headers for uniqueness.
The function feedmail-default-message-id-generator creates its work
based on a formatted date-time string, a random number, and a
domain-looking suffix.  You can control the suffix used by assigning a
string value to this variable.  If you don't supply one, the value of
the variable user-mail-address will be used.  If the value of
feedmail-message-id-suffix contains an \"@\" character, the string
will be used verbatim, else an \"@\" character will be prepended
automatically." :group 'feedmail-headers :type 'string)

(defcustom feedmail-date-generator t "\
*Specifies the creation of a DATE: header field.

If nil, nothing is done about DATE:.

If t, a DATE: header of a predetermined format is produced, but only
if there is not already a DATE: in the message.  A value of t is
equivalent to using the function feedmail-default-date-generator.

If neither nil nor t, it may be a string, a fiddle-plex, or a function
which returns either nil, t, a string, or a fiddle-plex (or, in fact,
another function, but let's not be ridiculous).  If a string, it
should be just the contents of the header, not the name of the header
itself nor the trailing newline.  If a function, it will be called
with one argument: the possibly-nil name of the file associated with
the message buffer.  For an explanation of fiddle-plexes, see the
documentation for the variable feedmail-fiddle-plex-blurb.  In all
cases the name element of the fiddle-plex is ignored and is hardwired
by feedmail to either \"Date\" or \"Resent-Date\".

If you decide to format your own date field, do us all a favor and know
what you're doing.  Study the relevant parts of RFC-822 and RFC-1123.
Don't make me come up there!

You should let feedmail generate a DATE: for you unless you are sure
that whatever you give your messages to will do it for you (e.g., most
configurations of sendmail).  Even if the latter case is true, it
probably won't hurt you to generate your own, and it will then show up
in the saved message if you use FCC:." :group 'feedmail-headers :type '(choice (const nil) function))

(defcustom feedmail-fiddle-headers-upwardly t "\
*Non-nil means fiddled header fields should be inserted at the top of the header.
Nil means insert them at the bottom.  This is mostly a novelty issue since
the standards define the ordering of header fields to be immaterial and it's
fairly likely that some MTA/MUA along the way will have its own idea of what the
order should be, regardless of what you specify." :group 'feedmail-header :type 'boolean)

(defcustom feedmail-fiddle-plex-user-list nil "\
If non-nil, should be a list of one or more fiddle-plexes.
Each element of the list can also be a function which returns a
fiddle-plex.

feedmail will use this list of fiddle-plexes to manipulate user-specified
message header fields.  It does this after it has completed all normal
message header field manipulation and before calling feedmail-last-chance-hook.

For an explanation of fiddle-plexes, see the documentation for the
variable feedmail-fiddle-plex-blurb.  In contrast to some other fiddle-plex
manipulation functions, in this context, it makes no sense to have an element
which is nil, t, or a simple string." :group 'feedmail-header :type 'list)

(defcustom feedmail-enable-spray nil "\
If non-nil, transmit message separately to each addressee.
feedmail normally accumulates a list of addressees and passes the message
along with that list to a buffer-eating function which expects any number
of addressees.  If this variable is non-nil, however, feedmail will
repeatedly call the same buffer-eating function.  Each time, the list of
addressees will be just one item from the original list.  This only affects
the message envelope addresses and doesn't affect what appears in the
message headers except as noted.

Spray mode is usually pointless, and if you can't think of a good reason for
it, you should avoid it since it is inherently less efficient than normal
multiple delivery.  One reason to use it is to overcome mis-featured mail
transports which betray your trust by revealing BCC: addressees in the
headers of a message.  Another use is to do a crude form of mailmerge, for
which see feedmail-spray-address-fiddle-plex-list.

If one of the calls to the buffer-eating function results in an error,
what happens next is carelessly defined, so beware.  This should get ironed
out in some future release, and there could be other API changes for spraying
as well." :group 'feedmail-spray :type 'boolean)

(defcustom feedmail-spray-address-fiddle-plex-list nil "\
User-supplied specification for a crude form of mailmerge capability.
When spraying is enabled, feedmail composes a list of envelope
addresses.  In turn, feedmail-spray-this-address is temporarily set
to each address (stripped of any comments and angle brackets) and
a function is called which fiddles message headers according to
this variable.  For an overview of fiddle-plex data structures, see
the documentation for feedmail-fiddle-plex-blurb.

May be nil, in which case nothing in particular is done about message
headers for specific addresses.

May be t, in which case a \"TO:\" header is added to the message with
the stripped address as the header contents.  The fiddle-plex operator
is 'supplement.

May be a string, in which case the string is assumed to be the name of
a message header field with the stripped address serving as the value.
The fiddle-plex operator is 'supplement.

May be a function, in which case it is called with no arguments and is
expected to return nil, t, a string, another function, or a fiddle-plex.
The result is used recursively.  The function may alter the value of the
variable feedmail-spray-this-address, perhaps to embellish it with a
human name.  It would be logical in such a case to return as a value a
string naming a message header like \"TO\" or an appropriately constructed
fiddle-plex.  For an example, see feedmail-spray-via-bbdb.

May be a list of any combination of the foregoing and/or
fiddle-plexes.  (A value for this variable which consists of a single
fiddle-plex must be nested inside another list to avoid ambiguity.)
If a list, each item is acted on in turn as described above.

For example,

  (setq feedmail-spray-address-fiddle-plex-list 'feedmail-spray-via-bbdb)

The idea of the example is that, during spray mode, as each message is
about to be transmitted to an individual address, the function will be
called and will consult feedmail-spray-this-address to find the
stripped envelope email address (no comments or angle brackets).  The
function should return an embellished form of the address.

The recipe for sending form letters is: (1) create a message with
all addressees on BCC: headers; (2) tell feedmail to remove BCC:
headers before sending the message; (3) create a function which will
embellish stripped addresses, if desired; (4) define
feedmail-spray-address-fiddle-plex-list appropriately; (5) send the
message with feedmail-enable-spray set non-nil; (6) stand back and
watch co-workers wonder at how efficient you are at accomplishing
inherently inefficient things." :group 'feedmail-spray :type 'list)

(defcustom feedmail-enable-queue nil "\
*If non-nil, provide for stashing outgoing messages in a queue.
This is the master on/off switch for feedmail message queuing.
Queuing is quite handy for laptop-based users.  It's also handy if you
get a lot of mail and process it more or less sequentially.  For
example, you might change your mind about contents of a reply based on
a message you see a bit later.

There is a separate queue for draft messages, intended to prevent
you from accidentally sending incomplete messages.  The queues are
disk-based and intended for later transmission.  The messages are
queued in their raw state as they appear in the mail-mode buffer and
can be arbitrarily edited later, before sending, by visiting the
appropriate file in the queue directory (and setting the buffer to
mail-mode or whatever).  If you visit a file in the queue directory
and try to queue it again, it will just get saved in its existing file
name.  You can move a message from the draft to the main queue or vice
versa by pretending to send it and then selecting whichever queue
directory you want at the prompt.  The right thing will happen.

To transmit all the messages in the queue, invoke the command
feedmail-run-the-queue or feedmail-run-the-queue-no-prompts." :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-queue-runner-confirm-global nil "\
*If non-nil, give a y-or-n confirmation prompt before running the queue.
Prompt even if the queue is about to be processed as a result of a call to
feedmail-run-the-queue-no-prompts.  This gives you a way to bail out
without having to answer no to the individual message prompts." :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-queue-directory (if (memq system-type '(axp-vms vax-vms)) (expand-file-name (concat (getenv "HOME") "[.MAIL.Q]")) (expand-file-name "~/mail/q")) "\
*Name of a directory where messages will be queued.
Directory will be created if necessary.  Should be a string that
doesn't end with a slash.  Default, except on VMS, is \"~/mail/q\"." :group 'feedmail-queue :type 'string)

(defcustom feedmail-queue-draft-directory (if (memq system-type '(axp-vms vax-vms)) (expand-file-name (concat (getenv "HOME") "[.MAIL.DRAFT]")) (expand-file-name "~/mail/draft")) "\
*Name of an directory where DRAFT messages will be queued.
Directory will be created if necessary.  Should be a string that
doesn't end with a slash.  Default, except on VMS, is \"~/mail/draft\"." :group 'feedmail-queue :type 'string)

(defcustom feedmail-ask-before-queue t "\
*If non-nil, feedmail will ask what you want to do with the message.
Default choices for the message action prompt will include sending it
immediately, putting it in the main queue, putting it in the draft
queue, or returning to the buffer to continue editing.  Only matters if
queuing is enabled.  If nil, the message is placed in the main queue
without a prompt." :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-ask-before-queue-prompt "FQM: Message action (q, i, d, e, ?)? [%s]: " "\
*A string which will be used for the message action prompt.
If it contains a \"%s\", that will be replaced with the value of
feedmail-ask-before-queue-default." :group 'feedmail-queue :type 'string)

(defcustom feedmail-ask-before-queue-reprompt "FQM: Please type q, i, d, or e; or ? for help [%s]: " "\
*A string which will be used for repompting after invalid input.
If it contains a \"%s\", that will be replaced with the value of
feedmail-ask-before-queue-default." :group 'feedmail-queue :type 'string)

(defcustom feedmail-ask-before-queue-default "queue" "\
*Meaning if user hits return in response to the message action prompt.
Should be a character or a string; if a string, only the first
character is significant.  Useful values are those described in
the help for the message action prompt." :group 'feedmail-queue :type '(choice string integer))

(defcustom feedmail-prompt-before-queue-user-alist nil "\
See feedmail-prompt-before-queue-standard-alist." :group 'feedmail-queue :type 'alist)

(defcustom feedmail-prompt-before-queue-help-supplement nil "\
User-provided supplementary help string for the message action prompt.
When the message action prompt is shown, the user can as for verbose help,
at which point a buffer pops up describing the meaning of possible
responses to the prompt.  Through various customizations (see, for
example, `feedmail-prompt-before-queue-user-alist'), the available responses
and the prompt itself can be changed.  If this variable is set to a string
value, that string is written to the help buffer after the standard info.
It may contain embedded line breaks.  It will be printed via princ." :group 'feedmail-queue :type 'string)

(defcustom feedmail-queue-reminder-alist '((after-immediate . feedmail-queue-reminder-brief) (after-queue . feedmail-queue-reminder-medium) (after-draft . feedmail-queue-reminder-medium) (after-run . feedmail-queue-reminder-brief) (on-demand . feedmail-run-the-queue-global-prompt)) "\
See `feedmail-queue-reminder'." :group 'feedmail-queue :type 'alist)

(defcustom feedmail-queue-chatty t "\
*If non-nil, blat a few status messages and such in the mini-buffer.
If nil, just do the work and don't pester people about what's going on.
In some cases, though, specific options inspire mini-buffer prompting.
That's not affected by this variable setting.  Also does not control
reporting of error/abnormal conditions." :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-queue-chatty-sit-for 2 "\
*Duration of pause after most queue-related messages.
After some messages are divulged, it is prudent to pause before
something else obliterates them.  This value controls the duration of
the pause." :group 'feedmail-queue :type 'integer)

(defcustom feedmail-queue-run-orderer nil "\
*If non-nil, name a function which will sort the queued messages.
The function is called during a running of the queue for sending, and
takes one argument, a list of the files in the queue directory.  It
may contain the names of non-message files, and it's okay to leave
them in the list when reordering it; they get skipped over later.
When nil, the default action processes the messages in normal sort
order by queued file name, which will typically result in the order
they were placed in the queue." :group 'feedmail-queue :type '(choice (const nil) function))

(defcustom feedmail-queue-use-send-time-for-date nil "\
*If non-nil, use send time for the DATE: header value.
This variable is used by the default date generating function,
feedmail-default-date-generator.  If nil, the default, the
last-modified timestamp of the queue file is used to create the
message DATE: header; if there is no queue file, the current time is
used.  If you are using VM, it might be supplying this header for
you.  To suppress VM's version

	(setq vm-mail-header-insert-date nil)" :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-queue-use-send-time-for-message-id nil "\
*If non-nil, use send time for the MESSAGE-ID: header value.
This variable is used by the default MESSAGE-ID: generating function,
feedmail-default-message-id-generator.  If nil, the default, the
last-modified timestamp of the queue file is used to create the
message MESSAGE-ID: header; if there is no queue file, the current time is
used.  If you are using VM, it might be supplying this header for
you.  To suppress VM's version

	(setq vm-mail-header-insert-message-id nil)" :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-ask-for-queue-slug nil "\
*If non-nil, prompt user for part of the queue file name.
The file will automatically get the FQM suffix and an embedded
sequence number for uniqueness, so don't specify that.  feedmail will
get rid of all characters other than alphanumeric and hyphen in the
results.  If this variable is nil or if you just hit return in
response to the prompt, feedmail queuing will take care of things
properly.  At the prompt, completion is available if you want to see
what filenames are already in use, though, as noted, you will not be
typing a complete file name.  You probably don't want to be bothered
with this prompting since feedmail, by default, uses queue file names
based on the subjects of the messages." :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-queue-slug-maker 'feedmail-queue-subject-slug-maker "\
*If non-nil, a function which creates part of the queued file name.
Takes a single argument giving the name of the directory into
which the message will be queued.  The returned string should be just
the non-directory filename part, without FQM suffix or uniquifying
sequence numbers.  The current buffer holds the raw message.  The
default function creates the slug based on the message subject, if
any." :group 'feedmail-queue :type '(choice (const nil) function))

(defcustom feedmail-queue-slug-suspect-regexp "[^a-z0-9-]+" "\
*Regular expression for characters/substrings to be replaced.
When feedmail creates a filename from a subject string, it puts hyphens
in place of strings which may cause problems in filenames.  By default,
only alphanumeric and hyphen characters are kept, and all others are
converted.  In non-ASCII environments, it may be more helpful to
tweak this regular expression to reflect local or personal language
conventions.  Substitutions are done repeatedly until the regular expression
no longer matches to transformed string.  Used by function
feedmail-tidy-up-slug and indirectly by feedmail-queue-subject-slug-maker." :group 'feedmail-queue :type 'string)

(defcustom feedmail-queue-default-file-slug t "\
*Indicates what to use for subject-less messages when forming a file name.
When feedmail queues a message, it creates a unique file name.  By default,
the file name is based in part on the subject of the message being queued.
If there is no subject, consult this variable.  See documentation for the
function feedmail-queue-subject-slug-maker.

If t, an innocuous default is used.

If a string, it is used directly.

If a function, it is called with no arguments from the buffer containing the raw
text of the message.  It must return a string (which may be empty).

If the symbol 'ask, you will be prompted for a string in the mini-buffer.
Filename completion is available so that you can inspect what's already been
used, but feedmail will do further manipulation on the string you return, so
it's not expected to be a complete filename." :group 'feedmail-queue :type 'string)

(defcustom feedmail-queue-fqm-suffix ".fqm" "\
*The FQM suffix used to distinguish feedmail queued message files.
You probably want this to be a period followed by some letters and/or
digits.  The distinction is to be able to tell them from other random
files that happen to be in the feedmail-queue-directory or
feedmail-queue-draft-directory. By the way, FQM stands for feedmail
queued message." :group 'feedmail-queue :type 'string)

(defcustom feedmail-nuke-buffer-after-queue nil "\
*If non-nil, silently kill the buffer after a message is queued.
You might like that since a side-effect of queueing the message is
that its buffer name gets changed to the filename.  That means that
the buffer won't be reused for the next message you compose.  If you
are using VM for creating messages, you probably want to leave this
nil, since VM has its own options for managing the recycling of
message buffers." :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-queue-auto-file-nuke nil "\
*If non-nil, automatically delete queue files when a message is sent.
Normally, feedmail will notice such files when you send a message in
immediate mode (i.e., not when you're running the queue) and will ask if
you want to delete them.  Since the answer is usually yes, setting this
variable to non-nil will tell feedmail to skip the prompt and just delete
the file without bothering you." :group 'feedmail-queue :type 'boolean)

(defcustom feedmail-debug nil "\
*If non-nil, blat a debug messages and such in the mini-buffer.
This is intended as an aid to tracing what's going on but is probably
of casual real use only to the feedmail developer." :group 'feedmail-debug :type 'boolean)

(defcustom feedmail-debug-sit-for 0 "\
*Duration of pause after feedmail-debug messages.
After some messages are divulged, it may be helpful to pause before
something else obliterates them.  This value controls the duration of
the pause.  If the value is nil or 0, the sit-for is not done, which
has the effect of not pausing at all.  Debug messages can be seen after
the fact in the messages buffer." :group 'feedmail-debug :type 'integer)

(defcustom feedmail-last-chance-hook nil "\
*User's last opportunity to modify the message on its way out.
It has already had all the header prepping from the standard package.
The next step after running the hook will be to push the buffer into a
subprocess that mails the mail.  The hook might be interested in
these: (1) feedmail-prepped-text-buffer contains the header and body
of the message, ready to go; (2) feedmail-address-list contains a list
of simplified recipients of addresses which are to be given to the
subprocess (the hook may change the list); (3) feedmail-error-buffer
is an empty buffer intended to soak up errors for display to the user.
If the hook allows interactive activity, the user should not send more
mail while in the hook since some of the internal buffers will be
reused and things will get confused." :group 'feedmail-misc :type 'hook)

(defcustom feedmail-before-fcc-hook nil "\
*User's last opportunity to modify the message before FCC action.
When this hook runs, the current buffer is already the appropriate
buffer.  It has already had all the header prepping from the standard
package.  The next step after running the hook will be to save the
message via FCC: processing. The hook might be interested in these:
\(1) feedmail-prepped-text-buffer contains the header and body of the
message, ready to go; (2) feedmail-address-list contains a list of
simplified recipients of addressees to whom the message was sent (3)
feedmail-error-buffer is an empty buffer intended to soak up errors
for display to the user.  If the hook allows interactive activity, the
user should not send more mail while in the hook since some of the
internal buffers will be reused and things will get confused.  It's
not necessary to arrange for the undoing of any changes you make to
the buffer." :group 'feedmail-misc :type 'hook)

(defcustom feedmail-queue-express-hook nil "\
*Chance to modify a message being sent directly to a queue.
Run by feedmail-queue-express-to-queue and feedmail-queue-express-to-draft.
For example, you might want to run vm-mime-encode-composition to take
care of attachments.  If you subsequently edit the message buffer, you
can undo the encoding." :group 'feedmail-queue :type 'hook)

(defcustom feedmail-queue-runner-mode-setter (function (lambda (&optional arg) (mail-mode))) "\
*A function to set the proper mode of a message file.  Called when
the message is read back out of the queue directory with a single
argument, the optional argument used in the call to
feedmail-run-the-queue or feedmail-run-the-queue-no-prompts.

Most people want mail-mode, so the default value is an anonymous
function which is just a wrapper to ignore the supplied argument when
calling it, but here's your chance to have something different.
If you are a VM user, you might like feedmail-vm-mail-mode, though you
really don't need that (and it's not particularly well-tested).

Called with funcall, not call-interactively." :group 'feedmail-queue :type 'function)

(defcustom feedmail-queue-alternative-mail-header-separator nil "\
*Alternative header demarcation for queued messages.
If you sometimes get alternative values for mail-header-separator in
queued messages, set the value of this variable to whatever it is.
For example, rmail-resend uses a mail-header-separator value of empty
string (\"\") when you send/queue a message.

When trying to send a queued message, if the value of this variable is
non-nil, feedmail will first try to send the message using the value
of mail-header-separator.  If it can't find that, it will temporarily
set mail-header-separator to the value of
feedmail-queue-alternative-mail-header-separator and try again." :group 'feedmail-queue :type 'string)

(defcustom feedmail-queue-runner-message-sender (function (lambda (&optional arg) (mail-send))) "\
*Function to initiate sending a message file.
Called for each message read back out of the queue directory with a
single argument, the optional argument used in the call to
feedmail-run-the-queue or feedmail-run-the-queue-no-prompts.
Interactively, that argument will be the prefix argument.
Most people want mail-send (bound to C-c C-s in mail-mode), but here's
your chance to have something different.  The default value is just a
wrapper function which discards the optional argument and calls
mail-send.  If you are a VM user, you might like vm-mail-send, though
you really don't need that.  Called with funcall, not call-interactively." :group 'feedmail-queue :type 'function)

(defcustom feedmail-queue-runner-cleaner-upper (function (lambda (fqm-file &optional arg) (delete-file fqm-file) (if arg (feedmail-say-chatter "Nuked %s" fqm-file)))) "\
*Function that will be called after a message has been sent.  It's
not called in the case of errors.  This function is called with two
arguments, the name of the message queue file for the message just
sent, and the optional argument used in the call to
feedmail-run-the-queue or feedmail-run-the-queue-no-prompts.
Interactively, that argument will be the prefix argument.  In any
case, the affiliated buffer is killed elsewhere, so don't do that
inside this function.  Return value is ignored.

The default action is an anonymous function which gets rid of the file
from the queue directory.  With a non-nil second argument, a brief
message is give for each file deleted.  You could replace this
function, for example, to archive all of your sent messages someplace
\(though there are better ways to get that particular result)." :group 'feedmail-queue :type 'function)

(defcustom feedmail-buffer-eating-function 'feedmail-buffer-to-binmail "\
*Function used to send the prepped buffer to a subprocess.
The function's three (mandatory) arguments are: (1) the buffer
containing the prepped message; (2) a buffer where errors should be
directed; and (3) a list containing the addresses individually as
strings.  Popular choices for this are feedmail-buffer-to-binmail,
feedmail-buffer-to-smtpmail, feedmail-buffer-to-sendmail, and
feedmail-buffer-to-smtp.  If you use the sendmail form, you probably
want to set feedmail-nuke-bcc and/or feedmail-nuke-resent-bcc to nil.
If you use the binmail form, check the value of
feedmail-binmail-template." :group 'feedmail-misc :type 'function)

(defcustom feedmail-binmail-template (if mail-interactive "/bin/mail %s" (if (file-exists-p "/bin/rmail") "/bin/rmail %s" "/bin/mail %s")) "\
*Command template for the subprocess which will get rid of the
mail.  It can result in any command understandable by /bin/sh.  Might
not work at all in non-UNIX environments.  The single '%s', if
present, gets replaced by the space-separated, simplified list of
addressees.  Used in feedmail-buffer-to-binmail to form the shell
command which will receive the contents of the prepped buffer as
stdin.  The default value uses /bin/rmail (if it exists) unless
mail-interactive has been set non-nil.

If you'd like your errors to come back as mail instead of immediately
in a buffer, try /bin/rmail instead of /bin/mail.  If /bin/rmail
exists, this can be accomplished by keeping the default nil setting of
mail-interactive.  You might also like to consult local mail experts
for any other interesting command line possibilities.  Some versions
of UNIX have an rmail program which behaves differently than
/bin/rmail and complains if feedmail gives it a message on stdin.  If
you don't know about such things and if there is no local expert to
consult, stick with /bin/mail or use one of the other buffer eating
functions.

The above description applies to \"classic\" UNIX /bin/mail and /bin/rmail.
On most Linux systems and perhaps other places, /bin/mail behaves
completely differently and shouldn't be used at all in this template.
Instead of /bin/rmail, there is a /usr/bin/rmail, and it can be used
with a wrapper.  The wrapper is necessary because /usr/bin/rmail on such
systems requires that the first line of the message appearing on standard
input have a UNIX-style From_ postmark.  If you have such a system, the
wrapping can be accomplished by setting the value of feedmail-binmail-template
to 'feedmail-binmail-linuxish-template'.  You should then send some test
messages to make sure it works as expected." :group 'feedmail-misc :type 'string)

;;;***

;;;### (autoloads (google-query-mirror google-query-result-count google-query-maxlen google) "google-query" "net-utils/google-query.el")
(defconst custom-define-current-source-file "google-query.el")

(defgroup google nil "Why leave XEmacs just to search Google..." :prefix "google-" :group 'hypermedia)

(defcustom google-query-maxlen 1024 "\
Maximum string length of query string.

This prevents you from accidentally sending a five megabyte query
string to Google.

You can set this reasonably high, all the same.  I think the maximum
length that Google can take is 2048 characters." :type 'number :group 'google)

(defcustom google-query-result-count 10 "\
Max number of results to return from a `google-query'." :type 'number :group 'google)

(defcustom google-query-mirror "https://www.google.com" "\
*Your favourite Google mirror." :type 'string :group 'google)

;;;***

;;;### (autoloads (idna-to-unicode-parameters idna-to-ascii-parameters idna-environment idna-program idna) "idna" "net-utils/idna.el")
(defconst custom-define-current-source-file "idna.el")

(defgroup idna nil "Internationalizing Domain Names in Applications.")

(defcustom idna-program "idn" "\
Name of the GNU Libidn \"idn\" application." :type 'string :group 'idna)

(defcustom idna-environment '("CHARSET=UTF-8") "\
List of environment variable definitions prepended to `process-environment'." :type '(repeat string) :group 'idna)

(defcustom idna-to-ascii-parameters '("--quiet" "--idna-to-ascii" "--usestd3asciirules") "\
Parameters passed to `idna-program' to invoke IDNA ToASCII mode." :type '(repeat string) :group 'idna)

(defcustom idna-to-unicode-parameters '("--quiet" "--idna-to-unicode" "--usestd3asciirules") "\
Parameters passed `idna-program' to invoke IDNA ToUnicode mode." :type '(repeat string) :group 'idna)

;;;***

;;;### (autoloads (metamail-switches metamail-mailer-name metamail-program-name metamail) "metamail" "net-utils/metamail.el")
(defconst custom-define-current-source-file "metamail.el")

(defgroup metamail nil "Metamail interface for Emacs." :group 'mail :group 'hypermedia :group 'processes)

(defcustom metamail-program-name "metamail" "\
*Metamail program name." :type 'string :group 'metamail)

(defcustom metamail-mailer-name "emacs" "\
*Mailer name set to MM_MAILER environment variable." :type 'string :group 'metamail)

(defcustom metamail-switches '("-x" "-d" "-z") "\
*Switches for `metamail' program.
`-z' is required to remove zap file.
It is not expected to be altered globally by `set' or `setq'.
Instead, change its value temporary using `let' or `let*' form.
`-m MAILER' argument is automatically generated from the
`metamail-mailer-name' variable." :type '(repeat (string :tag "Switch")) :group 'metamail)

;;;***

;;;### (autoloads (mozmail-default-mua mozmail-gnus-is-plugged mozmail) "mozmail" "net-utils/mozmail.el")
(defconst custom-define-current-source-file "mozmail.el")

(defgroup mozmail nil "Customisations for mozmail." :prefix "mozmail-" :group 'mail)

(defcustom mozmail-gnus-is-plugged t "\
*When non-nil use Gnus in \"plugged\" mode." :type 'boolean :group 'mozmail)

(defcustom mozmail-default-mua gnus "\
*The default (X)Emacs mailer to use.

Valid symbols are: gnus, vm, mhe, mew, wanderlust, rmail, emacs.

CAUTION: If you wish to set this variable outside of the custom
interface, you MUST set it via `customize-set-variable'.

For example:

    (customize-set-variable 'mozmail-default-mua 'gnus)" :type '(choice (const :tag "Gnus" :value gnus) (const :tag "VM" :value vm) (const :tag "MH-E" :value mhe) (const :tag "MEW" :value mew) (const :tag "Wanderlust" :value wanderlust) (const :tag "RMail" :value rmail) (const :tag "Emacs Mail" :value emacs)) :require 'mozmail :initialize (lambda (symbol value) (progn (let ((gnus 'gnus) (vm 'vm) (mhe 'mhe) (mew 'mew) (wanderlust 'wanderlust) (rmail 'rmail) (emacs 'emacs)) (custom-initialize-default symbol value) (defalias 'mozmail-compose (intern (format "mozmail-compose-%s" value))))) (message (format "%s set to %s" symbol value))) :set (lambda (symbol value) (defalias 'mozmail-compose (intern (format "mozmail-compose-%s" value))) (message (format "%s set to %s" symbol value))) :group 'mozmail)

;;;***

;;;### (autoloads (whois-reverse-lookup-server whois-server-name ftp-prompt-regexp ftp-program-options ftp-program nslookup-prompt-regexp nslookup-program-options nslookup-program route-program-options route-program arp-program-options arp-program netstat-program-options netstat-program ipconfig-program-options ipconfig-program ping-program-options ping-program traceroute-program-options traceroute-program net-utils-remove-ctl-m net-utils) "net-utils" "net-utils/net-utils.el")
(defconst custom-define-current-source-file "net-utils.el")

(defgroup net-utils nil "Network utility functions." :prefix "dirtrack-" :group 'shell)

(defcustom net-utils-remove-ctl-m (member system-type (list 'windows-nt 'msdos)) "\
If non-nil, remove control-Ms from output." :group 'net-utils :type 'boolean)

(defcustom traceroute-program (if (eq system-type 'windows-nt) "tracert" "traceroute") "\
Program to trace network hops to a destination." :group 'net-utils :type 'string)

(defcustom traceroute-program-options nil "\
Options for the traceroute program." :group 'net-utils :type '(repeat string))

(defcustom ping-program "ping" "\
Program to send network test packets to a host." :group 'net-utils :type 'string)

(defcustom ping-program-options (and (memq system-type (list 'linux 'gnu/linux 'irix)) (list "-c" "4")) "\
Options for the ping program.
These options can be used to limit how many ICMP packets are emitted." :group 'net-utils :type '(repeat string))

(defcustom ipconfig-program (if (eq system-type 'windows-nt) "ipconfig" "ifconfig") "\
Program to print network configuration information." :group 'net-utils :type 'string)

(defcustom ipconfig-program-options (list (if (eq system-type 'windows-nt) "/all" "-a")) "\
Options for ipconfig-program." :group 'net-utils :type '(repeat string))

(defcustom netstat-program "netstat" "\
Program to print network statistics." :group 'net-utils :type 'string)

(defcustom netstat-program-options nil "\
Options for netstat-program." :group 'net-utils :type '(repeat string))

(defcustom arp-program "arp" "\
Program to print IP to address translation tables." :group 'net-utils :type 'string)

(defcustom arp-program-options (list "-a") "\
Options for arp-program." :group 'net-utils :type '(repeat string))

(defcustom route-program (if (eq system-type 'windows-nt) "route" "netstat") "\
Program to print routing tables." :group 'net-utils :type 'string)

(defcustom route-program-options (if (eq system-type 'windows-nt) (list "print") (list "-r")) "\
Options for route-program." :group 'net-utils :type '(repeat string))

(defcustom nslookup-program "nslookup" "\
Program to interactively query DNS information." :group 'net-utils :type 'string)

(defcustom nslookup-program-options nil "\
List of options to pass to the nslookup program." :group 'net-utils :type '(repeat string))

(defcustom nslookup-prompt-regexp "^> " "\
Regexp to match the nslookup prompt." :group 'net-utils :type 'regexp)

(defcustom ftp-program "ftp" "\
Progam to run to do FTP transfers." :group 'net-utils :type 'string)

(defcustom ftp-program-options nil "\
List of options to pass to the FTP program." :group 'net-utils :type '(repeat string))

(defcustom ftp-prompt-regexp "^ftp>" "\
Regexp which matches the FTP program's prompt." :group 'net-utils :type 'regexp)

(defcustom whois-server-name "whois.internic.net" "\
Host name for the whois service." :group 'net-utils :type 'string)

(defcustom whois-reverse-lookup-server "whois.arin.net" "\
Server which provides inverse DNS mapping." :group 'net-utils :type 'string)

;;;***

;;;### (autoloads (punycode-decode-parameters punycode-encode-parameters punycode-environment punycode-program punycode) "punycode" "net-utils/punycode.el")
(defconst custom-define-current-source-file "punycode.el")

(defgroup punycode nil "Punycode: An ASCII compatible Unicode encoding format.")

(defcustom punycode-program "idn" "\
Name of the GNU Libidn \"idn\" application." :type 'string :group 'punycode)

(defcustom punycode-environment '("CHARSET=UTF-8") "\
List of environment variable definitions prepended to `process-environment'." :type '(repeat string) :group 'punycode)

(defcustom punycode-encode-parameters '("--quiet" "--punycode-encode") "\
Parameters passed to `punycode-program' to invoke punycode encoding mode." :type '(repeat string) :group 'punycode)

(defcustom punycode-decode-parameters '("--quiet" "--punycode-decode") "\
Parameters passed to `punycode-program' to invoke punycode decoding mode." :type '(repeat string) :group 'punycode)

;;;***

;;;### (autoloads (remote-compile-prompt-for-user remote-compile-prompt-for-host remote-compile-run-before remote-compile-user remote-compile-host remote-compile) "rcompile" "net-utils/rcompile.el")
(defconst custom-define-current-source-file "rcompile.el")

(defgroup remote-compile nil "Run a compilation on a remote machine" :group 'processes :group 'tools)

(defcustom remote-compile-host nil "\
*Host for remote compilations." :type '(choice string (const nil)) :group 'remote-compile)

(defcustom remote-compile-user nil "\
User for remote compilations.
nil means use the value returned by \\[user-login-name]." :type '(choice string (const nil)) :group 'remote-compile)

(defcustom remote-compile-run-before nil "\
*Command to run before compilation.
This can be used for setting up environment variables,
since rsh does not invoke the shell as a login shell and files like .login
\(tcsh) and .bash_profile (bash) are not run.
nil means run no commands." :type '(choice string (const nil)) :group 'remote-compile)

(defcustom remote-compile-prompt-for-host nil "\
*Non-nil means prompt for host if not available from filename." :type 'boolean :group 'remote-compile)

(defcustom remote-compile-prompt-for-user nil "\
*Non-nil means prompt for user if not available from filename." :type 'boolean :group 'remote-compile)

;;;***

;;;### (autoloads (shadow-todo-file shadow-info-file shadow-inhibit-overload shadow-inhibit-message shadow-noquery shadowfile) "shadowfile" "net-utils/shadowfile.el")
(defconst custom-define-current-source-file "shadowfile.el")

(defgroup shadowfile nil "Keep identical copies of files in more than one place." :group 'files :prefix "shadow")

(defcustom shadow-noquery nil "\
*If t, always copy shadow files without asking.
If nil (the default), always ask.  If not nil and not t, ask only if there
is no buffer currently visiting the file." :type 'boolean :group 'shadowfile)

(defcustom shadow-inhibit-message nil "\
*If nonnil, do not display a message when a file needs copying." :type 'boolean :group 'shadowfile)

(defcustom shadow-inhibit-overload nil "\
If nonnil, shadowfile won't redefine C-x C-c.
Normally it overloads the function `save-buffers-kill-emacs' to check
for files have been changed and need to be copied to other systems." :type 'boolean :group 'shadowfile)

(defcustom shadow-info-file nil "\
File to keep shadow information in.  
The shadow-info-file should be shadowed to all your accounts to
ensure consistency.  Default: ~/.xemacs/shadows" :type '(choice (const :tag "Default" nil) (file)) :group 'shadowfile)

(defcustom shadow-todo-file nil "\
File to store the list of uncopied shadows in.
This means that if a remote system is down, or for any reason you cannot or
decide not to copy your shadow files at the end of one emacs session, it will
remember and ask you again in your next emacs session.
This file must NOT be shadowed to any other system, it is host-specific.
Default: ~/.xemacs/shadow_todo" :type '(choice (const :tag "Default" nil) (file)) :group 'shadowfile)

;;;***

;;;### (autoloads (webster-www-url-format) "webster-www" "net-utils/webster-www.el")
(defconst custom-define-current-source-file "webster-www.el")

(defcustom webster-www-url-format "http://www.m-w.com/cgi-bin/mweb?book=%s&va=%s" "\
URL format to reference for Webster's dictionaries.
It is used in a call to `format' with a book name
\(\"Dictionary\" or \"Thesaurus\") as its first argument
and a word to look up as its second argument." :type 'string)

;;;***

;;;### (autoloads (report-xemacs-bug-send-init report-xemacs-bug-no-explanations report-xemacs-bug-no-confirmation report-xemacs-bug-beta-extra-headers report-xemacs-bug-beta-address report-xemacs-bug-extra-headers report-xemacs-bug-address xemacsbug) "xemacsbug" "net-utils/xemacsbug.el")
(defconst custom-define-current-source-file "xemacsbug.el")

(defgroup xemacsbug nil "Sending XEmacs bug reports." :group 'maint :group 'mail)

(defcustom report-xemacs-bug-address "XEmacs Beta <xemacs-beta@xemacs.org>" "\
*Address of mailing list for XEmacs bugs." :group 'xemacsbug :type 'string)

(defcustom report-xemacs-bug-extra-headers nil "\
*An alist of mail-header value pairs for XEamcs bugs.

It takes the format (HEADER . VALUE) where both HEADER and VALUE are
strings. See `compose-mail'." :group 'xemacsbug :type '(repeat (cons (string :tag "Header") (string :tag "Value"))))

(defcustom report-xemacs-bug-beta-address "XEmacs Beta <xemacs-beta@xemacs.org>" "\
*Address of mailing list for XEmacs beta bugs." :group 'xemacsbug :type 'string)

(defcustom report-xemacs-bug-beta-extra-headers nil "\
*An alist of mail-header value pairs for XEmacs beta bugs.

It takes the format (HEADER . VALUE) where both HEADER and VALUE are
strings. See `compose-mail'." :group 'xemacsbug :type '(repeat (cons (string :tag "Header") (string :tag "Value"))))

(defcustom report-xemacs-bug-no-confirmation nil "\
*If non-nil, suppress the confirmations asked for the sake of novice users." :group 'xemacsbug :type 'boolean)

(defcustom report-xemacs-bug-no-explanations nil "\
*If non-nil, suppress the explanations given for the sake of novice users." :group 'xemacsbug :type 'boolean)

(defcustom report-xemacs-bug-send-init nil "\
*If non-nil, include the user's init.el file in the bug report." :group 'xemacsbug :type 'boolean)

;;;***

(provide 'net-utils-custom-defines)
