;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'os-utils-custom-defines) (error "Feature os-utils-custom-defines already loaded"))

;;;### (autoloads (archive-zoo-write-file-member archive-zoo-expunge archive-zoo-extract archive-zip-case-fiddle archive-zip-update-case archive-zip-update archive-zip-expunge archive-zip-extract archive-zip-use-pkzip archive-lzh-write-file-member archive-lzh-expunge archive-lzh-extract archive-arc-write-file-member archive-arc-expunge archive-arc-extract archive-extract-hooks archive-remote-regexp archive-tmpdir archive-dos-members archive-zoo archive-zip archive-lzh archive-arc archive) "arc-mode" "os-utils/arc-mode.el")
(defconst custom-define-current-source-file "arc-mode.el")

(defgroup archive nil "Simple editing of archives." :group 'data)

(defgroup archive-arc nil "ARC-specific options to archive." :group 'archive)

(defgroup archive-lzh nil "LZH-specific options to archive." :group 'archive)

(defgroup archive-zip nil "ZIP-specific options to archive." :group 'archive)

(defgroup archive-zoo nil "ZOO-specific options to archive." :group 'archive)

(defcustom archive-dos-members t "\
*If non-nil then recognize member files using ^M^J as line terminator." :type 'boolean :group 'archive)

(defcustom archive-tmpdir (expand-file-name (make-temp-name (if (eq system-type 'ms-dos) "ar" "archive.tmp")) (or (getenv "TMPDIR") (getenv "TMP") "/tmp")) "\
*Directory for temporary files made by arc-mode.el" :type 'directory :group 'archive)

(defcustom archive-remote-regexp "^/[^/:]*[^/:.]:" "\
*Regexp recognizing archive files names that are not local.
A non-local file is one whose file name is not proper outside Emacs.
A local copy of the archive will be used when updating." :type 'regexp :group 'archive)

(defcustom archive-extract-hooks nil "\
*Hooks to run when an archive member has been extracted." :type 'hook :group 'archive)

(defcustom archive-arc-extract '("arc" "x") "\
*Program and its options to run in order to extract an arc file member.
Extraction should happen to the current directory.  Archive and member
name will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-arc)

(defcustom archive-arc-expunge '("arc" "d") "\
*Program and its options to run in order to delete arc file members.
Archive and member names will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-arc)

(defcustom archive-arc-write-file-member '("arc" "u") "\
*Program and its options to run in order to update an arc file member.
Archive and member name will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-arc)

(defcustom archive-lzh-extract '("lha" "pq") "\
*Program and its options to run in order to extract an lzh file member.
Extraction should happen to standard output.  Archive and member name will
be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-lzh)

(defcustom archive-lzh-expunge '("lha" "d") "\
*Program and its options to run in order to delete lzh file members.
Archive and member names will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-lzh)

(defcustom archive-lzh-write-file-member '("lha" "a") "\
*Program and its options to run in order to update an lzh file member.
Archive and member name will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-lzh)

(defcustom archive-zip-use-pkzip (memq system-type '(ms-dos windows-nt)) "\
*If non-nil then pkzip option are used instead of zip options.
Only set to true for msdog systems!" :type 'boolean :group 'archive-zip)

(defcustom archive-zip-extract (if archive-zip-use-pkzip '("pkunzip" "-e") '("unzip" "-qq" "-c")) "\
*Program and its options to run in order to extract a zip file member.
Extraction should happen to standard output.  Archive and member name will
be added.  If `archive-zip-use-pkzip' is non-nil then this program is
expected to extract to a file junking the directory part of the name." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-zip)

(defcustom archive-zip-expunge (if archive-zip-use-pkzip '("pkzip" "-d") '("zip" "-d" "-q")) "\
*Program and its options to run in order to delete zip file members.
Archive and member names will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-zip)

(defcustom archive-zip-update (if archive-zip-use-pkzip '("pkzip" "-u") '("zip" "-q")) "\
*Program and its options to run in order to update a zip file member.
Options should ensure that specified directory will be put into the zip
file.  Archive and member name will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-zip)

(defcustom archive-zip-update-case (if archive-zip-use-pkzip archive-zip-update '("zip" "-q" "-k")) "\
*Program and its options to run in order to update a case fiddled zip member.
Options should ensure that specified directory will be put into the zip file.
Archive and member name will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-zip)

(defcustom archive-zip-case-fiddle t "\
*If non-nil then zip file members are case fiddled.
Case fiddling will only happen for members created by a system that
uses caseless file names." :type 'boolean :group 'archive-zip)

(defcustom archive-zoo-extract '("zoo" "xpq") "\
*Program and its options to run in order to extract a zoo file member.
Extraction should happen to standard output.  Archive and member name will
be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-zoo)

(defcustom archive-zoo-expunge '("zoo" "DqPP") "\
*Program and its options to run in order to delete zoo file members.
Archive and member names will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-zoo)

(defcustom archive-zoo-write-file-member '("zoo" "a") "\
*Program and its options to run in order to update a zoo file member.
Archive and member name will be added." :type '(list (string :tag "Program") (repeat :tag "Options" :inline t (string :format "%v"))) :group 'archive-zoo)

;;;***

;;;### (autoloads (background-get-job-name background-select background-show background) "background" "os-utils/background.el")
(defconst custom-define-current-source-file "background.el")

(defgroup background nil "Fun with background jobs" :group 'processes)

(defcustom background-show t "\
*If non-nil, background jobs' buffers are shown when they're started." :type 'boolean :group 'background)

(defcustom background-select nil "\
*If non-nil, background jobs' buffers are selected when they're started." :type 'boolean :group 'background)

(defcustom background-get-job-name 'background-get-job-name-simple "\
Function to use to generate the job name (and therefore the buffer name
of processes run in the background." :type '(choice (function-item :tag "Simple Numbered" :value background-get-job-name-simple) (function-item :tag "Command based" :value background-get-job-name-command) (function-item :tag "Command and Directory based" :value background-get-job-name-command-n-dir)) :group 'background)

;;;***

;;;### (autoloads (crypt-auto-decode-insert crypt-bind-insert-file crypt-forget-passwd-timeout crypt-dos-has-ctrl-z crypt-default-encoding crypt-ignored-filenames crypt-compact-vs-C++ crypt-freeze-vs-fortran crypt-no-extension-implies-plain crypt-query-if-interactive crypt-auto-write-buffer crypt-auto-decode-buffer crypt-encrypted-disable-auto-save crypt-encoded-disable-auto-save crypt-confirm-password crypt-auto-write-buffer-encrypted crypt-never-ever-decrypt crypt-encryption-file-extension crypt-encryption-type) "crypt" "os-utils/crypt.el")
(defconst custom-define-current-source-file "crypt.el")

(defcustom crypt-encryption-type 'crypt "\
*Method of encryption.  Must be an element of `crypt-encryption-alist.'
If you change this after crypt++ is loaded then do \\[crypt-rebuild-tables]." :type 'symbol :group 'crypt)

(defcustom crypt-encryption-file-extension nil "\
*Regexp for extension of files encrypted with `crypt-encryption-type.'
Should be of the form \"\\\\(\\\\.foo\\\\)$\".  nil says use default values in
`crypt-encryption-alist.'  If you change this after crypt++ is loaded then do
\\[crypt-rebuild-tables]." :type 'regexp :group 'crypt)

(defcustom crypt-never-ever-decrypt nil "\
*t says never attempt to decrypt a buffer." :type 'boolean :group 'crypt)

(defcustom crypt-auto-write-buffer-encrypted nil "\
*t says files with `crypt-encryption-alist' file extension auto-encrypted.
nil says query.  See `crypt-auto-write-buffer.'" :type 'boolean :group 'crypt)

(defcustom crypt-confirm-password nil "\
*t says confirm new passwords when writing a newly encrypted buffer." :type 'boolean :group 'crypt)

(defcustom crypt-encoded-disable-auto-save t "\
*If t, turn off auto-save-mode for buffers which are encoded.
If non-nil but not t, then no message is displayed.

The default is t is because there isn't any way to tell emacs to encode the
autosave file, so the autosave would be in a different format from the
original.  The disadvantage of turning off autosaves is that any work you
do in that buffer will be completely lost if the changes are not explicitly
saved.

It is probably best to set this variable to nil and use buffer-local
variables in files for which you don't actually care about autosaves.
Unencoded recovery data is better than none at all." :type '(choice (const :tag "on" t) (const :tag "off" nil) (const :tag "no message" other)) :group 'crypt)

(defcustom crypt-encrypted-disable-auto-save t "\
*If t, turn off auto-save-mode for buffers which are encrypted.
If non-nil but not t, then no message is displayed.

The default is t is because there isn't any way to tell emacs to encrypt
the autosave file, so the autosave would be in cleartext form.  The
disadvantage of turning off autosaves is that any work you do in that
buffer will be completely lost if the changes are not explicitly saved.

You might consider setting this variable to nil and use buffer-local
variables in files for which security is more important than data
recovery." :type '(choice (const :tag "on" t) (const :tag "off" nil) (const :tag "no message" other)) :group 'crypt)

(defcustom crypt-auto-decode-buffer t "\
*t says buffers visiting encoded files will be decoded automatically.
nil means to ask before doing the decoding." :type 'boolean :group 'crypt)

(defcustom crypt-auto-write-buffer nil "\
*t says save files with `crypt-encoding-alist' file extensions as encoded.
nil says to ask before doing this encoding.  Similarly, buffers originating
from encoded files to be written to files not ending in `crypt-encoding-alist'
file extensions will be written in plain format automatically.  nil says to
ask before doing this decoding." :type 'boolean :group 'crypt)

(defcustom crypt-query-if-interactive t "\
*t says ask when saving buffers where `crypt-encoded-mode' was toggled.
nil says that even if filename extension is plain (i.e., not listed in
`crypt-encoding-alist') buffer will be written in an encoded format without
asking.

This variable is designed for users that edit a plain file (with plain
extension) and then toggle `(crypt-encoded-mode)' and do not wish to be
queried every time that they save the buffer.

NOTE: if `(crypt-encoded-mode)' was not called interactively (the usual
scenario) then the value of this variable has no effect on how the buffer is
written to disk.  In such a case `crypt-no-extension-implies-plain' is then
the relevant variable." :type 'boolean :group 'crypt)

(defcustom crypt-no-extension-implies-plain t "\
*t says file extensions not in `crypt-encoding-alist' may be written plain.
if `crypt-auto-write-buffer' is also t then any file ending in a plain
extension is written in plain format automatically, otherwise query user.

nil says user works with encoded (compressed) files without file extensions
and will not be queried each time they save these files.

NOTE: (1) this does not affect find-file (C-x C-f) since that works with a
magic regexp.  (2) there is no way to distinguish between write-file and
save-buffer so nil will mean that neither will query." :type 'boolean :group 'crypt)

(defcustom crypt-freeze-vs-fortran t "\
*t says `.F' file extension denotes a frozen file not a Fortran file.
If you change this variable after crypt++ has been loaded then do
\\[crypt-rebuild-tables]." :type 'boolean :group 'crypt)

(defcustom crypt-compact-vs-C++ nil "\
*t says `.C' file extension denotes a compacted file not a C++ file.
If you change this variable after crypt++ has been loaded then do
\\[crypt-rebuild-tables]." :type 'boolean :group 'crypt)

(defcustom crypt-ignored-filenames nil "\
*List of regexp filenames for which encoded to plain conversion is not done.
A filename with a plain extension, in encoded format, that is matched by one of
these elements will be saved in encoded format without a query for conversion to
plain format.

This variable is provided for users that want to compress their incoming mail
for RMAIL and VM which look for files `RMAIL' and `INBOX,' respectively, to
store incoming mail.  For example, the gzip extensions on `RMAIL.gz' and
`INBOX.gz' can be removed, this variable set to '(\"INBOX$\" \"RMAIL$\") and
no query about conversion to plain format will be made." :type '(repeat regexp) :group 'crypt)

(defcustom crypt-default-encoding "gzip" "\
*Default encoding type as string used when `crypt-encoded-mode' is toggled.
Must match one of the elements of `crypt-encoding-alist'." :type 'string :group 'crypt)

(defcustom crypt-dos-has-ctrl-z nil "\
t if this buffer had a ctrl-z stripped from end, otherwise, nil.
Buffer local and set by `crypt-dos-to-unix-region'" :type 'boolean :group 'crypt)

(defcustom crypt-forget-passwd-timeout (* 60 60) "\
*Do not retain passwords for encrypted buffers more than this many seconds.
If nil, keep them indefinitely." :type '(choice integer (const :tag "indefinite" nil)) :group 'crypt)

(defcustom crypt-bind-insert-file t "\
*t value means bind `crypt-insert-file' over `insert-file'.
If you wish to change this variable after crypt++ has been loaded then do
\\[crypt-bind-insert-file]." :type 'boolean :group 'crypt)

(defcustom crypt-auto-decode-insert nil "\
*t says decode/decrypt files that are inserted with `crypt-insert-file'.
nil says to ask before doing this." :type 'boolean :group 'crypt)

;;;***

;;;### (autoloads (jka-compr-temp-name-template jka-compr-compression-info-list jka-compr-shell jka-compr compression) "jka-compr" "os-utils/jka-compr.el")
(defconst custom-define-current-source-file "jka-compr.el")

(defgroup compression nil "Data compression utilities" :group 'data)

(defgroup jka-compr nil "jka-compr customization" :group 'compression)

(defcustom jka-compr-shell "sh" "\
*Shell to be used for calling compression programs.
The value of this variable only matters if you want to discard the
stderr of a compression/decompression program (see the documentation
for `jka-compr-compression-info-list')." :type 'string :group 'jka-compr)

(defcustom jka-compr-compression-info-list '(["\\.Z\\(~\\|\\.~[0-9]+~\\)?\\'" "compressing" "compress" ("-c") "uncompressing" "uncompress" ("-c") nil t] ["\\.bz2\\(~\\|\\.~[0-9]+~\\)?\\'" "bzip2ing" "bzip2" nil "unbzip2ing" "bzip2" ("-d") nil t] ["\\.tgz\\'" "zipping" "gzip" ("-c" "-q") "unzipping" "gzip" ("-c" "-q" "-d") t nil] ["\\.gz\\(~\\|\\.~[0-9]+~\\)?\\'" "zipping" "gzip" ("-c" "-q") "unzipping" "gzip" ("-c" "-q" "-d") t t]) "\
List of vectors that describe available compression techniques.
Each element, which describes a compression technique, is a vector of
the form [REGEXP COMPRESS-MSG COMPRESS-PROGRAM COMPRESS-ARGS
UNCOMPRESS-MSG UNCOMPRESS-PROGRAM UNCOMPRESS-ARGS
APPEND-FLAG EXTENSION], where:

   regexp                is a regexp that matches filenames that are
                         compressed with this format

   compress-msg          is the message to issue to the user when doing this
                         type of compression (nil means no message)

   compress-program      is a program that performs this compression

   compress-args         is a list of args to pass to the compress program

   uncompress-msg        is the message to issue to the user when doing this
                         type of uncompression (nil means no message)

   uncompress-program    is a program that performs this compression

   uncompress-args       is a list of args to pass to the uncompress program

   append-flag           is non-nil if this compression technique can be
                         appended

   auto-mode flag        non-nil means strip the regexp from file names
                         before attempting to set the mode.

Because of the way `call-process' is defined, discarding the stderr output of
a program adds the overhead of starting a shell each time the program is
invoked." :type '(repeat (vector :tag "Compression Technique" regexp (choice :tag "Compress Message" (string :format "%v") (const :tag "No Message" nil)) (string :tag "Compress Program") (repeat :tag "Compress Arguments" string) (choice :tag "Uncompress Message" (string :format "%v") (const :tag "No Message" nil)) (string :tag "Uncompress Program") (repeat :tag "Uncompress Arguments" string) (boolean :tag "Append") (boolean :tag "Auto Mode"))) :group 'jka-compr)

(defcustom jka-compr-temp-name-template (expand-file-name "jka-com" (temp-directory)) "\
Prefix added to all temp files created by jka-compr.
There should be no more than seven characters after the final `/'." :type 'string :group 'jka-compr)

;;;***

;;;### (autoloads (mchat-nsl-method mchat-window-percent mchat-loaded-hooks mchat-message-buffer-major-mode mchat-treat-message-hooks mchat-before-send-hooks mchat-minor-mode-hooks mchat-minor-mode-string mchat-major-mode-hooks mchat-major-mode-string mchat-flash-on-message mchat-ring-sound mchat-circulate-messages mchat-message-cache-size mchat-registered-groups mchat-user-tag mchat) "mchat" "os-utils/mchat.el")
(defconst custom-define-current-source-file "mchat.el")

(defgroup mchat nil "Multicast Chatting package.")

(defcustom mchat-user-tag (user-full-name) "\
*The tag to use to identify your messages." :group 'mchat :type 'string)

(defcustom mchat-registered-groups nil "\
*Alist of registered mchat groups. Each element looks like
\(NAME ADDRESS) where NAME is a string used to identify the group, and
ADDRESS is the multicast address. NAME must be unique. Please refer to
`open-multicast-group' for the syntax of ADDRESS." :group 'mchat :type '(repeat (group (string :tag "   Name") (string :tag "Address"))))

(defcustom mchat-message-cache-size 32 "\
*Number of sent messages to remember for each MChat group." :group 'mchat :type 'integer)

(defcustom mchat-circulate-messages nil "\
*If non nil, consider the message caches as circular lists, allowing
to jump directly from one end to the other." :group 'mchat :type 'boolean)

(defcustom mchat-ring-sound t "\
*Sound to use when somebody rings an MChat group (see `sound-alist').
Otherwise, t means just beep and nil means don't ever produce any sound." :group 'mchat :type 'symbol)

(defcustom mchat-flash-on-message 'needed "\
*When you receive a message in an MChat group, the selected frame can
be flashed according to the value of this variable:
- if t, always flash when a message arrives. As a special exception, this
  doesn't flash when you are in one of the two MChat buffers corresponding
  to this group.
- if 'needed, flash only when the MChat buffer is not visible,
- if nil, never flash.

NOTE: currently, it's not always possible to figure out exactly whether
the MChat buffer is visible (for instance if its frame is mapped, but
obscured by some other window)." :group 'mchat :type '(choice (const :tag "always" t) (const :tag "needed" needed) (const :tag "never" nil)))

(defcustom mchat-major-mode-string "MChat" "\
*String to use in the modeline when the MChat major mode is active." :group 'mchat :type 'string)

(defcustom mchat-major-mode-hooks nil "\
*Hooks to run after setting up the MChat major mode." :group 'mchat :type 'hook)

(defcustom mchat-minor-mode-string " mchat" "\
*String to use in the modeline when the MChat minor mode is active." :group 'mchat :type 'string)

(defcustom mchat-minor-mode-hooks nil "\
*Hooks to run after setting up the MChat minor mode." :group 'mchat :type 'hook)

(defcustom mchat-before-send-hooks nil "\
*Hooks to run before sending a message. The hooks are executed in the
MChat message buffer." :group 'mchat :type 'hook)

(defcustom mchat-treat-message-hooks nil "\
*Hooks to run after a message is received. The hooks will be called with
two arguments, the beginning and end position of the message in the MChat
group buffer. The group buffer will be current when the hooks are executed." :group 'mchat :type 'hook)

(defcustom mchat-message-buffer-major-mode 'text "\
*Major mode to use for MChat message buffers (less the -mode suffix)." :group 'mchat :type 'symbol)

(defcustom mchat-loaded-hooks nil "\
*Hooks run when mchat is loaded." :group 'mchat :type 'hook)

(defcustom mchat-window-percent 75 "\
*Percentage of frame occupied by the Group buffer. The rest will go to the
message buffer." :group 'mchat :type 'integer)

(defcustom mchat-nsl-method '("nsl" (system-name) "\\([0-9]+\\)\\.\\([0-9]+\\)\\.\\([0-9]+\\)\\.\\([0-9]+\\)" 1) "\
*Method to use in order to retrieve one IP address from your machine. It
looks like (PROGRAM ARGS REGEXP START) where:
- PROGRAM is the program to be called (a string)
- ARGS is a lisp expression returning a string of arguments you might want to
  pass to PROGRAM,
- REGEXP is the regexp to find the IP address in the output of PROGRAM,
- START is the indice of the sub-match returning the first component of the
  address." :group 'mchat :type '(list (string :tag "    Program") (sexp :tag "  Arguments") (string :tag "     Regexp") (integer :tag "First match")))

;;;***

;;;### (autoloads (rlogin-remote-user rlogin-host rlogin-directory-tracking-mode rlogin-process-connection-type rlogin-mode-hook rlogin-explicit-args rlogin-program rlogin) "rlogin" "os-utils/rlogin.el")
(defconst custom-define-current-source-file "rlogin.el")

(defgroup rlogin nil "Remote login interface" :group 'processes :group 'unix)

(defcustom rlogin-program "rlogin" "\
*Name of program to invoke rlogin" :type 'string :group 'rlogin)

(defcustom rlogin-explicit-args nil "\
*List of arguments to pass to rlogin on the command line." :type '(repeat (string :tag "Argument")) :group 'rlogin)

(defcustom rlogin-mode-hook nil "\
*Hooks to run after setting current buffer to rlogin-mode." :type 'hook :group 'rlogin)

(defcustom rlogin-process-connection-type (save-match-data (cond ((and (boundp 'system-configuration) (stringp system-configuration) (string-match "-solaris2" system-configuration)) t) (t nil))) "\
*If non-`nil', use a pty for the local rlogin process.
If `nil', use a pipe (if pipes are supported on the local system).

Generally it is better not to waste ptys on systems which have a static
number of them.  On the other hand, some implementations of `rlogin' assume
a pty is being used, and errors will result from using a pipe instead." :type '(choice (const :tag "pipes" nil) (other :tag "ptys" t)) :group 'rlogin)

(defcustom rlogin-directory-tracking-mode 'local "\
*Control whether and how to do directory tracking in an rlogin buffer.

nil means don't do directory tracking.

t means do so using an ftp remote file name.

Any other value means do directory tracking using local file names.
This works only if the remote machine and the local one
share the same directories (through NFS).  This is the default.

This variable becomes local to a buffer when set in any fashion for it.

It is better to use the function of the same name to change the behavior of
directory tracking in an rlogin session once it has begun, rather than
simply setting this variable, since the function does the necessary
re-synching of directories." :type '(choice (const :tag "off" nil) (const :tag "ftp" t) (other :tag "local" local)) :group 'rlogin)

(defcustom rlogin-host nil "\
*The name of the remote host.  This variable is buffer-local." :type '(choice (const nil) string) :group 'rlogin)

(defcustom rlogin-remote-user nil "\
*The username used on the remote host.
This variable is buffer-local and defaults to your local user name.
If rlogin is invoked with the `-l' option to specify the remote username,
this variable is set from that." :type '(choice (const nil) string) :group 'rlogin)

;;;***

;;;### (autoloads (ssh-remote-user ssh-host ssh-directory-tracking-mode ssh-process-connection-type ssh-mode-hook ssh-explicit-args ssh-program ssh) "ssh" "os-utils/ssh.el")
(defconst custom-define-current-source-file "ssh.el")

(defgroup ssh nil "Secure remote login interface" :group 'processes :group 'unix)

(defcustom ssh-program "ssh" "\
*Name of program to invoke ssh" :type 'string :group 'ssh)

(defcustom ssh-explicit-args 'nil "\
*List of arguments to pass to ssh on the command line." :type '(repeat (string :tag "Argument")) :group 'ssh)

(defcustom ssh-mode-hook nil "\
*Hooks to run after setting current buffer to ssh-mode." :type 'hook :group 'ssh)

(defcustom ssh-process-connection-type t "\
*If non-`nil', use a pty for the local ssh process.
If `nil', use a pipe (if pipes are supported on the local system).

Generally it is better not to waste ptys on systems which have a static
number of them.  However, ssh won't allocate a pty on the remote host
unless one is used locally as well." :type '(choice (const :tag "ptys" t) (const :tag "pipes" nil)) :group 'ssh)

(defcustom ssh-directory-tracking-mode 'local "\
*Control whether and how to do directory tracking in an ssh buffer.

nil means don't do directory tracking.

t means do so using an ftp remote file name.

Any other value means do directory tracking using local file names.
This works only if the remote machine and the local one
share the same directories (through NFS).  This is the default.

This variable becomes local to a buffer when set in any fashion for it.

It is better to use the function of the same name to change the behavior of
directory tracking in an ssh session once it has begun, rather than
simply setting this variable, since the function does the necessary
re-synching of directories." :type '(choice (const :tag "off" nil) (const :tag "ftp" t) (const :tag "local" local)) :group 'ssh)

(defcustom ssh-host nil "\
*The name of the remote host.  This variable is buffer-local." :type '(choice (const nil) string) :group 'ssh)

(defcustom ssh-remote-user nil "\
*The username used on the remote host.
This variable is buffer-local and defaults to your local user name.
If ssh is invoked with the `-l' option to specify the remote username,
this variable is set from that." :type '(choice (const nil) string) :group 'ssh)

;;;***

;;;### (autoloads (tar-update-datestamp tar-anal-blocksize tar) "tar-mode" "os-utils/tar-mode.el")
(defconst custom-define-current-source-file "tar-mode.el")

(defgroup tar nil "Simple editing of tar files from GNU emacs." :group 'unix :group 'data)

(defcustom tar-anal-blocksize 20 "\
*The blocksize of tar files written by Emacs, or nil, meaning don't care.
The blocksize of a tar file is not really the size of the blocks; rather, it is
the number of blocks written with one system call.  When tarring to a tape, 
this is the size of the *tape* blocks, but when writing to a file, it doesn't
matter much.  The only noticeable difference is that if a tar file does not
have a blocksize of 20, the tar program will issue a warning; all this really
controls is how many null padding bytes go on the end of the tar file." :type 'integer :group 'tar)

(defcustom tar-update-datestamp t "\
*Whether tar-mode should play fast and loose with sub-file datestamps;
if this is true, then editing and saving a tar file entry back into its
tar file will update its datestamp.  If false, the datestamp is unchanged.
You may or may not want this - it is good in that you can tell when a file
in a tar archive has been changed, but it is bad for the same reason that
editing a file in the tar archive at all is bad - the changed version of 
the file never exists on disk.

This does not work in Emacs 18, because there's no way to get the current 
time as an integer - if this var is true, then editing a file sets its date
to midnight, Jan 1 1970 GMT, which happens to be what 0 encodes." :type 'boolean :group 'tar)

;;;***

;;;### (autoloads (rsh-eat-password-string telnet-program telnet) "telnet" "os-utils/telnet.el")
(defconst custom-define-current-source-file "telnet.el")

(defgroup telnet nil "Run a telnet session from within an Emacs buffer." :group 'comint)

(defcustom telnet-program "telnet" "\
*Program to run to open a telnet connection." :type 'string :group 'telnet)

(defcustom rsh-eat-password-string nil "\
Non-nil means rsh will look for a string matching a password prompt." :type 'boolean :group 'telnet)

;;;***

(provide 'os-utils-custom-defines)
