;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'pc-autoloads) (error "Feature pc-autoloads already loaded"))

(package-provide 'pc :version 1.3 :author-version "No-Upstream-Ver" :type 'single-file)

;;;### (autoloads (fusion-set-mode fusion-mode) "fusion" "pc/fusion.el")

(autoload 'fusion-mode "fusion" "\
Toggle fusion mode on and off.
See also `fusion-set-mode'

arguments: ()
" t nil)

(autoload 'fusion-set-mode "fusion" "\
Turn fusion mode off when ON is nil, on otherwise
See also `fusion-mode'

arguments: (&optional ON)
" nil nil)

;;;***

;;;### (autoloads (pending-delete-mode turn-off-pending-delete turn-on-pending-delete pending-delete-mode) "pending-del" "pc/pending-del.el")

(defvar pending-delete-mode nil "\
Non-nil when Pending Delete mode is enabled. In Pending Delete mode, typed
text replaces the selected region. Normally, you shouldn't modify this
variable by hand, but use the function `pending-delete-mode' instead. However, 
you can customize the default value from the options menu (auto delete
selection).")

(custom-add-to-group 'keyboard 'pending-delete-mode 'custom-variable)

(custom-add-load 'pending-delete-mode 'pending-del)

(autoload 'turn-on-pending-delete "pending-del" "\
Turn on pending delete minor mode unconditionally.

arguments: (&optional IGNORED)
" t nil)

(autoload 'turn-off-pending-delete "pending-del" "\
Turn off pending delete minor mode unconditionally.

arguments: (&optional IGNORED)
" t nil)

(autoload 'pending-delete-mode "pending-del" "\
Toggle Pending Delete minor mode.
When the pending delete is on, typed text replaces the selection.
With a positive argument, turns it on.
With a non-positive argument, turns it off.

arguments: (&optional ARG)
" t nil)

(define-obsolete-function-alias 'pending-delete-on 'turn-on-pending-delete)

(define-obsolete-function-alias 'pending-delete-off 'turn-off-pending-delete)

(define-compatible-function-alias 'delete-selection-mode 'pending-delete-mode)

(defalias 'pending-delete 'pending-delete-mode)

;;;***

;;;### (autoloads (s-region-bind-cua s-region-bind) "s-region" "pc/s-region.el")

(autoload 's-region-bind "s-region" "\
Bind shifted keys from KEYLIST to region marking commands.
Each key in KEYLIST is rebound to deactivate region if the last command
was one of shift marking commands.  Keys with added shift modifier are
bound to start or continue marking a region.  Optional argument KEYLIST
defaults to `s-region-key-list'.  Optional argument MAP specifies keymap
to add binding to, defaulting to global keymap.

arguments: (&optional KEYLIST MAP)
" t nil)

(autoload 's-region-bind-cua "s-region" "\
Bind some of CUA keys in keymap MAP to kill and yank commands.
Optional argument MAP defaults to `global-map'.
New bindings:
  Sh-delete    kill-region
  Sh-insert    yank
  C-insert     copy-region-as-kill
  C-delete     kill-line
  C-backspace  backward-kill-word

arguments: (&optional MAP)
" t nil)

;;;***

(provide 'pc-autoloads)
