;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'pcl-cvs-custom-defines) (error "Feature pcl-cvs-custom-defines already loaded"))

;;;### (autoloads (cvs-edit-done-hook cvs-edit-mode-hook cvs-edit-hook cvs-edit-setup-invert cvs-edit-require-final-newline cvs-edit-keep-buffer cvs-edit-confirm cvs-edit) "cvs-edit" "pcl-cvs/cvs-edit.el")
(defconst custom-define-current-source-file "cvs-edit.el")

(defgroup cvs-edit nil "Major mode for editing commit messages for PCL-CVS." :group 'pcl-cvs :prefix "cvs-edit-")

(defcustom cvs-edit-confirm t "\
*If non-nil, `cvs-edit-done' will request confirmation.
If 'changed, only request confirmation if the list of files has
  changed since the beginning of the cvs-edit session." :group 'cvs-edit :type '(choice (const changed) (const t) (const nil)))

(defcustom cvs-edit-keep-buffer nil "\
*If non-nil, don't hide the buffer after `cvs-edit-done'." :group 'cvs-edit :type 'boolean)

(defcustom cvs-edit-require-final-newline cvs-commit-buffer-require-final-newline "\
*Enforce a newline at the end of commit log messages.
Enforce it silently if t, query if non-nil and don't do anything if nil." :group 'cvs-edit :type '(choice (const ask) (const t) (const nil)))

(defcustom cvs-edit-setup-invert nil "\
*Non-nil means `cvs-edit' should invert the meaning of its SETUP arg.
If SETUP is 'force, this variable has no effect." :group 'cvs-edit :type 'boolean)

(defcustom cvs-edit-hook '(cvs-edit-insert-cvs-template cvs-edit-insert-changelog) "\
*Hook run at the end of `cvs-edit'." :group 'cvs-edit :type '(hook :options (cvs-edit-insert-cvs-template cvs-edit-insert-changelog)))

(defcustom cvs-edit-mode-hook nil "\
*Hook run when entering `cvs-edit-mode'." :group 'cvs-edit :type 'hook)

(defcustom cvs-edit-done-hook nil "\
*Hook run before doing the actual commit.
This hook can be used to cleanup the message, enforce various
conventions, or to allow recording the message in some other database,
such as a bug-tracking system.  The list of files about to be committed
can be obtained from `cvs-edit-files'." :group 'cvs-edit :type '(hook :options (cvs-edit-delete-common-indentation cvs-edit-add-to-changelog)))

;;;***

;;;### (autoloads (cvs-log) "cvs-log" "pcl-cvs/cvs-log.el")
(defconst custom-define-current-source-file "cvs-log.el")

(defgroup cvs-log nil "Major mode for browsing log output for PCL-CVS." :group 'pcl-cvs :prefix "cvs-log-")

;;;***

;;;### (autoloads (cvs-status) "cvs-status" "pcl-cvs/cvs-status.el")
(defconst custom-define-current-source-file "cvs-status.el")

(defgroup cvs-status nil "Major mode for browsing `cvs status' output." :group 'pcl-cvs :prefix "cvs-status-")

;;;***

;;;### (autoloads (cvs-minor-mode-prefix cvs-reuse-cvs-buffer cvs-idiff-imerge-handlers cvs-buffer-name-alist cvs-find-file-and-jump cvs-add-default-message cvs-confirm-removals cvs-invert-ignore-marks cvs-default-ignore-marks cvs-force-dir-tag cvs-sort-ignore-file cvs-auto-revert cvs-auto-remove-directories cvs-auto-remove-handled cvs-cvsrc-file pcl-cvs) "pcl-cvs-defs" "pcl-cvs/pcl-cvs-defs.el")
(defconst custom-define-current-source-file "pcl-cvs-defs.el")

(defgroup pcl-cvs nil "Special support for the CVS versioning system." :group 'tools :prefix "cvs-")

(defcustom cvs-cvsrc-file "~/.cvsrc" "\
Path to your cvsrc file." :group 'pcl-cvs :type '(file))

(defcustom cvs-auto-remove-handled nil "\
*If up-to-date files should be acknowledged automatically.
If T, they will be removed from the *cvs* buffer after every command.
If DELAYED, they will be removed from the *cvs* buffer before every command.
If STATUS, they will only be removed after a `cvs-mode-status' command.
Else, they will never be automatically removed from the *cvs* buffer." :group 'pcl-cvs :type '(choice (const nil) (const status) (const delayed) (const t)))

(defcustom cvs-auto-remove-directories 'handled "\
*If ALL, directory entries will never be shown.
If HANDLED, only non-handled directories will be shown.
If EMPTY, only non-empty directories will be shown." :group 'pcl-cvs :type '(choice (const :tag "No" nil) (const all) (const handled) (const empty)))

(defcustom cvs-auto-revert t "\
*Non-nil if changed files should automatically be reverted." :group 'pcl-cvs :type '(boolean))

(defcustom cvs-sort-ignore-file t "\
*Non-nil if `cvs-mode-ignore' should sort the .cvsignore automatically." :group 'pcl-cvs :type '(boolean))

(defcustom cvs-force-dir-tag t "\
*If non-nil, tagging can only be applied to directories.
Tagging should generally be applied a directory at a time, but sometimes it is
useful to be able to tag a single file.  The normal way to do that is to use
`cvs-mode-force-command' so as to temporarily override the restrictions," :group 'pcl-cvs :type '(boolean))

(defcustom cvs-default-ignore-marks nil "\
*Non-nil if cvs mode commands should ignore any marked files.
Normally they run on the files that are marked (with `cvs-mode-mark'),
or the file under the cursor if no files are marked.  If this variable
is set to a non-nil value they will by default run on the file on the
current line.  See also `cvs-ignore-marks'" :group 'pcl-cvs :type '(boolean))

(defcustom cvs-invert-ignore-marks (let ((l nil)) (unless (equal cvs-diff-ignore-marks cvs-default-ignore-marks) (push "diff" l)) (when (and cvs-force-dir-tag (not cvs-default-ignore-marks)) (push "tag" l)) l) "\
*List of cvs commands that invert the default ignore-mark behavior.
Commands in this set will use the opposite default from the one set
in `cvs-default-ignore-marks'." :group 'pcl-cvs :type '(set (const "diff") (const "tag") (const "ignore")))

(defcustom cvs-confirm-removals t "\
*Ask for confirmation before removing files.
Non-nil means that PCL-CVS will ask confirmation before removing files
except for files whose content can readily be recovered from the repository.
A value of `list' means that the list of files to be deleted will be
displayed when asking for confirmation." :group 'pcl-cvs :type '(choice (const list) (const t) (const nil)))

(defcustom cvs-add-default-message nil "\
*Default message to use when adding files.
If set to nil, `cvs-mode-add' will always prompt for a message." :group 'pcl-cvs :type '(choice (const :tag "Prompt" nil) (string)))

(defcustom cvs-find-file-and-jump t "\
Jump to the modified area when finding a file.
If non-nil, `cvs-mode-file-file' will place the cursor at the beginning of
the modified area.  If the file is not locally modified, this will obviously
have no effect." :group 'pcl-cvs :type '(boolean))

(defcustom cvs-buffer-name-alist '(("diff" cvs-diff-buffer-name nil diff-mode) ("status" "*cvs-info*" cvs-status-mode) ("tree" (format "*cvs-%s*" cmd) cvs-status-mode) ("message" "*cvs-commit*" nil cvs-edit) ("log" "*cvs-info*" cvs-log-mode)) "\
*Buffer name and mode to be used for each command.
This is a list of elements of the form

	(CMD BUFNAME MODE &optional POSTPROC)

CMD is the name of the command.
BUFNAME is an expression that should evaluate to a string used as
  a buffer name.  It can use the variable CMD if it wants to.
MODE is the command to use to setup the buffer.
POSTPROC is a function that should be executed when the command terminates

The CMD used for `cvs-mode-commit' is \"message\".  For that special
  case, POSTPROC is called just after MODE with special arguments." :group 'pcl-cvs :type '(repeat (list (choice (const "diff") (const "status") (const "tree") (const "message") (const "log") (string)) (choice (const "*vc-diff*") (const "*cvs-info*") (const "*cvs-commit*") (const (expand-file-name "*cvs-commit*")) (const (format "*cvs-%s*" cmd)) (const (expand-file-name (format "*cvs-%s*" cmd))) (sexp :value "my-cvs-info-buffer") (const nil)) (choice (function-item diff-mode) (function-item cvs-edit-mode) (function-item cvs-status-mode) function (const nil)) (set :inline t (choice (function-item cvs-status-cvstrees) (function-item cvs-status-trees) function)))))

(defcustom cvs-idiff-imerge-handlers (if (fboundp 'ediff) '(cvs-ediff-diff . cvs-ediff-merge) '(cvs-emerge-diff . cvs-emerge-merge)) "\
*Pair of functions to be used for resp.  diff'ing and merg'ing interactively." :group 'pcl-cvs :type '(choice (const :tag "Ediff" (cvs-ediff-diff . cvs-ediff-merge)) (const :tag "Emerge" (cvs-emerge-diff . cvs-emerge-merge))))

(defcustom cvs-reuse-cvs-buffer 'subdir "\
When to reuse an existing cvs buffer.
Alternatives are:
 CURRENT: just reuse the current buffer if it is a cvs buffer
 SAMEDIR: reuse any cvs buffer displaying the same directory
 SUBDIR:  or reuse any cvs buffer displaying any sub- or super- directory
 ALWAYS:  reuse any cvs buffer." :group 'pcl-cvs :type '(choice (const always) (const subdir) (const samedir) (const current)))

(defcustom cvs-minor-mode-prefix "c" "\
Prefix key for the `cvs-mode' bindings in `cvs-minor-mode'." :group 'pcl-cvs)

;;;***

;;;### (autoloads (cvs-allow-dir-commit cvs-highlight cvs-display-full-path) "pcl-cvs-info" "pcl-cvs/pcl-cvs-info.el")
(defconst custom-define-current-source-file "pcl-cvs-info.el")

(defcustom cvs-display-full-path t "\
*Specifies how the filenames should look like in the listing.
If t, their full path name will be displayed, else only the filename." :group 'pcl-cvs :type '(boolean))

(defcustom cvs-highlight (or (and (boundp 'font-lock-auto-fontify) font-lock-auto-fontify) (and (boundp 'global-font-lock-mode) global-font-lock-mode)) "\
*Whether to use text highlighting ( la font-lock) or not." :group 'pcl-cvs :type '(boolean))

(defcustom cvs-allow-dir-commit nil "\
*Allow `cvs-mode-commit' on directories.
If you commit without any marked file and with the cursor positioned
on a directory entry, cvs would commit the whole directory.  This seems
to confuse some users sometimes." :group 'pcl-cvs :type '(boolean))

;;;***

;;;### (autoloads (cvs-parse-ignored-messages cvs-update-prog-output-skip-regexp) "pcl-cvs-parse" "pcl-cvs/pcl-cvs-parse.el")
(defconst custom-define-current-source-file "pcl-cvs-parse.el")

(defcustom cvs-update-prog-output-skip-regexp "$" "\
*A regexp that matches the end of the output from all cvs update programs.
That is, output from any programs that are run by CVS (by the flag -u
in the `modules' file - see cvs(5)) when `cvs update' is performed should
terminate with a line that this regexp matches.  It is enough that
some part of the line is matched.

The default (a single $) fits programs without output." :group 'pcl-cvs :type '(regexp :value "$"))

(defcustom cvs-parse-ignored-messages '("Executing ssh-askpass to query the password.*$" ".*Remote host denied X11 forwarding.*$" "^cvswrapper server: Updating.*$") "\
*A list of regexps matching messages that should be ignored by the parser.
Each regexp should match a whole set of lines and should hence be terminated
by `$'." :group 'pcl-cvs :type '(repeat regexp))

;;;***

;;;### (autoloads (cvs-dired-use-hook cvs-dired-action) "pcl-cvs" "pcl-cvs/pcl-cvs.el")
(defconst custom-define-current-source-file "pcl-cvs.el")

(defcustom cvs-dired-action 'cvs-examine "\
The action to be performed when opening a CVS directory.
Sensible values are `cvs-examine' and `cvs-status'." :group 'pcl-cvs :type '(choice (const cvs-examine) (const cvs-status)))

(defcustom cvs-dired-use-hook '(4) "\
Whether or not opening a CVS directory should run PCL-CVS.
nil means never do it.
ALWAYS means to always do it unless a prefix argument is given to the
  command that prompted the opening of the directory.
Anything else means to do it only if the prefix arg is equal to this value." :group 'pcl-cvs :type '(choice (const :tag "Never" nil) (const :tag "Always" always) (const :tag "Prefix" (4))))

;;;***

(provide 'pcl-cvs-custom-defines)
