;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'perl-modes-custom-defines) (error "Feature perl-modes-custom-defines already loaded"))

;;;### (autoloads (pod2man-program cperl-mode-hook cperl-ps-print-face-properties cperl-syntaxify-for-menu cperl-syntaxify-unwind cperl-syntaxify-by-font-lock cperl-indent-parens-as-block cperl-merge-trailing-else cperl-fix-hanging-brace-when-indent cperl-break-one-line-blocks-when-indent cperl-indent-region-fix-constructs cperl-message-electric-keyword cperl-extra-perl-args cperl-under-as-char cperl-indent-left-aligned-comments cperl-regexp-indent-step cperl-noscan-files-regexp cperl-scan-files-regexp cperl-use-syntax-table-text-property-for-tags cperl-use-syntax-table-text-property cperl-info-page cperl-shrink-wrap-info-frame cperl-max-help-size cperl-imenu-addback cperl-hook-after-change cperl-regexp-scan cperl-pod-here-scan cperl-highlight-variables-indiscriminately cperl-fontify-m-as-s cperl-pod-here-fontify cperl-invalid-face cperl-here-face cperl-pod-head-face cperl-pod-face cperl-lazy-help-time cperl-clobber-lisp-bindings cperl-info-on-command-no-prompt cperl-clobber-mode-lists cperl-vc-header-alist cperl-vc-rcs-header cperl-vc-sccs-header cperl-indent-comment-at-column-0 cperl-comment-column cperl-hairy cperl-electric-backspace-untabify cperl-electric-keywords cperl-electric-linefeed cperl-electric-parens-mark cperl-electric-parens cperl-electric-parens-string cperl-electric-lbrace-space cperl-font-lock cperl-tab-always-indent cperl-auto-newline-after-colon cperl-autoindent-on-semi cperl-auto-newline cperl-indent-wrt-brace cperl-close-paren-offset cperl-continued-brace-offset cperl-continued-statement-offset cperl-min-label-indent cperl-label-offset cperl-brace-offset cperl-brace-imaginary-offset cperl-lineup-step cperl-indent-level cperl-extra-newline-before-brace-multiline cperl-extra-newline-before-brace cperl-help-system cperl-speed cperl-faces cperl-autoinsert-details cperl-affected-by-hairy cperl-indentation-details cperl) "cperl-mode" "perl-modes/cperl-mode.el")
(defconst custom-define-current-source-file "cperl-mode.el")

(defgroup cperl nil "Major mode for editing Perl code." :prefix "cperl-" :group 'languages)

(defgroup cperl-indentation-details nil "Indentation." :prefix "cperl-" :group 'cperl)

(defgroup cperl-affected-by-hairy nil "Variables affected by `cperl-hairy'." :prefix "cperl-" :group 'cperl)

(defgroup cperl-autoinsert-details nil "Auto-insert tuneup." :prefix "cperl-" :group 'cperl)

(defgroup cperl-faces nil "Fontification colors." :prefix "cperl-" :group 'cperl)

(defgroup cperl-speed nil "Speed vs. validity tuneup." :prefix "cperl-" :group 'cperl)

(defgroup cperl-help-system nil "Help system tuneup." :prefix "cperl-" :group 'cperl)

(defcustom cperl-extra-newline-before-brace nil "\
*Non-nil means that if, elsif, while, until, else, for, foreach
and do constructs look like:

	if ()
	{
	}

instead of:

	if () {
	}" :type 'boolean :group 'cperl-autoinsert-details)

(defcustom cperl-extra-newline-before-brace-multiline cperl-extra-newline-before-brace "\
*Non-nil means the same as `cperl-extra-newline-before-brace', but
for constructs with multiline if/unless/while/until/for/foreach condition." :type 'boolean :group 'cperl-autoinsert-details)

(defcustom cperl-indent-level 2 "\
*Indentation of CPerl statements with respect to containing block." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-lineup-step nil "\
*`cperl-lineup' will always lineup at multiple of this number.
If nil, the value of `cperl-indent-level' will be used." :type '(choice (const nil) integer) :group 'cperl-indentation-details)

(defcustom cperl-brace-imaginary-offset 0 "\
*Imagined indentation of a Perl open brace that actually follows a statement.
An open brace following other text is treated as if it were this far
to the right of the start of its line." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-brace-offset 0 "\
*Extra indentation for braces, compared with other text in same context." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-label-offset -2 "\
*Offset of CPerl label lines relative to usual indentation." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-min-label-indent 1 "\
*Minimal offset of CPerl label lines." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-continued-statement-offset 2 "\
*Extra indent for lines not starting new statements." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-continued-brace-offset 0 "\
*Extra indent for substatements that start with open-braces.
This is in addition to cperl-continued-statement-offset." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-close-paren-offset -1 "\
*Extra indent for substatements that start with close-parenthesis." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-indent-wrt-brace t "\
*Non-nil means indent statements in if/etc block relative brace, not if/etc.
Versions 5.2 ... 5.20 behaved as if this were `nil'." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-auto-newline nil "\
*Non-nil means automatically newline before and after braces,
and after colons and semicolons, inserted in CPerl code.  The following
\\[cperl-electric-backspace] will remove the inserted whitespace.
Insertion after colons requires both this variable and
`cperl-auto-newline-after-colon' set." :type 'boolean :group 'cperl-autoinsert-details)

(defcustom cperl-autoindent-on-semi nil "\
*Non-nil means automatically indent after insertion of (semi)colon.
Active if `cperl-auto-newline' is false." :type 'boolean :group 'cperl-autoinsert-details)

(defcustom cperl-auto-newline-after-colon nil "\
*Non-nil means automatically newline even after colons.
Subject to `cperl-auto-newline' setting." :type 'boolean :group 'cperl-autoinsert-details)

(defcustom cperl-tab-always-indent t "\
*Non-nil means TAB in CPerl mode should always reindent the current line,
regardless of where in the line point is when the TAB command is used." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-font-lock nil "\
*Non-nil (and non-null) means CPerl buffers will use `font-lock-mode'.
Can be overwritten by `cperl-hairy' if nil." :type '(choice (const null) boolean) :group 'cperl-affected-by-hairy)

(defcustom cperl-electric-lbrace-space nil "\
*Non-nil (and non-null) means { after $ should be preceded by ` '.
Can be overwritten by `cperl-hairy' if nil." :type '(choice (const null) boolean) :group 'cperl-affected-by-hairy)

(defcustom cperl-electric-parens-string "({[]})<" "\
*String of parentheses that should be electric in CPerl.
Closing ones are electric only if the region is highlighted." :type 'string :group 'cperl-affected-by-hairy)

(defcustom cperl-electric-parens nil "\
*Non-nil (and non-null) means parentheses should be electric in CPerl.
Can be overwritten by `cperl-hairy' if nil." :type '(choice (const null) boolean) :group 'cperl-affected-by-hairy)

(defcustom cperl-electric-parens-mark (and window-system (or (and (boundp 'transient-mark-mode) transient-mark-mode) (and (boundp 'zmacs-regions) zmacs-regions))) "\
*Not-nil means that electric parens look for active mark.
Default is yes if there is visual feedback on mark." :type 'boolean :group 'cperl-autoinsert-details)

(defcustom cperl-electric-linefeed nil "\
*If true, LFD should be hairy in CPerl, otherwise C-c LFD is hairy.
In any case these two mean plain and hairy linefeeds together.
Can be overwritten by `cperl-hairy' if nil." :type '(choice (const null) boolean) :group 'cperl-affected-by-hairy)

(defcustom cperl-electric-keywords nil "\
*Not-nil (and non-null) means keywords are electric in CPerl.
Can be overwritten by `cperl-hairy' if nil." :type '(choice (const null) boolean) :group 'cperl-affected-by-hairy)

(defcustom cperl-electric-backspace-untabify t "\
*Not-nil means electric-backspace will untabify in CPerl." :type 'boolean :group 'cperl-autoinsert-details)

(defcustom cperl-hairy nil "\
*Not-nil means most of the bells and whistles are enabled in CPerl.
Affects: `cperl-font-lock', `cperl-electric-lbrace-space',
`cperl-electric-parens', `cperl-electric-linefeed', `cperl-electric-keywords',
`cperl-info-on-command-no-prompt', `cperl-clobber-lisp-bindings',
`cperl-lazy-help-time'." :type 'boolean :group 'cperl-affected-by-hairy)

(defcustom cperl-comment-column 32 "\
*Column to put comments in CPerl (use \\[cperl-indent] to lineup with code)." :type 'integer :group 'cperl-indentation-details)

(defcustom cperl-indent-comment-at-column-0 nil "\
*Non-nil means that comment started at column 0 should be indentable." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-vc-sccs-header '("($sccs) = ('%W%' =~ /(\\d+(\\.\\d+)+)/) ;") "\
*Special version of `vc-sccs-header' that is used in CPerl mode buffers." :type '(repeat string) :group 'cperl)

(defcustom cperl-vc-rcs-header '("($rcs) = (' $Id$ ' =~ /(\\d+(\\.\\d+)+)/);") "\
*Special version of `vc-rcs-header' that is used in CPerl mode buffers." :type '(repeat string) :group 'cperl)

(defcustom cperl-vc-header-alist 'nil "\
*What to use as `vc-header-alist' in CPerl.
Obsolete, with newer Emacsen use `cperl-vc-rcs-header' or
`cperl-vc-sccs-header' instead.  If this list is empty, `vc-header-alist'
will be reconstructed basing on these two variables." :type '(repeat (list symbol string)) :group 'cperl)

(defcustom cperl-clobber-mode-lists (not (and (boundp 'interpreter-mode-alist) (assoc "miniperl" interpreter-mode-alist) (assoc "\\.\\([pP][Llm]\\|al\\)$" auto-mode-alist))) "\
*Whether to install us into `interpreter-' and `extension' mode lists." :type 'boolean :group 'cperl)

(defcustom cperl-info-on-command-no-prompt nil "\
*Not-nil (and non-null) means not to prompt on C-h f.
The opposite behaviour is always available if prefixed with C-c.
Can be overwritten by `cperl-hairy' if nil." :type '(choice (const null) boolean) :group 'cperl-affected-by-hairy)

(defcustom cperl-clobber-lisp-bindings nil "\
*Not-nil (and non-null) means not overwrite C-h f.
The function is available on \\[cperl-info-on-command], \\[cperl-get-help].
Can be overwritten by `cperl-hairy' if nil." :type '(choice (const null) boolean) :group 'cperl-affected-by-hairy)

(defcustom cperl-lazy-help-time nil "\
*Not-nil (and non-null) means to show lazy help after given idle time.
Can be overwritten by `cperl-hairy' to be 5 sec if nil." :type '(choice (const null) (const nil) integer) :group 'cperl-affected-by-hairy)

(defcustom cperl-pod-face 'font-lock-comment-face "\
*The result of evaluation of this expression is used for POD highlighting." :type 'face :group 'cperl-faces)

(defcustom cperl-pod-head-face 'font-lock-variable-name-face "\
*The result of evaluation of this expression is used for POD highlighting.
Font for POD headers." :type 'face :group 'cperl-faces)

(defcustom cperl-here-face 'font-lock-string-face "\
*The result of evaluation of this expression is used for here-docs highlighting." :type 'face :group 'cperl-faces)

(defcustom cperl-invalid-face (if cperl-singly-quote-face 'underline ''underline) (if cperl-singly-quote-face "*This face is used for highlighting trailing whitespace." "*The result of evaluation of this expression highlights trailing whitespace.") :type 'face :group 'cperl-faces)

(defcustom cperl-pod-here-fontify '(featurep 'font-lock) "\
*Not-nil after evaluation means to highlight POD and here-docs sections." :type 'boolean :group 'cperl-faces)

(defcustom cperl-fontify-m-as-s t "\
*Not-nil means highlight 1arg regular expressions operators same as 2arg." :type 'boolean :group 'cperl-faces)

(defcustom cperl-highlight-variables-indiscriminately nil "\
*Non-nil means perform additional highlighting on variables.
Currently only changes how scalar variables are highlighted.
Note that that variable is only read at initialization time for
the variable `perl-font-lock-keywords-2', so changing it after you've
entered CPerl mode the first time will have no effect." :type 'boolean :group 'cperl)

(defcustom cperl-pod-here-scan t "\
*Not-nil means look for POD and here-docs sections during startup.
You can always make lookup from menu or using \\[cperl-find-pods-heres]." :type 'boolean :group 'cperl-speed)

(defcustom cperl-regexp-scan t "\
*Not-nil means make marking of regular expression more thorough.
Effective only with `cperl-pod-here-scan'." :type 'boolean :group 'cperl-speed)

(defcustom cperl-hook-after-change t "\
*Not-nil means install hook to know which regions of buffer are changed.
May significantly speed up delayed fontification.  Changes take effect
after reload." :type 'boolean :group 'cperl-speed)

(defcustom cperl-imenu-addback nil "\
*Not-nil means add backreferences to generated `imenu's.
May require patched `imenu' and `imenu-go'.  Obsolete." :type 'boolean :group 'cperl-help-system)

(defcustom cperl-max-help-size 66 "\
*Non-nil means shrink-wrapping of info-buffer allowed up to these percents." :type '(choice integer (const nil)) :group 'cperl-help-system)

(defcustom cperl-shrink-wrap-info-frame t "\
*Non-nil means shrink-wrapping of info-buffer-frame allowed." :type 'boolean :group 'cperl-help-system)

(defcustom cperl-info-page "perl" "\
*Name of the info page containing perl docs.
Older version of this page was called `perl5', newer `perl'." :type 'string :group 'cperl-help-system)

(defcustom cperl-use-syntax-table-text-property (boundp 'parse-sexp-lookup-properties) "\
*Non-nil means CPerl sets up and uses `syntax-table' text property." :type 'boolean :group 'cperl-speed)

(defcustom cperl-use-syntax-table-text-property-for-tags cperl-use-syntax-table-text-property "\
*Non-nil means: set up and use `syntax-table' text property generating TAGS." :type 'boolean :group 'cperl-speed)

(defcustom cperl-scan-files-regexp "\\.\\([pP][Llm]\\|xs\\)$" "\
*Regexp to match files to scan when generating TAGS." :type 'regexp :group 'cperl)

(defcustom cperl-noscan-files-regexp "/\\(\\.\\.?\\|SCCS\\|RCS\\|CVS\\|blib\\)$" "\
*Regexp to match files/dirs to skip when generating TAGS." :type 'regexp :group 'cperl)

(defcustom cperl-regexp-indent-step nil "\
*Indentation used when beautifying regexps.
If nil, the value of `cperl-indent-level' will be used." :type '(choice integer (const nil)) :group 'cperl-indentation-details)

(defcustom cperl-indent-left-aligned-comments t "\
*Non-nil means that the comment starting in leftmost column should indent." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-under-as-char t "\
*Non-nil means that the _ (underline) should be treated as word char." :type 'boolean :group 'cperl)

(defcustom cperl-extra-perl-args "" "\
*Extra arguments to use when starting Perl.
Currently used with `cperl-check-syntax' only." :type 'string :group 'cperl)

(defcustom cperl-message-electric-keyword t "\
*Non-nil means that the `cperl-electric-keyword' prints a help message." :type 'boolean :group 'cperl-help-system)

(defcustom cperl-indent-region-fix-constructs 1 "\
*Amount of space to insert between `}' and `else' or `elsif'
in `cperl-indent-region'.  Set to nil to leave as is.  Values other
than 1 and nil will probably not work." :type '(choice (const nil) (const 1)) :group 'cperl-indentation-details)

(defcustom cperl-break-one-line-blocks-when-indent t "\
*Non-nil means that one-line if/unless/while/until/for/foreach BLOCKs
need to be reformatted into multiline ones when indenting a region." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-fix-hanging-brace-when-indent t "\
*Non-nil means that BLOCK-end `}' may be put on a separate line
when indenting a region.
Braces followed by else/elsif/while/until are excepted." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-merge-trailing-else t "\
*Non-nil means that BLOCK-end `}' followed by else/elsif/continue
may be merged to be on the same line when indenting a region." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-indent-parens-as-block nil "\
*Non-nil means that non-block ()-, {}- and []-groups are indented as blocks,
but for trailing \",\" inside the group, which won't increase indentation.
One should tune up `cperl-close-paren-offset' as well." :type 'boolean :group 'cperl-indentation-details)

(defcustom cperl-syntaxify-by-font-lock (and cperl-can-font-lock (boundp 'parse-sexp-lookup-properties)) "\
*Non-nil means that CPerl uses `font-lock's routines for syntaxification." :type '(choice (const message) boolean) :group 'cperl-speed)

(defcustom cperl-syntaxify-unwind t "\
*Non-nil means that CPerl unwinds to a start of a long construction
when syntaxifying a chunk of buffer." :type 'boolean :group 'cperl-speed)

(defcustom cperl-syntaxify-for-menu t "\
*Non-nil means that CPerl syntaxifies up to the point before showing menu.
This way enabling/disabling of menu items is more correct." :type 'boolean :group 'cperl-speed)

(defcustom cperl-ps-print-face-properties '((font-lock-keyword-face nil nil bold shadow) (font-lock-variable-name-face nil nil bold) (font-lock-function-name-face nil nil bold italic box) (font-lock-constant-face nil "LightGray" bold) (cperl-array-face nil "LightGray" bold underline) (cperl-hash-face nil "LightGray" bold italic underline) (font-lock-comment-face nil "LightGray" italic) (font-lock-string-face nil nil italic underline) (cperl-nonoverridable-face nil nil italic underline) (font-lock-type-face nil nil underline) (font-lock-warning-face nil "LightGray" bold italic box) (underline nil "LightGray" strikeout)) "\
List given as an argument to `ps-extend-face-list' in `cperl-ps-print'." :type '(repeat (cons symbol (cons (choice (const nil) string) (cons (choice (const nil) string) (repeat symbol))))) :group 'cperl-faces)

(defcustom cperl-mode-hook nil "\
Hook run by CPerl mode." :type 'hook :group 'cperl)

(defcustom pod2man-program "pod2man" "\
*File name for `pod2man'." :type 'file :group 'cperl)

;;;***

(provide 'perl-modes-custom-defines)
