;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'pgg-custom-defines) (error "Feature pgg-custom-defines already loaded"))

;;;### (autoloads (pgg-passphrase-cache-expiry pgg-cache-passphrase pgg-encrypt-for-me pgg-query-keyserver pgg-default-keyserver-address pgg-default-user-id pgg-default-scheme pgg) "pgg-def" "pgg/pgg-def.el")
(defconst custom-define-current-source-file "pgg-def.el")

(defgroup pgg nil "Glue for the various PGP implementations." :group 'mime)

(defcustom pgg-default-scheme 'gpg "\
Default PGP scheme." :group 'pgg :type '(choice (const :tag "GnuPG" gpg) (const :tag "PGP 5" pgp5) (const :tag "PGP" pgp)))

(defcustom pgg-default-user-id (user-login-name) "\
User ID of your default identity." :group 'pgg :type 'string)

(defcustom pgg-default-keyserver-address "subkeys.pgp.net" "\
Host name of keyserver." :group 'pgg :type 'string)

(defcustom pgg-query-keyserver nil "\
Whether PGG queries keyservers for missing keys when verifying messages." :group 'pgg :type 'boolean)

(defcustom pgg-encrypt-for-me t "\
If t, encrypt all outgoing messages with user's public key." :group 'pgg :type 'boolean)

(defcustom pgg-cache-passphrase t "\
If t, cache passphrase." :group 'pgg :type 'boolean)

(defcustom pgg-passphrase-cache-expiry 16 "\
How many seconds the passphrase is cached.
Whether the passphrase is cached at all is controlled by
`pgg-cache-passphrase'." :group 'pgg :type 'integer)

;;;***

;;;### (autoloads (pgg-gpg-recipient-argument pgg-gpg-extra-args pgg-gpg-program pgg-gpg) "pgg-gpg" "pgg/pgg-gpg.el")
(defconst custom-define-current-source-file "pgg-gpg.el")

(defgroup pgg-gpg nil "GnuPG interface." :group 'pgg)

(defcustom pgg-gpg-program "gpg" "\
The GnuPG executable." :group 'pgg-gpg :type 'string)

(defcustom pgg-gpg-extra-args nil "\
Extra arguments for every GnuPG invocation." :group 'pgg-gpg :type '(repeat (string :tag "Argument")))

(defcustom pgg-gpg-recipient-argument "--recipient" "\
GnuPG option to specify recipient." :group 'pgg-gpg :type '(choice (const :tag "New `--recipient' option" "--recipient") (const :tag "Old `--remote-user' option" "--remote-user")))

;;;***

;;;### (autoloads (pgg-ignore-packet-checksum pgg-parse-signature-type-alist pgg-parse-compression-algorithm-alist pgg-parse-hash-algorithm-alist pgg-parse-symmetric-key-algorithm-alist pgg-parse-public-key-algorithm-alist pgg-parse) "pgg-parse" "pgg/pgg-parse.el")
(defconst custom-define-current-source-file "pgg-parse.el")

(defgroup pgg-parse nil "OpenPGP packet parsing." :group 'pgg)

(defcustom pgg-parse-public-key-algorithm-alist '((1 . RSA) (2 . RSA-E) (3 . RSA-S) (16 . ELG-E) (17 . DSA) (20 . ELG)) "\
Alist of the assigned number to the public key algorithm." :group 'pgg-parse :type '(repeat (cons (sexp :tag "Number") (sexp :tag "Type"))))

(defcustom pgg-parse-symmetric-key-algorithm-alist '((1 . IDEA) (2 . 3DES) (4 . CAST5) (5 . SAFER-SK128)) "\
Alist of the assigned number to the simmetric key algorithm." :group 'pgg-parse :type '(repeat (cons (sexp :tag "Number") (sexp :tag "Type"))))

(defcustom pgg-parse-hash-algorithm-alist '((1 . MD5) (2 . SHA1) (3 . RIPEMD160) (5 . MD2) (8 . SHA256) (9 . SHA384) (10 . SHA512)) "\
Alist of the assigned number to the cryptographic hash algorithm." :group 'pgg-parse :type '(repeat (cons (sexp :tag "Number") (sexp :tag "Type"))))

(defcustom pgg-parse-compression-algorithm-alist '((0) (1 . ZIP) (2 . ZLIB)) "\
Alist of the assigned number to the compression algorithm." :group 'pgg-parse :type '(repeat (cons (sexp :tag "Number") (sexp :tag "Type"))))

(defcustom pgg-parse-signature-type-alist '((0 . "Signature of a binary document") (1 . "Signature of a canonical text document") (2 . "Standalone signature") (16 . "Generic certification of a User ID and Public Key packet") (17 . "Persona certification of a User ID and Public Key packet") (18 . "Casual certification of a User ID and Public Key packet") (19 . "Positive certification of a User ID and Public Key packet") (24 . "Subkey Binding Signature") (31 . "Signature directly on a key") (32 . "Key revocation signature") (40 . "Subkey revocation signature") (48 . "Certification revocation signature") (64 . "Timestamp signature.")) "\
Alist of the assigned number to the signature type." :group 'pgg-parse :type '(repeat (cons (sexp :tag "Number") (sexp :tag "Type"))))

(defcustom pgg-ignore-packet-checksum t "\
If non-nil checksum of each ascii armored packet will be ignored." :group 'pgg-parse :type 'boolean)

;;;***

;;;### (autoloads (pgg-pgp-extra-args pgg-pgp-shell-command-switch pgg-pgp-shell-file-name pgg-pgp-program pgg-pgp) "pgg-pgp" "pgg/pgg-pgp.el")
(defconst custom-define-current-source-file "pgg-pgp.el")

(defgroup pgg-pgp nil "PGP 2.* and 6.* interface." :group 'pgg)

(defcustom pgg-pgp-program "pgp" "\
PGP 2.* and 6.* executable." :group 'pgg-pgp :type 'string)

(defcustom pgg-pgp-shell-file-name "/bin/sh" "\
File name to load inferior shells from.
Bourne shell or its equivalent (not tcsh) is needed for \"2>\"." :group 'pgg-pgp :type 'string)

(defcustom pgg-pgp-shell-command-switch "-c" "\
Switch used to have the shell execute its command line argument." :group 'pgg-pgp :type 'string)

(defcustom pgg-pgp-extra-args nil "\
Extra arguments for every PGP invocation." :group 'pgg-pgp :type '(choice (const :tag "None" nil) (string :tag "Arguments")))

;;;***

;;;### (autoloads (pgg-pgp5-extra-args pgg-pgp5-shell-command-switch pgg-pgp5-shell-file-name pgg-pgp5-pgpv-program pgg-pgp5-pgpk-program pgg-pgp5-pgps-program pgg-pgp5-pgpe-program pgg-pgp5) "pgg-pgp5" "pgg/pgg-pgp5.el")
(defconst custom-define-current-source-file "pgg-pgp5.el")

(defgroup pgg-pgp5 nil "PGP 5.* interface." :group 'pgg)

(defcustom pgg-pgp5-pgpe-program "pgpe" "\
PGP 5.* 'pgpe' executable." :group 'pgg-pgp5 :type 'string)

(defcustom pgg-pgp5-pgps-program "pgps" "\
PGP 5.* 'pgps' executable." :group 'pgg-pgp5 :type 'string)

(defcustom pgg-pgp5-pgpk-program "pgpk" "\
PGP 5.* 'pgpk' executable." :group 'pgg-pgp5 :type 'string)

(defcustom pgg-pgp5-pgpv-program "pgpv" "\
PGP 5.* 'pgpv' executable." :group 'pgg-pgp5 :type 'string)

(defcustom pgg-pgp5-shell-file-name "/bin/sh" "\
File name to load inferior shells from.
Bourne shell or its equivalent (not tcsh) is needed for \"2>\"." :group 'pgg-pgp5 :type 'string)

(defcustom pgg-pgp5-shell-command-switch "-c" "\
Switch used to have the shell execute its command line argument." :group 'pgg-pgp5 :type 'string)

(defcustom pgg-pgp5-extra-args nil "\
Extra arguments for every PGP 5.* invocation." :group 'pgg-pgp5 :type '(choice (const :tag "None" nil) (string :tag "Arguments")))

;;;***

(provide 'pgg-custom-defines)
