;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'prog-modes-custom-defines) (error "Feature prog-modes-custom-defines already loaded"))

;;;### (autoloads (asm-mode-syntax-table asm-support-c-comments-p asm-comment-char asm) "asm-mode" "prog-modes/asm-mode.el")
(defconst custom-define-current-source-file "asm-mode.el")

(defgroup asm nil "Assembler programming" :group 'languages)

(defcustom asm-comment-char ?\; "\
*The comment-start character assumed by Asm mode." :type 'sexp :group 'asm)

(defcustom asm-support-c-comments-p t "\
*Support C style comments.  If t C style comments will be
supported.  This is mainly for the benefit of font-lock." :type 'boolean :group 'asm)

(defcustom asm-mode-syntax-table nil "\
Syntax table used while in Asm mode.")

;;;***

;;;### (autoloads (lisp-lambda-list-keyword-parameter-alignment lisp-lambda-list-keyword-parameter-indentation lisp-lambda-list-keyword-alignment lisp-simple-loop-indentation lisp-loop-indent-subclauses lisp-backquote-indentation lisp-tag-body-indentation lisp-tag-indentation lisp-indent-maximum-backtracking lisp-indent) "cl-indent" "prog-modes/cl-indent.el")
(defconst custom-define-current-source-file "cl-indent.el")

(defgroup lisp-indent nil "Indentation in Lisp." :group 'lisp)

(defcustom lisp-indent-maximum-backtracking 3 "\
Maximum depth to backtrack out from a sublist for structured indentation.
If this variable is 0, no backtracking will occur and forms such as `flet'
may not be correctly indented." :type 'integer :group 'lisp-indent)

(defcustom lisp-tag-indentation 1 "\
Indentation of tags relative to containing list.
This variable is used by the function `lisp-indent-tagbody'." :type 'integer :group 'lisp-indent)

(defcustom lisp-tag-body-indentation 3 "\
Indentation of non-tagged lines relative to containing list.
This variable is used by the function `lisp-indent-tagbody' to indent normal
lines (lines without tags).
The indentation is relative to the indentation of the parenthesis enclosing
the special form.  If the value is t, the body of tags will be indented
as a block at the same indentation as the first s-expression following
the tag.  In this case, any forms before the first tag are indented
by `lisp-body-indent'." :type 'integer :group 'lisp-indent)

(defcustom lisp-backquote-indentation t "\
Whether or not to indent backquoted lists as code.
If nil, indent backquoted lists as data, i.e., like quoted lists." :type 'boolean :group 'lisp-indent)

(defcustom lisp-loop-indent-subclauses t "\
Whether or not to indent loop subclauses." :type 'boolean :group 'lisp-indent)

(defcustom lisp-simple-loop-indentation 2 "\
Indentation of forms in simple loop forms." :type 'integer :group 'lisp-indent)

(defcustom lisp-lambda-list-keyword-alignment nil "\
Whether to vertically align lambda-list keywords together.
If nil (the default), keyworded lambda-list parts are aligned
with the initial mandatory arguments, like this:

\(defun foo (arg1 arg2 &rest rest
	    &key key1 key2)
  #|...|#)

If non-nil, alignment is done with the first keyword
\(or falls back to the previous case), as in:

\(defun foo (arg1 arg2 &rest rest
		      &key key1 key2)
  #|...|#)" :type 'boolean :group 'lisp-indent)

(defcustom lisp-lambda-list-keyword-parameter-indentation 2 "\
Indentation of lambda list keyword parameters.
See `lisp-lambda-list-keyword-parameter-alignment'
for more information." :type 'integer :group 'lisp-indent)

(defcustom lisp-lambda-list-keyword-parameter-alignment nil "\
Whether to vertically align lambda-list keyword parameters together.
If nil (the default), the parameters are aligned
with their corresponding keyword, plus the value of
`lisp-lambda-list-keyword-parameter-indentation', like this:

\(defun foo (arg1 arg2 &key key1 key2
			key3 key4)
  #|...|#)

If non-nil, alignment is done with the first parameter
\(or falls back to the previous case), as in:

\(defun foo (arg1 arg2 &key key1 key2
			    key3 key4)
  #|...|#)" :type 'boolean :group 'lisp-indent)

;;;***

;;;### (autoloads (diff-minor-mode-prefix diff-advance-after-apply-hunk diff-update-on-the-fly diff-jump-to-old-file diff-default-read-only diff-mode) "diff-mode" "prog-modes/diff-mode.el")
(defconst custom-define-current-source-file "diff-mode.el")

(defgroup diff-mode nil "Major mode for viewing/editing diffs." :version "21.1" :group 'tools :group 'diff)

(defcustom diff-default-read-only nil "\
If non-nil, `diff-mode' buffers default to being read-only." :type 'boolean :group 'diff-mode)

(defcustom diff-jump-to-old-file nil "\
*Non-nil means `diff-goto-source' jumps to the old file.
Else, it jumps to the new file." :type 'boolean :group 'diff-mode)

(defcustom diff-update-on-the-fly t "\
*Non-nil means hunk headers are kept up-to-date on-the-fly.
When editing a diff file, the line numbers in the hunk headers
need to be kept consistent with the actual diff.  This can
either be done on the fly (but this sometimes interacts poorly with the
undo mechanism) or whenever the file is written (can be slow
when editing big diffs)." :type 'boolean :group 'diff-mode)

(defcustom diff-advance-after-apply-hunk t "\
*Non-nil means `diff-apply-hunk' will move to the next hunk after applying." :type 'boolean :group 'diff-mode)

(defcustom diff-minor-mode-prefix "=" "\
Prefix key for `diff-minor-mode' commands." :type '(choice (string "") (string "C-c=") string) :group 'diff-mode)

;;;***

;;;### (autoloads (eif-compile-options eif-short-command eif-compile-command eif-use-gnu-eiffel eif-fill-max-save eif-set-tab-width-flag eif-indent-string-continuations-relatively-flag eif-extra-string-continuation-indent eif-string-continuation-indent eif-extra-continuation-indent eif-continuation-indent eif-extra-then-indent eif-then-indent eif-extra-rescue-keyword-indent eif-rescue-keyword-indent eif-extra-check-keyword-indent eif-check-keyword-indent eif-extra-body-comment-indent eif-body-comment-indent eif-extra-feature-level-comment-indent eif-feature-level-comment-indent eif-extra-feature-level-kw-indent eif-feature-level-kw-indent eif-extra-feature-level-indent eif-feature-level-indent eif-extra-inherit-level-kw-indent eif-inherit-level-kw-indent eif-extra-class-level-comment-indent eif-class-level-comment-indent eif-extra-class-level-kw-indent eif-class-level-kw-indent eif-indent-increment eiffel-compile eiffel-indent eiffel) "eiffel" "prog-modes/eiffel.el")
(defconst custom-define-current-source-file "eiffel.el")

(defgroup eiffel nil "Eiffel mode for Emacs" :group 'oop)

(defgroup eiffel-indent nil "Indentation variables in Eiffel mode" :prefix "eif-" :group 'eiffel)

(defgroup eiffel-compile nil "Compilation support variables in Eiffel mode" :prefix "eif-" :group 'eiffel)

(defcustom eif-indent-increment 3 "\
*Default indentation interval (in spaces)." :type 'integer :group 'eiffel-indent)

(defcustom eif-class-level-kw-indent 0 "\
*Indentation for Class level keywords.
Specified as number of `eif-indent-increments'.  See the variable
`eif-class-level-keywords'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-class-level-kw-indent 0 "\
*Number of extra spaces to add to `eif-class-level-kw-indent'.
This results in the actual indentation of a class level keyword.  Can
be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-class-level-comment-indent 0 "\
*Indentation of comments at the beginning of a class.
Specified as number of `eif-indent-increments'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-class-level-comment-indent 0 "\
*Number of spaces to add to `eif-class-level-comment-indent'.
This results in the actual indentation of a class level comment.  Can
be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-inherit-level-kw-indent 2 "\
*Indentation of keywords falling under the Inherit clause.
Specified as number of `eif-indent-increments'.  See the variable
`eif-inherit-level-keywords'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-inherit-level-kw-indent 0 "\
*Number of spaces to add to `eif-inherit-level-kw-indent'.
This results in the actual indentation of an inherit level keyword.
Can be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-feature-level-indent 1 "\
*Indentation amount of features.
Specified as number of `eif-indent-increments'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-feature-level-indent 0 "\
*Number of spaces to add to `eif-feature-level-indent'.
This results in the indentation of a feature.  Can be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-feature-level-kw-indent 2 "\
*Indentation of keywords belonging to individual features.
Specified as number of `eif-indent-increments'.  See the variable
`eif-feature-level-keywords'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-feature-level-kw-indent 0 "\
*Number of spaces to add to `eif-feature-level-kw-indent'.
This results in the actual indentation of a feature level keyword.
Can be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-feature-level-comment-indent 3 "\
*Indentation of comments at the beginning of a feature.
Specified as number of `eif-indent-increments'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-feature-level-comment-indent 0 "\
*Number of spaces to add to `eif-feature-level-comment-indent'.
This results in the actual indentation of a feature level comment.
Can be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-body-comment-indent 0 "\
*Indentation of comments in the body of a routine.
Specified as number of `eif-indent-increments')" :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-body-comment-indent 0 "\
*Number of spaces to add to `eif-body-comment-indent'.
This results in the actual indentation of a routine body comment.  Can
be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-check-keyword-indent 0 "\
*Extra indentation for the check clause as described in ETL.
Specified as number of `eif-indent-increments'.  Default is 0, which
is different than in ETL's 1." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-check-keyword-indent 0 "\
*Number of spaces to add to `eif-check-keyword-indent'.
This results in the actual indentation of a check keyword.  Can be
negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-rescue-keyword-indent -1 "\
*Extra indentation for the rescue clause as described in ETL.
Specified as number of `eif-indent-increments'.  Default is -1." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-rescue-keyword-indent 0 "\
*Number of spaces to add to `eif-rescue-keyword-indent'.
This results in the actual indentation of a rescue keyword.  Can be
negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-then-indent 0 "\
*Indentation for a `then' appearing on a line by itself.
This is as opposed to a `then' on the same line as an `if'.  Specified
as number of `eif-indent-increments'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-then-indent 1 "\
*Number of spaces to add to `eif-then-indent'.
This results in the actual indentation of a `then' appearing on a line
by itself.  Can be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-continuation-indent 1 "\
*Extra indentation for a continued statement line.
Specified as number of `eif-indent-increments'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-continuation-indent 0 "\
*Number of spaces to add to `eif-continuation-indent'.
This results in the actual indentation of a continued statement
line.  Can be negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-string-continuation-indent 0 "\
*Extra indentation for a continued string.
Specified as number of `eif-indent-increments'." :type 'integer :group 'eiffel-indent)

(defcustom eif-extra-string-continuation-indent -1 "\
*Number of spaces to add to `eif-string-continuation-indent'.
This results in the actual indentation of a continued string.  Can be
negative." :type 'integer :group 'eiffel-indent)

(defcustom eif-indent-string-continuations-relatively-flag t "\
*Non-nil means string continuations are indented relative to 1st character.
That is, `eif-string-continuation-indent' and
`eif-extra-string-continuation-indent' are added to position of first
character of string.  If nil, string continuations are indented
relative to indent of previous line." :type 'boolean :group 'eiffel-indent)

(defcustom eif-set-tab-width-flag t "\
*Non-nil means `tab-width' is set to `eif-indent-increment' in `eiffel-mode'." :type 'boolean :group 'eiffel-indent)

(defcustom eif-fill-max-save 4096 "\
*Maximum size of a paragraph to save before filling.
Normally \\[eif-fill-paragraph] will mark a buffer as modified even if
the fill operation does not make any changes.  If the paragraph being
filled is smaller than the value of this variable then the contents of
the paragraph will be saved for comparison with the paragraph after
the fill operation.  If they are the same, the buffer modification
state is restored.  Set this to 0 to disable this feature, or a very
big number to enable it for all paragraphs." :type 'integer :group 'eiffel-indent)

(defcustom eif-use-gnu-eiffel t "\
*If t include support for compilation using GNU SmallEiffel." :type 'boolean :group 'eiffel-compile)

(defcustom eif-compile-command (if (file-executable-p "/usr/bin/se-compile") "se-compile" "compile") "\
*Program to use for compiling Eiffel programs.
The default is \"compile\", unless \"/usr/bin/se-compile\" exists, as
in Debian GNU/Linux, when the default value is \"se-compile\"." :type 'string :group 'eiffel-compile)

(defcustom eif-short-command "short" "\
*Program to use for producing short form of Eiffel classes." :type 'string :group 'eiffel-compile)

(defcustom eif-compile-options "" "\
*Options to use for compiling Eiffel programs." :type 'string :group 'eiffel-compile)

;;;***

;;;### (autoloads (go-fontify-function-calls go) "go-mode" "prog-modes/go-mode.el")
(defconst custom-define-current-source-file "go-mode.el")

(defgroup go nil "Major mode for editing Go code" :group 'languages)

(defcustom go-fontify-function-calls t "\
Fontify function and method calls if this is non-nil." :type 'boolean :group 'go)

;;;***

;;;### (autoloads (icon-tab-always-indent icon-auto-newline icon-continued-brace-offset icon-continued-statement-offset icon-brace-offset icon-brace-imaginary-offset icon-indent-level icon) "icon" "prog-modes/icon.el")
(defconst custom-define-current-source-file "icon.el")

(defgroup icon nil "Mode for editing Icon code." :group 'languages)

(defcustom icon-indent-level 4 "\
*Indentation of Icon statements with respect to containing block." :type 'integer :group 'icon)

(defcustom icon-brace-imaginary-offset 0 "\
*Imagined indentation of a Icon open brace that actually follows a statement." :type 'integer :group 'icon)

(defcustom icon-brace-offset 0 "\
*Extra indentation for braces, compared with other text in same context." :type 'integer :group 'icon)

(defcustom icon-continued-statement-offset 4 "\
*Extra indent for Icon lines not starting new statements." :type 'integer :group 'icon)

(defcustom icon-continued-brace-offset 0 "\
*Extra indent for Icon substatements that start with open-braces.
This is in addition to `icon-continued-statement-offset'." :type 'integer :group 'icon)

(defcustom icon-auto-newline nil "\
*Non-nil means automatically newline before and after braces Icon code.
This applies when braces are inserted." :type 'boolean :group 'icon)

(defcustom icon-tab-always-indent t "\
*Non-nil means TAB in Icon mode should always reindent the current line.
It will then reindent, regardless of where in the line point is
when the TAB command is used." :type 'boolean :group 'icon)

;;;***

;;;### (autoloads (javascript-shell-mode-hook javascript-shell-prompt-pattern javascript-shell-command-args javascript-shell-command javascript-shell javascript-mode-hook javascript) "javascript-mode" "prog-modes/javascript-mode.el")
(defconst custom-define-current-source-file "javascript-mode.el")

(defgroup javascript nil "Major mode for editing JavaScript code." :tag "JavaScript" :group 'languages :prefix "javascript-")

(defcustom javascript-mode-hook nil "\
Hook for customizing `javascript-mode'." :group 'javascript :type 'hook)

(defgroup javascript-shell nil "JavaScript shell options." :group 'javascript :prefix "javascript-shell-")

(defcustom javascript-shell-command "jsshell" "\
*Command for starting `javascript-shell'.
Set arguments for this command in `javascript-shell-command-args'." :type 'string :group 'javascript-shell)

(defcustom javascript-shell-command-args 'nil "\
*Command line arguments for `javascript-shell-command'." :type '(repeat (string :tag "Argument")) :group 'javascript-shell)

(defcustom javascript-shell-prompt-pattern "^js> *" "\
*JavaScript shell prompt pattern." :type 'regexp :group 'javascript-shell)

(defcustom javascript-shell-mode-hook nil "\
Hook for customizing `javascript-shell-mode'." :type 'hook :group 'javascript-shell)

;;;***

;;;### (autoloads (lua-indent-level lua-mode-hook lua-always-show lua-default-command-switches lua-default-application lua) "lua-mode" "prog-modes/lua-mode.el")
(defconst custom-define-current-source-file "lua-mode.el")

(defgroup lua nil "Major mode for editing Lua Code." :group 'languages)

(defcustom lua-default-application "lua" "\
*Default application to run in lua subprocess." :type 'string :group 'lua)

(defcustom lua-default-command-switches 'nil "\
*Command switches for `lua-default-application'.
Should be a list of strings." :type '(repeat (string :tag "Switch")) :group 'lua)

(defcustom lua-always-show t "\
*Non-nil means display `lua-process-buffer' after sending a command." :type 'boolean :group 'lua)

(defcustom lua-mode-hook nil "\
*Hooks called when lua mode fires up." :type 'hook :group 'lua)

(defcustom lua-indent-level 3 "\
*Amount by which lua subexpressions are indented." :type 'integer :group 'lua)

;;;***

;;;### (autoloads (makefile-up-to-date-buffer-name makefile-query-one-target-method makefile-brave-make makefile-runtime-macros-list makefile-special-targets-list makefile-browser-hook makefile-warn-suspicious-lines-p makefile-cleanup-continuations-p makefile-pickup-everything-picks-up-filenames-p makefile-browser-auto-advance-after-selection-p makefile-browser-unselected-mark makefile-browser-selected-mark makefile-backslash-column makefile-browser-cursor-column makefile-browser-leftmost-column makefile-tab-after-target-colon makefile-use-curly-braces-for-macros-p makefile-electric-keys makefile-macro-assign makefile-target-colon makefile-browser-buffer-name makefile) "make-mode" "prog-modes/make-mode.el")
(defconst custom-define-current-source-file "make-mode.el")

(defgroup makefile nil "Makefile editing commands for XEmacs." :group 'tools :prefix "makefile-")

(defcustom makefile-browser-buffer-name "*Macros and Targets*" "\
*Name of the macro- and target browser buffer." :type 'string :group 'makefile)

(defcustom makefile-target-colon ":" "\
*String to append to all target names inserted by `makefile-insert-target'.
\":\" or \"::\" are common values." :type 'string :group 'makefile)

(defcustom makefile-macro-assign " = " "\
*String to append to all macro names inserted by `makefile-insert-macro'.
The normal value should be \" = \", since this is what
standard make expects.  However, newer makes such as dmake
allow a larger variety of different macro assignments, so you
might prefer to use \" += \" or \" := \" ." :type 'string :group 'makefile)

(defcustom makefile-electric-keys nil "\
*If non-nil, Makefile mode should install electric keybindings.
Default is nil." :type 'boolean :group 'makefile)

(defcustom makefile-use-curly-braces-for-macros-p nil "\
*Controls the style of generated macro references.
Non-nil means macro references should use curly braces, like `${this}'.
nil means use parentheses, like `$(this)'." :type 'boolean :group 'makefile)

(defcustom makefile-tab-after-target-colon t "\
*If non-nil, insert a TAB after a target colon.
Otherwise, a space is inserted.
The default is t." :type 'boolean :group 'makefile)

(defcustom makefile-browser-leftmost-column 10 "\
*Number of blanks to the left of the browser selection mark." :type 'integer :group 'makefile)

(defcustom makefile-browser-cursor-column 10 "\
*Column the cursor goes to when it moves up or down in the Makefile browser." :type 'integer :group 'makefile)

(defcustom makefile-backslash-column 48 "\
*Column in which `makefile-backslash-region' inserts backslashes." :type 'integer :group 'makefile)

(defcustom makefile-browser-selected-mark "+  " "\
*String used to mark selected entries in the Makefile browser." :type 'string :group 'makefile)

(defcustom makefile-browser-unselected-mark "   " "\
*String used to mark unselected entries in the Makefile browser." :type 'string :group 'makefile)

(defcustom makefile-browser-auto-advance-after-selection-p t "\
*If non-nil, cursor will move after item is selected in Makefile browser." :type 'boolean :group 'makefile)

(defcustom makefile-pickup-everything-picks-up-filenames-p nil "\
*If non-nil, `makefile-pickup-everything' picks up filenames as targets.
This means it calls `makefile-pickup-filenames-as-targets'.
Otherwise filenames are omitted." :type 'boolean :group 'makefile)

(defcustom makefile-cleanup-continuations-p t "\
*If non-nil, automatically clean up continuation lines when saving.
A line is cleaned up by removing all whitespace following a trailing
backslash.  This is done silently.
IMPORTANT: Please note that enabling this option causes Makefile mode
to MODIFY A FILE WITHOUT YOUR CONFIRMATION when \"it seems necessary\"." :type 'boolean :group 'makefile)

(defcustom makefile-warn-suspicious-lines-p t "\
In non-nil, warn about suspicious lines when saving the makefile" :type 'boolean :group 'makefile)

(defcustom makefile-browser-hook 'nil "\
The hook to run when entering makefile browser." :type 'hook :group 'makefile)

(defcustom makefile-special-targets-list '(("DEFAULT") ("DONE") ("ERROR") ("EXPORT") ("FAILED") ("GROUPEPILOG") ("GROUPPROLOG") ("IGNORE") ("IMPORT") ("INCLUDE") ("INCLUDEDIRS") ("INIT") ("KEEP_STATE") ("MAKEFILES") ("MAKE_VERSION") ("NO_PARALLEL") ("PARALLEL") ("PHONY") ("PRECIOUS") ("REMOVE") ("SCCS_GET") ("SILENT") ("SOURCE") ("SUFFIXES") ("WAIT") ("c.o") ("C.o") ("m.o") ("el.elc") ("y.c") ("s.o")) "\
*List of special targets.
You will be offered to complete on one of those in the minibuffer whenever
you enter a \".\" at the beginning of a line in `makefile-mode'." :type '(repeat (list string)) :group 'makefile)

(defcustom makefile-runtime-macros-list '(("@") ("&") (">") ("<") ("*") ("^") ("+") ("?") ("%") ("$")) "\
*List of macros that are resolved by make at runtime.
If you insert a macro reference using `makefile-insert-macro-ref', the name
of the macro is checked against this list.  If it can be found its name will
not be enclosed in { } or ( )." :type '(repeat (list string)) :group 'makefile)

(defcustom makefile-brave-make "make" "\
*How to invoke make, for `makefile-query-targets'.
This should identify a `make' command that can handle the `-q' option." :type 'string :group 'makefile)

(defcustom makefile-query-one-target-method 'makefile-query-by-make-minus-q "\
*Function to call to determine whether a make target is up to date.
The function must satisfy this calling convention:

* As its first argument, it must accept the name of the target to
  be checked, as a string.

* As its second argument, it may accept the name of a makefile
  as a string.  Depending on what you're going to do you may
  not need this.

* It must return the integer value 0 (zero) if the given target
  should be considered up-to-date in the context of the given
  makefile, any nonzero integer value otherwise." :type 'function :group 'makefile)

(defcustom makefile-up-to-date-buffer-name "*Makefile Up-to-date overview*" "\
*Name of the Up-to-date overview buffer." :type 'string :group 'makefile)

;;;***

;;;### (autoloads (emacs-lisp-bytecomp-ext emacs-lisp-sources-regexp emacs-lisp-byte-compile-dir-interactive-p perl-dbg-flags perl-command compile-perl python-dbg-flags python-command compile-python tcl-dbg-flags tcl-command compile-tcl zsh-dbg-flags zsh-command compile-zsh csh-dbg-flags csh-command compile-csh sh-dbg-flags sh-command compile-sh f77-object-file-ext f77-build-output-args f77-source-file-ext-regexp f77-default-compiler-options f77-headers-ext-list f77-source-ext-list f77-cflags-varenv f77-compiler-varenv f77-default-compiler f77-companion-file-regexp f77-compilers-list compile-fortran ada-object-file-ext ada-build-output-args ada-source-file-ext-regexp ada-default-compiler-options ada-headers-ext-list ada-source-ext-list ada-aflags-varenv ada-compiler-varenv ada-default-compiler ada-companion-file-regexp ada-compilers-list compile-ada c++-object-file-ext c++-build-output-args c++-source-file-ext-regexp c++-default-compiler-options c++-headers-ext-list c++-source-ext-list c++-cflags-varenv c++-compiler-varenv c++-default-compiler c++-companion-file-regexp c++-compilers-list compile-c++ java-object-file-ext java-build-output-args java-source-file-ext-regexp java-default-compiler-options java-headers-ext-list java-source-ext-list java-cflags-varenv java-compiler-varenv java-default-compiler java-companion-file-regexp java-compilers-list compile-java cc-object-file-ext cc-build-output-args cc-source-file-ext-regexp cc-default-compiler-options cc-headers-ext-list cc-source-ext-list cc-cflags-varenv cc-compiler-varenv cc-default-compiler cc-companion-file-regexp cc-compilers-list compile-c mode-compile-remote-execute-misc-args mode-compile-remote-execute-set-username-arg mode-compile-remote-execute-set-command-arg mode-compile-remote-execute-set-host-arg mode-compile-remote-execute-command mode-compile-remote-hosts-alist compilation-remote mode-compile-reading-time mode-compile-expert-p mode-compile-after-kill-hook mode-compile-before-kill-hook mode-compile-after-compile-hook mode-compile-before-compile-hook mode-compile-other-frame-name mode-compile-other-frame-p compilation-frame mode-compile-never-edit-command-p mode-compile-always-save-buffer-p mode-compile-save-all-p mode-compile-ignore-makerule-regexp mode-compile-preferred-default-makerule mode-compile-make-options mode-compile-ignore-makefile-backups mode-compile-makefile-backups-regexp mode-compile-makefile-regexp mode-compile-make-program mode-compile-shell-alist mode-compile-filename-regexp-alist mode-compile-modes-alist compilation-elisp compilation-script compilation-lang compilation) "mode-compile" "prog-modes/mode-compile.el")
(defconst custom-define-current-source-file "mode-compile.el")

(defgroup compilation nil "Compilations from within Emacs variables." :link '(url-link :tag "Author's Emacs Page" "http://www.tls.cena.fr/~boubaker/Emacs/") :group 'tools :group 'development)

(defgroup compilation-lang nil "Language specific compilation options." :group 'languages :group 'compilation)

(defgroup compilation-script nil "Scripts compilation options." :group 'compilation)

(defgroup compilation-elisp nil "Emacs development compilation options." :group 'lisp :group 'compilation)

(defcustom mode-compile-modes-alist '((c-mode cc-compile kill-compilation) (java-mode java-compile kill-compilation) (c++-mode c++-compile kill-compilation) (ada-mode ada-compile kill-compilation) (fortran-mode f77-compile kill-compilation) (dired-mode dired-compile kill-compilation) (emacs-lisp-mode elisp-compile keyboard-quit) (lisp-interaction-mode elisp-compile keyboard-quit) (makefile-mode makefile-compile kill-compilation) (sh-mode sh-compile kill-compilation) (csh-mode csh-compile kill-compilation) (zsh-mode zsh-compile kill-compilation) (perl-mode perl-compile kill-compilation) (cperl-mode perl-compile kill-compilation) (tcl-mode tcl-compile kill-compilation) (python-mode python-compile kill-compilation) (fundamental-mode guess-compile nil) (text-mode guess-compile nil) (indented-text-mode guess-compile nil) (compilation-mode default-compile kill-compilation)) "\
Assoc list of compile/kill functions for some known modes.

Each element look like (MODE . (COMPILE-FUNCTION KILL-FUNCTION))
 `mode-compile' will call COMPILE-FUNCTION and `mode-compile-kill'
 KILL-FUNCTION if current major-mode is MODE.

If you want to add or modify a COMPILE-FUNCTION and its associated
KILL-FUNCTION for MODE and don't want to hack `mode-compile' you could
do the following (it exists however a more subtle method for
modifying, this is left as an exercise for the reader :-):
 (defun my-mode-compile() ...)
 (defun my-mode-compile-kill() ...)
 (setq mode-compile-modes-alist
       (append '((my-mode . (my-mode-compile my-mode-compile-kill)))
               mode-compile-modes-alist))" :type '(repeat (cons :tag "Association: mode/compilation functions" (function :tag "Mode") (list :tag "Compilation functions" (choice :tag "Function to run the compilation" (function-item :tag "Default" :value default-compile) (function-item :tag "Guess" :value guess-compile) (function-item :tag "Emacs lisp byte compilation" :value elisp-compile) (function :tag "Your choice, take care...")) (choice :tag "Function to kill a running compilation" (function-item :tag "Just kill" :value kill-compilation) (const :tag "Nothing -- use with guess-compile --" :value nil) (function-item :tag "To use with elisp-compile" :value keyboard-quit) (function :tag "Your choice, take care..." :value nil))))) :group 'compilation)

(defcustom mode-compile-filename-regexp-alist '((mode-compile-makefile-regexp . makefile-mode) ("\\.sh$" . sh-mode) ("\\.csh$" . csh-mode) ("\\.zsh$" . zsh-mode)) "\
Assoc list of major-modes for some filenames regexp.

Each element look like (REGEXP . MODE) This variable is really similar
to `auto-mode-alist' in the fact that it associate a MODE to a REGEXP
matching a filename. The only differences is that you are not obliged
to have the specified MODE available to use it (`guess-compile' use
it), the MODE is only a pointer to an association in
`mode-compile-modes-alist' to get the COMPILE-FUNCTION and the
KILL-FUNCTION. The REGEXP could be a form which evaluate to a string.

To add a new filename regexp do the following:
 (setq mode-compile-filename-regexp-alist
       (append '((my-filename-regexp . some-mode-mode-compile-know)
               mode-compile-modes-alist))" :type '(repeat (cons :tag "Association: filename/mode" (choice :tag "Filename regexp match" (regexp :tag "Regexp as a string") (symbol :tag "Variable containing the regexp") (sexp :tag "Form which evaluate to a string")) (function :tag "Mode to use -- should be a valid association in mode-compile-modes-alist --"))) :group 'compilation)

(defcustom mode-compile-shell-alist '(("sh" . sh-mode) ("csh" . csh-mode) ("zsh" . zsh-mode) ("perl" . perl-mode) ("tcl" . tcl-mode) ("python" . python-mode)) "\
Assoc list of compile function for some known shells.

Each element look like (SHELL . MODE) This variable look like
`auto-mode-alist' in the fact that it associate a MODE to a name; A
SHELL name here. The main difference is that you are not obliged to
have the specified MODE available to use it (`guess-compile' use it),
the MODE is only a pointer to an association in `mode-compile-modes-alist'
to get the COMPILE-FUNCTION and the KILL-FUNCTION.

To add a new shell do the following:
 (setq mode-compile-filename-shell-alist
       (append '((my-shell-name . some-mode-mode-compile-know)
               mode-compile-modes-alist))" :type '(repeat (cons :tag "Association: shell name/mode" (string :tag "Shell name") (function :tag "Mode to use -- should be a valid association in mode-compile-modes-alist --"))) :group 'compilation)

(defcustom mode-compile-make-program "make" "\
*The `make' program used to process makefiles.

If you have GNU make installed with name \"gmake\" use it." :type 'string :group 'compilation)

(defcustom mode-compile-makefile-regexp "\\(^[Mm]akefile\\|.*\\.[mM][aA]?[kK][eE]?\\.?.*$\\)" "\
Regexp matching 'could be' makefiles filenames." :type 'regexp :group 'compilation)

(defcustom mode-compile-makefile-backups-regexp "\\(\\(~\\|\\.[bB][aA][cC]?[kK]\\)$\\)\\|\\(\\(^\\|/\\)[.,][^/]+$\\)" "\
Regexp to find if a Makefile is a backup or not" :type 'regexp :group 'compilation)

(defcustom mode-compile-ignore-makefile-backups t "\
*Tell mode compile to ignore makefiles backup files when selecting the Makefile to use." :type 'boolean :group 'compilation)

(defcustom mode-compile-make-options (eval mode-compile-default-make-options) "\
*Options to give to `make'.
This could be any form evaluating to a string.

Some people asked me a way to modify the make options every time a
compilation command is launched, do that:
 (defun my-mode-compile-ask-make-options()
   \"*Hook called by mode-compile, asking for make options.\"
   (interactive)
   (read-string \"Make options: \"
                mode-compile-default-make-options))
 (setq mode-compile-make-options
           'my-mode-compile-ask-make-options)" :type '(choice string (sexp :tag "Form evaluating to a string")) :group 'compilation)

(defcustom mode-compile-preferred-default-makerule 'none "\
*Default makerule you would like to see in minibuffer as a default choice
when selecting the make rule to build.

Possible values are:
'none    -- let mode-compile deciding for you.
'all     -- try hard to show you the \"all\" rule.
'default -- try hard to show you the \"default\" rule.
'file    -- try to show you the name of the file which will be
            result of compilation.
The 'none action is taken as default is something fail." :type '(radio :tag "Symbol" (const :tag "None - Let mode compile made the choice" :value none) (const :tag "All - Show the \"all\" rule" :value all) (const :tag "Default - Show the \"default\" rule" :value default) (const :tag "File - Show the \"result file name\" rule" :value file)) :group 'compilation)

(defcustom mode-compile-ignore-makerule-regexp nil "\
*Makefile rules which must be ignored when building completion list.

For example if you want to remove all `files rules' set
it to: \"\\\\.\\\\([aoc]\\\\|s[ao][.0-9]*\\\\)\". " :type '(choice (const :tag "none" :value nil) (const :tag "The `all files' rule" :value "\\.\\([aoc]\\|s[ao][.0-9]*\\)") regexp) :group 'compilation)

(defcustom mode-compile-save-all-p nil "\
*Non-nil means save ALL the modified buffers without asking
before launching compilation command." :type 'boolean :group 'compilation)

(defcustom mode-compile-always-save-buffer-p nil "\
*Non-nil means save the current buffer without asking
before launching compilation command." :type 'boolean :group 'compilation)

(defcustom mode-compile-never-edit-command-p nil "\
*Non-nil means never ask to user to edit the compile command." :type 'boolean :group 'compilation)

(defgroup compilation-frame nil "Compile in another frame variables." :group 'frames :group 'compilation)

(defcustom mode-compile-other-frame-p nil "\
*Non-nil means compile in another frame.

A new Emacs FRAME is created and the compilation command is executed
in this other frame.  To specify the frame parameters see also
variable `mode-compile-frame-parameters-alist'." :type 'boolean :group 'compilation-frame)

(defcustom mode-compile-other-frame-name "COMPILATION" "\
Name of mode-compile's other frame.

This name could be used in your .Xdefaults or .Xresources file as:
Emacs.MODE-COMPILE-OTHER-FRAME-NAME.resource_to_be_set: ..." :type 'string :group 'compilation-frame)

(defcustom mode-compile-before-compile-hook nil "\
Hook to be run before compile command is executed
when `mode-compile' is invoked." :type 'hook :group 'compilation)

(defcustom mode-compile-after-compile-hook nil "\
Hook to be run after compile command is executed
when `mode-compile' is invoked." :type 'hook :group 'compilation)

(defcustom mode-compile-before-kill-hook nil "\
Hook to be run before killing compile command is executed
when `mode-compile-kill' is invoked." :type 'hook :group 'compilation)

(defcustom mode-compile-after-kill-hook nil "\
Hook to be run after killing compile command is executed
when `mode-compile-kill' is invoked." :type 'hook :group 'compilation)

(defcustom mode-compile-expert-p nil "\
*Non nil means `mode-compile' will not speaks too much.

See also variable variable mode-compile-reading-time." :type 'boolean :group 'compilation)

(defcustom mode-compile-reading-time 1 "\
*Seconds to wait in verbose mode after printing a message.

In verbose mode mode-compile print too much messages that it is
almost impossible to read them. Just setting this delay leave you the
time to read all the messages. If you don't want any delay set it to
`0'.

See also function sit-for." :type 'integer :group 'compilation)

(defgroup compilation-remote nil "Remote compilations options." :group 'compilation)

(defcustom mode-compile-remote-hosts-alist 'nil "\
Alist of favourite hosts names and the username
to use to log on (HOSTNAME . USERNAME).

If USERNAME is a function it will be called with HOSTNAME as argument
and should return an USERNAME string (for example you could use
something like efs-get-user - not tested -), if it is nil the function
user-login-name will be used." :type '(repeat (cons (string :tag "Hostname") (choice (const :tag "We'll use 'user-login-name" :value nil) (string :tag "Username") (function :tag "Function which return USERNAME given a HOSTNAME" :value efs-get-user)))) :group 'compilation-remote)

(defcustom mode-compile-remote-execute-command "rsh" "\
The shell command used to run a command remotely.
\"rsh\" is the only choice I know but I'm far to know everything...

 This variable is set automatically with the value of
remote-shell-program or efs-remote-shell-file-name at load time." :type 'string :group 'compilation)

(defcustom mode-compile-remote-execute-set-host-arg "" "\
Argument To set the remote host name to the
mode-compile-remote-execute-command,

None is required for \"rsh\"." :type 'string :group 'compilation-remote)

(defcustom mode-compile-remote-execute-set-command-arg "" "\
Argument to set the command to be run remotely to the
mode-compile-remote-execute-command.

None is required for \"rsh\"." :type 'string :group 'compilation-remote)

(defcustom mode-compile-remote-execute-set-username-arg "-l" "\
Argument to set the username under which we will log on
on the remote host, to give to mode-compile-remote-execute-command." :type 'string :group 'compilation-remote)

(defcustom mode-compile-remote-execute-misc-args "" "\
Misc additional arguments to give to the
mode-compile-remote-execute-command." :type 'string :group 'compilation-remote)

(defgroup compile-c nil "C Compilation options." :group 'c :group 'compilation-lang)

(defcustom cc-compilers-list '("gcc" "c89" "acc" "cc") "\
List of user's favourite C compilers in order of preference." :type '(repeat (string :tag "C Compiler name")) :group 'compile-c)

(defcustom cc-companion-file-regexp "\\(_[Pp]\\)?\\.[pP]?h" "\
Regexp to find associated .c file from a .h." :type 'regexp :group 'compile-c)

(defcustom cc-default-compiler "cc" "\
*Default C compiler to use when everything else fails.

This could be any form evaluating to a string, so you could map it to
a function asking you interactively to choose the compiler.

example:
 (defun my-choose-compiler()
   (read-string \"C compiler: \"))
 (setq cc-compilers-list '()
       cc-default-compiler 'my-choose-compiler)" :type '(choice string function) :group 'compile-c)

(defcustom cc-compiler-varenv "CC" "\
Varenv indicating the C compiler to use." :type 'string :group 'compile-c)

(defcustom cc-cflags-varenv "CFLAGS" "\
Varenv indicating the C compiler flags to use." :type 'string :group 'compile-c)

(defcustom cc-source-ext-list '("c") "\
Extensions for C compilable source files." :type '(repeat string) :group 'compile-c)

(defcustom cc-headers-ext-list '("h") "\
Extensions for C headers source files." :type '(repeat string) :group 'compile-c)

(defcustom cc-default-compiler-options "-g" "\
*Default options to give to the C compiler.

This could be any form evaluating to a string.
See `mode-compile-chosen-compiler' variable." :type '(choice string (sexp :tag "Form evaluating to a string")) :group 'compile-c)

(defcustom cc-source-file-ext-regexp "\\.c" "\
Regexp to find, from its name, if a C file is compilable." :type 'string :group 'compile-c)

(defcustom cc-build-output-args t "\
Build output-args for c-mode." :type 'boolean :group 'compile-c)

(defcustom cc-object-file-ext "o" "\
Extension of objects file (result of compilation)
in c mode." :type 'string :group 'compile-c)

(defgroup compile-java nil "Java compilation options." :group 'compilation-lang)

(defcustom java-compilers-list '("javac") "\
List of user's favourite java compilers in order of preference." :type '(repeat (string :tag "Java Compiler name")) :group 'compile-java)

(defcustom java-companion-file-regexp "" "\
Regexp to find associated compilable Java companion file.

This is useless in Java because there do not exist uncompilable files." :type 'regexp :group 'compile-java)

(defcustom java-default-compiler "javac" "\
*Default C compiler to use when everything else fails.

This could be any form evaluating to a string, so you could map it to
a function asking you interactively to choose the compiler.

example:
 (defun my-choose-compiler()
   (read-string \"Java compiler: \"))
 (setq java-default-compiler 'my-choose-compiler)." :type '(choice string function) :group 'compile-java)

(defcustom java-compiler-varenv "JAVAC" "\
Varenv indicating the C compiler to use." :type 'string :group 'compile-java)

(defcustom java-cflags-varenv "JAVAC_FLAGS" "\
Varenv indicating the C compiler flags to use." :type 'string :group 'compile-java)

(defcustom java-source-ext-list '("java") "\
Extensions for Java compilable source files." :type '(repeat string) :group 'compile-java)

(defcustom java-headers-ext-list '("java") "\
Extensions for Java source files." :type '(repeat string) :group 'compile-java)

(defcustom java-default-compiler-options "-O" "\
*Default options to give to the Java compiler.

This could be any form evaluating to a string.  See
`mode-compile-chosen-compiler' variable." :type '(choice string (sexp :tag "Form evaluating to a string")) :group 'compile-java)

(defcustom java-source-file-ext-regexp "\\.java" "\
Regexp to find, from its name, if a Java file is compilable." :type 'regexp :group 'compile-java)

(defcustom java-build-output-args nil "\
Don't build output-args for Java-mode." :type 'boolean :group 'compile-java)

(defcustom java-object-file-ext "class" "\
Extension of objects file (result of compilation)
in java mode." :type 'string :group 'compile-java)

(defgroup compile-c++ nil "C++ compilation options" :group 'compilation-lang)

(defcustom c++-compilers-list '("g++" "gcc" "CC") "\
List of user's favourite C++ compilers in order of preference." :type '(repeat (string :tag "C++ Compiler name")) :group 'compile-c++)

(defcustom c++-companion-file-regexp "\\(_[Pp]\\)?\\.\\([pP]?[Hh][Hh]?\\|[Hh]\\+\\+?\\)" "\
Regexp to find associated compilable C++ companion file
from a header file." :type 'regexp :group 'compile-c++)

(defcustom c++-default-compiler "CC" "\
*Default C++ compiler to use when everything else fails..

This could be any form evaluating to a string, so you could map it to
a function asking you interactively to choose the compiler.

example:
 (defun my-choose-compiler()
   (read-string \"C++ compiler: \"))
 (setq c++-default-compiler 'my-choose-compiler)" :type '(choice string function) :group 'compile-c++)

(defcustom c++-compiler-varenv "CXX" "\
Varenv indicating the C++ compiler to use." :type 'string :group 'compile-c++)

(defcustom c++-cflags-varenv "CXXFLAGS" "\
Varenv indicating the C++ compiler flags to use." :type 'string :group 'compile-c++)

(defcustom c++-source-ext-list '("cc" "C" "CC" "cpp" "cxx" "c++" "c+") "\
Extensions for C++ compilable source files." :type '(repeat string) :group 'compile-c++)

(defcustom c++-headers-ext-list '("H" "hh" "HH" "h++" "h+" "h" "hpp" "hxx") "\
Extensions for C++ headers source files." :type '(repeat string) :group 'compile-c++)

(defcustom c++-default-compiler-options "-g" "\
*Default options to give to the C++ compiler.
This could be any form evaluating to a string.  See
`mode-compile-chosen-compiler' variable." :type '(choice string (sexp :tag "Form evaluating to a string")) :group 'compile-c++)

(defcustom c++-source-file-ext-regexp "\\.\\(cc\\|CC?\\|c\\+\\+?\\|cpp\\|cxx\\)" "\
Regexp to find, from its name, if a C++ file is compilable." :type 'regexp :group 'compile-c++)

(defcustom c++-build-output-args t "\
Build output-args for c++-mode." :type 'boolean :group 'compile-c++)

(defcustom c++-object-file-ext "o" "\
Extension of objects file (result of compilation)
in c++ mode." :type 'string :group 'compile-c++)

(defgroup compile-ada nil "Ada compilation options" :group 'compilation-lang)

(defcustom ada-compilers-list '("gcc" "gnat" "ada") "\
List of user's favourite Ada compilers in order of preference." :type '(repeat (string :tag "Ada Compiler name")) :group 'compile-ada)

(defcustom ada-companion-file-regexp "" "\
Regexp to find associated compilable Ada companion file from a spec file.

This is useless in Ada because there do not exist uncompilable files." :type 'regexp :group 'compile-ada)

(defcustom ada-default-compiler "ada" "\
*Default Ada compiler to use when everything else fails.

This could be any form evaluating to a string, so you could map it to
a function asking you interactively to choose the compiler.

example:
 (defun my-choose-compiler()
   (read-string \"Ada compiler: \"))
 (setq ada-default-compiler 'my-choose-compiler)" :type '(choice string function) :group 'compile-ada)

(defcustom ada-compiler-varenv "ADA" "\
Varenv indicating the Ada compiler to use." :type 'string :group 'compile-ada)

(defcustom ada-aflags-varenv "AFLAGS" "\
Varenv indicating the Ada compiler flags to use." :type 'string :group 'compile-ada)

(defcustom ada-source-ext-list '("ads" "adb" "ada" "a") "\
Extensions for Ada compilable source files." :type '(repeat string) :group 'compile-ada)

(defcustom ada-headers-ext-list '("ads" "ada" "a") "\
Extensions for Ada spec source files." :type '(repeat string) :group 'compile-ada)

(defcustom ada-default-compiler-options "-g" "\
*Default options to give to the Ada compiler.

This could be any form evaluating to a string.  See
`mode-compile-chosen-compiler' variable." :type '(choice string (sexp :tag "Form evaluating to a string")) :group 'compile-ada)

(defcustom ada-source-file-ext-regexp "\\.\\(ad[abs]\\|a\\)" "\
Regexp to find, from its name, if an Ada file is compilable.

This is useless in Ada because there do not exist uncompilable files." :type 'regexp :group 'compile-ada)

(defcustom ada-build-output-args t "\
Build output-args for ada-mode." :type 'boolean :group 'compile-ada)

(defcustom ada-object-file-ext "o" "\
Extension of objects file (result of compilation)
in ada mode." :type 'string :group 'compile-ada)

(defgroup compile-fortran nil "Fortran compilation options" :group 'compilation-lang)

(defcustom f77-compilers-list '("f77" "fc") "\
List of user's favourite Fortran compilers in order of preference." :type '(repeat (string :tag "C Compiler name")) :group 'compile-fortran)

(defcustom f77-companion-file-regexp "\\(_[Pp]\\)?\\.[pP]?inc" "\
Regexp to find associated .f file from a .inc." :type 'regexp :group 'compile-fortran)

(defcustom f77-default-compiler "f77" "\
*Default fortran compiler to use when everything else fails..

This could be any form evaluating to a string, so you could map it to
a function asking you interactively to choose the compiler.

example:
 (defun my-choose-compiler()
   (read-string \"Fortran compiler: \"))
 (setq f77-default-compiler 'my-choose-compiler)" :type '(choice string function) :group 'compile-fortran)

(defcustom f77-compiler-varenv "F77" "\
Varenv indicating the fortran compiler to use." :type 'string :group 'compile-fortran)

(defcustom f77-cflags-varenv "FCOPTS" "\
Varenv indicating the fortran compiler flags to use." :type 'string :group 'compile-fortran)

(defcustom f77-source-ext-list '("f" "F" "for" "For") "\
Extensions for fortran compilable source files." :type '(repeat string) :group 'compile-fortran)

(defcustom f77-headers-ext-list '("inc" "h") "\
Extensions for fortran include files." :type '(repeat string) :group 'compile-fortran)

(defcustom f77-default-compiler-options "-w66 -a" "\
*Default options to give to the fortran compiler.

This could be any form evaluating to a string.  See
`mode-compile-chosen-compiler' variable." :type '(choice string (sexp :tag "Form evaluating to a string")) :group 'compile-fortran)

(defcustom f77-source-file-ext-regexp "\\.\\([Ff]\\|for\\)" "\
Regexp to find, from its name, if a fortran file is compilable." :type 'regexp :group 'compile-fortran)

(defcustom f77-build-output-args t "\
Build output-args for f77-mode." :type 'boolean :group 'compile-fortran)

(defcustom f77-object-file-ext "o" "\
Extension of objects file (result of compilation)
in Fortran mode." :type 'string :group 'compile-fortran)

(defgroup compile-sh nil "Sh (Bourne Shell scripts) compilation options" :group 'compilation-script)

(defcustom sh-command "sh" "\
Command to run sh scripts" :type 'string :group 'compile-sh)

(defcustom sh-dbg-flags "-fvx" "\
*Flags to give to sh for debugging a Bourne Shell script.

The -f flag must always be present." :type 'string :group 'compile-sh)

(defgroup compile-csh nil "Csh (C Shell) compilation options" :group 'compilation-script)

(defcustom csh-command "csh" "\
Command to run csh scripts" :type 'string :group 'compile-csh)

(defcustom csh-dbg-flags "-fVX" "\
*Flags to give to csh for debugging a C Shell script.

The -f flag must always be present." :type 'string :group 'compile-csh)

(defgroup compile-zsh nil "Zsh (Z Shell scripts) compilation options" :group 'compilation-script)

(defcustom zsh-command "zsh" "\
Command to run zsh scripts" :type 'string :group 'compile-zsh)

(defcustom zsh-dbg-flags "-nCvx" "\
*Flags to give to zsh for debugging a Z Shell script." :type 'string :group 'compile-zsh)

(defgroup compile-tcl nil "Tcl compilation options" :group 'compilation-script)

(defcustom tcl-command "wish" "\
Command to run tcl scripts" :type 'string :group 'compile-tcl)

(defcustom tcl-dbg-flags "" "\
*Flags to give to tcl -- none." :type 'string :group 'compile-tcl)

(defgroup compile-python nil "Python compilation options" :group 'compilation-script)

(defcustom python-command "python" "\
Command to run python scripts" :type 'string :group 'compile-python)

(defcustom python-dbg-flags "" "\
*Flags to give to python -- none." :type 'string :group 'compile-python)

(defgroup compile-perl nil "Perl compilation options" :group 'compilation-script)

(defcustom perl-command "perl" "\
Command to run perl." :type 'string :group 'compile-perl)

(defcustom perl-dbg-flags "-w" "\
*Flags to give to perl for debugging a Perl script." :type 'string :group 'compile-perl)

(defcustom emacs-lisp-byte-compile-dir-interactive-p t "\
*Non-nil means when byte-compiling a directory ask for each file
needing to be recompiled or not." :type 'boolean :group 'compilation-elisp)

(defcustom emacs-lisp-sources-regexp (cond ((boundp 'emacs-lisp-file-regexp) emacs-lisp-file-regexp) (t "\\.el$")) "\
Regexp to find emacs lisp sources files." :type 'regexp :group 'compilation-elisp)

(defcustom emacs-lisp-bytecomp-ext "c" "\
Extension added to byte-compiled emacs sources files." :type 'string :group 'compilation-elisp)

;;;***

;;;### (autoloads (m2-indent m2-end-comment-column m2-link-name m2-link-command m2-compile-command modula2) "modula2" "prog-modes/modula2.el")
(defconst custom-define-current-source-file "modula2.el")

(defgroup modula2 nil "Major mode for editing Modula-2 code." :prefix "m2-" :group 'languages)

(defcustom m2-compile-command "m2c" "\
Command to compile Modula-2 programs." :type 'string :group 'modula2)

(defcustom m2-link-command "m2l" "\
Command to link Modula-2 programs." :type 'string :group 'modula2)

(defcustom m2-link-name nil "\
Name of the Modula-2 executable." :type '(choice (const nil) string) :group 'modula2)

(defcustom m2-end-comment-column 75 "\
*Column for aligning the end of a comment, in Modula-2." :type 'integer :group 'modula2)

(defcustom m2-indent 5 "\
*This variable gives the indentation in Modula-2-Mode." :type 'integer :group 'modula2)

;;;***

;;;### (autoloads (c-backslash-column c-tab-always-indent c-auto-newline c-continued-brace-offset c-continued-statement-offset c-label-offset c-argdecl-indent c-brace-offset c-brace-imaginary-offset c-indent-level c-comment-prefix-regexp old-c) "old-c-mode" "prog-modes/old-c-mode.el")
(defconst custom-define-current-source-file "old-c-mode.el")

(defgroup old-c nil "Old C code editing commands for Emacs." :prefix "c-")

(defcustom c-comment-prefix-regexp '((pike-mode . "//+!?\\|\\**") (other . "//+\\|\\**")) "\
*Regexp to match the line prefix inside comments.
This regexp is used to recognize the fill prefix inside comments for
correct paragraph filling and other things.

If this variable is a string, it will be used in all CC Mode major
modes.  It can also be an association list, to associate specific
regexps to specific major modes.  The symbol for the major mode is
looked up in the association list, and its value is used as the line
prefix regexp.  If it's not found, then the symbol `other' is looked
up and its value is used instead.

The regexp should match the prefix used in both C++ style line
comments and C style block comments, but it does not need to match a
block comment starter.  In other words, it should at least match
\"//\" for line comments and the string in `c-block-comment-prefix',
which is sometimes inserted by CC Mode inside block comments.  It
should not match any surrounding whitespace.

Note that CC Mode modifies other variables from this one at mode
initialization, so you will need to do \\[c-mode] (or whatever mode
you're currently using) if you change it in a CC Mode buffer." :type '(radio (regexp :tag "Regexp for all modes") (list :tag "Mode-specific regexps" (set :inline t :format "%v" (cons :format "%v" (const :format "C     " c-mode) (regexp :format "%v")) (cons :format "%v" (const :format "C++   " c++-mode) (regexp :format "%v")) (cons :format "%v" (const :format "ObjC  " objc-mode) (regexp :format "%v")) (cons :format "%v" (const :format "Java  " java-mode) (regexp :format "%v")) (cons :format "%v" (const :format "IDL   " idl-mode) (regexp :format "%v")) (cons :format "%v" (const :format "Pike  " pike-mode) (regexp :format "%v"))) (cons :format "    %v" (const :format "Other " other) (regexp :format "%v")))) :group 'old-c)

(defcustom c-indent-level 2 "\
*Indentation of C statements with respect to containing block." :type 'integer :group 'old-c)

(defcustom c-brace-imaginary-offset 0 "\
*Imagined indentation of a C open brace that actually follows a statement." :type 'integer :group 'old-c)

(defcustom c-brace-offset 0 "\
*Extra indentation for braces, compared with other text in same context." :type 'integer :group 'old-c)

(defcustom c-argdecl-indent 5 "\
*Indentation level of declarations of C function arguments." :type 'integer :group 'old-c)

(defcustom c-label-offset -2 "\
*Offset of C label lines and case statements relative to usual indentation." :type 'integer :group 'old-c)

(defcustom c-continued-statement-offset 2 "\
*Extra indent for lines not starting new statements." :type 'integer :group 'old-c)

(defcustom c-continued-brace-offset 0 "\
*Extra indent for substatements that start with open-braces.
This is in addition to `c-continued-statement-offset'." :type 'integer :group 'old-c)

(defcustom c-auto-newline nil "\
*Non-nil means automatically newline before and after braces,
and after colons and semicolons, inserted in C code.
If you do not want a leading newline before braces then use:
  (define-key c-mode-map \"{\" 'electric-c-semi)" :type 'boolean :group 'old-c)

(defcustom c-tab-always-indent t "\
*Non-nil means TAB in C mode should always reindent the current line,
regardless of where in the line point is when the TAB command is used." :type 'boolean :group 'old-c)

(defcustom c-backslash-column 48 "\
*Minimum column for end-of-line backslashes of macro definitions." :type 'integer :group 'old-c)

;;;***

;;;### (autoloads (p4-exec-arg-len-max p4-window-config-stack-size p4-file-refresh-timer-time p4-cleanup-cache p4-cleanup-time p4-do-find-file p4-notify p4-user-email p4-sendmail-program p4-strict-complete p4-mode-hook p4-follow-symlinks p4-verbose p4-check-empty-diffs p4-auto-refresh p4-use-p4config-exclusively p4-colorized-diffs p4-default-depot-completion-prefix p4-default-diff-options p4) "p4" "prog-modes/p4.el")
(defconst custom-define-current-source-file "p4.el")

(defgroup p4 nil "Perforce VC System." :group 'tools)

(defcustom p4-default-diff-options "-du" "\
Type of p4 diff output to be displayed. (regular or context or
unified.)" :type 'string :group 'p4)

(defcustom p4-default-depot-completion-prefix "//depot/" "\
Prefix to be used for completion prompt when prompting user for a depot
file." :type 'string :group 'p4)

(defcustom p4-colorized-diffs t "\
Set this to nil to disable colorized diffs." :type 'boolean :group 'p4)

(defcustom p4-use-p4config-exclusively nil "\
Whether P4 mode should use P4CONFIG exclusively to check whether a file
is under P4 version control. If set to nil, `p4-check-mode' is always
called; otherwise, it checks to see if the file named by P4CONFIG exists in
this or a parent directory, and if so, only then runs p4-check-mode.

This provides for a much faster `p4-find-file-hook'." :type 'boolean :group 'p4)

(defcustom p4-auto-refresh t "\
Set this to automatically refresh p4 submitted files in buffers." :type 'boolean :group 'p4)

(defcustom p4-check-empty-diffs t "\
Set this to check for files with empty diffs before submitting." :type 'boolean :group 'p4)

(defcustom p4-verbose t "\
When set, p4 will pop up the output buffer with the result of the
command." :type 'boolean :group 'p4)

(defcustom p4-follow-symlinks nil "\
When set, p4 will call `file-truename' on all opened files." :type 'boolean :group 'p4)

(defcustom p4-mode-hook nil "\
Hook run by `p4-mode'." :type 'sexp :group 'p4)

(defcustom p4-strict-complete t "\
Set this variable in .emacs (or using `customize') if you want to alter
the completion behavior of `p4-set-client-name'.
" :type 'boolean :group 'p4)

(defcustom p4-sendmail-program (if (boundp 'sendmail-program) sendmail-program nil) "\
The sendmail program. To set this use `customize'." :type 'string :group 'p4)

(defcustom p4-user-email (if (boundp 'user-mail-address) user-mail-address nil) "\
The e-mail address of the current user. This is used with the
notification system, and must be set if notification should take place. To
set this, use `customize'." :type 'string :group 'p4)

(defcustom p4-notify nil "\
If this is t then the users in the notification list set by
`p4-set-notify-list' will get a notification of any P4 change submitted from
within emacs." :type 'boolean :group 'p4)

(defcustom p4-do-find-file t "\
If non-nil, the `p4-find-file-hook' will run when opening files." :type 'boolean :group 'p4)

(defcustom p4-cleanup-time 600 "\
seconds after which `p4-cache-cleanup' will
check for dirty caches." :type 'integer :group 'p4)

(defcustom p4-cleanup-cache t "\
`p4-cache-cleanup' will cleanup the
branches/clients/dirs/labels caches once in a while if this is non-nil." :type 'boolean :group 'p4)

(defcustom p4-file-refresh-timer-time 60 "\
seconds after which
`p4-file-refresh' will check for modified files in Emacs buffers. Set this
variable to 0 to disable periodic refreshing." :type 'integer :group 'p4)

(defcustom p4-window-config-stack-size 20 "\
Maximum stack size
for saved window configurations." :type 'integer :group 'p4)

(defcustom p4-exec-arg-len-max 20000 "\
Maximum total length of all
arguments to p4 commands." :type 'integer :group 'p4)

;;;***

;;;### (autoloads (pascal-separator-keywords pascal-start-keywords pascal-type-keywords pascal-toggle-completions pascal-auto-lineup pascal-auto-endcomments pascal-tab-always-indent pascal-auto-newline pascal-case-indent pascal-indent-level pascal) "pascal" "prog-modes/pascal.el")
(defconst custom-define-current-source-file "pascal.el")

(defgroup pascal nil "Major mode for editing Pascal source in Emacs" :group 'languages)

(defcustom pascal-indent-level 3 "\
*Indentation of Pascal statements with respect to containing block." :type 'integer :group 'pascal)

(defcustom pascal-case-indent 2 "\
*Indentation for case statements." :type 'integer :group 'pascal)

(defcustom pascal-auto-newline nil "\
*Non-nil means automatically newline after semicolons and the punctuation
mark after an end." :type 'boolean :group 'pascal)

(defcustom pascal-tab-always-indent t "\
*Non-nil means TAB in Pascal mode should always reindent the current line,
regardless of where in the line point is when the TAB command is used." :type 'boolean :group 'pascal)

(defcustom pascal-auto-endcomments t "\
*Non-nil means a comment { ... } is set after the ends which ends cases and
functions. The name of the function or case will be set between the braces." :type 'boolean :group 'pascal)

(defcustom pascal-auto-lineup '(all) "\
*List of contexts where auto lineup of :'s or ='s should be done.
Elements can be of type: 'paramlist', 'declaration' or 'case', which will
do auto lineup in parameterlist, declarations or case-statements
respectively. The word 'all' will do all lineups. '(case paramlist) for
instance will do lineup in case-statements and parameterlist, while '(all)
will do all lineups." :type '(repeat (choice (const all) (const paramlist) (const declaration) (const case))) :group 'pascal)

(defcustom pascal-toggle-completions nil "\
*Non-nil means that repeated use of \\<pascal-mode-map>\\[pascal-complete-word] will toggle the possible
completions in the minibuffer.  Normally, when there is more than one possible
completion, a buffer will display all completions." :type 'boolean :group 'pascal)

(defcustom pascal-type-keywords '("array" "file" "packed" "char" "integer" "real" "string" "record") "\
*Keywords for types used when completing a word in a declaration or parmlist.
\(eg. integer, real, char.)  The types defined within the Pascal program
will be completed runtime, and should not be added to this list." :type '(repeat (string :tag "Keyword")) :group 'pascal)

(defcustom pascal-start-keywords '("begin" "end" "function" "procedure" "repeat" "until" "while" "read" "readln" "reset" "rewrite" "write" "writeln") "\
*Keywords to complete when standing at the first word of a statement.
\(eg. begin, repeat, until, readln.)
The procedures and variables defined within the Pascal program
will be completed runtime and should not be added to this list." :type '(repeat (string :tag "Keyword")) :group 'pascal)

(defcustom pascal-separator-keywords '("downto" "else" "mod" "div" "then") "\
*Keywords to complete when NOT standing at the first word of a statement.
\(eg. downto, else, mod, then.) 
Variables and function names defined within the
Pascal program are completed runtime and should not be added to this list." :type '(repeat (string :tag "Keyword")) :group 'pascal)

;;;***

;;;### (autoloads (php-mode-force-pear php-mode-user-hook php-file-patterns php-search-url php-manual-url php-mode-speedbar-open php-speedbar-config php) "php-mode" "prog-modes/php-mode.el")
(defconst custom-define-current-source-file "php-mode.el")

(defgroup php nil "Major mode for editing PHP code." :prefix "php-" :group 'languages)

(defcustom php-speedbar-config t "\
*When set to true automatically configures Speedbar to observe PHP files.Ignores php-file patterns option; fixed to expression \"\\.\\(inc\\|php[s34]?\\)\"" :type 'boolean :group 'php)

(defcustom php-mode-speedbar-open nil "\
Normally php-mode starts with the speedbar closed.Turning this on will open it whenever php-mode is loaded." :type 'boolean :group 'php)

(defcustom php-manual-url "http://www.php.net/manual/en/manual.php" "\
*URL at which to find PHP manual.You can replace \"en\" with your ISO language code." :type 'string :group 'php)

(defcustom php-search-url "http://www.php.net/" "\
*URL at which to search for documentation on a word" :type 'string :group 'php)

(defcustom php-file-patterns (list "\\.php[s34]?\\'" "\\.phtml\\'" "\\.inc\\'") "\
*List of file patterns for which to automatically invoke php-mode." :type '(repeat (regexp :tag "Pattern")) :group 'php)

(defcustom php-mode-user-hook nil "\
List of functions to be executed on entry to php-mode" :type 'hook :group 'php)

(defcustom php-mode-force-pear nil "\
Normally PEAR coding rules are enforced only when the filename contains \"PEAR\"Turning this on will force PEAR rules on all PHP files." :type 'boolean :group 'php)

;;;***

;;;### (autoloads (prolog-indent-width prolog-eof-string prolog-compile-string prolog-consult-string prolog-program-name prolog) "prolog" "prog-modes/prolog.el")
(defconst custom-define-current-source-file "prolog.el")

(defgroup prolog nil "Major mode for editing and running Prolog under Emacs" :group 'languages)

(defcustom prolog-program-name "prolog" "\
*Program name for invoking an inferior Prolog with `run-prolog'." :type 'string :group 'prolog)

(defcustom prolog-consult-string "reconsult(user).\n" "\
*(Re)Consult mode (for C-Prolog and Quintus Prolog). " :type 'string :group 'prolog)

(defcustom prolog-compile-string "compile(user).\n" "\
*Compile mode (for Quintus Prolog)." :type 'string :group 'prolog)

(defcustom prolog-eof-string "end_of_file.\n" "\
*String that represents end of file for prolog.
nil means send actual operating system end of file." :type 'string :group 'prolog)

(defcustom prolog-indent-width 4 "\
Level of indentation in Prolog buffers." :type 'integer :group 'prolog)

;;;***

;;;### (autoloads (rexx-special-regexp rexx-tab-always-indent rexx-comment-col rexx-cont-indent rexx-end-indent rexx-indent rexx) "rexx-mode" "prog-modes/rexx-mode.el")
(defconst custom-define-current-source-file "rexx-mode.el")

(defgroup rexx nil "Major mode for editing REXX program files" :group 'languages)

(defcustom rexx-indent 8 "\
*This variable contains the indentation in rexx-mode." :type 'integer :group 'rexx)

(defcustom rexx-end-indent 0 "\
*This variable indicates the relative position of the \"end\" in REXX mode." :type 'integer :group 'rexx)

(defcustom rexx-cont-indent 8 "\
*This variable indicates how far a continued line shall be intended." :type 'integer :group 'rexx)

(defcustom rexx-comment-col 32 "\
*This variable gives the desired comment column 
for comments to the right of text." :type 'integer :group 'rexx)

(defcustom rexx-tab-always-indent t "\
*Non-nil means TAB in REXX mode should always reindent the current line,
regardless of where in the line point is when the TAB command is used." :type 'boolean :group 'rexx)

(defcustom rexx-special-regexp ".*\\(,\\|then\\|else\\)[ 	]*\\(/\\*.*\\*/\\)?[ 	]*$" "\
*Regular expression for parsing lines which shall be followed by
a extra indention" :type 'regexp :group 'rexx)

;;;***

;;;### (autoloads (rpm-spec-faces rpm-spec-default-clean-section rpm-spec-default-install-section rpm-spec-default-build-section rpm-spec-default-buildroot rpm-spec-default-epoch rpm-spec-default-release rpm-spec-use-compilation-mode rpm-spec-indent-heading-values rpm-spec-user-mail-address rpm-spec-user-full-name rpm-spec-insert-changelog-version rpm-spec-initialize-sections rpm-spec-nodeps rpm-spec-sign-gpg rpm-spec-quiet rpm-spec-nobuild rpm-spec-rmsource rpm-spec-clean rpm-spec-completion-ignore-case rpm-spec-target rpm-spec-buildroot rpm-spec-timecheck rpm-spec-short-circuit rpm-spec-add-attr rpm-spec-build-command rpm-spec) "rpm-spec-mode" "prog-modes/rpm-spec-mode.el")
(defconst custom-define-current-source-file "rpm-spec-mode.el")

(defgroup rpm-spec nil "RPM spec mode with Emacs/XEmacs enhancements." :prefix "rpm-spec-" :group 'languages)

(defcustom rpm-spec-build-command "rpmbuild" "\
Command for building an RPM package." :type 'string :group 'rpm-spec)

(defcustom rpm-spec-add-attr nil "\
Add \"%attr\" entry for file listings or not." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-short-circuit nil "\
Skip straight to specified stage.
\(ie, skip all stages leading up to the specified stage).  Only valid
in \"%build\" and \"%install\" stage." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-timecheck "0" "\
Set the \"timecheck\" age (0 to disable).
The timecheck value expresses, in seconds, the maximum age of a file
being packaged.  Warnings will be printed for all files beyond the
timecheck age." :type 'integer :group 'rpm-spec)

(defcustom rpm-spec-buildroot "" "\
When building, override the BuildRoot tag with directory <dir>." :type 'string :group 'rpm-spec)

(defcustom rpm-spec-target "" "\
Interpret given string as `arch-vendor-os'.
Set the macros _target, _target_arch and _target_os accordingly" :type 'string :group 'rpm-spec)

(defcustom rpm-spec-completion-ignore-case t "\
*Non-nil means that case differences are ignored during completion.
A value of nil means that case is significant.
This is used during Tempo template completion." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-clean nil "\
Remove the build tree after the packages are made." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-rmsource nil "\
Remove the source and spec file after the packages are made." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-nobuild nil "\
Do not execute any build stages.  Useful for testing out spec files." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-quiet nil "\
Print as little as possible.
Normally only error messages will be displayed." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-sign-gpg nil "\
Embed a GPG signature in the package.
This signature can be used to verify the integrity and the origin of
the package." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-nodeps nil "\
Do not verify build dependencies." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-initialize-sections t "\
Automatically add empty section headings to new spec files." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-insert-changelog-version t "\
Automatically add version in a new change log entry." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-user-full-name nil "\
*Full name of the user.
This is used in the change log and the Packager tag.  It defaults to the
value returned by function `user-full-name'." :type '(choice (const :tag "Use `user-full-name'" nil) string) :group 'rpm-spec)

(defcustom rpm-spec-user-mail-address nil "\
*Email address of the user.
This is used in the change log and the Packager tag.  It defaults to the
value returned by function `user-mail-address'." :type '(choice (const :tag "Use `user-mail-address'" nil) string) :group 'rpm-spec)

(defcustom rpm-spec-indent-heading-values nil "\
*Indent values for all tags in the \"heading\" of the spec file." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-use-compilation-mode t "\
*If non-nil, build in `compilation-mode' if it's available." :type 'boolean :group 'rpm-spec)

(defcustom rpm-spec-default-release "1" "\
*Default value for the Release tag in new spec files." :type 'string :group 'rpm-spec)

(defcustom rpm-spec-default-epoch nil "\
*If non-nil, default value for the Epoch tag in new spec files." :type '(choice (const :tag "No Epoch" nil) integer) :group 'rpm-spec)

(defcustom rpm-spec-default-buildroot "%{_tmppath}/%{name}-%{version}-%{release}-root" "\
*Default value for the BuildRoot tag in new spec files." :type 'integer :group 'rpm-spec)

(defcustom rpm-spec-default-build-section "" "\
*Default %build section in new spec files." :type 'string :group 'rpm-spec)

(defcustom rpm-spec-default-install-section "rm -rf $RPM_BUILD_ROOT\n" "\
*Default %install section in new spec files." :type 'string :group 'rpm-spec)

(defcustom rpm-spec-default-clean-section "rm -rf $RPM_BUILD_ROOT\n" "\
*Default %clean section in new spec files." :type 'string :group 'rpm-spec)

(defgroup rpm-spec-faces nil "Font lock faces for `rpm-spec-mode'." :prefix "rpm-spec-" :group 'rpm-spec :group 'faces)

;;;***

;;;### (autoloads (simula-abbrev-file simula-abbrev-stdproc simula-abbrev-keyword simula-electric-indent simula-inspect-indent simula-if-indent simula-label-offset simula-continued-statement-offset simula-substatement-offset simula-indent-level simula-tab-always-indent simula) "simula" "prog-modes/simula.el")
(defconst custom-define-current-source-file "simula.el")

(defgroup simula nil "SIMULA 87 code editing commands for Emacs." :group 'languages)

(defcustom simula-tab-always-indent nil "\
*Non-nil means TAB in SIMULA mode should always reindent the current line.
Otherwise TAB indents only when point is within
the run of whitespace at the beginning of the line." :type 'boolean :group 'simula)

(defcustom simula-indent-level 3 "\
*Indentation of SIMULA statements with respect to containing block." :type 'integer :group 'simula)

(defcustom simula-substatement-offset 3 "\
*Extra indentation after DO, THEN, ELSE, WHEN and OTHERWISE." :type 'integer :group 'simula)

(defcustom simula-continued-statement-offset 3 "\
*Extra indentation for lines not starting a statement or substatement.
If value is a list, each line in a multipleline continued statement
will have the car of the list extra indentation with respect to
the previous line of the statement." :type 'integer :group 'simula)

(defcustom simula-label-offset -4711 "\
*Offset of SIMULA label lines relative to usual indentation." :type 'integer :group 'simula)

(defcustom simula-if-indent '(0 . 0) "\
*Extra indentation of THEN and ELSE with respect to the starting IF.
Value is a cons cell, the car is extra THEN indentation and the cdr
extra ELSE indentation.  IF after ELSE is indented as the starting IF." :type '(cons (integer :tag "THEN") (integer :tag "ELSE")) :group 'simula)

(defcustom simula-inspect-indent '(0 . 0) "\
*Extra indentation of WHEN and OTHERWISE with respect to the INSPECT.
Value is a cons cell, the car is extra WHEN indentation
and the cdr extra OTHERWISE indentation." :type '(cons (integer :tag "WHEN") (integer :tag "OTHERWISE")) :group 'simula)

(defcustom simula-electric-indent nil "\
*Non-nil means `simula-indent-line' function may reindent previous line." :type 'boolean :group 'simula)

(defcustom simula-abbrev-keyword 'upcase "\
*Specify how to convert case for SIMULA keywords.
Value is one of the symbols `upcase', `downcase', `capitalize',
\(as in) `abbrev-table' or nil if they should not be changed." :type '(choice (const upcase) (const downcase) (const capitalize) (const abbrev-table) (const nil)) :group 'simula)

(defcustom simula-abbrev-stdproc 'abbrev-table "\
*Specify how to convert case for standard SIMULA procedure and class names.
Value is one of the symbols `upcase', `downcase', `capitalize',
\(as in) `abbrev-table', or nil if they should not be changed." :type '(choice (const upcase) (const downcase) (const capitalize) (const abbrev-table) (const nil)) :group 'simula)

(defcustom simula-abbrev-file nil "\
*File with extra abbrev definitions for use in SIMULA mode.
These are used together with the standard abbrev definitions for SIMULA.
Please note that the standard definitions are required
for SIMULA mode to function correctly." :type '(choice (const :tag "None") file) :group 'simula)

;;;***

;;;### (autoloads (sql-linter-options sql-linter-program sql-db2-options sql-db2-program sql-interbase-options sql-interbase-program sql-postgres-options sql-postgres-program sql-ms-options sql-ms-program sql-ingres-program sql-informix-program sql-sybase-options sql-sybase-program sql-solid-program sql-mysql-options sql-mysql-program sql-sqlite-options sql-sqlite-program sql-oracle-options sql-oracle-program sql-set-sqli-hook sql-mode-hook sql-interactive-mode-hook sql-input-ring-separator sql-input-ring-file-name sql-pop-to-buffer-after-send-region sql-electric-stuff sql-product sql-server sql-database sql-password sql-user SQL) "sql" "prog-modes/sql.el")
(defconst custom-define-current-source-file "sql.el")

(defgroup SQL nil "Running a SQL interpreter from within Emacs buffers" :version "20.4" :group 'processes)

(defcustom sql-user "" "\
*Default username." :type 'string :group 'SQL)

(defcustom sql-password "" "\
*Default password.

Storing your password in a textfile such as ~/.emacs could be dangerous.
Customizing your password will store it in your ~/.emacs file." :type 'string :group 'SQL)

(defcustom sql-database "" "\
*Default database." :type 'string :group 'SQL)

(defcustom sql-server "" "\
*Default server or host." :type 'string :group 'SQL)

(defcustom sql-product 'ansi "\
*Select the SQL database product used so that buffers can be
highlighted properly when you open them." :type '(choice (const :tag "ANSI" ansi) (const :tag "DB2" db2) (const :tag "Informix" informix) (const :tag "Ingres" ingres) (const :tag "Interbase" interbase) (const :tag "Linter" linter) (const :tag "Microsoft" ms) (const :tag "MySQL" mysql) (const :tag "Oracle" oracle) (const :tag "PostGres" postgres) (const :tag "Solid" solid) (const :tag "SQLite" sqlite) (const :tag "Sybase" sybase)) :group 'SQL)

(defcustom sql-electric-stuff nil "\
Treat some input as electric.
If set to the symbol `semicolon', then hitting `;' will send current
input in the SQLi buffer to the process.
If set to the symbol `go', then hitting `go' on a line by itself will
send current input in the SQLi buffer to the process.
If set to nil, then you must use \\[comint-send-input] in order to send
current input in the SQLi buffer to the process." :type '(choice (const :tag "Nothing" nil) (const :tag "The semikolon `;'" semicolon) (const :tag "The string `go' by itself" go)) :version "20.8" :group 'SQL)

(defcustom sql-pop-to-buffer-after-send-region nil "\
*If t, pop to the buffer SQL statements are sent to.

After a call to `sql-send-region' or `sql-send-buffer',
the window is split and the SQLi buffer is shown.  If this
variable is not nil, that buffer's window will be selected
by calling `pop-to-buffer'.  If this variable is nil, that
buffer is shown using `display-buffer'." :type 'boolean :group 'SQL)

(defcustom sql-input-ring-file-name nil "\
*If non-nil, name of the file to read/write input history.

You have to set this variable if you want the history of your commands
saved from one Emacs session to the next.  If this variable is set,
exiting the SQL interpreter in an SQLi buffer will write the input
history to the specified file.  Starting a new process in a SQLi buffer
will read the input history from the specified file.

This is used to initialize `comint-input-ring-file-name'.

Note that the size of the input history is determined by the variable
`comint-input-ring-size'." :type '(choice (const :tag "none" nil) (file)) :group 'SQL)

(defcustom sql-input-ring-separator "\n--\n" "\
*Separator between commands in the history file.

If set to \"\\n\", each line in the history file will be interpreted as
one command.  Multi-line commands are split into several commands when
the input ring is initialized from a history file.

This variable used to initialize `comint-input-ring-separator'.
`comint-input-ring-separator' is part of Emacs 21; if your Emacs
does not have it, setting `sql-input-ring-separator' will have no
effect.  In that case multiline commands will be split into several
commands when the input history is read, as if you had set
`sql-input-ring-separator' to \"\\n\"." :type 'string :group 'SQL)

(defcustom sql-interactive-mode-hook 'nil "\
*Hook for customizing `sql-interactive-mode'." :type 'hook :group 'SQL)

(defcustom sql-mode-hook 'nil "\
*Hook for customizing `sql-mode'." :type 'hook :group 'SQL)

(defcustom sql-set-sqli-hook 'nil "\
*Hook for reacting to changes of `sql-buffer'.

This is called by `sql-set-sqli-buffer' when the value of `sql-buffer'
is changed." :type 'hook :group 'SQL)

(defcustom sql-oracle-program "sqlplus" "\
*Command to start sqlplus by Oracle.

Starts `sql-interactive-mode' after doing some setup.

Under NT, \"sqlplus\" usually starts the sqlplus \"GUI\".  In order to
start the sqlplus console, use \"plus33\" or something similar.  You
will find the file in your Orant\\bin directory.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-oracle-options nil "\
*List of additional options for `sql-oracle-program'." :type '(repeat string) :version "20.8" :group 'SQL)

(defcustom sql-sqlite-program "sqlite" "\
*Command to start SQLite.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-sqlite-options nil "\
*List of additional options for `sql-sqlite-program'.
The following list of options is reported to make things work
on Windows: \"-C\" \"-t\" \"-f\" \"-n\"." :type '(repeat string) :version "20.8" :group 'SQL)

(defcustom sql-mysql-program "mysql" "\
*Command to start mysql by TcX.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-mysql-options nil "\
*List of additional options for `sql-mysql-program'.
The following list of options is reported to make things work
on Windows: \"-C\" \"-t\" \"-f\" \"-n\"." :type '(repeat string) :version "20.8" :group 'SQL)

(defcustom sql-solid-program "solsql" "\
*Command to start SOLID SQL Editor.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-sybase-program "isql" "\
*Command to start isql by SyBase.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-sybase-options nil "\
*List of additional options for `sql-sybase-program'.
Some versions of isql might require the -n option in order to work." :type '(repeat string) :version "20.8" :group 'SQL)

(defcustom sql-informix-program "dbaccess" "\
*Command to start dbaccess by Informix.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-ingres-program "sql" "\
*Command to start sql by Ingres.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-ms-program "osql" "\
*Command to start osql by Microsoft.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-ms-options '("-w" "300" "-n") "\
*List of additional options for `sql-ms-program'." :type '(repeat string) :version "22.1" :group 'SQL)

(defcustom sql-postgres-program "psql" "\
Command to start psql by Postgres.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-postgres-options '("-P" "pager=off") "\
*List of additional options for `sql-postgres-program'.
The default setting includes the -P option which breaks older versions
of the psql client (such as version 6.5.3).  The -P option is equivalent
to the --pset option.  If you want the psql to prompt you for a user
name, add the string \"-u\" to the list of options.  If you want to
provide a user name on the command line (newer versions such as 7.1),
add your name with a \"-U\" prefix (such as \"-Umark\") to the list." :type '(repeat string) :version "20.8" :group 'SQL)

(defcustom sql-interbase-program "isql" "\
*Command to start isql by Interbase.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-interbase-options nil "\
*List of additional options for `sql-interbase-program'." :type '(repeat string) :version "20.8" :group 'SQL)

(defcustom sql-db2-program "db2" "\
*Command to start db2 by IBM.

Starts `sql-interactive-mode' after doing some setup.

The program can also specify a TCP connection.  See `make-comint'." :type 'file :group 'SQL)

(defcustom sql-db2-options nil "\
*List of additional options for `sql-db2-program'." :type '(repeat string) :version "20.8" :group 'SQL)

(defcustom sql-linter-program "inl" "\
*Command to start inl by RELEX.

Starts `sql-interactive-mode' after doing some setup." :type 'file :group 'SQL)

(defcustom sql-linter-options nil "\
*List of additional options for `sql-linter-program'." :type '(repeat string) :version "21.3" :group 'SQL)

;;;***

;;;### (autoloads (inferior-tcl-mode-hook tcl-mode-hook inferior-tcl-source-command tcl-prompt-regexp tcl-command-switches tcl-application tcl-use-smart-word-finder tcl-help-directory-list tcl-electric-hash-style tcl-use-hairy-comment-detector tcl-tab-always-indent tcl-auto-newline tcl-continued-indent-level tcl-indent-level tcl) "tcl" "prog-modes/tcl.el")
(defconst custom-define-current-source-file "tcl.el")

(defgroup tcl nil "Major mode for editing Tcl source in Emacs" :group 'languages)

(defcustom tcl-indent-level 4 "\
*Indentation of Tcl statements with respect to containing block." :group 'tcl :type 'integer)

(defcustom tcl-continued-indent-level 4 "\
*Indentation of continuation line relative to first line of command." :group 'tcl :type 'integer)

(defcustom tcl-auto-newline nil "\
*Non-nil means automatically newline before and after braces you insert." :group 'tcl :type 'boolean)

(defcustom tcl-tab-always-indent t "\
*Control effect of TAB key.
If t (the default), always indent current line.
If nil and point is not in the indentation area at the beginning of
the line, a TAB is inserted.
Other values cause the first possible action from the following list
to take place:

  1. Move from beginning of line to correct indentation.
  2. Delete an empty comment.
  3. Move forward to start of comment, indenting if necessary.
  4. Move forward to end of line, indenting if necessary.
  5. Create an empty comment.
  6. Move backward to start of comment, indenting if necessary." :group 'tcl :type '(choice (const :tag "Always" t) (const :tag "Beginning only" nil) (const :tag "Maybe move or make or delete comment" 'tcl)))

(defcustom tcl-use-hairy-comment-detector t "\
*If not nil, use the more sophisticated, but slower, comment-delete method.
This variable is not effective in Emacs 18;
the fast function is always used in that version." :group 'tcl :type 'boolean)

(defcustom tcl-electric-hash-style 'smart "\
*Style of electric hash insertion to use.
Possible values are `backslash', meaning that `\\' quoting should be
done; `quote', meaning that `\"' quoting should be done; `smart',
meaning that the choice between `backslash' and `quote' should be
made depending on the number of hashes inserted; or nil, meaning that
no quoting should be done.  Any other value for this variable is
taken to mean `smart'.  The default is `smart'." :group 'tcl :type '(choice (const backslash) (const quote) (const smart) (const nil)))

(defcustom tcl-help-directory-list nil "\
*List of topmost directories containing TclX help files." :group 'tcl :type '(repeat directory))

(defcustom tcl-use-smart-word-finder t "\
*If not nil, use smart way to find current word, for Tcl help feature." :group 'tcl :type 'boolean)

(defcustom tcl-application "wish" "\
*Name of Tcl program to run in inferior Tcl mode." :group 'tcl :type 'string)

(defcustom tcl-command-switches nil "\
*List of switches to supply to the `tcl-application' program." :group 'tcl :type '(repeat string))

(defcustom tcl-prompt-regexp "^\\(% \\|\\)" "\
*If not nil, a regexp that will match the prompt in the inferior process.
If nil, the prompt is the name of the application with \">\" appended.

The default is \"^\\(% \\|\\)\", which will match the default primary
and secondary prompts for tclsh and wish." :group 'tcl :type 'regexp)

(defcustom inferior-tcl-source-command "source %s\n" "\
*Format-string for building a Tcl command to load a file.
This format string should use `%s' to substitute a file name
and should result in a Tcl expression that will command the
inferior Tcl to load that file.  The filename will be appropriately
quoted for Tcl." :group 'tcl :type 'string)

(defcustom tcl-mode-hook nil "\
Hook run on entry to Tcl mode.

Several functions exist which are useful to run from your
`tcl-mode-hook' (see each function's documentation for more
information):

  `tcl-guess-application'
    Guesses a default setting for `tcl-application' based on any
    \"#!\" line at the top of the file.
  `tcl-hashify-buffer'
    Quotes all \"#\" characters that don't correspond to actual
    Tcl comments.  (Useful when editing code not originally created
    with this mode).
  `tcl-auto-fill-mode'
    Auto-filling of Tcl comments.

Add functions to the hook with `add-hook':

   (add-hook 'tcl-mode-hook 'tcl-guess-application)

Emacs 18 users must use `setq' instead:

   (setq tcl-mode-hook (cons 'tcl-guess-application tcl-mode-hook))" :type 'hook :group 'tcl)

(defcustom inferior-tcl-mode-hook nil "\
Hook for customizing Inferior Tcl mode." :type 'hook :group 'tcl)

;;;***

;;;### (autoloads (verilog-before-getopt-flags-hook verilog-getopt-flags-hook verilog-before-delete-auto-hook verilog-delete-auto-hook verilog-before-auto-hook verilog-auto-hook verilog-mode-hook verilog-typedef-regexp verilog-auto-unused-ignore-regexp verilog-auto-output-ignore-regexp verilog-auto-inout-ignore-regexp verilog-auto-input-ignore-regexp verilog-auto-inst-column verilog-auto-inst-template-numbers verilog-auto-inst-vector verilog-auto-inst-param-value verilog-assignment-delay verilog-auto-reset-widths verilog-auto-sense-defines-constant verilog-auto-sense-include-inputs verilog-active-low-regexp verilog-library-extensions verilog-library-files verilog-library-directories verilog-library-flags verilog-auto-star-save verilog-auto-star-expand verilog-auto-save-policy verilog-auto-read-includes verilog-auto-endcomments verilog-highlight-grouping-keywords verilog-highlight-p1800-keywords verilog-auto-lineup verilog-minimum-comment-distance verilog-align-ifelse verilog-indent-begin-after-if verilog-tab-to-comment verilog-tab-always-indent verilog-auto-indent-on-newline verilog-auto-newline verilog-case-indent verilog-cexp-indent verilog-indent-level-directive verilog-indent-level-behavioral verilog-indent-lists verilog-indent-declaration-macros verilog-indent-level-declaration verilog-indent-level-module verilog-indent-level verilog-highlight-translate-off verilog-compiler verilog-simulator verilog-coverage verilog-linter verilog-mode-auto verilog-mode-actions verilog-mode-indent verilog-mode) "verilog-mode" "prog-modes/verilog-mode.el")
(defconst custom-define-current-source-file "verilog-mode.el")

(defgroup verilog-mode nil "Facilitates easy editing of Verilog source text." :version "22.2" :group 'languages)

(defgroup verilog-mode-indent nil "Customize indentation and highlighting of Verilog source text." :group 'verilog-mode)

(defgroup verilog-mode-actions nil "Customize actions on Verilog source text." :group 'verilog-mode)

(defgroup verilog-mode-auto nil "Customize AUTO actions when expanding Verilog source text." :group 'verilog-mode)

(defcustom verilog-linter "echo 'No verilog-linter set, see \"M-x describe-variable verilog-linter\"'" "\
*Unix program and arguments to call to run a lint checker on Verilog source.
Depending on the `verilog-set-compile-command', this may be invoked when
you type \\[compile].  When the compile completes, \\[next-error] will take
you to the next lint error." :type 'string :group 'verilog-mode-actions)

(defcustom verilog-coverage "echo 'No verilog-coverage set, see \"M-x describe-variable verilog-coverage\"'" "\
*Program and arguments to use to annotate for coverage Verilog source.
Depending on the `verilog-set-compile-command', this may be invoked when
you type \\[compile].  When the compile completes, \\[next-error] will take
you to the next lint error." :type 'string :group 'verilog-mode-actions)

(defcustom verilog-simulator "echo 'No verilog-simulator set, see \"M-x describe-variable verilog-simulator\"'" "\
*Program and arguments to use to interpret Verilog source.
Depending on the `verilog-set-compile-command', this may be invoked when
you type \\[compile].  When the compile completes, \\[next-error] will take
you to the next lint error." :type 'string :group 'verilog-mode-actions)

(defcustom verilog-compiler "echo 'No verilog-compiler set, see \"M-x describe-variable verilog-compiler\"'" "\
*Program and arguments to use to compile Verilog source.
Depending on the `verilog-set-compile-command', this may be invoked when
you type \\[compile].  When the compile completes, \\[next-error] will take
you to the next lint error." :type 'string :group 'verilog-mode-actions)

(defcustom verilog-highlight-translate-off nil "\
*Non-nil means background-highlight code excluded from translation.
That is, all code between \"// synopsys translate_off\" and
\"// synopsys translate_on\" is highlighted using a different background color
\(face `verilog-font-lock-translate-off-face').

Note: This will slow down on-the-fly fontification (and thus editing).

Note: Activate the new setting in a Verilog buffer by re-fontifying it (menu
entry \"Fontify Buffer\").  XEmacs: turn off and on font locking." :type 'boolean :group 'verilog-mode-indent)

(defcustom verilog-indent-level 3 "\
*Indentation of Verilog statements with respect to containing block." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-indent-level-module 3 "\
*Indentation of Module level Verilog statements (eg always, initial).
Set to 0 to get initial and always statements lined up on the left side of
your screen." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-indent-level-declaration 3 "\
*Indentation of declarations with respect to containing block.
Set to 0 to get them list right under containing block." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-indent-declaration-macros nil "\
*How to treat macro expansions in a declaration.
If nil, indent as:
	input [31:0] a;
	input        `CP;
	output       c;
If non nil, treat as:
	input [31:0] a;
	input `CP    ;
	output       c;" :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-indent-lists t "\
*How to treat indenting items in a list.
If t (the default), indent as:
	always @( posedge a or
	          reset ) begin

If nil, treat as:
	always @( posedge a or
	   reset ) begin" :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-indent-level-behavioral 3 "\
*Absolute indentation of first begin in a task or function block.
Set to 0 to get such code to start at the left side of the screen." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-indent-level-directive 1 "\
*Indentation to add to each level of `ifdef declarations.
Set to 0 to have all directives start at the left side of the screen." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-cexp-indent 2 "\
*Indentation of Verilog statements split across lines." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-case-indent 2 "\
*Indentation for case statements." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-auto-newline t "\
*True means automatically newline after semicolons." :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-auto-indent-on-newline t "\
*True means automatically indent line after newline." :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-tab-always-indent t "\
*True means TAB should always re-indent the current line.
A nil value means TAB will only reindent when at the beginning of the line." :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-tab-to-comment nil "\
*True means TAB moves to the right hand column in preparation for a comment." :group 'verilog-mode-actions :type 'boolean)

(defcustom verilog-indent-begin-after-if t "\
*If true, indent begin statements following if, else, while, for and repeat.
Otherwise, line them up." :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-align-ifelse nil "\
*If true, align `else' under matching `if'.
Otherwise else is lined up with first character on line holding matching if." :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-minimum-comment-distance 10 "\
*Minimum distance (in lines) between begin and end required before a comment.
Setting this variable to zero results in every end acquiring a comment; the
default avoids too many redundant comments in tight quarters." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-auto-lineup '(declaration) "\
*Algorithm for lining up statements on multiple lines.

If this list contains the symbol 'all', then all line ups described below
are done.

If this list contains the symbol 'declaration', then declarations are lined up
with any preceding declarations, taking into account widths and the like, so
for example the code:
	reg [31:0] a;
	reg b;
would become
	reg [31:0] a;
	reg        b;

If this list contains the symbol 'assignment', then assignments are lined up
with any preceding assignments, so for example the code
	a_long_variable = b + c;
	d = e + f;
would become
	a_long_variable = b + c;
	d               = e + f;" :group 'verilog-mode-indent :type 'list)

(defcustom verilog-highlight-p1800-keywords nil "\
*True means highlight words newly reserved by IEEE-1800.
These will appear in `verilog-font-lock-p1800-face' in order to gently
suggest changing where these words are used as variables to something else.
A nil value means highlight these words as appropriate for the SystemVerilog
IEEE-1800 standard.  Note that changing this will require restarting Emacs
to see the effect as font color choices are cached by Emacs." :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-highlight-grouping-keywords nil "\
*True means highlight grouping keywords 'begin' and 'end' more dramatically.
If false, these words are in the font-lock-type-face; if True then they are in
`verilog-font-lock-ams-face'. Some find that special highlighting on these
grouping constructs allow the structure of the code to be understood at a glance." :group 'verilog-mode-indent :type 'boolean)

(defcustom verilog-auto-endcomments t "\
*True means insert a comment /* ... */ after 'end's.
The name of the function or case will be set between the braces." :group 'verilog-mode-actions :type 'boolean)

(defcustom verilog-auto-read-includes nil "\
*True means to automatically read includes before AUTOs.
This will do a `verilog-read-defines' and `verilog-read-includes' before
each AUTO expansion.  This makes it easier to embed defines and includes,
but can result in very slow reading times if there are many or large
include files." :group 'verilog-mode-actions :type 'boolean)

(defcustom verilog-auto-save-policy nil "\
*Non-nil indicates action to take when saving a Verilog buffer with AUTOs.
A value of `force' will always do a \\[verilog-auto] automatically if
needed on every save.  A value of `detect' will do \\[verilog-auto]
automatically when it thinks necessary.  A value of `ask' will query the
user when it thinks updating is needed.

You should not rely on the 'ask or 'detect policies, they are safeguards
only.  They do not detect when AUTOINSTs need to be updated because a
sub-module's port list has changed." :group 'verilog-mode-actions :type '(choice (const nil) (const ask) (const detect) (const force)))

(defcustom verilog-auto-star-expand t "\
*Non-nil indicates to expand a SystemVerilog .* instance ports.
They will be expanded in the same way as if there was a AUTOINST in the
instantiation.  See also `verilog-auto-star' and `verilog-auto-star-save'." :group 'verilog-mode-actions :type 'boolean)

(defcustom verilog-auto-star-save nil "\
*Non-nil indicates to save to disk SystemVerilog .* instance expansions.
A nil value indicates direct connections will be removed before saving.
Only meaningful to those created due to `verilog-auto-star-expand' being set.

Instead of setting this, you may want to use /*AUTOINST*/, which will
always be saved." :group 'verilog-mode-actions :type 'boolean)

(defcustom verilog-library-flags '("") "\
*List of standard Verilog arguments to use for /*AUTOINST*/.
These arguments are used to find files for `verilog-auto', and match
the flags accepted by a standard Verilog-XL simulator.

    -f filename     Reads more `verilog-library-flags' from the filename.
    +incdir+dir     Adds the directory to `verilog-library-directories'.
    -Idir           Adds the directory to `verilog-library-directories'.
    -y dir          Adds the directory to `verilog-library-directories'.
    +libext+.v      Adds the extensions to `verilog-library-extensions'.
    -v filename     Adds the filename to `verilog-library-files'.

    filename        Adds the filename to `verilog-library-files'.
                    This is not recommended, -v is a better choice.

You might want these defined in each file; put at the *END* of your file
something like:

    // Local Variables:
    // verilog-library-flags:(\"-y dir -y otherdir\")
    // End:

Verilog-mode attempts to detect changes to this local variable, but they
are only insured to be correct when the file is first visited.  Thus if you
have problems, use \\[find-alternate-file] RET to have these take effect.

See also the variables mentioned above." :group 'verilog-mode-auto :type '(repeat string))

(defcustom verilog-library-directories '(".") "\
*List of directories when looking for files for /*AUTOINST*/.
The directory may be relative to the current file, or absolute.
Environment variables are also expanded in the directory names.
Having at least the current directory is a good idea.

You might want these defined in each file; put at the *END* of your file
something like:

    // Local Variables:
    // verilog-library-directories:(\".\" \"subdir\" \"subdir2\")
    // End:

Verilog-mode attempts to detect changes to this local variable, but they
are only insured to be correct when the file is first visited.  Thus if you
have problems, use \\[find-alternate-file] RET to have these take effect.

See also `verilog-library-flags', `verilog-library-files'
and `verilog-library-extensions'." :group 'verilog-mode-auto :type '(repeat file))

(defcustom verilog-library-files 'nil "\
*List of files to search for modules.
AUTOINST will use this when it needs to resolve a module name.
This is a complete path, usually to a technology file with many standard
cells defined in it.

You might want these defined in each file; put at the *END* of your file
something like:

    // Local Variables:
    // verilog-library-files:(\"/some/path/technology.v\" \"/some/path/tech2.v\")
    // End:

Verilog-mode attempts to detect changes to this local variable, but they
are only insured to be correct when the file is first visited.  Thus if you
have problems, use \\[find-alternate-file] RET to have these take effect.

See also `verilog-library-flags', `verilog-library-directories'." :group 'verilog-mode-auto :type '(repeat directory))

(defcustom verilog-library-extensions '(".v" ".sv") "\
*List of extensions to use when looking for files for /*AUTOINST*/.
See also `verilog-library-flags', `verilog-library-directories'." :type '(repeat string) :group 'verilog-mode-auto)

(defcustom verilog-active-low-regexp nil "\
*If set, treat signals matching this regexp as active low.
This is used for AUTORESET and AUTOTIEOFF.  For proper behavior,
you will probably also need `verilog-auto-reset-widths' set." :group 'verilog-mode-auto :type 'string)

(defcustom verilog-auto-sense-include-inputs nil "\
*If true, AUTOSENSE should include all inputs.
If nil, only inputs that are NOT output signals in the same block are
included." :group 'verilog-mode-auto :type 'boolean)

(defcustom verilog-auto-sense-defines-constant nil "\
*If true, AUTOSENSE should assume all defines represent constants.
When true, the defines will not be included in sensitivity lists.  To
maintain compatibility with other sites, this should be set at the bottom
of each Verilog file that requires it, rather than being set globally." :group 'verilog-mode-auto :type 'boolean)

(defcustom verilog-auto-reset-widths t "\
*If true, AUTORESET should determine the width of signals.
This is then used to set the width of the zero (32'h0 for example).  This
is required by some lint tools that aren't smart enough to ignore widths of
the constant zero.  This may result in ugly code when parameters determine
the MSB or LSB of a signal inside an AUTORESET." :type 'boolean :group 'verilog-mode-auto)

(defcustom verilog-assignment-delay "" "\
*Text used for delays in delayed assignments.  Add a trailing space if set." :group 'verilog-mode-auto :type 'string)

(defcustom verilog-auto-inst-param-value nil "\
*If set, AUTOINST will replace parameters with the parameter value.
If nil, leave parameters as symbolic names.

Parameters must be in Verilog 2001 format #(...), and if a parameter is not
listed as such there (as when the default value is acceptable), it will not
be replaced, and will remain symbolic.

For example, imagine a submodule uses parameters to declare the size of its
inputs.  This is then used by a upper module:

	module InstModule (o,i)
	   parameter WIDTH;
	   input [WIDTH-1:0] i;
	endmodule

	module ExampInst;
	   InstModule
 	     #(PARAM(10))
	    instName
	     (/*AUTOINST*/
	      .i 	(i[PARAM-1:0]));

Note even though PARAM=10, the AUTOINST has left the parameter as a
symbolic name.  If `verilog-auto-inst-param-value' is set, this will
instead expand to:

	module ExampInst;
	   InstModule
 	     #(PARAM(10))
	    instName
	     (/*AUTOINST*/
	      .i 	(i[9:0]));" :group 'verilog-mode-auto :type 'boolean)

(defcustom verilog-auto-inst-vector t "\
*If true, when creating default ports with AUTOINST, use bus subscripts.
If nil, skip the subscript when it matches the entire bus as declared in
the module (AUTOWIRE signals always are subscripted, you must manually
declare the wire to have the subscripts removed.)  Setting this to nil may
speed up some simulators, but is less general and harder to read, so avoid." :group 'verilog-mode-auto :type 'boolean)

(defcustom verilog-auto-inst-template-numbers nil "\
*If true, when creating templated ports with AUTOINST, add a comment.
The comment will add the line number of the template that was used for that
port declaration.  Setting this aids in debugging, but nil is suggested for
regular use to prevent large numbers of merge conflicts." :group 'verilog-mode-auto :type 'boolean)

(defcustom verilog-auto-inst-column 40 "\
*Indent-to column number for net name part of AUTOINST created pin." :group 'verilog-mode-indent :type 'integer)

(defcustom verilog-auto-input-ignore-regexp nil "\
*If set, when creating AUTOINPUT list, ignore signals matching this regexp.
See the \\[verilog-faq] for examples on using this." :group 'verilog-mode-auto :type 'string)

(defcustom verilog-auto-inout-ignore-regexp nil "\
*If set, when creating AUTOINOUT list, ignore signals matching this regexp.
See the \\[verilog-faq] for examples on using this." :group 'verilog-mode-auto :type 'string)

(defcustom verilog-auto-output-ignore-regexp nil "\
*If set, when creating AUTOOUTPUT list, ignore signals matching this regexp.
See the \\[verilog-faq] for examples on using this." :group 'verilog-mode-auto :type 'string)

(defcustom verilog-auto-unused-ignore-regexp nil "\
*If set, when creating AUTOUNUSED list, ignore signals matching this regexp.
See the \\[verilog-faq] for examples on using this." :group 'verilog-mode-auto :type 'string)

(defcustom verilog-typedef-regexp nil "\
*If non-nil, regular expression that matches Verilog-2001 typedef names.
For example, \"_t$\" matches typedefs named with _t, as in the C language." :group 'verilog-mode-auto :type 'string)

(defcustom verilog-mode-hook 'verilog-set-compile-command "\
*Hook run after Verilog mode is loaded." :type 'hook :group 'verilog-mode)

(defcustom verilog-auto-hook nil "\
*Hook run after `verilog-mode' updates AUTOs." :group 'verilog-mode-auto :type 'hook)

(defcustom verilog-before-auto-hook nil "\
*Hook run before `verilog-mode' updates AUTOs." :group 'verilog-mode-auto :type 'hook)

(defcustom verilog-delete-auto-hook nil "\
*Hook run after `verilog-mode' deletes AUTOs." :group 'verilog-mode-auto :type 'hook)

(defcustom verilog-before-delete-auto-hook nil "\
*Hook run before `verilog-mode' deletes AUTOs." :group 'verilog-mode-auto :type 'hook)

(defcustom verilog-getopt-flags-hook nil "\
*Hook run after `verilog-getopt-flags' determines the Verilog option lists." :group 'verilog-mode-auto :type 'hook)

(defcustom verilog-before-getopt-flags-hook nil "\
*Hook run before `verilog-getopt-flags' determines the Verilog option lists." :group 'verilog-mode-auto :type 'hook)

;;;***

;;;### (autoloads (vrml-mode-hook vrml-use-hairy-comment-detector vrml-tab-always-indent vrml-auto-newline vrml-indent-level vrml) "vrml-mode" "prog-modes/vrml-mode.el")
(defconst custom-define-current-source-file "vrml-mode.el")

(defgroup vrml nil "Major mode for editing VRML (.wrl) files." :group 'languages)

(defcustom vrml-indent-level 3 "\
*Indentation of VRML statements with respect to containing block." :type 'integer :group 'vrml)

(defcustom vrml-auto-newline nil "\
*Non-nil means automatically newline before and after braces
inserted in VRML code." :type 'boolean :group 'vrml)

(defcustom vrml-tab-always-indent t "\
*Control effect of TAB key.
If t (the default), always indent current line.
If nil and point is not in the indentation area at the beginning of
the line, a TAB is inserted.
Other values cause the first possible action from the following list
to take place:

  1. Move from beginning of line to correct indentation.
  2. Delete an empty comment.
  3. Move forward to start of comment, indenting if necessary.
  4. Move forward to end of line, indenting if necessary.
  5. Create an empty comment.
  6. Move backward to start of comment, indenting if necessary." :type '(choice (const :tag "on" t) (const :tag "off" nil) (sexp :format "%t
" :tag "The Works" other)) :group 'vrml)

(defcustom vrml-use-hairy-comment-detector t "\
*If not `nil', then the more complicated, but slower, comment
detecting function is used." :type 'boolean :group 'vrml)

(defcustom vrml-mode-hook nil "\
Hook run on entry to VRML mode." :type 'hook :group 'vrml)

;;;***

(provide 'prog-modes-custom-defines)
