;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ps-print-custom-defines) (error "Feature ps-print-custom-defines already loaded"))

;;;### (autoloads (lpr-page-header-switches lpr-page-header-program print-region-function lpr-headers-switches lpr-command lpr-printer-switch lpr-add-switches lpr-switches printer-name lpr) "lpr" "ps-print/lpr.el")
(defconst custom-define-current-source-file "lpr.el")

(defgroup lpr nil "Print Emacs buffer on line printer" :group 'wp)

(defcustom printer-name (and lpr-windows-system "PRN") "\
*The name of a local printer to which data is sent for printing.
\(Note that PostScript files are sent to `ps-printer-name', which see.)

On Unix-like systems, a string value should be a name understood by
lpr's -P option; otherwise the value should be nil.

On MS-DOS and MS-Windows systems, a string value is taken as the name of
a printer device or port, provided `lpr-command' is set to \"\".
Typical non-default settings would be \"LPT1\" to \"LPT3\" for parallel
printers, or \"COM1\" to \"COM4\" or \"AUX\" for serial printers, or
\"//hostname/printer\" for a shared network printer.  You can also set
it to the name of a file, in which case the output gets appended to that
file.  If you want to discard the printed output, set this to \"NUL\"." :type '(choice :menu-tag "Printer Name" :tag "Printer Name" (const :tag "Default" nil) (file :tag "Name")) :group 'lpr)

(defcustom lpr-switches nil "\
*List of strings to pass as extra options for the printer program.
It is recommended to set `printer-name' instead of including an explicit
switch on this list.
See `lpr-command'." :type '(repeat (string :tag "Argument")) :group 'lpr)

(defcustom lpr-add-switches (eq system-type 'berkeley-unix) "\
*Non-nil means construct -T and -J options for the printer program.
These are made assuming that the program is `lpr';
if you are using some other incompatible printer program,
this variable should be nil." :type 'boolean :group 'lpr)

(defcustom lpr-printer-switch (if lpr-lp-system "-d " "-P") "\
*Printer switch, that is, something like \"-P\", \"-d \", \"/D:\", etc.
This switch is used in conjunction with `printer-name'." :type '(choice :menu-tag "Printer Name Switch" :tag "Printer Name Switch" (const :tag "None" nil) (string :tag "Printer Switch")) :group 'lpr)

(defcustom lpr-command (cond (lpr-windows-system "") (lpr-lp-system "lp") (t "lpr")) "\
*Name of program for printing a file.

On MS-DOS and MS-Windows systems, if the value is an empty string then
Emacs will write directly to the printer port named by `printer-name'.
The programs `print' and `nprint' (the standard print programs on
Windows NT and Novell Netware respectively) are handled specially, using
`printer-name' as the destination for output; any other program is
treated like `lpr' except that an explicit filename is given as the last
argument." :type 'string :group 'lpr)

(defcustom lpr-headers-switches nil "\
*List of strings of options to request page headings in the printer program.
If nil, we run `lpr-page-header-program' to make page headings
and print the result." :type '(repeat (string :tag "Argument")) :group 'lpr)

(defcustom print-region-function nil "\
Function to call to print the region on a printer.
See definition of `print-region-1' for calling conventions." :type 'function :group 'lpr)

(defcustom lpr-page-header-program "pr" "\
*Name of program for adding page headers to a file." :type 'string :group 'lpr)

(defcustom lpr-page-header-switches '("-h" "-F") "\
*List of strings to use as options for the page-header-generating program.
The variable `lpr-page-header-program' specifies the program to use." :type '(repeat string) :group 'lpr)

;;;***

;;;### (autoloads (ps-mule-font-info-database-default ps-multibyte-buffer) "ps-mule" "ps-print/ps-mule.el")
(defconst custom-define-current-source-file "ps-mule.el")

(defcustom ps-multibyte-buffer nil "\
*Specifies the multi-byte buffer handling.

Valid values are:

  nil                     This is the value to use the default settings which
			  is by default for printing buffer with only ASCII
			  and Latin characters.   The default setting can be
			  changed by setting the variable
			  `ps-mule-font-info-database-default' differently.
			  The initial value of this variable is
			  `ps-mule-font-info-database-latin' (see
			  documentation).

  `non-latin-printer'     This is the value to use when you have a Japanese
			  or Korean PostScript printer and want to print
			  buffer with ASCII, Latin-1, Japanese (JISX0208 and
			  JISX0201-Kana) and Korean characters.  At present,
			  it was not tested the Korean characters printing.
			  If you have a korean PostScript printer, please,
			  test it.

  `bdf-font'              This is the value to use when you want to print
			  buffer with BDF fonts.  BDF fonts include both latin
			  and non-latin fonts.  BDF (Bitmap Distribution
			  Format) is a format used for distributing X's font
			  source file.  BDF fonts are included in
			  `intlfonts-1.2' which is a collection of X11 fonts
			  for all characters supported by Emacs.  In order to
			  use this value, be sure to have installed
			  `intlfonts-1.2' and set the variable
			  `bdf-directory-list' appropriately (see ps-bdf.el for
			  documentation of this variable).

  `bdf-font-except-latin' This is like `bdf-font' except that it is used
			  PostScript default fonts to print ASCII and Latin-1
			  characters.  This is convenient when you want or
			  need to use both latin and non-latin characters on
			  the same buffer.  See `ps-font-family',
			  `ps-header-font-family' and `ps-font-info-database'.

Any other value is treated as nil." :type '(choice (const non-latin-printer) (const bdf-font) (const bdf-font-except-latin) (const :tag "nil" nil)) :group 'ps-print-font)

(defcustom ps-mule-font-info-database-default ps-mule-font-info-database-latin "\
*The default setting to use when `ps-multibyte-buffer' is nil." :type '(symbol :tag "Multi-Byte Buffer Database Font Default") :group 'ps-print-font)

;;;***

;;;### (autoloads (ps-end-cut-regexp ps-begin-cut-regexp ps-paragraph-regexp ps-paragraph-spacing ps-line-spacing ps-postscript-code-directory ps-banner-page-when-duplexing ps-always-build-face-reference ps-build-face-reference ps-adobe-tag ps-razzle-dazzle ps-right-footer ps-left-footer ps-right-header ps-left-header ps-use-face-background ps-underlined-faces ps-italic-faces ps-bold-faces ps-black-white-faces ps-auto-font-detect ps-default-bg ps-default-fg ps-print-color-p ps-line-number-font-size ps-line-number-font ps-line-number-color ps-footer-font-size ps-footer-font-family ps-header-title-font-size ps-header-font-size ps-header-font-family ps-font-size ps-font-family ps-font-info-database ps-spool-tumble ps-spool-duplex ps-spool-config ps-show-n-of-n ps-switch-header ps-print-only-one-header ps-footer-lines ps-footer-frame-alist ps-print-footer-frame ps-print-footer ps-header-lines ps-header-frame-alist ps-print-header-frame ps-print-header ps-footer-line-pad ps-footer-offset ps-header-line-pad ps-header-offset ps-top-margin ps-bottom-margin ps-inter-column ps-right-margin ps-left-margin ps-print-background-text ps-print-background-image ps-line-number-start ps-line-number-step ps-line-number ps-zebra-stripe-follow ps-zebra-color ps-zebra-stripe-height ps-zebra-stripes ps-number-of-columns ps-n-up-filling ps-n-up-border-p ps-n-up-margin ps-n-up-printing ps-print-control-characters ps-even-or-odd-pages ps-selected-pages ps-print-upside-down ps-landscape-mode ps-warn-paper-type ps-paper-type ps-page-dimensions-database ps-end-with-control-d ps-manual-feed ps-print-region-function ps-lpr-switches ps-lpr-command ps-printer-name-option ps-printer-name ps-print-prologue-header ps-user-defined-prologue ps-error-handler-message ps-print-miscellany ps-print-page ps-print-printer ps-print-background ps-print-zebra ps-print-n-up ps-print-face ps-print-color ps-print-font ps-print-headers ps-print-vertical ps-print-horizontal ps-print postscript) "ps-print" "ps-print/ps-print.el")
(defconst custom-define-current-source-file "ps-print.el")

(defgroup postscript nil "PostScript Group" :tag "PostScript" :group 'emacs)

(defgroup ps-print nil "PostScript generator for Emacs" :link '(emacs-library-link :tag "Source Lisp File" "ps-print.el") :prefix "ps-" :group 'wp :group 'postscript)

(defgroup ps-print-horizontal nil "Horizontal page layout" :prefix "ps-" :tag "Horizontal" :group 'ps-print)

(defgroup ps-print-vertical nil "Vertical page layout" :prefix "ps-" :tag "Vertical" :group 'ps-print)

(defgroup ps-print-headers nil "Headers & footers layout" :prefix "ps-" :tag "Header & Footer" :group 'ps-print)

(defgroup ps-print-font nil "Fonts customization" :prefix "ps-" :tag "Font" :group 'ps-print)

(defgroup ps-print-color nil "Color customization" :prefix "ps-" :tag "Color" :group 'ps-print)

(defgroup ps-print-face nil "Faces customization" :prefix "ps-" :tag "PS Faces" :group 'ps-print :group 'faces)

(defgroup ps-print-n-up nil "N-up customization" :prefix "ps-" :tag "N-Up" :group 'ps-print)

(defgroup ps-print-zebra nil "Zebra customization" :prefix "ps-" :tag "Zebra" :group 'ps-print)

(defgroup ps-print-background nil "Background customization" :prefix "ps-" :tag "Background" :group 'ps-print)

(defgroup ps-print-printer nil "Printer customization" :prefix "ps-" :tag "Printer" :group 'ps-print)

(defgroup ps-print-page nil "Page customization" :prefix "ps-" :tag "Page" :group 'ps-print)

(defgroup ps-print-miscellany nil "Miscellany customization" :prefix "ps-" :tag "Miscellany" :group 'ps-print)

(defcustom ps-error-handler-message 'paper "\
*Specify where the error handler message should be sent.

Valid values are:

   `none'		catch the error and *DON'T* send any message.

   `paper'		catch the error and print on paper the error message.

   `system'		catch the error and send back the error message to
			printing system.  This is useful only if printing system
			send back an email reporting the error, or if there is
			some other alternative way to report back the error from
			the system to you.

   `paper-and-system'	catch the error, print on paper the error message and
			send back the error message to printing system.

Any other value is treated as `paper'." :type '(choice :menu-tag "Error Handler Message" :tag "Error Handler Message" (const none) (const paper) (const system) (const paper-and-system)) :group 'ps-print-miscellany)

(defcustom ps-user-defined-prologue nil "\
*User defined PostScript prologue code inserted before all prologue code.

`ps-user-defined-prologue' may be a string or a symbol function which returns a
string.  Note that this string is inserted after `ps-adobe-tag' and PostScript
prologue comments, and before ps-print PostScript prologue code section.  That
is, this string is inserted after error handler initialization and before
ps-print settings.

It's strongly recommended only insert PostScript code and/or comments specific
for your printing system particularities.  For example, some special
initialization that only your printing system needs.

Do not insert code for duplex printing, n-up printing or error handler,
ps-print handles this in a suitable way.

For more information about PostScript, see:
   PostScript Language Reference Manual (2nd edition)
   Adobe Systems Incorporated

As an example for `ps-user-defined-prologue' setting:

   ;; Setting for HP PostScript printer
   (setq ps-user-defined-prologue
	 (concat \"<</DeferredMediaSelection true /PageSize [612 792] \"
		 \"/MediaPosition 2 /MediaType (Plain)>> setpagedevice\"))
" :type '(choice :menu-tag "User Defined Prologue" :tag "User Defined Prologue" (const :tag "none" nil) string symbol) :group 'ps-print-miscellany)

(defcustom ps-print-prologue-header nil "\
*PostScript prologue header comments besides that ps-print generates.

`ps-print-prologue-header' may be a string or a symbol function which returns a
string.  Note that this string is inserted on PostScript prologue header
section which is used to define some document characteristic through PostScript
special comments, like \"%%Requirements: jog\\n\".

ps-print always inserts the %%Requirements: comment, so if you need to insert
more requirements put them first in `ps-print-prologue-header' using the
\"%%+\" comment.  For example, if you need to set numcopies to 3 and jog on
requirements and set %%LanguageLevel: to 2, do:

\(setq ps-print-prologue-header
      \"%%+ numcopies(3) jog\\n%%LanguageLevel: 2\\n\")

The duplex requirement is inserted by ps-print (see `ps-spool-duplex').

Do not forget to terminate the string with \"\\n\".

For more information about PostScript document comments, see:
   PostScript Language Reference Manual (2nd edition)
   Adobe Systems Incorporated
   Appendix G: Document Structuring Conventions -- Version 3.0" :type '(choice :menu-tag "Prologue Header" :tag "Prologue Header" (const :tag "none" nil) string symbol) :group 'ps-print-miscellany)

(defcustom ps-printer-name (and (boundp 'printer-name) (symbol-value 'printer-name)) "\
*The name of a local printer for printing PostScript files.

On Unix-like systems, a string value should be a name understood by lpr's -P
option; a value of nil means use the value of `printer-name' instead.

On MS-DOS and MS-Windows systems, a string value is taken as the name of the
printer device or port to which PostScript files are written, provided
`ps-lpr-command' is \"\".  By default it is the same as `printer-name'; typical
non-default settings would be \"LPT1\" to \"LPT3\" for parallel printers, or
\"COM1\" to \"COM4\" or \"AUX\" for serial printers, or \"\\\\hostname\\printer\"
for a shared network printer.  You can also set it to a name of a file, in
which case the output gets appended to that file.  (Note that `ps-print'
package already has facilities for printing to a file, so you might as well use
them instead of changing the setting of this variable.)  If you want to
silently discard the printed output, set this to \"NUL\".

Set to t, if the utility given by `ps-lpr-command' needs an empty printer name.

Any other value is treated as t, that is, an empty printer name.

See also `ps-printer-name-option' for documentation." :type '(choice :menu-tag "Printer Name" :tag "Printer Name" (const :tag "Same as printer-name" nil) (const :tag "No Printer Name" t) (file :tag "Print to file") (string :tag "Pipe to ps-lpr-command")) :group 'ps-print-printer)

(defcustom ps-printer-name-option (cond (ps-windows-system "/D:") (ps-lp-system "-d") (t "-P")) "\
*Option for `ps-printer-name' variable (see it).

On Unix-like systems, if it's been used lpr utility, it should be the string
\"-P\"; if it's been used lp utility, it should be the string \"-d\".

On MS-DOS and MS-Windows systems, if it's been used print utility, it should be
the string \"/D:\".

For any other printing utility, see the proper manual or documentation.

Set to \"\" or nil, if the utility given by `ps-lpr-command' needs an empty
option printer name option.

Any other value is treated as nil, that is, an empty printer name option.

This variable is used only when `ps-printer-name' is a non-empty string." :type '(choice :menu-tag "Printer Name Option" :tag "Printer Name Option" (const :tag "None" nil) (string :tag "Option")) :version "21.1" :group 'ps-print-printer)

(defcustom ps-lpr-command lpr-command "\
*Name of program for printing a PostScript file.

On MS-DOS and MS-Windows systems, if the value is an empty string then Emacs
will write directly to the printer port named by `ps-printer-name'.  The
programs `print' and `nprint' (the standard print programs on Windows NT and
Novell Netware respectively) are handled specially, using `ps-printer-name' as
the destination for output; any other program is treated like `lpr' except that
an explicit filename is given as the last argument." :type 'string :group 'ps-print-printer)

(defcustom ps-lpr-switches lpr-switches "\
*A list of extra switches to pass to `ps-lpr-command'." :type '(repeat :tag "PostScript lpr Switches" (choice :menu-tag "PostScript lpr Switch" :tag "PostScript lpr Switch" string symbol (repeat sexp))) :group 'ps-print-printer)

(defcustom ps-print-region-function nil "\
*Specify a function to print the region on a PostScript printer.
See definition of `call-process-region' for calling conventions.  The fourth
and the sixth arguments are both nil." :type '(choice (const nil) function) :group 'ps-print-printer)

(defcustom ps-manual-feed nil "\
*Non-nil means the printer will manually feed paper.

If it's nil, automatic feeding takes place." :type 'boolean :group 'ps-print-printer)

(defcustom ps-end-with-control-d (and ps-windows-system t) "\
*Non-nil means insert C-d at end of PostScript file generated." :version "21.1" :type 'boolean :group 'ps-print-printer)

(defcustom ps-page-dimensions-database (list (list 'a4 (/ (* 72 21.0) 2.54) (/ (* 72 29.7) 2.54) "A4") (list 'a3 (/ (* 72 29.7) 2.54) (/ (* 72 42.0) 2.54) "A3") (list 'letter (* 72 8.5) (* 72 11.0) "Letter") (list 'legal (* 72 8.5) (* 72 14.0) "Legal") (list 'letter-small (* 72 7.68) (* 72 10.16) "LetterSmall") (list 'tabloid (* 72 11.0) (* 72 17.0) "Tabloid") (list 'ledger (* 72 17.0) (* 72 11.0) "Ledger") (list 'statement (* 72 5.5) (* 72 8.5) "Statement") (list 'executive (* 72 7.5) (* 72 10.0) "Executive") (list 'a4small (* 72 7.47) (* 72 10.85) "A4Small") (list 'b4 (* 72 10.125) (* 72 14.33) "B4") (list 'b5 (* 72 7.16) (* 72 10.125) "B5")) "\
*List associating a symbolic paper type to its width, height and doc media.
See `ps-paper-type'." :type '(repeat (list :tag "Paper Type" (symbol :tag "Name") (number :tag "Width") (number :tag "Height") (string :tag "Media"))) :group 'ps-print-page)

(defcustom ps-paper-type 'letter "\
*Specify the size of paper to format for.
Should be one of the paper types defined in `ps-page-dimensions-database', for
example `letter', `legal' or `a4'." :type '(symbol :validate (lambda (wid) (if (assq (widget-value wid) ps-page-dimensions-database) nil (widget-put wid :error "Unknown paper size") wid))) :group 'ps-print-page)

(defcustom ps-warn-paper-type t "\
*Non-nil means give an error if paper size is not equal to `ps-paper-type'.

It's used when `ps-spool-config' is set to `setpagedevice'." :type 'boolean :group 'ps-print-page)

(defcustom ps-landscape-mode nil "\
*Non-nil means print in landscape mode." :type 'boolean :group 'ps-print-page)

(defcustom ps-print-upside-down nil "\
*Non-nil means print upside-down (that is, it's rotated by 180 grades)." :type 'boolean :version "21.1" :group 'ps-print-page)

(defcustom ps-selected-pages nil "\
*Specify which pages to print.

If it's nil, all pages are printed.

If it's a list, the list element may be an integer or a cons cell (FROM . TO)
designating FROM page to TO page; any invalid element is ignored, that is, an
integer lesser than one or if FROM is greater than TO.

Otherwise, it's treated as nil.

After ps-print processing `ps-selected-pages' is set to nil.  But the latest
`ps-selected-pages' is saved in `ps-last-selected-pages' (see it for
documentation).  So you can restore the latest selected pages by using
`ps-last-selected-pages' or by calling `ps-restore-selected-pages' command (see
it for documentation).

See also `ps-even-or-odd-pages'." :type '(repeat :tag "Selected Pages" (radio :tag "Page" (integer :tag "Number") (cons :tag "Range" (integer :tag "From") (integer :tag "To")))) :group 'ps-print-page)

(defcustom ps-even-or-odd-pages nil "\
*Specify if it prints even/odd pages.

Valid values are:

   nil		print all pages.

   `even-page'	print only even pages.

   `odd-page'	print only odd pages.

   `even-sheet'	print only even sheets.
		That is, if `ps-n-up-printing' is 1, it behaves as `even-page';
		but for values greater than 1, it'll print only the even sheet
		of paper.

   `odd-sheet'	print only odd sheets.
		That is, if `ps-n-up-printing' is 1, it behaves as `odd-page';
		but for values greater than 1, it'll print only the odd sheet
		of paper.

Any other value is treated as nil.

If you set `ps-selected-pages' (see it for documentation), first the pages are
filtered by `ps-selected-pages' and then by `ps-even-or-odd-pages'.  For
example, if we have:

   (setq ps-selected-pages '(1 4 (6 . 10) (12 . 16) 20))

Combining with `ps-even-or-odd-pages' and `ps-n-up-printing', we have:

`ps-n-up-printing' = 1:
   `ps-even-or-odd-pages'	PAGES PRINTED
	nil			1, 4, 6, 7, 8, 9, 10, 12, 13, 14, 15, 16, 20
	even-page		4, 6, 8, 10, 12, 14, 16, 20
	odd-page		1, 7, 9, 13, 15
	even-sheet		4, 6, 8, 10, 12, 14, 16, 20
	odd-sheet		1, 7, 9, 13, 15

`ps-n-up-printing' = 2:
   `ps-even-or-odd-pages'	PAGES PRINTED
	nil			1/4, 6/7, 8/9, 10/12, 13/14, 15/16, 20
	even-page		4/6, 8/10, 12/14, 16/20
	odd-page		1/7, 9/13, 15
	even-sheet		6/7, 10/12, 15/16
	odd-sheet		1/4, 8/9, 13/14, 20

So even-page/odd-page are about page parity and even-sheet/odd-sheet are about
sheet parity." :type '(choice :menu-tag "Print Even/Odd Pages" :tag "Print Even/Odd Pages" (const :tag "All Pages" nil) (const :tag "Only Even Pages" even-page) (const :tag "Only Odd Pages" odd-page) (const :tag "Only Even Sheets" even-sheet) (const :tag "Only Odd Sheets" odd-sheet)) :group 'ps-print-page)

(defcustom ps-print-control-characters 'control-8-bit "\
*Specify the printable form for control and 8-bit characters.
That is, instead of sending, for example, a ^D (\\004) to printer,
it is sent the string \"^D\".

Valid values are:

  `8-bit'         This is the value to use when you want an ASCII encoding of
		  any control or non-ASCII character.  Control characters are
		  encoded as \"^D\", and non-ASCII characters have an
		  octal encoding.

  `control-8-bit' This is the value to use when you want an ASCII encoding of
		  any control character, whether it is 7 or 8-bit.
		  European 8-bits accented characters are printed according
		  the current font.

  `control'       Only ASCII control characters have an ASCII encoding.
		  European 8-bits accented characters are printed according
		  the current font.

  nil             No ASCII encoding.  Any character is printed according the
		  current font.

Any other value is treated as nil." :type '(choice :menu-tag "Control Char" :tag "Control Char" (const 8-bit) (const control-8-bit) (const control) (const :tag "nil" nil)) :group 'ps-print-miscellany)

(defcustom ps-n-up-printing 1 "\
*Specify the number of pages per sheet paper." :type '(integer :tag "N Up Printing" :validate (lambda (wid) (if (and (< 0 (widget-value wid)) (<= (widget-value wid) 100)) nil (widget-put wid :error "Number of pages per sheet paper must be between 1 and 100.") wid))) :group 'ps-print-n-up)

(defcustom ps-n-up-margin (/ (* 72 1.0) 2.54) "\
*Specify the margin in points between the sheet border and n-up printing." :type 'number :group 'ps-print-n-up)

(defcustom ps-n-up-border-p t "\
*Non-nil means a border is drawn around each page." :type 'boolean :group 'ps-print-n-up)

(defcustom ps-n-up-filling 'left-top "\
*Specify how page matrix is filled on each sheet of paper.

Following are the valid values for `ps-n-up-filling' with a filling example
using a 3x4 page matrix:

   `left-top'   1  2  3  4         `left-bottom'    9  10 11 12
		5  6  7  8                          5  6  7  8
		9  10 11 12                         1  2  3  4

   `right-top'  4  3  2  1         `right-bottom'   12 11 10 9
		8  7  6  5                          8  7  6  5
		12 11 10 9                          4  3  2  1

   `top-left'   1  4  7  10        `bottom-left'    3  6  9  12
		2  5  8  11                         2  5  8  11
		3  6  9  12                         1  4  7  10

   `top-right'  10 7  4  1         `bottom-right'   12 9  6  3
		11 8  5  2                          11 8  5  2
		12 9  6  3                          10 7  4  1

Any other value is treated as `left-top'." :type '(choice :menu-tag "N-Up Filling" :tag "N-Up Filling" (const left-top) (const left-bottom) (const right-top) (const right-bottom) (const top-left) (const bottom-left) (const top-right) (const bottom-right)) :group 'ps-print-n-up)

(defcustom ps-number-of-columns (if ps-landscape-mode 2 1) "\
*Specify the number of columns" :type 'number :group 'ps-print-miscellany)

(defcustom ps-zebra-stripes nil "\
*Non-nil means print zebra stripes.
See also documentation for `ps-zebra-stripe-height' and `ps-zebra-color'." :type 'boolean :group 'ps-print-zebra)

(defcustom ps-zebra-stripe-height 3 "\
*Number of zebra stripe lines.
See also documentation for `ps-zebra-stripes' and `ps-zebra-color'." :type 'number :group 'ps-print-zebra)

(defcustom ps-zebra-color 0.95 "\
*Zebra stripe gray scale or RGB color.
See also documentation for `ps-zebra-stripes' and `ps-zebra-stripe-height'." :type '(choice :menu-tag "Zebra Gray/Color" :tag "Zebra Gray/Color" (number :tag "Gray Scale" :value 0.95) (string :tag "Color Name" :value "gray95") (list :tag "RGB Color" :value (0.95 0.95 0.95) (number :tag "Red") (number :tag "Green") (number :tag "Blue"))) :group 'ps-print-zebra)

(defcustom ps-zebra-stripe-follow nil "\
*Specify how zebra stripes continue on next page.

Visually, valid values are (the character `+' at right of each column indicates
that a line is printed):

		   `nil'        `follow'        `full'        `full-follow'
   Current Page --------     -----------     ---------     ----------------
		1  XXXXX +   1  XXXXXXXX +   1  XXXXXX +   1  XXXXXXXXXXXXX +
		2  XXXXX +   2  XXXXXXXX +   2  XXXXXX +   2  XXXXXXXXXXXXX +
		3  XXXXX +   3  XXXXXXXX +   3  XXXXXX +   3  XXXXXXXXXXXXX +
		4        +   4           +   4         +   4                +
		5        +   5           +   5         +   5                +
		6        +   6           +   6         +   6                +
		7  XXXXX +   7  XXXXXXXX +   7  XXXXXX +   7  XXXXXXXXXXXXX +
		8  XXXXX +   8  XXXXXXXX +   8  XXXXXX +   8  XXXXXXXXXXXXX +
		9  XXXXX +   9  XXXXXXXX +   9  XXXXXX +   9  XXXXXXXXXXXXX +
		10       +   10          +
		11       +   11          +
		--------     -----------     ---------     ----------------
      Next Page --------     -----------     ---------     ----------------
		12 XXXXX +   12          +   10 XXXXXX +   10               +
		13 XXXXX +   13 XXXXXXXX +   11 XXXXXX +   11               +
		14 XXXXX +   14 XXXXXXXX +   12 XXXXXX +   12               +
		15       +   15 XXXXXXXX +   13        +   13 XXXXXXXXXXXXX +
		16       +   16          +   14        +   14 XXXXXXXXXXXXX +
		17       +   17          +   15        +   15 XXXXXXXXXXXXX +
		18 XXXXX +   18          +   16 XXXXXX +   16               +
		19 XXXXX +   19 XXXXXXXX +   17 XXXXXX +   17               +
		20 XXXXX +   20 XXXXXXXX +   18 XXXXXX +   18               +
		21       +   21 XXXXXXXX +
		22       +   22          +
		--------     -----------     ---------     ----------------

Any other value is treated as `nil'." :type '(choice :menu-tag "Zebra Stripe Follow" :tag "Zebra Stripe Follow" (const :tag "Always Restart" nil) (const :tag "Continue on Next Page" follow) (const :tag "Print Only Full Stripe" full) (const :tag "Continue on Full Stripe" full-follow)) :group 'ps-print-zebra)

(defcustom ps-line-number nil "\
*Non-nil means print line number." :type 'boolean :group 'ps-print-miscellany)

(defcustom ps-line-number-step 1 "\
*Specify the interval that line number is printed.

For example, `ps-line-number-step' is set to 2, the printing will look like:

   1 one line
     one line
   3 one line
     one line
   5 one line
     one line
     ...

Valid values are:

   integer	an integer that specifies the interval that line number is
		printed.  If it's lesser than or equal to zero, it's used the
		value 1.

   `zebra'	specifies that only the line number of the first line in a
		zebra stripe is to be printed.

Any other value is treated as `zebra'." :type '(choice :menu-tag "Line Number Step" :tag "Line Number Step" (integer :tag "Step Interval") (const :tag "Synchronize Zebra" zebra)) :group 'ps-print-miscellany)

(defcustom ps-line-number-start 1 "\
*Specify the starting point in the interval given by `ps-line-number-step'.

For example, if `ps-line-number-step' is set to 3 and `ps-line-number-start' is
set to 3, the printing will look like:

      one line
      one line
    3 one line
      one line
      one line
    6 one line
      one line
      one line
    9 one line
      one line
      ...

The values for `ps-line-number-start':

   * If `ps-line-number-step' is an integer, must be between 1 and the value of
     `ps-line-number-step' inclusive.

   * If `ps-line-number-step' is set to `zebra', must be between 1 and the
     value of `ps-zebra-strip-height' inclusive.  Use this combination if you
     wish that line number be relative to zebra stripes." :type '(integer :tag "Start Step Interval") :group 'ps-print-miscellany)

(defcustom ps-print-background-image nil "\
*EPS image list to be printed on background.

The elements are:

   (FILENAME X Y XSCALE YSCALE ROTATION PAGES...)

FILENAME is a file name which contains an EPS image or some PostScript
programming like EPS.
FILENAME is ignored, if it doesn't exist or is read protected.

X and Y are relative positions on paper to put the image.
If X and Y are nil, the image is centralized on paper.

XSCALE and YSCALE are scale factor to be applied to image before printing.
If XSCALE and YSCALE are nil, the original size is used.

ROTATION is the image rotation angle; if nil, the default is 0.

PAGES designates the page to print background image.
PAGES may be a number or a cons cell (FROM . TO) designating FROM page to TO
page.
If PAGES is nil, print background image on all pages.

X, Y, XSCALE, YSCALE and ROTATION may be a floating point number, an integer
number or a string. If it is a string, the string should contain PostScript
programming that returns a float or integer value.

For example, if you wish to print an EPS image on all pages do:

   '((\"~/images/EPS-image.ps\"))" :type '(repeat (list (file :tag "EPS File") (choice :tag "X" (const :tag "default" nil) number string) (choice :tag "Y" (const :tag "default" nil) number string) (choice :tag "X Scale" (const :tag "default" nil) number string) (choice :tag "Y Scale" (const :tag "default" nil) number string) (choice :tag "Rotation" (const :tag "default" nil) number string) (repeat :tag "Pages" :inline t (radio (integer :tag "Page") (cons :tag "Range" (integer :tag "From") (integer :tag "To")))))) :group 'ps-print-background)

(defcustom ps-print-background-text nil "\
*Text list to be printed on background.

The elements are:

   (STRING X Y FONT FONTSIZE GRAY ROTATION PAGES...)

STRING is the text to be printed on background.

X and Y are positions on paper to put the text.
If X and Y are nil, the text is positioned at lower left corner.

FONT is a font name to be used on printing the text.
If nil, \"Times-Roman\" is used.

FONTSIZE is font size to be used, if nil, 200 is used.

GRAY is the text gray factor (should be very light like 0.8).
If nil, the default is 0.85.

ROTATION is the text rotation angle; if nil, the angle is given by the diagonal
from lower left corner to upper right corner.

PAGES designates the page to print background text.
PAGES may be a number or a cons cell (FROM . TO) designating FROM page to TO
page.
If PAGES is nil, print background text on all pages.

X, Y, FONTSIZE, GRAY and ROTATION may be a floating point number, an integer
number or a string. If it is a string, the string should contain PostScript
programming that returns a float or integer value.

For example, if you wish to print text \"Preliminary\" on all pages do:

   '((\"Preliminary\"))" :type '(repeat (list (string :tag "Text") (choice :tag "X" (const :tag "default" nil) number string) (choice :tag "Y" (const :tag "default" nil) number string) (choice :tag "Font" (const :tag "default" nil) string) (choice :tag "Fontsize" (const :tag "default" nil) number string) (choice :tag "Gray" (const :tag "default" nil) number string) (choice :tag "Rotation" (const :tag "default" nil) number string) (repeat :tag "Pages" :inline t (radio (integer :tag "Page") (cons :tag "Range" (integer :tag "From") (integer :tag "To")))))) :group 'ps-print-background)

(defcustom ps-left-margin (/ (* 72 2.0) 2.54) "\
*Left margin in points (1/72 inch)." :type 'number :group 'ps-print-horizontal)

(defcustom ps-right-margin (/ (* 72 2.0) 2.54) "\
*Right margin in points (1/72 inch)." :type 'number :group 'ps-print-horizontal)

(defcustom ps-inter-column (/ (* 72 2.0) 2.54) "\
*Horizontal space between columns in points (1/72 inch)." :type 'number :group 'ps-print-horizontal)

(defcustom ps-bottom-margin (/ (* 72 1.5) 2.54) "\
*Bottom margin in points (1/72 inch)." :type 'number :group 'ps-print-vertical)

(defcustom ps-top-margin (/ (* 72 1.5) 2.54) "\
*Top margin in points (1/72 inch)." :type 'number :group 'ps-print-vertical)

(defcustom ps-header-offset (/ (* 72 1.0) 2.54) "\
*Vertical space in points (1/72 inch) between the main text and the header." :type 'number :group 'ps-print-vertical)

(defcustom ps-header-line-pad 0.15 "\
*Portion of a header title line height to insert between the header frame
and the text it contains, both in the vertical and horizontal directions." :type 'number :group 'ps-print-vertical)

(defcustom ps-footer-offset (/ (* 72 1.0) 2.54) "\
*Vertical space in points (1/72 inch) between the main text and the footer." :type 'number :group 'ps-print-vertical)

(defcustom ps-footer-line-pad 0.15 "\
*Portion of a footer title line height to insert between the footer frame
and the text it contains, both in the vertical and horizontal directions." :type 'number :group 'ps-print-vertical)

(defcustom ps-print-header t "\
*Non-nil means print a header at the top of each page.
By default, the header displays the buffer name, page number, and, if the
buffer is visiting a file, the file's directory.  Headers are customizable by
changing variables `ps-left-header' and `ps-right-header'." :type 'boolean :group 'ps-print-headers)

(defcustom ps-print-header-frame t "\
*Non-nil means draw a gaudy frame around the header." :type 'boolean :group 'ps-print-headers)

(defcustom ps-header-frame-alist '((fore-color . 0.0) (back-color . 0.9) (border-width . 0.4) (border-color . 0.0) (shadow-color . 0.0)) "\
*Specify header frame properties alist.

Valid frame properties are:

   `fore-color'		Specify the foreground frame color.
			It should be a float number between 0.0 (black color)
			and 1.0 (white color), a string which is a color name,
			or a list of 3 float numbers which corresponds to the
			Red Green Blue color scale, each float number between
			0.0 (dark color) and 1.0 (bright color).

   `back-color'		Specify the background frame color (similar to
			`fore-color').

   `shadow-color'	Specify the shadow color (similar to `fore-color').

   `border-color'	Specify the border color (similar to `fore-color').

   `border-width'	Specify the border width.

Any other property is ignored.

Don't change this alist directly, instead use customization, or `ps-value',
`ps-get', `ps-put' and `ps-del' functions (see them for documentation)." :version "21.1" :type '(repeat (choice :menu-tag "Header Frame Element" :tag "" (cons :tag "Foreground Color" :format "%v" (const :format "" fore-color) (choice :menu-tag "Foreground Color" :tag "Foreground Color" (number :tag "Gray Scale" :value 0.0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0.0 0.0 0.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))) (cons :tag "Background Color" :format "%v" (const :format "" back-color) (choice :menu-tag "Background Color" :tag "Background Color" (number :tag "Gray Scale" :value 0.9) (string :tag "Color Name" :value "gray90") (list :tag "RGB Color" :value (0.9 0.9 0.9) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))) (cons :tag "Border Width" :format "%v" (const :format "" border-width) (number :tag "Border Width" :value 0.4)) (cons :tag "Border Color" :format "%v" (const :format "" border-color) (choice :menu-tag "Border Color" :tag "Border Color" (number :tag "Gray Scale" :value 0.0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0.0 0.0 0.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))) (cons :tag "Shadow Color" :format "%v" (const :format "" shadow-color) (choice :menu-tag "Shadow Color" :tag "Shadow Color" (number :tag "Gray Scale" :value 0.0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0.0 0.0 0.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))))) :group 'ps-print-headers)

(defcustom ps-header-lines 2 "\
*Number of lines to display in page header, when generating PostScript." :type 'integer :group 'ps-print-headers)

(defcustom ps-print-footer nil "\
*Non-nil means print a footer at the bottom of each page.
By default, the footer displays page number.
Footers are customizable by changing variables `ps-left-footer' and
`ps-right-footer'." :version "21.1" :type 'boolean :group 'ps-print-headers)

(defcustom ps-print-footer-frame t "\
*Non-nil means draw a gaudy frame around the footer." :version "21.1" :type 'boolean :group 'ps-print-headers)

(defcustom ps-footer-frame-alist '((fore-color . 0.0) (back-color . 0.9) (border-width . 0.4) (border-color . 0.0) (shadow-color . 0.0)) "\
*Specify footer frame properties alist.

Don't change this alist directly, instead use customization, or `ps-value',
`ps-get', `ps-put' and `ps-del' functions (see them for documentation).

See also `ps-header-frame-alist' for documentation." :version "21.1" :type '(repeat (choice :menu-tag "Header Frame Element" :tag "" (cons :tag "Foreground Color" :format "%v" (const :format "" fore-color) (choice :menu-tag "Foreground Color" :tag "Foreground Color" (number :tag "Gray Scale" :value 0.0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0.0 0.0 0.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))) (cons :tag "Background Color" :format "%v" (const :format "" back-color) (choice :menu-tag "Background Color" :tag "Background Color" (number :tag "Gray Scale" :value 0.9) (string :tag "Color Name" :value "gray90") (list :tag "RGB Color" :value (0.9 0.9 0.9) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))) (cons :tag "Border Width" :format "%v" (const :format "" border-width) (number :tag "Border Width" :value 0.4)) (cons :tag "Border Color" :format "%v" (const :format "" border-color) (choice :menu-tag "Border Color" :tag "Border Color" (number :tag "Gray Scale" :value 0.0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0.0 0.0 0.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))) (cons :tag "Shadow Color" :format "%v" (const :format "" shadow-color) (choice :menu-tag "Shadow Color" :tag "Shadow Color" (number :tag "Gray Scale" :value 0.0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0.0 0.0 0.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue")))))) :group 'ps-print-headers)

(defcustom ps-footer-lines 2 "\
*Number of lines to display in page footer, when generating PostScript." :version "21.1" :type 'integer :group 'ps-print-headers)

(defcustom ps-print-only-one-header nil "\
*Non-nil means print only one header/footer at the top/bottom of each page.
This is useful when printing more than one column, so it is possible to have
only one header/footer over all columns or one header/footer per column.
See also `ps-print-header' and `ps-print-footer'." :type 'boolean :group 'ps-print-headers)

(defcustom ps-switch-header 'duplex "\
*Specify if headers/footers are switched or not.

Valid values are:

nil	Never switch headers/footers.

t	Always switch headers/footers.

duplex	Switch headers/footers only when duplexing is on, that is, when
	`ps-spool-duplex' is non-nil.

Any other value is treated as t.

See also `ps-print-header' and `ps-print-footer'." :type '(choice :menu-tag "Switch Header/Footer" :tag "Switch Header/Footer" (const :tag "Never Switch" nil) (const :tag "Always Switch" t) (const :tag "Switch When Duplexing" duplex)) :group 'ps-print-headers)

(defcustom ps-show-n-of-n t "\
*Non-nil means show page numbers as N/M, meaning page N of M.
NOTE: page numbers are displayed as part of headers,
      see variable `ps-print-header'." :type 'boolean :group 'ps-print-headers)

(defcustom ps-spool-config (if ps-windows-system nil 'lpr-switches) "\
*Specify who is responsible for setting duplex and page size.

Valid values are:

  `lpr-switches'    duplex and page size are configured by `ps-lpr-switches'.
		    Don't forget to set `ps-lpr-switches' to select duplex
		    printing for your printer.

  `setpagedevice'   duplex and page size are configured by ps-print using the
		    setpagedevice PostScript operator.

  nil               duplex and page size are configured by ps-print *not* using
		    the setpagedevice PostScript operator.

Any other value is treated as nil.

WARNING: The setpagedevice PostScript operator affects ghostview utility when
	 viewing file generated using landscape.  Also on some printers,
	 setpagedevice affects zebra stripes; on other printers, setpagedevice
	 affects the left margin.
	 Besides all that, if your printer does not have the paper size
	 specified by setpagedevice, your printing will be aborted.
	 So, if you need to use setpagedevice, set `ps-spool-config' to
	 `setpagedevice', generate a test file and send it to your printer; if
	 the printed file isn't ok, set `ps-spool-config' to nil." :type '(choice :menu-tag "Spool Config" :tag "Spool Config" (const lpr-switches) (const setpagedevice) (const :tag "nil" nil)) :group 'ps-print-headers)

(defcustom ps-spool-duplex nil "\
*Non-nil generates PostScript for a two-sided printer.
For a duplex printer, the `ps-spool-*' and `ps-print-*' commands will insert
blank pages as needed between print jobs so that the next buffer printed will
start on the right page.  Also, if headers are turned on, the headers will be
reversed on duplex printers so that the page numbers fall to the left on
even-numbered pages.

See also `ps-spool-tumble'." :type 'boolean :group 'ps-print-headers)

(defcustom ps-spool-tumble nil "\
*Specify how the page images on opposite sides of a sheet are oriented.
If `ps-spool-tumble' is nil, produces output suitable for binding on the left
or right.  If `ps-spool-tumble' is non-nil, produces output suitable for
binding at the top or bottom.

It has effect only when `ps-spool-duplex' is non-nil." :type 'boolean :group 'ps-print-headers)

(defcustom ps-font-info-database '((Courier (fonts (normal . "Courier") (bold . "Courier-Bold") (italic . "Courier-Oblique") (bold-italic . "Courier-BoldOblique")) (size . 10.0) (line-height . 10.55) (space-width . 6.0) (avg-char-width . 6.0)) (Helvetica (fonts (normal . "Helvetica") (bold . "Helvetica-Bold") (italic . "Helvetica-Oblique") (bold-italic . "Helvetica-BoldOblique")) (size . 10.0) (line-height . 11.56) (space-width . 2.78) (avg-char-width . 5.09243)) (Times (fonts (normal . "Times-Roman") (bold . "Times-Bold") (italic . "Times-Italic") (bold-italic . "Times-BoldItalic")) (size . 10.0) (line-height . 11.0) (space-width . 2.5) (avg-char-width . 4.71432)) (Palatino (fonts (normal . "Palatino-Roman") (bold . "Palatino-Bold") (italic . "Palatino-Italic") (bold-italic . "Palatino-BoldItalic")) (size . 10.0) (line-height . 12.1) (space-width . 2.5) (avg-char-width . 5.08676)) (Helvetica-Narrow (fonts (normal . "Helvetica-Narrow") (bold . "Helvetica-Narrow-Bold") (italic . "Helvetica-Narrow-Oblique") (bold-italic . "Helvetica-Narrow-BoldOblique")) (size . 10.0) (line-height . 11.56) (space-width . 2.2796) (avg-char-width . 4.17579)) (NewCenturySchlbk (fonts (normal . "NewCenturySchlbk-Roman") (bold . "NewCenturySchlbk-Bold") (italic . "NewCenturySchlbk-Italic") (bold-italic . "NewCenturySchlbk-BoldItalic")) (size . 10.0) (line-height . 12.15) (space-width . 2.78) (avg-char-width . 5.31162)) (AvantGarde-Book (fonts (normal . "AvantGarde-Book") (italic . "AvantGarde-BookOblique")) (size . 10.0) (line-height . 11.77) (space-width . 2.77) (avg-char-width . 5.45189)) (AvantGarde-Demi (fonts (normal . "AvantGarde-Demi") (italic . "AvantGarde-DemiOblique")) (size . 10.0) (line-height . 12.72) (space-width . 2.8) (avg-char-width . 5.51351)) (Bookman-Demi (fonts (normal . "Bookman-Demi") (italic . "Bookman-DemiItalic")) (size . 10.0) (line-height . 11.77) (space-width . 3.4) (avg-char-width . 6.05946)) (Bookman-Light (fonts (normal . "Bookman-Light") (italic . "Bookman-LightItalic")) (size . 10.0) (line-height . 11.79) (space-width . 3.2) (avg-char-width . 5.67027)) (Symbol (fonts (normal . "Symbol")) (size . 10.0) (line-height . 13.03) (space-width . 2.5) (avg-char-width . 3.24324)) (Zapf-Dingbats (fonts (normal . "Zapf-Dingbats")) (size . 10.0) (line-height . 9.630000000000001) (space-width . 2.78) (avg-char-width . 2.78)) (Zapf-Chancery-MediumItalic (fonts (normal . "Zapf-Chancery-MediumItalic")) (size . 10.0) (line-height . 11.45) (space-width . 2.2) (avg-char-width . 4.10811))) "\
*Font info database: font family (the key), name, bold, italic, bold-italic,
reference size, line height, space width, average character width.
To get the info for another specific font (say Helvetica), do the following:
- create a new buffer
- generate the PostScript image to a file (C-u M-x ps-print-buffer)
- open this file and delete the leading `%' (which is the PostScript comment
  character) from the line
	   `% 3 cm 20 cm moveto  10/Courier ReportFontInfo  showpage'
  to get the line
	   `3 cm 20 cm moveto  10/Helvetica ReportFontInfo  showpage'
- add the values to `ps-font-info-database'.
You can get all the fonts of YOUR printer using `ReportAllFontInfo'.

Note also that ps-print DOESN'T download any font to your printer, instead it
uses the fonts resident in your printer." :type '(repeat (list :tag "Font Definition" (symbol :tag "Font Family") (cons :format "%v" (const :format "" fonts) (repeat :tag "Faces" (cons (choice :menu-tag "Font Weight/Slant" :tag "Font Weight/Slant" (const normal) (const bold) (const italic) (const bold-italic) (symbol :tag "Face")) (string :tag "Font Name")))) (cons :format "%v" (const :format "" size) (number :tag "Reference Size")) (cons :format "%v" (const :format "" line-height) (number :tag "Line Height")) (cons :format "%v" (const :format "" space-width) (number :tag "Space Width")) (cons :format "%v" (const :format "" avg-char-width) (number :tag "Average Character Width")))) :group 'ps-print-font)

(defcustom ps-font-family 'Courier "\
*Font family name for ordinary text, when generating PostScript." :type 'symbol :group 'ps-print-font)

(defcustom ps-font-size '(7 . 8.5) "\
*Font size, in points, for ordinary text, when generating PostScript." :type '(choice :menu-tag "Ordinary Text Font Size" :tag "Ordinary Text Font Size" (number :tag "Text Size") (cons :tag "Landscape/Portrait" (number :tag "Landscape Text Size") (number :tag "Portrait Text Size"))) :group 'ps-print-font)

(defcustom ps-header-font-family 'Helvetica "\
*Font family name for text in the header, when generating PostScript." :type 'symbol :group 'ps-print-font)

(defcustom ps-header-font-size '(10 . 12) "\
*Font size, in points, for text in the header, when generating PostScript." :type '(choice :menu-tag "Header Font Size" :tag "Header Font Size" (number :tag "Header Size") (cons :tag "Landscape/Portrait" (number :tag "Landscape Header Size") (number :tag "Portrait Header Size"))) :group 'ps-print-font)

(defcustom ps-header-title-font-size '(12 . 14) "\
*Font size, in points, for the top line of text in header, in PostScript." :type '(choice :menu-tag "Header Title Font Size" :tag "Header Title Font Size" (number :tag "Header Title Size") (cons :tag "Landscape/Portrait" (number :tag "Landscape Header Title Size") (number :tag "Portrait Header Title Size"))) :group 'ps-print-font)

(defcustom ps-footer-font-family 'Helvetica "\
*Font family name for text in the footer, when generating PostScript." :version "21.1" :type 'symbol :group 'ps-print-font)

(defcustom ps-footer-font-size '(10 . 12) "\
*Font size, in points, for text in the footer, when generating PostScript." :version "21.1" :type '(choice :menu-tag "Footer Font Size" :tag "Footer Font Size" (number :tag "Footer Size") (cons :tag "Landscape/Portrait" (number :tag "Landscape Footer Size") (number :tag "Portrait Footer Size"))) :group 'ps-print-font)

(defcustom ps-line-number-color "black" "\
*Specify color for line-number, when generating PostScript." :type '(choice :menu-tag "Line Number Color" :tag "Line Number Color" (number :tag "Gray Scale" :value 0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0 0 0) (number :tag "Red") (number :tag "Green") (number :tag "Blue"))) :version "21.1" :group 'ps-print-font :group 'ps-print-miscellany)

(defcustom ps-line-number-font "Times-Italic" "\
*Font for line-number, when generating PostScript." :type 'string :group 'ps-print-font :group 'ps-print-miscellany)

(defcustom ps-line-number-font-size 6 "\
*Font size, in points, for line number, when generating PostScript." :type '(choice :menu-tag "Line Number Font Size" :tag "Line Number Font Size" (number :tag "Font Size") (cons :tag "Landscape/Portrait" (number :tag "Landscape Font Size") (number :tag "Portrait Font Size"))) :group 'ps-print-font :group 'ps-print-miscellany)

(defcustom ps-print-color-p (or (and (fboundp 'color-values) (ps-e-color-values "Green")) (fboundp 'x-color-values) (fboundp 'color-instance-rgb-components)) "\
*Specify how buffer's text color is printed.

Valid values are:

   nil		Do not print colors.

   t		Print colors.

   black-white	Print colors on black/white printer.
		See also `ps-black-white-faces'.

Any other value is treated as t." :type '(choice :menu-tag "Print Color" :tag "Print Color" (const :tag "Do NOT Print Color" nil) (const :tag "Print Always Color" t) (const :tag "Print Black/White Color" black-white)) :group 'ps-print-color)

(defcustom ps-default-fg '(0.0 0.0 0.0) "\
*RGB values of the default foreground color.  Defaults to black." :type '(choice :menu-tag "Default Foreground Gray/Color" :tag "Default Foreground Gray/Color" (number :tag "Gray Scale" :value 0.0) (string :tag "Color Name" :value "black") (list :tag "RGB Color" :value (0.0 0.0 0.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue"))) :group 'ps-print-color)

(defcustom ps-default-bg '(1.0 1.0 1.0) "\
*RGB values of the default background color.  Defaults to white." :type '(choice :menu-tag "Default Background Gray/Color" :tag "Default Background Gray/Color" (number :tag "Gray Scale" :value 1.0) (string :tag "Color Name" :value "white") (list :tag "RGB Color" :value (1.0 1.0 1.0) (number :tag "Red") (number :tag "Green") (number :tag "Blue"))) :group 'ps-print-color)

(defcustom ps-auto-font-detect t "\
*Non-nil means automatically detect bold/italic/underline face attributes.
If nil, we rely solely on the lists `ps-bold-faces', `ps-italic-faces', and
`ps-underlined-faces'." :type 'boolean :group 'ps-print-font)

(defcustom ps-black-white-faces '((font-lock-builtin-face "black" nil bold) (font-lock-comment-face "gray20" nil italic) (font-lock-constant-face "black" nil bold) (font-lock-function-name-face "black" nil bold) (font-lock-keyword-face "black" nil bold) (font-lock-string-face "black" nil italic) (font-lock-type-face "black" nil italic) (font-lock-variable-name-face "black" nil bold italic) (font-lock-warning-face "black" nil bold italic)) "\
*Specify list of face attributes to print colors on black/white printers.

The list elements are the same as defined on `ps-extend-face' (which see).

This variable is used only when `ps-print-color-p' is set to `black-white'." :version "21.1" :type '(repeat (list :tag "Face Specification" (face :tag "Face Symbol") (choice :menu-tag "Foreground Color" :tag "Foreground Color" (const :tag "Black" nil) (string :tag "Color Name")) (choice :menu-tag "Background Color" :tag "Background Color" (const :tag "None" nil) (string :tag "Color Name")) (repeat :inline t (choice :menu-tag "Attribute" (const bold) (const italic) (const underline) (const strikeout) (const overline) (const shadow) (const box) (const outline))))) :group 'ps-print-face)

(defcustom ps-bold-faces (unless ps-print-color-p '(font-lock-function-name-face font-lock-builtin-face font-lock-variable-name-face font-lock-keyword-face font-lock-warning-face)) "\
*A list of the (non-bold) faces that should be printed in bold font.
This applies to generating PostScript." :type '(repeat face) :group 'ps-print-face)

(defcustom ps-italic-faces (unless ps-print-color-p '(font-lock-variable-name-face font-lock-type-face font-lock-string-face font-lock-comment-face font-lock-warning-face)) "\
*A list of the (non-italic) faces that should be printed in italic font.
This applies to generating PostScript." :type '(repeat face) :group 'ps-print-face)

(defcustom ps-underlined-faces (unless ps-print-color-p '(font-lock-function-name-face font-lock-constant-face font-lock-warning-face)) "\
*A list of the (non-underlined) faces that should be printed underlined.
This applies to generating PostScript." :type '(repeat face) :group 'ps-print-face)

(defcustom ps-use-face-background nil "\
*Specify if face background should be used.

Valid values are:

   t		always use face background color.
   nil		never use face background color.
   (face...)	list of faces whose background color will be used.

Any other value will be treated as t." :type '(choice :menu-tag "Use Face Background" :tag "Use Face Background" (const :tag "Always Use Face Background" t) (const :tag "Never Use Face Background" nil) (repeat :menu-tag "Face Background List" :tag "Face Background List" face)) :group 'ps-print-face)

(defcustom ps-left-header (list 'ps-get-buffer-name 'ps-header-dirpart) "\
*The items to display (each on a line) on the left part of the page header.
This applies to generating PostScript.

The value should be a list of strings and symbols, each representing an entry
in the PostScript array HeaderLinesLeft.

Strings are inserted unchanged into the array; those representing
PostScript string literals should be delimited with PostScript string
delimiters '(' and ')'.

For symbols with bound functions, the function is called and should return a
string to be inserted into the array.  For symbols with bound values, the value
should be a string to be inserted into the array.  In either case, function or
variable, the string value has PostScript string delimiters added to it." :type '(repeat (choice :menu-tag "Left Header" :tag "Left Header" string symbol)) :group 'ps-print-headers)

(defcustom ps-right-header (list "/pagenumberstring load" 'ps-time-stamp-locale-default 'ps-time-stamp-hh:mm:ss) "\
*The items to display (each on a line) on the right part of the page header.
This applies to generating PostScript.

See the variable `ps-left-header' for a description of the format of this
variable.

There are the following basic functions implemented:

   `ps-time-stamp-locale-default'	Return the locale's \"preferred\" date
					as, for example, \"06/18/01\".

   `ps-time-stamp-hh:mm:ss'		Return time as \"17:28:31\".

   `ps-time-stamp-mon-dd-yyyy'		Return date as \"Jun 18 2001\".

You can also create your own time stamp function by using `format-time-string'
\(which see)." :type '(repeat (choice :menu-tag "Right Header" :tag "Right Header" string symbol)) :group 'ps-print-headers)

(defcustom ps-left-footer (list 'ps-get-buffer-name 'ps-header-dirpart) "\
*The items to display (each on a line) on the left part of the page footer.
This applies to generating PostScript.

The value should be a list of strings and symbols, each representing an entry
in the PostScript array FooterLinesLeft.

Strings are inserted unchanged into the array; those representing PostScript
string literals should be delimited with PostScript string delimiters '(' and
')'.

For symbols with bound functions, the function is called and should return a
string to be inserted into the array.  For symbols with bound values, the value
should be a string to be inserted into the array.  In either case, function or
variable, the string value has PostScript string delimiters added to it." :version "21.1" :type '(repeat (choice :menu-tag "Left Footer" :tag "Left Footer" string symbol)) :group 'ps-print-headers)

(defcustom ps-right-footer (list "/pagenumberstring load" 'ps-time-stamp-locale-default 'ps-time-stamp-hh:mm:ss) "\
*The items to display (each on a line) on the right part of the page footer.
This applies to generating PostScript.

See the variable `ps-left-footer' for a description of the format of this
variable.

There are the following basic functions implemented:

   `ps-time-stamp-locale-default'	Return the locale's \"preferred\" date
					as, for example, \"06/18/01\".

   `ps-time-stamp-hh:mm:ss'		Return time as \"17:28:31\".

   `ps-time-stamp-mon-dd-yyyy'		Return date as \"Jun 18 2001\".

You can also create your own time stamp function by using `format-time-string'
\(which see)." :version "21.1" :type '(repeat (choice :menu-tag "Right Footer" :tag "Right Footer" string symbol)) :group 'ps-print-headers)

(defcustom ps-razzle-dazzle t "\
*Non-nil means report progress while formatting buffer." :type 'boolean :group 'ps-print-miscellany)

(defcustom ps-adobe-tag "%!PS-Adobe-3.0\n" "\
*Contains the header line identifying the output as PostScript.
By default, `ps-adobe-tag' contains the standard identifier.  Some printers
require slightly different versions of this line." :type 'string :group 'ps-print-miscellany)

(defcustom ps-build-face-reference t "\
*Non-nil means build the reference face lists.

ps-print sets this value to nil after it builds its internal reference lists of
bold and italic faces.  By settings its value back to t, you can force ps-print
to rebuild the lists the next time you invoke one of the ...-with-faces
commands.

You should set this value back to t after you change the attributes of any
face, or create new faces.  Most users shouldn't have to worry about its
setting, though." :type 'boolean :group 'ps-print-face)

(defcustom ps-always-build-face-reference nil "\
*Non-nil means always rebuild the reference face lists.

If this variable is non-nil, ps-print will rebuild its internal reference lists
of bold and italic faces *every* time one of the ...-with-faces commands is
called.  Most users shouldn't need to set this variable." :type 'boolean :group 'ps-print-face)

(defcustom ps-banner-page-when-duplexing nil "\
*Non-nil means the very first page is skipped.
It's like the very first character of buffer (or region) is ^L (\\014)." :type 'boolean :group 'ps-print-headers)

(defcustom ps-postscript-code-directory (or (cond ((eq ps-print-emacs-type 'emacs) data-directory) ((fboundp 'locate-data-directory) (locate-data-directory "ps-print")) ((boundp 'data-directory) data-directory) (t nil)) (error "ps-postscript-code-directory isn't set properly")) "\
*Directory where it's located the PostScript prologue file used by ps-print.
By default, this directory is the same as in the variable `data-directory'." :type 'directory :group 'ps-print-miscellany)

(defcustom ps-line-spacing 0 "\
*Specify line spacing, in points, for ordinary text.

See also `ps-paragraph-spacing' and `ps-paragraph-regexp'.

To get all lines with some spacing set both `ps-line-spacing' and
`ps-paragraph-spacing' variables." :type '(choice :menu-tag "Line Spacing For Ordinary Text" :tag "Line Spacing For Ordinary Text" (number :tag "Line Spacing") (cons :tag "Landscape/Portrait" (number :tag "Landscape Line Spacing") (number :tag "Portrait Line Spacing"))) :version "21.1" :group 'ps-print-miscellany)

(defcustom ps-paragraph-spacing 0 "\
*Specify paragraph spacing, in points, for ordinary text.

See also `ps-line-spacing' and `ps-paragraph-regexp'.

To get all lines with some spacing set both `ps-line-spacing' and
`ps-paragraph-spacing' variables." :type '(choice :menu-tag "Paragraph Spacing For Ordinary Text" :tag "Paragraph Spacing For Ordinary Text" (number :tag "Paragraph Spacing") (cons :tag "Landscape/Portrait" (number :tag "Landscape Paragraph Spacing") (number :tag "Portrait Paragraph Spacing"))) :version "21.1" :group 'ps-print-miscellany)

(defcustom ps-paragraph-regexp "[ 	]*$" "\
*Specify paragraph delimiter.

It should be a regexp or nil.

See also `ps-paragraph-spacing'." :type '(choice :menu-tag "Paragraph Delimiter" (const :tag "No Delimiter" nil) (regexp :tag "Delimiter Regexp")) :version "21.1" :group 'ps-print-miscellany)

(defcustom ps-begin-cut-regexp nil "\
*Specify regexp which is start of a region to cut out when printing.

As an example, variables `ps-begin-cut-regexp' and `ps-end-cut-regexp' may be
set to \"^Local Variables:\" and \"^End:\", respectively, in order to leave out
some special printing instructions from the actual print.  Special printing
instructions may be appended to the end of the file just like any other
buffer-local variables.  See section \"Local Variables in Files\" on Emacs
manual for more information.

Variables `ps-begin-cut-regexp' and `ps-end-cut-regexp' control together what
actually gets printed.  Both variables may be set to nil in which case no
cutting occurs." :type 'regexp :version "21.1" :group 'ps-print-miscellany)

(defcustom ps-end-cut-regexp nil "\
*Specify regexp which is end of the region to cut out when printing.

See `ps-begin-cut-regexp' for more information." :type 'regexp :version "21.1" :group 'ps-print-miscellany)

;;;***

(provide 'ps-print-custom-defines)
