;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'psgml-custom-defines) (error "Feature psgml-custom-defines already loaded"))

;;;### (autoloads (psgml-html-faces html-helper-user-menu html-helper-use-expert-menu html-helper-types-to-install html-helper-timestamp-end html-helper-timestamp-start html-helper-new-buffer-template html-helper-timestamp-hook html-helper-build-new-buffer html-helper-do-write-file-hooks html-helper-htmldtd-version html-helper-address-string psgml-html html) "psgml-html" "psgml/psgml-html.el")
(defconst custom-define-current-source-file "psgml-html.el")

(defgroup html nil "HyperText Markup Language" :group 'sgml)

(defgroup psgml-html nil "HTML mode in conjunction with PSGML" :tag "Psgml Html" :prefix "html-helper-" :prefix "psgml-html-" :group 'html :group 'hypermedia :group 'psgml)

(defcustom html-helper-address-string (concat "<a href=\"mailto:" (or user-mail-address (concat (user-login-name) "@" (or mail-host-address (system-name)))) "\">" (user-full-name) "</a>") "\
*The default author string of each file." :type 'string :group 'psgml-html)

(defcustom html-helper-htmldtd-version "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n" "\
*Version of HTML DTD you're using." :type 'string :group 'psgml-html)

(defcustom html-helper-do-write-file-hooks t "\
*If not nil, then modify `local-write-file-hooks' to do timestamps." :type 'boolean :group 'psgml-html)

(defcustom html-helper-build-new-buffer t "\
*If not nil, then insert `html-helper-new-buffer-strings' for new buffers." :type 'boolean :group 'psgml-html)

(defcustom html-helper-timestamp-hook 'html-helper-default-insert-timestamp "\
*Hook called for timestamp insertion.
Override this for your own timestamp styles." :type 'hook :group 'psgml-html)

(defcustom html-helper-new-buffer-template '(html-helper-htmldtd-version "<html>\n" "  <head>\n" "    <title>" (p "Document Title: " title) "</title>\n" "  </head>\n" "\n" "  <body>\n" "    <h1>" (s title) "</h1>\n\n" p "\n\n    <hr>\n" "    <address>" html-helper-address-string "</address>\n" (html-helper-return-created-string) html-helper-timestamp-start html-helper-timestamp-end "\n  </body>\n</html>\n") "\
*Template for new buffers.
Inserted by `html-helper-insert-new-buffer-strings' if
`html-helper-build-new-buffer' is set to t" :type 'sexp :group 'psgml-html)

(defcustom html-helper-timestamp-start "<!-- hhmts start -->\n" "\
*Start delimiter for timestamps.
Everything between `html-helper-timestamp-start' and
`html-helper-timestamp-end' will be deleted and replaced with the output
of the functions `html-helper-timestamp-hook' if
`html-helper-do-write-file-hooks' is t" :type 'string :group 'psgml-html)

(defcustom html-helper-timestamp-end "<!-- hhmts end -->" "\
*End delimiter for timestamps.
Everything between `html-helper-timestamp-start' and
`html-helper-timestamp-end' will be deleted and replaced with the output
of the function `html-helper-insert-timestamp' if
`html-helper-do-write-file-hooks' is t" :type 'string :group 'psgml-html)

(defcustom html-helper-types-to-install '(anchor header logical phys list textel entity image head form table special) "\
*List of tag types to install when html-helper-mode is first loaded.
If you want to not install some type of tag, override this variable.
Order is significant: menus go in this order." :type '(repeat symbol) :group 'psgml-html)

(defcustom html-helper-use-expert-menu nil "\
*If not nil, then use the full HTML menu." :type 'boolean :group 'psgml-html)

(defcustom html-helper-user-menu nil "\
*Extra items to put in the HTML expert menu.
The value of this symbol is appended to the beginning of the expert
menu that is handed off to easymenu for definition. It should be a
list of vectors or lists which themselves are vectors (for submenus)." :type 'sexp :group 'psgml-html)

(defgroup psgml-html-faces nil "Faces for highlighting HTML." :prefix "html-helper-" :group 'faces :group 'psgml-html)

;;;***

;;;### (autoloads (sgml-mode-hook sgml-xml-declaration sgml-declaration sgml-validate-files sgml-xml-validate-command sgml-validate-command sgml-custom-dtd sgml-custom-markup sgml-public-transliterations sgml-local-ecat-files sgml-ecat-files sgml-catalog-files sgml-local-catalogs sgml-public-map sgml-system-path sgml-inhibit-indent-tags sgml-trace-entity-lookup sgml-recompile-out-of-date-cdtd sgml-ignore-undefined-elements sgml-warn-about-undefined-entities sgml-warn-about-undefined-elements sgml-leave-point-after-insert sgml-omittag-transparent sgml-balanced-tag-edit sgml-auto-insert-required-elements sgml-general-insert-case sgml-normalize-trims sgml-tag-region-if-active sgml-offer-save sgml-auto-activate-dtd sgml-live-element-indicator sgml-set-face sgml-markup-faces sgml-default-doctype-name sgml-range-indicator-max-length sgml-system-identifiers-are-preferred sgml-insert-end-tag-on-new-line sgml-insert-missing-element-comment psgml-dtd psgml-insert psgml sgml) "psgml" "psgml/psgml.el")
(defconst custom-define-current-source-file "psgml.el")

(defgroup sgml nil "Standard Generalized Markup Language" :group 'languages)

(defgroup psgml nil "SGML-editing mode with parsing support" :prefix "sgml-" :group 'sgml)

(defgroup psgml-insert nil "Inserting features of psgml" :prefix "sgml-" :group 'psgml)

(defgroup psgml-dtd nil "DTD, CATALOG and DOCTYPE customizations in psgml" :prefix "sgml-" :group 'psgml)

(defcustom sgml-insert-missing-element-comment t "\
*If true, and sgml-auto-insert-required-elements also true,
`sgml-insert-element' will insert a comment if there is an element required
but there is more than one to choose from." :type 'boolean :group 'psgml-insert)

(defcustom sgml-insert-end-tag-on-new-line nil "\
*If true, `sgml-insert-element' will put the end-tag on a new line
after the start-tag. Useful on slow terminals if you find the end-tag after
the cursor irritating." :type 'boolean :group 'psgml-insert)

(defcustom sgml-system-identifiers-are-preferred nil "\
*Controls lookup of external entities.
nil means look up external entities by searching the catalogs
in `sgml-local-catalogs' and `sgml-catalog-files' and only if the
entity is not found in the catalogs, use a given system identifier.
Non-nil means use a system identifier for the entity if one is given.
If no system identifier is given the catalogs will searched." :type 'boolean :group 'psgml-dtd)

(defcustom sgml-range-indicator-max-length 9 "\
*Control of menu indicators.
Maximum number of characters used from the first and last entry
of a submenu to indicate the range of that menu." :type 'integer :group 'psgml)

(defcustom sgml-default-doctype-name nil "\
*Document type name to use if no document type declaration is present." :type '(choice string (const nil)) :group 'psgml-dtd)

(defcustom sgml-markup-faces (backquote ((start-tag \, (if (facep 'font-lock-function-name-face) 'font-lock-function-name-face 'bold)) (end-tag \, (if (facep 'font-lock-function-name-face) 'font-lock-function-name-face 'bold)) (comment \, (if (facep 'font-lock-comment-face) 'font-lock-comment-face 'bold)) (pi \, (if (facep 'font-lock-type-face) 'font-lock-type-face 'bold)) (sgml \, (if (facep 'font-lock-type-face) 'font-lock-type-face 'bold)) (doctype \, (if (facep 'font-lock-keyword-face) 'font-lock-keyword-face 'bold)) (entity \, (if (facep 'font-lock-string-face) 'font-lock-string-face 'bold)) (shortref \, (if (facep 'font-lock-string-face) 'font-lock-string-face 'bold)) (ignored \, (if (facep 'font-lock-constant-face) 'font-lock-constant-face 'default)) (ms-start \, (if (facep 'font-lock-constant-face) 'font-lock-constant-face 'default)) (ms-end \, (if (facep 'font-lock-constant-face) 'font-lock-constant-face 'default)))) "\
*List of markup to face mappings.
Element are of the form (MARKUP-TYPE . FACE).
Possible values for MARKUP-TYPE are:
comment	- comment declaration
doctype	- doctype declaration
end-tag
ignored	- ignored marked section
ms-end	- marked section start, if not ignored
ms-start- marked section end, if not ignored
pi	- processing instruction
sgml	- SGML declaration
start-tag
entity  - general entity reference
shortref- short reference" :type '(repeat (cons symbol face)) :group 'psgml)

(defcustom sgml-set-face nil "\
*If non-nil, psgml will set the face of parsed markup." :type 'boolean :group 'psgml)

(defcustom sgml-live-element-indicator nil "\
*If non-nil, indicate current element in mode line.
This may be slow." :type 'boolean :group 'psgml)

(defcustom sgml-auto-activate-dtd nil "\
*If non-nil, loading a sgml-file will automatically try to activate its DTD.
Activation means either to parse the document type declaration or to
load a previously saved parsed DTD.  The name of the activated DTD
will be shown in the mode line." :type 'boolean :group 'psgml-dtd)

(defcustom sgml-offer-save t "\
*If non-nil, ask about saving modified buffers before \\[sgml-validate] is run." :type 'boolean :group 'psgml)

(defcustom sgml-tag-region-if-active t "\
*If non-nil, the Tags menu will tag a region if the region is 
considered active by emacs.  If nil, region must be active and
`transient-mark-mode' must be on for the region to be tagged." :type 'boolean :group 'psgml)

(defcustom sgml-normalize-trims t "\
*If non-nil, sgml-normalize will trim off white space from end of element
when adding end tag." :type 'boolean :group 'psgml)

(defcustom sgml-general-insert-case 'lower "\
*The case that will be used for general names in inserted markup.
This can be the symbol `lower' or `upper'.  Only effective if
`sgml-namecase-general' is true." :type '(choice (const lower) (const upper)) :group 'psgml-insert)

(defcustom sgml-auto-insert-required-elements t "\
*If non-nil, automatically insert required elements in the content
of an inserted element." :type 'boolean :group 'psgml-insert)

(defcustom sgml-balanced-tag-edit t "\
*If non-nil, always insert start-end tag pairs." :type 'boolean :group 'psgml-insert)

(defcustom sgml-omittag-transparent (not sgml-balanced-tag-edit) "\
*If non-nil, will show legal tags inside elements with omittable start tags
and legal tags beyond omittable end tags." :type 'boolean :group 'psgml)

(defcustom sgml-leave-point-after-insert nil "\
*If non-nil, the point will remain after inserted tag(s).
If nil, the point will be placed before the inserted tag(s)." :type 'boolean :group 'psgml-insert)

(defcustom sgml-warn-about-undefined-elements t "\
*If non-nil, print a warning when a tag for an undefined element is found." :type 'boolean :group 'psgml)

(defcustom sgml-warn-about-undefined-entities t "\
*If non-nil, print a warning when an undefined entity is found." :type 'boolean :group 'psgml)

(defcustom sgml-ignore-undefined-elements nil "\
*If non-nil, recover from an undefined element by ignoring the tag.
If nil, recover from an undefined element by assuming it can occur any
where and has content model ANY." :type 'boolean :group 'psgml)

(defcustom sgml-recompile-out-of-date-cdtd 'ask "\
*If non-nil, out of date compiled DTDs will be automatically recompiled.
If the value is `ask', PSGML will ask before recompiling. A `nil'
value will cause PSGML to silently load an out of date compiled DTD.
A DTD that refers to undefined external entities is always out of
date, thus in such case it can be useful to set this variable to
`nil'." :type 'symbol :group 'psgml-dtd)

(defcustom sgml-trace-entity-lookup nil "\
*If non-nil, log messages about catalog files used to look for
external entities." :type 'boolean :group 'psgml-dtd)

(defcustom sgml-inhibit-indent-tags nil "\
*List of tags within which indentation is inhibited.
The tags should be given as strings." :type 'boolean :group 'psgml)

(defcustom sgml-system-path (split-path (or (getenv "SGML_SEARCH_PATH") ".")) "\
*List of directories used to look for system identifiers.
The directory listed in `sgml-data-directory' is always searched in
addition to the directories listed here." :type '(repeat directory) :group 'psgml)

(defcustom sgml-public-map (split-path (or (getenv "SGML_PATH") (concat "%S" path-separator (directory-file-name sgml-data-directory) "%o/%c/%d"))) "\
*Mapping from public identifiers to file names.
This is a list of possible file names.  To find the file for a public
identifier the elements of the list are used one at the time from the
beginning.  If the element is a string a file name is constructed from
the string by substitution of the whole public identifier for %P,
owner for %O, public text class for %C, and public text description
for %D.  The text class will be converted to lower case and the owner
and description will be transliterated according to the variable
`sgml-public-transliterations'.  If the file exists it will be the file
used for the public identifier.  An element can also be a dotted pair
\(regexp . filename), the filename is a string treated as above, but
only if the regular expression, regexp, matches the public
identifier." :type '(repeat file) :group 'psgml-dtd)

(defcustom sgml-local-catalogs nil "\
*A list of SGML entity catalogs to be searched first when parsing the buffer.
This is used in addition to `sgml-catalog-files',  and `sgml-public-map'.
This variable is automatically local to the buffer." :type '(repeat file) :group 'psgml-dtd)

(defcustom sgml-catalog-files (split-path (or (getenv "SGML_CATALOG_FILES") (concat "CATALOG" path-separator (expand-file-name "CATALOG" sgml-data-directory)))) "\
*List of catalog entry files.
The files are in the format defined in the SGML Open Draft Technical
Resolution on Entity Management." :type '(repeat file) :group 'psgml-dtd)

(defcustom sgml-ecat-files (list "ECAT" "~/sgml/ECAT" (expand-file-name "ECAT" sgml-data-directory)) "\
*List of catalog files for PSGML." :type '(repeat file) :group 'psgml-dtd)

(defcustom sgml-local-ecat-files nil "\
*List of local catalog files for PSGML.
Automatically becomes buffer local if set." :type '(repeat file) :group 'psgml-dtd)

(defcustom sgml-public-transliterations '((?\  . ?_) (?/ . ?%) (?: . ?-)) "\
*Transliteration for characters that should be avoided in file names.
This is a list of dotted pairs (FROM . TO); where FROM is the the
character to be translated to TO.  This is used when parts of a public
identifier are used to construct a file name." :type '(repeat (cons character character)) :group 'psgml-dtd)

(defcustom sgml-custom-markup nil "\
*Menu entries to be added to the Markup menu.
The value should be a list of lists of two strings.  The first
string is the menu line and the second string is the text inserted
when the menu item is chosen.  The second string can contain a \\r
where the cursor should be left.  Also if a selection is made
according the same rules as for the Tags menu, the selection is
replaced with the second string and \\r is replaced with the
selection.

Example:

  ((\"Version1\" \"<![%Version1[\\r]]>\")
   (\"New page\"  \"<?NewPage>\"))
" :type '(repeat (list :inline t (string :tag "Menu Line") (string :tag "Inserted String"))) :group 'psgml)

(defcustom sgml-custom-dtd nil "\
Menu entries to be added to the DTD menu.
The value should be a list of entries to be added to the DTD menu.
Every entry should be a list.  The first element of the entry is a string
used as the menu entry.  The second element is a string containing a
doctype declaration (this can be nil if no doctype).  The rest of the
list should be a list of variables and values.  For backward
compatibility a single string instead of a variable is assigned to
`sgml-default-dtd-file'.  All variables are made buffer local and are also
added to the buffers local variables list.

Example:
   ((\"HTML\" nil
     sgml-default-dtd-file \"~/sgml/html.ced\"
     sgml-omittag nil sgml-shorttag nil)
    (\"HTML+\" \"<!doctype htmlplus system 'htmlplus.dtd'>\"
     \"~/sgml/htmlplus.ced\"
     sgml-omittag t sgml-shorttag nil)
    (\"DOCBOOK\" \"<!doctype docbook system 'docbook.dtd'>\"
     \"~/sgml/docbook.ced\"
     sgml-omittag nil sgml-shorttag t)))
" :type '(repeat (list (string :tag "Menu Entry") (choice (const :tag "No doctype") (string :tag "Declaration")) (repeat :inline t (list :inline t (symbol :tag "Variable") (sexp :tag "Value"))))) :group 'psgml-dtd)

(defcustom sgml-validate-command (concat "nsgmls -s -m " (expand-file-name "CATALOG" sgml-data-directory) " %s %s") "\
*The shell command to validate an SGML document.

This is a `format' control string that by default should contain two
`%s' conversion specifications: the first will be replaced by the
value of `sgml-declaration' (or the empty string, if nil); the
second will be replaced by the current buffer's file name (or the
empty string, if nil).

If `sgml-validate-files' is non-nil, the format string should contain
one `%s' conversion specification for each element of its result.

If sgml-validate-command is a list, then every element should be a
string.  The strings will be tried in order and %-sequences in the
string will be replaced according to the list below, if the string contains
%-sequences with no replacement value the next string will be tried.

%b means the visited file of the current buffer
%s means the SGML declaration specified in the `sgml-declaration' variable
%d means the file containing the DOCTYPE declaration, if not in the buffer 
" :type '(choice string (repeat string)) :group 'psgml)

(defcustom sgml-xml-validate-command "onsgmls -wxml -s %s %s" "\
*The shell command to validate an SGML document being edited in
`xml-mode'.  See `sgml-validate-command' for details." :type '(choice string (repeat string)) :group 'psgml)

(defcustom sgml-validate-files nil "\
If non-nil, a function of no arguments that returns a list of file names.
These file names will serve as the arguments to the `sgml-validate-command'
format control string instead of the defaults." :type 'hook :group 'psgml)

(defcustom sgml-declaration nil "\
*If non-nil, the name of the SGML declaration file." :type '(choice (const nil) file) :group 'psgml-dtd)

(defcustom sgml-xml-declaration nil "\
*If non-nil, the name of the SGML declaration for XML files." :type '(choice (const nil) file) :group 'psgml-dtd)

(defcustom sgml-mode-hook nil "\
A hook or list of hooks to be run when entering `sgml-mode'." :type 'hook :group 'psgml)

;;;***

(provide 'psgml-custom-defines)
