;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'python-modes-custom-defines) (error "Feature python-modes-custom-defines already loaded"))

;;;### (autoloads (py-hide-show-hide-docstrings py-hide-show-keywords py-shell-switch-buffers-on-execute py-shell-input-prompt-2-regexp py-shell-input-prompt-1-regexp py-pychecker-command-args py-pychecker-command py-jython-packages py-import-check-point-max py-pdbtrack-minor-mode-string py-pdbtrack-do-tracking-p py-imenu-show-method-args-p py-delete-function py-backspace-function py-ask-about-save py-jump-on-exception py-beep-if-tab-change py-temp-directory py-honor-comment-indentation py-block-comment-prefix py-align-multiline-strings-p py-smart-indentation py-continuation-offset py-indent-offset py-jython-command-args py-python-command-args py-default-interpreter py-jython-command py-python-command py-tab-always-indent python) "python-mode" "python-modes/python-mode.el")
(defconst custom-define-current-source-file "python-mode.el")

(defgroup python nil "Support for the Python programming language, <http://www.python.org/>" :group 'languages :prefix "py-")

(defcustom py-tab-always-indent t "\
*Non-nil means TAB in Python mode should always reindent the current line,
regardless of where in the line point is when the TAB command is used." :type 'boolean :group 'python)

(defcustom py-python-command "python" "\
*Shell command used to start Python interpreter." :type 'string :group 'python)

(defcustom py-jython-command "jython" "\
*Shell command used to start the Jython interpreter." :type 'string :group 'python :tag "Jython Command")

(defcustom py-default-interpreter 'cpython "\
*Which Python interpreter is used by default.
The value for this variable can be either `cpython' or `jython'.

When the value is `cpython', the variables `py-python-command' and
`py-python-command-args' are consulted to determine the interpreter
and arguments to use.

When the value is `jython', the variables `py-jython-command' and
`py-jython-command-args' are consulted to determine the interpreter
and arguments to use.

Note that this variable is consulted only the first time that a Python
mode buffer is visited during an Emacs session.  After that, use
\\[py-toggle-shells] to change the interpreter shell." :type '(choice (const :tag "Python (a.k.a. CPython)" cpython) (const :tag "Jython" jython)) :group 'python)

(defcustom py-python-command-args '("-i") "\
*List of string arguments to be used when starting a Python shell." :type '(repeat string) :group 'python)

(defcustom py-jython-command-args '("-i") "\
*List of string arguments to be used when starting a Jython shell." :type '(repeat string) :group 'python :tag "Jython Command Args")

(defcustom py-indent-offset 4 "\
*Amount of offset per level of indentation.
`\\[py-guess-indent-offset]' can usually guess a good value when
you're editing someone else's Python code." :type 'integer :group 'python)

(defcustom py-continuation-offset 4 "\
*Additional amount of offset to give for some continuation lines.
Continuation lines are those that immediately follow a backslash
terminated line.  Only those continuation lines for a block opening
statement are given this extra offset." :type 'integer :group 'python)

(defcustom py-smart-indentation t "\
*Should `python-mode' try to automagically set some indentation variables?
When this variable is non-nil, two things happen when a buffer is set
to `python-mode':

    1. `py-indent-offset' is guessed from existing code in the buffer.
       Only guessed values between 2 and 8 are considered.  If a valid
       guess can't be made (perhaps because you are visiting a new
       file), then the value in `py-indent-offset' is used.

    2. `indent-tabs-mode' is turned off if `py-indent-offset' does not
       equal `tab-width' (`indent-tabs-mode' is never turned on by
       Python mode).  This means that for newly written code, tabs are
       only inserted in indentation if one tab is one indentation
       level, otherwise only spaces are used.

Note that both these settings occur *after* `python-mode-hook' is run,
so if you want to defeat the automagic configuration, you must also
set `py-smart-indentation' to nil in your `python-mode-hook'." :type 'boolean :group 'python)

(defcustom py-align-multiline-strings-p t "\
*Flag describing how multi-line triple quoted strings are aligned.
When this flag is non-nil, continuation lines are lined up under the
preceding line's indentation.  When this flag is nil, continuation
lines are aligned to column zero." :type '(choice (const :tag "Align under preceding line" t) (const :tag "Align to column zero" nil)) :group 'python)

(defcustom py-block-comment-prefix "##" "\
*String used by \\[comment-region] to comment out a block of code.
This should follow the convention for non-indenting comment lines so
that the indentation commands won't get confused (i.e., the string
should be of the form `#x...' where `x' is not a blank or a tab, and
`...' is arbitrary).  However, this string should not end in whitespace." :type 'string :group 'python)

(defcustom py-honor-comment-indentation t "\
*Controls how comment lines influence subsequent indentation.

When nil, all comment lines are skipped for indentation purposes, and
if possible, a faster algorithm is used (i.e. X/Emacs 19 and beyond).

When t, lines that begin with a single `#' are a hint to subsequent
line indentation.  If the previous line is such a comment line (as
opposed to one that starts with `py-block-comment-prefix'), then its
indentation is used as a hint for this line's indentation.  Lines that
begin with `py-block-comment-prefix' are ignored for indentation
purposes.

When not nil or t, comment lines that begin with a single `#' are used
as indentation hints, unless the comment character is in column zero." :type '(choice (const :tag "Skip all comment lines (fast)" nil) (const :tag "Single # `sets' indentation for next line" t) (const :tag "Single # `sets' indentation except at column zero" other)) :group 'python)

(defcustom py-temp-directory (let ((ok '(lambda (x) (and x (setq x (expand-file-name x)) (file-directory-p x) (file-writable-p x) x)))) (or (funcall ok (getenv "TMPDIR")) (funcall ok "/usr/tmp") (funcall ok "/tmp") (funcall ok "/var/tmp") (funcall ok ".") (error "Couldn't find a usable temp directory -- set `py-temp-directory'"))) "\
*Directory used for temporary files created by a *Python* process.
By default, the first directory from this list that exists and that you
can write into: the value (if any) of the environment variable TMPDIR,
/usr/tmp, /tmp, /var/tmp, or the current directory." :type 'string :group 'python)

(defcustom py-beep-if-tab-change t "\
*Ring the bell if `tab-width' is changed.
If a comment of the form

  	# vi:set tabsize=<number>:

is found before the first code line when the file is entered, and the
current value of (the general Emacs variable) `tab-width' does not
equal <number>, `tab-width' is set to <number>, a message saying so is
displayed in the echo area, and if `py-beep-if-tab-change' is non-nil
the Emacs bell is also rung as a warning." :type 'boolean :group 'python)

(defcustom py-jump-on-exception t "\
*Jump to innermost exception frame in *Python Output* buffer.
When this variable is non-nil and an exception occurs when running
Python code synchronously in a subprocess, jump immediately to the
source code of the innermost traceback frame." :type 'boolean :group 'python)

(defcustom py-ask-about-save t "\
If not nil, ask about which buffers to save before executing some code.
Otherwise, all modified buffers are saved without asking." :type 'boolean :group 'python)

(defcustom py-backspace-function 'backward-delete-char-untabify "\
*Function called by `py-electric-backspace' when deleting backwards." :type 'function :group 'python)

(defcustom py-delete-function 'delete-char "\
*Function called by `py-electric-delete' when deleting forwards." :type 'function :group 'python)

(defcustom py-imenu-show-method-args-p nil "\
*Controls echoing of arguments of functions & methods in the Imenu buffer.
When non-nil, arguments are printed." :type 'boolean :group 'python)

(defcustom py-pdbtrack-do-tracking-p t "\
*Controls whether the pdbtrack feature is enabled or not.
When non-nil, pdbtrack is enabled in all comint-based buffers,
e.g. shell buffers and the *Python* buffer.  When using pdb to debug a
Python program, pdbtrack notices the pdb prompt and displays the
source file and line that the program is stopped at, much the same way
as gud-mode does for debugging C programs with gdb." :type 'boolean :group 'python)

(defcustom py-pdbtrack-minor-mode-string " PDB" "\
*String to use in the minor mode list when pdbtrack is enabled." :type 'string :group 'python)

(defcustom py-import-check-point-max 20000 "\
Maximum number of characters to search for a Java-ish import statement.
When `python-mode' tries to calculate the shell to use (either a
CPython or a Jython shell), it looks at the so-called `shebang' line
-- i.e. #! line.  If that's not available, it looks at some of the
file heading imports to see if they look Java-like." :type 'integer :group 'python)

(defcustom py-jython-packages '("java" "javax" "org" "com") "\
Imported packages that imply `jython-mode'." :type '(repeat string) :group 'python)

(defcustom py-pychecker-command "pychecker" "\
*Shell command used to run Pychecker." :type 'string :group 'python :tag "Pychecker Command")

(defcustom py-pychecker-command-args '("--stdlib") "\
*List of string arguments to be passed to pychecker." :type '(repeat string) :group 'python :tag "Pychecker Command Args")

(defcustom py-shell-input-prompt-1-regexp "^>>> " "\
*A regular expression to match the input prompt of the shell." :type 'string :group 'python)

(defcustom py-shell-input-prompt-2-regexp "^[.][.][.] " "\
*A regular expression to match the input prompt of the shell after the
  first line of input." :type 'string :group 'python)

(defcustom py-shell-switch-buffers-on-execute t "\
*Controls switching to the Python buffer where commands are
  executed.  When non-nil the buffer switches to the Python buffer, if
  not no switching occurs." :type 'boolean :group 'python)

(defcustom py-hide-show-keywords '("class" "def" "elif" "else" "except" "for" "if" "while" "finally" "try" "with") "\
*Keywords used by hide-show" :type '(repeat string) :group 'python)

(defcustom py-hide-show-hide-docstrings t "\
*If doc strings shall be hidden" :type 'boolean :group 'python)

;;;***

(provide 'python-modes-custom-defines)
