;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'riece-custom-defines) (error "Feature riece-custom-defines already loaded"))

;;;### (autoloads (riece-addon-list-font-lock-keywords riece-addon-list-mark-face-alist riece-addon-list-faces riece-addon-list) "riece-addon" "lisp/riece-addon.el")
(defconst custom-define-current-source-file "riece-addon.el")

(defgroup riece-addon-list nil "Add-on listing." :tag "Addon list" :prefix "riece-addon-list-" :group 'riece)

(defgroup riece-addon-list-faces nil "Faces for riece-addon-list-mode." :tag "Faces" :prefix "riece-addon-list-" :group 'riece-addon-list)

(defcustom riece-addon-list-mark-face-alist '((?+ . riece-addon-list-enabled-face) (?- . riece-addon-list-disabled-face) (?\? . riece-addon-list-uninstalled-face) (?\  . riece-addon-list-unloaded-face)) "\
An alist mapping marks on riece-addon-list-buffer to faces." :type 'list :group 'riece-addon-list)

(defcustom riece-addon-list-font-lock-keywords '(("^\\([-+? ] \\S-+\\)\\s-+\\(.*\\)" (1 (cdr (assq (aref (match-string 1) 0) riece-addon-list-mark-face-alist))) (2 riece-addon-list-description-face))) "\
Default expressions to addon in riece-addon-list-mode." :type '(repeat (list string)) :group 'riece-addon-list)

;;;***

;;;### (autoloads (riece-alias-alist riece-alias-alternate-separator riece-alias-enable-percent-hack riece-alias-percent-hack-mask riece-alias) "riece-alias" "lisp/riece-alias.el")
(defconst custom-define-current-source-file "riece-alias.el")

(defgroup riece-alias nil "Aliases of channel/user names." :prefix "riece-" :group 'riece)

(defcustom riece-alias-percent-hack-mask "*.jp" "\
The mask of local IRC network" :type 'string :group 'riece-alias)

(defcustom riece-alias-enable-percent-hack t "\
If non-nil, the target mask is abbreviated with `%'." :type 'boolean :group 'riece-alias)

(defcustom riece-alias-alternate-separator "@" "\
A string to separate prefix and server." :type '(choice (const nil) string) :group 'riece-alias)

(defcustom riece-alias-alist nil "\
An alist mapping aliases to names." :type 'list :group 'riece-alias)

;;;***

;;;### (autoloads (riece-async-backup-file riece-async-buffer-size riece-async) "riece-async" "lisp/riece-async.el")
(defconst custom-define-current-source-file "riece-async.el")

(defgroup riece-async nil "Connect to IRC server via async proxy." :prefix "riece-" :group 'riece)

(defcustom riece-async-buffer-size 65535 "\
Maximum size of the write buffer." :type 'integer :group 'riece-async)

(defcustom riece-async-backup-file (expand-file-name "riece-async.bak" riece-directory) "\
A file which contains outdated messages." :type 'string :group 'riece-async)

;;;***

;;;### (autoloads (riece-biff-biff-mode-string riece-biff-default-mode-string riece-biff-check-channels riece-biff) "riece-biff" "lisp/riece-biff.el")
(defconst custom-define-current-source-file "riece-biff.el")

(defgroup riece-biff nil "Be notified if messages arrives." :prefix "riece-" :group 'riece)

(defcustom riece-biff-check-channels nil "\
*If non-nil, riece-biff checks only the channel contained in this list." :type '(repeat string) :group 'riece-biff)

(defcustom riece-biff-default-mode-string "[-]" "\
*String displayed when there is no arrival message." :type 'string :group 'riece-biff)

(defcustom riece-biff-biff-mode-string "[R]" "\
*String displayed when there are new arrival messages." :type 'string :group 'riece-biff)

;;;***

;;;### (autoloads (riece-default-coding-system riece-coding) "riece-coding" "lisp/riece-coding.el")
(defconst custom-define-current-source-file "riece-coding.el")

(defgroup riece-coding nil "Coding system." :tag "Coding" :prefix "riece-" :group 'riece)

(defcustom riece-default-coding-system (if (featurep 'mule) (cons 'ctext 'iso-2022-jp-2)) "\
Coding system for process I/O.
The value is a coding system, or a cons cell (DECODING . ENCODING)
specifying the coding systems for decoding and encoding respectively." :type '(choice (symbol :tag "Coding system") (cons (symbol :tag "Input coding system") (symbol :tag "Output coding system")) (const nil :tag "No conversion")) :group 'riece-coding)

;;;***

;;;### (autoloads (riece-ctlseq-face-cache-size riece-ctlseq-hide-controls riece-ctlseq-colors riece-ctlseq) "riece-ctlseq" "lisp/riece-ctlseq.el")
(defconst custom-define-current-source-file "riece-ctlseq.el")

(defgroup riece-ctlseq nil "Mark up control sequences in IRC buffer." :prefix "riece-" :group 'riece)

(defcustom riece-ctlseq-colors '("white" "black" "red" "orange" "yellow" "LightGreen" "DarkOliveGreen" "cyan4" "turquoise" "blue" "black" "black" "black" "black" "black" "DarkBlue" "purple1" "purple2" "purple3" "magenta") "\
List of colors can be used with ^C<fg>,<bg>." :group 'riece-ctlseq :type '(repeat (string :tag "Color")))

(defcustom riece-ctlseq-hide-controls t "\
If non-nil, control characters are hidden." :group 'riece-ctlseq :type 'boolean)

(defcustom riece-ctlseq-face-cache-size 128 "\
Maximum length of the internal face cache." :group 'riece-ctlseq :type 'integer)

;;;***

;;;### (autoloads (riece-doctor-bye-regexp riece-doctor-hello-regexp riece-doctor) "riece-doctor" "lisp/riece-doctor.el")
(defconst custom-define-current-source-file "riece-doctor.el")

(defgroup riece-doctor nil "Interface to doctor.el." :prefix "riece-" :group 'riece)

(defcustom riece-doctor-hello-regexp "^,doctor$" "\
Pattern of string patients start consultation." :type 'string :group 'riece-doctor)

(defcustom riece-doctor-bye-regexp "^,doctor bye$" "\
Pattern of string patients end consultation." :type 'string :group 'riece-doctor)

;;;***

;;;### (autoloads (riece-epg) "riece-epg" "lisp/riece-epg.el")
(defconst custom-define-current-source-file "riece-epg.el")

(defgroup riece-epg nil "Encrypt/decrypt messages." :group 'riece)

;;;***

;;;### (autoloads (riece-eval-ruby-prefix-regexp riece-eval-ruby) "riece-eval-ruby" "lisp/riece-eval-ruby.el")
(defconst custom-define-current-source-file "riece-eval-ruby.el")

(defgroup riece-eval-ruby nil "Evaluate input string as a Ruby program." :prefix "riece-" :group 'riece)

(defcustom riece-eval-ruby-prefix-regexp "^,ruby\\s-+" "\
Pattern of of the prefix for sending Ruby programs." :type 'string :group 'riece-eval-ruby)

;;;***

;;;### (autoloads (riece-eval-ignore-error riece-eval-regexp riece-eval) "riece-eval" "lisp/riece-eval.el")
(defconst custom-define-current-source-file "riece-eval.el")

(defgroup riece-eval nil "Evaluate an input string as an elisp form." :prefix "riece-" :group 'riece)

(defcustom riece-eval-regexp "^, \\(.+\\)" "\
*Pattern of string evaluating." :type 'string :group 'riece-eval)

(defcustom riece-eval-ignore-error nil "\
*If non-nil, an error is ignored." :type 'boolean :group 'riece-eval)

;;;***

;;;### (autoloads (riece-google-default-lang riece-google-license-key riece-google-program riece-google-ruby-command riece-google) "riece-google" "lisp/riece-google.el")
(defconst custom-define-current-source-file "riece-google.el")

(defgroup riece-google nil "Search keywords by Google." :prefix "riece-" :group 'riece)

(defcustom riece-google-ruby-command "ruby" "\
Command name for Ruby interpreter." :type 'string :group 'riece-google)

(defcustom riece-google-program '("# Copyright (c) 2004 SASADA Koichi <ko1 at atdot.net>\n#\n# This program is free software with ABSOLUTELY NO WARRANTY.\n# You can re-distribute and/or modify this program under\n# the same terms of the Ruby's lisence.\n\nrequire 'soap/wsdlDriver'\nrequire 'iconv'\nrequire 'kconv'\nrequire 'cgi'\n\nkeywords            = '" keywords "'\nmax_results         = " max-results "\nlicense_key         = '" license-key "'\ndefault_lang        = '" lang "'\ngoogle_wsdl         = 'http://api.google.com/GoogleSearch.wsdl'\ngoogle              = SOAP::WSDLDriverFactory.new(google_wsdl).create_driver\n\ndef erace_tag str\n  CGI.unescapeHTML(str.gsub(/\\<.+?\\>/, ''))\nend\n\ndef lang_check lang\n  if lang.empty? || /^lang_/ =~ lang\n    lang\n  else\n    'lang_' + lang\n  end\nend\n\ndef show_char_code_and_erace_tag str\n  case $KCODE\n  when 'EUC', 'SJIS'\n    CGI.unescapeHTML(str.gsub(/\\<.+?\\>/, '')).tojis\n  when 'NONE', 'UTF-8'\n    begin\n      str = Iconv.conv(\"EUC-JP\", \"UTF-8\", str)\n      CGI.unescapeHTML(str.gsub(/\\<.+?\\>/, '')).tojis\n    rescue => e\n      \"(char code problem: #{e.class}[#{e.message.dump}])\"\n    end\n  else\n    str\n  end\nend\n\ndef search_char_code str\n  case $KCODE\n  when 'EUC', 'SJIS'\n    str.toeuc\n  when 'NONE'\n    begin\n      Iconv.conv(\"UTF-8\", \"EUC-JP\", str.toeuc)\n    rescue => e\n      \"(char code problem: #{e.class})\"\n    end\n  when 'UTF-8'\n    str\n  else\n    raise\n  end\nend\n\nbegin\n  lang = lang_check(default_lang)\n  word = search_char_code(keywords)\n  result = google.doGoogleSearch(\n    license_key, word, 0, max_results, false, \"\",\n    false, lang, 'utf-8', 'utf-8'\n  )\n\n  count = result.estimatedTotalResultsCount\n  if count > 0\n    word = show_char_code_and_erace_tag(keywords)\n    count = count.to_s.gsub(/(\\d)(?=\\d{3}+$)/, '\\\\1,')\n    time = result.searchTime.to_s\n    print \"Search results for #{word} (Hits: #{count}: Time: #{time}):\\n\"\n\n    result.resultElements.each_with_index{|e, i|\n      title = show_char_code_and_erace_tag(e.title)\n      url   = e.URL\n      print \"#{title} - #{url}\\n\"\n    }\n  else\n    print \"no match\\n\"\n  end\n\nrescue Exception => e\n  print \"#{e.class}(#{e.message})\"\nend\n") "\
Ruby program for searching by Google." :type 'list :group 'riece-google)

(defcustom riece-google-license-key nil "\
*License key for Google API." :type 'string :group 'riece-google)

(defcustom riece-google-default-lang '("lang_en" "lang_ja") "\
*Default language for searching keywords." :type '(repeat (choice (const "lang_en" :tag "English") (const "lang_ja" :tag "Japanese") (string :tag "The other language"))) :group 'riece-google)

;;;***

;;;### (autoloads (riece-guess-channel-try-functions riece-guess) "riece-guess" "lisp/riece-guess.el")
(defconst custom-define-current-source-file "riece-guess.el")

(defgroup riece-guess nil "Guess the next channel." :tag "Guess" :prefix "riece-" :group 'riece)

(defcustom riece-guess-channel-try-functions nil "\
Functions which returns a list of channels the user wants to switch." :type '(repeat function) :group 'riece-guess)

;;;***

;;;### (autoloads (riece-hangman-words-file riece-hangman-bye-regexp riece-hangman-hello-regexp riece-hangman) "riece-hangman" "lisp/riece-hangman.el")
(defconst custom-define-current-source-file "riece-hangman.el")

(defgroup riece-hangman nil "Allow channel members to play the hangman game." :prefix "riece-" :group 'riece)

(defcustom riece-hangman-hello-regexp "^,hangman$" "\
Pattern of string to start the game." :type 'string :group 'riece-hangman)

(defcustom riece-hangman-bye-regexp "^,hangman bye$" "\
Pattern of string to end the game." :type 'string :group 'riece-hangman)

(defcustom riece-hangman-words-file "/usr/share/dict/words" "\
Location of words file." :type 'file :group 'riece-hangman)

;;;***

;;;### (autoloads (riece-channel-list-font-lock-keywords riece-channel-list-mark-face-alist riece-dialogue-font-lock-keywords riece-highlight-faces riece-highlight) "riece-highlight" "lisp/riece-highlight.el")
(defconst custom-define-current-source-file "riece-highlight.el")

(defgroup riece-highlight nil "Decorate IRC buffers with faces and fonts." :tag "Highlight" :prefix "riece-" :group 'riece)

(defgroup riece-highlight-faces nil "Faces for highlight IRC buffers." :tag "Faces" :prefix "riece-highlight-" :group 'riece-highlight)

(defcustom riece-dialogue-font-lock-keywords (append (list (list (concat "^" riece-time-prefix-regexp "\\(<[^>]+>\\|>[^<]+<\\|([^)]+)\\|{[^}]+}\\|=[^=]+=\\)") '(1 riece-dialogue-prefix-face append t))) (mapcar (lambda (line) (cons (concat "^" riece-time-prefix-regexp "\\(" (regexp-quote (symbol-value (intern (format "riece-%s-prefix" line)))) ".*\\)$") (list 1 (intern (format "riece-dialogue-%s-face" line)) t t))) '(change notice wallops error info)) '((riece-highlight-server-match 0 riece-dialogue-server-face t))) "\
Default expressions to highlight in riece-dialogue-mode." :type '(repeat (list string)) :group 'riece-highlight)

(defcustom riece-channel-list-mark-face-alist '((?* . riece-channel-list-current-face)) "\
An alist mapping marks on riece-channel-list-buffer to faces." :type 'list :group 'riece-highlight)

(defcustom riece-channel-list-font-lock-keywords '(("^[ 0-9][0-9]:\\(.\\)\\(.*\\)" (2 (or (cdr (assq (aref (match-string 1) 0) riece-channel-list-mark-face-alist)) riece-channel-list-default-face)))) "\
Default expressions to highlight in riece-channel-list-mode." :type '(repeat (list string)) :group 'riece-highlight)

;;;***

;;;### (autoloads (riece-channel-history-length riece-history) "riece-history" "lisp/riece-history.el")
(defconst custom-define-current-source-file "riece-history.el")

(defgroup riece-history nil "Manage history of channel shifting." :tag "History" :prefix "riece-" :group 'riece)

(defcustom riece-channel-history-length 3 "\
Length of riece-channel-history." :type 'integer :group 'riece-history)

;;;***

;;;### (autoloads (riece-channel-coding-system-alist) "riece-identity" "lisp/riece-identity.el")
(defconst custom-define-current-source-file "riece-identity.el")

(defcustom riece-channel-coding-system-alist nil "\
An alist mapping from channels to coding-systems." :type '(repeat (cons (string :tag "Channel") (symbol :tag "Coding system"))) :group 'riece-coding)

;;;***

;;;### (autoloads (riece-startup-ignored-user-list riece-ignore-buffer-name riece-ignore-discard-message riece-ignore) "riece-ignore" "lisp/riece-ignore.el")
(defconst custom-define-current-source-file "riece-ignore.el")

(defgroup riece-ignore nil "Ignore messages from some users." :prefix "riece-" :group 'riece)

(defcustom riece-ignore-discard-message 'log "\
If t, messages from ignored user are completely discarded.
If 'log, messages are removed from IRC buffers, but they are saved in
`riece-ignore-buffer'.
Otherwise, they are not removed from IRC buffers, but are hidden with
'invisible text-property." :group 'riece-ignore :type '(choice (const :tag "Discard completely" t) (const :tag "Discard but save logs" log) (const :tag "Make messages invisible" nil)))

(defcustom riece-ignore-buffer-name "*Ignore*" "\
The name of buffer where ignored messages are stored." :group 'riece-ignore :type 'string)

(defcustom riece-startup-ignored-user-list nil "\
List of user names whose messages are ignored." :group 'riece-ignore :type '(repeat string))

;;;***

;;;### (autoloads (riece-keepalive-ping-repeat riece-keepalive) "riece-keepalive" "lisp/riece-keepalive.el")
(defconst custom-define-current-source-file "riece-keepalive.el")

(defgroup riece-keepalive nil "Keep an IRC connection." :prefix "riece-" :group 'riece)

(defcustom riece-keepalive-ping-repeat 120 "\
Interval for sending PING to server." :type 'integer :group 'riece-keepalive)

;;;***

;;;### (autoloads (riece-keyword-notify-functions riece-notify-keyword-functions riece-keywords riece-keyword) "riece-keyword" "lisp/riece-keyword.el")
(defconst custom-define-current-source-file "riece-keyword.el")

(defgroup riece-keyword nil "Detect keywords in IRC buffers." :prefix "riece-" :group 'riece)

(defcustom riece-keywords nil "\
Keywords to be highlightened." :type '(repeat (choice (string :tag "Keyword") (cons (string :tag "Regexp") (integer :tag "Match")))) :group 'riece-keyword)

(defcustom riece-notify-keyword-functions nil "\
Functions used to notify keyword match." :type '(list function) :group 'riece-keyword)

(defcustom riece-keyword-notify-functions nil "\
Functions used to notify keyword match.
Two arguments are passed to each function: the keyword used to match
and the matched message object." :type '(list function) :group 'riece-keyword)

;;;***

;;;### (autoloads (riece-layout-alist riece-layout riece-layout) "riece-layout" "lisp/riece-layout.el")
(defconst custom-define-current-source-file "riece-layout.el")

(defgroup riece-layout nil "Window layouts." :prefix "riece-" :group 'riece)

(defcustom riece-layout "default" "\
Current layout setting." :type 'string :group 'riece-layout)

(defcustom riece-layout-alist '(("middle-right" riece-configure-windows right middle) ("middle-left" riece-configure-windows left middle) ("top-right" riece-configure-windows right top) ("top-left" riece-configure-windows left top) ("bottom-right" riece-configure-windows right bottom) ("bottom-left" riece-configure-windows left bottom) ("top" riece-configure-windows-top) ("spiral" riece-configure-windows-spiral) ("default" . "middle-right")) "\
An alist mapping the names to layout functions.
An element of this alist is either in the following forms:

\(NAME CONFIGURE-FUNCTION [PARAMETERS])
\(NAME1 . NAME2)

In the first form, NAME is a string which specifies the layout
setting, and CONFIGURE-FUNCTION is a function which does window
splitting, etc.  PARAMETERS are collected and passed to CONFIGURE-FUNCTION.
In the second form, NAME1 is an alias for NAME2." :type 'list :group 'riece-layout)

;;;***

;;;### (autoloads (riece-log-file-name-coding-system riece-log-coding-system riece-log-flashback riece-log-directory-map riece-log-directory riece-log) "riece-log" "lisp/riece-log.el")
(defconst custom-define-current-source-file "riece-log.el")

(defgroup riece-log nil "Save IRC logs." :prefix "riece-" :group 'riece)

(defcustom riece-log-directory (expand-file-name "log" riece-directory) "\
*Where to look for log files." :type 'directory :group 'riece-log)

(defcustom riece-log-directory-map nil "\
*The map of channel name and directory name." :type '(repeat (cons (string :tag "Channel name") (string :tag "Directory name"))) :group 'riece-log)

(defcustom riece-log-flashback 10 "\
*If non-nil, irc messages flash back from log files.
If integer, flash back only this line numbers. t means all lines." :type '(choice (integer :tag "line numbers") (const t :tag "of the day") (const nil :tag "no flashback")) :group 'riece-log)

(defcustom riece-log-coding-system nil "\
*Coding system used for log files." :type 'symbol :group 'riece-log)

(defcustom riece-log-file-name-coding-system (if (boundp 'file-name-coding-system) file-name-coding-system) "\
*Coding system used for filenames of log files." :type 'symbol :group 'riece-log)

;;;***

;;;### (autoloads (riece-message-make-global-name-function riece-message-make-name-function riece-message-make-close-bracket-function riece-message-make-open-bracket-function riece-message-filter-functions riece-message) "riece-message" "lisp/riece-message.el")
(defconst custom-define-current-source-file "riece-message.el")

(defgroup riece-message nil "Display messages." :tag "Message" :prefix "riece-" :group 'riece)

(defcustom riece-message-filter-functions nil "\
Functions to filter incoming messages." :type 'function :group 'riece-message)

(defcustom riece-message-make-open-bracket-function (function riece-message-make-open-bracket) "\
Function which makes `open-bracket' string for each message." :type 'function :group 'riece-message)

(defcustom riece-message-make-close-bracket-function (function riece-message-make-close-bracket) "\
Function which makes `close-bracket' string for each message." :type 'function :group 'riece-message)

(defcustom riece-message-make-name-function (function riece-message-make-name) "\
Function which makes local identity for each message." :type 'function :group 'riece-message)

(defcustom riece-message-make-global-name-function (function riece-message-make-global-name) "\
Function which makes global identity for each message." :type 'function :group 'riece-message)

;;;***

;;;### (autoloads (riece-mini-backlog-size riece-mini) "riece-mini" "lisp/riece-mini.el")
(defconst custom-define-current-source-file "riece-mini.el")

(defgroup riece-mini nil "Use Riece only on the minibuffer." :group 'riece)

(defcustom riece-mini-backlog-size 5 "\
*Line numbers for logging back log." :type 'integer :group 'riece-mini)

;;;***

;;;### (autoloads (riece-ndcc-server-address riece-ndcc) "riece-ndcc" "lisp/riece-ndcc.el")
(defconst custom-define-current-source-file "riece-ndcc.el")

(defgroup riece-ndcc nil "DCC written in elisp." :prefix "riece-" :group 'riece)

(defcustom riece-ndcc-server-address "127.0.0.1" "\
Local address of the DCC server.
Only used for sending files." :type 'vector :group 'riece-ndcc)

;;;***

;;;### (autoloads (riece-format-time-function riece-buffer-dispose-function riece-gather-channel-modes riece-away-message riece-part-message riece-quit-message riece-blink-parens riece-default-channel-binding riece-default-freeze riece-channel-list-buffer-mode riece-user-list-buffer-mode riece-others-buffer-mode riece-channel-buffer-mode riece-channel-cache-max-size riece-user-cache-max-size riece-default-open-connection-function riece-quit-timeout riece-retry-with-new-nickname riece-startup-server-list riece-startup-channel-list riece-nickname riece-realname riece-username riece-default-password riece-send-delay riece-max-send-size riece-protocol riece-server riece-server-alist riece-channel riece-server riece-addons riece-variables-files riece-saved-variables-file riece-variables-file riece-data-directory riece-addon-directory riece-directory riece-window-center-line riece-use-full-window riece-looks riece-command-prefix riece-debug riece-saved-forms riece-options riece) "riece-options" "lisp/riece-options.el")
(defconst custom-define-current-source-file "riece-options.el")

(defgroup riece nil "Riece specific customize group." :prefix "riece-" :group 'applications)

(defgroup riece-options nil "Riece user customizable variables." :prefix "riece-" :group 'riece)

(defcustom riece-saved-forms '(riece-server-alist riece-channel-buffer-mode riece-others-buffer-mode riece-user-list-buffer-mode riece-channel-list-buffer-mode riece-layout riece-addons) "\
Variables saved after each session is completed." :type 'string :group 'riece-options)

(defcustom riece-debug nil "\
If non-nil, random debug spews." :type 'boolean :group 'riece-options)

(defcustom riece-command-prefix "" "\
Key sequence to be used as prefix for command mode key bindings." :type 'string :group 'riece-options)

(defgroup riece-looks nil "Look and feel." :prefix "riece-" :group 'riece)

(defcustom riece-use-full-window t "\
If non-nil, whole Emacs window is used to display dialogue." :type 'boolean :group 'riece-looks)

(defcustom riece-window-center-line -2 "\
Line number of center point in window when scrolling.
If nil, erases the entire frame and then redraws with point in the
center of the window.  Negative means relative to bottom of window.
See the document of the function `recenter'." :type 'integer :group 'riece-looks)

(defcustom riece-directory (expand-file-name "~/.riece") "\
Where to look for startup files." :type 'directory :group 'riece-options)

(defcustom riece-addon-directory (expand-file-name "addons" riece-directory) "\
Where to look for add-on files." :type 'directory :group 'riece-options)

(defcustom riece-data-directory (if (fboundp 'locate-data-directory) (locate-data-directory "riece") (file-name-directory load-file-name)) "\
Where to look for data files." :type 'directory :group 'riece-options)

(defcustom riece-variables-file (expand-file-name "init" riece-directory) "\
Where to look for variables." :type 'file :group 'riece-options)

(defcustom riece-saved-variables-file (expand-file-name "save" riece-directory) "\
Where to look for variables.
This file was saved the last session." :type 'file :group 'riece-options)

(defcustom riece-variables-files (list riece-saved-variables-file riece-variables-file) "\
Where to look for variables.  Helps to remove clutter from your .emacs.
This feature is most likely to dissappear in near future.  The preferred
way is to put Riece variables on .emacs or file loaded from there." :type '(repeat (file :tag "Initialization File")) :group 'riece-options)

(defcustom riece-addons '(riece-highlight riece-ctcp riece-guess riece-unread riece-history riece-url riece-button riece-menu riece-icon riece-ignore riece-log riece-toolbar riece-alias riece-ctlseq riece-keyword riece-shrink-buffer riece-mcat) "\
Add-ons insinuated into Riece." :type '(repeat symbol) :group 'riece-options)

(defgroup riece-server nil "Server settings." :prefix "riece-" :group 'riece)

(defgroup riece-channel nil "Channel settings." :prefix "riece-" :group 'riece)

(defcustom riece-server-alist nil "\
An alist mapping server names to plist." :type 'riece-server-spec :group 'riece-server)

(defcustom riece-server (getenv "IRCSERVER") "\
IRC server host we are connecting to." :type 'string :group 'riece-server)

(defcustom riece-protocol 'irc "\
Protocol support." :type 'symbol :group 'riece-server)

(defcustom riece-max-send-size 512 "\
Maximum size of messages to be sent at a time." :type 'integer :group 'riece-server)

(defcustom riece-send-delay 2 "\
Duration of multiple send." :type 'integer :group 'riece-server)

(defcustom riece-default-password (getenv "IRCPASSWORD") "\
Your password." :type '(radio (string :tag "Password") (const :tag "No" nil)) :group 'riece-server)

(defcustom riece-username nil "\
Your login name." :type 'string :group 'riece-server)

(defcustom riece-realname nil "\
Your user name." :type 'string :group 'riece-server)

(defcustom riece-nickname (or (getenv "IRCNICK") (user-real-login-name)) "\
Your nickname." :type 'string :group 'riece-server)

(defcustom riece-startup-channel-list nil "\
A list of channels to join automatically at startup." :type '(repeat (choice (string :tag "Channel") (list (string :tag "Channel") (string :tag "Key")))) :group 'riece-channel)

(defcustom riece-startup-server-list nil "\
A list of servers to connect automatically at startup." :type '(repeat (string :tag "Server")) :group 'riece-server)

(defcustom riece-retry-with-new-nickname nil "\
When nickname has already been in use, grow-tail automatically." :type 'boolean :group 'riece-server)

(defcustom riece-quit-timeout 1 "\
Quit timeout when there is no response from server." :type '(radio (integer :tag "Seconds") (const nil)) :group 'riece-server)

(defcustom riece-default-open-connection-function (function open-network-stream) "\
Default function used for connecting to an IRC server." :type 'function :group 'riece-server)

(defcustom riece-user-cache-max-size 512 "\
Maximum size of cache of user names." :type 'integer :group 'riece-server)

(defcustom riece-channel-cache-max-size 512 "\
Maximum size of cache of channel names." :type 'integer :group 'riece-server)

(defcustom riece-channel-buffer-mode t "\
When non-nil, Riece will display a channel buffer." :type 'boolean :group 'riece-looks)

(defcustom riece-others-buffer-mode t "\
When non-nil, Riece will display an \"*Others*\" buffer." :type 'boolean :group 'riece-looks)

(defcustom riece-user-list-buffer-mode t "\
When non-nil, Riece will display a nick list buffer." :type 'boolean :group 'riece-looks)

(defcustom riece-channel-list-buffer-mode t "\
When non-nil, Riece will display a channel list buffer." :type 'boolean :group 'riece-looks)

(defcustom riece-default-freeze nil "\
Channel buffer local freeze flag is on at starting." :type 'boolean :group 'riece-looks)

(defcustom riece-default-channel-binding nil "\
The channel list to bind the channel number when joining." :type '(repeat (radio (string :tag "Bound Channel") (const nil))) :group 'riece-channel)

(defcustom riece-blink-parens nil "\
Should we blink matching parenthesis in the command buffer?" :type 'boolean :group 'riece-options)

(defcustom riece-quit-message (riece-extended-version) "\
Default quit message." :type '(string :tag "Quit message") :group 'riece-options)

(defcustom riece-part-message nil "\
Default part message." :type '(choice (const :tag "No message" nil) (string :tag "Part message")) :group 'riece-options)

(defcustom riece-away-message "Gone" "\
Default away message." :type '(string :tag "Away message") :group 'riece-options)

(defcustom riece-gather-channel-modes nil "\
If non-nil, gather channel modes when we join a channel." :type 'boolean :group 'riece-options)

(defcustom riece-buffer-dispose-function (function kill-buffer) "\
Function called after the buffer was disposed." :type 'function :group 'riece-options)

(defcustom riece-format-time-function (function current-time-string) "\
Function to convert the specified time to the human readable form." :type 'function :group 'riece-options)

;;;***

;;;### (autoloads (riece-rdcc-block-size riece-rdcc-save-directory riece-rdcc-decode-address-program riece-rdcc-send-program riece-rdcc-server-address riece-rdcc) "riece-rdcc" "lisp/riece-rdcc.el")
(defconst custom-define-current-source-file "riece-rdcc.el")

(defgroup riece-rdcc nil "DCC written in Ruby." :prefix "riece-" :group 'riece)

(defcustom riece-rdcc-server-address nil "\
Local address of the DCC server.
Only used for sending files." :type 'string :group 'riece-rdcc)

(defcustom riece-rdcc-send-program '("require 'socket'\naddress = " address "\nunless address\n  sock = UDPSocket.new\n  sock.connect('164.46.176.4', 7)		# www.unixuser.org/echo\n  address = sock.getsockname[4 .. 7].unpack('CCCC').join('.')\nend\nserver = TCPServer.new(address, 0)\noutput(\"#{server.addr[3].split(/\\./).collect{|c| c.to_i}.pack('CCCC').unpack('N')[0]} #{server.addr[1]}\")\nsession = server.accept\nif session\n  total = 0\n  File.open(" file ") {|file|\n    while (bytes = file.read(" block-size "))\n      total += bytes.length\n      output(total)\n      session.write(bytes)\n      begin\n        buf = session.read(4)\n      end until buf.unpack('N')[0] == total\n    end\n  }\n  session.close\nend\n") "\
Ruby program to send file with DCC." :type 'list :group 'riece-rdcc)

(defcustom riece-rdcc-decode-address-program '("\"#{" address " >> 24 & 0xFF}.#{" address " >> 16 & 0xFF}.#{" address " >> 8 & 0xFF}.#{" address " & 0xFF}\"") "\
Ruby program to numeric IP address." :type 'list :group 'riece-rdcc)

(defcustom riece-rdcc-save-directory nil "\
Default directory where received files are saved in." :type 'directory :group 'riece-rdcc)

(defcustom riece-rdcc-block-size 1024 "\
Number of bytes sent as a block." :type 'integer :group 'riece-rdcc)

;;;***

;;;### (autoloads (riece-ruby-log-file riece-ruby-err-file riece-ruby-out-file riece-ruby-command riece-ruby) "riece-ruby" "lisp/riece-ruby.el")
(defconst custom-define-current-source-file "riece-ruby.el")

(defgroup riece-ruby nil "Interact with Ruby interpreter." :prefix "riece-" :group 'riece)

(defcustom riece-ruby-command "ruby" "\
Command name for Ruby interpreter." :type 'string :group 'riece-ruby)

(defcustom riece-ruby-out-file (expand-file-name "riece-ruby.out" riece-directory) "\
A file which records stdout of Ruby programs." :type 'string :group 'riece-ruby)

(defcustom riece-ruby-err-file (expand-file-name "riece-ruby.err" riece-directory) "\
A file which records stderr of Ruby programs." :type 'string :group 'riece-ruby)

(defcustom riece-ruby-log-file (expand-file-name "riece-ruby.log" riece-directory) "\
A file used to logging." :type 'string :group 'riece-ruby)

;;;***

;;;### (autoloads (riece-shrink-buffer-remove-chars riece-max-buffer-size riece-shrink-buffer-idle-time-delay riece-shrink-buffer) "riece-shrink-buffer" "lisp/riece-shrink-buffer.el")
(defconst custom-define-current-source-file "riece-shrink-buffer.el")

(defgroup riece-shrink-buffer nil "Free old IRC messages to save memory usage." :prefix "riece-" :group 'riece)

(defcustom riece-shrink-buffer-idle-time-delay 5 "\
Number of idle seconds to wait before shrinking channel buffers." :type 'integer :group 'riece-shrink-buffer)

(defcustom riece-max-buffer-size 65536 "\
Maximum size of channel buffers." :type '(integer :tag "Number of characters") :group 'riece-shrink-buffer)

(defcustom riece-shrink-buffer-remove-chars (/ riece-max-buffer-size 2) "\
Number of chars removed when shrinking channel buffers." :type 'integer :group 'riece-shrink-buffer)

;;;***

;;;### (autoloads (riece-unread) "riece-unread" "lisp/riece-unread.el")
(defconst custom-define-current-source-file "riece-unread.el")

(defgroup riece-unread nil "Mark unread channels." :tag "Unread" :prefix "riece-" :group 'riece)

;;;***

;;;### (autoloads (riece-url-regexp-alist riece-url-regexp riece-url) "riece-url" "lisp/riece-url.el")
(defconst custom-define-current-source-file "riece-url.el")

(defgroup riece-url nil "URL Browsing in IRC buffer." :prefix "riece-" :group 'riece)

(defcustom riece-url-regexp "\\b\\(s?https?\\|ftp\\|file\\|gopher\\|news\\|telnet\\|wais\\|mailto\\):\\(//[-a-zA-Z0-9_.]+:[0-9]*\\)?[-a-zA-Z0-9_=?#$@~`%&*+|\\/.,;]*[-a-zA-Z0-9_=#$@~`%&*+|\\/;]" "\
Regular expression that matches URLs." :group 'riece-url :type 'regexp)

(defcustom riece-url-regexp-alist nil "\
An alist mapping regexp to URL.
For example:
  (setq riece-url-regexp-alist
        '((\"\\\\bBug#\\\\([0-9]+\\\\)\\\\b\" .
           \"http://bugs.debian.org/\\\\1\")))

This maps a string \"Bug#12345\" to a URL
\"http://bugs.debian.org/12345\"." :type 'alist :group 'riece-url)

;;;***

;;;### (autoloads (riece-user-agent) "riece-version" "lisp/riece-version.el")
(defconst custom-define-current-source-file "riece-version.el")

(defcustom riece-user-agent 'emacs-riece-type "\
Which information should be exposed in the User-Agent header.

It can be one of the symbols `riece' (show only Riece version), `emacs-riece'
\(show only Emacs and Riece versions), `emacs-riece-config' (same as
`emacs-riece' plus system configuration), `emacs-riece-type' (same as
`emacs-riece' plus system type) or a custom string.  If you set it to a
string, be sure to use a valid format, see RFC 2616." :group 'riece-options :type '(choice (item :tag "Show Riece and Emacs versions and system type" emacs-riece-type) (item :tag "Show Riece and Emacs versions and system configuration" emacs-riece-config) (item :tag "Show Riece and Emacs versions" emacs-riece) (item :tag "Show only Riece version" riece) (string :tag "Other")))

;;;***

;;;### (autoloads (riece-xfaceb-prefer-cface-to-xface) "riece-xfaceb" "lisp/riece-xfaceb.el")
(defconst custom-define-current-source-file "riece-xfaceb.el")

(defcustom riece-xfaceb-prefer-cface-to-xface (featurep 'png) "\
*When non-nil, display colour face images instead of X-Face." :type 'boolean :group 'riece-looks)

;;;***

;;;### (autoloads (riece-yank-strip-space riece-yank-tick riece-yank) "riece-yank" "lisp/riece-yank.el")
(defconst custom-define-current-source-file "riece-yank.el")

(defgroup riece-yank nil "Enter the element of kill-ring." :tag "Yank" :prefix "riece-" :group 'riece)

(defcustom riece-yank-tick 1 "\
Time span in second to send multiple lines." :type 'number :group 'riece-yank)

(defcustom riece-yank-strip-space nil "\
If non-nil, strip common spaces in front of lines and blank lines
before/after the first/last non-blank line." :type 'boolean :group 'riece-yank)

;;;***

(provide 'riece-custom-defines)
