;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'ruby-modes-custom-defines) (error "Feature ruby-modes-custom-defines already loaded"))

;;;### (autoloads (inferior-ruby-filter-regexp inferior-ruby-mode-hook inferior-ruby-prompt-pattern inferior-ruby-first-prompt-pattern ruby-program-name ruby-inferior-mode) "inf-ruby" "ruby-modes/inf-ruby.el")
(defconst custom-define-current-source-file "inf-ruby.el")

(defgroup ruby-inferior-mode nil "Major mode for interacting with an inferior ruby (irb) process." :group 'ruby :prefix "inferior-ruby-")

(defcustom ruby-program-name "irb --inf-ruby-mode" "\
*Program invoked by the `run-ruby' command." :type 'string :group 'ruby-inferior-mode)

(defcustom inferior-ruby-first-prompt-pattern "^irb(.*)[0-9:]+0> *" "\
*First prompt regex pattern of ruby interpreter." :type 'regexp :group 'ruby-inferior-mode)

(defcustom inferior-ruby-prompt-pattern "^\\(irb(.*)[0-9:]+[>*\"'] *\\)+" "\
*Prompt regex pattern of ruby interpreter." :type 'regexp :group 'ruby-inferior-mode)

(defcustom inferior-ruby-mode-hook nil "\
*Hook for customising `inferior-ruby-mode'." :type 'hook :group 'ruby-inferior-mode)

(defcustom inferior-ruby-filter-regexp "\\`\\s *\\S ?\\S ?\\s *\\'" "\
*Input matching this regexp are not saved on the history list.
Defaults to a regexp ignoring all inputs of 0, 1, or 2 letters." :type 'regexp :group 'ruby-inferior-mode)

;;;***

;;;### (autoloads (ruby-electric-newline-before-closing-bracket ruby-electric-expand-delimiters-list ruby-electric-simple-keywords-re ruby-electric) "ruby-electric" "ruby-modes/ruby-electric.el")
(defconst custom-define-current-source-file "ruby-electric.el")

(defgroup ruby-electric nil "Minor mode providing electric editing commands for ruby files" :group 'ruby)

(defcustom ruby-electric-simple-keywords-re "\\(def\\|if\\|class\\|module\\|unless\\|case\\|while\\|do\\|until\\|for\\|begin\\)" "\
*Regular expresion matching keywords for which closing 'end'
is to be inserted." :type 'regexp :group 'ruby-electric)

(defcustom ruby-electric-expand-delimiters-list '(all) "\
*List of contexts where matching delimiter should be
inserted. The word 'all' will do all insertions." :type '(set :extra-offset 8 (const :tag "Everything" all) (const :tag "Curly brace" ?{) (const :tag "Square brace" ?\[) (const :tag "Round brace" ?\() (const :tag "Quote" ?\') (const :tag "Double quote" ?\") (const :tag "Back quote" ?\`) (const :tag "Vertical bar" ?|)) :group 'ruby-electric)

(defcustom ruby-electric-newline-before-closing-bracket nil "\
*Controls whether a newline should be inserted before the
closing bracket or not." :type 'boolean :group 'ruby-electric)

;;;***

;;;### (autoloads (ruby-deep-indent-paren-style ruby-deep-indent-paren ruby-deep-arglist ruby-comment-column ruby-indent-level ruby-indent-tabs-mode ruby-indent-level ruby) "ruby-mode" "ruby-modes/ruby-mode.el")
(defconst custom-define-current-source-file "ruby-mode.el")

(defgroup ruby nil "Major mode for editing ruby scripts." :group 'languages :prefix "ruby-")

(defcustom ruby-indent-level 2 "\
*Indentation of ruby statements." :type 'integer :group 'ruby)

(defcustom ruby-indent-tabs-mode nil "\
*Indentation can insert tabs in ruby mode if this is non-nil." :type 'boolean :group 'ruby)

(defcustom ruby-indent-level 2 "\
*Indentation of ruby statements." :type 'integer :group 'ruby)

(defcustom ruby-comment-column 32 "\
*Indentation column of comments." :type 'integer :group 'ruby)

(defcustom ruby-deep-arglist t "\
*Deep indent lists in parenthesis when non-nil.
Also ignores spaces after parenthesis when 'space." :group 'ruby)

(defcustom ruby-deep-indent-paren '(?\( ?\[ ?\] t) "\
*Deep indent lists in parenthesis when non-nil. t means continuous line.
Also ignores spaces after parenthesis when 'space." :group 'ruby)

(defcustom ruby-deep-indent-paren-style 'space "\
Default deep indent style." :options '(t nil space) :group 'ruby)

;;;***

;;;### (autoloads (rubydb-command-name ruby-debug) "rubydb3x" "ruby-modes/rubydb3x.el")
(defconst custom-define-current-source-file "rubydb3x.el")

(defgroup ruby-debug nil "Ruby debugging." :group 'ruby :prefix "rubydb-")

(defcustom rubydb-command-name "ruby" "\
*Command for executing ruby." :type 'string :group 'ruby-debug)

;;;***

(provide 'ruby-modes-custom-defines)
