;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'scheme-custom-defines) (error "Feature scheme-custom-defines already loaded"))

;;;### (autoloads (dsssl-mode-hook scheme-mode-hook dsssl-sgml-declaration scheme-mit-dialect scheme) "scheme" "scheme/scheme.el")
(defconst custom-define-current-source-file "scheme.el")

(defgroup scheme nil "Editing Scheme code" :group 'languages)

(defcustom scheme-mit-dialect t "\
If non-nil, scheme mode is specialized for MIT Scheme.
Set this to nil if you normally use another dialect." :type 'boolean :group 'scheme)

(defcustom dsssl-sgml-declaration "<!DOCTYPE style-sheet PUBLIC \"-//James Clark//DTD DSSSL Style Sheet//EN\">\n" "\
*An SGML declaration for the DSSSL file.
If it is defined as a string this will be inserted into an empty buffer
which is in `dsssl-mode'.  It is typically James Clark's style-sheet
doctype, as required for Jade." :type '(choice (string :tag "Specified string") (const :tag "None" :value nil)) :group 'scheme)

(defcustom scheme-mode-hook nil "\
Normal hook run when entering `scheme-mode'.
See `run-hooks'." :type 'hook :group 'scheme)

(defcustom dsssl-mode-hook nil "\
Normal hook run when entering `dsssl-mode'.
See `run-hooks'." :type 'hook :group 'scheme)

;;;***

;;;### (autoloads (xscheme-signal-death-message xscheme-allow-pipelined-evaluation scheme-program-arguments scheme-band-name scheme-program-name scheme) "xscheme" "scheme/xscheme.el")
(defconst custom-define-current-source-file "xscheme.el")

(defgroup scheme nil "Scheme programming." :group 'languages)

(defcustom scheme-program-name "scheme" "\
*Program invoked by the `run-scheme' command." :type 'string :group 'scheme)

(defcustom scheme-band-name nil "\
*Band loaded by the `run-scheme' command." :type '(choice (const :tag "None" nil) (string :tag "File" "")) :group 'scheme)

(defcustom scheme-program-arguments nil "\
*Arguments passed to the Scheme program by the `run-scheme' command." :type '(choice (const :tag "None" nil) (string :tag "Args" "")) :group 'scheme)

(defcustom xscheme-allow-pipelined-evaluation t "\
If non-nil, an expression may be transmitted while another is evaluating.
Otherwise, attempting to evaluate an expression before the previous expression
has finished evaluating will signal an error." :type 'boolean :group 'scheme)

(defcustom xscheme-signal-death-message nil "\
If non-nil, causes a message to be generated when the Scheme process dies." :type 'boolean :group 'scheme)

;;;***

(provide 'scheme-custom-defines)
