;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'semantic-custom-defines) (error "Feature semantic-custom-defines already loaded"))

;;;### (autoloads (document-new-hist-comment document-autocomment-param-type-alist document-autocomment-param-alist document-autocomment-return-last-alist document-autocomment-return-first-alist document-autocomment-common-nouns-abbrevs document-autocomment-function-alist document-date-element document-history-element document-param-element document-function-comment document-file-brief-comment document-header-comment document-file-comment document-extra-line-after-short-parameters document-change-number document-copyright-notice-file) "document-vars" "semantic/document-vars.el")
(defconst custom-define-current-source-file "document-vars.el")

(defcustom document-copyright-notice-file nil "\
*A file name containing a copyright notice.
It will be reformatted in the header to have the correct prefix character.
See the %N token in `document-file-comment'" :group 'document :type 'file)

(defcustom document-change-number nil "\
*The current change number being worked on.
Large projects may use change numbers, bug numbers, or other tag." :group 'document :type 'string)

(defcustom document-extra-line-after-short-parameters t "\
*Non-nil to add an extra line when there is < 1 arguments." :group 'document :type 'string)

(defcustom document-file-comment "%s %B\n%m\n%m Copyright (C) %Y %O\n%m\n%m %N\n%m\n%m Description:\n%m\n%m   %D\n%m\n%m History:\n%m %H\n%m\n%m Tokens: %T\n%e\n" "\
Comment block for the beginning of a new file.
The format tokens available are:
 %B - Brief description of the file (Auto-comment by file name)
 %D - Made up documentation
 %N - Copyright notice for your organization
 %O - Owner (full name of copyright holder held in `document-copyright-holder'
 %H - History elements
 %T - cproto header id token.  Always is form 'token file.h' where
      token is defined in cpr-header-token, and file.h is the
      relational file name of the header.  If you wish to use cproto's
      features, you must have this somewhere in the header.
 %Y - Year
Commenting elements:
 %b - Comment start string
 %m - Comment line prefix (not the start)
 %e - Comment end string" :group 'document :type 'string)

(defcustom document-header-comment "%b\n%m Copyright (c) %Y %O\n%m\n%m %N\n%m\n%m History:\n%m %H\n%e\n" "\
Comment block for the beginning of a new header/dependency file.
The format tokens available are the same as for `document-file-comment'" :group 'document :type 'string)

(defcustom document-file-brief-comment "%F - %C" "\
Format of the brief comment with tokens.
Available tokens are:
 %F - file name short
 %C - Comment field" :group 'document :type 'string)

(defcustom document-function-comment "\^L\n%b\n%m Function: %F\n%m\n%m %f  %D%p\n%m\n%m Returns:     %R\n%m Parameters:  %P\n%m History:\n%m %H\n%e\n" "\
Comment block for the beginning of a new function/variable definition.
There are several format tokens represent the following:
  %F - function name
  %D - Made up documentation
  %f - Place, where everything before the point is the distance to set
       in the fill prefix.  Allows a first line in paragraph indent
  %p - Where to place point after insertion of a new header
  %R - Returns
  %P - Parameter list
  %H - History insertion point

  The parts %f and %p can be confusing, so here is an example:

 * Moose: %f%D%p

 Will set fill prefix to ` *         `, and put the point AFTER the
description.  The `Moose:` will not be in the prefix.  The default
value shows the equivalent of a hanging indent.

Commenting elements:
 %b - Comment start string
 %m - Comment line prefix (not the start)
 %e - Comment end string" :group 'document :type 'string)

(defcustom document-param-element "%P - %D" "\
The format of a parameter element in the list of parameters.
The parts are:
 %P - Parameter name spaced to length of max param
 %p - Parameter name with no padding
 %R - Type of element
 %D - Description of parameter as known by document." :group 'document :type 'string)

(defcustom document-history-element "%-7U %-10D %C" "\
Format for history element.
Valid % codes are:
  %U - Username, initials, what have you.
  %D - The current date formatted as in `document-date-element'
  %S - System Change id, SCCS vers, major change comment, etc
  %C - Auto comment area, cursor goes here for new elts." :group 'document :type 'string)

(defcustom document-date-element "%M/%D/%y" "\
Format for date elements.
Valid format chars are:
  %H - Hours
  %h - Hours 24 hr format
  %a - AM/PM flag
  %I - mInutes
  %S - Seconds
  %D - Day
  %w - Weekday string
  %M - Month as number
  %m - Month as string
  %Y - Year
  %y - Year as 2 numbers 1994 -> 94" :group 'document :type 'string)

(defcustom document-autocomment-function-alist '(("abort" . "Aborts the") ("realloc" . "moves or ") ("alloc\\(ate\\)?" . "Allocates and initializes a new ") ("clean" . "Cleans up the") ("clobber" . "Removes") ("close" . "Cleanly closes") ("check" . "Checks the") ("comp\\(are\\)?" . "Compares the") ("create" . "Creates a new ") ("find" . "Finds ") ("free" . "Frees up space") ("gen\\(erate\\)?" . "Generates a new ") ("get\\|find" . "Looks for the given ") ("gobble" . "Removes") ("he?lp" . "Provides help for") ("li?ste?n" . "Listens for ") ("connect" . "Connects to ") ("acc?e?pt" . "Accepts a ") ("load" . "Loads in ") ("match" . "Check that parameters match") ("name" . "Provides a name which ") ("parse" . "Parses the parameters and returns ") ("print\\|display" . "Prints out") ("read" . "Reads from") ("reset" . "Resets the parameters and returns") ("scan" . "Scans the ") ("setup\\|init\\(iallize\\)?" . "Initializes the ") ("select" . "Chooses the ") ("send" . "Sends a") ("re?c\\(v\\|ieves?\\)" . "Receives a ") ("wait" . "Waits for ") ("write" . "Writes to")) "\
List of names to string match against the function name.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string.

Certain prefixes may always mean the same thing, and the same comment
can be used as a beginning for the description.  Regexp should be
lower case since the string they are compared to is downcased.
A string may end in a space, in which case, last-alist is searched to
see how best to describe what can be returned.
Doesn't always work correctly, but that is just because English
doesn't always work correctly." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-common-nouns-abbrevs '(("sock\\(et\\)?" . "socket") ("addr\\(ess\\)?" . "address") ("buf\\(f\\(er\\)?\\)?" . "buffer") ("cur\\(r\\(ent\\)?\\)?" . "current") ("dev\\(ice\\)?" . "device") ("file" . "file") ("line" . "line") ("msg\\|message" . "message") ("name" . "name") ("next\\|nxt" . "next") ("port" . "port") ("host" . "host") ("obj\\|object" . "object") ("previous\\|prev" . "previous") ("str\\(ing\\)?" . "string") ("use?r" . "user") ("num\\(ber\\)?" . "number") ("\\(^\\|\\s-\\)id\\($\\|\\s-\\)" . "Identifier")) "\
List of common English abbreviations or full words.
These are nouns (as opposed to verbs) for use in creating expanded
versions of names.This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-return-first-alist '(("static" . "Locally defined function which ") ("Bool\\|BOOL" . "Status of ")) "\
List of regexp matches for types.
They provide a little bit of text when typing information is
described.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-return-last-alist '(("static[ 	\n]+struct \\([a-zA-Z0-9_]+\\)" . "%s") ("struct \\([a-zA-Z0-9_]+\\)" . "%s") ("static[ 	\n]+union \\([a-zA-Z0-9_]+\\)" . "%s") ("union \\([a-zA-Z0-9_]+\\)" . "%s") ("static[ 	\n]+enum \\([a-zA-Z0-9_]+\\)" . "%s") ("enum \\([a-zA-Z0-9_]+\\)" . "%s") ("static[ 	\n]+\\([a-zA-Z0-9_]+\\)" . "%s") ("\\([a-zA-Z0-9_]+\\)" . "of type %s")) "\
List of regexps which provide the type of the return value.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string, which can contain %s, whih is replaced with
`match-string' 1." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-param-alist '(("[Cc]txt" . "Context") ("[Ii]d" . "Identifier of") ("[Tt]ype" . "Type of") ("[Nn]ame" . "Name of") ("argc" . "Number of arguments") ("argv" . "Argument vector") ("envp" . "Environment variable vector")) "\
Alist of common variable names appearing as function parameters.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string of text to use to describe MATCH.
When one is encountered, document-insert-parameters will automatically
place this comment after the parameter name." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-param-type-alist '(("const" . "Constant") ("void" . "Empty") ("char[ ]*\\*" . "String ") ("\\*\\*" . "Pointer to ") ("\\*" . "Pointer ") ("char[ ]*\\([^ 	*]\\|$\\)" . "Character") ("int\\|long" . "Number of") ("FILE" . "File of") ("float\\|double" . "Value of") ("Bool\\|BOOL" . "Flag") ("Window" . "Window") ("GC" . "Graphic Context") ("Widget" . "Widget")) "\
Alist of input parameter types and strings desribing them.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-new-hist-comment "Created" "\
Comment used in the history when something is created." :group 'document :type 'string)

;;;***

;;;### (autoloads (document-copyright-holder document-my-initials document) "document" "semantic/document.el")
(defconst custom-define-current-source-file "document.el")

(defgroup document nil "File and tag browser frame." :group 'semantic :group 'texinfo)

(defcustom document-my-initials (user-login-name) "\
*The initials to use when commenting something." :group 'document :type 'string)

(defcustom document-copyright-holder (user-full-name) "\
*The string to use as the copyright holder in the file comment." :group 'document :type 'string)

;;;***

;;;### (autoloads (semantic-adebug-mode-hook semantic-adebug) "semantic-adebug" "semantic/semantic-adebug.el")
(defconst custom-define-current-source-file "semantic-adebug.el")

(defgroup semantic-adebug nil "semantic-adebug group." :group 'langauges)

(defcustom semantic-adebug-mode-hook nil "\
*Hook run when semantic-adebug starts." :group 'semantic-adebug :type 'hook)

;;;***

;;;### (autoloads (semantic-analyze-summary-function) "semantic-analyze" "semantic/semantic-analyze.el")
(defconst custom-define-current-source-file "semantic-analyze.el")

(defcustom semantic-analyze-summary-function 'semantic-format-tag-prototype "\
*Function to use when creating items in Imenu.
Some useful functions are found in `semantic-format-tag-functions'." :group 'semantic :type semantic-format-tag-custom-list)

;;;***

;;;### (autoloads (semantic-complete-inline-analyzer-displayor-class semantic-completion-displayor-format-tag-function) "semantic-complete" "semantic/semantic-complete.el")
(defconst custom-define-current-source-file "semantic-complete.el")

(defcustom semantic-completion-displayor-format-tag-function (function semantic-format-tag-name) "\
*A Tag format function to use when showing completions." :group 'semantic :type semantic-format-tag-custom-list)

(defcustom semantic-complete-inline-analyzer-displayor-class 'semantic-displayor-tooltip "\
*Class for displayor to use with inline completion.
Good values are:
  'semantic-displayor-tooltip - show options in a tooltip.
  'semantic-displayor-traditional - In a buffer." :group 'semantic :type '(radio (const :tag "Tooltip" semantic-displayor-tooltip) (const :tag "Traditional" semantic-displayor-traditional) (const :tag "Traditional with Focus" semantic-displayor-traditional-with-focus-highlight)))

;;;***

;;;### (autoloads (semantic-decoration-mode-hook global-semantic-decoration-mode semantic-decoration-styles) "semantic-decorate-mode" "semantic/semantic-decorate-mode.el")
(defconst custom-define-current-source-file "semantic-decorate-mode.el")

(defcustom semantic-decoration-styles nil "\
*List of active decoration styles.
It is an alist of (NAME . FLAG) elements, where NAME is a style name
and FLAG is non-nil if the style is enabled.
See also `define-semantic-decoration-style' which will automatically
add items to this list." :group 'semantic :type '(repeat (cons (string :tag "Decoration Name") (boolean :tag "Enabled"))))

(defcustom global-semantic-decoration-mode nil "\
*If non-nil, enable global use of command `semantic-decoration-mode'.
When this mode is activated, decorations specified by
`semantic-decoration-styles'." :group 'semantic :group 'semantic-modes :type 'boolean :require 'semantic-decorate-mode :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-decoration-mode (if val 1 -1))))

(defcustom semantic-decoration-mode-hook nil "\
*Hook run at the end of function `semantic-decoration-mode'." :group 'semantic :type 'hook)

;;;***

;;;### (autoloads (semantic-momentary-highlight-pulse-flag semantic-pulse-iterations) "semantic-decorate" "semantic/semantic-decorate.el")
(defconst custom-define-current-source-file "semantic-decorate.el")

(defcustom semantic-pulse-iterations 30 "\
Number of iterations in a puls operation." :group 'semantic :type 'number)

(defcustom semantic-momentary-highlight-pulse-flag (condition-case nil (let ((v (color-values (face-background 'default)))) (numberp (car-safe v))) (error nil)) "\
*Non-nil means to pulse the overlay face for momentary tag highlighting.
Pulsing involves a bright highlight that slowly shifts to the background
color." :group 'semantic :type 'boolean)

;;;***

;;;### (autoloads (semantic-edits-verbose-flag) "semantic-edit" "semantic/semantic-edit.el")
(defconst custom-define-current-source-file "semantic-edit.el")

(defcustom semantic-edits-verbose-flag nil "\
Non-nil means the incremental perser is verbose.
If nil, errors are still displayed, but informative messages are not." :group 'semantic :type 'boolean)

;;;***

;;;### (autoloads (se-summary-function) "semantic-example" "semantic/semantic-example.el")
(defconst custom-define-current-source-file "semantic-example.el")

(defcustom se-summary-function 'semantic-format-tag-uml-prototype "\
*Function to use when showing info about a token for Examples.
Shows how to:
  * Create a customization variable." :group 'semantic :type semantic-format-tag-custom-list)

;;;***

;;;### (autoloads (semantic-uml-no-protection-string semantic-uml-colon-string semantic-format-use-images-flag) "semantic-format" "semantic/semantic-format.el")
(defconst custom-define-current-source-file "semantic-format.el")

(defcustom semantic-format-use-images-flag ezimage-use-images "\
Non-nil means semantic format functions use images.
Images can be used as icons instead of some types of text strings." :group 'semantic :type 'boolean)

(defcustom semantic-uml-colon-string " : " "\
*String used as a color separator between parts of a UML string.
In UML, a variable may appear as `varname : type'.
Change this variable to change the output separator." :group 'semantic :type 'string)

(defcustom semantic-uml-no-protection-string "" "\
*String used to describe when no protection is specified.
Used by `semantic-format-tag-uml-protection-to-string'." :group 'semantic :type 'string)

;;;***

;;;### (autoloads (semantic-grammar-file-regexp) "semantic-grammar" "semantic/semantic-grammar.el")
(defconst custom-define-current-source-file "semantic-grammar.el")

(defcustom semantic-grammar-file-regexp "\\.[wb]y$" "\
Regexp which matches grammar source files." :group 'semantic :type 'regexp)

;;;***

;;;### (autoloads (semantic-ia-completion-menu-format-tag-function semantic-ia-completion-format-tag-function) "semantic-ia" "semantic/semantic-ia.el")
(defconst custom-define-current-source-file "semantic-ia.el")

(defcustom semantic-ia-completion-format-tag-function 'semantic-prototype-nonterminal "\
*Function used to convert a tag to a string during completion." :group 'semantic :type semantic-format-tag-custom-list)

(defcustom semantic-ia-completion-menu-format-tag-function 'semantic-uml-concise-prototype-nonterminal "\
*Function used to convert a tag to a string during completion." :group 'semantic :type semantic-format-tag-custom-list)

;;;***

;;;### (autoloads (semantic-idle-summary-function semantic-idle-scheduler-working-in-modeline-flag semantic-idle-scheduler-no-working-message semantic-idle-scheduler-max-buffer-size semantic-idle-scheduler-mode-hook global-semantic-idle-scheduler-mode semantic-idle-scheduler-idle-time semantic-idle-scheduler-verbose-flag) "semantic-idle" "semantic/semantic-idle.el")
(defconst custom-define-current-source-file "semantic-idle.el")

(defcustom semantic-idle-scheduler-verbose-flag nil "\
*Non-nil means that the idle scheduler should provide debug messages.
Use this setting to debug idle activities." :group 'semantic :type 'boolean)

(defcustom semantic-idle-scheduler-idle-time 2 "\
*Time in seconds of idle before scheduling events.
This time should be short enough to ensure that idle-scheduler will be
run as soon as Emacs is idle." :group 'semantic :type 'number :set (lambda (sym val) (set-default sym val) (when (timerp semantic-idle-scheduler-timer) (cancel-timer semantic-idle-scheduler-timer) (setq semantic-idle-scheduler-timer nil) (semantic-idle-scheduler-setup-timer))))

(defcustom global-semantic-idle-scheduler-mode nil "\
*If non-nil, enable global use of idle-scheduler mode." :group 'semantic :group 'semantic-modes :type 'boolean :require 'semantic-idle :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-idle-scheduler-mode (if val 1 -1))))

(defcustom semantic-idle-scheduler-mode-hook nil "\
*Hook run at the end of function `semantic-idle-scheduler-mode'." :group 'semantic :type 'hook)

(defcustom semantic-idle-scheduler-max-buffer-size 0 "\
*Maximum size in bytes of buffers where idle-scheduler is enabled.
If this value is less than or equal to 0, idle-scheduler is enabled in
all buffers regardless of their size." :group 'semantic :type 'number)

(defcustom semantic-idle-scheduler-no-working-message t "\
*If non-nil, disable display of working messages during parse." :group 'semantic :type 'boolean)

(defcustom semantic-idle-scheduler-working-in-modeline-flag nil "\
*Non-nil means show working messages in the mode line.
Typically, parsing will show messages in the minibuffer.
This will move the parse message into the modeline." :group 'semantic :type 'boolean)

(defcustom semantic-idle-summary-function 'semantic-format-tag-summarize "\
*Function to use when displaying tag information during idle time.
Some useful functions are found in `semantic-format-tag-functions'." :group 'semantic :type semantic-format-tag-custom-list)

;;;***

;;;### (autoloads (semantic-which-function-use-color semantic-imenu-auto-rebuild-directory-indexes semantic-imenu-index-directory semantic-imenu-sort-bucket-function semantic-imenu-bucketize-type-members semantic-imenu-expand-type-members semantic-imenu-buckets-to-submenu semantic-imenu-adopt-external-members semantic-imenu-bucketize-file semantic-imenu-summary-function semantic-imenu) "semantic-imenu" "semantic/semantic-imenu.el")
(defconst custom-define-current-source-file "semantic-imenu.el")

(defgroup semantic-imenu nil "Parser Generator Imenu interface." :group 'semantic :group 'imenu)

(defcustom semantic-imenu-summary-function 'semantic-format-tag-abbreviate "\
*Function to use when creating items in Imenu.
Some useful functions are found in `semantic-format-tag-functions'." :group 'semantic-imenu :type semantic-format-tag-custom-list)

(defcustom semantic-imenu-bucketize-file t "\
*Non-nil if tags in a file are to be grouped into buckets." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-adopt-external-members t "\
*Non-nil if types in a file should adopt externally defined members.
C++ and CLOS can define methods that are not in the body of a class
definition." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-buckets-to-submenu t "\
*Non-nil if buckets of tags are to be turned into submenus.
This option is ignored if `semantic-imenu-bucketize-file' is nil." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-expand-type-members t "\
*Non-nil if types should have submenus with members in them." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-bucketize-type-members t "\
*Non-nil if members of a type should be grouped into buckets.
nil means to keep them in the same order.
Overriden to nil if `semantic-imenu-bucketize-file' is nil." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-sort-bucket-function nil "\
*Function to use when sorting tags in the buckets of functions.
See `semantic-bucketize' and the FILTER argument for more details on this function." :group 'semantic-imenu :type '(radio (const :tag "No Sorting" nil) (const semantic-sort-tags-by-name-increasing) (const semantic-sort-tags-by-name-decreasing) (const semantic-sort-tags-by-type-increasing) (const semantic-sort-tags-by-type-decreasing) (const semantic-sort-tags-by-name-increasing-ci) (const semantic-sort-tags-by-name-decreasing-ci) (const semantic-sort-tags-by-type-increasing-ci) (const semantic-sort-tags-by-type-decreasing-ci) (function)))

(defcustom semantic-imenu-index-directory nil "\
*Non nil to index the entire directory for tags.
Doesn't actually parse the entire directory, but displays tags for all files
currently listed in the current Semantic database.
This variable has no meaning if semanticdb is not active." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-auto-rebuild-directory-indexes nil "\
*If non-nil automatically rebuild directory index imenus.
That is when a directory index imenu is updated, automatically rebuild
other buffer local ones based on the same semanticdb." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-which-function-use-color nil "\
*Use color when displaying the current function with `which-function'." :group 'semantic-imenu :type 'boolean)

;;;***

;;;### (autoloads (semantic-lex-debug-analyzers) "semantic-lex" "semantic/semantic-lex.el")
(defconst custom-define-current-source-file "semantic-lex.el")

(defcustom semantic-lex-debug-analyzers nil "\
Non nil means to debug analyzers with syntax protection.
Only in effect if `debug-on-error' is also non-nil." :group 'semantic :type 'boolean)

;;;***

;;;### (autoloads (semantic-mru-bookmark-mode-hook global-semantic-mru-bookmark-mode) "semantic-mru-bookmark" "semantic/semantic-mru-bookmark.el")
(defconst custom-define-current-source-file "semantic-mru-bookmark.el")

(defcustom global-semantic-mru-bookmark-mode nil "\
*If non-nil enable global use of variable `semantic-mru-bookmark-mode'.
When this mode is enabled, changes made to a buffer are highlighted
until the buffer is reparsed." :group 'semantic :group 'semantic-modes :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-mru-bookmark-mode (if val 1 -1))))

(defcustom semantic-mru-bookmark-mode-hook nil "\
*Hook run at the end of function `semantic-mru-bookmark-mode'." :group 'semantic :type 'hook)

;;;***

;;;### (autoloads (semantic-regtest-find-file-function semantic-regtest-highlight-tag semantic-regtest-print-tag-boundaries semantic-regtest-functions semantic-regtest) "semantic-regtest" "semantic/semantic-regtest.el")
(defconst custom-define-current-source-file "semantic-regtest.el")

(defgroup semantic-regtest nil "Settings for semantic grammar/parser regression-tests." :group 'semantic :prefix "semantic-regtest-")

(defcustom semantic-regtest-functions '(semantic-regtest-prin1) "\
*Functions used for the grammar/parser regression-test.
Every element must be a function which gets one tag-argument and must return
a string which is the printed information about this tag. The function must
take into accout the value of `semantic-regtest-print-tag-boundaries'.

If nil then always `semantic-format-tag-prin1' is used; then of course the
value of `semantic-regtest-print-tag-boundaries' is automatically considered." :group 'semantic-regtest :type '(repeat (function :tag "Regression-test function")))

(defcustom semantic-regtest-print-tag-boundaries nil "\
*The generic regression-tag-format contains tag-boundaries.

The default-value is nil because normally it is not senseful to include
tag-boundaries into the printed generic tag-format because it prevents the
parsing check being independent from changing whitespace or comments in the
testfiles - which would not changing the tag-data itself but the
data-locations. But if this option is not nil then for each tag the
tag-boundaries are included in the output - if the tag is not positionless." :group 'semantic-regtest :type 'boolean)

(defcustom semantic-regtest-highlight-tag t "\
*Highlight tag in the source-file.
This highlights the tag jumped to by `semantic-regtest-open-source-file' or
`semantic-regtest-mouse-open-source-file'." :group 'semantic-regtest :type 'boolean)

(defcustom semantic-regtest-find-file-function 'find-file-other-window "\
*Displayfunction for the files of `semantic-regtest-mode'.
This function is used to display a file in a window if one of the commands of
`semantic-regtest-mode' is used. The function gets one argument - a filename -
and has to display this file in a window.

Default is `find-file-other-window'." :group 'semantic-regtest :type 'function)

;;;***

;;;### (autoloads (semantic-sb-info-format-tag-function semantic-sb-button-format-tag-function semantic-sb-autoexpand-length) "semantic-sb" "semantic/semantic-sb.el")
(defconst custom-define-current-source-file "semantic-sb.el")

(defcustom semantic-sb-autoexpand-length 1 "\
*Length of a semantic bucket to autoexpand in place.
This will replace the named bucket that would have usually occured here." :group 'speedbar :type 'integer)

(defcustom semantic-sb-button-format-tag-function 'semantic-format-tag-abbreviate "\
*Function called to create the text for a but from a token." :group 'speedbar :type semantic-format-tag-custom-list)

(defcustom semantic-sb-info-format-tag-function 'semantic-format-tag-summarize "\
*Function called to create the text for info display from a token." :group 'speedbar :type semantic-format-tag-custom-list)

;;;***

;;;### (autoloads (semantic-stickyfunc-indent-string semantic-stickyfunc-mode-hook global-semantic-stickyfunc-mode semantic-show-parser-state-mode-hook global-semantic-show-parser-state-mode semantic-show-unmatched-syntax-mode-hook global-semantic-show-unmatched-syntax-mode semantic-highlight-edits-mode-hook global-semantic-highlight-edits-mode semantic-mode-line-prefix semantic-update-mode-line semantic-modes) "semantic-util-modes" "semantic/semantic-util-modes.el")
(defconst custom-define-current-source-file "semantic-util-modes.el")

(defgroup semantic-modes nil "Minor modes associated with the Semantic architecture." :group 'semantic)

(defcustom semantic-update-mode-line t "\
*If non-nil, show enabled minor modes in the mode line.
Only minor modes that are not turned on globally are shown in the mode
line." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (set-default sym val) (semantic-map-buffers (function semantic-mode-line-update))))

(defcustom semantic-mode-line-prefix (semantic-propertize "S" 'face 'bold) "\
*Prefix added to minor mode indicators in the mode line." :group 'semantic :type 'string :require 'semantic-util-modes :initialize 'custom-initialize-default)

(defcustom global-semantic-highlight-edits-mode nil "\
*If non-nil enable global use of variable `semantic-highlight-edits-mode'.
When this mode is enabled, changes made to a buffer are highlighted
until the buffer is reparsed." :group 'semantic :group 'semantic-modes :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-highlight-edits-mode (if val 1 -1))))

(defcustom semantic-highlight-edits-mode-hook nil "\
*Hook run at the end of function `semantic-highlight-edits-mode'." :group 'semantic :type 'hook)

(defcustom global-semantic-show-unmatched-syntax-mode nil "\
*If non-nil, enable global use of `semantic-show-unmatched-syntax-mode'.
When this mode is enabled, syntax in the current buffer which the
semantic parser cannot match is highlighted with a red underline." :group 'semantic :group 'semantic-modes :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-show-unmatched-syntax-mode (if val 1 -1))))

(defcustom semantic-show-unmatched-syntax-mode-hook nil "\
*Hook run at the end of function `semantic-show-unmatched-syntax-mode'." :group 'semantic :type 'hook)

(defcustom global-semantic-show-parser-state-mode nil "\
*If non-nil enable global use of `semantic-show-parser-state-mode'.
When enabled, the current parse state of the current buffer is displayed
in the mode line. See `semantic-show-parser-state-marker' for details
on what is displayed." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-show-parser-state-mode (if val 1 -1))))

(defcustom semantic-show-parser-state-mode-hook nil "\
*Hook run at the end of function `semantic-show-parser-state-mode'." :group 'semantic :type 'hook)

(defcustom global-semantic-stickyfunc-mode nil "\
*If non-nil, enable global use of `semantic-stickyfunc-mode'.
This minor mode only works for Emacs 21 or later.
When enabled, the header line is enabled, and the first line
of the current function or method is displayed in it.
This makes it appear that the first line of that tag is
`sticky' to the top of the window." :group 'semantic :group 'semantic-modes :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-stickyfunc-mode (if val 1 -1))))

(defcustom semantic-stickyfunc-mode-hook nil "\
*Hook run at the end of function `semantic-stickyfunc-mode'." :group 'semantic :type 'hook)

(defcustom semantic-stickyfunc-indent-string (if (and window-system (not (featurep 'xemacs))) (concat (condition-case nil (let ((charwidth (frame-char-width)) (scrollpos (frame-parameter (selected-frame) 'vertical-scroll-bars))) (if (or (eq scrollpos 'left) (eq scrollpos t)) (let ((w (when (boundp 'scroll-bar-width) (symbol-value 'scroll-bar-width)))) (if (not w) (setq w (frame-parameter (selected-frame) 'scroll-bar-width))) (if (not w) (setq w (+ (get 'scroll-bar-width 'x-frame-parameter) 1))) (if (not w) "  " (setq w (+ 2 w)) (make-string (/ w charwidth) ?\ ))) "")) (error "")) (condition-case nil (let* ((f (window-fringes)) (fw (car f)) (numspace (/ fw charwidth))) (make-string numspace ?\ )) (error (condition-case nil (if (get 'fringe 'face) " " "") (error ""))))) "") "\
*String used to indent the stickyfunc header.
Customize this string to match the space used by scrollbars and
fringe so it does not appear that the code is moving left/right
when it lands in the sticky line." :group 'semantic :type 'string)

;;;***

;;;### (autoloads (semantic-inhibit-functions semantic-dump-parse semantic) "semantic" "semantic/semantic.el")
(defconst custom-define-current-source-file "semantic.el")

(defgroup semantic nil "Parser Generator/Parser." :group 'lisp)

(defcustom semantic-dump-parse nil "\
When non-nil, dump parsing information." :group 'semantic :type 'boolean)

(defcustom semantic-inhibit-functions nil "\
List of functions to call with no arguments before to setup Semantic.
If any of these functions returns non-nil, the current buffer is not
setup to use Semantic." :group 'semantic :type 'hook)

;;;***

;;;### (autoloads (semanticdb-ebrowse-file-match) "semanticdb-ebrowse" "semantic/semanticdb-ebrowse.el")
(defconst custom-define-current-source-file "semanticdb-ebrowse.el")

(defcustom semanticdb-ebrowse-file-match "\\.\\(hh?\\|HH?\\|hpp\\)" "\
Regular expression matching file names for ebrowse to parse.
This expression should exclude C++ headers that have no extension.
By default, include only headers since the semantic use of EBrowse
is only for searching via semanticdb, and thus only headers would
be searched." :group 'semanticdb :type 'string)

;;;***

;;;### (autoloads (semanticdb-save-database-hooks semanticdb-persistent-path semanticdb-default-save-directory semanticdb-default-file-name) "semanticdb-file" "semantic/semanticdb-file.el")
(defconst custom-define-current-source-file "semanticdb-file.el")

(defcustom semanticdb-default-file-name "semantic.cache" "\
*File name of the semantic tag cache." :group 'semanticdb :type 'string)

(defcustom semanticdb-default-save-directory nil "\
*Directory name where semantic cache files are stored.
If this value is nil, files are saved in the current directory.  If the value
is a valid directory, then it overrides `semanticdb-default-file-name' and
stores caches in a coded file name in this directory." :group 'semanticdb :type '(choice :tag "Default-Directory" :menu-tag "Default-Directory" (const :tag "Use current directory" :value nil) (directory)))

(defcustom semanticdb-persistent-path '(project) "\
*List of valid paths that semanticdb will cache tags to.
When `global-semanticdb-minor-mode' is active, tag lists will
be saved to disk when Emacs exits.  Not all directories will have
tags that should be saved.
The value should be a list of valid paths.  A path can be a string,
indicating a directory in which to save a variable.  An element in the
list can also be a symbol.  Valid symbols are `never', which will
disable any saving anywhere, `always', which enables saving
everywhere, or `project', which enables saving in any directory that
passes a list of predicates in `semanticdb-project-predicate-functions'." :group 'semanticdb :type nil)

(defcustom semanticdb-save-database-hooks nil "\
*Hooks run after a database is saved.
Each function is called with one argument, the object representing
the database recently written." :group 'semanticdb :type 'hook)

;;;***

;;;### (autoloads (semanticdb-find-default-throttle) "semanticdb-find" "semantic/semanticdb-find.el")
(defconst custom-define-current-source-file "semanticdb-find.el")

(defcustom semanticdb-find-default-throttle '(project unloaded system recursive) "\
The default throttle for `semanticdb-find' routines.
The throttle controls how detailed the list of database
tables is for a symbol lookup.  The value is a list with
the following keys:
  `file'       - The file the search is being performed from.
                 This option is here for completeness only, and
                 is assumed to always be on.
  `local'      - Tables from the same local directory are included.
                 This includes files directly referenced by a file name
                 which might be in a different directory.
  `project'    - Tables from the same local project are included
                 If `project' is specified, then `local' is assumed.
  `unloaded'   - If a table is not in memory, load it.  If it is not cached
                 on disk either, get the source, parse it, and create
                 the table.
  `system'     - Tables from system databases.  These are specifically
                 tables from system header files, or language equivalent.
  `recursive'  - For include based searches, includes tables referenced
                 by included files.
  `omniscience' - Included system databases which are omniscience, or
                 somehow know everything.  Omniscience databases are found
                 in `semanticdb-project-system-databases'.
                 The Emacs Lisp system DB is an omniscience database." :group 'semanticdb :type semanticdb-find-throttle-custom-list)

;;;***

;;;### (autoloads (semanticdb-system-database-warn-level semanticdb-default-system-save-directory) "semanticdb-system" "semantic/semanticdb-system.el")
(defconst custom-define-current-source-file "semanticdb-system.el")

(defcustom semanticdb-default-system-save-directory (expand-file-name "~/.semanticdb") "\
*Directory name where semantic cache files for system headers are stored.
System files cannot have caches stored near them because users rarely have
write permission to such paths." :group 'semanticdb :type '(choice :tag "System-Save-Directory" :menu-tag "System-Save-Directory" (const :tag "Use current directory" :value nil) (directory)))

(defcustom semanticdb-system-database-warn-level 50 "\
*Number of files to be added to a system DB that causes us to warn.
If this number is exceeded, warn the users that it could take a while." :group 'semanticdb :type 'boolean)

;;;***

;;;### (autoloads (semanticdb-project-roots semanticdb-mode-hooks semanticdb-global-mode semanticdb) "semanticdb" "semantic/semanticdb.el")
(defconst custom-define-current-source-file "semanticdb.el")

(defgroup semanticdb nil "Parser Generator Persistent Database interface." :group 'semantic)

(defcustom semanticdb-global-mode nil "\
*If non-nil enable the use of `semanticdb-minor-mode'." :group 'semantic :type 'boolean :require 'semanticdb :initialize 'custom-initialize-default :set (lambda (sym val) (global-semanticdb-minor-mode (if val 1 -1)) (custom-set-default sym val)))

(defcustom semanticdb-mode-hooks nil "\
*Hooks run whenever `global-semanticdb-minor-mode' is run.
Use `semanticdb-minor-mode-p' to determine if the mode has been turned
on or off." :group 'semanticdb :type 'hook)

(defcustom semanticdb-project-roots nil "\
*List of directories, where each directory is the root of some project.
All subdirectories of a root project are considered a part of one project.
Values in this string can be overriden by project management programs
via the `semanticdb-project-root-functions' variable." :group 'semanticdb :type '(repeat string))

;;;***

;;;### (autoloads (senator-mode-menu-global-toggle-label senator-mode-menu-local-toggle-label senator-completion-menu-insert-function senator-completion-menu-summary-function senator-search-ignore-tag-classes senator-highlight-found senator-step-at-start-end-tag-classes senator-step-at-tag-classes senator-minor-mode-hook global-senator-minor-mode senator) "senator" "semantic/senator.el")
(defconst custom-define-current-source-file "senator.el")

(defgroup senator nil "SEmantic NAvigaTOR." :group 'semantic)

(defcustom global-senator-minor-mode nil "\
*If non-nil enable global use of senator minor mode." :group 'senator :type 'boolean :require 'senator :initialize 'custom-initialize-default :set (lambda (sym val) (global-senator-minor-mode (if val 1 -1))))

(defcustom senator-minor-mode-hook nil "\
Hook run at the end of function `senator-minor-mode'." :group 'senator :type 'hook)

(defcustom senator-step-at-tag-classes nil "\
*List of tag classes where to step.
A tag class is a symbol like 'variable, 'function, 'type, or other.
If nil navigation steps at any tag found.  This is a buffer local
variable.  It can be set in a mode hook to get a specific langage
navigation." :group 'senator :type '(repeat (symbol)))

(defcustom senator-step-at-start-end-tag-classes '(function) "\
*List of tag classes where to step at start and end.
A tag class is a symbol like 'variable, 'function, 'type, or other.
If nil, navigation only step at beginning of tags.  If t, step at
start and end of any tag where it is allowed to step.  Also, stepping
at start and end of a tag prevent stepping inside its components.
This is a buffer local variable.  It can be set in a mode hook to get
a specific langage navigation." :group 'senator :type '(choice :tag "Identifiers" (repeat :menu-tag "Symbols" (symbol)) (const :tag "All" t)))

(defcustom senator-highlight-found t "\
*If non-nil highlight tags found.
This option requires semantic 1.3 and above.  This is a buffer
local variable.  It can be set in a mode hook to get a specific
langage behaviour." :group 'senator :type 'boolean)

(defcustom senator-search-ignore-tag-classes '(code block) "\
*List of ignored tag classes.
Tags of those classes are excluded from search." :group 'senator :type '(repeat (symbol :tag "class")))

(defcustom senator-completion-menu-summary-function 'semantic-format-tag-concise-prototype "\
*Function to use when creating items in completion menu.
Some useful functions are in `semantic-format-tag-functions'." :group 'senator :type semantic-format-tag-custom-list)

(defcustom senator-completion-menu-insert-function 'senator-completion-menu-insert-default "\
*Function to use to insert an item from completion menu.
It will receive a Semantic tag as argument." :group 'senator :type '(radio (const senator-completion-menu-insert-default) (function)))

(defcustom senator-mode-menu-local-toggle-label "In this buffer" "\
*Label of menu item that toggles a Semantic minor mode locally." :group 'senator :type 'string :set (lambda (sym val) (set-default sym val) (setq senator-modes-menu-cache nil)))

(defcustom senator-mode-menu-global-toggle-label "Globally" "\
*Label of menu item that toggles a Semantic minor mode globally." :group 'senator :type 'string :set (lambda (sym val) (set-default sym val) (setq senator-modes-menu-cache nil)))

;;;***

;;;### (autoloads (working-percentage-step working-status-dynamic-type working-status-percentage-type working) "working" "semantic/working.el")
(defconst custom-define-current-source-file "working.el")

(defgroup working nil "Working messages display." :prefix "working" :group 'lisp)

(defcustom working-status-percentage-type 'working-bar-percent-display "\
*Function used to display the percent status.
Functions provided in `working' are:
  `working-percent-display'
  `working-bar-display'
  `working-bar-percent-display'
  `working-percent-bar-display'
  `working-bubble-display'
  `working-bubble-precent-display'
  `working-celeron-percent-display'" :group 'working :type '(choice (const working-percent-display) (const working-bar-display) (const working-bar-percent-display) (const working-percent-bar-display) (const working-bubble-display) (const working-bubble-percent-display) (const working-celeron-percent-display) (const nil)))

(defcustom working-status-dynamic-type 'working-celeron-display "\
*Function used to display an animation indicating progress being made.
Dynamic working types occur when the program does not know how long
it will take ahead of time.  Functions provided in `working' are:
  `working-number-display'
  `working-text-display'
  `working-spinner-display'
  `working-dotgrowth-display'
  `working-celeron-display'
  `working-bounce-display'" :group 'working :type '(choice (const working-number-display) (const working-text-display) (const working-spinner-display) (const working-dotgrowth-display) (const working-celeron-display) (const working-bounce-display) (const nil)))

(defcustom working-percentage-step 2 "\
*Percentage display step.
A number representing how large a step must be taken when working a
percentage display.  A number such as `2' means `2%'." :group 'working ':type 'number)

;;;***

(provide 'semantic-custom-defines)
