;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'sieve-custom-defines) (error "Feature sieve-custom-defines already loaded"))

;;;### (autoloads (sieve-manage-default-port sieve-manage-authenticator-alist sieve-manage-authenticators sieve-manage-stream-alist sieve-manage-streams sieve-manage-client-eol sieve-manage-server-eol sieve-manage-default-user sieve-manage-log sieve-manage) "sieve-manage" "sieve/sieve-manage.el")
(defconst custom-define-current-source-file "sieve-manage.el")

(defgroup sieve-manage nil "Low-level Managesieve protocol issues." :group 'mail :prefix "sieve-")

(defcustom sieve-manage-log "*sieve-manage-log*" "\
Name of buffer for managesieve session trace." :type 'string :group 'sieve-manage)

(defcustom sieve-manage-default-user (user-login-name) "\
Default username to use." :type 'string :group 'sieve-manage)

(defcustom sieve-manage-server-eol "
\n" "\
The EOL string sent from the server." :type 'string :group 'sieve-manage)

(defcustom sieve-manage-client-eol "
\n" "\
The EOL string we send to the server." :type 'string :group 'sieve-manage)

(defcustom sieve-manage-streams '(network starttls shell) "\
Priority of streams to consider when opening connection to server." :group 'sieve-manage)

(defcustom sieve-manage-stream-alist '((network sieve-manage-network-p sieve-manage-network-open) (shell sieve-manage-shell-p sieve-manage-shell-open) (starttls sieve-manage-starttls-p sieve-manage-starttls-open)) "\
Definition of network streams.

\(NAME CHECK OPEN)

NAME names the stream, CHECK is a function returning non-nil if the
server support the stream and OPEN is a function for opening the
stream." :group 'sieve-manage)

(defcustom sieve-manage-authenticators '(digest-md5 cram-md5 scram-md5 ntlm plain login) "\
Priority of authenticators to consider when authenticating to server." :group 'sieve-manage)

(defcustom sieve-manage-authenticator-alist '((cram-md5 sieve-manage-cram-md5-p sieve-manage-cram-md5-auth) (digest-md5 sieve-manage-digest-md5-p sieve-manage-digest-md5-auth) (scram-md5 sieve-manage-scram-md5-p sieve-manage-scram-md5-auth) (ntlm sieve-manage-ntlm-p sieve-manage-ntlm-auth) (plain sieve-manage-plain-p sieve-manage-plain-auth) (login sieve-manage-login-p sieve-manage-login-auth)) "\
Definition of authenticators.

\(NAME CHECK AUTHENTICATE)

NAME names the authenticator.  CHECK is a function returning non-nil if
the server support the authenticator and AUTHENTICATE is a function
for doing the actual authentication." :group 'sieve-manage)

(defcustom sieve-manage-default-port 2000 "\
Default port number for managesieve protocol." :type 'integer :group 'sieve-manage)

;;;***

;;;### (autoloads (sieve-mode-hook sieve) "sieve-mode" "sieve/sieve-mode.el")
(defconst custom-define-current-source-file "sieve-mode.el")

(defgroup sieve nil "Sieve." :group 'languages)

(defcustom sieve-mode-hook nil "\
Hook run in sieve mode buffers." :group 'sieve :type 'hook)

;;;***

;;;### (autoloads (sieve-template sieve-buffer sieve-new-script sieve) "sieve" "sieve/sieve.el")
(defconst custom-define-current-source-file "sieve.el")

(defgroup sieve nil "Manage sieve scripts." :group 'tools)

(defcustom sieve-new-script "<new script>" "\
Name of name script indicator." :type 'string :group 'sieve)

(defcustom sieve-buffer "*sieve*" "\
Name of sieve management buffer." :type 'string :group 'sieve)

(defcustom sieve-template "require \"fileinto\";\n\n# Example script (remove comment character '#' to make it effective!):\n#\n# if header :contains \"from\" \"coyote\" {\n#   discard;\n# } elsif header :contains [\"subject\"] [\"$$$\"] {\n#   discard;\n# } else {\n#  fileinto \"INBOX\";\n# }\n" "\
Template sieve script." :type 'string :group 'sieve)

;;;***

(provide 'sieve-custom-defines)
