;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'sml-mode-custom-defines) (error "Feature sml-mode-custom-defines already loaded"))

;;;### (autoloads (sml-symbol-indent sml) "sml-defs" "sml-mode/sml-defs.el")
(defconst custom-define-current-source-file "sml-defs.el")

(defgroup sml nil "Editing SML code." :group 'languages)

(defcustom sml-symbol-indent '(("fn" . -3) ("of" . 1) ("|" . -2) ("," . -2) (";" . -2) ("d=" . 2)) "\
Special indentation alist for some symbols.
An entry like (\"in\" . 1) indicates that a line starting with the
symbol `in' should be indented one char further to the right.
This is only used in a few specific cases, so it does not work
for all symbols and in all lines starting with the given symbol." :group 'sml :type '(repeat (cons string integer)))

;;;***

;;;### (autoloads (sml-yacc-indent-term sml-yacc-indent-pipe sml-yacc-indent-action sml-max-name-components sml-rightalign-and sml-electric-semi-mode sml-indent-args sml-indent-level) "sml-mode" "sml-mode/sml-mode.el")
(defconst custom-define-current-source-file "sml-mode.el")

(defcustom sml-indent-level 4 "\
*Indentation of blocks in ML (see also `sml-structure-indent')." :group 'sml :type '(integer))

(defcustom sml-indent-args sml-indent-level "\
*Indentation of args placed on a separate line." :group 'sml :type '(integer))

(defcustom sml-electric-semi-mode nil "\
*If non-nil, `;' will self insert, reindent the line, and do a newline.
If nil, just insert a `;'.  (To insert while t, do: \\[quoted-insert] ;)." :group 'sml :type 'boolean)

(defcustom sml-rightalign-and t "\
If non-nil, right-align `and' with its leader.
If nil:					If t:
	datatype a = A				datatype a = A
	and b = B				     and b = B" :group 'sml :type 'boolean)

(defcustom sml-max-name-components 3 "\
Maximum number of components to use for the current function name." :group 'sml :type 'integer)

(defcustom sml-yacc-indent-action 16 "\
Indentation column of the opening paren of actions." :group 'sml :type 'integer)

(defcustom sml-yacc-indent-pipe nil "\
Indentation column of the pipe char in the BNF.
If nil, align it with `:' or with previous cases." :group 'sml :type 'integer)

(defcustom sml-yacc-indent-term nil "\
Indentation column of the (non)term part.
If nil, align it with previous cases." :group 'sml :type 'integer)

;;;***

;;;### (autoloads (sml-prompt-regexp sml-compile-commands-alist sml-compile-command sml-config-file sml-host-name sml-default-arg sml-program-name sml-proc) "sml-proc" "sml-mode/sml-proc.el")
(defconst custom-define-current-source-file "sml-proc.el")

(defgroup sml-proc nil "Interacting with an SML process." :group 'sml)

(defcustom sml-program-name "sml" "\
*Program to run as ML." :group 'sml-proc :type '(string))

(defcustom sml-default-arg "" "\
*Default command line option to pass, if any." :group 'sml-proc :type '(string))

(defcustom sml-host-name "" "\
*Host on which to run ML." :group 'sml-proc :type '(string))

(defcustom sml-config-file "~/.smlproc.sml" "\
*File that should be fed to the ML process when started." :group 'sml-proc :type '(string))

(defcustom sml-compile-command "CM.make()" "\
The command used by default by `sml-compile'.
See also `sml-compile-commands-alist'.")

(defcustom sml-compile-commands-alist '(("CMB.make()" . "all-files.cm") ("CMB.make()" . "pathconfig") ("CM.make()" . "sources.cm") ("use \"load-all\"" . "load-all")) "\
*Commands used by default by `sml-compile'.
Each command is associated with its \"main\" file.
It is perfectly OK to associate several files with a command or several
commands with the same file.")

(defcustom sml-prompt-regexp "^[-=>#] *" "\
*Regexp used to recognise prompts in the inferior ML process." :group 'sml-proc :type '(regexp))

;;;***

(provide 'sml-mode-custom-defines)
