;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'speedbar-custom-defines) (error "Feature speedbar-custom-defines already loaded"))

;;;### (autoloads (bigclock-mode-hook bigclock-after-create-hook bigclock-before-popup-hook bigclock-before-delete-hook bigclock-update-flag bigclock-frame-parameters bigclock) "bigclock" "speedbar/bigclock.el")
(defconst custom-define-current-source-file "bigclock.el")

(defgroup bigclock nil "Faces used in dframe." :prefix "bigclock-" :group 'bigclock)

(defcustom bigclock-frame-parameters '((minibuffer) (width . 9) (height . 2) (border-width . 0) (menu-bar-lines . 0) (unsplittable . t) (font . "-*-courier-medium-r-normal-*-*-320-*-*-m-*-iso8859-1")) "\
Frame parameters for the big clock." :group 'bigclock :type '(repeat (sexp :tag "Parameter:")))

(defcustom bigclock-update-flag dframe-have-timer-flag "\
Non-nil means the clock will be able to update." :group 'bigclock :type 'boolean)

(defcustom bigclock-before-delete-hook nil "\
Hooks called before bigclock is deleted." :group 'bigclock :type 'hook)

(defcustom bigclock-before-popup-hook nil "\
Hooks called before poping up the bigclock frame." :group 'bigclock :type 'hook)

(defcustom bigclock-after-create-hook nil "\
Hooks called after creating the bigclock frame." :group 'bigclock :type 'hook)

(defcustom bigclock-mode-hook nil "\
Hook run when a bigclock buffer is created." :group 'bigclock :type 'hook)

;;;***

;;;### (autoloads (dframe-after-select-attached-frame-hook dframe-activity-change-focus-flag dframe-update-speed dframe) "dframe" "speedbar/dframe.el")
(defconst custom-define-current-source-file "dframe.el")

(defgroup dframe nil "Faces used in dframe." :prefix "dframe-" :group 'dframe)

(defcustom dframe-update-speed (if dframe-xemacsp (if dframe-xemacs20p 2 5) 1) "\
*Idle time in seconds needed before dframe will update itself.
Updates occur to allow dframe to display directory information
relevant to the buffer you are currently editing." :group 'dframe :type 'integer)

(defcustom dframe-activity-change-focus-flag nil "\
*Non-nil means the selected frame will change based on activity.
Thus, if a file is selected for edit, the buffer will appear in the
selected frame and the focus will change to that frame." :group 'dframe :type 'boolean)

(defcustom dframe-after-select-attached-frame-hook nil "\
*Hook run after dframe has selected the attached frame." :group 'dframe :type 'hook)

;;;***

;;;### (autoloads (speedbar-use-images) "sb-image" "speedbar/sb-image.el")
(defconst custom-define-current-source-file "sb-image.el")

(defcustom speedbar-use-images ezimage-use-images "\
*Non-nil if speedbar should display icons." :group 'speedbar :version "21.1" :type 'boolean)

;;;***

;;;### (autoloads (speedbar-select-frame-method speedbar-supported-extension-expressions speedbar-directory-unshown-regexp speedbar-ignored-directory-expressions speedbar-scanner-reset-hook speedbar-obj-do-check speedbar-vc-in-control-hook speedbar-vc-directory-enable-hook speedbar-vc-do-check speedbar-verbosity-level speedbar-timer-hook speedbar-mode-hook speedbar-before-delete-hook speedbar-after-create-hook speedbar-before-popup-hook speedbar-hide-button-brackets-flag speedbar-indentation-width speedbar-smart-directory-expand-flag speedbar-directory-button-trim-method speedbar-tag-regroup-maximum-length speedbar-tag-split-minimum-length speedbar-tag-group-name-minimum-length speedbar-tag-hierarchy-method speedbar-sort-tags speedbar-default-position speedbar-track-mouse-flag speedbar-use-tool-tips-flag speedbar-use-imenu-flag speedbar-frame-plist speedbar-frame-parameters speedbar-show-unknown-files speedbar-reconfigure-keymaps-hook speedbar-load-hook speedbar-visiting-tag-hook speedbar-before-visiting-tag-hook speedbar-visiting-file-hook speedbar-before-visiting-file-hook speedbar-query-confirmation-method speedbar-mode-specific-contents-flag speedbar-vc speedbar-faces speedbar) "speedbar" "speedbar/speedbar.el")
(defconst custom-define-current-source-file "speedbar.el")

(defgroup speedbar nil "File and tag browser frame." :group 'etags :group 'tools :group 'convenience)

(defgroup speedbar-faces nil "Faces used in speedbar." :prefix "speedbar-" :group 'speedbar :group 'faces)

(defgroup speedbar-vc nil "Version control display in speedbar." :prefix "speedbar-" :group 'speedbar)

(defcustom speedbar-mode-specific-contents-flag t "\
*Non-nil means speedbar will show special mode contents.
This permits some modes to create customized contents for the speedbar
frame." :group 'speedbar :type 'boolean)

(defcustom speedbar-query-confirmation-method 'all "\
*Query control for file operations.
The 'always flag means to always query before file operations.
The 'none-but-delete flag means to not query before any file
operations, except before a file deletion." :group 'speedbar :type '(radio (const :tag "Always Query before some file operations." all) (const :tag "Never Query before file operations, except for deletions." none-but-delete)))

(defcustom speedbar-before-visiting-file-hook '(push-mark) "\
*Hooks run before speedbar visits a file in the selected frame.
The default buffer is the buffer in the selected window in the attached frame." :group 'speedbar :type 'hook)

(defcustom speedbar-visiting-file-hook nil "\
*Hooks run when speedbar visits a file in the selected frame." :group 'speedbar :type 'hook)

(defcustom speedbar-before-visiting-tag-hook '(push-mark) "\
*Hooks run before speedbar visits a tag in the selected frame.
The default buffer is the buffer in the selected window in the attached frame." :group 'speedbar :type 'hook)

(defcustom speedbar-visiting-tag-hook '(speedbar-highlight-one-tag-line) "\
*Hooks run when speedbar visits a tag in the selected frame." :group 'speedbar :type 'hook :options '(speedbar-highlight-one-tag-line speedbar-recenter-to-top speedbar-recenter))

(defcustom speedbar-load-hook nil "\
*Hooks run when speedbar is loaded." :group 'speedbar :type 'hook)

(defcustom speedbar-reconfigure-keymaps-hook nil "\
*Hooks run when the keymaps are regenerated." :group 'speedbar :type 'hook)

(defcustom speedbar-show-unknown-files nil "\
*Non-nil show files we can't expand with a ? in the expand button.
nil means don't show the file in the list." :group 'speedbar :type 'boolean)

(defcustom speedbar-frame-parameters '((minibuffer) (width . 20) (border-width . 0) (menu-bar-lines . 0) (tool-bar-lines . 0) (unsplittable . t) (left-fringe . 0)) "\
*Parameters to use when creating the speedbar frame in Emacs.
Any parameter supported by a frame may be added.  The parameter `height'
will be initialized to the height of the frame speedbar is
attached to and added to this list before the new frame is initialized." :group 'speedbar :type '(repeat (sexp :tag "Parameter:")))

(defcustom speedbar-frame-plist '(minibuffer nil width 20 border-width 0 internal-border-width 0 unsplittable t default-toolbar-visible-p nil has-modeline-p nil menubar-visible-p nil default-gutter-visible-p nil) "\
*Parameters to use when creating the speedbar frame in XEmacs.
Parameters not listed here which will be added automatically are
`height' which will be initialized to the height of the frame speedbar
is attached to." :group 'speedbar :type '(repeat (group :inline t (symbol :tag "Property") (sexp :tag "Value"))))

(defcustom speedbar-use-imenu-flag (stringp (locate-library "imenu")) "\
*Non-nil means use imenu for file parsing.  nil to use etags.
XEmacs prior to 20.4 doesn't support imenu, therefore the default is to
use etags instead.  Etags support is not as robust as imenu support." :tag "Use Imenu for tags" :group 'speedbar :type 'boolean)

(defcustom speedbar-use-tool-tips-flag (and (not (featurep 'xemacs)) (>= emacs-major-version 21)) "\
*Non-nil means to use tool tips if they are avaialble.
When tooltips are not available, mouse-tracking and minibuffer
display is used instead." :group 'speedbar :type 'boolean)

(defcustom speedbar-track-mouse-flag (not speedbar-use-tool-tips-flag) "\
*Non-nil means to display info about the line under the mouse." :group 'speedbar :type 'boolean)

(defcustom speedbar-default-position 'left-right "\
*Default position of the speedbar frame.
Possible values are 'left, 'right or 'left-right.
If value is 'left-right, the most suitable location is
determined automatically." :group 'speedbar :type '(radio (const :tag "Automatic" left-right) (const :tag "Left" left) (const :tag "Right" right)))

(defcustom speedbar-sort-tags nil "\
*If non-nil, sort tags in the speedbar display.  *Obsolete*.
Use `semantic-tag-hierarchy-method' instead." :group 'speedbar :type 'boolean)

(defcustom speedbar-tag-hierarchy-method '(speedbar-prefix-group-tag-hierarchy speedbar-trim-words-tag-hierarchy) "\
*List of hooks which speedbar will use to organize tags into groups.
Groups are defined as expandable meta-tags.  Imenu supports
such things in some languages, such as separating variables from
functions.  Each hook takes one argument LST, and may destructively
create a new list of the same form.  LST is a list of elements of the
form:
  (ELT1 ELT2 ... ELTn)
where each ELT is of the form
  (TAG-NAME-STRING . NUMBER-OR-MARKER)
or
  (GROUP-NAME-STRING ELT1 ELT2... ELTn)" :group 'speedbar :type 'hook :options '(speedbar-prefix-group-tag-hierarchy speedbar-trim-words-tag-hierarchy speedbar-simple-group-tag-hierarchy speedbar-sort-tag-hierarchy))

(defcustom speedbar-tag-group-name-minimum-length 4 "\
*The minimum length of a prefix group name before expanding.
Thus, if the `speedbar-tag-hierarchy-method' includes `prefix-group'
and one such groups common characters is less than this number of
characters, then the group name will be changed to the form of:
  worda to wordb
instead of just
  word
This way we won't get silly looking listings." :group 'speedbar :type 'integer)

(defcustom speedbar-tag-split-minimum-length 20 "\
*Minimum length before we stop trying to create sub-lists in tags.
This is used by all tag-hierarchy methods that break large lists into
sub-lists." :group 'speedbar :type 'integer)

(defcustom speedbar-tag-regroup-maximum-length 10 "\
*Maximum length of submenus that are regrouped.
If the regrouping option is used, then if two or more short subgroups
are next to each other, then they are combined until this number of
items is reached." :group 'speedbar :type 'integer)

(defcustom speedbar-directory-button-trim-method 'span "\
*Indicates how the directory button will be displayed.
Possible values are:
 'span - span large directories over multiple lines.
 'trim - trim large directories to only show the last few.
 nil   - no trimming." :group 'speedbar :type '(radio (const :tag "Span large directories over mutiple lines." span) (const :tag "Trim large directories to only show the last few." trim) (const :tag "No trimming." nil)))

(defcustom speedbar-smart-directory-expand-flag t "\
*Non-nil means speedbar should use smart expansion.
Smart expansion only affects when speedbar wants to display a
directory for a file in the attached frame.  When smart expansion is
enabled, new directories which are children of a displayed directory
are expanded in the current framework.  If nil, then the current
hierarchy would be replaced with the new directory." :group 'speedbar :type 'boolean)

(defcustom speedbar-indentation-width 1 "\
*When sub-nodes are expanded, the number of spaces used for indentation." :group 'speedbar :type 'integer)

(defcustom speedbar-hide-button-brackets-flag nil "\
*Non-nil means speedbar will hide the brackets around the + or -." :group 'speedbar :type 'boolean)

(defcustom speedbar-before-popup-hook nil "\
*Hooks called before popping up the speedbar frame." :group 'speedbar :type 'hook)

(defcustom speedbar-after-create-hook '(speedbar-frame-reposition-smartly) "\
*Hooks called before popping up the speedbar frame." :group 'speedbar :type 'hook)

(defcustom speedbar-before-delete-hook nil "\
*Hooks called before deleting the speedbar frame." :group 'speedbar :type 'hook)

(defcustom speedbar-mode-hook nil "\
*Hooks called after creating a speedbar buffer." :group 'speedbar :type 'hook)

(defcustom speedbar-timer-hook nil "\
*Hooks called after running the speedbar timer function." :group 'speedbar :type 'hook)

(defcustom speedbar-verbosity-level 1 "\
*Verbosity level of the speedbar.  0 means say nothing.
1 means medium level verbosity.  2 and higher are higher levels of
verbosity." :group 'speedbar :type 'integer)

(defcustom speedbar-vc-do-check t "\
*Non-nil check all files in speedbar to see if they have been checked out.
Any file checked out is marked with `speedbar-vc-indicator'." :group 'speedbar-vc :type 'boolean)

(defcustom speedbar-vc-directory-enable-hook nil "\
*Return non-nil if the current directory should be checked for Version Control.
Functions in this hook must accept one parameter which is the directory
being checked." :group 'speedbar-vc :type 'hook)

(defcustom speedbar-vc-in-control-hook nil "\
*Return non-nil if the specified file is under Version Control.
Functions in this hook must accept two parameters.  The DIRECTORY of the
current file, and the FILENAME of the file being checked." :group 'speedbar-vc :type 'hook)

(defcustom speedbar-obj-do-check t "\
*Non-nil check all files in speedbar to see if they have an object file.
Any file checked out is marked with `speedbar-obj-indicator', and the
marking is based on `speedbar-obj-alist'" :group 'speedbar-vc :type 'boolean)

(defcustom speedbar-scanner-reset-hook nil "\
*Hook called whenever generic scanners are reset.
Set this to implement your own scanning / rescan safe functions with
state data." :group 'speedbar :type 'hook)

(defcustom speedbar-ignored-directory-expressions '("[/\\]logs?[/\\]\\'") "\
*List of regular expressions matching directories speedbar will ignore.
They should included directorys to directories which are notoriously very
large and take a long time to load in.  Use the function
`speedbar-add-ignored-directory-regexp' to add new items to this list after
speedbar is loaded.  You may place anything you like in this list
before speedbar has been loaded." :group 'speedbar :type '(repeat (regexp :tag "Directory Regexp")) :set (lambda (sym val) (setq speedbar-ignored-directory-expressions val speedbar-ignored-directory-regexp (speedbar-extension-list-to-regex val))))

(defcustom speedbar-directory-unshown-regexp "^\\(CVS\\|RCS\\|SCCS\\|\\..*\\)\\'" "\
*Regular expression matching directories not to show in speedbar.
They should include commonly existing directories which are not
useful, such as version control." :group 'speedbar :type 'string)

(defcustom speedbar-supported-extension-expressions (append '(".[ch]\\(\\+\\+\\|pp\\|c\\|h\\|xx\\)?" ".tex\\(i\\(nfo\\)?\\)?" ".el" ".emacs" ".l" ".lsp" ".p" ".java" ".f\\(90\\|77\\|or\\)?") (if speedbar-use-imenu-flag '(".ada" ".p[lm]" ".tcl" ".m" ".scm" ".pm" ".py" ".g" ".s?html" ".ma?k" "[Mm]akefile\\(\\.in\\)?"))) "\
*List of regular expressions which will match files supported by tagging.
Do not prefix the `.' char with a double \\ to quote it, as the period
will be stripped by a simplified optimizer when compiled into a
singular expression.  This variable will be turned into
`speedbar-file-regexp' for use with speedbar.  You should use the
function `speedbar-add-supported-extension' to add a new extension at
runtime, or use the configuration dialog to set it in your .emacs
file.
If you add an extension to this list, and it does not appear, you may
need to also modify `completion-ignored-extension' which will also help
file completion." :group 'speedbar :type '(repeat (regexp :tag "Extension Regexp")) :set (lambda (sym val) (setq speedbar-supported-extension-expressions val speedbar-file-regexp (speedbar-extension-list-to-regex val))))

(defcustom speedbar-select-frame-method 'attached "\
*Specify how to select a frame for displaying a file.
A value of 'attached means to use the attached frame (the frame
that speedbar was started from.)  A number such as 1 or -1 means to
pass that number to `other-frame' while selecting a frame from speedbar." :group 'speedbar :type 'sexp)

;;;***

(provide 'speedbar-custom-defines)
