;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'strokes-custom-defines) (error "Feature strokes-custom-defines already loaded"))

;;;### (autoloads (strokes-click-command strokes-use-strokes-buffer strokes-buffer-name strokes-file strokes-grid-resolution strokes-minimum-match-score strokes-character strokes-modeline-string strokes-mode strokes) "strokes" "strokes/strokes.el")
(defconst custom-define-current-source-file "strokes.el")

(defgroup strokes nil "Control Emacs through mouse strokes." :group 'mouse :group 'lisp :group 'extensions)

(defcustom strokes-mode nil "\
Non-nil when `strokes' is globally enabled." :type 'boolean :set (lambda (symbol value) (strokes-mode (or value 0))) :initialize 'custom-initialize-default :require 'strokes :group 'strokes)

(defcustom strokes-modeline-string " Strokes" "\
*Modeline identification when strokes are on (default is \" Strokes\")." :type 'string :group 'strokes)

(defcustom strokes-character ?@ "\
*Character used when drawing strokes in the strokes buffer.
\(The default is lower-case `@', which works okay)." :type 'character :group 'strokes)

(defcustom strokes-minimum-match-score 1000 "\
*Minimum score for a stroke to be considered a possible match.
Requiring a perfect match would set this variable to 0.
The default value is 1000, but it's mostly dependent on how precisely
you manage to replicate your user-defined strokes.  It also depends on
the value of `strokes-grid-resolution', since a higher grid resolution
will correspond to more sample points, and thus more distance
measurements.  Usually, this is not a problem since you first set
`strokes-grid-resolution' based on what your computer seems to be able
to handle (though the defaults are usually more than sufficient), and
then you can set `strokes-minimum-match-score' to something that works
for you.  The only purpose of this variable is to insure that if you
do a bogus stroke that really doesn't match any of the predefined
ones, then strokes should NOT pick the one that came closest." :type 'integer :group 'strokes)

(defcustom strokes-grid-resolution 9 "\
*Integer defining dimensions of the stroke grid.
The grid is a square grid, where STROKES-GRID-RESOLUTION defaults to
`9', making a 9x9 grid whose coordinates go from (0 . 0) on the top
left to ((STROKES-GRID-RESOLUTION - 1) . (STROKES-GRID-RESOLUTION - 1))
on the bottom right.  The greater the resolution, the more intricate
your strokes can be.
NOTE: This variable should be odd and MUST NOT be less than 3 and need
      not be greater than 33, which is the resolution of the pixmaps.
WARNING: Changing the value of this variable will gravely affect the
         strokes you have already programmed in.  You should try to
         figure out what it should be based on your needs and on how
         quick the particular platform(s) you're operating on, and
         only then start programming in your custom strokes." :type 'integer :group 'strokes)

(defcustom strokes-file "~/.strokes" "\
*File containing saved strokes for stroke-mode (default is ~/.strokes)." :type 'file :group 'strokes)

(defcustom strokes-buffer-name " *strokes*" "\
The buffer that the strokes take place in (default is ` *strokes*')." :type 'string :group 'strokes)

(defcustom strokes-use-strokes-buffer t "\
*If non-nil, the strokes buffer is used and strokes are displayed.
If nil, strokes will be read the same, however the user will not be
able to see the strokes.  This be helpful for people who don't like
the delay in switching to the strokes buffer." :type 'boolean :group 'strokes)

(defcustom strokes-click-command 'mouse-yank "\
*Command to execute when stroke is actually a `click' event.
This is set to `mouse-yank' by default." :type 'function :group 'strokes)

;;;***

(provide 'strokes-custom-defines)
