;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'supercite-custom-defines) (error "Feature supercite-custom-defines already loaded"))

;;;### (autoloads (sc-use-only-preference-p sc-titlecue-regexp sc-rewrite-header-list sc-reference-tag-string sc-preferred-header-style sc-pre-recite-hook sc-pre-uncite-hook sc-pre-cite-hook sc-attribs-postselect-hook sc-attribs-preselect-hook sc-attrib-selection-list sc-preferred-attribution-list sc-nuke-mail-header-list sc-nuke-mail-headers sc-nested-citation-p sc-name-filter-alist sc-mumble sc-mail-warn-if-non-rfc822-p sc-post-hook sc-pre-hook sc-load-hook sc-fixup-whitespace-p sc-electric-references-p sc-electric-mode-hook sc-electric-circular-p sc-downcase-p sc-default-author-name sc-default-attribution sc-confirm-always-p sc-cite-region-limit sc-default-recite-frame sc-default-uncite-frame sc-default-cite-frame sc-recite-frame-alist sc-uncite-frame-alist sc-cite-frame-alist sc-cite-blank-lines-p sc-citation-separator-regexp sc-citation-delimiter-regexp sc-citation-nonnested-root-regexp sc-citation-root-regexp sc-citation-leader-regexp sc-citation-separator sc-citation-delimiter sc-citation-leader sc-blank-lines-after-headers sc-auto-fill-region-p sc-extract-address-components sc-rewrite-region-function sc-rewrite-address-function supercite-hooks supercite-cite supercite-attr supercite-frames supercite) "supercite" "supercite/supercite.el")
(defconst custom-define-current-source-file "supercite.el")

(defgroup supercite nil "Supercite package" :prefix "sc-" :group 'mail :group 'news)

(defgroup supercite-frames nil "Supercite (regi) frames" :prefix "sc-" :group 'supercite)

(defgroup supercite-attr nil "Supercite attributions" :prefix "sc-" :group 'supercite)

(defgroup supercite-cite nil "Supercite citings" :prefix "sc-" :group 'supercite)

(defgroup supercite-hooks nil "Hooking into supercite" :prefix "sc-" :group 'supercite)

(defcustom sc-rewrite-address-function nil "\
*Function to rewrite addresses prior to being parsed by Supercite.
It should take as its only parameter an email address." :type 'function :group 'supercite)

(defcustom sc-rewrite-region-function nil "\
*Function to rewrite addresses prior to being parsed by Supercite." :type 'function :group 'supercite)

(defcustom sc-extract-address-components 'mail-extract-address-components "\
*Function for extracting address components from a From header.
One pre-defined function exist: `mail-extract-address-components'." :group 'supercite :type '(radio (function-item mail-extract-address-components) (function :tag "Other")))

(defcustom sc-auto-fill-region-p t "\
*If non-nil, automatically fill each paragraph after it has been cited." :type 'boolean :group 'supercite)

(defcustom sc-blank-lines-after-headers 1 "\
*Number of blank lines to leave after mail headers have been nuked.
Set to nil, to use whatever blank lines happen to occur naturally." :type '(choice (const :tag "leave" nil) integer) :group 'supercite)

(defcustom sc-citation-leader "    " "\
*String comprising first part of a citation." :type 'string :group 'supercite-cite)

(defcustom sc-citation-delimiter ">" "\
*String comprising third part of a citation.
This string is used in both nested and non-nested citations." :type 'string :group 'supercite-cite)

(defcustom sc-citation-separator " " "\
*String comprising fourth and last part of a citation." :type 'string :group 'supercite-cite)

(defcustom sc-citation-leader-regexp "[ 	]*" "\
*Regexp describing citation leader for a cited line.
This should NOT have a leading `^' character." :type 'regexp :group 'supercite-cite)

(defcustom sc-citation-root-regexp "[-._a-zA-Z0-9]*" "\
*Regexp describing variable root part of a citation for a cited line.
This should NOT have a leading `^' character.  See also
`sc-citation-nonnested-root-regexp'." :type 'regexp :group 'supercite-cite)

(defcustom sc-citation-nonnested-root-regexp "[-._a-zA-Z0-9]+" "\
*Regexp describing the variable root part of a nested citation.
This should NOT have a leading `^' character.  This variable is
related to `sc-citation-root-regexp' but where as that varariable
describes both nested and non-nested citation roots, this variable
describes only nested citation roots." :type 'regexp :group 'supercite-cite)

(defcustom sc-citation-delimiter-regexp "[>]+" "\
*Regexp describing citation delimiter for a cited line.
This should NOT have a leading `^' character." :type 'regexp :group 'supercite-cite)

(defcustom sc-citation-separator-regexp "[ 	]*" "\
*Regexp describing citation separator for a cited line.
This should NOT have a leading `^' character." :type 'regexp :group 'supercite-cite)

(defcustom sc-cite-blank-lines-p nil "\
*If non-nil, put a citation on blank lines." :type 'boolean :group 'supercite-cite)

(defcustom sc-cite-frame-alist 'nil "\
*Alist for frame selection during citing.
Each element of this list has the following form:

   (INFOKEY ((REGEXP . FRAME)
             (REGEXP . FRAME)
             (...)))

Where INFOKEY is a key for `sc-mail-field', REGEXP is a regular
expression to match against the INFOKEY's value.  FRAME is a citation
frame, or a variable containing a citation frame." :type '(repeat (list symbol (repeat (cons regexp (choice (repeat (repeat sexp)) symbol))))) :group 'supercite-frames)

(defcustom sc-uncite-frame-alist 'nil "\
*Alist for frame selection during unciting.
See the variable `sc-cite-frame-alist' for details." :type '(repeat (list symbol (repeat (cons regexp (choice (repeat (repeat sexp)) symbol))))) :group 'supercite-frames)

(defcustom sc-recite-frame-alist 'nil "\
*Alist for frame selection during reciting.
See the variable `sc-cite-frame-alist' for details." :type '(repeat (list symbol (repeat (cons regexp (choice (repeat (repeat sexp)) symbol))))) :group 'supercite-frames)

(defcustom sc-default-cite-frame '((begin (progn (sc-fill-if-different) (setq sc-tmp-nested-regexp (sc-cite-regexp "") sc-tmp-nonnested-regexp (sc-cite-regexp) sc-tmp-dumb-regexp (concat "\\(" (sc-cite-regexp "") "\\)" (sc-cite-regexp sc-citation-nonnested-root-regexp))))) ("^[ 	]*$" (if sc-cite-blank-lines-p (sc-cite-line) (sc-fill-if-different ""))) (sc-reference-tag-string (if (string= sc-reference-tag-string "") (list 'continue) nil)) (sc-tmp-dumb-regexp (sc-cite-coerce-dumb-citer)) (sc-tmp-nested-regexp (sc-add-citation-level)) (sc-tmp-nonnested-regexp (sc-cite-coerce-cited-line)) (sc-nested-citation-p (sc-add-citation-level)) (t (sc-cite-line)) (end (sc-fill-if-different ""))) "\
*Default REGI frame for citing a region." :type '(repeat (repeat sexp)) :group 'supercite-frames)

(defcustom sc-default-uncite-frame '(("^[ 	]*$" nil) ((sc-cite-regexp) (sc-uncite-line))) "\
*Default REGI frame for unciting a region." :type '(repeat (repeat sexp)) :group 'supercite-frames)

(defcustom sc-default-recite-frame '((begin (sc-fill-if-different)) ("^[ 	]*$" nil) ((sc-cite-regexp) (sc-recite-line (sc-cite-regexp))) (t (sc-cite-line)) (end (sc-fill-if-different ""))) "\
*Default REGI frame for reciting a region." :type '(repeat (repeat sexp)) :group 'supercite-frames)

(defcustom sc-cite-region-limit t "\
*This variable controls automatic citation of yanked text.
Legal values are:

non-nil   -- cite the entire region, regardless of its size
nil       -- do not cite the region at all
<integer> -- a number indicating the threshold for citation.  When
	     the number of lines in the region is greater than this
	     value, a warning message will be printed and the region
	     will not be cited.  Lines in region are counted with
	     `count-lines'.

The gathering of attribution information is not affected by the value
of this variable.  The number of lines in the region is calculated
*after* all mail headers are removed.  This variable is only consulted
during the initial citing via `sc-cite-original'." :type '(choice (const :tag "always cite" t) (const :tag "do not cite" nil) (integer :tag "citation threshold")) :group 'supercite-cite)

(defcustom sc-confirm-always-p t "\
*If non-nil, always confirm attribution string before citing text body." :type 'boolean :group 'supercite-attr)

(defcustom sc-default-attribution "Anon" "\
*String used when author's attribution cannot be determined." :type 'string :group 'supercite-attr)

(defcustom sc-default-author-name "Anonymous" "\
*String used when author's name cannot be determined." :type 'string :group 'supercite-attr)

(defcustom sc-downcase-p nil "\
*Non-nil means downcase the attribution and citation strings." :type 'boolean :group 'supercite-attr :group 'supercite-cite)

(defcustom sc-electric-circular-p t "\
*If non-nil, treat electric references as circular." :type 'boolean :group 'supercite-attr)

(defcustom sc-electric-mode-hook nil "\
*Hook for `sc-electric-mode' electric references mode." :type 'hook :group 'supercite-hooks)

(defcustom sc-electric-references-p nil "\
*Use electric references if non-nil." :type 'boolean :group 'supercite)

(defcustom sc-fixup-whitespace-p nil "\
*If non-nil, delete all leading white space before citing." :type 'boolean :group 'supercite)

(defcustom sc-load-hook nil "\
*Hook which gets run once after Supercite loads." :type 'hook :group 'supercite-hooks)

(defcustom sc-pre-hook nil "\
*Hook which gets run before each invocation of `sc-cite-original'." :type 'hook :group 'supercite-hooks)

(defcustom sc-post-hook nil "\
*Hook which gets run after each invocation of `sc-cite-original'." :type 'hook :group 'supercite-hooks)

(defcustom sc-mail-warn-if-non-rfc822-p t "\
*Warn if mail headers don't conform to RFC822." :type 'boolean :group 'supercite-attr)

(defcustom sc-mumble "" "\
*Value returned by `sc-mail-field' if field isn't in mail headers." :type 'string :group 'supercite-attr)

(defcustom sc-name-filter-alist '(("\\[.*\\]\\|\\[[^]]*\\|[^[]*\\]" . any) ("^\\(Mr\\|Mrs\\|Ms\\|Dr\\)[.]?$" . 0) ("^\\(Jr\\|Sr\\)[.]?$" . last) ("^ASTS$" . 0) ("^[I]+$" . last)) "\
*Name list components which are filtered out as noise.
This variable contains an association list where each element is of
the form:  (REGEXP . POSITION).

REGEXP is a regular expression which matches the name list component.
Match is performed using `string-match'.  POSITION is the position in
the name list which can match the regular expression, starting at zero
for the first element.  Use `last' to match the last element in the
list and `any' to match all elements." :type '(repeat (cons regexp (choice (const last) (const any) (integer :tag "position")))) :group 'supercite-attr)

(defcustom sc-nested-citation-p nil "\
*Controls whether to use nested or non-nested citation style.
Non-nil uses nested citations, nil uses non-nested citations." :type 'boolean :group 'supercite)

(defcustom sc-nuke-mail-headers 'all "\
*Controls mail header nuking.
Used in conjunction with `sc-nuke-mail-header-list'.  Legal values are:

`all'       -- nuke all mail headers
`none'      -- don't nuke any mail headers
`specified' -- nuke headers specified in `sc-nuke-mail-header-list'
`keep'      -- keep headers specified in `sc-nuke-mail-header-list'" :type '(choice (const all) (const none) (const specified) (const keep)) :group 'supercite)

(defcustom sc-nuke-mail-header-list nil "\
*List of mail header regexps to remove or keep in body of reply.
This list contains regular expressions describing the mail headers to
keep or nuke, depending on the value of `sc-nuke-mail-headers'." :type '(repeat regexp) :group 'supercite)

(defcustom sc-preferred-attribution-list '("sc-lastchoice" "x-attribution" "firstname" "initials" "lastname") "\
*Specifies what to use as the attribution string.
Supercite creates a list of possible attributions when it scans the
mail headers from the original message.  Each attribution choice is
associated with a key in an attribution alist.  Supercite tries to
pick a \"preferred\" attribution by matching the attribution alist
keys against the elements in `sc-preferred-attribution-list' in order.
The first non-empty string value found is used as the preferred
attribution.

Note that Supercite now honors the X-Attribution: mail field.  If
present in the original message, the value of this field should always
be used to select the most preferred attribution since it reflects how
the original author would like to be distinguished.  It should be
considered bad taste to put any attribution preference key before
\"x-attribution\" in this list, except perhaps for \"sc-lastchoice\"
\(see below).

Supercite remembers the last attribution used when reciting an already
cited paragraph.  This attribution will always be saved with the
\"sc-lastchoice\" key, which can be used in this list.  Note that the
last choice is always reset after every call of `sc-cite-original'.

Barring error conditions, the following preferences are always present
in the attribution alist:

\"emailname\"    -- email terminus name
\"initials\"     -- initials of author
\"firstname\"    -- first name of author
\"lastname\"     -- last name of author
\"middlename-1\" -- first middle name of author
\"middlename-2\" -- second middle name of author
...

Middle name indexes can be any positive integer greater than 0,
although it is unlikely that many authors will supply more than one
middle name, if that many.  The string of all middle names is
associated with the key \"middlenames\"." :type '(repeat string) :group 'supercite-attr)

(defcustom sc-attrib-selection-list nil "\
*An alist for selecting preferred attribution based on mail headers.
Each element of this list has the following form:

   (INFOKEY ((REGEXP . ATTRIBUTION)
             (REGEXP . ATTRIBUTION)
             (...)))

Where INFOKEY is a key for `sc-mail-field', REGEXP is a regular
expression to match against the INFOKEY's value. ATTRIBUTION can be a
string or a list.  If its a string, then it is the attribution that is
selected by `sc-select-attribution'.  If it is a list, it is `eval'd
and the return value must be a string, which is used as the selected
attribution.  Note that the variable `sc-preferred-attribution-list'
must contain an element of the string \"sc-consult\" for this variable
to be consulted during attribution selection." :type '(repeat (group (string :tag "Infokey") (repeat :format "
%v%i
" (cons :format "
%v" (regexp :tag "     Regexp") (choice :tag "Attribution" :format "%{%t%}: %[choice%] %v" sexp string))))) :group 'supercite-attr)

(defcustom sc-attribs-preselect-hook nil "\
*Hook to run before selecting an attribution." :type 'hook :group 'supercite-attr :group 'supercite-hooks)

(defcustom sc-attribs-postselect-hook nil "\
*Hook to run after selecting an attribution, but before confirmation." :type 'hook :group 'supercite-attr :group 'supercite-hooks)

(defcustom sc-pre-cite-hook nil "\
*Hook to run before citing a region of text." :type 'hook :group 'supercite-cite :group 'supercite-hooks)

(defcustom sc-pre-uncite-hook nil "\
*Hook to run before unciting a region of text." :type 'hook :group 'supercite-cite :group 'supercite-hooks)

(defcustom sc-pre-recite-hook nil "\
*Hook to run before reciting a region of text." :type 'hook :group 'supercite-cite :group 'supercite-hooks)

(defcustom sc-preferred-header-style 4 "\
*Index into `sc-rewrite-header-list' specifying preferred header style.
Index zero accesses the first function in the list." :type 'integer :group 'supercite)

(defcustom sc-reference-tag-string ">>>>> " "\
*String used at the beginning of built-in reference headers." :type 'string :group 'supercite)

(defcustom sc-rewrite-header-list '((sc-no-header) (sc-header-on-said) (sc-header-inarticle-writes) (sc-header-regarding-adds) (sc-header-attributed-writes) (sc-header-author-writes) (sc-header-verbose) (sc-no-blank-line-or-header) (sc-header-author-email-writes)) "\
*List of reference header rewrite functions.
The variable `sc-preferred-header-style' controls which function in
this list is chosen for automatic reference header insertions.
Electric reference mode will cycle through this list of functions." :type '(repeat sexp) :group 'supercite)

(defcustom sc-titlecue-regexp "\\s +-+\\s +" "\
*Regular expression describing the separator between names and titles.
Set to nil to treat entire field as a name." :type '(choice (const :tag "entire field as name" nil) regexp) :group 'supercite-attr)

(defcustom sc-use-only-preference-p nil "\
*Controls what happens when the preferred attribution cannot be found.
If non-nil, then `sc-default-attribution' will be used.  If nil, then
some secondary scheme will be employed to find a suitable attribution
string." :type 'boolean :group 'supercite-attr)

;;;***

(provide 'supercite-custom-defines)
