;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'texinfo-custom-defines) (error "Feature texinfo-custom-defines already loaded"))

;;;### (autoloads (makeinfo-options makeinfo-run-command makeinfo) "makeinfo" "texinfo/makeinfo.el")
(defconst custom-define-current-source-file "makeinfo.el")

(defgroup makeinfo nil "Run makeinfo conveniently." :group 'docs)

(defcustom makeinfo-run-command "makeinfo" "\
*Command used to run `makeinfo' subjob.
The name of the file is appended to this string, separated by a space." :type 'string :group 'makeinfo)

(defcustom makeinfo-options "--fill-column=70" "\
*String containing options for running `makeinfo'.  
Do not include `--footnote-style' or `--paragraph-indent';
the proper way to specify those is with the Texinfo commands
`@footnotestyle` and `@paragraphindent'." :type 'string :group 'makeinfo)

;;;***

;;;### (autoloads (texinfo-delete-from-print-queue-command texinfo-texindex-command texinfo-tex-command texinfo-texi2dvi-command texinfo-mode-hook texinfo-close-quote texinfo-open-quote texinfo) "texinfo" "texinfo/texinfo.el")
(defconst custom-define-current-source-file "texinfo.el")

(defgroup texinfo nil "Texinfo Mode." :group 'docs)

(defcustom texinfo-open-quote "``" "\
*String inserted by typing \\[texinfo-insert-quote] to open a quotation." :type 'string :group 'texinfo)

(defcustom texinfo-close-quote "''" "\
*String inserted by typing \\[texinfo-insert-quote] to close a quotation." :type 'string :group 'texinfo)

(defcustom texinfo-mode-hook nil "\
Normal hook run when entering Texinfo mode." :type 'hook :options '(turn-on-auto-fill flyspell-mode) :group 'texinfo)

(defcustom texinfo-texi2dvi-command "texi2dvi" "\
*Command used by `texinfo-tex-buffer' to run TeX and texindex on a buffer." :type 'string :group 'texinfo)

(defcustom texinfo-tex-command "tex" "\
*Command used by `texinfo-tex-region' to run TeX on a region." :type 'string :group 'texinfo)

(defcustom texinfo-texindex-command "texindex" "\
*Command used by `texinfo-texindex' to sort unsorted index files." :type 'string :group 'texinfo)

(defcustom texinfo-delete-from-print-queue-command "lprm" "\
*Command string used to delete a job from the line printer queue.
Command is used by \\[texinfo-delete-from-print-queue] based on
number provided by a previous \\[tex-show-print-queue]
command." :type 'string :group 'texinfo)

;;;***

;;;### (autoloads (texinfo-delete-from-print-queue-command texinfo-show-tex-queue-command texinfo-tex-dvi-print-command texinfo-texindex-command texinfo-tex-command texinfo-tex-shell-cd-command texinfo-tex) "texnfo-tex" "texinfo/texnfo-tex.el")
(defconst custom-define-current-source-file "texnfo-tex.el")

(defgroup texinfo-tex nil "TeX and hardcopy printing commands for Texinfo mode" :prefix "texinfo-" :group 'tex :tag "Texinfo TeX" :group 'texinfo)

(defcustom texinfo-tex-shell-cd-command "cd" "\
Command to give to shell running TeX to change directory." :type 'string :group 'texinfo-tex)

(defcustom texinfo-tex-command "tex" "\
*Command used by  texinfo-tex-region  to run tex on a region." :type 'string :group 'texinfo-tex)

(defcustom texinfo-texindex-command "texindex" "\
*Command used by  texinfo-texindex  to sort unsorted index files." :type 'string :group 'texinfo-tex)

(defcustom texinfo-tex-dvi-print-command "lpr -d" "\
*Command string used by \\[tex-print] to print a .dvi file." :type 'string :group 'texinfo-tex)

(defcustom texinfo-show-tex-queue-command "lpq" "\
*Command string used to show the Texinfo TeX print queue.
Command is used by \\[texinfo-show-tex-print-queue] and it
should show the queue that \\[texinfo-tex-print] puts jobs on." :type 'string :group 'texinfo-tex)

(defcustom texinfo-delete-from-print-queue-command "lprm" "\
*Command string used to delete a job from the line printer queue.
Command is used by \\[texinfo-delete-from-tex-print-queue] based on
number provided by a previous \\[texinfo-show-tex-print-queue]
command." :type 'string :group 'texinfo-tex)

;;;***

(provide 'texinfo-custom-defines)
