;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'text-modes-custom-defines) (error "Feature text-modes-custom-defines already loaded"))

;;;### (autoloads (ansi-color-for-comint-mode ansi-color-names-vector ansi-color-faces-vector ansi-colors) "ansi-color" "text-modes/ansi-color.el")
(defconst custom-define-current-source-file "ansi-color.el")

(defgroup ansi-colors nil "Translating SGR control sequences to faces.\nThis translation effectively colorizes strings and regions based upon\nSGR control sequences embedded in the text.  SGR (Select Graphic\nRendition) control sequences are defined in section 3.8.117 of the\nECMA-48 standard (identical to ISO/IEC 6429), which is freely available\nas a PDF file <URL:http://www.ecma.ch/ecma1/STAND/ECMA-048.HTM>." :version "21.1" :group 'processes)

(defcustom ansi-color-faces-vector [default bold default italic underline bold bold-italic modeline] "\
Faces used for SGR control sequences determining a face.
This vector holds the faces used for SGR control sequence parameters 0
to 7.

Parameter  Description        Face used by default
  0        default            default
  1        bold               bold
  2        faint              default
  3        italic             italic
  4        underlined         underline
  5        slowly blinking    bold
  6        rapidly blinking   bold-italic
  7        negative image     modeline

Note that the symbol `default' is special: It will not be combined
with the current face.

This vector is used by `ansi-color-make-color-map' to create a color
map.  This color map is stored in the variable `ansi-color-map'." :type '(vector face face face face face face face face) :set 'ansi-color-map-update :initialize 'custom-initialize-default :group 'ansi-colors)

(defcustom ansi-color-names-vector ["black" "red" "green" "yellow" "blue" "magenta" "cyan" "white"] "\
Colors used for SGR control sequences determining a color.
This vector holds the colors used for SGR control sequences parameters
30 to 37 (foreground colors) and 40 to 47 (background colors).

Parameter  Color
  30  40   black
  31  41   red
  32  42   green
  33  43   yellow
  34  44   blue
  35  45   magenta
  36  46   cyan
  37  47   white

This vector is used by `ansi-color-make-color-map' to create a color
map.  This color map is stored in the variable `ansi-color-map'." :type '(vector string string string string string string string string) :set 'ansi-color-map-update :initialize 'custom-initialize-default :group 'ansi-colors)

(defcustom ansi-color-for-comint-mode nil "\
Determines what to do with comint output.
If nil, do nothing.
If the symbol `filter', then filter all SGR control sequences.
If anything else (such as t), then translate SGR control sequences
into text-properties.

In order for this to have any effect, `ansi-color-process-output' must
be in `comint-output-filter-functions'.

This can be used to enable colorized ls --color=yes output
in shell buffers.  You set this variable by calling one of:
\\[ansi-color-for-comint-mode-on]
\\[ansi-color-for-comint-mode-off]
\\[ansi-color-for-comint-mode-filter]" :type '(choice (const :tag "Do nothing" nil) (const :tag "Filter" filter) (const :tag "Translate" t)) :group 'ansi-colors)

;;;***

;;;### (autoloads (apache-mode-hook apache-file-patterns apache-manual-url apache) "apache-mode" "text-modes/apache-mode.el")
(defconst custom-define-current-source-file "apache-mode.el")

(defgroup apache nil "Major mode for editing Apache configuration files." :prefix "apache-" :group 'languages)

(defcustom apache-manual-url "http://httpd.apache.org/" "\
*URL at which to find the Apache manual." :type 'string :group 'apache)

(defcustom apache-file-patterns (list "\\.htaccess\\(\\.default\\)?$" "httpd\\.conf\\(\\.default\\)?$" "srm\\.conf\\(\\.default\\)?$" "access\\.conf\\(\\.default\\)?$") "\
*List of file patterns for which to automatically invoke `apache-mode'." :type '(repeat (regexp :tag "Pattern")) :group 'apache)

(defcustom apache-mode-hook nil "\
*List of hook functions run by `apache-mode' (see `run-hooks')." :type 'hook :group 'apache)

;;;***

;;;### (autoloads (rtf apache) "auto-autoloads" "text-modes/auto-autoloads.el")
(defconst custom-define-current-source-file "auto-autoloads.el")

(defgroup apache nil "Major mode for editing Apache configuration files." :prefix "apache-" :group 'languages)

(defgroup rtf nil "Support RTF selections and spooling of RTF to a buffer." :group 'wp :tag "RTF")

;;;***

;;;### (autoloads (auto-insert-prompt auto-insert-query auto-insert auto-insert) "autoinsert" "text-modes/autoinsert.el")
(defconst custom-define-current-source-file "autoinsert.el")

(defgroup auto-insert nil "Automatic mode-dependent insertion of text into new files." :group 'tools)

(defcustom auto-insert 'not-modified "\
*Controls automatic insertion into newly found empty files:
	nil	do nothing
	t	insert if possible
	other	insert if possible, but mark as unmodified.
Insertion is possible when something appropriate is found in
`auto-insert-alist'.  When the insertion is marked as unmodified, you can
save it with  \\[write-file] RET.
This variable is used when `auto-insert' is called as a function, e.g.
when you do (add-hook 'find-file-hooks 'auto-insert).
With \\[auto-insert], this is always treated as if it were `t'." :type '(radio (const :tag "Do nothing" nil) (const :tag "Insert if possible" t) (sexp :format "%t
" :tag "Insert if possible, but mark as unmodified" other)) :require 'autoinsert :group 'auto-insert)

(defcustom auto-insert-query 'function "\
*If non-`nil', ask user before auto-inserting.
When this is `function', only ask when called non-interactively." :type '(choice (const :tag "Don't ask" nil) (const :tag "Ask when non-interactive" function) (sexp :format "%t
" :tag "Ask" other)) :group 'auto-insert)

(defcustom auto-insert-prompt "Perform %s auto-insertion? " "\
*Prompt to use when querying whether to auto-insert.
If this contains a %s, that will be replaced by the matching rule." :type 'string :group 'auto-insert)

;;;***

;;;### (autoloads (crontab-delete-blank-lines crontab-use-local-file crontab-directory crontab-filename crontab) "crontab" "text-modes/crontab.el")
(defconst custom-define-current-source-file "crontab.el")

(defgroup crontab nil "Assist in editing crontab files." :group 'languages)

(defcustom crontab-filename "~/.crontab" "\
*The name of the file to store the User's Crontab." :type 'file :group 'crontab)

(defcustom crontab-directory "/usr/spool/cron/crontabs" "\
*The name of the directory in which crontab stores it's entries." :type 'file :group 'crontab)

(defcustom crontab-use-local-file nil "\
*Non-nil means use file stored in User's Home directory, if it exists.
Otherwise, always ask crontab for the current entry (maybe)." :type 'boolean :group 'crontab)

(defcustom crontab-delete-blank-lines t "\
*Non-nil means to delete any blank lines in the crontab file on save." :type 'boolean :group 'crontab)

;;;***

;;;### (autoloads (cssm-indent-function cssm-newline-before-closing-bracket cssm-mirror-mode cssm-indent-level css) "css-mode" "text-modes/css-mode.el")
(defconst custom-define-current-source-file "css-mode.el")

(defgroup css nil "Major mode for editing CSS files." :group 'languages :group 'hypermedia :prefix "cssm-")

(defcustom cssm-indent-level 2 "\
*The indentation level inside @media rules." :type 'integer :group 'css)

(defcustom cssm-mirror-mode t "\
*Whether brackets, quotes etc should be mirrored automatically on insertion." :type 'boolean :group 'css)

(defcustom cssm-newline-before-closing-bracket nil "\
*In `cssm-mirror-mode', controls whether a newline should be inserted
before the closing bracket or not." :type 'boolean :group 'css)

(defcustom cssm-indent-function (function cssm-c-style-indenter) "\
*Which function to use when deciding which column to indent to.
Built-in choices are `cssm-old-style-indenter' and `cssm-c-style-indenter'." :type 'function :group 'css)

;;;***

;;;### (autoloads (desktop-entry-faces desktop-entry-validate-command desktop-entry) "desktop-entry-mode" "text-modes/desktop-entry-mode.el")
(defconst custom-define-current-source-file "desktop-entry-mode.el")

(defgroup desktop-entry nil "Support for editing freedesktop.org desktop entry files." :group 'languages)

(defcustom desktop-entry-validate-command "desktop-file-validate" "\
*Command for validating desktop entry files." :type 'string :group 'desktop-entry)

(defgroup desktop-entry-faces nil "Font lock faces for `desktop-entry-mode'." :prefix "desktop-entry-" :group 'desktop-entry :group 'faces)

;;;***

;;;### (autoloads (filladapt-debug filladapt-fill-paragraph-post-hook filladapt-token-conversion-table filladapt-token-paragraph-start-table filladapt-token-match-many-table filladapt-token-match-table filladapt-not-token-table filladapt-token-table filladapt-fill-column-backward-fuzz filladapt-fill-column-forward-fuzz filladapt-fill-column-tolerance filladapt-mode-line-string filladapt) "filladapt" "text-modes/filladapt.el")
(defconst custom-define-current-source-file "filladapt.el")

(defgroup filladapt nil "Enhanced filling" :group 'fill)

(defcustom filladapt-mode-line-string " Filladapt" "\
*String to display in the modeline when Filladapt mode is active.
Set this to nil if you don't want a modeline indicator for Filladapt." :type 'string :group 'filladapt)

(defcustom filladapt-fill-column-tolerance nil "\
*Tolerate filled paragraph lines ending this far from the fill column.
If any lines other than the last paragraph line end at a column
less than fill-column - filladapt-fill-column-tolerance, fill-column will
be adjusted using the filladapt-fill-column-*-fuzz variables and
the paragraph will be re-filled until the tolerance is achieved
or filladapt runs out of fuzz values to try.

A nil value means behave normally, that is, don't try refilling
paragraphs to make filled line lengths fit within any particular
range." :type '(choice (const nil) integer) :group 'filladapt)

(defcustom filladapt-fill-column-forward-fuzz 5 "\
*Try values from fill-column to fill-column plus this variable
when trying to make filled paragraph lines fall with the tolerance
range specified by filladapt-fill-column-tolerance." :type 'integer :group 'filladapt)

(defcustom filladapt-fill-column-backward-fuzz 5 "\
*Try values from fill-column to fill-column minus this variable
when trying to make filled paragraph lines fall with the tolerance
range specified by filladapt-fill-column-tolerance." :type 'integer :group 'filladapt)

(defcustom filladapt-token-table '(("^" beginning-of-line) (">+" citation->) ("\\(\\w\\|[0-9]\\)[^'`\"< 	\n]*>[ 	]*" supercite-citation) (";+" lisp-comment) ("#+" sh-comment) ("%+" postscript-comment) ("///*" c++-comment) ("@c[ 	]" texinfo-comment) ("@comment[ 	]" texinfo-comment) ("\\\\item[ 	]" bullet) ("[0-9]+\\.[ 	]" bullet) ("[0-9]+\\(\\.[0-9]+\\)+[ 	]" bullet) ("[A-Za-z]\\.[ 	]" bullet) ("(?[0-9]+)[ 	]" bullet) ("(?[A-Za-z])[ 	]" bullet) ("[0-9]+[A-Za-z]\\.[ 	]" bullet) ("(?[0-9]+[A-Za-z])[ 	]" bullet) ("[-~*+]+[ 	]" bullet) ("o[ 	]" bullet) ("[ 	]+" space) ("$" end-of-line)) "\
Table of tokens filladapt knows about.
Format is

   ((REGEXP SYM) ...)

filladapt uses this table to build a tokenized representation of
the beginning of the current line.  Each REGEXP is matched
against the beginning of the line until a match is found.
Matching is done case-sensitively.  The corresponding SYM is
added to the list, point is moved to (match-end 0) and the
process is repeated.  The process ends when there is no REGEXP in
the table that matches what is at point." :type '(repeat (list regexp symbol)) :group 'filladapt)

(defcustom filladapt-not-token-table '("[Ee]\\.g\\.[ 	,]" "[Ii]\\.e\\.[ 	,]" "^$") "\
List of regexps that can never be a token.
Before trying the regular expressions in filladapt-token-table,
the regexps in this list are tried.  If any regexp in this list
matches what is at point then the token generator gives up and
doesn't try any of the regexps in filladapt-token-table.

Regexp matching is done case-sensitively." :type '(repeat regexp) :group 'filladapt)

(defcustom filladapt-token-match-table '((citation-> citation->) (supercite-citation supercite-citation) (lisp-comment lisp-comment) (sh-comment sh-comment) (postscript-comment postscript-comment) (c++-comment c++-comment) (texinfo-comment texinfo-comment) (bullet) (space bullet space) (beginning-of-line beginning-of-line)) "\
Table describing what tokens a certain token will match.

To decide whether a line belongs in the current paragraph,
filladapt creates a token list for the fill prefix of both lines.
Tokens and the columns where tokens end are compared.  This table
specifies what a certain token will match.

Table format is

   (SYM [SYM1 [SYM2 ...]])

The first symbol SYM is the token, subsequent symbols are the
tokens that SYM will match." :type '(repeat (repeat symbol)) :group 'filladapt)

(defcustom filladapt-token-match-many-table '(space) "\
List of tokens that can match multiple tokens.
If one of these tokens appears in a token list, it will eat all
matching tokens in a token list being matched against it until it
encounters a token that doesn't match or a token that ends on
a greater column number." :type '(repeat symbol) :group 'filladapt)

(defcustom filladapt-token-paragraph-start-table '(bullet) "\
List of tokens that indicate the start of a paragraph.
If parsing a line generates a token list containing one of
these tokens, then the line is considered to be the start of a
paragraph." :type '(repeat symbol) :group 'filladapt)

(defcustom filladapt-token-conversion-table '((citation-> . exact) (supercite-citation . exact) (lisp-comment . exact) (sh-comment . exact) (postscript-comment . exact) (c++-comment . exact) (texinfo-comment . exact) (bullet . spaces) (space . exact) (end-of-line . exact)) "\
Table that specifies how to convert a token into a fill prefix.
Table format is

   ((SYM . HOWTO) ...)

SYM is the symbol naming the token to be converted.
HOWTO specifies how to do the conversion.
  `exact' means copy the token's string directly into the fill prefix.
  `spaces' means convert all characters in the token string that are
      not a TAB or a space into spaces and copy the resulting string into 
      the fill prefix." :type '(repeat (cons symbol (choice (const exact) (const spaces)))) :group 'filladapt)

(defcustom filladapt-fill-paragraph-post-hook nil "\
Hooks run after filladapt runs fill-paragraph." :type 'hook :group 'filladapt)

(defcustom filladapt-debug nil "\
Non-nil means filladapt debugging is enabled.
Use the filladapt-debug command to turn on debugging.

With debugging enabled, filladapt will

    a. display the proposed indentation with the tokens highlighted
       using filladapt-debug-indentation-face-1 and
       filladapt-debug-indentation-face-2.
    b. display the current paragraph using the face specified by
       filladapt-debug-paragraph-face." :type 'boolean :group 'filladapt)

;;;***

;;;### (autoloads (flyspell-auto-correct-binding flyspell-use-meta-tab flyspell-after-incorrect-word-string flyspell-before-incorrect-word-string flyspell-insert-function flyspell-large-region flyspell-mode-line-string flyspell-use-global-abbrev-table-p flyspell-abbrev-p flyspell-dictionaries-that-consider-dash-as-word-delimiter flyspell-check-tex-math-command flyspell-tex-command-regexp flyspell-default-dictionary flyspell-incorrect-hook flyspell-issue-message-flag flyspell-issue-welcome-flag flyspell-deplacement-commands flyspell-default-deplacement-commands flyspell-delayed-commands flyspell-default-delayed-commands flyspell-highlight-properties flyspell-persistent-highlight flyspell-delay flyspell-duplicate-distance flyspell-sort-corrections flyspell-mark-duplications-flag flyspell-highlight-flag flyspell) "flyspell" "text-modes/flyspell.el")
(defconst custom-define-current-source-file "flyspell.el")

(defgroup flyspell nil "Spell checking on the fly." :tag "FlySpell" :prefix "flyspell-" :group 'ispell :group 'processes)

(defcustom flyspell-highlight-flag t "\
*How Flyspell should indicate misspelled words.
Non-nil means use highlight, nil means use minibuffer messages." :group 'flyspell :type 'boolean)

(defcustom flyspell-mark-duplications-flag t "\
*Non-nil means Flyspell reports a repeated word as an error." :group 'flyspell :type 'boolean)

(defcustom flyspell-sort-corrections nil "\
*Non-nil means, sort the corrections alphabetically before popping them." :group 'flyspell :version "21.1" :type 'boolean)

(defcustom flyspell-duplicate-distance -1 "\
*The maximum distance for finding duplicates of unrecognized words.
This applies to the feature that when a word is not found in the dictionary,
if the same spelling occurs elsewhere in the buffer,
Flyspell uses a different face (`flyspell-duplicate-face') to highlight it.
This variable specifies how far to search to find such a duplicate.
-1 means no limit (search the whole buffer).
0 means do not search for duplicate unrecognized spellings." :group 'flyspell :version "21.1" :type 'number)

(defcustom flyspell-delay 3 "\
*The number of seconds to wait before checking, after a \"delayed\" command." :group 'flyspell :type 'number)

(defcustom flyspell-persistent-highlight t "\
*Non-nil means misspelled words remain highlighted until corrected.
If this variable is nil, only the most recently detected misspelled word
is highlighted." :group 'flyspell :type 'boolean)

(defcustom flyspell-highlight-properties t "\
*Non-nil means highlight incorrect words even if a property exists for this word." :group 'flyspell :type 'boolean)

(defcustom flyspell-default-delayed-commands '(self-insert-command delete-backward-char backward-or-forward-delete-char delete-char scrollbar-vertical-drag) "\
The standard list of delayed commands for Flyspell.
See `flyspell-delayed-commands'." :group 'flyspell :version "21.1" :type '(repeat (symbol)))

(defcustom flyspell-delayed-commands nil "\
List of commands that are \"delayed\" for Flyspell mode.
After these commands, Flyspell checking is delayed for a short time,
whose length is specified by `flyspell-delay'." :group 'flyspell :type '(repeat (symbol)))

(defcustom flyspell-default-deplacement-commands '(next-line previous-line scroll-up scroll-down) "\
The standard list of deplacement commands for Flyspell.
See `flyspell-deplacement-commands'." :group 'flyspell :version "21.1" :type '(repeat (symbol)))

(defcustom flyspell-deplacement-commands nil "\
List of commands that are \"deplacement\" for Flyspell mode.
After these commands, Flyspell checking is performed only if the previous
command was not the very same command." :group 'flyspell :version "21.1" :type '(repeat (symbol)))

(defcustom flyspell-issue-welcome-flag t "\
*Non-nil means that Flyspell should display a welcome message when started." :group 'flyspell :type 'boolean)

(defcustom flyspell-issue-message-flag t "\
*Non-nil means that Flyspell emits messages when checking words." :group 'flyspell :type 'boolean)

(defcustom flyspell-incorrect-hook nil "\
*List of functions to be called when incorrect words are encountered.
Each function is given three arguments: the beginning and the end
of the incorrect region.  The third is either the symbol 'doublon' or the list
of possible corrections as returned by 'ispell-parse-output'.

If any of the functions return non-Nil, the word is not highlighted as
incorrect." :group 'flyspell :version "21.1" :type 'hook)

(defcustom flyspell-default-dictionary nil "\
A string that is the name of the default dictionary.
This is passed to the `ispell-change-dictionary' when flyspell is started.
If the variable `ispell-local-dictionary' or `ispell-dictionary' is non-nil
when flyspell is started, the value of that variable is used instead
of `flyspell-default-dictionary' to select the default dictionary.
Otherwise, if `flyspell-default-dictionary' is nil, it means to use
Ispell's ultimate default dictionary." :group 'flyspell :version "21.1" :type '(choice string (const :tag "Default" nil)))

(defcustom flyspell-tex-command-regexp "\\(\\(begin\\|end\\)[ 	]*{\\|\\(cite[a-z*]*\\|label\\|ref\\|eqref\\|usepackage\\|documentclass\\)[ 	]*\\(\\[[^]]*\\]\\)?{[^{}]*\\)" "\
A string that is the regular expression that matches TeX commands." :group 'flyspell :version "21.1" :type 'string)

(defcustom flyspell-check-tex-math-command nil "\
*Non nil means check even inside TeX math environment.
TeX math environments are discovered by the TEXMATHP that implemented
inside the texmathp.el Emacs package.  That package may be found at:
http://strw.leidenuniv.nl/~dominik/Tools" :group 'flyspell :type 'boolean)

(defcustom flyspell-dictionaries-that-consider-dash-as-word-delimiter '("francais" "deutsch8" "norsk") "\
List of dictionary names that consider `-' as word delimiter." :group 'flyspell :version "21.1" :type '(repeat (string)))

(defcustom flyspell-abbrev-p nil "\
*If non-nil, add correction to abbreviation table." :group 'flyspell :version "21.1" :type 'boolean)

(defcustom flyspell-use-global-abbrev-table-p nil "\
*If non-nil, prefer global abbrev table to local abbrev table." :group 'flyspell :version "21.1" :type 'boolean)

(defcustom flyspell-mode-line-string " Fly" "\
*String displayed on the modeline when flyspell is active.
Set this to nil if you don't want a modeline indicator." :group 'flyspell :type '(choice string (const :tag "None" nil)))

(defcustom flyspell-large-region 1000 "\
*The threshold that determines if a region is small.
The `flyspell-region' function is invoked if the region is small, the
word are checked one after the other using regular flyspell check
means.  If the region is large, a new Ispell process is spawned to get
speed." :group 'flyspell :version "21.1" :type 'number)

(defcustom flyspell-insert-function (function insert) "\
*Function for inserting word by flyspell upon correction." :group 'flyspell :type 'function)

(defcustom flyspell-before-incorrect-word-string nil "\
String used to indicate an incorrect word starting." :group 'flyspell :type '(choice string (const nil)))

(defcustom flyspell-after-incorrect-word-string nil "\
String used to indicate an incorrect word ending." :group 'flyspell :type '(choice string (const nil)))

(defcustom flyspell-use-meta-tab t "\
*Non-nil means that flyspell uses META-TAB to correct word." :group 'flyspell :type 'boolean)

(defcustom flyspell-auto-correct-binding (cond ((eq flyspell-emacs 'xemacs) [(control \;)]) (t [?\^[])) "\
The key binding for flyspell auto correction." :group 'flyspell)

;;;***

;;;### (autoloads (folding-isearch-install folding-allow-overlays folding-behave-table folding-mode-hook-no-regexp folding-mode-string folding-check-allow-folding-function folding-check-folded-file-function folding-inside-mode-name folding-internal-margins folding-folding-on-startup folding-load-hook folding-mode-hook folding-default-mouse-keys-function folding-default-keys-function folding-shift-in-on-goto folding-advice-instantiate folding-font-lock-end-mark folding-font-lock-begin-mark folding-goto-key folding-mode-prefix-key folding) "folding" "text-modes/folding.el")
(defconst custom-define-current-source-file "folding.el")

(defgroup folding nil "Managing buffers with Folds." :group 'tools)

(defcustom folding-mode-prefix-key "@" "\
*Prefix key to use for Folding commands in Folding mode." :type 'string :group 'folding)

(defcustom folding-goto-key "" "\
*Key to be bound to `folding-goto-line' in folding mode.
The default value is M - g, but you probably don't want folding to
occupy it if you have used M - g got `goto-line'." :type 'string :group 'folding)

(defcustom folding-font-lock-begin-mark 'font-lock-reference-face "\
Face to highlight beginning fold mark." :type 'face :group 'folding)

(defcustom folding-font-lock-end-mark 'font-lock-reference-face "\
Face to highlight end fold mark." :type 'face :group 'folding)

(defcustom folding-advice-instantiate t "\
*In non-nil install advice code. Eg for `goto-line'." :type 'boolean :group 'folding)

(defcustom folding-shift-in-on-goto t "\
*Flag in folding adviced function `goto-line'.
If non-nil, folds are entered when going to a given line.
Otherwise the buffer is unfolded. Can also be set to 'show.
This variable is used only if `folding-advice-instantiate' was
non-nil when folding was loaded.

See also `folding-goto-key'." :type 'boolean :group 'folding)

(defcustom folding-default-keys-function 'folding-bind-default-keys "\
*Function or list of functions used to define keys for Folding mode.
Possible values are:
  folding-bind-default-key
        The standard keymap.

  `folding-bind-backward-compatible-keys'
        Keys used by older versions of Folding mode. This function
        does not conform to Emacs 19.29 style conversions concerning
        key bindings. The prefix key is C - c

  `folding-bind-outline-compatible-keys'
        Define keys compatible with Outline mode.

  `folding-bind-foldout-compatible-keys'
        Define some extra keys compatible with Foldout.

All except `folding-bind-backward-compatible-keys' used the value of
the variable `folding-mode-prefix-key' as prefix the key.
The default is C - c @" :type 'function :group 'folding)

(defcustom folding-default-mouse-keys-function 'folding-bind-default-mouse "\
*Function to bind default mouse keys to `folding-mode-map'." :type 'function :group 'folding)

(defcustom folding-mode-hook nil "\
*Hook called when Folding mode is entered.

A hook named `<major-mode>-folding-hook' is also called, if it
exists. Eg., `c-mode-folding-hook' is called whenever Folding mode is
started in C mode." :type 'hook :group 'folding)

(defcustom folding-load-hook nil "\
*Hook run when file is loaded." :type 'hook :group 'folding)

(defcustom folding-folding-on-startup t "\
*If non-nil, buffers are folded when starting Folding mode." :type 'boolean :group 'folding)

(defcustom folding-internal-margins 1 "\
*Number of blank lines left next to fold mark when tidying folds.

This variable is local to each buffer. To set the default value for all
buffers, use `set-default'.

When exiting a fold, and at other times, `folding-tidy-inside' is invoked
to ensure that the fold is in the correct form before leaving it. This
variable specifies the number of blank lines to leave between the
enclosing fold marks and the enclosed text.

If this value is nil or negative, no blank lines are added or removed
inside the fold marks. A value of 0 (zero) is valid, meaning leave no
blank lines.

See also `folding-tidy-inside'." :type 'boolean :group 'folding)

(defcustom folding-inside-mode-name "Fld" "\
*Mode line addition to show inside levels of 'fold' ." :type 'string :group 'folding)

(defcustom folding-check-folded-file-function 'folding-check-folded "\
*Function that return t or nil after examining if the file is folded." :type 'function :group 'folding)

(defcustom folding-check-allow-folding-function 'folding-check-if-folding-allowed "\
*Function that return t or nil after deciding if automatic folding." :type 'function :group 'folding)

(defcustom folding-mode-string "Fld" "\
*The minor mode string displayed when mode is on." :type 'string :group 'folding)

(defcustom folding-mode-hook-no-regexp "RMAIL" "\
*Regexp which disable automatic folding mode turn on for certain files." :type 'string :group 'folding)

(defcustom folding-behave-table '((close folding-hide-current-entry) (open folding-show-current-entry) (up folding-shift-out) (other folding-mouse-call-original)) "\
*Table of of logical commands and their associated functions.
If you want fold to behave like `folding-shift-in', when it 'open'
a fold, you just change the function entry in this table.

Table form:
  '( (LOGICAL-ACTION  CMD) (..) ..)" :type '(repeat (symbol :tag "logical action") (function :tag "callback")) :group 'folding)

(defcustom folding-allow-overlays nil "\
*If non-nil use overlay code. If nil, then selective display is used.
Note, that this code is highly experimental and will not most likely do what
you expect. using value t will not change folding to use overlays
completely. This variable was introduced to experiment with the overlay
interface, but the work never finished and it is unlikely that it
will continued any later time. Folding at present state is designed
too highly for selective display to make the change worthwhile." :type 'boolean :group 'folding)

(defcustom folding-isearch-install t "\
*When non-nil, the isearch commands will handle folds." :type 'boolean :group 'folding)

;;;***

;;;### (autoloads (hexl-follow-ascii dehexlify-command hexlify-command hexl-options hexl-iso hexl-program hexl) "hexl" "text-modes/hexl.el")
(defconst custom-define-current-source-file "hexl.el")

(defgroup hexl nil "Edit a file in a hex dump format using the hexl filter." :group 'data)

(defcustom hexl-program "hexl" "\
The program that will hexlify and dehexlify its stdin.
`hexl-program' will always be concatenated with `hexl-options'
and \"-de\" when dehexlifying a buffer." :type 'string :group 'hexl)

(defcustom hexl-iso "" "\
If your emacs can handle ISO characters, this should be set to
\"-iso\" otherwise it should be \"\"." :type 'string :group 'hexl)

(defcustom hexl-options (format "-hex %s" hexl-iso) "\
Options to hexl-program that suit your needs." :type 'string :group 'hexl)

(defcustom hexlify-command (format "%s %s" (shell-quote-argument (expand-file-name hexl-program exec-directory)) hexl-options) "\
The command to use to hexlify a buffer." :type 'string :group 'hexl)

(defcustom dehexlify-command (format "%s -de %s" (shell-quote-argument (expand-file-name hexl-program exec-directory)) hexl-options) "\
The command to use to unhexlify a buffer." :type 'string :group 'hexl)

(defcustom hexl-follow-ascii t "\
If non-nil then highlight the ASCII/HEX character corresponding to point." :type 'boolean :group 'hexl :version "20.3")

;;;***

;;;### (autoloads (htmlize-html-major-mode htmlize-use-rgb-txt htmlize-css-name-prefix htmlize-ignore-face-size htmlize-convert-nonascii-to-entities htmlize-html-charset htmlize-replace-form-feeds htmlize-hyperlink-style htmlize-generate-hyperlinks htmlize-output-type htmlize-head-tags htmlize) "htmlize" "text-modes/htmlize.el")
(defconst custom-define-current-source-file "htmlize.el")

(defgroup htmlize nil "Convert buffer text and faces to HTML." :group 'hypermedia)

(defcustom htmlize-head-tags "" "\
*Additional tags to insert within HEAD of the generated document." :type 'string :group 'htmlize)

(defcustom htmlize-output-type 'css "\
*Output type of generated HTML, one of `css', `inline-css', or `font'.
When set to `css' (the default), htmlize will generate a style sheet
with description of faces, and use it in the HTML document, specifying
the faces in the actual text with <span class=\"FACE\">.

When set to `inline-css', the style will be generated as above, but
placed directly in the STYLE attribute of the span ELEMENT: <span
style=\"STYLE\">.  This makes it easier to paste the resulting HTML to
other documents.

When set to `font', the properties will be set using layout tags
<font>, <b>, <i>, <u>, and <strike>.

`css' output is normally preferred, but `font' is still useful for
supporting old, pre-CSS browsers, and both `inline-css' and `font' for
easier embedding of colorized text in foreign HTML documents (no style
sheet to carry around)." :type '(choice (const css) (const inline-css) (const font)) :group 'htmlize)

(defcustom htmlize-generate-hyperlinks t "\
*Non-nil means generate the hyperlinks for URLs and mail addresses.
This is on by default; set it to nil if you don't want htmlize to
insert hyperlinks in the resulting HTML.  (In which case you can still
do your own hyperlinkification from htmlize-after-hook.)" :type 'boolean :group 'htmlize)

(defcustom htmlize-hyperlink-style "\n      a {\n        color: inherit;\n        background-color: inherit;\n        font: inherit;\n        text-decoration: inherit;\n      }\n      a:hover {\n        text-decoration: underline;\n      }\n" "\
*The CSS style used for hyperlinks when in CSS mode." :type 'string :group 'htmlize)

(defcustom htmlize-replace-form-feeds t "\
*Non-nil means replace form feeds in source code with HTML separators.
Form feeds are the ^L characters at line beginnings that are sometimes
used to separate sections of source code.  If this variable is set to
`t', form feed characters are replaced with the <hr> separator.  If this
is a string, it specifies the replacement to use.  Note that <pre> is
temporarily closed before the separator is inserted, so the default
replacement is effectively \"</pre><hr /><pre>\".  If you specify
another replacement, don't forget to close and reopen the <pre> if you
want the output to remain valid HTML.

If you need more elaborate processing, set this to nil and use
htmlize-after-hook." :type 'boolean :group 'htmlize)

(defcustom htmlize-html-charset nil "\
*The charset declared by the resulting HTML documents.
When non-nil, causes htmlize to insert the following in the HEAD section
of the generated HTML:

  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=CHARSET\">

where CHARSET is the value you've set for htmlize-html-charset.  Valid
charsets are defined by MIME and include strings like \"iso-8859-1\",
\"iso-8859-15\", \"utf-8\", etc.

If you are using non-Latin-1 charsets, you might need to set this for
your documents to render correctly.  Also, the W3C validator requires
submitted HTML documents to declare a charset.  So if you care about
validation, you can use this to prevent the validator from bitching.

Needless to say, if you set this, you should actually make sure that
the buffer is in the encoding you're claiming it is in.  (Under Mule
that is done by ensuring the correct \"file coding system\" for the
buffer.)  If you don't understand what that means, this option is
probably not for you." :type '(choice (const :tag "Unset" nil) string) :group 'htmlize)

(defcustom htmlize-convert-nonascii-to-entities (featurep 'mule) "\
*Whether non-ASCII characters should be converted to HTML entities.

When this is non-nil, characters with codes in the 128-255 range will be
considered Latin 1 and rewritten as \"&#CODE;\".  Characters with codes
above 255 will be converted to \"&#UCS;\", where UCS denotes the Unicode
code point of the character.  If the code point cannot be determined,
the character will be copied unchanged, as would be the case if the
option were nil.

When the option is nil, the non-ASCII characters are copied to HTML
without modification.  In that case, the web server and/or the browser
must be set to understand the encoding that was used when saving the
buffer.  (You might also want to specify it by setting
`htmlize-html-charset'.)

Note that in an HTML entity \"&#CODE;\", CODE is always a UCS code point,
which has nothing to do with the charset the page is in.  For example,
\"&#169;\" *always* refers to the copyright symbol, regardless of charset
specified by the META tag or the charset sent by the HTTP server.  In
other words, \"&#169;\" is exactly equivalent to \"&copy;\".

By default, entity conversion is turned on for Mule-enabled Emacsen and
turned off otherwise.  This is because Mule knows the charset of
non-ASCII characters in the buffer.  A non-Mule Emacs cannot tell
whether a character with code 0xA9 represents Latin 1 copyright symbol,
Latin 2 \"S with caron\", or something else altogether.  Setting this to
t without Mule means asserting that 128-255 characters always mean Latin
1.

For most people htmlize will work fine with this option left at the
default setting; don't change it unless you know what you're doing." :type 'sexp :group 'htmlize)

(defcustom htmlize-ignore-face-size 'absolute "\
*Whether face size should be ignored when generating HTML.
If this is nil, face sizes are used.  If set to t, sizes are ignored
If set to `absolute', only absolute size specifications are ignored.
Please note that font sizes only work with CSS-based output types." :type '(choice (const :tag "Don't ignore" nil) (const :tag "Ignore all" t) (const :tag "Ignore absolute" absolute)) :group 'htmlize)

(defcustom htmlize-css-name-prefix "" "\
*The prefix used for CSS names.
The CSS names that htmlize generates from face names are often too
generic for CSS files; for example, `font-lock-type-face' is transformed
to `type'.  Use this variable to add a prefix to the generated names.
The string \"htmlize-\" is an example of a reasonable prefix." :type 'string :group 'htmlize)

(defcustom htmlize-use-rgb-txt t "\
*Whether `rgb.txt' should be used to convert color names to RGB.

This conversion means determining, for instance, that the color
\"IndianRed\" corresponds to the (205, 92, 92) RGB triple.  `rgb.txt'
is the X color database that maps hundreds of color names to such RGB
triples.  When this variable is non-nil, `htmlize' uses `rgb.txt' to
look up color names.

If this variable is nil, htmlize queries Emacs for RGB components of
colors using `color-instance-rgb-components' and `x-color-values'.
This can yield incorrect results on non-true-color displays.

If the `rgb.txt' file is not found (which will be the case if you're
running Emacs on non-X11 systems), this option is ignored." :type 'boolean :group 'htmlize)

(defcustom htmlize-html-major-mode nil "\
The mode the newly created HTML buffer will be put in.
Set this to nil if you prefer the default (fundamental) mode." :type '(radio (const :tag "No mode (fundamental)" nil) (function-item html-mode) (function :tag "User-defined major mode")) :group 'htmlize)

;;;***

;;;### (autoloads (po-gzip-uuencode-command po-team-name-to-code po-highlight-face po-highlighting po-translation-project-mail-label po-translation-project-address po-default-file-header po-auto-replace-revision-date po-auto-select-on-unfuzzy po-auto-fuzzy-on-edit po-auto-edit-with-msgid po) "po-mode" "text-modes/po-mode.el")
(defconst custom-define-current-source-file "po-mode.el")

(defgroup po nil "Major mode for editing PO files" :group 'i18n)

(defcustom po-auto-edit-with-msgid nil "\
*Automatically use msgid when editing untranslated entries." :type 'boolean :group 'po)

(defcustom po-auto-fuzzy-on-edit nil "\
*Automatically mark entries fuzzy when being edited." :type 'boolean :group 'po)

(defcustom po-auto-select-on-unfuzzy nil "\
*Automatically select some new entry while making an entry not fuzzy." :type 'boolean :group 'po)

(defcustom po-auto-replace-revision-date t "\
*Automatically revise date in headers.  Value is nil, t, or ask." :type '(choice (const nil) (const t) (const ask)) :group 'po)

(defcustom po-default-file-header "# SOME DESCRIPTIVE TITLE.\n# Copyright (C) YEAR Free Software Foundation, Inc.\n# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.\n#\n#, fuzzy\nmsgid \"\"\nmsgstr \"\"\n\"Project-Id-Version: PACKAGE VERSION\\n\"\n\"PO-Revision-Date: YEAR-MO-DA HO:MI +ZONE\\n\"\n\"Last-Translator: FULL NAME <EMAIL@ADDRESS>\\n\"\n\"Language-Team: LANGUAGE <LL@li.org>\\n\"\n\"MIME-Version: 1.0\\n\"\n\"Content-Type: text/plain; charset=CHARSET\\n\"\n\"Content-Transfer-Encoding: 8bit\\n\"\n" "\
*Default PO file header." :type 'string :group 'po)

(defcustom po-translation-project-address "translation@iro.umontreal.ca" "\
*Electronic mail address of the Translation Project.
Typing \\[po-send-mail] (normally bound to `M') the user will send the PO file
to this email address." :type 'string :group 'po)

(defcustom po-translation-project-mail-label "TP-Robot" "\
*Subject label when sending the PO file to `po-translation-project-address'.
Don't change it when you send PO files to \"translation@iro.umontreal.ca\", the
Translation Project Robot at http://www.iro.umontreal.ca/contrib/po/HTML/.  If
the label is different, your submission will be consiedered as a regular mail
and not stored at the TP site and also not forwarded to the package maintainer." :type 'string :group 'po)

(defcustom po-highlighting (or po-EMACS20 po-XEMACS) "\
*Highlight text whenever appropriate, when non-nil.
However, on older Emacses, a yet unexplained highlighting bug causes files
to get mangled." :type 'boolean :group 'po)

(defcustom po-highlight-face 'highlight "\
*The face used for PO mode highlighting.  For Emacses with overlays.
Possible values are 'highlight', 'modeline', 'secondary-selection',
'region', and 'underline'.
This variable can be set by the user to whatever face they desire.
It's most convenient if the cursor color and highlight color are
slightly different." :type 'face :group 'po)

(defcustom po-team-name-to-code '(("LANGUAGE" . "LL") ("(Afan) Oromo" . "om") ("Abkhazian" . "ab") ("Afar" . "aa") ("Afrikaans" . "af") ("Albanian" . "sq") ("Amharic" . "am") ("Arabic" . "ar") ("Argentinian" . "es_AR") ("Armenian" . "hy") ("Assamese" . "as") ("Avestan" . "ae") ("Aymara" . "ay") ("Azerbaijani" . "az") ("Bashkir" . "ba") ("Basque" . "eu") ("Belarusian" . "be") ("Bengali" . "bn") ("Bihari" . "bh") ("Bislama" . "bi") ("Bosnian" . "bs") ("Brazilian Portuguese" . "pt_BR") ("Breton" . "br") ("Bulgarian" . "bg") ("Burmese" . "my") ("Catalan" . "ca") ("Chamorro" . "ch") ("Chechen" . "ce") ("Chinese" . "zh") ("Chinese (simplified)" . "zh_CN") ("Chinese (traditional)" . "zh_TW") ("Church Slavic" . "cu") ("Chuvash" . "cv") ("Cornish" . "kw") ("Corsican" . "co") ("Croatian" . "hr") ("Czech" . "cs") ("Danish" . "da") ("Dutch" . "nl") ("Dzongkha" . "dz") ("English" . "en") ("Esperanto" . "eo") ("Estonian" . "et") ("Faroese" . "fo") ("Fijian" . "fj") ("Finnish" . "fi") ("French" . "fr") ("Frisian" . "fy") ("Galician" . "gl") ("Georgian" . "ka") ("German" . "de") ("Greek" . "el") ("Guarani" . "gn") ("Gujarati" . "gu") ("Hausa" . "ha") ("Hebrew" . "he") ("Herero" . "hz") ("Hindi" . "hi") ("Hiri Motu" . "ho") ("Hungarian" . "hu") ("Icelandic" . "is") ("Ido" . "io") ("Indonesian" . "id") ("Interlingua" . "ia") ("Interlingue" . "ie") ("Inuktitut" . "iu") ("Inupiak" . "ik") ("Irish" . "ga") ("Italian" . "it") ("Japanese" . "ja") ("Javanese" . "jv") ("Kalaallisut" . "kl") ("Kannada" . "kn") ("Kashmiri" . "ks") ("Kazakh" . "kk") ("Khmer" . "km") ("Kikuyu" . "ki") ("Kinyarwanda" . "rw") ("Kirghiz" . "ky") ("Kirundi" . "rn") ("Komi" . "kv") ("Konkani" . "kok") ("Korean" . "ko") ("Kuanyama" . "kj") ("Kurdish" . "ku") ("Laotian" . "lo") ("Latin" . "la") ("Latvian" . "lv") ("Letzeburgesch" . "lb") ("Lingala" . "ln") ("Lithuanian" . "lt") ("Macedonian" . "mk") ("Malagasy" . "mg") ("Malay" . "ms") ("Malayalam" . "ml") ("Maltese" . "mt") ("Manipuri" . "mni") ("Manx" . "gv") ("Maori" . "mi") ("Marathi" . "mr") ("Marshall" . "mh") ("Moldavian" . "mo") ("Mongolian" . "mn") ("Nauru" . "na") ("Navajo" . "nv") ("Ndonga" . "ng") ("Nepali" . "ne") ("North Ndebele" . "nd") ("Northern Sami" . "se") ("Norwegian Bokmal" . "nb") ("Norwegian Nynorsk" . "nn") ("Norwegian" . "no") ("Nyanja" . "ny") ("Occitan" . "oc") ("Oriya" . "or") ("Ossetian" . "os") ("Pali" . "pi") ("Pashto" . "ps") ("Persian" . "fa") ("Polish" . "pl") ("Portuguese" . "pt") ("Punjabi" . "pa") ("Quechua" . "qu") ("Rhaeto-Roman" . "rm") ("Romanian" . "ro") ("Russian" . "ru") ("Samoan" . "sm") ("Sango" . "sg") ("Sanskrit" . "sa") ("Sardinian" . "sc") ("Scots" . "gd") ("Serbian" . "sr") ("Sesotho" . "st") ("Setswana" . "tn") ("Shona" . "sn") ("Sindhi" . "sd") ("Sinhalese" . "si") ("Siswati" . "ss") ("Slovak" . "sk") ("Slovenian" . "sl") ("Somali" . "so") ("Sorbian" . "wen") ("South Ndebele" . "nr") ("Spanish" . "es") ("Sundanese" . "su") ("Swahili" . "sw") ("Swedish" . "sv") ("Tagalog" . "tl") ("Tahitian" . "ty") ("Tajik" . "tg") ("Tamil" . "ta") ("Tatar" . "tt") ("Telugu" . "te") ("Thai" . "th") ("Tibetan" . "bo") ("Tigrinya" . "ti") ("Tonga" . "to") ("Tsonga" . "ts") ("Turkish" . "tr") ("Turkmen" . "tk") ("Twi" . "tw") ("Uighur" . "ug") ("Ukrainian" . "uk") ("Urdu" . "ur") ("Uzbek" . "uz") ("Vietnamese" . "vi") ("Volapuk" . "vo") ("Walloon" . "wa") ("Welsh" . "cy") ("Wolof" . "wo") ("Xhosa" . "xh") ("Yiddish" . "yi") ("Yoruba" . "yo") ("Zhuang" . "za") ("Zulu" . "zu")) "\
*Association list giving team codes from team names.
This is used for generating a submission file name for the 'M' command.
If a string instead of an alist, it is a team code to use unconditionnally." :type 'sexp :group 'po)

(defcustom po-gzip-uuencode-command "gzip -9 | uuencode -m" "\
*The filter to use for preparing a mail invoice of the PO file.
Normally \"gzip -9 | uuencode -m\", remove the -9 for lesser compression,
or remove the -m if you are not using the GNU version of 'uuencode'." :type 'string :group 'po)

;;;***

;;;### (autoloads (rtf-default-colour-table rtf-create-colours rtf-gen-ruler-p rtf-untabify-p rtf) "rtf-support" "text-modes/rtf-support.el")
(defconst custom-define-current-source-file "rtf-support.el")

(defgroup rtf nil "Support RTF selections and spooling of RTF to a buffer." :group 'wp :tag "RTF")

(defcustom rtf-untabify-p t "\
Set this to t to untabify the text before changing it to RTF." :type 'boolean :group 'rtf)

(defcustom rtf-gen-ruler-p nil "\
Set this to t to generate a set of RTF tabstops.
This is intended for RTF readers that cannot handle character-based tabs
properly (e.g. Microsoft Word). Note that this feature uses on-screen
character metrics, so tabstops generated like this tend to be somewhat
inaccurate.  It is usually better to untabify the text by setting
`rtf-untabify-p' rather than using this feature." :type 'boolean :group 'rtf)

(defcustom rtf-create-colours nil "\
Non-nil causes RTF output to contain new colours.
This is for compatibility with RTF readers that do not expect anything
but the standard set of colours (e.g. Microsoft Word prior to Word 2000).
If new colours are not being created, face colours are best-matched with
those in the default colour table `rtf-default-colour-table' using a
Euclidean distance metric." :type 'boolean :group 'rtf)

(defcustom rtf-default-colour-table '((nil . 0) ((0 0 0) . 1) ((0 0 255) . 2) ((0 255 255) . 3) ((0 255 0) . 4) ((255 0 255) . 5) ((255 0 0) . 6) ((255 255 0) . 7) ((255 255 255) . 8) ((0 0 128) . 9) ((0 128 128) . 10) ((0 128 0) . 11) ((128 0 128) . 12) ((128 0 0) . 13) ((128 128 0) . 14) ((128 128 128) . 15) ((192 192 192) . 16)) "\
The default colour table to use in RTF output.
This is the palette of colours that is used when rtf-create-colours is nil;
by default it matches the standard set used in Microsoft Word.

It is only used when `rtf-create-colours' is nil, in which case Emacs face
colours are matched with available palette colours by minimising the
Euclidean distance between the selected palette colour and the face colour.

Ideally, the indices should be unique, although that isn't enforced here
because it's possible that someone might find a use for non-unique indices
\(in conjunction with the various broken programs that are about)." :type '(repeat rtf-color-table-entry) :group 'rtf)

;;;***

;;;### (autoloads (scribe-electric-parenthesis scribe-electric-quote scribe-fancy-paragraphs scribe) "scribe" "text-modes/scribe.el")
(defconst custom-define-current-source-file "scribe.el")

(defgroup scribe nil "Scribe mode, and its idiosyncratic commands." :group 'wp)

(defcustom scribe-fancy-paragraphs nil "\
*Non-NIL makes Scribe mode use a different style of paragraph separation." :type 'boolean :group 'scribe)

(defcustom scribe-electric-quote nil "\
*Non-NIL makes insert of double quote use `` or '' depending on context." :type 'boolean :group 'scribe)

(defcustom scribe-electric-parenthesis nil "\
*Non-NIL makes parenthesis char ( (]}> ) automatically insert its close
if typed after an @Command form." :type 'boolean :group 'scribe)

;;;***

;;;### (autoloads (tpum-load-hook tpum-search-ahead-mode tpum-max-height tpum-cstyle tpum-truncate-lines tpum-isearch-global-scope tpum-auto-submenu-mode tpum-menu-type tpum-faces tpum-global-mode tpum) "tpum" "text-modes/tpum.el")
(defconst custom-define-current-source-file "tpum.el")

(defgroup tpum nil "Popup menus in text mode." :prefix "tpum-" :group 'environment)

(defcustom tpum-global-mode nil "\
*Non-nil mean tpum is enabled globally." :type 'boolean :group 'tpum)

(defgroup tpum-faces nil "Faces used in tpum." :prefix "tpum-" :group 'tpum :group 'faces)

(defcustom tpum-menu-type 'inline "\
Type of `popup-menu' behaviour.
'inline - To inline in current buffer.
'frame  - To pop Emacs frame." :type '(choice (const :tag "Inline" inline) (const :tag "Frame" frame)) :group 'tpum)

(defcustom tpum-auto-submenu-mode nil "\
*Non-nil mean auto opening submenus at point." :type 'boolean :group 'tpum)

(defcustom tpum-isearch-global-scope t "\
*Non-nil mean that isearch will be performed in any shown tpums." :type 'boolean :group 'tpum)

(defcustom tpum-truncate-lines nil "\
*Value of `truncate-lines' while in `tpum-mode'." :type 'boolean :group 'tpum)

(defcustom tpum-cstyle 'tpum-style-plain "\
*Style to be used." :type 'symbol :group 'tpum)

(defcustom tpum-max-height 80 "\
*Maximum height of popup menu." :type 'number :group 'tpum)

(defcustom tpum-search-ahead-mode t "\
*Non-nil mean to use type ahead search mode." :type 'boolean :group 'tpum)

(defcustom tpum-load-hook nil "\
*Hooks to run after tpum loaded." :type 'hook :group 'tpum)

;;;***

;;;### (autoloads (old-whitespace-blank-search-string old-whitespace-tab-search-string old-whitespace-blank-and-tab-search-string old-whitespace-toolbar-function old-whitespace-install-submenu old-whitespace-install-toolbar-icon old-whitespace-incremental-mode-hook old-whitespace-mode-hook old-whitespace-chars old-whitespace-incremental-mode-line-string old-whitespace-mode-line-string old-whitespace-mode old-whitespace) "whitespace-mode" "text-modes/whitespace-mode.el")
(defconst custom-define-current-source-file "whitespace-mode.el")

(defgroup old-whitespace nil "Minor mode for making whitespace visible" :group 'outlines :group 'matching)

(defcustom old-whitespace-mode nil "\
Non-nil, if the `old-whitespace-mode' is active." :type 'boolean :set (lambda (symbol value) (old-whitespace-mode (or value 0))) :require 'whitespace-mode :initialize 'custom-initialize-default :group 'old-whitespace)

(defcustom old-whitespace-mode-line-string " WSP" "\
*String displayed on the modeline when old-whitespace-mode is active.
Set this to nil if you don't want a modeline indicator." :group 'old-whitespace :type 'string)

(defcustom old-whitespace-incremental-mode-line-string " WSPI" "\
*String displayed on the modeline when old-whitespace-incremental-mode
is active. Set this to nil if you don't want a modeline indicator." :group 'old-whitespace :type 'string)

(defcustom old-whitespace-chars 'tabs-and-blanks "\
*Determines, which whitespaces are highlighted.
Valid values are:
'tabs-and-blanks => tabs and blanks are highlighted;
'tabs            => only tabs are highlighted;
'blanks          => only blanks are highlighted;.

Changing this variable during the old-whitespace-*-mode is active could lead
to wrong highlighted whitespaces." :type '(radio (const tabs-and-blanks) (const tabs) (const blanks)) :group 'old-whitespace)

(defcustom old-whitespace-mode-hook nil "\
*Run after the `old-whitespace-mode' is switched on." :type 'hook :group 'old-whitespace)

(defcustom old-whitespace-incremental-mode-hook nil "\
*Run after the `old-whitespace-incremental-mode' is switched on." :type 'hook :group 'old-whitespace)

(defcustom old-whitespace-install-toolbar-icon nil "\
Set it to t, if a toolbar icon should be installed during loading this file.
The icon calls the function 'old-whitespace-toolbar-function'." :type 'boolean :group 'old-whitespace)

(defcustom old-whitespace-install-submenu nil "\
Set it to t, if a submenu should be installed during loading this file." :type 'boolean :group 'old-whitespace)

(defcustom old-whitespace-toolbar-function 'old-whitespace-incremental-mode "\
*The toolbar icon for the whitespace mode calls this function.
Valid values are: 'old-whitespace--mode and 'old-whitespace-incremental-mode." :type 'function :group 'old-whitespace)

(defcustom old-whitespace-blank-and-tab-search-string "\\( \\)\\|\\(	\\)" "\
The regexp used to search for tabs and blanks." :type 'regexp :group 'old-whitespace)

(defcustom old-whitespace-tab-search-string "	" "\
The search string used to find tabs." :type 'string :group 'old-whitespace)

(defcustom old-whitespace-blank-search-string " " "\
The search string used to find blanks." :type 'string :group 'old-whitespace)

;;;***

;;;### (autoloads (whitespace-visual-blank-search-string whitespace-visual-tab-search-string whitespace-visual-blank-and-tab-search-string whitespace-visual-toolbar-function whitespace-visual-install-submenu whitespace-visual-install-toolbar-icon whitespace-visual-incremental-mode-hook whitespace-visual-mode-hook whitespace-visual-chars whitespace-visual-incremental-mode-line-string whitespace-visual-mode-line-string whitespace-visual-mode whitespace-visual) "whitespace-visual-mode" "text-modes/whitespace-visual-mode.el")
(defconst custom-define-current-source-file "whitespace-visual-mode.el")

(defgroup whitespace-visual nil "Minor mode for making whitespaces visible" :group 'outlines :group 'matching)

(defcustom whitespace-visual-mode nil "\
Non-nil, if the `whitespace-visual-mode' is active." :type 'boolean :set (lambda (symbol value) (whitespace-visual-mode (or value 0))) :require 'whitespace-visual-mode :initialize 'custom-initialize-default :group 'whitespace-visual)

(defcustom whitespace-visual-mode-line-string " WSP" "\
*String displayed on the modeline when whitespace-visual-mode is active.
Set this to nil if you don't want a modeline indicator." :group 'whitespace-visual :type 'string)

(defcustom whitespace-visual-incremental-mode-line-string " WSPI" "\
*String displayed on the modeline when whitespace-visual-incremental-mode
is active. Set this to nil if you don't want a modeline indicator." :group 'whitespace-visual :type 'string)

(defcustom whitespace-visual-chars 'tabs-and-blanks "\
*Determines, which whitespaces are highlighted.
Valid values are:
'tabs-and-blanks => tabs and blanks are highlighted;
'tabs            => only tabs are highlighted;
'blanks          => only blanks are highlighted;.

Changing this variable during the whitespace-visual-*-mode is active could lead
to wrong highlighted whitespaces." :type '(radio (const tabs-and-blanks) (const tabs) (const blanks)) :group 'whitespace-visual)

(defcustom whitespace-visual-mode-hook nil "\
*Run after the `whitespace-visual-mode' is switched on." :type 'hook :group 'whitespace-visual)

(defcustom whitespace-visual-incremental-mode-hook nil "\
*Run after the `whitespace-visual-incremental-mode' is switched on." :type 'hook :group 'whitespace-visual)

(defcustom whitespace-visual-install-toolbar-icon nil "\
Set it to t, if a toolbar icon should be installed during loading this file.
The icon calls the function 'whitespace-visual-toolbar-function'." :type 'boolean :group 'whitespace-visual)

(defcustom whitespace-visual-install-submenu nil "\
Set it to t, if a submenu should be installed during loading this file." :type 'boolean :group 'whitespace-visual)

(defcustom whitespace-visual-toolbar-function 'whitespace-visual-incremental-mode "\
*The toolbar icon for the whitespace visual mode calls this function.
Valid values are: 
 'whitespace-visual--mode and 'whitespace-visual-incremental-mode." :type 'function :group 'whitespace-visual)

(defcustom whitespace-visual-blank-and-tab-search-string "\\( \\)\\|\\(	\\)" "\
The regexp used to search for tabs and blanks." :type 'regexp :group 'whitespace-visual)

(defcustom whitespace-visual-tab-search-string "	" "\
The search string used to find tabs." :type 'string :group 'whitespace-visual)

(defcustom whitespace-visual-blank-search-string " " "\
The search string used to find blanks." :type 'string :group 'whitespace-visual)

;;;***

;;;### (autoloads (whitespace-faces whitespace-display-spaces-in-color whitespace-display-in-modeline whitespace-rescan-timer-time whitespace-modes whitespace-files whitespace-silent whitespace-auto-cleanup whitespace-abort-on-error whitespace-errbuf whitespace-ateol-regexp whitespace-check-ateol-whitespace whitespace-indent-regexp whitespace-check-indent-whitespace whitespace-spacetab-regexp whitespace-check-spacetab-whitespace whitespace-check-trailing-whitespace whitespace-check-leading-whitespace) "whitespace" "text-modes/whitespace.el")
(defconst custom-define-current-source-file "whitespace.el")

(defcustom whitespace-check-leading-whitespace t "\
Flag to check leading whitespace. This is the global for the system.
It can be overriden by setting a buffer local variable
`whitespace-check-buffer-leading'" :type 'boolean :group 'whitespace)

(defcustom whitespace-check-trailing-whitespace t "\
Flag to check trailing whitespace. This is the global for the system.
It can be overriden by setting a buffer local variable
`whitespace-check-buffer-trailing'" :type 'boolean :group 'whitespace)

(defcustom whitespace-check-spacetab-whitespace t "\
Flag to check space followed by a TAB. This is the global for the system.
It can be overriden by setting a buffer local variable
`whitespace-check-buffer-spacetab'" :type 'boolean :group 'whitespace)

(defcustom whitespace-spacetab-regexp "[ ]+	" "\
Regexp to match a space followed by a TAB." :type 'regexp :group 'whitespace)

(defcustom whitespace-check-indent-whitespace indent-tabs-mode "\
Flag to check indentation whitespace. This is the global for the system.
It can be overriden by setting a buffer local variable
`whitespace-check-buffer-indent'" :type 'boolean :group 'whitespace)

(defcustom whitespace-indent-regexp (concat "^\\(	*\\)    " "    ") "\
Regexp to match (any TABS followed by) 8/more whitespaces at start of line." :type 'regexp :group 'whitespace)

(defcustom whitespace-check-ateol-whitespace t "\
Flag to check end-of-line whitespace. This is the global for the system.
It can be overriden by setting a buffer local variable
`whitespace-check-buffer-ateol'" :type 'boolean :group 'whitespace)

(defcustom whitespace-ateol-regexp "[ 	]+$" "\
Regexp to match a TAB or a space at the EOL." :type 'regexp :group 'whitespace)

(defcustom whitespace-errbuf "*Whitespace Errors*" "\
The name of the buffer where whitespace related messages will be logged." :type 'string :group 'whitespace)

(defcustom whitespace-abort-on-error nil "\
While writing a file, abort if the file is unclean. If
`whitespace-auto-cleanup' is set, that takes precedence over this
variable." :type 'boolean :group 'whitespace)

(defcustom whitespace-auto-cleanup nil "\
Cleanup a buffer automatically on finding it whitespace unclean." :type 'boolean :group 'whitespace)

(defcustom whitespace-silent nil "\
All whitespace errors will be shown only in the modeline when t.

Note that setting this may cause all whitespaces introduced in a file to go
unnoticed when the buffer is killed, unless the user visits the `*Whitespace
Errors*' buffer before opening (or closing) another file." :type 'boolean :group 'whitespace)

(defcustom whitespace-files nil "\
Files in which we turn on whitespace checking.

Each entry is either a regexp matching the file name,
or looks like (REGEXP CHECK t|nil ...).
CHECK is one of 'leading, 'trailing, 'indent, 'spacetab or 'ateol.
Checks not specified will inherit from the default value.

See also `whitespace-check-whitespace-mode'." :type (backquote (repeat (choice (regexp :tag "File Name Matching") (group :value ("") (regexp :tag "File Name Matching") (\, whitespace-checks-custom-type))))) :group 'whitespace)

(defcustom whitespace-modes '(ada-mode asm-mode autoconf-mode awk-mode c-mode c++-mode cc-mode change-log-mode cperl-mode electric-nroff-mode emacs-lisp-mode f90-mode fortran-mode html-mode html3-mode java-mode jde-mode ksh-mode latex-mode LaTeX-mode lisp-mode m4-mode makefile-mode modula-2-mode nroff-mode objc-mode pascal-mode perl-mode prolog-mode python-mode scheme-mode sgml-mode sh-mode shell-script-mode simula-mode tcl-mode tex-mode (texinfo-mode indent nil spacetab nil) vrml-mode xml-mode) "\
Major Modes in which we turn on whitespace checking.

Each entry is either a symbol corresponding to a major mode,
or looks like (SYMBOL CHECK t|nil ...).
CHECK is one of 'leading, 'trailing, 'indent, 'spacetab or 'ateol.
Checks not specified will inherit from the default value.

See also `whitespace-check-whitespace-mode'." :type (backquote (repeat (choice (symbol :tag "Major Mode") (group :value (fundamental) (symbol :tag "Major Mode") (\, whitespace-checks-custom-type))))) :group 'whitespace)

(defcustom whitespace-rescan-timer-time 600 "\
Period in seconds to rescan modified buffers for whitespace creep.

This is the period after which the timer will fire causing
`whitespace-rescan-files-in-buffers' to check for whitespace creep in
modified buffers.

To disable timer scans, set this to zero." :type 'integer :group 'whitespace)

(defcustom whitespace-display-in-modeline t "\
Display whitespace errors on the modeline." :type 'boolean :group 'whitespace)

(defcustom whitespace-display-spaces-in-color t "\
Display the bogus whitespaces by coloring them with
`whitespace-highlight-face'." :type 'boolean :group 'whitespace)

(defgroup whitespace-faces nil "Faces used in whitespace." :prefix "whitespace-" :group 'whitespace :group 'faces)

;;;***

;;;### (autoloads (winmgr-mode-hook winmgr-basic-offset winmgr) "winmgr-mode" "text-modes/winmgr-mode.el")
(defconst custom-define-current-source-file "winmgr-mode.el")

(defgroup winmgr nil "Generic window manager mode." :tag "Window Managers" :group 'languages)

(defcustom winmgr-basic-offset 4 "\
*Number of spaces per indentation level." :type 'integer :group 'winmgr)

(defcustom winmgr-mode-hook nil "\
Hook to be run when `winmgr-mode' is entered." :type 'hook :group 'winmgr)

;;;***

;;;### (autoloads (xrdb-program-args xrdb-program xrdb-compress-whitespace xrdb-subdivide-by xrdb-mode-hook xrdb) "xrdb-mode" "text-modes/xrdb-mode.el")
(defconst custom-define-current-source-file "xrdb-mode.el")

(defgroup xrdb nil "Support for editing X resource database files" :group 'languages)

(defcustom xrdb-mode-hook nil "\
*Hook to be run when `xrdb-mode' is entered." :type 'hook :group 'xrdb)

(defcustom xrdb-subdivide-by 'paragraph "\
*Default alignment subdivision when re-indenting a region or buffer.
This variable controls how much of the buffer is searched to find a
goal column on which to align.  Every non-comment line in the region
defined by this variable is scanned for the first `:' character on the 
line, and this character's column is the line's goal column.  The
rightmost line goal column in the region is taken as the region's goal 
column.

This variable can take one of the following symbol values:

 `buffer'    - All lines in the buffer are scanned.  This is the
               slowest option. 

 `paragraph' - All lines in the paragraph are scanned.  Paragraphs
               are delimited by blank lines, comment lines, and page
               delimiters.

 `page'      - All lines in the page are scanned.  Pages are delimited 
               with `page-delimiter', usually ^L (control-L).

 `line'      - Only the previous non-comment line is scanned.  This is
               the fastest method.

This variable is used by the various indentation commands, and can be
overridden in those commands by using \\[universal-argument]." :type '(radio (const :tag "Do not subdivide buffer" buffer) (const :tag "Subdivide by paragraphs" paragraph) (const :tag "Subdivide by pages" page) (const :tag "Each line is independent" line)) :group 'xrdb)

(defcustom xrdb-compress-whitespace nil "\
*Collapse all whitespace to a single space after insertion of `:'." :type 'boolean :group 'xrdb)

(defcustom xrdb-program "xrdb" "\
*Program to run to load or merge resources in the X resource database." :type 'string :group 'xrdb)

(defcustom xrdb-program-args '("-merge") "\
*List of string arguments to pass to `xrdb-program'." :type '(repeat string) :group 'xrdb)

;;;***

(provide 'text-modes-custom-defines)
