;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'textools-custom-defines) (error "Feature textools-custom-defines already loaded"))

;;;### (autoloads (bibtex-comma-after-last-field bibtex-align-at-equal-sign bibtex-contline-indentation bibtex-text-indentation bibtex-field-indentation bibtex-entry-offset bibtex-autokey-before-presentation-function bibtex-autokey-edit-before-use bibtex-autokey-year-title-separator bibtex-autokey-name-year-separator bibtex-autokey-titleword-separator bibtex-autokey-titleword-length bibtex-autokey-titleword-change-strings bibtex-autokey-titleword-abbrevs bibtex-autokey-titleword-case-convert bibtex-autokey-titleword-ignore bibtex-autokey-titlewords-stretch bibtex-autokey-title-terminators bibtex-autokey-titlewords bibtex-autokey-year-use-crossref-entry bibtex-autokey-year-length bibtex-autokey-name-separator bibtex-autokey-name-length bibtex-autokey-name-case-convert bibtex-autokey-name-change-strings bibtex-autokey-additional-names bibtex-autokey-names-stretch bibtex-autokey-names bibtex-autokey-prefix-string bibtex-help-message bibtex-string-files bibtex-predefined-strings bibtex-predefined-month-strings bibtex-add-entry-hook bibtex-parse-keys-timeout bibtex-entry-kill-ring-max bibtex-field-kill-ring-max bibtex-maintain-sorted-entries bibtex-sort-ignore-string-entries bibtex-clean-entry-hook bibtex-entry-format bibtex-user-optional-fields bibtex-include-OPTkey bibtex-include-OPTcrossref bibtex-entry-delimiters bibtex-field-delimiters bibtex-mode-hook bibtex-autokey bibtex) "bibtex" "textools/bibtex.el")
(defconst custom-define-current-source-file "bibtex.el")

(defgroup bibtex nil "BibTeX mode." :group 'tex :prefix "bibtex-")

(defgroup bibtex-autokey nil "Generates automatically a key from the author/editor and the title field" :group 'bibtex :prefix "bibtex-autokey-")

(defcustom bibtex-mode-hook nil "\
List of functions to call on entry to BibTeX mode." :group 'bibtex :type 'hook)

(defcustom bibtex-field-delimiters 'braces "\
*Controls type of field delimiters used.
Set this to `braces' or `double-quotes' according to your personal
preferences.  This variable is buffer-local." :group 'bibtex :type '(choice (const braces) (const double-quotes)))

(defcustom bibtex-entry-delimiters 'braces "\
*Controls type of entry delimiters used.
Set this to `braces' or `parentheses' according to your personal
preferences.  This variable is buffer-local." :group 'bibtex :type '(choice (const braces) (const parentheses)))

(defcustom bibtex-include-OPTcrossref '("InProceedings" "InCollection") "\
*All entries listed here will have an OPTcrossref field." :group 'bibtex :type '(repeat string))

(defcustom bibtex-include-OPTkey t "\
*If non-nil, all entries will have an OPTkey field.
If this is a string, it will be used as the initial field text.
If this is a function, it will be called to generate the initial field text." :group 'bibtex :type '(choice (const :tag "None" nil) (const :tag "Default" t) (string :tag "Initial text") (function :tag "Initialize Function" :value fun)))

(defcustom bibtex-user-optional-fields '(("annote" "Personal annotation (ignored)")) "\
*List of optional fields the user wants to have always present.
Entries should be of the same form as the OPTIONAL and
CROSSREF-OPTIONAL lists in `bibtex-entry-field-alist' (see documentation
of this variable for details)." :group 'bibtex :type '(repeat (group (string :tag "Field") (string :tag "Comment") (option (group :inline t :extra-offset -4 (choice :tag "Init" :value "" string function))))))

(defcustom bibtex-entry-format '(opts-or-alts numerical-fields) "\
*Controls type of formatting performed by `bibtex-clean-entry'.
It may be t, nil, or a list of symbols out of the following: 
opts-or-alts        Delete empty optional and alternative fields and
                      remove OPT and ALT prefixes from used fields.
numerical-fields    Delete delimiters around numeral fields.
page-dashes         Change double dashes in page field to single dash
                      (for scribe compatibility).
inherit-booktitle   If entry contains a crossref field and booktitle
                      field is empty, it is set to the contents of the
                      title field of the crossreferenced entry.
                      Caution: this will work only if buffer is
                       correctly sorted.
realign             Realign entries, so that field texts and perhaps equal
                      signs (depending on the value of
                      bibtex-align-at-equal-sign) begin in the same column.
last-comma          Add or delete comma on end of last field in entry,
                      according to value of `bibtex-comma-after-last-field'.
delimiters          Change delimiters according to variables
                      `bibtex-field-delimiters' and `bibtex-entry-delimiters'.
unify-case          Change case of entry and field names.

The value t means do all of the above formatting actions.
The value nil means do no formatting at all." :group 'bibtex :type '(choice (const :tag "None" nil) (const :tag "All" t) (set :menu-tag "Some" (const opts-or-alts) (const numerical-fields) (const page-dashes) (const inherit-booktitle) (const realign) (const last-comma) (const delimiters) (const unify-case))))

(defcustom bibtex-clean-entry-hook nil "\
*List of functions to call when entry has been cleaned.
Functions are called with point inside the cleaned entry, and the buffer
narrowed to just the entry." :group 'bibtex :type 'hook)

(defcustom bibtex-sort-ignore-string-entries t "\
*If non-nil, BibTeX @String entries are not sort-significant.
That means they are ignored when determining ordering of the buffer
\(e.g. sorting, locating alphabetical position for new entries, etc.).
This variable is buffer-local." :group 'bibtex :type 'boolean)

(defcustom bibtex-maintain-sorted-entries nil "\
*If non-nil, BibTeX mode maintains all BibTeX entries in sorted order.
Setting this variable to nil will strip off some comfort (e.g. TAB
completion for reference keys in minibuffer, automatic detection of
duplicates) from BibTeX mode.  See also `bibtex-sort-ignore-string-entries'.
This variable is buffer-local." :group 'bibtex :type 'boolean)

(defcustom bibtex-field-kill-ring-max 20 "\
*Max length of `bibtex-field-kill-ring' before discarding oldest elements." :group 'bibtex :type 'integer)

(defcustom bibtex-entry-kill-ring-max 20 "\
*Max length of `bibtex-entry-kill-ring' before discarding oldest elements." :group 'bibtex :type 'integer)

(defcustom bibtex-parse-keys-timeout 60 "\
*Specifies interval for parsing buffers.
All BibTeX buffers in emacs are parsed if emacs has been idle
`bibtex-parse-keys-timeout' seconds.  Only buffers which were modified
after last parsing and which are maintained in sorted order are parsed." :group 'bibtex :type 'integer)

(defcustom bibtex-add-entry-hook nil "\
List of functions to call when entry has been inserted." :group 'bibtex :type 'hook)

(defcustom bibtex-predefined-month-strings '(("jan") ("feb") ("mar") ("apr") ("may") ("jun") ("jul") ("aug") ("sep") ("oct") ("nov") ("dec")) "\
Alist of month string definitions.
Should contain all strings used for months in the BibTeX style files.
Each element is a list with just one element: the string." :group 'bibtex :type '(repeat (list string)))

(defcustom bibtex-predefined-strings (append bibtex-predefined-month-strings '(("acmcs") ("acta") ("cacm") ("ibmjrd") ("ibmsj") ("ieeese") ("ieeetc") ("ieeetcad") ("ipl") ("jacm") ("jcss") ("scp") ("sicomp") ("tcs") ("tocs") ("tods") ("tog") ("toms") ("toois") ("toplas"))) "\
Alist of string definitions.
Should contain the strings defined in the BibTeX style files.  Each
element is a list with just one element: the string." :group 'bibtex :type '(repeat (list string)))

(defcustom bibtex-string-files nil "\
*List of BibTeX files containing string definitions.
Those files must be specified using pathnames relative to the
directories specified in `bibtex-string-file-path'.  This variable is only
evaluated when BibTeX mode is entered (i. e. when loading the BibTeX
file)." :group 'bibtex :type '(repeat file))

(defcustom bibtex-help-message t "\
*If not nil print help messages in the echo area on entering a new field." :group 'bibtex :type 'boolean)

(defcustom bibtex-autokey-prefix-string "" "\
*String to use as a prefix for all generated keys.
See the documentation of function `bibtex-generate-autokey' for more detail." :group 'bibtex-autokey :type 'string)

(defcustom bibtex-autokey-names 1 "\
*Number of names to use for the automatically generated reference key.
If this is variable is nil, all names are used.
Possibly more names are used according to `bibtex-autokey-names-stretch'.
See the documentation of function `bibtex-generate-autokey' for more detail." :group 'bibtex-autokey :type '(choice (const :tag "All" infty) integer))

(defcustom bibtex-autokey-names-stretch 0 "\
*Number of names that can additionally be used.
These names are used only, if all names are used then.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'integer)

(defcustom bibtex-autokey-additional-names "" "\
*String to prepend to the generated key if not all names could be used.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'string)

(defcustom bibtex-autokey-name-change-strings bibtex-autokey-transcriptions "\
Alist of (OLD-REGEXP NEW-STRING) pairs.
Any part of name matching a OLD-REGEXP is replaced by NEW-STRING.
Case is significant in OLD-REGEXP.  All regexps are tried in the
order in which they appear in the list, so be sure to avoid inifinite
loops here.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type '(repeat (list (regexp :tag "Old") (string :tag "New"))))

(defcustom bibtex-autokey-name-case-convert 'downcase "\
*Function called for each name to perform case conversion.
See the documentation of function `bibtex-generate-autokey' for more detail." :group 'bibtex-autokey :type '(choice (const :tag "Preserve case" identity) (const :tag "Downcase" downcase) (const :tag "Capitalize" capitalize) (const :tag "Upcase" upcase) (function :tag "Conversion function")))

(defcustom bibtex-autokey-name-length 'infty "\
*Number of characters from name to incorporate into key.
If this is set to anything but a number, all characters are used.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type '(choice (const :tag "All" infty) integer))

(defcustom bibtex-autokey-name-separator "" "\
*String that comes between any two names in the key.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'string)

(defcustom bibtex-autokey-year-length 2 "\
*Number of rightmost digits from the year field yo incorporate into key.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'integer)

(defcustom bibtex-autokey-year-use-crossref-entry t "\
*If non-nil use year field from crossreferenced entry if necessary.
If this variable is non-nil and the current entry has no year, but a
valid crossref entry, the year field from the crossreferenced entry is
used.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'boolean)

(defcustom bibtex-autokey-titlewords 5 "\
*Number of title words to use for the automatically generated reference key.
If this is set to anything but a number, all title words are used.
Possibly more words from the title are used according to
`bibtex-autokey-titlewords-stretch'.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type '(choice (const :tag "All" infty) integer))

(defcustom bibtex-autokey-title-terminators '("\\." "!" "\\?" ":" ";" "--") "\
*Regexp list defining the termination of the main part of the title.
Case of the regexps is ignored.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type '(repeat regexp))

(defcustom bibtex-autokey-titlewords-stretch 2 "\
*Number of words that can additionally be used from the title.
These words are used only, if a sentence from the title can be ended then.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'integer)

(defcustom bibtex-autokey-titleword-ignore '("A" "An" "On" "The" "Eine?" "Der" "Die" "Das" "[^A-Z].*" ".*[^a-zA-Z0-9].*") "\
*Determines words from the title that are not to be used in the key.
Each item of the list is a regexp.  If a word of the title matches a
regexp from that list, it is not included in the title part of the key.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type '(repeat regexp))

(defcustom bibtex-autokey-titleword-case-convert 'downcase "\
*Function called for each titleword to perform case conversion.
See the documentation of function `bibtex-generate-autokey' for more detail." :group 'bibtex-autokey :type '(choice (const :tag "Preserve case" identity) (const :tag "Downcase" downcase) (const :tag "Capitalize" capitalize) (const :tag "Upcase" upcase) (function :tag "Conversion function")))

(defcustom bibtex-autokey-titleword-abbrevs nil "\
*Determines exceptions to the usual abbreviation mechanism.
An alist of (OLD-REGEXP NEW-STRING) pairs.  Case is ignored
in matching against OLD-REGEXP, and the first matching pair is used.
See the documentation of function `bibtex-generate-autokey' for details.")

(defcustom bibtex-autokey-titleword-change-strings bibtex-autokey-transcriptions "\
Alist of (OLD-REGEXP NEW-STRING) pairs.
Any part of title word matching a OLD-REGEXP is replaced by NEW-STRING.
Case is significant in OLD-REGEXP.  All regexps are tried in the
order in which they appear in the list, so be sure to avoid inifinite
loops here.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type '(repeat (list (regexp :tag "Old") (string :tag "New"))))

(defcustom bibtex-autokey-titleword-length 5 "\
*Number of characters from title words to incorporate into key.
If this is set to anything but a number, all characters are used.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type '(choice (const :tag "All" infty) integer))

(defcustom bibtex-autokey-titleword-separator "_" "\
*String to be put between the title words.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'string)

(defcustom bibtex-autokey-name-year-separator "" "\
*String to be put between name part and year part of key.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'string)

(defcustom bibtex-autokey-year-title-separator ":_" "\
*String to be put between name part and year part of key.
See the documentation of function `bibtex-generate-autokey' for details." :group 'bibtex-autokey :type 'string)

(defcustom bibtex-autokey-edit-before-use t "\
*If non-nil, user is allowed to edit the generated key before it is used." :group 'bibtex-autokey :type 'boolean)

(defcustom bibtex-autokey-before-presentation-function nil "\
Function to call before the generated key is presented.
If non-nil this should be a single function, which is called before
the generated key is presented (in entry or, if
`bibtex-autokey-edit-before-use' is t, in minibuffer). This function
must take one argument (the automatically generated key), and must
return with a string (the key to use)." :group 'bibtex-autokey :type 'function)

(defcustom bibtex-entry-offset 0 "\
*Offset for BibTeX entries.
Added to the value of all other variables which determine colums." :group 'bibtex :type 'integer)

(defcustom bibtex-field-indentation 2 "\
*Starting column for the name part in BibTeX fields." :group 'bibtex :type 'integer)

(defcustom bibtex-text-indentation (+ bibtex-field-indentation (length "organization = ")) "\
*Starting column for the text part in BibTeX fields.
Should be equal to the space needed for the longest name part." :group 'bibtex :type 'integer)

(defcustom bibtex-contline-indentation (+ bibtex-text-indentation 1) "\
*Starting column for continuation lines of BibTeX fields." :group 'bibtex :type 'integer)

(defcustom bibtex-align-at-equal-sign nil "\
*If non-nil, align fields at equal sign instead of field text.
If non-nil, the column for the equal sign is
the value of `bibtex-text-indentation', minus 2." :group 'bibtex :type 'boolean)

(defcustom bibtex-comma-after-last-field nil "\
*If non-nil, a comma is put at end of last field in the entry template." :group 'bibtex :type 'boolean)

;;;***

(provide 'textools-custom-defines)
