;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'time-custom-defines) (error "Feature time-custom-defines already loaded"))

;;;### (autoloads (display-time-form-list display-time-compatible display-time-load-list display-time-mail-balloon-suppress-gnus-group display-time-mail-balloon-enhance-gnus-group display-time-mail-balloon-suppress display-time-mail-balloon-enhance display-time-mail-balloon-gnus-split-width display-time-mail-balloon-subject-width display-time-mail-balloon-from-width display-time-mail-balloon-max-displayed display-time-mail-balloon-show-gnus-group display-time-no-mail-balloon display-time-mail-balloon display-time-display-time-background display-time-display-time-foreground display-time-display-pad display-time-no-mail-sign-string display-time-mail-sign-string display-time-show-icons-maybe display-time-ignore-read-mail display-time-hook display-time-echo-area display-time-24hr-format display-time-interval display-time-day-and-date display-time-mail-file display-time-balloon display-time) "time" "time/time.el")
(defconst custom-define-current-source-file "time.el")

(defgroup display-time nil "Facilities to display the current time/date/load and a new-mail indicator\nin the XEmacs mode line or echo area." :group 'applications)

(defgroup display-time-balloon nil "Fancy add-ons to display-time for using the `balloon-help' feature.\nballoon-help must be loaded before these settings take effect." :group 'display-time)

(defcustom display-time-mail-file nil "\
*File name of mail inbox file, for indicating existence of new mail.
Non-nil and not a string means don't check for mail.  nil means use
default, which is system-dependent, and is the same as used by Rmail." :group 'display-time)

(defcustom display-time-day-and-date nil "\
*Non-nil means \\[display-time] should display day,date and time.
This affects the spec 'date in the variable display-time-form-list." :group 'display-time :type 'boolean)

(defcustom display-time-interval 20 "\
*Seconds between updates of time in the mode line." :group 'display-time :type 'integer)

(defcustom display-time-24hr-format nil "\
*Non-nil indicates time should be displayed as hh:mm, 0 <= hh <= 23.
Nil means 1 <= hh <= 12, and an AM/PM suffix is used.
This affects the spec 'time in the variable display-time-form-list." :group 'display-time :type 'boolean)

(defcustom display-time-echo-area nil "\
*If non-nil, display-time will use the echo area instead of the mode line." :group 'display-time :type 'boolean)

(defcustom display-time-hook nil "\
*List of functions to be called when the time is updated on the mode line." :group 'display-time :type 'hook)

(defcustom display-time-ignore-read-mail t "\
*Non-nil means display the mail icon on any non-empty mailbox." :group 'display-time :type 'boolean)

(defcustom display-time-show-icons-maybe t "\
Use icons for time, load and mail status if possible
and not specified different explicitly" :group 'display-time :type 'boolean)

(defcustom display-time-mail-sign-string " Mail" "\
The string used as mail indicator in the echo area 
\(and in the modeline if display-time-show-icons-maybe is nil)
if display-time-echo-area is t" :group 'display-time :type 'string)

(defcustom display-time-no-mail-sign-string "" "\
The string used as no-mail indicator in the echo area
\(and in the modeline if display-time-show-icons-maybe is nil)
if display-time-echo-area is t" :group 'display-time :type 'string)

(defcustom display-time-display-pad "grey35" "\
How the load indicator's trapezoidal \"pad\" is to be displayed.
This can be 'transparent or a string describing the color it should have" :group 'display-time :type '(choice :tag "Value" (const transparent) (string :tag "Color")))

(defcustom display-time-display-time-foreground "firebrick" "\
How the time LEDs foreground is to be displayed.
This can be 'modeline (foreground color of the Modeline)
or a string describing the color it should have" :group 'display-time :type '(choice :tag "Value" (const modeline) (string :tag "Color")))

(defcustom display-time-display-time-background 'transparent "\
How the time LEDs background is to be displayed.
This can be 'transparent or a string describing the color it should have" :group 'display-time :type '(choice :tag "Value" (const transparent) (string :tag "Color")))

(defcustom display-time-mail-balloon 'display-time-mail-balloon "\
What to use to generate the balloon frame of the \"mail\" glyph
if balloon-help is loaded. This can be the function
display-time-mail-balloon, nil or a string." :group 'display-time-balloon :type '(choice (const display-time-mail-balloon) (const nil) (string)))

(defcustom display-time-no-mail-balloon "No mail is good mail." "\
The string used in the balloon frame of the \"no mail\" glyph
if balloon-help is loaded. This can also be nil" :group 'display-time-balloon :type '(choice (const nil) (string)))

(defcustom display-time-mail-balloon-show-gnus-group nil "\
Show the mail group gnus would put this message in.
This is only useful if you use gnus to read your mail and have set the variable
nnmail-split-methods to split your incoming mail into different groups.
Look at the documentation for gnus. If you don't know what we're talking about,
don't care and leave this set to nil" :group 'display-time-balloon :type 'boolean)

(defcustom display-time-mail-balloon-max-displayed 10 "\
The maximum number of messaged which are displayed in the mail balloon.
You need to have balloon-help loaded to use this." :group 'display-time-balloon :type 'number)

(defcustom display-time-mail-balloon-from-width 20 "\
The width of the `From:' part of the mail balloon.
You need to have balloon-help loaded to use this" :group 'display-time-balloon :type 'number)

(defcustom display-time-mail-balloon-subject-width 25 "\
The width of the `Subject:' part of the mail balloon.
You need to have balloon-help loaded to use this" :group 'display-time-balloon :type 'number)

(defcustom display-time-mail-balloon-gnus-split-width 10 "\
The width of the `Gnus Mail Group' part of the mail balloon.
This denotes the mail group gnus would decide to put this message in.
For getting this information, it consults the relevant variables from gnus
\(nnmail-split-methods).
You need to have balloon-help loaded to use this" :group 'display-time-balloon :type 'number)

(defcustom display-time-mail-balloon-enhance nil "\
A list of regular expressions describing which messages should be highlighted
in the mail balloon. The regexp will be matched against the complete header block
of an email. You need to load balloon-help to use this" :group 'display-time-balloon :type '(repeat (string :tag "Regexp")))

(defcustom display-time-mail-balloon-suppress nil "\
A list of regular expressions describing which messages should be completely suppressed
in the mail balloon. The regexp will be matched against the complete header block
of an email. It will only take effect if the message is not matched already
by display-time-mail-balloon-enhance.
You need to load balloon-help to use this" :group 'display-time-balloon :type '(repeat (string :tag "Regexp")))

(defcustom display-time-mail-balloon-enhance-gnus-group nil "\
A list of regular expressions describing which messages should be highlighted
in the mail balloon. The regexp will be matched against the group gnus would stuff
this message into. It will only take effect if the message is not matched already
by display-time-mail-balloon-suppress.

This requires display-time-mail-balloon-show-gnus-group to be t
and balloon-help to be loaded" :group 'display-time-balloon :type '(repeat (string :tag "Regexp")))

(defcustom display-time-mail-balloon-suppress-gnus-group nil "\
A list of regular expressions describing which messages should be completely suppressed
in the mail balloon. The regexp will be matched against the group gnus would stuff
this message into. It will only take effect if the message is not matched already
by display-time-mail-balloon-enhance or display-time-mail-balloon-enhance-gnus-group.

This requires display-time-mail-balloon-show-gnus-group to be t
and balloon-help to be loaded" :group 'display-time-balloon :type '(repeat (string :tag "Regexp")))

(defcustom display-time-load-list (list 0.2 0.5 0.8 1.1 1.8 2.6) "\
*A list giving six thresholds for the load
which correspond to the six different icons to be displayed
as a load indicator" :group 'display-time :type '(list (number :tag "Threshold 1") (number :tag "Threshold 2") (number :tag "Threshold 3") (number :tag "Threshold 4") (number :tag "Threshold 5") (number :tag "Threshold 6")))

(defcustom display-time-compatible nil "\
*This variable may be set to t to get the old behaviour of display-time.
It should be considered obsolete and only be used if you really want the
old behaviour (eq. you made extensive customizations yourself).
This means no display of a spiffy mail icon or use of the
display-time-form-list instead of the old display-time-string-form." :group 'display-time :type 'boolean)

(defcustom display-time-form-list (list 'date 'time 'load 'mail) "\
*This list describes the format of the strings/glyphs
which are to be displayed by display-time.
The old variable display-time-string-forms is only used if
display-time-compatible is non-nil. It is a list consisting of
strings or any of the following symbols:

There are three complex specs whose behaviour is changed via
the setting of various variables 

date:          This prints out the date in a manner compatible to
               the default value of the obsolete variable
               display-time-string-forms. It respects the variable
               display-time-day-and-date. If this is t it will print
               out the current date in the form DAYNAME MONTH DAY
               otherwise it will print nothing.
	      
time:          This prints out the time in a manner compatible to 
               the default value of the obsolete variable
               display-time-string-forms. It respects the variable
               display-time-24hr-format. If this is t it will print
               out the current hours in 24-hour format, if nil the
               hours will be printed in 12-hour format and the
               minutes will be followed by 'AM' or 'PM'.
	      
time-text:     The same as above, but will not use a glyph
	      
The other specs are simpler, as their meaning is not changed via
variables.

24-hours:      This prints the hours in 24-hours format
	      
24-hours-text: The same as above, but will not use a glyph
	      
12-hours:      This prints the hours in 12-hours format
	      
12-hours-text: The same as above, but will not use a glyph
	      
am-pm:         This prints am or pm.

Timezone:      This prints out the local timezone
	      
am-pm-text:    The same as above, but will not use a glyph
	      
minutes:       This prints the minutes.
	      
minutes-text:  The same as above, but will not use a glyph
	      
day:           This prints out the current day as a number. 
	      
dayname:       This prints out today's name.
	      
month:         This prints out the current month as a number
	      
monthname:     This prints out the current month's name

year:          This prints out the current year.
	      
load:          This prints out the system's load.
	      
load-text:     The same as above, but will not use a glyph
	      
mail:          This displays a mail indicator. Under X this will 
               normally be a small icon which changes depending if 
               there is new mail or not.
	      
mail-text:     The same as above, but will not use a glyph" :group 'display-time :type '(repeat (choice :tag "Symbol/String" (const :tag "Date" date) (const :tag "Time" time) (const :tag "Time (text)" time-text) (const :tag "24 hour format" 24-hours) (const :tag "24 hour format (text)" 24-hours-text) (const :tag "12 hour format" 12-hours) (const :tag "12 hour format (text)" 12-hours-text) (const :tag "AM/PM indicator" am-pm) (const :tag "AM/PM indicator (text)" am-pm-text) (const :tag "Timezone" timezone) (const :tag "Minutes" minutes) (const :tag "Minutes (text)" minutes-text) (const :tag "Day" day) (const :tag "Dayname" dayname) (const :tag "Month" month) (const :tag "Monthname" monthname) (const :tag "Year" year) (const :tag "Load" load) (const :tag "Load (text)" load-text) (const :tag "Mail sign" mail) (const :tag "Mail sign (text)" mail-text) (string :tag "String"))))

;;;***

(provide 'time-custom-defines)
