;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'vc-custom-defines) (error "Feature vc-custom-defines already loaded"))

;;;### (autoloads (log-edit-common-indent log-edit-done-hook log-edit-mode-hook log-edit-hook log-edit-setup-invert log-edit-require-final-newline log-edit-keep-buffer log-edit-confirm log-edit) "log-edit" "vc/log-edit.el")
(defconst custom-define-current-source-file "log-edit.el")

(defgroup log-edit nil "Major mode for editing RCS and CVS commit messages." :group 'pcl-cvs :group 'vc :version "21.1" :prefix "log-edit-")

(defcustom log-edit-confirm 'changed "\
*If non-nil, `log-edit-done' will request confirmation.
If 'changed, only request confirmation if the list of files has
  changed since the beginning of the log-edit session." :group 'log-edit :type '(choice (const changed) (const t) (const nil)))

(defcustom log-edit-keep-buffer nil "\
*If non-nil, don't hide the buffer after `log-edit-done'." :group 'log-edit :type 'boolean)

(defcustom log-edit-require-final-newline cvs-commit-buffer-require-final-newline "\
*Enforce a newline at the end of commit log messages.
Enforce it silently if t, query if non-nil and don't do anything if nil." :group 'log-edit :type '(choice (const ask) (const t) (const nil)))

(defcustom log-edit-setup-invert nil "\
*Non-nil means `log-edit' should invert the meaning of its SETUP arg.
If SETUP is 'force, this variable has no effect." :group 'log-edit :type 'boolean)

(defcustom log-edit-hook '(log-edit-insert-cvs-template log-edit-insert-changelog) "\
*Hook run at the end of `log-edit'." :group 'log-edit :type '(hook :options (log-edit-insert-changelog log-edit-insert-cvs-rcstemplate log-edit-insert-cvs-template log-edit-insert-filenames)))

(defcustom log-edit-mode-hook (if (boundp 'vc-log-mode-hook) vc-log-mode-hook) "\
*Hook run when entering `log-edit-mode'." :group 'log-edit :type 'hook)

(defcustom log-edit-done-hook nil "\
*Hook run before doing the actual commit.
This hook can be used to cleanup the message, enforce various
conventions, or to allow recording the message in some other database,
such as a bug-tracking system.  The list of files about to be committed
can be obtained from `log-edit-files'." :group 'log-edit :type '(hook :options (log-edit-set-common-indentation log-edit-add-to-changelog)))

(defcustom log-edit-common-indent 0 "\
Minimum indentation to use in `log-edit-set-common-indentation'." :group 'log-edit :type 'integer)

;;;***

;;;### (autoloads (hg-outgoing-repository hg-incoming-repository hg-update-modeline hg-log-limit hg-rev-completion-limit hg-commit-allow-empty-file-list hg-commit-allow-empty-message hg-global-prefix hg-log-mode-hook hg-pre-commit-hook hg-commit-mode-hook hg-mode-hook hg-binary mercurial) "mercurial" "vc/mercurial.el")
(defconst custom-define-current-source-file "mercurial.el")

(defgroup mercurial nil "Mercurial distributed SCM." :group 'tools)

(defcustom hg-binary (or (executable-find "hg") (dolist (path '("~/bin/hg" "/usr/bin/hg" "/usr/local/bin/hg")) (when (file-executable-p path) (return path)))) "\
The path to Mercurial's hg executable." :type '(file :must-match t) :group 'mercurial)

(defcustom hg-mode-hook nil "\
Hook run when a buffer enters hg-mode." :type 'sexp :group 'mercurial)

(defcustom hg-commit-mode-hook nil "\
Hook run when a buffer is created to prepare a commit." :type 'sexp :group 'mercurial)

(defcustom hg-pre-commit-hook nil "\
Hook run before a commit is performed.
If you want to prevent the commit from proceeding, raise an error." :type 'sexp :group 'mercurial)

(defcustom hg-log-mode-hook nil "\
Hook run after a buffer is filled with log information." :type 'sexp :group 'mercurial)

(defcustom hg-global-prefix "h" "\
The global prefix for Mercurial keymap bindings." :type 'sexp :group 'mercurial)

(defcustom hg-commit-allow-empty-message nil "\
Whether to allow changes to be committed with empty descriptions." :type 'boolean :group 'mercurial)

(defcustom hg-commit-allow-empty-file-list nil "\
Whether to allow changes to be committed without any modified files." :type 'boolean :group 'mercurial)

(defcustom hg-rev-completion-limit 100 "\
The maximum number of revisions that hg-read-rev will offer to complete.
This affects memory usage and performance when prompting for revisions
in a repository with a lot of history." :type 'integer :group 'mercurial)

(defcustom hg-log-limit 50 "\
The maximum number of revisions that hg-log will display." :type 'integer :group 'mercurial)

(defcustom hg-update-modeline t "\
Whether to update the modeline with the status of a file after every save.
Set this to nil on platforms with poor process management, such as Windows." :type 'boolean :group 'mercurial)

(defcustom hg-incoming-repository "default" "\
The repository from which changes are pulled from by default.
This should be a symbolic repository name, since it is used for all
repository-related commands." :type 'string :group 'mercurial)

(defcustom hg-outgoing-repository "default-push" "\
The repository to which changes are pushed to by default.
This should be a symbolic repository name, since it is used for all
repository-related commands." :type 'string :group 'mercurial)

;;;***

;;;### (autoloads (vc-arch-mode-line-rewrite) "vc-arch" "vc/vc-arch.el")
(defconst custom-define-current-source-file "vc-arch.el")

(defcustom vc-arch-mode-line-rewrite '(("\\`.*--\\(.*--.*\\)--\\(v?\\).*-\\([0-9]+\\)\\'" . "\\2\\3[\\1]")) "\
Rewrite rules to shorten Arch's revision names on the mode-line." :type '(repeat (cons regexp string)) :group 'vc)

;;;***

;;;### (autoloads (vc-cvs-sticky-tag-display vc-cvs-sticky-date-format-string vc-cvs-stay-local vc-cvs-use-edit vc-cvs-header vc-cvs-diff-switches vc-cvs-register-switches vc-cvs-global-switches vc-cvs-program) "vc-cvs" "vc/vc-cvs.el")
(defconst custom-define-current-source-file "vc-cvs.el")

(defcustom vc-cvs-program "cvs" "\
*Executable to run for CVS commands." :type 'file :group 'vc)

(defcustom vc-cvs-global-switches nil "\
*Global switches to pass to any CVS command." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "22.1" :group 'vc)

(defcustom vc-cvs-register-switches nil "\
*Extra switches for registering a file into CVS.
A string or list of strings passed to the checkin program by
\\[vc-register]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "21.1" :group 'vc)

(defcustom vc-cvs-diff-switches nil "\
*A string or list of strings specifying extra switches for cvs diff under VC." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "21.1" :group 'vc)

(defcustom vc-cvs-header (or (cdr (assoc 'CVS vc-header-alist)) '("$Id$")) "\
*Header keywords to be inserted by `vc-insert-headers'." :version "21.1" :type '(repeat string) :group 'vc)

(defcustom vc-cvs-use-edit t "\
*Non-nil means to use `cvs edit' to \"check out\" a file.
This is only meaningful if you don't use the implicit checkout model
\(i.e. if you have $CVSREAD set)." :type 'boolean :version "21.1" :group 'vc)

(defcustom vc-cvs-stay-local t "\
*Non-nil means use local operations when possible for remote repositories.
This avoids slow queries over the network and instead uses heuristics
and past information to determine the current status of a file.

The value can also be a regular expression or list of regular
expressions to match against the host name of a repository; then VC
only stays local for hosts that match it.  Alternatively, the value
can be a list of regular expressions where the first element is the
symbol `except'; then VC always stays local except for hosts matched
by these regular expressions." :type '(choice (const :tag "Always stay local" t) (const :tag "Don't stay local" nil) (list :format "
Examine hostname and %v" :tag "Examine hostname ..." (set :format "%v" :inline t (const :format "%t" :tag "don't" except)) (regexp :format " stay local,
%t: %v" :tag "if it matches") (repeat :format "%v%i
" :inline t (regexp :tag "or")))) :version "21.1" :group 'vc)

(defcustom vc-cvs-sticky-date-format-string "%c" "\
*Format string for mode-line display of sticky date.
Format is according to `format-time-string'.  Only used if
`vc-cvs-sticky-tag-display' is t." :type '(string) :version "22.1" :group 'vc)

(defcustom vc-cvs-sticky-tag-display t "\
*Specify the mode-line display of sticky tags.
Value t means default display, nil means no display at all.  If the
value is a function or macro, it is called with the sticky tag and
its' type as parameters, in that order.  TYPE can have three different
values: `symbolic-name' (TAG is a string), `revision-number' (TAG is a
string) and `date' (TAG is a date as returned by `encode-time').  The
return value of the function or macro will be displayed as a string.

Here's an example that will display the formatted date for sticky
dates and the word \"Sticky\" for sticky tag names and revisions.

  (lambda (tag type)
    (cond ((eq type 'date) (format-time-string
                              vc-cvs-sticky-date-format-string tag))
          ((eq type 'revision-number) \"Sticky\")
          ((eq type 'symbolic-name) \"Sticky\")))

Here's an example that will abbreviate to the first character only,
any text before the first occurrence of `-' for sticky symbolic tags.
If the sticky tag is a revision number, the word \"Sticky\" is
displayed.  Date and time is displayed for sticky dates.

   (lambda (tag type)
     (cond ((eq type 'date) (format-time-string \"%Y%m%d %H:%M\" tag))
           ((eq type 'revision-number) \"Sticky\")
           ((eq type 'symbolic-name)
            (condition-case nil
                (progn
                  (string-match \"\\\\([^-]*\\\\)\\\\(.*\\\\)\" tag)
                  (concat (substring (match-string 1 tag) 0 1) \":\"
                          (substring (match-string 2 tag) 1 nil)))
              (error tag)))))       ; Fall-back to given tag name.

See also variable `vc-cvs-sticky-date-format-string'." :type '(choice boolean function) :version "22.1" :group 'vc)

;;;***

;;;### (autoloads (vc-stay-local vc-mistrust-permissions vc-mode-face vc-keep-workfiles vc-consult-headers vc-display-status vc-follow-symlinks vc-make-backup-files vc-path vc-handled-backends vc-ignore-dir-regexp) "vc-hooks" "vc/vc-hooks.el")
(defconst custom-define-current-source-file "vc-hooks.el")

(defcustom vc-ignore-dir-regexp "\\`\\(?:[\\/][\\/]\\|/\\(?:net\\|afs\\|\\.\\.\\.\\)/\\)\\'" "\
Regexp matching directory names that are not under VC's control.
The default regexp prevents fruitless and time-consuming attempts
to determine the VC status in directories in which filenames are
interpreted as hostnames." :type 'regexp :group 'vc)

(defcustom vc-handled-backends '(RCS CVS SVN SCCS Arch MCVS GIT) "\
*List of version control backends for which VC will be used.
Entries in this list will be tried in order to determine whether a
file is under that sort of version control.
Removing an entry from the list prevents VC from being activated
when visiting a file managed by that backend.
An empty list disables VC altogether." :type '(repeat symbol) :version "21.1" :group 'vc)

(defcustom vc-path (if (file-directory-p "/usr/sccs") '("/usr/sccs") nil) "\
*List of extra directories to search for version control commands." :type '(repeat directory) :group 'vc)

(defcustom vc-make-backup-files nil "\
*If non-nil, backups of registered files are made as with other files.
If nil (the default), files covered by version control don't get backups." :type 'boolean :group 'vc :group 'backup)

(defcustom vc-follow-symlinks 'ask "\
*What to do if visiting a symbolic link to a file under version control.
Editing such a file through the link bypasses the version control system,
which is dangerous and probably not what you want.

If this variable is t, VC follows the link and visits the real file,
telling you about it in the echo area.  If it is `ask', VC asks for
confirmation whether it should follow the link.  If nil, the link is
visited and a warning displayed." :type '(choice (const :tag "Ask for confirmation" ask) (const :tag "Visit link and warn" nil) (const :tag "Follow link" t)) :group 'vc)

(defcustom vc-display-status t "\
*If non-nil, display revision number and lock status in modeline.
Otherwise, not displayed." :type 'boolean :group 'vc)

(defcustom vc-consult-headers t "\
*If non-nil, identify work files by searching for version headers." :type 'boolean :group 'vc)

(defcustom vc-keep-workfiles t "\
*If non-nil, don't delete working files after registering changes.
If the back-end is CVS, workfiles are always kept, regardless of the
value of this flag." :type 'boolean :group 'vc)

(defcustom vc-mode-face 'highlight "\
*Face used to display vc mode line, or nil/default for none." :type 'face :group 'vc)

(defcustom vc-mistrust-permissions nil "\
*If non-nil, don't assume permissions/ownership track version-control status.
If nil, do rely on the permissions.
See also variable `vc-consult-headers'." :type 'boolean :group 'vc)

(defcustom vc-stay-local t "\
*Non-nil means use local operations when possible for remote repositories.
This avoids slow queries over the network and instead uses heuristics
and past information to determine the current status of a file.

The value can also be a regular expression or list of regular
expressions to match against the host name of a repository; then VC
only stays local for hosts that match it.  Alternatively, the value
can be a list of regular expressions where the first element is the
symbol `except'; then VC always stays local except for hosts matched
by these regular expressions." :type '(choice (const :tag "Always stay local" t) (const :tag "Don't stay local" nil) (list :format "
Examine hostname and %v" :tag "Examine hostname ..." (set :format "%v" :inline t (const :format "%t" :tag "don't" except)) (regexp :format " stay local,
%t: %v" :tag "if it matches") (repeat :format "%v%i
" :inline t (regexp :tag "or")))) :version "22.1" :group 'vc)

;;;***

;;;### (autoloads (vc-mcvs-use-edit vc-mcvs-header vc-mcvs-diff-switches vc-mcvs-register-switches vc-mcvs-global-switches) "vc-mcvs" "vc/vc-mcvs.el")
(defconst custom-define-current-source-file "vc-mcvs.el")

(defcustom vc-mcvs-global-switches nil "\
*Global switches to pass to any Meta-CVS command." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "22.1" :group 'vc)

(defcustom vc-mcvs-register-switches nil "\
*Extra switches for registering a file into Meta-CVS.
A string or list of strings passed to the checkin program by
\\[vc-register]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "22.1" :group 'vc)

(defcustom vc-mcvs-diff-switches nil "\
*A string or list of strings specifying extra switches for cvs diff under VC." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "22.1" :group 'vc)

(defcustom vc-mcvs-header (or (cdr (assoc 'MCVS vc-header-alist)) vc-cvs-header) "\
*Header keywords to be inserted by `vc-insert-headers'." :version "22.1" :type '(repeat string) :group 'vc)

(defcustom vc-mcvs-use-edit vc-cvs-use-edit "\
*Non-nil means to use `cvs edit' to \"check out\" a file.
This is only meaningful if you don't use the implicit checkout model
\(i.e. if you have $CVSREAD set)." :type 'boolean :version "22.1" :group 'vc)

;;;***

;;;### (autoloads (vc-rcs-master-templates vc-rcsdiff-knows-brief vc-rcs-header vc-rcs-diff-switches vc-rcs-register-switches vc-rcs-release) "vc-rcs" "vc/vc-rcs.el")
(defconst custom-define-current-source-file "vc-rcs.el")

(defcustom vc-rcs-release nil "\
*The release number of your RCS installation, as a string.
If nil, VC itself computes this value when it is first needed." :type '(choice (const :tag "Auto" nil) (string :tag "Specified") (const :tag "Unknown" unknown)) :group 'vc)

(defcustom vc-rcs-register-switches nil "\
*Extra switches for registering a file in RCS.
A string or list of strings.  These are passed to the checkin program
by \\[vc-rcs-register]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "21.1" :group 'vc)

(defcustom vc-rcs-diff-switches nil "\
*A string or list of strings specifying extra switches for rcsdiff under VC." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "21.1" :group 'vc)

(defcustom vc-rcs-header (or (cdr (assoc 'RCS vc-header-alist)) '("$Id$")) "\
*Header keywords to be inserted by `vc-insert-headers'." :type '(repeat string) :version "21.1" :group 'vc)

(defcustom vc-rcsdiff-knows-brief nil "\
*Indicates whether rcsdiff understands the --brief option.
The value is either `yes', `no', or nil.  If it is nil, VC tries
to use --brief and sets this variable to remember whether it worked." :type '(choice (const :tag "Work out" nil) (const yes) (const no)) :group 'vc)

(defcustom vc-rcs-master-templates '("%sRCS/%s,v" "%s%s,v" "%sRCS/%s") "\
*Where to look for RCS master files.
For a description of possible values, see `vc-check-master-templates'." :type '(choice (const :tag "Use standard RCS file names" '("%sRCS/%s,v" "%s%s,v" "%sRCS/%s")) (repeat :tag "User-specified" (choice string function))) :version "21.1" :group 'vc)

;;;***

;;;### (autoloads (vc-sccs-master-templates vc-sccs-header vc-sccs-diff-switches vc-sccs-register-switches) "vc-sccs" "vc/vc-sccs.el")
(defconst custom-define-current-source-file "vc-sccs.el")

(defcustom vc-sccs-register-switches nil "\
*Extra switches for registering a file in SCCS.
A string or list of strings passed to the checkin program by
\\[vc-sccs-register]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "21.1" :group 'vc)

(defcustom vc-sccs-diff-switches nil "\
*A string or list of strings specifying extra switches for `vcdiff',
the diff utility used for SCCS under VC." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "21.1" :group 'vc)

(defcustom vc-sccs-header (or (cdr (assoc 'SCCS vc-header-alist)) '("%W%")) "\
*Header keywords to be inserted by `vc-insert-headers'." :type '(repeat string) :group 'vc)

(defcustom vc-sccs-master-templates '("%sSCCS/s.%s" "%ss.%s" vc-sccs-search-project-dir) "\
*Where to look for SCCS master files.
For a description of possible values, see `vc-check-master-templates'." :type '(choice (const :tag "Use standard SCCS file names" ("%sSCCS/s.%s" "%ss.%s" vc-sccs-search-project-dir)) (repeat :tag "User-specified" (choice string function))) :version "21.1" :group 'vc)

;;;***

;;;### (autoloads (vc-svn-program vc-svn-header vc-svn-diff-switches vc-svn-register-switches vc-svn-global-switches) "vc-svn" "vc/vc-svn.el")
(defconst custom-define-current-source-file "vc-svn.el")

(defcustom vc-svn-global-switches nil "\
*Global switches to pass to any SVN command." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "22.1" :group 'vc)

(defcustom vc-svn-register-switches nil "\
*Extra switches for registering a file into SVN.
A string or list of strings passed to the checkin program by
\\[vc-register]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "22.1" :group 'vc)

(defcustom vc-svn-diff-switches t "\
String or list of strings specifying extra switches for svn diff under VC.
If nil, use the value of `vc-diff-switches'.
If you want to force an empty list of arguments, use t." :type '(choice (const :tag "Unspecified" nil) (const :tag "None" t) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :version "22.1" :group 'vc)

(defcustom vc-svn-header (or (cdr (assoc 'SVN vc-header-alist)) '("$Id$")) "\
*Header keywords to be inserted by `vc-insert-headers'." :version "22.1" :type '(repeat string) :group 'vc)

(defcustom vc-svn-program "svn" "\
Name of the svn executable." :type 'string :group 'vc)

;;;***

;;;### (autoloads (vc-checkout-carefully vc-comment-alist vc-static-header-alist vc-annotate-menu-elements vc-annotate-background vc-annotate-very-old-color vc-annotate-color-map vc-logentry-check-hook vc-before-checkin-hook vc-checkin-hook vc-annotate-display-mode vc-checkout-hook vc-allow-async-revert vc-diff-knows-L vc-diff-switches vc-directory-exclusion-list vc-dired-terse-display vc-dired-recurse vc-dired-listing-switches vc-register-switches vc-checkout-switches vc-checkin-switches vc-command-messages vc-default-init-version vc-initial-comment vc-delete-logbuf-window vc-suppress-confirm vc) "vc" "vc/vc.el")
(defconst custom-define-current-source-file "vc.el")

(defgroup vc nil "Version-control system in Emacs." :group 'tools)

(defcustom vc-suppress-confirm nil "\
If non-nil, treat user as expert; suppress yes-no prompts on some things." :type 'boolean :group 'vc)

(defcustom vc-delete-logbuf-window t "\
If non-nil, delete the *VC-log* buffer and window after each logical action.
If nil, bury that buffer instead.
This is most useful if you have multiple windows on a frame and would like to
preserve the setting." :type 'boolean :group 'vc)

(defcustom vc-initial-comment nil "\
If non-nil, prompt for initial comment when a file is registered." :type 'boolean :group 'vc)

(defcustom vc-default-init-version "1.1" "\
A string used as the default version number when a new file is registered.
This can be overridden by giving a prefix argument to \\[vc-register].  This
can also be overridden by a particular VC backend." :type 'string :group 'vc :version "20.3")

(defcustom vc-command-messages nil "\
If non-nil, display run messages from back-end commands." :type 'boolean :group 'vc)

(defcustom vc-checkin-switches nil "\
A string or list of strings specifying extra switches for checkin.
These are passed to the checkin program by \\[vc-checkin]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :group 'vc)

(defcustom vc-checkout-switches nil "\
A string or list of strings specifying extra switches for checkout.
These are passed to the checkout program by \\[vc-checkout]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :group 'vc)

(defcustom vc-register-switches nil "\
A string or list of strings; extra switches for registering a file.
These are passed to the checkin program by \\[vc-register]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :group 'vc)

(defcustom vc-dired-listing-switches "-al" "\
Switches passed to `ls' for vc-dired.  MUST contain the `l' option." :type 'string :group 'vc :version "21.1")

(defcustom vc-dired-recurse t "\
If non-nil, show directory trees recursively in VC Dired." :type 'boolean :group 'vc :version "20.3")

(defcustom vc-dired-terse-display t "\
If non-nil, show only locked files in VC Dired." :type 'boolean :group 'vc :version "20.3")

(defcustom vc-directory-exclusion-list '("SCCS" "RCS" "CVS" "MCVS" ".svn" "{arch}") "\
List of directory names to be ignored when walking directory trees." :type '(repeat string) :group 'vc)

(defcustom vc-diff-switches nil "\
A string or list of strings specifying switches for diff under VC.
When running diff under a given BACKEND, VC concatenates the values of
`diff-switches', `vc-diff-switches', and `vc-BACKEND-diff-switches' to
get the switches for that command.  Thus, `vc-diff-switches' should
contain switches that are specific to version control, but not
specific to any particular backend." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :group 'vc :version "21.1")

(defcustom vc-diff-knows-L nil "\
*Indicates whether diff understands the -L option.
The value is either `yes', `no', or nil.  If it is nil, VC tries
to use -L and sets this variable to remember whether it worked." :type '(choice (const :tag "Work out" nil) (const yes) (const no)) :group 'vc)

(defcustom vc-allow-async-revert nil "\
Specifies whether the diff during \\[vc-revert-buffer] may be asynchronous.
Enabling this option means that you can confirm a revert operation even
if the local changes in the file have not been found and displayed yet." :type '(choice (const :tag "No" nil) (const :tag "Yes" t)) :group 'vc :version "22.1")

(defcustom vc-checkout-hook nil "\
Normal hook (list of functions) run after checking out a file.
See `run-hooks'." :type 'hook :group 'vc :version "21.1")

(defcustom vc-annotate-display-mode 'fullscale "\
Which mode to color the output of \\[vc-annotate] with by default." :type '(choice (const :tag "By Color Map Range" nil) (const :tag "Scale to Oldest" scale) (const :tag "Scale Oldest->Newest" fullscale) (number :tag "Specify Fractional Number of Days" :value "20.5")) :group 'vc)

(defcustom vc-checkin-hook nil "\
Normal hook (list of functions) run after a checkin is done.
See also `log-edit-done-hook'." :type 'hook :options '(log-edit-comment-to-change-log) :group 'vc)

(defcustom vc-before-checkin-hook nil "\
Normal hook (list of functions) run before a file is checked in.
See `run-hooks'." :type 'hook :group 'vc)

(defcustom vc-logentry-check-hook nil "\
Normal hook run by `vc-backend-logentry-check'.
Use this to impose your own rules on the entry in addition to any the
version control backend imposes itself." :type 'hook :group 'vc)

(defcustom vc-annotate-color-map (if (and nil (tty-display-color-p) (<= (display-color-cells) 8)) (let* ((colors (sort (delq nil (mapcar (lambda (x) (if (not (or (string-equal (car x) "white") (string-equal (car x) "black"))) (car x))) (tty-color-alist))) (lambda (a b) (cond ((or (string-equal a "red") (string-equal b "blue")) t) ((or (string-equal b "red") (string-equal a "blue")) nil) ((string-equal a "yellow") t) ((string-equal b "yellow") nil) ((string-equal a "cyan") t) ((string-equal b "cyan") nil) ((string-equal a "green") t) ((string-equal b "green") nil) ((string-equal a "magenta") t) ((string-equal b "magenta") nil) (t (string< a b)))))) (date 20) (delta (/ (- 360 date) (1- (length colors))))) (mapcar (lambda (x) (prog1 (cons date x) (setq date (+ date delta)))) colors)) '((20 . "#FF3F3F") (40 . "#FF6C3F") (60 . "#FF993F") (80 . "#FFC63F") (100 . "#FFF33F") (120 . "#DDFF3F") (140 . "#B0FF3F") (160 . "#83FF3F") (180 . "#56FF3F") (200 . "#3FFF56") (220 . "#3FFF83") (240 . "#3FFFB0") (260 . "#3FFFDD") (280 . "#3FF3FF") (300 . "#3FC6FF") (320 . "#3F99FF") (340 . "#3F6CFF") (360 . "#3F3FFF"))) "\
Association list of age versus color, for \\[vc-annotate].
Ages are given in units of fractional days.  Default is eighteen
steps using a twenty day increment, from red to blue.  For TTY
displays with 8 or fewer colors, the default is red to blue with
all other colors between (excluding black and white)." :type 'alist :group 'vc)

(defcustom vc-annotate-very-old-color "#3F3FFF" "\
Color for lines older than the current color range in \\[vc-annotate]]." :type 'string :group 'vc)

(defcustom vc-annotate-background "black" "\
Background color for \\[vc-annotate].
Default color is used if nil." :type 'string :group 'vc)

(defcustom vc-annotate-menu-elements '(2 0.5 0.1 0.01) "\
Menu elements for the mode-specific menu of VC-Annotate mode.
List of factors, used to expand/compress the time scale.  See `vc-annotate'." :type '(repeat number) :group 'vc)

(defcustom vc-static-header-alist '(("\\.c\\'" . "\n#ifndef lint\nstatic char vcid[] = \"%s\";\n#endif /* lint */\n")) "\
*Associate static header string templates with file types.
A %s in the template is replaced with the first string associated with
the file's version control type in `vc-header-alist'." :type '(repeat (cons :format "%v" (regexp :tag "File Type") (string :tag "Header String"))) :group 'vc)

(defcustom vc-comment-alist '((nroff-mode ".\\\"" "")) "\
*Special comment delimiters for generating VC headers.
Add an entry in this list if you need to override the normal `comment-start'
and `comment-end' variables.  This will only be necessary if the mode language
is sensitive to blank lines." :type '(repeat (list :format "%v" (symbol :tag "Mode") (string :tag "Comment Start") (string :tag "Comment End"))) :group 'vc)

(defcustom vc-checkout-carefully (= (user-uid) 0) "\
*Non-nil means be extra-careful in checkout.
Verify that the file really is not locked
and that its contents match what the master file says." :type 'boolean :group 'vc)

;;;***

(provide 'vc-custom-defines)
