;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'viper-custom-defines) (error "Feature viper-custom-defines already loaded"))

;;;### (autoloads (viper-smart-suffix-list) "viper-cmd" "viper/viper-cmd.el")
(defconst custom-define-current-source-file "viper-cmd.el")

(defcustom viper-smart-suffix-list '("" "tex" "c" "cc" "C" "java" "el" "html" "htm" "xml" "pl" "flr" "P" "p" "h" "H") "\
*List of suffixes that Viper tries to append to filenames ending with a `.'.
This is useful when the current directory contains files with the same
prefix and many different suffixes.  Usually, only one of the suffixes
represents an editable file.  However, file completion will stop at the `.'
The smart suffix feature lets you hit RET in such a case, and Viper will
select the appropriate suffix.

Suffixes are tried in the order given and the first suffix for which a
corresponding file exists is selected.  If no file exists for any of the
suffixes, the user is asked to confirm.

To turn this feature off, set this variable to nil." :type '(repeat string) :group 'viper-misc)

;;;***

;;;### (autoloads (ex-cycle-through-non-files ex-cycle-other-window viper-glob-function ex-compile-command ex-unix-type-shell-options ex-unix-type-shell viper-ex) "viper-ex" "viper/viper-ex.el")
(defconst custom-define-current-source-file "viper-ex.el")

(defgroup viper-ex nil "Viper support for Ex commands." :prefix "ex-" :group 'viper)

(defcustom ex-unix-type-shell (let ((case-fold-search t)) (and (stringp shell-file-name) (string-match (concat "\\(" "csh$\\|csh.exe$" "\\|" "ksh$\\|ksh.exe$" "\\|" "^sh$\\|sh.exe$" "\\|" "[^a-z]sh$\\|[^a-z]sh.exe$" "\\|" "bash$\\|bash.exe$" "\\)") shell-file-name))) "\
Is the user using a unix-type shell under a non-OS?" :type 'boolean :group 'viper-ex)

(defcustom ex-unix-type-shell-options (let ((case-fold-search t)) (if ex-unix-type-shell (cond ((string-match "\\(csh$\\|csh.exe$\\)" shell-file-name) "-f") ((string-match "\\(bash$\\|bash.exe$\\)" shell-file-name) "-noprofile")))) "\
Options to pass to the Unix-style shell.
Don't put `-c' here, as it is added automatically." :type '(choice (const nil) string) :group 'viper-ex)

(defcustom ex-compile-command "make" "\
The command to run when the user types :make." :type 'string :group 'viper-ex)

(defcustom viper-glob-function (cond (ex-unix-type-shell 'viper-glob-unix-files) (viper-ms-style-os-p 'viper-glob-mswindows-files) (t 'viper-glob-unix-files)) "\
Expand the file spec containing wildcard symbols.
The default tries to set this variable to work with Unix, Windows,
and OS/2.

However, if it doesn't work right for some types of Unix shells or some OS,
the user should supply the appropriate function and set this variable to the
corresponding function symbol." :type 'symbol :group 'viper-ex)

(defcustom ex-cycle-other-window t "\
*If t, :n and :b cycles through files and buffers in other window.
Then :N and :B cycles in the current window.  If nil, this behavior is
reversed." :type 'boolean :group 'viper-ex)

(defcustom ex-cycle-through-non-files nil "\
*Cycle through *scratch* and other buffers that don't visit any file." :type 'boolean :group 'viper-ex)

;;;***

;;;### (autoloads (viper-load-hook viper-emacs-state-hook viper-replace-state-hook viper-insert-state-hook viper-vi-state-hook viper-hooks viper-vi-style-in-minibuffer viper-change-notification-threshold viper-tags-file-name viper-spell-function viper-highlighting viper-related-files-and-buffers-ring viper-search-wrap-around viper-buffer-search-char viper-delete-backwards-in-replace viper-ESC-moves-cursor-back viper-ex-style-editing viper-ex-style-motion viper-parse-sexp-ignore-comments viper-re-replace viper-re-query-replace viper-search-scroll-threshold viper-re-search viper-case-fold-search viper-quote-string viper-search viper-keep-point-on-repeat viper-shift-width viper-electric-mode viper-auto-indent viper-fast-keyseq-timeout viper-command-ring-size viper-insertion-ring-size viper-read-buffer-function viper-use-replace-region-delimiters viper-replace-region-start-delimiter viper-replace-region-end-delimiter viper-emacs-state-cursor-color viper-insert-state-cursor-color viper-replace-overlay-cursor-color viper-allow-multiline-replace-regions viper-keep-point-on-undo viper-force-faces viper-suppress-input-method-change-message viper-ms-style-os-p) "viper-init" "viper/viper-init.el")
(defconst custom-define-current-source-file "viper-init.el")

(defcustom viper-ms-style-os-p (memq system-type '(ms-dos windows-nt windows-95)) "\
Tells if Emacs is running under an MS-style OS: ms-dos, windows-nt, W95." :type 'boolean :tag "Is it Microsoft-made OS?" :group 'viper-misc)

(defcustom viper-suppress-input-method-change-message nil "\
If t, the message notifying about changes in the input method is not displayed.
Normally, a message is displayed each time on enters the vi, insert or replace
state." :type 'boolean :group 'viper-misc)

(defcustom viper-force-faces nil "\
If t, Viper will think that it is running on a display that supports faces.
This is provided as a temporary relief for users of graphics-capable terminals
that Viper doesn't know about.
In all likelihood, you don't need to bother with this setting." :type 'boolean :group 'viper-highlighting)

(defcustom viper-keep-point-on-undo nil "\
*Non-nil means not to move point while undoing commands.
This style is different from Emacs and Vi.  Try it to see if
it better fits your working style." :type 'boolean :tag "Preserve Position of Point After Undo" :group 'viper)

(defcustom viper-allow-multiline-replace-regions t "\
If non-nil, Viper will allow multi-line replace regions.
This is an extension to standard Vi.
If nil, commands that attempt to replace text spanning multiple lines first
delete the text being replaced, as in standard Vi." :type 'boolean :group 'viper)

(defcustom viper-replace-overlay-cursor-color "Red" "\
*Cursor color when Viper is in Replace state." :type 'string :group 'viper)

(defcustom viper-insert-state-cursor-color "Green" "\
Cursor color when Viper is in insert state." :type 'string :group 'viper)

(defcustom viper-emacs-state-cursor-color nil "\
Cursor color when Viper is in Emacs state." :type 'string :group 'viper)

(defcustom viper-replace-region-end-delimiter "$" "\
A string marking the end of replacement regions.
It is used only with TTYs or if `viper-use-replace-region-delimiters'
is non-nil." :type 'string :group 'viper)

(defcustom viper-replace-region-start-delimiter "" "\
A string marking the beginning of replacement regions.
It is used only with TTYs or if `viper-use-replace-region-delimiters'
is non-nil." :type 'string :group 'viper)

(defcustom viper-use-replace-region-delimiters (or (not (viper-has-face-support-p)) (and (featurep 'xemacs) (eq (viper-device-type) 'tty))) "\
*If non-nil, Viper will always use `viper-replace-region-end-delimiter' and
`viper-replace-region-start-delimiter' to delimit replacement regions, even on
color displays.  By default, the delimiters are used only on TTYs." :type 'boolean :group 'viper)

(defcustom viper-read-buffer-function 'read-buffer "\
Function to use for prompting the user for a buffer name." :type 'symbol :group 'viper)

(defcustom viper-insertion-ring-size 14 "\
The size of history of inserted text.
This is a list where Viper keeps the history of previously inserted pieces of
text." :type 'integer :group 'viper-misc)

(defcustom viper-command-ring-size 14 "\
The size of history of Vi commands repeatable with dot." :type 'integer :group 'viper-misc)

(defcustom viper-fast-keyseq-timeout 200 "\
*Key sequence separated by no more than this many milliseconds is viewed as a Vi-style macro, if such a macro is defined.
Setting this too high may slow down your typing.  Setting this value too low
will make it hard to use Vi-style timeout macros." :type 'integer :group 'viper-misc)

(defcustom viper-auto-indent nil "\
*Enable autoindent, if t.
This is a buffer-local variable." :type 'boolean :group 'viper)

(defcustom viper-electric-mode t "\
*If t, electrify Viper.
Currently, this only electrifies auto-indentation, making it appropriate to the
mode of the buffer.
This means that auto-indentation will depart from standard Vi and will indent
appropriate to the mode of the buffer.  This is especially useful for editing
programs and LaTeX documents." :type 'boolean :group 'viper)

(defcustom viper-shift-width 8 "\
*The value of the shiftwidth.
This determines the number of columns by which the Ctl-t moves the cursor in
the Insert state." :type 'integer :group 'viper)

(defcustom viper-keep-point-on-repeat t "\
*If t, don't move point when repeating previous command.
This is useful for doing repeated changes with the '.' key.
The user can change this to nil, if she likes when the cursor moves
to a new place after repeating previous Vi command." :type 'boolean :group 'viper)

(defgroup viper-search nil "Variables that define the search and query-replace behavior of Viper." :prefix "viper-" :group 'viper)

(defcustom viper-quote-string "> " "\
String inserted at the beginning of quoted region." :type 'string :group 'viper)

(defcustom viper-case-fold-search nil "\
*If not nil, search ignores cases." :type 'boolean :group 'viper-search)

(defcustom viper-re-search t "\
*If not nil, search is regexp search, otherwise vanilla search." :type 'boolean :tag "Regexp Search" :group 'viper-search)

(defcustom viper-search-scroll-threshold 2 "\
*If search lands within this threshnold from the window top/bottom,
the window will be scrolled up or down appropriately, to reveal context.
If you want Viper search to behave as usual in Vi, set this variable to a
negative number." :type 'boolean :group 'viper-search)

(defcustom viper-re-query-replace t "\
*If t then do regexp replace, if nil then do string replace." :type 'boolean :tag "Regexp Query Replace" :group 'viper-search)

(defcustom viper-re-replace t "\
*If t, do regexp replace.  nil means do string replace." :type 'boolean :tag "Regexp Replace" :group 'viper-search)

(defcustom viper-parse-sexp-ignore-comments t "\
*If t, `%' ignores the parentheses that occur inside comments." :type 'boolean :group 'viper)

(defcustom viper-ex-style-motion t "\
*If t, the commands l,h do not cross lines, etc (Ex-style).
If nil, these commands cross line boundaries." :type 'boolean :group 'viper)

(defcustom viper-ex-style-editing t "\
*If t, Ex-style behavior while editing in Vi command and insert states.
`Backspace' and `Delete' don't cross line boundaries in insert.
`X' and `x' can't delete characters across line boundary in Vi, etc.
Note: this doesn't preclude `Backspace' and `Delete' from deleting characters
by moving past the insertion point.  This is a feature, not a bug.

If nil, the above commands can work across lines." :type 'boolean :group 'viper)

(defcustom viper-ESC-moves-cursor-back nil "\
*If t, ESC moves cursor back when changing from insert to vi state.
If nil, the cursor stays where it was when ESC was hit." :type 'boolean :group 'viper)

(defcustom viper-delete-backwards-in-replace nil "\
*If t, DEL key will delete characters while moving the cursor backwards.
If nil, the cursor will move backwards without deleting anything." :type 'boolean :group 'viper)

(defcustom viper-buffer-search-char nil "\
*Key used for buffer-searching.  Must be a character type, e.g., ?g." :type '(choice (const nil) character) :group 'viper-search)

(defcustom viper-search-wrap-around t "\
*If t, search wraps around." :type 'boolean :tag "Search Wraps Around" :group 'viper-search)

(defcustom viper-related-files-and-buffers-ring nil "\
*List of file and buffer names that are considered to be related to the current buffer.
Related buffers can be cycled through via :R and :P commands." :type 'boolean :group 'viper-misc)

(defgroup viper-highlighting nil "Hilighting of replace region, search pattern, minibuffer, etc." :prefix "viper-" :group 'viper)

(defcustom viper-spell-function 'ispell-region "\
Spell function used by #s<move> command to spell." :type 'function :group 'viper-misc)

(defcustom viper-tags-file-name "TAGS" "\
The tags file used by Viper." :type 'string :group 'viper-misc)

(defcustom viper-change-notification-threshold 1 "\
Notify the user when this many lines or characters have been deleted/yanked.
For line-deleting/yanking commands (like `dd', `yy'), the value denotes the
number of lines.  For character-based commands (such as `x', `dw', etc.), the
value refers to the number of characters affected." :type 'integer :group 'viper-misc)

(defcustom viper-vi-style-in-minibuffer t "\
If t, use vi-style editing in minibuffer.
Should be set in `~/.viper' file." :type 'boolean :group 'viper)

(defgroup viper-hooks nil "Viper hooks." :prefix "viper-" :group 'viper)

(defcustom viper-vi-state-hook 'viper-restore-cursor-type "\
*Hooks run just before the switch to Vi mode is completed." :type 'hook :group 'viper-hooks)

(defcustom viper-insert-state-hook 'viper-set-insert-cursor-type "\
*Hooks run just before the switch to Insert mode is completed." :type 'hook :group 'viper-hooks)

(defcustom viper-replace-state-hook 'viper-restore-cursor-type "\
*Hooks run just before the switch to Replace mode is completed." :type 'hook :group 'viper-hooks)

(defcustom viper-emacs-state-hook 'viper-restore-cursor-type "\
*Hooks run just before the switch to Emacs mode is completed." :type 'hook :group 'viper-hooks)

(defcustom viper-load-hook nil "\
Hooks run just after loading Viper." :type 'hook :group 'viper-hooks)

;;;***

;;;### (autoloads (viper-quoted-insert-key viper-toggle-key viper-want-ctl-h-help viper-no-multiple-ESC viper-want-emacs-keys-in-vi viper-want-emacs-keys-in-insert) "viper-keym" "viper/viper-keym.el")
(defconst custom-define-current-source-file "viper-keym.el")

(defcustom viper-want-emacs-keys-in-insert t "\
*Set to nil if you want complete Vi compatibility in insert mode.
Complete compatibility with Vi is not recommended for power use of Viper." :type 'boolean :group 'viper)

(defcustom viper-want-emacs-keys-in-vi t "\
*Set to nil if you want complete Vi compatibility in Vi mode.
Full Vi compatibility is not recommended for power use of Viper." :type 'boolean :group 'viper)

(defcustom viper-no-multiple-ESC t "\
*If true, multiple ESC in Vi mode will cause bell to ring.
This is set to t on a windowing terminal and to 'twice on a dumb
terminal (unless the user level is 1, 2, or 5).  On a dumb terminal, this
enables cursor keys and is generally more convenient, as terminals usually
don't have a convenient Meta key.
Setting viper-no-multiple-ESC to nil will allow as many multiple ESC,
as is allowed by the major mode in effect." :type 'boolean :group 'viper)

(defcustom viper-want-ctl-h-help nil "\
*If non-nil, C-h gets bound to help-command; otherwise, C-h gets the usual Vi bindings." :type 'boolean :group 'viper)

(defcustom viper-toggle-key [(control ?z)] "\
The key used to change states from Emacs to Vi and back.
In insert mode, this key also functions as Meta.

Enter as a sexp.  Examples: \"\\C-z\", [(control ?z)]." :type 'sexp :group 'viper :set (lambda (symbol value) (let ((old-value (if (boundp 'viper-toggle-key) viper-toggle-key [(control ?z)]))) (mapc (lambda (buf) (with-current-buffer buf (when (and (boundp 'viper-insert-basic-map) (keymapp viper-insert-basic-map)) (when old-value (define-key viper-insert-basic-map old-value nil)) (define-key viper-insert-basic-map value 'viper-escape-to-vi)) (when (and (boundp 'viper-vi-intercept-map) (keymapp viper-vi-intercept-map)) (when old-value (define-key viper-vi-intercept-map old-value nil)) (define-key viper-vi-intercept-map value 'viper-toggle-key-action)) (when (and (boundp 'viper-emacs-intercept-map) (keymapp viper-emacs-intercept-map)) (define-key viper-emacs-intercept-map old-value nil) (define-key viper-emacs-intercept-map value 'viper-change-state-to-vi)))) (buffer-list)) (set-default symbol value))))

(defcustom viper-quoted-insert-key "" "\
The key used to quote special characters when inserting them in Insert state." :type 'string :group 'viper)

;;;***

;;;### (autoloads (viper-repeat-from-history-key) "viper-macs" "viper/viper-macs.el")
(defconst custom-define-current-source-file "viper-macs.el")

(defcustom viper-repeat-from-history-key 'f12 "\
Prefix key for accessing previously typed Vi commands.

The previous command is accessible, as usual, via `.'.  The command before this
can be invoked as `<this key> 1', and the command before that, and the command
before that one is accessible as `<this key> 2'.
The notation for these keys is borrowed from XEmacs.  Basically,
a key is a symbol, e.g., `a', `\\1', `f2', etc., or a list, e.g.,
`(meta control f1)'." :type 'sexp :group 'viper)

;;;***

;;;### (autoloads (viper-mouse-insert-key viper-mouse-search-key viper-multiclick-timeout viper-surrounding-word-function viper-mouse) "viper-mous" "viper/viper-mous.el")
(defconst custom-define-current-source-file "viper-mous.el")

(defgroup viper-mouse nil "Support for Viper special mouse-bound commands." :prefix "viper-" :group 'viper)

(defcustom viper-surrounding-word-function 'viper-surrounding-word "\
*Function that determines what constitutes a word for clicking events.
Takes two parameters: a COUNT, indicating how many words to return,
and CLICK-COUNT, telling whether this is the first click, a double-click,
or a tripple-click." :type 'symbol :group 'viper-mouse)

(defcustom viper-multiclick-timeout (if (viper-window-display-p) (if (featurep 'xemacs) mouse-track-multi-click-time double-click-time) 500) "\
*Time interval in millisecond within which successive mouse clicks are
considered related." :type 'integer :group 'viper-mouse)

(defcustom viper-mouse-search-key '(meta shift 1) "\
*Key used to click-search in Viper.
This must be a list that specifies the mouse button and modifiers.
The supported modifiers are `meta', `shift', and `control'.
For instance, `(meta shift 1)' means that holding the meta and shift
keys down and clicking on a word with mouse button 1
will search for that word in the buffer that was current before the click.
This buffer may be different from the one where the click occurred." :type '(list (set :inline t :tag "Modifiers" :format "%t: %v" (const :format "%v " meta) (const :format "%v " shift) (const control)) (integer :tag "Button")) :set 'viper-reset-mouse-search-key :group 'viper-mouse)

(defcustom viper-mouse-insert-key '(meta shift 2) "\
*Key used to click-insert in Viper.
Must be a list that specifies the mouse button and modifiers.
The supported modifiers are `meta', `shift', and `control'.
For instance, `(meta shift 2)' means that holding the meta and shift keys
down, and clicking on a word with mouse button 2, will insert that word
at the cursor in the buffer that was current just before the click.
This buffer may be different from the one where the click occurred." :type '(list (set :inline t :tag "Modifiers" :format "%t: %v" (const :format "%v " meta) (const :format "%v " shift) (const control)) (integer :tag "Button")) :set 'viper-reset-mouse-insert-key :group 'viper-mouse)

;;;***

;;;### (autoloads (viper-syntax-preference) "viper-util" "viper/viper-util.el")
(defconst custom-define-current-source-file "viper-util.el")

(defcustom viper-syntax-preference 'reformed-vi "\
*Syntax type characterizing Viper's alphanumeric symbols.
Affects movement and change commands that deal with Vi-style words.
Works best when set in the hooks to various major modes.

`strict-vi' means Viper words are (hopefully) exactly as in Vi.

`reformed-vi' means Viper words are like Emacs words (as determined using
Emacs syntax tables, which are different for different major modes) with two
exceptions: the symbol `_' is always part of a word and typical Vi non-word
symbols, such as `,',:,\",),{, etc., are excluded.
This behaves very close to `strict-vi', but also works well with non-ASCII
characters from various alphabets.

`extended' means Viper word constituents are symbols that are marked as being
parts of words OR symbols in Emacs syntax tables.
This is most appropriate for major modes intended for editing programs.

`emacs' means Viper words are the same as Emacs words as specified by Emacs
syntax tables.
This option is appropriate if you like Emacs-style words." :type '(radio (const strict-vi) (const reformed-vi) (const extended) (const emacs)) :set 'viper-set-syntax-preference :group 'viper)

;;;***

;;;### (autoloads (viper-major-mode-modifier-list viper-insert-state-mode-list viper-emacs-state-mode-list viper-vi-state-mode-list viper-mode viper-always viper-misc viper) "viper" "viper/viper.el")
(defconst custom-define-current-source-file "viper.el")

(defgroup viper nil "Vi emulation within Emacs.\nNOTE: Viper customization should be saved in `viper-custom-file-name', which\ndefaults to `~/.viper'." :prefix "viper-" :group 'emulations)

(defgroup viper-misc nil "Miscellaneous Viper customization." :prefix "viper-" :group 'viper)

(defcustom viper-always t "\
Non-nil means, arrange for vi-state to be a default when appropriate.
This is different from `viper-mode' variable in that `viper-mode' determines
whether to use Viper in the first place, while `viper-always', if nil, lets
user decide when to invoke Viper in a major mode." :type 'boolean :tag "Always Invoke Viper" :group 'viper-misc)

(defcustom viper-mode (cond (noninteractive nil) (t 'ask)) "\
To Viperize or not to Viperize.
If t, viperize Emacs.  If nil -- don't.  If `ask', ask the user.
This variable is used primarily when Viper is being loaded.

Must be set in `~/.emacs' before Viper is loaded.
DO NOT set this variable interactively, unless you are using the customization
widget." :type '(choice (const nil) (const t) (const ask)) :tag "Set Viper Mode on Loading" :group 'viper-misc)

(defcustom viper-vi-state-mode-list '(fundamental-mode makefile-mode awk-mode m4-mode xrdb-mode winmgr-mode autoconf-mode cvs-edit-mode html-mode html-helper-mode emacs-lisp-mode lisp-mode lisp-interaction-mode jde-mode java-mode cc-mode c-mode c++-mode objc-mode fortran-mode f90-mode basic-mode bat-mode asm-mode prolog-mode flora-mode sql-mode text-mode indented-text-mode tex-mode latex-mode bibtex-mode ps-mode diff-mode idl-mode perl-mode cperl-mode javascript-mode tcl-mode python-mode sh-mode ksh-mode csh-mode gnus-article-mode mh-show-mode) "\
Major modes that require Vi command state." :type '(repeat symbol) :group 'viper-misc)

(defcustom viper-emacs-state-mode-list '(Custom-mode dired-mode efs-mode tar-mode browse-kill-ring-mode recentf-mode recentf-dialog-mode occur-mode mh-folder-mode gnus-group-mode gnus-summary-mode completion-list-mode help-mode Info-mode Buffer-menu-mode compilation-mode rcirc-mode jde-javadoc-checker-report-mode view-mode vm-mode vm-summary-mode) "\
*A list of major modes that should come up in Emacs state.
Normally, Viper would bring buffers up in Emacs state, unless the corresponding
major mode has been placed on `viper-vi-state-mode-list' or
`viper-insert-state-mode-list'.  So, don't place a new mode on this list,
unless it is coming up in a wrong Viper state." :type '(repeat symbol) :group 'viper-misc)

(defcustom viper-insert-state-mode-list '(internal-ange-ftp-mode comint-mode gud-mode inferior-emacs-lisp-mode erc-mode eshell-mode shell-mode) "\
*A list of major modes that should come up in Vi Insert state." :type '(repeat symbol) :group 'viper-misc)

(defcustom viper-major-mode-modifier-list '((help-mode emacs-state viper-slash-and-colon-map) (comint-mode insert-state viper-comint-mode-modifier-map) (comint-mode vi-state viper-comint-mode-modifier-map) (gud-mode insert-state viper-comint-mode-modifier-map) (shell-mode insert-state viper-comint-mode-modifier-map) (inferior-emacs-lisp-mode insert-state viper-comint-mode-modifier-map) (shell-mode vi-state viper-comint-mode-modifier-map) (ange-ftp-shell-mode insert-state viper-comint-mode-modifier-map) (ange-ftp-shell-mode vi-state viper-comint-mode-modifier-map) (internal-ange-ftp-mode insert-state viper-comint-mode-modifier-map) (internal-ange-ftp-mode vi-state viper-comint-mode-modifier-map) (dired-mode emacs-state viper-dired-modifier-map) (tar-mode emacs-state viper-slash-and-colon-map) (mh-folder-mode emacs-state viper-slash-and-colon-map) (gnus-group-mode emacs-state viper-gnus-modifier-map) (gnus-summary-mode emacs-state viper-gnus-modifier-map) (Info-mode emacs-state viper-slash-and-colon-map) (Buffer-menu-mode emacs-state viper-slash-and-colon-map) (erc-mode insert-state viper-comint-mode-modifier-map) (erc-mode vi-state viper-comint-mode-modifier-map)) "\
List specifying how to modify the various major modes to enable some Viperisms.
The list has the structure: ((mode viper-state keymap) (mode viper-state
keymap) ...).  If `mode' is on the list, the `kemap' will be made active (on
the minor-mode-map-alist) in the specified viper state.
If you change this list, have to restart Emacs for the change to take effect.
However, if you did the change through the customization widget, then Emacs
needs to be restarted only if you deleted a triple mode-state-keymap from the
list.  No need to restart Emacs in case of insertion or modification of an
existing triple." :type '(repeat (list symbol (choice (const emacs-state) (const vi-state) (const insert-state)) symbol)) :set 'viper-apply-major-mode-modifiers :group 'viper-misc)

;;;***

(provide 'viper-custom-defines)
