;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'w3-custom-defines) (error "Feature w3-custom-defines already loaded"))

;;;### (autoloads (socks-nslookup-program socks-server socks) "socks" "lisp/socks.el")
(defconst custom-define-current-source-file "socks.el")

(defgroup socks nil "SOCKS Support" :prefix "socks-" :group 'processes)

(defcustom socks-server (list "Default server" "socks" 1080 5) "\
" :group 'socks :type '(list (string :format "" :value "Default server") (string :tag "Server") (integer :tag "Port") (radio-button-choice :tag "SOCKS Version" :format "%t: %v" (const :tag "SOCKS v4  " :format "%t" :value 4) (const :tag "SOCKS v5" :format "%t" :value 5))))

(defcustom socks-nslookup-program "nslookup" "\
*If non-NIL then a string naming the nslookup program." :type '(choice (const :tag "None" :value nil) string) :group 'socks)

;;;***

;;;### (autoloads (ssl-view-certificate-program-arguments ssl-view-certificate-program-name ssl-program-arguments ssl-program-name ssl-certificate-verification-policy ssl-certificate-directory-style ssl-view-certificate-program-arguments ssl-view-certificate-program-name ssl-rehash-program-name ssl-certificate-directory ssl) "ssl" "lisp/ssl.el")
(defconst custom-define-current-source-file "ssl.el")

(defgroup ssl nil "Support for `Secure Sockets Layer' encryption." :group 'comm)

(defcustom ssl-certificate-directory "~/.w3/certs/" "\
*Directory in which to store CA certificates." :group 'ssl :type 'directory)

(defcustom ssl-rehash-program-name "c_rehash" "\
*Program to run after adding a cert to a directory .
Run with one argument, the directory name." :group 'ssl :type 'string)

(defcustom ssl-view-certificate-program-name "x509" "\
*The program to run to provide a human-readable view of a certificate." :group 'ssl :type 'string)

(defcustom ssl-view-certificate-program-arguments '("-text" "-inform" "DER") "\
*Arguments that should be passed to the certificate viewing program.
The certificate is piped to it.
Maybe a way of passing a file should be implemented" :group 'ssl :type '(repeat string))

(defcustom ssl-certificate-directory-style 'ssleay "\
*Style of cert database to use, the only valid value right now is `ssleay'.
This means a directory of pem encoded certificates with hash symlinks." :group 'ssl :type '(choice (const :tag "SSLeay" :value ssleay) (const :tag "OpenSSL" :value openssl)))

(defcustom ssl-certificate-verification-policy 0 "\
*How far up the certificate chain we should verify." :group 'ssl :type '(choice (const :tag "No verification" :value 0) (const :tag "Verification required" :value 1) (const :tag "Reject connection if verification fails" :value 3) (const :tag "SSL_VERIFY_CLIENT_ONCE" :value 5)))

(defcustom ssl-program-name "openssl" "\
*The program to run in a subprocess to open an SSL connection." :group 'ssl :type 'string)

(defcustom ssl-program-arguments '("s_client" "-quiet" "-host" host "-port" service "-verify" (int-to-string ssl-certificate-verification-policy) "-CApath" ssl-certificate-directory) "\
*Arguments that should be passed to the program `ssl-program-name'.
This should be used if your SSL program needs command line switches to
specify any behaviour (certificate file locations, etc).
The special symbols 'host and 'port may be used in the list of arguments
and will be replaced with the hostname and service/port that will be connected
to." :group 'ssl :type 'list)

(defcustom ssl-view-certificate-program-name ssl-program-name "\
*The program to run to provide a human-readable view of a certificate." :group 'ssl :type 'string)

(defcustom ssl-view-certificate-program-arguments '("x509" "-text" "-inform" "DER") "\
*Arguments that should be passed to the certificate viewing program.
The certificate is piped to it.
Maybe a way of passing a file should be implemented." :group 'ssl :type 'list)

;;;***

;;;### (autoloads (url-cache-creation-function url-cache-expire-time url-cache-directory) "url-cache" "lisp/url-cache.el")
(defconst custom-define-current-source-file "url-cache.el")

(defcustom url-cache-directory (expand-file-name "cache" url-configuration-directory) "\
The directory where cache files should be stored." :type 'directory :group 'url-file)

(defcustom url-cache-expire-time 3600 "\
Default maximum time in seconds before cache files expire.
Used by the function `url-cache-expired'." :version "24.1" :type 'integer :group 'url-cache)

(defcustom url-cache-creation-function 'url-cache-create-filename-using-md5 "\
What function to use to create a cached filename." :type '(choice (const :tag "MD5 of filename (low collision rate)" :value url-cache-create-filename-using-md5) (const :tag "Human readable filenames (higher collision rate)" :value url-cache-create-filename-human-readable) (function :tag "Other")) :group 'url-cache)

;;;***

;;;### (autoloads (url-cookie-save-interval url-cookie-untrusted-urls url-cookie-trusted-urls url-cookie-multiple-line url-cookie-confirmation url-cookie-file url-cookie) "url-cookie" "lisp/url-cookie.el")
(defconst custom-define-current-source-file "url-cookie.el")

(defgroup url-cookie nil "URL cookies." :prefix "url-" :prefix "url-cookie-" :group 'url)

(defcustom url-cookie-file nil "\
File where cookies are stored on disk." :type '(choice (const :tag "Default" :value nil) file) :group 'url-file :group 'url-cookie)

(defcustom url-cookie-confirmation nil "\
If non-nil, confirmation by the user is required to accept HTTP cookies." :type 'boolean :group 'url-cookie)

(defcustom url-cookie-multiple-line nil "\
If nil, HTTP requests put all cookies for the server on one line.
Some web servers, such as http://www.hotmail.com/, only accept cookies
when they are on one line.  This is broken behavior, but just try
telling Microsoft that." :type 'boolean :group 'url-cookie)

(defcustom url-cookie-trusted-urls nil "\
A list of regular expressions matching URLs to always accept cookies from." :type '(repeat regexp) :group 'url-cookie)

(defcustom url-cookie-untrusted-urls nil "\
A list of regular expressions matching URLs to never accept cookies from." :type '(repeat regexp) :group 'url-cookie)

(defcustom url-cookie-save-interval 3600 "\
The number of seconds between automatic saves of cookies.
Default is 1 hour.  Note that if you change this variable outside of
the `customize' interface after `url-do-setup' has been run, you need
to run the `url-cookie-setup-save-timer' function manually." :set (function (lambda (var val) (set-default var val) (if (and (boundp 'url-setup-done) url-setup-done) (url-cookie-setup-save-timer)))) :type 'integer :group 'url-cookie)

;;;***

;;;### (autoloads (url-gateway-nslookup-program url-gateway-broken-resolution url-gateway-telnet-password url-gateway-telnet-user-name url-gateway-telnet-password-prompt url-gateway-telnet-login-prompt url-gateway-telnet-parameters url-gateway-telnet-host url-gateway-rlogin-parameters url-gateway-rlogin-user-name url-gateway-rlogin-host url-gateway-prompt-pattern url-gateway-local-host-regexp url-gateway) "url-gw" "lisp/url-gw.el")
(defconst custom-define-current-source-file "url-gw.el")

(defgroup url-gateway nil "URL gateway variables." :group 'url)

(defcustom url-gateway-local-host-regexp nil "\
A regular expression specifying local hostnames/machines." :type '(choice (const nil) regexp) :group 'url-gateway)

(defcustom url-gateway-prompt-pattern "^[^#$%>;]*[#$%>;] *" "\
A regular expression matching a shell prompt." :type 'regexp :group 'url-gateway)

(defcustom url-gateway-rlogin-host nil "\
What hostname to actually rlog into before doing a telnet." :type '(choice (const nil) string) :group 'url-gateway)

(defcustom url-gateway-rlogin-user-name nil "\
Username to log into the remote machine with when using rlogin." :type '(choice (const nil) string) :group 'url-gateway)

(defcustom url-gateway-rlogin-parameters '("telnet" "-8") "\
Parameters to `url-open-rlogin'.
This list will be used as the parameter list given to rsh." :type '(repeat string) :group 'url-gateway)

(defcustom url-gateway-telnet-host nil "\
What hostname to actually login to before doing a telnet." :type '(choice (const nil) string) :group 'url-gateway)

(defcustom url-gateway-telnet-parameters '("exec" "telnet" "-8") "\
Parameters to `url-open-telnet'.
This list will be executed as a command after logging in via telnet." :type '(repeat string) :group 'url-gateway)

(defcustom url-gateway-telnet-login-prompt "^
*.?login:" "\
Prompt that tells us we should send our username when logging in w/telnet." :type 'regexp :group 'url-gateway)

(defcustom url-gateway-telnet-password-prompt "^
*.?password:" "\
Prompt that tells us we should send our password when logging in w/telnet." :type 'regexp :group 'url-gateway)

(defcustom url-gateway-telnet-user-name nil "\
User name to log in via telnet with." :type '(choice (const nil) string) :group 'url-gateway)

(defcustom url-gateway-telnet-password nil "\
Password to use to log in via telnet with." :type '(choice (const nil) string) :group 'url-gateway)

(defcustom url-gateway-broken-resolution nil "\
Whether to use nslookup to resolve hostnames.
This should be used when your version of Emacs cannot correctly use DNS,
but your machine can.  This usually happens if you are running a statically
linked Emacs under SunOS 4.x." :type 'boolean :group 'url-gateway)

(defcustom url-gateway-nslookup-program "nslookup" "\
If non-nil then a string naming nslookup program." :type '(choice (const :tag "None" :value nil) string) :group 'url-gateway)

;;;***

;;;### (autoloads (url-history-save-interval url-history-file url-history-track url-history) "url-history" "lisp/url-history.el")
(defconst custom-define-current-source-file "url-history.el")

(defgroup url-history nil "History variables in the URL package." :prefix "url-history" :group 'url)

(defcustom url-history-track nil "\
Controls whether to keep a list of all the URLs being visited.
If non-nil, the URL package will keep track of all the URLs visited.
If set to t, then the list is saved to disk at the end of each Emacs
session." :set (function (lambda (var val) (set-default var val) (and (boundp 'url-setup-done) url-setup-done (url-history-setup-save-timer)))) :type '(choice (const :tag "off" nil) (const :tag "on" t) (const :tag "within session" 'session)) :group 'url-history)

(defcustom url-history-file nil "\
The global history file for the URL package.
This file contains a list of all the URLs you have visited.  This file
is parsed at startup and used to provide URL completion." :type '(choice (const :tag "Default" :value nil) file) :group 'url-history)

(defcustom url-history-save-interval 3600 "\
The number of seconds between automatic saves of the history list.
Default is 1 hour.  Note that if you change this variable outside of
the `customize' interface after `url-do-setup' has been run, you need
to run the `url-history-setup-save-timer' function manually." :set (function (lambda (var val) (set-default var val) (if (and (boundp 'url-setup-done) url-setup-done) (url-history-setup-save-timer)))) :type 'integer :group 'url-history)

;;;***

;;;### (autoloads (url-irc-function) "url-irc" "lisp/url-irc.el")
(defconst custom-define-current-source-file "url-irc.el")

(defcustom url-irc-function 'url-irc-rcirc "\
Function to actually open an IRC connection.
The function should take the following arguments:
    HOST - the hostname of the IRC server to contact
    PORT - the port number of the IRC server to contact
 CHANNEL - What channel on the server to visit right away (can be nil)
    USER - What username to use
PASSWORD - What password to use" :type '(choice (const :tag "rcirc" :value url-irc-rcirc) (const :tag "ERC" :value url-irc-erc) (const :tag "ZEN IRC" :value url-irc-zenirc) (function :tag "Other")) :group 'url)

;;;***

;;;### (autoloads (url-news) "url-news" "lisp/url-news.el")
(defconst custom-define-current-source-file "url-news.el")

(defgroup url-news nil "News related options." :group 'url)

;;;***

;;;### (autoloads (url-queue-timeout url-queue-parallel-processes) "url-queue" "lisp/url-queue.el")
(defconst custom-define-current-source-file "url-queue.el")

(defcustom url-queue-parallel-processes 6 "\
The number of concurrent processes." :version "24.1" :type 'integer :group 'url)

(defcustom url-queue-timeout 5 "\
How long to let a job live once it's started (in seconds)." :version "24.1" :type 'integer :group 'url)

;;;***

;;;### (autoloads (url-debug) "url-util" "lisp/url-util.el")
(defconst custom-define-current-source-file "url-util.el")

(defcustom url-debug nil "\
What types of debug messages from the URL library to show.
Debug messages are logged to the *URL-DEBUG* buffer.

If t, all messages will be logged.
If a number, all messages will be logged, as well shown via `message'.
If a list, it is a list of the types of messages to be logged." :type '(choice (const :tag "none" nil) (const :tag "all" t) (checklist :tag "custom" (const :tag "HTTP" :value http) (const :tag "DAV" :value dav) (const :tag "General" :value retrieval) (const :tag "Filename handlers" :value handlers) (symbol :tag "Other"))) :group 'url-hairy)

;;;***

;;;### (autoloads (url-gateway-method url-confirmation-func url-max-redirections url-news-server url-show-status url-temporary-directory url-max-password-attempts url-mime-language-string url-bad-port-list url-standalone-mode url-proxy-services url-mail-command url-uncompressor-alist url-privacy-level url-directory-index-file url-personal-mail-address url-automatic-caching url-honor-refresh-requests url-hairy url-mime url-cache url-file url) "url-vars" "lisp/url-vars.el")
(defconst custom-define-current-source-file "url-vars.el")

(defgroup url nil "Uniform Resource Locator tool." :version "22.1" :group 'comm)

(defgroup url-file nil "URL storage." :prefix "url-" :group 'url)

(defgroup url-cache nil "URL cache." :prefix "url-" :prefix "url-cache-" :group 'url)

(defgroup url-mime nil "MIME options of URL." :prefix "url-" :group 'url)

(defgroup url-hairy nil "Hairy options of URL." :prefix "url-" :group 'url)

(defcustom url-honor-refresh-requests t "\
Whether to do automatic page reloads.
These are done at the request of the document author or the server via
the `Refresh' header in an HTTP response.  If nil, no refresh
requests will be honored.  If t, all refresh requests will be honored.
If non-nil and not t, the user will be asked for each refresh request." :type '(choice (const :tag "off" nil) (const :tag "on" t) (const :tag "ask" 'ask)) :group 'url-hairy)

(defcustom url-automatic-caching nil "\
If non-nil, all documents will be automatically cached to the local disk." :type 'boolean :group 'url-cache)

(defcustom url-personal-mail-address nil "\
Your full email address.
This is what is sent to HTTP servers as the FROM field in an HTTP
request." :type '(choice (const :tag "Unspecified" nil) string) :group 'url)

(defcustom url-directory-index-file "index.html" "\
The filename to look for when indexing a directory.
If this file exists, and is readable, then it will be viewed instead of
using `dired' to view the directory." :type 'string :group 'url-file)

(defcustom url-privacy-level '(email) "\
How private you want your requests to be.
HTTP has header fields for various information about the user, including
operating system information, email addresses, the last page you visited, etc.
This variable controls how much of this information is sent.

This should a symbol or a list.
Valid values if a symbol are:
none     -- send all information
low      -- don't send the last location
high     -- don't send the email address or last location
paranoid -- don't send anything

If a list, this should be a list of symbols of what NOT to send.
Valid symbols are:
email    -- the email address
os       -- the operating system info
lastloc  -- the last location
agent    -- do not send the User-Agent string
cookies  -- never accept HTTP cookies

Samples:

 (setq url-privacy-level 'high)
 (setq url-privacy-level '(email lastloc))    ;; equivalent to 'high
 (setq url-privacy-level '(os))

::NOTE::
This variable controls several other variables and is _NOT_ automatically
updated.  Call the function `url-setup-privacy-info' after modifying this
variable." :initialize 'custom-initialize-default :set (lambda (sym val) (set-default sym val) (url-setup-privacy-info)) :type '(radio (const :tag "None (you believe in the basic goodness of humanity)" :value none) (const :tag "Low (do not reveal last location)" :value low) (const :tag "High (no email address or last location)" :value high) (const :tag "Paranoid (reveal nothing!)" :value paranoid) (checklist :tag "Custom" (const :tag "Email address" :value email) (const :tag "Operating system" :value os) (const :tag "Last location" :value lastloc) (const :tag "Browser identification" :value agent) (const :tag "No cookies" :value cookie))) :group 'url)

(defcustom url-uncompressor-alist '((".z" . "x-gzip") (".gz" . "x-gzip") (".uue" . "x-uuencoded") (".hqx" . "x-hqx") (".Z" . "x-compress") (".bz2" . "x-bzip2")) "\
An alist of file extensions and appropriate content-transfer-encodings." :type '(repeat (cons :format "%v" (string :tag "Extension") (string :tag "Encoding"))) :group 'url-mime)

(defcustom url-mail-command 'compose-mail "\
This function will be called whenever URL needs to send mail.
It should enter a mail-mode-like buffer in the current window.
The commands `mail-to' and `mail-subject' should still work in this
buffer, and it should use `mail-header-separator' if possible." :type 'function :group 'url)

(defcustom url-proxy-services nil "\
An alist of schemes and proxy servers that gateway them.
Looks like ((\"http\" . \"hostname:portnumber\") ...).  This is set up
from the ACCESS_proxy environment variables." :type '(repeat (cons :format "%v" (string :tag "Protocol") (string :tag "Proxy"))) :group 'url)

(defcustom url-standalone-mode nil "\
Rely solely on the cache?" :type 'boolean :group 'url-cache)

(defcustom url-bad-port-list '("25" "119" "19") "\
List of ports to warn the user about connecting to.
Defaults to just the mail, chargen, and NNTP ports so you cannot be
tricked into sending fake mail or forging messages by a malicious HTML
document." :type '(repeat (string :tag "Port")) :group 'url-hairy)

(defcustom url-mime-language-string nil "\
String to send in the Accept-language: field in HTTP requests.

Specifies the preferred language when servers can serve documents in
several languages.  Use RFC 1766 abbreviations, e.g.: `en' for
English, `de' for German.  A comma-separated specifies descending
order of preference.  The ordering can be made explicit using `q'
factors defined by HTTP, e.g. `de,en-gb;q=0.8,en;q=0.7'.  `*' means
get the first available language (as opposed to the default)." :type '(radio (const :tag "None (get default language version)" :value nil) (const :tag "Any (get first available language version)" :value "*") (string :tag "Other")) :group 'url-mime :group 'i18n)

(defcustom url-max-password-attempts 5 "\
Maximum number of times a password will be prompted for.
Applies when a protected document is denied by the server." :type 'integer :group 'url)

(defcustom url-temporary-directory (or (getenv "TMPDIR") "/tmp") "\
Where temporary files go." :type 'directory :group 'url-file)

(defcustom url-show-status t "\
Whether to show a running total of bytes transferred.
Can cause a large hit if using a remote X display over a slow link, or
a terminal with a slow modem." :type 'boolean :group 'url)

(defcustom url-news-server nil "\
The default news server from which to get newsgroups/articles.
Applies if no server is specified in the URL.  Defaults to the
environment variable NNTPSERVER or \"news\" if NNTPSERVER is
undefined." :type '(choice (const :tag "None" :value nil) string) :group 'url)

(defcustom url-max-redirections 30 "\
The maximum number of redirection requests to honor in a HTTP connection.
A negative number means to honor an unlimited number of redirection requests." :type 'integer :group 'url)

(defcustom url-confirmation-func 'y-or-n-p "\
What function to use for asking yes or no functions.
Possible values are `yes-or-no-p' or `y-or-n-p', or any function that
takes a single argument (the prompt), and returns t only if a positive
answer is given." :type '(choice (const :tag "Short (y or n)" :value y-or-n-p) (const :tag "Long (yes or no)" :value yes-or-no-p) (function :tag "Other")) :group 'url-hairy)

(defcustom url-gateway-method 'native "\
The type of gateway support to use.
Should be a symbol specifying how to get a connection from the local machine.

Currently supported methods:
`telnet': Run telnet in a subprocess to connect;
`rlogin': Rlogin to another machine to connect;
`socks': Connect through a socks server;
`tls': Connect with TLS;
`ssl': Connect with SSL (deprecated, use `tls' instead);
`native': Connect directly." :type '(radio (const :tag "Telnet to gateway host" :value telnet) (const :tag "Rlogin to gateway host" :value rlogin) (const :tag "Use SOCKS proxy" :value socks) (const :tag "Use SSL/TLS for all connections" :value tls) (const :tag "Use SSL for all connections (obsolete)" :value ssl) (const :tag "Direct connection" :value native)) :group 'url-hairy)

;;;***

;;;### (autoloads (url-configuration-directory) "url" "lisp/url.el")
(defconst custom-define-current-source-file "url.el")

(defcustom url-configuration-directory (if (featurep 'xemacs) (or (and (file-accessible-directory-p (expand-file-name "~/.url/")) (expand-file-name "~/.url/")) (and (file-accessible-directory-p (expand-file-name user-init-directory)) (expand-file-name "url/" user-init-directory))) (locate-user-emacs-file "url/" ".url/")) "\
Directory used by the URL package for cookies, history, etc." :type 'directory :group 'url)

;;;***

;;;### (autoloads (w3-html-errors-font-lock-keywords w3-display-errors-hook w3-source-file-hook w3-mode-hook w3-load-hook w3-user-fonts-take-precedence w3-user-colors-take-precedence w3-honor-stylesheets w3-track-mouse w3-maximum-line-length w3-right-margin w3-reuse-buffers w3-popup-menu-on-mouse-3 w3-notify w3-netscape-compatible-comments w3-modeline-format w3-max-menu-width w3-max-menu-length w3-image-mappings w3-delay-image-loads w3-auto-image-alt w3-debug-buffer w3-debug-html w3-defined-link-types w3-do-incremental-display w3-use-unicode-table-characters w3-use-terminal-glyphs w3-use-terminal-characters-on-tty w3-use-terminal-characters w3-force-conversion-alist w3-horizontal-rule-char w3-echo-link w3-bullets w3-display-frames w3-documentation-root w3-explicit-encodings-file w3-hotlist-file w3-default-stylesheet w3-default-homepage w3-default-configuration-file w3-configuration-directory w3-hooks w3-display w3-parsing w3-menus w3-printing w3-images w3-files w3) "w3-cus" "lisp/w3-cus.el")
(defconst custom-define-current-source-file "w3-cus.el")

(defgroup w3 '((url custom-group)) "Emacs-W3 - the web browser of choice." :group 'hypermedia)

(defgroup w3-files nil "Emacs-W3 configuration files." :group 'w3 :prefix "w3-")

(defgroup w3-images nil "Controlling image handling." :group 'w3 :prefix "w3-")

(defgroup w3-printing nil "Various options for hardcopy from web pages." :group 'w3 :prefix "w3-")

(defgroup w3-menus nil "The look of menus in Emacs-W3" :group 'w3 :prefix "w3-")

(defgroup w3-parsing nil "Options relating to HTML parsing" :group 'w3 :prefix "w3-")

(defgroup w3-display nil "Variables relating to how web pages are displayed." :group 'w3 :prefix "w3-")

(defgroup w3-hooks nil "Hooks relating to Emacs-W3." :group 'w3 :prefix "w3-")

(defcustom w3-configuration-directory "~/.w3/" "\
Directory where Emacs-w3 can find its configuration files." :group 'w3-files :type 'directory)

(defcustom w3-default-configuration-file "profile" "\
Base filename where per-user customizations are kept.
This filename is relative to `w3-configuration-directory' if
not fully specified." :group 'w3-files :type 'string)

(defcustom w3-default-homepage nil "\
The url to open at startup.  It can be any valid URL.
This will default to the environment variable WWW_HOME if you do not
set it in your .emacs file.  If WWW_HOME is undefined, then it will
default to  the hypertext documentation for W3 at Indiana University." :group 'w3-files :type 'string)

(defcustom w3-default-stylesheet nil "\
The filename of the users default stylesheet." :group 'w3-files :type '(choice (const :tag "None" :value nil) (file)))

(defcustom w3-hotlist-file nil "\
*Hotlist filename.
This should be the name of a file that is stored in either
NCSA's Mosaic/X or Netscape/X format.  It is used to keep a listing
of commonly accessed URL's without having to go through 20 levels of
menus to get to them." :group 'w3-files :type 'file)

(defcustom w3-explicit-encodings-file nil "\
Explicit encodings filename.
This should be the name of a file that is used to keep user-specified
explicit encodings for URLs." :group 'w3-files :type 'file)

(defcustom w3-documentation-root "http://www.cs.indiana.edu/elisp/w3/" "\
Where the w3 documentation lives.  This MUST end in a slash." :group 'w3-files :type 'string)

(defcustom w3-display-frames t "\
*Fetch frames - can be:
nil		no frame display whatsoever
'as-links	display frame hyperlinks, but do not fetch them
'ask		display frame hyperlinks and ask whether to fetch them
t		display frame hyperlinks and fetch them." :group 'w3-display :type '(choice (const :tag "Do not display frames" :value nil) (const :tag "Show hyperlinks" :value as-links) (const :tag "Show hyperlinks, ask whether to retrieve them" :value ask) (const :tag "Automatically retrieve frames" :value t)))

(defcustom w3-bullets '((disc . ?*) (circle . ?o) (square . ?\#) (none . ?\ )) "\
An alist of unordered list types.
This maps to characters to use as the bullet character." :group 'w3-display :type '(repeat (cons :format "%v" (symbol :tag "Type") (character :tag "Character"))))

(defcustom w3-echo-link '(title url text name) "\
*Whether to display the URL of a link when tabbing through links.
Value is a list of one or more of the following symbols:

  url    == url of the target
  text   == text of the link
  title  == title attribute of the link
  name   == name or id attribute of the link

If none of the information is available, nothing will be shown for the link
in menus, etc." :group 'w3-display :type '(set (const :tag "URL" :value url) (const :tag "Link Text" :value text) (const :tag "Title of the link as defined in the HTML tag" :value title) (const :tag "Name of the link as defined in the HTML tag" :value name)))

(defcustom w3-horizontal-rule-char nil "\
The character to use to create a horizontal rule.
Must be the character's code, not a string.  This character is
replicated across the screen to create a division.
If nil W3 will use a terminal graphic character if possible." :group 'w3-display :type '(choice (const :tag "Best possible" :value nil) (character)))

(defcustom w3-force-conversion-alist nil "\
*An alist of URL host/filename regexps and coding systems to use for them." :group 'w3-display :type (backquote (repeat (cons (string :tag "Host / filename") (symbol :tag "Coding system" :value binary)))))

(defcustom w3-use-terminal-characters nil "\
*Use terminal graphics characters for drawing tables and rules if available." :group 'w3-display :type 'boolean)

(defcustom w3-use-terminal-characters-on-tty nil "\
*Use terminal graphics characters for tables and rules even on a tty.
This triggers display bugs on both Emacs and XEmacs.
\(Though it's usually tolerable at least in Emacs.)" :group 'w3-display :type 'boolean)

(defcustom w3-use-terminal-glyphs nil "\
*Use glyphs if possible rather than properties for terminal graphics characters.

Glyphs are probably more efficient but don't work with the most recent versions
of XEmacs and there are some cute tricks we can play with text-properties that
glyphs won't let us do. It may be possible someday to make XEmacs automagically
translate the characters back to ascii characters when pasted into another
buffer. (On the other hand, right now `w3-excise-terminal-characters' doesn't
work at all if we're using text-properties)." :group 'w3-display :type '(choice (const :tag "Use Glyphs" :value t) (const :tag "Use Text Properties" :value nil)))

(defcustom w3-use-unicode-table-characters nil "\
*Non-nil means use Unicode box-drawing characters for tables if avilable.
This only works for Emacs 21.  You might wat to turn this off if your
Unicode font isn't available in appropriate sizes." :group 'w3-display :type 'boolean)

(defcustom w3-do-incremental-display nil "\
*Non-nil means do incremental display of pages." :group 'w3-display :type 'boolean)

(defcustom w3-defined-link-types '("previous" "next" "up" "down" "home" "toc" "index" "glossary" "copyright" "bookmark" "help" "made" "contents" "top") "\
A list of the (lower-case) names which have special significance.
The significance is when they are used as the values of REL or REV
attributes of <link> elements.  They will be presented on the toolbar
or the links menu, for instance." :group 'w3-display :type '(repeat string))

(defcustom w3-debug-html nil "\
*Non-nil means to gripe about bad HTML." :group 'w3-parsing :type '(choice (const :tag "HTML Errors" :value t) (const :tag "Errors and stylistic issues" :value style) (const :tag "None" :value nil)))

(defcustom w3-debug-buffer "*HTML Debug*" "\
Name of buffer to store debugging information in." :group 'w3-parsing :type 'string)

(defcustom w3-auto-image-alt 'w3-default-image-alt-func "\
*Whether to create an alt attribute for an image that is missing it.
If nil, Emacs-W3 will not automatically create an ALT attribute.

If a string, it should be a string suitable for running through format,
with only one %s, which will be replaced with just the filename of the
graphic that is not loaded.

Otherwise, it is considered a function and is passed a single
argument, the filename of the graphic that is not loaded." :group 'w3-images :type '(choice (const :tag "None" :value nil) (const :tag "Default" :value "[IMAGE(%s)]") (string :tag "Format string") (sexp :tag "Function" :value nil)))

(defcustom w3-delay-image-loads (not (or (and (fboundp 'display-images-p) (display-images-p)) (featurep 'gif) (featurep 'jpeg) (featurep 'imagick) (featurep 'png))) "\
*Non-nil means delay loading images, not automatically retrieve them." :group 'w3-images :type 'boolean)

(defcustom w3-image-mappings '(("image/x-xbitmap" . xbm) ("image/xbitmap" . xbm) ("image/xbm" . xbm) ("image/jpeg" . jpeg) ("image/gif" . gif) ("image/png" . png) ("image/x-fax" . g3fax) ("image/x-raster" . rast) ("image/windowdump" . xwd) ("image/x-icon" . icon) ("image/portable-graymap" . pgm) ("image/portable-pixmap" . ppm) ("image/x-pixmap" . xpm) ("image/x-xpixmap" . xpm) ("image/pict" . pict) ("image/x-rgb" . sgi) ("image/x-sgi" . sgi) ("image/x-macpaint" . macpt) ("image/x-targa" . tga) ("image/tiff" . tiff)) "\
How to map MIME types to image types for the `image' package.
Each entry is a cons cell of MIME types and image-type symbols." :group 'w3-images :type '(repeat (cons :format "%v" (string :tag "MIME Type") (symbol :tag "Image type"))))

(defcustom w3-max-menu-length 35 "\
The maximum length of a pulldown menu.
This is the length before it will be split into smaller chunks, with
the first part as a submenu, followed by the rest of the menu." :group 'w3-menus :type 'integer)

(defcustom w3-max-menu-width 40 "\
*The maximum width of a pulldown menu choice." :group 'w3-menus :type 'integer)

(defcustom w3-modeline-format '("  " ("W3" (w3-netscape-emulation-minor-mode " (NS)") (w3-lynx-emulation-minor-mode " (Lynx)") ": " (40 (-40 "%b")) " " (w3-current-isindex "[Searchable]  ") (w3-current-badhtml "[BAD HTML]  ") "%p" "  " global-mode-string)) "\
The modeline format string when in w3 mode." :group 'w3-advanced :type 'sexp)

(defcustom w3-netscape-compatible-comments nil "\
*Whether to honor netscape-style <! > comments." :group 'w3-parsing :type 'boolean)

(defcustom w3-notify 'semibully "\
*Selects the behavior when w3 page is ready.
This variable may have one of the following values:

newframe   -- put the w3 page in its own frame
bully      -- make the w3 page the current buffer and only window
semibully  -- make the w3 page the current buffer in the same window
aggressive -- make the w3 page the current buffer in the other window
friendly   -- display  w3page in other window but don't make current
polite     -- don't display w3 page, but prints message when ready (beeps)
quiet      -- like `polite', but don't beep
meek       -- make no indication that page is ready

Any other value of `w3-notify' is equivalent to `meek'." :group 'w3-display :type '(choice (const :tag "Display in a new frame" :value newframe) (const :tag "Display in the current window, select buffer, and kill other windows" :value bully) (const :tag "Display in the current window, select buffer" :value semibully) (const :tag "Display in another window, select buffer" :value aggressive) (const :tag "Display in another window, but do not select it" :value friendly) (const :tag "Do not display page, but show a message and beep" :value polite) (const :tag "Do not display page, but show a message (no beep)" :value quiet) (const :tag "Do not indicate that the page has been retrieved" :value meek)))

(defcustom w3-popup-menu-on-mouse-3 t "\
*Non-nil value means W3 should provide context-sensitive menus on mouse-3.
A nil value means W3 should not change the binding of mouse-3." :group 'w3-display :type 'boolean)

(defcustom w3-reuse-buffers 'yes "\
What to do when following a link will re-fetch a document.
This means a document that has already been fetched into a W3 buffer.
Possible values are: nil, `yes', and `no'.  Nil means ask the user if
we should reuse the buffer.  A value of 'yes means assume the user
wants us to reuse the buffer.  A value of 'no means assume the user
wants us to re-fetch the document.

This will also accept:
'no	==> always reload
'yes	==> always reuse
'ask	==> always ask" :group 'w3-display :type '(choice (const :tag "Always reload" :value no) (const :tag "Always reuse" :value yes) (const :tag "Always ask" :value ask)))

(defcustom w3-right-margin 2 "\
*Default right margin for Emacs-W3 buffers.
This amount is subtracted from (window-width) for each new WWW buffer
and used as the new fill column." :group 'w3-display :type 'integer)

(defcustom w3-maximum-line-length nil "\
*Maximum length of a line.
If nil, then lines can extend all the way to the window margin." :group 'w3-display :type '(radio (const :tag "Use all available space" :value nil) (integer :tag "Limit to")))

(defcustom w3-track-mouse t "\
*Non-nil means track the mouse and message the url under the mouse." :group 'w3-display :type 'boolean)

(defcustom w3-honor-stylesheets nil "\
*Whether to let a document specify a CSS stylesheet." :group 'w3-display :type 'boolean)

(defcustom w3-user-colors-take-precedence nil "\
*Non-nil means don't let a document define certain colors itself.
Like foreground and background colors and pixmaps, color of links and
visited links, etc." :group 'w3-display :type 'boolean)

(defcustom w3-user-fonts-take-precedence nil "\
*Non-nil means don't let a document define certain fonts.
Certain fonts can cause problems under Emacs." :group 'w3-display :type 'boolean)

(defcustom w3-load-hook nil "\
Hook run after loading w3." :group 'w3-hooks :type 'hook)

(defcustom w3-mode-hook nil "\
Hook run after entering W3 mode." :group 'w3-hooks :type 'hook)

(defcustom w3-source-file-hook nil "\
Hook run after getting document source." :group 'w3-hooks :type 'hook)

(defcustom w3-display-errors-hook nil "\
Hook run after displaying HTML errors for a page." :group 'w3-hooks :type 'hook)

(defcustom w3-html-errors-font-lock-keywords '(("\\(HTML errors for\\) \\(.*\\)" (1 font-lock-function-name-face) (2 font-lock-reference-face)) ("Empty \\([A-Z0-9]+\\) element." (1 font-lock-type-face)) ("Bad attribute name syntax: \\(.*\\)" (1 font-lock-type-face)) ("Bad attribute value syntax: \\(.*\\)" (1 font-lock-type-face)) ("Evil attribute value syntax: \\(.*\\)" (1 font-lock-type-face)) ("Attribute value missing end quote: \\(.*\\)" (1 font-lock-type-face)) ("Bad start-tag \\([A-Z0-9]+\\)" (1 font-lock-type-face)) ("\\([A-Z0-9]+\\) element has no \\([A-Z0-9]+\\) attribute" (1 font-lock-type-face) (2 font-lock-type-face)) (", inferring \\(</?[A-Z0-9]+>\\)" (1 font-lock-type-face)) ("Bad unclosed \\([A-Z0-9]+\\) tag" (1 font-lock-type-face)) ("Bad comment (unterminated or unbalanced \"\\(--\\)\" pairs)" (1 font-lock-type-face t)) ("Obsolete element \\(.*\\)" (1 font-lock-type-face)) ("Deprecated element \\(.*\\)" (1 font-lock-type-face)) ("\\[deprecated inside \\([A-Z0-9]+\\)\\]" (1 font-lock-type-face)) ("\\(</[A-Z0-9]+>\\) end-tag not omissible (required due to \\(</?[A-Z0-9]+>\\) end-tag)" (1 font-lock-type-face) (2 font-lock-type-face)) ("Bad data characters [\\([^][]\\)], " (1 font-lock-comment-face)) ("Bad \\(<!\\) syntax." (1 font-lock-type-face)) ("Unterminated IGNORE marked section.") ("Invalid SGML character: \\(.\\)" (1 font-lock-type-face)) ("Unmatched end-tag \\(</[A-Z0-9]+>\\)" (1 font-lock-type-face)) ("^  [A-Z][a-zA-Z0-9 ]*: .*" . font-lock-comment-face) ("^  [A-Z][a-zA-Z0-9 ]*: " . font-lock-comment-face) ("\\*ERROR\\*" 0 font-lock-keyword-face t)) "\
Font locking keywords used for HTML error display." :group 'w3 :type 'sexp)

;;;***

;;;### (autoloads (w3-dummy-img-alt-repl w3-dummy-img-re w3-min-img-size) "w3-display" "lisp/w3-display.el")
(defconst custom-define-current-source-file "w3-display.el")

(defcustom w3-min-img-size 15 "\
*Image size under which the alt string is replaced by `w3-dummy-img-alt-repl'.
15 is a bit aggressive, 5 pixels would be safer" :group 'w3-images :type 'integer)

(defcustom w3-dummy-img-re "\\b\\(boule\\|bullet\\|dot\\|pebble[0-9]*[a-z]?[0-9]*\\|pixel\\)\\b" "\
Image name regexp for which the alt string is replaced by `w3-dummy-img-alt-repl'." :group 'w3-images :type 'regexp)

(defcustom w3-dummy-img-alt-repl "*" "\
*Dummy image alt string replacement." :group 'w3-images :type 'string)

;;;***

;;;### (autoloads (w3-java-vm-arguments w3-java-vm-program w3-java) "w3-java" "lisp/w3-java.el")
(defconst custom-define-current-source-file "w3-java.el")

(defgroup w3-java nil "Emacs/W3 Java Runtime support" :prefix "w3-java" :group 'w3)

(defcustom w3-java-vm-program "hotjava" "\
*The program name of the Java virtual machine." :type '(choice (string :tag "External program") (function :tag "Lisp function")) :group 'w3-java)

(defcustom w3-java-vm-arguments '(file) "\
*Arguments that should be passed to the program `w3-java-vm-program'.
The special symbol 'file may be used in the list of arguments and will
be replaced with the name of a file containing the commands to run a
Java applet." :type 'list :group 'w3-java)

;;;***

;;;### (autoloads (w3-use-menus) "w3-menu" "lisp/w3-menu.el")
(defconst custom-define-current-source-file "w3-menu.el")

(defcustom w3-use-menus '(file edit view go bookmark options buffers style emacs nil help) "\
*Non-nil value causes W3 to provide a menu interface.
A value that is a list causes W3 to install its own menubar.
A value of 1 causes W3 to install a \"W3\" item in the Emacs menubar.

If the value of w3-use-menus is a list, it should be a list of symbols.
The symbols and the order that they are listed determine what menus
will be in the menubar and how they are ordered.  Valid symbol values
are:

file		-- A list of file related commands
edit		-- Various standard editing commands (copy/paste)
view		-- Controlling various things about the document view
go		-- Navigation control
bookmark	-- Bookmark / hotlist control
options		-- Various options
buffers		-- The standard buffers menu
emacs		-- A toggle button to switch back to normal emacs menus
style		-- Control style information and who gets to set what
search          -- Various search engines
help		-- The help menu
nil		-- ** special **

If nil appears in the list, it should appear exactly once.  All
menus after nil in the list will be displayed flushright in the
menubar.

NOTE!  The current port of Emacs to Windows NT/95 does not support
buttons in the menubar, so the 'emacs' keyword is currently ignored
on that platform." :group 'w3-menus :type '(set (const :tag "File related commands" :value file) (const :tag "Standard editing commands" :value edit) (const :tag "View document information" :value view) (const :tag "Navigation" :value go) (const :tag "Bookmarks" :value bookmark) (const :tag "Options" :value options) (const :tag "Buffer list" :value buffers) (const :tag "Stylesheet information" :value style) (const :tag "Search engines" :value search) (const :tag "Toggle to default menus" :value emacs) (const :tag "Separator" :value nil) (const :tag "Help" :value help)))

;;;***

;;;### (autoloads (w3-parse-hooks) "w3-parse" "lisp/w3-parse.el")
(defconst custom-define-current-source-file "w3-parse.el")

(defcustom w3-parse-hooks nil "\
*List of hooks to be run before parsing." :type 'hook :group 'w3-display :options '(w3-parse-munge-ethiopic-text))

;;;***

(provide 'w3-custom-defines)
