;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'x-symbol-custom-defines) (error "Feature x-symbol-custom-defines already loaded"))

;;;### (autoloads (x-symbol-bib-class-face-alist x-symbol-bib-class-alist x-symbol-bib-electric-ignore x-symbol-bib-header-groups-alist x-symbol-bib-modeline-name x-symbol-bib-auto-style) "x-symbol-bib" "lisp/x-symbol-bib.el")
(defconst custom-define-current-source-file "x-symbol-bib.el")

(defcustom x-symbol-bib-auto-style '(t nil nil nil nil nil) "\
Values for X-Symbol's buffer-local variables with language `bib'.
See language access `x-symbol-LANG-auto-style'." :group 'x-symbol-bib :group 'x-symbol-mode :type 'x-symbol-auto-style)

(defcustom x-symbol-bib-modeline-name "bib" "\
Modeline name of token language `bib'.
See language access `x-symbol-LANG-modeline-name'." :group 'x-symbol-bib :type 'string)

(defcustom x-symbol-bib-header-groups-alist x-symbol-tex-header-groups-alist "\
Header/submenu specification of the specific menu for language `bib'.
See language access `x-symbol-LANG-header-groups-alist'." :group 'x-symbol-bib :group 'x-symbol-input-init :type 'x-symbol-headers)

(defcustom x-symbol-bib-electric-ignore x-symbol-tex-electric-ignore "\
Specification restricting input method ELECTRIC with language `bib'.
See language access `x-symbol-LANG-electric-ignore'." :group 'x-symbol-bib :group 'x-symbol-input-control :type 'x-symbol-function-or-regexp)

(defcustom x-symbol-bib-class-alist x-symbol-tex-class-alist "\
Token classes displayed by info in echo area, for language `bib'.
See language access `x-symbol-LANG-class-alist'." :group 'x-symbol-bib :group 'x-symbol-info-strings :type 'x-symbol-class-info)

(defcustom x-symbol-bib-class-face-alist x-symbol-tex-class-face-alist "\
Color scheme in language specific grid and info, for language `bib'.
See language access `x-symbol-LANG-class-face-alist'." :group 'x-symbol-bib :group 'x-symbol-input-init :group 'x-symbol-info-general :type 'x-symbol-class-faces)

;;;***

;;;### (autoloads (x-symbol-image-convert-colormap x-symbol-image-colormap-allocation x-symbol-auto-style-alist x-symbol-auto-8bit-search-limit x-symbol-auto-mode-suffixes x-symbol-texi-modes x-symbol-texi-name x-symbol-bib-modes x-symbol-bib-name x-symbol-sgml-modes x-symbol-sgml-name x-symbol-tex-modes x-symbol-tex-name x-symbol-charsym-name x-symbol-auto-key-autoload x-symbol-compose-key x-symbol-initialize) "x-symbol-hooks" "lisp/x-symbol-hooks.el")
(defconst custom-define-current-source-file "x-symbol-hooks.el")

(defcustom x-symbol-initialize t "\
Whether to do an extended initialization of package X-Symbol.
If t, do full initialization.  Otherwise, the value should be a list
with element.  To enable, include

 * `languages' to register all supported token languages,
 * `global' to turn on X-Symbol's global mode, i.e., as files are
   loaded, execute `turn-on-x-symbol-conditionally',
 * `keys' to set up the usual X-Symbol key bindings in `global-map',
 * `font-path' to add `x-symbol-font-directory' to the font-path,
 * `comint' to make X-Symbol work with comint,
 * `fast-lock' to make X-Symbol work with fast-lock,
 * `auctex' to make X-Symbol optimally work with AucTeX 9.8a+, it
   changes AucTeX's `TeX-region-hook', `TeX-translate-location-hook',
   and `LaTeX-math-insert-function',
 * `reftex' to make X-Symbol optimally work with RefTeX 3.26+,
 * `bib-cite' to make X-Symbol not overwriting bib-cite's highlighting.

You do not have to install the packages whose initialization is
enabled." :group 'x-symbol-mode :type '(choice (const :tag "All" t) (set :value (languages global keys font-path comint fast-lock auctex reftex bib-cite) (const :tag "Token languages" languages) (const :tag "Global mode" global) (const :tag "Key bindings" keys) (const :tag "Font path" font-path) (const :tag "Package comint" comint) (const :tag "Package fast-lock" fast-lock) (const :tag "Package AucTeX" auctex) (const :tag "Package RefTeX" reftex) (const :tag "Package bib-cite" bib-cite))))

(defcustom x-symbol-compose-key '(control ?=) "\
Key used to access command `x-symbol-map'.
By default, pressing this key twice invokes the GRID: \\[x-symbol-grid].
This is a list, no vector!" :group 'x-symbol-input-init :type '(x-symbol-key :tag "Prefix key"))

(defcustom x-symbol-auto-key-autoload t "\
*If non-nil, pressing `x-symbol-compose-key' initialize x-symbol.
The binding of `x-symbol-compose-key' is redefined after initialization.
With value nil, you must provide a prefix argument to initialize package
X-Symbol." :group 'x-symbol-input-init :type 'boolean)

(defcustom x-symbol-charsym-name "x-symbol charsym" "\
Standard name of the pseudo token language x-symbol charsym.
See language access `x-symbol-LANG-name'.  The pseudo language
corresponds to `x-symbol-language' having value nil and is only used for
input methods.  See `x-symbol-language-text'." :group 'x-symbol-miscellaneous :type 'string)

(defcustom x-symbol-tex-name "TeX macro" "\
Standard name of token language `tex'.
See language access `x-symbol-LANG-name'." :group 'x-symbol-tex :type 'string)

(defcustom x-symbol-tex-modes '(tex-mode latex-mode plain-tex-mode noweb-mode) "\
Major modes typically using X-Symbol with token language `tex'.
See language access `x-symbol-LANG-modes'." :group 'x-symbol-tex :group 'x-symbol-mode :type '(repeat function))

(defcustom x-symbol-sgml-name "SGML entity" "\
Standard name of token language `sgml'.
See language access `x-symbol-LANG-name'." :group 'x-symbol-sgml :type 'string)

(defcustom x-symbol-sgml-modes '(html-mode hm--html-mode html-helper-mode) "\
Major modes typically using X-Symbol with language `sgml'.
See language access `x-symbol-LANG-modes'." :group 'x-symbol-sgml :group 'x-symbol-mode :type '(repeat function))

(defcustom x-symbol-bib-name "BibTeX macro" "\
Standard name of token language `bib'.
See language access `x-symbol-LANG-name'." :group 'x-symbol-bib :type 'string)

(defcustom x-symbol-bib-modes '(bibtex-mode) "\
Major modes typically using X-Symbol with language `bib'.
See language access `x-symbol-LANG-modes'." :group 'x-symbol-bib :group 'x-symbol-mode :type '(repeat function))

(defcustom x-symbol-texi-name "TeXinfo command" "\
Standard name of token language `texi'.
See language access `x-symbol-LANG-name'." :group 'x-symbol-texi :type 'string)

(defcustom x-symbol-texi-modes '(texinfo-mode) "\
Major modes typically using X-Symbol with language `texi'.
See language access `x-symbol-LANG-modes'." :group 'x-symbol-texi :group 'x-symbol-mode :type '(repeat function))

(defcustom x-symbol-auto-mode-suffixes (x-symbol-auto-mode-suffixes) "\
*Regexps matching file suffixes not to be considered.
All suffixes from a file name matching these regexps are deleted before
the file name is used for `x-symbol-auto-mode-alist'.  The default value
includes the REGEXP in all three-valued elements of `auto-mode-alist',
at definition time, of course." :group 'x-symbol-mode :type '(repeat regexp))

(defcustom x-symbol-auto-8bit-search-limit nil "\
*Limits search for 8bit characters in the file.
Used when finding an appropriate value for `x-symbol-8bits'.  See also
`x-symbol-mode'." :group 'x-symbol-mode :type '(choice (const :tag "No limit" nil) (integer :tag "Limit")))

(defcustom x-symbol-auto-style-alist nil "\
*Alist to setup X-Symbol values for buffers visiting files.
Elements look like
  (MATCH LANGUAGE MODE-ON CODING 8BITS UNIQUE SUBSCRIPTS IMAGE)
or
  (MATCH LANGUAGE . VARIABLE)

If MATCH matches a buffer in which command `x-symbol-mode' is invoked,
the rest of the element is used to setup some buffer-local x-symbol
specific variables.  If no element matches, set `x-symbol-language' to
the symbol property `x-symbol-language' of the major mode symbol if the
variable is not already buffer-local.

If `x-symbol-mode' is not already buffer-local, MODE-ON determines
whether to turn the mode on with `turn-on-x-symbol-conditionally'.
LANGUAGE, CODING, 8BITS, UNIQUE, SUBSCRIPTS and IMAGE are used to set
`x-symbol-language', `x-symbol-coding', `x-symbol-8bits',
`x-symbol-unique', `x-symbol-subscripts' and `x-symbol-image' if these
values are not already buffer-local.

MATCH is either a list of major modes which must include the mode of the
current buffer or a regexp matching the file name ignoring some
suffixes, see `x-symbol-auto-mode-suffixes', or a value used directly.

MODE-ON, LANGUAGE, CODING, 8BITS, UNIQUE, SUBSCRIPTS and IMAGE are
`eval'ed in that order.  During the evaluation, `x-symbol-mode' is
non-nil according to MODE-ON.

VARIABLE is a symbol whose value contains the above mentioned values,
see the language access `x-symbol-LANG-auto-style'." :group 'x-symbol-mode :type '(repeat (cons :format "%v" (choice (repeat :tag "In major modes" :menu-tag "In major modes" (function :value text-mode)) (regexp :tag "When matched by") (function :tag "Predicate")) (cons :format "%v" (symbol :tag "Token language") (choice (x-symbol-auto-style :menu-tag "Values" :format "
%v") (variable :tag "Like variable"))))))

(defcustom x-symbol-image-colormap-allocation 'xpm "\
If non-nil, prevent colors in colormap to be de-allocated.
The non-nil value should be an image format.  See
`x-symbol-image-convert-colormap'." :group 'x-symbol-image-general :initialize 'custom-initialize-default :set 'x-symbol-image-set-colormap :type '(choice (const :tag "Colors can be de-allocated" nil) (const :tag "Colormap is xpm file" xpm) (symbol :tag "Other image format")))

(defcustom x-symbol-image-convert-colormap (and x-symbol-data-directory (expand-file-name "colormap138.xpm" x-symbol-data-directory)) "\
File name of colormap files.
Used by `x-symbol-image-start-convert-colormap' for image cache file
names not matched by `x-symbol-image-convert-mono-regexp'.  See also
`x-symbol-image-colormap-allocation'." :group 'x-symbol-image-general :initialize 'custom-initialize-default :set 'x-symbol-image-set-colormap :type '(choice (const :tag "No map" nil) file))

;;;***

;;;### (autoloads (x-symbol-sgml-font-lock-alist x-symbol-sgml-font-lock-contents-regexp x-symbol-sgml-font-lock-limit-regexp x-symbol-sgml-font-lock-regexp x-symbol-sgml-subscript-matcher x-symbol-sgml-image-keywords x-symbol-sgml-image-file-truename-alist x-symbol-sgml-image-cached-dirs x-symbol-sgml-image-searchpath x-symbol-sgml-master-directory x-symbol-sgml-electric-ignore x-symbol-sgml-class-face-alist x-symbol-sgml-class-alist x-symbol-sgml-header-groups-alist x-symbol-sgml-modeline-name x-symbol-sgml-auto-coding-alist x-symbol-sgml-auto-style) "x-symbol-sgml" "lisp/x-symbol-sgml.el")
(defconst custom-define-current-source-file "x-symbol-sgml.el")

(defcustom x-symbol-sgml-auto-style '((not (memq major-mode '(sgml-mode xml-mode))) (x-symbol-auto-coding-alist x-symbol-sgml-auto-coding-alist) x-symbol-coding (not x-symbol-mode) x-symbol-mode x-symbol-mode) "\
Values for X-Symbol's buffer-local variables with language `sgml'.
See language access `x-symbol-LANG-auto-style'." :group 'x-symbol-sgml :group 'x-symbol-mode :type 'x-symbol-auto-style)

(defcustom x-symbol-sgml-auto-coding-alist '(("<meta\\s-+http-equiv\\s-*=\\s-*\"content-type\"\\s-*content\\s-*=\\s-*\"text/html\\s-*;\\s-*charset\\s-*=\\s-*\\([A-Za-z0-9---]+\\)\"\\s-*>" 1 ("iso-8859-1" . iso-8859-1) ("iso-8859-2" . iso-8859-2) ("iso-8859-3" . iso-8859-3) ("iso-8859-9" . iso-8859-9) ("iso-8859-15" . iso-8859-15))) "\
*Alist used to determine the file coding with language `sgml'.
Used in the default value of `x-symbol-sgml-auto-style'.  See variable
`x-symbol-auto-coding-alist' for details." :group 'x-symbol-sgml :group 'x-symbol-mode :type 'x-symbol-auto-coding)

(defcustom x-symbol-sgml-modeline-name "sgml" "\
Modeline name of token language `sgml'.
See language access `x-symbol-LANG-modeline-name'." :group 'x-symbol-sgml :type 'string)

(defcustom x-symbol-sgml-header-groups-alist '(("Operator" bigop operator) ("Relation" relation) ("Arrow, Punctuation" arrow triangle shape white line dots punctuation quote parenthesis) ("Symbol" symbol currency mathletter setsymbol) ("Greek Letter" greek greek1) ("Misc. Letter" letter slash) ("Cedilla, Ogonek" cedilla ogonek) ("Dotaccent, Ring" dotaccent ring) ("Tilde, Breve" tilde breve) ("Circumflex, Caron" circumflex caron) ("Diaeresis, Umlaut" diaeresis hungarumlaut) ("Acute, Grave" acute grave)) "\
Header/submenu specification of the specific menu for language `sgml'.
See language access `x-symbol-LANG-header-groups-alist'." :group 'x-symbol-sgml :group 'x-symbol-input-init :type 'x-symbol-headers)

(defcustom x-symbol-sgml-class-alist '((symbol) (noname "SGML char-ref" (x-symbol-emph-info-face)) (VALID "SGML entity" (x-symbol-info-face)) (INVALID "no SGML entity" (x-symbol-emph-info-face))) "\
Token classes displayed by info in echo area, for language `sgml'.
See language access `x-symbol-LANG-class-alist'." :group 'x-symbol-sgml :group 'x-symbol-info-strings :type 'x-symbol-class-info)

(defcustom x-symbol-sgml-class-face-alist '((symbol x-symbol-sgml-symbol-face (x-symbol-sgml-symbol-face)) (noname x-symbol-sgml-noname-face (x-symbol-sgml-noname-face))) "\
Color scheme in language specific grid and info, for language `sgml'.
See language access `x-symbol-LANG-class-face-alist'." :group 'x-symbol-sgml :group 'x-symbol-input-init :group 'x-symbol-info-general :type 'x-symbol-class-faces)

(defcustom x-symbol-sgml-electric-ignore nil "\
Specification restricting input method ELECTRIC with language `sgml'.
See language access `x-symbol-LANG-electric-ignore'." :group 'x-symbol-sgml :group 'x-symbol-input-control :type 'x-symbol-function-or-regexp)

(defcustom x-symbol-sgml-master-directory 'ignore "\
Function returning the directory of the master file or nil.
See `x-symbol-image-parse-buffer'." :group 'x-symbol-sgml :group 'x-symbol-image-language :type 'function)

(defcustom x-symbol-sgml-image-searchpath '("./") "\
Search path for implicitly relative image file names.
See language access `x-symbol-LANG-image-searchpath'." :group 'x-symbol-sgml :group 'x-symbol-image-language :type '(repeat directory))

(defcustom x-symbol-sgml-image-cached-dirs '("images/" "pictures/") "\
Directory parts of images stored in the memory cache.
See language access `x-symbol-LANG-image-cached-dirs'." :group 'x-symbol-sgml :group 'x-symbol-image-language :type '(repeat string))

(defcustom x-symbol-sgml-image-file-truename-alist '(("\\`file:" . "") ("\\`[A-Za-z]+:")) "\
Alist used to determine the file name of an image URL.
Each element looks like
  (REGEXP) or
  (REGEXP . NEWTEXT) or
  (REGEXP FUNCTION ARG...)
If the the image file name is matched by REGEXP, the corresponding
element is processed, if no REGEXP matches, the image file name is used
as it is.  With the first form, the image command will not be
highlighted.  With the second form, replace text matched by REGEXP with
NEWTEXT, see `replace-match' for details.  With the third form,
FUNCTION, call FUNCTION with the image file name and the remaining
arguments ARGs to get the true file name.

E.g., I add the following element to this variable:
  (\"\\\\`http://www\\\\.fmi\\\\.uni-passau\\\\.de/~wedler/\" . \"~/public_html/\")" :group 'x-symbol-sgml :group 'x-symbol-image-language :type '(repeat (cons :format "%v" :value ("" . "") regexp (choice (const :tag "Not highlighted" nil) (string :tag "Replace match with") (cons :tag "Call" function (repeat :tag "With arguments" sexp))))))

(defcustom x-symbol-sgml-image-keywords '("\\.\\(gif\\|png\\|jpe?g\\)\\'" ("<img[ 	][^\n>]*src=\"\\([^\n\"]+\\)\"[^\n>]*>" x-symbol-sgml-image-file-truename 1)) "\
Keywords for image insertion commands of language `sgml'.
See language access `x-symbol-LANG-image-keywords'." :group 'x-symbol-sgml :group 'x-symbol-image-language :type 'x-symbol-image-keywords)

(defcustom x-symbol-sgml-subscript-matcher 'x-symbol-sgml-subscript-matcher "\
Function matching super-/subscripts for language `sgml'.
See language access `x-symbol-LANG-subscript-matcher'." :group 'x-symbol-sgml :type 'function)

(defcustom x-symbol-sgml-font-lock-regexp "<su[bp]>" "\
Regexp matching the start tag of SGML's super- and subscripts.
See also `x-symbol-sgml-font-lock-alist'." :group 'x-symbol-sgml :type 'regexp)

(defcustom x-symbol-sgml-font-lock-limit-regexp "\n\\|</?su[bp]>" "\
Regexp matching the end tag of SGML's super- and subscripts.
This regexp should match the end of line and the closing tags in
`x-symbol-sgml-font-lock-alist'." :group 'x-symbol-sgml :type 'regexp)

(defcustom x-symbol-sgml-font-lock-contents-regexp "[^ 	\n]" "\
*Regexp matching the super- and subscript contents.
This regexp should match the text between the opening and closing super-
or subscript tag." :group 'x-symbol-sgml :type 'regexp)

(defcustom x-symbol-sgml-font-lock-alist '(("<sub>" . "</sub>") ("<sup>" . "</sup>")) "\
Alist for correct tag pairs for HTML's super- and subscripts.
Each element looks like (OPEN . CLOSE).  All keys OPEN in this alist
should be matched by `x-symbol-sgml-font-lock-regexp', all CLOSEs should
be matched by `x-symbol-sgml-font-lock-limit-regexp'." :group 'x-symbol-sgml :type '(repeat (cons :format "%v" (string :tag "Open tag") (string :tag "Close tag"))))

;;;***

;;;### (autoloads (x-symbol-tex-class-face-alist x-symbol-tex-class-alist x-symbol-tex-font-lock-allowed-faces x-symbol-tex-invisible-braces x-symbol-tex-subscript-matcher x-symbol-tex-image-keywords x-symbol-tex-image-cached-dirs x-symbol-tex-image-searchpath x-symbol-tex-master-directory x-symbol-tex-token-suppress-space x-symbol-tex-electric-ignore-regexp x-symbol-tex-electric-ignore x-symbol-tex-header-groups-alist x-symbol-tex-modeline-name x-symbol-tex-coding-master x-symbol-tex-auto-coding-alist x-symbol-tex-auto-style) "x-symbol-tex" "lisp/x-symbol-tex.el")
(defconst custom-define-current-source-file "x-symbol-tex.el")

(defcustom x-symbol-tex-auto-style '((if buffer-file-name (string-match "\\.tex\\'" buffer-file-name) t) (if x-symbol-mode (x-symbol-auto-coding-alist x-symbol-tex-auto-coding-alist nil (if x-symbol-tex-coding-master 'x-symbol-tex-auto-coding-alist))) x-symbol-coding (not x-symbol-mode) x-symbol-mode x-symbol-mode) "\
Values for X-Symbol's buffer-local variables with language `tex'.
See language access `x-symbol-LANG-auto-style'." :group 'x-symbol-tex :group 'x-symbol-mode :type 'x-symbol-auto-style)

(defcustom x-symbol-tex-auto-coding-alist '(("\\\\usepackage[ 	]*\\[\\([A-Za-z]+[0-9]+\\)\\]{inputenc}" 1 ("latin1" . iso-8859-1) ("latin2" . iso-8859-2) ("latin3" . iso-8859-3) ("latin5" . iso-8859-9) ("latin9" . iso-8859-15)) ("\\`[ 	]*%&.*[  	]+--?translate-file[ 	]*=[ 	]*i\\([A-Za-z]+[0-9]+\\)-" 1 ("l1" . iso-8859-1) ("l2" . iso-8859-2))) "\
*Alist used to determine the file coding with language `tex'.
Used in the default value of `x-symbol-tex-auto-style'.  See variable
`x-symbol-auto-coding-alist' for details." :group 'x-symbol-tex :group 'x-symbol-mode :type 'x-symbol-auto-coding)

(defcustom x-symbol-tex-coding-master 'TeX-master "\
*If non-nil, symbol of local variable with name of master file.
Used inside function `x-symbol-tex-auto-coding-alist'." :group 'x-symbol-tex :group 'x-symbol-mode :type 'boolean)

(defcustom x-symbol-tex-modeline-name "tex" "\
Modeline name of token language `tex'.
See language access `x-symbol-LANG-modeline-name'." :group 'x-symbol-tex :type 'string)

(defcustom x-symbol-tex-header-groups-alist nil "\
Header/submenu specification of the specific menu for language `tex'.
See language access `x-symbol-LANG-header-groups-alist'." :group 'x-symbol-tex :group 'x-symbol-input-init :type 'x-symbol-headers)

(defcustom x-symbol-tex-electric-ignore 'x-symbol-tex-default-electric-ignore "\
Specification restricting input method ELECTRIC with language `tex'.
See language access `x-symbol-LANG-electric-ignore'." :group 'x-symbol-tex :group 'x-symbol-input-control :type 'x-symbol-function-or-regexp)

(defcustom x-symbol-tex-electric-ignore-regexp "[A-Za-z]~\\'" "\
*Regexp matching contexts not to be used for input method ELECTRIC.
Used by `x-symbol-tex-default-electric-ignore'." :group 'x-symbol-tex :group 'x-symbol-input-control :type '(choice (const :tag "None" nil) regexp))

(defcustom x-symbol-tex-token-suppress-space t "\
*If non-nil, suppress space after text-mode control words.
If non-nil, inserting SPC without prefix argument after a text-mode only
control word will only replace the control word with the character
according to `x-symbol-token-input', it will not insert the space." :group 'x-symbol-tex :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-tex-master-directory 'x-symbol-tex-default-master-directory "\
Specification of the master directory for images for language `tex'.
See language access `x-symbol-LANG-master-directory'." :group 'x-symbol-tex :group 'x-symbol-image-language :type 'function)

(defcustom x-symbol-tex-image-searchpath (let ((dirs (or (getenv "TEXPICTS") (getenv "TEXINPUTS"))) dir result) (if dirs (setq dirs (if (fboundp 'split-path) (split-path dirs) (parse-colon-path dirs)))) (while dirs (when (setq dir (pop dirs)) (or (member dir '("" "/")) (member (setq dir (file-name-as-directory dir)) result) (push dir result)))) (nreverse (if (member "./" result) result (cons "./" result)))) "\
Search path for implicitly relative image file names.
See language access `x-symbol-LANG-image-searchpath'." :group 'x-symbol-tex :group 'x-symbol-image-language :type '(repeat directory))

(defcustom x-symbol-tex-image-cached-dirs '("figures/") "\
Directory parts of images stored in the memory cache.
See language access `x-symbol-LANG-image-cached-dirs'." :group 'x-symbol-tex :group 'x-symbol-image-language :type '(repeat string))

(defcustom x-symbol-tex-image-keywords '("\\.\\(eps\\|ps\\(tex\\)?\\|gif\\|png\\|jpe?g\\|pdf\\)\\'" ("\\\\epsf\\(box\\|file\\)[ 	]*\\(\\[[^][\n]*\\]\\)?{\\([^ 	\n,{}]+\\.e?ps\\)}" 3) ("\\\\e?psfig[ 	]*{file=\\([^ 	\n,{}]+\\.e?ps\\)[^\n{}]*}" 1) ("\\\\includegraphics\\*?[ 	]*\\(\\[[^][\n]*\\]\\)?\\(\\[[^][\n]*\\]\\)?{\\([^ 	\n,{}]+\\)}" 3 ".\\.[^./]+\\'" ".eps") ("\\\\input[ 	]*{\\([^ 	\n,{}]+\\.pstex\\)_t}" 1)) "\
Keywords for image insertion commands of language `tex'.
See language access `x-symbol-LANG-image-keywords'." :group 'x-symbol-tex :group 'x-symbol-image-language :type 'x-symbol-image-keywords)

(defcustom x-symbol-tex-subscript-matcher 'x-symbol-tex-subscript-matcher "\
Function matching super-/subscripts for language `tex'.
See language access `x-symbol-LANG-subscript-matcher'." :group 'x-symbol-tex :type 'function)

(defcustom x-symbol-tex-invisible-braces nil "\
TODO" :group 'x-symbol-tex :type 'boolean)

(defcustom x-symbol-tex-font-lock-allowed-faces '(tex-math-face font-lock-string-face font-lock-doc-string-face font-latex-math-face) "\
*Faces which are allowed when fontifying simple super- and subscripts.
Package x-symbol only uses super- and subscripts if they are in braces,
if the \"^\"/\"_\" has not been fontified yet or is only fontified with
faces which appear in this list.  Value t means, always use super- and
subscripts." :group 'x-symbol-tex :type '(repeat (symbol :tag "Face name")))

(defcustom x-symbol-tex-class-alist '((text) (math) (accent "accent" (x-symbol-info-face)) (aletter "acc.letter" (x-symbol-info-face)) (letter "letter" (x-symbol-info-face)) (greek "greek" (x-symbol-info-face)) (ordinary "ordinary" (x-symbol-info-face)) (binop "binop" (x-symbol-info-face)) (bigop "bigop" (x-symbol-info-face)) (relation "relation" (x-symbol-info-face)) (delim "delimiter" (x-symbol-info-face)) (punct "punctuation" (x-symbol-info-face)) (quote "quote" (x-symbol-info-face)) (space "space" (x-symbol-info-face)) (special "special" (x-symbol-info-face)) (latexsym "latexsym.sty" (x-symbol-emph-info-face)) (amssymb "amssymb.sty" (x-symbol-emph-info-face)) (stmaryrd "stmaryrd.sty" (x-symbol-emph-info-face)) (T1 "T1 fontenc.sty" (x-symbol-emph-info-face)) (correct-T1 "correct: T1 fontenc.sty" (x-symbol-info-face)) (inputenc "inputenc.sty" (x-symbol-emph-info-face)) (inputenc-unavail "inputenc.sty: unavailable" (x-symbol-emph-info-face)) (gobbles-spc "gobbles space" (x-symbol-info-face)) (user "user" (x-symbol-emph-info-face)) (VALID "unknown TeX class" (x-symbol-emph-info-face)) (INVALID "no TeX macro" (x-symbol-emph-info-face))) "\
Token classes displayed by info in echo area, for language `tex'.
See language access `x-symbol-LANG-class-alist'." :group 'x-symbol-tex :group 'x-symbol-info-strings :type 'x-symbol-class-info)

(defcustom x-symbol-tex-class-face-alist '((math x-symbol-tex-math-face (x-symbol-tex-math-face)) (text x-symbol-tex-text-face (x-symbol-tex-text-face))) "\
Color scheme in language specific grid and info, for language `tex'.
See language access `x-symbol-LANG-class-face-alist'." :group 'x-symbol-tex :group 'x-symbol-input-init :group 'x-symbol-info-general :type 'x-symbol-class-faces)

;;;***

;;;### (autoloads (x-symbol-texi-class-face-alist x-symbol-texi-class-alist x-symbol-texi-electric-ignore x-symbol-texi-header-groups-alist x-symbol-texi-modeline-name x-symbol-texi-auto-style) "x-symbol-texi" "lisp/x-symbol-texi.el")
(defconst custom-define-current-source-file "x-symbol-texi.el")

(defcustom x-symbol-texi-auto-style '(t nil nil nil nil nil) "\
Values for X-Symbol's buffer-local variables with language `texi'.
See language access `x-symbol-LANG-auto-style'." :group 'x-symbol-texi :group 'x-symbol-mode :type 'x-symbol-auto-style)

(defcustom x-symbol-texi-modeline-name "texi" "\
Modeline name of token language `texi'.
See language access `x-symbol-LANG-modeline-name'." :group 'x-symbol-texi :type 'string)

(defcustom x-symbol-texi-header-groups-alist '(("Symbol" bigop operator line relation arrow triangle shape white dots punctuation quote parenthesis symbol currency mathletter setsymbol) ("Misc. Letter" greek greek1 letter slash cedilla ogonek) ("Dotaccent, Ring" dotaccent ring) ("Tilde, Breve" tilde breve) ("Circumflex, Caron" circumflex caron) ("Diaeresis, Umlaut" diaeresis hungarumlaut) ("Acute, Grave" acute grave)) "\
Header/submenu specification of the specific menu for language `texi'.
See language access `x-symbol-LANG-header-groups-alist'." :group 'x-symbol-texi :group 'x-symbol-input-init :type 'x-symbol-headers)

(defcustom x-symbol-texi-electric-ignore nil "\
Specification restricting input method ELECTRIC with language `texi'.
See language access `x-symbol-LANG-electric-ignore'." :group 'x-symbol-texi :group 'x-symbol-input-control :type 'x-symbol-function-or-regexp)

(defcustom x-symbol-texi-class-alist '((aletter "acc.letter" (x-symbol-info-face)) (symbol "symbol" (x-symbol-info-face)) (bullet "bullet" (x-symbol-info-face)) (no-code "not as code" (x-symbol-emph-info-face)) (VALID "unknown TeXinfo command" (x-symbol-emph-info-face)) (INVALID "no TeXinfo command" (x-symbol-emph-info-face))) "\
Token classes displayed by info in echo area, for language `texi'.
See language access `x-symbol-LANG-class-alist'." :group 'x-symbol-texi :group 'x-symbol-info-strings :type 'x-symbol-class-info)

(defcustom x-symbol-texi-class-face-alist nil "\
Color scheme in language specific grid and info, for language `texi'.
See language access `x-symbol-LANG-class-face-alist'." :group 'x-symbol-texi :group 'x-symbol-input-init :group 'x-symbol-info-general :type 'x-symbol-class-faces)

;;;***

;;;### (autoloads (x-symbol-image-converter x-symbol-image-convert-program x-symbol-image-convert-file-alist x-symbol-image-editor-alist x-symbol-image-help-echo x-symbol-image-convert-mono-regexp x-symbol-image-cache-directories x-symbol-image-searchpath-follow-symlink x-symbol-image-explicitly-relative-regexp x-symbol-image-scale-method x-symbol-image-current-marker x-symbol-image-use-remote x-symbol-image-update-cache x-symbol-image-max-height x-symbol-image-max-width x-symbol-info-keys-post x-symbol-info-keys-sep x-symbol-info-keys-pre x-symbol-info-keys-keymaps x-symbol-info-coding-alist x-symbol-info-coding-post x-symbol-info-coding-sep x-symbol-info-coding-pre x-symbol-info-classes-charsym x-symbol-info-classes-post x-symbol-info-classes-sep x-symbol-info-classes-pre x-symbol-info-token-charsym x-symbol-info-token-pre x-symbol-info-context-post x-symbol-info-context-pre x-symbol-info-alias-before x-symbol-info-alias-after x-symbol-info-intro-yank x-symbol-info-intro-list x-symbol-info-intro-highlight x-symbol-info-intro-before x-symbol-info-intro-after x-symbol-context-info-ignore-groups x-symbol-context-info-ignore-regexp x-symbol-context-info-threshold x-symbol-context-info-ignore x-symbol-idle-delay x-symbol-rotate-prefix-alist x-symbol-rotate-suffix-char x-symbol-electric-ignore x-symbol-context-ignore x-symbol-grid-tab-width x-symbol-grid-ignore-charsyms x-symbol-grid-header-echo x-symbol-grid-reuse x-symbol-grid-buffer-format x-symbol-completions-buffer x-symbol-header-groups-alist x-symbol-menu-max-items x-symbol-map-default-bindings x-symbol-map-default-keys-alist x-symbol-valid-charsym-function x-symbol-charsym-ascii-groups x-symbol-charsym-ascii-alist x-symbol-auto-coding-search-limit x-symbol-set-coding-system-if-undecided x-symbol-modeline-state-list x-symbol-coding-modeline-alist x-symbol-coding-name-alist x-symbol-charsym-modeline-name x-symbol-context-info x-symbol-character-info x-symbol-reveal-invisible x-symbol-temp-help x-symbol-temp-grid x-symbol-local-grid x-symbol-local-menu x-symbol-electric-input x-symbol-token-input x-symbol-LANG-modeline-name x-symbol-texi x-symbol-bib x-symbol-sgml x-symbol-tex x-symbol-image-language x-symbol-image-general x-symbol-miscellaneous x-symbol-info-strings x-symbol-info-general x-symbol-input-control x-symbol-input-init x-symbol-mode x-symbol) "x-symbol-vars" "lisp/x-symbol-vars.el")
(defconst custom-define-current-source-file "x-symbol-vars.el")

(defgroup x-symbol nil "Semi WYSIWYG for LaTeX, HTML, etc using additional fonts." :group 'wp :link '(info-link "(x-symbol)") :link '(url-link "http://x-symbol.sourceforge.net/") :prefix "x-symbol-")

(defgroup x-symbol-mode nil "Controlling whether and how to turn on X-Symbol mode." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-input-init nil "Initialization of input methods supported by X-Symbol." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-input-control nil "Control if input methods supported by X-Symbol." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-info-general nil "General customization of X-Symbol info in echo area." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-info-strings nil "Customization of X-Symbol info strings in echo area." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-miscellaneous nil "Miscellaneous customization for X-Symbol." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-image-general nil "General customization of images in X-Symbol buffers." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-image-language nil "Language dependent customization of images in X-Symbol buffers." :group 'x-symbol :prefix "x-symbol-")

(defgroup x-symbol-tex nil "X-Symbol token language \"TeX macro\"." :group 'x-symbol :group 'tex :prefix "x-symbol-tex-")

(defgroup x-symbol-sgml nil "X-Symbol token language \"SGML entity\"." :group 'x-symbol :group 'sgml :prefix "x-symbol-sgml-")

(defgroup x-symbol-bib nil "X-Symbol token language \"BibTeX macro\"." :group 'x-symbol :group 'tex :prefix "x-symbol-bib-")

(defgroup x-symbol-texi nil "X-Symbol token language \"TeXinfo command\"." :group 'x-symbol :group 'tex :group 'docs :prefix "x-symbol-texi-")

(defcustom x-symbol-LANG-modeline-name "lang" "\
Language access: modeline name of the token language.
For each token language LANG, `x-symbol-LANG-modeline-name' is a
string with the name of the token language LANG in the modeline." :group 'x-symbol-miscellaneous :type 'string)

(defcustom x-symbol-token-input t "\
*If non-nil, enable input method TOKEN.
With input method TOKEN, and if the characters before point represent a
token, an insertion command after a completed token forces Emacs to
replace the token before point by the corresponding character.  Use
\"\\[universal-argument] 0 space\" to just replace the token.  Use
\\[undo] or \\[unexpand-abbrev] to undo the replacement.

A command is considered to be a insertion command if it is a self-insert
command or has a non-nil symbol property `x-symbol-input'." :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-electric-input t "\
*If non-nil, enable input method ELECTRIC.
With this features, some contexts of input method CONTEXTS are
automatically replaced with the corresponding character, i.e., you do
not have to invoke \\[x-symbol-modify-key].  Use \\[undo] or
\\[unexpand-abbrev] to undo the replacement.

Because an unwanted replacement of a context with a character can be
quite annoying, the following conditions must be fulfilled:

 * The context must have been defined as an electric context for the
   character, see `x-symbol-init-cset'.
 * The character must be valid, i.e., represent a token of the current
   token language, see `x-symbol-valid-charsym-function'.
 * All characters of the context have been typed without any other
   command in between, e.g., with language \"TeX macro\", \"- >\" inserts
   \\to, \"- \\[backward-char] \\[forward-char] >\" simply inserts \"->\".
 * No prefix argument has been used for any character in the context.
 * The electric context must not be a suffix of a longer valid context
   for another character.  E.g., \"''o\" is not changed to \"'\"+`oacute'
   because \"''o\" is the context for `ohungarumlaut'.
 * Contexts matched by a global or a token language dependent regexp are
   not replaced.  Functions can also be used to prevent a context to be
   replaced by a character.  E.g., with language \"TeX macro\", only
   replace \"->\" by \\to if we are in TeX's math mode (using texmathp).
   See `x-symbol-context-ignore' and `x-symbol-electric-ignore'." :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-local-menu t "\
*If non-nil, provide a token language specific menu.
In a language specific menu, only insertion commands for valid
characters appear.  The entries are mentioned and sorted according to
the token." :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-local-grid t "\
*If non-nil, provide a token language specific grid.
See `x-symbol-grid'.  In a language specific grid, only valid characters
appear.  They may be also colored according to some language specific
token class coloring scheme.  E.g., with language \"TeX macro\", purple
character can only be used in TeX's math mode, blue character can only
be used in TeX's text mode, see `x-symbol-charsym-face'." :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-temp-grid nil "\
*If non-nil, the X-Symbol grid buffer only appears temporarily.
If a temporary grid is still visible, the first insertion of an X-Symbol
characters restores the window configuration current before the
invocation of `x-symbol-grid'." :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-temp-help t "\
*If non-nil, the key completion buffer only appears temporarily.
If the temporary key completions buffer is still visible, the first
insertion of an X-Symbol characters restores the window configuration
current before the invocation of `x-symbol-help'." :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-reveal-invisible t "\
*If non-nil, reveal invisible characters at point.
Usually, with a non-nil `x-symbol-subscripts', some parts of the text
might be invisible.  With this feature and if point is in such an area,
all the text in the area is revealed and displayed with
`x-symbol-revealed-face'.  With value t, also reveal if point is
directly after such an area.  See function `x-symbol-reveal-invisible'." :group 'x-symbol-info-general :group 'x-symbol-miscellaneous :type '(radio (const :tag "No" nil) (const :tag "Characters Around Point" t) (sexp :tag "Character After Point" :format "%t" :value after)))

(defcustom x-symbol-character-info t "\
*If non-nil, display info for characters at point in echo area.
The info for the character after point includes the character itself,
the token of the current language, eventually colored according to some
coloring scheme, the token specific classes, the codings in which the
characters is considered to be a 8bit character and the key bindings.
With value t and no info for the character after point, show info for
character before point instead.  See also `x-symbol-context-info'." :group 'x-symbol-info-general :type '(radio (const :tag "None" nil) (const :tag "Characters Around Point" t) (sexp :tag "Character After Point" :format "%t" :value after)))

(defcustom x-symbol-context-info t "\
*If non-nil, display info for context before point in echo area.
If enabled and no info for characters at point, display the info for
the character to which \\[x-symbol-modify-key] would replace the context
before point.  See also `x-symbol-character-info'." :group 'x-symbol-info-general :type 'boolean)

(defcustom x-symbol-charsym-modeline-name "none" "\
Modeline name of the pseudo language x-symbol charsym.
See language access `x-symbol-LANG-modeline-name'." :group 'x-symbol-miscellaneous :type 'string)

(defcustom x-symbol-coding-name-alist '((iso-8859-1 . "Latin-1") (iso-8859-2 . "Latin-2") (iso-8859-3 . "Latin-3") (iso-8859-9 . "Latin-5") (iso-8859-15 . "Latin-9")) "\
*Alist of codings with their names presented to the user.
The elements look like (CODING . NAME) where CODING is a valid value for
`x-symbol-coding' and NAME is the NAME used in the menu." :group 'x-symbol-miscellaneous :type '(repeat (cons :format "%v" x-symbol-coding string)))

(defcustom x-symbol-coding-modeline-alist '((iso-8859-1 . "-l1") (iso-8859-2 . "-l2") (iso-8859-3 . "-l3") (iso-8859-9 . "-l5") (iso-8859-15 . "-l9") (info . "-i") (error . "-err")) "\
*Alist of codings with their names in the modeline.
The elements look like (CODING . NAME) where CODING is a valid value for
`x-symbol-coding' and NAME is used by `x-symbol-coding-modeline-text'." :group 'x-symbol-mode :type '(repeat (cons :format "%v" x-symbol-coding string)))

(defcustom x-symbol-modeline-state-list '(" XS:" (x-symbol-language . x-symbol-language-modeline-text) (x-symbol-8bits "8") (x-symbol-unique "*") (x-symbol-coding . x-symbol-coding-modeline-text) "/" (x-symbol-subscripts "s") (x-symbol-image "i")) "\
*Alist used by `x-symbol-update-modeline' to construct the modeline.
This function constructs `x-symbol-modeline-string' by concatenating the
result from the elements in this list.  Each element looks like
  SEPARATOR or
  (VARIABLE NON-NIL . NIL) or
  (VARIABLE . FUNCTION)

SEPARATOR is a string and is used directly, only use the first from two
consecutive SEPARATORs.  If VARIABLE is non-nil, use NON-NIL, otherwise
NIL, both NON-NIL and NIL should be strings or nil.  FUNCTION is called
with the value of VARIABLE as argument and should return a string or
nil.  Two SEPARATORs where all the elements in between return nil, are
considered to be consecutive." :group 'x-symbol-mode :type '(repeat (choice (string :tag "Separator") (cons :tag "Depending on variable" variable (cons :format "%v" (choice :tag "Non-nil" (const :tag "Nothing" nil) string) (choice :tag "Nil" (const :tag "Nothing" nil) string))) (cons :tag "Calling function" (sexp :tag "With argument") function))))

(defcustom x-symbol-set-coding-system-if-undecided t "\
*If non-nil, set coding system if undecided when turning on X-Symbol.
If this variable is non-nil, `x-symbol-default-coding' is non-nil, and
`buffer-file-coding-system' specifies an undecided coding system, set
`buffer-file-coding-system' according to `x-symbol-default-coding'." :group 'x-symbol-mode :type 'boolean)

(defcustom x-symbol-auto-coding-search-limit 10000 "\
*Limits searching for coding strings in the file.
Used in variable `x-symbol-auto-mode-alist' when finding an appropriate
value for `x-symbol-coding'." :group 'x-symbol-mode :type '(choice (const :tag "No limit" nil) (integer :tag "Limit")))

(defcustom x-symbol-charsym-ascii-alist nil "\
Alist of charsyms and their Ascii representation.
Each element looks like (CHARSYM . ASCII) where CHARSYM is a x-symbol
charsym and ASCII is a string.  Used by `x-symbol-translate-to-ascii'.

E.g., if you prefer the German way to Asciify accented characters, use
  (setq x-symbol-charsym-ascii-alist
	'((adiaeresis . \"ae\") (Adiaeresis . \"Ae\")
	  (odiaeresis . \"oe\") (Odiaeresis . \"Oe\")
	  (udiaeresis . \"ue\") (Udiaeresis . \"Ue\")))" :group 'x-symbol-miscellaneous :type '(repeat (cons :format "%v" x-symbol-charsym string)))

(defcustom x-symbol-charsym-ascii-groups '(digit1 letter slash cedilla ogonek dotaccent ring tilde breve circumflex caron diaeresis hungarumlaut acute grave) "\
Charsym groups with default ascii representations.
Charsyms with a group in this list use their subgroup string as the last
possibility as the ascii representation.  See `x-symbol-init-cset' for
details.  Used by `x-symbol-translate-to-ascii'." :group 'x-symbol-miscellaneous :type '(repeat x-symbol-group))

(defcustom x-symbol-valid-charsym-function 'x-symbol-default-valid-charsym "\
Function which should return non-nil if a charsym is valid.
Function is called with the charsym and optional language." :group 'x-symbol-input-control :type 'function)

(defcustom x-symbol-map-default-keys-alist '((help x-symbol-help) ((control ?h) x-symbol-help) (button1) (button2) (button3) (down-mouse-1 ignore) (down-mouse-2 ignore) (down-mouse-3 ignore) (mouse-1) (mouse-2) (mouse-3) ((meta home) beginning-of-buffer-other-window t) ((meta end) end-of-buffer-other-window t) ((meta prior) scroll-other-window-down t) ((meta next) scroll-other-window t)) "\
Alist used by `x-symbol-map-default-binding'.
Each element looks like (KEY COMMAND TEMPORARYP).

If the last event in the undefined X-Symbol key sequence matches KEY,
see `events-to-keys', COMMAND is executed.  If COMMAND is nil, execute
command which has binding KEY without prefix of the X-Symbol key
sequence.  IF TEMPORARYP is non-nil, use key prefix and the prefix
argument for the following command." :group 'x-symbol-input-control :type '(repeat (group x-symbol-key (choice (const :tag "Usual command" nil) x-symbol-command) (boolean :tag "Temporary"))))

(defcustom x-symbol-map-default-bindings '(("	" x-symbol-read-token-direct) ("
" x-symbol-read-token) (nil x-symbol-grid) ([(left)] x-symbol-modify-key) ([(right)] x-symbol-modify-key) ([(up)] x-symbol-rotate-key) ([(down)] x-symbol-rotate-key)) "\
TODO.  nil = (vector x-symbol-compose-key)" :group 'x-symbol-input-control :type '(repeat (group (sexp :tag "Key sequence" nil) x-symbol-command)))

(defcustom x-symbol-menu-max-items 30 "\
*Maximum number of entries in submenus of the x-symbol menu.
If the number of character input commands in a submenu exceed this
value, use more than one submenu for the same header.  These submenus
have nearly the same length.  See also `x-symbol-header-groups-alist'." :group 'x-symbol-input-init :type 'integer)

(defcustom x-symbol-header-groups-alist '(("Operator" bigop operator) ("Relation" relation) ("Arrow" arrow) ("Shaped" triangle shape) ("Punctuation" white line dots punctuation quote parenthesis) ("Symbol" symbol currency) ("Math Letter" mathletter setsymbol) ("Greek Letter" greek greek1) ("Misc. Letter" letter slash) ("Cedilla, Ogonek" cedilla ogonek) ("Dotaccent, Ring" dotaccent ring) ("Tilde, Breve" tilde breve) ("Circumflex, Caron" circumflex caron) ("Diaeresis, Umlaut" diaeresis hungarumlaut) ("Acute, Grave" acute grave)) "\
Alist to determine the header/submenu for characters.
Each element looks like (HEADER GROUP...) where HEADER is a string and
GROUP is the group of a character as explained in `x-symbol-init-cset'.
This alist is used for `x-symbol-grid' and the `x-symbol-menu'.
Token languages might define their own alist.

For each token language LANG, `x-symbol-LANG-header-groups-alist', if
non-nil, contains the specification for the language specific grid and
menu." :group 'x-symbol-input-init :type 'x-symbol-headers)

(defcustom x-symbol-completions-buffer "*X-Symbol Key Completions*" "\
Buffer name for key completions buffer.
Used by `x-symbol-help', i.e., when pressing Help during a x-symbol
key sequence." :group 'x-symbol-input-init :type 'string)

(defcustom x-symbol-grid-buffer-format "*X-Symbol Grid (%s)*" "\
Buffer name format for grid buffers.
Used with substitution `x-symbol-charsym-name'/%s when invoked from a
buffer without a valid token language or if `x-symbol-local-grid' has
value nil.  Otherwise, used with substitution NAME/%s where NAME is the
name of `x-symbol-language'." :group 'x-symbol-input-init :type 'string)

(defcustom x-symbol-grid-reuse t "\
If non-nil, \\[x-symbol-grid] reuses old grid buffers.
If non-nil, avoid unnecessary computations.  You should probably set
this to nil, if you use side-by-side buffers with different width." :group 'x-symbol-input-control :type 'boolean)

(defcustom x-symbol-grid-header-echo '("button2 scrolls up/down, button3 pops up X-Symbol menu  (all non-highlighted parts)" (8 24 x-symbol-info-face) (33 54 x-symbol-info-face) (56 x-symbol-info-face)) "\
Text used for the echo are if mouse if over a heading.
See `x-symbol-fancy-value' for the value type." :group 'x-symbol-input-init :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-grid-ignore-charsyms '(nobreakspace) "\
Charsyms not being displayed in the grid, see `x-symbol-grid'." :group 'x-symbol-input-control :type '(repeat x-symbol-charsym))

(defcustom x-symbol-grid-tab-width 4 "\
Tab width in the grid between characters, see `x-symbol-grid'.
The widest character should not be wider than the tab width if the
default face has font of `x-symbol-heading-face'." :group 'x-symbol-input-init :type 'number)

(defcustom x-symbol-context-ignore nil "\
Regexp matching contexts not to be replaced by input method CONTEXT.
You may also use a function instead of a regexp, see
`x-symbol-call-function-or-regexp'." :group 'x-symbol-input-control :type 'x-symbol-function-or-regexp)

(defcustom x-symbol-electric-ignore "[ 	]\\|'[ls]" "\
Regexp matching contexts not to be replaced by input method ELECTRIC.
A language dependent regexp is also checked before a context is
replaced, see `x-symbol-electric-input' for details.  You may also use a
function instead of a regexp, see `x-symbol-call-function-or-regexp'.

For each token language LANG, `x-symbol-LANG-electric-ignore', if
non-nil, defines the language dependent version." :group 'x-symbol-input-control :type 'x-symbol-function-or-regexp)

(defcustom x-symbol-rotate-suffix-char ?\# "\
Additional suffix character usually used to simulate Greekifying.
\\[x-symbol-modify-key] modifies the longest context before point
whereas \\[x-symbol-rotate-key] appends this character to the context to
determine the correct target character for the context.  The value is
typically a suffix being defined in `x-symbol-group-input-alist'." :group 'x-symbol-input-control :type 'character)

(defcustom x-symbol-rotate-prefix-alist '((8 . north) (7 . north-west) (4 . west) (1 . south-west) (2 . south) (28 . vertical) (82 . vertical) (3 . south-east) (6 . east) (64 . horizontal) (46 . horizontal) (9 . north-east) (5)) "\
Alist used if `x-symbol-rotate-key' is called with a prefix arg.
Each element looks like (NUMBER . DIRECTION) where NUMBER is the numeric
value of the prefix argument and DIRECTION is a valid direction in
`x-symbol-rotate-aspects-alist'." :group 'x-symbol-input-control :type '(repeat (cons :format "%v" (integer :tag "Numeric Prefix Arg") (symbol :tag "Direction"))))

(defcustom x-symbol-idle-delay 0.5 "\
*Time in seconds of idle time before showing info in the echo area.
Also used as idle time before revealing invisible characters.  See
`x-symbol-character-info', `x-symbol-context-info' and
`x-symbol-reveal-invisible'.  See also `x-symbol-start-itimer-once'." :group 'x-symbol-miscellaneous :type 'number)

(defcustom x-symbol-context-info-ignore 'x-symbol-default-context-info-ignore "\
Regexp matching contexts not used to display a context info for.
See `x-symbol-context-info'.  You may also use a function instead of a
regexp, see `x-symbol-call-function-or-regexp'." :group 'x-symbol-info-general :type 'x-symbol-function-or-regexp)

(defcustom x-symbol-context-info-threshold 2 "\
Minimum length of contexts to display a context info for.
Used by `x-symbol-default-context-info-ignore'." :group 'x-symbol-info-general :type 'integer)

(defcustom x-symbol-context-info-ignore-regexp "\\`[A-Za-z]+\\'" "\
Regexp matching contexts not to display a context info for.
Used by `x-symbol-default-context-info-ignore'." :group 'x-symbol-info-general :type 'regexp)

(defcustom x-symbol-context-info-ignore-groups '(letter slash cedilla ogonek dotaccent ring tilde breve circumflex caron diaeresis hungarumlaut acute grave) "\
Groups of characters not to display a context info for.
Used by `x-symbol-default-context-info-ignore'." :group 'x-symbol-info-general :type '(repeat x-symbol-group))

(defcustom x-symbol-info-intro-after '("AFTER:  " (0 -2 x-symbol-info-face)) "\
Intro spec of info for the character after point.
See `x-symbol-character-info'.  See `x-symbol-fancy-value' for the value
type." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-intro-before '("BEFORE:  " (0 -2 x-symbol-info-face)) "\
Intro spec of info for character before point.
See `x-symbol-character-info'.  See `x-symbol-fancy-value' for the value
type." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-intro-highlight '("button2 inserts:  " (-10 -2 x-symbol-info-face)) "\
Intro spec of the info character in grid under mouse.
See `x-symbol-fancy-value' for the value type, STRING is passed to
`substitute-command-keys'." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-intro-list '("\\[x-symbol-list-selected] inserts:  " (-10 -2 x-symbol-info-face)) "\
Intro spec of the info character in grid under point.
Used by \\[x-symbol-list-info].  See `x-symbol-fancy-value' for the
value type, STRING is passed to `substitute-command-keys'." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-intro-yank '("\\[yank] inserts:  " (-10 -2 x-symbol-info-face)) "\
Intro spec of info for the character inserted in read-only buffer.
See `x-symbol-insert-command'.  See `x-symbol-fancy-value' for the value
type, STRING is passed to `substitute-command-keys'." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-alias-after '("\\[forward-char] \\[x-symbol-modify-key] replaces char alias with:  " (-27 -2 x-symbol-emph-info-face)) "\
Intro spec of short info for character alias after point.
See `x-symbol-character-info'.  See `x-symbol-fancy-value' for the value
type, STRING is passed to `substitute-command-keys'." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-alias-before '("\\[x-symbol-modify-key] replaces char alias with:  " (-27 -2 x-symbol-emph-info-face)) "\
Intro spec of short info for character alias before point.
See `x-symbol-character-info'.  See `x-symbol-fancy-value' for the value
type, STRING is passed to `substitute-command-keys'." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-context-pre '("\\[x-symbol-modify-key] replaces " (-9 -1 x-symbol-info-face)) "\
Spec of text before context in info for context before point.
See `x-symbol-context-info'.  See `x-symbol-fancy-value' for the value
type, STRING is passed to `substitute-command-keys'." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-context-post '(" with:  " (1 -2 x-symbol-info-face)) "\
Spec of text after context in info for context before point.
See `x-symbol-context-info'.  See `x-symbol-fancy-value' for the value
type." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-token-pre '(" = " (x-symbol-info-face)) "\
Spec of text between character and token in info.
See `x-symbol-fancy-value' for the value type." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-token-charsym '("<%s>" (0 1 x-symbol-info-face) (-1 x-symbol-info-face)) "\
Spec with format for x-symbol charsym in info.
See `x-symbol-fancy-string' for the value type, the format with
substitution CHARSYM/%s is the STRING." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-classes-pre '(" (" (1 x-symbol-info-face)) "\
Spec of text before token classes in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-classes-sep '(", " (x-symbol-info-face)) "\
Spec of text between token classes in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-classes-post '(")" (x-symbol-info-face)) "\
Spec of text before after token classes in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-classes-charsym '("charsym" (x-symbol-info-face)) "\
Spec of token class string for x-symbol charsyms in info.
See `x-symbol-fancy-value' for the value type." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-coding-pre '("." (x-symbol-info-face)) "\
Spec of text before codings in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-coding-sep '("." (x-symbol-info-face)) "\
Spec of text between codings in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-coding-post '("") "\
Spec of text after codings in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-coding-alist '((iso-8859-1 "l1" (x-symbol-info-face)) (iso-8859-2 "l2" (x-symbol-info-face)) (iso-8859-3 "l3" (x-symbol-info-face)) (iso-8859-9 "l5" (x-symbol-info-face)) (iso-8859-15 "l9" (x-symbol-info-face))) "\
Specs for coding info.
Each element looks like (CODING . SPEC).  Characters which are defined
to be 8bit characters with CODING, are displayed with SPEC in the info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :type '(repeat (group x-symbol-coding string (x-symbol-fancy-spec :inline t :tag "Face specifications"))))

(defcustom x-symbol-info-keys-keymaps 'x-symbol-default-info-keys-keymaps "\
Function returning the root keymaps for the key info.
If non-nil, called with the current charsym as argument, the result is
the second argument to `where-is-internal'.  See also
`x-symbol-info-keys-pre'." :group 'x-symbol-info-strings :type '(choice (const :tag "Current maps" nil) function))

(defcustom x-symbol-info-keys-pre '("   \\[x-symbol-map] +: " (-4 -1 x-symbol-info-face)) "\
Spec of text before key bindings in info.
See `x-symbol-fancy-associations' for details, STRING is passed to
`substitute-command-keys'.  See also `x-symbol-info-keys-keymaps'." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-keys-sep '(" , " (0 -1 x-symbol-info-face)) "\
Spec of text between key bindings in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-info-keys-post '("") "\
Spec of text after key bindings in info.
See `x-symbol-fancy-associations' for details." :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-image-max-width 120 "\
*Maximum width of glyphs." :group 'x-symbol-image-general :type 'integer)

(defcustom x-symbol-image-max-height 80 "\
*Maximum height of glyphs." :group 'x-symbol-image-general :type 'integer)

(defcustom x-symbol-image-update-cache 'old "\
*If non-nil, automatically update the image cache file.
With value nil, only create an image cache file if it does not exist.
With value t, always produce a new cache file.  With any other value,
only produce a cache file if it does not exist or is older than the
corresponding image file.  This variable has no influence if a glyph
having used the image cache file in question is stored in the buffer
local memory cache, see `x-symbol-image-memory-cache'.

See `x-symbol-image-cache-directories' for the file name of the
cached image.  See also `x-symbol-image-special-glyphs'." :group 'x-symbol-image-general :type '(radio (const :tag "No" nil) (const :tag "Always" t) (sexp :tag "Old" :format "%t" :value old)))

(defcustom x-symbol-image-use-remote nil "\
*If nil, only show glyphs which can be stored in the memory cache.
The memory cache stores glyphs for file names without directory part or
a directory part in the language access
`x-symbol-LANG-image-cached-dirs', e.g., it should contain \"images\",
if \"images/mail.png\" should be stored in the memory cache.

If this variable is nil, use `x-symbol-image-remote-glyph' for image
files not in the memory cache.  If it is non-nil, try to find the image
file during editing, ignoring the searchpath, for speed, though.
Editing lines with image files not in the memory cache will be slow,
since file accesses are necessary for every command.

When searching for the images file, all file names, including
directories in a search path, are relative to the return value of the
function in language access `x-symbol-LANG-master-directory', value nil
means function `default-directory'.

Implicitly relative file names, i.e., those which are neither absolute
nor are matched by `x-symbol-image-explicitly-relative-regexp', are
searched in the directories of language access
`x-symbol-LANG-image-searchpath'." :group 'x-symbol-image-general :type 'boolean)

(defcustom x-symbol-image-current-marker " *" "\
*Marker to indicate the directory of the image file.
Marker used in `x-symbol-image-menu' to indicate directories in the
image search path containing the image file.  The first marked directory
is used by button2 over an image insertion command." :group 'x-symbol-image-general :type 'string)

(defcustom x-symbol-image-scale-method "\\.[0-9][0-9]\\'" "\
*Regexp matching the scale factor in the image file name.
If non-nil and this regexp matches the image file name without its final
extension, only the part up to the beginning of the match is used to
determine the name of the image cache file and the design file if it
differs from the image file, see `x-symbol-image-editor-alist'.

Example: with the default values, for the image and image design file
\"file.70.jpeg\", the image cache file is \"file.png\", for the image
file \"file.70.eps\", the image cache file is \"file.png\", the image
design file is \"file.fig\"." :group 'x-symbol-image-general :type '(choice (const :tag "No scale method" nil) regexp))

(defcustom x-symbol-image-explicitly-relative-regexp "\\`\\.\\.?/" "\
Regexp matching files considered to be explicitly relative." :group 'x-symbol-image-general :type 'regexp)

(defcustom x-symbol-image-searchpath-follow-symlink nil "\
*Non-nil, if recursive searching for dirs should follow symbolic links.
Directories in the image search path ending with \"//\" are recursively
inserted.  With value nil, do not include subdirectories which are
symbolic links.  Directories which are directly specified in the image
searchpath are always included." :group 'x-symbol-image-general :type 'boolean)

(defcustom x-symbol-image-cache-directories (backquote (((\, (concat "\\`" (regexp-quote (file-truename "~/")))) . "~/.images/") ("." . t))) "\
List of directories for image cache files.
Each element should be of the form:
  (REGEXP) or
  (REGEXP . t) or
  (REGEXP . NEWDIR) or
  (REGEXP FUNCTION ARG...)

Used by `x-symbol-image-cache-name' to determine the directory where to
store the image cache files.  The elements in this list are processed
until REGEXP matches the directory part INDIR of the fully expanded
image file name, see `file-truename'.

With the first form, no image cache file will be produced and
`x-symbol-image-junk-glyph' represents the image file.  With the second
form, the image cache file is just produced temporary and is stored in
`x-symbol-image-temp-name'+SUFFIX.  If the glyph for the image file is
not stored in `x-symbol-image-memory-cache', the second form is an alias
for the first form.

With the third form, the match by REGEXP in INDIR is replaced with
NEWDIR, see `replace-match'.  With the fourth from, FUNCTION is called
with INDIR and arguments ARGs.  In both cases, the result is expanded
with INDIR to get the directory for the image cache file.

Example: if we have the value
  ((\"\\\\`/home/user/junk/\")
   (\"\\\\`/home/user/tmp/.*\" . \".images/\")
   (\"\\\\`/home/user/\" . \"~/.images/\")
   (\".\" . t)
and the following image files, we get:
  /home/user/junk/stupid.eps is not cached, a recycle sign is shown
  /home/user/tmp/tmp1/image.eps is cached in /home/user/tmp/tmp1/.images/
  /home/user/d1/d2/image.eps is cached in /home/user/.images/d1/d2/
  /usr/local/image.eps is temporary cached in file /tmp/xsi-a006JH.SUFFIX" :group 'x-symbol-image-general :type '(repeat (cons :format "%v" :value (".") regexp (choice (const :tag "Junk" nil) (const :tag "Temporary" t) (string :tag "Replace match with") (cons :tag "Call" function (repeat :tag "With arguments" sexp))))))

(defcustom x-symbol-image-convert-mono-regexp (and x-symbol-image-temp-name (regexp-quote x-symbol-image-temp-name)) "\
Regexp matching image cache file names not using a colormap.
Used by `x-symbol-image-start-convert-colormap' to determine monochrome
image cache files.  This regexp should match temporary image cache files
since \"convert\" is slow when using a colormap." :group 'x-symbol-image-general :type '(choice (const :tag "None" nil) regexp))

(defcustom x-symbol-image-help-echo '("button2 runs: %S , button3 pops up menu" (8 13 x-symbol-info-face) (-23 -21 x-symbol-info-face) (-12 x-symbol-info-face)) "\
Format string for info when the mouse is over image insertion commands.
Used with substitution COMMAND/%S, where COMMAND describes the
invocation of the image editor, see `x-symbol-image-editor-alist'." :group 'x-symbol-image-general :group 'x-symbol-info-strings :set 'x-symbol-set-cache-variable :type 'x-symbol-fancy)

(defcustom x-symbol-image-editor-alist '(("\\.\\(eps\\|ps\\(tex\\)?\\)\\'" "xfig %s &" ".fig") ("." "display %s &")) "\
Alist of image editors used by `x-symbol-image-editor'.
Each element looks like (REGEXP . EDITOR-SPEC) where EDITOR-SPEC looks
like (SHELL-COMMAND-FORMAT [EXT]) or (FUNCTION ARG...).

If REGEXP matches the image file, EDITOR-SPEC is used.  With the first
form, a shell command SHELL-COMMAND-FORMAT with substitution FILE/%s is
invoked where the image design file FILE is the image file, if used
without optional EXT or EXT with value nil, or the result of
`x-symbol-image-file-name' otherwise, called with arguments image file
name and EXT.

With the second form, calling (FUNCTION FILE nil ARG...) should return a
string describing the editor, used by function
`x-symbol-image-help-echo' and the title of `x-symbol-image-menu'.
Calling (FUNCTION FILE BUFFER ARG...)  should invoke the image editor.
FILE is the image file, BUFFER is the buffer in which the image is
used." :group 'x-symbol-image-general :type '(repeat (cons :format "%v" :value ("." "display %s &") regexp (choice (list :tag "Shell command" string (choice (const :tag "Unchanged filename" nil) (string :tag "Abstract extension"))) (cons :tag "Call" function (repeat :tag "With arguments" sexp))))))

(defcustom x-symbol-image-convert-file-alist '(("\\.pstex\\'" . "ps:")) "\
Alist to determine a prefix for the INFILE passed to \"convert\".
Each element looks like (REGEXP . PREFIX).  If REGEXP matches INFILE,
INFILE is prefixed by PREFIX for the invocation of \"convert\".  If no
REGEXP matches, no prefix is used.  See `x-symbol-image-convert-file'." :group 'x-symbol-image-general :type '(repeat (cons :format "%v" regexp (string :tag "Prefix"))))

(defcustom x-symbol-image-convert-program (if (eq system-type 'windows-nt) "C:\\ImageMagick\\convert" "convert") "\
*Name of the program used in `x-symbol-image-converter'." :group 'x-symbol-image-general :type 'string)

(defcustom x-symbol-image-converter (when (console-type) (save-excursion (set-buffer (get-buffer-create " *x-symbol-image command*")) (erase-buffer) (call-process shell-file-name nil t nil shell-command-switch (concat x-symbol-image-convert-program " -list Format")) (call-process shell-file-name nil t nil shell-command-switch (concat x-symbol-image-convert-program " -h")) (let (iformat) (cond ((when (featurep 'png) (goto-char (point-min)) (re-search-forward "^[ 	]*[pP][nN][gG]" nil t)) (setq iformat 'png)) ((when (featurep 'gif) (goto-char (point-min)) (re-search-forward "^[ 	]*[gG][iI][fF]" nil t)) (setq iformat 'gif)) (t (setq iformat (cond ((featurep 'png) 'png) ((featurep 'gif) 'gif))) (unless iformat (warn "x-symbol-image: your Emacs neither supports png nor gif")) (goto-char (point-min)) (if (re-search-forward "ImageMagick" nil t) (if iformat (warn "x-symbol-image: \"convert\" doesn't list recognized formats, I'll try %S" iformat)) (warn "x-symbol-image: no valid image converter") (setq iformat nil)))) (kill-buffer (current-buffer)) (when iformat (list* iformat (cdr (assq iformat '((png . ".png") (gif . ".gif")))) (if (and (boundp 'system-type) (eq system-type 'windows-nt)) 'x-symbol-image-start-convert-mswindows (let ((colors (if (featurep 'xemacs) (or (device-color-cells) 2) (if (display-color-p) 256 2)))) (cond ((< colors 32) 'x-symbol-image-start-convert-mono) ((> colors 767) 'x-symbol-image-start-convert-truecolor) (x-symbol-image-convert-colormap 'x-symbol-image-start-convert-colormap) (t 'x-symbol-image-start-convert-color))))))))) "\
Converter to produce the image cache file from the image file.
This definition has the form (IMAGE-FORMAT EXTENSION . COMMAND).
IMAGE-FORMAT is a image format compiled into your XEmacs.  EXTENSION is
the extension used for image cache file names.

COMMAND, called with arguments INFILE and OUTFILE should start and
return the process which creates the image cache file OUTFILE from the
image file INFILE.  COMMAND should also use `x-symbol-image-max-width'
and `x-symbol-image-max-height'.  Value nil means, use
`x-symbol-image-junk-glyph' instead creating a glyph from IMAGE.

Predefined COMMANDS start \"convert\" from ImageMagick with different
options according to the number of colors in your device:
`x-symbol-image-start-convert-truecolor',
`x-symbol-image-start-convert-color' and
`x-symbol-image-start-convert-mono'." :group 'x-symbol-image-general :type '(choice (const :tag "No image converter" nil) (cons :tag "Converter" (symbol :tag "Image format") (cons :format "%v" (string :tag "File extension") (choice :tag "Convert function" (function-item :tag "To monochrome" x-symbol-image-start-convert-mono) (function-item :tag "To color, restricted" x-symbol-image-start-convert-color) (function-item :tag "To color, colormap" x-symbol-image-start-convert-colormap) (function-item :tag "To color, unrestricted" x-symbol-image-start-convert-truecolor) (function :tag "Other function"))))))

;;;***

(provide 'x-symbol-custom-defines)
