;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'xemacs-devel-custom-defines) (error "Feature xemacs-devel-custom-defines already loaded"))

;;;### (autoloads (patch-review) "auto-autoloads" "xemacs-devel/auto-autoloads.el")
(defconst custom-define-current-source-file "auto-autoloads.el")

(defgroup patch-review nil "Patch submission review." :group 'mail)

;;;***

;;;### (autoloads (checkdoc checkdoc-symbol-words checkdoc-verb-check-experimental-flag checkdoc-defun-regexp checkdoc-arguments-in-order-flag checkdoc-max-keyref-before-warn checkdoc-spellcheck-documentation-flag checkdoc-triple-semi-comment-check-flag checkdoc-permit-comma-termination-flag checkdoc-force-history-flag checkdoc-force-docstrings-flag checkdoc-bouncy-flag checkdoc-autofix-flag) "checkdoc" "xemacs-devel/checkdoc.el")
(defconst custom-define-current-source-file "checkdoc.el")

(defcustom checkdoc-autofix-flag 'semiautomatic "\
*Non-nil means attempt auto-fixing of doc strings.
If this value is the symbol `query', then the user is queried before
any change is made.  If the value is `automatic', then all changes are
made without asking unless the change is very-complex.  If the value
is `semiautomatic' or any other value, then simple fixes are made
without asking, and complex changes are made by asking the user first.
The value `never' is the same as nil, never ask or change anything." :group 'checkdoc :type '(choice (const automatic) (const query) (const never) (const semiautomatic)))

(defcustom checkdoc-bouncy-flag t "\
*Non-nil means to \"bounce\" to auto-fix locations.
Setting this to nil will silently make fixes that require no user
interaction.  See `checkdoc-autofix-flag' for auto-fixing details." :group 'checkdoc :type 'boolean)

(defcustom checkdoc-force-docstrings-flag t "\
*Non-nil means that all checkable definitions should have documentation.
Style guide dictates that interactive functions MUST have documentation,
and that it's good but not required practice to make non user visible items
have doc strings." :group 'checkdoc :type 'boolean)

(defcustom checkdoc-force-history-flag t "\
*Non-nil means that files should have a History section or ChangeLog file.
This helps document the evolution of, and recent changes to, the package." :group 'checkdoc :type 'boolean)

(defcustom checkdoc-permit-comma-termination-flag nil "\
*Non-nil means the first line of a docstring may end with a comma.
Ordinarily, a full sentence is required.  This may be misleading when
there is a substantial caveat to the one-line description -- the comma
should be used when the first part could stand alone as a sentence, but
it indicates that a modifying clause follows." :group 'checkdoc :type 'boolean)

(defcustom checkdoc-triple-semi-comment-check-flag t "\
*Non-nil means to check for multiple adjacent occurrences of ;;; comments.
According to the style of Emacs code in the Lisp libraries, a block
comment can look like this:
;;; Title
;;  text
;;  text
But when inside a function, code can be commented out using the ;;;
construct for all lines.  When this variable is nil, the ;;; construct
is ignored regardless of its location in the code." :group 'checkdoc :type 'boolean)

(defcustom checkdoc-spellcheck-documentation-flag nil "\
*Non-nil means run Ispell on text based on value.
This is automatically set to nil if Ispell does not exist on your
system.  Possible values are:

  nil         - Don't spell-check during basic style checks.
  defun       - Spell-check when style checking a single defun
  buffer      - Spell-check when style checking the whole buffer
  interactive - Spell-check during any interactive check.
  t           - Always spell-check" :group 'checkdoc :type '(choice (const nil) (const defun) (const buffer) (const interactive) (const t)))

(defcustom checkdoc-max-keyref-before-warn 10 "\
*The number of \\ [command-to-keystroke] tokens allowed in a doc string.
Any more than this and a warning is generated suggesting that the construct
\\ {keymap} be used instead." :group 'checkdoc :type 'integer)

(defcustom checkdoc-arguments-in-order-flag t "\
*Non-nil means warn if arguments appear out of order.
Setting this to nil will mean only checking that all the arguments
appear in the proper form in the documentation, not that they are in
the same order as they appear in the argument list.  No mention is
made in the style guide relating to order." :group 'checkdoc :type 'boolean)

(defcustom checkdoc-defun-regexp "^(def\\(un\\|var\\|custom\\|macro\\|const\\|subst\\|advice\\|method\\)\\s-+\\(\\(\\sw\\|\\s_\\)+\\)[ 	\n]+" "\
*Regular expression used to identify a defun.
A search leaves the cursor in front of the parameter list." :group 'checkdoc :type 'string)

(defcustom checkdoc-verb-check-experimental-flag t "\
*Non-nil means to attempt to check the voice of the doc string.
This check keys off some words which are commonly misused.  See the
variable `checkdoc-common-verbs-wrong-voice' if you wish to add your own." :group 'checkdoc :type 'boolean)

(defcustom checkdoc-symbol-words nil "\
A list of symbols which also happen to make good words.
These symbol-words are ignored when unquoted symbols are searched for.
This should be set in an Emacs Lisp file's local variables." :group 'checkdoc :type '(repeat (symbol :tag "Word")))

(defgroup checkdoc nil "Support for doc string checking in Emacs Lisp." :prefix "checkdoc" :group 'lisp)

;;;***

;;;### (autoloads (eldoc-argument-case eldoc-minor-mode-string eldoc-idle-delay eldoc-mode eldoc) "eldoc" "xemacs-devel/eldoc.el")
(defconst custom-define-current-source-file "eldoc.el")

(defgroup eldoc nil "Show function arglist or variable docstring in echo area." :group 'extensions)

(defcustom eldoc-mode nil "\
*If non-nil, show the defined parameters for the elisp function near point.

For the emacs lisp function at the beginning of the sexp which point is
within, show the defined parameters for the function in the echo area.
This information is extracted directly from the function or macro if it is
in pure lisp.  If the emacs function is a subr, the parameters are obtained
from the documentation string if possible.

If point is over a documented variable, print that variable's docstring
instead.

This variable is buffer-local." :type 'boolean :group 'eldoc)

(defcustom eldoc-idle-delay 0.5 "\
*Number of seconds of idle time to wait before printing.
If user input arrives before this interval of time has elapsed after the
last input, no documentation will be printed.

If this variable is set to 0, no idle time is required." :type 'number :group 'eldoc)

(defcustom eldoc-minor-mode-string " ElDoc" "\
*String to display in mode line when Eldoc Mode is enabled; nil for none." :type '(choice string (const :tag "none" nil)) :group 'eldoc)

(defcustom eldoc-argument-case 'upcase "\
Case to display argument names of functions, as a symbol.
This has two preferred values: `upcase' or `downcase'.
Actually, any name of a function which takes a string as an argument and
returns another string is acceptable." :type '(choice (const upcase) (const downcase)) :group 'eldoc)

;;;***

;;;### (autoloads (elp-recycle-buffers-p elp-use-standard-output elp-report-limit elp-sort-by-function elp-reset-after-results elp-function-list elp) "elp" "xemacs-devel/elp.el")
(defconst custom-define-current-source-file "elp.el")

(defgroup elp nil "Emacs Lisp Profiler" :group 'lisp)

(defcustom elp-function-list nil "\
*List of functions to profile.
Used by the command `elp-instrument-list'." :type '(repeat function) :group 'elp)

(defcustom elp-reset-after-results t "\
*Non-nil means reset all profiling info after results are displayed.
Results are displayed with the `elp-results' command." :type 'boolean :group 'elp)

(defcustom elp-sort-by-function 'elp-sort-by-total-time "\
*Non-nil specifies elp results sorting function.
These functions are currently available:

  elp-sort-by-call-count   -- sort by the highest call count
  elp-sort-by-total-time   -- sort by the highest total time
  elp-sort-by-average-time -- sort by the highest average times

You can write you're own sort function. It should adhere to the
interface specified by the PRED argument for the `sort' defun.  Each
\"element of LIST\" is really a 4 element vector where element 0 is
the call count, element 1 is the total time spent in the function,
element 2 is the average time spent in the function, and element 3 is
the symbol's name string." :type 'function :group 'elp)

(defcustom elp-report-limit 1 "\
*Prevents some functions from being displayed in the results buffer.
If a number, no function that has been called fewer than that number
of times will be displayed in the output buffer.  If nil, all
functions will be displayed." :type '(choice integer (const :tag "Show All" nil)) :group 'elp)

(defcustom elp-use-standard-output nil "\
*Non-nil says to output to `standard-output' instead of a buffer." :type 'boolean :group 'elp)

(defcustom elp-recycle-buffers-p t "\
*nil says to not recycle the `elp-results-buffer'.
In other words, a new unique buffer is create every time you run
\\[elp-results]." :type 'boolean :group 'elp)

;;;***

;;;### (autoloads (find-function-after-hook find-function-recenter-line find-function-source-path find-face-regexp find-variable-regexp find-function-regexp find-function) "find-func" "xemacs-devel/find-func.el")
(defconst custom-define-current-source-file "find-func.el")

(defgroup find-function nil "Finds the definition of the Emacs Lisp symbol near point." :group 'lisp)

(defcustom find-function-regexp (concat "^\\s-*(\\(def\\(ine-skeleton\\|ine-generic-mode\\|ine-derived-mode\\|ine\\(?:-global\\)?-minor-mode\\|ine-compilation-mode\\|un-cvs-mode\\|foo\\|[^cfgv]\\w+\\*?\\)\\|easy-mmode-define-[a-z-]+\\|easy-menu-define\\|menu-bar-make-toggle\\)" find-function-space-re "\\('\\|(quote \\)?%s\\(\\s-\\|$\\|(\\|)\\)") "\
The regexp used by `find-function' to search for a function definition.
Note it must contain a `%s' at the place where `format'
should insert the function name.  The default value avoids `defconst',
`defgroup', `defvar', `defface'.

Please send improvements and fixes to the maintainer." :type 'regexp :group 'find-function)

(defcustom find-variable-regexp (concat "^\\s-*(\\(def[^fumag]\\(\\w\\|\\s_\\)+\\*?\\|easy-mmode-def\\(map\\|syntax\\)\\|easy-menu-define\\)" find-function-space-re "%s\\(\\s-\\|$\\)") "\
The regexp used by `find-variable' to search for a variable definition.
Note it must contain a `%s' at the place where `format'
should insert the variable name.  The default value
avoids `defun', `defmacro', `defalias', `defadvice', `defgroup', `defface'.

Please send improvements and fixes to the maintainer." :type 'regexp :group 'find-function)

(defcustom find-face-regexp (concat "^\\s-*(defface" find-function-space-re "%s\\(\\s-\\|$\\)") "\
The regexp used by `find-face' to search for a face definition.
Note it must contain a `%s' at the place where `format'
should insert the face name.

Please send improvements and fixes to the maintainer." :type 'regexp :group 'find-function :version "22.1")

(defcustom find-function-source-path nil "\
The default list of directories where `find-function' searches.

If this variable is nil then `find-function' searches `load-path' by
default." :type '(repeat directory) :group 'find-function)

(defcustom find-function-recenter-line 1 "\
The window line-number from which to start displaying a symbol definition.
A value of nil implies center the beginning of the definition.
See the function `center-to-window-line' for more information, and
`find-function' and `find-variable'." :type '(choice (const :tag "Center" nil) integer) :group 'find-function)

(defcustom find-function-after-hook nil "\
Hook run after finding symbol definition.

See the functions `find-function' and `find-variable'." :group 'find-function)

;;;***

;;;### (autoloads (copylefts-to-hide hide-copyleft) "hide-copyleft" "xemacs-devel/hide-copyleft.el")
(defconst custom-define-current-source-file "hide-copyleft.el")

(defgroup hide-copyleft nil "Hide copyright prologs." :group 'matching)

(defcustom copylefts-to-hide '(("free software; you can redistribute it" . "notice must be preserved on all") ("free software; you can redistribute it" . "copy of the GNU General Public License.*\n?.*\n?.*\n?.*\n?.*\\(02139,\\|02111-1307\\)") ("distributed in the hope that it will be useful," . "notice must be preserved on all") ("free software; you can redistribute it" . "General Public License for more details\\.") ("Permission to use, copy, modify," . "WITH THE USE OR PERFORMANCE") ("Permission to use, copy, modify," . "without express or implied warranty") ("Copyright.*OPEN SOFTWARE FOUNDATION" . "X Window System is a trademark of the") ("THIS SOFTWARE IS FURNISHED UNDER A LICENSE" . "X Window System is a trademark of the") ("Permission to use, copy, and distribute" . " provided \"as is\" without") ("Copyright 19[0-9][0-9] by " . "OR PERFORMANCE OF THIS SOFTWARE\\.") ("RESTRICTED RIGHTS LEGEND" . "All rights reserved\\.\\(\n;;; ?$\\)?") ("^%%BeginDocumentation" . "^%%EndDocumentation")) "\
An alist of pairs of regexps which delimit copyright notices to hide.
The first one found is hidden, so order is significant." :group 'hide-copyleft :type '(repeat (cons (regexp :tag "Top line") (regexp :tag "Bottom line"))))

;;;***

;;;### (autoloads (ielm-mode-hook ielm-dynamic-multiline-inputs ielm-dynamic-return ielm-noisy ielm) "ielm" "xemacs-devel/ielm.el")
(defconst custom-define-current-source-file "ielm.el")

(defgroup ielm nil "Interaction mode for Emacs Lisp." :group 'lisp)

(defcustom ielm-noisy t "\
*If non-nil, IELM will beep on error." :type 'boolean :group 'ielm)

(defcustom ielm-dynamic-return t "\
*Controls whether \\<ielm-map>\\[ielm-return] has intelligent behaviour in IELM.
If non-nil, \\[ielm-return] evaluates input for complete sexps, or inserts a newline
and indents for incomplete sexps.  If nil, always inserts newlines." :type 'boolean :group 'ielm)

(defcustom ielm-dynamic-multiline-inputs t "\
*Force multiline inputs to start from column zero?
If non-nil, after entering the first line of an incomplete sexp, a newline
will be inserted after the prompt, moving the input to the next line.
This gives more frame width for large indented sexps, and allows functions
such as `edebug-defun' to work with such inputs." :type 'boolean :group 'ielm)

(defcustom ielm-mode-hook nil "\
*Hooks to be run when IELM (`inferior-emacs-lisp-mode') is started." :type 'hook :group 'ielm)

;;;***

;;;### (autoloads (patch-keywords-followup-to patch-review-mua patch-keywords patch-review) "patch-keywords" "xemacs-devel/patch-keywords.el")
(defconst custom-define-current-source-file "patch-keywords.el")

(defgroup patch-review nil "Patch submission review." :group 'mail)

(defcustom patch-keywords '("APPROVE" "COMMIT" "FORWARD" "QUERY" "RECOMMEND" "SUPERSEDES" "VETO" "21.4" "21.5") "\
List of keywords used for reviewing patches.

The default values are the keywords currently used by the XEmacs
Review Board." :group 'patch-review :type '(repeat (string :tag "Review Action Keyword")) :tag "Action Keywords")

(defcustom patch-review-mua 'gnus "\
The MUA (Mail User Agent) you use for reviewing patches.

Currently, the only MUAs that are supported are Gnus and VM.  Should
we even bother with things like MEW or Rmail?" :group 'patch-review :type '(choice (item gnus) (item vm) (item mew\ \(Not\ Supported\)) (item rmail\ \(Not\ Supported\))) :tag "MUA")

(defcustom patch-keywords-followup-to "XEmacs Beta <xemacs-beta@xemacs.org>" "\
The address to put into the \"Mail-Followup-To:\" header.
This is so that any further discussions relating to the submitted
patch can take place in a separate forum." :group 'patch-review :type 'string :tag "Followups Address")

;;;***

;;;### (autoloads (patcher-gnus-article-minor-mode-hook patcher-gnus-article-minor-mode-string patcher-gnus-summary-minor-mode-hook patcher-gnus-summary-minor-mode-string patcher-mail-run-gnus-other-frame patcher-mail-run-gnus patcher-mail-check-commit-action patcher-mail-check-change-logs-insertion patcher-mail patcher-minor-mode-hook patcher-minor-mode-string patcher-logmsg-mode-hook patcher-max-inheritance-depth patcher-max-theme-depth patcher-subprojects patcher-projects patcher-projects patcher-themes patcher-themes patcher-default-themes patcher-default-kill-source-files-after-diffing patcher-default-kill-change-logs-after-sending patcher-default-kill-source-files-after-sending patcher-default-edit-log-message patcher-default-change-logs-separator patcher-default-log-message-items patcher-default-failed-command-regexp patcher-default-committed-notice patcher-default-confirm-commits patcher-default-commit-command patcher-default-commit-privilege patcher-default-change-logs-diff-command patcher-default-diff-line-filter patcher-default-after-save-change-log-hook patcher-default-notice-change-log-hook patcher-default-after-diff-hook patcher-default-diff-header patcher-default-diff-cleaner patcher-default-diff-command patcher-default-pre-command patcher-default-command-directory patcher-default-diff-prologue-function patcher-default-change-logs-prologue patcher-default-change-logs-appearance patcher-default-change-logs-user-mail patcher-default-change-logs-user-name patcher-default-change-logs-updating patcher-default-mail-prologue patcher-default-subject patcher-default-subject-committed-prefix patcher-default-subject-prefix patcher-default-gnus-group patcher-default-to-address patcher-default-user-mail patcher-default-user-name patcher-default-mail-method patcher-default-name patcher-default patcher) "patcher" "xemacs-devel/patcher.el")
(defconst custom-define-current-source-file "patcher.el")

(defgroup patcher nil "Automatic archive-base project maintenance.")

(defgroup patcher-default nil "Default settings for Patcher project options." :group 'patcher)

(defcustom patcher-default-name nil "\
*Default name for Patcher projects.

This project option (a string) exists to let you define different Patcher
projects (hence with different names) sharing a common name for the
underlying diff and commit commands.  If set, it will be used rather than
the real project's name." :group 'patcher-default :type '(choice (const :tag "Patcher name" nil) (string :tag "Other name")))

(defcustom patcher-default-mail-method 'compose-mail "\
*Default method used by Patcher to prepare a mail.

Currently, there are four built-in methods: 'compose-mail (the default),
'sendmail, 'message, 'gnus and 'fake.  Please refer to the corresponding
`patcher-mail-*' function for a description of each method.

You can also define your own method, say `foo'.  In that case, you *must*
provide a function named `patcher-mail-foo' which takes two arguments: a
project descriptor and a string containing the subject of the message.
This function must prepare a mail buffer.  If you want to do this, please
see how it's done for the built-in methods." :group 'patcher-default :type '(radio (const compose-mail) (const sendmail) (const message) (const gnus) (const fake) (symbol :tag "other")))

(defcustom patcher-default-user-name nil "\
*Default user full name to use when sending a Patcher mail.

If nil, `user-full-name' is used." :group 'patcher-default :type '(choice (const :tag "user-full-name" nil) string))

(defcustom patcher-default-user-mail nil "\
*Default user mail address to use when sending a Patcher mail.

If nil, `user-mail-address' is used." :group 'patcher-default :type '(choice (const :tag "user-mail-address" nil) string))

(defcustom patcher-default-to-address nil "\
*Default To: header value to use when sending a Patcher mail.

This variable is used by all mail methods except the 'gnus one (see
`patcher-default-mail-method').  If nil, it is prompted for." :group 'patcher-default :type '(choice (const :tag "Ask" nil) string))

(defcustom patcher-default-gnus-group nil "\
*Default Gnus group to use when sending a Patcher mail.

This variable is used only in the 'gnus mail method (see
`patcher-default-mail-method').  The mail sending process will behave as if
you had typed `C-u a' in the group buffer on that Gnus group.  If nil,
it is prompted for." :group 'patcher-default :type '(choice (const :tag "Ask" nil) string))

(defcustom patcher-default-subject-prefix "[PATCH]" "\
*Default prefix for the subject of Patcher mails.

The following string transformations are performed:
- %n: the value of the :name project option if set, or the project's name
      in the Patcher sense.
- %N: the project's name in the Patcher sense.

A space will be inserted between the prefix and the rest of the subject,
as appropriate.  This part of the subject is never prompted for.  See
also `patcher-default-subject' and
`patcher-default-subject-committed-prefix'." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-subject-committed-prefix "[COMMIT]" "\
*Default prefix for the subject of Patcher mails.

Same as `patcher-default-subject-prefix', but for committed patches.
If nil, keep the normal subject prefix." :group 'patcher-default :type '(choice (const :tag "Don't change" nil) string))

(defcustom patcher-default-subject nil "\
*Default subject for Patcher mails.

The following string transformations are performed:
- %n: the value of the :name project option if set, or the project's name
      in the Patcher sense.
- %N: the project's name in the Patcher sense.

Please note that this is used *only* to provide a default value for prompted
subjects.  Subjects are *always* prompted for.

See also `patcher-default-subject-prefix' and
`patcher-default-subject-committed-prefix', which are not subject to
prompting." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-mail-prologue nil "\
*Default prologue for every Patcher mail." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-change-logs-updating 'automatic "\
*Default ChangeLog updating mode.

Possible values and their meaning are:
- 'automatic: (the default) Patcher generates ChangeLog skeletons
   automatically based on the created diff (you then have to fill up the
   entries as needed).
- 'manual: you are supposed to have updated the ChangeLog files by hand,
   prior to calling Patcher.
-  nil: you don't do ChangeLogs at all." :group 'patcher-default :type '(radio (const :tag "Automatic" automatic) (const :tag "Manual" manual) (const :tag "None" nil)))

(defcustom patcher-default-change-logs-user-name nil "\
*Default user full name for generated ChangeLog entries.

If nil, let `patch-to-change-log' decide what to use.
Otherwise, it should be a string." :group 'patcher-default :type '(choice (const :tag "Default" nil) (string :tag "Other name")))

(defcustom patcher-default-change-logs-user-mail nil "\
*Default user mail address for generated ChangeLog entries.

If nil, let `patch-to-change-log' decide what to use.
Otherwise, it should be a string." :group 'patcher-default :type '(choice (const :tag "Default" nil) (string :tag "Other mail")))

(defcustom patcher-default-change-logs-appearance 'verbatim "\
*Default appearance of ChangeLog entries in Patcher mails.

The values currently supported are:
- 'verbatim (the default): ChangeLog entries appear simply as text above
   the patch.  A short line mentioning the ChangeLog file they belong to
   is added when necessary.
- 'packed: ChangeLog files are diff'ed, but the output is packed above the
   rest of the patch.
- 'patch: ChangeLog files are diff'ed, and the output appears as part of
   the patch itself.
-  nil: ChangeLog entries don't appear at all.

See also the `patcher-default-change-logs-diff-command' user option." :group 'patcher-default :type '(radio (const :tag "Verbatim" verbatim) (const :tag "Diff, packed together" packed) (const :tag "Diff, part of the patch" patch) (const :tag "Don't appear in message" nil)))

(defcustom patcher-default-change-logs-prologue "%f addition:" "\
*Default ChangeLogs prologue for every Patcher mail.

This applies when ChangeLog additions appear verbatim in the message.
A %f occurring in this string will be replaced with the ChangeLog file name
\(relative to the project's directory)." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-diff-prologue-function 'patcher-default-diff-prologue "\
*Default function used to insert a prologue before each diff output.

Insertion must occur at current point in current buffer.
This function should take one argument indicating the kind of diff:
- a value of 'sources indicates a source diff only,
- a value of 'change-logs indicates a ChangeLog diff only,
- a value of 'mixed indicates a diff on both source and ChangeLog files.

The following variables are bound (when appropriate) when this function
is executed:
- `name': the name of the current Patcher project,
- `source-diff': the command used to create a source diff,
- `change-log-diff': the command used to create a ChangeLog diff,
- `source-files': sources files affected by the current patch,
- `change-log-files': ChangeLog files affected by the current patch.

In the case of a 'mixed diff, a nil value for `change-log-diff' indicates
that the same command was used for both the source and ChangeLog files." :group 'patcher-default :type '(choice (const :tag "Default" patcher-default-diff-prologue) (const :tag "None" nil) (symbol :tag "Other")))

(defcustom patcher-default-command-directory nil "\
*Default command directory for Patcher projects.

This directory (a string) can be relative to the project's directory.
All diff and commit commands are executed from this directory if set.
Otherwise, the project's directory is used." :group 'patcher-default :type '(choice (const :tag "Same directory" nil) (string :tag "Other directory")))

(defcustom patcher-default-pre-command "" "\
*Default string to prefix patcher commands with.

This is where you would put things like \"runsocks\"." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-diff-command nil "\
*Default method used by Patcher to generate a patch.

The following string transformations are performed:
- %n: the value of the :name project option if set, or the project's name
      in the Patcher sense.
- %N: the project's name in the Patcher sense.
- %f: the files affected by the patch.  These files can be specified by
      using `patcher-mail-subproject' instead of `patcher-mail' to prepare
      the patch.  Otherwise, the %f will simply be removed." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-diff-cleaner 'patcher-generic-diff-cleaner "\
*Default function used for cleaning up a diff.

This function is used to transform RCS-specific diff outputs into
something more standard, that `patch-to-change-log' can handle." :group 'patcher-default :type '(choice (const :tag "None" nil) function))

(defcustom patcher-default-diff-header nil "\
*Default diff header used by Patcher to determine the diff'ed file.

This variable is of the form (REGEXP . NUMBER). REGEXP is used to match
the beginning of a diff output, and NUMBER is the parenthesized level in
which to find the file name.

The default value is suitable for a Unix unified diff command output,
although file names with spaces are not supported." :group 'patcher-default :type '(choice (const :tag "None" nil) (list regexp (integer :tag "Old file match number") (integer :tag "New file match number"))))

(defcustom patcher-default-after-diff-hook nil "\
*Default hook run on the output of a Patcher diff comand.

The functions in this hook should operate on the current buffer and take
two optional arguments limiting the processing to a buffer region
\(in the absence of arguments, the whole buffer should be processed).

When each function in this hook is run, the point is placed at the
beginning of the region, and the buffer excursion is saved for you." :group 'patcher-default :type 'hook)

(defcustom patcher-default-notice-change-log-hook nil "\
*Default hook run every time Patcher notices a new ChangeLog file.

Noticing a ChangeLog file in this context means figuring out that it is
involved in the current patch. Every function in this hook hook will be
given the ChangeLog file name, relative to the project's directory, as
argument." :group 'patcher-default :type 'hook)

(defcustom patcher-default-after-save-change-log-hook nil "\
*Default hook run after a ChangeLog file is saved.

The functions in this hook are executed in the ChangeLog's buffer." :group 'patcher-default :type 'hook)

(defcustom patcher-default-diff-line-filter nil "\
*Default line filter to pass Patcher diffs through.

When inserting a diff in Patcher mails, lines matching this regexp will
be excluded.

Note: the regexp must match the whole line.  Don't add beginning and end
of line markers to it, Patcher will do this for you.

A value of nil (the default) means no line filter." :group 'patcher-default :type '(choice (const :tag "None" nil) regexp))

(defcustom patcher-default-change-logs-diff-command 'diff "\
*Default command to use to generate ChangeLog diffs.

This value is used when the ChangeLog appearance is either 'packed or
'patch (see the variable `patcher-default-change-logs-appearance').

If set to 'diff (the default), use the same command as for the rest of the
patch. Otherwise, it should be a string.

The following string transformations are performed:
- %n: the value of the :name project option if set, or the project's name
      in the Patcher sense.
- %N: the project's name in the Patcher sense.
- %f: the ChangeLog filenames.

Note: it is highly recommended to remove the context from ChangeLog diffs
because they often fail to apply correctly." :group 'patcher-default :type '(choice (const :tag "Project diff command" diff) (string :tag "Other diff command" "cvs -q diff -U 0 %f")))

(defcustom patcher-default-commit-privilege nil "\
*Default value for Patcher commit privilege status.

If you have the privilege to commit patches yourself, you should set
this option to t." :group 'patcher-default :type 'boolean)

(defcustom patcher-default-commit-command nil "\
*Default method used by Patcher to commit a patch.

The following string transformations are performed:
- %n: the value of the :name project option if set, or the project's name
      in the Patcher sense.
- %N: the project's name in the Patcher sense.
- %s: the name of a file containing the commit log message.
- %S: the commit log message itself (quoted to prevent shell expansion).
- %f: the files affected by the patch.  These files can be specified by using
     `patcher-mail-subproject' instead of `patcher-mail' to prepare the patch.
      Otherwise, the %f will simply be removed.

- %?f{xxx}: this construct is an \"if %f\" form: if %f expands to something,
	    this construct expands to `xxx'. Otherwise, its value is
	    discarded. See the `git' built-in themes for an example of use
	    (in `patcher-built-in-themes').
- %!f{xxx}: this construct is an \"if not %f\" form: if %f expands to nothing,
	    this construct expands to `xxx'. Otherwise, its value is
	    discarded. See the `git' built-in themes for an example of use
	    (in `patcher-built-in-themes')." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-confirm-commits t "\
*Whether Patcher asks for a confirmation before doing a commit by default." :group 'patcher-default :type 'boolean)

(defcustom patcher-default-committed-notice "NOTE: This patch has been committed." "\
*Default notice added to a mail after a commit." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-failed-command-regexp nil "\
*Default regular expression for matching the result of a failed command.

Commands in question are the diff and the commit one." :group 'patcher-default :type '(choice (const :tag "None" nil) regexp))

(defcustom patcher-default-log-message-items '(subject) "\
*Default elements used to initialize a Patcher commit log message.

This is nil, or a list of the following items:
- 'subject: the subject of the corresponding Patcher mail (sans the prefix),
- 'compressed-change-logs: the compressed ChangeLog entries for the current
   patch.
- 'change-logs: the ChangeLog entries for the current patch.  If some items
   appear before the ChangeLog entries, the ChangeLogs separator will
   automatically be included." :group 'patcher-default :type '(set (const :tag "Subject" subject) (const :tag "Compressed ChangeLogs" compressed-change-logs) (const :tag "ChangeLogs" change-logs)))

(defcustom patcher-default-change-logs-separator "-------------------- ChangeLog entries follow: --------------------" "\
*Default ChangeLog entries separator for Patcher commit log messages.

Either nil, or a string which will be inserted in a line of its own.

See also the function `patcher-logmsg-insert-change-logs'." :group 'patcher-default :type '(choice (const :tag "None" nil) string))

(defcustom patcher-default-edit-log-message t "\
*Whether Patcher lets you edit the commit log message by default.

If nil, Patcher will directly use the initialization value (see
`patcher-default-init-log-message')." :group 'patcher-default :type 'boolean)

(defcustom patcher-default-kill-source-files-after-sending t "\
*Whether to kill source files after sending the mail be default.

This is effective only when sources files have not been killed already
\(see the variable `patcher-default-kill-source-files-after-diffing').

That feature is not implemented yet." :group 'patcher-default :type 'boolean)

(defcustom patcher-default-kill-change-logs-after-sending t "\
*Whether to kill the ChangeLog files after sending the mail by default." :group 'patcher-default :type 'boolean)

(defcustom patcher-default-kill-source-files-after-diffing t "\
*Whether to kill source files after building the ChangeLog skeletons
by default.

These files are loaded temporarily by `patch-to-change-log'.  If this
variable is non nil, `patch-to-change-log' will be instructed to remove
them when they are not needed anymore.

See also the variable `patcher-default-kill-source-files-after-sending'." :group 'patcher-default :type 'boolean)

(defcustom patcher-default-themes nil "\
*Default themes to use in Patcher projects.

This is a list of theme names (symbols) that must be defined either
in `patcher-themes' or `patcher-built-in-themes'." :group 'patcher-default :type '(repeat (symbol :tag "Theme name")))

(defgroup patcher-themes nil "Theme settings for Patcher projects." :group 'patcher)

(defcustom patcher-themes 'nil "\
*List of themes to use in Patcher projects.

Each element looks like (NAME :OPTION VALUE ...).  NAME is the theme
name (a symbol).  The remainder of the list is the same as in project
descriptors (see `patcher-projects').

Themes are searched for respectively in this variable and in
`patcher-built-in-themes'.

See also `patcher-max-theme-depth'." :group 'patcher-themes :type (backquote (repeat (group (symbol :tag "Theme name") (repeat :inline t :tag "Options" (choice :inline t :value (:mail-method compose-mail) (\,@ patcher-project-options-custom-type)))))))

(defgroup patcher-projects nil "Project settings for Patcher." :group 'patcher)

(defcustom patcher-projects 'nil "\
*List of project descriptors.

Each project descriptor looks like (NAME DIR :OPTION VALUE ...).
- NAME is the project's name (a string).
- DIR is the project's root directory (a string).

The remainder of the project descriptor is composed of \"project options\"
\(keyword / value pairs).  When Patcher needs a project option, it tries
to find it at different places:
- First, it looks for it in the project descriptor itself.
- If that fails, it tries to find it in the project themes, if any.
- If that fails, it tries to find it in the inherited projects, if any.
- If that fails, it falls back to the corresponding `patcher-default-*'
  user option." :group 'patcher-projects :type (backquote (repeat (group (string :tag "Project") (directory :tag "Project directory") (repeat :inline t :tag "Options" (choice :inline t :value (:mail-method compose-mail) (\,@ patcher-project-options-custom-type) (list :inline t :tag "Inheritance" :format "%{%t%}: %v" (const :tag "" :value :inheritance) (repeat :tag "From" (string :tag "Project")))))))))

(defcustom patcher-subprojects 'nil "\
*List of Patcher subproject descriptors.

Subproject descriptors are similar to project descriptors (see the
variable `patcher-projects') with a few exceptions:

- Instead of the project directory field DIR, you specify the name of the
  project this subproject is based on.
- Two project options are available in addition to the standard ones:
  - :subdirectory lets you specify a subdirectory (of the parent
     project's directory) in which the whole subproject resides.  There is
     no corresponding `patcher-default-subdirectory' fallback..
  - :files lets you specify a list of files or directories composing the
     subproject.  Each file specification can contain wildcards.  If a
     :subdirectory option is given, these files or directories should be
     relative to this subdirectory.  Otherwise, they should be relative to
     the base project's directory.  There is no corresponding
     `patcher-default-files' variable.
  Note that a subproject with neither a :subdirectory nor a :files option
  behaves exactly like the corresponding base project.
- Subprojects don't have an :inheritance mechanism.  Instead, they
  implicitly inherit from their base project (which in turn can inherit
  from other projects).

Note: the normal way to use predefined Patcher subprojects is to call
`patcher-mail', *not* `patcher-mail-subproject'.  Using the former will
directly use the set of files and/or directory you have specified.  Using
the latter will also let you modify this set." :group 'patcher-projects :type (backquote (repeat (group (string :tag "Subproject") (string :tag "Of project") (repeat :inline t :tag "Options" (choice :inline t :value (:subdirectory "") (list :inline t :tag "Subdirectory" :format "%{%t%}: %v" (const :tag "" :value :subdirectory) directory) (list :inline t :tag "Files" :format "%{%t%}: %v" (const :tag "" :value :files) (repeat :format "
%v%i
" file)) (\,@ patcher-project-options-custom-type)))))))

(defcustom patcher-max-theme-depth 8 "\
*Maximum nesting level in Patcher themes.

This option is a guard against infinite loops that might occur for wrong
settings of Patcher themes (as themes can contain themes)." :group 'patcher-themes :type 'integer)

(defcustom patcher-max-inheritance-depth 8 "\
*Maximum nesting level in Patcher projects.

This option is a guard against infinite loops that might occur for wrong
settings of Patcher projects (as projects can inherit projects)." :group 'patcher-projects :type 'integer)

(defcustom patcher-logmsg-mode-hook nil "\
*Hook to run after setting up Patcher-Logmsg mode." :group 'patcher :type 'hook)

(defcustom patcher-minor-mode-string " Patch" "\
*Patcher minor mode modeline string." :group 'patcher :type 'string)

(defcustom patcher-minor-mode-hook nil "\
*Hooks to run after setting up Patcher minor mode." :group 'patcher :type 'hook)

(defgroup patcher-mail nil "Mailing options for Patcher projects." :group 'patcher)

(defcustom patcher-mail-check-change-logs-insertion 'ask "\
*ChangeLogs insertion checking prior to sending a Patcher mail.

This option affects the behavior of Patcher when ChangeLogs are supposed
to appear by manual insertion into the mail buffer:
- if nil, Patcher never checks that you have inserted them, and lets you
  send the message as-is,
- if t, Patcher blindly aborts the sending process if you have forgotten
  to insert the ChangeLogs in the message buffer,
- if 'ask (the default), Patcher asks you whether you want to proceed with
  sending or not." :group 'patcher-mail :type '(radio (const :tag "Never check" nil) (const :tag "Abort sending upon omission" t) (const :tag "Ask the user" ask)))

(defcustom patcher-mail-check-commit-action 'ask "\
*Commit action checking prior to sending a Patcher mail.

This option affects the behavior of Patcher when you have set the
:commit-privilege project option:
- if nil, Patcher never checks that you have commited your changes,
  and lets you send the message without having done so,
- if t, Patcher blindly aborts the sending process if you have forgotten
  to commit your changes,
- if 'ask (the default), Patcher asks you whether you want to proceed with
  sending or not." :group 'patcher-mail :type '(radio (const :tag "Never check" nil) (const :tag "Abort sending upon omission" t) (const :tag "Ask the user" ask)))

(defcustom patcher-mail-run-gnus 'prompt "\
*Whether Patcher should run Gnus.

The 'gnus mailing method of Patcher needs a running Gnus session.
If Gnus is not running at the time it is needed, Patcher can start
it (or not) depending on this variable:
- if nil, Patcher will abort execution,
- it 'prompt (the default), Patcher will ask you what to do,
- if t Patcher will unconditionally start Gnus.

See also the function `patcher-mail-gnus'." :group 'patcher-mail :type '(radio (const :tag "never" nil) (const :tag "ask user" prompt) (const :tag "as needed" t)))

(defcustom patcher-mail-run-gnus-other-frame t "\
*Whether Patcher should start Gnus in a new frame.

This is used in case Patcher has to start Gnus by itself (see the
variable `patcher-mail-run-gnus').  Possible values are:
- nil:     start Gnus in the current frame,
- t:       start Gnus in a new frame,
- 'follow: start Gnus in a new frame, and also use this frame to prepare
	   the new Patcher message." :group 'patcher-mail :type '(radio (const :tag "Use current frame" nil) (const :tag "Create new frame" t) (const :tag "Create new frame, and use it for patcher" follow)))

(defcustom patcher-gnus-summary-minor-mode-string " Patch" "\
*Patcher Gnus Summary minor mode modeline string." :group 'patcher :type 'string)

(defcustom patcher-gnus-summary-minor-mode-hook nil "\
*Hooks to run after setting up Patcher Gnus Summary minor mode." :group 'patcher :type 'hook)

(defcustom patcher-gnus-article-minor-mode-string " Patch" "\
*Patcher Gnus Article minor mode modeline string." :group 'patcher :type 'string)

(defcustom patcher-gnus-article-minor-mode-hook nil "\
*Hooks to run after setting up Patcher Gnus Article minor mode." :group 'patcher :type 'hook)

;;;***

(provide 'xemacs-devel-custom-defines)
