;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'xetla-custom-defines) (error "Feature xetla-custom-defines already loaded"))

;;;### (autoloads (xetla-password-prompt-regexp xetla-show-internal-buffers-on-menu xetla-number-of-dead-process-buffer xetla-error-buffer xetla-process-buffer) "xetla-core" "xetla/xetla-core.el")
(defconst custom-define-current-source-file "xetla-core.el")

(defcustom xetla-process-buffer " *xetla-process*" "\
*Name of the process buffer." :type 'string :group 'xetla-internal)

(defcustom xetla-error-buffer " *xetla-errors*" "\
*Name of the buffer to which xetla's stderr is redirected." :type 'string :group 'xetla-internal)

(defcustom xetla-number-of-dead-process-buffer 20 "\
*Number of process buffers to keep after process termination.
When the number of process buffers exceeds this number, the most ancient
is killed.  This includes both the process buffer and the error
buffer (to which stderr is redirected).

A nil value here means \"Never kill any process buffer\". Useful for
debugging, but this will eat the memory of your computer ;-)" :type 'integer :group 'xetla-internal)

(defcustom xetla-show-internal-buffers-on-menu nil "\
Toggle display of dead process buffers in the buffer menu." :type 'boolean :group 'xetla-internal)

(defcustom xetla-password-prompt-regexp "[Pp]ass\\(word\\|phrase\\).*:\\s *\\'" "\
*Regexp matching prompts for passwords in the inferior process.
This is used by `eshell-watch-for-password-prompt'." :type 'regexp :group 'xetla)

;;;***

;;;### (autoloads (xetla-state-variables-list xetla-state-file-name xetla-state xetla-tips-enabled xetla-tips xetla-apply-patch-mapping xetla-log-edit-keywords xetla-revisions-shows-merged-by xetla-revisions-shows-merges xetla-revisions-shows-library xetla-revisions-shows-date xetla-revisions-shows-creator xetla-revisions-shows-summary xetla-use-arrow-keys-for-navigation xetla-follow-symlinks-mode xetla-follow-symlinks xetla-name-read-error-hook xetla-name-read-final-hook xetla-name-read-init-hook xetla-make-archive-hook xetla-make-version-hook xetla-make-category-hook xetla-make-branch-hook xetla-version-list-mode-hook xetla-revision-list-mode-hook xetla-logs-mode-hook xetla-log-edit-mode-hook xetla-inventory-mode-hook xetla-inventory-file-mode-hook xetla-category-list-mode-hook xetla-cat-log-mode-hook xetla-branch-list-mode-hook xetla-bookmarks-mode-hook xetla-archive-list-mode-hook xetla-hooks xetla-log-insert-last xetla-buffer-quit-mode xetla-switch-to-buffer-first xetla-read-directory-mode xetla-read-project-tree-mode xetla-switch-to-changes-buffer xetla-switch-to-buffer-mode xetla-log-buffer xetla-log-commands xetla-internal xetla-bookmarks-cleanup-dont-prompt xetla-cache-xetla-get-changeset xetla-log-library-greedy xetla-log-library xetla-config-directory xetla-tag-function xetla-bookmarks-file-name xetla-bookmarks xetla-use-skip-present-option xetla-use-forward-option xetla-three-way-merge xetla-commit-fix-missing-space xetla-commit-headers-allowed-to-be-empty xetla-commit-check-log-buffer-functions xetla-strict-commits xetla-changes-recursive xetla-automatically-revert-buffers xetla-do-not-prompt-for-save xetla-install-command-help-system xetla-highlight xetla-patch-executable xetla-diff-executable xetla-tla-executable xetla-prefix-key xetla-faces xetla-bindings xetla-file-actions xetla-revisions xetla-inventory xetla) "xetla-defs" "xetla/xetla-defs.el")
(defconst custom-define-current-source-file "xetla-defs.el")

(defgroup xetla nil "Arch interface for emacs." :group 'tools :prefix "xetla-")

(defgroup xetla-inventory nil "This group contains items used in inventory mode." :group 'xetla)

(defgroup xetla-revisions nil "This group contains items used in revisions mode." :group 'xetla)

(defgroup xetla-file-actions nil "This group contains items manipulating finding, saving and reverting files." :group 'xetla)

(defgroup xetla-bindings nil "This group contains items related to key bindings." :group 'xetla)

(defgroup xetla-faces nil "This group contains faces defined for Xetla." :group 'xetla)

(defcustom xetla-prefix-key [(control x) ?T] "\
Prefix key for most xetla commands." :type '(choice (const [(control x) ?T]) (const [(control x) ?t]) (const [(control x) ?v]) (const [(control x) ?V]) (const [(control x) ?v ?t]) (sexp)) :group 'xetla-bindings :set (lambda (var value) (if (boundp var) (global-unset-key (symbol-value var))) (set var value) (global-set-key (symbol-value var) xetla-global-keymap)))

(defcustom xetla-tla-executable "tla" "\
*The name of the xetla executable." :type 'string :group 'xetla)

(defcustom xetla-diff-executable "diff" "\
*The name of the diff executable." :type 'string :group 'xetla)

(defcustom xetla-patch-executable "patch" "\
*The name of the patch executable." :type 'string :group 'xetla)

(defcustom xetla-highlight t "\
*Use highlighting for XEtla buffers." :type 'boolean :group 'xetla)

(defcustom xetla-install-command-help-system t "\
*Use f1 to display help for the actual function call during minibuffer input.
Note: this functionality is provided for all minibuffer prompts." :type 'boolean :group 'xetla)

(defcustom xetla-do-not-prompt-for-save nil "\
*Whether or not xetla will prompt before saving.

If non nil, xetla will not prompt you before saving buffers of the
working local tree." :type 'boolean :group 'xetla-file-actions)

(defcustom xetla-automatically-revert-buffers t "\
*Whether or not xetla will automatically revert buffers.

If non nil, xetla will automatically revert unmodified buffers after an
arch operation modifying the file." :type 'boolean :group 'xetla-file-actions)

(defcustom xetla-changes-recursive t "\
*Whether or not xetla will compute changes recursively.

If non nil, `xetla-changes' will be applied recursively to subprojects
of the current tree" :type 'boolean :group 'xetla)

(defcustom xetla-strict-commits nil "\
*If non-nil, commit operations are invoked with the -strict option." :type 'boolean :group 'xetla)

(defcustom xetla-commit-check-log-buffer-functions '(xetla-commit-check-empty-headers xetla-commit-check-empty-line xetla-commit-check-missing-space) "\
*List of functions to check the ++log.. buffer.

Each function is called, from the log buffer, with no argument. It
should raise an error if commit should be canceled." :type 'hook :group 'xetla)

(defcustom xetla-commit-headers-allowed-to-be-empty "^\\(Keywords\\)$" "\
*Headers allowed to be empty in the ++log.. buffer.

This should be a regexp matching the header names. Headers not
matching this regexp should not be empty when committing." :type 'string :group 'xetla)

(defcustom xetla-commit-fix-missing-space t "\
*Whether or not xetla will add missing spaces after header names.

If non-nil, missing spaces after a space will be inserted
automatically instead of raising an error when committing." :type 'boolean :group 'xetla)

(defcustom xetla-three-way-merge t "\
*If non-nil, star-merge operations are invoked with -three-way." :type 'boolean :group 'xetla)

(defcustom xetla-use-forward-option nil "\
*If non-nil, use the -forward option with commands that allow it." :type 'boolean :group 'xetla)

(defcustom xetla-use-skip-present-option nil "\
*If non-nil, use -skip-present with commands that allow it." :type 'boolean :group 'xetla)

(defgroup xetla-bookmarks nil "xetla bookmarks allows you to save places (archive, category,\nbranch, version) in the archive that you use often. Try M-x\nxetla-bookmarks RET to see." :group 'xetla)

(defcustom xetla-bookmarks-file-name "bookmarks.el" "\
*File in which xetla bookmarks will be saved.
The bookmark file is stored in the `xetla-config-directory'" :type 'file :group 'xetla-bookmarks)

(defcustom xetla-tag-function 'xetla-tag-uuid "\
Function called to generate the value of the arch-tag.

The function must take no argument, and return a string without a
final newline." :type '(choice (const xetla-tag-uuid) (const xetla-tag-name-date-filename) function) :group 'xetla)

(defcustom xetla-config-directory "~/.xetla/" "\
*Directory in which the xetla config files will be stored." :type 'directory :group 'xetla)

(defcustom xetla-log-library "~/.arch-log-library/" "\
*Directory in which the log library will be stored." :type 'directory :group 'xetla-internal)

(defcustom xetla-log-library-greedy t "\
*Whether log files are automatically saved in the log library.

If non-nil, then, whenever xetla needs to access a log file, this file
will be copied to the log library." :type 'boolean :group 'xetla-internal)

(defcustom xetla-cache-xetla-get-changeset 2 "\
*Cache `xetla-get-changeset' calls.
When nil, don't cache.
When a number, cache only if the `xetla-get-changeset' call takes
more seconds than the number.
Otherwise don't cache the results.
The cache is kept only in RAM." :type 'integer :group 'xetla)

(defcustom xetla-bookmarks-cleanup-dont-prompt nil "\
*Whether xetla should prompt before cleaning a local tree.

non nil means `xetla-bookmarks-cleanup-local-trees' shouldn't prompt
before removing a local-tree" :type 'boolean :group 'xetla-bookmarks)

(defgroup xetla-internal nil "This group contains items used mainly for debugging." :group 'xetla)

(defcustom xetla-log-commands t "\
*Non nil means log all xetla commands in the buffer *xetla-log*." :type 'boolean :group 'xetla-internal)

(defcustom xetla-log-buffer " *xetla-log*" "\
*Name of the buffer in which xetla logs main events." :type 'string :group 'xetla-internal)

(defcustom xetla-switch-to-buffer-mode 'pop-to-buffer "\
*Mode for switching to xetla buffers.
Recommended settings are: 'pop-to-buffer, and 'show-in-other-window
and 'single-window" :type '(choice (const pop-to-buffer) (const single-window) (const dedicated-frame) (const show-in-other-window)) :group 'xetla)

(defcustom xetla-switch-to-changes-buffer nil "\
Switch to the changes buffer or stay in the current buffer." :type 'boolean :group 'xetla)

(defcustom xetla-read-project-tree-mode 'sometimes "\
*Mode for prompting project tree directories. Possible values are:

- always: When running a tla command requiring a tree, always prompt
  for it.

- sometimes: If a command is ran inside a project tree, the tree root
  is used. Otherwise, prompt.

- never: If a command is run inside a project tree, use the tree root.
  Othwise, raise an error." :type '(choice (const always) (const sometimes) (const never)) :group 'xetla)

(defcustom xetla-read-directory-mode 'sometimes "\
*How prompting project directories should be done.

Works similarly to `xetla-read-project-tree-mode', but this one is used
for commands like `xetla-inventory' for which a subdirectory of a
project tree is accepted." :type '(choice (const always) (const sometimes) (const never)) :group 'xetla)

(defcustom xetla-switch-to-buffer-first t "\
*Switch to newly created buffer on creation of buffers?

If non-nil, xetla commands implementing this feature will switch to the
newly created buffer when the command is called. Further (potentially
asynchronous) processes are run without modifying your
window-configuration. Otherwise, xetla will switch to the new buffer on
command completion." :type 'boolean :group 'xetla)

(defcustom xetla-buffer-quit-mode 'kill "\
*How *xetla-...* buffer should be killed.
If the value is 'kill, buffers are actually killed. Otherwise, just
burry them." :type '(choice (const kill) (const burry)) :group 'xetla)

(defcustom xetla-log-insert-last t "\
*If non-nil, insert changelog entries at the end of the log file." :type 'boolean :group 'xetla)

(defgroup xetla-hooks nil "This group contains hooks into xetla." :prefix "xetla-" :group 'xetla)

(defcustom xetla-archive-list-mode-hook nil "\
*Hooks run after switching to `xetla-archive-list-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-bookmarks-mode-hook nil "\
*Hooks run after switching to `xetla-bookmarks-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-branch-list-mode-hook nil "\
*Hooks run after switching to `xetla-branch-list-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-cat-log-mode-hook nil "\
*Hooks run after switching to `xetla-cat-log-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-category-list-mode-hook nil "\
*Hooks run after switching to `xetla-category-list-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-inventory-file-mode-hook nil "\
*Hooks run after switching to `xetla-inventory-file-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-inventory-mode-hook nil "\
*Hooks run after switching to `xetla-inventory-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-log-edit-mode-hook nil "\
*Hooks run after switching to `xetla-log-edit-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-logs-mode-hook nil "\
*Hooks run after switching to `xetla-logs-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-revision-list-mode-hook nil "\
*Hooks run after switching to `xetla-revision-list-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-version-list-mode-hook nil "\
*Hooks run after switching to `xetla-version-list-mode'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-make-branch-hook nil "\
*Hooks run after making a branch." :type 'hook :group 'xetla-hooks)

(defcustom xetla-make-category-hook nil "\
*Hooks run after making a category." :type 'hook :group 'xetla-hooks)

(defcustom xetla-make-version-hook nil "\
*Hooks run after making a version." :type 'hook :group 'xetla-hooks)

(defcustom xetla-make-archive-hook nil "\
*Hooks run after creating a new archive." :type 'hook :group 'xetla-hooks)

(defcustom xetla-name-read-init-hook nil "\
*Hooks run when the control enters to `xetla-name-read'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-name-read-final-hook nil "\
*Hooks run when the control leaves `xetla-name-read'.
The name read by `xetla-name-read' is passed to functions connected
to this hook as an argument." :type 'hook :group 'xetla-hooks)

(defcustom xetla-name-read-error-hook nil "\
*Hooks run when an error is occurred in `xetla-name-read'." :type 'hook :group 'xetla-hooks)

(defcustom xetla-follow-symlinks 'tree "\
*Follow symlinks of this type." :type '(choice (const :tag "None" nil) (const :tag "Symlinks into an arch-managed tree" tree) (const :tag "Symlinks to an arch-managed file" id)) :group 'xetla-file-actions)

(defcustom xetla-follow-symlinks-mode 'follow "\
*Before following a symlink do this." :type '(choice (const :tag "Ask" ask) (const :tag "Follow" follow) (const :tag "Warn" warn)) :group 'xetla-file-actions)

(defcustom xetla-use-arrow-keys-for-navigation nil "\
*Enable left/right for navigation.
This works best if `xetla-switch-to-buffer-mode' is set to 'single-window.

It enables binding for navigation allowing you to browse by only using the
cursor keys, which is much faster than n/p/return/^.  Use up/down to move to
an item, right to select it and left to go to its \"logical\" parent!

Got the idea?

See the variable `xetla-use-arrow-keys-for-navigation-list' for a list of
bindings that will be installed." :type '(choice (const :tag "Disabled" nil) (const :tag "Enabled" t) (const :tag "Enabled with Shift" shift)) :group 'xetla-bindings)

(defcustom xetla-revisions-shows-summary t "\
*Whether summary should be displayed for `xetla-revisions'." :type 'boolean :group 'xetla-revisions)

(defcustom xetla-revisions-shows-creator t "\
*Whether creator should be displayed for `xetla-revisions'." :type 'boolean :group 'xetla-revisions)

(defcustom xetla-revisions-shows-date t "\
*Whether date should be displayed for `xetla-revisions'." :type 'boolean :group 'xetla-revisions)

(defcustom xetla-revisions-shows-library t "\
*Display library information in revision lists.

If non-nil the presence of this revision in the library should be
displayed for `xetla-revisions'" :type 'boolean :group 'xetla-revisions)

(defcustom xetla-revisions-shows-merges nil "\
*Display merge information in revision lists.

If non-nil, the list of merged patches of this revision should be
displayed for `xetla-revisions'" :type 'boolean :group 'xetla-revisions)

(defcustom xetla-revisions-shows-merged-by t "\
*Display \"merged-by\" field in revision lists.

If non-nil the list of patches merged by this revision should be
displayed for `xetla-revisions'" :type 'boolean :group 'xetla-revisions)

(defcustom xetla-log-edit-keywords '("admin" "audit" "bugfix" "build/compile" "compat" "delete" "docfix" "documentation" "enhancement" "internal" "linting" "merge" "newfeature" "newfile" "release" "rename" "revert" "security" "sync" "trivial" "typo" "update" "ui" "user-visible" "warnfix" "whitespace") "\
A list of keywords for the Keywords field of a log message." :type '(repeat (string)) :group 'xetla)

(defcustom xetla-apply-patch-mapping nil "\
*Tree in which patches should be applied.

An alist of rules to match fully qualified revision names to target
directories.

That variable is used to offer a directory in `xetla-gnus-apply-patch'.
Example setting: '(((nil \"xetla\" nil nil nil) \"~/work/xetla/xetla\")))" :type '(repeat (cons :tag "Rule" (cons :tag "Full revision (regexps)" (choice (const nil) (regexp :tag "Archive")) (cons (choice (const nil) (regexp :tag "Category")) (cons (choice (const nil) (regexp :tag "Branch")) (cons (choice (const nil) (regexp :tag "Version")) (cons (choice (const nil) (string :tag "Revision")) (const nil)))))) (cons (string :tag "tree") (const nil)))) :group 'xetla)

(defgroup xetla-tips nil "\"Tip of the day\" feature for XEtla" :prefix "xetla-" :group 'xetla)

(defcustom xetla-tips-enabled t "\
*Set this to nil to disable tips." :type 'boolean :group 'xetla-tips)

(defgroup xetla-state nil "Saving XEtla's state between Emacs sessions." :prefix "xetla-" :group 'xetla)

(defcustom xetla-state-file-name "state.el" "\
*File in which xetla saves state variables between Emacs sessions.
The file is stored in the `xetla-config-directory'" :type 'file :group 'xetla-state)

(defcustom xetla-state-variables-list '(xetla-tips-number) "\
*List of variables to store in the state file `xetla-state-file-name'." :type '(repeat (symbol)) :group 'xetla-state)

;;;***

;;;### (autoloads (xetla-send-comments-format xetla-send-comments-width xetla-warn-about-conflict-files xetla-make-log-function) "xetla" "xetla/xetla.el")
(defconst custom-define-current-source-file "xetla.el")

(defcustom xetla-make-log-function 'xetla-default-make-log-function "\
*Function used to create the log buffer.

Must return a string which is the absolute name of the log file.  This
function is called only when the log file doesn't exist already.  The
default is `xetla-default-make-log-function', which just calls \"xetla
make-log\". If you want to override this function, you may just write
a wrapper around `xetla-default-make-log-function'." :type 'function :group 'xetla)

(defcustom xetla-warn-about-conflict-files t "\
*When non-`nil' ask whether to commit if conflict files are present.
When `nil' commit anyway." :group 'xetla)

(defcustom xetla-send-comments-width 25 "\
*Max length for the summary line when using %t in `xetla-send-comments-format'.")

(defcustom xetla-send-comments-format "Your patch %c--%b--%v--%r (%t)" "\
Format for the Subject line for `xetla-revision-send-comments'.

The following substring will be substituted:

%f: Full revision name
%a: The archive name
%c: The category name
%b: The branch name
%v: The version name
%r: The revision name
%s: The summary line
%t: The summary line, truncated to `xetla-send-comments-width'
characters.")

;;;***

(provide 'xetla-custom-defines)
