;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'xslide-custom-defines) (error "Feature xslide-custom-defines already loaded"))

;;;### (autoloads (xsl-process-error-regexps xsl-process-command xsl-process-find-output xsl-process-browse-output xsl-offer-save) "xslide-process" "xslide/xslide-process.el")
(defconst custom-define-current-source-file "xslide-process.el")

(defcustom xsl-offer-save t "\
*If non-nil, ask about saving modified buffers before \\[xsl-process] is run." :type '(choice (const :tag "Yes" t) (const :tag "No" nil)) :group 'xsl-process)

(defcustom xsl-process-browse-output nil "\
*If non-nil, open output in browser after \\[xsl-process] is run." :type '(choice (const :tag "Yes" t) (const :tag "No" nil)) :group 'xsl-process)

(defcustom xsl-process-find-output nil "\
*If non-nil, find output file after \\[xsl-process] is run." :type '(choice (const :tag "Yes" t) (const :tag "No" nil)) :group 'xsl-process)

(defcustom xsl-process-command (list "xt %i %s %o" "java com.jclark.xsl.Driver %i %s %o" "java org.apache.xalan.xslt.Process -IN %i -XSL %s -OUT %o" "saxon -o %o %i %s" "saxon -o %o %i" "java com.icl.saxon.StyleSheet -o %o %i %s" "java com.icl.saxon.StyleSheet -o %o %i" "xsltproc -o %o %s %i" "java jd.xml.xslt.Stylesheet -out %o %i %s" "java oracle.xml.parser.v2.oraxsl %i %s %o") "\
*The shell command to process an XSL document.

This is a `format' control string that by default should contain three
`%s' conversion specifications: the first will be replaced by the
value of `xsl-process-input-file' (or the empty string, if nil); the
second will be replaced by `xsl-process-stylesheet-file' (or the empty
string, if nil); the third will be replaced by
`xsl-process-output-file' (or the empty string, if nil).

If `xsl-process-files' is non-nil, the format string should contain
one `%s' conversion specification for each element of its result.

If `xsl-process-command' is a list, then every element should be a
string.  The strings will be tried in order and %-sequences in the
string will be replaced according to the list below, if the string contains
%-sequences with no replacement value the next string will be tried.

%b means the visited file of the current buffer
%i means the value of `xsl-process-input-file'
%s means the value of `xsl-process-stylesheet-file'
%o means the value of `xsl-process-output-file'
" :type '(repeat :tag "Commands" string) :group 'xsl-process)

(defcustom xsl-process-error-regexps '(("^file:\\([^;]+\\)\\; Line \\([0-9]+\\)\\;\\( Column \\([0-9]+\\)\\;\\)?" 1 2 4) ("^Error\\( at [^ ]+\\)? on line \\([0-9]+\\)\\( column \\([0-9]+\\)\\)? of file:\\(\\(/[A-Za-z]:\\)?[^:]+\\):$" 5 2 4) ("^file:\\([^<]+\\)<Line \\([0-9]+\\)\\(, Column \\([0-9]+\\)\\)?>:" 1 2 4) ("^- uri[ 	]+= file:\\(.+\\)\\([
\n+]- \\(\\([^(]*?(\\)?line[ 	]+\\(= \\)?\\([0-9]+\\)\\)?\\)?\\([
\n]+- column[ 	]+= \\([0-9]+\\)\\)?" 1 6 8) (".*\\<file:\\(\\(/[A-Za-z]:\\)?[^:]+\\):[ 	]*\\(\\([0-9]+\\):[ 	]*\\(\\([0-9]+\\):\\)?\\)?" 1 4 6) (".*\\([^ ]+\\.x[ms]l\\):[ 	]*\\([0-9]+\\):[ 	]*\\(\\([0-9]+\\):\\)?" 1 2 4) ("^\\([^:]+\\): \\([0-9]+\\): error:" 1 2)) "\
*Alist of regexps to recognize error messages from `xsl-process'.
See `compilation-error-regexp-alist'." :type '(repeat :tag "Regexps" (list (regexp :tag "Regexp") (integer :tag "File index") (integer :tag "Line index") (choice :tag "Column index" (integer) (const :tag "None" nil)))) :group 'xsl-process)

;;;***

;;;### (autoloads (xsl-element-indent-step xsl-indent-attributes xsl-initial-fo-initial-point xsl-initial-fo-file xsl-initial-stylesheet-initial-point xsl-initial-stylesheet-file xsl-process xsl-faces xsl) "xslide" "xslide/xslide.el")
(defconst custom-define-current-source-file "xslide.el")

(defgroup xsl nil "Major mode for editing XSL." :prefix "xsl-" :group 'languages)

(defgroup xsl-faces nil "Font faces used in XSL mode." :group 'xsl :group 'faces)

(defgroup xsl-process nil "Running XSL processors from XSL mode." :group 'xsl)

(defcustom xsl-initial-stylesheet-file (locate-library "xslide-initial.xsl" t) "\
*File containing initial stylesheet inserted into empty XSL buffers." :type '(choice (file :must-match t) (const :tag "No initial stylesheet" nil)) :group 'xsl)

(defcustom xsl-initial-stylesheet-initial-point 0 "\
*Initial position of point in initial stylesheet." :type '(integer) :group 'xsl)

(defcustom xsl-initial-fo-file (locate-library "xslide-initial.fo" t) "\
*File containing initial FO stylesheet inserted into empty XSL buffers." :type '(choice (file :must-match t) (const :tag "No initial FO file" nil)) :group 'xsl)

(defcustom xsl-initial-fo-initial-point 0 "\
*Initial position of point in initial FO stylesheet." :type '(integer) :group 'xsl)

(defcustom xsl-indent-attributes nil "\
*Whether to indent attributes on lines following an open tag.
If non-nil, attributes will be aligned with the space after the
element name, otherwise by two spaces." :type '(choice (const :tag "Yes" t) (const :tag "No" nil)) :group 'xsl)

(defcustom xsl-element-indent-step 2 "\
*Amount by which to indent success levels of nested elements." :type '(integer) :group 'xsl)

;;;***

(provide 'xslide-custom-defines)
