;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'xslt-process-custom-defines) (error "Feature xslt-process-custom-defines already loaded"))

;;;### (autoloads (xslt-process-mode-line-string xslt-process-key-binding xslt-process-additional-classpath xslt-process-jvm-arguments xslt-process-cocoon1-properties-file xslt-process-default-processor xslt-process) "xslt-process" "lisp/xslt-process.el")
(defconst custom-define-current-source-file "xslt-process.el")

(defgroup xslt-process nil "Run an XSLT processor on an Emacs buffer." :group 'tools)

(defcustom xslt-process-default-processor (list 'TrAX) "\
*The default XSLT processor to be applied to an XML document." :group 'xslt-process :type '(list (radio-button-choice (const :tag "Saxon" Saxon) (const :tag "Xalan 1.x" Xalan1) (const :tag "Generic TrAX processor (Saxon 6.1 and greater, Xalan2 etc.)" TrAX) (const :tag "Cocoon 1.x" Cocoon1))))

(defcustom xslt-process-cocoon1-properties-file "" "\
*The location of the Cocoon 1.x properties file." :group 'xslt-process :type '(file :must-match t :tag "Properties file"))

(defcustom xslt-process-jvm-arguments nil "\
*Additional arguments to be passed to the JVM.
Use this option to pass additional arguments to the JVM that might be
needed for the XSLT processor to function correctly." :group 'xslt-process :type '(repeat (string :tag "Argument")))

(defcustom xslt-process-additional-classpath nil "\
*Additional Java classpath to be passed when invoking Bean Shell.
Note that modifying this won't have any effect until you restart the
Bean Shell. You can do this by killing the *bsh* buffer." :group 'xslt-process :type '(repeat (file :must-match t :tag "Path")))

(defcustom xslt-process-key-binding "" "\
*Keybinding for invoking the XSLT processor.
To enter a normal key, enter its corresponding character. To enter a
key with a modifier, either type C-q followed by the desired modified
keystroke, e.g. C-q C-c to enter Control c. To enter a function key,
use the [f1], [f2] etc. notation." :group 'xslt-process :type '(string :tag "Key"))

(defcustom xslt-process-mode-line-string " XSLT" "\
*String displayed in the modeline when the xslt-process minor
mode is active. Set this to nil if you don't want a modeline
indicator." :group 'xslt-process :type 'string)

;;;***

(provide 'xslt-process-custom-defines)
