;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'xwem-custom-defines) (error "Feature xwem-custom-defines already loaded"))

;;;### (autoloads (xwem-batt-ac-line-color xwem-batt-ac-line-width xwem-batt-percentage-colors xwem-batt-width xwem-batt-height xwem-batt-update-interval xwem-batt) "xwem-battery" "lisp/xwem-battery.el")
(defconst custom-define-current-source-file "xwem-battery.el")

(defgroup xwem-batt nil "Group to customise APM battery monitor." :prefix "xwem-batt-" :group 'xwem)

(defcustom xwem-batt-update-interval 5 "\
*Apm battery dockapp update interval in seconds." :type 'number :group 'xwem-batt)

(defcustom xwem-batt-height 24 "\
*Height of apm battery dockapp in pixels." :type 'number :group 'xwem-batt)

(defcustom xwem-batt-width 10 "\
*Width of apm battery dockapp in pixels." :type 'number :group 'xwem-batt)

(defcustom xwem-batt-percentage-colors '((20 . "red3") (30 . "red2") (50 . "orange") (60 . "yellow2") (70 . "yellow3") (80 . "green3") (100 . "green2")) "\
*Table to translate percentage to color." :type '(repeat (cons (number :tag "Percents") (color :tag "Color"))) :group 'xwem-batt)

(defcustom xwem-batt-ac-line-width 4 "\
*Width of ac-line." :type 'number :group 'xwem-batt)

(defcustom xwem-batt-ac-line-color "blue" "\
*Color used to display ac-line." :type 'color :group 'xwem-batt)

;;;***

;;;### (autoloads (xwem-clgen-allow-make-frame xwem-clgen-select-new xwem-clgen-activate-new xwem-clgen-other-split-type xwem-clgen-other-on-split xwem-clgen-other-strategy xwem-clgen) "xwem-clgen" "lisp/xwem-clgen.el")
(defconst custom-define-current-source-file "xwem-clgen.el")

(defgroup xwem-clgen nil "Group to customise management of generic clients." :prefix "xwem-clgen-" :group 'xwem-modes)

(defcustom xwem-clgen-other-strategy 'samewin "\
*Strategy used when searching for other client in window.
Possible values are:
  
  `samewin'   - Search for client managed in window.

  `sameframe-nonactive' - Search for nonactive client managed
                          in window's frame.

  `sameframe-any'       - Search for any client managed in window's
                          frame.

  `samemanda-nonactive' - Search for any nonactive client with same
                          manage entry as other client.

  `any-nonactive'       - Search for any nonactive client." :type '(choice (const :tag "Same Window" samewin) (const :tag "Inactive in same frame" sameframe-nonactive) (const :tag "Any in same frame" sameframe-any) (const :tag "Inactive with same manda" samemanda-nonactive) (const :tag "Any inactive" any-nonactive)) :group 'xwem-clgen)

(defcustom xwem-clgen-other-on-split t "\
*Non-nil mean activate client in other window when doing window split." :type 'boolean :group 'xwem-clgen)

(defcustom xwem-clgen-other-split-type 'vertical "\
*Split type." :type '(choice (const :tag "Vertical" vertical) (const :tag "Horizontal" horizontal)) :group 'xwem-clgen)

(defcustom xwem-clgen-activate-new t "\
*Non-nil mean newly managed generic clients are activated in their windows." :type 'boolean :group 'xwem-clgen)

(defcustom xwem-clgen-select-new t "\
*Non-nil mean, select new clients managed in selected window.
This value overrides `xwem-clgen-activate-new' if window is selected." :type 'boolean :group 'xwem-clgen)

(defcustom xwem-clgen-allow-make-frame t "\
*Non-nil mean, clgen permited to create new frames." :type 'boolean :group 'xwem-clgen)

;;;***

;;;### (autoloads (xwem-client-deselect-hook xwem-client-select-hook xwem-cl-state-change-hook xwem-cl-change-hook xwem-cl-withdraw-hook xwem-cl-iconify-hook xwem-cl-refit-hook xwem-cl-deactivate-hook xwem-cl-activate-hook xwem-cl-manage-hook xwem-cl-destroy-hook xwem-cl-create-hook xwem-cl-mark-ring-max xwem-client-nonselected-border-color xwem-client-selected-border-color xwem-client-default-properties xwem-client-focusing xwem-iresize-visible xwem-imove-visible xwem-client-strict-activation xwem-cl-switch-other-omit-mode-specific xwem-cl-other-include-iconified xwem-cl-other-include-active xwem-cl-noicon-name xwem-cl-noname-name xwem-cl-use-parent-xwin xwem-modes xwem-cl) "xwem-clients" "lisp/xwem-clients.el")
(defconst custom-define-current-source-file "xwem-clients.el")

(defgroup xwem-cl nil "Group to customize XWEM Clients handling." :prefix "xwem-cl-" :group 'xwem)

(defgroup xwem-modes nil "Group to customize XWEM managing modes." :prefix "xwem-" :group 'xwem)

(defcustom xwem-cl-use-parent-xwin t "\
*Non-nil mean that CL will use some X window, where it(CL) lowered.
This is need to fullish some X applications, which accuire clients in
such evil manner." :type 'boolean :group 'xwem-cl)

(defcustom xwem-cl-noname-name "<noname>" "\
*Name for clients which does not have name." :type 'string :group 'xwem-cl)

(defcustom xwem-cl-noicon-name "<noname>" "\
*Icon name for clients which does not have their own." :type 'string :group 'xwem-cl)

(defcustom xwem-cl-other-include-active t "\
*Non-nil mean include active clients in clients list when switching.
If `xwem-clswi-include-active' is function, it must be a function that
accepts one argument - CL and returns non-nil if CL must be included." :type '(choice (const :tag "No" nil) (const :tag "Yes" t) (function :tag "Custom function")) :group 'xwem-cl)

(defcustom xwem-cl-other-include-iconified nil "\
*Non-nil mean include iconified clients in clients list when switching.
If `xwem-clswi-include-iconified' is function, it must be a function that
accepts one argument - CL and returns non-nil if CL must be included." :type '(choice (const :tag "No" nil) (const :tag "Yes" t) (function :tag "Custom function")) :group 'xwem-cl)

(defcustom xwem-cl-switch-other-omit-mode-specific nil "\
*Non-nil mean \\<xwem-global-map>\\[xwem-switch-other-client]
wont select client that can be selected with \\<xwem-global-map>\\[xwem-cl-switch-to-other]." :type 'boolean :group 'xwem-cl)

(defcustom xwem-client-strict-activation nil "\
*Non-nil mean client is checked for aliveness before the activation.
Seting `xwem-client-strict-activation' to non-nil can decrease
activation speed a little, because it requires full interaction with X
server, however it guaranties to prevent X errors on activation." :type 'boolean :group 'xwem-cl)

(defcustom xwem-imove-visible t "\
*Non-nil mean `xwem-client-imove' will info you about new position." :type 'boolean :group 'xwem-cl)

(defcustom xwem-iresize-visible t "\
*Non-nil mean `xwem-client-iresize' will info you about new size." :type 'boolean :group 'xwem-cl)

(defcustom xwem-client-focusing 'advanced "\
Clients focusing type.
One of:

  'advanced -  Any client can be selected, even if it has broken focus model.
  'standard -  Strictly follow ICCCM, hoping everything will be ok.

You should change default value only in very rare circumstances.  You
should fully understand how focusing works in xwem to change default
value." :type '(choice (const :tag "Advanced" advanced) (const :tag "Standard" standard)) :group 'xwem-cl)

(defcustom xwem-client-default-properties '(x-border-width 2) "\
*Default properties for newly managed clients." :type 'list :group 'xwem-cl)

(defcustom xwem-client-selected-border-color "green" "\
*Border color when client is selected." :type 'color :group 'xwem-cl)

(defcustom xwem-client-nonselected-border-color "gray" "\
*Border color when client is not selected." :type 'color :group 'xwem-cl)

(defcustom xwem-cl-mark-ring-max 16 "\
*Maximum size of `xwem-cl-mark-ring'.
Start discarding off end if gets this big." :type 'number :group 'xwem-cl)

(defcustom xwem-cl-create-hook nil "\
Hook to call when creating new client." :type 'hook :group 'xwem-cl)

(defcustom xwem-cl-destroy-hook nil "\
Hooks called with one argument - cl, when cl destroyed.
NOT USED YET." :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-manage-hook nil "\
*Hooks to be called with just managed CL as argument." :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-activate-hook nil "\
*Hooks to call when client activates.
Called with two arguments:
 CL   - Activated client
 TYPE - Activation type - either 'activate or 'select" :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-deactivate-hook nil "\
*Hooks to call when client deactivates.
Called with two arguments:
 CL   - Deactivated client
 TYPE - Deactivation type - either 'deactivate or 'deselect" :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-refit-hook nil "\
Hooks called when CL just refited." :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-iconify-hook nil "\
Hooks called when CL just iconified." :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-withdraw-hook nil "\
*Hooks to call when CL moved to withdrawn state." :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-change-hook nil "\
Hooks called when something changed in CL." :type 'hook :group 'xwem-hooks)

(defcustom xwem-cl-state-change-hook nil "\
*Hooks to run when state of client changes.
Every hook called with three args - CL OLD-STATE NEW-STATE." :type 'hook :group 'xwem-hooks)

(defcustom xwem-client-select-hook nil "\
*Hooks called when new client just selected.
It is pretty guarantied that `xwem-selected-client' is valid xwem-cl
structure at time of hook execution." :type 'hook :group 'xwem-hooks)

(defcustom xwem-client-deselect-hook nil "\
Hooks called with one arg - cl, when cl deselected.
It is pretty guarantied that `xwem-selected-client' is valid xwem-cl
structure at time of hook execution." :type 'hook :group 'xwem-hooks)

;;;***

;;;### (autoloads (xwem-clswi-show-info xwem-clswi-beep-on-error xwem-clswi) "xwem-clswi" "lisp/xwem-clswi.el")
(defconst custom-define-current-source-file "xwem-clswi.el")

(defgroup xwem-clswi nil "Group to customize clients switcher." :prefix "xwem-clswi-" :group 'xwem)

(defcustom xwem-clswi-beep-on-error t "\
*Non-nil mean beep on any error." :type 'boolean :group 'xwem-clswi)

(defcustom xwem-clswi-show-info nil "\
*Non-nil mean show info about client in xwem minibuffer after switch.
It also can be a function which accepts one argument - client and
return non-nil to show info." :type '(restricted-sexp :match-alternatives (functionp boolean-p)) :group 'xwem-clswi)

;;;***

;;;### (autoloads (xwem-desktop-onetime-goals xwem-desktop-goals xwem-desktop) "xwem-desktop" "lisp/xwem-desktop.el")
(defconst custom-define-current-source-file "xwem-desktop.el")

(defgroup xwem-desktop nil "Group to customize xwem desktop." :prefix "xwem-desktop-" :group 'xwem)

(defcustom xwem-desktop-goals '((keymap . xwem-user-macros-prefix) (xwem-read-filename-history . 100) (xwem-launcher-history . 100) (xwem-read-expression-history . 100) (xwem-open-file-commands-alist . 1024)) "\
*List of variables to save.
Each element is eather symbol or cons cell in form.
\(symbol . maxsize)." :type '(repeat (choice (const :tag "Frames configuration" frames-config) (cons :tag "Keymap goal" (const :tag "Keymap" keymap) (symbol :tag "Keymap prefix")) (cons :tag "History" (choice (const :tag "Launcher history" xwem-launcher-history) (const :tag "Expression history" xwem-read-expression-history) (symbol :tag "Custom history")) (number :tag "Max Size")))) :group 'xwem-desktop)

(defcustom xwem-desktop-onetime-goals '((frames-config . "frames-config")) "\
One time goals to save." :type '(repeat (choice (const :tag "Frames config" frames-config) (cons :tag "Variable" (symbol :tag "Custom Symbol") (number :tag "Max Size")))) :group 'xwem-desktop)

;;;***

;;;### (autoloads (xwem-edmacro-can-edit-nonmacro xwem-edmacro-can-edit-unbinded xwem-edmacro) "xwem-edmacro" "lisp/xwem-edmacro.el")
(defconst custom-define-current-source-file "xwem-edmacro.el")

(defgroup xwem-edmacro nil "Group to customize `xwem-edmacro' addon." :prefix "xwem-edmacro-" :group 'xwem-keyboard)

(defcustom xwem-edmacro-can-edit-unbinded t "\
*Non-nil mean that `xwem-edmacro' allows edit unbinded keys." :type 'boolean :group 'xwem-edmacro)

(defcustom xwem-edmacro-can-edit-nonmacro nil "\
*Non-nil allow you to edit keys binded to non-macro commands.
USE WITH CAUTION, if this variable is non-nil you can override any
binding in `xwem-global-map'!" :type 'boolean :group 'xwem-edmacro)

;;;***

;;;### (autoloads (xwem-background-mode-bound xwem-faces) "xwem-faces" "lisp/xwem-faces.el")
(defconst custom-define-current-source-file "xwem-faces.el")

(defgroup xwem-faces nil "*Group to customize faces used by XWEM." :prefix "xwem-face-" :group 'xwem)

(defcustom xwem-background-mode-bound 72000 "\
Number which is used to determine whether color has `dark' or `light' background mode.
Normally you should'nt modify it." :type '(choice (const :tag "Default" 65536) (const :tag "Low" 50000) (const :tag "Medium" 72000) (const :tag "High" 94000)) :group 'xwem-faces)

;;;***

;;;### (autoloads (xwem-default-focus-mode) "xwem-focus" "lisp/xwem-focus.el")
(defconst custom-define-current-source-file "xwem-focus.el")

(defcustom xwem-default-focus-mode 'generic "\
*Default CL's focus mode." :type '(choice (const :tag "Generic mode" generic) (const :tag "Click to focus" click-focus) (const :tag "Follow mouse" follow-mouse)) :group 'xwem)

;;;***

;;;### (autoloads (xwem-frame-default-title-layout xwem-frame-configuration-exporting xwem-frame-redraw-hook xwem-frame-move-hook xwem-frame-resize-hook xwem-frame-destroy-hook xwem-frame-change-hook xwem-frame-creation-hook xwem-frame-deselect-hook xwem-frame-select-hook xwem-frame-keep-number xwem-frame-autoselect-embedded xwem-frame-autoiconify-mode xwem-frame-rolling-switch xwem-frame-imoveresize-use-minibuffer xwem-frame-imoveresize-mode-function xwem-frame-imove-mode xwem-frame-iresize-mode xwem-frame-on-delim-resize-mode xwem-dedicated-frame-defalut-properties xwem-embedded-frame-default-properties xwem-frame-default-properties xwem-frame-cursor-background-color xwem-frame-cursor-foreground-color xwem-frame-cursor-shape xwem-frame-background xwem-frame) "xwem-frame" "lisp/xwem-frame.el")
(defconst custom-define-current-source-file "xwem-frame.el")

(defgroup xwem-frame nil "Group to customize xwem frames." :prefix "xwem-frame-" :prefix "xwem-face-" :group 'xwem)

(defcustom xwem-frame-background "gray60" "\
*Frame background color." :type 'color :group 'xwem-frame)

(defcustom xwem-frame-cursor-shape '(X-XC-top_left_arrow) "\
*Cursors shape which will be used when pointer is over xwem frame." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-frame-cursor (mapcar 'xwem-frame-xwin (xwem-frames-list))) :initialize 'custom-initialize-default :group 'xwem-frame)

(defcustom xwem-frame-cursor-foreground-color "#111111" "\
*Cursor's foreground color used when pointer is on xwem's frame." :type 'color :set (xwem-cus-set-cursor-foreground xwem-frame-cursor) :initialize 'custom-initialize-default :group 'xwem-frame)

(defcustom xwem-frame-cursor-background-color "#EEEEEE" "\
*Cursor's background color used when pointer is on xwem's frame." :type 'color :set (xwem-cus-set-cursor-background xwem-frame-cursor) :initialize 'custom-initialize-default :group 'xwem-frame)

(defcustom xwem-frame-default-properties (list 'inner-border-width 3 'inner-border-thickness 1 'outer-border-width 0 'background "gray60" 'title-height 18) "\
*Default properties list for xwem frames." :type '(restricted-sexp :match-alternatives (valid-plist-p)) :group 'xwem-frame)

(defcustom xwem-embedded-frame-default-properties (list 'inner-border-width 0 'inner-border-thickness 0 'outer-border-width 0) "\
*Default properties for embedded xwem frames.
Values in `xwem-embedded-frame-default-properties' overrides values in
`xwem-frame-default-properties'." :type '(restricted-sexp :match-alternatives (valid-plist-p)) :group 'xwem-frame)

(defcustom xwem-dedicated-frame-defalut-properties (list 'inner-border-width 2 'inner-border-thickness 1 'outer-border-width 0) "\
*Default properties for dedicated xwem frames.
Values in `xwem-dedicated-frame-defalut-properties' overrides values in
`xwem-frame-default-properties'." :type '(restricted-sexp :match-alternatives (valid-plist-p)) :group 'xwem-frame)

(defcustom xwem-frame-on-delim-resize-mode 'normal "\
*Mode to outline current window when doing `xwem-frame-on-delim-resize'." :type '(choice (const :tag "Normal border" normal) (const :tag "Opaque" opaque)) :group 'xwem-frame)

(defcustom xwem-frame-iresize-mode 'normal "\
*Default type of drawing outlines when resizing frame interactively.
Opaque mode can do unexpected things, such as eat your food from
refrigerator, so set it to Opaque on your own risk." :type '(choice (const :tag "Normal border" normal) (const :tag "Contiguous borders" contiguous) (const :tag "Outline Corners" corners) (const :tag "Grid" grid) (const :tag "Opaque" opaque)) :group 'xwem-frame)

(defcustom xwem-frame-imove-mode 'normal "\
*Default type of drawing outlines when moving frame interactively." :type '(choice (const :tag "Normal border" normal) (const :tag "Contiguous border" contiguous) (const :tag "Outline Corners" corners) (const :tag "Grid" grid) (const :tag "Opaque" opaque)) :group 'xwem-frame)

(defcustom xwem-frame-imoveresize-mode-function 'xwem-frame-imoveresize-mode-function-default "\
Function to call in way to select move or resize mode.
It is passed with two arguments - FRAME and WHAT.
Where FRAME is frame which is about to move/resize and WHAT is one of
'resize or 'move.
It should return one of:
 'normal     - Normal resize/move mode, just outline frame rectangle.
 'contiguous - Butified 'normal mode.
 'corners    - Outline frame corners.
 'grid       - Outline frame and draw grid inside.
 'opaque     - Opaque move/resize mode." :type 'function :group 'xwem-frame)

(defcustom xwem-frame-imoveresize-use-minibuffer t "\
*If non-nil, frame's geometry will be show while imove/iresize." :type 'boolean :group 'xwem-frame)

(defcustom xwem-frame-rolling-switch t "\
*Non-nil mean that \\<xwem-global-map>\\[xwem-frame-next] and
\\<xwem-global-map>\\[xwem-frame-previous] will always switch, even if
there no next or previous frame." :type 'boolean :group 'xwem-frame)

(defcustom xwem-frame-autoiconify-mode nil "\
Non-nil mean frame possible automatically iconifies when switching.
If switching from OFR to NFR frame values mean next:
 nil       - No frame will be iconified.
 intersect - OFR will be iconified if it intersects with NFR.
 always    - OFR always iconfied." :type '(choice (const :tag "Disabled" nil) (conts :tag "Intersect" intersect) (const :tag "Always" always)) :group 'xwem-frame)

(defcustom xwem-frame-autoselect-embedded t "\
*Non-nil mean if embedded frame selected as client, also select frame." :type 'boolean :group 'xwem-frame)

(defcustom xwem-frame-keep-number nil "\
*Non-nil mean frames keeps their numbers when intermediate frame destroyed." :type 'boolean :group 'xwem-frame)

(defcustom xwem-frame-select-hook nil "\
*Hooks to call when new frame just selected." :type 'hook :group 'xwem-frame)

(defcustom xwem-frame-deselect-hook nil "\
*Hooks to call when selected frame is about to be deselected." :type 'hook :group 'xwem-frame)

(defcustom xwem-frame-creation-hook nil "\
Hooks called with one argument - frame, when frame just created." :type 'hook :group 'xwem-hooks)

(defcustom xwem-frame-change-hook nil "\
Hooks called with one argument - frame, when frame changed." :type 'hook :group 'xwem-hooks)

(defcustom xwem-frame-destroy-hook nil "\
Hooks called with one argument - frame, when frame destroyed." :type 'hook :group 'xwem-hooks)

(defcustom xwem-frame-resize-hook nil "\
Hooks called with one argument - frame, when frame resized." :type 'hook :group 'xwem-hooks)

(defcustom xwem-frame-move-hook nil "\
Hooks called with one argument - frame, when frame moved." :type 'hook :group 'xwem-hooks)

(defcustom xwem-frame-redraw-hook nil "\
Hooks called with one argument - frame, when frame redrawed." :type 'hook :group 'xwem-hooks)

(defcustom xwem-frame-configuration-exporting t "\
*Non-nil mean, frame configuration exports after each frame command.
Non-nil value is useful when using xwem-agent.  It allows you restore
frames on (S)XEmacs restart." :type 'boolean :group 'xwem-frame)

(defcustom xwem-frame-default-title-layout 'top "\
*Default FRAME's title layout." :type '(choice (const :tag "No title" none) (const :tag "Top" top) (const :tag "Bottom" bottom) (const :tag "Left" left) (const :tag "Right" right)) :group 'xwem-frame)

;;;***

;;;### (autoloads (xwem-framei-dockapp-format-function xwem-framei-format-function xwem-framei-select-face-function xwem-framei-yoffset xwem-framei-xoffset xwem-framei-showtime xwem-framei) "xwem-framei" "lisp/xwem-framei.el")
(defconst custom-define-current-source-file "xwem-framei.el")

(defgroup xwem-framei nil "*Group to customize xwem frame indicator." :prefix "xwem-framei-" :group 'xwem-frame)

(defcustom xwem-framei-showtime 1 "\
Period of time in second while xwem framei is shown." :type 'number :group 'xwem-framei)

(defcustom xwem-framei-xoffset 20 "\
*X Offset from top left frame corner in pixels, where to show framei." :type 'number :group 'xwem-framei)

(defcustom xwem-framei-yoffset 20 "\
*Y Offset from top left frame corner in pixels, where to show framei." :type 'number :group 'xwem-framei)

(defcustom xwem-framei-select-face-function 'xwem-framei-default-sff "\
*Function called with one arg - frame and should return face, which
will be used.  Function can look like this:

\(cond ((string= \"Devel\" (xwem-frame-name frame))
       (get-face 'my-xwem-fi-devel-face))
      ((string= \"Inet\" (xwem-frame-name frame))
       (get-face 'my-xwem-fi-inet-face))
      )

To use different faces for different frames." :type 'function :group 'xwem-framei)

(defcustom xwem-framei-format-function 'xwem-framei-default-format "\
Function passed with one arg - frame, should return string to display." :type 'funtion :group 'xwem-framei)

(defcustom xwem-framei-dockapp-format-function 'xwem-framei-dockapp-default-format "\
Function passed with one arg - frame, should return string to display." :type 'funtion :group 'xwem-framei)

;;;***

;;;### (autoloads (xwem-holer-min-pixels xwem-holer-resize-cursor-background xwem-holer-resize-cursor-foreground xwem-holer-move-cursor-background xwem-holer-move-cursor-foreground xwem-holer-move-cursor-shape xwem-holer-outline-color xwem-holer-outline-width xwem-holer) "xwem-holer" "lisp/xwem-holer.el")
(defconst custom-define-current-source-file "xwem-holer.el")

(defgroup xwem-holer nil "Group to customize xwem holer." :prefix "xwem-holer-" :group 'xwem)

(defcustom xwem-holer-outline-width 3 "\
Width of outliner." :type 'number :group 'xwem-holer)

(defcustom xwem-holer-outline-color "blue2" "\
*Color of holer outliner." :type 'color :group 'xwem-holer)

(defcustom xwem-holer-move-cursor-shape 'X-XC-fleur "\
*Shape of cursor when moving holer." :type (xwem-cursor-shape-choice) :group 'xwem-holer)

(defcustom xwem-holer-move-cursor-foreground "#0000AA" "\
*Cursor's foreground when moving holer." :type 'color :group 'xwem-holer)

(defcustom xwem-holer-move-cursor-background "#000088" "\
*Cursor's background when moving holer." :type 'color :group 'xwem-holer)

(defcustom xwem-holer-resize-cursor-foreground "#0000AA" "\
*Cursor's foreground when resizing holer." :type 'color :group 'xwem-holer)

(defcustom xwem-holer-resize-cursor-background "#000088" "\
*Cursor's background when resizing holer." :type 'color :group 'xwem-holer)

(defcustom xwem-holer-min-pixels 10 "\
*Minimum pixels to change holer geometry.
Set it higher value to speed up moving/resizing." :type 'number :group 'xwem-holer)

;;;***

;;;### (autoloads (xwem-icons-list xwem-icons-dir) "xwem-icons" "lisp/xwem-icons.el")
(defconst custom-define-current-source-file "xwem-icons.el")

(defcustom xwem-icons-dir (locate-data-directory "xwem") "\
Directory where icons for use by XWEM lies." :type 'directory :group 'xwem)

(defcustom xwem-icons-list '(("mini-display.xpm" (class-inst "^Terminal$") (class-name "^Terminal$")) ("mini-clock.xpm" (application "xclock")) ("mini-measure.xpm" (application "xload")) ("mini-calc.xpm" (or (buffer-major-mode calc-mode) (class-name "[cC]alc"))) ("mini-xkeycaps.xpm" (application "xkeycaps")) ("mini-xv.xpm" (application "xv")) ("mini-imagemagic.xpm" (application "display")) ("mini-xdvi.xpm" (class-inst "^xdvi$") (class-name "^XDvi$")) ("mini-acroread.xpm" (class-name "^AcroRead\\|Xpdf$")) ("mini-info.xpm" (class-name "Xman")) ("mini-gimp.xpm" (class-name "^Gimp$")) ("mini-djvu.xpm" (class-inst "^djview$") (class-name "^Djview$")) ("mini-xemacstex.xpm" (or (buffer-major-mode plain-tex-mode) (buffer-major-mode texinfo-mode) (and (application "xemacs") (name "\\.tex")))) ("mini-xemacsC.xpm" (or (buffer-major-mode c-mode) (and (application "xemacs") (name "\\.[ch]")))) ("mini-xemacsgnus.xpm" (or (buffer-major-mode gnus-group-mode) (buffer-major-mode gnus-article-mode) (buffer-major-mode gnus-summary-mode) (and (application "xemacs") (name "\\(Group\\|Summary\\|Article\\)")))) ("mini-xemacspy.xpm" (or (buffer-major-mode python-mode) (and (application "xemacs") (name "\\.py")))) ("mini-links.xpm" (application "links")) ("mini-ddd.xpm" (application "ddd")) ("mini-vnc.xpm" (application "vncviewer")) ("mini-firefox.xpm" (application "firefox")) ("mini-mozilla.xpm" (application "mozilla")) ("mini-opera.xpm" (application "opera")) ("mini-gv.xpm" (or (application "gv") (application "ghostview"))) ("mini-xfig.xpm" (application "xfig")) ("mini-ethereal.xpm" (application "ethereal")) ("mini-font.xpm" (or (application "xfd") (application "xfontsel"))) ("mini-sh1.xpm" (or (buffer-major-mode eshell-mode) (buffer-major-mode shell-mode) (buffer-major-mode term-mode) (buffer-major-mode terminal-mode) (and (class-inst "x?console") (class-name "[Xx]?[Cc]onsole")))) ("mini-colors.xpm" (or (buffer-name "\\*Colors\\*") (and (class-inst "x?colors?") (class-name "[Xx]?colors?")) (name "^xcmap$"))) ("mini-xchat.xpm" (application "xchat")) ("mini-diag.xpm" (application "gnumeric")) ("mini-xemacs.xpm" (application "xemacs")) ("mini-zoom.xpm" (or (class-inst "^Xmag$") (name "^Lupe$"))) ("mini-graph.xpm" (application "gnuplot")) ("mini-icq.xpm" (or (buffer-major-mode eicq-buddy-mode) (buffer-major-mode eicq-log-mode) (and (application "xemacs") (name "\\*Status\\*")) (application "licq") (name "[LlMmVv][Ii][Cc][Qq]"))) ("mini-term.xpm" (and (class-name "^.[tT]erm$") (or (class-inst "^.term$") (class-inst "^rxvt$")))) ("mini-x2.xpm" (eval t))) "\
Icons matching list in `xwem-manage-list' format." :type '(repeat (cons :tag "Icon specifier" (string :tag "Icon name") (repeat (cons (choice (const :tag "Application" application) (const :tag "Class name" class-name) (const :tag "Class instance" class-inst) (const :tag "Name" name) (const :tag "Buffer Major Mode" buffer-major-mode) (const :tag "Buffer Name" buffer-name) (const :tag "Buffer Name" buffer-name) (const :tag "Sexp for evaluation" eval) (const :tag "Function" function) (const :tag "Or operation" or) (const :tag "And operation" and)) (repeat sexp))))) :group 'xwem)

;;;***

;;;### (autoloads (xwem-completing-read-type) "xwem-interactive" "lisp/xwem-interactive.el")
(defconst custom-define-current-source-file "xwem-interactive.el")

(defcustom xwem-completing-read-type 'iswitchb "\
*Type of interactive client reading.
Possible values are `iswitchb', requires iswitchb package, or
`complete' uses standard `completing-read'." :type '(choice (const :tag "Iswitchb" iswitchb) (const :tag "Standard" complete)) :group 'xwem-misc)

;;;***

;;;### (autoloads (xwem-keyboard-use-synth-events xwem-keyboard-init-hook xwem-kbd-quit-hook xwem-universal-key xwem-prefix-help-command xwem-help-key xwem-quit-command xwem-quit-key xwem-kbd-evillocks xwem-control-modifier xwem-meta-modifier xwem-hyper-modifier xwem-keyboard-echo-keystrokes xwem-post-command-hook xwem-pre-command-hook xwem-keyboard) "xwem-keyboard" "lisp/xwem-keyboard.el")
(defconst custom-define-current-source-file "xwem-keyboard.el")

(defgroup xwem-keyboard nil "Group to customize keyboard in XWEM." :prefix "xwem-" :group 'xwem)

(defcustom xwem-pre-command-hook nil "\
*Hooks to run just before executing command.
This may examine `xwem-this-command' variable to find out which
command is about to be run, or may change it to cause a different
command to run." :type 'hook :group 'xwem-keyboard :group 'xwem-hooks)

(defcustom xwem-post-command-hook nil "\
*Hooks to run after command execution." :type 'hook :group 'xwem-keyboard :group 'xwem-hooks)

(defcustom xwem-keyboard-echo-keystrokes 1 "\
*If non-nil than echo unfinished commands in echo area after this many seconds of pause." :type 'number :group 'xwem-keyboard)

(defcustom xwem-hyper-modifier 'hyper "\
*This is a little trick of how ``H'' interpretted in `xwem-kbd' specification." :type '(choice (const :tag "Meta" meta) (const :tag "Control" control) (const :tag "Super" super) (const :tag "Hyper" hyper) (const :tag "Alt" alt)) :group 'xwem-keyboard)

(defcustom xwem-meta-modifier 'meta "\
*This is a little trick of how ``M'' interpretted in `xwem-kbd' specification." :type '(choice (const :tag "Meta" meta) (const :tag "Control" control) (const :tag "Super" super) (const :tag "Hyper" hyper) (const :tag "Alt" alt)) :group 'xwem-keyboard)

(defcustom xwem-control-modifier 'control "\
*This is a little trick of how ``C'' interpretted in `xwem-kbd'." :type '(choice (const :tag "Meta" meta) (const :tag "Control" control) (const :tag "Super" super) (const :tag "Hyper" hyper) (const :tag "Alt" alt)) :group 'xwem-keyboard)

(defcustom xwem-kbd-evillocks (list XK-NumLock XK-Caps-Lock) "\
List of evil locks." :type (backquote (repeat (choice (const :tag "NumLock" (\, XK-NumLock)) (const :tag "CapsLock" (\, XK-Caps-Lock))))) :group 'xwem-keyboard)

(defcustom xwem-quit-key [(hyper ?g)] "\
Quit command key." :type 'sexp :group 'xwem-keyboard)

(defcustom xwem-quit-command 'xwem-keyboard-quit "\
Default command to be called when `xwem-quit-key' pressed." :type 'function :group 'xwem-keyboard)

(defcustom xwem-help-key [(hyper ?h)] "\
Help command key." :type 'sexp :group 'xwem-keyboard)

(defcustom xwem-prefix-help-command 'xwem-describe-prefix-bindings "\
Default command to be called when `xwem-help-key' pressed." :type 'function :group 'xwem-keys)

(defcustom xwem-universal-key [(hyper ?u)] "\
Key for universal argument commands." :type 'sexp :group 'xwem-keyboard)

(defcustom xwem-kbd-quit-hook nil "\
*Hooks to be runned when KBD exits.
Runned only on \\<xwem-global-map>\\[xwem-kbd-quit], but not on
\\<xwem-global-map>\\[xwem-keyboard-quit]." :type 'hook :group 'xwem-keyboard :group 'xwem-hooks)

(defcustom xwem-keyboard-init-hook nil "\
*Hooks called after xwem keyboard initialization." :type 'hook :group 'xwem-keyboard :group 'xwem-hooks)

(defcustom xwem-keyboard-use-synth-events nil "\
*Non-nil mean use XSendEvent instead of XTEST's FakeInput.
Useful to set it to non-nil when using sticky modifiers or in any
other case when xwem can't properly force modifiers releasing.
However if having `xwem-keyboard-use-synth-events' to non-nil, make
sure you've configured clients to accept synthetic X events (f.i. set
`x-allow-sendevents' to non-nil to make XEmacs accept synthetic
events).
This is client local variable.  Each client have its own value for it." :type 'boolean :group 'xwem-keyboard)

;;;***

;;;### (autoloads (xwem-keymacro-macrofile xwem-keymacro-show-macro xwem-keymacro-debug xwem-keymacro-minib-bg) "xwem-keymacro" "lisp/xwem-keymacro.el")
(defconst custom-define-current-source-file "xwem-keymacro.el")

(defcustom xwem-keymacro-minib-bg "gray60" "\
*Background color for xwem's minibuffer while recording KBD macro.
If nil - background will not change." :type 'color :group 'xwem-keyboard)

(defcustom xwem-keymacro-debug nil "\
*Non-nil mean run keyboard macrosing stuff in debug mode." :type 'boolean :group 'xwem-keyboard)

(defcustom xwem-keymacro-show-macro nil "\
*Non-nil mean show keyboard macro in minibuffer, while executing." :type 'boolean :group 'xwem-keyboard)

(defcustom xwem-keymacro-macrofile "xwem-macros.el" "\
*Default filename where keyboard macros stores." :type 'file :group 'xwem-keyboard)

;;;***

;;;### (autoloads (xwem-keytt-synth-p) "xwem-keytt" "lisp/xwem-keytt.el")
(defconst custom-define-current-source-file "xwem-keytt.el")

(defcustom xwem-keytt-synth-p nil "\
*Non-nil mean use synthetic X events." :type 'boolean)

;;;***

;;;### (autoloads (xwem-open-file-registration xwem-open-file-commands-alist xwem-launch-dock-thick xwem-launch-dock-height xwem-launch-dock-width xwem-xlock-arguments xwem-xlock-program xwem-lupe-arguments xwem-lupe-program xwem-xterm-font4 xwem-xterm-font3 xwem-xterm-font2 xwem-xterm-font1 xwem-xterm-font-argument xwem-xterm-program xwem-launcher-frame-type xwem-launcher-split-type xwem-launcher-history xwem-launcher-abbrev-table xwem-launcher-function xwem-launcher-beep-done xwem-launcher) "xwem-launcher" "lisp/xwem-launcher.el")
(defconst custom-define-current-source-file "xwem-launcher.el")

(defgroup xwem-launcher nil "Group to customize XWEM's programs launcher." :prefix "xwem-" :group 'xwem)

(defcustom xwem-launcher-beep-done nil "\
*Non-nil mean beep when execution of program done.
Beep performed using (xwem-play-sound 'ready)." :type 'boolean :group 'xwem-launcher)

(defcustom xwem-launcher-function 'xwem-execute-program "\
Function to be used to execute external program." :type 'function :group 'xwem-launcher)

(defcustom xwem-launcher-abbrev-table nil "\
Abbrev table used by `xwem-launcher-query'." :type 'list :group 'xwem-launcher)

(defcustom xwem-launcher-history nil "\
History of `xwem-launcher-query'ies." :type 'list :group 'xwem-launcher)

(defcustom xwem-launcher-split-type 'xwem-execute-program-other-win-vertical "\
Window split type, when launching program in other window." :type '(choice (const :tag "Horizontal" xwem-execute-program-other-win-horizontal) (const :tag "Vertical" xwem-execute-program-other-win-vertical)) :group 'xwem-launcher)

(defcustom xwem-launcher-frame-type 'xwem-execute-program-other-frame "\
Type of frame, when launching program in other frame." :type '(choice (const :tag "Normal frame" xwem-execute-program-other-frame) (const :tag "Embedded frame" xwem-execute-program-embedded-frame)) :group 'xwem-launcher)

(defcustom xwem-xterm-program "xterm" "\
Name of terminal emulator program." :type 'string :group 'xwem-launcher)

(defcustom xwem-xterm-font-argument "-fn" "\
Program key to specify in order to change font." :type 'string :group 'xwem-launcher)

(defcustom xwem-xterm-font1 "" "\
Default xterm font." :type 'string :group 'xwem-launcher)

(defcustom xwem-xterm-font2 "10x20" "\
Second xterm font." :type 'string :group 'xwem-launcher)

(defcustom xwem-xterm-font3 "9x15" "\
Third xterm font." :type 'string :group 'xwem-launcher)

(defcustom xwem-xterm-font4 "fixed" "\
Forth xterm font." :type 'string :group 'xwem-launcher)

(defcustom xwem-lupe-program "lupe" "\
Xmag like mignifier program." :type 'string :group 'xwem-launcher)

(defcustom xwem-lupe-arguments "-noshape -nohud" "\
Argument to pass to `xwem-lupe-program'." :type 'string :group 'xwem-launcher)

(defcustom xwem-xlock-program "xlock" "\
Program to run in order to lock X display." :type 'string :group 'xwem-launcher)

(defcustom xwem-xlock-arguments "-mode image" "\
Arguments to supply `xwem-xlock-program'." :type 'string :group 'xwem-launcher)

(defcustom xwem-launch-dock-width 24 "\
*Launcher dockapp width." :type 'number :group 'xwem-launcher)

(defcustom xwem-launch-dock-height 24 "\
*Launcher dockapp height." :type 'number :group 'xwem-launcher)

(defcustom xwem-launch-dock-thick 2 "\
*Launcher dockapp border thickness." :type 'number :group 'xwem-launcher)

(defcustom xwem-open-file-commands-alist '(("\\.\\(ps\\|ps_pages\\|eps\\)\\'" . "gv") ("\\.pdf\\'" . "xpdf") ("\\.\\(jpe?g\\|gif\\|png\\)\\'" . "display") ("\\.dvi\\'" . "xdvi") ("\\.chm\\'" . "xchm") ("\\.djvu\\'" . "djview") ("\\.txt\\'" . "xterm -e less")) "\
*Alist specifying how to view special types of files.
`xwem-open-file-commands-alist' can be dynamically changed by
`xwemw-open-file' when registering new file extensions, so we
recommend to use `xwem-desktop' package to save/restore
`xwem-open-file-commands-alist' value between sessions." :group 'xwem-launcher :type '(repeat (cons (string :tag "Regexp") (string :tag "Command"))))

(defcustom xwem-open-file-registration 'query "\
*Defines the behaviour of `xwem-open-file' when file extension is
not defined in `xwem-open-file-commands-alist'.

 nil - Do nothing.
 t - Register new extensions in `xwem-open-file-commands-alist'.
 query - Query about registration." :group 'xwem-launcher :type '(choice (const :tag "No registration" nil) (const :tag "Auto registration" t) (const :tag "Query for registration" query)))

;;;***

;;;### (autoloads (xwem-win-horizontal-delim-width xwem-win-vertical-delim-width xwem-misc-turbo-mode xwem-minibuffer-outer-border-width xwem-minibuffer-border-width xwem-commands-inhibit-gc xwem-commands-gc-cons-threshold xwem-client-focusing) "xwem-loaddefs" "lisp/xwem-loaddefs.el")
(defconst custom-define-current-source-file "xwem-loaddefs.el")

(defcustom xwem-client-focusing 'advanced "\
Clients focusing type.
One of:

  'advanced -  Any client can be selected, even if it has broken focus model.
  'standard -  Strictly follow ICCCM, hoping everything will be ok.

You should change default value only in very rare circumstances.  You
should fully understand how focusing works in xwem to change default
value." :type '(choice (const :tag "Advanced" advanced) (const :tag "Standard" standard)) :group 'xwem-cl)

(defcustom xwem-commands-gc-cons-threshold 5000000 "\
*Value of `gc-cons-threshold' to use when executing xwem commands.
Make sense only if `xwem-commands-inhibit-gc' is non-nil." :type 'number :group 'xwem)

(defcustom xwem-commands-inhibit-gc t "\
*Non-nil mean that xwem interactive commands runs without GCing." :type 'boolean :group 'xwem)

(defcustom xwem-minibuffer-border-width 2 "\
Border width for `xwem-minibuffer'." :type 'number :set (lambda (sym val) (set sym val) (let ((cl (and xwem-minibuffer (xwem-minib-cl xwem-minibuffer)))) (when (xwem-cl-p cl) (xwem-client-set-property cl 'x-border-width xwem-minibuffer-border-width)))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-outer-border-width 1 "\
*Outer border width for xwem minibuffer." :type 'number :group 'xwem-minibuffer)

(defcustom xwem-misc-turbo-mode nil "\
*Non-nil mean xwem will work as fast as it can.
In this case, some color related customizations may not apply on fly.
So on-fly theming will not work, etc.
However seting its value to non-nil is most convinient for most users." :type 'boolean :group 'xwem-misc)

(defcustom xwem-win-vertical-delim-width '(8 . 1) "\
*Width in pixels for vertical delimiters.
car is delimiter width, cdr is shadow thickness." :type '(cons number number) :group 'xwem-win)

(defcustom xwem-win-horizontal-delim-width '(6 . 1) "\
*Width in pixels for horizontal delimiters.
car is delimiter width, cdr is shadow thickness." :type '(cons number number) :group 'xwem-win)

;;;***

;;;### (autoloads (xwem-use-presetup xwem-exit-hook xwem-after-init-hook xwem-before-init-hook xwem-after-init-wins-hook xwem-before-init-wins-hook xwem-config-read-hook xwem-load-hook xwem-custom-display xwem-commands-inhibit-gc xwem-commands-gc-cons-threshold xwem-debug-routines xwem-debug xwem-inhibit-startup-message xwem-dir xwem-hooks xwem) "xwem-main" "lisp/xwem-main.el")
(defconst custom-define-current-source-file "xwem-main.el")

(defgroup xwem nil "XWEM window manager." :prefix "xwem-" :group 'applications)

(defgroup xwem-hooks nil "Group to customize xwem hooks." :prefix "xwem-" :group 'xwem)

(defcustom xwem-dir (file-name-as-directory (expand-file-name ".xwem" (getenv "HOME"))) "\
Directory to store XWEM's files." :type 'directory :group 'xwem)

(defcustom xwem-inhibit-startup-message nil "\
*Non-nil mean, do not show message after successful XWEM start." :type 'boolean :group 'xwem)

(defcustom xwem-debug nil "\
*Non-nil mean run xlib and xwem in debugging mode." :type 'boolean :group 'xwem)

(defcustom xwem-debug-routines '(xwem-cl xwem-event xwem-frame xwem-misc xwem-root xwem-deffered xwem-tray x-misc x-event x-tray x-error x-record) "\
Routines to debug on." :type '(set (const :tag "XWEM CLients" xwem-cl) (const :tag "XWEM Events" xwem-event) (const :tag "XWEM Frames" xwem-frame) (const :tag "XWEM Misc" xwem-misc) (const :tag "XWEM Root" xwem-root) (const :tag "XWEM Deffered calls" xwem-deffered) (const :tag "XWEM Tray" xwem-tray) (const :tag "X Misc" x-misc) (const :tag "X Event" x-event) (const :tag "X Tray" x-tray) (const :tag "X Error" x-error) (const :tag "X RECORD" x-record)) :group 'xwem)

(defcustom xwem-commands-gc-cons-threshold 5000000 "\
*Value of `gc-cons-threshold' to use when executing xwem commands.
Make sense only if `xwem-commands-inhibit-gc' is non-nil." :type 'number :group 'xwem)

(defcustom xwem-commands-inhibit-gc t "\
*Non-nil mean that xwem interactive commands runs without GCing." :type 'boolean :group 'xwem)

(defcustom xwem-custom-display nil "\
*Custom display, mostly for debugging purposes." :type '(choice (const :tag "No custom display" nil) (const "127.0.0.1:2") (string :tag "Custom display")) :group 'xwem)

(defcustom xwem-load-hook nil "\
*Hooks to call after xwem was load." :type 'hook :group 'xwem-hooks)

(defcustom xwem-config-read-hook nil "\
*Hooks to call after xwem read config file." :type 'hook :group 'xwem-hooks)

(defcustom xwem-before-init-wins-hook nil "\
Hooks called before `xwem-init-wins'." :type 'hook :group 'xwem-hooks)

(defcustom xwem-after-init-wins-hook nil "\
Hooks called after `xwem-init-wins'." :type 'hook :group 'xwem-hooks)

(defcustom xwem-before-init-hook nil "\
Hooks to be run before xwem initialization." :type 'hook :group 'xwem-hooks)

(defcustom xwem-after-init-hook nil "\
Hooks to be runned after xwem initialisation." :type 'hook :group 'xwem-hooks)

(defcustom xwem-exit-hook nil "\
Hooks called after xwem exit." :type 'hook :group 'xwem-hooks)

(defcustom xwem-use-presetup t "\
*When non-nil, us things that normally should be in xwemrc." :type 'boolean :group 'xwem)

;;;***

;;;### (autoloads (xwem-applications-alist xwem-manage-list xwem-manage-default-properties xwem-manage-default-expectance-expire-timeout) "xwem-manage" "lisp/xwem-manage.el")
(defconst custom-define-current-source-file "xwem-manage.el")

(defcustom xwem-manage-default-expectance-expire-timeout 5 "\
*Default expire timeout for expectance entries." :type 'number :group 'xwem)

(defcustom xwem-manage-default-properties '(reguard-x-border-width t) "\
*Default managing properties.
These properties are always set in any managing model.
Supported properties are:

  `reguard-x-border-width' - Reguard border width.
  `win-support'  - Managing model uses window operations.
." :type 'list :group 'xwem)

(defcustom xwem-manage-list nil "\
List where each element in form:

\(MANAGE-TYPE CLIENT-PLIST MATCH-SPEC)

MANAGE-TYPE is symbol.

CLIENT-PLIST is list of client properties to set when client manages
and unset when client changes manage type.  In core supported
properties are:

  `noselect' - Non-nil mean client can't be selected, usefull for
               `rooter' clients.

  `no-minib-overlap' - Non-nil to not overlap xwem minibuffer, usefull
                       for `fullscreen' clients.

  `xwem-icon-name'   - Icon to use for this client.

  `xwem-focus-mode'  - Specifies client's focus mode.

  `xwem-tab-format'  - Format to use in tabber.

  `xwem-tab-face'    - Face to use in tabber.

MATCH-TYPE is a list of match entries, where each entrie TODO:
describe me." :type 'list :group 'xwem)

(defcustom xwem-applications-alist '(("xemacs" (and (class-inst "^emacs$") (class-name "Emacs$"))) ("xterm" (and (class-inst "^xterm$") (class-name "^XTerm$"))) ("xdvi" (and (class-inst "^xdvi$") (class-name "^XDvi$"))) ("djview" (and (class-inst "^djview$") (class-name "^Djview$"))) ("rdesktop" (and (class-inst "^rdesktop$") (class-name "^rdesktop$"))) ("vncviewer" (and (class-inst "^vncviewer$") (class-name "^Vncviewer$"))) ("display" (and (class-inst "^display$") (class-name "^[dD]isplay$"))) ("xv" (and (class-inst "^xv$") (class-name "^XV"))) ("xcalc" (and (class-inst "^xcalc$") (class-name "^XCalc$"))) ("xclock" (and (class-inst "^xclock$") (class-name "^[Xx][cC]lock$"))) ("xload" (and (class-inst "^xload$") (class-name "^XLoad$"))) ("xkeycaps" (and (class-inst "^xkeycaps$") (class-name "^XKeyCaps$"))) ("gimp_startup" (and (class-inst "^gimp_startup$") (class-name "^Gimp$"))) ("gv" (and (class-inst "^gv$") (class-name "^GV$"))) ("ghostview" (and (class-inst "^ghostview$") (class-name "^Ghostview$"))) ("xfd" (and (class-inst "^xfd$") (class-name "^Xfd$"))) ("xfontsel" (and (class-inst "^xfontsel$") (class-name "^XFontSel$"))) ("gnumeric" (and (class-inst "^gnumeric$") (class-name "^Gnumeric$"))) ("ethereal" (and (class-inst "^ethereal$") (class-name "^Ethereal$"))) ("gkrellm" (and (class-inst "gkrellm") (class-name "Gkrellm"))) ("gdesklets" (and (class-inst "^gDesklets$") (class-name "^Gdesklets$"))) ("gdeskcal" (and (class-inst "^gdeskcal$") (class-name "^Gdeskcal$"))) ("links" (and (class-inst "^Links$") (class-name "^Links$"))) ("licq" (and (class-inst "^licq$") (class-name "^Licq$"))) ("mozilla" (or (class-name "^[mM]ozilla") (class-inst "^[mM]ozilla"))) ("xmms" (class-name "^[Xx]mms$")) ("xine" (class-name "^xine$")) ("mplayer" (class-name "^MPlayer$")) ("xchat" (class-name "^X-Chat$")) ("gimp" (class-name "^Gimp$")) ("ddd" (class-name "^Ddd$")) ("firefox" (class-name "^Firefox")) ("opera" (class-name "^Opera$")) ("xpdf" (class-name "^Xpdf$")) ("acroread" (class-name "^AcroRead$")) ("gnuplot" (name "^Gnuplot$")) ("xchm" (name "^xCHM"))) "\
Alist of known applications.
CAR is appllication name, CDR is match-spec.

Use `xwem-appcollect' to create `xwem-applications-alist'." :type '(cons string sexp) :group 'xwem)

;;;***

;;;### (autoloads (xwem-minib-specifiers xwem-minib-resize-exact xwem-minibuffer-focusout-hook xwem-minibuffer-focusin-hook xwem-minibuffer-outer-border-color xwem-minibuffer-outer-border-width xwem-minibuffer-set-default-minibuffer-frame xwem-minibuffer-emacs-frames-has-minibuffer xwem-minibuffer-raise-when-active xwem-minibiffer-always-on-top-rank xwem-minibuffer-autohide-timeout xwem-minibuffer-hide-show-parameter xwem-minibuffer-hide-cursor-mode xwem-minibuffer-active-border-color xwem-minibuffer-passive-border-color xwem-minibuffer-border-width xwem-minibuffer-width xwem-minibuffer-height xwem-minibuffer-font xwem-minibuffer-bgcol xwem-minibuffer-name xwem-minibuffer) "xwem-minibuffer" "lisp/xwem-minibuffer.el")
(defconst custom-define-current-source-file "xwem-minibuffer.el")

(defgroup xwem-minibuffer nil "Group to customize XWEM minibuffer." :prefix "xwem-minibuffer-" :group 'xwem-modes)

(defcustom xwem-minibuffer-name "xwem-minibuffer" "\
*Minibuffer name to be used by XWEM." :type 'string :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-bgcol "gray80" "\
*Background color to be used in `xwem-minib-frame'." :type 'color :set (lambda (sym val) (set sym val) (when (and xwem-minibuffer (X-Win-p (xwem-minib-xwin xwem-minibuffer))) (XSetWindowBackground (xwem-dpy) (xwem-minib-xwin xwem-minibuffer) (XAllocColor (xwem-dpy) (XDefaultColormap (xwem-dpy)) (xwem-make-color xwem-minibuffer-bgcol))) (XClearArea (xwem-dpy) (xwem-minib-xwin xwem-minibuffer) 0 0 (X-Geom-width (xwem-minib-xgeom xwem-minibuffer)) (X-Geom-height (xwem-minib-xgeom xwem-minibuffer)) nil))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-font (face-font-name 'default) "\
*Font to be used in `xwem-minib-frame'.  May be nil or string." :type '(restricted-sexp :match-alternatives ('nil try-font-name)) :set (lambda (sym val) (set sym val) (when (and xwem-minibuffer (xwem-minib-frame xwem-minibuffer)) (set-face-font 'default xwem-minibuffer-font (xwem-minib-frame xwem-minibuffer)))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-height 1 "\
Height of `xwem-minibuffer'." :type 'number :set (lambda (sym val) (set sym val) (let ((frame (and xwem-minibuffer (xwem-minib-frame xwem-minibuffer))) (mcl (and xwem-minibuffer (xwem-minib-cl xwem-minibuffer)))) (when (and frame mcl) (setq st (/ (frame-pixel-height frame) (frame-height frame)) nsz (* st xwem-minibuffer-height)) (xwem-client-resize mcl nil nsz)))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-width 80 "\
*Usable width of `xwem-minibuffer' frame." :type 'number :set (lambda (sym val) (set sym val) (let ((frame (and xwem-minibuffer (xwem-minib-frame xwem-minibuffer))) (mcl (and xwem-minibuffer (xwem-minib-cl xwem-minibuffer)))) (when (and frame mcl) (setq st (/ (frame-pixel-width frame) (frame-width frame)) nsz (* st xwem-minibuffer-width)) (xwem-client-resize mcl nsz nil)))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-border-width 2 "\
Border width for `xwem-minibuffer'." :type 'number :set (lambda (sym val) (set sym val) (let ((cl (and xwem-minibuffer (xwem-minib-cl xwem-minibuffer)))) (when (xwem-cl-p cl) (xwem-client-set-property cl 'x-border-width xwem-minibuffer-border-width)))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-passive-border-color "blue3" "\
Border color for `xwem-minibuffer'." :type 'color :set (lambda (sym val) (set sym val) (let ((cl (and xwem-minibuffer (xwem-minib-cl xwem-minibuffer)))) (when (xwem-cl-p cl) (xwem-set-face-foreground 'x-border-face xwem-minibuffer-passive-border-color nil cl) (xwem-client-set-property cl 'x-border-color (xwem-face-foreground 'x-border-face (and (xwem-cl-selected-p cl) '(selected)) cl))))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-active-border-color "blue" "\
Border color for `xwem-minibuffer' when it focused." :type 'color :set (lambda (sym val) (set sym val) (let ((cl (and xwem-minibuffer (xwem-minib-cl xwem-minibuffer)))) (when (xwem-cl-p cl) (xwem-set-face-foreground 'x-border-face xwem-minibuffer-active-border-color '(selected) cl) (xwem-client-set-property cl 'x-border-color (xwem-face-foreground 'x-border-face (and (xwem-cl-selected-p cl) '(selected)) cl))))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-hide-cursor-mode t "\
*Non-nil mean that Emacs cursor will be invisible in `xwem-minibuffer'.
When `xwem-minibuffer' loses focus Emacs cursor hides, and unhides
when it focused." :type 'boolean :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-hide-show-parameter 0 "\
*Animation delay parameter, when hiding/showing xwem minibuffer." :type 'number :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-autohide-timeout nil "\
*Non-nil mean xwem minibuffer will be autohided, after that many seconds." :type '(choice (const :tag "Disabled" nil) (number :tag "Seconds")) :set (lambda (sym value) (set sym value) (let ((mcl (xwem-minib-cl xwem-minibuffer))) (when mcl (if value (xwem-minibuffer-enable-autohide-timer mcl) (xwem-activate mcl) (xwem-minibuffer-disable-autohide-timer mcl))))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibiffer-always-on-top-rank 20 "\
*Always on top rank or nil." :type '(choice (const :tag "No rank" nil) (number :tag "Rank")) :set (lambda (sym value) (set sym value) (let ((xwin (xwem-minib-xwin xwem-minibiffer))) (when xwin (if value (xwem-misc-set-xwin-always-on-top xwin value) (xwem-misc-unset-always-on-top xwin))))) :initialize 'custom-initialize-default :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-raise-when-active t "\
*Non-nil mean xwem minibuffer is raised when activated." :type 'boolean :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-emacs-frames-has-minibuffer t "\
*Non-nil mean Emacs frames will have their own minibuffers." :type 'boolean :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-set-default-minibuffer-frame t "\
*Non-nil mean that xwem minibuffer frame will be set as `default-minibuffer-frame'.
Modify this variable only if you know what you are doing." :type 'boolean :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-outer-border-width 1 "\
*Outer border width for xwem minibuffer." :type 'number :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-outer-border-color "black" "\
*Outer border color for xwem minibuffer." :type 'color :group 'xwem-minibuffer)

(defcustom xwem-minibuffer-focusin-hook nil "\
*Hooks called when xwem minibuffer got focus." :type 'hook :group 'xwem-minibuffer :group 'xwem-hooks)

(defcustom xwem-minibuffer-focusout-hook nil "\
*Hooks called when xwem minibuffer lose focus." :type 'hook :group 'xwem-minibuffer :group 'xwem-hooks)

(defcustom xwem-minib-resize-exact t "\
*If non-`nil', make minibuffer frame exactly the size needed to display all its contents.
Otherwise, the minibuffer frame can temporarily increase in size but
never get smaller while it is active." :type 'boolean :group 'xwem-minibuffer)

(defcustom xwem-minib-specifiers '((default-toolbar-visible-p) (default-gutter-visible-p . t) (top-gutter) (top-gutter-border-width . 1) (menubar-visible-p) (horizontal-scrollbar-visible-p) ((face-font 'default) . xwem-minibuffer-font)) "\
*Alist of specifiers to be set for xwem minibuffer." :type '(repeat (cons (sexp :tag "Specifier sexp") (sexp :tag "Specifier value sexp"))) :set (lambda (sym value) (set sym value) (when (and xwem-minibuffer (frame-live-p (xwem-minib-frame xwem-minibuffer))) (xwem-minib-apply-specifiers (xwem-minib-frame xwem-minibuffer)))) :group 'xwem-minibuffer)

;;;***

;;;### (autoloads (xwem-cursor-help-background-color xwem-cursor-help-foreground-color xwem-cursor-help-shape xwem-cursor-quote-background-color xwem-cursor-quote-foreground-color xwem-cursor-quote-shape xwem-cursor-resize-background-color xwem-cursor-resize-foreground-color xwem-cursor-resize-shape xwem-cursor-move-background-color xwem-cursor-move-foreground-color xwem-cursor-move-shape xwem-cursor-wait-background-color xwem-cursor-wait-foreground-color xwem-cursor-wait-shape xwem-cursor-default-background-color xwem-cursor-default-foreground-color xwem-cursor-default-shape xwem-cursor xwem-misc-functions-to-profile xwem-misc-turbo-mode xwem-messages-label-prefixes xwem-messages-beeps-alist xwem-messages-ignore-labels xwem-messages-buffer-lines xwem-messages-buffer-name xwem-misc) "xwem-misc" "lisp/xwem-misc.el")
(defconst custom-define-current-source-file "xwem-misc.el")

(defgroup xwem-misc nil "Group to customize miscellaneous options." :prefix "xwem-" :group 'xwem)

(defcustom xwem-messages-buffer-name " *xwem-messages*" "\
*Buffer name for xwem messages." :type 'string :group 'xwem-misc)

(defcustom xwem-messages-buffer-lines 1000 "\
*Maximum lines in xwem messages buffer." :type 'number :group 'xwem-misc)

(defcustom xwem-messages-ignore-labels '(prompt progress nolog) "\
*List of message labels to ignore putting them into xwem message log buffer." :type '(repeat (choice (symbol :tag "Custom label") (const :tag "Alarm" alarm) (const :tag "Error" error) (const :tag "Warning" warning) (const :tag "Info" info) (const :tag "Note" note) (const :tag "TODO" todo) (const :tag "Prompt" prompt) (const :tag "Progress" progress) (const :tag "NoLog" nolog))) :group 'xwem-misc)

(defcustom xwem-messages-beeps-alist '((warning . warning) (error . error) (alarm . alarm)) "\
*Alist in form (MSG-LABEL . SOUND).
Where SOUND is element of `xwem-sound-alist'." :type (backquote (repeat (cons (symbol :tag "Message Label") (\, (nconc '(choice) (mapcar (function (lambda (ss) (list 'const :tag (symbol-name (car ss)) (car ss)))) xwem-sound-alist) '((symbol :tag "Sound type"))))))) :group 'xwem-misc)

(defcustom xwem-messages-label-prefixes '((warning "Warning" (red)) (error "Erorr" (red bold)) (alarm "Alarm" (red bold italic)) (note "Note" (yellow)) (info "Info" (default)) (todo "TODO" (bold))) "\
List of prefixes for certain labels.
CAR is label." :type '(list (symbol :tag "Message label") string (repeat face)) :group 'xwem-misc)

(defcustom xwem-misc-turbo-mode nil "\
*Non-nil mean xwem will work as fast as it can.
In this case, some color related customizations may not apply on fly.
So on-fly theming will not work, etc.
However seting its value to non-nil is most convinient for most users." :type 'boolean :group 'xwem-misc)

(defcustom xwem-misc-functions-to-profile nil "\
List of functions to profile using xwem profiler." :type (list 'repeat (cons 'choice (delq nil (mapcar (function (lambda (fun) (and (symbolp fun) (fboundp fun) (> (length (symbol-name fun)) 4) (string= "xwem" (substring (symbol-name fun) 0 4)) (list 'function-item fun)))) obarray)))) :group 'xwem-misc)

(defgroup xwem-cursor nil "Group to customize cursors in XWEM." :prefix "xwem-cursor-" :group 'xwem)

(defcustom xwem-cursor-default-shape 'X-XC-left_ptr "\
*Shape of default xwem cursor." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-cursor-default) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-default-foreground-color "#002800" "\
*Default cursor's foreground color." :type 'color :set (xwem-cus-set-cursor-foreground xwem-cursor-default) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-default-background-color "#000000" "\
*Default cursor's background color." :type 'color :set (xwem-cus-set-cursor-background xwem-cursor-default) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-wait-shape 'X-XC-icon "\
*Shape of cursor, when XWEM wait for something." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-cursor-wait) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-wait-foreground-color "#ea0000" "\
*Cursor's foreground color when XWEM wait for something." :type 'color :set (xwem-cus-set-cursor-foreground xwem-cursor-wait) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-wait-background-color "#280000" "\
*Cursor's background color when XWEM waiit for something." :type 'color :set (xwem-cus-set-cursor-background xwem-cursor-wait) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-move-shape 'X-XC-fleur "\
*Shape of cursor, when moving something." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-cursor-move) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-move-foreground-color "#777777" "\
*Cursor's foreground color when moving something." :type 'color :set (xwem-cus-set-cursor-foreground xwem-cursor-move) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-move-background-color "#280000" "\
*Cursor's background color when moving something." :type 'color :set (xwem-cus-set-cursor-background xwem-cursor-move) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-resize-shape 'X-XC-sizing "\
*Shape of cursor, when resizing something." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-cursor-resize) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-resize-foreground-color "#777777" "\
*Cursor's foreground color when resizing something." :type 'color :set (xwem-cus-set-cursor-foreground xwem-cursor-resize) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-resize-background-color "#280000" "\
*Cursor's background color when resizing something." :type 'color :set (xwem-cus-set-cursor-background xwem-cursor-resize) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-quote-shape 'X-XC-sb_down_arrow "\
*Shape of cursor, when XWEM quoting keyboard or mouse." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-cursor-quote) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-quote-foreground-color "#0000BB" "\
*Cursor's foreground color when XWEM quoting keyboard/mouse." :type 'color :set (xwem-cus-set-cursor-foreground xwem-cursor-quote) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-quote-background-color "#000099" "\
*Cursor's background color when XWEM quoting keyboard/mouse." :type 'color :set (xwem-cus-set-cursor-background xwem-cursor-quote) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-help-shape '(X-XC-question_arrow) "\
*Shape of cursor, when getting help with XWEM." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-cursor-help) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-help-foreground-color "#00BB00" "\
*Cursor's foreground color when quering XWEM for help." :type 'color :set (xwem-cus-set-cursor-foreground xwem-cursor-help) :initialize 'custom-initialize-default :group 'xwem-cursor)

(defcustom xwem-cursor-help-background-color "#009900" "\
*Cursor's background color when quering XWEM for help." :type 'color :set (xwem-cus-set-cursor-background xwem-cursor-help) :initialize 'custom-initialize-default :group 'xwem-cursor)

;;;***

;;;### (autoloads (xwem-mogu-minor-mode-hook xwem-mogu-stack-rank xwem-mogu-mouse-node-color xwem-mogu-node-color xwem-mogu-grid-color xwem-mogu-grid-width xwem-mogu-characters xwem-mogu-numbers xwem-mogu-identificators-visible-p xwem-mogu-numbers-characters-visible-p xwem-mogu-keep-pointer-offset xwem-mogu) "xwem-mogu" "lisp/xwem-mogu.el")
(defconst custom-define-current-source-file "xwem-mogu.el")

(defgroup xwem-mogu nil "Group to customize xwem mouse grid uberness." :prefix "xwem-mogu-" :group 'xwem-modes)

(defcustom xwem-mogu-keep-pointer-offset nil "\
*Non-nil mean mouse offset is kept when mouse-node is moved." :type 'boolean :group 'xwem-mogu)

(defcustom xwem-mogu-numbers-characters-visible-p t "\
*Non-nil mean <number>s and <character>s are visible." :type 'boolean :group 'xwem-mogu)

(defcustom xwem-mogu-identificators-visible-p nil "\
*Non-nil identificators are shown for each node." :type 'boolean :group 'xwem-mogu)

(defcustom xwem-mogu-numbers 8 "\
Maximum number of <number>s." :type 'number :group 'xwem-mogu)

(defcustom xwem-mogu-characters 6 "\
Maximum number of <character>s." :type 'number :group 'xwem-mogu)

(defcustom xwem-mogu-grid-width 1 "\
*Width of grid lines." :type 'number :group 'xwem-mogu)

(defcustom xwem-mogu-grid-color "gray78" "\
Color for grid." :type 'color :group 'xwem-mogu)

(defcustom xwem-mogu-node-color "gray50" "\
Color for nodes." :type 'color :group 'xwem-mogu)

(defcustom xwem-mogu-mouse-node-color "red4" "\
Color for mouse-node." :type 'color :group 'xwem-mogu)

(defcustom xwem-mogu-stack-rank '(((eval t) 30 . 30)) "\
Stack ranks specification for xwem mogu." :type '(cons (sexp :tag "Client MATCH-SPEC") (cons (number :tag "Active") (number :tag "Inactive"))) :group 'xwem-mogu)

(defcustom xwem-mogu-minor-mode-hook nil "\
Hooks to run when mogu mode is enabled or disabled.
When running hooks value of `xwem-mogu-minor-mode' is non-nil when
mogu minor mode is enabling.
When running hooks value of `xwem-mogu-minor-mode' is nil when mogu
minor mode is disabling." :type 'hook :group 'xwem-hooks :group 'xwem-mogu)

;;;***

;;;### (autoloads (xwem-popup-menu-function) "xwem-mouse" "lisp/xwem-mouse.el")
(defconst custom-define-current-source-file "xwem-mouse.el")

(defcustom xwem-popup-menu-function 'popup-menu "\
*Function used to popup menus.
It is created for case when you change default `popup-menu' function,
for example if you are using tpum.el." :type 'function :group 'xwem)

;;;***

;;;### (autoloads (xwem-fullscreen-ai-rank xwem-fullscreen-iconify-when-inactive xwem-fullscreen-switch-any-other xwem-fullscreen) "xwem-netwm" "lisp/xwem-netwm.el")
(defconst custom-define-current-source-file "xwem-netwm.el")

(defgroup xwem-fullscreen nil "Group to customize fullscreen managing model." :prefix "xwem-fullscreen-" :group 'xwem-modes)

(defcustom xwem-fullscreen-switch-any-other nil "\
*Non-nil mean switch to any other client, if no other fullscreen client available." :type 'boolean :group 'xwem-fullscreen)

(defcustom xwem-fullscreen-iconify-when-inactive t "\
*Non-nil mean iconify fullscreen clients, when they gets inactive/deselected." :type 'boolean :group 'xwem-fullscreen)

(defcustom xwem-fullscreen-ai-rank '(1000 . 0) "\
*Always on top rank pair for active and inactive states." :type '(cons :tag "Rank pair" (number :tag "Active rank") (number :tag "Inactive rank")) :group 'xwem-fullscreen)

;;;***

;;;### (autoloads (xwem-osd-default-stack-rank xwem-osd-default-color xwem-osd-default-font xwem-osd) "xwem-osd" "lisp/xwem-osd.el")
(defconst custom-define-current-source-file "xwem-osd.el")

(defgroup xwem-osd nil "Group to customize OSD." :prefix "xwem-osd-" :group 'xwem-misc)

(defcustom xwem-osd-default-font "fixed" "\
Default font for text drawed in osd." :type 'string :group 'xwem-osd)

(defcustom xwem-osd-default-color "black" "\
Default color used to draw." :type 'color :group 'xwem-osd)

(defcustom xwem-osd-default-stack-rank 100 "\
Default rank." :type 'number :group 'xwem-osd)

;;;***

;;;### (autoloads (xwem-pager-grid-p xwem-pager-viewport-size xwem-pager-prefer-horizontal xwem-pager-dim xwem-pager) "xwem-pager" "lisp/xwem-pager.el")
(defconst custom-define-current-source-file "xwem-pager.el")

(defgroup xwem-pager nil "Group to customize xwem pager." :prefix "xwem-pager-" :group 'xwem-tray)

(defcustom xwem-pager-dim (cons '(2 . 3) '(4 . 4)) "\
Minimum and maximum viewports to show at X and Y." :type '(cons (cons :tag "Minimum" (number :tag "X") (number :tag "Y")) (cons :tag "Maximum" (number :tag "X") (number :tag "Y"))) :set (lambda (sym val) (set sym val) (when (xwem-pager-xwin) (xwem-pager-redimentionize))) :initialize 'custom-initialize-default :group 'xwem-pager)

(defcustom xwem-pager-prefer-horizontal t "\
*Non-nil mean pager will prefer horizontal increment when redimentinizing." :type 'boolean :set (lambda (sym val) (set sym val) (when (xwem-pager-xwin) (xwem-pager-redimentionize))) :initialize 'custom-initialize-default :group 'xwem-pager)

(defcustom xwem-pager-viewport-size '(12 . 6) "\
(X . Y) where X*Y pixel will represent one viewport." :type '(cons (number :tag "X") (number :tag "Y")) :set (lambda (sym val) (set sym val) (when (xwem-pager-xwin) (xwem-pager-redimentionize))) :initialize 'custom-initialize-default :group 'xwem-pager)

(defcustom xwem-pager-grid-p t "\
*Set to non-nil if you want visible grid." :type 'boolean :set (lambda (sym val) (set sym val) (when (xwem-pager-xwin) (xwem-pager-redraw (xwem-pager-xwin) t))) :initialize 'custom-initialize-default :group 'xwem-pager)

;;;***

;;;### (autoloads (xwem-recover-parameter xwem-recover) "xwem-recover" "lisp/xwem-recover.el")
(defconst custom-define-current-source-file "xwem-recover.el")

(defgroup xwem-recover nil "Group to customize xwem recovering tool." :prefix "xwem-recover-" :group 'xwem)

(defcustom xwem-recover-parameter '(12 . 3) "\
*How many errors allowed without recovering.
car specifies number of errors, cdr specifies time in seconds." :type '(cons number number) :group 'xwem-recover)

;;;***

;;;### (autoloads (xwem-registers-auto-override xwem-registers-auto-registers xwem-registers-win-config-select-frame xwem-registers-frame-config-no-delete xwem-registers) "xwem-register" "lisp/xwem-register.el")
(defconst custom-define-current-source-file "xwem-register.el")

(defgroup xwem-registers nil "Group to customize xwem registers behaviour." :prefix "xwem-registers-" :group 'xwem-misc)

(defcustom xwem-registers-frame-config-no-delete t "\
This valued passed as NO-DELETE argument to `xwem-set-frame-configuration'." :type 'boolean :group 'xwem-registers)

(defcustom xwem-registers-win-config-select-frame t "\
*Non-nil mean, when jumping to window configuration also select
frame for which config was generated.  Directly passed as
SELECT-FRAME-P to `xwem-set-window-configuration'." :type 'boolean :group 'xwem-registers)

(defcustom xwem-registers-auto-registers '((?x (application "xemacs"))) "\
*List of automatic registers.

Sample configuration:

  (setq xwem-registers-auto-registers
    '((?x (application \"xemacs\"))
      (?m (application \"mozilla\"))))
" :type '(repeat (cons (character :tag "Register") (sexp :tag "Match expression"))) :group 'xwem-registers)

(defcustom xwem-registers-auto-override nil "\
*Non-nil mean when autoregister matches and such register already
exists it would override it with new value." :type 'boolean :group 'xwem-registers)

;;;***

;;;### (autoloads (xwem-report-bug-send-init) "xwem-report" "lisp/xwem-report.el")
(defconst custom-define-current-source-file "xwem-report.el")

(defcustom xwem-report-bug-send-init nil "\
*If non-nil, include the user's init.el file in the bug report." :group 'xwem-misc :type 'boolean)

;;;***

;;;### (autoloads (xwem-root-another-wm-mode xwem-root-cursor-background-color xwem-root-cursor-foreground-color xwem-root-cursor-shape xwem-root) "xwem-root" "lisp/xwem-root.el")
(defconst custom-define-current-source-file "xwem-root.el")

(defgroup xwem-root nil "Group to customize root screen." :prefix "xwem-root-" :group 'xwem)

(defcustom xwem-root-cursor-shape '(X-XC-left_ptr) "\
*Cursors shape which will be used when pointer is over root window." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-root-cursor (xwem-rootwin)) :initialize 'custom-initialize-default :group 'xwem-root)

(defcustom xwem-root-cursor-foreground-color "white" "\
*Cursor's foreground color used when pointer is over root window." :type 'color :set (xwem-cus-set-cursor-foreground xwem-root-cursor) :initialize 'custom-initialize-default :group 'xwem-root)

(defcustom xwem-root-cursor-background-color "black" "\
*Cursor's background color used when pointer is over root window." :type 'color :set (xwem-cus-set-cursor-background xwem-root-cursor) :initialize 'custom-initialize-default :group 'xwem-root)

(defcustom xwem-root-another-wm-mode nil "\
*Non-nil mean try to start even if another WM is running.
EXPERIMENTAL, NOT TESTED, DOES NOT WORK, set to non-nil on your own risk." :type 'boolean :group 'xwem-root)

;;;***

;;;### (autoloads (xwem-rooter-always-on-top-spec xwem-rooter) "xwem-rooter" "lisp/xwem-rooter.el")
(defconst custom-define-current-source-file "xwem-rooter.el")

(defgroup xwem-rooter nil "Group to customize rooter apps." :prefix "xwem-rooter-" :group 'xwem-modes)

(defcustom xwem-rooter-always-on-top-spec '((((eval t)) . 30)) "\
*List of conscells in form:
\(MATCH-SPEC . RANK) for always-on-top icons.
If MATCH-SPEC matches rooticon's client - than RANK is set as always
on top rank." :type 'sexp :group 'xwem-rooter)

;;;***

;;;### (autoloads (xwem-rooticon-always-on-top-spec xwem-rooticon-default-show-label xwem-rooticon-default-icon xwem-rooticon-show-label xwem-rooticon-placing xwem-rooticon) "xwem-rooticon" "lisp/xwem-rooticon.el")
(defconst custom-define-current-source-file "xwem-rooticon.el")

(defgroup xwem-rooticon nil "Group to customize rooticon behaviour." :prefix "xwem-rooticon-" :group 'xwem)

(defcustom xwem-rooticon-placing 'behind-minibuffer "\
*Placing behaviour." :type '(choice (const :tag "Behind minibuffer" behind-minibuffer) (const :tag "Random" random)) :group 'xwem-rooticon)

(defcustom xwem-rooticon-show-label nil "\
*Non-nil mean show Icon name in rooticon." :type 'boolean :group 'xwem-rooticon)

(defcustom xwem-rooticon-default-icon "root-icon.xpm" "\
*Default rooticon to use.
This icon is used which client does not have its own icon." :type 'file :group 'xwem-rooticon)

(defcustom xwem-rooticon-default-show-label t "\
*Non-nil mean show label, when `xwem-rooticon-default-icon' is used." :type 'boolean :group 'xwem-rooticon)

(defcustom xwem-rooticon-always-on-top-spec '((((eval t)) . 15)) "\
*List of cons cells in format:
\(MATCH-SPEC . RANK) for always-on-top icons.
If MATCH-SPEC matches rooticon's client - than RANK is set as always
on top rank." :type 'sexp :group 'xwem-rooticon)

;;;***

;;;### (autoloads (xwem-selections-no-remove xwem-selections-maximum xwem-selections) "xwem-selections" "lisp/xwem-selections.el")
(defconst custom-define-current-source-file "xwem-selections.el")

(defgroup xwem-selections nil "Group to customize `xwem-selections'." :prefix "xwem-selections-" :group 'xwem)

(defcustom xwem-selections-maximum 20 "\
Maximum number of saved selections." :type 'number :group 'xwem-selections)

(defcustom xwem-selections-no-remove t "\
*Non-nil mean, reverse meaning of prefix arg for `xwem-paste-cutbuffer' command.
Without prefix arg, keep currently pasted cutbuffer.
With prefix arg, remove it." :type 'boolean :group 'xwem-selections)

;;;***

;;;### (autoloads (xwem-sm-mode-line xwem-smart-mods-alist) "xwem-smartmods" "lisp/xwem-smartmods.el")
(defconst custom-define-current-source-file "xwem-smartmods.el")

(defcustom xwem-smart-mods-alist (list (cons XK-Control-L XK-Space)) "\
*Alist of smart modifiers list in form (MOD-SYM . KEY-SYM)." :type '(repeat (cons number number)) :group 'xwem-keyboard)

(defcustom xwem-sm-mode-line "SmartMods" "\
*String to show when smart modifiers mode is on." :type 'string :group 'xwem-modes)

;;;***

;;;### (autoloads (xwem-visible-bell xwem-sound-list xwem-sound-extension-list xwem-sound-directory-list xwem-sound-directory xwem-sound-beeping-alist xwem-sound-default-alist xwem-sound) "xwem-sound" "lisp/xwem-sound.el")
(defconst custom-define-current-source-file "xwem-sound.el")

(defgroup xwem-sound nil "Group to customize XWEM sounds." :prefix "xwem-sound-" :prefix "xwem-" :group 'xwem)

(defcustom xwem-sound-default-alist '((default :sound bass) (undefined-key :sound drum) (command-fail :sound bass) (quit :sound quiet :volume 75) (ready :sound cuckoo) (alarm :sound cuckoo :volume 100) (warning :sound clink :volume 70) (error :sound bong :volume 100)) "\
The alist of sounds and associated error symbols.
Used to set `xwem-sound-alist' in `xwem-sound-load-default'." :group 'xwem-sound :type '(repeat (group (symbol :tag "Name") (checklist :inline t :greedy t (group :inline t (const :format "" :value :sound) (symbol :tag "Sound")) (group :inline t (const :format "" :value :volume) (integer :tag "Volume")) (group :inline t (const :format "" :value :pitch) (integer :tag "Pitch")) (group :inline t (const :format "" :value :duration) (integer :tag "Duration"))))))

(defcustom xwem-sound-beeping-alist '((default :sound t :pitch 70 :duration 15 :volume 100) (undefined-key :sound t :pitch 100 :duration 10 :volume 100) (command-fail :sound t :pitch 1000 :duration 40 :volume 100) (quit :sound t :pitch 70 :duration 5 :volume 100) (ready :sound t :pitch 800 :duration 50 :volume 100) (alarm :sound t :pitch 2000 :duration 150 :volume 100) (warning :sound t :pitch 50 :duration 10 :volume 100) (error :sound t :pitch 3000 :duration 50 :volume 100)) "\
X Bell oriented candidate for `xwem-sound-alist'.
Format is identical as for `xwem-sound-default-alist'." :group 'xwem-sound :type '(repeat (group (symbol :tag "Name") (checklist :inline t :greedy t (group :inline t (const :format "" :value :sound) (symbol :tag "Sound")) (group :inline t (const :format "" :value :volume) (integer :tag "Volume")) (group :inline t (const :format "" :value :pitch) (integer :tag "Pitch")) (group :inline t (const :format "" :value :duration) (integer :tag "Duration"))))))

(defcustom xwem-sound-directory (locate-data-directory "sounds") "\
Default directory to load sound files." :type 'directory :group 'sound)

(defcustom xwem-sound-directory-list (locate-data-directory-list "sounds") "\
List of directories, which to search for sound files." :type '(repeat directory) :group 'xwem-sound)

(defcustom xwem-sound-extension-list ".au:" "\
Filename extensions to complete sound file name with. If more than one
   extension is used, they should be separated by \":\". " :type 'string :group 'xwem-sound)

(defcustom xwem-sound-list '((xwem-sound-file-load "bass-snap" 'bass 100) (xwem-sound-file-load "drum-beep" 'drum 100) (xwem-sound-file-load "quiet-beep" 'quiet 100) (xwem-sound-file-load "cuckoo" 'cuckoo 100) (xwem-sound-file-load "clink" 'clink 100) (xwem-sound-file-load "bong" 'bong 100) (xwem-sound-file-load "say-beep" 'say-beep 100)) "\
A list of calls to `xwem-sound-file-load' to be processed by `xwem-sound-load-default'.
Reference `xwem-sound-file-load' for detailed information." :type '(repeat (sexp :tag "Sound")) :group 'xwem-sound)

(defcustom xwem-visible-bell nil "\
*If non-nil mean try to flash selected frame to represent a bell." :type 'boolean :group 'xwem-sound)

;;;***

;;;### (autoloads (xwem-special-fill-border-width xwem-special-default-strategy xwem-special-display-buffer-strategy xwem-special-display-buffer-names xwem-special-toolbar-visible-p xwem-special-menubar-visible-p xwem-special-hide-method xwem-special-auto-hide xwem-special-border-color xwem-special-border-width xwem-special-model-function xwem-special-frame-name xwem-special) "xwem-special" "lisp/xwem-special.el")
(defconst custom-define-current-source-file "xwem-special.el")

(defgroup xwem-special nil "Group to customize special emacs frames handling." :prefix "xwem-special-" :group 'xwem-modes)

(defcustom xwem-special-frame-name "xwem-special-frame" "\
*Name for special emacs frames" :type 'string :group 'xwem-special)

(defcustom xwem-special-model-function 'xwem-special-at-center "\
*Special frame handiling model function." :type '(choice (const :tag "At Center" xwem-special-at-center) (const :tag "At Pointer" xwem-special-at-pointer) (function :tag "User function")) :group 'xwem-special)

(defcustom xwem-special-border-width 2 "\
Border width of special Emacs frames." :type 'number :group 'xwem-special)

(defcustom xwem-special-border-color "red4" "\
Border color of special Emacs frames." :type 'color :group 'xwem-special)

(defcustom xwem-special-auto-hide nil "\
*Non-nill mean that special frames will autohide when loses focus or visibility." :type 'boolean :group 'xwem-special)

(defcustom xwem-special-hide-method 'XDestroyWindow "\
*Method used to hide special frames.
One of 'XDestroyWindow or 'XUnmapWindow.
If 'XUnmapWindow than special frames will not be removed from clients
list, so it will be possible to access them after hidding." :type 'boolean :group 'xwem-special)

(defcustom xwem-special-menubar-visible-p nil "\
Non-nil for menubar in special Emacs frames." :type 'boolean :group 'xwem-special)

(defcustom xwem-special-toolbar-visible-p nil "\
Non-nil for toolbar in special Emacs frames." :type 'boolean :group 'xwem-special)

(defcustom xwem-special-display-buffer-names nil "\
*List of buffer names to display using special frame." :type '(repeat string) :group 'xwem-special)

(defcustom xwem-special-display-buffer-strategy 'half "\
*Strategy to use when display one of `xwem-special-display-buffer-names' buffer in special frame." :type '(choice (const :tag "Half screen" half) (const :tag "Center" centre)) :group 'xwem-special)

(defcustom xwem-special-default-strategy 'half "\
*Default strategy to use when displaying special Emacs frame." :type '(choice (const :tag "Half screen" half) (const :tag "Fill current client" fill) (const :tag "Center" centre)) :group 'xwem-special)

(defcustom xwem-special-fill-border-width 10 "\
*Pixels border when using `fill' strategy." :type 'number :group 'xwem-special)

;;;***

;;;### (autoloads (xwem-strokes-gc-function xwem-strokes-cursor-background-color xwem-strokes-cursor-foreground-color xwem-strokes-cursor-type xwem-strokes-click-command xwem-strokes-file xwem-strokes-minimum-match-score xwem-strokes-grid xwem-strokes) "xwem-strokes" "lisp/xwem-strokes.el")
(defconst custom-define-current-source-file "xwem-strokes.el")

(defgroup xwem-strokes nil "Group to customize XWEM strokes." :prefix "xwem-strokes-" :group 'xwem)

(defcustom xwem-strokes-grid 25 "\
*XWEM strokes Grid resolution.
Look at `strokes-grid-resolution' for details." :type 'integer :group 'xwem-strokes)

(defcustom xwem-strokes-minimum-match-score 2000 "\
*Take a look at `strokes-minimum-match-score'." :type 'integer :group 'xwem-strokes)

(defcustom xwem-strokes-file "xwem-strokes.el" "\
*File contained strokes for xwem stroke mode." :type 'file :group 'xwem-strokes)

(defcustom xwem-strokes-click-command 'xwem-strokes-default-click-command "\
*Command to execute when stroke is actually a `click'." :type 'function :group 'xwem-strokes)

(defcustom xwem-strokes-cursor-type '(X-XC-dot) "\
*Type of cursor to use when XWEM enters strokes mode." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-strokes-cursor) :initialize 'custom-initialize-default :group 'xwem-strokes)

(defcustom xwem-strokes-cursor-foreground-color "#00ea00" "\
*Cursor's foreground color when XWEM in strokes mode." :type 'color :set (xwem-cus-set-cursor-foreground xwem-strokes-cursor) :initialize 'custom-initialize-default :group 'xwem-strokes)

(defcustom xwem-strokes-cursor-background-color "#002800" "\
*Cursor's background color when XWEM in strokes mode." :type 'color :set (xwem-cus-set-cursor-background xwem-strokes-cursor) :initialize 'custom-initialize-default :group 'xwem-strokes)

(defcustom xwem-strokes-gc-function 'X-GXCopy "\
Function applied to draw strokes." :type (xwem-gc-function-choice) :group 'xwem-strokes)

;;;***

;;;### (autoloads (xwem-tabber-font:frame\.nonselected-tab\.nonselected xwem-tabber-font:frame\.nonselected-tab\.selected xwem-tabber-font:frame\.selected-tab\.nonselected xwem-tabber-font:frame\.selected-tab\.selected xwem-tab-show-cl-info-on-click xwem-tab-delim-interval xwem-tab-empty-format xwem-tab-default-format xwem-tab) "xwem-tabbing" "lisp/xwem-tabbing.el")
(defconst custom-define-current-source-file "xwem-tabbing.el")

(defgroup xwem-tab nil "Group to customize tabs." :prefix "xwem-tab-" :prefix "xwem-face-" :group 'xwem)

(defcustom xwem-tab-default-format " %i %*%# %n" "\
*Default format for tab item." :type 'string :group 'xwem-tab)

(defcustom xwem-tab-empty-format "<empty>" "\
What to show when there no client." :type 'string :group 'xwem-tab)

(defcustom xwem-tab-delim-interval 2 "\
*Number of clients to group, will draw largeer delimeter." :type 'number :group 'xwem-tab)

(defcustom xwem-tab-show-cl-info-on-click t "\
*Non-nil mean show client info when `xwem-tabber-switch-cl' called." :type 'boolean :group 'xwem-tab)

(defcustom xwem-tabber-font:frame\.selected-tab\.selected nil "\
Font to be used in selected tab of selected frame." :type '(restricted-sexp :match-alternatives (nil try-font-name)) :set (lambda (sym val) (set sym val) (xwem-set-face-font 'xwem-tabber-face (or val (xwem-face-font 'xwem-tabber-face '(default))) '(frame-selected tab-selected))) :initialize 'custom-initialize-default :group 'xwem-tab)

(defcustom xwem-tabber-font:frame\.selected-tab\.nonselected nil "\
Font to be used in selected tab of selected frame." :type '(restricted-sexp :match-alternatives (nil try-font-name)) :set (lambda (sym val) (set sym val) (xwem-set-face-font 'xwem-tabber-face (or val (xwem-face-font 'xwem-tabber-face '(default))) '(frame-selected tab-nonselected))) :initialize 'custom-initialize-default :group 'xwem-tab)

(defcustom xwem-tabber-font:frame\.nonselected-tab\.selected nil "\
Font to be used in selected tab of selected frame." :type '(restricted-sexp :match-alternatives (nil try-font-name)) :set (lambda (sym val) (set sym val) (xwem-set-face-font 'xwem-tabber-face (or val (xwem-face-font 'xwem-tabber-face '(default))) '(frame-nonselected tab-selected))) :initialize 'custom-initialize-default :group 'xwem-tab)

(defcustom xwem-tabber-font:frame\.nonselected-tab\.nonselected nil "\
Font to be used in selected tab of selected frame." :type '(restricted-sexp :match-alternatives (nil try-font-name)) :set (lambda (sym val) (set sym val) (xwem-set-face-font 'xwem-tabber-face (or val (xwem-face-font 'xwem-tabber-face '(default))) '(frame-nonselected tab-nonselected))) :initialize 'custom-initialize-default :group 'xwem-tab)

;;;***

;;;### (autoloads (xwem-theme-extrim xwem-theme-default xwem-theme) "xwem-theme" "lisp/xwem-theme.el")
(defconst custom-define-current-source-file "xwem-theme.el")

(defgroup xwem-theme nil "Group to customize xwem themes." :prefix "xwem-theme-" :group 'xwem)

(defcustom xwem-theme-default (backquote ((face xwem-tabber-face (((frame-selected tab-selected) (:foreground "white" :background "green4" :bold t)) ((delimiter-left frame-selected tab-selected) (:foreground "white")) ((delimiter-right frame-selected tab-selected) (:foreground "black")) ((frame-selected tab-nonselected) (:foreground "black" :background "gray80")) ((delimiter-left frame-selected tab-nonselected) (:foreground "white")) ((delimiter-right frame-selected tab-nonselected) (:foreground "black")) ((frame-nonselected tab-selected) (:foreground "gray80" :background "DarkGreen" :bold t)) ((delimiter-left frame-nonselected tab-selected) (:foreground "white")) ((delimiter-right frame-nonselected tab-selected) (:foreground "black")) ((frame-nonselected tab-nonselected) (:foreground "black" :background "gray40")) ((delimiter-left frame-nonselected tab-nonselected) (:foreground "white")) ((delimiter-right frame-nonselected tab-nonselected) (:foreground "black")) (t (:foreground "white")))) (face x-border-face (((selected) (:foreground "green")) (t (:foreground "gray80")))) (face xwem-frame-inner-border-face (((light nonselected) (:foreground "gray80" :background "gray80")) ((medium nonselected) (:foreground "gray50" :background "gray50")) ((dark nonselected) (:foreground "gray20" :background "gray20")) ((light selected) (:foreground "cyan2" :background "cyan2")) ((medium selected) (:foreground "royalblue" :background "royalblue")) ((dark selected) (:foreground "blue4" :background "blue4")))) (face xwem-launch-dock-face (((medium) (:foreground "gray70")) ((light) (:foreground "white")) ((dark) (:foreground "black")))) (face xwem-strokes-face (((background light) (:foreground "red4" :background "black")) ((background dark) (:foreground "red" :background "black")) ((background begin light) (:foreground "magenta4" :background "black" :line-width 12 :cap-style X-CapRound)) ((background begin dark) (:foreground "magenta" :background "black" :line-width 12 :cap-style X-CapRound)))) (face xwem-tray-delimiter-face (((background light) (:foreground "gray40")) ((background light shadow) (:foreground "gray30")) ((background dark) (:foreground "gray70")) ((background dark shadow) (:foreground "gray80")))) (face xwem-window-outline-face (((frame-selected win-selected) (:foreground "green" :background "green4" :line-width 4)) ((frame-selected win-nonselected) (:foreground "gray70" :background "gray70" :line-width 4)) ((frame-nonselected win-selected) (:foreground "green3" :background "green4" :line-width 4)) ((frame-nonselected win-nonselected) (:foreground "gray60" :background "gray40" :line-width 4)))) (face xwem-window-delimiter-face (((horizontal) (:foreground "royalblue" :background "black")) ((horizontal shadow) (:foreground "blue4" :background "black")) ((horizontal light shadow) (:foreground "cyan" :background "black")) ((vertical) (:foreground "royalblue" :background "black")) ((shadow vertical) (:foreground "blue4" :background "black")) ((light shadow vertical) (:foreground "cyan" :background "black")) (t (:foreground "gray20" :background "black")))) (frame-property inner-border-width 8) (frame-property inner-border-thickness 2) (frame-property title-height 18) (client-property x-border-width 2) (custom xwem-cursor-help-foreground-color "#00BB00") (custom xwem-cursor-help-background-color "#009900") (custom xwem-root-cursor-foreground-color "white") (custom xwem-root-cursor-background-color "black") (custom xwem-frame-cursor-foreground-color "#111111") (custom xwem-frame-cursor-background-color "#EEEEEE") (custom xwem-minibuffer-bgcol "gray80"))) "\
Default xwem theme." :type 'xwem-theme :group 'xwem-theme)

(defcustom xwem-theme-extrim (backquote ((face xwem-tabber-face (((frame-selected tab-selected) (:foreground "white" :background "gray20" :font "-*-fixed-medium-r-*-*-12-*-*-*-*-*-*-*" :bold t)) ((delimiter-left frame-selected tab-selected) (:foreground "white")) ((delimiter-right frame-selected tab-selected) (:foreground "black")) ((frame-selected tab-nonselected) (:foreground "black" :background "gray80" :font "-*-fixed-medium-r-*-*-12-*-*-*-*-*-*-*")) ((delimiter-left frame-selected tab-nonselected) (:foreground "white")) ((delimiter-right frame-selected tab-nonselected) (:foreground "black")) ((frame-nonselected tab-selected) (:foreground "gray80" :background "gray40" :font "-*-fixed-medium-r-*-*-12-*-*-*-*-*-*-*" :bold t)) ((delimiter-left frame-nonselected tab-selected) (:foreground "white")) ((delimiter-right frame-nonselected tab-selected) (:foreground "black")) ((frame-nonselected tab-nonselected) (:foreground "black" :background "gray40" :font "-*-fixed-medium-r-*-*-12-*-*-*-*-*-*-*")) ((delimiter-left frame-nonselected tab-nonselected) (:foreground "white")) ((delimiter-right frame-nonselected tab-nonselected) (:foreground "black")) (t (:foreground "white")))) (face x-border-face (((selected) (:foreground "white")) (t (:foreground "dark")))) (face xwem-frame-inner-border-face (((light nonselected) (:foreground "gray80")) ((medium nonselected) (:foreground "gray50")) ((dark nonselected) (:foreground "gray20")) ((light selected) (:foreground "white")) ((medium selected) (:foreground "gray50")) ((dark selected) (:foreground "dark")))) (face xwem-launch-dock-face (((medium) (:foreground "gray70")) ((light) (:foreground "white")) ((dark) (:foreground "black")))) (face xwem-strokes-face (((background light) (:foreground "dimgray" :background "black")) ((background dark) (:foreground "lightgray" :background "black")) ((background begin light) (:foreground "darkslategrey" :background "black" :line-width 12 :cap-style X-CapRound)) ((background begin dark) (:foreground "grey" :background "black" :line-width 12 :cap-style X-CapRound)) (t (:foreground "dimgray" :background "black" :line-width 6 :cap-style X-CapRound :subwindow-mode X-IncludeInferiors :function (eval xwem-strokes-gc-function))))) (face xwem-tray-delimiter-face (((background light) (:foreground "gray40")) ((background light shadow) (:foreground "gray30")) ((background dark) (:foreground "gray70")) ((background dark shadow) (:foreground "gray80")))) (face xwem-window-outline-face (((frame-selected win-selected) (:foreground "dark" :background "dark")) ((frame-selected win-nonselected) (:foreground "gray50" :background "gray50")) ((frame-nonselected win-selected) (:foreground "gray20" :background "gray20")) ((frame-nonselected win-nonselected) (:foreground "gray60" :background "gray40")))) (face xwem-window-delimiter-face (((horizontal) (:foreground "gray30" :background "black")) ((horizontal shadow) (:foreground "gray10" :background "black")) ((horizontal light shadow) (:foreground "gray80" :background "black")) ((vertical) (:foreground "gray10" :background "black")) ((shadow vertical) (:foreground "gray40" :background "black")) ((light shadow vertical) (:foreground "white" :background "black")) (t (:foreground "gray20" :background "black")))) (frame-property inner-border-width 3) (frame-property inner-border-thickness 1) (frame-property title-height 12) (client-property x-border-width 3) (custom xwem-cursor-help-foreground-color "#888888") (custom xwem-cursor-help-background-color "#080808") (custom xwem-root-cursor-foreground-color "black") (custom xwem-root-cursor-background-color "white") (custom xwem-frame-cursor-foreground-color "white") (custom xwem-frame-cursor-background-color "black") (custom xwem-minibuffer-bgcol "black"))) "\
Extrimal xwem theme." :type 'xwem-theme :group 'xwem-theme)

;;;***

;;;### (autoloads (xwem-time-get-mail-function xwem-time-load-interval xwem-time-load-list xwem-time-update-interval xwem-time-time-color xwem-time-format-distance xwem-time-format xwem-time) "xwem-time" "lisp/xwem-time.el")
(defconst custom-define-current-source-file "xwem-time.el")

(defgroup xwem-time nil "Group to customize XWEM time display." :prefix "xwem-time-" :group 'xwem)

(defcustom xwem-time-format '(time load mail) "\
*Format to display time/load/mail.
List of keywords, where each keyword is either:

  time - Display time
  load - Display load average
  mail - Display mail status." :type '(list (choice (const :tag "Time" time) (const :tag "Load average" load) (const :tag "Mail status" mail))) :set (lambda (sym val) (set sym val) (when xwem-time-win (xwem-time-reformat xwem-time-win))) :initialize 'custom-initialize-default :group 'xwem-time)

(defcustom xwem-time-format-distance 3 "\
*Distance in pixels between time/load/mail items." :type 'number :group 'xwem-time)

(defcustom xwem-time-time-color "#CA1E1C" "\
Foreground color to display time." :type 'color :group 'xwem-time)

(defcustom xwem-time-update-interval 1 "\
*Seconds between updates of xwem time window." :type 'integer :group 'xwem-time)

(defcustom xwem-time-load-list (list 0.1 0.2 0.3 0.4 0.5 0.6 0.8 1.0 1.2 1.5 1.8) "\
*A list giving six thresholds for the load
which correspond to the six different icons to be displayed
as a load indicator." :type '(list (number :tag "Threshold 1") (number :tag "Threshold 2") (number :tag "Threshold 3") (number :tag "Threshold 4") (number :tag "Threshold 5") (number :tag "Threshold 6") (number :tag "Threshold 7") (number :tag "Threshold 8") (number :tag "Threshold 9") (number :tag "Threshold 10") (number :tag "Threshold 11")) :group 'xwem-time)

(defcustom xwem-time-load-interval 5 "\
*Seconds between load average updates." :type 'integer :group 'xwem-time)

(defcustom xwem-time-get-mail-function 'xwem-time-default-get-mail "\
Function to call in order to check mail availability." :type 'function :group 'xwem-time)

;;;***

;;;### (autoloads (xwem-transient-switch-back xwem-transient-client-properties xwem-transient) "xwem-transient" "lisp/xwem-transient.el")
(defconst custom-define-current-source-file "xwem-transient.el")

(defgroup xwem-transient nil "Group to customize transient clients support." :prefix "xwem-transient-" :group 'xwem-cl)

(defcustom xwem-transient-client-properties '(x-border-width 2 x-border-color "blue4") "\
*Client properties to use when managing transient clients." :type 'list :group 'xwem-transient)

(defcustom xwem-transient-switch-back t "\
*Non-nil mean when transient client dies, switch to client who created it." :type 'boolean :group 'xwem-transient)

;;;***

;;;### (autoloads (xwem-tray-delimiter-height-reminder xwem-tray-delimiter-width xwem-tray-cursor-background-color xwem-tray-cursor-foreground-color xwem-tray-cursor-shape xwem-tray-groups-distance xwem-tray-minib-dock-offset xwem-tray-minib-start-offset xwem-tray-default-align xwem-tray-use-groups xwem-tray xwem-tray-class xwem-tray-name xwem-tray-id) "xwem-tray" "lisp/xwem-tray.el")
(defconst custom-define-current-source-file "xwem-tray.el")

(defcustom xwem-tray-id 0 "\
System tray identificator.")

(defcustom xwem-tray-name "xwem-tray" "\
X Name for xwem tray.")

(defcustom xwem-tray-class '("xwem-tray" "xwem-tray") "\
X Class for xwem tray")

(defgroup xwem-tray nil "Group to customize XWEM system tray." :prefix "xwem-tray-" :group 'xwem)

(defcustom xwem-tray-use-groups nil "\
*Non-nil mean systray with use EXPERIMENTAL dockapp grouping.
Set it to non-nil on your own risk." :type 'boolean :group 'xwem-tray)

(defcustom xwem-tray-default-align 'right "\
*Position in minibuffer where dockapps will placed." :type '(choice (const :tag "At Right" right) (const :tag "At Left" left)) :group 'xwem-tray)

(defcustom xwem-tray-minib-start-offset 4 "\
*Start offset in pixels." :type 'number :group 'xwem-tray)

(defcustom xwem-tray-minib-dock-offset 5 "\
*Offset in pixels between dockapps." :type 'number :group 'xwem-tray)

(defcustom xwem-tray-groups-distance 5 "\
*Minimum distance between systray groups." :type 'number :group 'xwem-tray)

(defcustom xwem-tray-cursor-shape 'X-XC-right_ptr "\
*Cursor shape which will be used when pointer is over dock app." :type (xwem-cursor-shape-choice) :set (xwem-cus-set-cursor-shape xwem-tray-cursor (and (xwem-tray-p xwem-tray) (xwem-tray-xwin xwem-tray))) :initialize 'custom-initialize-default :group 'xwem-tray)

(defcustom xwem-tray-cursor-foreground-color "#000075" "\
*Cursor's foreground color used when poniter is on dock app." :type 'color :set (xwem-cus-set-cursor-foreground xwem-tray-cursor) :initialize 'custom-initialize-default :group 'xwem-tray)

(defcustom xwem-tray-cursor-background-color "#000039" "\
*Cursor's background color used when poniter is on dock app." :type 'color :set (xwem-cus-set-cursor-background xwem-tray-cursor) :initialize 'custom-initialize-default :group 'xwem-tray)

(defcustom xwem-tray-delimiter-width 4 "\
*Delimiter width." :type 'number :group 'xwem-tray)

(defcustom xwem-tray-delimiter-height-reminder 2 "\
*How many pixels on top/bottom from xwem minibuffer.." :type 'number :group 'xwem-tray)

;;;***

;;;### (autoloads (xwem-vline-config xwem-vline-width) "xwem-vline" "lisp/xwem-vline.el")
(defconst custom-define-current-source-file "xwem-vline.el")

(defcustom xwem-vline-width 1 "\
*Width in pixels of vertical line." :type 'number :group 'xwem-modes)

(defcustom xwem-vline-config (backquote ((((application "xemacs")) :color "red2" :column fill-column :column-width (font-width (face-font 'default))) (((application "xterm")) :color "grey70" :column fill-column :column-width 8) (((eval t)) :color "grey70" :column fill-column :column-width 8))) "\
*Vline configuration for clients." :type 'list :group 'xwem-modes)

;;;***

;;;### (autoloads (xwem-weather-update-frequency xwem-weather-temperature-format xwem-weather-data-file xwem-weather-data-directory xwem-weather-station-id xwem-weather) "xwem-weather" "lisp/xwem-weather.el")
(defconst custom-define-current-source-file "xwem-weather.el")

(defgroup xwem-weather nil "XWEM Weather options." :prefix "xwem-weather-" :group 'xwem)

(defcustom xwem-weather-station-id "ybbn" "\
*The four letter weather station ID.

The default setting is the author's local station, Brisbane,
Australia.  So you can all be jealous of the wonderful weather we
have in Australia. :-P

You should be able to find out what the code is for your nearest
weather station at http://weather.noaa.gov/" :type 'string :link '(url-link "http://weather.noaa.gov/") :group 'xwem-weather)

(defcustom xwem-weather-data-directory xwem-dir "\
*The directory to story weather data files." :type '(directory :must-match t) :group 'xwem-weather)

(defcustom xwem-weather-data-file (expand-file-name xwem-weather-station-id xwem-weather-data-directory) "\
*File to hold the weather data." :type 'file :group 'xwem-weather)

(defcustom xwem-weather-temperature-format 'celsius "\
*Display temperature in Celsius or Fahrenheit." :type '(choice (const :tag "Celsius" celsius) (const :tag "Fahrenheit" fahrenheit)) :group 'xwem-weather)

(defcustom xwem-weather-update-frequency 0 "\
*The number of seconds between updates of the weather info.

Most weather stations only update once/hour so it might not be very
beneficial to set this to lower than an hour.

If this is set to 0 updates will not happen.

If you want to set this outside of the custom interface, you MUST use
`customize-set-variable'." :type '(choice (integer :tag "Do not update" 0) (integer :tag "Every 10 minutes" 600) (integer :tag "Every 15 minutes" 900) (integer :tag "Every 30 minutes" 1800) (integer :tag "Every 60 minutes" 3600) (integer :tag "Every 2 hours" 7200) (integer :tag "Every 4 hours" 14400) (integer :tag "Every 12 hours" 43200) (integer :tag "Every 24 hours" 86400) (integer :tag "Other")) :set '(lambda (sym value) (xwem-weather-alter-update-frequency value)) :initialize 'custom-initialize-default :group 'xwem-weather)

;;;***

;;;### (autoloads (xwem-win-split-hook xwem-win-clients-change-hook xwem-win-delete-hook xwem-win-switch-hook xwem-win-max-clients xwem-win-collect-deleted-clients xwem-win-winmove-allow-jumping xwem-win-default-properties xwem-win-default-border-width xwem-win-horizontal-delim-width xwem-win-vertical-delim-width xwem-win-min-height xwem-win-min-width xwem-win) "xwem-win" "lisp/xwem-win.el")
(defconst custom-define-current-source-file "xwem-win.el")

(defgroup xwem-win nil "Group to customize XWEM windows." :prefix "xwem-win-" :group 'xwem)

(defcustom xwem-win-min-width 80 "\
*Minimal width for window" :type 'number :group 'xwem-win)

(defcustom xwem-win-min-height 80 "\
*Minimal height for window" :type 'number :group 'xwem-win)

(defcustom xwem-win-vertical-delim-width '(8 . 1) "\
*Width in pixels for vertical delimiters.
car is delimiter width, cdr is shadow thickness." :type '(cons number number) :group 'xwem-win)

(defcustom xwem-win-horizontal-delim-width '(6 . 1) "\
*Width in pixels for horizontal delimiters.
car is delimiter width, cdr is shadow thickness." :type '(cons number number) :group 'xwem-win)

(defcustom xwem-win-default-border-width 1 "\
*Default border width for newly created windows." :type 'number :group 'xwem-win)

(defcustom xwem-win-default-properties (list 'attachable nil) "\
*Default properties list for frame windows.

dead       - window that referenced but not workable.
deleted    - deleted window have this equal to t
frame      - frame window attached to.
next       - next window in windows double linked list.
prev       - previous window.
hchild     - child window after horizontal split.
vchild     - child window after vertical split.
parent     - parent window (window in which we do split).
client     - client currently active in window. (index in clients-list)
attachable - if non-nil then frame may be attached to some frame's
             window. (not yet implemented [is it will be usefull?])
expectances - list of expectances for window.
" :type '(restricted-sexp :match-alternatives (valid-plist-p)) :group 'xwem-win)

(defcustom xwem-win-winmove-allow-jumping t "\
*Non-nil allows jumping to opposite edge, when no window founded." :type 'boolean :group 'xwem-win)

(defcustom xwem-win-collect-deleted-clients t "\
*Non-nil mean clients managed in window that are deleting now, will
be placed in `xwem-window-other' window." :type 'boolean :group 'xwem-win)

(defcustom xwem-win-max-clients 32 "\
*Maximum number of clients in window.
NOT USED." :type 'number :group 'xwem-win)

(defcustom xwem-win-switch-hook nil "\
Hooks to be called when window switching occurs.
Function will receive two arguments OLD-WIN and NEW-WIN." :type 'hook :group 'xwem-hooks)

(defcustom xwem-win-delete-hook nil "\
Hooks called with one arg - window when deleting window." :type 'hook :group 'xwem-hooks)

(defcustom xwem-win-clients-change-hook nil "\
Hooks called when win's clients list changed." :type 'hook :group 'xwem-hooks)

(defcustom xwem-win-split-hook nil "\
Hook to be called after window split.
Functions will be called with two arguments: SPLIT-WIN, NEW-WIN." :type 'hook :group 'xwem-hooks)

;;;***

;;;### (autoloads (xwem-worklog-dockapp-sector-width xwem-worklog-dockapp-height xwem-worklog-dockapp-width xwem-worklog-tasks-description xwem-worklog-logout-hook xwem-worklog-login-hook xwem-worklog-task-resume-hook xwem-worklog-task-pause-hook xwem-worklog-task-stop-hook xwem-worklog-task-start-hook xwem-worklog-load-hook xwem-worklog-sort-type xwem-worklog-dockapp-diagram-type xwem-worklog-diagram-type xwem-worklog-use-diagram xwem-worklog-pause-cursor-background-color xwem-worklog-pause-cursor-foreground-color xwem-worklog-pause-cursor-shape xwem-worklog-pwin-border-color xwem-worklog-pwin-border-width xwem-worklog-pwin-height xwem-worklog-pwin-width xwem-worklog-pwin-background xwem-worklog-login-stop-period xwem-worklog-login-notify-period xwem-worklog-logout-auto-period xwem-worklog-logout-notify-period xwem-worklog-day-ends xwem-worklog-day-length xwem-worklog-day-start xwem-worklog-register-new-tasks xwem-worklog-pause-dont-stop xwem-worklog-auto-continue xwem-worklog-auto-login xwem-worklog-history-lines xwem-worklog-history-mode xwem-worklog-file xwem-worklog-silent xwem-worklog) "xwem-worklog" "lisp/xwem-worklog.el")
(defconst custom-define-current-source-file "xwem-worklog.el")

(defgroup xwem-worklog nil "Group to customize xwem worklog." :prefix "xwem-worklog-" :group 'xwem)

(defcustom xwem-worklog-silent nil "\
*Non-nil mean worklog will not print any messages in xwem minibuffer." :type 'boolean :group 'xwem-worklog)

(defcustom xwem-worklog-file "worklog" "\
*File to store xwem worklogs in worklog format." :type 'file :group 'xwem-worklog)

(defcustom xwem-worklog-history-mode t "\
*Non-nil mean save tasks to the `xwem-worklog-file'.
Note that `xwem-worklog-task-time-decrease' and
`xwem-worklog-task-time-increase' will not change file entries." :type 'boolean :group 'xwem-worklog)

(defcustom xwem-worklog-history-lines 2000 "\
*Number of lines to read from file, when entering history mode." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-auto-login t "\
*Non-nil mean, automatically login, when worklog started." :type 'boolean :group 'xwem-worklog)

(defcustom xwem-worklog-auto-continue nil "\
*Non-nil mean auto continue, when task started/stoped while in pause." :type 'boolean :group 'xwem-worklog)

(defcustom xwem-worklog-pause-dont-stop t "\
*Non-nil mean do not suspend current task when entering pause." :type 'boolean :group 'xwem-worklog)

(defcustom xwem-worklog-register-new-tasks t "\
*Non-nil mean register new tasks in `xwem-worklog-tasks-description'.
Task not registered if it is already in `xwem-worklog-tasks-description'." :type 'boolean :group 'xwem-worklog)

(defcustom xwem-worklog-day-start 9 "\
*Hour number when your workday starts in 0-23 range." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-day-length 9 "\
*Length in hours of your workday." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-day-ends 18 "\
*Hour number when your workday ends." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-logout-notify-period 5 "\
*Period in minutes to notify, that your workday is end, and you need to logout." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-logout-auto-period 60 "\
*Period in minutes to autologout, after your workday is end." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-login-notify-period 5 "\
*Period in minutes to notify that your workday started." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-login-stop-period 45 "\
*Period in minites when login notifying stops." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-pwin-background (face-background-name 'default) "\
*Color used as background color for xwem worklog pause window." :type 'color :group 'xwem-worklog)

(defcustom xwem-worklog-pwin-width 500 "\
*Width of pause window." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-pwin-height 700 "\
*Height of xwem worklog pause window." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-pwin-border-width 2 "\
*Border width for xwem worklog pause window." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-pwin-border-color "red4" "\
*Border color for xwem worklog pause window." :type 'color :group 'xwem-worklog)

(defcustom xwem-worklog-pause-cursor-shape 'X-XC-gumby "\
*Shape of cursor while in xwem worklog pause." :type (xwem-cursor-shape-choice) :group 'xwem-worklog)

(defcustom xwem-worklog-pause-cursor-foreground-color "#777777" "\
*Cursor's foreground color, while in xwem worklog pause." :type 'color :group 'xwem-worklog)

(defcustom xwem-worklog-pause-cursor-background-color nil "\
*Cursor's background color, while in xwem worklog pause." :type 'color :group 'xwem-worklog)

(defcustom xwem-worklog-use-diagram t "\
*Non-nil mean draw digram for today, when enter list mode." :type 'boolean :group 'xwem-worklog)

(defcustom xwem-worklog-diagram-type '3d "\
*Type of diagram to draw in list mode." :type '(choice (const :tag "3D Sectors" 3d) (const :tag "Plain Sectors" plain)) :group 'xwem-worklog)

(defcustom xwem-worklog-dockapp-diagram-type 'plain "\
*Type of diagram to draw in worklog dockapp." :type '(choice (const :tag "3D Sectors" 3d) (const :tag "Plain Sectors" plain)) :group 'xwem-worklog)

(defcustom xwem-worklog-sort-type 'Today-time "\
*Sorting type for `xwem-worklog-sorted-task-list'." :type '(choice (const :tag "Sort by name" name) (const :tag "Sort by Name" Name) (const :tag "Sort by today time" today-time) (const :tag "Sort by Today time" Today-time) (const :tag "Sort by total time" total-time) (const :tag "Sort by Total time" Total-time)) :group 'xwem-worklog)

(defcustom xwem-worklog-load-hook nil "\
*Hooks to run when `xwem-worklog' loaded." :type 'hook :group 'xwem-worklog)

(defcustom xwem-worklog-task-start-hook nil "\
*Hooks to run when new task just started." :type 'hook :group 'xwem-worklog)

(defcustom xwem-worklog-task-stop-hook nil "\
*Hooks to run when task just stoped." :type 'hook :group 'xwem-worklog)

(defcustom xwem-worklog-task-pause-hook nil "\
*Hooks to run when task is paused." :type 'hook :group 'xwem-worklog)

(defcustom xwem-worklog-task-resume-hook nil "\
*Hooks to run when task is resumed." :type 'hook :group 'xwem-worklog)

(defcustom xwem-worklog-login-hook nil "\
*Hooks to run when login." :type 'hook :group 'xwem-worklog)

(defcustom xwem-worklog-logout-hook nil "\
*Hooks to run when logout." :type 'hook :group 'xwem-worklog)

(defcustom xwem-worklog-tasks-description '(("Web browsing" (:key [(hyper ?w)] :color "dodgerblue" :cost 0) (or (application "mozilla") (application "firefox") (application "links") (buffer-major-mode w3m-mode) (and (application "xemacs") (name "\\*w3m\\*")))) ("Mail reading" (:key [(hyper ?m) ?r] :color "blue1" :cost 0) (or (buffer-major-mode gnus-group-mode) (buffer-major-mode gnus-article-mode) (buffer-major-mode gnus-summary-mode) (and (application "xemacs") (name "\\*\\(Group\\|Summary\\|Article\\)")))) ("Mail writing" (:key [(hyper ?m) ?w] :color "blue4" :cost 0) (or (buffer-major-mode message-mode) (buffer-major-mode bbdb-mode) (and (application "xemacs") (name "\\*\\(BBDB\\*\\|mail\\*\\|wide reply\\|reply\\)")))) ("Chating" (:key [?C] :color "palegreen" :cost 0) (or (buffer-major-mode erc-mode) (buffer-major-mode eicq-buddy-mode) (buffer-major-mode eicq-log-mode) (and (application "xemacs") (or (name "\\*Status\\*") (name "\\(#eicq\\|#xemacs\\|#sxemacs\\|irc\\.freenode\\.org\\)"))) (application "licq") (name "[LlMmVv][Ii][Cc][Qq]"))) ("Info/man reading" (:key [(hyper ?i)] :color "cyan" :cost 10) (or (buffer-major-mode Manual-mode) (buffer-major-mode Info-mode) (buffer-major-mode hyper-apropos-mode) (and (application "xemacs") (name "\\(\\*info\\*\\|Man: \\|\\*Help\\*\\|\\*Hyper Apropos\\*\\)")) (class-name "Xman"))) ("Emacs lisping" (:key [(hyper ?e)] :color "yellow2" :cost 0) (or (buffer-major-mode emacs-lisp-mode) (buffer-major-mode lisp-interaction-mode) (and (application "xemacs") (name "\\(\\*scratch\\*\\|\\.el\\)")))) ("C for fun" (:key [(hyper ?f)] :color "tomato" :cost 0)) ("C for profit" (:key [(hyper ?p)] :color "magenta" :cost 100) (or (buffer-major-mode cvs-mode) (buffer-major-mode c-mode) (buffer-major-mode gdb-mode) (application "ddd") (and (or (application "xemacs") (and (class-inst "^.term$") (class-name "^.Term$"))) (name "\\(gdb\\|\\*cvs\\*\\|\\.[ch]\\)")))) ("WorkProject" (:key [(hyper ?c)] :color "green2" :cost 200)) ("Administrativa" (:key [(hyper ?a)] :color "lightblue" :cost 150) (or (application "ethereal") (and (application "xterm") (name "\\(tcpdump\\|ssh\\)")))) ("Windows remote" (:color "lightcyan") (application "rdesktop")) ("Smoke" (:key [(hyper ?s)] :color "red3" :cost -50)) ("Nothing" (:key [(hyper ?n)] :color "gray80" :cost 50)) ("Unknown" (:color "gray50" :cost 0) (eval t))) "\
List of task descriptions in `xwem-manage-list' format.

Supported properties are:

  :key   - Key to bind task in `xwem-worklog-map'.
  :color - Color to use when drawing some task related info.
  :cost  - Task cost in $/hour. (not implemented)
  :image - Use image instead of :color. (not implemented)

You could define your own properties, which you will handle for
yourself.
" :type '(repeat sexp) :group 'xwem-worklog)

(defcustom xwem-worklog-dockapp-width 24 "\
*Width in pixels for worklog dockapp." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-dockapp-height 24 "\
*Height in pixels for worklog dockapp." :type 'number :group 'xwem-worklog)

(defcustom xwem-worklog-dockapp-sector-width 0 "\
*Sector width for worklog dockapps." :type 'number :group 'xwem-worklog)

;;;***

(provide 'xwem-custom-defines)
