;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'gnus-custom-defines) (error "Feature gnus-custom-defines already loaded"))

;;;### (autoloads (binhex-use-external binhex-decoder-switches binhex-decoder-program) "binhex" "lisp/binhex.el")
(defconst custom-define-current-source-file "binhex.el")

(defcustom binhex-decoder-program "hexbin" "\
*Non-nil value should be a string that names a binhex decoder.
The program should expect to read binhex data on its standard
input and write the converted data to its standard output." :type 'string :group 'gnus-extract)

(defcustom binhex-decoder-switches '("-d") "\
*List of command line flags passed to the command `binhex-decoder-program'." :group 'gnus-extract :type '(repeat string))

(defcustom binhex-use-external (executable-find binhex-decoder-program) "\
*Use external binhex program." :version "22.1" :group 'gnus-extract :type 'boolean)

;;;***

;;;### (autoloads (canlock-force-insert-header canlock-password-for-verify canlock-password canlock) "canlock" "lisp/canlock.el")
(defconst custom-define-current-source-file "canlock.el")

(defgroup canlock nil "The Cancel-Lock feature." :group 'news)

(defcustom canlock-password nil "\
Password to use when signing a Cancel-Lock or a Cancel-Key header." :type '(radio (const :format "Not specified " nil) (string :tag "Password")) :group 'canlock)

(defcustom canlock-password-for-verify canlock-password "\
Password to use when verifying a Cancel-Lock or a Cancel-Key header." :type '(radio (const :format "Not specified " nil) (string :tag "Password")) :group 'canlock)

(defcustom canlock-force-insert-header nil "\
If non-nil, insert a Cancel-Lock or a Cancel-Key header even if the
buffer does not look like a news message." :type 'boolean :group 'canlock)

;;;***

;;;### (autoloads (gnus-outlook-display-hook gnus-outlook-deuglify-attrib-end-regexp gnus-outlook-deuglify-attrib-verb-regexp gnus-outlook-deuglify-attrib-cut-regexp gnus-outlook-deuglify-no-wrap-chars gnus-outlook-deuglify-unwrap-stop-chars gnus-outlook-deuglify-cite-marks gnus-outlook-deuglify-unwrap-max gnus-outlook-deuglify-unwrap-min gnus-outlook-deuglify) "deuglify" "lisp/deuglify.el")
(defconst custom-define-current-source-file "deuglify.el")

(defgroup gnus-outlook-deuglify nil "Deuglify articles generated by broken user agents like MS Outlook (Express)." :version "22.1" :group 'gnus)

(defcustom gnus-outlook-deuglify-unwrap-min 45 "\
Minimum length of the cited line above the (possibly) wrapped line." :version "22.1" :type 'integer :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-deuglify-unwrap-max 95 "\
Maximum length of the cited line after unwrapping." :version "22.1" :type 'integer :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-deuglify-cite-marks ">|#%" "\
Characters that indicate cited lines." :version "22.1" :type 'string :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-deuglify-unwrap-stop-chars nil "\
Characters that inhibit unwrapping if they are the last one on the cited line above the possible wrapped line." :version "22.1" :type '(radio (const :format "None  " nil) (string :value ".?!")) :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-deuglify-no-wrap-chars "`" "\
Characters that inhibit unwrapping if they are the first one in the possibly wrapped line." :version "22.1" :type 'string :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-deuglify-attrib-cut-regexp "\\(On \\|Am \\)?\\(Mon\\|Tue\\|Wed\\|Thu\\|Fri\\|Sat\\|Sun\\),[^,]+, " "\
Regular expression matching the beginning of an attribution line that should be cut off." :version "22.1" :type 'string :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-deuglify-attrib-verb-regexp "wrote\\|writes\\|says\\|schrieb\\|schreibt\\|meinte\\|skrev\\|a crit\\|schreef\\|escribi" "\
Regular expression matching the verb used in an attribution line." :version "22.1" :type 'string :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-deuglify-attrib-end-regexp ": *\\|\\.\\.\\." "\
Regular expression matching the end of an attribution line." :version "22.1" :type 'string :group 'gnus-outlook-deuglify)

(defcustom gnus-outlook-display-hook nil "\
A hook called after an deuglified article has been prepared.
It is run after `gnus-article-prepare-hook'." :version "22.1" :type 'hook :group 'gnus-outlook-deuglify)

;;;***

;;;### (autoloads (earcon-regexp-alist earcon-suffix earcon-prefix earcon) "earcon" "lisp/earcon.el")
(defconst custom-define-current-source-file "earcon.el")

(defgroup earcon nil "Turn ** sounds ** into noise." :group 'gnus-visual)

(defcustom earcon-prefix "**" "\
*String denoting the start of an earcon." :type 'string :group 'earcon)

(defcustom earcon-suffix "**" "\
String denoting the end of an earcon." :type 'string :group 'earcon)

(defcustom earcon-regexp-alist '(("boring" 1 "Boring.au") ("evil[ 	]+laugh" 1 "Evil_Laugh.au") ("gag\\|puke" 1 "Puke.au") ("snicker" 1 "Snicker.au") ("meow" 1 "catmeow.wav") ("sob\\|boohoo" 1 "cry.wav") ("drum[ 	]*roll" 1 "drumroll.au") ("blast" 1 "explosion.au") ("flush\\|plonk!*" 1 "flush.au") ("kiss" 1 "kiss.wav") ("tee[ 	]*hee" 1 "laugh.au") ("shoot" 1 "shotgun.wav") ("yawn" 1 "snore.wav") ("cackle" 1 "witch.au") ("yell\\|roar" 1 "yell2.au") ("whoop-de-doo" 1 "whistle.au")) "\
*A list of regexps to map earcons to real sounds." :type '(repeat (list regexp (integer :tag "Match") (string :tag "Sound"))) :group 'earcon)

;;;***

;;;### (autoloads (fill-flowed-encode-column fill-flowed-display-column) "flow-fill" "lisp/flow-fill.el")
(defconst custom-define-current-source-file "flow-fill.el")

(defcustom fill-flowed-display-column 'fill-column "\
Column beyond which format=flowed lines are wrapped, when displayed.
This can be a Lisp expression or an integer." :version "22.1" :group 'mime-display :type '(choice (const :tag "Standard `fill-column'" fill-column) (const :tag "Fit Window" (- (window-width) 5)) (sexp) (integer)))

(defcustom fill-flowed-encode-column 66 "\
Column beyond which format=flowed lines are wrapped, in outgoing messages.
This can be a Lisp expression or an integer.
RFC 2646 suggests 66 characters for readability." :version "22.1" :group 'mime-display :type '(choice (const :tag "Standard fill-column" fill-column) (const :tag "RFC 2646 default (66)" 66) (sexp) (integer)))

;;;***

;;;### (autoloads (gmm-tool-bar-style gmm-verbose gmm) "gmm-utils" "lisp/gmm-utils.el")
(defconst custom-define-current-source-file "gmm-utils.el")

(defgroup gmm nil "Utility functions for Gnus, Message and MML" :prefix "gmm-" :version "22.1" :group 'lisp)

(defcustom gmm-verbose 7 "\
Integer that says how verbose gmm should be.
The higher the number, the more messages will flash to say what
it done.  At zero, it will be totally mute; at five, it will
display most important messages; and at ten, it will keep on
jabbering all the time." :type 'integer :group 'gmm)

(defcustom gmm-tool-bar-style (if (and (boundp 'tool-bar-mode) tool-bar-mode (and (fboundp 'display-visual-class) (not (memq (display-visual-class) (list 'static-gray 'gray-scale 'static-color 'pseudo-color))))) 'gnome 'retro) "\
Prefered tool bar style." :type '(choice (const :tag "GNOME style" gnome) (const :tag "Retro look" retro)) :group 'gmm)

;;;***

;;;### (autoloads (gnus-agent-article-alist-save-format gnus-agent-prompt-send-queue gnus-agent-queue-mail gnus-agent-auto-agentize-methods gnus-agent-expire-unagentized-dirs gnus-agent-enable-expiration gnus-agent-max-fetch-size gnus-agent-consider-all-articles gnus-agent-download-marks gnus-agent-mark-unread-after-downloaded gnus-agent-go-online gnus-agent-synchronize-flags gnus-agent-confirmation-function gnus-agent-server-mode-hook gnus-agent-summary-mode-hook gnus-agent-group-mode-hook gnus-agent-expire-all gnus-agent-expire-days gnus-agent-handle-level gnus-agent-fetched-hook gnus-agent-unplugged-hook gnus-agent-plugged-hook gnus-agent-directory) "gnus-agent" "lisp/gnus-agent.el")
(defconst custom-define-current-source-file "gnus-agent.el")

(defcustom gnus-agent-directory (nnheader-concat gnus-directory "agent/") "\
Where the Gnus agent will store its files." :group 'gnus-agent :type 'directory)

(defcustom gnus-agent-plugged-hook nil "\
Hook run when plugging into the network." :group 'gnus-agent :type 'hook)

(defcustom gnus-agent-unplugged-hook nil "\
Hook run when unplugging from the network." :group 'gnus-agent :type 'hook)

(defcustom gnus-agent-fetched-hook nil "\
Hook run when finished fetching articles." :version "22.1" :group 'gnus-agent :type 'hook)

(defcustom gnus-agent-handle-level gnus-level-subscribed "\
Groups on levels higher than this variable will be ignored by the Agent." :group 'gnus-agent :type 'integer)

(defcustom gnus-agent-expire-days 7 "\
Read articles older than this will be expired.
If you wish to disable Agent expiring, see `gnus-agent-enable-expiration'." :group 'gnus-agent :type '(number :tag "days"))

(defcustom gnus-agent-expire-all nil "\
If non-nil, also expire unread, ticked and dormant articles.
If nil, only read articles will be expired." :group 'gnus-agent :type 'boolean)

(defcustom gnus-agent-group-mode-hook nil "\
Hook run in Agent group minor modes." :group 'gnus-agent :type 'hook)

(defcustom gnus-agent-summary-mode-hook nil "\
Hook run in Agent summary minor modes." :group 'gnus-agent :type 'hook)

(defcustom gnus-agent-server-mode-hook nil "\
Hook run in Agent summary minor modes." :group 'gnus-agent :type 'hook)

(defcustom gnus-agent-confirmation-function 'y-or-n-p "\
Function to confirm when error happens." :version "21.1" :group 'gnus-agent :type 'function)

(defcustom gnus-agent-synchronize-flags t "\
Indicate if flags are synchronized when you plug in.
If this is `ask' the hook will query the user." :version "21.1" :type '(choice (const :tag "Always" t) (const :tag "Never" nil) (const :tag "Ask" ask)) :group 'gnus-agent)

(defcustom gnus-agent-go-online 'ask "\
Indicate if offline servers go online when you plug in.
If this is `ask' the hook will query the user." :version "21.3" :type '(choice (const :tag "Always" t) (const :tag "Never" nil) (const :tag "Ask" ask)) :group 'gnus-agent)

(defcustom gnus-agent-mark-unread-after-downloaded t "\
Indicate whether to mark articles unread after downloaded." :version "21.1" :type 'boolean :group 'gnus-agent)

(defcustom gnus-agent-download-marks '(download) "\
Marks for downloading." :version "21.1" :type '(repeat (symbol :tag "Mark")) :group 'gnus-agent)

(defcustom gnus-agent-consider-all-articles nil "\
When non-nil, the agent will let the agent predicate decide
whether articles need to be downloaded or not, for all articles.  When
nil, the default, the agent will only let the predicate decide
whether unread articles are downloaded or not.  If you enable this,
groups with large active ranges may open slower and you may also want
to look into the agent expiry settings to block the expiration of
read articles as they would just be downloaded again." :version "22.1" :type 'boolean :group 'gnus-agent)

(defcustom gnus-agent-max-fetch-size 10000000 "\
Chunk size for `gnus-agent-fetch-session'.
The function will split its article fetches into chunks smaller than
this limit." :version "22.1" :group 'gnus-agent :type 'integer)

(defcustom gnus-agent-enable-expiration 'ENABLE "\
The default expiration state for each group.
When set to ENABLE, the default, `gnus-agent-expire' will expire old
contents from a group's local storage.  This value may be overridden
to disable expiration in specific categories, topics, and groups.  Of
course, you could change gnus-agent-enable-expiration to DISABLE then
enable expiration per categories, topics, and groups." :version "22.1" :group 'gnus-agent :type '(radio (const :format "Enable " ENABLE) (const :format "Disable " DISABLE)))

(defcustom gnus-agent-expire-unagentized-dirs t "\
*Whether expiration should expire in unagentized directories.
Have gnus-agent-expire scan the directories under
\(gnus-agent-directory) for groups that are no longer agentized.
When found, offer to remove them." :version "22.1" :type 'boolean :group 'gnus-agent)

(defcustom gnus-agent-auto-agentize-methods '(nntp nnimap) "\
Initially, all servers from these methods are agentized.
The user may remove or add servers using the Server buffer.
See Info node `(gnus)Server Buffer'." :version "22.1" :type '(repeat symbol) :group 'gnus-agent)

(defcustom gnus-agent-queue-mail t "\
Whether and when outgoing mail should be queued by the agent.
When `always', always queue outgoing mail.  When nil, never
queue.  Otherwise, queue if and only if unplugged." :version "22.1" :group 'gnus-agent :type '(radio (const :format "Always" always) (const :format "Never" nil) (const :format "When unplugged" t)))

(defcustom gnus-agent-prompt-send-queue nil "\
If non-nil, `gnus-group-send-queue' will prompt if called when
unplugged." :version "22.1" :group 'gnus-agent :type 'boolean)

(defcustom gnus-agent-article-alist-save-format 1 "\
Indicates whether to use compression(2), versus no
compression(1), when writing agentview files.  The compressed
files do save space but load times are 6-7 times higher.  A group
must be opened then closed for the agentview to be updated using
the new format." :version "22.1" :group 'gnus-agent :type '(radio (const :format "Compressed" 2) (const :format "Uncompressed" 1)))

;;;***

;;;### (autoloads (gnus-header-button-alist gnus-button-alist gnus-button-browse-level gnus-button-message-level gnus-button-emacs-level gnus-button-man-level gnus-button-tex-level gnus-button-mid-or-mail-heuristic-alist gnus-button-prefer-mid-or-mail gnus-button-mid-or-mail-regexp gnus-button-ctan-directory-regexp gnus-button-handle-ctan-bogus-regexp gnus-button-ctan-handler gnus-ctan-url gnus-button-man-handler gnus-button-valid-localpart-regexp gnus-button-valid-fqdn-regexp gnus-button-url-regexp gnus-article-edit-mode-hook gnus-mime-display-multipart-related-as-mixed gnus-mime-display-multipart-alternative-as-mixed gnus-mime-display-multipart-as-mixed gnus-article-over-scroll gnus-use-idna gnus-article-encrypt-protocol gnus-treat-x-pgp-sig gnus-treat-translate gnus-treat-play-sounds gnus-treat-fill-long-lines gnus-treat-wash-html gnus-treat-capitalize-sentences gnus-treat-body-boundary gnus-treat-newsgroups-picon gnus-treat-mail-picon gnus-treat-from-picon gnus-treat-display-smileys gnus-treat-display-face gnus-treat-display-x-face gnus-treat-overstrike gnus-treat-fold-newsgroups gnus-treat-fold-headers gnus-treat-unfold-headers gnus-treat-strip-multiple-blank-lines gnus-treat-strip-leading-blank-lines gnus-treat-strip-trailing-blank-lines gnus-treat-strip-headers-in-body gnus-treat-date-user-defined gnus-treat-date-iso8601 gnus-treat-date-original gnus-treat-date-lapsed gnus-treat-date-english gnus-treat-date-local gnus-treat-date-ut gnus-treat-highlight-citation gnus-treat-highlight-headers gnus-treat-strip-banner gnus-treat-strip-pem gnus-treat-strip-list-identifiers gnus-treat-hide-citation-maybe gnus-treat-hide-citation gnus-treat-fill-article gnus-treat-hide-signature gnus-treat-hide-boring-headers gnus-treat-hide-headers gnus-treat-leading-whitespace gnus-treat-unsplit-urls gnus-treat-strip-cr gnus-treat-emphasize gnus-treat-buttonize-head gnus-treat-buttonize gnus-treat-highlight-signature gnus-mime-action-alist gnus-article-mime-match-handle-function gnus-article-date-lapsed-new-header gnus-mime-multipart-functions gnus-article-mime-part-function gnus-picon-databases gnus-body-boundary-delimiter gnus-inhibit-mime-unbuttonizing gnus-buttonized-mime-types gnus-unbuttonized-mime-types gnus-ignored-mime-types gnus-display-mime-function gnus-article-decode-hook gnus-header-face-alist gnus-signature-face gnus-article-mouse-face gnus-article-button-face gnus-article-prepare-hook gnus-article-menu-hook gnus-article-mode-hook gnus-article-mode-line-format gnus-page-delimiter gnus-split-methods gnus-file-save-name gnus-folder-save-name gnus-mail-save-name gnus-rmail-save-name gnus-article-save-coding-system gnus-default-article-saver gnus-saved-headers gnus-prompt-before-saving gnus-save-all-headers gnus-article-time-format gnus-emphasize-whitespace-regexp gnus-emphasis-alist gnus-article-address-banner-alist gnus-article-banner-alist gnus-article-x-face-too-ugly gnus-article-x-face-command gnus-hidden-properties gnus-signature-limit gnus-signature-separator gnus-article-skip-boring gnus-boring-article-headers gnus-sorted-header-list gnus-visible-headers gnus-ignored-headers gnus-article-various gnus-article-buttons gnus-article-mime gnus-article-saving gnus-article-emphasis gnus-article-washing gnus-article-headers gnus-article-signature gnus-article-highlight gnus-article-hiding gnus-article-treat gnus-article) "gnus-art" "lisp/gnus-art.el")
(defconst custom-define-current-source-file "gnus-art.el")

(defgroup gnus-article nil "Article display." :link '(custom-manual "(gnus)Article Buffer") :group 'gnus)

(defgroup gnus-article-treat nil "Treating article parts." :link '(custom-manual "(gnus)Article Hiding") :group 'gnus-article)

(defgroup gnus-article-hiding nil "Hiding article parts." :link '(custom-manual "(gnus)Article Hiding") :group 'gnus-article)

(defgroup gnus-article-highlight nil "Article highlighting." :link '(custom-manual "(gnus)Article Highlighting") :group 'gnus-article :group 'gnus-visual)

(defgroup gnus-article-signature nil "Article signatures." :link '(custom-manual "(gnus)Article Signature") :group 'gnus-article)

(defgroup gnus-article-headers nil "Article headers." :link '(custom-manual "(gnus)Hiding Headers") :group 'gnus-article)

(defgroup gnus-article-washing nil "Special commands on articles." :link '(custom-manual "(gnus)Article Washing") :group 'gnus-article)

(defgroup gnus-article-emphasis nil "Fontisizing articles." :link '(custom-manual "(gnus)Article Fontisizing") :group 'gnus-article)

(defgroup gnus-article-saving nil "Saving articles." :link '(custom-manual "(gnus)Saving Articles") :group 'gnus-article)

(defgroup gnus-article-mime nil "Worshiping the MIME wonder." :link '(custom-manual "(gnus)Using MIME") :group 'gnus-article)

(defgroup gnus-article-buttons nil "Pushable buttons in the article buffer." :link '(custom-manual "(gnus)Article Buttons") :group 'gnus-article)

(defgroup gnus-article-various nil "Other article options." :link '(custom-manual "(gnus)Misc Article") :group 'gnus-article)

(defcustom gnus-ignored-headers (mapcar (lambda (header) (concat "^" header ":")) '("Path" "Expires" "Date-Received" "References" "Xref" "Lines" "Relay-Version" "Message-ID" "Approved" "Sender" "Received" "X-UIDL" "MIME-Version" "Return-Path" "In-Reply-To" "Content-Type" "Content-Transfer-Encoding" "X-WebTV-Signature" "X-MimeOLE" "X-MSMail-Priority" "X-Priority" "X-Loop" "X-Authentication-Warning" "X-MIME-Autoconverted" "X-Face" "X-Attribution" "X-Originating-IP" "Delivered-To" "NNTP-[-A-Za-z]+" "Distribution" "X-no-archive" "X-Trace" "X-Complaints-To" "X-NNTP-Posting-Host" "X-Orig.*" "Abuse-Reports-To" "Cache-Post-Path" "X-Article-Creation-Date" "X-Poster" "X-Mail2News-Path" "X-Server-Date" "X-Cache" "Originator" "X-Problems-To" "X-Auth-User" "X-Post-Time" "X-Admin" "X-UID" "Resent-[-A-Za-z]+" "X-Mailing-List" "Precedence" "Original-[-A-Za-z]+" "X-filename" "X-Orcpt" "Old-Received" "X-Pgp" "X-Auth" "X-From-Line" "X-Gnus-Article-Number" "X-Majordomo" "X-Url" "X-Sender" "MBOX-Line" "Priority" "X400-[-A-Za-z]+" "Status" "X-Gnus-Mail-Source" "Cancel-Lock" "X-FTN" "X-EXP32-SerialNo" "Encoding" "Importance" "Autoforwarded" "Original-Encoded-Information-Types" "X-Ya-Pop3" "X-Face-Version" "X-Vms-To" "X-ML-NAME" "X-ML-COUNT" "Mailing-List" "X-finfo" "X-md5sum" "X-md5sum-Origin" "X-Sun-Charset" "X-Accept-Language" "X-Envelope-Sender" "List-[A-Za-z]+" "X-Listprocessor-Version" "X-Received" "X-Distribute" "X-Sequence" "X-Juno-Line-Breaks" "X-Notes-Item" "X-MS-TNEF-Correlator" "x-uunet-gateway" "X-Received" "Content-length" "X-precedence" "X-Authenticated-User" "X-Comment" "X-Report" "X-Abuse-Info" "X-HTTP-Proxy" "X-Mydeja-Info" "X-Copyright" "X-No-Markup" "X-Abuse-Info" "X-From_" "X-Accept-Language" "Errors-To" "X-BeenThere" "X-Mailman-Version" "List-Help" "List-Post" "List-Subscribe" "List-Id" "List-Unsubscribe" "List-Archive" "X-Content-length" "X-Posting-Agent" "Original-Received" "X-Request-PGP" "X-Fingerprint" "X-WRIEnvto" "X-WRIEnvfrom" "X-Virus-Scanned" "X-Delivery-Agent" "Posted-Date" "X-Gateway" "X-Local-Origin" "X-Local-Destination" "X-UserInfo1" "X-Received-Date" "X-Hashcash" "Face" "X-DMCA-Notifications" "X-Abuse-and-DMCA-Info" "X-Postfilter" "X-Gpg-.*" "X-Disclaimer")) "\
*All headers that start with this regexp will be hidden.
This variable can also be a list of regexps of headers to be ignored.
If `gnus-visible-headers' is non-nil, this variable will be ignored." :type '(choice :custom-show nil regexp (repeat regexp)) :group 'gnus-article-hiding)

(defcustom gnus-visible-headers "^From:\\|^Newsgroups:\\|^Subject:\\|^Date:\\|^Followup-To:\\|^Reply-To:\\|^Organization:\\|^Summary:\\|^Keywords:\\|^To:\\|^[BGF]?Cc:\\|^Posted-To:\\|^Mail-Copies-To:\\|^Mail-Followup-To:\\|^Apparently-To:\\|^Gnus-Warning:\\|^Resent-From:\\|^X-Sent:" "\
*All headers that do not match this regexp will be hidden.
This variable can also be a list of regexp of headers to remain visible.
If this variable is non-nil, `gnus-ignored-headers' will be ignored." :type '(repeat :value-to-internal (lambda (widget value) (custom-split-regexp-maybe value)) :match (lambda (widget value) (or (stringp value) (widget-editable-list-match widget value))) regexp) :group 'gnus-article-hiding)

(defcustom gnus-sorted-header-list '("^From:" "^Subject:" "^Summary:" "^Keywords:" "^Newsgroups:" "^Followup-To:" "^To:" "^Cc:" "^Date:" "^Organization:") "\
*This variable is a list of regular expressions.
If it is non-nil, headers that match the regular expressions will
be placed first in the article buffer in the sequence specified by
this list." :type '(repeat regexp) :group 'gnus-article-hiding)

(defcustom gnus-boring-article-headers '(empty followup-to reply-to) "\
Headers that are only to be displayed if they have interesting data.
Possible values in this list are:

  'empty       Headers with no content.
  'newsgroups  Newsgroup identical to Gnus group.
  'to-address  To identical to To-address.
  'to-list     To identical to To-list.
  'cc-list     CC identical to To-list.
  'followup-to Followup-to identical to Newsgroups.
  'reply-to    Reply-to identical to From.
  'date        Date less than four days old.
  'long-to     To and/or Cc longer than 1024 characters.
  'many-to     Multiple To and/or Cc." :type '(set (const :tag "Headers with no content." empty) (const :tag "Newsgroups identical to Gnus group." newsgroups) (const :tag "To identical to To-address." to-address) (const :tag "To identical to To-list." to-list) (const :tag "CC identical to To-list." cc-list) (const :tag "Followup-to identical to Newsgroups." followup-to) (const :tag "Reply-to identical to From." reply-to) (const :tag "Date less than four days old." date) (const :tag "To and/or Cc longer than 1024 characters." long-to) (const :tag "Multiple To and/or Cc headers." many-to)) :group 'gnus-article-hiding)

(defcustom gnus-article-skip-boring nil "\
Skip over text that is not worth reading.
By default, if you set this t, then Gnus will display citations and
signatures, but will never scroll down to show you a page consisting
only of boring text.  Boring text is controlled by
`gnus-article-boring-faces'." :version "22.1" :type 'boolean :group 'gnus-article-hiding)

(defcustom gnus-signature-separator '("^-- $" "^-- *$") "\
Regexp matching signature separator.
This can also be a list of regexps.  In that case, it will be checked
from head to tail looking for a separator.  Searches will be done from
the end of the buffer." :type '(choice :format "%{%t%}: %[Value Menu%]
%v" (regexp) (repeat :tag "List of regexp" regexp)) :group 'gnus-article-signature)

(defcustom gnus-signature-limit nil "\
Provide a limit to what is considered a signature.
If it is a number, no signature may not be longer (in characters) than
that number.  If it is a floating point number, no signature may be
longer (in lines) than that number.  If it is a function, the function
will be called without any parameters, and if it returns nil, there is
no signature in the buffer.  If it is a string, it will be used as a
regexp.  If it matches, the text in question is not a signature." :type '(choice (const nil) (integer :value 200) (number :value 4.0) function (regexp :value ".*")) :group 'gnus-article-signature)

(defcustom gnus-hidden-properties '(invisible t intangible t) "\
Property list to use for hiding text." :type 'sexp :group 'gnus-article-hiding)

(defcustom gnus-article-x-face-command (if (featurep 'xemacs) (if (or (gnus-image-type-available-p 'xface) (gnus-image-type-available-p 'pbm)) 'gnus-display-x-face-in-from "{ echo '/* Width=48, Height=48 */'; uncompface; } | icontopbm | ee -") (if (gnus-image-type-available-p 'pbm) 'gnus-display-x-face-in-from "{ echo '/* Width=48, Height=48 */'; uncompface; } | icontopbm | display -")) "\
*String or function to be executed to display an X-Face header.
If it is a string, the command will be executed in a sub-shell
asynchronously.  The compressed face will be piped to this command." :type (backquote (choice string (function-item gnus-display-x-face-in-from) function)) :version "21.1" :group 'gnus-picon :group 'gnus-article-washing)

(defcustom gnus-article-x-face-too-ugly nil "\
Regexp matching posters whose face shouldn't be shown automatically." :type '(choice regexp (const nil)) :group 'gnus-article-washing)

(defcustom gnus-article-banner-alist nil "\
Banner alist for stripping.
For example,
     ((egroups . \"^[ \\t\\n]*-------------------+\\\\( \\\\(e\\\\|Yahoo! \\\\)Groups Sponsor -+\\\\)?....\\n\\\\(.+\\n\\\\)+\"))" :version "21.1" :type '(repeat (cons symbol regexp)) :group 'gnus-article-washing)

(defcustom gnus-article-address-banner-alist nil "\
Alist of mail addresses and banners.
Each element has the form (ADDRESS . BANNER), where ADDRESS is a regexp
to match a mail address in the From: header, BANNER is one of a symbol
`signature', an item in `gnus-article-banner-alist', a regexp and nil.
If ADDRESS matches author's mail address, it will remove things like
advertisements.  For example:

\((\"@yoo-hoo\\\\.co\\\\.jp\\\\'\" . \"\\n_+\\nDo You Yoo-hoo!\\\\?\\n.*\\n.*\\n\"))
" :type '(repeat (cons (regexp :tag "Address") (choice :tag "Banner" :value nil (const :tag "Remove signature" signature) (symbol :tag "Item in `gnus-article-banner-alist'" none) regexp (const :tag "None" nil)))) :version "22.1" :group 'gnus-article-washing)

(defcustom gnus-emphasis-alist (let ((types '(("\\*" "\\*" bold nil 2) ("_" "_" underline) ("/" "/" italic) ("_/" "/_" underline-italic) ("_\\*" "\\*_" underline-bold) ("\\*/" "/\\*" bold-italic) ("_\\*/" "/\\*_" underline-bold-italic)))) (nconc (gnus-emphasis-custom-with-format (mapcar (lambda (spec) (list (format format (car spec) (cadr spec)) (or (nth 3 spec) 2) (or (nth 4 spec) 3) (intern (format "gnus-emphasis-%s" (nth 2 spec))))) types)) '(("\\(\\s-\\|^\\)\\(_\\(\\(\\w\\|_[^_]\\)+\\)_\\)\\(\\s-\\|[?!.,;]\\)" 2 3 gnus-emphasis-underline)))) "\
*Alist that says how to fontify certain phrases.
Each item looks like this:

  (\"_\\\\(\\\\w+\\\\)_\" 0 1 'underline)

The first element is a regular expression to be matched.  The second
is a number that says what regular expression grouping used to find
the entire emphasized word.  The third is a number that says what
regexp grouping should be displayed and highlighted.  The fourth
is the face used for highlighting." :type '(repeat (menu-choice :format "%[Customizing Style%]
%v" :indent 2 (group :tag "Default" :value ("" 0 0 default) :value-create (lambda (widget) (let ((value (widget-get (cadr (widget-get (widget-get widget :parent) :args)) :value))) (if (not (eq (nth 2 value) 'default)) (widget-put widget :value (gnus-emphasis-custom-value-to-external value)))) (widget-group-value-create widget)) regexp (integer :format "Match group: %v") (integer :format "Emphasize group: %v") face) (group :tag "Simple" :value (("_" . "_") nil default) (cons :format "%v" (regexp :format "Start regexp: %v") (regexp :format "End regexp: %v")) (boolean :format "Show start and end patterns: %[%v%]
" :on " On " :off " Off ") face))) :get (lambda (symbol) (mapcar 'gnus-emphasis-custom-value-to-internal (default-value symbol))) :set (lambda (symbol value) (set-default symbol (mapcar 'gnus-emphasis-custom-value-to-external value))) :group 'gnus-article-emphasis)

(defcustom gnus-emphasize-whitespace-regexp "^[ 	]+\\|[ 	]*\n" "\
A regexp to describe whitespace which should not be emphasized.
Typical values are \"^[ \\t]+\\\\|[ \\t]*\\n\" and \"[ \\t]+\\\\|[ \\t]*\\n\".
The former avoids underlining of leading and trailing whitespace,
and the latter avoids underlining any whitespace at all." :version "21.1" :group 'gnus-article-emphasis :type 'regexp)

(defcustom gnus-article-time-format "%a, %b %d %Y %T %Z" "\
Format for display of Date headers in article bodies.
See `format-time-string' for the possible values.

The variable can also be function, which should return a complete Date
header.  The function is called with one argument, the time, which can
be fed to `format-time-string'." :type '(choice string symbol) :link '(custom-manual "(gnus)Article Date") :group 'gnus-article-washing)

(defcustom gnus-save-all-headers t "\
*If non-nil, don't remove any headers before saving.
This will be overridden by the `:headers' property that the symbol of
the saver function, which is specified by `gnus-default-article-saver',
might have." :group 'gnus-article-saving :type 'boolean)

(defcustom gnus-prompt-before-saving 'always "\
*This variable says how much prompting is to be done when saving articles.
If it is nil, no prompting will be done, and the articles will be
saved to the default files.  If this variable is `always', each and
every article that is saved will be preceded by a prompt, even when
saving large batches of articles.  If this variable is neither nil not
`always', there the user will be prompted once for a file name for
each invocation of the saving commands." :group 'gnus-article-saving :type '(choice (item always) (item :tag "never" nil) (sexp :tag "once" :format "%t
" :value t)))

(defcustom gnus-saved-headers gnus-visible-headers "\
Headers to keep if `gnus-save-all-headers' is nil.
If `gnus-save-all-headers' is non-nil, this variable will be ignored.
If that variable is nil, however, all headers that match this regexp
will be kept while the rest will be deleted before saving.  This and
`gnus-save-all-headers' will be overridden by the `:headers' property
that the symbol of the saver function, which is specified by
`gnus-default-article-saver', might have." :group 'gnus-article-saving :type 'regexp)

(defcustom gnus-default-article-saver 'gnus-summary-save-in-rmail "\
A function to save articles in your favourite format.
The function will be called by way of the `gnus-summary-save-article'
command, and friends such as `gnus-summary-save-article-rmail'.

Gnus provides the following functions:

* gnus-summary-save-in-rmail (Rmail format)
* gnus-summary-save-in-mail (Unix mail format)
* gnus-summary-save-in-folder (MH folder)
* gnus-summary-save-in-file (article format)
* gnus-summary-save-body-in-file (article body)
* gnus-summary-save-in-vm (use VM's folder format)
* gnus-summary-write-to-file (article format -- overwrite)
* gnus-summary-write-body-to-file (article body -- overwrite)

The symbol of each function may have the following properties:

* :decode
The value non-nil means save decoded articles.  This is meaningful
only with `gnus-summary-save-in-file', `gnus-summary-save-body-in-file',
`gnus-summary-write-to-file', and `gnus-summary-write-body-to-file'.

* :function
The value specifies an alternative function which appends, not
overwrites, articles to a file.  This implies that when saving many
articles at a time, `gnus-prompt-before-saving' is bound to t and all
articles are saved in a single file.  This is meaningful only with
`gnus-summary-write-to-file' and `gnus-summary-write-body-to-file'.

* :headers
The value specifies the symbol of a variable of which the value
specifies headers to be saved.  If it is omitted,
`gnus-save-all-headers' and `gnus-saved-headers' control what
headers should be saved." :group 'gnus-article-saving :type '(radio (function-item gnus-summary-save-in-rmail) (function-item gnus-summary-save-in-mail) (function-item gnus-summary-save-in-folder) (function-item gnus-summary-save-in-file) (function-item gnus-summary-save-body-in-file) (function-item gnus-summary-save-in-vm) (function-item gnus-summary-write-to-file) (function-item gnus-summary-write-body-to-file) (function)))

(defcustom gnus-article-save-coding-system (or (and (mm-coding-system-p 'utf-8) 'utf-8) (and (mm-coding-system-p 'iso-2022-7bit) 'iso-2022-7bit) (and (mm-coding-system-p 'emacs-mule) 'emacs-mule) (and (mm-coding-system-p 'escape-quoted) 'escape-quoted)) "\
Coding system used to save decoded articles to a file.

The recommended coding systems are `utf-8', `iso-2022-7bit' and so on,
which can safely encode any characters in text.  This is used by the
commands including:

* gnus-summary-save-article-file
* gnus-summary-save-article-body-file
* gnus-summary-write-article-file
* gnus-summary-write-article-body-file

and the functions to which you may set `gnus-default-article-saver':

* gnus-summary-save-in-file
* gnus-summary-save-body-in-file
* gnus-summary-write-to-file
* gnus-summary-write-body-to-file

Those commands and functions save just text displayed in the article
buffer to a file if the value of this variable is non-nil.  Note that
buttonized MIME parts will be lost in a saved file in that case.
Otherwise, raw articles will be saved." :group 'gnus-article-saving :type (backquote (choice :format "%{%t%}:
 %[Value Menu%] %v" (const :tag "Save raw articles" nil) (\,@ (delq nil (mapcar (lambda (arg) (if (mm-coding-system-p (nth 3 arg)) arg)) '((const :tag "UTF-8" utf-8) (const :tag "iso-2022-7bit" iso-2022-7bit) (const :tag "Emacs internal" emacs-mule) (const :tag "escape-quoted" escape-quoted))))) (symbol :tag "Coding system"))))

(defcustom gnus-rmail-save-name 'gnus-plain-save-name "\
A function generating a file name to save articles in Rmail format.
The function is called with NEWSGROUP, HEADERS, and optional LAST-FILE." :group 'gnus-article-saving :type 'function)

(defcustom gnus-mail-save-name 'gnus-plain-save-name "\
A function generating a file name to save articles in Unix mail format.
The function is called with NEWSGROUP, HEADERS, and optional LAST-FILE." :group 'gnus-article-saving :type 'function)

(defcustom gnus-folder-save-name 'gnus-folder-save-name "\
A function generating a file name to save articles in MH folder.
The function is called with NEWSGROUP, HEADERS, and optional LAST-FOLDER." :group 'gnus-article-saving :type 'function)

(defcustom gnus-file-save-name 'gnus-numeric-save-name "\
A function generating a file name to save articles in article format.
The function is called with NEWSGROUP, HEADERS, and optional
LAST-FILE." :group 'gnus-article-saving :type 'function)

(defcustom gnus-split-methods '((gnus-article-archive-name) (gnus-article-nndoc-name)) "\
*Variable used to suggest where articles are to be saved.
For instance, if you would like to save articles related to Gnus in
the file \"gnus-stuff\", and articles related to VM in \"vm-stuff\",
you could set this variable to something like:

 '((\"^Subject:.*gnus\\|^Newsgroups:.*gnus\" \"gnus-stuff\")
   (\"^Subject:.*vm\\|^Xref:.*vm\" \"vm-stuff\"))

This variable is an alist where the where the key is the match and the
value is a list of possible files to save in if the match is non-nil.

If the match is a string, it is used as a regexp match on the
article.  If the match is a symbol, that symbol will be funcalled
from the buffer of the article to be saved with the newsgroup as the
parameter.  If it is a list, it will be evalled in the same buffer.

If this form or function returns a string, this string will be used as
a possible file name; and if it returns a non-nil list, that list will
be used as possible file names." :group 'gnus-article-saving :type '(repeat (choice (list :value (fun) function) (cons :value ("" "") regexp (repeat string)) (sexp :value nil))))

(defcustom gnus-page-delimiter "^\^L" "\
*Regexp describing what to use as article page delimiters.
The default value is \"^\", which is a form linefeed at the
beginning of a line." :type 'regexp :group 'gnus-article-various)

(defcustom gnus-article-mode-line-format "Gnus: %g [%w] %S%m" "\
*The format specification for the article mode line.
See `gnus-summary-mode-line-format' for a closer description.

The following additional specs are available:

%w  The article washing status.
%m  The number of MIME parts in the article." :type 'string :group 'gnus-article-various)

(defcustom gnus-article-mode-hook nil "\
*A hook for Gnus article mode." :type 'hook :group 'gnus-article-various)

(defcustom gnus-article-menu-hook nil "\
*Hook run after the creation of the article mode menu." :type 'hook :group 'gnus-article-various)

(defcustom gnus-article-prepare-hook nil "\
*A hook called after an article has been prepared in the article buffer." :type 'hook :group 'gnus-article-various)

(defcustom gnus-article-button-face 'bold "\
Face used for highlighting buttons in the article buffer.

An article button is a piece of text that you can activate by pressing
`RET' or `mouse-2' above it." :type 'face :group 'gnus-article-buttons)

(defcustom gnus-article-mouse-face 'highlight "\
Face used for mouse highlighting in the article buffer.

Article buttons will be displayed in this face when the cursor is
above them." :type 'face :group 'gnus-article-buttons)

(defcustom gnus-signature-face 'gnus-signature "\
Face used for highlighting a signature in the article buffer.
Obsolete; use the face `gnus-signature' for customizations instead." :type 'face :group 'gnus-article-highlight :group 'gnus-article-signature)

(defcustom gnus-header-face-alist '(("From" nil gnus-header-from) ("Subject" nil gnus-header-subject) ("Newsgroups:.*," nil gnus-header-newsgroups) ("" gnus-header-name gnus-header-content)) "\
*Controls highlighting of article headers.

An alist of the form (HEADER NAME CONTENT).

HEADER is a regular expression which should match the name of a
header and NAME and CONTENT are either face names or nil.

The name of each header field will be displayed using the face
specified by the first element in the list where HEADER matches
the header name and NAME is non-nil.  Similarly, the content will
be displayed by the first non-nil matching CONTENT face." :group 'gnus-article-headers :group 'gnus-article-highlight :type '(repeat (list (regexp :tag "Header") (choice :tag "Name" (item :tag "skip" nil) (face :value default)) (choice :tag "Content" (item :tag "skip" nil) (face :value default)))))

(defcustom gnus-article-decode-hook '(article-decode-charset article-decode-encoded-words article-decode-group-name article-decode-idna-rhs) "\
*Hook run to decode charsets in articles." :group 'gnus-article-headers :type 'hook)

(defcustom gnus-display-mime-function 'gnus-display-mime "\
Function to display MIME articles." :group 'gnus-article-mime :type 'function)

(defcustom gnus-ignored-mime-types nil "\
List of MIME types that should be ignored by Gnus." :version "21.1" :group 'gnus-article-mime :type '(repeat regexp))

(defcustom gnus-unbuttonized-mime-types '(".*/.*") "\
List of MIME types that should not be given buttons when rendered inline.
See also `gnus-buttonized-mime-types' which may override this variable.
This variable is only used when `gnus-inhibit-mime-unbuttonizing' is nil." :version "21.1" :group 'gnus-article-mime :type '(repeat regexp))

(defcustom gnus-buttonized-mime-types nil "\
List of MIME types that should be given buttons when rendered inline.
If set, this variable overrides `gnus-unbuttonized-mime-types'.
To see e.g. security buttons you could set this to
`(\"multipart/signed\")'.  You could also add \"multipart/alternative\" to
this list to display radio buttons that allow you to choose one of two
media types those mails include.  See also `mm-discouraged-alternatives'.
This variable is only used when `gnus-inhibit-mime-unbuttonizing' is nil." :version "22.1" :group 'gnus-article-mime :type '(repeat regexp))

(defcustom gnus-inhibit-mime-unbuttonizing nil "\
If non-nil, all MIME parts get buttons.
When nil (the default value), then some MIME parts do not get buttons,
as described by the variables `gnus-buttonized-mime-types' and
`gnus-unbuttonized-mime-types'." :version "22.1" :group 'gnus-article-mime :type 'boolean)

(defcustom gnus-body-boundary-delimiter "_" "\
String used to delimit header and body.
This variable is used by `gnus-article-treat-body-boundary' which can
be controlled by `gnus-treat-body-boundary'." :version "22.1" :group 'gnus-article-various :type '(choice (item :tag "None" :value nil) string))

(defcustom gnus-picon-databases '("/usr/lib/picon" "/usr/local/faces" "/usr/share/picons") "\
Defines the location of the faces database.
For information on obtaining this database of pretty pictures, please
see http://www.cs.indiana.edu/picons/ftp/index.html" :version "22.1" :type '(repeat directory) :link '(url-link :tag "download" "http://www.cs.indiana.edu/picons/ftp/index.html") :link '(custom-manual "(gnus)Picons") :group 'gnus-picon)

(defcustom gnus-article-mime-part-function nil "\
Function called with a MIME handle as the argument.
This is meant for people who want to do something automatic based
on parts -- for instance, adding Vcard info to a database." :group 'gnus-article-mime :type '(choice (const nil) function))

(defcustom gnus-mime-multipart-functions nil "\
An alist of MIME types to functions to display them." :version "21.1" :group 'gnus-article-mime :type 'alist)

(defcustom gnus-article-date-lapsed-new-header nil "\
Whether the X-Sent and Date headers can coexist.
When using `gnus-treat-date-lapsed', the \"X-Sent:\" header will
either replace the old \"Date:\" header (if this variable is nil), or
be added below it (otherwise)." :version "21.1" :group 'gnus-article-headers :type 'boolean)

(defcustom gnus-article-mime-match-handle-function 'undisplayed-alternative "\
Function called with a MIME handle as the argument.
This is meant for people who want to view first matched part.
For `undisplayed-alternative' (default), the first undisplayed
part or alternative part is used.  For `undisplayed', the first
undisplayed part is used.  For a function, the first part which
the function return t is used.  For nil, the first part is
used." :version "21.1" :group 'gnus-article-mime :type '(choice (item :tag "first" :value nil) (item :tag "undisplayed" :value undisplayed) (item :tag "undisplayed or alternative" :value undisplayed-alternative) (function)))

(defcustom gnus-mime-action-alist '(("save to file" . gnus-mime-save-part) ("save and strip" . gnus-mime-save-part-and-strip) ("delete part" . gnus-mime-delete-part) ("display as text" . gnus-mime-inline-part) ("view the part" . gnus-mime-view-part) ("pipe to command" . gnus-mime-pipe-part) ("toggle display" . gnus-article-press-button) ("toggle display" . gnus-article-view-part-as-charset) ("view as type" . gnus-mime-view-part-as-type) ("view internally" . gnus-mime-view-part-internally) ("view externally" . gnus-mime-view-part-externally)) "\
An alist of actions that run on the MIME attachment." :group 'gnus-article-mime :type '(repeat (cons (string :tag "name") (function))))

(defcustom gnus-treat-highlight-signature '(or t (typep "text/x-vcard")) "\
Highlight the signature.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles'." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-buttonize 100000 "\
Add buttons.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles'." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-buttonize-head 'head "\
Add buttons to the head.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-emphasize (and (or window-system (featurep 'xemacs) (>= (string-to-number emacs-version) 21)) 50000) "\
Emphasize text.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-strip-cr nil "\
Remove carriage returns.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-unsplit-urls nil "\
Remove newlines from within URLs.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-leading-whitespace nil "\
Remove leading whitespace in headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-hide-headers 'head "\
Hide headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-hide-boring-headers nil "\
Hide boring headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-hide-signature nil "\
Hide the signature.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-fill-article nil "\
Fill the article.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-hide-citation nil "\
Hide cited text.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-hide-citation-maybe nil "\
Hide cited text.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-strip-list-identifiers 'head "\
Strip list identifiers from `gnus-list-identifiers`.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "21.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-strip-pem nil "\
Strip PEM signatures.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-strip-banner t "\
Strip banners from articles.
The banner to be stripped is specified in the `banner' group parameter.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-highlight-headers 'head "\
Highlight the headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-highlight-citation t "\
Highlight cited text.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-date-ut nil "\
Display the Date in UT (GMT).
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-date-local nil "\
Display the Date in the local timezone.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-date-english nil "\
Display the Date in a format that can be read aloud in English.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-date-lapsed nil "\
Display the Date header in a way that says how much time has elapsed.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-date-original nil "\
Display the date in the original timezone.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-date-iso8601 nil "\
Display the date in the ISO8601 format.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "21.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-date-user-defined nil "\
Display the date in a user-defined format.
The format is defined by the `gnus-article-time-format' variable.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-strip-headers-in-body t "\
Strip the X-No-Archive header line from the beginning of the body.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "21.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-strip-trailing-blank-lines nil "\
Strip trailing blank lines.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details.

When set to t, it also strips trailing blanks in all MIME parts.
Consider to use `last' instead." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-strip-leading-blank-lines nil "\
Strip leading blank lines.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details.

When set to t, it also strips trailing blanks in all MIME parts." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-strip-multiple-blank-lines nil "\
Strip multiple blank lines.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-unfold-headers 'head "\
Unfold folded header lines.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-fold-headers nil "\
Fold headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-fold-newsgroups 'head "\
Fold the Newsgroups and Followup-To headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-overstrike t "\
Treat overstrike highlighting.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-display-x-face (and (not noninteractive) (gnus-image-type-available-p 'xbm) (if (featurep 'xemacs) (featurep 'xface) (and (string-match "^0x" (shell-command-to-string "uncompface")) (executable-find "icontopbm"))) 'head) "\
Display X-Face headers.
Valid values are nil and `head'.
See Info node `(gnus)Customizing Articles' and Info node
`(gnus)X-Face' for details." :group 'gnus-article-treat :version "21.1" :link '(custom-manual "(gnus)Customizing Articles") :link '(custom-manual "(gnus)X-Face") :type gnus-article-treat-head-custom :set (lambda (symbol value) (set-default symbol (cond ((or (boundp symbol) (get symbol 'saved-value)) value) ((boundp 'gnus-treat-display-xface) (message "** gnus-treat-display-xface is an obsolete variable; use gnus-treat-display-x-face instead") (default-value 'gnus-treat-display-xface)) ((get 'gnus-treat-display-xface 'saved-value) (message "** gnus-treat-display-xface is an obsolete variable; use gnus-treat-display-x-face instead") (eval (car (get 'gnus-treat-display-xface 'saved-value)))) (t value)))))

(defcustom gnus-treat-display-face (and (not noninteractive) (gnus-image-type-available-p 'png) 'head) "\
Display Face headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' and Info node
`(gnus)X-Face' for details." :group 'gnus-article-treat :version "22.1" :link '(custom-manual "(gnus)Customizing Articles") :link '(custom-manual "(gnus)X-Face") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-display-smileys (gnus-image-type-available-p 'xpm) "\
Display smileys.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' and Info node
`(gnus)Smileys' for details." :group 'gnus-article-treat :version "21.1" :link '(custom-manual "(gnus)Customizing Articles") :link '(custom-manual "(gnus)Smileys") :type gnus-article-treat-custom)

(defcustom gnus-treat-from-picon (if (and (gnus-image-type-available-p 'xpm) (gnus-picons-installed-p)) 'head nil) "\
Display picons in the From header.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' and Info node
`(gnus)Picons' for details." :version "22.1" :group 'gnus-article-treat :group 'gnus-picon :link '(custom-manual "(gnus)Customizing Articles") :link '(custom-manual "(gnus)Picons") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-mail-picon (if (and (gnus-image-type-available-p 'xpm) (gnus-picons-installed-p)) 'head nil) "\
Display picons in To and Cc headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' and Info node
`(gnus)Picons' for details." :version "22.1" :group 'gnus-article-treat :group 'gnus-picon :link '(custom-manual "(gnus)Customizing Articles") :link '(custom-manual "(gnus)Picons") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-newsgroups-picon (if (and (gnus-image-type-available-p 'xpm) (gnus-picons-installed-p)) 'head nil) "\
Display picons in the Newsgroups and Followup-To headers.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' and Info node
`(gnus)Picons' for details." :version "22.1" :group 'gnus-article-treat :group 'gnus-picon :link '(custom-manual "(gnus)Customizing Articles") :link '(custom-manual "(gnus)Picons") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-body-boundary (if (or gnus-treat-newsgroups-picon gnus-treat-mail-picon gnus-treat-from-picon) 'head nil) "\
Draw a boundary at the end of the headers.
Valid values are nil and `head'.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-head-custom)

(defcustom gnus-treat-capitalize-sentences nil "\
Capitalize sentence-starting words.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "21.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-wash-html nil "\
Format as HTML.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-fill-long-lines nil "\
Fill long lines.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-play-sounds nil "\
Play sounds.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "21.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-translate nil "\
Translate articles from one language to another.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "21.1" :group 'gnus-article-treat :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-treat-x-pgp-sig nil "\
Verify X-PGP-Sig.
To automatically treat X-PGP-Sig, set it to head.
Valid values are nil, t, `head', `last', an integer or a predicate.
See Info node `(gnus)Customizing Articles' for details." :version "22.1" :group 'gnus-article-treat :group 'mime-security :link '(custom-manual "(gnus)Customizing Articles") :type gnus-article-treat-custom)

(defcustom gnus-article-encrypt-protocol "PGP" "\
The protocol used for encrypt articles.
It is a string, such as \"PGP\". If nil, ask user." :version "22.1" :type 'string :group 'mime-security)

(defcustom gnus-use-idna nil "\
Whether IDNA decoding of headers is used when viewing messages.
This requires GNU Libidn, and by default only enabled if it is found." :version "22.1" :group 'gnus-article-headers :type 'boolean)

(defcustom gnus-article-over-scroll nil "\
If non-nil, allow scrolling the article buffer even when there no more text." :version "22.1" :group 'gnus-article :type 'boolean)

(defcustom gnus-mime-display-multipart-as-mixed nil "\
Display \"multipart\" parts as  \"multipart/mixed\".

If t, it overrides nil values of
`gnus-mime-display-multipart-alternative-as-mixed' and
`gnus-mime-display-multipart-related-as-mixed'." :group 'gnus-article-mime :type 'boolean)

(defcustom gnus-mime-display-multipart-alternative-as-mixed nil "\
Display \"multipart/alternative\" parts as  \"multipart/mixed\"." :version "22.1" :group 'gnus-article-mime :type 'boolean)

(defcustom gnus-mime-display-multipart-related-as-mixed nil "\
Display \"multipart/related\" parts as  \"multipart/mixed\".

If displaying \"text/html\" is discouraged (see
`mm-discouraged-alternatives') images or other material inside a
\"multipart/related\" part might be overlooked when this variable is nil." :version "22.1" :group 'gnus-article-mime :type 'boolean)

(defcustom gnus-article-edit-mode-hook nil "\
Hook run in article edit mode buffers." :group 'gnus-article-various :type 'hook)

(defcustom gnus-button-url-regexp (if (string-match "[[:digit:]]" "1") "\\b\\(\\(www\\.\\|\\(s?https?\\|ftp\\|file\\|gopher\\|nntp\\|news\\|telnet\\|wais\\|mailto\\|info\\):\\)\\(//[-a-z0-9_.]+:[0-9]*\\)?[-a-z0-9_=!?#$@~%&*+\\/:;.,[:word:]]+[-a-z0-9_=#$@~%&*+\\/[:word:]]\\)" "\\b\\(\\(www\\.\\|\\(s?https?\\|ftp\\|file\\|gopher\\|nntp\\|news\\|telnet\\|wais\\|mailto\\|info\\):\\)\\(//[-a-z0-9_.]+:[0-9]*\\)?\\([-a-z0-9_=!?#$@~%&*+\\/:;.,]\\|\\w\\)+\\([-a-z0-9_=#$@~%&*+\\/]\\|\\w\\)\\)") "\
Regular expression that matches URLs." :group 'gnus-article-buttons :type 'regexp)

(defcustom gnus-button-valid-fqdn-regexp message-valid-fqdn-regexp "\
Regular expression that matches a valid FQDN." :version "22.1" :group 'gnus-article-buttons :type 'regexp)

(defcustom gnus-button-valid-localpart-regexp "[a-z0-9$%(*-=?[_][^<>\")!;:,{}\n	 @]*" "\
Regular expression that matches a localpart of mail addresses or MIDs." :version "22.1" :group 'gnus-article-buttons :type 'regexp)

(defcustom gnus-button-man-handler 'manual-entry "\
Function to use for displaying man pages.
The function must take at least one argument with a string naming the
man page." :version "22.1" :type '(choice (function-item :tag "Man" manual-entry) (function-item :tag "Woman" woman) (function :tag "Other")) :group 'gnus-article-buttons)

(defcustom gnus-ctan-url "http://tug.ctan.org/tex-archive/" "\
Top directory of a CTAN (Comprehensive TeX Archive Network) archive.
If the default site is too slow, try to find a CTAN mirror, see
<URL:http://tug.ctan.org/tex-archive/CTAN.sites?action=/index.html>.  See also
the variable `gnus-button-handle-ctan'." :version "22.1" :group 'gnus-article-buttons :link '(custom-manual "(gnus)Group Parameters") :type '(choice (const "http://www.tex.ac.uk/tex-archive/") (const "http://tug.ctan.org/tex-archive/") (const "http://www.dante.de/CTAN/") (string :tag "Other")))

(defcustom gnus-button-ctan-handler 'browse-url "\
Function to use for displaying CTAN links.
The function must take one argument, the string naming the URL." :version "22.1" :type '(choice (function-item :tag "Browse Url" browse-url) (function :tag "Other")) :group 'gnus-article-buttons)

(defcustom gnus-button-handle-ctan-bogus-regexp "^/?tex-archive/\\|^/" "\
Bogus strings removed from CTAN URLs." :version "22.1" :group 'gnus-article-buttons :type '(choice (const "^/?tex-archive/\\|/") (regexp :tag "Other")))

(defcustom gnus-button-ctan-directory-regexp (regexp-opt (list "archive-tools" "biblio" "bibliography" "digests" "documentation" "dviware" "fonts" "graphics" "help" "indexing" "info" "language" "languages" "macros" "nonfree" "obsolete" "support" "systems" "tds" "tools" "usergrps" "web") t) "\
Regular expression for ctan directories.
It should match all directories in the top level of `gnus-ctan-url'." :version "22.1" :group 'gnus-article-buttons :type 'regexp)

(defcustom gnus-button-mid-or-mail-regexp (concat "\\b\\(<?" gnus-button-valid-localpart-regexp "@" gnus-button-valid-fqdn-regexp ">?\\)\\b") "\
Regular expression that matches a message ID or a mail address." :version "22.1" :group 'gnus-article-buttons :type 'regexp)

(defcustom gnus-button-prefer-mid-or-mail 'gnus-button-mid-or-mail-heuristic "\
What to do when the button on a string as \"foo123@bar.invalid\" is pushed.
Strings like this can be either a message ID or a mail address.  If it is one
of the symbols `mid' or `mail', Gnus will always assume that the string is a
message ID or a mail address, respectively.  If this variable is set to the
symbol `ask', always query the user what do do.  If it is a function, this
function will be called with the string as its only argument.  The function
must return `mid', `mail', `invalid' or `ask'." :version "22.1" :group 'gnus-article-buttons :type '(choice (function-item :tag "Heuristic function" gnus-button-mid-or-mail-heuristic) (const ask) (const mid) (const mail)))

(defcustom gnus-button-mid-or-mail-heuristic-alist '((-10.0 . ".+\\$.+@") (-10.0 . "#") (-10.0 . "\\*") (-5.0 . "\\+[^+]*\\+.*@") (-5.0 . "@[Nn][Ee][Ww][Ss]") (-5.0 . "@.*[Dd][Ii][Aa][Ll][Uu][Pp]") (-1.0 . "^[^a-z]+@") (-5.0 . "\\.[0-9][0-9]+.*@") (-5.0 . "[a-z].*[A-Z].*[a-z].*[A-Z].*@") (-3.0 . "[A-Z][A-Z][a-z][a-z].*@") (-5.0 . "\\...?.?@") (-2.0 . "^[0-9]") (-1.0 . "^[0-9][0-9]") (-3.0 . "^[0-9][0-9a-fA-F][0-9a-fA-F][^0-9a-fA-F]") (-5.0 . "^[0-9][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][^0-9a-fA-F]") (-3.0 . "[0-9][0-9][0-9][0-9][0-9][^0-9].*@") (-3.0 . "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][^0-9].*@") (-3.0 . "[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9].*@") (25.0 . "-dated-[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]+.*@") (-20.0 . "\\.fsf@") (-20.0 . "^slrn") (-20.0 . "^Pine") (-20.0 . "_-_") (-20.0 . "\\.ln@") (-30.0 . "@ID-[0-9]+\\.[a-zA-Z]+\\.dfncis\\.de") (-30.0 . "@4[Aa][Xx]\\.com") (10.0 . "^[^0-9]+@") (3.0 . "^[^0-9]+[0-9][0-9]?[0-9]?@") (3.0 . "@stud") (2.0 . "[a-z][a-z][._-][A-Z][a-z].*@") (0.5 . "^[A-Z][a-z]") (0.5 . "^[A-Z][a-z][a-z]") (1.5 . "^[A-Z][a-z][A-Z][a-z][^a-z]") (2.0 . "^[A-Z][a-z][A-Z][a-z][a-z][^a-z]")) "\
An alist of (RATE . REGEXP) pairs for `gnus-button-mid-or-mail-heuristic'.

A negative RATE indicates a message IDs, whereas a positive indicates a mail
address.  The REGEXP is processed with `case-fold-search' set to nil." :version "22.1" :group 'gnus-article-buttons :type '(repeat (cons (number :tag "Rate") (regexp :tag "Regexp"))))

(defcustom gnus-button-tex-level 5 "\
*Integer that says how many TeX-related buttons Gnus will show.
The higher the number, the more buttons will appear and the more false
positives are possible.  Note that you can set this variable local to
specific groups.  Setting it higher in TeX groups is probably a good idea.
See Info node `(gnus)Group Parameters' and the variable `gnus-parameters' on
how to set variables in specific groups." :version "22.1" :group 'gnus-article-buttons :link '(custom-manual "(gnus)Group Parameters") :type 'integer)

(defcustom gnus-button-man-level 5 "\
*Integer that says how many man-related buttons Gnus will show.
The higher the number, the more buttons will appear and the more false
positives are possible.  Note that you can set this variable local to
specific groups.  Setting it higher in Unix groups is probably a good idea.
See Info node `(gnus)Group Parameters' and the variable `gnus-parameters' on
how to set variables in specific groups." :version "22.1" :group 'gnus-article-buttons :link '(custom-manual "(gnus)Group Parameters") :type 'integer)

(defcustom gnus-button-emacs-level 5 "\
*Integer that says how many emacs-related buttons Gnus will show.
The higher the number, the more buttons will appear and the more false
positives are possible.  Note that you can set this variable local to
specific groups.  Setting it higher in Emacs or Gnus related groups is
probably a good idea.  See Info node `(gnus)Group Parameters' and the variable
`gnus-parameters' on how to set variables in specific groups." :version "22.1" :group 'gnus-article-buttons :link '(custom-manual "(gnus)Group Parameters") :type 'integer)

(defcustom gnus-button-message-level 5 "\
*Integer that says how many buttons for news or mail messages will appear.
The higher the number, the more buttons will appear and the more false
positives are possible." :version "22.1" :group 'gnus-article-buttons :type 'integer)

(defcustom gnus-button-browse-level 5 "\
*Integer that says how many buttons for browsing will appear.
The higher the number, the more buttons will appear and the more false
positives are possible." :version "22.1" :group 'gnus-article-buttons :type 'integer)

(defcustom gnus-button-alist '(("<\\(url:[>\n	 ]*?\\)?\\(nntp\\|news\\):[>\n	 ]*\\([^>\n	 ]*@[^>\n	 ]*\\)>" 0 (>= gnus-button-message-level 0) gnus-button-handle-news 3) ((concat "\\b\\(nntp\\|news\\):\\(" gnus-button-valid-localpart-regexp "@[a-z0-9.-]+[a-z]\\)") 0 t gnus-button-handle-news 2) ("\\(\\b<\\(url:[>\n	 ]*\\)?\\(nntp\\|news\\):[>\n	 ]*\\(//\\)?\\([^>\n	 ]*\\)>\\)" 1 (>= gnus-button-message-level 0) gnus-button-fetch-group 5) ("\\b\\(nntp\\|news\\):\\(//\\)?\\([^'\">\n	 ]+\\)" 0 (>= gnus-button-message-level 0) gnus-button-fetch-group 3) ("\\bmid:\\(//\\)?\\([^'\">\n	 ]+@[^'\">\n	 /]+\\)" 0 (>= gnus-button-message-level 0) gnus-button-message-id 2) ("\\bin\\( +article\\| +message\\)? +\\(<\\([^\n @<>]+@[^\n @<>]+\\)>\\)" 2 (>= gnus-button-message-level 0) gnus-button-message-id 3) ("\\(<URL: *\\)mailto: *\\([^> \n	]+\\)>" 0 (>= gnus-button-message-level 0) gnus-url-mailto 2) ("\\bmailto:\\([-a-z.@_+0-9%=?&/]+\\)" 0 (>= gnus-button-message-level 0) gnus-url-mailto 1) ("\\bmailto:\\([^ \n	]+\\)" 0 (>= gnus-button-message-level 0) gnus-url-mailto 1) ((concat "\\bCTAN:[ 	\n]?[^>)!;:,'\n	 ]*\\(" gnus-button-ctan-directory-regexp "[^][>)!;:,'\n	 ]+\\)") 0 (>= gnus-button-tex-level 1) gnus-button-handle-ctan 1) ((concat "\\btex-archive/\\(" gnus-button-ctan-directory-regexp "/[-_.a-z0-9/]+[-_./a-z0-9]+[/a-z0-9]\\)") 1 (>= gnus-button-tex-level 6) gnus-button-handle-ctan 1) ((concat "\\b\\(" gnus-button-ctan-directory-regexp "/[-_.a-z0-9]+/[-_./a-z0-9]+[/a-z0-9]\\)") 1 (>= gnus-button-tex-level 8) gnus-button-handle-ctan 1) ("\\binfo://\\([^'\">\n	 ]+\\)" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-info-url 1) ("\\binfo:\\([^('\n	
 \"><][^'\n	
 \"><]*\\)" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-info-url-gnome 1) ("<\\(info:\\(([^)]+)[^>\n
]*\\)\\)>" 1 (>= gnus-button-emacs-level 1) gnus-button-handle-info-url-kde 2) ("\\((Info-goto-node\\|(info\\)[ 	\n]*\\(\"[^\"]*\"\\))" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-info-url 2) ("\\b\\(C-h\\|<?[Ff]1>?\\)[ 	\n]+i[ 	\n]+d?[ 	\n]?m[ 	\n]+\\([^ ]+ ?[^ ]+\\)[ 	\n]+RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-info-keystrokes 2) ("\\bcustom:\\(//\\)?\\([^'\">\n	 ]+\\)" 0 (>= gnus-button-emacs-level 5) gnus-button-handle-custom 2) ("M-x[ 	\n]customize-[^ ]+[ 	\n]RET[ 	\n]\\([^ ]+\\)[ 	\n]RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-custom 1) ("M-x[ 	\n]+apropos[ 	\n]+RET[ 	\n]+\\([^ 	\n]+\\)[ 	\n]+RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-apropos 1) ("M-x[ 	\n]+apropos-command[ 	\n]+RET[ 	\n]+\\([^ 	\n]+\\)[ 	\n]+RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-apropos-command 1) ("M-x[ 	\n]+apropos-variable[ 	\n]+RET[ 	\n]+\\([^ 	\n]+\\)[ 	\n]+RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-apropos-variable 1) ("M-x[ 	\n]+apropos-documentation[ 	\n]+RET[ 	\n]+\\([^ 	\n]+\\)[ 	\n]+RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-apropos-documentation 1) ("/\\([a-z][-a-z0-9]+\\.el\\)\\>[^.?]" 1 (>= gnus-button-emacs-level 8) gnus-button-handle-library 1) ("`\\([a-z][-a-z0-9]+\\.el\\)'" 1 (>= gnus-button-emacs-level 8) gnus-button-handle-library 1) ("`\\([a-z][a-z0-9]+-[a-z]+-[-a-z]+\\|\\(gnus\\|message\\)-[-a-z]+\\)'" 0 (>= gnus-button-emacs-level 8) gnus-button-handle-symbol 1) ("`\\([a-z][a-z0-9]+-[a-z]+\\)'" 0 (>= gnus-button-emacs-level 9) gnus-button-handle-symbol 1) ("(setq[ 	\n]+\\([a-z][a-z0-9]+-[-a-z0-9]+\\)[ 	\n]+.+)" 1 (>= gnus-button-emacs-level 7) gnus-button-handle-describe-variable 1) ("\\bM-x[ 	\n]+\\([^ 	\n]+\\)[ 	\n]+RET" 1 (>= gnus-button-emacs-level 7) gnus-button-handle-describe-function 1) ("\\b\\(C-h\\|<?[Ff]1>?\\)[ 	\n]+f[ 	\n]+\\([^ 	\n]+\\)[ 	\n]+RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-describe-function 2) ("\\b\\(C-h\\|<?[Ff]1>?\\)[ 	\n]+v[ 	\n]+\\([^ 	\n]+\\)[ 	\n]+RET" 0 (>= gnus-button-emacs-level 1) gnus-button-handle-describe-variable 2) ("`\\(\\(C-h\\|<?[Ff]1>?\\)[ 	\n]+k[ 	\n]+\\([^']+\\)\\)'" 1 (>= gnus-button-emacs-level 1) gnus-button-handle-describe-key 3) ("<URL: *\\([^<>]*\\)>" 1 (>= gnus-button-browse-level 0) gnus-button-embedded-url 1) ("\"URL: *\\([^\"]*\\)\"" 1 (>= gnus-button-browse-level 0) gnus-button-embedded-url 1) ("\"URL: *\\([^\"]*\\)\"" 1 (>= gnus-button-browse-level 0) gnus-button-embedded-url 1) (gnus-button-url-regexp 0 (>= gnus-button-browse-level 0) browse-url 0) ("\\b\\([a-z][a-z]+([1-9])\\)\\W" 0 (and (>= gnus-button-man-level 1) (< gnus-button-man-level 3)) gnus-button-handle-man 1) ("\\b\\([a-z][-_.a-z0-9]+([1-9])\\)\\W" 0 (and (>= gnus-button-man-level 3) (< gnus-button-man-level 5)) gnus-button-handle-man 1) ("\\b\\(\\(?:[a-z][-+_.:a-z0-9]+([1-9][X1a-z]*)\\)\\|\\b\\(?:X([1-9])\\)\\)\\W" 0 (>= gnus-button-man-level 5) gnus-button-handle-man 1) (gnus-button-mid-or-mail-regexp 0 (>= gnus-button-message-level 5) gnus-button-handle-mid-or-mail 1)) "\
*Alist of regexps matching buttons in article bodies.

Each entry has the form (REGEXP BUTTON FORM CALLBACK PAR...), where
REGEXP: is the string (case insensitive) matching text around the button (can
also be Lisp expression evaluating to a string),
BUTTON: is the number of the regexp grouping actually matching the button,
FORM: is a Lisp expression which must eval to true for the button to
be added,
CALLBACK: is the function to call when the user push this button, and each
PAR: is a number of a regexp grouping whose text will be passed to CALLBACK.

CALLBACK can also be a variable, in that case the value of that
variable it the real callback function." :group 'gnus-article-buttons :type '(repeat (list (choice regexp variable sexp) (integer :tag "Button") (sexp :tag "Form") (function :tag "Callback") (repeat :tag "Par" :inline t (integer :tag "Regexp group")))))

(defcustom gnus-header-button-alist '(("^\\(References\\|Message-I[Dd]\\|^In-Reply-To\\):" "<[^<>]+>" 0 (>= gnus-button-message-level 0) gnus-button-message-id 0) ("^\\(From\\|Reply-To\\):" ": *\\(.+\\)$" 1 (>= gnus-button-message-level 0) gnus-button-reply 1) ("^\\(Cc\\|To\\):" "[^ 	\n<>,()\"]+@[^ 	\n<>,()\"]+" 0 (>= gnus-button-message-level 0) gnus-msg-mail 0) ("^X-[Uu][Rr][Ll]:" gnus-button-url-regexp 0 (>= gnus-button-browse-level 0) browse-url 0) ("^Subject:" gnus-button-url-regexp 0 (>= gnus-button-browse-level 0) browse-url 0) ("^[^:]+:" gnus-button-url-regexp 0 (>= gnus-button-browse-level 0) browse-url 0) ("^[^:]+:" "\\bmailto:\\([-a-z.@_+0-9%=?&/]+\\)" 0 (>= gnus-button-message-level 0) gnus-url-mailto 1) ("^[^:]+:" "\\(<\\(url: \\)?\\(nntp\\|news\\):\\([^>\n ]*\\)>\\)" 1 (>= gnus-button-message-level 0) gnus-button-message-id 4)) "\
*Alist of headers and regexps to match buttons in article heads.

This alist is very similar to `gnus-button-alist', except that each
alist has an additional HEADER element first in each entry:

\(HEADER REGEXP BUTTON FORM CALLBACK PAR)

HEADER is a regexp to match a header.  For a fuller explanation, see
`gnus-button-alist'." :group 'gnus-article-buttons :group 'gnus-article-headers :type '(repeat (list (regexp :tag "Header") (choice regexp variable) (integer :tag "Button") (sexp :tag "Form") (function :tag "Callback") (repeat :tag "Par" :inline t (integer :tag "Regexp group")))))

;;;***

;;;### (autoloads (gnus-async-prefetch-article-p gnus-use-header-prefetch gnus-prefetched-article-deletion-strategy gnus-asynchronous gnus-use-article-prefetch gnus-asynchronous) "gnus-async" "lisp/gnus-async.el")
(defconst custom-define-current-source-file "gnus-async.el")

(defgroup gnus-asynchronous nil "Support for asynchronous operations." :group 'gnus)

(defcustom gnus-use-article-prefetch 30 "\
*If non-nil, prefetch articles in groups that allow this.
If a number, prefetch only that many articles forward;
if t, prefetch as many articles as possible." :group 'gnus-asynchronous :type '(choice (const :tag "off" nil) (const :tag "all" t) (integer :tag "some" 0)))

(defcustom gnus-asynchronous nil "\
*If nil, inhibit all Gnus asynchronicity.
If non-nil, let the other asynch variables be heeded." :group 'gnus-asynchronous :type 'boolean)

(defcustom gnus-prefetched-article-deletion-strategy '(read exit) "\
List of symbols that say when to remove articles from the prefetch buffer.
Possible values in this list are `read', which means that
articles are removed as they are read, and `exit', which means
that all articles belonging to a group are removed on exit
from that group." :group 'gnus-asynchronous :type '(set (const read) (const exit)))

(defcustom gnus-use-header-prefetch nil "\
*If non-nil, prefetch the headers to the next group." :group 'gnus-asynchronous :type 'boolean)

(defcustom gnus-async-prefetch-article-p 'gnus-async-unread-p "\
Function called to say whether an article should be prefetched or not.
The function is called with one parameter -- the article data.
It should return non-nil if the article is to be prefetched." :group 'gnus-asynchronous :type 'function)

;;;***

;;;### (autoloads (gnus-audio-wav-player gnus-audio-au-player gnus-audio-directory gnus-audio) "gnus-audio" "lisp/gnus-audio.el")
(defconst custom-define-current-source-file "gnus-audio.el")

(defgroup gnus-audio nil "Playing sound in Gnus." :version "21.1" :group 'gnus-visual :group 'multimedia)

(defcustom gnus-audio-directory (nnheader-find-etc-directory "sounds") "\
The directory containing the Sound Files." :type '(choice directory (const nil)) :group 'gnus-audio)

(defcustom gnus-audio-au-player (executable-find "play") "\
Executable program for playing sun AU format sound files." :group 'gnus-audio :type '(choice file (const nil)))

(defcustom gnus-audio-wav-player (executable-find "play") "\
Executable program for playing WAV files." :group 'gnus-audio :type '(choice file (const nil)))

;;;***

;;;### (autoloads (gnus-uncacheable-groups gnus-cacheable-groups gnus-cache-remove-articles gnus-cache-enter-articles gnus-cache-active-file) "gnus-cache" "lisp/gnus-cache.el")
(defconst custom-define-current-source-file "gnus-cache.el")

(defcustom gnus-cache-active-file (expand-file-name "active" gnus-cache-directory) "\
*The cache active file." :group 'gnus-cache :type 'file)

(defcustom gnus-cache-enter-articles '(ticked dormant) "\
Classes of articles to enter into the cache." :group 'gnus-cache :type '(set (const ticked) (const dormant) (const unread) (const read)))

(defcustom gnus-cache-remove-articles '(read) "\
Classes of articles to remove from the cache." :group 'gnus-cache :type '(set (const ticked) (const dormant) (const unread) (const read)))

(defcustom gnus-cacheable-groups nil "\
*Groups that match this regexp will be cached.

If you only want to cache your nntp groups, you could set this
variable to \"^nntp\".

If a group matches both gnus-cacheable-groups and gnus-uncacheable-groups
it's not cached." :group 'gnus-cache :type '(choice (const :tag "off" nil) regexp))

(defcustom gnus-uncacheable-groups nil "\
*Groups that match this regexp will not be cached.

If you want to avoid caching your nnml groups, you could set this
variable to \"^nnml\".

If a group matches both gnus-cacheable-groups and gnus-uncacheable-groups
it's not cached." :group 'gnus-cache :type '(choice (const :tag "off" nil) regexp))

;;;***

;;;### (autoloads (gnus-article-boring-faces gnus-cite-blank-line-after-header gnus-cite-hide-absolute gnus-cite-hide-percentage gnus-cite-face-list gnus-cite-attribution-face gnus-cite-ignore-quoted-from gnus-cite-unsightly-citation-regexp gnus-cite-attribution-suffix gnus-cite-attribution-prefix gnus-cite-minimum-match-count gnus-supercite-secondary-regexp gnus-supercite-regexp gnus-cite-max-prefix gnus-cite-parse-max-size gnus-cited-lines-visible gnus-cited-closed-text-button-line-format gnus-cited-opened-text-button-line-format gnus-cite) "gnus-cite" "lisp/gnus-cite.el")
(defconst custom-define-current-source-file "gnus-cite.el")

(defgroup gnus-cite nil "Citation." :prefix "gnus-cite-" :link '(custom-manual "(gnus)Article Highlighting") :group 'gnus-article)

(defcustom gnus-cited-opened-text-button-line-format "%(%{[-]%}%)\n" "\
Format of opened cited text buttons." :group 'gnus-cite :type 'string)

(defcustom gnus-cited-closed-text-button-line-format "%(%{[+]%}%)\n" "\
Format of closed cited text buttons." :group 'gnus-cite :type 'string)

(defcustom gnus-cited-lines-visible nil "\
The number of lines of hidden cited text to remain visible.
Or a pair (cons) of numbers which are the number of lines at the top
and bottom of the text, respectively, to remain visible." :group 'gnus-cite :type '(choice (const :tag "none" nil) integer (cons :tag "Top and Bottom" integer integer)))

(defcustom gnus-cite-parse-max-size 25000 "\
Maximum article size (in bytes) where parsing citations is allowed.
Set it to nil to parse all articles." :group 'gnus-cite :type '(choice (const :tag "all" nil) integer))

(defcustom gnus-cite-max-prefix 20 "\
Maximum possible length for a citation prefix." :group 'gnus-cite :type 'integer)

(defcustom gnus-supercite-regexp (concat "^\\(" message-cite-prefix-regexp "\\)? *" ">>>>> +\"\\([^\"\n]+\\)\" +==") "\
*Regexp matching normal Supercite attribution lines.
The first grouping must match prefixes added by other packages." :group 'gnus-cite :type 'regexp)

(defcustom gnus-supercite-secondary-regexp "^.*\"\\([^\"\n]+\\)\" +==" "\
Regexp matching mangled Supercite attribution lines.
The first regexp group should match the Supercite attribution." :group 'gnus-cite :type 'regexp)

(defcustom gnus-cite-minimum-match-count 2 "\
Minimum number of identical prefixes before we believe it's a citation." :group 'gnus-cite :type 'integer)

(defcustom gnus-cite-attribution-prefix "In article\\|in <\\|On \\(Mon\\|Tue\\|Wed\\|Thu\\|Fri\\|Sat\\|Sun\\),\\|----- ?Original Message ?-----" "\
*Regexp matching the beginning of an attribution line." :group 'gnus-cite :type 'regexp)

(defcustom gnus-cite-attribution-suffix "\\(\\(wrote\\|writes\\|said\\|says\\|>\\)\\(:\\|\\.\\.\\.\\)\\|----- ?Original Message ?-----\\)[ 	]*$" "\
*Regexp matching the end of an attribution line.
The text matching the first grouping will be used as a button." :group 'gnus-cite :type 'regexp)

(defcustom gnus-cite-unsightly-citation-regexp "^-----Original Message-----\nFrom: \\(.+\n\\)+\n" "\
Regexp matching Microsoft-type rest-of-message citations." :version "22.1" :group 'gnus-cite :type 'regexp)

(defcustom gnus-cite-ignore-quoted-from t "\
Non-nil means don't regard lines beginning with \">From \" as cited text.
Those lines may have been quoted by MTAs in order not to mix up with
the envelope From line." :version "22.1" :group 'gnus-cite :type 'boolean)

(defcustom gnus-cite-attribution-face 'gnus-cite-attribution "\
Face used for attribution lines.
It is merged with the face for the cited text belonging to the attribution." :version "22.1" :group 'gnus-cite :type 'face)

(defcustom gnus-cite-face-list '(gnus-cite-1 gnus-cite-2 gnus-cite-3 gnus-cite-4 gnus-cite-5 gnus-cite-6 gnus-cite-7 gnus-cite-8 gnus-cite-9 gnus-cite-10 gnus-cite-11) "\
*List of faces used for highlighting citations.

When there are citations from multiple articles in the same message,
Gnus will try to give each citation from each article its own face.
This should make it easier to see who wrote what." :group 'gnus-cite :type '(repeat face))

(defcustom gnus-cite-hide-percentage 50 "\
Only hide excess citation if above this percentage of the body." :group 'gnus-cite :type 'number)

(defcustom gnus-cite-hide-absolute 10 "\
Only hide excess citation if above this number of lines in the body." :group 'gnus-cite :type 'integer)

(defcustom gnus-cite-blank-line-after-header t "\
If non-nil, put a blank line between the citation header and the button." :group 'gnus-cite :type 'boolean)

(defcustom gnus-article-boring-faces (cons 'gnus-signature gnus-cite-face-list) "\
List of faces that are not worth reading.
If an article has more pages below the one you are looking at, but
nothing on those pages is a word of at least three letters that is not
in a boring face, then the pages will be skipped." :type '(repeat face) :group 'gnus-article-hiding)

;;;***

;;;### (autoloads (gnus-delay-default-hour gnus-delay-default-delay gnus-delay-header gnus-delay-group gnus-delay) "gnus-delay" "lisp/gnus-delay.el")
(defconst custom-define-current-source-file "gnus-delay.el")

(defgroup gnus-delay nil "Arrange for sending postings later." :version "22.1" :group 'gnus)

(defcustom gnus-delay-group "delayed" "\
Group name for storing delayed articles." :type 'string :group 'gnus-delay)

(defcustom gnus-delay-header "X-Gnus-Delayed" "\
Header name for storing info about delayed articles." :type 'string :group 'gnus-delay)

(defcustom gnus-delay-default-delay "3d" "\
*Default length of delay." :type 'string :group 'gnus-delay)

(defcustom gnus-delay-default-hour 8 "\
*If deadline is given as date, then assume this time of day." :version "22.1" :type 'integer :group 'gnus-delay)

;;;***

;;;### (autoloads (gnus-demon-timestep gnus-demon-handlers gnus-demon) "gnus-demon" "lisp/gnus-demon.el")
(defconst custom-define-current-source-file "gnus-demon.el")

(defgroup gnus-demon nil "Demonic behavior." :group 'gnus)

(defcustom gnus-demon-handlers nil "\
Alist of daemonic handlers to be run at intervals.
Each handler is a list on the form

\(FUNCTION TIME IDLE)

FUNCTION is the function to be called.
TIME is the number of `gnus-demon-timestep's between each call.
If nil, never call.  If t, call each `gnus-demon-timestep'.
If IDLE is t, only call if Emacs has been idle for a while.  If IDLE
is a number, only call when Emacs has been idle more than this number
of `gnus-demon-timestep's.  If IDLE is nil, don't care about
idleness.  If IDLE is a number and TIME is nil, then call once each
time Emacs has been idle for IDLE `gnus-demon-timestep's." :group 'gnus-demon :type '(repeat (list function (choice :tag "Time" (const :tag "never" nil) (const :tag "one" t) (integer :tag "steps" 1)) (choice :tag "Idle" (const :tag "don't care" nil) (const :tag "for a while" t) (integer :tag "steps" 1)))))

(defcustom gnus-demon-timestep 60 "\
*Number of seconds in each demon timestep." :group 'gnus-demon :type 'integer)

;;;***

;;;### (autoloads (gnus-diary-delay-format-function gnus-diary-time-format gnus-diary-summary-line-format gnus-diary) "gnus-diary" "lisp/gnus-diary.el")
(defconst custom-define-current-source-file "gnus-diary.el")

(defgroup gnus-diary nil "Utilities on top of the nndiary back end for Gnus." :version "22.1" :group 'gnus)

(defcustom gnus-diary-summary-line-format "%U%R%z %uD: %(%s%) (%ud)\n" "\
*Summary line format for nndiary groups." :type 'string :group 'gnus-diary :group 'gnus-summary-format)

(defcustom gnus-diary-time-format "%a, %b %e %y, %H:%M" "\
*Time format to display appointments in nndiary summary buffers.
Please refer to `format-time-string' for information on possible values." :type 'string :group 'gnus-diary)

(defcustom gnus-diary-delay-format-function 'gnus-diary-delay-format-english "\
*Function called to format a diary delay string.
It is passed two arguments.  The first one is non-nil if the delay is in
the past.  The second one is of the form ((NUM . UNIT) ...) where NUM is
an integer and UNIT is one of 'year 'month 'week 'day 'hour or 'minute.
It should return strings like \"In 2 months, 3 weeks\", \"3 hours,
1 minute ago\" and so on.

There are currently two built-in format functions:
`gnus-diary-delay-format-english' (the default)
`gnus-diary-delay-format-french'" :type '(choice (const :tag "english" gnus-diary-delay-format-english) (const :tag "french" gnus-diary-delay-format-french) (symbol :tag "other")) :group 'gnus-diary)

;;;***

;;;### (autoloads (gnus-duplicate-file gnus-duplicate-list-length gnus-save-duplicate-list gnus-duplicate) "gnus-dup" "lisp/gnus-dup.el")
(defconst custom-define-current-source-file "gnus-dup.el")

(defgroup gnus-duplicate nil "Suppression of duplicate articles." :group 'gnus)

(defcustom gnus-save-duplicate-list nil "\
*If non-nil, save the duplicate list when shutting down Gnus.
If nil, duplicate suppression will only work on duplicates
seen in the same session." :group 'gnus-duplicate :type 'boolean)

(defcustom gnus-duplicate-list-length 10000 "\
*The number of Message-IDs to keep in the duplicate suppression list." :group 'gnus-duplicate :type 'integer)

(defcustom gnus-duplicate-file (nnheader-concat gnus-directory "suppression") "\
*The name of the file to store the duplicate suppression list." :group 'gnus-duplicate :type 'file)

;;;***

;;;### (autoloads (gnus-edit-form-menu-hook gnus-edit-form-mode-hook gnus-edit-form) "gnus-eform" "lisp/gnus-eform.el")
(defconst custom-define-current-source-file "gnus-eform.el")

(defgroup gnus-edit-form nil "A mode for editing forms." :group 'gnus)

(defcustom gnus-edit-form-mode-hook nil "\
Hook run in `gnus-edit-form-mode' buffers." :group 'gnus-edit-form :type 'hook)

(defcustom gnus-edit-form-menu-hook nil "\
Hook run when creating menus in `gnus-edit-form-mode' buffers." :group 'gnus-edit-form :type 'hook)

;;;***

;;;### (autoloads (gnus-convert-image-to-face-command gnus-convert-image-to-x-face-command gnus-convert-pbm-to-x-face-command gnus-x-face-directory) "gnus-fun" "lisp/gnus-fun.el")
(defconst custom-define-current-source-file "gnus-fun.el")

(defcustom gnus-x-face-directory (expand-file-name "x-faces" gnus-directory) "\
*Directory where X-Face PBM files are stored." :version "22.1" :group 'gnus-fun :type 'directory)

(defcustom gnus-convert-pbm-to-x-face-command "pbmtoxbm %s | compface" "\
Command for converting a PBM to an X-Face." :version "22.1" :group 'gnus-fun :type 'string)

(defcustom gnus-convert-image-to-x-face-command "giftopnm %s | ppmnorm | pnmscale -width 48 -height 48 | ppmtopgm | pgmtopbm | pbmtoxbm | compface" "\
Command for converting an image to an X-Face.
By default it takes a GIF filename and output the X-Face header data
on stdout." :version "22.1" :group 'gnus-fun :type 'string)

(defcustom gnus-convert-image-to-face-command "djpeg %s | ppmnorm | pnmscale -width 48 -height 48 | ppmquant %d | pnmtopng" "\
Command for converting an image to a Face.
By default it takes a JPEG filename and output the Face header data
on stdout." :version "22.1" :group 'gnus-fun :type 'string)

;;;***

;;;### (autoloads (gnus-fetch-old-ephemeral-headers gnus-large-ephemeral-newsgroup gnus-group-update-tool-bar gnus-group-tool-bar-zap-list gnus-group-tool-bar-retro gnus-group-tool-bar-gnome gnus-group-tool-bar gnus-group-jump-to-group-prompt gnus-group-name-charset-group-alist gnus-group-name-charset-method-alist gnus-group-icon-list gnus-group-icons gnus-new-mail-mark gnus-group-highlight gnus-useful-groups gnus-group-update-hook gnus-after-exiting-gnus-hook gnus-exit-gnus-hook gnus-suspend-gnus-hook gnus-group-prepare-hook gnus-group-prepare-function gnus-group-update-group-hook gnus-group-catchup-group-hook gnus-group-menu-hook gnus-group-mode-line-format gnus-group-line-format gnus-group-sort-function gnus-group-list-inactive-groups gnus-group-default-list-level gnus-list-groups-with-ticked-articles gnus-permanently-visible-groups gnus-goto-next-group-when-activating gnus-group-goto-unread gnus-keep-same-level gnus-no-groups-message gnus-group-recent-archive-directory gnus-group-archive-directory) "gnus-group" "lisp/gnus-group.el")
(defconst custom-define-current-source-file "gnus-group.el")

(defcustom gnus-group-archive-directory "/ftp@ftp.hpc.uh.edu:/pub/emacs/ding-list/" "\
*The address of the (ding) archives." :group 'gnus-group-foreign :type 'directory)

(defcustom gnus-group-recent-archive-directory "/ftp@ftp.hpc.uh.edu:/pub/emacs/ding-list-recent/" "\
*The address of the most recent (ding) articles." :group 'gnus-group-foreign :type 'directory)

(defcustom gnus-no-groups-message "No gnus is bad news" "\
*Message displayed by Gnus when no groups are available." :group 'gnus-start :type 'string)

(defcustom gnus-keep-same-level nil "\
*Non-nil means that the next newsgroup after the current will be on the same level.
When you type, for instance, `n' after reading the last article in the
current newsgroup, you will go to the next newsgroup.  If this variable
is nil, the next newsgroup will be the next from the group
buffer.
If this variable is non-nil, Gnus will either put you in the
next newsgroup with the same level, or, if no such newsgroup is
available, the next newsgroup with the lowest possible level higher
than the current level.
If this variable is `best', Gnus will make the next newsgroup the one
with the best level." :group 'gnus-group-levels :type '(choice (const nil) (const best) (sexp :tag "other" t)))

(defcustom gnus-group-goto-unread t "\
*If non-nil, movement commands will go to the next unread and subscribed group." :link '(custom-manual "(gnus)Group Maneuvering") :group 'gnus-group-various :type 'boolean)

(defcustom gnus-goto-next-group-when-activating t "\
*If non-nil, the \\<gnus-group-mode-map>\\[gnus-group-get-new-news-this-group] command will advance point to the next group." :link '(custom-manual "(gnus)Scanning New Messages") :group 'gnus-group-various :type 'boolean)

(defcustom gnus-permanently-visible-groups nil "\
*Regexp to match groups that should always be listed in the group buffer.
This means that they will still be listed even when there are no
unread articles in the groups.

If nil, no groups are permanently visible." :group 'gnus-group-listing :type '(choice regexp (const nil)))

(defcustom gnus-list-groups-with-ticked-articles t "\
*If non-nil, list groups that have only ticked articles.
If nil, only list groups that have unread articles." :group 'gnus-group-listing :type 'boolean)

(defcustom gnus-group-default-list-level gnus-level-subscribed "\
*Default listing level.
Ignored if `gnus-group-use-permanent-levels' is non-nil." :group 'gnus-group-listing :type 'integer)

(defcustom gnus-group-list-inactive-groups t "\
*If non-nil, inactive groups will be listed." :group 'gnus-group-listing :group 'gnus-group-levels :type 'boolean)

(defcustom gnus-group-sort-function 'gnus-group-sort-by-alphabet "\
*Function used for sorting the group buffer.
This function will be called with group info entries as the arguments
for the groups to be sorted.  Pre-made functions include
`gnus-group-sort-by-alphabet', `gnus-group-sort-by-real-name',
`gnus-group-sort-by-unread', `gnus-group-sort-by-level',
`gnus-group-sort-by-score', `gnus-group-sort-by-method',
`gnus-group-sort-by-server', and `gnus-group-sort-by-rank'.

This variable can also be a list of sorting functions.  In that case,
the most significant sort function should be the last function in the
list." :group 'gnus-group-listing :link '(custom-manual "(gnus)Sorting Groups") :type '(repeat :value-to-internal (lambda (widget value) (if (listp value) value (list value))) :match (lambda (widget value) (or (symbolp value) (widget-editable-list-match widget value))) (choice (function-item gnus-group-sort-by-alphabet) (function-item gnus-group-sort-by-real-name) (function-item gnus-group-sort-by-unread) (function-item gnus-group-sort-by-level) (function-item gnus-group-sort-by-score) (function-item gnus-group-sort-by-method) (function-item gnus-group-sort-by-server) (function-item gnus-group-sort-by-rank) (function :tag "other" nil))))

(defcustom gnus-group-line-format "%M%S%p%P%5y:%B%(%g%)%l %O\n" "\
*Format of group lines.
It works along the same lines as a normal formatting string,
with some simple extensions.

%M    Only marked articles (character, \"*\" or \" \")
%S    Whether the group is subscribed (character, \"U\", \"K\", \"Z\" or \" \")
%L    Level of subscribedness (integer)
%N    Number of unread articles (integer)
%I    Number of dormant articles (integer)
%i    Number of ticked and dormant (integer)
%T    Number of ticked articles (integer)
%R    Number of read articles (integer)
%U    Number of unseen articles (integer)
%t    Estimated total number of articles (integer)
%y    Number of unread, unticked articles (integer)
%G    Group name (string)
%g    Qualified group name (string)
%c    Short (collapsed) group name.  See `gnus-group-uncollapsed-levels'.
%C    Group comment (string)
%D    Group description (string)
%s    Select method (string)
%o    Moderated group (char, \"m\")
%p    Process mark (char)
%B    Whether a summary buffer for the group is open (char, \"*\")
%O    Moderated group (string, \"(m)\" or \"\")
%P    Topic indentation (string)
%m    Whether there is new(ish) mail in the group (char, \"%\")
%l    Whether there are GroupLens predictions for this group (string)
%n    Select from where (string)
%z    A string that look like `<%s:%n>' if a foreign select method is used
%d    The date the group was last entered.
%E    Icon as defined by `gnus-group-icon-list'.
%u    User defined specifier.  The next character in the format string should
      be a letter.  Gnus will call the function gnus-user-format-function-X,
      where X is the letter following %u.  The function will be passed a
      single dummy parameter as argument.  The function should return a
      string, which will be inserted into the buffer just like information
      from any other group specifier.

Note that this format specification is not always respected.  For
reasons of efficiency, when listing killed groups, this specification
is ignored altogether.  If the spec is changed considerably, your
output may end up looking strange when listing both alive and killed
groups.

If you use %o or %O, reading the active file will be slower and quite
a bit of extra memory will be used.  %D will also worsen performance.
Also note that if you change the format specification to include any
of these specs, you must probably re-start Gnus to see them go into
effect.

General format specifiers can also be used.
See Info node `(gnus)Formatting Variables'." :link '(custom-manual "(gnus)Formatting Variables") :group 'gnus-group-visual :type 'string)

(defcustom gnus-group-mode-line-format "Gnus: %%b {%M%:%S}" "\
*The format specification for the group mode line.
It works along the same lines as a normal formatting string,
with some simple extensions:

%S   The native news server.
%M   The native select method.
%:   \":\" if %S isn't \"\"." :group 'gnus-group-visual :type 'string)

(defcustom gnus-group-menu-hook nil "\
Hook run after the creation of the group mode menu." :group 'gnus-group-various :type 'hook)

(defcustom gnus-group-catchup-group-hook nil "\
Hook run when catching up a group from the group buffer." :group 'gnus-group-various :link '(custom-manual "(gnus)Group Data") :type 'hook)

(defcustom gnus-group-update-group-hook nil "\
Hook called when updating group lines." :group 'gnus-group-visual :type 'hook)

(defcustom gnus-group-prepare-function 'gnus-group-prepare-flat "\
*A function that is called to generate the group buffer.
The function is called with three arguments: The first is a number;
all group with a level less or equal to that number should be listed,
if the second is non-nil, empty groups should also be displayed.  If
the third is non-nil, it is a number.  No groups with a level lower
than this number should be displayed.

The only current function implemented is `gnus-group-prepare-flat'." :group 'gnus-group-listing :type 'function)

(defcustom gnus-group-prepare-hook nil "\
Hook called after the group buffer has been generated.
If you want to modify the group buffer, you can use this hook." :group 'gnus-group-listing :type 'hook)

(defcustom gnus-suspend-gnus-hook nil "\
Hook called when suspending (not exiting) Gnus." :group 'gnus-exit :type 'hook)

(defcustom gnus-exit-gnus-hook nil "\
Hook called when exiting Gnus." :group 'gnus-exit :type 'hook)

(defcustom gnus-after-exiting-gnus-hook nil "\
Hook called after exiting Gnus." :group 'gnus-exit :type 'hook)

(defcustom gnus-group-update-hook '(gnus-group-highlight-line) "\
Hook called when a group line is changed.
The hook will not be called if `gnus-visual' is nil.

The default function `gnus-group-highlight-line' will
highlight the line according to the `gnus-group-highlight'
variable." :group 'gnus-group-visual :type 'hook)

(defcustom gnus-useful-groups '(("(ding) mailing list mirrored at gmane.org" "gmane.emacs.gnus.general" (nntp "Gmane" (nntp-address "news.gmane.org"))) ("Gnus bug archive" "gnus.gnus-bug" (nntp "news.gnus.org" (nntp-address "news.gnus.org"))) ("Local Gnus help group" "gnus-help" (nndoc "gnus-help" (nndoc-article-type mbox) (eval (backquote (nndoc-address (\, (let ((file (nnheader-find-etc-directory "gnus-tut.txt" t))) (unless file (error "Couldn't find doc group")) file)))))))) "\
*Alist of useful group-server pairs." :group 'gnus-group-listing :type '(repeat (list (string :tag "Description") (string :tag "Name") (sexp :tag "Method"))))

(defcustom gnus-group-highlight '(((and mailp (= unread 0) (eq level 1)) . gnus-group-mail-1-empty) ((and mailp (eq level 1)) . gnus-group-mail-1) ((and mailp (= unread 0) (eq level 2)) . gnus-group-mail-2-empty) ((and mailp (eq level 2)) . gnus-group-mail-2) ((and mailp (= unread 0) (eq level 3)) . gnus-group-mail-3-empty) ((and mailp (eq level 3)) . gnus-group-mail-3) ((and mailp (= unread 0)) . gnus-group-mail-low-empty) ((and mailp) . gnus-group-mail-low) ((and (= unread 0) (eq level 1)) . gnus-group-news-1-empty) ((and (eq level 1)) . gnus-group-news-1) ((and (= unread 0) (eq level 2)) . gnus-group-news-2-empty) ((and (eq level 2)) . gnus-group-news-2) ((and (= unread 0) (eq level 3)) . gnus-group-news-3-empty) ((and (eq level 3)) . gnus-group-news-3) ((and (= unread 0) (eq level 4)) . gnus-group-news-4-empty) ((and (eq level 4)) . gnus-group-news-4) ((and (= unread 0) (eq level 5)) . gnus-group-news-5-empty) ((and (eq level 5)) . gnus-group-news-5) ((and (= unread 0) (eq level 6)) . gnus-group-news-6-empty) ((and (eq level 6)) . gnus-group-news-6) ((and (= unread 0)) . gnus-group-news-low-empty) (t . gnus-group-news-low)) "\
*Controls the highlighting of group buffer lines.

Below is a list of `Form'/`Face' pairs.  When deciding how a a
particular group line should be displayed, each form is
evaluated.  The content of the face field after the first true form is
used.  You can change how those group lines are displayed by
editing the face field.

It is also possible to change and add form fields, but currently that
requires an understanding of Lisp expressions.  Hopefully this will
change in a future release.  For now, you can use the following
variables in the Lisp expression:

group: The name of the group.
unread: The number of unread articles in the group.
method: The select method used.
mailp: Whether it's a mail group or not.
level: The level of the group.
score: The score of the group.
ticked: The number of ticked articles." :group 'gnus-group-visual :type '(repeat (cons (sexp :tag "Form") face)))

(defcustom gnus-new-mail-mark ?% "\
Mark used for groups with new mail." :group 'gnus-group-visual :type 'character)

(defgroup gnus-group-icons nil "Add Icons to your group buffer." :group 'gnus-group-visual)

(defcustom gnus-group-icon-list nil "\
*Controls the insertion of icons into group buffer lines.

Below is a list of `Form'/`File' pairs.  When deciding how a
particular group line should be displayed, each form is evaluated.
The icon from the file field after the first true form is used.  You
can change how those group lines are displayed by editing the file
field.  The File will either be found in the
`gnus-group-glyph-directory' or by designating absolute name of the
file.

It is also possible to change and add form fields, but currently that
requires an understanding of Lisp expressions.  Hopefully this will
change in a future release.  For now, you can use the following
variables in the Lisp expression:

group: The name of the group.
unread: The number of unread articles in the group.
method: The select method used.
mailp: Whether it's a mail group or not.
newsp: Whether it's a news group or not
level: The level of the group.
score: The score of the group.
ticked: The number of ticked articles." :group 'gnus-group-icons :type '(repeat (cons (sexp :tag "Form") file)))

(defcustom gnus-group-name-charset-method-alist nil "\
Alist of method and the charset for group names.

For example:
    (((nntp \"news.com.cn\") . cn-gb-2312))" :version "21.1" :group 'gnus-charset :type '(repeat (cons (sexp :tag "Method") (symbol :tag "Charset"))))

(defcustom gnus-group-name-charset-group-alist (if (or (and (fboundp 'find-coding-system) (find-coding-system 'utf-8)) (mm-coding-system-p 'utf-8)) '((".*" . utf-8)) nil) "\
Alist of group regexp and the charset for group names.

For example:
    ((\"\\.com\\.cn:\" . cn-gb-2312))" :group 'gnus-charset :type '(repeat (cons (regexp :tag "Group") (symbol :tag "Charset"))))

(defcustom gnus-group-jump-to-group-prompt nil "\
Default prompt for `gnus-group-jump-to-group'.
If non-nil, the value should be a string, e.g. \"nnml:\",
in which case `gnus-group-jump-to-group' offers \"Group: nnml:\"
in the minibuffer prompt." :version "22.1" :group 'gnus-group-various :type '(choice (string :tag "Prompt string") (const :tag "Empty" nil)))

(defcustom gnus-group-tool-bar (if (eq gmm-tool-bar-style 'gnome) 'gnus-group-tool-bar-gnome 'gnus-group-tool-bar-retro) "\
Specifies the Gnus group tool bar.

It can be either a list or a symbol refering to a list.  See
`gmm-tool-bar-from-list' for the format of the list.  The
default key map is `gnus-group-mode-map'.

Pre-defined symbols include `gnus-group-tool-bar-gnome' and
`gnus-group-tool-bar-retro'." :type '(choice (const :tag "GNOME style" gnus-group-tool-bar-gnome) (const :tag "Retro look" gnus-group-tool-bar-retro) (repeat :tag "User defined list" gmm-tool-bar-item) (symbol)) :version "22.1" :initialize 'custom-initialize-default :set 'gnus-group-tool-bar-update :group 'gnus-group)

(defcustom gnus-group-tool-bar-gnome '((gnus-group-post-news "mail/compose") (gnus-agent-toggle-plugged "disconnect" t :help "Gnus is currently unplugged.  Click to work online." :visible (and gnus-agent (not gnus-plugged))) (gnus-agent-toggle-plugged "connect" t :help "Gnus is currently plugged.  Click to work offline." :visible (and gnus-agent gnus-plugged)) (gnus-group-send-queue "mail/outbox" t :visible (and gnus-agent gnus-plugged) :help "Send articles from the queue group") (gnus-group-get-new-news "mail/inbox" nil :visible (or (not gnus-agent) gnus-plugged)) (gnus-topic-read-group "open" nil :visible (and (boundp 'gnus-topic-mode) gnus-topic-mode)) (gnus-group-read-group "open" nil :visible (not (and (boundp 'gnus-topic-mode) gnus-topic-mode))) (gnus-group-save-newsrc "save") (gnus-group-describe-group "describe") (gnus-group-unsubscribe-current-group "gnus/toggle-subscription") (gnus-group-prev-unread-group "left-arrow") (gnus-group-next-unread-group "right-arrow") (gnus-group-exit "exit") (gmm-customize-mode "preferences" t :help "Edit mode preferences") (gnus-info-find-node "help")) "\
List of functions for the group tool bar (GNOME style).

See `gmm-tool-bar-from-list' for the format of the list." :type '(repeat gmm-tool-bar-item) :version "22.1" :initialize 'custom-initialize-default :set 'gnus-group-tool-bar-update :group 'gnus-group)

(defcustom gnus-group-tool-bar-retro '((gnus-group-get-new-news "gnus/get-news") (gnus-group-get-new-news-this-group "gnus/gnntg") (gnus-group-catchup-current "gnus/catchup") (gnus-group-describe-group "gnus/describe-group") (gnus-group-subscribe "gnus/subscribe" t :help "Subscribe to the current group") (gnus-group-unsubscribe "gnus/unsubscribe" t :help "Unsubscribe from the current group") (gnus-group-exit "gnus/exit-gnus" gnus-group-mode-map)) "\
List of functions for the group tool bar (retro look).

See `gmm-tool-bar-from-list' for the format of the list." :type '(repeat gmm-tool-bar-item) :version "22.1" :initialize 'custom-initialize-default :set 'gnus-group-tool-bar-update :group 'gnus-group)

(defcustom gnus-group-tool-bar-zap-list t "\
List of icon items from the global tool bar.
These items are not displayed in the Gnus group mode tool bar.

See `gmm-tool-bar-from-list' for the format of the list." :type 'gmm-tool-bar-zap-list :version "22.1" :initialize 'custom-initialize-default :set 'gnus-group-tool-bar-update :group 'gnus-group)

(defcustom gnus-group-update-tool-bar (and (not (featurep 'xemacs)) (boundp 'tool-bar-mode) tool-bar-mode (fboundp 'force-window-update)) "\
Force updating the group buffer tool bar." :group 'gnus-group :version "22.1" :initialize 'custom-initialize-default :set (lambda (symbol value) (set-default symbol value) (when (gnus-alive-p) (with-current-buffer gnus-group-buffer (gnus-group-get-new-news 0)))) :type 'boolean)

(defcustom gnus-large-ephemeral-newsgroup 200 "\
The number of articles which indicates a large ephemeral newsgroup.
Same as `gnus-large-newsgroup', but only used for ephemeral newsgroups.

If the number of articles in a newsgroup is greater than this value,
confirmation is required for selecting the newsgroup.  If it is nil, no
confirmation is required." :version "22.1" :group 'gnus-group-select :type '(choice (const :tag "No limit" nil) integer))

(defcustom gnus-fetch-old-ephemeral-headers nil "\
Same as `gnus-fetch-old-headers', but only used for ephemeral newsgroups." :version "22.1" :group 'gnus-thread :type '(choice (const :tag "off" nil) (const some) number (sexp :menu-tag "other" t)))

;;;***

;;;### (autoloads (gnus-server-unopen-status gnus-open-server-hook) "gnus-int" "lisp/gnus-int.el")
(defconst custom-define-current-source-file "gnus-int.el")

(defcustom gnus-open-server-hook nil "\
Hook called just before opening connection to the news server." :group 'gnus-start :type 'hook)

(defcustom gnus-server-unopen-status nil "\
The default status if the server is not able to open.
If the server is covered by Gnus agent, the possible values are
`denied', set the server denied; `offline', set the server offline;
nil, ask user.  If the server is not covered by Gnus agent, set the
server denied." :version "22.1" :group 'gnus-start :type '(choice (const :tag "Ask" nil) (const :tag "Deny server" denied) (const :tag "Unplug Agent" offline)))

;;;***

;;;### (autoloads (gnus-kill-killed gnus-winconf-kill-file gnus-kill-save-kill-file gnus-kill-expiry-days gnus-kill-file-mode-hook) "gnus-kill" "lisp/gnus-kill.el")
(defconst custom-define-current-source-file "gnus-kill.el")

(defcustom gnus-kill-file-mode-hook nil "\
Hook for Gnus kill file mode." :group 'gnus-score-kill :type 'hook)

(defcustom gnus-kill-expiry-days 7 "\
*Number of days before expiring unused kill file entries." :group 'gnus-score-kill :group 'gnus-score-expire :type 'integer)

(defcustom gnus-kill-save-kill-file nil "\
*If non-nil, will save kill files after processing them." :group 'gnus-score-kill :type 'boolean)

(defcustom gnus-winconf-kill-file nil "\
What does this do, Lars?
I don't know, Per." :group 'gnus-score-kill :type 'sexp)

(defcustom gnus-kill-killed t "\
*If non-nil, Gnus will apply kill files to already killed articles.
If it is nil, Gnus will never apply kill files to articles that have
already been through the scoring process, which might very well save lots
of time." :group 'gnus-score-kill :type 'boolean)

;;;***

;;;### (autoloads (gnus-summary-resend-default-address gnus-confirm-treat-mail-like-news gnus-confirm-mail-reply-to-news gnus-message-replysignencrypted gnus-message-replyencrypt gnus-message-replysign gnus-discouraged-post-methods gnus-debug-exclude-variables gnus-debug-files gnus-gcc-externalize-attachments gnus-gcc-mark-as-read gnus-posting-styles gnus-bug-create-help-buffer gnus-message-setup-hook gnus-crosspost-complaint gnus-add-to-list gnus-mailing-list-groups gnus-outgoing-message-group gnus-post-method) "gnus-msg" "lisp/gnus-msg.el")
(defconst custom-define-current-source-file "gnus-msg.el")

(defcustom gnus-post-method 'current "\
*Preferred method for posting USENET news.

If this variable is `current' (which is the default), Gnus will use
the \"current\" select method when posting.  If it is `native', Gnus
will use the native select method when posting.

This method will not be used in mail groups and the like, only in
\"real\" newsgroups.

If not `native' nor `current', the value must be a valid method as discussed
in the documentation of `gnus-select-method'.  It can also be a list of
methods.  If that is the case, the user will be queried for what select
method to use when posting." :group 'gnus-group-foreign :link '(custom-manual "(gnus)Posting Server") :type (backquote (choice (const native) (const current) (sexp :tag "Methods" (\, gnus-select-method)))))

(defcustom gnus-outgoing-message-group nil "\
*All outgoing messages will be put in this group.
If you want to store all your outgoing mail and articles in the group
\"nnml:archive\", you set this variable to that value.  This variable
can also be a list of group names.

If you want to have greater control over what group to put each
message in, you can set this variable to a function that checks the
current newsgroup name and then returns a suitable group name (or list
of names)." :group 'gnus-message :type '(choice (const nil) (function) (string :tag "Group") (repeat :tag "List of groups" (string :tag "Group"))))

(defcustom gnus-mailing-list-groups nil "\
*If non-nil a regexp matching groups that are really mailing lists.
This is useful when you're reading a mailing list that has been
gatewayed to a newsgroup, and you want to followup to an article in
the group." :group 'gnus-message :type '(choice (regexp) (const nil)))

(defcustom gnus-add-to-list nil "\
*If non-nil, add a `to-list' parameter automatically." :group 'gnus-message :type 'boolean)

(defcustom gnus-crosspost-complaint "Hi,\n\nYou posted the article below with the following Newsgroups header:\n\nNewsgroups: %s\n\nThe %s group, at least, was an inappropriate recipient\nof this message.  Please trim your Newsgroups header to exclude this\ngroup before posting in the future.\n\nThank you.\n\n" "\
Format string to be inserted when complaining about crossposts.
The first %s will be replaced by the Newsgroups header;
the second with the current group name." :group 'gnus-message :type 'string)

(defcustom gnus-message-setup-hook nil "\
Hook run after setting up a message buffer." :group 'gnus-message :type 'hook)

(defcustom gnus-bug-create-help-buffer t "\
*Should we create the *Gnus Help Bug* buffer?" :group 'gnus-message :type 'boolean)

(defcustom gnus-posting-styles nil "\
*Alist of styles to use when posting.
See Info node `(gnus)Posting Styles'." :group 'gnus-message :link '(custom-manual "(gnus)Posting Styles") :type '(repeat (cons (choice (regexp) (variable) (list (const header) (string :tag "Header") (regexp :tag "Regexp")) (function) (sexp)) (repeat (list (choice (const signature) (const signature-file) (const organization) (const address) (const x-face-file) (const name) (const body) (symbol) (string :tag "Header")) (choice (string) (function) (variable) (sexp)))))))

(defcustom gnus-gcc-mark-as-read nil "\
If non-nil, automatically mark Gcc articles as read." :version "22.1" :group 'gnus-message :type 'boolean)

(defcustom gnus-gcc-externalize-attachments nil "\
Should local-file attachments be included as external parts in Gcc copies?
If it is `all', attach files as external parts;
if a regexp and matches the Gcc group name, attach files as external parts;
if nil, attach files as normal parts." :version "22.1" :group 'gnus-message :type '(choice (const nil :tag "None") (const all :tag "Any") (string :tag "Regexp")))

(defcustom gnus-debug-files '("gnus.el" "gnus-sum.el" "gnus-group.el" "gnus-art.el" "gnus-start.el" "gnus-async.el" "gnus-msg.el" "gnus-score.el" "gnus-win.el" "gnus-topic.el" "gnus-agent.el" "gnus-cache.el" "gnus-srvr.el" "mm-util.el" "mm-decode.el" "nnmail.el" "message.el") "\
Files whose variables will be reported in `gnus-bug'." :version "22.1" :group 'gnus-message :type '(repeat (string :tag "File")))

(defcustom gnus-debug-exclude-variables '(mm-mime-mule-charset-alist nnmail-split-fancy message-minibuffer-local-map) "\
Variables that should not be reported in `gnus-bug'." :version "22.1" :group 'gnus-message :type '(repeat (symbol :tag "Variable")))

(defcustom gnus-discouraged-post-methods '(nndraft nnml nnimap nnmaildir nnmh nnfolder nndir) "\
A list of back ends that are not used in \"real\" newsgroups.
This variable is used only when `gnus-post-method' is `current'." :version "22.1" :group 'gnus-group-foreign :type '(repeat (symbol :tag "Back end")))

(defcustom gnus-message-replysign nil "\
Automatically sign replies to signed messages.
See also the `mml-default-sign-method' variable." :group 'gnus-message :type 'boolean)

(defcustom gnus-message-replyencrypt nil "\
Automatically encrypt replies to encrypted messages.
See also the `mml-default-encrypt-method' variable." :group 'gnus-message :type 'boolean)

(defcustom gnus-message-replysignencrypted t "\
Setting this causes automatically encrypted messages to also be signed." :group 'gnus-message :type 'boolean)

(defcustom gnus-confirm-mail-reply-to-news nil "\
If non-nil, Gnus requests confirmation when replying to news.
This is done because new users often reply by mistake when reading
news.
This can also be a function receiving the group name as the only
parameter, which should return non-nil if a confirmation is needed; or
a regexp, in which case a confirmation is asked for if the group name
matches the regexp." :version "22.1" :group 'gnus-message :type '(choice (const :tag "No" nil) (const :tag "Yes" t) (regexp :tag "If group matches regexp") (function :tag "If function evaluates to non-nil")))

(defcustom gnus-confirm-treat-mail-like-news nil "\
If non-nil, Gnus will treat mail like news with regard to confirmation
when replying by mail.  See the `gnus-confirm-mail-reply-to-news' variable
for fine-tuning this.
If nil, Gnus will never ask for confirmation if replying to mail." :version "22.1" :group 'gnus-message :type 'boolean)

(defcustom gnus-summary-resend-default-address t "\
If non-nil, Gnus tries to suggest a default address to resend to.
If nil, the address field will always be empty after invoking
`gnus-summary-resend-message'." :version "22.1" :group 'gnus-message :type 'boolean)

;;;***

;;;### (autoloads (gnus-nocem-check-from gnus-nocem-check-article-limit gnus-nocem-liberal-fetch gnus-nocem-verifyer gnus-nocem-expiry-wait gnus-nocem-directory gnus-nocem-issuers gnus-nocem-groups gnus-nocem) "gnus-nocem" "lisp/gnus-nocem.el")
(defconst custom-define-current-source-file "gnus-nocem.el")

(defgroup gnus-nocem nil "NoCeM pseudo-cancellation treatment." :group 'gnus-score)

(defcustom gnus-nocem-groups '("news.lists.filters" "news.admin.net-abuse.bulletins" "alt.nocem.misc" "news.admin.net-abuse.announce") "\
*List of groups that will be searched for NoCeM messages." :group 'gnus-nocem :type '(repeat (string :tag "Group")))

(defcustom gnus-nocem-issuers '("AutoMoose-1" "clewis@ferret.ocunix" "cosmo.roadkill" "SpamHippo" "hweede@snafu.de") "\
*List of NoCeM issuers to pay attention to.

This can also be a list of `(ISSUER CONDITION ...)' elements.

See <URL:http://www.xs4all.nl/~rosalind/nocemreg/nocemreg.html> for an
issuer registry." :group 'gnus-nocem :link '(url-link "http://www.xs4all.nl/~rosalind/nocemreg/nocemreg.html") :type '(repeat (choice string sexp)))

(defcustom gnus-nocem-directory (nnheader-concat gnus-article-save-directory "NoCeM/") "\
*Directory where NoCeM files will be stored." :group 'gnus-nocem :type 'directory)

(defcustom gnus-nocem-expiry-wait 15 "\
*Number of days to keep NoCeM headers in the cache." :group 'gnus-nocem :type 'integer)

(defcustom gnus-nocem-verifyer 'pgg-verify "\
*Function called to verify that the NoCeM message is valid.
One likely value is `pgg-verify'.  If the function in this variable
isn't bound, the message will be used unconditionally." :group 'gnus-nocem :type '(radio (function-item pgg-verify) (function-item mc-verify) (function :tag "other")))

(defcustom gnus-nocem-liberal-fetch nil "\
*If t try to fetch all messages which have @@NCM in the subject.
Otherwise don't fetch messages which have references or whose message-id
matches a previously scanned and verified nocem message." :group 'gnus-nocem :type 'boolean)

(defcustom gnus-nocem-check-article-limit 500 "\
*If non-nil, the maximum number of articles to check in any NoCeM group." :group 'gnus-nocem :version "21.1" :type '(choice (const :tag "unlimited" nil) (integer 1000)))

(defcustom gnus-nocem-check-from t "\
Non-nil means check for valid issuers in message bodies.
Otherwise don't bother fetching articles unless their author matches a
valid issuer, which is much faster if you are selective about the issuers." :group 'gnus-nocem :version "21.1" :type 'boolean)

;;;***

;;;### (autoloads (gnus-picon-file-types gnus-picon-domain-directories gnus-picon-user-directories gnus-picon-news-directories) "gnus-picon" "lisp/gnus-picon.el")
(defconst custom-define-current-source-file "gnus-picon.el")

(defcustom gnus-picon-news-directories '("news") "\
*List of directories to search for newsgroups faces." :type '(repeat string) :group 'gnus-picon)

(defcustom gnus-picon-user-directories '("users" "usenix" "local" "misc") "\
*List of directories to search for user faces." :type '(repeat string) :group 'gnus-picon)

(defcustom gnus-picon-domain-directories '("domains") "\
*List of directories to search for domain faces.
Some people may want to add \"unknown\" to this list." :type '(repeat string) :group 'gnus-picon)

(defcustom gnus-picon-file-types (let ((types (list "xbm"))) (when (gnus-image-type-available-p 'gif) (push "gif" types)) (when (gnus-image-type-available-p 'xpm) (push "xpm" types)) types) "\
*List of suffixes on picon file names to try." :type '(repeat string) :group 'gnus-picon)

;;;***

;;;### (autoloads (gnus-registry-max-entries gnus-registry-cache-file gnus-registry-trim-articles-without-groups gnus-registry-minimum-subject-length gnus-registry-entry-caching gnus-registry-track-extra gnus-registry-use-long-group-names gnus-registry-clean-empty gnus-registry-install gnus-registry-unfollowed-groups gnus-registry) "gnus-registry" "lisp/gnus-registry.el")
(defconst custom-define-current-source-file "gnus-registry.el")

(defgroup gnus-registry nil "The Gnus registry." :version "22.1" :group 'gnus)

(defcustom gnus-registry-unfollowed-groups '("delayed" "drafts" "queue") "\
List of groups that gnus-registry-split-fancy-with-parent won't follow.
The group names are matched, they don't have to be fully qualified." :group 'gnus-registry :type '(repeat string))

(defcustom gnus-registry-install nil "\
Whether the registry should be installed." :group 'gnus-registry :type 'boolean)

(defcustom gnus-registry-clean-empty t "\
Whether the empty registry entries should be deleted.
Registry entries are considered empty when they have no groups." :group 'gnus-registry :type 'boolean)

(defcustom gnus-registry-use-long-group-names nil "\
Whether the registry should use long group names (BUGGY)." :group 'gnus-registry :type 'boolean)

(defcustom gnus-registry-track-extra nil "\
Whether the registry should track extra data about a message.
The Subject and Sender (From:) headers are currently tracked this
way." :group 'gnus-registry :type '(set :tag "Tracking choices" (const :tag "Track by subject (Subject: header)" subject) (const :tag "Track by sender (From: header)" sender)))

(defcustom gnus-registry-entry-caching t "\
Whether the registry should cache extra information." :group 'gnus-registry :type 'boolean)

(defcustom gnus-registry-minimum-subject-length 5 "\
The minimum length of a subject before it's considered trackable." :group 'gnus-registry :type 'integer)

(defcustom gnus-registry-trim-articles-without-groups t "\
Whether the registry should clean out message IDs without groups." :group 'gnus-registry :type 'boolean)

(defcustom gnus-registry-cache-file "~/.gnus.registry.eld" "\
File where the Gnus registry will be stored." :group 'gnus-registry :type 'file)

(defcustom gnus-registry-max-entries nil "\
Maximum number of entries in the registry, nil for unlimited." :group 'gnus-registry :type '(radio (const :format "Unlimited " nil) (integer :format "Maximum number: %v")))

;;;***

;;;### (autoloads (gnus-tree-mode-hook gnus-generate-tree-function gnus-tree-mode-line-format gnus-selected-tree-face gnus-tree-minimize-window gnus-tree-line-format gnus-summary-pick-line-format gnus-pick-elegant-flow gnus-mark-unpicked-articles-as-read gnus-pick-mode-hook gnus-pick-display-summary) "gnus-salt" "lisp/gnus-salt.el")
(defconst custom-define-current-source-file "gnus-salt.el")

(defcustom gnus-pick-display-summary nil "\
*Display summary while reading." :type 'boolean :group 'gnus-summary-pick)

(defcustom gnus-pick-mode-hook nil "\
Hook run in summary pick mode buffers." :type 'hook :group 'gnus-summary-pick)

(defcustom gnus-mark-unpicked-articles-as-read nil "\
*If non-nil, mark all unpicked articles as read." :type 'boolean :group 'gnus-summary-pick)

(defcustom gnus-pick-elegant-flow t "\
If non-nil, `gnus-pick-start-reading' runs
 `gnus-summary-next-group' when no articles have been picked." :type 'boolean :group 'gnus-summary-pick)

(defcustom gnus-summary-pick-line-format "%-5P %U%R%z%I%(%[%4L: %-23,23n%]%) %s\n" "\
*The format specification of the lines in pick buffers.
It accepts the same format specs that `gnus-summary-line-format' does." :type 'string :group 'gnus-summary-pick)

(defcustom gnus-tree-line-format "%(%[%3,3n%]%)" "\
Format of tree elements." :type 'string :group 'gnus-summary-tree)

(defcustom gnus-tree-minimize-window t "\
If non-nil, minimize the tree buffer window.
If a number, never let the tree buffer grow taller than that number of
lines." :type '(choice boolean integer) :group 'gnus-summary-tree)

(defcustom gnus-selected-tree-face 'modeline "\
*Face used for highlighting selected articles in the thread tree." :type 'face :group 'gnus-summary-tree)

(defcustom gnus-tree-mode-line-format "Gnus: %%b %S %Z" "\
*The format specification for the tree mode line." :type 'string :group 'gnus-summary-tree)

(defcustom gnus-generate-tree-function 'gnus-generate-vertical-tree "\
*Function for generating a thread tree.
Two predefined functions are available:
`gnus-generate-horizontal-tree' and `gnus-generate-vertical-tree'." :type '(radio (function-item gnus-generate-vertical-tree) (function-item gnus-generate-horizontal-tree) (function :tag "Other" nil)) :group 'gnus-summary-tree)

(defcustom gnus-tree-mode-hook nil "\
*Hook run in tree mode buffers." :type 'hook :group 'gnus-summary-tree)

;;;***

;;;### (autoloads (gnus-score-thread-simplify gnus-score-after-write-file-function gnus-score-default-duration gnus-score-default-fold gnus-score-default-type gnus-score-default-header gnus-score-uncacheable-files gnus-score-exact-adapt-limit gnus-score-mimic-keymap gnus-adaptive-word-no-group-words gnus-adaptive-word-minimum gnus-default-adaptive-word-score-alist gnus-default-ignored-adaptive-words gnus-ignored-adaptive-words gnus-adaptive-word-length-limit gnus-default-adaptive-score-alist gnus-home-adapt-file gnus-home-score-file gnus-score-decay-scale gnus-score-decay-constant gnus-decay-score-function gnus-decay-scores gnus-update-score-entry-dates gnus-score-expiry-days gnus-score-interactive-default-score gnus-score-find-score-files-function gnus-adaptive-file-suffix gnus-score-file-suffix gnus-score-file-multiple-match-alist gnus-score-file-single-match-alist gnus-global-score-files) "gnus-score" "lisp/gnus-score.el")
(defconst custom-define-current-source-file "gnus-score.el")

(defcustom gnus-global-score-files nil "\
List of global score files and directories.
Set this variable if you want to use people's score files.  One entry
for each score file or each score file directory.  Gnus will decide
by itself what score files are applicable to which group.

Say you want to use the single score file
\"/ftp.gnus.org@ftp:/pub/larsi/ding/score/soc.motss.SCORE\" and all
score files in the \"/ftp.some-where:/pub/score\" directory.

 (setq gnus-global-score-files
       '(\"/ftp.gnus.org:/pub/larsi/ding/score/soc.motss.SCORE\"
	 \"/ftp.some-where:/pub/score\"))" :group 'gnus-score-files :type '(repeat file))

(defcustom gnus-score-file-single-match-alist nil "\
Alist mapping regexps to lists of score files.
Each element of this alist should be of the form
	(\"REGEXP\" [ \"SCORE-FILE-1\" ] [ \"SCORE-FILE-2\" ] ... )

If the name of a group is matched by REGEXP, the corresponding scorefiles
will be used for that group.
The first match found is used, subsequent matching entries are ignored (to
use multiple matches, see `gnus-score-file-multiple-match-alist').

These score files are loaded in addition to any files returned by
`gnus-score-find-score-files-function'." :group 'gnus-score-files :type '(repeat (cons regexp (repeat file))))

(defcustom gnus-score-file-multiple-match-alist nil "\
Alist mapping regexps to lists of score files.
Each element of this alist should be of the form
	(\"REGEXP\" [ \"SCORE-FILE-1\" ] [ \"SCORE-FILE-2\" ] ... )

If the name of a group is matched by REGEXP, the corresponding scorefiles
will be used for that group.
If multiple REGEXPs match a group, the score files corresponding to each
match will be used (for only one match to be used, see
`gnus-score-file-single-match-alist').

These score files are loaded in addition to any files returned by
`gnus-score-find-score-files-function'." :group 'gnus-score-files :type '(repeat (cons regexp (repeat file))))

(defcustom gnus-score-file-suffix "SCORE" "\
Suffix of the score files." :group 'gnus-score-files :type 'string)

(defcustom gnus-adaptive-file-suffix "ADAPT" "\
Suffix of the adaptive score files." :group 'gnus-score-files :group 'gnus-score-adapt :type 'string)

(defcustom gnus-score-find-score-files-function 'gnus-score-find-bnews "\
Function used to find score files.
The function will be called with the group name as the argument, and
should return a list of score files to apply to that group.  The score
files do not actually have to exist.

Predefined values are:

`gnus-score-find-single': Only apply the group's own score file.
`gnus-score-find-hierarchical': Also apply score files from parent groups.
`gnus-score-find-bnews': Apply score files whose names matches.

See the documentation to these functions for more information.

This variable can also be a list of functions to be called.  Each
function is given the group name as argument and should either return
a list of score files, or a list of score alists.

If functions other than these pre-defined functions are used,
the `a' symbolic prefix to the score commands will always use
\"all.SCORE\"." :group 'gnus-score-files :type '(radio (function-item gnus-score-find-single) (function-item gnus-score-find-hierarchical) (function-item gnus-score-find-bnews) (repeat :tag "List of functions" (choice (function :tag "Other" :value 'ignore) (function-item gnus-score-find-single) (function-item gnus-score-find-hierarchical) (function-item gnus-score-find-bnews))) (function :tag "Other" :value 'ignore)))

(defcustom gnus-score-interactive-default-score 1000 "\
*Scoring commands will raise/lower the score with this number as the default." :group 'gnus-score-default :type 'integer)

(defcustom gnus-score-expiry-days 7 "\
*Number of days before unused score file entries are expired.
If this variable is nil, no score file entries will be expired." :group 'gnus-score-expire :type '(choice (const :tag "never" nil) number))

(defcustom gnus-update-score-entry-dates t "\
*If non-nil, update matching score entry dates.
If this variable is nil, then score entries that provide matches
will be expired along with non-matching score entries." :group 'gnus-score-expire :type 'boolean)

(defcustom gnus-decay-scores nil "\
*If non-nil, decay non-permanent scores." :group 'gnus-score-decay :type 'boolean)

(defcustom gnus-decay-score-function 'gnus-decay-score "\
*Function called to decay a score.
It is called with one parameter -- the score to be decayed." :group 'gnus-score-decay :type '(radio (function-item gnus-decay-score) (function :tag "Other")))

(defcustom gnus-score-decay-constant 3 "\
*Decay all \"small\" scores with this amount." :group 'gnus-score-decay :type 'integer)

(defcustom gnus-score-decay-scale 0.05 "\
*Decay all \"big\" scores with this factor." :group 'gnus-score-decay :type 'number)

(defcustom gnus-home-score-file nil "\
Variable to control where interactive score entries are to go.
It can be:

 * A string
   This file will be used as the home score file.

 * A function
   The result of this function will be used as the home score file.
   The function will be passed the name of the group as its
   parameter.

 * A list
   The elements in this list can be:

   * `(regexp file-name ...)'
     If the `regexp' matches the group name, the first `file-name'
     will be used as the home score file.  (Multiple filenames are
     allowed so that one may use gnus-score-file-single-match-alist to
     set this variable.)

   * A function.
     If the function returns non-nil, the result will be used
     as the home score file.  The function will be passed the
     name of the group as its parameter.

   * A string.  Use the string as the home score file.

   The list will be traversed from the beginning towards the end looking
   for matches." :group 'gnus-score-files :type '(choice string (repeat (choice string (cons regexp (repeat file)) function)) (function-item gnus-hierarchial-home-score-file) (function-item gnus-current-home-score-file) function))

(defcustom gnus-home-adapt-file nil "\
Variable to control where new adaptive score entries are to go.
This variable allows the same syntax as `gnus-home-score-file'." :group 'gnus-score-adapt :group 'gnus-score-files :type '(choice string (repeat (choice string (cons regexp (repeat file)) function)) function))

(defcustom gnus-default-adaptive-score-alist (backquote ((gnus-kill-file-mark) (gnus-unread-mark) (gnus-read-mark (from (\, (+ 2 gnus-score-decay-constant))) (subject (\, (+ 27 gnus-score-decay-constant)))) (gnus-catchup-mark (subject (\, (+ -7 (* -1 gnus-score-decay-constant))))) (gnus-killed-mark (from (\, (- -1 gnus-score-decay-constant))) (subject (\, (+ -17 (* -1 gnus-score-decay-constant))))) (gnus-del-mark (from (\, (- -1 gnus-score-decay-constant))) (subject (\, (+ -12 (* -1 gnus-score-decay-constant))))))) "\
Alist of marks and scores.
If you use score decays, you might want to set values higher than
`gnus-score-decay-constant'." :group 'gnus-score-adapt :type '(repeat (cons (symbol :tag "Mark") (repeat (list (choice :tag "Header" (const from) (const subject) (symbol :tag "other")) (integer :tag "Score"))))))

(defcustom gnus-adaptive-word-length-limit nil "\
*Words of a length lesser than this limit will be ignored when doing adaptive scoring." :version "22.1" :group 'gnus-score-adapt :type '(radio (const :format "Unlimited " nil) (integer :format "Maximum length: %v")))

(defcustom gnus-ignored-adaptive-words nil "\
List of words to be ignored when doing adaptive word scoring." :group 'gnus-score-adapt :type '(repeat string))

(defcustom gnus-default-ignored-adaptive-words '("a" "i" "the" "to" "of" "and" "in" "is" "it" "for" "that" "if" "you" "this" "be" "on" "with" "not" "have" "are" "or" "as" "from" "can" "but" "by" "at" "an" "will" "no" "all" "was" "do" "there" "my" "one" "so" "we" "they" "what" "would" "any" "which" "about" "get" "your" "use" "some" "me" "then" "name" "like" "out" "when" "up" "time" "other" "more" "only" "just" "end" "also" "know" "how" "new" "should" "been" "than" "them" "he" "who" "make" "may" "people" "these" "now" "their" "here" "into" "first" "could" "way" "had" "see" "work" "well" "were" "two" "very" "where" "while" "us" "because" "good" "same" "even" "much" "most" "many" "such" "long" "his" "over" "last" "since" "right" "before" "our" "without" "too" "those" "why" "must" "part" "being" "current" "back" "still" "go" "point" "value" "each" "did" "both" "true" "off" "say" "another" "state" "might" "under" "start" "try" "re") "\
*Default list of words to be ignored when doing adaptive word scoring." :group 'gnus-score-adapt :type '(repeat string))

(defcustom gnus-default-adaptive-word-score-alist (backquote (((\, gnus-read-mark) . 30) ((\, gnus-catchup-mark) . -10) ((\, gnus-killed-mark) . -20) ((\, gnus-del-mark) . -15))) "\
*Alist of marks and scores." :group 'gnus-score-adapt :type '(repeat (cons (character :tag "Mark") (integer :tag "Score"))))

(defcustom gnus-adaptive-word-minimum nil "\
If a number, this is the minimum score value that can be assigned to a word." :group 'gnus-score-adapt :type '(choice (const nil) integer))

(defcustom gnus-adaptive-word-no-group-words nil "\
If t, don't adaptively score words included in the group name." :group 'gnus-score-adapt :type 'boolean)

(defcustom gnus-score-mimic-keymap nil "\
*Have the score entry functions pretend that they are a keymap." :group 'gnus-score-default :type 'boolean)

(defcustom gnus-score-exact-adapt-limit 10 "\
*Number that says how long a match has to be before using substring matching.
When doing adaptive scoring, one normally uses fuzzy or substring
matching.  However, if the header one matches is short, the possibility
for false positives is great, so if the length of the match is less
than this variable, exact matching will be used.

If this variable is nil, exact matching will always be used." :group 'gnus-score-adapt :type '(choice (const nil) integer))

(defcustom gnus-score-uncacheable-files "ADAPT$" "\
All score files that match this regexp will not be cached." :group 'gnus-score-adapt :group 'gnus-score-files :type 'regexp)

(defcustom gnus-score-default-header nil "\
Default header when entering new scores.

Should be one of the following symbols.

 a: from
 s: subject
 b: body
 h: head
 i: message-id
 t: references
 x: xref
 e: `extra' (non-standard overview)
 l: lines
 d: date
 f: followup

If nil, the user will be asked for a header." :group 'gnus-score-default :type '(choice (const :tag "from" a) (const :tag "subject" s) (const :tag "body" b) (const :tag "head" h) (const :tag "message-id" i) (const :tag "references" t) (const :tag "xref" x) (const :tag "extra" e) (const :tag "lines" l) (const :tag "date" d) (const :tag "followup" f) (const :tag "ask" nil)))

(defcustom gnus-score-default-type nil "\
Default match type when entering new scores.

Should be one of the following symbols.

 s: substring
 e: exact string
 f: fuzzy string
 r: regexp string
 b: before date
 a: after date
 n: this date
 <: less than number
 >: greater than number
 =: equal to number

If nil, the user will be asked for a match type." :group 'gnus-score-default :type '(choice (const :tag "substring" s) (const :tag "exact string" e) (const :tag "fuzzy string" f) (const :tag "regexp string" r) (const :tag "before date" b) (const :tag "after date" a) (const :tag "this date" n) (const :tag "less than number" <) (const :tag "greater than number" >) (const :tag "equal than number" =) (const :tag "ask" nil)))

(defcustom gnus-score-default-fold nil "\
Non-nil means use case folding for new score file entries." :group 'gnus-score-default :type 'boolean)

(defcustom gnus-score-default-duration nil "\
Default duration of effect when entering new scores.

Should be one of the following symbols.

 t: temporary
 p: permanent
 i: immediate

If nil, the user will be asked for a duration." :group 'gnus-score-default :type '(choice (const :tag "temporary" t) (const :tag "permanent" p) (const :tag "immediate" i) (const :tag "ask" nil)))

(defcustom gnus-score-after-write-file-function nil "\
Function called with the name of the score file just written to disk." :group 'gnus-score-files :type '(choice (const nil) function))

(defcustom gnus-score-thread-simplify nil "\
If non-nil, subjects will simplified as in threading." :group 'gnus-score-various :type 'boolean)

;;;***

;;;### (autoloads (gnus-sieve-update-shell-command gnus-sieve-crosspost gnus-sieve-select-method gnus-sieve-region-end gnus-sieve-region-start gnus-sieve-file gnus-sieve) "gnus-sieve" "lisp/gnus-sieve.el")
(defconst custom-define-current-source-file "gnus-sieve.el")

(defgroup gnus-sieve nil "Manage sieve scripts in Gnus." :group 'gnus)

(defcustom gnus-sieve-file "~/.sieve" "\
Path to your Sieve script." :type 'file :group 'gnus-sieve)

(defcustom gnus-sieve-region-start "\n## Begin Gnus Sieve Script\n" "\
Line indicating the start of the autogenerated region in
your Sieve script." :type 'string :group 'gnus-sieve)

(defcustom gnus-sieve-region-end "\n## End Gnus Sieve Script\n" "\
Line indicating the end of the autogenerated region in
your Sieve script." :type 'string :group 'gnus-sieve)

(defcustom gnus-sieve-select-method nil "\
Which select method we generate the Sieve script for.

For example: \"nnimap:mailbox\"" :group 'gnus-sieve)

(defcustom gnus-sieve-crosspost t "\
Whether the generated Sieve script should do crossposting." :type 'boolean :group 'gnus-sieve)

(defcustom gnus-sieve-update-shell-command "echo put %f | sieveshell %s" "\
Shell command to execute after updating your Sieve script.  The following
formatting characters are recognized:

%f    Script's file name (gnus-sieve-file)
%s    Server name (from gnus-sieve-select-method)" :type 'string :group 'gnus-sieve)

;;;***

;;;### (autoloads (gnus-soup-ignored-headers gnus-soup-packet-regexp gnus-soup-packet-directory gnus-soup-unpacker gnus-soup-packer gnus-soup-prefix-file gnus-soup-replies-directory gnus-soup-directory gnus-soup) "gnus-soup" "lisp/gnus-soup.el")
(defconst custom-define-current-source-file "gnus-soup.el")

(defgroup gnus-soup nil "SOUP packet writing support for Gnus." :group 'gnus)

(defcustom gnus-soup-directory (nnheader-concat gnus-home-directory "SoupBrew/") "\
Directory containing an unpacked SOUP packet." :version "22.1" :type 'directory :group 'gnus-soup)

(defcustom gnus-soup-replies-directory (nnheader-concat gnus-soup-directory "SoupReplies/") "\
Directory where Gnus will do processing of replies." :version "22.1" :type 'directory :group 'gnus-soup)

(defcustom gnus-soup-prefix-file "gnus-prefix" "\
Name of the file where Gnus stores the last used prefix." :version "22.1" :type 'file :group 'gnus-soup)

(defcustom gnus-soup-packer "tar cf - %s | gzip > $HOME/Soupout%d.tgz" "\
Format string command for packing a SOUP packet.
The SOUP files will be inserted where the %s is in the string.
This string MUST contain both %s and %d.  The file number will be
inserted where %d appears." :version "22.1" :type 'string :group 'gnus-soup)

(defcustom gnus-soup-unpacker "gunzip -c %s | tar xvf -" "\
Format string command for unpacking a SOUP packet.
The SOUP packet file name will be inserted at the %s." :version "22.1" :type 'string :group 'gnus-soup)

(defcustom gnus-soup-packet-directory gnus-home-directory "\
Where gnus-soup will look for REPLIES packets." :version "22.1" :type 'directory :group 'gnus-soup)

(defcustom gnus-soup-packet-regexp "Soupin" "\
Regular expression matching SOUP REPLIES packets in `gnus-soup-packet-directory'." :version "22.1" :type 'regexp :group 'gnus-soup)

(defcustom gnus-soup-ignored-headers "^Xref:" "\
Regexp to match headers to be removed when brewing SOUP packets." :version "22.1" :type 'regexp :group 'gnus-soup)

;;;***

;;;### (autoloads (gnus-make-format-preserve-properties gnus-use-correct-string-widths) "gnus-spec" "lisp/gnus-spec.el")
(defconst custom-define-current-source-file "gnus-spec.el")

(defcustom gnus-use-correct-string-widths (featurep 'xemacs) "\
*If non-nil, use correct functions for dealing with wide characters." :version "22.1" :group 'gnus-format :type 'boolean)

(defcustom gnus-make-format-preserve-properties (featurep 'xemacs) "\
*If non-nil, use a replacement `format' function which preserves
text properties. This is only needed on XEmacs, as FSF Emacs does this anyway." :version "22.1" :group 'gnus-format :type 'boolean)

;;;***

;;;### (autoloads (gnus-server-browse-in-group-buffer gnus-server-mode-line-format gnus-server-line-format gnus-server-exit-hook gnus-server-mode-hook) "gnus-srvr" "lisp/gnus-srvr.el")
(defconst custom-define-current-source-file "gnus-srvr.el")

(defcustom gnus-server-mode-hook nil "\
Hook run in `gnus-server-mode' buffers." :group 'gnus-server :type 'hook)

(defcustom gnus-server-exit-hook nil "\
Hook run when exiting the server buffer." :group 'gnus-server :type 'hook)

(defcustom gnus-server-line-format "     {%(%h:%w%)} %s%a\n" "\
Format of server lines.
It works along the same lines as a normal formatting string,
with some simple extensions.

The following specs are understood:

%h backend
%n name
%w address
%s status
%a agent covered

General format specifiers can also be used.
See Info node `(gnus)Formatting Variables'." :link '(custom-manual "(gnus)Formatting Variables") :group 'gnus-server-visual :type 'string)

(defcustom gnus-server-mode-line-format "Gnus: %%b" "\
The format specification for the server mode line." :group 'gnus-server-visual :type 'string)

(defcustom gnus-server-browse-in-group-buffer nil "\
Whether server browsing should take place in the group buffer.
If nil, a faster, but more primitive, buffer is used instead." :version "22.1" :group 'gnus-server-visual :type 'boolean)

;;;***

;;;### (autoloads (gnus-always-read-dribble-file gnus-group-mode-hook gnus-save-standard-newsrc-hook gnus-save-quick-newsrc-hook gnus-save-newsrc-hook gnus-read-newsrc-el-hook gnus-after-getting-new-news-hook gnus-get-new-news-hook gnus-get-top-new-news-hook gnus-setup-news-hook gnus-started-hook gnus-before-startup-hook gnus-startup-hook gnus-check-bogus-groups-hook gnus-modtime-botch gnus-options-not-subscribe gnus-options-subscribe gnus-auto-subscribed-groups gnus-subscribe-hierarchical-interactive gnus-subscribe-options-newsgroup-method gnus-subscribe-newsgroup-hooks gnus-subscribe-newsgroup-method gnus-ignored-newsgroups gnus-save-killed-list gnus-save-newsrc-file gnus-read-newsrc-file gnus-activate-foreign-newsgroups gnus-activate-level gnus-level-default-unsubscribed gnus-level-default-subscribed gnus-read-active-file gnus-check-bogus-newsgroups gnus-check-new-newsgroups gnus-dribble-directory gnus-use-dribble-file gnus-default-subscribed-newsgroups gnus-site-init-file gnus-init-file gnus-save-startup-file-via-temp-buffer gnus-backup-startup-file gnus-startup-file) "gnus-start" "lisp/gnus-start.el")
(defconst custom-define-current-source-file "gnus-start.el")

(defcustom gnus-startup-file (nnheader-concat gnus-home-directory ".newsrc") "\
Your `.newsrc' file.
`.newsrc-SERVER' will be used instead if that exists." :group 'gnus-start :type 'file)

(defcustom gnus-backup-startup-file 'never "\
Whether to create backup files.
This variable takes the same values as the `version-control'
variable." :version "22.1" :group 'gnus-start :type '(choice (const :tag "Never" never) (const :tag "If existing" nil) (other :tag "Always" t)))

(defcustom gnus-save-startup-file-via-temp-buffer t "\
Whether to write the startup file contents to a buffer then save
the buffer or write directly to the file.  The buffer is faster
because all of the contents are written at once.  The direct write
uses considerably less memory." :version "22.1" :group 'gnus-start :type '(choice (const :tag "Write via buffer" t) (const :tag "Write directly to file" nil)))

(defcustom gnus-init-file (nnheader-concat gnus-home-directory ".gnus") "\
Your Gnus Emacs-Lisp startup file name.
If a file with the `.el' or `.elc' suffixes exists, it will be read instead." :group 'gnus-start :type 'file)

(defcustom gnus-site-init-file (condition-case nil (concat (file-name-directory (directory-file-name installation-directory)) "site-lisp/gnus-init") (error nil)) "\
The site-wide Gnus Emacs-Lisp startup file name, or nil if none.
If a file with the `.el' or `.elc' suffixes exists, it will be read instead." :group 'gnus-start :type '(choice file (const nil)))

(defcustom gnus-default-subscribed-newsgroups nil "\
List of newsgroups to subscribe, when a user runs Gnus the first time.
The value should be a list of strings.
If it is t, Gnus will not do anything special the first time it is
started; it'll just use the normal newsgroups subscription methods." :group 'gnus-start :type '(choice (repeat string) (const :tag "Nothing special" t)))

(defcustom gnus-use-dribble-file t "\
*Non-nil means that Gnus will use a dribble file to store user updates.
If Emacs should crash without saving the .newsrc files, complete
information can be restored from the dribble file." :group 'gnus-dribble-file :type 'boolean)

(defcustom gnus-dribble-directory nil "\
*The directory where dribble files will be saved.
If this variable is nil, the directory where the .newsrc files are
saved will be used." :group 'gnus-dribble-file :type '(choice directory (const nil)))

(defcustom gnus-check-new-newsgroups 'ask-server "\
*Non-nil means that Gnus will run `gnus-find-new-newsgroups' at startup.
This normally finds new newsgroups by comparing the active groups the
servers have already reported with those Gnus already knows, either alive
or killed.

When any of the following are true, `gnus-find-new-newsgroups' will instead
ask the servers (primary, secondary, and archive servers) to list new
groups since the last time it checked:
  1. This variable is `ask-server'.
  2. This variable is a list of select methods (see below).
  3. `gnus-read-active-file' is nil or `some'.
  4. A prefix argument is given to `gnus-find-new-newsgroups' interactively.

Thus, if this variable is `ask-server' or a list of select methods or
`gnus-read-active-file' is nil or `some', then the killed list is no
longer necessary, so you could safely set `gnus-save-killed-list' to nil.

This variable can be a list of select methods which Gnus will query with
the `ask-server' method in addition to the primary, secondary, and archive
servers.

Eg.
  (setq gnus-check-new-newsgroups
	'((nntp \"some.server\") (nntp \"other.server\")))

If this variable is nil, then you have to tell Gnus explicitly to
check for new newsgroups with \\<gnus-group-mode-map>\\[gnus-find-new-newsgroups]." :group 'gnus-start :type '(choice (const :tag "no" nil) (const :tag "by brute force" t) (const :tag "ask servers" ask-server) (repeat :menu-tag "ask additional servers" :tag "ask additional servers" :value ((nntp "")) (sexp :format "%v"))))

(defcustom gnus-check-bogus-newsgroups nil "\
*Non-nil means that Gnus will check and remove bogus newsgroup at startup.
If this variable is nil, then you have to tell Gnus explicitly to
check for bogus newsgroups with \\<gnus-group-mode-map>\\[gnus-group-check-bogus-groups]." :group 'gnus-start-server :type 'boolean)

(defcustom gnus-read-active-file 'some "\
*Non-nil means that Gnus will read the entire active file at startup.
If this variable is nil, Gnus will only know about the groups in your
`.newsrc' file.

If this variable is `some', Gnus will try to only read the relevant
parts of the active file from the server.  Not all servers support
this, and it might be quite slow with other servers, but this should
generally be faster than both the t and nil value.

If you set this variable to nil or `some', you probably still want to
be told about new newsgroups that arrive.  To do that, set
`gnus-check-new-newsgroups' to `ask-server'.  This may not work
properly with all servers." :group 'gnus-start-server :type '(choice (const nil) (const some) (const t)))

(defcustom gnus-level-default-subscribed 3 "\
*New subscribed groups will be subscribed at this level." :group 'gnus-group-levels :type 'integer)

(defcustom gnus-level-default-unsubscribed 6 "\
*New unsubscribed groups will be unsubscribed at this level." :group 'gnus-group-levels :type 'integer)

(defcustom gnus-activate-level (1+ gnus-level-subscribed) "\
*Groups higher than this level won't be activated on startup.
Setting this variable to something low might save lots of time when
you have many groups that you aren't interested in." :group 'gnus-group-levels :type 'integer)

(defcustom gnus-activate-foreign-newsgroups 4 "\
*If nil, Gnus will not check foreign newsgroups at startup.
If it is non-nil, it should be a number between one and nine.  Foreign
newsgroups that have a level lower or equal to this number will be
activated on startup.  For instance, if you want to active all
subscribed newsgroups, but not the rest, you'd set this variable to
`gnus-level-subscribed'.

If you subscribe to lots of newsgroups from different servers, startup
might take a while.  By setting this variable to nil, you'll save time,
but you won't be told how many unread articles there are in the
groups." :group 'gnus-group-levels :type '(choice integer (const :tag "none" nil)))

(defcustom gnus-read-newsrc-file t "\
*Non-nil means that Gnus will read the `.newsrc' file.
Gnus always reads its own startup file, which is called
\".newsrc.eld\".  The file called \".newsrc\" is in a format that can
be readily understood by other newsreaders.  If you don't plan on
using other newsreaders, set this variable to nil to save some time on
entry." :version "21.1" :group 'gnus-newsrc :type 'boolean)

(defcustom gnus-save-newsrc-file t "\
*Non-nil means that Gnus will save the `.newsrc' file.
Gnus always saves its own startup file, which is called
\".newsrc.eld\".  The file called \".newsrc\" is in a format that can
be readily understood by other newsreaders.  If you don't plan on
using other newsreaders, set this variable to nil to save some time on
exit." :group 'gnus-newsrc :type 'boolean)

(defcustom gnus-save-killed-list t "\
*If non-nil, save the list of killed groups to the startup file.
If you set this variable to nil, you'll save both time (when starting
and quitting) and space (both memory and disk), but it will also mean
that Gnus has no record of which groups are new and which are old, so
the automatic new newsgroups subscription methods become meaningless.

You should always set `gnus-check-new-newsgroups' to `ask-server' or
nil if you set this variable to nil.

This variable can also be a regexp.  In that case, all groups that do
not match this regexp will be removed before saving the list." :group 'gnus-newsrc :type '(radio (sexp :format "Non-nil
" :match (lambda (widget value) (and value (not (stringp value)))) :value t) (const nil) regexp))

(defcustom gnus-ignored-newsgroups (mapconcat 'identity '("^to\\." "^[0-9. 	]+\\( \\|$\\)" "^[\"][]\"[#'()]") "\\|") "\
*A regexp to match uninteresting newsgroups in the active file.
Any lines in the active file matching this regular expression are
removed from the newsgroup list before anything else is done to it,
thus making them effectively non-existent." :group 'gnus-group-new :type 'regexp)

(defcustom gnus-subscribe-newsgroup-method 'gnus-subscribe-zombies "\
*Function(s) called with a group name when new group is detected.
A few pre-made functions are supplied: `gnus-subscribe-randomly'
inserts new groups at the beginning of the list of groups;
`gnus-subscribe-alphabetically' inserts new groups in strict
alphabetic order; `gnus-subscribe-hierarchically' inserts new groups
in hierarchical newsgroup order; `gnus-subscribe-interactively' asks
for your decision; `gnus-subscribe-killed' kills all new groups;
`gnus-subscribe-zombies' will make all new groups into zombies;
`gnus-subscribe-topics' will enter groups into the topics that
claim them." :group 'gnus-group-new :type '(radio (function-item gnus-subscribe-randomly) (function-item gnus-subscribe-alphabetically) (function-item gnus-subscribe-hierarchically) (function-item gnus-subscribe-interactively) (function-item gnus-subscribe-killed) (function-item gnus-subscribe-zombies) (function-item gnus-subscribe-topics) function (repeat function)))

(defcustom gnus-subscribe-newsgroup-hooks nil "\
*Hooks run after you subscribe to a new group.
The hooks will be called with new group's name as argument." :version "22.1" :group 'gnus-group-new :type 'hook)

(defcustom gnus-subscribe-options-newsgroup-method 'gnus-subscribe-alphabetically "\
*Function(s) called to subscribe newsgroups mentioned on \"options -n\" lines.
If, for instance, you want to subscribe to all newsgroups in the
\"no\" and \"alt\" hierarchies, you'd put the following in your
.newsrc file:

options -n no.all alt.all

Gnus will then subscribe all new newsgroups in these hierarchies
with the subscription method in this variable." :group 'gnus-group-new :type '(radio (function-item gnus-subscribe-randomly) (function-item gnus-subscribe-alphabetically) (function-item gnus-subscribe-hierarchically) (function-item gnus-subscribe-interactively) (function-item gnus-subscribe-killed) (function-item gnus-subscribe-zombies) (function-item gnus-subscribe-topics) function (repeat function)))

(defcustom gnus-subscribe-hierarchical-interactive nil "\
*If non-nil, Gnus will offer to subscribe hierarchically.
When a new hierarchy appears, Gnus will ask the user:

'alt.binaries': Do you want to subscribe to this hierarchy? ([d]ys):

If the user pressed `d', Gnus will descend the hierarchy, `y' will
subscribe to all newsgroups in the hierarchy and `s' will skip this
hierarchy in its entirety." :group 'gnus-group-new :type 'boolean)

(defcustom gnus-auto-subscribed-groups "^nnml\\|^nnfolder\\|^nnmbox\\|^nnmh\\|^nnbabyl\\|^nnmaildir" "\
*All new groups that match this regexp will be subscribed automatically.
Note that this variable only deals with new groups.  It has no effect
whatsoever on old groups.

New groups that match this regexp will not be handled by
`gnus-subscribe-newsgroup-method'.  Instead, they will
be subscribed using `gnus-subscribe-options-newsgroup-method'." :group 'gnus-group-new :type 'regexp)

(defcustom gnus-options-subscribe nil "\
*All new groups matching this regexp will be subscribed unconditionally.
Note that this variable deals only with new newsgroups.  This variable
does not affect old newsgroups.

New groups that match this regexp will not be handled by
`gnus-subscribe-newsgroup-method'.  Instead, they will
be subscribed using `gnus-subscribe-options-newsgroup-method'." :group 'gnus-group-new :type '(choice regexp (const :tag "none" nil)))

(defcustom gnus-options-not-subscribe nil "\
*All new groups matching this regexp will be ignored.
Note that this variable deals only with new newsgroups.  This variable
does not affect old (already subscribed) newsgroups." :group 'gnus-group-new :type '(choice regexp (const :tag "none" nil)))

(defcustom gnus-modtime-botch nil "\
*Non-nil means .newsrc should be deleted prior to save.
Its use is due to the bogus appearance that .newsrc was modified on
disc." :group 'gnus-newsrc :type 'boolean)

(defcustom gnus-check-bogus-groups-hook nil "\
A hook run after removing bogus groups." :group 'gnus-start-server :type 'hook)

(defcustom gnus-startup-hook nil "\
A hook called at startup.
This hook is called after Gnus is connected to the NNTP server." :group 'gnus-start :type 'hook)

(defcustom gnus-before-startup-hook nil "\
A hook called at before startup.
This hook is called as the first thing when Gnus is started." :group 'gnus-start :type 'hook)

(defcustom gnus-started-hook nil "\
A hook called as the last thing after startup." :group 'gnus-start :type 'hook)

(defcustom gnus-setup-news-hook '(gnus-fixup-nnimap-unread-after-getting-new-news) "\
A hook after reading the .newsrc file, but before generating the buffer." :group 'gnus-start :type 'hook)

(defcustom gnus-get-top-new-news-hook nil "\
A hook run just before Gnus checks for new news globally." :version "22.1" :group 'gnus-group-new :type 'hook)

(defcustom gnus-get-new-news-hook nil "\
A hook run just before Gnus checks for new news." :group 'gnus-group-new :type 'hook)

(defcustom gnus-after-getting-new-news-hook '(gnus-display-time-event-handler gnus-fixup-nnimap-unread-after-getting-new-news) "\
*A hook run after Gnus checks for new news when Gnus is already running." :group 'gnus-group-new :type 'hook)

(defcustom gnus-read-newsrc-el-hook nil "\
A hook called after reading the newsrc.eld? file." :group 'gnus-newsrc :type 'hook)

(defcustom gnus-save-newsrc-hook nil "\
A hook called before saving any of the newsrc files." :group 'gnus-newsrc :type 'hook)

(defcustom gnus-save-quick-newsrc-hook nil "\
A hook called just before saving the quick newsrc file.
Can be used to turn version control on or off." :group 'gnus-newsrc :type 'hook)

(defcustom gnus-save-standard-newsrc-hook nil "\
A hook called just before saving the standard newsrc file.
Can be used to turn version control on or off." :group 'gnus-newsrc :type 'hook)

(defcustom gnus-group-mode-hook nil "\
Hook for Gnus group mode." :group 'gnus-group-various :options '(gnus-topic-mode) :type 'hook)

(defcustom gnus-always-read-dribble-file nil "\
Unconditionally read the dribble file." :group 'gnus-newsrc :type 'boolean)

;;;***

;;;### (autoloads (gnus-summary-display-while-building gnus-summary-respool-default-method gnus-sum-thread-tree-single-leaf gnus-sum-thread-tree-leaf-with-other gnus-sum-thread-tree-indent gnus-sum-thread-tree-vertical gnus-sum-thread-tree-single-indent gnus-sum-thread-tree-false-root gnus-sum-thread-tree-root gnus-summary-tool-bar-zap-list gnus-summary-tool-bar-retro gnus-summary-tool-bar-gnome gnus-summary-tool-bar gnus-article-emulate-mime gnus-article-loose-mime gnus-summary-muttprint-program gnus-read-all-available-headers gnus-summary-save-parts-default-mime gnus-orphan-score gnus-alter-articles-to-read-function gnus-preserve-marks gnus-summary-show-article-charset-alist gnus-group-highlight-words-alist gnus-newsgroup-maximum-articles gnus-newsgroup-ignored-charsets gnus-ignored-from-addresses gnus-extra-headers gnus-alter-header-function gnus-summary-highlight gnus-summary-selected-face gnus-summary-display-arrow gnus-summary-article-expire-hook gnus-summary-article-delete-hook gnus-summary-article-move-hook gnus-ps-print-hook gnus-group-no-more-groups-hook gnus-mark-article-hook gnus-summary-update-hook gnus-exit-group-hook gnus-parse-headers-hook gnus-visual-mark-article-hook gnus-select-article-hook gnus-select-group-hook gnus-summary-generate-hook gnus-summary-prepared-hook gnus-summary-prepare-hook gnus-summary-exit-hook gnus-summary-menu-hook gnus-summary-mode-hook gnus-thread-expunge-below gnus-summary-expunge-below gnus-thread-score-function gnus-thread-sort-functions gnus-article-sort-functions gnus-summary-mark-below gnus-list-identifiers gnus-summary-mode-line-format gnus-summary-dummy-line-format gnus-insert-pseudo-articles gnus-view-pseudos-separately gnus-view-pseudos gnus-inhibit-user-auto-expire gnus-auto-expirable-marks gnus-view-pseudo-asynchronously gnus-not-empty-thread-mark gnus-empty-thread-mark gnus-score-below-mark gnus-score-over-mark gnus-unsendable-mark gnus-downloadable-mark gnus-downloaded-mark gnus-undownloaded-mark gnus-duplicate-mark gnus-canceled-mark gnus-sparse-mark gnus-ancient-mark gnus-no-mark gnus-unseen-mark gnus-saved-mark gnus-cached-mark gnus-recent-mark gnus-forwarded-mark gnus-replied-mark gnus-catchup-mark gnus-low-score-mark gnus-kill-file-mark gnus-souped-mark gnus-spam-mark gnus-killed-mark gnus-expirable-mark gnus-read-mark gnus-del-mark gnus-dormant-mark gnus-ticked-mark gnus-unread-mark gnus-move-split-methods gnus-break-pages gnus-single-article-buffer gnus-summary-ignore-duplicates gnus-show-all-headers gnus-auto-center-summary gnus-summary-check-current gnus-auto-goto-ignores gnus-auto-select-same gnus-auto-select-next gnus-auto-select-subject gnus-auto-select-first gnus-auto-extend-newsgroup gnus-thread-indent-level gnus-thread-operation-ignore-subject gnus-thread-ignore-subject gnus-thread-hide-killed gnus-thread-hide-subtree gnus-show-threads gnus-simplify-subject-fuzzy-regexp gnus-summary-zcore-fuzz gnus-summary-default-low-score gnus-summary-default-high-score gnus-summary-default-score gnus-summary-goto-unread gnus-summary-same-subject gnus-summary-thread-gathering-function gnus-build-sparse-threads gnus-simplify-ignored-prefixes gnus-simplify-subject-functions gnus-summary-gather-subject-limit gnus-summary-gather-exclude-subject gnus-summary-make-false-root-always gnus-summary-make-false-root gnus-refer-thread-limit gnus-fetch-old-headers gnus-kill-summary-on-exit) "gnus-sum" "lisp/gnus-sum.el")
(defconst custom-define-current-source-file "gnus-sum.el")

(defcustom gnus-kill-summary-on-exit t "\
*If non-nil, kill the summary buffer when you exit from it.
If nil, the summary will become a \"*Dead Summary*\" buffer, and
it will be killed sometime later." :group 'gnus-summary-exit :type 'boolean)

(defcustom gnus-fetch-old-headers nil "\
*Non-nil means that Gnus will try to build threads by grabbing old headers.
If an unread article in the group refers to an older, already read (or
just marked as read) article, the old article will not normally be
displayed in the Summary buffer.  If this variable is t, Gnus
will attempt to grab the headers to the old articles, and thereby
build complete threads.  If it has the value `some', only enough
headers to connect otherwise loose threads will be displayed.  This
variable can also be a number.  In that case, no more than that number
of old headers will be fetched.  If it has the value `invisible', all
old headers will be fetched, but none will be displayed.

The server has to support NOV for any of this to work." :group 'gnus-thread :type '(choice (const :tag "off" nil) (const :tag "on" t) (const some) (const invisible) number (sexp :menu-tag "other" t)))

(defcustom gnus-refer-thread-limit 200 "\
*The number of old headers to fetch when doing \\<gnus-summary-mode-map>\\[gnus-summary-refer-thread].
If t, fetch all the available old headers." :group 'gnus-thread :type '(choice number (sexp :menu-tag "other" t)))

(defcustom gnus-summary-make-false-root 'adopt "\
*nil means that Gnus won't gather loose threads.
If the root of a thread has expired or been read in a previous
session, the information necessary to build a complete thread has been
lost.  Instead of having many small sub-threads from this original thread
scattered all over the summary buffer, Gnus can gather them.

If non-nil, Gnus will try to gather all loose sub-threads from an
original thread into one large thread.

If this variable is non-nil, it should be one of `none', `adopt',
`dummy' or `empty'.

If this variable is `none', Gnus will not make a false root, but just
present the sub-threads after another.
If this variable is `dummy', Gnus will create a dummy root that will
have all the sub-threads as children.
If this variable is `adopt', Gnus will make one of the \"children\"
the parent and mark all the step-children as such.
If this variable is `empty', the \"children\" are printed with empty
subject fields.  (Or rather, they will be printed with a string
given by the `gnus-summary-same-subject' variable.)" :group 'gnus-thread :type '(choice (const :tag "off" nil) (const none) (const dummy) (const adopt) (const empty)))

(defcustom gnus-summary-make-false-root-always nil "\
Always make a false dummy root." :version "22.1" :group 'gnus-thread :type 'boolean)

(defcustom gnus-summary-gather-exclude-subject "^ *$\\|^(none)$" "\
*A regexp to match subjects to be excluded from loose thread gathering.
As loose thread gathering is done on subjects only, that means that
there can be many false gatherings performed.  By rooting out certain
common subjects, gathering might become saner." :group 'gnus-thread :type 'regexp)

(defcustom gnus-summary-gather-subject-limit nil "\
*Maximum length of subject comparisons when gathering loose threads.
Use nil to compare full subjects.  Setting this variable to a low
number will help gather threads that have been corrupted by
newsreaders chopping off subject lines, but it might also mean that
unrelated articles that have subject that happen to begin with the
same few characters will be incorrectly gathered.

If this variable is `fuzzy', Gnus will use a fuzzy algorithm when
comparing subjects." :group 'gnus-thread :type '(choice (const :tag "off" nil) (const fuzzy) (sexp :menu-tag "on" t)))

(defcustom gnus-simplify-subject-functions nil "\
List of functions taking a string argument that simplify subjects.
The functions are applied recursively.

Useful functions to put in this list include:
`gnus-simplify-subject-re', `gnus-simplify-subject-fuzzy',
`gnus-simplify-whitespace', and `gnus-simplify-all-whitespace'." :group 'gnus-thread :type '(repeat function))

(defcustom gnus-simplify-ignored-prefixes nil "\
*Remove matches for this regexp from subject lines when simplifying fuzzily." :group 'gnus-thread :type '(choice (const :tag "off" nil) regexp))

(defcustom gnus-build-sparse-threads nil "\
*If non-nil, fill in the gaps in threads.
If `some', only fill in the gaps that are needed to tie loose threads
together.  If `more', fill in all leaf nodes that Gnus can find.  If
non-nil and non-`some', fill in all gaps that Gnus manages to guess." :group 'gnus-thread :type '(choice (const :tag "off" nil) (const some) (const more) (sexp :menu-tag "all" t)))

(defcustom gnus-summary-thread-gathering-function 'gnus-gather-threads-by-subject "\
*Function used for gathering loose threads.
There are two pre-defined functions: `gnus-gather-threads-by-subject',
which only takes Subjects into consideration; and
`gnus-gather-threads-by-references', which compared the References
headers of the articles to find matches." :group 'gnus-thread :type '(radio (function-item gnus-gather-threads-by-subject) (function-item gnus-gather-threads-by-references) (function :tag "other")))

(defcustom gnus-summary-same-subject "" "\
*String indicating that the current article has the same subject as the previous.
This variable will only be used if the value of
`gnus-summary-make-false-root' is `empty'." :group 'gnus-summary-format :type 'string)

(defcustom gnus-summary-goto-unread t "\
*If t, many commands will go to the next unread article.
This applies to marking commands as well as other commands that
\"naturally\" select the next article, like, for instance, `SPC' at
the end of an article.

If nil, the marking commands do NOT go to the next unread article
\(they go to the next article instead).  If `never', commands that
usually go to the next unread article, will go to the next article,
whether it is read or not." :group 'gnus-summary-marks :link '(custom-manual "(gnus)Setting Marks") :type '(choice (const :tag "off" nil) (const never) (sexp :menu-tag "on" t)))

(defcustom gnus-summary-default-score 0 "\
*Default article score level.
All scores generated by the score files will be added to this score.
If this variable is nil, scoring will be disabled." :group 'gnus-score-default :type '(choice (const :tag "disable") integer))

(defcustom gnus-summary-default-high-score 0 "\
*Default threshold for a high scored article.
An article will be highlighted as high scored if its score is greater
than this score." :version "22.1" :group 'gnus-score-default :type 'integer)

(defcustom gnus-summary-default-low-score 0 "\
*Default threshold for a low scored article.
An article will be highlighted as low scored if its score is smaller
than this score." :version "22.1" :group 'gnus-score-default :type 'integer)

(defcustom gnus-summary-zcore-fuzz 0 "\
*Fuzziness factor for the zcore in the summary buffer.
Articles with scores closer than this to `gnus-summary-default-score'
will not be marked." :group 'gnus-summary-format :type 'integer)

(defcustom gnus-simplify-subject-fuzzy-regexp nil "\
*Strings to be removed when doing fuzzy matches.
This can either be a regular expression or list of regular expressions
that will be removed from subject strings if fuzzy subject
simplification is selected." :group 'gnus-thread :type '(repeat regexp))

(defcustom gnus-show-threads t "\
*If non-nil, display threads in summary mode." :group 'gnus-thread :type 'boolean)

(defcustom gnus-thread-hide-subtree nil "\
*If non-nil, hide all threads initially.
This can be a predicate specifier which says which threads to hide.
If threads are hidden, you have to run the command
`gnus-summary-show-thread' by hand or select an article." :group 'gnus-thread :type '(radio (sexp :format "Non-nil
" :match (lambda (widget value) (not (or (consp value) (functionp value)))) :value t) (const nil) (sexp :tag "Predicate specifier")))

(defcustom gnus-thread-hide-killed t "\
*If non-nil, hide killed threads automatically." :group 'gnus-thread :type 'boolean)

(defcustom gnus-thread-ignore-subject t "\
*If non-nil, which is the default, ignore subjects and do all threading based on the Reference header.
If nil, articles that have different subjects from their parents will
start separate threads." :group 'gnus-thread :type 'boolean)

(defcustom gnus-thread-operation-ignore-subject t "\
*If non-nil, subjects will be ignored when doing thread commands.
This affects commands like `gnus-summary-kill-thread' and
`gnus-summary-lower-thread'.

If this variable is nil, articles in the same thread with different
subjects will not be included in the operation in question.  If this
variable is `fuzzy', only articles that have subjects that are fuzzily
equal will be included." :group 'gnus-thread :type '(choice (const :tag "off" nil) (const fuzzy) (sexp :tag "on" t)))

(defcustom gnus-thread-indent-level 4 "\
*Number that says how much each sub-thread should be indented." :group 'gnus-thread :type 'integer)

(defcustom gnus-auto-extend-newsgroup t "\
*If non-nil, extend newsgroup forward and backward when requested." :group 'gnus-summary-choose :type 'boolean)

(defcustom gnus-auto-select-first t "\
If non-nil, select an article on group entry.
An article is selected automatically when entering a group
e.g. with \\<gnus-group-mode-map>\\[gnus-group-read-group], or via `gnus-summary-next-page' or
`gnus-summary-catchup-and-goto-next-group'.

Which article is selected is controlled by the variable
`gnus-auto-select-subject'.

If you want to prevent automatic selection of articles in some
newsgroups, set the variable to nil in `gnus-select-group-hook'." :group 'gnus-group-select :type '(choice (const :tag "none" nil) (sexp :menu-tag "first" t)))

(defcustom gnus-auto-select-subject 'unread "\
*Says what subject to place under point when entering a group.

This variable can either be the symbols `first' (place point on the
first subject), `unread' (place point on the subject line of the first
unread article), `best' (place point on the subject line of the
higest-scored article), `unseen' (place point on the subject line of
the first unseen article), `unseen-or-unread' (place point on the subject
line of the first unseen article or, if all article have been seen, on the
subject line of the first unread article), or a function to be called to
place point on some subject line." :version "22.1" :group 'gnus-group-select :type '(choice (const best) (const unread) (const first) (const unseen) (const unseen-or-unread)))

(defcustom gnus-auto-select-next t "\
*If non-nil, offer to go to the next group from the end of the previous.
If the value is t and the next newsgroup is empty, Gnus will exit
summary mode and go back to group mode.  If the value is neither nil
nor t, Gnus will select the following unread newsgroup.  In
particular, if the value is the symbol `quietly', the next unread
newsgroup will be selected without any confirmation, and if it is
`almost-quietly', the next group will be selected without any
confirmation if you are located on the last article in the group.
Finally, if this variable is `slightly-quietly', the `\\<gnus-summary-mode-map>\\[gnus-summary-catchup-and-goto-next-group]' command
will go to the next group without confirmation." :group 'gnus-summary-maneuvering :type '(choice (const :tag "off" nil) (const quietly) (const almost-quietly) (const slightly-quietly) (sexp :menu-tag "on" t)))

(defcustom gnus-auto-select-same nil "\
*If non-nil, select the next article with the same subject.
If there are no more articles with the same subject, go to
the first unread article." :group 'gnus-summary-maneuvering :type 'boolean)

(defcustom gnus-auto-goto-ignores 'unfetched "\
*Says how to handle unfetched articles when maneuvering.

This variable can either be the symbols nil (maneuver to any
article), `undownloaded' (maneuvering while unplugged ignores articles
that have not been fetched), `always-undownloaded' (maneuvering always
ignores articles that have not been fetched), `unfetched' (maneuvering
ignores articles whose headers have not been fetched).

NOTE: The list of unfetched articles will always be nil when plugged
and, when unplugged, a subset of the undownloaded article list." :version "22.1" :group 'gnus-summary-maneuvering :type '(choice (const :tag "None" nil) (const :tag "Undownloaded when unplugged" undownloaded) (const :tag "Undownloaded" always-undownloaded) (const :tag "Unfetched" unfetched)))

(defcustom gnus-summary-check-current nil "\
*If non-nil, consider the current article when moving.
The \"unread\" movement commands will stay on the same line if the
current article is unread." :group 'gnus-summary-maneuvering :type 'boolean)

(defcustom gnus-auto-center-summary t "\
*If non-nil, always center the current summary buffer.
In particular, if `vertical' do only vertical recentering.  If non-nil
and non-`vertical', do both horizontal and vertical recentering." :group 'gnus-summary-maneuvering :type '(choice (const :tag "none" nil) (const vertical) (integer :tag "height") (sexp :menu-tag "both" t)))

(defcustom gnus-show-all-headers nil "\
*If non-nil, don't hide any headers." :group 'gnus-article-hiding :group 'gnus-article-headers :type 'boolean)

(defcustom gnus-summary-ignore-duplicates nil "\
*If non-nil, ignore articles with identical Message-ID headers." :group 'gnus-summary :type 'boolean)

(defcustom gnus-single-article-buffer t "\
*If non-nil, display all articles in the same buffer.
If nil, each group will get its own article buffer." :group 'gnus-article-various :type 'boolean)

(defcustom gnus-break-pages t "\
*If non-nil, do page breaking on articles.
The page delimiter is specified by the `gnus-page-delimiter'
variable." :group 'gnus-article-various :type 'boolean)

(defcustom gnus-move-split-methods nil "\
*Variable used to suggest where articles are to be moved to.
It uses the same syntax as the `gnus-split-methods' variable.
However, whereas `gnus-split-methods' specifies file names as targets,
this variable specifies group names." :group 'gnus-summary-mail :type '(repeat (choice (list :value (fun) function) (cons :value ("" "") regexp (repeat string)) (sexp :value nil))))

(defcustom gnus-unread-mark ?\  "\
*Mark used for unread articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-ticked-mark ?! "\
*Mark used for ticked articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-dormant-mark ?\? "\
*Mark used for dormant articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-del-mark ?r "\
*Mark used for del'd articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-read-mark ?R "\
*Mark used for read articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-expirable-mark ?E "\
*Mark used for expirable articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-killed-mark ?K "\
*Mark used for killed articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-spam-mark ?$ "\
*Mark used for spam articles." :version "22.1" :group 'gnus-summary-marks :type 'character)

(defcustom gnus-souped-mark ?F "\
*Mark used for souped articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-kill-file-mark ?X "\
*Mark used for articles killed by kill files." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-low-score-mark ?Y "\
*Mark used for articles with a low score." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-catchup-mark ?C "\
*Mark used for articles that are caught up." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-replied-mark ?A "\
*Mark used for articles that have been replied to." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-forwarded-mark ?F "\
*Mark used for articles that have been forwarded." :version "22.1" :group 'gnus-summary-marks :type 'character)

(defcustom gnus-recent-mark ?N "\
*Mark used for articles that are recent." :version "22.1" :group 'gnus-summary-marks :type 'character)

(defcustom gnus-cached-mark ?* "\
*Mark used for articles that are in the cache." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-saved-mark ?S "\
*Mark used for articles that have been saved." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-unseen-mark ?\. "\
*Mark used for articles that haven't been seen." :version "22.1" :group 'gnus-summary-marks :type 'character)

(defcustom gnus-no-mark ?\  "\
*Mark used for articles that have no other secondary mark." :version "22.1" :group 'gnus-summary-marks :type 'character)

(defcustom gnus-ancient-mark ?O "\
*Mark used for ancient articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-sparse-mark ?Q "\
*Mark used for sparsely reffed articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-canceled-mark ?G "\
*Mark used for canceled articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-duplicate-mark ?M "\
*Mark used for duplicate articles." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-undownloaded-mark ?- "\
*Mark used for articles that weren't downloaded." :version "22.1" :group 'gnus-summary-marks :type 'character)

(defcustom gnus-downloaded-mark ?+ "\
*Mark used for articles that were downloaded." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-downloadable-mark ?% "\
*Mark used for articles that are to be downloaded." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-unsendable-mark ?= "\
*Mark used for articles that won't be sent." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-score-over-mark ?+ "\
*Score mark used for articles with high scores." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-score-below-mark ?- "\
*Score mark used for articles with low scores." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-empty-thread-mark ?\  "\
*There is no thread under the article." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-not-empty-thread-mark ?= "\
*There is a thread under the article." :group 'gnus-summary-marks :type 'character)

(defcustom gnus-view-pseudo-asynchronously nil "\
*If non-nil, Gnus will view pseudo-articles asynchronously." :group 'gnus-extract-view :type 'boolean)

(defcustom gnus-auto-expirable-marks (list gnus-killed-mark gnus-del-mark gnus-catchup-mark gnus-low-score-mark gnus-ancient-mark gnus-read-mark gnus-souped-mark gnus-duplicate-mark) "\
*The list of marks converted into expiration if a group is auto-expirable." :version "21.1" :group 'gnus-summary :type '(repeat character))

(defcustom gnus-inhibit-user-auto-expire t "\
*If non-nil, user marking commands will not mark an article as expirable, even if the group has auto-expire turned on." :version "21.1" :group 'gnus-summary :type 'boolean)

(defcustom gnus-view-pseudos nil "\
*If `automatic', pseudo-articles will be viewed automatically.
If `not-confirm', pseudos will be viewed automatically, and the user
will not be asked to confirm the command." :group 'gnus-extract-view :type '(choice (const :tag "off" nil) (const automatic) (const not-confirm)))

(defcustom gnus-view-pseudos-separately t "\
*If non-nil, one pseudo-article will be created for each file to be viewed.
If nil, all files that use the same viewing command will be given as a
list of parameters to that command." :group 'gnus-extract-view :type 'boolean)

(defcustom gnus-insert-pseudo-articles t "\
*If non-nil, insert pseudo-articles when decoding articles." :group 'gnus-extract-view :type 'boolean)

(defcustom gnus-summary-dummy-line-format "   %(:                             :%) %S\n" "\
*The format specification for the dummy roots in the summary buffer.
It works along the same lines as a normal formatting string,
with some simple extensions.

%S  The subject

General format specifiers can also be used.
See `(gnus)Formatting Variables'." :link '(custom-manual "(gnus)Formatting Variables") :group 'gnus-threading :type 'string)

(defcustom gnus-summary-mode-line-format "Gnus: %g [%A] %Z" "\
*The format specification for the summary mode line.
It works along the same lines as a normal formatting string,
with some simple extensions:

%G  Group name
%p  Unprefixed group name
%A  Current article number
%z  Current article score
%V  Gnus version
%U  Number of unread articles in the group
%e  Number of unselected articles in the group
%Z  A string with unread/unselected article counts
%g  Shortish group name
%S  Subject of the current article
%u  User-defined spec
%s  Current score file name
%d  Number of dormant articles
%r  Number of articles that have been marked as read in this session
%E  Number of articles expunged by the score files" :group 'gnus-summary-format :type 'string)

(defcustom gnus-list-identifiers nil "\
Regexp that matches list identifiers to be removed from subject.
This can also be a list of regexps." :version "21.1" :group 'gnus-summary-format :group 'gnus-article-hiding :type '(choice (const :tag "none" nil) (regexp :value ".*") (repeat :value (".*") regexp)))

(defcustom gnus-summary-mark-below 0 "\
*Mark all articles with a score below this variable as read.
This variable is local to each summary buffer and usually set by the
score file." :group 'gnus-score-default :type 'integer)

(defcustom gnus-article-sort-functions '(gnus-article-sort-by-number) "\
*List of functions used for sorting articles in the summary buffer.

Each function takes two articles and returns non-nil if the first
article should be sorted before the other.  If you use more than one
function, the primary sort function should be the last.  You should
probably always include `gnus-article-sort-by-number' in the list of
sorting functions -- preferably first.  Also note that sorting by date
is often much slower than sorting by number, and the sorting order is
very similar.  (Sorting by date means sorting by the time the message
was sent, sorting by number means sorting by arrival time.)

Ready-made functions include `gnus-article-sort-by-number',
`gnus-article-sort-by-author', `gnus-article-sort-by-subject',
`gnus-article-sort-by-date', `gnus-article-sort-by-random'
and `gnus-article-sort-by-score'.

When threading is turned on, the variable `gnus-thread-sort-functions'
controls how articles are sorted." :group 'gnus-summary-sort :type '(repeat (choice (function-item gnus-article-sort-by-number) (function-item gnus-article-sort-by-author) (function-item gnus-article-sort-by-subject) (function-item gnus-article-sort-by-date) (function-item gnus-article-sort-by-score) (function-item gnus-article-sort-by-random) (function :tag "other"))))

(defcustom gnus-thread-sort-functions '(gnus-thread-sort-by-number) "\
*List of functions used for sorting threads in the summary buffer.
By default, threads are sorted by article number.

Each function takes two threads and returns non-nil if the first
thread should be sorted before the other.  If you use more than one
function, the primary sort function should be the last.  You should
probably always include `gnus-thread-sort-by-number' in the list of
sorting functions -- preferably first.  Also note that sorting by date
is often much slower than sorting by number, and the sorting order is
very similar.  (Sorting by date means sorting by the time the message
was sent, sorting by number means sorting by arrival time.)

Ready-made functions include `gnus-thread-sort-by-number',
`gnus-thread-sort-by-author', `gnus-thread-sort-by-subject',
`gnus-thread-sort-by-date', `gnus-thread-sort-by-score',
`gnus-thread-sort-by-most-recent-number',
`gnus-thread-sort-by-most-recent-date',
`gnus-thread-sort-by-random', and
`gnus-thread-sort-by-total-score' (see `gnus-thread-score-function').

When threading is turned off, the variable
`gnus-article-sort-functions' controls how articles are sorted." :group 'gnus-summary-sort :type '(repeat (choice (function-item gnus-thread-sort-by-number) (function-item gnus-thread-sort-by-author) (function-item gnus-thread-sort-by-subject) (function-item gnus-thread-sort-by-date) (function-item gnus-thread-sort-by-score) (function-item gnus-thread-sort-by-total-score) (function-item gnus-thread-sort-by-random) (function :tag "other"))))

(defcustom gnus-thread-score-function '+ "\
*Function used for calculating the total score of a thread.

The function is called with the scores of the article and each
subthread and should then return the score of the thread.

Some functions you can use are `+', `max', or `min'." :group 'gnus-summary-sort :type 'function)

(defcustom gnus-summary-expunge-below nil "\
All articles that have a score less than this variable will be expunged.
This variable is local to the summary buffers." :group 'gnus-score-default :type '(choice (const :tag "off" nil) integer))

(defcustom gnus-thread-expunge-below nil "\
All threads that have a total score less than this variable will be expunged.
See `gnus-thread-score-function' for en explanation of what a
\"thread score\" is.

This variable is local to the summary buffers." :group 'gnus-threading :group 'gnus-score-default :type '(choice (const :tag "off" nil) integer))

(defcustom gnus-summary-mode-hook nil "\
*A hook for Gnus summary mode.
This hook is run before any variables are set in the summary buffer." :options '(turn-on-gnus-mailing-list-mode gnus-pick-mode) :group 'gnus-summary-various :type 'hook)

(defcustom gnus-summary-menu-hook nil "\
*Hook run after the creation of the summary mode menu." :group 'gnus-summary-visual :type 'hook)

(defcustom gnus-summary-exit-hook nil "\
*A hook called on exit from the summary buffer.
It will be called with point in the group buffer." :group 'gnus-summary-exit :type 'hook)

(defcustom gnus-summary-prepare-hook nil "\
*A hook called after the summary buffer has been generated.
If you want to modify the summary buffer, you can use this hook." :group 'gnus-summary-various :type 'hook)

(defcustom gnus-summary-prepared-hook nil "\
*A hook called as the last thing after the summary buffer has been generated." :group 'gnus-summary-various :type 'hook)

(defcustom gnus-summary-generate-hook nil "\
*A hook run just before generating the summary buffer.
This hook is commonly used to customize threading variables and the
like." :group 'gnus-summary-various :type 'hook)

(defcustom gnus-select-group-hook nil "\
*A hook called when a newsgroup is selected.

If you'd like to simplify subjects like the
`gnus-summary-next-same-subject' command does, you can use the
following hook:

 (add-hook gnus-select-group-hook
	   (lambda ()
	     (mapcar (lambda (header)
		       (mail-header-set-subject
			header
			(gnus-simplify-subject
			 (mail-header-subject header) 're-only)))
		     gnus-newsgroup-headers)))" :group 'gnus-group-select :type 'hook)

(defcustom gnus-select-article-hook nil "\
*A hook called when an article is selected." :group 'gnus-summary-choose :options '(gnus-agent-fetch-selected-article) :type 'hook)

(defcustom gnus-visual-mark-article-hook (list 'gnus-highlight-selected-summary) "\
*Hook run after selecting an article in the summary buffer.
It is meant to be used for highlighting the article in some way.  It
is not run if `gnus-visual' is nil." :group 'gnus-summary-visual :type 'hook)

(defcustom gnus-parse-headers-hook nil "\
*A hook called before parsing the headers." :group 'gnus-various :type 'hook)

(defcustom gnus-exit-group-hook nil "\
*A hook called when exiting summary mode.
This hook is not called from the non-updating exit commands like `Q'." :group 'gnus-various :type 'hook)

(defcustom gnus-summary-update-hook (list 'gnus-summary-highlight-line) "\
*A hook called when a summary line is changed.
The hook will not be called if `gnus-visual' is nil.

The default function `gnus-summary-highlight-line' will
highlight the line according to the `gnus-summary-highlight'
variable." :group 'gnus-summary-visual :type 'hook)

(defcustom gnus-mark-article-hook '(gnus-summary-mark-read-and-unread-as-read) "\
*A hook called when an article is selected for the first time.
The hook is intended to mark an article as read (or unread)
automatically when it is selected." :group 'gnus-summary-choose :type 'hook)

(defcustom gnus-group-no-more-groups-hook nil "\
*A hook run when returning to group mode having no more (unread) groups." :group 'gnus-group-select :type 'hook)

(defcustom gnus-ps-print-hook nil "\
*A hook run before ps-printing something from Gnus." :group 'gnus-summary :type 'hook)

(defcustom gnus-summary-article-move-hook nil "\
*A hook called after an article is moved, copied, respooled, or crossposted." :version "22.1" :group 'gnus-summary :type 'hook)

(defcustom gnus-summary-article-delete-hook nil "\
*A hook called after an article is deleted." :version "22.1" :group 'gnus-summary :type 'hook)

(defcustom gnus-summary-article-expire-hook nil "\
*A hook called after an article is expired." :version "22.1" :group 'gnus-summary :type 'hook)

(defcustom gnus-summary-display-arrow (and (fboundp 'display-graphic-p) (display-graphic-p)) "\
*If non-nil, display an arrow highlighting the current article." :version "22.1" :group 'gnus-summary :type 'boolean)

(defcustom gnus-summary-selected-face 'gnus-summary-selected "\
Face used for highlighting the current article in the summary buffer." :group 'gnus-summary-visual :type 'face)

(defcustom gnus-summary-highlight '(((eq mark gnus-canceled-mark) . gnus-summary-cancelled) ((and uncached (> score default-high)) . gnus-summary-high-undownloaded) ((and uncached (< score default-low)) . gnus-summary-low-undownloaded) (uncached . gnus-summary-normal-undownloaded) ((and (> score default-high) (or (eq mark gnus-dormant-mark) (eq mark gnus-ticked-mark))) . gnus-summary-high-ticked) ((and (< score default-low) (or (eq mark gnus-dormant-mark) (eq mark gnus-ticked-mark))) . gnus-summary-low-ticked) ((or (eq mark gnus-dormant-mark) (eq mark gnus-ticked-mark)) . gnus-summary-normal-ticked) ((and (> score default-high) (eq mark gnus-ancient-mark)) . gnus-summary-high-ancient) ((and (< score default-low) (eq mark gnus-ancient-mark)) . gnus-summary-low-ancient) ((eq mark gnus-ancient-mark) . gnus-summary-normal-ancient) ((and (> score default-high) (eq mark gnus-unread-mark)) . gnus-summary-high-unread) ((and (< score default-low) (eq mark gnus-unread-mark)) . gnus-summary-low-unread) ((eq mark gnus-unread-mark) . gnus-summary-normal-unread) ((> score default-high) . gnus-summary-high-read) ((< score default-low) . gnus-summary-low-read) (t . gnus-summary-normal-read)) "\
*Controls the highlighting of summary buffer lines.

A list of (FORM . FACE) pairs.  When deciding how a particular
summary line should be displayed, each form is evaluated.  The content
of the face field after the first true form is used.  You can change
how those summary lines are displayed, by editing the face field.

You can use the following variables in the FORM field.

score:        The article's score.
default:      The default article score.
default-high: The default score for high scored articles.
default-low:  The default score for low scored articles.
below:        The score below which articles are automatically marked as read.
mark:         The article's mark.
uncached:     Non-nil if the article is uncached." :group 'gnus-summary-visual :type '(repeat (cons (sexp :tag "Form" nil) face)))

(defcustom gnus-alter-header-function nil "\
Function called to allow alteration of article header structures.
The function is called with one parameter, the article header vector,
which it may alter in any way." :type '(choice (const :tag "None" nil) function) :group 'gnus-summary)

(defcustom gnus-extra-headers '(To Newsgroups) "\
*Extra headers to parse." :version "21.1" :group 'gnus-summary :type '(repeat symbol))

(defcustom gnus-ignored-from-addresses (and user-mail-address (not (string= user-mail-address "")) (regexp-quote user-mail-address)) "\
*Regexp of From headers that may be suppressed in favor of To headers." :version "21.1" :group 'gnus-summary :type 'regexp)

(defcustom gnus-newsgroup-ignored-charsets '(unknown-8bit x-unknown) "\
List of charsets that should be ignored.
When these charsets are used in the \"charset\" parameter, the
default charset will be used instead." :version "21.1" :type '(repeat symbol) :group 'gnus-charset)

(defcustom gnus-newsgroup-maximum-articles nil "\
The maximum number of articles a newsgroup.
If this is a number, old articles in a newsgroup exceeding this number
are silently ignored.  If it is nil, no article is ignored.  Note that
setting this variable to a number might prevent you from reading very
old articles." :group 'gnus-group-select :version "22.2" :type '(choice (const :tag "No limit" nil) integer))

(defcustom gnus-group-highlight-words-alist nil "\
Alist of group regexps and highlight regexps.
This variable uses the same syntax as `gnus-emphasis-alist'." :version "21.1" :type '(repeat (cons (regexp :tag "Group") (repeat (list (regexp :tag "Highlight regexp") (number :tag "Group for entire word" 0) (number :tag "Group for displayed part" 0) (symbol :tag "Face" gnus-emphasis-highlight-words))))) :group 'gnus-summary-visual)

(defcustom gnus-summary-show-article-charset-alist nil "\
Alist of number and charset.
The article will be shown with the charset corresponding to the
numbered argument.
For example: ((1 . cn-gb-2312) (2 . big5))." :version "21.1" :type '(repeat (cons (number :tag "Argument" 1) (symbol :tag "Charset"))) :group 'gnus-charset)

(defcustom gnus-preserve-marks t "\
Whether marks are preserved when moving, copying and respooling messages." :version "21.1" :type 'boolean :group 'gnus-summary-marks)

(defcustom gnus-alter-articles-to-read-function nil "\
Function to be called to alter the list of articles to be selected." :type '(choice (const nil) function) :group 'gnus-summary)

(defcustom gnus-orphan-score nil "\
*All orphans get this score added.  Set in the score file." :group 'gnus-score-default :type '(choice (const nil) integer))

(defcustom gnus-summary-save-parts-default-mime "image/.*" "\
*A regexp to match MIME parts when saving multiple parts of a
message with `gnus-summary-save-parts' (\\<gnus-summary-mode-map>\\[gnus-summary-save-parts]).
This regexp will be used by default when prompting the user for which
type of files to save." :group 'gnus-summary :type 'regexp)

(defcustom gnus-read-all-available-headers nil "\
Whether Gnus should parse all headers made available to it.
This is mostly relevant for slow back ends where the user may
wish to widen the summary buffer to include all headers
that were fetched.  Say, for nnultimate groups." :version "22.1" :group 'gnus-summary :type '(choice boolean regexp))

(defcustom gnus-summary-muttprint-program "muttprint" "\
Command (and optional arguments) used to run Muttprint." :version "22.1" :group 'gnus-summary :type 'string)

(defcustom gnus-article-loose-mime nil "\
If non-nil, don't require MIME-Version header.
Some brain-damaged MUA/MTA, e.g. Lotus Domino 5.0.6 clients, does not
supply the MIME-Version header or deliberately strip it from the mail.
Set it to non-nil, Gnus will treat some articles as MIME even if
the MIME-Version header is missed." :version "22.1" :type 'boolean :group 'gnus-article-mime)

(defcustom gnus-article-emulate-mime t "\
If non-nil, use MIME emulation for uuencode and the like.
This means that Gnus will search message bodies for text that look
like uuencoded bits, yEncoded bits, and so on, and present that using
the normal Gnus MIME machinery." :version "22.1" :type 'boolean :group 'gnus-article-mime)

(defcustom gnus-summary-tool-bar (if (eq gmm-tool-bar-style 'gnome) 'gnus-summary-tool-bar-gnome 'gnus-summary-tool-bar-retro) "\
Specifies the Gnus summary tool bar.

It can be either a list or a symbol refering to a list.  See
`gmm-tool-bar-from-list' for the format of the list.  The
default key map is `gnus-summary-mode-map'.

Pre-defined symbols include `gnus-summary-tool-bar-gnome' and
`gnus-summary-tool-bar-retro'." :type '(choice (const :tag "GNOME style" gnus-summary-tool-bar-gnome) (const :tag "Retro look" gnus-summary-tool-bar-retro) (repeat :tag "User defined list" gmm-tool-bar-item) (symbol)) :version "22.1" :initialize 'custom-initialize-default :set 'gnus-summary-tool-bar-update :group 'gnus-summary)

(defcustom gnus-summary-tool-bar-gnome '((gnus-summary-post-news "mail/compose" nil) (gnus-summary-insert-new-articles "mail/inbox" nil :visible (or (not gnus-agent) gnus-plugged)) (gnus-summary-reply-with-original "mail/reply") (gnus-summary-reply "mail/reply" nil :visible nil) (gnus-summary-followup-with-original "mail/reply-all") (gnus-summary-followup "mail/reply-all" nil :visible nil) (gnus-summary-mail-forward "mail/forward") (gnus-summary-save-article "mail/save") (gnus-summary-search-article-forward "search" nil :visible nil) (gnus-summary-print-article "print") (gnus-summary-tick-article-forward "flag-followup" nil :visible nil) (gnus-summary-save-newsrc "save" nil :visible nil) (gnus-summary-prev-article "left-arrow") (gnus-summary-next-article "right-arrow") (gnus-summary-next-page "next-page") (gnus-summary-mark-as-expirable "delete" nil :visible (gnus-check-backend-function 'request-expire-articles gnus-newsgroup-name)) (gnus-summary-mark-as-spam "mail/spam" t :visible (and (fboundp 'spam-group-ham-contents-p) (spam-group-ham-contents-p gnus-newsgroup-name)) :help "Mark as spam") (gnus-summary-mark-as-read-forward "mail/not-spam" nil :visible (and (fboundp 'spam-group-spam-contents-p) (spam-group-spam-contents-p gnus-newsgroup-name))) (gnus-summary-exit "exit") (gmm-customize-mode "preferences" t :help "Edit mode preferences") (gnus-info-find-node "help")) "\
List of functions for the summary tool bar (GNOME style).

See `gmm-tool-bar-from-list' for the format of the list." :type '(repeat gmm-tool-bar-item) :version "22.1" :initialize 'custom-initialize-default :set 'gnus-summary-tool-bar-update :group 'gnus-summary)

(defcustom gnus-summary-tool-bar-retro '((gnus-summary-prev-unread-article "gnus/prev-ur") (gnus-summary-next-unread-article "gnus/next-ur") (gnus-summary-post-news "gnus/post") (gnus-summary-followup-with-original "gnus/fuwo") (gnus-summary-followup "gnus/followup") (gnus-summary-reply-with-original "gnus/reply-wo") (gnus-summary-reply "gnus/reply") (gnus-summary-caesar-message "gnus/rot13") (gnus-uu-decode-uu "gnus/uu-decode") (gnus-summary-save-article-file "gnus/save-aif") (gnus-summary-save-article "gnus/save-art") (gnus-uu-post-news "gnus/uu-post") (gnus-summary-catchup "gnus/catchup") (gnus-summary-catchup-and-exit "gnus/cu-exit") (gnus-summary-exit "gnus/exit-summ") (gnus-summary-print-article "gnus/print" nil :visible nil) (gnus-summary-mark-as-expirable "gnus/close" nil :visible nil) (gnus-summary-save-newsrc "gnus/save" nil :visible nil) (gnus-summary-search-article-forward "gnus/search" nil :visible nil) (gnus-info-find-node "gnus/help" nil :visible nil)) "\
List of functions for the summary tool bar (retro look).

See `gmm-tool-bar-from-list' for the format of the list." :type '(repeat gmm-tool-bar-item) :version "22.1" :initialize 'custom-initialize-default :set 'gnus-summary-tool-bar-update :group 'gnus-summary)

(defcustom gnus-summary-tool-bar-zap-list t "\
List of icon items from the global tool bar.
These items are not displayed in the Gnus summary mode tool bar.

See `gmm-tool-bar-from-list' for the format of the list." :type 'gmm-tool-bar-zap-list :version "22.1" :initialize 'custom-initialize-default :set 'gnus-summary-tool-bar-update :group 'gnus-summary)

(defcustom gnus-sum-thread-tree-root "> " "\
With %B spec, used for the root of a thread.
If nil, use subject instead." :version "22.1" :type '(radio (const :format "%v  " nil) string) :group 'gnus-thread)

(defcustom gnus-sum-thread-tree-false-root "> " "\
With %B spec, used for a false root of a thread.
If nil, use subject instead." :version "22.1" :type '(radio (const :format "%v  " nil) string) :group 'gnus-thread)

(defcustom gnus-sum-thread-tree-single-indent "" "\
With %B spec, used for a thread with just one message.
If nil, use subject instead." :version "22.1" :type '(radio (const :format "%v  " nil) string) :group 'gnus-thread)

(defcustom gnus-sum-thread-tree-vertical "| " "\
With %B spec, used for drawing a vertical line." :version "22.1" :type 'string :group 'gnus-thread)

(defcustom gnus-sum-thread-tree-indent "  " "\
With %B spec, used for indenting." :version "22.1" :type 'string :group 'gnus-thread)

(defcustom gnus-sum-thread-tree-leaf-with-other "+-> " "\
With %B spec, used for a leaf with brothers." :version "22.1" :type 'string :group 'gnus-thread)

(defcustom gnus-sum-thread-tree-single-leaf "\\-> " "\
With %B spec, used for a leaf without brothers." :version "22.1" :type 'string :group 'gnus-thread)

(defcustom gnus-summary-respool-default-method nil "\
Default method type for respooling an article.
If nil, use to the current newsgroup method." :type 'symbol :group 'gnus-summary-mail)

(defcustom gnus-summary-display-while-building nil "\
If non-nil, show and update the summary buffer as it's being built.
If the value is t, update the buffer after every line is inserted.  If
the value is an integer (N), update the display every N lines." :version "22.1" :group 'gnus-thread :type '(choice (const :tag "off" nil) number (const :tag "frequently" t)))

;;;***

;;;### (autoloads (gnus-topic-display-empty-topics gnus-topic-indent-level gnus-topic-line-format gnus-topic-mode-hook gnus-topic) "gnus-topic" "lisp/gnus-topic.el")
(defconst custom-define-current-source-file "gnus-topic.el")

(defgroup gnus-topic nil "Group topics." :group 'gnus-group)

(defcustom gnus-topic-mode-hook nil "\
Hook run in topic mode buffers." :type 'hook :group 'gnus-topic)

(defcustom gnus-topic-line-format "%i[ %(%{%n%}%) -- %A ]%v\n" "\
Format of topic lines.
It works along the same lines as a normal formatting string,
with some simple extensions.

%i  Indentation based on topic level.
%n  Topic name.
%v  Nothing if the topic is visible, \"...\" otherwise.
%g  Number of groups in the topic.
%a  Number of unread articles in the groups in the topic.
%A  Number of unread articles in the groups in the topic and its subtopics.

General format specifiers can also be used.
See Info node `(gnus)Formatting Variables'." :link '(custom-manual "(gnus)Formatting Variables") :type 'string :group 'gnus-topic)

(defcustom gnus-topic-indent-level 2 "\
*How much each subtopic should be indented." :type 'integer :group 'gnus-topic)

(defcustom gnus-topic-display-empty-topics t "\
*If non-nil, display the topic lines even of topics that have no unread articles." :type 'boolean :group 'gnus-topic)

;;;***

;;;### (autoloads (gnus-undo-mode-hook gnus-undo-mode gnus-undo-limit gnus-undo) "gnus-undo" "lisp/gnus-undo.el")
(defconst custom-define-current-source-file "gnus-undo.el")

(defgroup gnus-undo nil "Undoing in Gnus buffers." :group 'gnus)

(defcustom gnus-undo-limit 2000 "\
The number of undoable actions recorded." :type 'integer :group 'gnus-undo)

(defcustom gnus-undo-mode nil "\
Minor mode for undoing in Gnus buffers." :type 'boolean :group 'gnus-undo)

(defcustom gnus-undo-mode-hook nil "\
Hook called in all `gnus-undo-mode' buffers." :type 'hook :group 'gnus-undo)

;;;***

;;;### (autoloads (gnus-use-byte-compile gnus-verbose) "gnus-util" "lisp/gnus-util.el")
(defconst custom-define-current-source-file "gnus-util.el")

(defcustom gnus-verbose 7 "\
*Integer that says how verbose Gnus should be.
The higher the number, the more messages Gnus will flash to say what
it's doing.  At zero, Gnus will be totally mute; at five, Gnus will
display most important messages; and at ten, Gnus will keep on
jabbering all the time." :group 'gnus-start :type 'integer)

(defcustom gnus-use-byte-compile t "\
If non-nil, byte-compile crucial run-time code.
Setting it to nil has no effect after the first time `gnus-byte-compile'
is run." :type 'boolean :version "22.1" :group 'gnus-various)

;;;***

;;;### (autoloads (gnus-uu-post-separate-description gnus-uu-post-threaded gnus-uu-post-length gnus-uu-post-include-before-composing gnus-uu-post-encode-method gnus-uu-be-dangerous gnus-uu-save-separate-articles gnus-uu-digest-headers gnus-uu-pre-uudecode-hook gnus-uu-save-in-digest gnus-uu-correct-stripped-uucode gnus-uu-unmark-articles-not-decoded gnus-uu-view-with-metamail gnus-uu-kill-carriage-return gnus-uu-ignore-default-archive-rules gnus-uu-grabbed-file-functions gnus-uu-ignore-default-view-rules gnus-uu-do-not-unpack-archives gnus-uu-tmp-dir gnus-uu-ignore-files-by-type gnus-uu-ignore-files-by-name gnus-uu-user-archive-rules gnus-uu-default-archive-rules gnus-uu-user-view-rules-end gnus-uu-user-view-rules gnus-uu-default-view-rules gnus-extract-post gnus-extract-archive gnus-extract-view gnus-extract) "gnus-uu" "lisp/gnus-uu.el")
(defconst custom-define-current-source-file "gnus-uu.el")

(defgroup gnus-extract nil "Extracting encoded files." :prefix "gnus-uu-" :group 'gnus)

(defgroup gnus-extract-view nil "Viewwing extracted files." :group 'gnus-extract)

(defgroup gnus-extract-archive nil "Extracting encoded archives." :group 'gnus-extract)

(defgroup gnus-extract-post nil "Extracting encoded archives." :prefix "gnus-uu-post" :group 'gnus-extract)

(defcustom gnus-uu-default-view-rules '(("\\.te?xt$\\|\\.doc$\\|read.*me\\|\\.c?$\\|\\.h$\\|\\.bat$\\|\\.asm$\\|makefile" "cat %s | sed 's/
$//'") ("\\.pas$" "cat %s | sed 's/
$//'") ("\\.[1-9]$" "groff -mandoc -Tascii %s | sed s/.//g") ("\\.\\(jpe?g\\|gif\\|tiff?\\|p[pgb]m\\|xwd\\|xbm\\|pcx\\)$" "display") ("\\.tga$" "tgatoppm %s | ee -") ("\\.\\(wav\\|aiff\\|hcom\\|u[blw]\\|s[bfw]\\|voc\\|smp\\)$" "sox -v .5 %s -t .au -u - > /dev/audio") ("\\.au$" "cat %s > /dev/audio") ("\\.midi?$" "playmidi -f") ("\\.mod$" "str32") ("\\.ps$" "ghostview") ("\\.dvi$" "xdvi") ("\\.html$" "xmosaic") ("\\.mpe?g$" "mpeg_play") ("\\.\\(flc\\|fli\\|rle\\|iff\\|pfx\\|avi\\|sme\\|rpza\\|dl\\|qt\\|rsrc\\|mov\\)$" "xanim") ("\\.\\(tar\\|arj\\|zip\\|zoo\\|arc\\|gz\\|Z\\|lzh\\|ar\\|lha\\)$" "gnus-uu-archive")) "\
*Default actions to be taken when the user asks to view a file.
To change the behavior, you can either edit this variable or set
`gnus-uu-user-view-rules' to something useful.

For example:

To make gnus-uu use 'xli' to display JPEG and GIF files, put the
following in your .emacs file:

  (setq gnus-uu-user-view-rules '((\"jpg$\\\\|gif$\" \"xli\")))

Both these variables are lists of lists with two string elements.  The
first string is a regular expression.  If the file name matches this
regular expression, the command in the second string is executed with
the file as an argument.

If the command string contains \"%s\", the file name will be inserted
at that point in the command string.  If there's no \"%s\" in the
command string, the file name will be appended to the command string
before executing.

There are several user variables to tailor the behavior of gnus-uu to
your needs.  First we have `gnus-uu-user-view-rules', which is the
variable gnus-uu first consults when trying to decide how to view a
file.  If this variable contains no matches, gnus-uu examines the
default rule variable provided in this package.  If gnus-uu finds no
match here, it uses `gnus-uu-user-view-rules-end' to try to make a
match." :group 'gnus-extract-view :type '(repeat (group regexp (string :tag "Command"))))

(defcustom gnus-uu-user-view-rules nil "\
What actions are to be taken to view a file.
See the documentation on the `gnus-uu-default-view-rules' variable for
details." :group 'gnus-extract-view :type '(repeat (group regexp (string :tag "Command"))))

(defcustom gnus-uu-user-view-rules-end '(("" "file")) "\
*What actions are to be taken if no rule matched the file name.
See the documentation on the `gnus-uu-default-view-rules' variable for
details." :group 'gnus-extract-view :type '(repeat (group regexp (string :tag "Command"))))

(defcustom gnus-uu-default-archive-rules '(("\\.tar$" "tar xf") ("\\.zip$" "unzip -o") ("\\.ar$" "ar x") ("\\.arj$" "unarj x") ("\\.zoo$" "zoo -e") ("\\.\\(lzh\\|lha\\)$" "lha x") ("\\.Z$" "uncompress") ("\\.gz$" "gunzip") ("\\.arc$" "arc -x")) "\
*See `gnus-uu-user-archive-rules'." :group 'gnus-extract-archive :type '(repeat (group regexp (string :tag "Command"))))

(defcustom gnus-uu-user-archive-rules nil "\
A list that can be set to override the default archive unpacking commands.
To use, for instance, 'untar' to unpack tar files and 'zip -x' to
unpack zip files, say the following:
  (setq gnus-uu-user-archive-rules
    '((\"\\\\.tar$\" \"untar\")
      (\"\\\\.zip$\" \"zip -x\")))" :group 'gnus-extract-archive :type '(repeat (group regexp (string :tag "Command"))))

(defcustom gnus-uu-ignore-files-by-name nil "\
*A regular expression saying what files should not be viewed based on name.
If, for instance, you want gnus-uu to ignore all .au and .wav files,
you could say something like

  (setq gnus-uu-ignore-files-by-name \"\\\\.au$\\\\|\\\\.wav$\")

Note that this variable can be used in conjunction with the
`gnus-uu-ignore-files-by-type' variable." :group 'gnus-extract :type '(choice (const :tag "off" nil) (regexp :format "%v")))

(defcustom gnus-uu-ignore-files-by-type nil "\
*A regular expression saying what files that shouldn't be viewed, based on MIME file type.
If, for instance, you want gnus-uu to ignore all audio files and all mpegs,
you could say something like

  (setq gnus-uu-ignore-files-by-type \"audio/\\\\|video/mpeg\")

Note that this variable can be used in conjunction with the
`gnus-uu-ignore-files-by-name' variable." :group 'gnus-extract :type '(choice (const :tag "off" nil) (regexp :format "%v")))

(defcustom gnus-uu-tmp-dir (cond ((fboundp 'temp-directory) (temp-directory)) ((boundp 'temporary-file-directory) temporary-file-directory) ("/tmp/")) "\
*Variable saying where gnus-uu is to do its work.
Default is \"/tmp/\"." :group 'gnus-extract :type 'directory)

(defcustom gnus-uu-do-not-unpack-archives nil "\
*Non-nil means that gnus-uu won't peek inside archives looking for files to display.
Default is nil." :group 'gnus-extract-archive :type 'boolean)

(defcustom gnus-uu-ignore-default-view-rules nil "\
*Non-nil means that gnus-uu will ignore the default viewing rules.
Only the user viewing rules will be consulted.  Default is nil." :group 'gnus-extract-view :type 'boolean)

(defcustom gnus-uu-grabbed-file-functions nil "\
Functions run on each file after successful decoding.
They will be called with the name of the file as the argument.
Likely functions you can use in this list are `gnus-uu-grab-view'
and `gnus-uu-grab-move'." :group 'gnus-extract :options '(gnus-uu-grab-view gnus-uu-grab-move) :type 'hook)

(defcustom gnus-uu-ignore-default-archive-rules nil "\
*Non-nil means that gnus-uu will ignore the default archive unpacking commands.
Only the user unpacking commands will be consulted.  Default is nil." :group 'gnus-extract-archive :type 'boolean)

(defcustom gnus-uu-kill-carriage-return t "\
*Non-nil means that gnus-uu will strip all carriage returns from articles.
Default is t." :group 'gnus-extract :type 'boolean)

(defcustom gnus-uu-view-with-metamail nil "\
*Non-nil means that files will be viewed with metamail.
The gnus-uu viewing functions will be ignored and gnus-uu will try
to guess at a content-type based on file name suffixes.  Default
it nil." :group 'gnus-extract :type 'boolean)

(defcustom gnus-uu-unmark-articles-not-decoded nil "\
*Non-nil means that gnus-uu will mark articles that were unsuccessfully decoded as unread.
Default is nil." :group 'gnus-extract :type 'boolean)

(defcustom gnus-uu-correct-stripped-uucode nil "\
*Non-nil means that gnus-uu will *try* to fix uuencoded files that have had trailing spaces deleted.
Default is nil." :group 'gnus-extract :type 'boolean)

(defcustom gnus-uu-save-in-digest nil "\
*Non-nil means that gnus-uu, when asked to save without decoding, will save in digests.
If this variable is nil, gnus-uu will just save everything in a
file without any embellishments.  The digesting almost conforms to RFC1153 -
no easy way to specify any meaningful volume and issue numbers were found,
so I simply dropped them." :group 'gnus-extract :type 'boolean)

(defcustom gnus-uu-pre-uudecode-hook nil "\
Hook run before sending a message to uudecode." :group 'gnus-extract :type 'hook)

(defcustom gnus-uu-digest-headers '("^Date:" "^From:" "^To:" "^Cc:" "^Subject:" "^Message-ID:" "^Keywords:" "^Summary:" "^References:" "^Content-Type:" "^Content-Transfer-Encoding:" "^MIME-Version:" "^Content-Disposition:" "^Content-Description:" "^Content-ID:") "\
*List of regexps to match headers included in digested messages.
The headers will be included in the sequence they are matched.  If nil
include all headers." :group 'gnus-extract :type '(repeat regexp))

(defcustom gnus-uu-save-separate-articles nil "\
*Non-nil means that gnus-uu will save articles in separate files." :group 'gnus-extract :type 'boolean)

(defcustom gnus-uu-be-dangerous 'ask "\
*Specifies what to do if unusual situations arise during decoding.
If nil, be as conservative as possible.  If t, ignore things that
didn't work, and overwrite existing files.  Otherwise, ask each time." :group 'gnus-extract :type '(choice (const :tag "conservative" nil) (const :tag "ask" ask) (const :tag "liberal" t)))

(defcustom gnus-uu-post-encode-method 'gnus-uu-post-encode-uuencode "\
Function used for encoding binary files.
There are three functions supplied with gnus-uu for encoding files:
`gnus-uu-post-encode-uuencode', which does straight uuencoding;
`gnus-uu-post-encode-mime', which encodes with base64 and adds MIME
headers; and `gnus-uu-post-encode-mime-uuencode', which encodes with
uuencode and adds MIME headers." :group 'gnus-extract-post :type '(radio (function-item gnus-uu-post-encode-uuencode) (function-item gnus-uu-post-encode-mime) (function-item gnus-uu-post-encode-mime-uuencode) (function :tag "Other")))

(defcustom gnus-uu-post-include-before-composing nil "\
Non-nil means that gnus-uu will ask for a file to encode before you compose the article.
If this variable is t, you can either include an encoded file with
\\[gnus-uu-post-insert-binary-in-article] or have one included for you when you post the article." :group 'gnus-extract-post :type 'boolean)

(defcustom gnus-uu-post-length 990 "\
Maximum length of an article.
The encoded file will be split into how many articles it takes to
post the entire file." :group 'gnus-extract-post :type 'integer)

(defcustom gnus-uu-post-threaded nil "\
Non-nil means that gnus-uu will post the encoded file in a thread.
This may not be smart, as no other decoder I have seen are able to
follow threads when collecting uuencoded articles.  (Well, I have seen
one package that does that - gnus-uu, but somehow, I don't think that
counts...)  The default is nil." :group 'gnus-extract-post :type 'boolean)

(defcustom gnus-uu-post-separate-description t "\
Non-nil means that the description will be posted in a separate article.
The first article will typically be numbered (0/x).  If this variable
is nil, the description the user enters will be included at the
beginning of the first article, which will be numbered (1/x).  Default
is t." :group 'gnus-extract-post :type 'boolean)

;;;***

;;;### (autoloads (gnus-configure-windows-hook gnus-use-frames-on-any-display gnus-always-force-window-configuration gnus-window-min-height gnus-window-min-width gnus-use-full-window gnus-windows) "gnus-win" "lisp/gnus-win.el")
(defconst custom-define-current-source-file "gnus-win.el")

(defgroup gnus-windows nil "Window configuration." :group 'gnus)

(defcustom gnus-use-full-window t "\
*If non-nil, use the entire Emacs screen." :group 'gnus-windows :type 'boolean)

(defcustom gnus-window-min-width 2 "\
*Minimum width of Gnus buffers." :group 'gnus-windows :type 'integer)

(defcustom gnus-window-min-height 1 "\
*Minimum height of Gnus buffers." :group 'gnus-windows :type 'integer)

(defcustom gnus-always-force-window-configuration nil "\
*If non-nil, always force the Gnus window configurations." :group 'gnus-windows :type 'boolean)

(defcustom gnus-use-frames-on-any-display nil "\
*If non-nil, frames on all displays will be considered useable by Gnus.
When nil, only frames on the same display as the selected frame will be
used to display Gnus windows." :version "22.1" :group 'gnus-windows :type 'boolean)

(defcustom gnus-configure-windows-hook nil "\
*A hook called when configuring windows." :version "22.1" :group 'gnus-windows :type 'hook)

;;;***

;;;### (autoloads (gnus-toolbar-thickness gnus-use-toolbar gnus-xmas-force-redisplay gnus-xmas-glyph-directory gnus-xmas) "gnus-xmas" "lisp/gnus-xmas.el")
(defconst custom-define-current-source-file "gnus-xmas.el")

(defgroup gnus-xmas nil "XEmacsoid support for Gnus" :group 'gnus)

(defcustom gnus-xmas-glyph-directory nil "\
Directory where Gnus logos and icons are located.
If this variable is nil, Gnus will try to locate the directory
automatically." :type '(choice (const :tag "autodetect" nil) directory) :group 'gnus-xmas)

(defcustom gnus-xmas-force-redisplay nil "\
*If non-nil, force a redisplay before recentering the summary buffer.
This is ugly, but it works around a bug in `window-displayed-height'." :type 'boolean :group 'gnus-xmas)

(defcustom gnus-use-toolbar (if (featurep 'toolbar) 'default) "\
*Position to display the toolbar.  Nil means do not use a toolbar.
If it is non-nil, it should be one of the symbols `default', `top',
`bottom', `right', and `left'.  `default' means to use the default
toolbar, the rest mean to display the toolbar on the place which those
names show." :type '(choice (const default) (const top) (const bottom) (const left) (const right) (const :tag "no toolbar" nil)) :set (lambda (symbol value) (set-default symbol (if (or (not value) (memq value (list 'default 'top 'bottom 'right 'left))) value 'default)) (gnus-xmas-update-toolbars)) :group 'gnus-xmas)

(defcustom gnus-toolbar-thickness (if (featurep 'toolbar) (cons (specifier-instance default-toolbar-height) (specifier-instance default-toolbar-width))) "\
*Cons of the height and the width specifying the thickness of a toolbar.
The height is used for the toolbar displayed on the top or the bottom,
the width is used for the toolbar displayed on the right or the left." :type '(cons :tag "height & width" (integer :tag "height") (integer :tag "width")) :set (lambda (symbol value) (set-default symbol (if (and (consp value) (natnump (car value)) (natnump (cdr value))) value '(37 . 40))) (gnus-xmas-update-toolbars)) :group 'gnus-xmas)

;;;***

;;;### (autoloads (gnus-kill-file-name gnus-summary-line-format gnus-cache-directory gnus-user-agent gnus-other-frame-parameters gnus-other-frame-function gnus-agent gnus-default-charset gnus-agent-cache gnus-article-save-directory gnus-mouse-face gnus-visual gnus-group-change-level-function gnus-apply-kill-hook gnus-load-hook gnus-group-use-permanent-levels gnus-group-uncollapsed-levels gnus-install-group-spam-parameters gnus-mode-non-string-length gnus-updated-mode-lines gnus-valid-select-methods gnus-shell-command-separator gnus-carpal gnus-extract-address-components gnus-interactive-exit gnus-interactive-catchup gnus-expert-user gnus-novice-user gnus-summary-prepare-exit-hook gnus-use-scoring gnus-suppress-duplicates gnus-use-nocem gnus-keep-backlog gnus-use-grouplens gnus-use-trees gnus-use-cache gnus-use-adaptive-scoring gnus-use-undo gnus-save-score gnus-kill-files-directory gnus-use-long-file-name gnus-large-newsgroup gnus-process-mark gnus-use-cross-reference gnus-group-fetch-control-use-browse-url gnus-group-charter-alist gnus-group-faq-directory gnus-refer-article-method gnus-local-domain gnus-secondary-select-methods gnus-nntp-server gnus-secondary-servers gnus-message-archive-group gnus-message-archive-method gnus-select-method gnus-nntpserver-file gnus-default-directory gnus-directory gnus-home-directory gnus-parameters-case-fold-search gnus-parameters gnus-logo-color-style gnus-play-startup-jingle gnus-inhibit-startup-message gnus-fun gnus-exit gnus-various gnus-meta gnus-message gnus-server-visual gnus-server gnus-newsrc gnus-dribble-file gnus-files gnus-agent gnus-visual gnus-score-various gnus-score-files gnus-score-decay gnus-score-expire gnus-score-default gnus-score-adapt gnus-score-kill gnus-score gnus-extract-view gnus-summary-tree gnus-summary-pick gnus-summary-various gnus-summary-visual gnus-summary-sort gnus-summary-mail gnus-picon gnus-summary-maneuvering gnus-summary-choose gnus-summary-format gnus-thread gnus-summary-marks gnus-summary-exit gnus-summary gnus-group-various gnus-group-visual gnus-group-listing gnus-group-select gnus-group-levels gnus-group-new gnus-group-foreign gnus-group gnus-start-server gnus-registry gnus-cache gnus-charset gnus-format gnus-start gnus) "gnus" "lisp/gnus.el")
(defconst custom-define-current-source-file "gnus.el")

(defgroup gnus nil "The coffee-brewing, all singing, all dancing, kitchen sink newsreader." :group 'news :group 'mail)

(defgroup gnus-start nil "Starting your favorite newsreader." :group 'gnus)

(defgroup gnus-format nil "Dealing with formatting issues." :group 'gnus)

(defgroup gnus-charset nil "Group character set issues." :link '(custom-manual "(gnus)Charsets") :version "21.1" :group 'gnus)

(defgroup gnus-cache nil "Cache interface." :link '(custom-manual "(gnus)Article Caching") :group 'gnus)

(defgroup gnus-registry nil "Article Registry." :group 'gnus)

(defgroup gnus-start-server nil "Server options at startup." :group 'gnus-start)

(defgroup gnus-group nil "Group buffers." :link '(custom-manual "(gnus)Group Buffer") :group 'gnus)

(defgroup gnus-group-foreign nil "Foreign groups." :link '(custom-manual "(gnus)Foreign Groups") :group 'gnus-group)

(defgroup gnus-group-new nil "Automatic subscription of new groups." :group 'gnus-group)

(defgroup gnus-group-levels nil "Group levels." :link '(custom-manual "(gnus)Group Levels") :group 'gnus-group)

(defgroup gnus-group-select nil "Selecting a Group." :link '(custom-manual "(gnus)Selecting a Group") :group 'gnus-group)

(defgroup gnus-group-listing nil "Showing slices of the group list." :link '(custom-manual "(gnus)Listing Groups") :group 'gnus-group)

(defgroup gnus-group-visual nil "Sorting the group buffer." :link '(custom-manual "(gnus)Group Buffer Format") :group 'gnus-group :group 'gnus-visual)

(defgroup gnus-group-various nil "Various group options." :link '(custom-manual "(gnus)Scanning New Messages") :group 'gnus-group)

(defgroup gnus-summary nil "Summary buffers." :link '(custom-manual "(gnus)Summary Buffer") :group 'gnus)

(defgroup gnus-summary-exit nil "Leaving summary buffers." :link '(custom-manual "(gnus)Exiting the Summary Buffer") :group 'gnus-summary)

(defgroup gnus-summary-marks nil "Marks used in summary buffers." :link '(custom-manual "(gnus)Marking Articles") :group 'gnus-summary)

(defgroup gnus-thread nil "Ordering articles according to replies." :link '(custom-manual "(gnus)Threading") :group 'gnus-summary)

(defgroup gnus-summary-format nil "Formatting of the summary buffer." :link '(custom-manual "(gnus)Summary Buffer Format") :group 'gnus-summary)

(defgroup gnus-summary-choose nil "Choosing Articles." :link '(custom-manual "(gnus)Choosing Articles") :group 'gnus-summary)

(defgroup gnus-summary-maneuvering nil "Summary movement commands." :link '(custom-manual "(gnus)Summary Maneuvering") :group 'gnus-summary)

(defgroup gnus-picon nil "Show pictures of people, domains, and newsgroups." :group 'gnus-visual)

(defgroup gnus-summary-mail nil "Mail group commands." :link '(custom-manual "(gnus)Mail Group Commands") :group 'gnus-summary)

(defgroup gnus-summary-sort nil "Sorting the summary buffer." :link '(custom-manual "(gnus)Sorting the Summary Buffer") :group 'gnus-summary)

(defgroup gnus-summary-visual nil "Highlighting and menus in the summary buffer." :link '(custom-manual "(gnus)Summary Highlighting") :group 'gnus-visual :group 'gnus-summary)

(defgroup gnus-summary-various nil "Various summary buffer options." :link '(custom-manual "(gnus)Various Summary Stuff") :group 'gnus-summary)

(defgroup gnus-summary-pick nil "Pick mode in the summary buffer." :link '(custom-manual "(gnus)Pick and Read") :prefix "gnus-pick-" :group 'gnus-summary)

(defgroup gnus-summary-tree nil "Tree display of threads in the summary buffer." :link '(custom-manual "(gnus)Tree Display") :prefix "gnus-tree-" :group 'gnus-summary)

(defgroup gnus-extract-view nil "Viewing extracted files." :link '(custom-manual "(gnus)Viewing Files") :group 'gnus-extract)

(defgroup gnus-score nil "Score and kill file handling." :group 'gnus)

(defgroup gnus-score-kill nil "Kill files." :group 'gnus-score)

(defgroup gnus-score-adapt nil "Adaptive score files." :group 'gnus-score)

(defgroup gnus-score-default nil "Default values for score files." :group 'gnus-score)

(defgroup gnus-score-expire nil "Expiring score rules." :group 'gnus-score)

(defgroup gnus-score-decay nil "Decaying score rules." :group 'gnus-score)

(defgroup gnus-score-files nil "Score and kill file names." :group 'gnus-score :group 'gnus-files)

(defgroup gnus-score-various nil "Various scoring and killing options." :group 'gnus-score)

(defgroup gnus-visual nil "Options controlling the visual fluff." :group 'gnus :group 'faces)

(defgroup gnus-agent nil "Offline support for Gnus." :group 'gnus)

(defgroup gnus-files nil "Files used by Gnus." :group 'gnus)

(defgroup gnus-dribble-file nil "Auto save file." :link '(custom-manual "(gnus)Auto Save") :group 'gnus-files)

(defgroup gnus-newsrc nil "Storing Gnus state." :group 'gnus-files)

(defgroup gnus-server nil "Options related to newsservers and other servers used by Gnus." :group 'gnus)

(defgroup gnus-server-visual nil "Highlighting and menus in the server buffer." :group 'gnus-visual :group 'gnus-server)

(defgroup gnus-message '((message custom-group)) "Composing replies and followups in Gnus." :group 'gnus)

(defgroup gnus-meta nil "Meta variables controlling major portions of Gnus.\nIn general, modifying these variables does not take affect until Gnus\nis restarted, and sometimes reloaded." :group 'gnus)

(defgroup gnus-various nil "Other Gnus options." :link '(custom-manual "(gnus)Various Various") :group 'gnus)

(defgroup gnus-exit nil "Exiting Gnus." :link '(custom-manual "(gnus)Exiting Gnus") :group 'gnus)

(defgroup gnus-fun nil "Frivolous Gnus extensions." :link '(custom-manual "(gnus)Exiting Gnus") :group 'gnus)

(defcustom gnus-inhibit-startup-message nil "\
If non-nil, the startup message will not be displayed.
This variable is used before `.gnus.el' is loaded, so it should
be set in `.emacs' instead." :group 'gnus-start :type 'boolean)

(defcustom gnus-play-startup-jingle nil "\
If non-nil, play the Gnus jingle at startup." :group 'gnus-start :type 'boolean)

(defcustom gnus-logo-color-style 'oort "\
*Color styles used for the Gnus logo." :type (backquote (choice (\,@ (mapcar (lambda (elem) (list 'const (car elem))) gnus-logo-color-alist)))) :group 'gnus-xmas)

(defcustom gnus-parameters nil "\
Alist of group parameters.

For example:
   ((\"mail\\\\..*\"  (gnus-show-threads nil)
		  (gnus-use-scoring nil)
		  (gnus-summary-line-format
			\"%U%R%z%I%(%[%d:%ub%-23,23f%]%) %s\\n\")
		  (gcc-self . t)
		  (display . all))
     (\"mail\\\\.me\" (gnus-use-scoring  t))
     (\"list\\\\..*\" (total-expire . t)
		  (broken-reply-to . t)))" :version "22.1" :group 'gnus-group-various :type '(repeat (cons regexp (repeat sexp))))

(defcustom gnus-parameters-case-fold-search 'default "\
If it is t, ignore case of group names specified in `gnus-parameters'.
If it is nil, don't ignore case.  If it is `default', which is for the
backward compatibility, use the value of `case-fold-search'." :version "22.1" :group 'gnus-group-various :type '(choice :format "%{%t%}:
 %[Value Menu%] %v" (const :tag "Use `case-fold-search'" default) (const nil) (const t)))

(defcustom gnus-home-directory "~/" "\
Directory variable that specifies the \"home\" directory.
All other Gnus file and directory variables are initialized from this variable." :group 'gnus-files :type 'directory)

(defcustom gnus-directory (or (getenv "SAVEDIR") (nnheader-concat gnus-home-directory "News/")) "\
*Directory variable from which all other Gnus file variables are derived.

Note that Gnus is mostly loaded when the `.gnus.el' file is read.
This means that other directory variables that are initialized from
this variable won't be set properly if you set this variable in `.gnus.el'.
Set this variable in `.emacs' instead." :group 'gnus-files :type 'directory)

(defcustom gnus-default-directory nil "\
*Default directory for all Gnus buffers." :group 'gnus-files :type '(choice (const :tag "current" nil) directory))

(defcustom gnus-nntpserver-file "/etc/nntpserver" "\
A file with only the name of the nntp server in it." :group 'gnus-files :group 'gnus-server :type 'file)

(defcustom gnus-select-method (condition-case nil (nconc (list 'nntp (or (condition-case nil (gnus-getenv-nntpserver) (error nil)) (when (and gnus-default-nntp-server (not (string= gnus-default-nntp-server ""))) gnus-default-nntp-server) "news")) (if (or (null gnus-nntp-service) (equal gnus-nntp-service "nntp")) nil (list gnus-nntp-service))) (error nil)) "\
Default method for selecting a newsgroup.
This variable should be a list, where the first element is how the
news is to be fetched, the second is the address.

For instance, if you want to get your news via \"flab.flab.edu\" using
NNTP, you could say:

\(setq gnus-select-method '(nntp \"flab.flab.edu\"))

If you want to use your local spool, say:

\(setq gnus-select-method (list 'nnspool (system-name)))

If you use this variable, you must set `gnus-nntp-server' to nil.

There is a lot more to know about select methods and virtual servers -
see the manual for details." :group 'gnus-server :group 'gnus-start :initialize 'custom-initialize-default :type 'gnus-select-method)

(defcustom gnus-message-archive-method "archive" "\
*Method used for archiving messages you've sent.
This should be a mail method." :group 'gnus-server :group 'gnus-message :type '(choice (const :tag "Default archive method" "archive") gnus-select-method))

(defcustom gnus-message-archive-group nil "\
*Name of the group in which to save the messages you've written.
This can either be a string; a list of strings; or an alist
of regexps/functions/forms to be evaluated to return a string (or a list
of strings).  The functions are called with the name of the current
group (or nil) as a parameter.

If you want to save your mail in one group and the news articles you
write in another group, you could say something like:

 (setq gnus-message-archive-group
	'((if (message-news-p)
	      \"misc-news\"
	    \"misc-mail\")))

Normally the group names returned by this variable should be
unprefixed -- which implicitly means \"store on the archive server\".
However, you may wish to store the message on some other server.  In
that case, just return a fully prefixed name of the group --
\"nnml+private:mail.misc\", for instance." :group 'gnus-message :type '(choice (const :tag "none" nil) function sexp string))

(defcustom gnus-secondary-servers nil "\
List of NNTP servers that the user can choose between interactively.
To make Gnus query you for a server, you have to give `gnus' a
non-numeric prefix - `C-u M-x gnus', in short." :group 'gnus-server :type '(repeat string))

(defcustom gnus-nntp-server nil "\
*The name of the host running the NNTP server.
This variable is semi-obsolete.  Use the `gnus-select-method'
variable instead." :group 'gnus-server :type '(choice (const :tag "disable" nil) string))

(defcustom gnus-secondary-select-methods nil "\
A list of secondary methods that will be used for reading news.
This is a list where each element is a complete select method (see
`gnus-select-method').

If, for instance, you want to read your mail with the nnml back end,
you could set this variable:

\(setq gnus-secondary-select-methods '((nnml \"\")))" :group 'gnus-server :type '(repeat gnus-select-method))

(defcustom gnus-local-domain nil "\
Local domain name without a host name.
The DOMAINNAME environment variable is used instead if it is defined.
If the function `system-name' returns the full Internet name, there is
no need to set this variable." :group 'gnus-message :type '(choice (const :tag "default" nil) string))

(defcustom gnus-refer-article-method nil "\
Preferred method for fetching an article by Message-ID.
If you are reading news from the local spool (with nnspool), fetching
articles by Message-ID is painfully slow.  By setting this method to an
nntp method, you might get acceptable results.

The value of this variable must be a valid select method as discussed
in the documentation of `gnus-select-method'.

It can also be a list of select methods, as well as the special symbol
`current', which means to use the current select method.  If it is a
list, Gnus will try all the methods in the list until it finds a match." :group 'gnus-server :type '(choice (const :tag "default" nil) (const current) (const :tag "Google" (nnweb "refer" (nnweb-type google))) gnus-select-method (repeat :menu-tag "Try multiple" :tag "Multiple" :value (current (nnweb "refer" (nnweb-type google))) (choice :tag "Method" (const current) (const :tag "Google" (nnweb "refer" (nnweb-type google))) gnus-select-method))))

(defcustom gnus-group-faq-directory '("/ftp@mirrors.aol.com:/pub/rtfm/usenet/" "/ftp@sunsite.doc.ic.ac.uk:/pub/usenet/news-faqs/" "/ftp@src.doc.ic.ac.uk:/usenet/news-FAQS/" "/ftp@ftp.seas.gwu.edu:/pub/rtfm/" "/ftp@ftp.pasteur.fr:/pub/FAQ/" "/ftp@rtfm.mit.edu:/pub/usenet/" "/ftp@ftp.uni-paderborn.de:/pub/FAQ/" "/ftp@ftp.sunet.se:/pub/usenet/" "/ftp@nctuccca.nctu.edu.tw:/pub/Documents/rtfm/usenet-by-group/" "/ftp@hwarang.postech.ac.kr:/pub/usenet/" "/ftp@ftp.hk.super.net:/mirror/faqs/") "\
*Directory where the group FAQs are stored.
This will most commonly be on a remote machine, and the file will be
fetched by ange-ftp.

This variable can also be a list of directories.  In that case, the
first element in the list will be used by default.  The others can
be used when being prompted for a site.

Note that Gnus uses an aol machine as the default directory.  If this
feels fundamentally unclean, just think of it as a way to finally get
something of value back from them.

If the default site is too slow, try one of these:

   North America: mirrors.aol.com		 /pub/rtfm/usenet
		  ftp.seas.gwu.edu		 /pub/rtfm
		  rtfm.mit.edu			 /pub/usenet
   Europe:	  ftp.uni-paderborn.de		 /pub/FAQ
		  src.doc.ic.ac.uk               /usenet/news-FAQS
		  ftp.sunet.se			 /pub/usenet
		  ftp.pasteur.fr                 /pub/FAQ
   Asia:	  nctuccca.nctu.edu.tw		 /pub/Documents/rtfm/usenet-by-group/
		  hwarang.postech.ac.kr		 /pub/usenet
		  ftp.hk.super.net		 /mirror/faqs" :group 'gnus-group-various :type '(choice directory (repeat directory)))

(defcustom gnus-group-charter-alist '(("no" concat "http://no.news-admin.org/charter/" name ".txt") ("de" concat "http://purl.net/charta/" name ".html") ("dk" concat "http://www.usenet.dk/grupper.pl?get=" name) ("england" concat "http://england.news-admin.org/charters/" name) ("fr" concat "http://www.usenet-fr.net/fur/chartes/" name ".html") ("europa" concat "http://www.europa.usenet.eu.org/chartas/charta-en-" (gnus-replace-in-string name "europa\\." "") ".html") ("nl" concat "http://www.xs4all.nl/~sister/usenet/charters/" name) ("aus" concat "http://aus.news-admin.org/groupinfo.cgi/" name) ("pl" concat "http://www.usenet.pl/opisy/" name) ("ch" concat "http://www.use-net.ch/Usenet/charter.html#" name) ("at" concat "http://www.usenet.at/chartas/" name "/charta") ("uk" concat "http://www.usenet.org.uk/" name ".html") ("dfw" concat "http://www.cirr.com/dfw/charters/" name ".html") ("se" concat "http://www.usenet-se.net/Reglementen/" (gnus-replace-in-string name "\\." "_") ".html") ("milw" concat "http://usenet.mil.wi.us/" (gnus-replace-in-string name "milw\\." "") "-charter") ("ca" concat "http://www.sbay.org/ca/charter-" name ".html") ("netins" concat "http://www.netins.net/usenet/charter/" (gnus-replace-in-string name "\\." "-") "-charter.html")) "\
*An alist of (HIERARCHY . FORM) pairs used to construct the URL of a charter.
When FORM is evaluated `name' is bound to the name of the group." :version "22.1" :group 'gnus-group-various :type '(repeat (cons (string :tag "Hierarchy") (sexp :tag "Form"))))

(defcustom gnus-group-fetch-control-use-browse-url nil "\
*Non-nil means that control messages are displayed using `browse-url'.
Otherwise they are fetched with ange-ftp and displayed in an ephemeral
group." :version "22.1" :group 'gnus-group-various :type 'boolean)

(defcustom gnus-use-cross-reference t "\
*Non-nil means that cross referenced articles will be marked as read.
If nil, ignore cross references.  If t, mark articles as read in
subscribed newsgroups.  If neither t nor nil, mark as read in all
newsgroups." :group 'gnus-server :type '(choice (const :tag "off" nil) (const :tag "subscribed" t) (sexp :format "all" :value always)))

(defcustom gnus-process-mark ?\# "\
*Process mark." :group 'gnus-group-visual :group 'gnus-summary-marks :type 'character)

(defcustom gnus-large-newsgroup 200 "\
*The number of articles which indicates a large newsgroup.
If the number of articles in a newsgroup is greater than this value,
confirmation is required for selecting the newsgroup.
If it is nil, no confirmation is required." :group 'gnus-group-select :type '(choice (const :tag "No limit" nil) integer))

(defcustom gnus-use-long-file-name (not (memq system-type '(usg-unix-v xenix))) "\
*Non-nil means that the default name of a file to save articles in is the group name.
If it's nil, the directory form of the group name is used instead.

If this variable is a list, and the list contains the element
`not-score', long file names will not be used for score files; if it
contains the element `not-save', long file names will not be used for
saving; and if it contains the element `not-kill', long file names
will not be used for kill files.

Note that the default for this variable varies according to what system
type you're using.  On `usg-unix-v' and `xenix' this variable defaults
to nil while on all other systems it defaults to t." :group 'gnus-start :type '(radio (sexp :format "Non-nil
" :match (lambda (widget value) (and value (not (listp value)))) :value t) (const nil) (checklist (const :format "%v " not-score) (const :format "%v " not-save) (const not-kill))))

(defcustom gnus-kill-files-directory gnus-directory "\
*Name of the directory where kill files will be stored (default \"~/News\")." :group 'gnus-score-files :group 'gnus-score-kill :type 'directory)

(defcustom gnus-save-score nil "\
*If non-nil, save group scoring info." :group 'gnus-score-various :group 'gnus-start :type 'boolean)

(defcustom gnus-use-undo t "\
*If non-nil, allow undoing in Gnus group mode buffers." :group 'gnus-meta :type 'boolean)

(defcustom gnus-use-adaptive-scoring nil "\
*If non-nil, use some adaptive scoring scheme.
If a list, then the values `word' and `line' are meaningful.  The
former will perform adaption on individual words in the subject
header while `line' will perform adaption on several headers." :group 'gnus-meta :group 'gnus-score-adapt :type '(set (const word) (const line)))

(defcustom gnus-use-cache 'passive "\
*If nil, Gnus will ignore the article cache.
If `passive', it will allow entering (and reading) articles
explicitly entered into the cache.  If anything else, use the
cache to the full extent of the law." :group 'gnus-meta :group 'gnus-cache :type '(choice (const :tag "off" nil) (const :tag "passive" passive) (const :tag "active" t)))

(defcustom gnus-use-trees nil "\
*If non-nil, display a thread tree buffer." :group 'gnus-meta :type 'boolean)

(defcustom gnus-use-grouplens nil "\
*If non-nil, use GroupLens ratings." :group 'gnus-meta :type 'boolean)

(defcustom gnus-keep-backlog 20 "\
*If non-nil, Gnus will keep read articles for later re-retrieval.
If it is a number N, then Gnus will only keep the last N articles
read.  If it is neither nil nor a number, Gnus will keep all read
articles.  This is not a good idea." :group 'gnus-meta :type '(choice (const :tag "off" nil) integer (sexp :format "all" :value t)))

(defcustom gnus-use-nocem nil "\
*If non-nil, Gnus will read NoCeM cancel messages.
You can also set this variable to a positive number as a group level.
In that case, Gnus scans NoCeM messages when checking new news if this
value is not exceeding a group level that you specify as the prefix
argument to some commands, e.g. `gnus', `gnus-group-get-new-news', etc.
Otherwise, Gnus does not scan NoCeM messages if you specify a group
level to those commands." :group 'gnus-meta :type '(choice (const :tag "off" nil) (const :tag "on" t) (list :convert-widget (lambda (widget) (list 'integer :tag "group level" :value (if (boundp 'gnus-level-default-subscribed) gnus-level-default-subscribed 3))))))

(defcustom gnus-suppress-duplicates nil "\
*If non-nil, Gnus will mark duplicate copies of the same article as read." :group 'gnus-meta :type 'boolean)

(defcustom gnus-use-scoring t "\
*If non-nil, enable scoring." :group 'gnus-meta :type 'boolean)

(defcustom gnus-summary-prepare-exit-hook '(gnus-summary-expire-articles) "\
*A hook called when preparing to exit from the summary buffer.
It calls `gnus-summary-expire-articles' by default." :group 'gnus-summary-exit :type 'hook)

(defcustom gnus-novice-user t "\
*Non-nil means that you are a Usenet novice.
If non-nil, verbose messages may be displayed and confirmations may be
required." :group 'gnus-meta :type 'boolean)

(defcustom gnus-expert-user nil "\
*Non-nil means that you will never be asked for confirmation about anything.
That doesn't mean *anything* anything; particularly destructive
commands will still require prompting." :group 'gnus-meta :type 'boolean)

(defcustom gnus-interactive-catchup t "\
*If non-nil, require your confirmation when catching up a group." :group 'gnus-group-select :type 'boolean)

(defcustom gnus-interactive-exit t "\
*If non-nil, require your confirmation when exiting Gnus." :group 'gnus-exit :type 'boolean)

(defcustom gnus-extract-address-components 'gnus-extract-address-components "\
*Function for extracting address components from a From header.
Two pre-defined function exist: `gnus-extract-address-components',
which is the default, quite fast, and too simplistic solution, and
`mail-extract-address-components', which works much better, but is
slower." :group 'gnus-summary-format :type '(radio (function-item gnus-extract-address-components) (function-item mail-extract-address-components) (function :tag "Other")))

(defcustom gnus-carpal nil "\
*If non-nil, display clickable icons." :group 'gnus-meta :type 'boolean)

(defcustom gnus-shell-command-separator ";" "\
String used to separate shell commands." :group 'gnus-files :type 'string)

(defcustom gnus-valid-select-methods '(("nntp" post address prompt-address physical-address) ("nnspool" post address) ("nnvirtual" post-mail virtual prompt-address) ("nnmbox" mail respool address) ("nnml" post-mail respool address) ("nnmh" mail respool address) ("nndir" post-mail prompt-address physical-address) ("nneething" none address prompt-address physical-address) ("nndoc" none address prompt-address) ("nnbabyl" mail address respool) ("nnkiboze" post virtual) ("nnsoup" post-mail address) ("nndraft" post-mail) ("nnfolder" mail respool address) ("nngateway" post-mail address prompt-address physical-address) ("nnweb" none) ("nngoogle" post) ("nnslashdot" post) ("nnultimate" none) ("nnrss" none) ("nnwfm" none) ("nnwarchive" none) ("nnlistserv" none) ("nnagent" post-mail) ("nnimap" post-mail address prompt-address physical-address) ("nnmaildir" mail respool address) ("nnnil" none)) "\
*An alist of valid select methods.
The first element of each list lists should be a string with the name
of the select method.  The other elements may be the category of
this method (i. e., `post', `mail', `none' or whatever) or other
properties that this method has (like being respoolable).
If you implement a new select method, all you should have to change is
this variable.  I think." :group 'gnus-server :type '(repeat (group (string :tag "Name") (radio-button-choice (const :format "%v " post) (const :format "%v " mail) (const :format "%v " none) (const post-mail)) (checklist :inline t (const :format "%v " address) (const :format "%v " prompt-address) (const :format "%v " physical-address) (const :format "%v " virtual) (const respool)))))

(defcustom gnus-updated-mode-lines '(group article summary tree) "\
List of buffers that should update their mode lines.
The list may contain the symbols `group', `article', `tree' and
`summary'.  If the corresponding symbol is present, Gnus will keep
that mode line updated with information that may be pertinent.
If this variable is nil, screen refresh may be quicker." :group 'gnus-various :type '(set (const group) (const article) (const summary) (const tree)))

(defcustom gnus-mode-non-string-length nil "\
*Max length of mode-line non-string contents.
If this is nil, Gnus will take space as is needed, leaving the rest
of the mode line intact.  Note that the default of nil is unlikely
to be desirable; see the manual for further details." :group 'gnus-various :type '(choice (const nil) integer))

(defcustom gnus-install-group-spam-parameters t "\
*Disable the group parameters for spam detection.
Enable if `G c' in XEmacs is giving you trouble, and make sure to submit a bug report." :version "22.1" :type 'boolean :group 'gnus-start)

(defcustom gnus-group-uncollapsed-levels 1 "\
Number of group name elements to leave alone when making a short group name." :group 'gnus-group-visual :type 'integer)

(defcustom gnus-group-use-permanent-levels nil "\
*If non-nil, once you set a level, Gnus will use this level." :group 'gnus-group-levels :type 'boolean)

(defcustom gnus-load-hook nil "\
A hook run while Gnus is loaded." :group 'gnus-start :type 'hook)

(defcustom gnus-apply-kill-hook '(gnus-apply-kill-file) "\
A hook called to apply kill files to a group.
This hook is intended to apply a kill file to the selected newsgroup.
The function `gnus-apply-kill-file' is called by default.

Since a general kill file is too heavy to use only for a few
newsgroups, I recommend you to use a lighter hook function.  For
example, if you'd like to apply a kill file to articles which contains
a string `rmgroup' in subject in newsgroup `control', you can use the
following hook:

 (setq gnus-apply-kill-hook
      (list
	(lambda ()
	  (cond ((string-match \"control\" gnus-newsgroup-name)
		 (gnus-kill \"Subject\" \"rmgroup\")
		 (gnus-expunge \"X\"))))))" :group 'gnus-score-kill :options '(gnus-apply-kill-file) :type 'hook)

(defcustom gnus-group-change-level-function nil "\
Function run when a group level is changed.
It is called with three parameters -- GROUP, LEVEL and OLDLEVEL." :group 'gnus-group-levels :type '(choice (const nil) function))

(defcustom gnus-visual '(summary-highlight group-highlight article-highlight mouse-face summary-menu group-menu article-menu tree-highlight menu highlight browse-menu server-menu page-marker tree-menu binary-menu pick-menu grouplens-menu) "\
*Enable visual features.
If `visual' is disabled, there will be no menus and few faces.  Most of
the visual customization options below will be ignored.  Gnus will use
less space and be faster as a result.

This variable can also be a list of visual elements to switch on.  For
instance, to switch off all visual things except menus, you can say:

   (setq gnus-visual '(menu))

Valid elements include `summary-highlight', `group-highlight',
`article-highlight', `mouse-face', `summary-menu', `group-menu',
`article-menu', `tree-highlight', `menu', `highlight', `browse-menu',
`server-menu', `page-marker', `tree-menu', `binary-menu', `pick-menu',
and `grouplens-menu'." :group 'gnus-meta :group 'gnus-visual :type '(set (const summary-highlight) (const group-highlight) (const article-highlight) (const mouse-face) (const summary-menu) (const group-menu) (const article-menu) (const tree-highlight) (const menu) (const highlight) (const browse-menu) (const server-menu) (const page-marker) (const tree-menu) (const binary-menu) (const pick-menu) (const grouplens-menu)))

(defcustom gnus-mouse-face (condition-case nil (if (gnus-visual-p 'mouse-face 'highlight) (if (boundp 'gnus-mouse-face) (or gnus-mouse-face 'highlight) 'highlight) 'default) (error 'highlight)) "\
*Face used for group or summary buffer mouse highlighting.
The line beneath the mouse pointer will be highlighted with this
face." :group 'gnus-visual :type 'face)

(defcustom gnus-article-save-directory gnus-directory "\
*Name of the directory articles will be saved in (default \"~/News\")." :group 'gnus-article-saving :type 'directory)

(defcustom gnus-agent-cache t "\
Controls use of the agent cache while plugged.
When set, Gnus will prefer using the locally stored content rather
than re-fetching it from the server.  You also need to enable
`gnus-agent' for this to have any affect." :version "22.1" :group 'gnus-agent :type 'boolean)

(defcustom gnus-default-charset 'undecided "\
Default charset assumed to be used when viewing non-ASCII characters.
This variable is overridden on a group-to-group basis by the
`gnus-group-charset-alist' variable and is only used on groups not
covered by that variable." :type 'symbol :group 'gnus-charset)

(defcustom gnus-agent t "\
Whether we want to use the Gnus agent or not.

You may customize gnus-agent to disable its use.  However, some
back ends have started to use the agent as a client-side cache.
Disabling the agent may result in noticeable loss of performance." :version "22.1" :group 'gnus-agent :type 'boolean)

(defcustom gnus-other-frame-function 'gnus "\
Function called by the command `gnus-other-frame'." :group 'gnus-start :type '(choice (function-item gnus) (function-item gnus-no-server) (function-item gnus-slave) (function-item gnus-slave-no-server)))

(defcustom gnus-other-frame-parameters nil "\
Frame parameters used by `gnus-other-frame' to create a Gnus frame.
This should be an alist for Emacs, or a plist for XEmacs." :group 'gnus-start :type (if (featurep 'xemacs) '(repeat (list :inline t :format "%v" (symbol :tag "Property") (sexp :tag "Value"))) '(repeat (cons :format "%v" (symbol :tag "Parameter") (sexp :tag "Value")))))

(defcustom gnus-user-agent '(emacs gnus type) "\
Which information should be exposed in the User-Agent header.

Can be a list of symbols or a string.  Valid symbols are `gnus'
\(show Gnus version) and `emacs' (show Emacs version).  In
addition to the Emacs version, you can add `codename' (show
\(S)XEmacs codename) or either `config' (show system
configuration) or `type' (show system type).  If you set it to
a string, be sure to use a valid format, see RFC 2616." :version "22.1" :group 'gnus-message :type '(choice (list (set :inline t (const gnus :tag "Gnus version") (const emacs :tag "Emacs version") (choice :tag "system" (const type :tag "system type") (const config :tag "system configuration")) (const codename :tag "Emacs codename"))) (string)))

(defcustom gnus-cache-directory (nnheader-concat gnus-directory "cache/") "\
*The directory where cached articles will be stored." :group 'gnus-cache :type 'directory)

(defcustom gnus-summary-line-format "%U%R%z%I%(%[%4L: %-23,23f%]%) %s\n" "\
*The format specification of the lines in the summary buffer.

It works along the same lines as a normal formatting string,
with some simple extensions.

%N   Article number, left padded with spaces (string)
%S   Subject (string)
%s   Subject if it is at the root of a thread, and \"\" otherwise (string)
%n   Name of the poster (string)
%a   Extracted name of the poster (string)
%A   Extracted address of the poster (string)
%F   Contents of the From: header (string)
%f   Contents of the From: or To: headers (string)
%x   Contents of the Xref: header (string)
%D   Date of the article (string)
%d   Date of the article (string) in DD-MMM format
%o   Date of the article (string) in YYYYMMDD`T'HHMMSS format
%M   Message-id of the article (string)
%r   References of the article (string)
%c   Number of characters in the article (integer)
%k   Pretty-printed version of the above (string)
     For example, \"1.2k\" or \"0.4M\".
%L   Number of lines in the article (integer)
%I   Indentation based on thread level (a string of spaces)
%B   A complex trn-style thread tree (string)
     The variables `gnus-sum-thread-*' can be used for customization.
%T   A string with two possible values: 80 spaces if the article
     is on thread level two or larger and 0 spaces on level one
%R   \"A\" if this article has been replied to, \" \" otherwise (character)
%U   Status of this article (character, \"R\", \"K\", \"-\" or \" \")
%[   Opening bracket (character, \"[\" or \"<\")
%]   Closing bracket (character, \"]\" or \">\")
%>   Spaces of length thread-level (string)
%<   Spaces of length (- 20 thread-level) (string)
%i   Article score (number)
%z   Article zcore (character)
%t   Number of articles under the current thread (number).
%e   Whether the thread is empty or not (character).
%l   GroupLens score (string).
%V   Total thread score (number).
%P   The line number (number).
%O   Download mark (character).
%*   If present, indicates desired cursor position
     (instead of after first colon).
%u   User defined specifier.  The next character in the format string should
     be a letter.  Gnus will call the function gnus-user-format-function-X,
     where X is the letter following %u.  The function will be passed the
     current header as argument.  The function should return a string, which
     will be inserted into the summary just like information from any other
     summary specifier.

The %U (status), %R (replied) and %z (zcore) specs have to be handled
with care.  For reasons of efficiency, Gnus will compute what column
these characters will end up in, and \"hard-code\" that.  This means that
it is invalid to have these specs after a variable-length spec.  Well,
you might not be arrested, but your summary buffer will look strange,
which is bad enough.

The smart choice is to have these specs as far to the left as
possible.

This restriction may disappear in later versions of Gnus.

General format specifiers can also be used.
See Info node `(gnus)Formatting Variables'." :link '(custom-manual "(gnus)Formatting Variables") :type 'string :group 'gnus-summary-format)

(defcustom gnus-kill-file-name "KILL" "\
Suffix of the kill files." :group 'gnus-score-kill :group 'gnus-score-files :type 'string)

;;;***

;;;### (autoloads (gpg-ring) "gpg-ring" "lisp/gpg-ring.el")
(defconst custom-define-current-source-file "gpg-ring.el")

(defgroup gpg-ring nil "GNU Privacy Guard user interface." :tag "GnuPG user interface" :group 'gpg)

;;;***

;;;### (autoloads (gpg-command-key-retrieve gpg-command-key-secret-ring gpg-command-key-public-ring gpg-command-key-verify gpg-command-key-export gpg-command-key-import gpg-command-encrypt gpg-command-sign-encrypt gpg-command-sign-detached gpg-command-sign-cleartext gpg-command-decrypt gpg-command-verify-cleartext gpg-command-verify gpg-command-passphrase-env gpg-command-flag-recipient gpg-command-flag-sign-with-key gpg-command-flag-armor gpg-command-flag-textmode gpg-command-all-arglist gpg-command-default-alist gpg-temp-directory gpg-default-key-id gpg-passphrase-timeout gpg-commands-key gpg-commands gpg-options gpg) "gpg" "lisp/gpg.el")
(defconst custom-define-current-source-file "gpg.el")

(defgroup gpg nil "GNU Privacy Guard interface." :tag "GnuPG" :group 'processes)

(defgroup gpg-options nil "Controlling GnuPG invocation." :tag "GnuPG Options" :group 'gpg)

(defgroup gpg-commands nil "Primary GnuPG Operations." :tag "GnuPG Commands" :group 'gpg)

(defgroup gpg-commands-key nil "Commands for GnuPG key management." :tag "GnuPG Key Commands" :group 'gpg-commands)

(defcustom gpg-passphrase-timeout 0 "\
Timeout (in seconds) for the passphrase cache.
The passphrase cache is cleared after is hasn't been used for this
many seconds.  The values 0 means that the passphrase is not cached at
all." :tag "Passphrase Timeout" :type 'number :group 'gpg-options)

(defcustom gpg-default-key-id nil "\
Default key/user ID used for signatures." :tag "Default Key ID" :type '(choice (const :tag "Use GnuPG default." :value nil) (string)) :group 'gpg-options)

(defcustom gpg-temp-directory (expand-file-name "~/tmp") "\
Directory for temporary files.
If you are running Emacs 20, this directory must have mode 0700." :tag "Temp directory" :type 'string :group 'gpg-options)

(defcustom gpg-command-default-alist '((gpg . "gpg") (gpg-2comp . "gpg")) "\
Default paths for some GnuPG-related programs.
Modify this variable if you have to change the paths to the
executables required by the GnuPG interface.  You can enter \"gpg-2comp\"
for `gpg-2comp' if you have obtained this script, in order to gain
PGP 2.6.x compatibility." :tag "GnuPG programs" :type 'gpg-command-alist :group 'gpg-options)

(defcustom gpg-command-all-arglist nil "\
List of arguments to add to all GPG commands." :tag "All command args" :group 'gpg-options)

(defcustom gpg-command-flag-textmode "--textmode" "\
The flag to indicate canonical text mode to GnuPG." :tag "Text mode flag" :type 'string :group 'gpg-options)

(defcustom gpg-command-flag-armor "--armor" "\
The flag to request ASCII-armoring output from GnuPG." :tag "Armor flag" :type 'string :group 'gpg-options)

(defcustom gpg-command-flag-sign-with-key '("--local-user=" sign-with-key) "\
String to include to specify the signing key ID.
The elements are concatenated (without spaces) to form a command line
option." :tag "Sign with key flag" :type '(repeat :tag "Argument parts" (choice :format "%[Type%] %v" (const :tag "Start next argument." :value next-argument) (const :tag "Insert signing key ID here." :value sign-with-key) (string))) :group 'gpg-options)

(defcustom gpg-command-flag-recipient '(nil "-r" next-argument recipient next-argument) "\
Format of a recipient specification.
The elements are concatenated (without spaces) to form a command line
option.  The second part is repeated for each recipient." :tag "Recipients Flag" :type '(cons (repeat :tag "Common prefix" (choice :format "%[Type%] %v" (const :tag "Start next argument." :value next-argument) (string))) (repeat :tag "For each recipient" (choice :format "%[Type%] %v" (const :tag "Start next argument." :value next-argument) (const :tag "Insert recipient key ID here." :value recipient) (string)))) :group 'gpg-options)

(defcustom gpg-command-passphrase-env nil "\
Environment variable to set when a passphrase is required, or nil.
If an operation is invoked which requires a passphrase, this
environment variable is set before calling the external program to
indicate that it should read the passphrase from standard input." :tag "Passphrase environment" :type '(choice (const :tag "Disabled" :value nil) (cons (string :tag "Variable") (string :tag "Value"))) :group 'gpg-options)

(defcustom gpg-command-verify '(gpg "--status-fd" "1" "--batch" "--verbose" "--verify" signature-file message-file) "\
Command to verify a detached signature.
The invoked program has to read the signed message and the signature
from the given files.  It should write human-readable information to
standard output and/or standard error.  The program shall not convert
charsets or line endings; the input data shall be treated as binary." :tag "Verify Command" :type '(cons gpg-command-program (repeat :tag "Arguments" (choice :format "%[Type%] %v" (const :tag "Insert name of file containing the message here." :value message-file) (const :tag "Insert name of file containing the signature here." :value signature-file) (string :format "%v")))) :group 'gpg-commands)

(defcustom gpg-command-verify-cleartext '(gpg "--status-fd" "1" "--batch" "--verbose" "--verify" message-file) "\
Command to verify a message.
The invoked program has to read the signed message from the given
file.  It should write human-readable information to standard output
and/or standard error.  The program shall not convert charsets or line
endings; the input data shall be treated as binary." :tag "Cleartext Verify Command" :type '(cons gpg-command-program (repeat :tag "Arguments" (choice :format "%[Type%] %v" (const :tag "Insert name of file containing the message here." :value message-file) (string :format "%v")))) :group 'gpg-commands)

(defcustom gpg-command-decrypt '(gpg "--status-fd" "2" "--decrypt" "--batch" "--passphrase-fd=0") "\
Command to decrypt a message.
The invoked program has to read the passphrase from standard
input, followed by the encrypted message.  It writes the decrypted
message to standard output, and human-readable diagnostic messages to
standard error." :tag "Decrypt Command" :type '(cons gpg-command-program (repeat :tag "Arguments" (choice :format "%[Type%] %v" (const :tag "Insert name of file containing the message here." :value message-file) (string :format "%v")))) :group 'gpg-commands)

(defcustom gpg-command-sign-cleartext '(gpg-2comp "--batch" "--passphrase-fd=0" "--output=-" armor textmode "--clearsign" sign-with-key) "\
Command to create a \"clearsign\" text file.  
The invoked program has to read the passphrase from standard input,
followed by the message to sign.  It should write the ASCII-amored
signed text message to standard output, and diagnostic messages to
standard error." :tag "Clearsign Command" :type 'gpg-command-sign-options :group 'gpg-commands)

(defcustom gpg-command-sign-detached '(gpg-2comp "--batch" "--passphrase-fd=0" "--output=-" armor textmode "--detach-sign" sign-with-key) "\
Command to create a detached signature. 
The invoked program has to read the passphrase from standard input,
followed by the message to sign.  It should write the ASCII-amored
detached signature to standard output, and diagnostic messages to
standard error.  The program shall not convert charsets or line
endings; the input data shall be treated as binary." :tag "Sign Detached Command" :type 'gpg-command-sign-options :group 'gpg-commands)

(defcustom gpg-command-sign-encrypt '(gpg-2comp "--batch" "--passphrase-fd=0" "--output=-" armor textmode "--always-trust" sign-with-key recipients "--sign" "--encrypt" plaintext-file) "\
Command to sign and encrypt a file.
The invoked program has to read the passphrase from standard input,
followed by the message to sign and encrypt if there is no
`plaintext-file' placeholder.  It should write the ASCII-amored
encrypted message to standard output, and diagnostic messages to
standard error." :tag "Sign And Encrypt Command" :type '(cons gpg-command-program (repeat :tag "Arguments" (choice :format "%[Type%] %v" (const :tag "Insert the `sign with key' option here if necessary." :value sign-with-key) (const :tag "Insert list of recipients here." :value recipients) (const :tag "Insert here name of file with plaintext." :value plaintext-file) (string :format "%v")))) :group 'gpg-commands)

(defcustom gpg-command-encrypt '(gpg-2comp "--batch" "--output=-" armor textmode "--always-trust" "--encrypt" recipients plaintext-file) "\
Command to encrypt a file.  
The invoked program has to read the message to encrypt from standard
input or from the plaintext file (if the `plaintext-file' placeholder
is present).  It should write the ASCII-amored encrypted message to
standard output, and diagnostic messages to standard error." :type '(cons gpg-command-program (repeat :tag "Arguments" (choice :format "%[Type%] %v" (const :tag "Insert list of recipients here." :value recipients) (const :tag "Insert here name of file with plaintext." :value plaintext-file) (string :format "%v")))) :group 'gpg-commands)

(defcustom gpg-command-key-import '(gpg "--import" "--verbose" message-file) "\
Command to import a public key from a file." :tag "Import Command" :type '(cons gpg-command-program (repeat :tag "Arguments" (choice :format "%[Type%] %v" (const :tag "Insert name of file containing the key here." :value message-file) (string :format "%v")))) :group 'gpg-commands-key)

(defcustom gpg-command-key-export '(gpg "--no-verbose" "--armor" "--export" key-id) "\
Command to export a public key from the key ring.
The key should be written to standard output using ASCII armor." :tag "Export Command" :type 'gpg-command-key-options :group 'gpg-commands-key)

(defcustom gpg-command-key-verify '(gpg "--no-verbose" "--batch" "--fingerprint" "--check-sigs" key-id) "\
Command to verify a public key." :tag "Verification Command" :type 'gpg-command-key-options :group 'gpg-commands-key)

(defcustom gpg-command-key-public-ring '(gpg "--no-verbose" "--batch" "--with-colons" "--list-keys" key-id) "\
Command to list the contents of the public key ring." :tag "List Public Key Ring Command" :type 'gpg-command-key-options :group 'gpg-commands-key)

(defcustom gpg-command-key-secret-ring '(gpg "--no-verbose" "--batch" "--with-colons" "--list-secret-keys" key-id) "\
Command to list the contents of the secret key ring." :tag "List Secret Key Ring Command" :type 'gpg-command-key-options :group 'gpg-commands-key)

(defcustom gpg-command-key-retrieve '(gpg "--batch" "--recv-keys" key-id) "\
Command to retrieve public keys." :tag "Retrieve Keys Command" :type 'gpg-command-key-options :group 'gpg-commands-key)

;;;***

;;;### (autoloads (hashcash-in-news hashcash-double-spend-database hashcash-path hashcash-accept-resources hashcash-default-accept-payment hashcash-payment-alist hashcash-default-payment hashcash) "hashcash" "lisp/hashcash.el")
(defconst custom-define-current-source-file "hashcash.el")

(defgroup hashcash nil "Hashcash configuration." :group 'mail)

(defcustom hashcash-default-payment 0 "\
*The default number of bits to pay to unknown users.
If this is zero, no payment header will be generated.
See `hashcash-payment-alist'." :type 'integer :group 'hashcash)

(defcustom hashcash-payment-alist 'nil "\
*An association list mapping email addresses to payment amounts.
Elements may consist of (ADDR AMOUNT) or (ADDR STRING AMOUNT), where
ADDR is the email address of the intended recipient and AMOUNT is
the value of hashcash payment to be made to that user.  STRING, if
present, is the string to be hashed; if not present ADDR will be used." :group 'hashcash)

(defcustom hashcash-default-accept-payment 10 "\
*The default minimum number of bits to accept on incoming payments." :type 'integer :group 'hashcash)

(defcustom hashcash-accept-resources (backquote (((\, user-mail-address) nil))) "\
*An association list mapping hashcash resources to payment amounts.
Resources named here are to be accepted in incoming payments.  If the
corresponding AMOUNT is NIL, the value of `hashcash-default-accept-payment'
is used instead." :group 'hashcash)

(defcustom hashcash-path (executable-find "hashcash") "\
*The path to the hashcash binary." :group 'hashcash)

(defcustom hashcash-double-spend-database "hashcash.db" "\
*The path to the double-spending database." :group 'hashcash)

(defcustom hashcash-in-news nil "\
*Specifies whether or not hashcash payments should be made to newsgroups." :type 'boolean :group 'hashcash)

;;;***

;;;### (autoloads (imap-store-password imap-read-timeout imap-default-user imap-shell-host imap-debug imap-log imap-use-utf7 imap-process-connection-type imap-shell-program imap-ssl-program imap-gssapi-program imap-kerberos4-program imap) "imap" "lisp/imap.el")
(defconst custom-define-current-source-file "imap.el")

(defgroup imap nil "Low-level IMAP issues." :version "21.1" :group 'mail)

(defcustom imap-kerberos4-program '("imtest -m kerberos_v4 -u %l -p %p %s" "imtest -kp %s %p") "\
List of strings containing commands for Kerberos 4 authentication.
%s is replaced with server hostname, %p with port to connect to, and
%l with the value of `imap-default-user'.  The program should accept
IMAP commands on stdin and return responses to stdout.  Each entry in
the list is tried until a successful connection is made." :group 'imap :type '(repeat string))

(defcustom imap-gssapi-program (list (concat "gsasl %s %p " "--mechanism GSSAPI " "--authentication-id %l") "imtest -m gssapi -u %l -p %p %s") "\
List of strings containing commands for GSSAPI (krb5) authentication.
%s is replaced with server hostname, %p with port to connect to, and
%l with the value of `imap-default-user'.  The program should accept
IMAP commands on stdin and return responses to stdout.  Each entry in
the list is tried until a successful connection is made." :group 'imap :type '(repeat string))

(defcustom imap-ssl-program '("openssl s_client -quiet -ssl3 -connect %s:%p" "openssl s_client -quiet -ssl2 -connect %s:%p" "s_client -quiet -ssl3 -connect %s:%p" "s_client -quiet -ssl2 -connect %s:%p") "\
A string, or list of strings, containing commands for SSL connections.
Within a string, %s is replaced with the server address and %p with
port number on server.  The program should accept IMAP commands on
stdin and return responses to stdout.  Each entry in the list is tried
until a successful connection is made." :group 'imap :type '(choice string (repeat string)))

(defcustom imap-shell-program '("ssh %s imapd" "rsh %s imapd" "ssh %g ssh %s imapd" "rsh %g rsh %s imapd") "\
A list of strings, containing commands for IMAP connection.
Within a string, %s is replaced with the server address, %p with port
number on server, %g with `imap-shell-host', and %l with
`imap-default-user'.  The program should read IMAP commands from stdin
and write IMAP response to stdout. Each entry in the list is tried
until a successful connection is made." :group 'imap :type '(repeat string))

(defcustom imap-process-connection-type nil "\
*Value for `process-connection-type' to use for Kerberos4, GSSAPI and SSL.
The `process-connection-type' variable control type of device
used to communicate with subprocesses.  Values are nil to use a
pipe, or t or `pty' to use a pty.  The value has no effect if the
system has no ptys or if all ptys are busy: then a pipe is used
in any case.  The value takes effect when a IMAP server is
opened, changing it after that has no effect." :version "22.1" :group 'imap :type 'boolean)

(defcustom imap-use-utf7 t "\
If non-nil, do utf7 encoding/decoding of mailbox names.
Since the UTF7 decoding currently only decodes into ISO-8859-1
characters, you may disable this decoding if you need to access UTF7
encoded mailboxes which doesn't translate into ISO-8859-1." :group 'imap :type 'boolean)

(defcustom imap-log nil "\
If non-nil, a imap session trace is placed in *imap-log* buffer.
Note that username, passwords and other privacy sensitive
information (such as e-mail) may be stored in the *imap-log*
buffer.  It is not written to disk, however.  Do not enable this
variable unless you are comfortable with that." :group 'imap :type 'boolean)

(defcustom imap-debug nil "\
If non-nil, random debug spews are placed in *imap-debug* buffer.
Note that username, passwords and other privacy sensitive
information (such as e-mail) may be stored in the *imap-debug*
buffer.  It is not written to disk, however.  Do not enable this
variable unless you are comfortable with that." :group 'imap :type 'boolean)

(defcustom imap-shell-host "gateway" "\
Hostname of rlogin proxy." :group 'imap :type 'string)

(defcustom imap-default-user (user-login-name) "\
Default username to use." :group 'imap :type 'string)

(defcustom imap-read-timeout (if (string-match "windows-nt\\|os/2\\|emx\\|cygwin" (symbol-name system-type)) 1.0 0.1) "\
*How long to wait between checking for the end of output.
Shorter values mean quicker response, but is more CPU intensive." :type 'number :group 'imap)

(defcustom imap-store-password nil "\
If non-nil, store session password without promting." :group 'imap :type 'boolean)

;;;***

;;;### (autoloads (mail-source-movemail-program mail-source-idle-time-delay mail-source-report-new-mail-interval mail-source-incoming-file-prefix mail-source-delete-old-incoming-confirm mail-source-delete-incoming mail-source-default-file-modes mail-source-directory mail-source-crash-box mail-source-flash mail-source-primary-source mail-source-ignore-errors mail-sources mail-source) "mail-source" "lisp/mail-source.el")
(defconst custom-define-current-source-file "mail-source.el")

(defgroup mail-source nil "The mail-fetching library." :version "21.1" :group 'gnus)

(defcustom mail-sources nil "\
*Where the mail backends will look for incoming mail.
This variable is a list of mail source specifiers.
See Info node `(gnus)Mail Source Specifiers'." :group 'mail-source :link '(custom-manual "(gnus)Mail Source Specifiers") :type (backquote (choice (const nil) (repeat (choice :format "%[Value Menu%] %v" :value (file) (cons :tag "Spool file" (const :format "" file) (checklist :tag "Options" :greedy t (group :inline t (const :format "" :value :path) file))) (cons :tag "Several files in a directory" (const :format "" directory) (checklist :tag "Options" :greedy t (group :inline t (const :format "" :value :path) (directory :tag "Path")) (group :inline t (const :format "" :value :suffix) (string :tag "Suffix")) (group :inline t (const :format "" :value :predicate) (function :tag "Predicate")) (group :inline t (const :format "" :value :prescript) (choice :tag "Prescript" :value nil (string :format "%v") (function :format "%v"))) (group :inline t (const :format "" :value :postscript) (choice :tag "Postscript" :value nil (string :format "%v") (function :format "%v"))) (group :inline t (const :format "" :value :plugged) (boolean :tag "Plugged")))) (cons :tag "POP3 server" (const :format "" pop) (checklist :tag "Options" :greedy t (group :inline t (const :format "" :value :server) (string :tag "Server")) (group :inline t (const :format "" :value :port) (choice :tag "Port" :value "pop3" (number :format "%v") (string :format "%v"))) (group :inline t (const :format "" :value :user) (string :tag "User")) (group :inline t (const :format "" :value :password) (string :tag "Password")) (group :inline t (const :format "" :value :program) (string :tag "Program")) (group :inline t (const :format "" :value :prescript) (choice :tag "Prescript" :value nil (string :format "%v") (function :format "%v"))) (group :inline t (const :format "" :value :postscript) (choice :tag "Postscript" :value nil (string :format "%v") (function :format "%v"))) (group :inline t (const :format "" :value :function) (function :tag "Function")) (group :inline t (const :format "" :value :authentication) (choice :tag "Authentication" :value apop (const password) (const apop))) (group :inline t (const :format "" :value :plugged) (boolean :tag "Plugged")))) (cons :tag "Maildir (qmail, postfix...)" (const :format "" maildir) (checklist :tag "Options" :greedy t (group :inline t (const :format "" :value :path) (directory :tag "Path")) (group :inline t (const :format "" :value :plugged) (boolean :tag "Plugged")))) (cons :tag "IMAP server" (const :format "" imap) (checklist :tag "Options" :greedy t (group :inline t (const :format "" :value :server) (string :tag "Server")) (group :inline t (const :format "" :value :port) (choice :tag "Port" :value 143 number string)) (group :inline t (const :format "" :value :user) (string :tag "User")) (group :inline t (const :format "" :value :password) (string :tag "Password")) (group :inline t (const :format "" :value :stream) (choice :tag "Stream" :value network (\,@ mail-source-imap-streams))) (group :inline t (const :format "" :value :program) (string :tag "Program")) (group :inline t (const :format "" :value :authenticator) (choice :tag "Authenticator" :value login (\,@ mail-source-imap-authenticators))) (group :inline t (const :format "" :value :mailbox) (string :tag "Mailbox" :value "INBOX")) (group :inline t (const :format "" :value :predicate) (string :tag "Predicate" :value "UNSEEN UNDELETED")) (group :inline t (const :format "" :value :fetchflag) (string :tag "Fetchflag" :value "\\Deleted")) (group :inline t (const :format "" :value :dontexpunge) (boolean :tag "Dontexpunge")) (group :inline t (const :format "" :value :plugged) (boolean :tag "Plugged")))) (cons :tag "Webmail server" (const :format "" webmail) (checklist :tag "Options" :greedy t (group :inline t (const :format "" :value :subtype) (choice :tag "Subtype" :value hotmail (const hotmail) (const yahoo) (const netaddress) (const netscape) (const my-deja))) (group :inline t (const :format "" :value :user) (string :tag "User")) (group :inline t (const :format "" :value :password) (string :tag "Password")) (group :inline t (const :format "" :value :dontexpunge) (boolean :tag "Dontexpunge")) (group :inline t (const :format "" :value :plugged) (boolean :tag "Plugged")))))))))

(defcustom mail-source-ignore-errors nil "\
*Ignore errors when querying mail sources.
If nil, the user will be prompted when an error occurs.  If non-nil,
the error will be ignored." :version "22.1" :group 'mail-source :type 'boolean)

(defcustom mail-source-primary-source nil "\
*Primary source for incoming mail.
If non-nil, this maildrop will be checked periodically for new mail." :group 'mail-source :type 'sexp)

(defcustom mail-source-flash t "\
*If non-nil, flash periodically when mail is available." :group 'mail-source :type 'boolean)

(defcustom mail-source-crash-box "~/.emacs-mail-crash-box" "\
File where mail will be stored while processing it." :group 'mail-source :type 'file)

(defcustom mail-source-directory message-directory "\
Directory where incoming mail source files (if any) will be stored." :group 'mail-source :type 'directory)

(defcustom mail-source-default-file-modes 384 "\
Set the mode bits of all new mail files to this integer." :group 'mail-source :type 'integer)

(defcustom mail-source-delete-incoming 2 "\
If non-nil, delete incoming files after handling.
If t, delete immediately, if nil, never delete.  If a positive number, delete
files older than number of days.

Removing of old files happens in `mail-source-callback', i.e. no
old incoming files will be deleted unless you receive new mail.
You may also set this variable to nil and call
`mail-source-delete-old-incoming' interactively." :group 'mail-source :version "22.2" :type '(choice (const :tag "immediately" t) (const :tag "never" nil) (integer :tag "days")))

(defcustom mail-source-delete-old-incoming-confirm nil "\
If non-nil, ask for confirmation before deleting old incoming files.
This variable only applies when `mail-source-delete-incoming' is a positive
number." :version "22.2" :group 'mail-source :type 'boolean)

(defcustom mail-source-incoming-file-prefix "Incoming" "\
Prefix for file name for storing incoming mail" :group 'mail-source :type 'string)

(defcustom mail-source-report-new-mail-interval 5 "\
Interval in minutes between checks for new mail." :group 'mail-source :type 'number)

(defcustom mail-source-idle-time-delay 5 "\
Number of idle seconds to wait before checking for new mail." :group 'mail-source :type 'number)

(defcustom mail-source-movemail-program nil "\
If non-nil, name of program for fetching new mail." :version "22.1" :group 'mail-source :type '(choice (const nil) string))

;;;***

;;;### (autoloads (mailcap-download-directory mailcap) "mailcap" "lisp/mailcap.el")
(defconst custom-define-current-source-file "mailcap.el")

(defgroup mailcap nil "Definition of viewers for MIME types." :version "21.1" :group 'mime)

(defcustom mailcap-download-directory nil "\
*Directory to which `mailcap-save-binary-file' downloads files by default.
nil means your home directory." :type '(choice (const :tag "Home directory" nil) directory) :group 'mailcap)

;;;***

;;;### (autoloads (message-tab-body-function message-completion-alist message-newgroups-header-regexp message-tool-bar-zap-list message-tool-bar-retro message-tool-bar-gnome message-tool-bar message-simplify-subject-functions message-beginning-of-line message-header-synonyms message-strip-special-text-properties message-replacement-char message-valid-fqdn-regexp message-use-idna message-user-fqdn message-wide-reply-confirm-recipients message-mail-user-agent message-hierarchical-addresses message-alternative-emails message-send-mail-partially-limit message-sent-hook message-send-news-hook message-send-mail-hook message-send-hook message-hidden-headers message-dont-reply-to-names message-default-charset message-auto-save-directory message-mail-alias-type message-mailer-swallows-blank-line message-default-news-headers message-default-mail-headers message-default-headers message-user-path message-expires message-distribution-function message-signature-insert-empty-line message-signature-file message-signature message-indent-citation-function message-cite-function message-indentation-spaces message-yank-cited-prefix message-yank-prefix message-citation-line-function message-minibuffer-local-map message-header-setup-hook message-header-hook message-mode-hook message-signature-setup-hook message-cancel-hook message-setup-hook message-generate-headers-first message-post-method message-qmail-inject-args message-qmail-inject-program message-sendmail-envelope-from message-sendmail-f-is-evil message-allow-no-recipients message-subscribed-regexps message-subscribed-addresses message-subscribed-address-file message-subscribed-address-functions message-use-mail-followup-to message-use-followup-to message-followup-to-function message-wide-reply-to-function message-reply-to-function message-send-news-function message-send-mail-function message-cancel-message message-cite-prefix-regexp message-ignored-cited-headers message-forward-ignored-headers message-ignored-resent-headers message-wash-forwarded-subjects message-forward-before-signature message-forward-show-mml message-forward-as-mime message-make-forward-subject-function message-user-organization-file message-user-organization message-kill-buffer-on-exit message-generate-new-buffers message-interactive message-elide-ellipsis message-signature-separator message-cross-post-note-function message-followup-to-note message-cross-post-note message-cross-post-default message-archive-note message-archive-header message-mark-insert-end message-mark-insert-begin message-subject-trailing-was-regexp message-subject-trailing-was-ask-regexp message-subject-trailing-was-query message-subject-re-regexp message-ignored-supersedes-headers message-ignored-mail-headers message-ignored-news-headers message-deletable-headers message-required-mail-headers message-required-news-headers message-draft-headers message-required-headers message-syntax-checks message-insert-canlock message-from-style message-ignored-bounced-headers message-courtesy-message message-fcc-externalize-attachments message-fcc-handler-function message-send-rename-function message-max-buffers message-directory message-faces message-mail message-news message-headers message-insertion message-forwarding message-interface message-sending message-buffers message-various message) "message" "lisp/message.el")
(defconst custom-define-current-source-file "message.el")

(defgroup message '((user-mail-address custom-variable) (user-full-name custom-variable)) "Mail and news message composing." :link '(custom-manual "(message)Top") :group 'mail :group 'news)

(defgroup message-various nil "Various Message Variables." :link '(custom-manual "(message)Various Message Variables") :group 'message)

(defgroup message-buffers nil "Message Buffers." :link '(custom-manual "(message)Message Buffers") :group 'message)

(defgroup message-sending nil "Message Sending." :link '(custom-manual "(message)Sending Variables") :group 'message)

(defgroup message-interface nil "Message Interface." :link '(custom-manual "(message)Interface") :group 'message)

(defgroup message-forwarding nil "Message Forwarding." :link '(custom-manual "(message)Forwarding") :group 'message-interface)

(defgroup message-insertion nil "Message Insertion." :link '(custom-manual "(message)Insertion") :group 'message)

(defgroup message-headers nil "Message Headers." :link '(custom-manual "(message)Message Headers") :group 'message)

(defgroup message-news nil "Composing News Messages." :group 'message)

(defgroup message-mail nil "Composing Mail Messages." :group 'message)

(defgroup message-faces nil "Faces used for message composing." :group 'message :group 'faces)

(defcustom message-directory "~/Mail/" "\
*Directory from which all other mail file variables are derived." :group 'message-various :type 'directory)

(defcustom message-max-buffers 10 "\
*How many buffers to keep before starting to kill them off." :group 'message-buffers :type 'integer)

(defcustom message-send-rename-function nil "\
Function called to rename the buffer after sending it." :group 'message-buffers :type '(choice function (const nil)))

(defcustom message-fcc-handler-function 'message-output "\
*A function called to save outgoing articles.
This function will be called with the name of the file to store the
article in.  The default function is `message-output' which saves in Unix
mailbox format." :type '(radio (function-item message-output) (function :tag "Other")) :group 'message-sending)

(defcustom message-fcc-externalize-attachments nil "\
If non-nil, attachments are included as external parts in Fcc copies." :version "22.1" :type 'boolean :group 'message-sending)

(defcustom message-courtesy-message "The following message is a courtesy copy of an article\nthat has been posted to %s as well.\n\n" "\
*This is inserted at the start of a mailed copy of a posted message.
If the string contains the format spec \"%s\", the Newsgroups
the article has been posted to will be inserted there.
If this variable is nil, no such courtesy message will be added." :group 'message-sending :type '(radio string (const nil)))

(defcustom message-ignored-bounced-headers "^\\(Received\\|Return-Path\\|Delivered-To\\):" "\
*Regexp that matches headers to be removed in resent bounced mail." :group 'message-interface :type 'regexp)

(defcustom message-from-style 'default "\
*Specifies how \"From\" headers look.

If nil, they contain just the return address like:
	king@grassland.com
If `parens', they look like:
	king@grassland.com (Elvis Parsley)
If `angles', they look like:
	Elvis Parsley <king@grassland.com>

Otherwise, most addresses look like `angles', but they look like
`parens' if `angles' would need quoting and `parens' would not." :type '(choice (const :tag "simple" nil) (const parens) (const angles) (const default)) :group 'message-headers)

(defcustom message-insert-canlock t "\
Whether to insert a Cancel-Lock header in news postings." :version "22.1" :group 'message-headers :type 'boolean)

(defcustom message-syntax-checks (if message-insert-canlock '((sender . disabled)) nil) "\
*Controls what syntax checks should not be performed on outgoing posts.
To disable checking of long signatures, for instance, add
 `(signature . disabled)' to this list.

Don't touch this variable unless you really know what you're doing.

Checks include `approved', `continuation-headers', `control-chars',
`empty', `existing-newsgroups', `from', `illegible-text',
`invisible-text', `long-header-lines', `long-lines', `message-id',
`multiple-headers', `new-text', `newsgroups', `quoting-style',
`repeated-newsgroups', `reply-to', `sender', `sendsys', `shoot',
`shorten-followup-to', `signature', `size', `subject', `subject-cmsg'
and `valid-newsgroups'." :group 'message-news :type '(repeat sexp))

(defcustom message-required-headers '((optional . References) From) "\
*Headers to be generated or prompted for when sending a message.
Also see `message-required-news-headers' and
`message-required-mail-headers'." :version "22.1" :group 'message-news :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(repeat sexp))

(defcustom message-draft-headers '(References From) "\
*Headers to be generated when saving a draft message." :version "22.1" :group 'message-news :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(repeat sexp))

(defcustom message-required-news-headers '(From Newsgroups Subject Date Message-ID (optional . Organization) (optional . User-Agent)) "\
*Headers to be generated or prompted for when posting an article.
RFC977 and RFC1036 require From, Date, Newsgroups, Subject,
Message-ID.  Organization, Lines, In-Reply-To, Expires, and
User-Agent are optional.  If you don't want message to insert some
header, remove it from this list." :group 'message-news :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(repeat sexp))

(defcustom message-required-mail-headers '(From Subject Date (optional . In-Reply-To) Message-ID (optional . User-Agent)) "\
*Headers to be generated or prompted for when mailing a message.
It is recommended that From, Date, To, Subject and Message-ID be
included.  Organization and User-Agent are optional." :group 'message-mail :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(repeat sexp))

(defcustom message-deletable-headers '(Message-ID Date Lines) "\
Headers to be deleted if they already exist and were generated by message previously." :group 'message-headers :link '(custom-manual "(message)Message Headers") :type 'sexp)

(defcustom message-ignored-news-headers "^NNTP-Posting-Host:\\|^Xref:\\|^[BGF]cc:\\|^Resent-Fcc:\\|^X-Draft-From:\\|^X-Gnus-Agent-Meta-Information:" "\
*Regexp of headers to be removed unconditionally before posting." :group 'message-news :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(repeat :value-to-internal (lambda (widget value) (custom-split-regexp-maybe value)) :match (lambda (widget value) (or (stringp value) (widget-editable-list-match widget value))) regexp))

(defcustom message-ignored-mail-headers "^[GF]cc:\\|^Resent-Fcc:\\|^Xref:\\|^X-Draft-From:\\|^X-Gnus-Agent-Meta-Information:" "\
*Regexp of headers to be removed unconditionally before mailing." :group 'message-mail :group 'message-headers :link '(custom-manual "(message)Mail Headers") :type 'regexp)

(defcustom message-ignored-supersedes-headers "^Path:\\|^Date\\|^NNTP-Posting-Host:\\|^Xref:\\|^Lines:\\|^Received:\\|^X-From-Line:\\|^X-Trace:\\|^X-ID:\\|^X-Complaints-To:\\|Return-Path:\\|^Supersedes:\\|^NNTP-Posting-Date:\\|^X-Trace:\\|^X-Complaints-To:\\|^Cancel-Lock:\\|^Cancel-Key:\\|^X-Hashcash:\\|^X-Payment:" "\
*Header lines matching this regexp will be deleted before posting.
It's best to delete old Path and Date headers before posting to avoid
any confusion." :group 'message-interface :link '(custom-manual "(message)Superseding") :type '(repeat :value-to-internal (lambda (widget value) (custom-split-regexp-maybe value)) :match (lambda (widget value) (or (stringp value) (widget-editable-list-match widget value))) regexp))

(defcustom message-subject-re-regexp "^[ 	]*\\([Rr][Ee]\\(\\[[0-9]*\\]\\)*:[ 	]*\\)*[ 	]*" "\
*Regexp matching \"Re: \" in the subject line." :group 'message-various :link '(custom-manual "(message)Message Headers") :type 'regexp)

(defcustom message-subject-trailing-was-query 'ask "\
*What to do with trailing \"(was: <old subject>)\" in subject lines.
If nil, leave the subject unchanged.  If it is the symbol `ask', query
the user what do do.  In this case, the subject is matched against
`message-subject-trailing-was-ask-regexp'.  If
`message-subject-trailing-was-query' is t, always strip the trailing
old subject.  In this case, `message-subject-trailing-was-regexp' is
used." :version "22.1" :type '(choice (const :tag "never" nil) (const :tag "always strip" t) (const ask)) :link '(custom-manual "(message)Message Headers") :group 'message-various)

(defcustom message-subject-trailing-was-ask-regexp "[ 	]*\\([[(]+[Ww][Aa][Ss][ 	]*.*[])]+\\)" "\
*Regexp matching \"(was: <old subject>)\" in the subject line.

The function `message-strip-subject-trailing-was' uses this regexp if
`message-subject-trailing-was-query' is set to the symbol `ask'.  If
the variable is t instead of `ask', use
`message-subject-trailing-was-regexp' instead.

It is okay to create some false positives here, as the user is asked." :version "22.1" :group 'message-various :link '(custom-manual "(message)Message Headers") :type 'regexp)

(defcustom message-subject-trailing-was-regexp "[ 	]*\\((*[Ww][Aa][Ss]:[ 	]*.*)\\)" "\
*Regexp matching \"(was: <old subject>)\" in the subject line.

If `message-subject-trailing-was-query' is set to t, the subject is
matched against `message-subject-trailing-was-regexp' in
`message-strip-subject-trailing-was'.  You should use a regexp creating very
few false positives here." :version "22.1" :group 'message-various :link '(custom-manual "(message)Message Headers") :type 'regexp)

(defcustom message-mark-insert-begin "--8<---------------cut here---------------start------------->8---\n" "\
How to mark the beginning of some inserted text." :version "22.1" :type 'string :link '(custom-manual "(message)Insertion Variables") :group 'message-various)

(defcustom message-mark-insert-end "--8<---------------cut here---------------end--------------->8---\n" "\
How to mark the end of some inserted text." :version "22.1" :type 'string :link '(custom-manual "(message)Insertion Variables") :group 'message-various)

(defcustom message-archive-header "X-No-Archive: Yes\n" "\
Header to insert when you don't want your article to be archived.
Archives (such as groups.google.com) respect this header." :version "22.1" :type 'string :link '(custom-manual "(message)Header Commands") :group 'message-various)

(defcustom message-archive-note "X-No-Archive: Yes - save http://groups.google.com/" "\
Note to insert why you wouldn't want this posting archived.
If nil, don't insert any text in the body." :version "22.1" :type '(radio string (const nil)) :link '(custom-manual "(message)Header Commands") :group 'message-various)

(defcustom message-cross-post-default t "\
When non-nil `message-cross-post-followup-to' will perform a crosspost.
If nil, `message-cross-post-followup-to' will only do a followup.  Note that
you can explicitly override this setting by calling
`message-cross-post-followup-to' with a prefix." :version "22.1" :type 'boolean :group 'message-various)

(defcustom message-cross-post-note "Crosspost & Followup-To: " "\
Note to insert before signature to notify of cross-post and follow-up." :version "22.1" :type 'string :group 'message-various)

(defcustom message-followup-to-note "Followup-To: " "\
Note to insert before signature to notify of follow-up only." :version "22.1" :type 'string :group 'message-various)

(defcustom message-cross-post-note-function 'message-cross-post-insert-note "\
Function to use to insert note about Crosspost or Followup-To.
The function will be called with four arguments.  The function should not only
insert a note, but also ensure old notes are deleted.  See the documentation
for `message-cross-post-insert-note'." :version "22.1" :type 'function :group 'message-various)

(defcustom message-signature-separator "^-- *$" "\
Regexp matching the signature separator." :type 'regexp :link '(custom-manual "(message)Various Message Variables") :group 'message-various)

(defcustom message-elide-ellipsis "\n[...]\n\n" "\
*The string which is inserted for elided text." :type 'string :link '(custom-manual "(message)Various Commands") :group 'message-various)

(defcustom message-interactive t "\
Non-nil means when sending a message wait for and display errors.
nil means let mailer mail back a message to report errors." :group 'message-sending :group 'message-mail :link '(custom-manual "(message)Sending Variables") :type 'boolean)

(defcustom message-generate-new-buffers 'unique "\
*Say whether to create a new message buffer to compose a message.
Valid values include:

nil
  Generate the buffer name in the Message way (e.g., *mail*, *news*,
  *mail to whom*, *news on group*, etc.) and continue editing in the
  existing buffer of that name.  If there is no such buffer, it will
  be newly created.

`unique' or t
  Create the new buffer with the name generated in the Message way.

`unsent'
  Similar to `unique' but the buffer name begins with \"*unsent \".

`standard'
  Similar to nil but the buffer name is simpler like *mail message*.

function
  If this is a function, call that function with three parameters:
  The type, the To address and the group name (any of these may be nil).
  The function should return the new buffer name." :group 'message-buffers :link '(custom-manual "(message)Message Buffers") :type '(choice (const nil) (sexp :tag "unique" :format "unique
" :value unique :match (lambda (widget value) (memq value '(unique t)))) (const unsent) (const standard) (function :format "
    %{%t%}: %v")))

(defcustom message-kill-buffer-on-exit nil "\
*Non-nil means that the message buffer will be killed after sending a message." :group 'message-buffers :link '(custom-manual "(message)Message Buffers") :type 'boolean)

(defcustom message-user-organization (or (and (boundp 'gnus-local-organization) (stringp gnus-local-organization) gnus-local-organization) (getenv "ORGANIZATION") t) "\
*String to be used as an Organization header.
If t, use `message-user-organization-file'." :group 'message-headers :type '(choice string (const :tag "consult file" t)))

(defcustom message-user-organization-file "/usr/lib/news/organization" "\
*Local news organization file." :type 'file :link '(custom-manual "(message)News Headers") :group 'message-headers)

(defcustom message-make-forward-subject-function (function message-forward-subject-name-subject) "\
*List of functions called to generate subject headers for forwarded messages.
The subject generated by the previous function is passed into each
successive function.

The provided functions are:

* `message-forward-subject-author-subject' Source of article (author or
      newsgroup), in brackets followed by the subject
* `message-forward-subject-name-subject' Source of article (name of author
      or newsgroup), in brackets followed by the subject
* `message-forward-subject-fwd' Subject of article with 'Fwd:' prepended
      to it." :group 'message-forwarding :link '(custom-manual "(message)Forwarding") :type '(radio (function-item message-forward-subject-author-subject) (function-item message-forward-subject-fwd) (function-item message-forward-subject-name-subject) (repeat :tag "List of functions" function)))

(defcustom message-forward-as-mime t "\
*Non-nil means forward messages as an inline/rfc822 MIME section.
Otherwise, directly inline the old message in the forwarded message." :version "21.1" :group 'message-forwarding :link '(custom-manual "(message)Forwarding") :type 'boolean)

(defcustom message-forward-show-mml 'best "\
*Non-nil means show forwarded messages as MML (decoded from MIME).
Otherwise, forwarded messages are unchanged.
Can also be the symbol `best' to indicate that MML should be
used, except when it is a bad idea to use MML.  One example where
it is a bad idea is when forwarding a signed or encrypted
message, because converting MIME to MML would invalidate the
digital signature." :version "21.1" :group 'message-forwarding :type '(choice (const :tag "use MML" t) (const :tag "don't use MML " nil) (const :tag "use MML when appropriate" best)))

(defcustom message-forward-before-signature t "\
*Non-nil means put forwarded message before signature, else after." :group 'message-forwarding :type 'boolean)

(defcustom message-wash-forwarded-subjects nil "\
*Non-nil means try to remove as much cruft as possible from the subject.
Done before generating the new subject of a forward." :group 'message-forwarding :link '(custom-manual "(message)Forwarding") :type 'boolean)

(defcustom message-ignored-resent-headers "^Return-receipt\\|^X-Gnus\\|^Gnus-Warning:\\|^>?From " "\
*All headers that match this regexp will be deleted when resending a message." :group 'message-interface :link '(custom-manual "(message)Resending") :type '(repeat :value-to-internal (lambda (widget value) (custom-split-regexp-maybe value)) :match (lambda (widget value) (or (stringp value) (widget-editable-list-match widget value))) regexp))

(defcustom message-forward-ignored-headers "^Content-Transfer-Encoding:\\|^X-Gnus" "\
*All headers that match this regexp will be deleted when forwarding a message." :version "21.1" :group 'message-forwarding :type '(repeat :value-to-internal (lambda (widget value) (custom-split-regexp-maybe value)) :match (lambda (widget value) (or (stringp value) (widget-editable-list-match widget value))) regexp))

(defcustom message-ignored-cited-headers "." "\
*Delete these headers from the messages you yank." :group 'message-insertion :link '(custom-manual "(message)Insertion Variables") :type 'regexp)

(defcustom message-cite-prefix-regexp (if (string-match "[[:digit:]]" "1") "\\([ 	]*[-_.[:word:]]+>+\\|[ 	]*[]>|}+]\\)+" (let ((old-table (syntax-table)) non-word-constituents) (set-syntax-table text-mode-syntax-table) (setq non-word-constituents (concat (if (string-match "\\w" "-") "" "-") (if (string-match "\\w" "_") "" "_") (if (string-match "\\w" ".") "" "."))) (set-syntax-table old-table) (if (equal non-word-constituents "") "\\([ 	]*\\(\\w\\)+>+\\|[ 	]*[]>|}+]\\)+" (concat "\\([ 	]*\\(\\w\\|[" non-word-constituents "]\\)+>+\\|[ 	]*[]>|}+]\\)+")))) "\
*Regexp matching the longest possible citation prefix on a line." :version "22.1" :group 'message-insertion :link '(custom-manual "(message)Insertion Variables") :type 'regexp)

(defcustom message-cancel-message "I am canceling my own article.\n" "\
Message to be inserted in the cancel message." :group 'message-interface :link '(custom-manual "(message)Canceling News") :type 'string)

(defcustom message-send-mail-function 'message-send-mail-with-sendmail "\
Function to call to send the current buffer as mail.
The headers should be delimited by a line whose contents match the
variable `mail-header-separator'.

Valid values include `message-send-mail-with-sendmail' (the default),
`message-send-mail-with-mh', `message-send-mail-with-qmail',
`message-smtpmail-send-it', `smtpmail-send-it' and `feedmail-send-it'.

See also `send-mail-function'." :type '(radio (function-item message-send-mail-with-sendmail) (function-item message-send-mail-with-mh) (function-item message-send-mail-with-qmail) (function-item message-smtpmail-send-it) (function-item smtpmail-send-it) (function-item feedmail-send-it) (function :tag "Other")) :group 'message-sending :link '(custom-manual "(message)Mail Variables") :group 'message-mail)

(defcustom message-send-news-function 'message-send-news "\
Function to call to send the current buffer as news.
The headers should be delimited by a line whose contents match the
variable `mail-header-separator'." :group 'message-sending :group 'message-news :link '(custom-manual "(message)News Variables") :type 'function)

(defcustom message-reply-to-function nil "\
If non-nil, function that should return a list of headers.
This function should pick out addresses from the To, Cc, and From headers
and respond with new To and Cc headers." :group 'message-interface :link '(custom-manual "(message)Reply") :type '(choice function (const nil)))

(defcustom message-wide-reply-to-function nil "\
If non-nil, function that should return a list of headers.
This function should pick out addresses from the To, Cc, and From headers
and respond with new To and Cc headers." :group 'message-interface :link '(custom-manual "(message)Wide Reply") :type '(choice function (const nil)))

(defcustom message-followup-to-function nil "\
If non-nil, function that should return a list of headers.
This function should pick out addresses from the To, Cc, and From headers
and respond with new To and Cc headers." :group 'message-interface :link '(custom-manual "(message)Followup") :type '(choice function (const nil)))

(defcustom message-use-followup-to 'ask "\
*Specifies what to do with Followup-To header.
If nil, always ignore the header.  If it is t, use its value, but
query before using the \"poster\" value.  If it is the symbol `ask',
always query the user whether to use the value.  If it is the symbol
`use', always use the value." :group 'message-interface :link '(custom-manual "(message)Followup") :type '(choice (const :tag "ignore" nil) (const :tag "use & query" t) (const use) (const ask)))

(defcustom message-use-mail-followup-to 'use "\
*Specifies what to do with Mail-Followup-To header.
If nil, always ignore the header.  If it is the symbol `ask', always
query the user whether to use the value.  If it is the symbol `use',
always use the value." :version "22.1" :group 'message-interface :link '(custom-manual "(message)Mailing Lists") :type '(choice (const :tag "ignore" nil) (const use) (const ask)))

(defcustom message-subscribed-address-functions nil "\
*Specifies functions for determining list subscription.
If nil, do not attempt to determine list subscription with functions.
If non-nil, this variable contains a list of functions which return
regular expressions to match lists.  These functions can be used in
conjunction with `message-subscribed-regexps' and
`message-subscribed-addresses'." :version "22.1" :group 'message-interface :link '(custom-manual "(message)Mailing Lists") :type '(repeat sexp))

(defcustom message-subscribed-address-file nil "\
*A file containing addresses the user is subscribed to.
If nil, do not look at any files to determine list subscriptions.  If
non-nil, each line of this file should be a mailing list address." :version "22.1" :group 'message-interface :link '(custom-manual "(message)Mailing Lists") :type '(radio file (const nil)))

(defcustom message-subscribed-addresses nil "\
*Specifies a list of addresses the user is subscribed to.
If nil, do not use any predefined list subscriptions.  This list of
addresses can be used in conjunction with
`message-subscribed-address-functions' and `message-subscribed-regexps'." :version "22.1" :group 'message-interface :link '(custom-manual "(message)Mailing Lists") :type '(repeat string))

(defcustom message-subscribed-regexps nil "\
*Specifies a list of addresses the user is subscribed to.
If nil, do not use any predefined list subscriptions.  This list of
regular expressions can be used in conjunction with
`message-subscribed-address-functions' and `message-subscribed-addresses'." :version "22.1" :group 'message-interface :link '(custom-manual "(message)Mailing Lists") :type '(repeat regexp))

(defcustom message-allow-no-recipients 'ask "\
Specifies what to do when there are no recipients other than Gcc/Fcc.
If it is the symbol `always', the posting is allowed.  If it is the
symbol `never', the posting is not allowed.  If it is the symbol
`ask', you are prompted." :version "22.1" :group 'message-interface :link '(custom-manual "(message)Message Headers") :type '(choice (const always) (const never) (const ask)))

(defcustom message-sendmail-f-is-evil nil "\
*Non-nil means don't add \"-f username\" to the sendmail command line.
Doing so would be even more evil than leaving it out." :group 'message-sending :link '(custom-manual "(message)Mail Variables") :type 'boolean)

(defcustom message-sendmail-envelope-from nil "\
*Envelope-from when sending mail with sendmail.
If this is nil, use `user-mail-address'.  If it is the symbol
`header', use the From: header of the message." :version "22.1" :type '(choice (string :tag "From name") (const :tag "Use From: header from message" header) (const :tag "Use `user-mail-address'" nil)) :link '(custom-manual "(message)Mail Variables") :group 'message-sending)

(defcustom message-qmail-inject-program "/var/qmail/bin/qmail-inject" "\
Location of the qmail-inject program." :group 'message-sending :link '(custom-manual "(message)Mail Variables") :type 'file)

(defcustom message-qmail-inject-args nil "\
Arguments passed to qmail-inject programs.
This should be a list of strings, one string for each argument.  It
may also be a function.

For e.g., if you wish to set the envelope sender address so that bounces
go to the right place or to deal with listserv's usage of that address, you
might set this variable to '(\"-f\" \"you@some.where\")." :group 'message-sending :link '(custom-manual "(message)Mail Variables") :type '(choice (function) (repeat string)))

(defcustom message-post-method (cond ((and (boundp 'gnus-post-method) (listp gnus-post-method) gnus-post-method) gnus-post-method) ((boundp 'gnus-select-method) gnus-select-method) (t '(nnspool ""))) "\
*Method used to post news.
Note that when posting from inside Gnus, for instance, this
variable isn't used." :group 'message-news :group 'message-sending :type 'sexp)

(defcustom message-generate-headers-first '(references) "\
Which headers should be generated before starting to compose a message.
If t, generate all required headers.  This can also be a list of headers to
generate.  The variables `message-required-news-headers' and
`message-required-mail-headers' specify which headers to generate.

Note that the variable `message-deletable-headers' specifies headers which
are to be deleted and then re-generated before sending, so this variable
will not have a visible effect for those headers." :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(choice (const :tag "None" nil) (const :tag "References" '(references)) (const :tag "All" t) (repeat (sexp :tag "Header"))))

(defcustom message-setup-hook nil "\
Normal hook, run each time a new outgoing message is initialized.
The function `message-setup' runs this hook." :group 'message-various :link '(custom-manual "(message)Various Message Variables") :type 'hook)

(defcustom message-cancel-hook nil "\
Hook run when cancelling articles." :group 'message-various :link '(custom-manual "(message)Various Message Variables") :type 'hook)

(defcustom message-signature-setup-hook nil "\
Normal hook, run each time a new outgoing message is initialized.
It is run after the headers have been inserted and before
the signature is inserted." :group 'message-various :link '(custom-manual "(message)Various Message Variables") :type 'hook)

(defcustom message-mode-hook nil "\
Hook run in message mode buffers." :group 'message-various :type 'hook)

(defcustom message-header-hook nil "\
Hook run in a message mode buffer narrowed to the headers." :group 'message-various :type 'hook)

(defcustom message-header-setup-hook nil "\
Hook called narrowed to the headers when setting up a message buffer." :group 'message-various :link '(custom-manual "(message)Various Message Variables") :type 'hook)

(defcustom message-minibuffer-local-map (let ((map (make-sparse-keymap 'message-minibuffer-local-map))) (set-keymap-parent map minibuffer-local-map) map) "\
Keymap for `message-read-from-minibuffer'." :version "22.1" :group 'message-various)

(defcustom message-citation-line-function 'message-insert-citation-line "\
*Function called to insert the \"Whomever writes:\" line.

Note that Gnus provides a feature where the reader can click on
`writes:' to hide the cited text.  If you change this line too much,
people who read your message will have to change their Gnus
configuration.  See the variable `gnus-cite-attribution-suffix'." :type 'function :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-yank-prefix "> " "\
*Prefix inserted on the lines of yanked messages.
Fix `message-cite-prefix-regexp' if it is set to an abnormal value.
See also `message-yank-cited-prefix'." :type 'string :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-yank-cited-prefix ">" "\
*Prefix inserted on cited or empty lines of yanked messages.
Fix `message-cite-prefix-regexp' if it is set to an abnormal value.
See also `message-yank-prefix'." :version "22.1" :type 'string :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-indentation-spaces 3 "\
*Number of spaces to insert at the beginning of each cited line.
Used by `message-yank-original' via `message-yank-cite'." :group 'message-insertion :link '(custom-manual "(message)Insertion Variables") :type 'integer)

(defcustom message-cite-function 'message-cite-original "\
*Function for citing an original message.
Predefined functions include `message-cite-original' and
`message-cite-original-without-signature'.
Note that `message-cite-original' uses `mail-citation-hook' if that is non-nil." :type '(radio (function-item message-cite-original) (function-item message-cite-original-without-signature) (function-item sc-cite-original) (function :tag "Other")) :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-indent-citation-function 'message-indent-citation "\
*Function for modifying a citation just inserted in the mail buffer.
This can also be a list of functions.  Each function can find the
citation between (point) and (mark t).  And each function should leave
point and mark around the citation text as modified." :type 'function :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-signature t "\
*String to be inserted at the end of the message buffer.
If t, the `message-signature-file' file will be inserted instead.
If a function, the result from the function will be used instead.
If a form, the result from the form will be used instead." :type 'sexp :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-signature-file "~/.signature" "\
*Name of file containing the text inserted at end of message buffer.
Ignored if the named file doesn't exist.
If nil, don't insert a signature." :type '(choice file (const :tags "None" nil)) :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-signature-insert-empty-line t "\
*If non-nil, insert an empty line before the signature separator." :version "22.1" :type 'boolean :link '(custom-manual "(message)Insertion Variables") :group 'message-insertion)

(defcustom message-distribution-function nil "\
*Function called to return a Distribution header." :group 'message-news :group 'message-headers :link '(custom-manual "(message)News Headers") :type '(choice function (const nil)))

(defcustom message-expires 14 "\
Number of days before your article expires." :group 'message-news :group 'message-headers :link '(custom-manual "(message)News Headers") :type 'integer)

(defcustom message-user-path nil "\
If nil, use the NNTP server name in the Path header.
If stringp, use this; if non-nil, use no host name (user name only)." :group 'message-news :group 'message-headers :link '(custom-manual "(message)News Headers") :type '(choice (const :tag "nntp" nil) (string :tag "name") (sexp :tag "none" :format "%t" t)))

(defcustom message-default-headers "" "\
*A string containing header lines to be inserted in outgoing messages.
It is inserted before you edit the message, so you can edit or delete
these lines." :group 'message-headers :link '(custom-manual "(message)Message Headers") :type 'message-header-lines)

(defcustom message-default-mail-headers "" "\
*A string of header lines to be inserted in outgoing mails." :group 'message-headers :group 'message-mail :link '(custom-manual "(message)Mail Headers") :type 'message-header-lines)

(defcustom message-default-news-headers "" "\
*A string of header lines to be inserted in outgoing news articles." :group 'message-headers :group 'message-news :link '(custom-manual "(message)News Headers") :type 'message-header-lines)

(defcustom message-mailer-swallows-blank-line (if (and (string-match "sparc-sun-sunos\\(\\'\\|[^5]\\)" system-configuration) (file-readable-p "/etc/sendmail.cf") (let ((buffer (get-buffer-create " *temp*"))) (unwind-protect (save-excursion (set-buffer buffer) (insert-file-contents "/etc/sendmail.cf") (goto-char (point-min)) (let ((case-fold-search nil)) (re-search-forward "^OR\\>" nil t))) (kill-buffer buffer)))) '(looking-at "[ 	]\\|[][!\"#$%&'()*+,-./0-9;<=>?@A-Z\\\\^_`a-z{|}~]+:")) "\
*Set this non-nil if the system's mailer runs the header and body together.
\(This problem exists on Sunos 4 when sendmail is run in remote mode.)
The value should be an expression to test whether the problem will
actually occur." :group 'message-sending :link '(custom-manual "(message)Mail Variables") :type 'sexp)

(defcustom message-mail-alias-type 'abbrev "\
*What alias expansion type to use in Message buffers.
The default is `abbrev', which uses mailabbrev.  nil switches
mail aliases off." :group 'message :link '(custom-manual "(message)Mail Aliases") :type '(choice (const :tag "Use Mailabbrev" abbrev) (const :tag "No expansion" nil)))

(defcustom message-auto-save-directory (file-name-as-directory (nnheader-concat message-directory "drafts")) "\
*Directory where Message auto-saves buffers if Gnus isn't running.
If nil, Message won't auto-save." :group 'message-buffers :link '(custom-manual "(message)Various Message Variables") :type '(choice directory (const :tag "Don't auto-save" nil)))

(defcustom message-default-charset (and (not (mm-multibyte-p)) 'iso-8859-1) "\
Default charset used in non-MULE Emacsen.
If nil, you might be asked to input the charset." :version "21.1" :group 'message :link '(custom-manual "(message)Various Message Variables") :type 'symbol)

(defcustom message-dont-reply-to-names (and (boundp 'rmail-dont-reply-to-names) rmail-dont-reply-to-names) "\
*A regexp specifying addresses to prune when doing wide replies.
A value of nil means exclude your own user name only." :version "21.1" :group 'message :link '(custom-manual "(message)Wide Reply") :type '(choice (const :tag "Yourself" nil) regexp))

(defcustom message-hidden-headers nil "\
Regexp of headers to be hidden when composing new messages.
This can also be a list of regexps to match headers.  Or a list
starting with `not' and followed by regexps." :version "22.1" :group 'message :link '(custom-manual "(message)Message Headers") :type '(repeat regexp))

(defcustom message-send-hook nil "\
Hook run before sending messages.
This hook is run quite early when sending." :group 'message-various :options '(ispell-message) :link '(custom-manual "(message)Various Message Variables") :type 'hook)

(defcustom message-send-mail-hook nil "\
Hook run before sending mail messages.
This hook is run very late -- just before the message is sent as
mail." :group 'message-various :link '(custom-manual "(message)Various Message Variables") :type 'hook)

(defcustom message-send-news-hook nil "\
Hook run before sending news messages.
This hook is run very late -- just before the message is sent as
news." :group 'message-various :link '(custom-manual "(message)Various Message Variables") :type 'hook)

(defcustom message-sent-hook nil "\
Hook run after sending messages." :group 'message-various :type 'hook)

(defcustom message-send-mail-partially-limit 1000000 "\
The limitation of messages sent as message/partial.
The lower bound of message size in characters, beyond which the message
should be sent in several parts.  If it is nil, the size is unlimited." :version "21.1" :group 'message-buffers :link '(custom-manual "(message)Mail Variables") :type '(choice (const :tag "unlimited" nil) (integer 1000000)))

(defcustom message-alternative-emails nil "\
*Regexp matching alternative email addresses.
The first address in the To, Cc or From headers of the original
article matching this variable is used as the From field of
outgoing messages.

This variable has precedence over posting styles and anything that runs
off `message-setup-hook'." :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(choice (const :tag "Always use primary" nil) regexp))

(defcustom message-hierarchical-addresses nil "\
A list of hierarchical mail address definitions.

Inside each entry, the first address is the \"top\" address, and
subsequent addresses are subaddresses; this is used to indicate that
mail sent to the first address will automatically be delivered to the
subaddresses.  So if the first address appears in the recipient list
for a message, the subaddresses will be removed (if present) before
the mail is sent.  All addresses in this structure should be
downcased." :version "22.1" :group 'message-headers :type '(repeat (repeat string)))

(defcustom message-mail-user-agent nil "\
Like `mail-user-agent'.
Except if it is nil, use Gnus native MUA; if it is t, use
`mail-user-agent'." :version "22.1" :type '(radio (const :tag "Gnus native" :format "%t
" nil) (const :tag "`mail-user-agent'" :format "%t
" t) (function-item :tag "Default Emacs mail" :format "%t
" sendmail-user-agent) (function-item :tag "Emacs interface to MH" :format "%t
" mh-e-user-agent) (function :tag "Other")) :version "21.1" :group 'message)

(defcustom message-wide-reply-confirm-recipients nil "\
Whether to confirm a wide reply to multiple email recipients.
If this variable is nil, don't ask whether to reply to all recipients.
If this variable is non-nil, pose the question \"Reply to all
recipients?\" before a wide reply to multiple recipients.  If the user
answers yes, reply to all recipients as usual.  If the user answers
no, only reply back to the author." :version "22.1" :group 'message-headers :link '(custom-manual "(message)Wide Reply") :type 'boolean)

(defcustom message-user-fqdn nil "\
*Domain part of Message-Ids." :version "22.1" :group 'message-headers :link '(custom-manual "(message)News Headers") :type '(radio (const :format "%v  " nil) (string :format "FQDN: %v")))

(defcustom message-use-idna nil "\
Whether to encode non-ASCII in domain names into ASCII according to IDNA.
GNU Libidn, and in particular the elisp package \"idna.el\" and
the external program \"idn\", must be installed for this
functionality to work." :version "22.1" :group 'message-headers :link '(custom-manual "(message)IDNA") :type '(choice (const :tag "Ask" ask) (const :tag "Never" nil) (const :tag "Always" t)))

(defcustom message-valid-fqdn-regexp (concat "[a-z0-9][-.a-z0-9]+\\." "\\([a-z][a-z]\\|" "aero\\|arpa\\|bitnet\\|biz\\|bofh\\|" "cat\\|com\\|coop\\|edu\\|gov\\|" "info\\|int\\|jobs\\|" "mil\\|mobi\\|museum\\|name\\|net\\|" "org\\|pro\\|travel\\|uucp\\)") "\
Regular expression that matches a valid FQDN." :version "22.1" :group 'message-headers :type 'regexp)

(defcustom message-replacement-char "." "\
Replacement character used instead of unprintable or not decodable chars." :group 'message-various :version "22.1" :type '(choice string (const ".") (const "?")))

(defcustom message-strip-special-text-properties t "\
Strip special properties from the message buffer.

Emacs has a number of special text properties which can break message
composing in various ways.  If this option is set, message will strip
these properties from the message composition buffer.  However, some
packages requires these properties to be present in order to work.
If you use one of these packages, turn this option off, and hope the
message composition doesn't break too bad." :version "22.1" :group 'message-various :link '(custom-manual "(message)Various Message Variables") :type 'boolean)

(defcustom message-header-synonyms '((To Cc Bcc) (Original-To)) "\
List of lists of header synonyms.
E.g., if this list contains a member list with elements `Cc' and `To',
then `message-carefully-insert-headers' will not insert a `To' header
when the message is already `Cc'ed to the recipient." :version "22.1" :group 'message-headers :link '(custom-manual "(message)Message Headers") :type '(repeat sexp))

(defcustom message-beginning-of-line t "\
Whether \\<message-mode-map>\\[message-beginning-of-line] goes to beginning of header values." :version "22.1" :group 'message-buffers :link '(custom-manual "(message)Movement") :type 'boolean)

(defcustom message-simplify-subject-functions '(message-strip-list-identifiers message-strip-subject-re message-strip-subject-trailing-was message-strip-subject-encoded-words) "\
List of functions taking a string argument that simplify subjects.
The functions are applied when replying to a message.

Useful functions to put in this list include:
`message-strip-list-identifiers', `message-strip-subject-re',
`message-strip-subject-trailing-was', and
`message-strip-subject-encoded-words'." :version "22.1" :group 'message-various :type '(repeat function))

(defcustom message-tool-bar (if (eq gmm-tool-bar-style 'gnome) 'message-tool-bar-gnome 'message-tool-bar-retro) "\
Specifies the message mode tool bar.

It can be either a list or a symbol refering to a list.  See
`gmm-tool-bar-from-list' for the format of the list.  The
default key map is `message-mode-map'.

Pre-defined symbols include `message-tool-bar-gnome' and
`message-tool-bar-retro'." :type '(repeat gmm-tool-bar-list-item) :type '(choice (const :tag "GNOME style" message-tool-bar-gnome) (const :tag "Retro look" message-tool-bar-retro) (repeat :tag "User defined list" gmm-tool-bar-item) (symbol)) :version "22.1" :initialize 'custom-initialize-default :set 'message-tool-bar-update :group 'message)

(defcustom message-tool-bar-gnome '((ispell-message "spell" nil :visible (or (not (boundp 'flyspell-mode)) (not flyspell-mode))) (flyspell-buffer "spell" t :visible (and (boundp 'flyspell-mode) flyspell-mode) :help "Flyspell whole buffer") (gmm-ignore "separator") (message-send-and-exit "mail/send") (message-dont-send "mail/save-draft") (message-kill-buffer "close") (mml-attach-file "attach" mml-mode-map) (mml-preview "mail/preview" mml-mode-map) (message-insert-importance-high "important" nil :visible nil) (message-insert-importance-low "unimportant" nil :visible nil) (message-insert-disposition-notification-to "receipt" nil :visible nil) (gmm-customize-mode "preferences" t :help "Edit mode preferences") (message-info "help" t :help "Message manual")) "\
List of items for the message tool bar (GNOME style).

See `gmm-tool-bar-from-list' for details on the format of the list." :type '(repeat gmm-tool-bar-item) :version "22.1" :initialize 'custom-initialize-default :set 'message-tool-bar-update :group 'message)

(defcustom message-tool-bar-retro '((message-send-and-exit "gnus/mail-send") (message-kill-buffer "close") (message-dont-send "cancel") (mml-attach-file "attach" mml-mode-map) (ispell-message "spell") (mml-preview "preview" mml-mode-map) (message-insert-importance-high "gnus/important") (message-insert-importance-low "gnus/unimportant") (message-insert-disposition-notification-to "gnus/receipt")) "\
List of items for the message tool bar (retro style).

See `gmm-tool-bar-from-list' for details on the format of the list." :type '(repeat gmm-tool-bar-item) :version "22.1" :initialize 'custom-initialize-default :set 'message-tool-bar-update :group 'message)

(defcustom message-tool-bar-zap-list '(new-file open-file dired kill-buffer write-file print-buffer customize help) "\
List of icon items from the global tool bar.
These items are not displayed on the message mode tool bar.

See `gmm-tool-bar-from-list' for the format of the list." :type 'gmm-tool-bar-zap-list :version "22.1" :initialize 'custom-initialize-default :set 'message-tool-bar-update :group 'message)

(defcustom message-newgroups-header-regexp "^\\(Newsgroups\\|Followup-To\\|Posted-To\\|Gcc\\):" "\
Regexp that match headers that lists groups." :group 'message :type 'regexp)

(defcustom message-completion-alist (list (cons message-newgroups-header-regexp 'message-expand-group) '("^\\(Resent-\\)?\\(To\\|B?Cc\\):" . message-expand-name) '("^\\(Reply-To\\|From\\|Mail-Followup-To\\|Mail-Copies-To\\):" . message-expand-name) '("^\\(Disposition-Notification-To\\|Return-Receipt-To\\):" . message-expand-name)) "\
Alist of (RE . FUN).  Use FUN for completion on header lines matching RE." :version "22.1" :group 'message :type '(alist :key-type regexp :value-type function))

(defcustom message-tab-body-function nil "\
*Function to execute when `message-tab' (TAB) is executed in the body.
If nil, the function bound in `text-mode-map' or `global-map' is executed." :version "22.1" :group 'message :link '(custom-manual "(message)Various Commands") :type '(choice (const nil) function))

;;;***

;;;### (autoloads (mm-body-charset-encoding-alist) "mm-bodies" "lisp/mm-bodies.el")
(defconst custom-define-current-source-file "mm-bodies.el")

(defcustom mm-body-charset-encoding-alist '((iso-2022-jp . 7bit) (iso-2022-jp-2 . 7bit) (utf-16 . base64) (utf-16be . base64) (utf-16le . base64)) "\
Alist of MIME charsets to encodings.
Valid encodings are `7bit', `8bit', `quoted-printable' and `base64'." :type '(repeat (cons (symbol :tag "charset") (choice :tag "encoding" (const 7bit) (const 8bit) (const quoted-printable) (const base64)))) :group 'mime)

;;;***

;;;### (autoloads (mm-decrypt-option mm-verify-option mm-external-terminal-program mm-attachment-file-modes mm-default-directory mm-inline-large-images mm-tmp-directory mm-discouraged-alternatives mm-automatic-external-display mm-inline-override-types mm-attachment-override-types mm-automatic-display mm-keep-viewer-alive-types mm-inlined-types mm-inline-media-tests mm-enable-external mm-inline-text-html-with-w3m-keymap mm-w3m-safe-url-regexp mm-inline-text-html-with-images mm-text-html-renderer mime-security mime-display) "mm-decode" "lisp/mm-decode.el")
(defconst custom-define-current-source-file "mm-decode.el")

(defgroup mime-display nil "Display of MIME in mail and news articles." :link '(custom-manual "(emacs-mime)Display Customization") :version "21.1" :group 'mail :group 'news :group 'multimedia)

(defgroup mime-security nil "MIME security in mail and news articles." :link '(custom-manual "(emacs-mime)Display Customization") :group 'mail :group 'news :group 'multimedia)

(defcustom mm-text-html-renderer (cond ((locate-library "w3") 'w3) ((executable-find "w3m") (if (locate-library "w3m") 'w3m 'w3m-standalone)) ((executable-find "links") 'links) ((executable-find "lynx") 'lynx) (t 'html2text)) "\
Render of HTML contents.
It is one of defined renderer types, or a rendering function.
The defined renderer types are:
`w3'   : use Emacs/W3;
`w3m'  : use emacs-w3m;
`w3m-standalone': use w3m;
`links': use links;
`lynx' : use lynx;
`html2text' : use html2text;
nil    : use external viewer." :version "22.1" :type '(choice (const w3) (const w3m) (const w3m-standalone) (const links) (const lynx) (const html2text) (const nil) (function)) :group 'mime-display)

(defcustom mm-inline-text-html-with-images nil "\
If non-nil, Gnus will allow retrieving images in HTML contents with
the <img> tags.  It has no effect on Emacs/w3.  See also the
documentation for the `mm-w3m-safe-url-regexp' variable." :version "22.1" :type 'boolean :group 'mime-display)

(defcustom mm-w3m-safe-url-regexp "\\`cid:" "\
Regexp matching URLs which are considered to be safe.
Some HTML mails might contain a nasty trick used by spammers, using
the <img> tag which is far more evil than the [Click Here!] button.
It is most likely intended to check whether the ominous spam mail has
reached your eyes or not, in which case the spammer knows for sure
that your email address is valid.  It is done by embedding an
identifier string into a URL that you might automatically retrieve
when displaying the image.  The default value is \"\\\\`cid:\" which only
matches parts embedded to the Multipart/Related type MIME contents and
Gnus will never connect to the spammer's site arbitrarily.  You may
set this variable to nil if you consider all urls to be safe." :version "22.1" :type '(choice (regexp :tag "Regexp") (const :tag "All URLs are safe" nil)) :group 'mime-display)

(defcustom mm-inline-text-html-with-w3m-keymap t "\
If non-nil, use emacs-w3m command keys in the article buffer." :version "22.1" :type 'boolean :group 'mime-display)

(defcustom mm-enable-external t "\
Indicate whether external MIME handlers should be used.

If t, all defined external MIME handlers are used.  If nil, files are saved by
`mailcap-save-binary-file'.  If it is the symbol `ask', you are prompted
before the external MIME handler is invoked." :version "22.1" :type '(choice (const :tag "Always" t) (const :tag "Never" nil) (const :tag "Ask" ask)) :group 'mime-display)

(defcustom mm-inline-media-tests '(("image/p?jpeg" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'jpeg handle))) ("image/png" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'png handle))) ("image/gif" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'gif handle))) ("image/tiff" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'tiff handle))) ("image/xbm" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'xbm handle))) ("image/x-xbitmap" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'xbm handle))) ("image/xpm" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'xpm handle))) ("image/x-xpixmap" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'xpm handle))) ("image/bmp" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'bmp handle))) ("image/x-portable-bitmap" mm-inline-image (lambda (handle) (mm-valid-and-fit-image-p 'pbm handle))) ("text/plain" mm-inline-text identity) ("text/enriched" mm-inline-text identity) ("text/richtext" mm-inline-text identity) ("text/x-patch" mm-display-patch-inline (lambda (handle) (fboundp 'diff-mode))) ("application/emacs-lisp" mm-display-elisp-inline identity) ("application/x-emacs-lisp" mm-display-elisp-inline identity) ("text/html" mm-inline-text-html (lambda (handle) (or mm-inline-text-html-renderer mm-text-html-renderer))) ("text/x-vcard" mm-inline-text-vcard (lambda (handle) (or (featurep 'vcard) (locate-library "vcard")))) ("message/delivery-status" mm-inline-text identity) ("message/rfc822" mm-inline-message identity) ("message/partial" mm-inline-partial identity) ("message/external-body" mm-inline-external-body identity) ("text/.*" mm-inline-text identity) ("audio/wav" mm-inline-audio (lambda (handle) (and (or (featurep 'nas-sound) (featurep 'native-sound)) (device-sound-enabled-p)))) ("audio/au" mm-inline-audio (lambda (handle) (and (or (featurep 'nas-sound) (featurep 'native-sound)) (device-sound-enabled-p)))) ("application/pgp-signature" ignore identity) ("application/x-pkcs7-signature" ignore identity) ("application/pkcs7-signature" ignore identity) ("application/x-pkcs7-mime" ignore identity) ("application/pkcs7-mime" ignore identity) ("multipart/alternative" ignore identity) ("multipart/mixed" ignore identity) ("multipart/related" ignore identity) ("audio/.*" ignore ignore) ("image/.*" ignore ignore) (".*" mm-inline-text mm-readable-p)) "\
Alist of media types/tests saying whether types can be displayed inline." :type '(repeat (list (regexp :tag "MIME type") (function :tag "Display function") (function :tag "Display test"))) :group 'mime-display)

(defcustom mm-inlined-types '("image/.*" "text/.*" "message/delivery-status" "message/rfc822" "message/partial" "message/external-body" "application/emacs-lisp" "application/x-emacs-lisp" "application/pgp-signature" "application/x-pkcs7-signature" "application/pkcs7-signature" "application/x-pkcs7-mime" "application/pkcs7-mime" "application/pgp") "\
List of media types that are to be displayed inline.
See also `mm-inline-media-tests', which says how to display a media
type inline." :type '(repeat regexp) :group 'mime-display)

(defcustom mm-keep-viewer-alive-types '("application/postscript" "application/msword" "application/vnd.ms-excel" "application/pdf" "application/x-dvi") "\
List of media types for which the external viewer will not be killed
when selecting a different article." :version "22.1" :type '(repeat regexp) :group 'mime-display)

(defcustom mm-automatic-display '("text/plain" "text/enriched" "text/richtext" "text/html" "text/x-vcard" "image/.*" "message/delivery-status" "multipart/.*" "message/rfc822" "text/x-patch" "application/pgp-signature" "application/emacs-lisp" "application/x-emacs-lisp" "application/x-pkcs7-signature" "application/pkcs7-signature" "application/x-pkcs7-mime" "application/pkcs7-mime" "application/pgp\\'") "\
A list of MIME types to be displayed automatically." :type '(repeat regexp) :group 'mime-display)

(defcustom mm-attachment-override-types '("text/x-vcard" "application/pkcs7-mime" "application/x-pkcs7-mime" "application/pkcs7-signature" "application/x-pkcs7-signature") "\
Types to have \"attachment\" ignored if they can be displayed inline." :type '(repeat regexp) :group 'mime-display)

(defcustom mm-inline-override-types nil "\
Types to be treated as attachments even if they can be displayed inline." :type '(repeat regexp) :group 'mime-display)

(defcustom mm-automatic-external-display nil "\
List of MIME type regexps that will be displayed externally automatically." :type '(repeat regexp) :group 'mime-display)

(defcustom mm-discouraged-alternatives nil "\
List of MIME types that are discouraged when viewing multipart/alternative.
Viewing agents are supposed to view the last possible part of a message,
as that is supposed to be the richest.  However, users may prefer other
types instead, and this list says what types are most unwanted.  If,
for instance, text/html parts are very unwanted, and text/richtext are
somewhat unwanted, then the value of this variable should be set
to:

 (\"text/html\" \"text/richtext\")

Adding \"image/.*\" might also be useful.  Spammers use it as the
prefered part of multipart/alternative messages.  See also
`gnus-buttonized-mime-types', to which adding \"multipart/alternative\"
enables you to choose manually one of two types those mails include." :type '(repeat regexp) :group 'mime-display)

(defcustom mm-tmp-directory (if (fboundp 'temp-directory) (temp-directory) (if (boundp 'temporary-file-directory) temporary-file-directory "/tmp/")) "\
Where mm will store its temporary files." :type 'directory :group 'mime-display)

(defcustom mm-inline-large-images nil "\
If non-nil, then all images fit in the buffer." :type 'boolean :group 'mime-display)

(defcustom mm-default-directory nil "\
The default directory where mm will save files.
If not set, `default-directory' will be used." :type '(choice directory (const :tag "Default" nil)) :group 'mime-display)

(defcustom mm-attachment-file-modes 384 "\
Set the mode bits of saved attachments to this integer." :version "22.1" :type 'integer :group 'mime-display)

(defcustom mm-external-terminal-program "xterm" "\
The program to start an external terminal." :version "22.1" :type 'string :group 'mime-display)

(defcustom mm-verify-option 'never "\
Option of verifying signed parts.
`never', not verify; `always', always verify;
`known', only verify known protocols.  Otherwise, ask user." :version "22.1" :type '(choice (item always) (item never) (item :tag "only known protocols" known) (item :tag "ask" nil)) :group 'mime-security)

(defcustom mm-decrypt-option nil "\
Option of decrypting encrypted parts.
`never', not decrypt; `always', always decrypt;
`known', only decrypt known protocols.  Otherwise, ask user." :version "22.1" :type '(choice (item always) (item never) (item :tag "only known protocols" known) (item :tag "ask" nil)) :group 'mime-security)

;;;***

;;;### (autoloads (mm-content-transfer-encoding-defaults) "mm-encode" "lisp/mm-encode.el")
(defconst custom-define-current-source-file "mm-encode.el")

(defcustom mm-content-transfer-encoding-defaults '(("text/x-patch" 8bit) ("text/.*" qp-or-base64) ("message/rfc822" 8bit) ("application/emacs-lisp" qp-or-base64) ("application/x-emacs-lisp" qp-or-base64) ("application/x-patch" qp-or-base64) (".*" base64)) "\
Alist of regexps that match MIME types and their encodings.
If the encoding is `qp-or-base64', then either quoted-printable
or base64 will be used, depending on what is more efficient.

`qp-or-base64' has another effect.  It will fold long lines so that
MIME parts may not be broken by MTA.  So do `quoted-printable' and
`base64'.

Note: It affects body encoding only when a part is a raw forwarded
message (which will be made by `gnus-summary-mail-forward' with the
arg 2 for example) or is neither the text/* type nor the message/*
type.  Even though in those cases, you can use the `encoding' MML tag
to specify encoding of non-ASCII MIME parts." :type '(repeat (list (regexp :tag "MIME type") (choice :tag "encoding" (const 7bit) (const 8bit) (const qp-or-base64) (const quoted-printable) (const base64)))) :group 'mime)

;;;***

;;;### (autoloads (mm-url-arguments mm-url-program mm-url-use-external mm-url) "mm-url" "lisp/mm-url.el")
(defconst custom-define-current-source-file "mm-url.el")

(defgroup mm-url nil "A wrapper of url package and external url command for Gnus." :group 'gnus)

(defcustom mm-url-use-external (not (condition-case nil (require 'url) (error nil))) "\
*If non-nil, use external grab program `mm-url-program'." :version "22.1" :type 'boolean :group 'mm-url)

(defcustom mm-url-program (cond ((executable-find "wget") 'wget) ((executable-find "w3m") 'w3m) ((executable-find "lynx") 'lynx) ((executable-find "curl") 'curl) (t "GET")) "\
The url grab program.
Likely values are `wget', `w3m', `lynx' and `curl'." :version "22.1" :type '(choice (symbol :tag "wget" wget) (symbol :tag "w3m" w3m) (symbol :tag "lynx" lynx) (symbol :tag "curl" curl) (string :tag "other")) :group 'mm-url)

(defcustom mm-url-arguments nil "\
The arguments for `mm-url-program'." :version "22.1" :type '(repeat string) :group 'mm-url)

;;;***

;;;### (autoloads (mm-coding-system-priorities mm-charset-eval-alist mm-charset-override-alist mm-codepage-ibm-list mm-codepage-iso-8859-list) "mm-util" "lisp/mm-util.el")
(defconst custom-define-current-source-file "mm-util.el")

(defcustom mm-codepage-iso-8859-list (list 1250 '(1252 . 1) '(1254 . 9) '(1255 . 8)) "\
A list of Windows codepage numbers and iso-8859 charset numbers.

If an element is a number corresponding to a supported windows
codepage, appropriate entries to `mm-charset-synonym-alist' are
added by `mm-setup-codepage-iso-8859'.  An element may also be a
cons cell where the car is a codepage number and the cdr is the
corresponding number of an iso-8859 charset." :type '(list (set :inline t (const 1250 :tag "Central and East European") (const (1252 . 1) :tag "West European") (const (1254 . 9) :tag "Turkish") (const (1255 . 8) :tag "Hebrew")) (repeat :inline t :tag "Other options" (choice (integer :tag "Windows codepage number") (cons (integer :tag "Windows codepage number") (integer :tag "iso-8859 charset  number"))))) :version "22.1" :group 'mime)

(defcustom mm-codepage-ibm-list (list 437 860 861 862 863 865 852 850 855 866 857 864 869 874) "\
List of IBM codepage numbers.

The codepage mappings slighly differ between IBM and other vendors.
See \"ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/IBM/README.TXT\".

If an element is a number corresponding to a supported windows
codepage, appropriate entries to `mm-charset-synonym-alist' are
added by `mm-setup-codepage-ibm'." :type '(list (set :inline t (const 437 :tag "US etc.") (const 860 :tag "Portugal") (const 861 :tag "Iceland") (const 862 :tag "Israel") (const 863 :tag "Canadian French") (const 865 :tag "Nordic") (const 852) (const 850 :tag "Latin 1") (const 855 :tag "Cyrillic") (const 866 :tag "Cyrillic - Russian") (const 857 :tag "Turkish") (const 864 :tag "Arabic") (const 869 :tag "Greek") (const 874 :tag "Thai")) (repeat :inline t :tag "Other options" (integer :tag "Codepage number"))) :version "22.1" :group 'mime)

(defcustom mm-charset-override-alist (backquote ((iso-8859-1 . windows-1252))) "\
A mapping from undesired charset names to their replacement.

You may add pairs like (iso-8859-1 . windows-1252) here,
i.e. treat iso-8859-1 as windows-1252.  windows-1252 is a
superset of iso-8859-1." :type '(list (set :inline t (const (iso-8859-1 . windows-1252)) (const (undecided . windows-1252))) (repeat :inline t :tag "Other options" (cons (symbol :tag "From charset") (symbol :tag "To charset")))) :version "22.1" :group 'mime)

(defcustom mm-charset-eval-alist (if (featurep 'xemacs) nil '((windows-1250 mm-codepage-setup 1250 t) (windows-1251 mm-codepage-setup 1251 t) (windows-1253 mm-codepage-setup 1253 t) (windows-1257 mm-codepage-setup 1257 t))) "\
An alist of (CHARSET . FORM) pairs.
If an article is encoded in an unknown CHARSET, FORM is
evaluated.  This allows to load additional libraries providing
charsets on demand.  If supported by your Emacs version, you
could use `autoload-coding-system' here." :version "22.1" :type '(list (set :inline t (const (windows-1250 mm-codepage-setup 1250 t)) (const (windows-1251 mm-codepage-setup 1251 t)) (const (windows-1253 mm-codepage-setup 1253 t)) (const (windows-1257 mm-codepage-setup 1257 t)) (const (cp850 mm-codepage-setup 850 nil))) (repeat :inline t :tag "Other options" (cons (symbol :tag "charset") (symbol :tag "form")))) :group 'mime)

(defcustom mm-coding-system-priorities (if (boundp 'current-language-environment) (let ((lang (symbol-value 'current-language-environment))) (cond ((string= lang "Japanese") '(iso-8859-1 iso-2022-jp iso-2022-jp-2 shift_jis utf-8))))) "\
Preferred coding systems for encoding outgoing messages.

More than one suitable coding system may be found for some text.
By default, the coding system with the highest priority is used
to encode outgoing messages (see `sort-coding-systems').  If this
variable is set, it overrides the default priority." :version "21.2" :type '(repeat (symbol :tag "Coding system")) :group 'mime)

;;;***

;;;### (autoloads (mm-uu-configure-list mm-uu-diff-groups-regexp mm-uu-emacs-sources-regexp mm-uu-binhex-decode-function mm-uu-decode-function) "mm-uu" "lisp/mm-uu.el")
(defconst custom-define-current-source-file "mm-uu.el")

(defcustom mm-uu-decode-function 'uudecode-decode-region "\
*Function to uudecode.
Internal function is done in Lisp by default, therefore decoding may
appear to be horribly slow.  You can make Gnus use an external
decoder, such as uudecode." :type '(choice (function-item :tag "Auto detect" uudecode-decode-region) (function-item :tag "Internal" uudecode-decode-region-internal) (function-item :tag "External" uudecode-decode-region-external)) :group 'gnus-article-mime)

(defcustom mm-uu-binhex-decode-function 'binhex-decode-region "\
*Function to binhex decode.
Internal function is done in elisp by default, therefore decoding may
appear to be horribly slow . You can make Gnus use the external Unix
decoder, such as hexbin." :type '(choice (function-item :tag "Auto detect" binhex-decode-region) (function-item :tag "Internal" binhex-decode-region-internal) (function-item :tag "External" binhex-decode-region-external)) :group 'gnus-article-mime)

(defcustom mm-uu-emacs-sources-regexp "\\.emacs\\.sources" "\
The regexp of Emacs sources groups." :version "22.1" :type 'regexp :group 'gnus-article-mime)

(defcustom mm-uu-diff-groups-regexp "\\(gmane\\|gnu\\)\\..*\\(diff\\|commit\\|cvs\\|bug\\|devel\\)" "\
Regexp matching diff groups." :version "22.1" :type 'regexp :group 'gnus-article-mime)

(defcustom mm-uu-configure-list '((shar . disabled)) "\
A list of mm-uu configuration.
To disable dissecting shar codes, for instance, add
`(shar . disabled)' to this list." :type 'alist :options (mapcar (lambda (entry) (list (car entry) '(const disabled))) mm-uu-type-alist) :group 'gnus-article-mime)

;;;***

;;;### (autoloads (mm-fill-flowed) "mm-view" "lisp/mm-view.el")
(defconst custom-define-current-source-file "mm-view.el")

(defcustom mm-fill-flowed t "\
If non-nil an format=flowed article will be displayed flowed." :type 'boolean :version "22.1" :group 'mime-display)

;;;***

;;;### (autoloads (mml-signencrypt-style-alist mml-default-encrypt-method mml-default-sign-method) "mml-sec" "lisp/mml-sec.el")
(defconst custom-define-current-source-file "mml-sec.el")

(defcustom mml-default-sign-method "pgpmime" "\
Default sign method.
The string must have an entry in `mml-sign-alist'." :version "22.1" :type '(choice (const "smime") (const "pgp") (const "pgpauto") (const "pgpmime") string) :group 'message)

(defcustom mml-default-encrypt-method "pgpmime" "\
Default encryption method.
The string must have an entry in `mml-encrypt-alist'." :version "22.1" :type '(choice (const "smime") (const "pgp") (const "pgpauto") (const "pgpmime") string) :group 'message)

(defcustom mml-signencrypt-style-alist '(("smime" separate) ("pgp" combined) ("pgpauto" combined) ("pgpmime" combined)) "\
Alist specifying if `signencrypt' results in two separate operations or not.
The first entry indicates the MML security type, valid entries include
the strings \"smime\", \"pgp\", and \"pgpmime\".  The second entry is
a symbol `separate' or `combined' where `separate' means that MML signs
and encrypt messages in a two step process, and `combined' means that MML
signs and encrypt the message in one step.

Note that the output generated by using a `combined' mode is NOT
understood by all PGP implementations, in particular PGP version
2 does not support it!  See Info node `(message)Security' for
details." :version "22.1" :group 'message :type '(repeat (list (choice (const :tag "S/MIME" "smime") (const :tag "PGP" "pgp") (const :tag "PGP/MIME" "pgpmime") (string :tag "User defined")) (choice (const :tag "Separate" separate) (const :tag "Combined" combined)))))

;;;***

;;;### (autoloads (mml-dnd-attach-options mml-dnd-protocol-alist mml-insert-mime-headers-always mml-content-disposition-parameters mml-content-type-parameters) "mml" "lisp/mml.el")
(defconst custom-define-current-source-file "mml.el")

(defcustom mml-content-type-parameters '(name access-type expiration size permission format) "\
*A list of acceptable parameters in MML tag.
These parameters are generated in Content-Type header if exists." :version "22.1" :type '(repeat (symbol :tag "Parameter")) :group 'message)

(defcustom mml-content-disposition-parameters '(filename creation-date modification-date read-date) "\
*A list of acceptable parameters in MML tag.
These parameters are generated in Content-Disposition header if exists." :version "22.1" :type '(repeat (symbol :tag "Parameter")) :group 'message)

(defcustom mml-insert-mime-headers-always nil "\
If non-nil, always put Content-Type: text/plain at top of empty parts.
It is necessary to work against a bug in certain clients." :version "22.1" :type 'boolean :group 'message)

(defcustom mml-dnd-protocol-alist '(("^file:///" . mml-dnd-attach-file) ("^file://" . dnd-open-file) ("^file:" . mml-dnd-attach-file)) "\
The functions to call when a drop in `mml-mode' is made.
See `dnd-protocol-alist' for more information.  When nil, behave
as in other buffers." :type '(choice (repeat (cons (regexp) (function))) (const :tag "Behave as in other buffers" nil)) :version "22.1" :group 'message)

(defcustom mml-dnd-attach-options nil "\
Which options should be queried when attaching a file via drag and drop.

If it is a list, valid members are `type', `description' and
`disposition'.  `disposition' implies `type'.  If it is nil,
don't ask for options.  If it is t, ask the user whether or not
to specify options." :type '(choice (const :tag "Non" nil) (const :tag "Query" t) (list :value (type description disposition) (set :inline t (const type) (const description) (const disposition)))) :version "22.1" :group 'message)

;;;***

;;;### (autoloads (mml2015-unabbrev-trust-alist) "mml2015" "lisp/mml2015.el")
(defconst custom-define-current-source-file "mml2015.el")

(defcustom mml2015-unabbrev-trust-alist '(("TRUST_UNDEFINED") ("TRUST_NEVER") ("TRUST_MARGINAL" . t) ("TRUST_FULLY" . t) ("TRUST_ULTIMATE" . t)) "\
Map GnuPG trust output values to a boolean saying if you trust the key." :version "22.1" :group 'mime-security :type '(repeat (cons (regexp :tag "GnuPG output regexp") (boolean :tag "Trust key"))))

;;;***

;;;### (autoloads (nndiary-check-directory-twice nndiary-request-accept-article-hooks nndiary-request-update-info-hooks nndiary-request-create-group-hooks nndiary-week-starts-on-monday nndiary-reminders nndiary-split-methods nndiary-mail-sources nndiary) "nndiary" "lisp/nndiary.el")
(defconst custom-define-current-source-file "nndiary.el")

(defgroup nndiary nil "The Gnus Diary back end." :version "22.1" :group 'gnus-diary)

(defcustom nndiary-mail-sources (backquote ((file :path (\, (expand-file-name "~/.nndiary"))))) "\
*NNDiary specific mail sources.
This variable is used by nndiary in place of the standard `mail-sources'
variable when `nndiary-get-new-mail' is set to non-nil.  These sources
must contain diary messages ONLY." :group 'nndiary :group 'mail-source :type 'sexp)

(defcustom nndiary-split-methods '(("diary" "")) "\
*NNDiary specific split methods.
This variable is used by nndiary in place of the standard
`nnmail-split-methods' variable when `nndiary-get-new-mail' is set to
non-nil." :group 'nndiary :group 'nnmail-split :type '(choice (repeat :tag "Alist" (group (string :tag "Name") regexp)) (function-item nnmail-split-fancy) (function :tag "Other")))

(defcustom nndiary-reminders '((0 . day)) "\
*Different times when you want to be reminded of your appointments.
Diary articles will appear again, as if they'd been just received.

Entries look like (3 . day) which means something like \"Please
Hortense, would you be so kind as to remind me of my appointments 3 days
before the date, thank you very much. Anda, hmmm... by the way, are you
doing anything special tonight ?\".

The units of measure are 'minute 'hour 'day 'week 'month and 'year (no,
not 'century, sorry).

NOTE: the units of measure actually express dates, not durations: if you
use 'week, messages will pop up on Sundays at 00:00 (or Mondays if
`nndiary-week-starts-on-monday' is non-nil) and *not* 7 days before the
appointment, if you use 'month, messages will pop up on the first day of
each months, at 00:00 and so on.

If you really want to specify a duration (like 24 hours exactly), you can
use the equivalent in minutes (the smallest unit).  A fuzz of 60 seconds
maximum in the reminder is not that painful, I think.  Although this
scheme might appear somewhat weird at a first glance, it is very powerful.
In order to make this clear, here are some examples:

- '(0 . day): this is the default value of `nndiary-reminders'.  It means
  pop up the appointments of the day each morning at 00:00.

- '(1 . day): this means pop up the appointments the day before, at 00:00.

- '(6 . hour): for an appointment at 18:30, this would pop up the
  appointment message at 12:00.

- '(360 . minute): for an appointment at 18:30 and 15 seconds, this would
  pop up the appointment message at 12:30." :group 'nndiary :type '(repeat (cons :format "%v
" (integer :format "%v") (choice :format "%[%v(s)%] before...
" :value day (const :format "%v" minute) (const :format "%v" hour) (const :format "%v" day) (const :format "%v" week) (const :format "%v" month) (const :format "%v" year)))))

(defcustom nndiary-week-starts-on-monday nil "\
*Whether a week starts on monday (otherwise, sunday)." :type 'boolean :group 'nndiary)

(defcustom nndiary-request-create-group-hooks nil "\
*Hooks to run after `nndiary-request-create-group' is executed.
The hooks will be called with the full group name as argument." :group 'nndiary :type 'hook)

(defcustom nndiary-request-update-info-hooks nil "\
*Hooks to run after `nndiary-request-update-info-group' is executed.
The hooks will be called with the full group name as argument." :group 'nndiary :type 'hook)

(defcustom nndiary-request-accept-article-hooks nil "\
*Hooks to run before accepting an article.
Executed near the beginning of `nndiary-request-accept-article'.
The hooks will be called with the article in the current buffer." :group 'nndiary :type 'hook)

(defcustom nndiary-check-directory-twice t "\
*If t, check directories twice to avoid NFS failures." :group 'nndiary :type 'boolean)

;;;***

;;;### (autoloads (gnus-nov-is-evil gnus-verbose-backends) "nnheader" "lisp/nnheader.el")
(defconst custom-define-current-source-file "nnheader.el")

(defcustom gnus-verbose-backends 7 "\
Integer that says how verbose the Gnus backends should be.
The higher the number, the more messages the Gnus backends will flash
to say what it's doing.  At zero, the Gnus backends will be totally
mute; at five, they will display most important messages; and at ten,
they will keep on jabbering all the time." :group 'gnus-start :type 'integer)

(defcustom gnus-nov-is-evil nil "\
If non-nil, Gnus backends will never output headers in the NOV format." :group 'gnus-server :type 'boolean)

;;;***

;;;### (autoloads (nnimap-debug nnimap-prune-cache nnimap-authinfo-file nnimap-retrieve-groups-asynchronous nnimap-dont-close nnimap-close-asynchronous nnimap-split-download-body nnimap-split-fancy nnimap-split-predicate nnimap-split-rule nnimap-split-inbox nnimap-split-crosspost nnimap) "nnimap" "lisp/nnimap.el")
(defconst custom-define-current-source-file "nnimap.el")

(defgroup nnimap nil "Reading IMAP mail with Gnus." :group 'gnus)

(defcustom nnimap-split-crosspost t "\
If non-nil, do crossposting if several split methods match the mail.
If nil, the first match found will be used." :group 'nnimap :type 'boolean)

(defcustom nnimap-split-inbox nil "\
Name of mailbox to split mail from.

Mail is read from this mailbox and split according to rules in
`nnimap-split-rule'.

This can be a string or a list of strings." :group 'nnimap :type '(choice (string) (repeat string)))

(defcustom nnimap-split-rule nil "\
Mail will be split according to these rules.

Mail is read from mailbox(es) specified in `nnimap-split-inbox'.

If you'd like, for instance, one mail group for mail from the
\"gnus-imap\" mailing list, one group for junk mail and leave
everything else in the incoming mailbox, you could do something like
this:

\(setq nnimap-split-rule '((\"INBOX.gnus-imap\"   \"From:.*gnus-imap\")
			  (\"INBOX.junk\"        \"Subject:.*buy\")))

As you can see, `nnimap-split-rule' is a list of lists, where the
first element in each \"rule\" is the name of the IMAP mailbox (or the
symbol `junk' if you want to remove the mail), and the second is a
regexp that nnimap will try to match on the header to find a fit.

The second element can also be a function.  In that case, it will be
called narrowed to the headers with the first element of the rule as
the argument.  It should return a non-nil value if it thinks that the
mail belongs in that group.

This variable can also have a function as its value, the function will
be called with the headers narrowed and should return a group where it
thinks the article should be splitted to.  See `nnimap-split-fancy'.

To allow for different split rules on different virtual servers, and
even different split rules in different inboxes on the same server,
the syntax of this variable have been extended along the lines of:

\(setq nnimap-split-rule
      '((\"my1server\"    (\".*\"    ((\"ding\"    \"ding@gnus.org\")
				  (\"junk\"    \"From:.*Simon\")))
	(\"my2server\"    (\"INBOX\" nnimap-split-fancy))
	(\"my[34]server\" (\".*\"    ((\"private\" \"To:.*Simon\")
				  (\"junk\"    my-junk-func)))))

The virtual server name is in fact a regexp, so that the same rules
may apply to several servers.  In the example, the servers
\"my3server\" and \"my4server\" both use the same rules.  Similarly,
the inbox string is also a regexp.  The actual splitting rules are as
before, either a function, or a list with group/regexp or
group/function elements." :group 'nnimap :type '(choice :tag "Rule type" (repeat :menu-tag "Single-server" :tag "Single-server list" (list (string :tag "Mailbox") (choice :tag "Predicate" (regexp :tag "A regexp") (nnimap-strict-function :tag "A function")))) (choice :menu-tag "A function" :tag "A function" (function-item nnimap-split-fancy) (function-item nnmail-split-fancy) (nnimap-strict-function :tag "User-defined function")) (repeat :menu-tag "Multi-server (extended)" :tag "Multi-server list" (list (regexp :tag "Server regexp") (list (regexp :tag "Incoming Mailbox regexp") (repeat :tag "Rules for matching server(s) and mailbox(es)" (list (string :tag "Destination mailbox") (choice :tag "Predicate" (regexp :tag "A Regexp") (nnimap-strict-function :tag "A Function")))))))))

(defcustom nnimap-split-predicate "UNSEEN UNDELETED" "\
The predicate used to find articles to split.
If you use another IMAP client to peek on articles but always would
like nnimap to split them once it's started, you could change this to
\"UNDELETED\". Other available predicates are available in
RFC2060 section 6.4.4." :group 'nnimap :type 'string)

(defcustom nnimap-split-fancy nil "\
Like the variable `nnmail-split-fancy'." :group 'nnimap :type 'sexp)

(defcustom nnimap-split-download-body 'default "\
Whether to download entire articles during splitting.
This is generally not required, and will slow things down considerably.
You may need it if you want to use an advanced splitting function that
analyzes the body before splitting the article.
If this variable is nil, bodies will not be downloaded; if this
variable is the symbol `default' the default behavior is
used (which currently is nil, unless you use a statistical
spam.el test); if this variable is another non-nil value bodies
will be downloaded." :version "22.1" :group 'nnimap :type '(choice (const :tag "Let system decide" deault) boolean))

(defcustom nnimap-close-asynchronous t "\
Close mailboxes asynchronously in `nnimap-close-group'.
This means that errors caught by nnimap when closing the mailbox will
not prevent Gnus from updating the group status, which may be harmful.
However, it increases speed." :version "22.1" :type 'boolean :group 'nnimap)

(defcustom nnimap-dont-close t "\
Never close mailboxes.
This increases the speed of closing mailboxes (quiting group) but may
decrease the speed of selecting another mailbox later.  Re-selecting
the same mailbox will be faster though." :version "22.1" :type 'boolean :group 'nnimap)

(defcustom nnimap-retrieve-groups-asynchronous t "\
Send asynchronous STATUS commands for each mailbox before checking mail.
If you have mailboxes that rarely receives mail, this speeds up new
mail checking.  It works by first sending STATUS commands for each
mailbox, and then only checking groups which has a modified UIDNEXT
more carefully for new mail.

In summary, the default is O((1-p)*k+p*n) and changing it to nil makes
it O(n).  If p is small, then the default is probably faster." :version "22.1" :type 'boolean :group 'nnimap)

(defcustom nnimap-authinfo-file "~/.authinfo" "\
Authorization information for IMAP servers.  In .netrc format." :type '(choice file (repeat :tag "Entries" :menu-tag "Inline" (list :format "%v" :value ("" ("login" . "") ("password" . "")) (string :tag "Host") (checklist :inline t (cons :format "%v" (const :format "" "login") (string :format "Login: %v")) (cons :format "%v" (const :format "" "password") (string :format "Password: %v")))))) :group 'nnimap)

(defcustom nnimap-prune-cache t "\
If non-nil, nnimap check whether articles still exist on server before using data stored in NOV cache." :type 'boolean :group 'nnimap)

(defcustom nnimap-debug nil "\
If non-nil, random debug spews are placed in *nnimap-debug* buffer.
Note that username, passwords and other privacy sensitive
information (such as e-mail) may be stored in the *nnimap-debug*
buffer.  It is not written to disk, however.  Do not enable this
variable unless you are comfortable with that." :group 'nnimap :type 'boolean)

;;;***

;;;### (autoloads (nnir-namazu-remove-prefix nnir-namazu-additional-switches nnir-namazu-index-directory nnir-namazu-program nnir-hyrex-remove-prefix nnir-hyrex-index-directory nnir-hyrex-additional-switches nnir-hyrex-program nnir-swish-e-remove-prefix nnir-swish-e-additional-switches nnir-swish-e-program nnir-swish-e-index-file nnir-swish++-remove-prefix nnir-swish++-additional-switches nnir-swish++-program nnir-swish++-configuration-file nnir-excite-remove-prefix nnir-excite-collection nnir-excite-aquery-program nnir-wais-remove-prefix nnir-wais-database nnir-wais-program nnir-glimpse-additional-switches nnir-glimpse-remove-prefix nnir-glimpse-home nnir-glimpse-program nnir-search-engine nnir-mail-backend nnir) "nnir" "lisp/nnir.el")
(defconst custom-define-current-source-file "nnir.el")

(defgroup nnir nil "Search nnmh and nnml groups in Gnus with Glimpse, freeWAIS-sf, or EWS." :group 'gnus)

(defcustom nnir-mail-backend '(nnml "") "\
*Specifies which backend should be searched.
More precisely, this is used to determine from which backend to fetch the
messages found.

This must be equal to an existing server, so maybe it is best to use
something like the following:
    (setq nnir-mail-backend (nth 0 gnus-secondary-select-methods))
The above line works fine if the mail backend you want to search is
the first element of gnus-secondary-select-methods (`nth' starts counting
at zero)." :type '(sexp) :group 'nnir)

(defcustom nnir-search-engine 'wais "\
*The search engine to use.  Must be a symbol.
See `nnir-engines' for a list of supported engines, and for example
settings of `nnir-search-engine'." :type '(sexp) :group 'nnir)

(defcustom nnir-glimpse-program "glimpse" "\
*Name of Glimpse executable." :type '(string) :group 'nnir)

(defcustom nnir-glimpse-home (getenv "HOME") "\
*Value of `-H' glimpse option.
`~' and environment variables must be expanded, see the functions
`expand-file-name' and `substitute-in-file-name'." :type '(directory) :group 'nnir)

(defcustom nnir-glimpse-remove-prefix (concat (getenv "HOME") "/Mail/") "\
*The prefix to remove from each file name returned by Glimpse
in order to get a group name (albeit with / instead of .).  This is a
regular expression.

For example, suppose that Glimpse returns file names such as
\"/home/john/Mail/mail/misc/42\".  For this example, use the following
setting:  (setq nnir-glimpse-remove-prefix \"/home/john/Mail/\")
Note the trailing slash.  Removing this prefix gives \"mail/misc/42\".
`nnir' knows to remove the \"/42\" and to replace \"/\" with \".\" to
arrive at the correct group name, \"mail.misc\"." :type '(regexp) :group 'nnir)

(defcustom nnir-glimpse-additional-switches '("-i") "\
*A list of strings, to be given as additional arguments to glimpse.
The switches `-H', `-W', `-l' and `-y' are always used -- calling
glimpse without them does not make sense in our situation.
Suggested elements to put here are `-i' and `-w'.

Note that this should be a list.  Ie, do NOT use the following:
    (setq nnir-glimpse-additional-switches \"-i -w\") ; wrong!
Instead, use this:
    (setq nnir-glimpse-additional-switches '(\"-i\" \"-w\"))" :type '(repeat (string)) :group 'nnir)

(defcustom nnir-wais-program "waissearch" "\
*Name of waissearch executable." :type '(string) :group 'nnir)

(defcustom nnir-wais-database (expand-file-name "~/.wais/mail") "\
*Name of Wais database containing the mail.

Note that this should be a file name without extension.  For example,
if you have a file /home/john/.wais/mail.fmt, use this:
    (setq nnir-wais-database \"/home/john/.wais/mail\")
The string given here is passed to `waissearch -d' as-is." :type '(file) :group 'nnir)

(defcustom nnir-wais-remove-prefix (concat (getenv "HOME") "/Mail/") "\
*The prefix to remove from each directory name returned by waissearch
in order to get a group name (albeit with / instead of .).  This is a
regular expression.

This variable is similar to `nnir-glimpse-remove-prefix', only for Wais,
not Glimpse." :type '(regexp) :group 'nnir)

(defcustom nnir-excite-aquery-program "aquery.pl" "\
*Name of the EWS query program.  Should be `aquery.pl' or a path to same." :type '(string) :group 'nnir)

(defcustom nnir-excite-collection "Mail" "\
*Name of the EWS collection to search." :type '(string) :group 'nnir)

(defcustom nnir-excite-remove-prefix (concat (getenv "HOME") "/Mail/") "\
*The prefix to remove from each file name returned by EWS
in order to get a group name (albeit with / instead of .).  This is a
regular expression.

This variable is very similar to `nnir-glimpse-remove-prefix', except
that it is for EWS, not Glimpse." :type '(regexp) :group 'nnir)

(defcustom nnir-swish++-configuration-file (expand-file-name "~/Mail/swish++.conf") "\
*Configuration file for swish++." :type '(file) :group 'nnir)

(defcustom nnir-swish++-program "search" "\
*Name of swish++ search executable." :type '(string) :group 'nnir)

(defcustom nnir-swish++-additional-switches 'nil "\
*A list of strings, to be given as additional arguments to swish++.

Note that this should be a list.  Ie, do NOT use the following:
    (setq nnir-swish++-additional-switches \"-i -w\") ; wrong
Instead, use this:
    (setq nnir-swish++-additional-switches '(\"-i\" \"-w\"))" :type '(repeat (string)) :group 'nnir)

(defcustom nnir-swish++-remove-prefix (concat (getenv "HOME") "/Mail/") "\
*The prefix to remove from each file name returned by swish++
in order to get a group name (albeit with / instead of .).  This is a
regular expression.

This variable is very similar to `nnir-glimpse-remove-prefix', except
that it is for swish++, not Glimpse." :type '(regexp) :group 'nnir)

(defcustom nnir-swish-e-index-file (expand-file-name "~/Mail/index.swish-e") "\
*Index file for swish-e.
This could be a server parameter." :type '(file) :group 'nnir)

(defcustom nnir-swish-e-program "swish-e" "\
*Name of swish-e search executable.
This cannot be a server parameter." :type '(string) :group 'nnir)

(defcustom nnir-swish-e-additional-switches 'nil "\
*A list of strings, to be given as additional arguments to swish-e.

Note that this should be a list.  Ie, do NOT use the following:
    (setq nnir-swish-e-additional-switches \"-i -w\") ; wrong
Instead, use this:
    (setq nnir-swish-e-additional-switches '(\"-i\" \"-w\"))

This could be a server parameter." :type '(repeat (string)) :group 'nnir)

(defcustom nnir-swish-e-remove-prefix (concat (getenv "HOME") "/Mail/") "\
*The prefix to remove from each file name returned by swish-e
in order to get a group name (albeit with / instead of .).  This is a
regular expression.

This variable is very similar to `nnir-glimpse-remove-prefix', except
that it is for swish-e, not Glimpse.

This could be a server parameter." :type '(regexp) :group 'nnir)

(defcustom nnir-hyrex-program "nnir-search" "\
*Name of the nnir-search executable." :type '(string) :group 'nnir)

(defcustom nnir-hyrex-additional-switches 'nil "\
*A list of strings, to be given as additional arguments for nnir-search.
Note that this should be a list. Ie, do NOT use the following:
    (setq nnir-hyrex-additional-switches \"-ddl ddl.xml -c nnir\") ; wrong !
Instead, use this:
    (setq nnir-hyrex-additional-switches '(\"-ddl\" \"ddl.xml\" \"-c\" \"nnir\"))" :type '(repeat (string)) :group 'nnir)

(defcustom nnir-hyrex-index-directory (getenv "HOME") "\
*Index directory for HyREX." :type '(directory) :group 'nnir)

(defcustom nnir-hyrex-remove-prefix (concat (getenv "HOME") "/Mail/") "\
*The prefix to remove from each file name returned by HyREX
in order to get a group name (albeit with / instead of .).

For example, suppose that HyREX returns file names such as
\"/home/john/Mail/mail/misc/42\".  For this example, use the following
setting:  (setq nnir-hyrex-remove-prefix \"/home/john/Mail/\")
Note the trailing slash.  Removing this prefix gives \"mail/misc/42\".
`nnir' knows to remove the \"/42\" and to replace \"/\" with \".\" to
arrive at the correct group name, \"mail.misc\"." :type '(directory) :group 'nnir)

(defcustom nnir-namazu-program "namazu" "\
*Name of Namazu search executable." :type '(string) :group 'nnir)

(defcustom nnir-namazu-index-directory (expand-file-name "~/Mail/namazu/") "\
*Index directory for Namazu." :type '(directory) :group 'nnir)

(defcustom nnir-namazu-additional-switches 'nil "\
*A list of strings, to be given as additional arguments to namazu.
The switches `-q', `-a', and `-s' are always used, very few other switches
make any sense in this context.

Note that this should be a list.  Ie, do NOT use the following:
    (setq nnir-namazu-additional-switches \"-i -w\") ; wrong
Instead, use this:
    (setq nnir-namazu-additional-switches '(\"-i\" \"-w\"))" :type '(repeat (string)) :group 'nnir)

(defcustom nnir-namazu-remove-prefix (concat (getenv "HOME") "/Mail/") "\
*The prefix to remove from each file name returned by Namazu
in order to get a group name (albeit with / instead of .).

This variable is very similar to `nnir-glimpse-remove-prefix', except
that it is for Namazu, not Glimpse." :type '(directory) :group 'nnir)

;;;***

;;;### (autoloads (nnmail-split-lowercase-expanded nnmail-split-fancy-match-partial-words nnmail-mail-splitting-decodes nnmail-mail-splitting-charset nnmail-split-header-length-limit nnmail-extra-headers nnmail-treat-duplicates nnmail-message-id-cache-file nnmail-message-id-cache-length nnmail-split-abbrev-alist nnmail-split-fancy nnmail-large-newsgroup nnmail-spool-hook nnmail-split-hook nnmail-post-get-new-mail-hook nnmail-pre-get-new-mail-hook nnmail-list-identifiers nnmail-prepare-incoming-message-hook nnmail-prepare-incoming-header-hook nnmail-prepare-incoming-hook nnmail-read-incoming-hook nnmail-crosspost-link-function nnmail-delete-file-function nnmail-scan-directory-mail-source-once nnmail-resplit-incoming nnmail-spool-file nnmail-cache-accepted-message-ids nnmail-fancy-expiry-targets nnmail-expiry-target nnmail-expiry-wait-function nnmail-expiry-wait nnmail-default-file-modes nnmail-use-long-file-names nnmail-keep-last-article nnmail-cache-ignore-groups nnmail-split-fancy-with-parent-ignore-groups nnmail-crosspost nnmail-split-methods nnmail-various nnmail-procmail nnmail-expire nnmail-files nnmail-split nnmail-duplicate nnmail-prepare nnmail-retrieve nnmail) "nnmail" "lisp/nnmail.el")
(defconst custom-define-current-source-file "nnmail.el")

(defgroup nnmail nil "Reading mail with Gnus." :group 'gnus)

(defgroup nnmail-retrieve nil "Retrieving new mail." :group 'nnmail)

(defgroup nnmail-prepare nil "Preparing (or mangling) new mail after retrieval." :group 'nnmail)

(defgroup nnmail-duplicate nil "Handling of duplicate mail messages." :group 'nnmail)

(defgroup nnmail-split nil "Organizing the incoming mail in folders." :group 'nnmail)

(defgroup nnmail-files nil "Mail files." :group 'gnus-files :group 'nnmail)

(defgroup nnmail-expire nil "Expiring old mail." :group 'nnmail)

(defgroup nnmail-procmail nil "Interfacing with procmail and other mail agents." :group 'nnmail)

(defgroup nnmail-various nil "Various mail options." :group 'nnmail)

(defcustom nnmail-split-methods '(("mail.misc" "")) "\
*Incoming mail will be split according to this variable.

If you'd like, for instance, one mail group for mail from the
\"4ad-l\" mailing list, one group for junk mail and one for everything
else, you could do something like this:

 (setq nnmail-split-methods
       '((\"mail.4ad\" \"From:.*4ad\")
	 (\"mail.junk\" \"From:.*Lars\\\\|Subject:.*buy\")
	 (\"mail.misc\" \"\")))

As you can see, this variable is a list of lists, where the first
element in each \"rule\" is the name of the group (which, by the way,
does not have to be called anything beginning with \"mail\",
\"yonka.zow\" is a fine, fine name), and the second is a regexp that
nnmail will try to match on the header to find a fit.

The second element can also be a function.  In that case, it will be
called narrowed to the headers with the first element of the rule as
the argument.  It should return a non-nil value if it thinks that the
mail belongs in that group.

The last element should always have \"\" as the regexp.

This variable can also have a function as its value." :group 'nnmail-split :type '(choice (repeat :tag "Alist" (group (string :tag "Name") (choice regexp function))) (function-item nnmail-split-fancy) (function :tag "Other")))

(defcustom nnmail-crosspost t "\
If non-nil, do crossposting if several split methods match the mail.
If nil, the first match found will be used." :group 'nnmail-split :type 'boolean)

(defcustom nnmail-split-fancy-with-parent-ignore-groups nil "\
Regexp that matches group names to be ignored when applying `nnmail-split-fancy-with-parent'.
This can also be a list of regexps." :version "22.1" :group 'nnmail-split :type '(choice (const :tag "none" nil) (regexp :value ".*") (repeat :value (".*") regexp)))

(defcustom nnmail-cache-ignore-groups nil "\
Regexp that matches group names to be ignored when inserting message ids into the cache (`nnmail-cache-insert').
This can also be a list of regexps." :version "22.1" :group 'nnmail-split :type '(choice (const :tag "none" nil) (regexp :value ".*") (repeat :value (".*") regexp)))

(defcustom nnmail-keep-last-article nil "\
If non-nil, nnmail will never delete/move a group's last article.
It can be marked expirable, so it will be deleted when it is no longer last.

You may need to set this variable if other programs are putting
new mail into folder numbers that Gnus has marked as expired." :group 'nnmail-procmail :group 'nnmail-various :type 'boolean)

(defcustom nnmail-use-long-file-names nil "\
If non-nil the mail backends will use long file and directory names.
If nil, groups like \"mail.misc\" will end up in directories like
\"mail/misc/\"." :group 'nnmail-files :type 'boolean)

(defcustom nnmail-default-file-modes 384 "\
Set the mode bits of all new mail files to this integer." :group 'nnmail-files :type 'integer)

(defcustom nnmail-expiry-wait 7 "\
*Expirable articles that are older than this will be expired.
This variable can either be a number (which will be interpreted as a
number of days) -- this doesn't have to be an integer.  This variable
can also be `immediate' and `never'." :group 'nnmail-expire :type '(choice (const immediate) (number :tag "days") (const never)))

(defcustom nnmail-expiry-wait-function nil "\
Variable that holds function to specify how old articles should be before they are expired.
The function will be called with the name of the group that the expiry
is to be performed in, and it should return an integer that says how
many days an article can be stored before it is considered \"old\".
It can also return the values `never' and `immediate'.

Eg.:

\(setq nnmail-expiry-wait-function
      (lambda (newsgroup)
	(cond ((string-match \"private\" newsgroup) 31)
	      ((string-match \"junk\" newsgroup) 1)
	      ((string-match \"important\" newsgroup) 'never)
	      (t 7))))" :group 'nnmail-expire :type '(choice (const :tag "nnmail-expiry-wait" nil) (function :format "%v" nnmail-)))

(defcustom nnmail-expiry-target 'delete "\
*Variable that says where expired messages should end up.
The default value is `delete' (which says to delete the messages),
but it can also be a string or a function.  If it is a string, expired
messages end up in that group.  If it is a function, the function is
called in a buffer narrowed to the message in question.  The function
receives one argument, the name of the group the message comes from.
The return value should be `delete' or a group name (a string)." :version "21.1" :group 'nnmail-expire :type '(choice (const delete) (function :format "%v" nnmail-) string))

(defcustom nnmail-fancy-expiry-targets nil "\
Determine expiry target based on articles using fancy techniques.

This is a list of (\"HEADER\" \"REGEXP\" \"TARGET\") entries.  If
`nnmail-expiry-target' is set to the function
`nnmail-fancy-expiry-target' and HEADER of the article matches REGEXP,
the message will be expired to a group determined by invoking
`format-time-string' with TARGET used as the format string and the
time extracted from the articles' Date header (if missing the current
time is used).

In the special cases that HEADER is the symbol `to-from', the regexp
will try to match against both the From and the To header.

Example:

\(setq nnmail-fancy-expiry-targets
      '((to-from \"boss\" \"nnfolder:Work\")
	(\"Subject\" \"IMPORTANT\" \"nnfolder:IMPORTANT.%Y.%b\")
	(\"from\" \".*\" \"nnfolder:Archive-%Y\")))

In this case, articles containing the string \"boss\" in the To or the
From header will be expired to the group \"nnfolder:Work\";
articles containing the sting \"IMPORTANT\" in the Subject header will
be expired to the group \"nnfolder:IMPORTANT.YYYY.MMM\"; and
everything else will be expired to \"nnfolder:Archive-YYYY\"." :version "22.1" :group 'nnmail-expire :type '(repeat (list (choice :tag "Match against" (string :tag "Header") (const to-from)) regexp (string :tag "Target group format string"))))

(defcustom nnmail-cache-accepted-message-ids nil "\
If non-nil, put Message-IDs of Gcc'd articles into the duplicate cache.
If non-nil, also update the cache when copy or move articles." :group 'nnmail :type 'boolean)

(defcustom nnmail-spool-file '((file)) "\
*Where the mail backends will look for incoming mail.
This variable is a list of mail source specifiers.
This variable is obsolete; `mail-sources' should be used instead." :group 'nnmail-files :type 'sexp)

(defcustom nnmail-resplit-incoming nil "\
*If non-nil, re-split incoming procmail sorted mail." :group 'nnmail-procmail :type 'boolean)

(defcustom nnmail-scan-directory-mail-source-once nil "\
*If non-nil, scan all incoming procmail sorted mails once.
It scans low-level sorted spools even when not required." :version "21.1" :group 'nnmail-procmail :type 'boolean)

(defcustom nnmail-delete-file-function 'delete-file "\
Function called to delete files in some mail backends." :group 'nnmail-files :type 'function)

(defcustom nnmail-crosspost-link-function (if (string-match "windows-nt\\|emx" (symbol-name system-type)) 'copy-file 'add-name-to-file) "\
*Function called to create a copy of a file.
This is `add-name-to-file' by default, which means that crossposts
will use hard links.  If your file system doesn't allow hard
links, you could set this variable to `copy-file' instead." :group 'nnmail-files :type '(radio (function-item add-name-to-file) (function-item copy-file) (function :tag "Other")))

(defcustom nnmail-read-incoming-hook (if (eq system-type 'windows-nt) '(nnheader-ms-strip-cr) nil) "\
*Hook that will be run after the incoming mail has been transferred.
The incoming mail is moved from the specified spool file (which normally is
something like \"/usr/spool/mail/$user\") to the user's home
directory.  This hook is called after the incoming mail box has been
emptied, and can be used to call any mail box programs you have
running (\"xwatch\", etc.)

Eg.

\(add-hook 'nnmail-read-incoming-hook
	  (lambda ()
	    (call-process \"/local/bin/mailsend\" nil nil nil
			  \"read\" nnmail-spool-file)))

If you have xwatch running, this will alert it that mail has been
read.

If you use `display-time', you could use something like this:

\(add-hook 'nnmail-read-incoming-hook
	  (lambda ()
	    ;; Update the displayed time, since that will clear out
	    ;; the flag that says you have mail.
	    (when (eq (process-status \"display-time\") 'run)
	      (display-time-filter display-time-process \"\"))))" :group 'nnmail-prepare :type 'hook)

(defcustom nnmail-prepare-incoming-hook nil "\
Hook called before treating incoming mail.
The hook is run in a buffer with all the new, incoming mail." :group 'nnmail-prepare :type 'hook)

(defcustom nnmail-prepare-incoming-header-hook nil "\
Hook called narrowed to the headers of each message.
This can be used to remove excessive spaces (and stuff like
that) from the headers before splitting and saving the messages." :group 'nnmail-prepare :type 'hook)

(defcustom nnmail-prepare-incoming-message-hook nil "\
Hook called narrowed to each message." :group 'nnmail-prepare :type 'hook)

(defcustom nnmail-list-identifiers nil "\
Regexp that matches list identifiers to be removed.
This can also be a list of regexps." :group 'nnmail-prepare :type '(choice (const :tag "none" nil) (regexp :value ".*") (repeat :value (".*") regexp)))

(defcustom nnmail-pre-get-new-mail-hook nil "\
Hook called just before starting to handle new incoming mail." :group 'nnmail-retrieve :type 'hook)

(defcustom nnmail-post-get-new-mail-hook nil "\
Hook called just after finishing handling new incoming mail." :group 'nnmail-retrieve :type 'hook)

(defcustom nnmail-split-hook nil "\
Hook called before deciding where to split an article.
The functions in this hook are free to modify the buffer
contents in any way they choose -- the buffer contents are
discarded after running the split process." :group 'nnmail-split :type 'hook)

(defcustom nnmail-spool-hook nil "\
*A hook called when a new article is spooled." :version "22.1" :group 'nnmail :type 'hook)

(defcustom nnmail-large-newsgroup 50 "\
*The number of articles which indicates a large newsgroup or nil.
If the number of articles is greater than the value, verbose
messages will be shown to indicate the current status." :group 'nnmail-various :type '(choice (const :tag "infinite" nil) (number :tag "count")))

(defcustom nnmail-split-fancy "mail.misc" "\
Incoming mail can be split according to this fancy variable.
To enable this, set `nnmail-split-methods' to `nnmail-split-fancy'.

The format of this variable is SPLIT, where SPLIT can be one of
the following:

GROUP: Mail will be stored in GROUP (a string).

\(FIELD VALUE [- RESTRICT [- RESTRICT [...]]] SPLIT): If the message
  field FIELD (a regexp) contains VALUE (a regexp), store the messages
  as specified by SPLIT.  If RESTRICT (a regexp) matches some string
  after FIELD and before the end of the matched VALUE, return nil,
  otherwise process SPLIT.  Multiple RESTRICTs add up, further
  restricting the possibility of processing SPLIT.

\(| SPLIT...): Process each SPLIT expression until one of them matches.
  A SPLIT expression is said to match if it will cause the mail
  message to be stored in one or more groups.

\(& SPLIT...): Process each SPLIT expression.

\(: FUNCTION optional args): Call FUNCTION with the optional args, in
  the buffer containing the message headers.  The return value FUNCTION
  should be a split, which is then recursively processed.

\(! FUNCTION SPLIT): Call FUNCTION with the result of SPLIT.  The
  return value FUNCTION should be a split, which is then recursively
  processed.

junk: Mail will be deleted.  Use with care!  Do not submerge in water!
  Example:
  (setq nnmail-split-fancy
	'(| (\"Subject\" \"MAKE MONEY FAST\" junk)
	    ...other.rules.omitted...))

FIELD must match a complete field name.  VALUE must match a complete
word according to the `nnmail-split-fancy-syntax-table' syntax table.
You can use \".*\" in the regexps to match partial field names or words.

FIELD and VALUE can also be lisp symbols, in that case they are expanded
as specified in `nnmail-split-abbrev-alist'.

GROUP can contain \\& and \\N which will substitute from matching
\\(\\) patterns in the previous VALUE.

Example:

\(setq nnmail-split-methods 'nnmail-split-fancy
      nnmail-split-fancy
      ;; Messages from the mailer daemon are not crossposted to any of
      ;; the ordinary groups.  Warnings are put in a separate group
      ;; from real errors.
      '(| (\"from\" mail (| (\"subject\" \"warn.*\" \"mail.warning\")
			  \"mail.misc\"))
	  ;; Non-error messages are crossposted to all relevant
	  ;; groups, but we don't crosspost between the group for the
	  ;; (ding) list and the group for other (ding) related mail.
	  (& (| (any \"ding@ifi\\\\.uio\\\\.no\" \"ding.list\")
		(\"subject\" \"ding\" \"ding.misc\"))
	     ;; Other mailing lists...
	     (any \"procmail@informatik\\\\.rwth-aachen\\\\.de\" \"procmail.list\")
	     (any \"SmartList@informatik\\\\.rwth-aachen\\\\.de\" \"SmartList.list\")
	     ;; Both lists below have the same suffix, so prevent
	     ;; cross-posting to mkpkg.list of messages posted only to
	     ;; the bugs- list, but allow cross-posting when the
	     ;; message was really cross-posted.
	     (any \"bugs-mypackage@somewhere\" \"mypkg.bugs\")
	     (any \"mypackage@somewhere\" - \"bugs-mypackage\" \"mypkg.list\")
	     ;;
	     ;; People...
	     (any \"larsi@ifi\\\\.uio\\\\.no\" \"people.Lars Magne Ingebrigtsen\"))
	  ;; Unmatched mail goes to the catch all group.
	  \"misc.misc\"))" :group 'nnmail-split :type 'nnmail-split-fancy)

(defcustom nnmail-split-abbrev-alist '((any . "from\\|to\\|cc\\|sender\\|apparently-to\\|resent-from\\|resent-to\\|resent-cc") (mail . "mailer-daemon\\|postmaster\\|uucp") (to . "to\\|cc\\|apparently-to\\|resent-to\\|resent-cc") (from . "from\\|sender\\|resent-from") (nato . "to\\|cc\\|resent-to\\|resent-cc") (naany . "from\\|to\\|cc\\|sender\\|resent-from\\|resent-to\\|resent-cc")) "\
*Alist of abbreviations allowed in `nnmail-split-fancy'." :group 'nnmail-split :type '(repeat (cons :format "%v" symbol regexp)))

(defcustom nnmail-message-id-cache-length 1000 "\
*The approximate number of Message-IDs nnmail will keep in its cache.
If this variable is nil, no checking on duplicate messages will be
performed." :group 'nnmail-duplicate :type '(choice (const :tag "disable" nil) (integer :format "%v")))

(defcustom nnmail-message-id-cache-file (nnheader-concat gnus-home-directory ".nnmail-cache") "\
The file name of the nnmail Message-ID cache." :group 'nnmail-duplicate :group 'nnmail-files :type 'file)

(defcustom nnmail-treat-duplicates 'warn "\
*If non-nil, nnmail keep a cache of Message-IDs to discover mail duplicates.
Three values are valid: nil, which means that nnmail is not to keep a
Message-ID cache; `warn', which means that nnmail should insert extra
headers to warn the user about the duplication (this is the default);
and `delete', which means that nnmail will delete duplicated mails.

This variable can also be a function.  It will be called from a buffer
narrowed to the article in question with the Message-ID as a
parameter.  It should return nil, `warn' or `delete'." :group 'nnmail-duplicate :type '(choice (const :tag "off" nil) (const warn) (const delete)))

(defcustom nnmail-extra-headers '(To Newsgroups) "\
*Extra headers to parse." :version "21.1" :group 'nnmail :type '(repeat symbol))

(defcustom nnmail-split-header-length-limit 2048 "\
Header lines longer than this limit are excluded from the split function." :version "21.1" :group 'nnmail :type 'integer)

(defcustom nnmail-mail-splitting-charset nil "\
Default charset to be used when splitting incoming mail." :version "22.1" :group 'nnmail :type 'symbol)

(defcustom nnmail-mail-splitting-decodes nil "\
Whether the nnmail splitting functionality should MIME decode headers." :version "22.1" :group 'nnmail :type 'boolean)

(defcustom nnmail-split-fancy-match-partial-words nil "\
Whether to match partial words when fancy splitting.
Normally, regexes given in `nnmail-split-fancy' are implicitly surrounded
by \"\\=\\<...\\>\".  If this variable is true, they are not implicitly surrounded
by anything." :version "22.1" :group 'nnmail :type 'boolean)

(defcustom nnmail-split-lowercase-expanded t "\
Whether to lowercase expanded entries (i.e. \\N) when splitting mails.
This avoids the creation of multiple groups when users send to an address
using different case (i.e. mailing-list@domain vs Mailing-List@Domain)." :version "22.1" :group 'nnmail :type 'boolean)

;;;***

;;;### (autoloads (nntp-authinfo-file nntp) "nntp" "lisp/nntp.el")
(defconst custom-define-current-source-file "nntp.el")

(defgroup nntp nil "NNTP access for Gnus." :group 'gnus)

(defcustom nntp-authinfo-file "~/.authinfo" "\
.netrc-like file that holds nntp authinfo passwords." :group 'nntp :type '(choice file (repeat :tag "Entries" :menu-tag "Inline" (list :format "%v" :value ("" ("login" . "") ("password" . "")) (string :tag "Host") (checklist :inline t (cons :format "%v" (const :format "" "login") (string :format "Login: %v")) (cons :format "%v" (const :format "" "password") (string :format "Password: %v")))))))

;;;***

;;;### (autoloads (rfc1843-newsgroups-regexp rfc1843-decode-hzp rfc1843-decode-loosely) "rfc1843" "lisp/rfc1843.el")
(defconst custom-define-current-source-file "rfc1843.el")

(defcustom rfc1843-decode-loosely nil "\
Loosely check HZ encoding if non-nil.
When it is set non-nil, only buffers or strings with strictly
HZ-encoded are decoded." :type 'boolean :group 'mime)

(defcustom rfc1843-decode-hzp t "\
HZ+ decoding support if non-nil.
HZ+ specification (also known as HZP) is to provide a standardized
7-bit representation of mixed Big5, GB, and ASCII text for convenient
e-mail transmission, news posting, etc.
The document of HZ+ 0.78 specification can be found at
ftp://ftp.math.psu.edu/pub/simpson/chinese/hzp/hzp.doc" :type 'boolean :group 'mime)

(defcustom rfc1843-newsgroups-regexp "chinese\\|hz" "\
Regexp of newsgroups in which might be HZ encoded." :type 'string :group 'mime)

;;;***

;;;### (autoloads (smiley-mouse-face smiley-circle-color smiley-tongue-color smiley-features-color smiley-flesh-color smiley-regexp-alist smiley-nosey-regexp-alist smiley-deformed-regexp-alist smiley-data-directory smiley) "smiley" "lisp/smiley.el")
(defconst custom-define-current-source-file "smiley.el")

(defgroup smiley nil "Turn :-)'s into real images." :group 'gnus-visual)

(defcustom smiley-data-directory (if (featurep 'xemacs) (message-xmas-find-glyph-directory "smilies") "/usr/local/lib/xemacs/xemacs-packages/etc/smilies") "\
*Location of the smiley faces files." :type 'directory :group 'smiley)

(defcustom smiley-deformed-regexp-alist '(("\\(\\^_?\\^;;;\\)\\W" 1 "WideFaceAse3.xbm") ("\\(\\^_?\\^;;\\)\\W" 1 "WideFaceAse2.xbm") ("\\(\\^_?\\^;\\)\\W" 1 "WideFaceAse1.xbm") ("\\(\\^_?\\^\\)\\W" 1 "WideFaceSmile.xbm") ("\\(;_;\\)\\W" 1 "WideFaceWeep.xbm") ("\\(T_T\\)\\W" 1 "WideFaceWeep.xbm") ("\\(:-*[<]+\\)\\W" 1 "FaceAngry.xpm") ("\\(:-+\\]+\\)\\W" 1 "FaceGoofy.xpm") ("\\(:-*D\\)\\W" 1 "FaceGrinning.xpm") ("\\(:-*[)>}]+\\)\\W" 1 "FaceHappy.xpm") ("\\(=[)]+\\)\\W" 1 "FaceHappy.xpm") ("\\(:-*[/\\\"]\\)[^/]\\W" 1 "FaceIronic.xpm") ("[^.0-9]\\([8|]-*[|Oo%]\\)\\W" 1 "FaceKOed.xpm") ("\\([:|]-*#+\\)\\W" 1 "FaceNyah.xpm") ("\\(:-*[({]+\\)\\W" 1 "FaceSad.xpm") ("\\(=[({]+\\)\\W" 1 "FaceSad.xpm") ("\\(:-*[Oo*]\\)\\W" 1 "FaceStartled.xpm") ("\\(:-*|\\)\\W" 1 "FaceStraight.xpm") ("\\(:-*p\\)\\W" 1 "FaceTalking.xpm") ("\\(:-*d\\)\\W" 1 "FaceTasty.xpm") ("\\(;-*[>)}]+\\)\\W" 1 "FaceWinking.xpm") ("\\(:-*[Vv]\\)\\W" 1 "FaceWry.xpm") ("\\([:|]-*P\\)\\W" 1 "FaceYukky.xpm") ("\\(X-+)+\\)\\W" 1 "dead.xpm")) "\
*Normal and deformed faces for smilies." :type '(repeat (list regexp (integer :tag "Match") (string :tag "Image"))) :group 'smiley)

(defcustom smiley-nosey-regexp-alist '(("\\(:-+[<]+\\)\\W" 1 "FaceAngry.xpm") ("\\(:-+\\]+\\)\\W" 1 "FaceGoofy.xpm") ("\\(:-+D\\)\\W" 1 "FaceGrinning.xpm") ("\\(:-+[}]+\\)\\W" 1 "FaceHappy.xpm") ("\\(:-*)+\\)\\W" 1 "FaceHappy.xpm") ("\\(=[)]+\\)\\W" 1 "FaceHappy.xpm") ("\\(:-+[/\\\"]+\\)\\W" 1 "FaceIronic.xpm") ("\\([8|]-+[|Oo%]\\)\\W" 1 "FaceKOed.xpm") ("\\([:|]-+#+\\)\\W" 1 "FaceNyah.xpm") ("\\(:-+[({]+\\)\\W" 1 "FaceSad.xpm") ("\\(=[({]+\\)\\W" 1 "FaceSad.xpm") ("\\(:-+[Oo*]\\)\\W" 1 "FaceStartled.xpm") ("\\(:-+|\\)\\W" 1 "FaceStraight.xpm") ("\\(:-+p\\)\\W" 1 "FaceTalking.xpm") ("\\(:-+d\\)\\W" 1 "FaceTasty.xpm") ("\\(;-+[>)}]+\\)\\W" 1 "FaceWinking.xpm") ("\\(:-+[Vv]\\)\\W" 1 "FaceWry.xpm") ("\\(][:8B]-[)>]\\)\\W" 1 "FaceDevilish.xpm") ("\\([:|]-+P\\)\\W" 1 "FaceYukky.xpm") ("\\(X-+)+\\)\\W" 1 "dead.xpm")) "\
*Smileys with noses.  These get less false matches." :type '(repeat (list regexp (integer :tag "Match") (string :tag "Image"))) :group 'smiley)

(defcustom smiley-regexp-alist smiley-deformed-regexp-alist "\
*A list of regexps to map smilies to real images.
Defaults to the contents of `smiley-deformed-regexp-alist'.
An alternative is `smiley-nosey-regexp-alist' that matches less
aggressively.
If this is a symbol, take its value." :type '(radio (variable-item smiley-deformed-regexp-alist) (variable-item smiley-nosey-regexp-alist) symbol (repeat (list regexp (integer :tag "Match") (string :tag "Image")))) :group 'smiley)

(defcustom smiley-flesh-color "yellow" "\
*Flesh color." :type 'string :group 'smiley)

(defcustom smiley-features-color "black" "\
*Features color." :type 'string :group 'smiley)

(defcustom smiley-tongue-color "red" "\
*Tongue color." :type 'string :group 'smiley)

(defcustom smiley-circle-color "black" "\
*Circle color." :type 'string :group 'smiley)

(defcustom smiley-mouse-face 'highlight "\
*Face used for mouse highlighting in the smiley buffer.

Smiley buttons will be displayed in this face when the cursor is
above them." :type 'face :group 'smiley)

;;;***

;;;### (autoloads (smime-dns-server smime-crl-check smime-encrypt-cipher smime-openssl-program smime-certificate-directory smime-CA-file smime-CA-directory smime-keys smime) "smime" "lisp/smime.el")
(defconst custom-define-current-source-file "smime.el")

(defgroup smime nil "S/MIME configuration." :group 'mime)

(defcustom smime-keys nil "\
*Map mail addresses to a file containing Certificate (and private key).
The file is assumed to be in PEM format. You can also associate additional
certificates to be sent with every message to each address." :type '(repeat (list (string :tag "Mail address") (file :tag "File name") (repeat :tag "Additional certificate files" (file :tag "File name")))) :group 'smime)

(defcustom smime-CA-directory nil "\
*Directory containing certificates for CAs you trust.
Directory should contain files (in PEM format) named to the X.509
hash of the certificate.  This can be done using OpenSSL such as:

$ ln -s ca.pem `openssl x509 -noout -hash -in ca.pem`.0

where `ca.pem' is the file containing a PEM encoded X.509 CA
certificate." :type '(choice (const :tag "none" nil) directory) :group 'smime)

(defcustom smime-CA-file nil "\
*Files containing certificates for CAs you trust.
File should contain certificates in PEM format." :version "22.1" :type '(choice (const :tag "none" nil) file) :group 'smime)

(defcustom smime-certificate-directory "~/Mail/certs/" "\
*Directory containing other people's certificates.
It should contain files named to the X.509 hash of the certificate,
and the files themself should be in PEM format." :type 'directory :group 'smime)

(defcustom smime-openssl-program (and (condition-case nil (eq 0 (call-process "openssl" nil nil nil "version")) (error nil)) "openssl") "\
*Name of OpenSSL binary." :type 'string :group 'smime)

(defcustom smime-encrypt-cipher "-des3" "\
*Cipher algorithm used for encryption." :version "22.1" :type '(choice (const :tag "Triple DES" "-des3") (const :tag "DES" "-des") (const :tag "RC2 40 bits" "-rc2-40") (const :tag "RC2 64 bits" "-rc2-64") (const :tag "RC2 128 bits" "-rc2-128")) :group 'smime)

(defcustom smime-crl-check nil "\
*Check revocation status of signers certificate using CRLs.
Enabling this will have OpenSSL check the signers certificate
against a certificate revocation list (CRL).

For this to work the CRL must be up-to-date and since they are
normally updated quite often (ie. several times a day) you
probably need some tool to keep them up-to-date. Unfortunately
Gnus cannot do this for you.

The CRL should either be appended (in PEM format) to your
`smime-CA-file' or be located in a file (also in PEM format) in
your `smime-certificate-directory' named to the X.509 hash of the
certificate with .r0 as file name extension.

At least OpenSSL version 0.9.7 is required for this to work." :type '(choice (const :tag "No check" nil) (const :tag "Check certificate" "-crl_check") (const :tag "Check certificate chain" "-crl_check_all")) :group 'smime)

(defcustom smime-dns-server nil "\
*DNS server to query certificates from.
If nil, use system defaults." :version "22.1" :type '(choice (const :tag "System defaults") string) :group 'smime)

;;;***

;;;### (autoloads (spam-report-requests-file spam-report-url-ping-function spam-report-gmane-use-article-number spam-report-gmane-regex spam-report) "spam-report" "lisp/spam-report.el")
(defconst custom-define-current-source-file "spam-report.el")

(defgroup spam-report nil "Spam reporting configuration." :group 'mail :group 'news)

(defcustom spam-report-gmane-regex nil "\
Regexp matching Gmane newsgroups, e.g. \"^nntp\\+.*:gmane\\.\"
If you are using spam.el, consider setting gnus-spam-process-newsgroups
or the gnus-group-spam-exit-processor-report-gmane group/topic parameter
instead." :type '(radio (const nil) (regexp :value "^nntp+.*:gmane.")) :group 'spam-report)

(defcustom spam-report-gmane-use-article-number t "\
Whether the article number (faster!) or the header should be used.

You must set this to nil if you don't read Gmane groups directly
from news.gmane.org, e.g. when using local newsserver such as
leafnode." :type 'boolean :group 'spam-report)

(defcustom spam-report-url-ping-function 'spam-report-url-ping-plain "\
Function to use for url ping spam reporting.
The function must accept the arguments `host' and `report'." :type '(choice (const :tag "Connect directly" spam-report-url-ping-plain) (const :tag "Use the external program specified in `mm-url-program'" spam-report-url-ping-mm-url) (const :tag "Store request URLs in `spam-report-requests-file'" spam-report-url-to-file) (function :tag "User defined function" nil)) :group 'spam-report)

(defcustom spam-report-requests-file (nnheader-concat gnus-directory "spam/" "spam-report-requests.url") "\
File where spam report request are stored." :type 'file :group 'spam-report)

;;;***

;;;### (autoloads (spam-stat-split-fancy-spam-threshhold spam-stat-split-fancy-spam-group spam-stat-max-buffer-length spam-stat-max-word-length spam-stat-unknown-word-score spam-stat-install-hooks spam-stat-file spam-stat) "spam-stat" "lisp/spam-stat.el")
(defconst custom-define-current-source-file "spam-stat.el")

(defgroup spam-stat nil "Statistical spam detection for Emacs.\nUse the functions to build a dictionary of words and their statistical\ndistribution in spam and non-spam mails.  Then use a function to determine\nwhether a buffer contains spam or not." :version "22.1" :group 'gnus)

(defcustom spam-stat-file "~/.spam-stat.el" "\
File used to save and load the dictionary.
See `spam-stat-to-hash-table' for the format of the file." :type 'file :group 'spam-stat)

(defcustom spam-stat-install-hooks t "\
Whether spam-stat should install its hooks in Gnus.
This is set to nil if you use spam-stat through spam.el." :type 'boolean :group 'spam-stat)

(defcustom spam-stat-unknown-word-score 0.2 "\
The score to use for unknown words.
Also used for words that don't appear often enough." :type 'number :group 'spam-stat)

(defcustom spam-stat-max-word-length 15 "\
Only words shorter than this will be considered." :type 'integer :group 'spam-stat)

(defcustom spam-stat-max-buffer-length 10240 "\
Only the beginning of buffers will be analyzed.
This variable says how many characters this will be." :type 'integer :group 'spam-stat)

(defcustom spam-stat-split-fancy-spam-group "mail.spam" "\
Name of the group where spam should be stored, if
`spam-stat-split-fancy' is used in fancy splitting rules.  Has no
effect when spam-stat is invoked through spam.el." :type 'string :group 'spam-stat)

(defcustom spam-stat-split-fancy-spam-threshhold 0.9 "\
Spam score threshhold in spam-stat-split-fancy." :type 'number :group 'spam-stat)

;;;***

;;;### (autoloads (spam-spamoracle-binary spam-spamoracle-database spam-spamoracle spam-bogofilter-database-directory spam-bogofilter-bogosity-positive-spam-header spam-bogofilter-ham-strong-switch spam-bogofilter-spam-strong-switch spam-bogofilter-ham-switch spam-bogofilter-spam-switch spam-bogofilter-header spam-bogofilter-program spam-bogofilter spam-ifile-all-categories spam-ifile-ham-category spam-ifile-spam-category spam-ifile-database spam-ifile-program spam-ifile spam-regex-body-ham spam-regex-body-spam spam-regex-headers-ham spam-regex-headers-spam spam-face spam-blackhole-good-server-regex spam-blackhole-servers spam-junk-mailgroups spam-split-group spam-install-hooks spam-use-spamoracle spam-use-stat spam-use-ifile spam-use-BBDB-exclusive spam-use-BBDB spam-use-bogofilter spam-use-bogofilter-headers spam-use-regex-body spam-use-regex-headers spam-use-hashcash spam-use-blackholes spam-use-whitelist-exclusive spam-use-whitelist spam-blacklist-ignored-regexes spam-use-blacklist spam-use-dig spam-blacklist spam-whitelist spam-autodetect-recheck-messages spam-disable-spam-split-during-ham-respool spam-mark-ham-unread-before-move-from-spam-group spam-mark-only-unseen-as-spam spam-process-ham-in-spam-groups spam-split-symbolic-return-positive spam-split-symbolic-return spam-log-to-registry spam-mark-new-messages-in-spam-group-as-spam spam-process-ham-in-nonham-groups spam-move-spam-nonspam-groups-only spam-directory spam) "spam" "lisp/spam.el")
(defconst custom-define-current-source-file "spam.el")

(defgroup spam nil "Spam configuration." :version "22.1" :group 'mail :group 'news)

(defcustom spam-directory (nnheader-concat gnus-directory "spam/") "\
Directory for spam whitelists and blacklists." :type 'directory :group 'spam)

(defcustom spam-move-spam-nonspam-groups-only t "\
Whether spam should be moved in non-spam groups only.
When t, only ham and unclassified groups will have their spam moved
to the spam-process-destination.  When nil, spam will also be moved from
spam groups." :type 'boolean :group 'spam)

(defcustom spam-process-ham-in-nonham-groups nil "\
Whether ham should be processed in non-ham groups." :type 'boolean :group 'spam)

(defcustom spam-mark-new-messages-in-spam-group-as-spam t "\
Whether new messages in a spam group should get the spam-mark." :type 'boolean :group 'spam)

(defcustom spam-log-to-registry nil "\
Whether spam/ham processing should be logged in the registry." :type 'boolean :group 'spam)

(defcustom spam-split-symbolic-return nil "\
Whether `spam-split' should work with symbols or group names." :type 'boolean :group 'spam)

(defcustom spam-split-symbolic-return-positive nil "\
Whether `spam-split' should ALWAYS work with symbols or group names.
Do not set this if you use `spam-split' in a fancy split
  method." :type 'boolean :group 'spam)

(defcustom spam-process-ham-in-spam-groups nil "\
Whether ham should be processed in spam groups." :type 'boolean :group 'spam)

(defcustom spam-mark-only-unseen-as-spam t "\
Whether only unseen articles should be marked as spam in spam groups.
When nil, all unread articles in a spam group are marked as
spam.  Set this if you want to leave an article unread in a spam group
without losing it to the automatic spam-marking process." :type 'boolean :group 'spam)

(defcustom spam-mark-ham-unread-before-move-from-spam-group nil "\
Whether ham should be marked unread before it's moved.
The article is moved out of a spam group according to ham-process-destination.
This variable is an official entry in the international Longest Variable Name
Competition." :type 'boolean :group 'spam)

(defcustom spam-disable-spam-split-during-ham-respool nil "\
Whether `spam-split' should be ignored while resplitting ham in a process
destination.  This is useful to prevent ham from ending up in the same spam
group after the resplit.  Don't set this to t if you have spam-split as the
last rule in your split configuration." :type 'boolean :group 'spam)

(defcustom spam-autodetect-recheck-messages nil "\
Should spam.el recheck all meessages when autodetecting?
Normally this is nil, so only unseen messages will be checked." :type 'boolean :group 'spam)

(defcustom spam-whitelist (expand-file-name "whitelist" spam-directory) "\
The location of the whitelist.
The file format is one regular expression per line.
The regular expression is matched against the address." :type 'file :group 'spam)

(defcustom spam-blacklist (expand-file-name "blacklist" spam-directory) "\
The location of the blacklist.
The file format is one regular expression per line.
The regular expression is matched against the address." :type 'file :group 'spam)

(defcustom spam-use-dig t "\
Whether `query-dig' should be used instead of `query-dns'." :type 'boolean :group 'spam)

(defcustom spam-use-blacklist nil "\
Whether the blacklist should be used by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-blacklist-ignored-regexes nil "\
Regular expressions that the blacklist should ignore." :type '(repeat (regexp :tag "Regular expression to ignore when blacklisting")) :group 'spam)

(defcustom spam-use-whitelist nil "\
Whether the whitelist should be used by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-use-whitelist-exclusive nil "\
Whether whitelist-exclusive should be used by `spam-split'.
Exclusive whitelisting means that all messages from senders not in the whitelist
are considered spam." :type 'boolean :group 'spam)

(defcustom spam-use-blackholes nil "\
Whether blackholes should be used by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-use-hashcash nil "\
Whether hashcash payments should be detected by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-use-regex-headers nil "\
Whether a header regular expression match should be used by `spam-split'.
Also see the variables `spam-regex-headers-spam' and `spam-regex-headers-ham'." :type 'boolean :group 'spam)

(defcustom spam-use-regex-body nil "\
Whether a body regular expression match should be used by `spam-split'.
Also see the variables `spam-regex-body-spam' and `spam-regex-body-ham'." :type 'boolean :group 'spam)

(defcustom spam-use-bogofilter-headers nil "\
Whether bogofilter headers should be used by `spam-split'.
Enable this if you pre-process messages with Bogofilter BEFORE Gnus sees them." :type 'boolean :group 'spam)

(defcustom spam-use-bogofilter nil "\
Whether bogofilter should be invoked by `spam-split'.
Enable this if you want Gnus to invoke Bogofilter on new messages." :type 'boolean :group 'spam)

(defcustom spam-use-BBDB nil "\
Whether BBDB should be used by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-use-BBDB-exclusive nil "\
Whether BBDB-exclusive should be used by `spam-split'.
Exclusive BBDB means that all messages from senders not in the BBDB are
considered spam." :type 'boolean :group 'spam)

(defcustom spam-use-ifile nil "\
Whether ifile should be used by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-use-stat nil "\
Whether `spam-stat' should be used by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-use-spamoracle nil "\
Whether spamoracle should be used by `spam-split'." :type 'boolean :group 'spam)

(defcustom spam-install-hooks (or spam-use-dig spam-use-blacklist spam-use-whitelist spam-use-whitelist-exclusive spam-use-blackholes spam-use-hashcash spam-use-regex-headers spam-use-regex-body spam-use-bogofilter-headers spam-use-bogofilter spam-use-BBDB spam-use-BBDB-exclusive spam-use-ifile spam-use-stat spam-use-spamoracle) "\
Whether the spam hooks should be installed.
Default to t if one of the spam-use-* variables is set." :group 'spam :type 'boolean)

(defcustom spam-split-group "spam" "\
Group name where incoming spam should be put by `spam-split'." :type 'string :group 'spam)

(defcustom spam-junk-mailgroups (cons spam-split-group '("mail.junk" "poste.pourriel")) "\
Mailgroups with spam contents.
All unmarked article in such group receive the spam mark on group entry." :type '(repeat (string :tag "Group")) :group 'spam)

(defcustom spam-blackhole-servers '("bl.spamcop.net" "relays.ordb.org" "dev.null.dk" "relays.visi.com") "\
List of blackhole servers." :type '(repeat (string :tag "Server")) :group 'spam)

(defcustom spam-blackhole-good-server-regex nil "\
String matching IP addresses that should not be checked in the blackholes." :type '(radio (const nil) regexp) :group 'spam)

(defcustom spam-face 'spam "\
Face for spam-marked articles." :type 'face :group 'spam)

(defcustom spam-regex-headers-spam '("^X-Spam-Flag: YES") "\
Regular expression for positive header spam matches." :type '(repeat (regexp :tag "Regular expression to match spam header")) :group 'spam)

(defcustom spam-regex-headers-ham '("^X-Spam-Flag: NO") "\
Regular expression for positive header ham matches." :type '(repeat (regexp :tag "Regular expression to match ham header")) :group 'spam)

(defcustom spam-regex-body-spam 'nil "\
Regular expression for positive body spam matches." :type '(repeat (regexp :tag "Regular expression to match spam body")) :group 'spam)

(defcustom spam-regex-body-ham 'nil "\
Regular expression for positive body ham matches." :type '(repeat (regexp :tag "Regular expression to match ham body")) :group 'spam)

(defgroup spam-ifile nil "Spam ifile configuration." :group 'spam)

(defcustom spam-ifile-program (executable-find "ifile") "\
Name of the ifile program." :type '(choice (file :tag "Location of ifile") (const :tag "ifile is not installed")) :group 'spam-ifile)

(defcustom spam-ifile-database nil "\
File name of the ifile database." :type '(choice (file :tag "Location of the ifile database") (const :tag "Use the default")) :group 'spam-ifile)

(defcustom spam-ifile-spam-category "spam" "\
Name of the spam ifile category." :type 'string :group 'spam-ifile)

(defcustom spam-ifile-ham-category nil "\
Name of the ham ifile category.
If nil, the current group name will be used." :type '(choice (string :tag "Use a fixed category") (const :tag "Use the current group name")) :group 'spam-ifile)

(defcustom spam-ifile-all-categories nil "\
Whether the ifile check will return all categories, or just spam.
Set this to t if you want to use the `spam-split' invocation of ifile as
your main source of newsgroup names." :type 'boolean :group 'spam-ifile)

(defgroup spam-bogofilter nil "Spam bogofilter configuration." :group 'spam)

(defcustom spam-bogofilter-program (executable-find "bogofilter") "\
Name of the Bogofilter program." :type '(choice (file :tag "Location of bogofilter") (const :tag "Bogofilter is not installed")) :group 'spam-bogofilter)

(defcustom spam-bogofilter-header "X-Bogosity" "\
The header that Bogofilter inserts in messages." :type 'string :group 'spam-bogofilter)

(defcustom spam-bogofilter-spam-switch "-s" "\
The switch that Bogofilter uses to register spam messages." :type 'string :group 'spam-bogofilter)

(defcustom spam-bogofilter-ham-switch "-n" "\
The switch that Bogofilter uses to register ham messages." :type 'string :group 'spam-bogofilter)

(defcustom spam-bogofilter-spam-strong-switch "-S" "\
The switch that Bogofilter uses to unregister ham messages." :type 'string :group 'spam-bogofilter)

(defcustom spam-bogofilter-ham-strong-switch "-N" "\
The switch that Bogofilter uses to unregister spam messages." :type 'string :group 'spam-bogofilter)

(defcustom spam-bogofilter-bogosity-positive-spam-header "^\\(Yes\\|Spam\\)" "\
The regex on `spam-bogofilter-header' for positive spam identification." :type 'regexp :group 'spam-bogofilter)

(defcustom spam-bogofilter-database-directory nil "\
Location of the Bogofilter database.
When nil, use the default location." :type '(choice (directory :tag "Location of the Bogofilter database directory") (const :tag "Use the default")) :group 'spam-bogofilter)

(defgroup spam-spamoracle nil "Spam spamoracle configuration." :group 'spam)

(defcustom spam-spamoracle-database nil "\
Location of spamoracle database file.
When nil, use the default spamoracle database." :type '(choice (directory :tag "Location of spamoracle database file.") (const :tag "Use the default")) :group 'spam-spamoracle)

(defcustom spam-spamoracle-binary (executable-find "spamoracle") "\
Location of the spamoracle binary." :type '(choice (directory :tag "Location of the spamoracle binary") (const :tag "Use the default")) :group 'spam-spamoracle)

;;;***

;;;### (autoloads (uudecode-use-external uudecode-decoder-switches uudecode-decoder-program) "uudecode" "lisp/uudecode.el")
(defconst custom-define-current-source-file "uudecode.el")

(defcustom uudecode-decoder-program "uudecode" "\
*Non-nil value should be a string that names a uu decoder.
The program should expect to read uu data on its standard
input and write the converted data to its standard output." :type 'string :group 'gnus-extract)

(defcustom uudecode-decoder-switches nil "\
*List of command line flags passed to `uudecode-decoder-program'." :group 'gnus-extract :type '(repeat string))

(defcustom uudecode-use-external (executable-find uudecode-decoder-program) "\
*Use external uudecode program." :version "22.1" :group 'gnus-extract :type 'boolean)

;;;***

(provide 'gnus-custom-defines)
